var html_name = page_arr.bankcard_identification;
var title, idCard, UIAlbumBrowser, photoBrowser;
var count = 0;
var baiduReader = null;
var businessPhoto = null;
var Photo_name = null;
var access_token;
var detection = '';

page_init = function () {
    title = page_data['title'] || '';
    //获取请求的access_token
    getToken();
    //idCard作为请求的参数
    if (page_data['title'] === '身份证正面') {
        idCard = 'front';
    } else if (page_data['title'] === '身份证背面') {
        idCard = 'back';
    }

    //初始图片渲染
    // if ($.nui.isEmpty(page_data['img_name'])) {
    $('.yhk-img').children('img').attr('src', page_data['img']);
    Photo_name = '';
    // } else {
    //     $('.yhk-img').children('img').attr('src', fun.getImgPath(page_data['img_name'], true, { url: UPLOAD_IMG_PATH }));
    //     $('.yhk-img').children('img').attr('large-url', fun.getImgPath(page_data['img_name'], true, { url: UPLOAD_IMG_PATH }));
    //     Photo_name = page_data['img_name'];
    // }
    UIAlbumBrowser = api.require('UIAlbumBrowser'); // 多选图片模块
    photoBrowser = api.require('photoBrowser') //预览大图模块
    /******头部显示******/
    $("#header").header({
        back: true,
        title: title,
    });

    //无图片显示提示语
    if ($('.yhk-img').find('img').attr('src').indexOf('yhk.jpg') > -1) {
        $('#logout').text('开始拍照');
    } else {
        $('.yhk-text').show();
        $('#logout').text('上传识别');
    }

    //图片路径转base64
    if ($.nui.isTrue(page_data['img_name'])) {
        fun.getUrlBase64(fun.getImgPath(page_data['img_name'], true, { url: UPLOAD_IMG_PATH }), '', function (base64) {
            baiduReader = base64.split(',')[1];
        })
    }
}

// 拍摄弹窗
$('.yhk-text').on('click', function () {
    // // if ($(this).attr('disabled')) return;
    $('#openCamera').show();
    $('.box').show();
});

//点击底部按钮
$('#logout').on('click', function () {
    if ($('#logout').text() === '开始拍照') {
        $('#openCamera').show();
        $('.box').show();
    } else if (page_data['type'] === 'mp' || page_data['type'] === 'mp_button') {
        cardReader(baiduReader, access_token);
    } else if (page_data['type'] === 'mp_yhk') {
        moreReader(baiduReader, access_token);
    } else if (page_data['type'] === 'yyzz') {
        businessReader(baiduReader, access_token);
    } else if (page_data['type'] === 'yhk') {
        yhkReader(baiduReader, access_token);
    } else {
        idReader(baiduReader, access_token);
    }
});

//点击预览图片
$('.yhk-img').on('click', function () {
    previewImg($(this));
});

//取消拍照
$('#cancelPhoto').on('click', function () {
    $('#openCamera').hide();
    $('.box').hide();
});

// 点击添加图片
$('#paizhao').on('click', function () {
    photo();
})
$('#selectPhoto').on('click', function () {
    album();
})

//名片识别
function cardReader(base64, access_token) {
    $.ajax({
        type: 'POST',
        url: 'https://aip.baidubce.com/rest/2.0/ocr/v1/business_card?access_token=' + access_token,
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded;'
        },
        data: {
            image: base64
        },
        success: function (res) {
            console.log(res)
            var data = res['words_result'];

            if ($.nui.isEmpty(data)) return fun.toast('识别失败，请重新识别');

            if ($.nui.isEmpty(data['NAME']) || $.nui.isEmpty(data['ADDR']) || $.nui.isEmpty(data['MOBILE']) || $.nui.isEmpty(data['TEL'])) {
                return fun.toast('识别失败，请重新识别')
            } else if (data['NAME'][0] === '' || data['TEL'][0] === '') {
                return fun.toast('识别失败，请重新识别')
            } else {
                fun.toast('识别成功，已自动生成资料');
                var newArr = [];
                if ($.nui.isTrue(data['TITLE'])) {
                    var position = data['TITLE'][0]
                } else {
                    var position = '';
                }

                if ($.nui.isTrue(data['COMPANY'])) {
                    var company = data['COMPANY'][0]
                } else {
                    var company = '';
                }


                if (data['NAME'].length != 1 || data['ADDR'].length != 1 || data['MOBILE'].length != 1 || data['TEL'].length != 1) {
                    if (data['TEL'].length != 1) {
                        for (var i = 0; i < data['TEL'].length; i++) {
                            var tyObj = {
                                company: company,
                                name: '',
                                position: position,
                                mobile: '',
                                phone: '',
                                address: ''
                            }
                            if ($.nui.isTrue(data['NAME'][i])) {
                                var name = { name: data['NAME'][i] };
                            } else {
                                var name = { name: data['NAME'][0] };
                            }
                            var nameObj = $.extend(tyObj, name)

                            if ($.nui.isTrue(data['ADDR'][i])) {
                                var addr = { address: data['ADDR'][i] };
                            } else {
                                var addr = { address: data['ADDR'][0] };
                            }
                            var addrObj = $.extend(nameObj, addr)

                            if ($.nui.isTrue(data['MOBILE'][i])) {
                                var modile = { mobile: data['MOBILE'][i] };
                            } else {
                                var modile = { mobile: data['MOBILE'][0] };
                            }
                            var modileObj = $.extend(addrObj, modile)
                            var tel = { phone: data['TEL'][i] };
                            var telObj = $.extend(modileObj, tel)

                            newArr.push(telObj)
                        }
                    } else if (data['NAME'].length != 1) {
                        for (var i = 0; i < data['NAME'].length; i++) {
                            var tyObj = {
                                company: company,
                                name: '',
                                position: position,
                                mobile: '',
                                phone: '',
                                address: ''
                            }
                            if ($.nui.isTrue(data['TEL'][i])) {
                                var tel = { phone: data['TEL'][i] };
                            } else {
                                var tel = { phone: data['TEL'][0] };
                            }
                            var telObj = $.extend(tyObj, tel)

                            if ($.nui.isTrue(data['ADDR'][i])) {
                                var addr = { address: data['ADDR'][i] };
                            } else {
                                var addr = { address: data['ADDR'][0] };
                            }
                            var addrObj = $.extend(telObj, addr)

                            if ($.nui.isTrue(data['MOBILE'][i])) {
                                var modile = { mobile: data['MOBILE'][i] };
                            } else {
                                var modile = { mobile: data['MOBILE'][0] };
                            }
                            var modileObj = $.extend(addrObj, modile)
                            var name = { name: data['NAME'][i] };
                            var nameObj = $.extend(modileObj, name);
                            newArr.push(nameObj)
                        }
                    } else if (data['ADDR'].length != 1) {
                        for (var i = 0; i < data['ADDR'].length; i++) {
                            var tyObj = {
                                company: company,
                                name: '',
                                position: position,
                                mobile: '',
                                phone: '',
                                address: ''
                            }
                            if ($.nui.isTrue(data['TEL'][i])) {
                                var tel = { phone: data['TEL'][i] }
                            } else {
                                var tel = { phone: data['TEL'][0] }
                            }
                            var telObj = $.extend(tyObj, tel)

                            if ($.nui.isTrue(data['NAME'][i])) {
                                var name = { name: data['NAME'][i] }
                            } else {
                                var name = { name: data['NAME'][0] }
                            }
                            var nameObj = $.extend(telObj, name)

                            if ($.nui.isTrue(data['MOBILE'][i])) {
                                var modile = { mobile: data['MOBILE'][i] }
                            } else {
                                var modile = { mobile: data['MOBILE'][0] }
                            }
                            var modileObj = $.extend(nameObj, modile)
                            var addr = { address: data['ADDR'][i] };
                            var addrObj = $.extend(modileObj, addr);
                            newArr.push(addrObj)
                        }
                    } else if (data['MOBILE'].length != 1) {
                        for (var i = 0; i < data['MOBILE'].length; i++) {
                            var tyObj = {
                                company: company,
                                name: '',
                                position: position,
                                mobile: '',
                                phone: '',
                                address: ''
                            }
                            if ($.nui.isTrue(data['TEL'][i])) {
                                var tel = { phone: data['TEL'][i] }
                            } else {
                                var tel = { phone: data['TEL'][0] }
                            }
                            var telObj = $.extend(tyObj, tel)

                            if ($.nui.isTrue(data['NAME'][i])) {
                                var name = { name: data['NAME'][i] }
                            } else {
                                var name = { name: data['NAME'][0] }
                            }
                            var nameObj = $.extend(telObj, name)

                            if ($.nui.isTrue(data['ADDR'][i])) {
                                var addr = { address: data['ADDR'][i] }
                            } else {
                                var addr = { address: data['ADDR'][0] }
                            }
                            var addrObj = $.extend(nameObj, addr)
                            var modile = { mobile: data['MOBILE'][i] };
                            var modileObj = $.extend(addrObj, modile)
                            newArr.push(modileObj)
                        }
                    }
                } else {
                    var tyObj = {
                        company: company,
                        name: data['NAME'][0] || '',
                        position: position,
                        mobile: data['MOBILE'][0] || '',
                        phone: data['TEL'][0] || '',
                        address: data['ADDR'][0] || ''
                    }
                    newArr.push(tyObj)

                }

                //判斷有没有识别到公司名称,没有则调用文字识别接口识别公司名称
                if (data['COMPANY'][0] === '') {
                    $.ajax({
                        type: 'POST',
                        url: 'https://aip.baidubce.com/rest/2.0/ocr/v1/accurate_basic?access_token=' + access_token,
                        headers: {
                            'Content-Type': 'application/x-www-form-urlencoded;'
                        },
                        data: {
                            image: baiduReader
                        },
                        success: function (res) {
                            console.log(res)
                            var character = res['words_result'];
                            if ($.nui.isEmpty(character)) return fun.toast('识别失败，请重新识别');
                            for (var j = 0; j < character.length; j++) {
                                if (/(纺织)|(布行)|(布业)|(服装)|(服饰)|(制衣)/.test(character[j]['words'])) {
                                    detection = character[j]['words'];
                                    break;
                                }
                            }
                            //赋值公司名称
                            for (var z = 0; z < newArr.length; z++) {
                                newArr[z]['company'] = detection;
                            }
                            setTimeout(function () {
                                api.sendEvent({
                                    name: page_data['return_page'],
                                    extra: {
                                        'status': page_data.type,
                                        'newArr': newArr,
                                        'photo_name': Photo_name
                                    }
                                });
                                api.closeWin();
                            }, 300);
                        }
                    })
                } else {
                    setTimeout(function () {
                        api.sendEvent({
                            name: page_data['return_page'],
                            extra: {
                                'status': page_data.type,
                                'newArr': newArr,
                                'photo_name': Photo_name
                            }
                        });
                        api.closeWin();
                    }, 300);
                }

            }
        }
    })
}

//银行卡识别
function yhkReader(base64, access_token) {
    $.ajax({
        type: 'POST',
        url: 'https://aip.baidubce.com/rest/2.0/ocr/v1/bankcard?access_token=' + access_token,
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded;'
        },
        data: {
            image: base64
        },
        success: function (res) {
            console.log(res)
            var data = res['result'];
            if ($.nui.isEmpty(data)) {
                return fun.toast('请上传银行卡图片')
            } else {
                if ($.nui.isEmpty(data['bank_card_number']) || $.nui.isEmpty(data['bank_name'])) {
                    return fun.toast('识别失败，请重新识别')
                } else {
                    fun.toast('识别成功，已自动生成资料');
                    setTimeout(function () {
                        api.sendEvent({
                            name: page_data['return_page'],
                            extra: {
                                'status': 'yhk',
                                'bank_card_number': data['bank_card_number'],   //卡号
                                'bank_name': data['bank_name'],  //开户行
                                'bank_jc': bank_abbreviation(data['bank_name']),   //简称
                                'photo_name': Photo_name
                            }
                        });
                        api.closeWin();
                    }, 300);
                }
            }
        }
    })
}

//名片_银行卡识别（文字识别）
function moreReader(base64, access_token) {
    $.ajax({
        type: 'POST',
        url: 'https://aip.baidubce.com/rest/2.0/ocr/v1/accurate_basic?access_token=' + access_token,
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded;'
        },
        data: {
            image: base64
        },
        success: function (res) {
            var data = res['words_result'];
            var reg = /[\u4e00-\u9fa5]/g;
            var moreArr = [];
            var bigObj, bank_name, card_number, name, smallObj, card_jc;
            if ($.nui.isEmpty(data) || $.nui.isEmpty(data[0]['words'])) {
                return fun.toast('识别失败，请重新识别')
            } else {
                // fun.toast('识别成功，已自动生成资料');
                for (var i = 0; i < data.length; i++) {
                    var k = moreArr.length - 1;
                    var moreObj = {
                        bank_name: '',
                        card_number: '',
                        name: ''
                    }
                    if ((data[i]['words']).indexOf('银行') > -1 || (data[i]['words']).indexOf('微信') > -1 || (data[i]['words']).indexOf('支付宝') > -1) {
                        bank_name = (((data[i]['words']).match(reg)).join(""));
                        card_number = (data[i]['words']).replace(/[^0-9]/ig, "");
                        name = '';
                        smallObj = {
                            bank_name: bank_name,
                            card_number: card_number,
                            name: name
                        }
                        bigObj = $.extend(moreObj, smallObj);
                        moreArr.push(bigObj)
                    } else if ((data[i]['words']).indexOf('户名') > -1 || (data[i]['words']).indexOf('开户人') > -1) {
                        var num = 0;
                        if ((data[i]['words']).indexOf('户名') > -1) {
                            num = (data[i]['words']).indexOf('户名') + 3;
                            name = (data[i]['words']).slice(num);
                        } else if ((data[i]['words']).indexOf('开户人') > -1) {
                            num = (data[i]['words']).indexOf('开户人') + 4;
                            name = (data[i]['words']).slice(num);
                        }
                        if ($.nui.isTrue(moreArr[k]) && moreArr[k]['name'] === '') {
                            moreArr[k]['name'] = name;
                        } else {
                            bigObj = $.extend(moreObj, name);
                            moreArr.push(bigObj)
                        }
                    } else if (/^[0-9]$/.test(data[i]['words'])) {
                        card_number = data[i]['words'] || '';
                        if ($.nui.isTrue(moreArr[i - 1]) && moreArr[i - 1]['card_number'] === '') {
                            moreArr[i - 1]['card_number'] = card_number;
                        } else {
                            bigObj = $.extend(moreObj, card_number);
                            moreArr.push(bigObj)
                        }
                    } else if ((data[i]['words']).indexOf('卡号') > -1) {
                        num = (data[i]['words']).indexOf('卡号') + 3;
                        card_number = (data[i]['words']).slice(num);
                        if ($.nui.isTrue(moreArr[k]) && moreArr[k]['card_number'] === '') {
                            moreArr[k]['card_number'] = card_number;
                        } else {
                            bigObj = $.extend(moreObj, card_number);
                            moreArr.push(bigObj)
                        }
                    }
                }
                for (var x = 0; x < moreArr.length; x++) {
                    moreArr[x]['card_jc'] = bank_abbreviation(moreArr[x]['bank_name'])
                    moreArr[x]['card_number'] = (moreArr[x]['card_number']).replace(/\s*/g, "")
                }

                //如果为空，可能是识别银行卡
                if ($.nui.isEmpty(moreArr)) {
                    $.ajax({
                        type: 'POST',
                        url: 'https://aip.baidubce.com/rest/2.0/ocr/v1/bankcard?access_token=' + access_token,
                        headers: {
                            'Content-Type': 'application/x-www-form-urlencoded;'
                        },
                        data: {
                            image: base64
                        },
                        success: function (res) {
                            var data = res['result'];
                            if ($.nui.isEmpty(data)) {
                                return fun.toast('请上传银行卡图片')
                            } else {
                                if ($.nui.isEmpty(data['bank_card_number']) || $.nui.isEmpty(data['bank_name'])) {
                                    return fun.toast('识别失败，请重新识别')
                                } else {
                                    fun.toast('识别成功，已自动生成资料');
                                    moreArr.push({
                                        card_jc: bank_abbreviation(data['bank_name']),
                                        bank_name: data['bank_name'],
                                        card_number: data['bank_card_number'].replace(/\s*/g, "")
                                    })
                                    setTimeout(function () {
                                        api.sendEvent({
                                            name: page_data['return_page'],
                                            extra: {
                                                'status': 'mp_yhk',
                                                'moreArr': moreArr
                                            }
                                        });
                                        api.closeWin();
                                    }, 300);
                                }
                            }
                        }
                    })
                } else {
                    fun.toast('识别成功，已自动生成资料');
                    setTimeout(function () {
                        api.sendEvent({
                            name: page_data['return_page'],
                            extra: {
                                'status': 'mp_yhk',
                                'moreArr': moreArr
                            }
                        });
                        api.closeWin();
                    }, 300);
                }

            }
        }
    })
}

//营业执照识别
function businessReader(base64, access_token) {
    $.ajax({
        type: 'POST',
        url: 'https://aip.baidubce.com/rest/2.0/ocr/v1/business_license?access_token=' + access_token,
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded;'
        },
        data: {
            image: base64
        },
        success: function (res) {
            console.log(res)
            var data = res['words_result'];
            if ($.nui.isEmpty(data)) return fun.toast('识别失败，请重新识别');
            if ($.nui.isEmpty(data['单位名称']) || $.nui.isEmpty(data['地址']) || $.nui.isEmpty(data['社会信用代码'])
                || data['单位名称']['words'] === '无' || data['地址']['words'] === '无' || data['社会信用代码']['words'] === '无') {
                return fun.toast('识别失败，请重新识别')
            } else {
                fun.toast('识别成功，已自动生成资料');
                setTimeout(function () {
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'yyzz',
                            'place': data['地址']['words'],   //地址
                            'company': data['单位名称']['words'],  //公司名称
                            'tax': data['社会信用代码']['words'],   //税号
                            'photo_name': Photo_name
                        }
                    });
                    api.closeWin();
                }, 300);
            }
        }
    })
}

//身份证识别
function idReader(base64, access_token) {
    $.ajax({
        type: 'POST',
        url: 'https://aip.baidubce.com/rest/2.0/ocr/v1/idcard?access_token=' + access_token,
        headers: {
            'Content-Type': 'application/x-www-form-urlencoded;'
        },
        data: {
            id_card_side: idCard,
            image: base64
        },
        success: function (res) {
            console.log(res)
            var data = res['words_result'];
            if ($.nui.isEmpty(data)) return fun.toast('识别失败，请重新识别');
            if (idCard === 'front') {
                if ($.nui.isEmpty(data['公民身份号码']) || $.nui.isEmpty(data['出生']) || $.nui.isEmpty(data['姓名']) || $.nui.isEmpty(data['性别']) || $.nui.isEmpty(data['住址']) || $.nui.isEmpty(data['民族'])) {
                    return fun.toast('识别失败，请重新识别')
                } else if ($.nui.isEmpty(data['性别']['words']) || $.nui.isEmpty(data['姓名']['words'])
                    || $.nui.isEmpty(data['民族']['words']) || $.nui.isEmpty(data['住址']['words']) || $.nui.isEmpty(data['出生']['words'])) {
                    return fun.toast('识别失败，请重新识别')
                } else {
                    fun.toast('识别成功，已自动生成资料');
                    setTimeout(function () {
                        api.sendEvent({
                            name: page_data['return_page'],
                            extra: {
                                'status': 'sfz_z',
                                'name': data['姓名']['words'],
                                'sex': data['性别']['words'],
                                'national': data['民族']['words'],
                                'number': data['公民身份号码']['words'],
                                'place': data['住址']['words'],
                                'born': data['出生']['words'],
                                'photo_name': Photo_name
                            }
                        });
                        api.closeWin();
                    }, 300);
                }
            } else {
                if ($.nui.isEmpty(data['签发日期']) && $.nui.isEmpty(data['失效日期']) && data['签发日期']['words'] && data['失效日期']['words']) {
                    return fun.toast('识别失败，请重新识别')
                } else {
                    var fa_data = data['签发日期']['words'];
                    var shi_data = data['失效日期']['words'];
                    if (fa_data.length !== 8 || shi_data.length !== 8) {
                        return fun.toast('识别失败，请重新识别')
                    } else {
                        fun.toast('识别成功，已自动生成资料');
                        var Issue_date = fa_data.slice(0, 4) + '.' + fa_data.slice(4, 6) + '.' + fa_data.slice(7, 8) + '-';
                        var Expiry_date = shi_data.slice(0, 4) + '.' + shi_data.slice(4, 6) + '.' + shi_data.slice(7, 8);
                        setTimeout(function () {
                            api.sendEvent({
                                name: page_data['return_page'],
                                extra: {
                                    'status': 'sfz_b',
                                    'Valid_date': Issue_date + Expiry_date,
                                    'photo_name': Photo_name
                                }
                            });
                            api.closeWin();
                        }, 300);
                    }
                }

            }
        }
    })
}

// 获取token
function getToken() {
    $.ajax({
        type: 'POST',
        url: 'https://aip.baidubce.com/oauth/2.0/token?grant_type=client_credentials&client_id=3Y3AQRg8a8mY3RbZCt62pG2s&client_secret=pvdPgfDaMCCiQ30aSnTafwuEat2hwpyw&',
        success: function (res) {
            access_token = res.access_token;
        }
    })
}

//开户行简称
function bank_abbreviation(data) {
    if (data.indexOf('建设银行') > -1) return '建行';
    if (data.indexOf('招商银行') > -1) return '招行';
    if (data.indexOf('中国银行') > -1) return '中行';
    if (data.indexOf('农业银行') > -1) return '农行';
    if (data.indexOf('交通银行') > -1) return '交行';
    if (data.indexOf('中信银行') > -1) return '中信';
    if (data.indexOf('兴业银行') > -1) return '兴业';
    if (data.indexOf('民生银行') > -1) return '民生';
    if (data.indexOf('网商银行') > -1) return '网商';
    if (data.indexOf('广发银行') > -1) return '广发';
    if (data.indexOf('光大银行') > -1) return '光大';
    if (data.indexOf('浦东发展') > -1) return '浦发';
    if (data.indexOf('平安银行') > -1) return '平安';
    if (data.indexOf('华夏银行') > -1) return '华夏';
    if (data.indexOf('邮政') > -1) return '邮储';
    if (data.indexOf('汇丰银行') > -1) return '汇丰';
    if (data.indexOf('广州银行') > -1) return '广州';
    if (data.indexOf('上海银行') > -1) return '上海';
    if (data.indexOf('北京银行') > -1) return '北京';
    if (data.indexOf('江苏银行') > -1) return '江苏';
    if (data.indexOf('工商银行') > -1) return '工行';
    if (data.indexOf('宁波银行') > -1) return '宁波';
    if (data.indexOf('深圳发展银行') > -1) return '深发';
    if (data.indexOf('浙商银行') > -1) return '浙商';
    if (data.indexOf('微信') > -1) return '微信';
    if (data.indexOf('支付宝') > -1) return '支付宝';
    return '其他';
}

//  图片预览
function previewImg(__this) {
    var img_arr = [];
    $('img').each(function (i, obj) {
        if ($.nui.isTrue($(obj).attr('large-url'))) {
            img_arr.push($(obj).attr('large-url'));
        }
        $(obj).attr('index', i);
    })

    if ($.nui.isEmpty(img_arr)) return;

    photoBrowser.open({
        images: img_arr,
        activeIndex: $(__this).attr('index') || 0,
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        }
    });
}

// 拍照
function photo() {
    QuestPermission.requestPermission('camera', null, function () {
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 100,
            targetWidth: 800,
            targetHeight: 800,
            // saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if (ret.data) addImgToImgs(ret);
            } else { }
        });
    })
}

// 选择相册
function album() {
    QuestPermission.requestPermission(['photos'], null, function () {
        // 20200927 点击很多次确定会返回上一个页面，这里要限制只执行一次
        var UIAlbumBrowserTimer = null;
        var UIAlbumBrowserTimerFlag = true;

        UIAlbumBrowser.imagePicker({
            max: 1,//最多选择图片的数量
            showCamera: false,//禁止访问相机
            styles: {
                bg: '#fff',
                nav: {
                    cancelColor: '#000',//取消按钮颜色
                    nextStepColor: '#000',//确定按钮颜色
                    cancelText: '取消',
                    finishText: '确定'
                },
            },
            // isOpenPreview: true
        }, function (ret) {

            if(UIAlbumBrowserTimerFlag) {
                UIAlbumBrowserTimerFlag = false;
                clearTimeout(UIAlbumBrowserTimer);
                UIAlbumBrowserTimer = null;
                UIAlbumBrowserTimer = setTimeout(function(){
                    UIAlbumBrowserTimerFlag = true;
                }, 1000);

                nextConfirm(ret);
            }

            function nextConfirm(ret) {
                if (ret.eventType == 'nextStep') { // 确定事件
                    var u = navigator.userAgent;
                    var list = ret['list'];
                    if ($.nui.isEmpty(list)) return UIAlbumBrowser.closePicker();
                    fun.UploadRestriction(list, function () {
                        if (u.indexOf('Android') > -1 || u.indexOf('Linux') > -1) {//安卓路径无误
                            UIAlbumBrowser.closePicker();
                            addImgToImgs(list, true);
                        } else if (!!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) { // ios路径需转化,包括iPad
                            UIAlbumBrowser.closePicker();
                            IOSChange(list, function (temporary) {
                                addImgToImgs(temporary, true);
                            })
                        }
                    });
                }
            }
            
            if (ret.eventType === 'cancel') { // 取消事件
                $('#openCamera').hide();
                $('.box').hide();
            }
        })
    });
};

//添加图片
function addImgToImgs(data, Introduction) {
    fun.showLoad();
    var base64 = fun.is_value(data['base64Data']);
    var fileData = {
        data: data,
        index: 0
    };
    if (Introduction) {
        addImgs(data, function (param) {
            fun.imagePickerRender({
                pushHtml: [],
                allImageData: param,
                end: function (params) {
                    var html = params.html || [];
                    $('.yhk-img').html(html.join(''));
                    fun.hideLoad();
                },
                renderHtml: function (params) {
                    var url = fun.is_value(params.imgUrl); // 图片路径
                    var imgName = fun.is_value(params.imgName); // 图片名称
                    var html = params.html || [];
                    var index = params.index;
                    var item = data[index] || {};
                    html.push('    <img src="' + url + '" large-url="' + url + '">');
                    baiduReader = fun.is_value(item['base64']).split(',')[1];
                    businessPhoto = url;
                    Photo_name = imgName;
                }
            });
        })
    } else {
        showSingleData({
            base64: base64,
            fileData: fileData,
            pictureData: data
        });
    }
    $('.yhk-text').show();
    $('#logout').text('上传识别');
    $('#openCamera').hide();
    $('.box').hide();
}

// 拍照渲染
function showSingleData(params) {
    var fileData = params.fileData;
    var pictureData = params.pictureData;

    fun.fileUpload(fileData, function (imgName) {
        var base64 = params.base64;
        var url = fun.is_value(pictureData.data);
        var html = [];
        html.push('    <img src="' + url + '" large-url="' + url + '">');
        $('.yhk-img').html(html.join(''));
        baiduReader = base64.split(',')[1];
        businessPhoto = url;
        Photo_name = imgName;
        fun.hideLoad();
    });
}

// 递归取base64，执行渲染方法
function addImgs(param, callback) {
    if (count >= param.length) {
        count = 0;
        if (typeof callback === 'function') callback(param)
        return param;
    }
    count++;
    fun.getUrlBase64(param[count - 1]['path'], param[count - 1]['suffix'], function (base64) {
        param[count - 1]['base64'] = base64;
        addImgs(param, callback);
    });
}

// 转化iso路径
function IOSChange(list, callback) {
    var temporary = list;
    $.each(list, function (i, item) {
        UIAlbumBrowser.transPath({
            path: item['path'],
            quality: 100
        }, function (res, err) {
            if (res) {
                temporary[i]['path'] = res['path'];
                if (i >= list.length - 1) {
                    if (typeof callback === 'function') callback(temporary);
                }
            }
        });
    })
};

// var vm = {
//     'app_id': '2129749737',
//     'time_stamp': date,
//     'nonce_str': 'fa577ce340859f9fe',
//     'sign': ''
// };
// var data = 'uzomB4PpewVTG18m';
// var signData;
// var date = Math.round(new Date() / 1000);
// function createSign(vm, data) {
//     var sign;
//     var newData = {
//         'app_id': '2129749737',
//         'time_stamp': date,
//         'nonce_str': 'fa577ce340859f9fe',
//         'sign': ''
//     }
//     return new Promise(function (resolve) {
//         //字典排序
//         var aa = ksort(
//             vm,
//             newData
//         )
//         var bb = ""
//         //拼接URL键值对
//         var sortObj = ksort({
//             'app_id': '2129749737',
//             'time_stamp': date,
//             'nonce_str': 'fa577ce340859f9fe',
//             'sign': ''
//         })
//         var str = '';
//         Object.keys(sortObj).forEach(function (key, i) {
//             if (sortObj[key] !== '') {
//                 str += key + '=' + encodeURIComponent(sortObj[key]) + '&'
//             }
//         });

//         // 拼接app_key
//         var code = str + 'app_key=uzomB4PpewVTG18m'

//         // MD5运算
//         var md5Code = $.nui.md5(code);

//         // 转换大写
//         sign = md5Code.toUpperCase();
//         resolve(sign);
//     })
// }


// function ksort(obj) {
//     var keys = Object.keys(obj).sort(),
//     sortedObj = {};

//     for (var i in keys) {
//         sortedObj[keys[i]] = obj[keys[i]];
//     }
//     return sortedObj;
// }

// function MJ(img){

//     createSign(vm, data)
//         .then(function (data) {
//             signData = data;
//         })
//     $.ajax({
//         type: 'POST',
//         headers: {
//             'Content-Type': 'application/x-www-form-urlencoded;'
//         },
//         url: 'https://api.ai.qq.com/fcgi-bin/ocr/ocr_bcocr',
//         data:{
//             "app_id":"2129749737",
//             "time_stamp":date,
//             "nonce_str":"fa577ce340859f9fe",
//             "sign": signData,
//             "image": img
//         },
//         success:function(res){
//             console.log(res)
//             console.log(signData)
//         }
//     })
// }
