var html_name = page_arr.bills_zsmx; //页面名称
var Bills = Bills || {},    //开单配置项
    photoBrowser = {},      //大图浏览
    jjsfssl,                //计价数反算出库数
    __PAGE_DATA = {},       //页面数据
    back_ori_data = {},     //点击返回前的原始数据
    back_save_data = {},    //点击返回时的保存数据
    showFs = true,          //显示计价数反算出库数 开关
    cache_data = {},        //缓存一些数据
    __JL_DATA = [],         //所有记录行数据
    __CP_YS_JL = [],        //所有相同产品记录行数据
    ROW_DATA = {},          //当前页面记录行数据
    target_page = '',       //点击完成要返回哪个页面
    finally_page = '',      //点击完成要返回哪个页面
    hsdj_fixed = 4,         //单价默认显示4位小数
    delMxData = [],         //存储删除的明细数据
    isClear = false,
    IS_TMMX_DEL = false,
    PAGE_INIT_DATA = {},    //删除时初始化页面数据
    is_update_phsz = false,
    psslTmpDisabled = [];   //匹数数量临时禁用掉的数组

// Bills['config'] = Bills['config'] || {};        //开单配置项
Bills['wldw_type'] = '';                        //往来单位类型
Bills['WldwSubInfo'] = {};                      //往来单位子信息

Bills['config'] = {
    fy_zdy: 'bpxszdyfy',            // 布匹-销售自定义费用
    ck_zdy: 'bpckzdygl',            // 仓库自定义字段
    kd_zdy: 'bpkdzdyzd',            // 开单自定义字段
    dckms: 'dckms_bp',              // 多仓库模式
    adjs: 'adjs_bpxs',              // 按单结算
    dwgshsbl: 'dwgshsbl_bp',        // 单位公式换算保留位数
    jesswr: 'jesswr_bpxs',          // 金额四舍五入
    bdjesswr: 'bdjesswr_bpxs',      // 本单金额四舍五入
    dddjwlcddj: 'dddjwlcddj_bpxs',  // 订单单价为0重读单价
    qyssjms: 'qyssjms_bp'
};

Bills['config']['dwgshsbl'] = 'dwgshsbl_bp';    //单位公式换算保留
Bills['AJAX_URL'] = {
    'getDj': AJAX_URL.getBpXsDjAndScdj,         //获取单价
};
fun.clearItem('cp_list');           //清除本地产品缓存数据

var SYS_CONFIG = {},   //系统设置
    cp_list = [],         //产品列表
    jjdw_list = [];     //单位列表


var $this_height;
var px_rem = fun.fontUnit(12.75);
var longClick = 0;

// 标题栏初始化
$('#header').header({
    title: '&nbsp;',
    text_btn: true,
    text_val: '去结算',
    much: true, //更多
    appendBackBtnEvt: backCallback
});

/* 
    实售金额 = 实售数 * 实售单价
    实售总金额 = 实售额 + 5个费用
    回扣 = 含税总金额 - 实售总金额
*/
var billZsmx = {
    computedSsje: function () { // 计算实售金额
        var ssdj = fun.toNumber($('#ssj').val().trim()) || 0;
        var sssl = fun.toNumber($('#sss').val().trim()) || 0;
        return ($.nui.decimalMul(ssdj, sssl)).fixed();
    },
    computedSszje: function () { // 计算实售总金额
        var ssje = this.computedSsje(); // 实售额
        var zdyFy = this.computedCustomMoney(); // 自定义费用
        return ($.nui.decimalAdd(ssje, zdyFy)).fixed();
    },
    computedCustomMoney: function () {
        return (function () { // 自定义费用
            var total = 0;
            for (var i = 1; i <= 5; i++) {
                var fyZdy = 'fy_zdy' + i;
                total += fun.toNumber(ROW_DATA[fyZdy] || 0);
            }
            return total.fixed();
        })();
    },
    computedHk: function () { // 计算回扣
        return ($.nui.decimalSub(fun.toNumber(ROW_DATA['hszje'] || 0), fun.toNumber(ROW_DATA['sszje'] || 0))).fixed();
    },
    upDateSszje: function () {
        $('#ssje').val(this.computedSszje());
    },
    upDateHk: function () {
        $('#hk').val(this.computedHk());
    },
    setJjsl: function () {
        $('#jjsl_val').val(ROW_DATA['jjsl']);
    },
    lastProductColorName: '',
    upDateLastProductColorName: function (data) {
        this.lastProductColorName =
            $.nui.isEmpty(data.cp_ys_mc) ? data['cp_ys_bh'] : data['cp_ys_bh'] + ' ' + data['cp_ys_mc'];
    },
    nowProductColorName: function (data) {
        return $.nui.isEmpty(data.cp_ys_mc) ? data['cp_ys_bh'] : data['cp_ys_bh'] + ' ' + data['cp_ys_mc'];
    },
    editPrice: {},
};

billZsmx.isOpenQyssjmsBp = function () {
    return !!Number(SYS_CONFIG[Bills['config']['qyssjms']]);
}

billZsmx.authShow = function () {
    if (this.isOpenQyssjmsBp()) {
        switch (page_data['djlx']) {
            case 'bp_xsfhjs':
            case 'bp_xsthjs':
            case 'bp_xsdd':
                $('#ssjms_wrap, .kickback-wrap').css({
                    display: 'flex'
                })
                break;
        }
    }
}

// 单据类型是否是销售发货结算、采购退货结算
billZsmx.djlxIsXscgthjs = function () {
    var djlxArr = ['bp_xsfhjs', 'bp_cgthjs'];
    return djlxArr.indexOf(page_data['djlx']) > -1;
}

// 当前明细布匹有关联条码 且 对应仓库有开启明细管理
billZsmx.enabledMxgl = function (mxData) {
    mxData = mxData || [];
    return $.nui.isTrue(mxData) && fun.toNumber(mxData.tm_sl) > 0;
}

billZsmx.clothChoiceActive = function () {
    return this.djlxIsXscgthjs() && 'bpck-choice';
}

billZsmx.clothUnActive = function () {
    return this.djlxIsXscgthjs() && 'bpck-color';
}

billZsmx.addMxInactive = function (mxData) {
    mxData = mxData || [];
    return this.enabledMxgl(mxData) && mxData.sl < mxData.tm_sl && this.clothUnActive();
}

billZsmx.addMxActive = function (mxData) {
    mxData = mxData || [];
    return this.enabledMxgl(mxData) && mxData.sl < mxData.tm_sl && this.clothChoiceActive();
}

$('#complete_btn').hide();
var winHeight = $(window).height(); //获取当前页面高度
$(window).resize(function () {
    var thisHeight = $(this).height();
    if (winHeight - thisHeight > 50) {
        $('.layer-content').css('visibility', 'hidden');
        setPanelHide();
    } else {
        $('.layer-content').css('visibility', 'visible');
    }
});

setPanelHide();

// apicloud页面初始化
page_init = function () {

    photoBrowser = api.require('photoBrowser');

    SYS_CONFIG = fun.getItem('sys_config') || {};   //系统设置
    cp_list = fun.getItem('cp_list') || [];         //产品列表
    jjdw_list = fun.getItem('jjdw_list') || [];     //单位列表

    fun.keyboardEject('.record_added');
    fun.setHeaderLocation('.content-wrap');//解决ios头部定位失效
    $('.collapse-wrap').css('top', api.safeArea.top - 17 + 'px');

    // 预加载数据
    fun.load_DATA_LIST(['cp'], function () {
        cp_list = fun.getItem('cp_list') || []; //产品列表
    });

    fun.load_DATA_LIST(['jjdw', 'sys_config'], function () {
        jjdw_list = fun.getItem('jjdw_list') || []; //单位列表
        SYS_CONFIG = fun.getItem('sys_config') || {}; //系统设置
        billZsmx.authShow();
    });

    if ($.nui.isTrue(page_data['__route'])) {
        __PAGE_DATA = page_data['kdbj_tmp'];
    } else {
        __PAGE_DATA = page_data;
    }

    __PAGE_DATA['ck_info'] = __PAGE_DATA['ck_info'] || {};

    __JL_DATA = __PAGE_DATA['__JL_DATA'] || [];

    __PAGE_DATA['__DJ_DATA'] = __PAGE_DATA['__DJ_DATA'] || {};

    $('#complete_btn').show();

    page_data.keyback = function () {
        backCallback();
    };

    init();

    // 初始化已添加颜色记录
    initColorAdd();

    if ($.nui.isTrue(__PAGE_DATA['__PAGE_EDIT'])) {
        $('.color-wrap').css('display', 'inline-block');
        $('.color-search-label').css('display', 'inline-block');

    } else {
        $('.color-search-label,.color-wrap').hide();
    }

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        console.log(temp);
        switch (temp['status']) {
            case 'select_list':
                if (temp['data']['page_type'] == 'cp_ys') {
                    if (temp['data']['clearData']) {
                        resetData();
                    }
                }
                setSelectedValue({
                    data: temp['data']
                });
                break;
            // case 'fhjs_dkc':
            //     var list = temp['data']['list'];
            //     break;
            case 'goodsdata':
                $('#gg').val(temp['name']).data('ggid', temp['id']);
                break;
        }
    });
    fun.inputType();
    // bindEvent();
};

// 初始化已添加颜色记录 --new
function initColorAdd() {
    __CP_YS_JL = [];
    for (var i = 0; i < __JL_DATA.length; i++) {
        if ($.nui.isEmpty(__JL_DATA[i]['__row_uuid'])) {
            __JL_DATA[i]['__row_uuid'] = $.nui.getRandomNum();
        }
        if ($.nui.isTrue(__JL_DATA[i]['is_delete'])) continue;
        if (__JL_DATA[i]['cp_id'] == ROW_DATA['cp_id']) {
            __CP_YS_JL.push(__JL_DATA[i]);
        }
    }

    if (__CP_YS_JL.length >= 1) {
        $('.record_added').show();
    } else {
        $('.record_added').hide();
    }
}

// 设置颜色功能按钮显示 --new
function setColorBtnDisplay() {
    if ($.nui.isTrue($('#color_search').data('cp_ys_id'))) {
        $('.color-search-label,.color-wrap').css('display', 'inline-block');
    } else {
        $('.color-search-label,.color-wrap').hide();
    }

    // if ($.nui.isTrue(__PAGE_DATA['__PAGE_EDIT'])) {
    // //     $('.color-wrap').show();
    // //     $('.color-search-label').css('display','inline-block');

    // } else {
    //     $('.color-search-label,.color-wrap').hide();
    // }
}

// 初始化页面布局 --new
function initPageLayout() {
    // placeholder居中
    if (api.systemType == 'ios') {
        $('.ps-input,.sl-input').addClass('ios-placeholder');
    }

    if (api.uiMode == 'pad') {
        $('.ps-input,.sl-input').addClass('pad-placeholder');
    }

    if (page_data['djlx'] == 'kc_bppyd') {
        if (!Auth.check('yxckbpcbj', 'view')) {
            // $('.show-dj').hide();
        } else {
            // $('.show-dj').show();
        }
    } else {
        // $('.show-dj').show();
    }

    if (__PAGE_DATA['bj_type'] == 'zs') {
        $('.show-xs-tips').show();

        switch (page_data.djlx) {
            case 'bp_xsfhjs':
            case 'bp_cgthjs':
            case 'kc_bptbd':
                $('.ckdkc-show').show();
                break;
            default:
                $('.ckdkc-show').hide();
                break;
        }

        $('#cloth_wrap').hide();
    } else {
        $('.show-xs-tips').hide();
        $('#cloth_wrap').show();
        if ($.nui.isEmpty(__PAGE_DATA['edit_row'])) {
            if (!billZsmx.checkCkWinAndTm()) {
                setTimeout(function () {
                    $('.add-item').trigger('tap');
                }, 20);
            }
        }
    }

    switch (page_data['djlx']) {
        case 'bp_xsfhjs':
        case 'bp_xsthjs':
        case 'bp_xsdd':
            $('.lx-box').css('visibility', 'visible');
            break;
        case 'bp_cglhjs':
        case 'bp_cgthjs':
        case 'bp_cgdd':
            $('#lx').attr('disabled', true);
            break;
        case 'kc_bppyd':
        case 'kc_bptbd':
        case 'kc_bpmxpkd':
        case 'kc_bpzspd':
            $('#lx').attr('disabled', true);
            break;
        default:
            $('#lx').attr('disabled', true);
            break;
    }

    showPhszHtml(function () {
        $('#fk').val(ROW_DATA['fk'] || '');
        $('#kz').val(ROW_DATA['kz'] || '');
        $('#gg').val(ROW_DATA['gg'] || '');
        $('#gh').val(ROW_DATA['gh'] || '');
    });
}

// 初始化其他配置
function initBillsConfig() {
    if (['bp_cgthjs', 'bp_cglhjs'].indexOf(Bills['djlx']) > -1) {           // 采购模块处理
        Bills.config.fy_zdy = 'bpxszdyfy';
        Bills.config.adjs = 'adjs_bpcg';
        Bills.config.jesswr = 'jesswr_bpcg';
        Bills.config.bdjesswr = 'bdjesswr_bpcg';
        Bills.config.dddjwlcddj = 'dddjwlcddj_bpcg';
    } else if (['kc_bppyd', 'kc_bptbd'].indexOf(Bills['djlx']) > -1) {      // 库存模块处理
        Bills.config = {
            ck_zdy: 'bpckzdygl', // 仓库自定义字段
            dckms: 'dckms_bp',   // 多仓库模式
            dwgshsbl: 'dwgshsbl_bp', // 单位公式换算保留位数
        };
        if (Bills['djlx'] === 'kc_bppyd') {
            Bills.config.kd_zdy = 'bpkdzdyzd';
        }
    }
}

// 创建可编辑的页面代码 --new
function getPageHtml() {
    var html = [];

    switch (page_data.djlx) {
        case '':
            break;
        default:
            break;
    }

    return html.join('');
}

// 显示幅宽克重规格缸号html代码 --new
function showPhszHtml(callback) {
    var html = [];
    var ghHtml = [];
    var tmp_sys_config = fun.getItem('sys_config') || {};
    var kdphsz = tmp_sys_config['kdphsz'] || '';
    var arr = kdphsz.split(',') || [];

    var fkkz_show = (kdphsz.indexOf('fk,kz') > -1) ? '' : 'display:none;';
    var gg_show = (kdphsz.indexOf('gg') > -1) ? '' : 'display:none;';
    var gh_show = (kdphsz.indexOf('gh') > -1) ? '' : 'display:none;';

    html.push('<div class="fk-wrap" style="' + fkkz_show + '">');
    html.push('     <label for="fk" class="label-text">幅宽</label>');
    html.push('     <input id="fk" type="text" class="" placeholder="">');
    html.push('</div>');
    html.push('<div class="kz-wrap" style="' + fkkz_show + '">');
    html.push('     <label for="kz" class="label-text">克重</label>');
    html.push('     <input id="kz" type="text" class="" placeholder="">');
    html.push('</div>');
    html.push('<div class="gg-wrap" style="' + gg_show + '">');
    html.push('     <label for="gg" class="label-text">规格</label>');
    html.push('     <input id="gg" type="text" class="" placeholder="" readonly="readonly">');
    html.push('</div>');

    var fkkz_disabled = $('#fk').attr('disabled') || $('#kz').attr('disabled');
    var gg_disabled = $('#gg').attr('disabled');
    var gh_disabled = $('#gh').attr('disabled');

    if (arr.length > 3) {
        $('.fkkzgggh').html(html.join(''));
        if ($('.only-gh').length) {
            $('.only-gh').remove();
        }
        ghHtml.push('<div class="gh-wrap" style="' + gh_show + '">');
        ghHtml.push('     <label for="gh" class="label-text">缸号</label>');
        ghHtml.push('     <input id="gh" type="text" class="" placeholder="">');
        ghHtml.push('</div>');
        $('.fkkzgggh').after('<li class="only-gh">' + ghHtml.join('') + '</li>');
    } else {
        html.push('<div class="gh-wrap" style="' + gh_show + '">');
        html.push('     <label for="gh" class="label-text">缸号</label>');
        html.push('     <input id="gh" type="text" class="" placeholder="">');
        html.push('</div>');

        $('.fkkzgggh').html(html.join(''));
        if ($('.only-gh').length) {
            $('.only-gh').remove();
        }
    }

    if (fkkz_show && gg_show && gh_show) {
        $('.fkkzgggh').hide();
    } else {
        $('.fkkzgggh').show();
    }

    for (var i = 0; i < $('.fkkzgggh>div:visible').length; i++) {
        var _dom = $('.fkkzgggh>div:visible').eq(i);
        if (i == 0 || i == 3) {
            _dom.css('width', '30%');
        } else {
            _dom.css('width', '35%');
        }
    }
    $('#fk,#kz,#gg,#gh').val('');

    if (fkkz_disabled) {
        $('#fk,#kz').attr('disabled', true);
    }
    if (gg_disabled) {
        $('#gg').attr('disabled', true);
    }
    if (gh_disabled) {
        $('#gh').attr('disabled', true);
    }

    if (typeof callback === 'function') callback();
}

// 页面数据初始化
function init(options) {
    var _options = $.extend({ setColorEmpty: false }, options);

    // 初始化页面布局
    initPageLayout();
    initEditDom();

    if (page_data.hsdj_fixed) { // 单价显示位数处理
        hsdj_fixed = page_data.hsdj_fixed;
        $('#dj').attr('decimal_digits', hsdj_fixed);
    }

    jjsfssl = fun.getItem(page_data['djlx'] + '_jjsfssl') || false;//计价数反算出库数

    switch (page_data['djlx']) {
        case 'bp_xsfhjs':
            target_page = page_arr.xs_fhjs_kd;
            finally_page = page_arr.xs_fhjs_kd;
            Bills['wldw_type'] = 'kh';
            $('.dkc-item').show();
            break;
        case 'bp_xsthjs':
            target_page = page_arr.xs_thjs_kd;
            finally_page = page_arr.xs_thjs_kd;
            Bills['wldw_type'] = 'kh';
            // $('.stock-btn').hide();
            $('.dkc-item').hide();
            break;
        case 'bp_cglhjs':
            target_page = page_arr.cg_lhjs_kd;
            finally_page = page_arr.cg_lhjs_kd;
            Bills['AJAX_URL']['getDj'] = AJAX_URL.getBpCgDjAndScdj; //获取单价
            Bills['wldw_type'] = 'gys';
            // $('.stock-btn').hide();
            $('.dkc-item').hide();
            // $('.lx-block').hide();
            break;
        case 'bp_cgthjs':
            target_page = page_arr.cg_thjs_kd;
            finally_page = page_arr.cg_thjs_kd;
            Bills['AJAX_URL']['getDj'] = AJAX_URL.getBpCgDjAndScdj; //获取单价
            Bills['wldw_type'] = 'gys';
            // $('.lx-block').hide();
            $('.dkc-item').show();
            break;
        default:
            if (page_data['djlx'] === 'kc_bppyd') {
                $('#dj_display').text('成本');
            }
            if (page_data['djlx'] === 'kc_bppyd' || page_data['djlx'] === 'kc_bpzspd') {
                Bills['AJAX_URL']['getDj'] = AJAX_URL.getKccpCbj;       // 获取成本价
            }
            if (page_data['djlx'] == 'kc_bptbd') {
                $('.dkc-item').show();
            }
            target_page = page_data.return_page;
            finally_page = page_data.return_page;
            break;
    }
    Bills['djlx'] = page_data['djlx'];

    switch (page_data['djlx']) {
        case 'bp_xsfhjs':
        case 'bp_xsthjs':
        case 'bp_cglhjs':
        case 'bp_cgthjs':
        case 'bp_xsdd':
        case 'bp_cgdd':
            $('.jj-wrap,.djjelx').show();
            $('.je-wrap').css('visibility', 'visible');
            break;
        default:
            $('.jj-wrap').hide();
            $('.je-wrap').css('visibility', 'hidden');
            if (page_data['djlx'] == 'kc_bppyd') {
                if (!Auth.check('yxckbpcbj', 'view')) {
                    $('.show-dj').css('visibility', 'hidden');
                    $('#dj').attr('disabled', true);
                } else {
                    $('.show-dj').css('visibility', 'visible');
                    $('#dj').removeAttr('disabled');
                    $('.djjelx').show();
                    $('.je-wrap').css('visibility', 'visible');
                }
            } else if (page_data['djlx'] == 'kc_bptbd') {
                $('.djjelx').hide();
            } else {
                $('.show-dj').css('visibility', 'visible');
                $('#dj').removeAttr('disabled');
            }
            break;
    }

    // 设置金额处理类型
    initBillsConfig();

    var cp_list = fun.getItem('cp_list') || [];

    var list_data = __PAGE_DATA['list_data'] || {};

    // 标题初始化
    afterInitHeader(list_data);

    // 初始化图片
    initImgs(list_data);

    $('#dw').text(list_data['dw_mc'] || '单位').data('dw_id', list_data['dw_id'] || 0);

    $('#color_search').val((list_data['cp_ys_bh'] || '') + ' ' + (list_data['cp_ys_mc'] || '')).data({
        'cp_ys_id': list_data['cp_ys_id'],
        'cp_ys_bh': list_data['cp_ys_bh'],
        'cp_ys_mc': list_data['cp_ys_mc']
    });

    if ($.nui.isTrue(__PAGE_DATA['edit_row'])) {
        $('#color_search').val((list_data['cp_ys_bh'] || '') + (list_data['cp_ys_mc'] || ''));
        $('#color_search').data({
            'cp_ys_id': list_data['cp_ys_id'],
            'cp_ys_bh': list_data['cp_ys_bh'],
            'cp_ys_mc': list_data['cp_ys_mc']
        });

        $('#dj').val(list_data['hsdj'] || 0);

        $('#je').val(list_data['hszje'] || 0);
        var ssje = 0;
        switch (page_data.djlx) {
            case 'bp_xsfhjs':
            case 'bp_xsdd':
            case 'bp_xsthjs':
                // if (page_data.djlx == 'bp_xsdd') {
                //     ssje = list_data['ssje'] || 0;
                // } else {
                //     ssje = list_data['sszje'] || 0;
                // }
                ssje = list_data['sszje'] || 0;

                $('#ssj').val(list_data['ssdj'] || 0); // 实售价
                $('#ssje').val(ssje); // 实售额
                $('#sss').val(list_data['sssl'] || 0); // 实售数
                $('#hk').val($.nui.decimalSub((list_data['hszje'] || 0), ssje)); // 回扣

                ROW_DATA['sssl'] = list_data['sssl'];
                break;
        }

        $('#lx').text(list_data['jg_lx_mc'] || '大货').data('jg_lx', list_data['jg_lx'] || 'dh');

        $('#fk').val(list_data['fk'] || '');
        $('#kz').val(list_data['kz'] || '');
        $('#gg').val(list_data['gg'] || '');
        $('#gh').val(list_data['gh'] || '');

        $('#ps').val(parseInt(list_data['ps'] || 0) || 0);
        $('#sl').val(list_data['zsl'] || '');
        $('#jjsl_val').val(list_data['jjsl'] || 0);

        $('#dw').text(list_data['dw_mc'] || '').data('dw_id', list_data['dw_id'] || 0);

        $('#sel_jjdw').text(list_data['jjdw_mc']).data('jjdw_id', list_data['jjdw_id']);
        $('#jjdw').text(list_data['jjdw_mc']).data('jjdw_id', list_data['jjdw_id']);

        if (list_data['cp_ys_bh'] === '色卡') {
            $('#lx,#dw,#jjdw').attr('disabled', true);
        }

        setJjslColor();

        ROW_DATA = $.extend({}, list_data);

        cache_data['mx'] = (list_data['mx'] || []).slice(0);

        if ($.nui.isTrue((list_data['mx'] || []))) {
            $('.show-xs-tips').hide();
            $('#cloth_wrap').show();
        }

        showMxList(list_data['mx'] || []);

        // 当前记录行 是调用 销售订单 生成的，则以下字段不允许编辑：商品编号、商品名称、色号、颜色、客户、类型
        if ($.nui.isTrue(list_data['dd_jl_id']) || $.nui.isTrue(list_data['ckd_jl_id'])) {
            $('#lx,#color_search,#color').attr('disabled', true);
        }

        setPageDomDisabled(list_data);

        if (!__PAGE_DATA['__PAGE_EDIT']) {
            $('input,#dw,#jjdw,#sel_jjdw,.cloth-mx-item,#cloth_wrap,#toggle,#color_search,#color').attr('disabled', true);
            $('.add-item,.dkc-item').hide();
        }

        var curr_cp_info = fun.getListInfoByKey(cp_list || [], list_data['cp_id']) || {};

        PAGE_INIT_DATA = {
            cp_id: curr_cp_info['id'] || 0,
            cp_bh: curr_cp_info['number'] || '',
            cp_mc: curr_cp_info['name'] || '',
            cp_ys_id: 0,
            cp_ys_bh: '',
            cp_ys_mc: '',
            fzsh: '',
            fzys: '',
            kcms: curr_cp_info['diff'] || '+',
            imgs: (curr_cp_info['imgs'] && curr_cp_info['imgs'].split(',')[0]) || '',
            dw_id: curr_cp_info['unit_id'] || 0,
            dw_mc: curr_cp_info['unit_name'] || '',
            fk: curr_cp_info['width'] || '',
            kz: curr_cp_info['weight'] || '',
            gg: curr_cp_info['spec'] || '',
            cf: curr_cp_info['component'] || '',
            unit_options: curr_cp_info['unit_options'] // 计价数量
        };
    } else {
        var list_cp_info = fun.getListInfoByKey(cp_list || [], list_data['cp_id']) || {};
        list_data['fzbh'] = fun.getValByKey(cp_list || [], list_data['cp_id'], 'assistant_number') || '';
        list_data['fzmc'] = fun.getValByKey(cp_list || [], list_data['cp_id'], 'assistant_name') || '';

        list_data['fk'] = list_cp_info['width'] || '';
        list_data['kz'] = list_cp_info['weight'] || '';
        list_data['gg'] = list_cp_info['spec'] || '';

        $('#fk').val(list_data['fk'] || '');
        $('#kz').val(list_data['kz'] || '');

        if (list_data['cp_ys_bh'] === '色卡') {
            shSkLx();
        } else {
            if (fun.getValByKey(fun.getItem('ck_list') || [], ((__PAGE_DATA['ck_info'] && __PAGE_DATA['ck_info']['id']) || 0), 'type') === 'skyb') {
                if (list_data['dw_mc'] === '份' || list_data['jjdw_mc'] === '份') {
                    list_data = $.extend(true, { cp_id: list_data['cp_id'] }, list_data);
                    __setUnit(list_data);
                } else {
                    __setUnit(list_data);
                }
            } else {
                __setUnit(list_data);
            }
        }

        updateLx();


        if ($.nui.isTrue(page_data['__route'])) {
            if ($.nui.isTrue(page_data['ys_tmp'])) {
                var ys_info = page_data['ys_tmp'];
                if (_options['setColorEmpty']) {
                    list_data['cp_ys_id'] = 0;
                    list_data['cp_ys_bh'] = '';
                    list_data['cp_ys_mc'] = '';
                } else {
                    list_data['cp_ys_id'] = ys_info['id'];
                    list_data['cp_ys_bh'] = ys_info['number'];
                    list_data['cp_ys_mc'] = ys_info['name'];
                }

                $('#color_search').val((list_data['cp_ys_bh'] || '') + ' ' + (list_data['cp_ys_mc'] || '')).data({
                    'cp_ys_id': list_data['cp_ys_id'],
                    'cp_ys_bh': list_data['cp_ys_bh'],
                    'cp_ys_mc': list_data['cp_ys_mc']
                });

                if (list_data['cp_ys_bh'] === '色卡') {
                    shSkLx();
                } else {
                    if (fun.getValByKey(fun.getItem('ck_list') || [], ((__PAGE_DATA['ck_info'] && __PAGE_DATA['ck_info']['id']) || 0), 'type') === 'skyb') {
                        if (list_data['dw_mc'] === '份' || list_data['jjdw_mc'] === '份') {
                            list_data = $.extend(true, { cp_id: list_data['cp_id'] }, list_data);
                            __setUnit(list_data);
                        } else {
                            __setUnit(list_data);
                        }
                    } else {
                        __setUnit(list_data);
                    }
                }

                updateLx();
                updateDj();
            }
        }
        PAGE_INIT_DATA = $.extend({}, list_data);
    }


    ROW_DATA = $.extend({}, list_data);
    billZsmx.upDateLastProductColorName(ROW_DATA);

    // 如果进入的窗口是 ：客户订单、采购订单、采购来货结算、销售退货结算。
    // 如果进入的窗口是：销售开单、采购退货结算 且 当前仓库没有开启：条码管理。

    switch (page_data['djlx']) {
        case 'bp_xsdd':
        case 'bp_cgdd':
        case 'bp_cglhjs':
        case 'bp_xsthjs':
        case 'kc_bppyd':
        case 'kc_bptbd':
            $('#gg').val(ROW_DATA['gg'] || '');
            break;
        case 'bp_xsfhjs':
        case 'bp_cgthjs':
            if ($.nui.isEmpty(fun.getHouseValue(ROW_DATA['ck_id'], 'is_bar'))) {
                $('#gg').val(ROW_DATA['gg'] || '');
            }
            break;

    }

    // 盘盈单、调拨单开单，部分字段隐藏
    if (page_data.djlx === 'kc_bppyd' || page_data.djlx === 'kc_bptbd') {
        if (!page_data.ck_info) {
            page_data.ck_info = page_data.kdbj_tmp.ck_info;
        }
        // $('.stock-btn').hide();
        $('.dkc-item').hide();
        // $('.lx-block').hide();
        // $('.jj').hide();
        if (page_data.djlx === 'kc_bptbd') { // 调拨单，还需要隐藏单价这一行
            // $('.row1').hide();
            // $('.dbd-show').show();
            // $('.dbd-show .stock-btn').show();
            $('.dkc-item').show();
        }
    }

    // 页面不可编辑时，调库存按钮不可编辑并隐藏
    if (!__PAGE_DATA['__PAGE_EDIT']) {
        $('.stock-btn').attr('disabled', true);
        $('.stock-btn').hide();
        $('.dkc-item').attr('disabled', true);
        $('.dkc-item').hide();
    }

    if (!$('#ps').attr('disabled')) {
        psslTmpDisabled.push('ps');
    }
    if (!$('#sl').attr('disabled')) {
        psslTmpDisabled.push('sl');
    }

    back_ori_data = getRowSaveData();
}

// 标题初始化后 --new
function afterInitHeader(list_data) {
    $('#header_title').html((list_data['cp_bh'] || '') + ' ' + (list_data['cp_mc'] || ''));
    $('#header_title').data({
        cp_id: list_data['cp_id'],
        cp_bh: list_data['cp_bh'],
        cp_mc: list_data['cp_mc'],
    });
    if (__PAGE_DATA['__PAGE_EDIT']) {
        $('#complete_btn').show();
    } else {
        $('#complete_btn').hide();
    }
}

// 初始化图片 --new
function initImgs(list_data) {
    var img_url;
    if (list_data['imgs']) {
        img_url = fun.getImgPath(list_data['imgs']);
    } else if (list_data['cp_imgs']) {
        img_url = fun.getImgPath(list_data['cp_imgs']);
    } else {
        img_url = "../img/logo.png";
    }
    if (img_url == "../img/logo.png") {
        $('.img-box').css({
            'background-color': '#f5f5f5',
            'border-radius': '0.25rem',
        });
    } else {
        $('#preview').attr('src', img_url).css({
            'width': '100%',
            'height': '100%',
            'opacity': 1,
            'margin': 0,
        });
        $('.img-mask').show();
    }
}

//点击返回，或按键返回触发
function backCallback() {

    var flag = getRowMxData();
    if (!flag) return;

    back_save_data = getRowSaveData();
    var tmp_return_page = page_data['return_page'];

    if ($.nui.isTrue(page_data['__route'])) {
        if (page_data['kdbj_tmp']) {
            page_data['return_page'] = page_data['kdbj_tmp']['return_page'];
            target_page = page_data['return_page'];
        }
        //     var __opt = {html_name: html_name, page_data: page_data};
        //     // __opt.page_data[html_name] = __JL_DATA;
        //     __opt.page_data['ck'] = fun.getListInfoByKey(fun.getItem('ck_list'), ROW_DATA['ck_id']) || {};
        //     __opt.page_data['wldw'] = page_data['wldw'];
        //     __opt.page_data['xsjs_tmp'] = {
        //         __JL_DATA: __JL_DATA
        //     };
        //
        //     PageShow.gotoNextPage(__opt);
        //     return;
    }

    // 数据没有修改，直接返回上一页
    if ($.nui.isObjEquals(back_ori_data, back_save_data)) {
        if ($.nui.isTrue(page_data['__route'])) {
            if (page_data.djlx === 'kc_bppyd' || page_data.djlx === 'kc_bptbd') { // 盘盈单、调拨单开单
                closeAndSendEvent();
            } else {
                api.closeToWin({ name: tmp_return_page });
            }
        } else {
            closeAndSendEvent();
        }
        return;
    }

    __setRowData(null, {}, { hsdj_fixed: hsdj_fixed, upDateSssl: false }); // 点击返回不需要换算实售数量

    api.sendEvent({
        name: finally_page,
        extra: {
            'status': 'update_phsz',
            'data': {

            }
        }
    });

    if (__PAGE_DATA['MXTM']) {
        var __result = mxRow();

        switch (__result['status']) {
            case 'ok':
                api.sendEvent({
                    name: __PAGE_DATA['return_page'],
                    extra: {
                        'status': __result['state'] ? 'update_row' : 'delete_row',//update_mxbp
                        'data': {
                            row_index: __PAGE_DATA['row_index'],
                            row_data: ROW_DATA,
                        }
                    }
                });
                api.closeToWin({
                    name: finally_page
                });
                break;
        }
    } else {
        if ($.nui.isEmpty(__PAGE_DATA['edit_row']) && $.nui.isEmpty(ROW_DATA['zsl']) && $.nui.isEmpty(ROW_DATA['ps'])) {
            // if (isClear) {
            //     isClear = false;
            //     jumpToPage();
            // } else {
            return closeAndSendEvent();
            // }
        } else {
            if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && ($.nui.isTrue(parseFloat(ROW_DATA['zsl'] || 0)) || $.nui.isTrue(parseInt(ROW_DATA['ps'] || 0)))) return fun.toast('请选择颜色！');

            if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && $.nui.isEmpty(ROW_DATA['zsl']) && $.nui.isEmpty(ROW_DATA['ps'])) {
                if ($.nui.isTrue(page_data['__route'])) {
                    api.closeToWin({ name: tmp_return_page });
                } else {
                    closeAndSendEvent();
                }
                return;
            }

            // if (page_data['djlx'] == 'bp_xsthjs') {
            //     if ($.nui.isEmpty(ROW_DATA['zsl']) && $.nui.isEmpty(ROW_DATA['ps'])) return fun.toast('请填写数量或匹数！');
            // } else {
            //     if ($.nui.isEmpty(ROW_DATA['zsl'])) return fun.toast('请填写数量！');
            // }

            // if (__PAGE_DATA['bj_type'] == 'zs') {
            //     if ($.nui.isTrue(__PAGE_DATA['edit_row']) && ($.nui.isEmpty(ROW_DATA['zsl']) || parseFloat(ROW_DATA['zsl'] || 0) == 0) && $.nui.isEmpty(ROW_DATA['ps'])) return fun.toast('请填写数量或匹数！');
            // } else {
            //     if ($.nui.isEmpty(ROW_DATA['zsl']) || parseFloat(ROW_DATA['zsl'] || 0) == 0) return fun.toast('请填写数量！');
            //     if ($.nui.isEmpty(ROW_DATA['ps'])) return fun.toast('请填写匹数！');
            // }

            if (page_data.djlx !== 'kc_bppyd' && page_data.djlx !== 'kc_bptbd') {
                if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) return fun.toast('请选择计价单位！');
            } else {
                delete ROW_DATA['jjdw_id'];
            }

            if (__PAGE_DATA['edit_row']) {
                __JL_DATA.splice(__PAGE_DATA['row_index'], 1, ROW_DATA);
            } else {
                __JL_DATA.push(ROW_DATA);
            }

            api.sendEvent({
                name: target_page,
                extra: {
                    'status': 'update_rows',
                    'data': {
                        __JL_DATA: __JL_DATA
                    }
                }
            });

            if ($.nui.isTrue(page_data['__route'])) {
                api.closeToWin({ name: tmp_return_page });
            } else {
                closeAndSendEvent();
            }
        }
    }

    function jumpToPage() {
        if ($.nui.isTrue(page_data['__route']) && !page_data['NOT_OPEN_AGAIN']) {
            if (['kc_bppyd', 'kc_bptbd'].indexOf(page_data.djlx) > -1) { // 盘盈开单编辑、调拨单编辑
                gotoPydEdit(__JL_DATA);
            } else {
                var __opt = { html_name: html_name, page_data: page_data };
                __opt.page_data['ck'] = fun.getListInfoByKey(fun.getItem('ck_list') || [], ROW_DATA['ck_id']) || {};
                __opt.page_data['wldw'] = page_data['wldw'];

                if (page_data.djlx === 'bp_cglhjs' || page_data.djlx === 'bp_cgthjs') {               // 来货\退货结算处理
                    __opt.page_data.data = { list: __JL_DATA };
                    __opt.closeWin = true;
                } else {
                    __opt.page_data['xsjs_tmp'] = { __JL_DATA: __JL_DATA };
                }

                if (page_data.djlx === 'bp_cglhjs' || page_data.djlx === 'bp_cgthjs') {
                    page_data.return_page = page_arr.cg_lthjs_tj;
                }
                PageShow.gotoNextPage(__opt);
            }

            return;
        }

        if (page_data.NOT_OPEN_AGAIN && page_data.djlx === 'kc_bptbd') { // 调拨单特殊处理
            page_data.return_page = page_data.goto_page;
            gotoPydEdit(__JL_DATA);
        } else {
            // if ($.nui.isTrue(page_data['__route'])) {
            //     if (page_data['kdbj_tmp']) {
            //         page_data['return_page'] = page_data['kdbj_tmp']['return_page'];
            //         target_page = page_data['return_page'];
            //     }
            // }
            api.sendEvent({
                name: finally_page,
                extra: {
                    'status': 'update_rows',
                    'data': {
                        __JL_DATA: __JL_DATA
                    }
                }
            });

            api.closeToWin({
                name: finally_page
            });
        }
    }
}

// 设置开单偏好设置
function setKdph(data, callback) {
    var tmp_list = [];
    var _data = data || [];

    for (var i = 0; i < _data.length; i++) {
        tmp_list.push(_data[i]['id']);
    }

    // if (SYS_CONFIG['kdphsz'] == tmp_list.join(',')) {
    //     return;
    // }

    var save_data = {
        "type": "sys",
        "list": [
            { "key": "kdphsz", "value": tmp_list.join(',') }
        ]
    };

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveSysConfig,
        data: save_data,
        success: function (res) {
            if (res['status'] == 0) {
                is_update_phsz = true;
                fun.load_DATA_LIST(['sys_config'], function () {
                    showPhszHtml(function () {
                        $('#fk').val(ROW_DATA['fk'] || '');
                        $('#kz').val(ROW_DATA['kz'] || '');
                        $('#gg').val(ROW_DATA['gg'] || '');
                        $('#gh').val(ROW_DATA['gh'] || '');

                        if (typeof callback === 'function') callback();
                    });
                }, { showLoad: false });
            } else {
                fun.toast('保存失败');
            }
        }
    });
}

// 设置清除按钮是否显示
function setClearBtnShow(flag) {
    var tmpFlag;
    if (flag) {
        tmpFlag = parseFloat($('#value').val().trim() || 0);
    } else {
        tmpFlag = $('#value').val().trim();
    }

    if (tmpFlag) {
        $('#remove').show();
    } else {
        $('#remove').hide();
    }
}

// 设置调库存按钮显示
function setDkcBtnShow() {
    switch (page_data.djlx) {
        case 'bp_xsfhjs':
        case 'bp_cgthjs':
        case 'kc_bptbd':
            $('.dkc-item').show();
            break;
        default:
            $('.dkc-item').hide();
            break;
    }
}

// 检测数据加载，无数据时则重复执行
function __checkData() {
    // if(fun.clearCpData) {
    //     fun.remove_DATA_LIST('cp');
    //     fun.clearCpData = false;
    // }
    if (!fun.dataIsRead(['cp'])) {
        setTimeout(__checkData, 250);
    } else {
        setTimeout(function () {
            if (typeof page_init === "function") page_init();
        }, 100);
    }
}

// 获取记录行保存数据
function getRowSaveData() {
    var list_data = __PAGE_DATA['list_data'] || {};

    __PAGE_DATA['ck_info'] = __PAGE_DATA['ck_info'] || {};

    var data3 = {
        "ck_id": __PAGE_DATA['ck_info']['id'] || 0,
        "ck_mc": __PAGE_DATA['ck_info']['name'] || '',
        "cp_id": $('#header_title').data('cp_id') || 0,
        "cp_bh": $('#header_title').data('cp_bh') || '',
        "cp_mc": $('#header_title').data('cp_mc') || '',
        "cp_ys_id": $('#color_search').data('cp_ys_id') || 0,
        "cp_ys_bh": $('#color_search').data('cp_ys_bh') || '',
        "cp_ys_mc": $('#color_search').data('cp_ys_mc') || '',
        "fk": $('#fk').val().trim(),
        "kz": $('#kz').val().trim(),
        "gh": $('#gh').val().trim(),
        "gg": $('#gg').val().trim(),
        "jg_lx_mc": $('#lx').length ? ($('#lx').text().trim() || '大货') : '大货',
        "jg_lx": $('#lx').length ? ($('#lx').data('jg_lx') || 'dh') : 'dh',
        "ps": parseInt($('#ps').val().trim() || 0),
        "dw_id": $('#dw').data('dw_id') || 0,
        "dw_mc": $('#dw').text().trim(),
        "zsl": parseFloat($('#sl').val().trim() || 0),
        "jjdw_id": $('#jjdw').data('jjdw_id') || 0,
        "jjdw_mc": fun.getValByKey(fun.getItem('jjdw_list') || [], $('#jjdw').data('jjdw_id') || 0) || '',

        "hsdj": parseFloat($('#dj').val().trim() || 0),
    };

    // if (__PAGE_DATA['edit_row']) {
    //     data3['cp_ys_id'] = __PAGE_DATA['list_data']['cp_ys_id'];
    //     data3['cp_ys_bh'] = __PAGE_DATA['list_data']['cp_ys_bh'];
    //     data3['cp_ys_mc'] = __PAGE_DATA['list_data']['cp_ys_mc'];
    // }

    ROW_DATA = $.extend({}, list_data, ROW_DATA, data3);

    if (typeof ROW_DATA['jjsl'] === 'undefined') {
        ROW_DATA['jjsl'] = 0;
    }

    if ($.nui.isEmpty(ROW_DATA['jjsl'])) {
        ROW_DATA['jjsl'] = 0;
    }

    switch (page_data['djlx']) {
        case 'bp_xsfhjs':
        case 'bp_xsthjs':
        case 'bp_cglhjs':
        case 'bp_cgthjs':
        case 'bp_xsdd':
        case 'bp_cgdd':
        case 'bp_cgbj':
        case 'bp_xsbj':
            break;
        case 'kc_bppyd':
            delete ROW_DATA['jjdw_id'];
            break;
        default:
            delete ROW_DATA['jjdw_id'];
            delete ROW_DATA['hsdj'];
            break;
    }

    if ($.nui.isEmpty(ROW_DATA['__row_uuid'])) {
        ROW_DATA['__row_uuid'] = $.nui.getRandomNum();
    }

    return ROW_DATA;
}

// 获取明细数据
function getMxData() {
    var list = [];

    for (var i = 0; i < $('.cloth-mx-item').length; i++) {
        var $item = $('.cloth-mx-item').eq(i).find('.item-mx');
        var $ele = $('.cloth-mx-item').eq(i);
        var mx_data = $ele.data('mx_data') || {};
        $.nui.isTrue(mx_data) && list.push(mx_data);
    }

    list = list.concat(delMxData);

    return list;
}

// 渲染明细数据列表
function showMxList(data) {
    var html = [];

    var enabledEdit = ($.nui.isEmpty(ROW_DATA['ckd_dj_id']) && $.nui.isEmpty(ROW_DATA['ybjl_id']));// || $.nui.isTrue(ROW_DATA['is_yy_tm']

    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        if ($.nui.isTrue(val['is_delete'])) continue;
        var disabledStyle = enabledEdit ? '' : 'disabled';

        if (page_data.djlx === 'kc_bptbd' && $.nui.isTrue(ROW_DATA['is_yy_tm'])) {
            disabledStyle = 'disabled';
        }

        html.push('<div style="" data-mx_index="' + i + '" ' + disabledStyle + ' data-mx_data=\'' + fun.formatString(JSON.stringify(val)) + '\' class="cloth-item cloth-mx-item ' + fun.is_value(billZsmx.addMxInactive(val)) + '"><span class="item-mx">' + (val['sl'] || 0) + '</span></div>');
    }
    if (enabledEdit) {
        html.push(createMxBtnHtml());
    }

    $('#cloth_wrap').html(html.join(''));

    setDkcBtnShow();

    showAddItemBtn();
    if (!__PAGE_DATA['__PAGE_EDIT']) {
        // $('.dkc-item').attr('disabled', true);
        $('.dkc-item').hide();
    }

    setScanCodeBtnDisplay();
}

// 重置页面数据
function resetData() {
    $('#color_search').val('').removeData();
    $('#lx').text('').removeData();
    $('#gh,#ps,#sl,#je,#ssj,#ssje,#sss').val('');
    $('#jjsl_val').val('');
    $('#dj').val(0);

    $('#cloth_wrap').html(createMxBtnHtml());

    setDkcBtnShow();

    showAddItemBtn();
    if (!__PAGE_DATA['__PAGE_EDIT']) {
        $('.dkc-item').attr('disabled', true);
        $('.dkc-item').hide();
    }

    setJjslColor();

    ROW_DATA['mx'] = [];
    ROW_DATA['hsdj'] = 0;
    ROW_DATA['dj'] = 0;
    ROW_DATA['gh'] = '';
    ROW_DATA['ps'] = '';
    ROW_DATA['zsl'] = '';
    ROW_DATA['jjsl'] = '';

    delete ROW_DATA['ckd_dj_id'];
    delete ROW_DATA['ckd_jl_id'];
    delete ROW_DATA['is_yy_tm'];

    ROW_DATA['ssdj'] = 0;
    setScanCodeBtnDisplay();
    // 20191126
    setAfterChangeColor({
        'cp_ys_id': 0,
        'cp_ys_bh': '',
        'cp_ys_mc': ''
    });
    updateLx();

    cache_data['target'] = '';

    $('#value').length && $('#value').val('');

    $('input').removeClass('active-border');
    setPanelHide();
}

// 20191126
// 更换颜色后事件
function setAfterChangeColor(options) {
    var _options = $.extend({ cp_ys_id: 0, cp_ys_bh: '', cp_ys_mc: '' }, options);

    var cp_ys_bh = _options['cp_ys_bh'];
    if (cp_ys_bh === '色卡') {
        shSkLx();
    } else {
        if ($('#lx').data('jg_lx') == 'sk') {
            $('#lx,#dw,#jjdw').removeAttr('disabled');
        }

        ROW_DATA['dw_id'] = __PAGE_DATA['list_data']['dw_id'] || 0;
        ROW_DATA['dw_mc'] = __PAGE_DATA['list_data']['dw_mc'] || '';

        __setUnit(ROW_DATA, _options.notUpDateJjdw, _options.notUpDateUnit);
    }

    /*
        色卡切换非色卡，非色卡切换色卡才需要更新，非色卡切换非色卡不需要重新计算（单位和计价单位不需要重新读取）
        _options.notUpDateJjdw 和 _options.notUpDateUnit 为 true 已经判断了是非色卡和非色卡之间的切换关系
    */

    var upDateParams = {};
    if (_options.notUpDateJjdw && _options.notUpDateUnit) {
        upDateParams = { calcJjsl: false };
    } else {
        upDateParams = { calcSssl: true };
    }
    updateRowDataAmountAndMoney(null, ROW_DATA, upDateParams);

    $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);
    setJjslColor();
}

// 设置从搜索页返回的值
function setSelectedValue(params) {
    var data = params.data;
    var listData = data['list_data'];
    switch (data['page_type']) {
        case 'cp_ys':
            // 选择相同不需要更新
            if (Number($('#color_search').data('cp_ys_id')) === Number(data['id'])) return;
            $('#color_search').val((listData['number'] || '') + ' ' + (listData['name'])).data({
                'cp_ys_id': data['id'],
                'cp_ys_bh': listData['number'],
                'cp_ys_mc': listData['name']
            });

            var transmitParams = {
                'cp_ys_id': data['id'],
                'cp_ys_bh': listData['number'],
                'cp_ys_mc': listData['name'],
            }

            /*
                非色卡切换到色卡，色卡切换到非色卡，才需要重新赋值单位和计价单位
                当前情况为 非色卡切换非色卡（不需要更新）
            */

            if (billZsmx.lastProductColorName !== '色卡' && billZsmx.nowProductColorName(transmitParams) !== '色卡') {
                transmitParams.notUpDateUnit = true;
                transmitParams.notUpDateJjdw = true;
            }

            // 20191126
            setAfterChangeColor(
                transmitParams
            );

            billZsmx.upDateLastProductColorName({
                cp_ys_bh: listData['number'],
                cp_ys_mc: listData['name']
            });

            updateLx();
            updateDj();

            setColorBtnDisplay();

            break;
        case 'dw':
            console.log(data);
            // 选单位，选择相同但是是点击选中，不需要重新计算
            if (fun.toNumber($('#dw').data('dw_id')) === fun.toNumber(data['id'])) {
                return;
            }
            $('#dw').text(data['select_val']).data('dw_id', data['id']);
            __setRowData(null, { dw_id: data['id'], dw_mc: data['select_val'] }, { hsdj_fixed: hsdj_fixed });

            billZsmx.setJjsl();

            if ($.nui.isEmpty($('#jjdw').data('jjdw_id'))) {
                $('#jjdw').text(data['select_val']).data('jjdw_id', data['id']);
            }

			// 盘盈单选择单位需要更新成本价
            if(page_data.djlx === 'kc_bppyd'){
                getRowSaveData();
                __PAGE_DATA['__DJ_DATA'] = __PAGE_DATA['__DJ_DATA'] || {};
                billZsmx.updatePydCbj();
            }

            break;
        case 'jjdw':
            $('#sel_jjdw').text(data['select_val']).data('jjdw_id', data['id']);

            ROW_DATA['jjdw_id'] = data['id'];
            ROW_DATA['jjdw_mc'] = data['select_val'];

            $('#jjdw').data('jjdw_id', data['id']);

            //20191023计价单位
            updateDataAfterChangeDw();
            cache_data['kcms'] = ROW_DATA['kcms'] || '+';
            cache_data['kc'] = ROW_DATA['kc'] || 0;
            cache_data['jjsl'] = ROW_DATA['jjsl'] || 0;
            cache_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
            cache_data['jjdw_mc'] = ROW_DATA['jjdw_mc'] || '';
            break;
    }
}

//更新单价
function updateDj(callback) {
    getRowSaveData();

    __PAGE_DATA['__DJ_DATA'] = __PAGE_DATA['__DJ_DATA'] || {};

    switch(page_data.djlx){
        case 'kc_bppyd':
            billZsmx.updatePydCbj();
            break;
        default:
            __getDj({
                data: {
                    "djlx": Bills['djlx'],
                    "wldw_id": __PAGE_DATA['__DJ_DATA']['wldw_id'] || 0,
                    "cp_id": ROW_DATA['cp_id'] || 0,
                    "cp_ys_id": ROW_DATA['cp_ys_id'] || 0,
                    "jjdw_id": ROW_DATA['jjdw_id'] || 0,
                    "kdsj": __PAGE_DATA['__DJ_DATA']['kdsj'] || fun.formatDate(new Date()),
                    "dj_info": ROW_DATA['dj_info'] || {},
                    "dd_dj_id": ROW_DATA['dd_dj_id'] || 0,
                    "dd_jl_id": ROW_DATA['dd_jl_id'] || 0,
                    "gx_id": ROW_DATA['gx_id'] || 0,
        
                    // 获取成本价 需要用到 仓库、单位
                    "ck_id": __PAGE_DATA['ck_info']['id'] || 0,
                    "dw_id": ROW_DATA['dw_id'] || 0,
                    // 标准价 最低价 需要用到类型
                    "jg_lx": fun.getValByKey(fun.getSaleLxData({ showAll: true }) || [], ROW_DATA['jg_lx_mc'], 'simple', 'name') || 'dh'
                },
                callback: function (res) {
                    if (res['status'] == 0) {
                        // $('#dj').val(res['data']['dj']);
        
                        var dj_data = {
                            dj: res['data']['dj']
                        };
        
                        switch (page_data['djlx']) {
                            case 'bp_xsdd':
                            case 'bp_xsfhjs':
                            case 'bp_xsthjs':
                                dj_data['ssdj'] = res['data']['ssdj'];
                                dj_data['bzj'] = res['data']['bzj'] || 0;
                                dj_data['zdj'] = res['data']['zdj'] || 0;
                                break;
                        }
                       
                        __setRowData(null, dj_data, { hsdj_fixed: hsdj_fixed, setSsj: true, upDateSssl: false, upDateBqsl: false, upDateSsdj: true });
        
                        if (page_data['djlx'] === 'kc_bppyd') {
                            ROW_DATA['hsdj'] = ROW_DATA['dj'];
                        }
        
                        $('#dj').val(ROW_DATA['hsdj'] || 0);
                        $('#ssdj').val(ROW_DATA['ssdj'] || 0);
                        // 获取上次价
                        if (__PAGE_DATA.loadScdj) {
                            ROW_DATA.scdj = res.data.scdj;
                        }
                    }
                }
            });
            break;
    }

}

// 更新类型
function updateLx() {
    if ($('#color_search').data('cp_ys_bh') === '色卡') {
        shSkLx();
    } else if (__PAGE_DATA['ck_info']['type'] === 'skyb') {
        $('#lx').text('样版').data('jg_lx', 'yb');
    } else if (__PAGE_DATA['ck_info']['type'] === 'jy') {
        $('#lx').text('剪样').data('jg_lx', 'jy');
    } else {
        if ($('#lx').data('jg_lx') && $('#lx').data('jg_lx') != 'dh') {

        } else {
            $('#lx').text('大货').data('jg_lx', 'dh');
        }
    }
}

// 20191126
// 色号为色卡时更新单位、计价单位、类型
function shSkLx() {
    var jjdw_list = fun.getItem('jjdw_list') || [];
    var sk_dw_id = fun.getValByKey(jjdw_list || [], '份', 'id', 'name');
    var sk_dw_mc = '份';

    ROW_DATA['dw_id'] = sk_dw_id;
    ROW_DATA['dw_mc'] = sk_dw_mc;
    ROW_DATA['jjdw_id'] = sk_dw_id;
    ROW_DATA['jjdw_mc'] = sk_dw_mc;
    ROW_DATA['jg_lx'] = 'sk';
    ROW_DATA['jg_lx_mc'] = '色卡';

    $('#lx').text('色卡').data('jg_lx', 'sk').attr('disabled', true);
    $('#dw').text(sk_dw_mc).data('dw_id', sk_dw_id).attr('disabled', true);
    $('#jjdw').text(sk_dw_mc).data('jjdw_id', sk_dw_id).attr('disabled', true);
}

// 格式化明细数据
function formatMxData() {
    var mxData = getMxData();

    var list = [];
    var px = 1;
    for (var i = 0; i < mxData.length; i++) {
        var val = mxData[i];
        list.push(val);
    }
    return list;
}

// 计算匹数和数量
function calcPsAndSl() {
    var mxData = getMxData();

    var $dom = $('.cloth-mx-item.choice-cloth');
    if (__PAGE_DATA['bj_type'] == 'zs' && !$dom.length) {
        $('#ps').val(ROW_DATA['ps'] || '');
        $('#sl').val(ROW_DATA['zsl'] || '');
        $('#jjsl_val').val(ROW_DATA['jjsl'] || '');
        return;
    }

    var ps = 0, zsl = 0;
    var tmpMx = [];


    for (var i = 0; i < mxData.length; i++) {
        tmpMx.push(mxData[i]);
        if ($.nui.isTrue(mxData[i]['is_delete'])) continue;
        zsl = $.nui.decimalAdd(zsl, parseFloat(mxData[i]['sl'] || 0));
        ps = $.nui.decimalAdd(ps, 1);
    }
    $('#ps').val(ps || '');
    $('#sl').val(zsl || '');

    __setRowData(null, { ps: ps, zsl: zsl, mx: tmpMx.slice(0) }, { hsdj_fixed: hsdj_fixed });

    $('#ps').val(ROW_DATA['ps'] || 0);
    $('#sl').val(ROW_DATA['zsl'] || 0);

    $('#jjsl_val').val(ROW_DATA['jjsl']);

    setJjslColor();
}

// 选产品后设置单位
function __setUnit(list_data, notUpDateJjdw, notUpDateUnit) {
    var tempNotUpDateUnit = $.nui.isEmpty(notUpDateJjdw) && $.nui.isEmpty(notUpDateUnit);
    if (tempNotUpDateUnit) {
        $('#dw').text(list_data['dw_mc'] || '单位').data('dw_id', list_data['dw_id'] || 0);
    }
    var cp_list = fun.getItem('cp_list') || [];
    var jjdw_list = fun.getItem('jjdw_list') || [];
    // 根据 往来单位类型, 赋值 档案 预设的 计价单位
    var unit_options = fun.getValByKey(cp_list || [], list_data['cp_id'], 'unit_options');

    if (tempNotUpDateUnit) { // 换颜色之后，计价数量不用重新换算（2020-4-16 测试登记错误，换颜色重新换算导致算法错误）
        switch (Bills['wldw_type']) {
            case 'kh':
                list_data['jjdw_id'] = unit_options['xsdw_id'];
                break;
            case 'gys':
                list_data['jjdw_id'] = unit_options['cgdw_id'];
                break;
            case 'jgs':
                list_data['jjdw_id'] = unit_options['jgdw_id'];
                break;
        }

        list_data['jjdw_mc'] = fun.getValByKey(jjdw_list || [], list_data['jjdw_id'], 'name');

        if ($.nui.isEmpty(list_data['jjdw_id'])) {
            list_data['jjdw_id'] = list_data['dw_id'] || 0;
            list_data['jjdw_mc'] = list_data['dw_mc'] || '';
        }

        $('#jjdw').text(list_data['jjdw_mc'] || ' ').data('jjdw_id', list_data['jjdw_id'] || 0);
    }

    // 有开启一匹多仓库,则要赋值 单位2
    if (tempNotUpDateUnit && $.nui.isTrue(SYS_CONFIG['ypbddwgl'])) {
        list_data['dw2_id'] = unit_options['dw2_id'] || 0;
        list_data['dw2_mc'] = fun.getValByKey(jjdw_list || [], list_data['dw2_id']);
    }
}

function __setJyDw(list_data) {
    if (__PAGE_DATA['ck_info']['type'] === 'jy') {
        var cp_list = fun.getItem('cp_list') || [];
        var jjdw_list = fun.getItem('jjdw_list') || [];
        // 根据 往来单位类型, 赋值 档案 预设的 计价单位
        var unit_options = fun.getValByKey(cp_list || [], list_data['cp_id'], 'unit_options') || {};

        switch (Bills['wldw_type']) {
            case 'kh':
                list_data['jjdw_id'] = unit_options['xsdw_id'];
                break;
            case 'gys':
                list_data['jjdw_id'] = unit_options['cgdw_id'];
                break;
            case 'jgs':
                list_data['jjdw_id'] = unit_options['jgdw_id'];
                break;
        }

        fun.setJyDwAndJjdw(list_data, unit_options);

        list_data['jjdw_mc'] = fun.getValByKey(jjdw_list || [], list_data['jjdw_id'], 'name');

        if ($.nui.isEmpty(list_data['jjdw_id'])) {
            list_data['jjdw_id'] = list_data['dw_id'] || 0;
            list_data['jjdw_mc'] = list_data['dw_mc'] || '';
        }
        console.log(list_data['jjdw_mc'], list_data['dw_mc'])
        $('#jjdw').text(list_data['jjdw_mc'] || ' ').data('jjdw_id', list_data['jjdw_id'] || 0);
        $('#dw').text(list_data['dw_mc'] || '单位').data('dw_id', list_data['dw_id'] || 0);
    }
}

//设置计价数量颜色
function setJjslColor() {
    if ($('#sl').val().trim() == $('#jjsl_val').val().trim()) {
        $('#jjsl_val').css('color', '#000');
    } else {
        $('#jjsl_val').css('color', '#18b4ed');
    }
}

// 关闭当前页面，发送通知事件
function closeAndSendEvent() {

    api.sendEvent({
        name: page_data.return_page,
        extra: {
            'status': 'update_phsz',
        }
    });

    api.sendEvent({
        name: page_data.return_page,
        extra: {
            'status': 'close_win',
        }
    });

    setTimeout(function () {
        if ($.nui.isTrue(__PAGE_DATA['edit_row'])) {
            api.sendEvent({
                name: page_data.return_page,
                extra: {
                    'status': 'update_rows',
                    'data': {
                        __JL_DATA: __JL_DATA,
                    }
                }
            });
            api.closeWin();
        } else {
            if ($.nui.isTrue(page_data['__route'])) {
                api.closeToWin({ name: page_arr.choice_product });
            } else {
                api.sendEvent({
                    name: page_data.return_page,
                    extra: {
                        'status': 'update_rows',
                        'data': {
                            __JL_DATA: __JL_DATA,
                        }
                    }
                });
                api.closeWin();
            }
        }
    }, 300);
}

// 删除布匹按钮是否显示
function setDelClothShow() {
    if ($('.cloth-mx-item.choice-cloth').length) $('#del_cloth').show();
    else $('#del_cloth').hide();
}

//键盘隐藏后获取明细数据
function getRowMxData() {
    var list = [];
    var $dom = $('.cloth-mx-item.choice-cloth');
    if (__PAGE_DATA['bj_type'] == 'zs') {
        if ($('.active-border').length) {
            var tmp_data = {};
            if ($('.active-border').attr('id') == 'ps') {
                tmp_data['ps'] = parseInt($('#ps').val() || 0);
            }
            if ($('.active-border').attr('id') == 'sl') {
                tmp_data['zsl'] = parseFloat($('#sl').val() || 0);
            }

            __setRowData(null, tmp_data, {
                upDateSssl: false
            });

            showMxList(ROW_DATA['mx'] || []);

            $('#jjsl_val').val(ROW_DATA['jjsl'] || '');
            setJjslColor();
            return true;
        }
    }
    // if (!$dom.length) return true;
    if ($.nui.isEmpty(parseFloat($dom.text() || 0))) {
        var row = $dom.data('mx_data') || {};
        if ($.nui.isEmpty(row)) {
            $dom.remove();
            $('#value').val('');
            showAddItemBtn();
        } else {
            fun.dialog({
                content: '您确定要删除【' + (row['sl']) + '】这匹布吗？',
                btn: ['删除', '取消'],
                yes: function () {
                    var index = __PAGE_DATA['row_index'] || 0;
                    __delRowMxValue(row, index);

                    $('#value').val('');

                    showMxList(ROW_DATA['mx'] || []);
                    calcPsAndSl();
                    showAddItemBtn();
                    showFs = (__getMxLength(ROW_DATA['mx'] || []) < 2);

                },
                no: function () {
                    var prevMxData = $dom.prev('.cloth-mx-item:visible').data('mx_data') || {};
                    var __px = prevMxData['px'] || 1;
                    var __ph = (prevMxData['ph'] || 0) + 1;
                    if (__ph > 10) {
                        __ph = 1;
                        __px++;
                    }

                    var _data = {
                        "__jl_index": __PAGE_DATA['row_index'] || 0,
                        "px": __px,
                        "ph": __ph,
                        "sl": parseFloat(row['sl'] || 0)
                    };

                    var __mx_data = $('.cloth-mx-item.choice-cloth').data('mx_data') || {};

                    console.log($('.cloth-mx-item.choice-cloth').data('mx_data'))

                    var _data1 = $.extend({}, __mx_data, _data, { "sl": parseFloat(row['sl'] || 0) });
                    //修改布匹
                    // $('#value').val('');
                    $('.cloth-mx-item.choice-cloth .item-mx').text(row['sl']);
                    $('.cloth-mx-item.choice-cloth').data('mx_data', _data1);

                    $('#value').val(row['sl']);

                    setDelClothShow();
                    setClearBtnShow();
                }
            });
            return false;
        }
        return true;
    }
    var row = $dom.data('mx_data') || {};
    var val = $dom.text().trim();
    $dom.find('.item-mx').text(parseFloat(val) || '');
    val = $dom.text().trim();
    if ($.nui.isTrue(row)) {
        if (row['sl'] != val) {//修改

            var prevMxData = $dom.prev('.cloth-mx-item:visible').data('mx_data') || {};
            var currMxData = $dom.data('mx_data') || {};

            var curr_tm_sl = parseFloat(currMxData['tm_sl'] || 0);

            if (curr_tm_sl > 0 && parseFloat(val || 0) > 0 && parseFloat(val || 0) > curr_tm_sl) {
                $dom.find('.item-mx').text(parseFloat(row['sl']) || '');
                fun.toast('该布匹最多只能发：' + currMxData['tm_sl'] + (ROW_DATA['dw_mc'] || ''));
                return false;
            } else {
                var __px = prevMxData['px'] || 1;
                var __ph = (prevMxData['ph'] || 0) + 1;
                if (__ph > 10) {
                    __ph = 1;
                    __px++;
                }

                var _data = {
                    "__jl_index": __PAGE_DATA['row_index'] || 0,
                    "px": __px,
                    "ph": __ph,
                    "sl": parseFloat(val || 0),
                    "is_delete": 0
                };

                var _data1 = $.extend({}, _data, currMxData, { "sl": parseFloat(val || 0) });

                //修改布匹
                $('#value').val('');
                $('.cloth-mx-item.choice-cloth').data('mx_data', _data1);

                billZsmx.bpckSeleteStatus(_data1, 'bpck-choice');
            }

        }
    } else {//添加
        var prevMxData = $dom.prev('.cloth-mx-item:visible').data('mx_data') || {};
        var __px = prevMxData['px'] || 1;
        var __ph = (prevMxData['ph'] || 0) + 1;
        if (__ph > 10) {
            __ph = 1;
            __px++;
        }

        var _data = {
            "__jl_index": __PAGE_DATA['row_index'] || 0,
            "px": __px,
            "ph": __ph,
            "sl": parseFloat(val || 0),
            is_delete: 0
        };
        //添加布匹

        $('.cloth-mx-item.choice-cloth').data('mx_data', _data);

        // $('#cloth_wrap').scrollTop($('#cloth_wrap').height()); //滚动到底
        $('#value').val('');

    }

    calcPsAndSl();

    setPsAndSlDisabled();

    showFs = (__getMxLength(ROW_DATA['mx'] || []) < 2);

    return true;
}

// 设置键盘隐藏
function setPanelHide() {
    $('.form_edit,.layer-content').hide();
    $('#toggle').find('.icon-toggle').removeClass('icon-xia').addClass('icon-shang');

    $('.opening').css('height', '3rem')
    $('.layer-content').css({
        height: '2.5rem'
    });

    getRowMxData();

    setDelClothShow();
    setClearBtnShow();

    setJjslColor();
}

// 设置键盘显示
function setPanelShow() {
    if ($.nui.isTrue(ROW_DATA['ckd_dj_id']) || $.nui.isTrue(ROW_DATA['ybjl_id'])) return;// || $.nui.isTrue(ROW_DATA['is_yy_tm']
    $('.form_edit,.layer-content').show();
    $('#toggle').find('.icon-toggle').removeClass('icon-shang').addClass('icon-xia');

    $('.opening').css('height', '12.75rem');
    $('.layer-content').css({
        height: '12.75rem'
    });

    $this_height && window.scrollTo(0, $this_height - px_rem);
    setClearBtnShow();

    if (__PAGE_DATA['bj_type'] == 'zs') {
    }

}

// 盘盈单开单返回处理
function gotoPydEdit(jl) {
    if (page_data.return_page === page_arr.kc_pyd_edit || page_data.return_page === page_arr.kc_dbd_edit) { // 盘盈单、调拨单修改，发送添加事件
        api.sendEvent({
            name: page_data.return_page,
            extra: {
                'data': { list: jl }
            }
        });

        setTimeout(function () {
            api.closeToWin({ name: page_data.return_page });
        }, 200)
    } else {                        // 盘盈单、调拨单新增
        page_data.data = { list: jl };
        PageShow.gotoNextPageByIndex(page_data, true);
    }
}

// 设置记录表的行单元格是否可编辑
function setGridColunmDisable(row, index) {
    // 允许编辑：辅助编号、辅助名称、辅助色号、辅助颜色、
    // 模式、空差、计价单位、计价数量、备注、开单自定义字段
    // 金额类字段、费用自定义字段
    // 其他字段都不允许用户手动修改。

    var col_arr = ['jjdw_mc', 'jjsl', 'bz', 'kcms', 'kc', 'dj'];

    if ($.nui.isTrue(fun.getHouseValue(row['ck_id'], 'is_detail')) &&
        $.nui.isEmpty(fun.getHouseValue(row['ck_id'], 'is_bar')) &&
        $.nui.isEmpty(row['ckd_dj_id']) && $.nui.isEmpty(row['dd_dj_id']) &&
        $.nui.isTrue(row['is_yy_tm'] && row['ps'] <= 1)) {
        // 当前记录行 是调库存情况 且 是没开启条码的明细仓库 且 是一行一匹生成
        col_arr = col_arr.concat(['zsl']);

        $('#color_search,#lx,#gh,#fk,#kz,#gg,#dw').attr('disabled', true);
    } else if ($.nui.isTrue($.nui.isTrue(row['ckd_dj_id'])) || $.nui.isTrue(row['is_yy_tm'])) {
        // 当前记录行 是调用 退货单 或 库存条码 生成的
        $('#color_search,#color,#lx,#gh,#fk,#kz,#gg,#dw,#sl').attr('disabled', true);
        showFs = false;
    } else if ($.nui.isTrue(row['dd_dj_id'])) {
        // 当前记录行 是调用 销售订单 生成的，则以下字段不允许编辑：商品编号、商品名称、色号、颜色
        $('#color_search').attr('disabled', true);
    } else if ($.nui.isTrue(fun.getHouseValue(row['ck_id'], 'is_bar'))) {
        // 当前行的仓库有开启 条码管理
        $('#color_search,#lx,#gh,#fk,#kz,#gg,#dw,#sl').attr('disabled', true);
        showFs = false;
    } else if ($.nui.isTrue(fun.getHouseValue(row['ck_id'], 'is_detail'))) {
        // 当前行的仓库有开启 明细管理 并且 明细里有 条码
        for (var i = 0; (row['mx'] !== undefined) && (i < row['mx'].length); i++) {
            if ($.nui.isTrue(row['mx'][i]['is_delete'])) continue;
            if ($.nui.isTrue(row['mx'][i]['tm'])) {
                $('#color_search,#lx,#gh,#fk,#kz,#gg,#dw,#sl').attr('disabled', true);
                showFs = false;
                break;
            }
        }
    }
}

// 设置页面元素是否禁用
function setPageDomDisabled(row) {
    var ck_id = ROW_DATA['ck_id'];

    var is_detail = fun.getHouseValue(ck_id, 'is_detail');

    /*if (is_detail && !__isEmptyMx(row['mx'])) {
        $('#ps').attr('disabled', true);
    } else {
        $('#ps').removeAttr('disabled');
    }

    if (is_detail && !__isEmptyMx(row['mx'])) {// || (parseInt(row['ps']) <= 1)
        $('#sl').attr('disabled', true);
        // showFs = false;
    } else {
        $('#sl').removeAttr('disabled');
        // showFs = true;
    }*/

    if (!__isEmptyMx(row['mx'])) {
        $('#ps').attr('disabled', true);
    } else {
        $('#ps').removeAttr('disabled');
    }

    if (/*is_detail && */!__isEmptyMx(row['mx']) && (parseInt(__getMxLength(row['mx'] || [])) > 1)) {// || (parseInt(row['ps']) <= 1)
        $('#sl').attr('disabled', true);
        // showFs = false;
    } else {
        $('#sl').removeAttr('disabled');
        // showFs = true;
    }


    // 当前记录行 是调用 退货单 或 库存条码 生成的
    if ($.nui.isTrue(row['fhjs_dj_id']) || $.nui.isTrue(row['ckd_dj_id']) || $.nui.isTrue(row['is_yy_tm'])) {
        $('#color_search,#fk,#kz,#gg,#lx,#ps,#sl,#gh,#dw').attr('disabled', true);
        showFs = false;
    }

    if ($.nui.isTrue(row['fhjs_dj_id'])) {
        $('.add-item').hide();
        $('.cloth-mx-item,#cloth_wrap').attr('disabled', true);
    }


    // 当前记录行 是调用 销售订单 生成的，则以下字段不允许编辑：商品编号、商品名称、色号、颜色
    if ($.nui.isTrue(row['dd_dj_id'])) {
        $('#color_search').attr('disabled', true);
    }

    setPsAndSlDisabled();

    if ($.nui.isTrue(row['ckd_dj_id']) || $.nui.isTrue(row['ybjl_id'])) {
        setCommonDomDisabled();
    }

    if (page_data.djlx === 'kc_bptbd' && $.nui.isTrue(row['is_yy_tm'])) {
        $('#cloth_wrap').attr('disabled', true);
    }
}

// 设置匹数数量是否禁用
function setPsAndSlDisabled() {
    if (!__isEmptyMx(ROW_DATA['mx'])) {
        $('#ps').attr('disabled', true);
    } else {
        (psslTmpDisabled.indexOf('ps') > -1 && __PAGE_DATA['bj_type'] != 'mx') && $('#ps').removeAttr('disabled');
    }

    if (!__isEmptyMx(ROW_DATA['mx']) && (__getMxLength(ROW_DATA['mx'] || []) > 1)) {
        $('#sl').attr('disabled', true);
    } else {
        (psslTmpDisabled.indexOf('sl') > -1 && __PAGE_DATA['bj_type'] != 'mx') && $('#sl').removeAttr('disabled');
    }

    if (__PAGE_DATA['bj_type'] == 'zs') {
        if (__getMxLength(ROW_DATA['mx'] || [])) {
            $('#ps,#sl').attr('disabled', true);
        } else {
            $('#ps,#sl').removeAttr('disabled');
        }
    }
}

//更新数据更改单位之后
function updateDataAfterChangeDw() {
    var tmpJjsl = parseFloat($('#jjsl').val() || 0);
    showFs && fun.setItem(page_data['djlx'] + '_jjsfssl', $('.check-box').hasClass('check-choice'));

    ROW_DATA['kcms'] = $('.symbol.active').data('type') || '';
    ROW_DATA['kc'] = parseFloat($('#kc').val().trim() || 0);
    ROW_DATA['jjdw_id'] = $('#sel_jjdw').data('jjdw_id');
    ROW_DATA['jjdw_mc'] = $('#sel_jjdw').text();

    // if(ROW_DATA['jjsl']!=cache_data['jjsl']){
    //     ROW_DATA['jjsl'] = tmpJjsl;
    // }

    if (ROW_DATA['kcms'] == '-') {
        ROW_DATA['kcms'] = '+';
        ROW_DATA['kc'] = -parseFloat(ROW_DATA['kc'] || 0);
    }
    $('#jjsl_val').val(ROW_DATA['jjsl']);
    setJjslColor();
    $('#jjdw').text(ROW_DATA['jjdw_mc']).data(ROW_DATA['jjdw_id']);

    showFs = !!$('.check-box').length;

    if (showFs && __getMxLength(ROW_DATA['mx'] || []) < 2) {
        jjsfssl = $('.check-box').hasClass('check-choice');
        if (jjsfssl && $.nui.isTrue(tmpJjsl)) {
            var num = fun.dwhsIsBack({
                dw: ROW_DATA['dw_mc'] || '',
                jjdw: ROW_DATA['jjdw_mc'] || '',
                jjsl: ROW_DATA['jjsl'] || 0,
                kcms: ROW_DATA['kcms'] || '+',
                kc: ROW_DATA['kc'] || 0,
                ps: parseInt(ROW_DATA['ps'] || 0),
                is_back: true
            });

            ROW_DATA['zsl'] = Number(num).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
        } else {
            if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = parseFloat(tmpJjsl || 0);
        }
    } else {
        // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = parseFloat(tmpJjsl || 0);
    }

    var dwhs_data = {};

    if (cache_data['kcms'] != ROW_DATA['kcms']) {
        dwhs_data['kcms'] = ROW_DATA['kcms'] || '+';
    }
    if (cache_data['kc'] != ROW_DATA['kc']) {
        dwhs_data['kc'] = ROW_DATA['kc'] || 0;
    }

    // if (cache_data['jjsl'] != tmpJjsl) {
    //     dwhs_data['jjsl'] = tmpJjsl || 0;
    // }

    if (cache_data['jjdw_id'] != ROW_DATA['jjdw_id']) {
        dwhs_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
    }

    dwhs_data['zsl'] = ROW_DATA['zsl'] || 0;

    if ($.nui.isTrue(dwhs_data)) {
        __setRowData(null, dwhs_data, { hsdj_fixed: hsdj_fixed, upDateSssl: false });
    }

    // __setRowData(null, {
    //     jjsl: ROW_DATA['jjsl'] || 0,
    //     // zsl: ROW_DATA['zsl'] || 0,
    //     // kcms: ROW_DATA['kcms'] || '',
    //     // kc: parseFloat(ROW_DATA['kc'] || 0),
    //     // jjdw_id: ROW_DATA['jjdw_id'] || 0,
    //     // jjdw_mc: ROW_DATA['jjdw_mc'] || ''
    // });


    if (showFs && __getMxLength(ROW_DATA['mx'] || []) < 2) {
        if (jjsfssl) {
            ROW_DATA['jjsl'] = parseFloat(tmpJjsl || 0);
        } else {
            // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
        }
    }

    $('#sl').val(ROW_DATA['zsl']);
    $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);
    // $('#jjsl').val(ROW_DATA['jjsl']);

    //记录行匹数小于2时，则 计价数量允许反算出数量
    if (__getMxLength(ROW_DATA['mx'] || []) < 2) {
        //有开启 计价数反算出数量

        if (showFs && jjsfssl) {
            backCalc();

            function backCalc() {
                if ($.nui.isEmpty(ROW_DATA['jjsl'])) return;
                if ($.nui.isEmpty(ROW_DATA['cp_id']) || $.nui.isTrue(ROW_DATA['ckd_jl_id'])) return;
                if (ROW_DATA['ps'] > 1 && !$.nui.isEmpty(ROW_DATA['mx'])) return;
                // 记录行被调用不进行反算
                if ($.nui.isTrue(ROW_DATA['is_has']) || $.nui.isTrue(ROW_DATA['is_has_cgdd']) ||
                    $.nui.isTrue(ROW_DATA['is_has_wwjg']) || $.nui.isTrue(ROW_DATA['is_has_cglhd']) ||
                    $.nui.isTrue(ROW_DATA['is_has_cglhjs']) || $.nui.isTrue(ROW_DATA['is_has_jgthd']) ||
                    $.nui.isTrue(ROW_DATA['is_has_jgthjs'])) return;

                var num = fun.dwhsIsBack({
                    dw: ROW_DATA['dw_mc'] || '',
                    jjdw: ROW_DATA['jjdw_mc'] || '',
                    jjsl: ROW_DATA['jjsl'] || 0,
                    kcms: ROW_DATA['kcms'] || '+',
                    kc: ROW_DATA['kc'] || 0,
                    fk: ROW_DATA['fk'] || '',
                    kz: ROW_DATA['kz'] || '',
                    ps: parseInt(ROW_DATA['ps'] || 0),
                    is_back: true
                });

                num = num.fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);

                ROW_DATA['zsl'] = num;//.fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                ROW_DATA['jjsl'] = parseFloat(tmpJjsl || 0) || 0;

                $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);
                $('#sl').val(ROW_DATA['zsl']);
                setJjslColor();

                var t_mx = ROW_DATA['mx'] || [];
                var t_data = {};

                if ($.nui.isEmpty(t_mx)) {
                    t_data = { zsl: num/*, is_fs: 1*/, no_calc_jjsl: 1 };
                    if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                        t_data['ps'] = 1;
                        t_data['mx'] = [{ px: 1, ph: 1, sl: num }];
                    }
                } else {
                    var isPush = true;
                    var t_ps = 0;
                    for (var i = 0; i < t_mx.length; i++) {
                        if ($.nui.isTrue(t_mx[i]['is_delete'])) continue;
                        t_ps += 1;
                        if ((t_mx[i]['tm_sl'] > 0) && (num > 0)) {
                            // 如果当前仓库有开启：不负库存
                            // 当用户修改的数量大于该布匹对应的库存数时，修改无效。
                            if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_minus'))) {
                                if (num > t_mx[i]['tm_sl']) num = t_mx[i]['sl'] || 0;
                            }
                        }
                        t_mx[i]['sl'] = num;
                        isPush = false;
                    }

                    t_data = { zsl: num/*, is_fs: 1*/, no_calc_jjsl: 1 };

                    if (isPush && $.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                        t_mx.push({ px: 1, ph: 1, sl: num });
                    }

                }

                __setRowData(null, t_data, { hsdj_fixed: hsdj_fixed, upDateSssl: false });

                $('#ps').val(ROW_DATA['ps']);
                $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);


                /*总数需要可以输明细*/
                // if (__PAGE_DATA['bj_type'] == 'mx') {
                showMxList(ROW_DATA['mx'] || []);
                // }
            }
        }
    }
    // if (__PAGE_DATA['bj_type'] == 'mx') calcPsAndSl();
    setJjslColor();

    if ((cache_data['jjdw_id'] != ROW_DATA['jjdw_id'])) {
        updateDj();
    }

    $('.cloth-mx-item.choice-cloth') && $('.cloth-mx-item.choice-cloth').removeClass('choice-cloth bpck-choice');

    $('#jjsl').val(ROW_DATA['jjsl'] || '');
}

// 改变单价后事件
function afterGetRowData() {
    console.log('afterGetRowData');

    // var _options = $.extend({ setDj: true, setJe: true }, options);
    $('#je').val(ROW_DATA['hszje'] || 0);

    if (parseFloat($('#ssj').val() || 0) == parseFloat(ROW_DATA['ssdj'] || 0)) {

    } else {
        $('#ssj').val(ROW_DATA['ssdj'] || 0);
    }

    var ssje = ROW_DATA['sszje'] || 0;
    // if (page_data.djlx != 'bp_xsdd') {
    //     ssje = ROW_DATA['sszje'] || 0;
    // } else {
    //     ssje = ROW_DATA['ssje'] || 0;
    // }
    switch (page_data.djlx) {
        case 'bp_xsfhjs':
        case 'bp_xsthjs':
        case 'bp_xsdd':
            $('#ssje').val(ssje);
            $('#sss').val(ROW_DATA['sssl']);
            $('#hk').val($.nui.decimalSub((ROW_DATA['hszje'] || 0), ssje)); // 计算回扣
            billZsmx.setJjsl();
            break;
    }
}

// 细码数、调库存、扫码删除布匹 按钮html代码
function createMxBtnHtml() {
    var html = [];
    if (__PAGE_DATA['__PAGE_EDIT'] && $.nui.isEmpty(ROW_DATA['ckd_dj_id']) && $.nui.isEmpty(ROW_DATA['ybjl_id'])) {
        var display_style = '';

        if ($.nui.isTrue(ROW_DATA['is_yy_tm'])) {
            display_style = 'display: none;';
        }

        if (billZsmx.checkCkWinAndTm()) {
            display_style = 'display: none;';
        }

        html.push('<div style="' + display_style + '" class="cloth-item add-item"><span>+细码数</span></div>');

        // if ($.nui.isEmpty(ROW_DATA['is_yy_tm'])) {
        //     html.push('<div class="cloth-item add-item"><span>+细码数</span></div>');
        // }

        switch (page_data.djlx) {
            case 'bp_xsfhjs':
            case 'bp_cgthjs':
            case 'kc_bptbd':
                html.push('<div class="cloth-item dkc-item"><span>调库存</span></div>');
                break;
            default:
                break;
        }
        html.push('<div class="cloth-item saoma-item"><i class="iconfont icon-erweima"></i><span>扫码删除布匹</span></div>');
    }
    return html.join('');
}

// 设置扫码删除布匹显示隐藏
function setScanCodeBtnDisplay() {
    var mx = ROW_DATA['mx'] || [];

    for (var i = 0; i < mx.length; i++) {
        var val = mx[i];

        if ($.nui.isTrue(val['is_delete'])) continue;
        if ($.nui.isTrue(val['tm'])) {
            if ($.nui.isTrue(__PAGE_DATA['__PAGE_EDIT'])) {
                $('.saoma-item').show();
            }
            // $('.add-item').hide();
            return true;
        }
    }
    $('.saoma-item').hide();
    return false;
}

// 记录表单元格编辑后触发的事件
function setRowData(index, data, opt, _data) {
    switch (page_data.djlx) {
        case 'bp_xsfhjs':
        case 'bp_xsthjs':
        case 'bp_xsdd':
            _data['ssdj'] = parseFloat(_data['ssdj'] || 0);
            //如果没有开启实售价 则拿单价字段
            if ($.nui.isTrue(SYS_CONFIG[Bills['config']['qyssjms']])) {// || opt['setSsj']
                if (opt.upDateSsdj) { // 限制只执行一次
                    if ($.nui.isTrue(_data.dj) && $.nui.isEmpty(_data.ssdj)) { // 有单价没实售单价，实售价 = 单价
                        _data['ssdj'] = _data['dj'];
                    };
                }
                if (opt.upDateSssl) { // 点击页面没做任何修改，不需要重新换算单位
                    _data['sssl'] = fun.toNumber(fun.dwhs({
                        zsl: _data['bqsl'] || 0,
                        ps: _data['ps'] || 0,
                        fk: _data['fk'] || '',
                        kz: _data['kz'] || '',
                        dw: _data['dw_mc'] || '',
                        jjdw: _data['jjdw_mc'] || '',
                        kc: parseFloat(_data['sskc'] || 0),
                        kcms: _data['kcms'] || '+',
                        mx: []
                    }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                }
            }
            _data['ssje'] = (_data['ssdj'] * (_data['sssl'] || 0)).fixed();

            _data['ssje'] = __jeSswr(_data['ssje']);
            _data['sszje'] = (_data['ssdj'] * (_data['sssl'] || 0)).fixed();
            // 自定义费用
            for (var i = 1; i <= 5; i++) _data['sszje'] += parseFloat(_data['fy_zdy' + i] || 0);
            _data['sszje'] = __jeSswr(_data['sszje']);

            break;
        case 'kc_bppyd':
            _data['cbj'] = _data['hsdj'];
            _data['hszje'] = parseFloat(_data['cbj'] * _data['zsl']).fixed();
            break;
    }

    // 修改匹数检测
    // 销售发货结算增加 
    switch (page_data.djlx) {
        // 修改明细，删除明细重新计算匹数
        case 'bp_xsfhjs': // 销售发货结算
        case 'bp_cgthjs': // 采购退货结算
        case 'kc_bptbd': // 调拨单
            billZsmx.recomputePs(_data);
            break;
    }
}

// 重新计算匹数
billZsmx.recomputePs = function (data) {
    if ($.nui.isTrue(__getMxLength(data.mx))) {
        data.ps = data.mx.reduce(function (total, curItem, curIdx, self) {
            $.nui.isEmpty(curItem.is_delete) && total++;
            return total;
        }, 0);
    }
}

// 行记录添加方法
function addRow(options) {
    var flag = getRowMxData();
    if (!flag) return { status: 'err', msg: '' };

    getRowSaveData();
    __setRowData(null, {}, { hsdj_fixed: hsdj_fixed, upDateSssl: false });

    if ($.nui.isEmpty(ROW_DATA['cp_ys_id'])) {
        // 没有选颜色 但 有填 数量 或者 匹数 则要提示： 请选择颜色 
        if ($.nui.isTrue(parseFloat(ROW_DATA['zsl'] || 0)) || $.nui.isTrue(ROW_DATA['ps'])) {
            fun.toast('请选择颜色！');
            return { status: 'empty_ys', msg: '颜色不能为空' };
        }
    } else {
        // 有选颜色 但 数量、匹数 都没有填 
        if ($.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(ROW_DATA['ps'])) {
            if ($.nui.isEmpty(__PAGE_DATA['edit_row'])) {
                // 如果是新增的情况下，则代表 当次操作不保存
                return { status: 'ok' };
            }
        }
    }

    if (page_data.djlx !== 'kc_bppyd' && page_data.djlx !== 'kc_bptbd') {
        if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) {
            fun.toast('请选择计价单位！');
            return { status: 'empty_jjdw', msg: '计价单位不能为空' };
        }

    } else {
        delete ROW_DATA['jjdw_id'];
    }

    var TMP_ROW_DATA = $.extend({}, ROW_DATA);

    // 判断 匹数 数量 都不能为空 
    if ($.nui.isEmpty(__PAGE_DATA['edit_row']) && ($.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(ROW_DATA['ps']))) {
        return { status: 'ok' };
    } else {
        if (__PAGE_DATA['edit_row']) {
            __JL_DATA[__PAGE_DATA['row_index']] = TMP_ROW_DATA;
        } else {
            __JL_DATA.push(TMP_ROW_DATA);
        }

        return { status: 'ok' };
    }
}

// 明细条码记录修改方法
function mxRow(options) {
    var flag = getRowMxData();
    if (!flag) return { status: 'err', msg: '' };

    getRowSaveData();
    __setRowData(null, {}, { hsdj_fixed: hsdj_fixed, upDateSssl: false });

    var state = 0;
    if (fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail')) {
        var mx = ROW_DATA['mx'] || [];
        for (var i = 0; i < mx.length; i++) {
            if ($.nui.isEmpty(mx[i]['is_delete'])) {
                state = 1;
            }
        }
    }

    return { status: 'ok', state: state };
}

// 页面初始化时是否可编辑元素
function initEditDom() {
    if ($.nui.isTrue(__PAGE_DATA['__PAGE_EDIT'])) {
        $('input,#dw,#jjdw,#sel_jjdw,.cloth-mx-item,#cloth_wrap,#toggle,#color_search,#color,#lx').removeAttr('disabled');
        $('#scgys,#complete_btn').show();
    } else {
        $('input,#dw,#jjdw,#sel_jjdw,.cloth-mx-item,#cloth_wrap,#toggle,#color_search,#color,#lx').attr('disabled', true);
        $('.show-xs-tips,#scgys,#complete_btn').hide();
    }
    // if ($.nui.isTrue(__PAGE_DATA['__PAGE_EDIT']) && $.nui.isTrue(__PAGE_DATA['edit_row'])) {
    //     $('#scgys').show();
    // } else {
    //     $('#scgys').hide();
    // }
}

// 明细条码跳转页面限制
function mxTm() {

}

// 事件绑定
// function bindEvent() {
//更多
$('body').on('tap', '#much_btn', function (e) {
    e.stopPropagation();
    if ($('.collapse-wrap').hasClass('open')) {
        $('.collapse-wrap').removeClass('open');
    } else {
        $('.collapse-wrap').addClass('open');
    }
});

// 右上角删除该颜色
$('body').on('touchend', '#scgys', function (e) {
    e.preventDefault();
    var _this = this;

    var cpysbhmc = ($('#color_search').data('cp_ys_bh') || '') + ' ' + ($('#color_search').data('cp_ys_mc') || '');
    var title = $.nui.isTrue($.trim(cpysbhmc)) ? '【' + $.trim(cpysbhmc) + '】' : '';

    fun.dialog({
        content: '你确定要删除' + title + '吗？',
        btn: ['删除', '取消'],
        yes: function () {

            // 删除成功
            if (typeof __PAGE_DATA['row_index'] !== 'undefined' && __PAGE_DATA['row_index'] != null) {
                if ($.nui.isTrue(__JL_DATA[__PAGE_DATA['row_index']])) {
                    __JL_DATA[__PAGE_DATA['row_index']]['is_delete'] = 1;
                    __JL_DATA[__PAGE_DATA['row_index']]['__status'] = 'del';
                }
            }

            // 清空当前页面数据，并处于新增状态
            __PAGE_DATA['edit_row'] = false;
            __PAGE_DATA['row_index'] = undefined;
            __PAGE_DATA['list_data'] = $.extend({}, PAGE_INIT_DATA, {
                cp_ys_id: 0,
                cp_ys_bh: '',
                cp_ys_mc: ''
            });

            ROW_DATA = $.extend({}, PAGE_INIT_DATA);

            __PAGE_DATA['MXTM'] = false;
            psslTmpDisabled = [];
            $('input,.cloth-mx-item,#cloth_wrap,#color').removeAttr('disabled');

            init({ setColorEmpty: true });
            initColorAdd();
            resetData();
            setColorBtnDisplay();
            isClear = true;
            getRowSaveData();
        }
    });
    return false;
});

//偏好设置
$('body').on('touchend', '#phsz', function (e) {
    e.preventDefault();
    e.stopPropagation();

    getRowSaveData();

    var list_data = [
        { name: '幅宽/克重', id: 'fk,kz' },
        { name: '规格', id: 'gg' },
        { name: '缸号', id: 'gh' }
    ];

    for (var i = 0; i < list_data.length; i++) {
        if (fun.getKdSetting(list_data[i]['id'])) {
            list_data[i]['is_choose'] = 1;
        }
    }

    fun.showBookList({
        width: '280px',
        shadeClose: false,
        checkbox: true,
        list: list_data,
        // triggerClose: false,
        // closeFn: function() {

        // },
        choose: function (data) {
            setKdph(data, function () {
                layer.closeAll();
            });
        }
    });
    $('.collapse-wrap').removeClass('open');
    return false;
});

//点击其他区域，关闭更多
$('body').on('tap', function (e) {
    $('.collapse-wrap').removeClass('open');
});

// 大图预览
$('body').on('tap', '.img-box', function (e) {
    e.preventDefault();
    e.stopPropagation();
    var flag = getRowMxData();
    if (!flag) return;

    var cp_id = $('#header_title').data('cp_id');

    var cp_info = fun.getListInfoByKey(cp_list, cp_id);
    var cp_imgs = cp_info['imgs'] || '';

    if ($.nui.isEmpty(cp_imgs)) return;
    var img_arr = [];
    cp_imgs = cp_imgs.split(',');

    if ($.isArray(cp_imgs)) {
        for (var i = 0; i < cp_imgs.length; i++) {
            img_arr.push(fun.getImgPath(cp_imgs[i], true));
        }
    } else {
        img_arr.push(fun.getImgPath(cp_imgs, true));
    }
    if (img_arr.length === 0) return;
    photoBrowser.open({
        images: img_arr,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        } else {
        }
    });
    return false;
});

// 调库存
$('body').on('tap', '.stock-btn,.dkc-item', function (e) {
    if ($(this).attr('disabled')) return;

    __PAGE_DATA['__DJ_DATA'] = __PAGE_DATA['__DJ_DATA'] || {};

    var flag = getRowMxData();
    if (!flag) return;
    var ck_id = (__PAGE_DATA['ck_info'] && __PAGE_DATA['ck_info']['id']) || 0;

    var cp_info = {
        number: $('#header_title').data('cp_bh'),//__PAGE_DATA['list_data']['cp_bh'],
        name: $('#header_title').data('cp_mc'),//__PAGE_DATA['list_data']['cp_mc'],
        id: $('#header_title').data('cp_id')//__PAGE_DATA['list_data']['cp_id'],
    };

    var _tmp = getRowSaveData();

    if ($.nui.isTrue(_tmp['ckd_dj_id']) || $.nui.isTrue(_tmp['ybjl_id'])) return;

    var cp_ys_info = {
        cp_ys_id: _tmp['cp_ys_id'],
        cp_ys_bh: _tmp['cp_ys_bh'],
        cp_ys_mc: _tmp['cp_ys_mc']
    };

    var state = 0;

    if (fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail')) {
        for (var i = 0; i < (ROW_DATA['mx'] || []).length; i++) {
            if ($.nui.isEmpty(ROW_DATA['mx'][i]['is_delete'])) {
                state = 1;
            }
        }
    } else {
        state = 1;
    }

    if ($.nui.isEmpty(__PAGE_DATA['edit_row']) && ($.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(parseInt(ROW_DATA['ps'] || 0)))) {
        var trueJlData = [];
        for (var i = 0; i < __JL_DATA.length; i++) {
            if ($.nui.isEmpty(__JL_DATA[i]['is_delete'])) {
                trueJlData.push(__JL_DATA[i]);
            }
        }

        if ($.nui.isTrue(__JL_DATA) && $.nui.isEmpty(trueJlData) && $.nui.isEmpty(__PAGE_DATA['row_index'])) {
            // api.sendEvent({
            //     name: page_data['return_page'],
            //     extra: {
            //         'status': 'delete_row',//update_mxbp
            //         'data': {
            //             row_index: __PAGE_DATA['row_index'],
            //             row_data: ROW_DATA,
            //         }
            //     }
            // });
            for (var i = __JL_DATA.length - 1; i >= 0; i--) {
                if ($.nui.isTrue(__JL_DATA[i]['is_delete'])) {
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'delete_row',//update_mxbp
                            'data': {
                                row_index: __JL_DATA[i]['__del_index'],
                                row_data: __JL_DATA[i],
                            }
                        }
                    });
                }
            }
        }
    } else {
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         'status': state ? 'update_row' : 'delete_row',//update_mxbp
        //         'data': {
        //             row_index: __PAGE_DATA['row_index'],
        //             row_data: ROW_DATA,
        //         }
        //     }
        // });
        // 多仓库总数新增时调库存，需要检查有没有问题
        // 调库存时，保存原有数据
        if (typeof __PAGE_DATA['row_index'] !== 'undefined' && __PAGE_DATA['row_index'] !== null && __JL_DATA[__PAGE_DATA.row_index]) { // 编辑记录行
            updateRowDataAmountAndMoney(__PAGE_DATA['row_index'], ROW_DATA);

            if (state) {

            } else {
                if ($.nui.isTrue(ROW_DATA['mx'])) {
                    // ROW_DATA['is_delete'] = 1;
                }
            }


            // TODO 不注释掉，调库存后会删除原先记录
            // 注释掉暂时还不清楚有什么效果
            // 单据保存过
            if ($.nui.isTrue(__PAGE_DATA['__DJ_DATA']['id']) || (__PAGE_DATA.edit_row && $.nui.isEmpty(__PAGE_DATA['__DJ_DATA']['id']))) {

                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        'status': state ? 'update_row' : 'delete_row',//update_mxbp
                        'data': {
                            row_index: __PAGE_DATA['row_index'],
                            row_data: ROW_DATA,
                        }
                    }
                });
            } else {

            }
            __JL_DATA[__PAGE_DATA['row_index']] = ROW_DATA;
        } else {       // 新增记录行
            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    'status': state ? 'update_row' : 'delete_row',//update_mxbp
                    'data': {
                        row_index: __PAGE_DATA['row_index'],
                        row_data: ROW_DATA,
                    }
                }
            });

            __JL_DATA.push(ROW_DATA);
            __PAGE_DATA['row_index'] = __JL_DATA.length - 1;   // 标记成有记录

        }
    }

    var tm_arr = [];
    for (var i = 0; i < __JL_DATA.length; i++) {
        if ($.nui.isTrue(__JL_DATA[i]['is_delete'])) continue;
        if ($.nui.isTrue(__JL_DATA[i]['mx'])) {
            if ($.nui.isTrue(__JL_DATA[i]['tm'])) tm_arr.push(__JL_DATA[i]['tm']);
            for (var j = 0; j < __JL_DATA[i]['mx'].length; j++) {
                if ($.nui.isTrue(__JL_DATA[i]['mx'][j]['is_delete'])) continue;
                if ($.nui.isTrue(__JL_DATA[i]['mx'][j]['tm'])) {
                    tm_arr.push(__JL_DATA[i]['mx'][j]['tm']);
                }
            }
        }
    }

    var dkcParams = {
        djlx: page_data.djlx,
        return_page: page_arr.choice_product,
        goto_page: __PAGE_DATA['return_page'],
        ck_id: ck_id,
        cp_info: cp_info,
        dw_id: _tmp['dw_id'] || 0,
        cp_ys_info: cp_ys_info,
        disabledCpCkYs: true,
        __EDIT_ROW: __PAGE_DATA.edit_row,
        row_index: __PAGE_DATA['row_index'],
        __row_data: ROW_DATA,
        tm_arr: tm_arr,
        __JL_DATA: __JL_DATA,
        __DJ_DATA: __PAGE_DATA['__DJ_DATA'] || {},
        get_jjdw: true,                  // 会从__row_data中获取计价单位
        ck_is_disabled: __PAGE_DATA['ck_is_disabled']
    };

    // 20200827处理调库存 待出库问题
    if ($.nui.isTrue(dkcParams['__DJ_DATA']['id'])) {
        if ($.nui.isEmpty(__getMxLength(ROW_DATA['mx'] || []))) {
            ROW_DATA['mx'] = [];
            dkcParams['__row_data'] = ROW_DATA;
        }
    }

    fun.showPageFull({
        page_url: page_arr.detailed_stock2,
        pageParam: dkcParams
    });
});

// 单位
$('body').on('tap', '#dw', function (e) {
    e.stopPropagation();
    var flag = getRowMxData();
    if (!flag) return;

    if ($(this).attr('disabled')) return;
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            "return_page": html_name,
            "page_type": 'dw',
            "return_type": 'dw'
        }
    });
});

// 颜色搜索
$('body').on('tap', '#color_search_wrap', function (e) {
    if ($(this).find('#color_search').attr('disabled')) return;

    var cp_id = $('#header_title').data('cp_id');
    var cp_list = fun.getItem('cp_list') || [];
    var tmp_data = fun.getListInfoByKey(cp_list, cp_id) || {};

    var ck_id = (__PAGE_DATA['ck_info'] && __PAGE_DATA['ck_info']['id']) || 0;
    tmp_data['imgs'] = tmp_data['imgs'] || '';

    var cpbj_info = {
        cp_id: tmp_data['id'] || 0,
        cp_bh: tmp_data['number'] || '',
        cp_mc: tmp_data['name'] || '',
        cp_ys_id: 0,
        cp_ys_bh: '',
        cp_ys_mc: '',
        fzsh: '',
        fzys: '',
        kcms: tmp_data['diff'] || '+',
        imgs: (tmp_data['imgs'] && tmp_data['imgs'].split(',')[0]) || '',
        dw_id: tmp_data['unit_id'] || 0,
        dw_mc: tmp_data['unit_name'] || '',
        fk: tmp_data['width'] || '',
        kz: tmp_data['weight'] || '',
        gg: tmp_data['spec'] || '',
        cf: tmp_data['component'] || ''
    };
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            return_page: html_name,
            cp_id: cp_id,
            page_type: 'cp_ys',
            clearData: false,
            cpbj_info: cpbj_info,
            NOT_SHOW_SK: fun.getHouseValue(ck_id, 'type') !== 'skyb',
            djlx: page_data['djlx'],
            ck_id: ROW_DATA['ck_id'] || 0,
            __JL_DATA: __JL_DATA
        }
    });
});

// 下个色
$('body').on('tap', '#color', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;
    // var flag = getRowMxData();
    // if (!flag) return;

    // getRowSaveData();
    // __setRowData(null, {}, { hsdj_fixed: hsdj_fixed });

    // if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && ($.nui.isTrue(ROW_DATA['zsl']) || $.nui.isTrue(ROW_DATA['ps']))) return fun.toast('请选择颜色！');
    // if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && $.nui.isEmpty(ROW_DATA['zsl']) && $.nui.isEmpty(ROW_DATA['ps'])) {
    //     jumpToYs();
    //     return;
    // }

    // if (page_data.djlx !== 'kc_bppyd' && page_data.djlx !== 'kc_bptbd') {
    //     if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) return fun.toast('请选择计价单位！');
    // } else {
    //     delete ROW_DATA['jjdw_id'];
    // }

    // // 判断 匹数 数量 都不能为空 

    // var TMP_ROW_DATA = $.extend({}, ROW_DATA);


    // if ($.nui.isEmpty(__PAGE_DATA['edit_row']) && ($.nui.isEmpty(ROW_DATA['zsl']) || parseFloat(ROW_DATA['zsl'] || 0) == 0) && $.nui.isEmpty(ROW_DATA['ps'])) {

    // } else {
    //     if ($.nui.isTrue(__PAGE_DATA['edit_row'])) {
    //         __JL_DATA[__PAGE_DATA['row_index']] = TMP_ROW_DATA;
    //     } else {
    //         __JL_DATA.push(TMP_ROW_DATA);
    //     }
    //     // 把当前详情页的记录数据发给选择产品的页面，目的是为了让 选产品的页面 更新：已选匹、已选数量 页面效果
    //     api.sendEvent({
    //         name: page_arr.choice_product,
    //         extra: {
    //             'status': 'update_rows',
    //             'data': {
    //                 __JL_DATA: __JL_DATA,
    //             }
    //         }
    //     });

    // }


    // switch (_options['status']) {
    //     case 'ok'://完成

    //         fun.showLoad('生成单据中...');
    //         break;
    //     case 'tzym'://跳转选颜色页面
    //         // if (__PAGE_DATA['edit_row']) {
    //         //     __JL_DATA[__PAGE_DATA['row_index']] = TMP_ROW_DATA;
    //         // } else {
    //             __JL_DATA.push(TMP_ROW_DATA);
    //         // }

    //         // 把当前详情页的记录数据发给选择产品的页面，目的是为了让 选产品的页面 更新：已选匹、已选数量 页面效果
    //         api.sendEvent({
    //             name: page_arr.choice_product,
    //             extra: {
    //                 'status': 'update_rows',
    //                 'data': {
    //                     __JL_DATA: __JL_DATA,
    //                 }
    //             }
    //         });
    //         break;
    // }

    if (__PAGE_DATA['MXTM']) {
        var __result = mxRow();

        switch (__result['status']) {
            case 'ok':
                // api.sendEvent({
                //     name: __PAGE_DATA['return_page'],
                //     extra: {
                //         'status': __result['state'] ? 'update_row' : 'delete_row',//update_mxbp
                //         'data': {
                //             row_index: __PAGE_DATA['row_index'],
                //             row_data: ROW_DATA,
                //         }
                //     }
                // });
                var TMP_ROW_DATA = $.extend({}, ROW_DATA);
                __JL_DATA[__PAGE_DATA['row_index']] = TMP_ROW_DATA;

                // 清除页面的部分状态值
                __PAGE_DATA['edit_row'] = false;
                __PAGE_DATA['row_index'] = undefined;
                __PAGE_DATA['MXTM'] = false;
                __PAGE_DATA['list_data'] = $.extend({}, PAGE_INIT_DATA);

                ROW_DATA = $.extend({}, PAGE_INIT_DATA, {
                    cp_ys_id: 0,
                    cp_ys_bh: '',
                    cp_ys_mc: ''
                });

                console.log(11, ROW_DATA)
                getRowSaveData();
                // 跳转 颜色选择页
                jumpToYs();
                break;
        }
    } else {
        var __result = addRow();

        switch (__result['status']) {
            case 'ok':
                // 清除页面的部分状态值
                __PAGE_DATA['edit_row'] = false;
                __PAGE_DATA['row_index'] = undefined;
                __PAGE_DATA['list_data'] = $.extend({}, PAGE_INIT_DATA);

                ROW_DATA = $.extend({}, PAGE_INIT_DATA, {
                    cp_ys_id: 0,
                    cp_ys_bh: '',
                    cp_ys_mc: ''
                });

                // 把当前详情页的记录数据发给选择产品的页面，目的是为了让 选产品的页面 更新：已选匹、已选数量 页面效果
                api.sendEvent({
                    name: page_arr.choice_product,
                    extra: {
                        'status': 'update_rows',
                        'data': {
                            __JL_DATA: __JL_DATA,
                        }
                    }
                });

                getRowSaveData();
                // 跳转 颜色选择页
                jumpToYs();
                break;
            case 'not_zsl_ps':
                getRowSaveData();
                // 跳转 颜色选择页
                jumpToYs();
                break;
        }
    }


    // 跳转 颜色选择页
    function jumpToYs() {
        var cp_list = fun.getItem('cp_list') || [];
        var tmp_data = fun.getListInfoByKey(cp_list, ROW_DATA['cp_id']) || {};
        var cpbj_info = {
            cp_id: tmp_data['id'] || 0,
            cp_bh: tmp_data['number'] || '',
            cp_mc: tmp_data['name'] || '',
            cp_ys_id: 0,
            cp_ys_bh: '',
            cp_ys_mc: '',
            fzsh: '',
            fzys: '',
            kcms: tmp_data['diff'] || '+',
            imgs: tmp_data['imgs'] ? (tmp_data['imgs'].split(',')[0] || '') : '',
            dw_id: tmp_data['unit_id'] || 0,
            dw_mc: tmp_data['unit_name'] || '',
            fk: tmp_data['width'] || '',
            kz: tmp_data['weight'] || '',
            gg: tmp_data['spec'] || '',
            cf: tmp_data['component'] || ''
        };

        fun.showPageFull({
            page_url: page_arr.select_list,
            pageParam: {
                return_page: html_name,
                cp_id: $('#header_title').data('cp_id'),
                page_type: 'cp_ys',
                clearData: true,
                cpbj_info: cpbj_info,
                NOT_SHOW_SK: fun.getHouseValue(ROW_DATA['ck_id'], 'type') !== 'skyb',
                djlx: page_data['djlx'],
                ck_id: ROW_DATA['ck_id'] || 0,
                __JL_DATA: __JL_DATA
            }
        });

        setTimeout(function () {
            resetData();
            // 初始化页面布局
            initPageLayout();
            initEditDom();
            isXGE = true;
            setColorBtnDisplay();
            initColorAdd();
            isClear = true;
        }, 200);
        if (billZsmx.checkCkWinAndTm()) {
            setPanelHide();
        }
    }
});

// 类型
$('body').on('click', '#lx,#lx_icon', function (e) {
    e.preventDefault();

    var _id = $(this).attr('id');
    var val = '';
    switch (_id) {
        case 'lx':
            val = $(this).text().trim() || '';
            if ($(this).attr('disabled')) return;
            break;
        case 'lx_icon':
            val = $('#lx').text().trim() || '';
            if ($('#lx').attr('disabled')) return;
            break;
    }
    getRowSaveData();
    var list = fun.getSaleLxData({ ck_id: ROW_DATA['ck_id'], cp_ys_bh: ROW_DATA['cp_ys_bh'] });
    $(list).each(function (i, arr) {
        if (arr['name'] == val) {
            list[i]['is_choose'] = 1;
        } else {
            list[i]['is_choose'] = 0;
        }
    });
    fun.showBookList({
        list: list,
        choose: function (val) {
            if ($('#lx').data('jg_lx') === val['id']) return; // 选择相同不执行
            $('#lx').text(val['name']).data('jg_lx', val['id']);
            //2020-06-09 新增选择剪样后读取对应单位
            if (val['id'] == 'jy' && (page_data['djlx'] == 'bp_xsfhjs' || page_data['djlx'] == 'bp_xsthjs')) {
                if ($('#dw').attr('disabled') != true && $('#jjdw').text() != '份') {
                    var unit_options = fun.getValByKey(cp_list || [], ROW_DATA['cp_id'], 'unit_options');
                    var jjdw_name = fun.getValByKey(jjdw_list || [], unit_options['jydw_id'], 'name');
                    if ($.nui.isTrue(unit_options['jydw_id'])) {
                        ROW_DATA['jjdw_id'] = unit_options['jydw_id'];
                        ROW_DATA['dw_id'] = unit_options['jydw_id'];
                        ROW_DATA['jjdw_mc'] = jjdw_name;
                        ROW_DATA['dw_mc'] = jjdw_name;
                        $('#dw').text(jjdw_name).data('dw_id', ROW_DATA['jjdw_id']);
                        $('#jjdw').text(jjdw_name).data('jjdw_id', ROW_DATA['jjdw_id']);
                        __setRowData(null, { dw_id: ROW_DATA['dw_id'], dw_mc: ROW_DATA['dw_mc'], jjdw_id: ROW_DATA['jjdw_id'], jjdw_mc: ROW_DATA['jjdw_mc'] }, { hsdj_fixed: hsdj_fixed });
                        billZsmx.setJjsl();
                    }
                    // else if($.nui.isTrue(unit_options['xsdw_id'])){
                    //     jjdw_name = fun.getValByKey(jjdw_list || [], unit_options['xsdw_id'], 'name');
                    //     ROW_DATA['jjdw_id'] = unit_options['xsdw_id'];
                    //     ROW_DATA['dw_id'] = unit_options['xsdw_id'];
                    //     ROW_DATA['jjdw_mc'] = jjdw_name;
                    //     ROW_DATA['dw_mc'] = jjdw_name;
                    //     $('#dw').text(jjdw_name).data('dw_id',ROW_DATA['jjdw_id']);
                    //     $('#jjdw').text(jjdw_name).data('jjdw_id',ROW_DATA['jjdw_id']);
                    // }
                }
            }

            if (val['id'] === 'sk') {
                $('#dw').text('份').attr('disabled', true);
                $('#jjdw').text('份').attr('disabled', true);

                ROW_DATA['jjdw_mc'] = '份';
                ROW_DATA['dw_mc'] = '份';
            } else {

            }

            getRowSaveData();
            fun.showLoad();

            __PAGE_DATA['__DJ_DATA'] = __PAGE_DATA['__DJ_DATA'] || {};

            __getDj({
                data: {
                    "djlx": Bills['djlx'],
                    "wldw_id": __PAGE_DATA['__DJ_DATA']['wldw_id'] || 0,
                    "cp_id": ROW_DATA['cp_id'] || 0,
                    "cp_ys_id": ROW_DATA['cp_ys_id'] || 0,
                    "jjdw_id": ROW_DATA['jjdw_id'] || 0,
                    "kdsj": __PAGE_DATA['__DJ_DATA']['kdsj'] || fun.formatDate(new Date()),
                    // 标准价 最低价 需要用到类型
                    "jg_lx": fun.getValByKey(fun.getSaleLxData({ showAll: true }) || [], ROW_DATA['jg_lx_mc'], 'simple', 'name') || 'dh'
                },
                callback: function (res) {
                    if (res['status'] == 0) {
                        var __data = {};
                        __data['lx'] = val['name'];
                        __data['jg_lx_mc'] = val['name'];
                        __data['jg_lx'] = val['simple'];
                        __data['simple'] = val['simple'];
                        __data['bzj'] = res['data']['bzj'] || 0;
                        __data['zdj'] = res['data']['zdj'] || 0;
                        __data['dj'] = res['data']['dj'] || 0;
                        __data['scdj'] = res['data']['scdj'] || 0;
                        __data['ssdj'] = res['data']['ssdj'] || 0;
                        __setRowData(null, __data, { hsdj_fixed: hsdj_fixed, upDateSssl: false, upDateSsdj: true});
                        if (page_data['djlx'] === 'kc_bppyd') {
                            ROW_DATA['hsdj'] = ROW_DATA['dj'];
                        }
                        $('#dj').val(ROW_DATA['hsdj'] || 0);
                    }
                    fun.hideLoad();
                }
            });
        }
    });
});

// 完成
$('body').on('tap', '#complete_btn', function (e) {
    e.stopPropagation();
    // var flag = getRowMxData();
    // if (!flag) return;

    // getRowSaveData();
    // __setRowData(null, {}, { hsdj_fixed: hsdj_fixed });

    // if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && ($.nui.isTrue(parseFloat(ROW_DATA['zsl'] || 0)) || $.nui.isTrue(ROW_DATA['ps']))) return fun.toast('请选择颜色！');
    // if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && $.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(ROW_DATA['ps'])) {
    //     jumpToPage();
    //     return;
    // }

    // if (page_data.djlx !== 'kc_bppyd' && page_data.djlx !== 'kc_bptbd') {
    //     if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) return fun.toast('请选择计价单位！');
    // } else {
    //     delete ROW_DATA['jjdw_id'];
    // }


    // // 判断 匹数 数量 都不能为空 

    // var TMP_ROW_DATA = $.extend({}, ROW_DATA);

    // if ($.nui.isEmpty(__PAGE_DATA['edit_row']) && ($.nui.isEmpty(ROW_DATA['zsl']) || parseFloat(ROW_DATA['zsl'] || 0) == 0) && $.nui.isEmpty(ROW_DATA['ps'])) {

    // } else {
    //     if (__PAGE_DATA['edit_row']) {
    //         // __JL_DATA.splice(__PAGE_DATA['row_index'], 1, ROW_DATA);
    //         __JL_DATA[__PAGE_DATA['row_index']] = TMP_ROW_DATA;
    //     } else {
    //         __JL_DATA.push(TMP_ROW_DATA);
    //     }

    //     fun.showLoad('生成单据中...');
    // }

    // switch (addRow){
    //     case 'ok':
    //         fun.showLoad('生成单据中...');
    //         jumpToPage();
    //         break;
    //     case 'tzym': // 
    //         jumpToPage();
    //         break;
    // }

    if (__PAGE_DATA['MXTM']) {
        var __result = mxRow();

        api.sendEvent({
            name: finally_page,
            extra: {
                'status': 'update_phsz',
                'data': {

                }
            }
        });

        switch (__result['status']) {
            case 'ok':
                api.sendEvent({
                    name: __PAGE_DATA['return_page'],
                    extra: {
                        'status': __result['state'] ? 'update_row' : 'delete_row',//update_mxbp
                        'data': {
                            row_index: __PAGE_DATA['row_index'],
                            row_data: ROW_DATA,
                        }
                    }
                });
                api.closeToWin({
                    name: finally_page
                });
                break;
        }
    } else {
        var __result = addRow();

        api.sendEvent({
            name: finally_page,
            extra: {
                'status': 'update_phsz',
                'data': {

                }
            }
        });

        switch (__result['status']) {
            case 'ok':
                fun.showLoad('生成单据中...');
                // 跳转 到 开单页            
                jumpToPage();
                break;
            case 'not_zsl_ps':
                // 跳转 到 开单页            
                jumpToPage();
                break;
        }
    }

    // jumpToPage();
    // 跳转 到 开单页
    function jumpToPage() {
        if ($.nui.isTrue(page_data['__route']) && !page_data['NOT_OPEN_AGAIN']) {
            if (['kc_bppyd', 'kc_bptbd'].indexOf(page_data.djlx) > -1) { // 盘盈开单编辑、调拨单编辑
                gotoPydEdit(__JL_DATA);
            } else {
                var __opt = { html_name: html_name, page_data: page_data };
                __opt.page_data['ck'] = fun.getListInfoByKey(fun.getItem('ck_list') || [], ROW_DATA['ck_id']) || {};
                __opt.page_data['wldw'] = page_data['wldw'];

                if (page_data.djlx === 'bp_cglhjs' || page_data.djlx === 'bp_cgthjs') {               // 来货\退货结算处理
                    __opt.page_data.data = { list: __JL_DATA };
                    __opt.closeWin = true;
                } else {
                    __opt.page_data['xsjs_tmp'] = { __JL_DATA: __JL_DATA };
                }

                if (page_data.djlx === 'bp_cglhjs' || page_data.djlx === 'bp_cgthjs') {
                    page_data.return_page = page_arr.cg_lthjs_tj;
                }
                PageShow.gotoNextPage(__opt);
            }

            return;
        }

        // if (page_data.NOT_OPEN_AGAIN && page_data.djlx === 'kc_bptbd') { // 调拨单特殊处理
        //     // TODO 为什么这么写
        //     page_data.return_page = page_data.goto_page;
        //     gotoPydEdit(__JL_DATA);
        // } else {
        // if ($.nui.isTrue(page_data['__route'])) {
        //     if (page_data['kdbj_tmp']) {
        //         page_data['return_page'] = page_data['kdbj_tmp']['return_page'];
        //         target_page = page_data['return_page'];
        //     }
        // }
        api.sendEvent({
            name: finally_page,
            extra: {
                'status': 'update_rows',
                'data': {
                    __JL_DATA: __JL_DATA
                }
            }
        });

        api.closeToWin({
            name: finally_page
        });
        // }
    }
});

// 展开收缩
$('body').on('tap', '#toggle', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;
    if ($(this).find('.icon-toggle').hasClass('icon-xia')) {
        setPanelHide();
    } else {
        setPanelShow();
    }
});

// 点击输入框
$('body').on('tap', 'input', function (e) {
    var target = $(e.target);

    if (target.is('#value')) {
        e.stopPropagation();
        return false;
    } else {
        cache_data['target'] = '';
    }
});

// 匹数
$('body').on('tap', '#ps', function (e) {
    e.stopPropagation();

    if (__PAGE_DATA['bj_type'] === 'mx') {
        cache_data['target'] = 'mx';
        return;
    } else if (__PAGE_DATA['bj_type'] === 'zs') {
        getRowMxData();
        $('.choice-cloth').removeClass('choice-cloth bpck-choice');
    }

    if ($(this).attr('disabled')) return;

    $('input').removeClass('active-border');
    $(this).addClass('active-border');

    // $(this).select();
    cache_data['target'] = 'ps';
    $('#value').val($(this).val());
    setPanelShow();
    // if(__PAGE_DATA['bj_type'] != 'mx') $(this).removeAttr('readonly');
});

// 数量
$('body').on('tap', '#sl', function (e) {
    e.stopPropagation();

    if (__PAGE_DATA['bj_type'] == 'mx') {
        cache_data['target'] = 'mx';
        return;
    } else if (__PAGE_DATA['bj_type'] === 'zs') {
        getRowMxData();
        $('.choice-cloth').removeClass('choice-cloth bpck-choice');
    }

    if ($(this).attr('disabled')) return;

    $('input').removeClass('active-border');
    $(this).addClass('active-border');

    cache_data['target'] = 'sl';
    $('#value').val($(this).val());
    // if(__PAGE_DATA['bj_type'] != 'mx') $(this).removeAttr('readonly');

    setJjslColor();
    setPanelShow();
});

// 细码数添加按钮
$('body').on('tap', '.add-item', function (e) {
    $this_height = 10000000;
    if (__PAGE_DATA['bj_type'] == 'zs') {
        e.stopPropagation();

        if ($('.active-border').length) {
            if ($('.active-border').attr('id') == 'ps') {
                $('#ps').val($('#value').val());
                $('#value').val('');
                __setRowData(null, { ps: parseInt($('#ps').val() || 0) }, { hsdj_fixed: hsdj_fixed });

            } else if ($('.active-border').attr('id') == 'sl') {
                $('#sl').val($('#value').val());
                $('#value').val('');
                __setRowData(null, { zsl: parseFloat($('#sl').val() || 0) }, { hsdj_fixed: hsdj_fixed });

                $('#jjsl_val').val(ROW_DATA['jjsl']);

                setJjslColor();
            }

            $('input').removeClass('active-border');
        }
        setPanelShow();

        cache_data['target'] = 'mx';

        // $('input').removeClass('active-border');
    }


    if ($(this).prev('.cloth-mx-item:visible').length) {
        var itemVal = $(this).prev('.cloth-mx-item:visible').find('.item-mx').text().trim();
        if ($.nui.isEmpty(itemVal) || (parseFloat(itemVal || 0) == 0)) return fun.toast('请输入布匹数量！');
    }

    var flag = getRowMxData();
    if (!flag) return;
    // var _data = {
    //     "__jl_index": page_data['row_index'] || 0,
    //     // "px": 2,
    //     // "ph": 1,
    //     "sl": $('#value').val().trim(),
    //     // "bqsl": 150,
    //     // "jjsl": 150,
    //     // "sl2": 0,
    //     // "jz": 150
    // };
    var prevMxData = $('.cloth-mx-item.choice-cloth').prev('.cloth-mx-item:visible').data('mx_data') || {};
    var __px = prevMxData['px'] || 1;
    var __ph = (prevMxData['ph'] || 0) + 1;
    if (__ph > 10) {
        __ph = 1;
        __px++;
    }


    var curr_val = $('.cloth-mx-item.choice-cloth').find('.item-mx').text().trim();
    var curr_mx_data = $('.cloth-mx-item.choice-cloth').data('mx_data') || {};

    var _data = {
        "__jl_index": __PAGE_DATA['row_index'] || 0,
        "px": __px,
        "ph": __ph,
        "sl": parseFloat(curr_val || 0),
        is_delete: 0
    };

    var ___data1 = $.extend({}, curr_mx_data, _data);

    $('.cloth-mx-item.choice-cloth').data('mx_data', ___data1);

    calcPsAndSl();
    $('#value').val('');
    $('.cloth-mx-item').removeClass('choice-cloth bpck-choice');

    // data-mx_data=\''+JSON.stringify(_data)+'\'

    $(this).before('<div class="cloth-item cloth-mx-item choice-cloth ' + fun.is_value(billZsmx.addMxActive(___data1)) + '"><span class="item-mx"></span></div>');
    $('.content-wrap').scrollTop(100000);
    setPsAndSlDisabled();
});

//查看已添加的颜色
$('body').on('tap', '.record_added', function (e) {
    e.stopPropagation();
    var Html = [];

    var flag = getRowMxData();
    if (!flag) return;

    getRowSaveData();

    if (__PAGE_DATA['edit_row'] && typeof __PAGE_DATA['row_index'] !== 'undefined' && __PAGE_DATA['row_index'] !== null) {
        __JL_DATA[__PAGE_DATA['row_index']] = $.extend({}, ROW_DATA);
    }

    __CP_YS_JL = [];
    for (var i = 0; i < __JL_DATA.length; i++) {
        if ($.nui.isEmpty(__JL_DATA[i]['__row_uuid'])) {
            __JL_DATA[i]['__row_uuid'] = $.nui.getRandomNum();
        }
        if ($.nui.isTrue(__JL_DATA[i]['is_delete'])) continue;
        if (__JL_DATA[i]['cp_id'] == ROW_DATA['cp_id']) {
            __CP_YS_JL.push(__JL_DATA[i]);
        }
    }

    for (var i = 0; i < __CP_YS_JL.length; i++) {
        var val = __CP_YS_JL[i];

        var row_index = $.nui.findIndex(__JL_DATA, function (item) {
            return val.__row_uuid === item.__row_uuid;
        });

        Html.push('<li class="selection-list lower-border-line" row_index="' + row_index + '">');
        Html.push('    <div class="selection-box">');
        Html.push('         <span class="selection-color">' + val['cp_ys_bh'] + val['cp_ys_mc'] + '</span>');
        Html.push('    </div>');
        Html.push('    <div class="selection-box">');
        Html.push('         <span class="selection-text">已选：' + val['ps'] + '匹 ' + val['zsl'] + val['dw_mc'] + '</span>');
        Html.push('         <i class="iconfont icon-youfanhui"></i>');
        Html.push('    </div>');
        Html.push('</li>');
    }

    $('.selection').html(Html.join(''));
    $('.selection-mask,.selection').show();
    $('.collapse-wrap').removeClass('open');
    $('#header').css('z-index', '6');
});

// 点击已添加颜色记录行
$('body').on('tap', '.selection-list', function (e) {

    // TODO
    // 先保存当前页面数据到记录里
    // 再切换当前记录行数据，并显示到页面

    var select_data = __JL_DATA[$(this).attr('row_index')];

    var cpysbhmc = (select_data['cp_ys_bh'] || '') + ' ' + (select_data['cp_ys_mc'] || '');
    var title = $.nui.isTrue($.trim(cpysbhmc)) ? '【' + $.trim(cpysbhmc) + '】' : '';

    switch (page_data.djlx) {
        case 'bp_xsdd':
        case 'bp_cgdd':
            if ($.nui.isTrue(select_data['is_has'])) {
                return fun.toast(title + '被调用过，不允许编辑。');
            } else if ($.nui.isTrue(select_data['is_jd'])) {
                return fun.toast(title + '已结单，不允许编辑。');
            }
            break;
    }

    if (__PAGE_DATA['MXTM']) {
        var __result = mxRow();

        switch (__result['status']) {
            case 'ok':
                // api.sendEvent({
                //     name: __PAGE_DATA['return_page'],
                //     extra: {
                //         'status': __result['state'] ? 'update_row' : 'delete_row',//update_mxbp
                //         'data': {
                //             row_index: __PAGE_DATA['row_index'],
                //             row_data: ROW_DATA,
                //         }
                //     }
                // });
                var TMP_ROW_DATA = $.extend({}, ROW_DATA);
                __JL_DATA[__PAGE_DATA['row_index']] = TMP_ROW_DATA;

                __PAGE_DATA['edit_row'] = true;
                __PAGE_DATA['row_index'] = $(this).attr('row_index');
                __PAGE_DATA['list_data'] = __JL_DATA[$(this).attr('row_index')];
                psslTmpDisabled = [];
                $('input,.cloth-mx-item,#cloth_wrap').removeAttr('disabled');

                __PAGE_DATA['MXTM'] = $.nui.isTrue(__PAGE_DATA['list_data']['mx']) && $.nui.isTrue(existTm(__PAGE_DATA['list_data']['mx'])); //有条码

                init();
                setColorBtnDisplay();
                initColorAdd();
                $('#header').css('z-index', ' 10000000');
                $('.selection-mask,.selection').hide();
                break;
        }
    } else {
        var __result = addRow();
        switch (__result['status']) {
            case 'ok':
                __PAGE_DATA['edit_row'] = true;
                __PAGE_DATA['row_index'] = $(this).attr('row_index');
                __PAGE_DATA['list_data'] = __JL_DATA[$(this).attr('row_index')];
                psslTmpDisabled = [];
                $('input,.cloth-mx-item,#cloth_wrap').removeAttr('disabled');

                init();
                setColorBtnDisplay();
                initColorAdd();
                $('#header').css('z-index', ' 10000000');
                $('.selection-mask,.selection').hide();
                break;
        }
    }
});

// 点击阴影
$('body').on('tap', '.selection-mask', function (e) {
    $('#header').css('z-index', ' 10000000');
    $('.selection-mask,.selection').hide();
});

// 监听计价数是否发生变化
$('body').on('input', '#jjsl', function (e) {
    $(this).addClass('ipt-change');
});

// 新需求20191226
$('body').on('tap', '.show-xs-tips', function (e) {
    $(this).hide();
    $('#cloth_wrap').show();
    setTimeout(function () {
        $('.add-item').trigger('tap');
    }, 20);
});

// 点击数字键盘显示区
$('body').on('tap', '#value', function (e) {
    e.stopPropagation();
    return false;
});

// 明细区
$('body').on('tap', '#cloth_wrap', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;
    cache_data['target'] = 'mx';
    if (__PAGE_DATA['bj_type'] == 'zs') {
        // if (__PAGE_DATA['bj_type'] == 'zs') {
        if ($('.active-border').length) {
            var tmp_data = {};
            if ($('.active-border').attr('id') == 'ps') {
                tmp_data['ps'] = parseInt($('#ps').val() || 0);
            }
            if ($('.active-border').attr('id') == 'sl') {
                tmp_data['zsl'] = parseFloat($('#sl').val() || 0);
            }

            __setRowData(null, tmp_data, { upDateSssl: false })
        }
        // }
        $('#jjsl_val').val(ROW_DATA['jjsl'] || '');
        setJjslColor();
        setPanelHide();
        $('input').removeClass('active-border');
        $('#value').val('');
        setDelClothShow();
        setClearBtnShow();
        return;
    }
    setPanelShow();
});

// 点击数字键盘
$('body').on('tap', '.layer-content', function (e) {
    e.stopPropagation();
    return false;
});

//绑定键盘按键
$('body').on('tap', '.num', function (e) {
    e.stopPropagation();

    if ($.nui.isEmpty(cache_data['target'])) return;

    var val = $('#value');
    var key = $(this).attr('key');

    var vibrate = [];
    vibrate = (api.systemType == 'android') ? [10, 30] : [10];
    if (api.systemType == 'android') {
        api.notification({
            vibrate: vibrate,
        });
    }

    if (key == '.' && cache_data['target'] == 'ps') return;

    if (key == '.' && val.val().trim() === '') {
        val.val('0' + key);
    }

    if (key == '.' && val.val().indexOf('.') > -1) return;
    if (parseFloat((val.val().trim() + $(this).attr('key')) || 0) > 100000000) return fun.toast('输入数字不能超过100000000！');
    var tmpVal = val.val().trim();
    if (tmpVal.split('.')[1] && tmpVal.split('.')[1].length >= 4) return fun.toast('最多只能输入4位小数！');

    if (key != '.' && val.val().trim() === '0') {
        val.val(key);
    } else {
        val.val(val.val() + $(this).attr('key'));
    }

    switch (cache_data['target']) {
        case 'ps':
            $('#ps').val(val.val());
            __setRowData(null, { ps: parseInt($('#ps').val() || 0) }, { hsdj_fixed: hsdj_fixed });
            break;
        case 'sl':
            $('#sl').val(val.val());

            var value = parseFloat($('#sl').val() || 0);
            var row = ROW_DATA;
            var zps = 0,
                mx = row['mx'] || [];
            if (value <= 0) {
                for (var i = 0; i < mx.length; i++) {
                    if ($.nui.isTrue(mx[i]['is_delete'])) continue;
                    mx[i]['is_delete'] = 1;
                }
            } else {
                for (var i = 0; i < mx.length; i++) {
                    if ($.nui.isTrue(mx[i]['is_delete'])) continue;
                    zps++;
                    if (zps >= 2) break;
                }
                var isPush = true;
                if (zps <= 1) {
                    for (var i = 0; i < mx.length; i++) {
                        if ($.nui.isTrue(mx[i]['is_delete'])) continue;
                        // 如果当前有值的信息是 明细表第一行的第一匹则直接修改值，反之则删除
                        mx[i]['sl'] = value;
                        isPush = false;
                        break;
                    }
                }
                // 判断明细表是否只有1匹，则把 记录表的 数量 赋值给 明细表
                if (isPush && $.nui.isTrue(__PAGE_DATA['ck_info']) && $.nui.isTrue(__PAGE_DATA['ck_info']['is_detail'])) {
                    mx.push({
                        px: 1,
                        ph: 1,
                        sl: row['zsl']
                    });
                }
            }

            var _tmpJlRow = {
                zsl: value
            };
            if (zps === 1) _tmpJlRow['ps'] = 1;

            __setRowData(null, _tmpJlRow, { hsdj_fixed: hsdj_fixed });

            $('#jjsl_val').val(ROW_DATA['jjsl'] || '');

            // setRowDataJjsl(_tmpJlRow);
            setJjslColor();
            break;
        case 'mx':
            $('.choice-cloth').find('.item-mx').text(val.val());
            // var mxData = $('.choice-cloth').data('mx_data');
            // if ($.nui.isTrue(billZsmx.enabledMxgl(mxData)) && billZsmx.djlxIsXscgthjs()) {
            //     if (fun.toNumber(val.val()) === fun.toNumber(mxData.tm_sl)) {
            //         $('.choice-cloth').removeClass('bpck-choice bpck-color');
            //     } else {
            //         $('.choice-cloth').removeClass('bpck-choice bpck-color');
            //     }
            // }
            break;
        case 'dj':

            break;
        case 'jjsl':

            break;
    }

    //震动
    // api.notification({
    //     vibrate: [10],
    //     // sound:'default',
    //     // sound: 'widget://res/audio/accept.mp3'
    // });

    setPanelShow();

    setDelClothShow();
});

// 清除按钮绑定多个事件
$('body').delegate('#remove', {
    touchstart: function (e) {
        e.stopPropagation();
        longClick = 0; //设置初始为0
        timeOutEvent = setTimeout(function () { //此处为长按事件
            longClick = 1; //假如长按，则设置为1
            $('#value').val('');
            switch (cache_data['target']) {
                case 'ps':
                    $('#ps').val('');
                    __setRowData(null, { ps: 0 }, { hsdj_fixed: hsdj_fixed });
                    break;
                case 'sl':
                    $('#sl').val('');
                    __setRowData(null, { zsl: 0 }, { hsdj_fixed: hsdj_fixed });
                    $('#jjsl_val').val(ROW_DATA['jjsl'] || '');
                    setJjslColor();
                    break;
                case 'mx':
                    $this_height = $('.choice-cloth').length && $('.choice-cloth').offset().top || 0;
                    window.scrollTo(0, $this_height - px_rem);
                    $('.choice-cloth').find('.item-mx').text('') //.remove();
                    calcPsAndSl();
                    break;
                case 'dj':

                    break;
                case 'jjsl':

                    break;
            }

            setClearBtnShow();
            // cache_data['target'] === 'mx' && calcPsAndSl();
        }, 500);
    },
    touchmove: function (e) {
        e.stopPropagation();
        clearTimeout(timeOutEvent);
        timeOutEvent = 0;
        e.preventDefault();
    },
    touchend: function (e) {
        e.stopPropagation();
        clearTimeout(timeOutEvent);
        if (timeOutEvent != 0 && longClick == 0) { //此处为点击事件
            var val = $('#value');
            var valText = val.val();
            val.val(valText.substring(0, valText.length - 1));

            switch (cache_data['target']) {
                case 'ps':
                    $('#ps').val(val.val());
                    __setRowData(null, { ps: parseInt($('#ps').val() || 0) }, { hsdj_fixed: hsdj_fixed });
                    break;
                case 'sl':
                    $('#sl').val(val.val());
                    __setRowData(null, { zsl: parseFloat($('#sl').val() || 0) }, { hsdj_fixed: hsdj_fixed });
                    $('#jjsl_val').val(ROW_DATA['jjsl'] || '');
                    setJjslColor();
                    break;
                case 'mx':
                    $this_height = $('.choice-cloth').length && $('.choice-cloth').offset().top || 0;
                    window.scrollTo(0, $this_height - px_rem);
                    $('.choice-cloth').find('.item-mx').text(val.val());
                    if (!val.val()) {
                        // $('.choice-cloth').remove();
                        calcPsAndSl();
                    }
                    break;
                case 'dj':

                    break;
                case 'jjsl':

                    break;
            }
        }
        setClearBtnShow();
        setDelClothShow();
        var vibrate = [];
        vibrate = (api.systemType == 'android') ? [10, 30] : [10];

        if (api.systemType == 'android') {
            api.notification({
                vibrate: vibrate,
            });
        }
        return false;
    }
});

//确定
$('body').on('tap', '#save-btn', function (e) {
    e.stopPropagation();
    window.scrollTo(0, 10000000);
    switch (cache_data['target']) {
        case 'ps':
            if (__PAGE_DATA['bj_type'] == 'mx') return;
            $('#ps').val($('#value').val());
            $('#value').val('');
            __setRowData(null, { ps: parseInt($('#ps').val() || 0) }, { hsdj_fixed: hsdj_fixed });
            // setRowDataJjsl({
            //     ps: parseInt($('#ps').val() || 0)
            // });
            setPanelHide();
            break;
        case 'sl':
            if (__PAGE_DATA['bj_type'] == 'mx') return;
            $('#sl').val($('#value').val());
            $('#value').val('');
            __setRowData(null, { zsl: parseFloat($('#sl').val() || 0) }, { hsdj_fixed: hsdj_fixed });

            $('#jjsl_val').val(ROW_DATA['jjsl']);
            // $('#jjsl').val(ROW_DATA['jjsl']);

            setJjslColor();
            setPanelHide();
            break;
        case 'mx':
            if ($.nui.isEmpty($('#value').val().trim()) || (parseFloat($('#value').val().trim() || 0) == 0)) {
                return fun.toast('请输入布匹数量！');
            }
            if (!$('.cloth-mx-item').hasClass('choice-cloth')) {
                var prevMxData = $('.cloth-mx-item.choice-cloth').prev('.cloth-mx-item:visible').data('mx_data') || {};
                var __px = prevMxData['px'] || 1;
                var __ph = (prevMxData['ph'] || 0) + 1;
                if (__ph > 10) {
                    __ph = 1;
                    __px++;
                }

                var _data = {
                    "__jl_index": __PAGE_DATA['row_index'] || 0,
                    "px": __px,
                    "ph": __ph,
                    "sl": parseFloat($('#value').val().trim() || 0),
                    is_delete: 0
                };

                if (!fun.getHouseValue(ROW_DATA.ck_id, 'is_bar')) { // 条码仓只能通过调库存
                    //添加布匹
                    $('#cloth_wrap').append('<div data-mx_data=\'' + fun.formatString(JSON.stringify(_data)) + '\' class="cloth-item cloth-mx-item ' + fun.is_value(billZsmx.addMxInactive(_data)) + '"><span class="item-mx">' + $('#value').val() + '</span></div>');
                    setPanelHide();
                }

                // $('#cloth_wrap').scrollTop($('#cloth_wrap').height()); //滚动到底
                // window.scrollTo(0, document.documentElement.clientHeight);
                $this_height = $('.choice-cloth').length && $('.choice-cloth').offset().top || 0;
                $this_height && window.scrollTo(0, $this_height - px_rem);
                $('#value').val('');

                // ROW_DATA['mx'].push(_data);

            } else {
                // var _data = $('.cloth-mx-item.choice-cloth').data('mx_data');

                var prevMxData = $('.cloth-mx-item.choice-cloth').prev('.cloth-mx-item:visible').data('mx_data') || {};
                var currMxData = $('.cloth-mx-item.choice-cloth').data('mx_data') || {};

                var curr_tm_sl = parseFloat(currMxData['tm_sl'] || 0);

                if (curr_tm_sl > 0 && parseFloat($('#value').val().trim() || 0) > 0 && parseFloat($('#value').val().trim() || 0) > curr_tm_sl) {
                    $('.cloth-mx-item.choice-cloth').find('.item-mx').text(parseFloat(currMxData['sl']) || '');
                    fun.toast('该布匹最多只能发：' + currMxData['tm_sl'] + (ROW_DATA['dw_mc'] || ''));
                } else {
                    var __px = prevMxData['px'] || 1;
                    var __ph = (prevMxData['ph'] || 0) + 1;
                    if (__ph > 10) {
                        __ph = 1;
                        __px++;
                    }

                    var _data = {
                        "__jl_index": __PAGE_DATA['row_index'] || 0,
                        "px": __px,
                        "ph": __ph,
                        "sl": parseFloat($('#value').val().trim() || 0),
                        is_delete: 0
                    };

                    var _data1 = $.extend({}, _data, currMxData, { "sl": parseFloat($('#value').val().trim() || 0) });

                    //修改布匹
                    $('#value').val('');
                    $('.cloth-mx-item.choice-cloth').data('mx_data', _data1);
                    // 20210412修复赋值
                    $('.cloth-mx-item.choice-cloth').find('.item-mx').text(parseFloat(_data['sl']) || '');

                    billZsmx.bpckSeleteStatus(_data1, 'bpck-color');

                    //TODO 位置可能要调换到下面
                    // $('.cloth-mx-item').removeClass('choice-cloth');

                    // ROW_DATA['mx'].push(_data);
                }
            }
            if ($('#cloth_wrap').find('.add-item').length) {
                $('#cloth_wrap').find('.add-item').remove();
            }
            if ($('#cloth_wrap').find('.dkc-item').length) {
                $('#cloth_wrap').find('.dkc-item').remove();
            }
            if ($('#cloth_wrap').find('.saoma-item').length) {
                $('#cloth_wrap').find('.saoma-item').remove();
            }

            $('#cloth_wrap').append(createMxBtnHtml());

            setDkcBtnShow();

            showAddItemBtn();

            if (!__PAGE_DATA['__PAGE_EDIT']) {
                $('.dkc-item').attr('disabled', true);
                $('.dkc-item').hide();
            }

            setScanCodeBtnDisplay();

            calcPsAndSl();
            //TODO 位置可能要调换
            $('.cloth-mx-item').removeClass('choice-cloth bpck-choice');
            var enabledEdit = ($.nui.isEmpty(ROW_DATA['ckd_dj_id']) && $.nui.isEmpty(ROW_DATA['ybjl_id']));//|| $.nui.isTrue(ROW_DATA['is_yy_tm'])
            if (enabledEdit) {// && !fun.getHouseValue(ROW_DATA.ck_id, 'is_bar')
                if(!billZsmx.checkCkWinAndTm()){
                    $('.add-item').before('<div class="cloth-item cloth-mx-item choice-cloth ' + fun.is_value(billZsmx.addMxActive()) + '"><span class="item-mx"></span></div>');
                }
            } else {
                setPanelHide();
            }
            // $('.content-wrap').scrollTop(100000000);
            $this_height = $('.choice-cloth').length && $('.choice-cloth').offset().top || 0;
            $this_height && window.scrollTo(0, $this_height - px_rem);
            setPsAndSlDisabled();
            break;
        case 'dj':

            break;
        case 'jjsl':

            break;
    }
    // cache_data['target'] = '';

    formatMxData();
    setPsAndSlDisabled();
    $('input').removeClass('active-border');
});

// 点击单价全选
$('body').on('tap', '#dj,#ssj', function (e) {
    // $(this).select();
});

// 监听单价输入
$('body').on('input blur', '#dj', function (e) {
    billZsmx.editPrice = { hsdj: $(this).val() };
    if (billZsmx.isOpenQyssjmsBp()) {
        /*
            如果有开启【系统设置 - 开启实售价模式 - 布匹】
            如果 当前实售价 = 修改前单价 的值时，
            将修改后的单价也赋值给实售价。
        */
        if (fun.toNumber(ROW_DATA.ssdj || 0) === fun.toNumber(ROW_DATA.hsdj || 0)) {
            billZsmx.editPrice = { hsdj: $(this).val(), ssdj: $(this).val() };
        } else {
            billZsmx.editPrice = { hsdj: $(this).val() };
        }
    } else {
        /*
            如果没开启【系统设置 - 开启实售价模式 - 布匹】
            将修改后的单价也赋值给实售价。
        */
        billZsmx.editPrice = { hsdj: $(this).val(), ssdj: $(this).val() };
    }
    __setRowData(null, billZsmx.editPrice, { hsdj_fixed: hsdj_fixed, upDateSssl: false });
});

// 监听实售单价输入
$('body').on('input blur', '#ssj', function (e) {
    __setRowData(null, { ssdj: $(this).val() }, { hsdj_fixed: hsdj_fixed, upDateSssl: false });
});

// 点击幅宽克重缸号
$('body').on('click', '#fk,#kz,#gh', function (e) {
    if ($(this).attr('disabled') || $(this).attr('abcdisabled')) return;
    // $(this).select();
    // this.selectionStart = 0;
    // this.selectionEnd = $(this).val().length;
    // $(this).focus().select();
});

// 监听幅宽、克重、缸号输入
$('body').on('input', '#fk,#kz,#gh', function (e) {
    var key = $(this).attr('id');
    var _data = {};
    _data[key] = $(this).val();
    __setRowData(null, _data, { hsdj_fixed: hsdj_fixed });
});

// 点击body
$('body').on('tap', function (e) {
    e.stopPropagation();
    var target = $(e.target);
    if (target.is('#back_btn') || target.is('.layui-m-layershade')
        || target.is('.layui-m-layermain') || target.is('.layui-m-layermain *')) return;
    if (cache_data['target'] == 'mx') {
        // calcPsAndSl();
    } else {
        // if ($('#sl').val() != ROW_DATA['zsl']) {
        __setRowData(null, {}, { hsdj_fixed: hsdj_fixed, upDateSssl: false });
        $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);
        // }
    }

    cache_data['target'] = '';
    $('#value').val('');
    $('input').removeClass('active-border');
    setPanelHide();
    setJjslColor();
});

//点击每匹
$('body').on('tap', '.cloth-mx-item', function (e) {
    e.stopPropagation();

    if ($(this).attr('disabled')) return;
    $('#del_cloth').show();

    cache_data['target'] = 'mx';
    getRowMxData();

    $('#value').val($(this).text());
    $this_height = $(this).offset().top;

    setPanelShow();
    // $(this).addClass('choice-cloth ' + fun.is_value(billZsmx.addMxActive($(this).data('mx_data'))) + ' ').siblings().removeClass('choice-cloth bpck-choice');

    // 给当前选中元素增加选中状态，清除其它元素所有状态
    $(this).addClass('choice-cloth').siblings().removeClass('choice-cloth bpck-choice bpck-color');

    // 添加半匹出库小于库存数未选中状态
    $(this).siblings().each((function (idx, item) {
        if ($.nui.isTrue(billZsmx.enabledMxgl($(this).data('mx_data'))) && billZsmx.djlxIsXscgthjs()) {
            if (fun.toNumber($(this).text()) < fun.toNumber($(this).data('mx_data').tm_sl)) {
                $(this).addClass('bpck-color');
            }
        }
    }))

    // 当前半匹出库小于库存数选中状态
    if ($.nui.isTrue(billZsmx.enabledMxgl($(this).data('mx_data'))) && billZsmx.djlxIsXscgthjs()) {
        if (fun.toNumber($(this).text()) === fun.toNumber($(this).data('mx_data').tm_sl)) {
            $(this).removeClass('bpck-choice bpck-color');
        } else {
            $(this).addClass('bpck-choice');
        }
    }

    for (var i = 0; i < $('.cloth-mx-item').length; i++) {
        var $item = $('.cloth-mx-item').eq(i);
        if (!$item.find('.item-mx').text().trim() && !$item.hasClass('choice-cloth')) {
            $item.remove();
            i--;
        }
    }
    calcPsAndSl();
});

// 计价数量点击
$('body').on('click', '#jjsl_val', function (e) {
    e.stopPropagation();

    var flag = getRowMxData();
    if (!flag) return;

    var html = [];
    style = 'width:92%;height:10.5rem;border:none;background:#fff; border-radius: 0.5rem; position:absolute; top: 30%; left: 4%;';
    html.push('<span class="title">计价</span>');
    html.push('<ul class="list-group">');
    html.push('<li class="item">');
    html.push('		<div class="text-box"><span>空差</span></div>');
    html.push('		<div class="right"><div class="symbol" data-type="+"><span>+</span></div>');
    html.push('		<div class="symbol" data-type="-"><span>-</span></div>');
    html.push('		<div class="symbol" data-type="×" data-type2="*"><span>×</span></div>');
    html.push('		<div class="symbol" data-type="÷" data-type2="/"><span>÷</span></div>');
    html.push('		<input id="kc" type="text" class="input-box equal num-input" num_type="2" decimal_digits="4"/></div>');
    html.push('</li>');
    html.push('<li class="item">');
    html.push('<div class="text-box"><span>计价数</span></div>');
    html.push('<input id="jjsl" type="text" class="input-box num-input" num_type="2" decimal_digits="4"/>');
    // html.push('<select name="" class="input-box drop-down"><option>公斤</option><option>克</option></select>');
    html.push('<div id="sel_jjdw_wrap" class="input-box drop-down"><span id="sel_jjdw" class="ellipsis-span">公斤</span><i class="iconfont icon-xia down-icon"></i></div>');
    html.push('</li>');
    if (page_data['djlx'] == 'bp_xsfhjs' && showFs && __getMxLength(ROW_DATA['mx'] || []) < 2) {
        html.push('<li class="last-item">');
        html.push('		<div class="check-box"><i class="iconfont icon-check"></i></div>');
        html.push('		<span class="inverse fhjs-jjsfs">计价数反算出库数</span>');
        html.push('</li>');
    }
    html.push('</ul>');
    html.push('<button id="confirm" class="confirm button">确认</button>');
    html.push('<button class="cancel button">取消</button>');
    layer.open({
        type: 1,
        content: html.join(''),
        style: style,
        skin: 'jj-info',
        shadeClose: false,
        success: function (layero, index) {
            var alertObj = {
                kcAndSskcIsSame: fun.toNumber(ROW_DATA['kc']) === fun.toNumber(ROW_DATA['sskc']),
                assign: function () {
                    $('#sss').val(ROW_DATA['sssl']);
                    $('#ssje').val(billZsmx.computedSszje());
                    ROW_DATA['ssje'] = billZsmx.computedSsje();
                    ROW_DATA['sszje'] = billZsmx.computedSszje();
                    $('#hk').val(billZsmx.computedHk());
                },
                setRowKcAfter: function () {
                    if (alertObj.kcAndSskcIsSame) {
                        ROW_DATA['sskc'] = ROW_DATA['kc'];
                        ROW_DATA['sssl'] = fun.toNumber(fun.dwhs({
                            zsl: ROW_DATA['bqsl'] || 0,
                            ps: ROW_DATA['ps'] || 0,
                            fk: ROW_DATA['fk'] || '',
                            kz: ROW_DATA['kz'] || '',
                            dw: ROW_DATA['dw_mc'] || '',
                            jjdw: ROW_DATA['jjdw_mc'] || '',
                            kc: parseFloat(ROW_DATA['sskc'] || 0),
                            kcms: ROW_DATA['kcms'] || '+',
                            mx: []
                        }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                        alertObj.assign();
                    }
                },
                initTempCacheData: function () { // 缓存打开的数据，为了在计价数量弹窗弹起来的情况下，选择单位跳转选择回来会重新赋值
                    var tempRowData = JSON.parse(JSON.stringify(ROW_DATA));
                    return {
                        kcms: tempRowData.kcms,
                        kc: tempRowData.kc,
                        jjsl: tempRowData.jjsl,
                        jjdw_id: tempRowData.jjdw_id,
                        jjdw_mc: tempRowData.jjdw_mc
                    }
                }
            };

            if (ROW_DATA['jjdw_mc'] === '份') $('#sel_jjdw_wrap').attr('disabled', true);
            else { $('#sel_jjdw_wrap').removeAttr('disabled'); }
            cache_data['kcms'] = ROW_DATA['kcms'] || '+';
            cache_data['kc'] = ROW_DATA['kc'] || 0;
            cache_data['jjsl'] = ROW_DATA['jjsl'] || 0;
            cache_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
            cache_data['jjdw_mc'] = ROW_DATA['jjdw_mc'] || '';
            var tempCache = alertObj.initTempCacheData();

            if ('*/'.indexOf(ROW_DATA['kcms'] || '+') > -1) {
                $('.symbol[data-type2="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
            } else {
                $('.symbol[data-type="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
            }


            $('#kc').val(Math.abs(ROW_DATA['kc'] || 0));
            if (ROW_DATA['kc'] < 0) {
                $('.symbol[data-type="-"]').addClass('active').siblings().removeClass('active');
            }

            $('#jjsl').val(ROW_DATA['jjsl']);
            $('#sel_jjdw').text(ROW_DATA['jjdw_mc']).data('jjdw_id', ROW_DATA['jjdw_id']);
            showFs = !!$('.check-box').length;
            if (showFs && __getMxLength(ROW_DATA['mx'] || []) < 2) {
                if (jjsfssl) {
                    $('.check-box').addClass('check-choice');
                } else {
                    $('.check-box').removeClass('check-choice');
                }
            }

            // 选择空差模式
            $('.symbol').on('tap', function (e) {
                $(this).addClass('active').siblings().removeClass('active');
            });

            // 点击跳转选择计价单位
            $('body').on('tap', '#sel_jjdw_wrap', function (e) {
                if ($(this).attr('disabled')) return;
                fun.showPageFull({
                    page_url: page_arr.select_list,
                    pageParam: {
                        "return_page": html_name,
                        "page_type": 'jjdw',
                        "return_type": 'jjdw'
                    }
                });
            });

            $('.cancel').on('click', function (e) {
                ROW_DATA['jjdw_id'] = tempCache['jjdw_id'];
                ROW_DATA['jjdw_mc'] = tempCache['jjdw_mc'];
                ROW_DATA['kc'] = tempCache['kc'];
                ROW_DATA['kcms'] = tempCache['kcms'];
                ROW_DATA['jjsl'] = tempCache['jjsl'];

                $('#jjdw').text(ROW_DATA['jjdw_mc']).data('jjdw_id', ROW_DATA['jjdw_id']);

                //20191023计价单位
                __setRowData(null, {
                    jjdw_id: ROW_DATA['jjdw_id'],
                    jjdw_mc: ROW_DATA['jjdw_mc']
                }, { hsdj_fixed: hsdj_fixed, upDateSssl: false });
                $('#jjsl_val').val(ROW_DATA['jjsl']);
                setJjslColor();

                layer.closeAll();
            });

            // 点击确定
            $('#confirm').on('click', function (e) {
                var tmpJjsl = parseFloat($('#jjsl').val() || 0);
                showFs && fun.setItem(page_data['djlx'] + '_jjsfssl', $('.check-box').hasClass('check-choice'));

                ROW_DATA['kcms'] = $('.symbol.active').data('type') || '';
                ROW_DATA['kc'] = parseFloat($('#kc').val().trim() || 0);
                ROW_DATA['jjdw_id'] = $('#sel_jjdw').data('jjdw_id');
                ROW_DATA['jjdw_mc'] = $('#sel_jjdw').text();
                ROW_DATA['jjsl'] = tmpJjsl;

                if (ROW_DATA['kcms'] == '-') {
                    ROW_DATA['kcms'] = '+';
                    ROW_DATA['kc'] = -parseFloat(ROW_DATA['kc'] || 0);
                }
                $('#jjsl_val').val(ROW_DATA['jjsl']);
                setJjslColor();
                $('#jjdw').text(ROW_DATA['jjdw_mc']).data(ROW_DATA['jjdw_id']);

                showFs = !!$('.check-box').length;

                if (showFs && __getMxLength(ROW_DATA['mx'] || []) < 2) {
                    jjsfssl = $('.check-box').hasClass('check-choice');
                    if (jjsfssl && $.nui.isTrue(tmpJjsl)) {
                        var num = fun.dwhsIsBack({
                            dw: ROW_DATA['dw_mc'] || '',
                            jjdw: ROW_DATA['jjdw_mc'] || '',
                            jjsl: ROW_DATA['jjsl'] || 0,
                            kcms: ROW_DATA['kcms'] || '+',
                            kc: ROW_DATA['kc'] || 0,
                            ps: parseInt(ROW_DATA['ps'] || 0),
                            is_back: true
                        });

                        ROW_DATA['zsl'] = Number(num).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                    } else {
                        if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = parseFloat(tmpJjsl || 0);
                    }
                } else {
                    if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = parseFloat(tmpJjsl || 0);
                }

                var dwhs_data = {};

                if (cache_data['kcms'] != ROW_DATA['kcms']) {
                    dwhs_data['kcms'] = ROW_DATA['kcms'] || '+';
                }
                if (cache_data['kc'] != ROW_DATA['kc']) {
                    dwhs_data['kc'] = ROW_DATA['kc'] || 0;
                }

                if (cache_data['jjsl'] != tmpJjsl) {
                    dwhs_data['jjsl'] = tmpJjsl || 0;
                }
                if (cache_data['jjdw_id'] != ROW_DATA['jjdw_id']) {
                    dwhs_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
                }

                if ($.nui.isTrue(dwhs_data)) { // 有修改到
                    __setRowData(null, dwhs_data, { hsdj_fixed: hsdj_fixed });
                }

                // __setRowData(null, {
                //     jjsl: ROW_DATA['jjsl'] || 0,
                //     // zsl: ROW_DATA['zsl'] || 0,
                //     // kcms: ROW_DATA['kcms'] || '',
                //     // kc: parseFloat(ROW_DATA['kc'] || 0),
                //     // jjdw_id: ROW_DATA['jjdw_id'] || 0,
                //     // jjdw_mc: ROW_DATA['jjdw_mc'] || ''
                // });


                if (showFs && __getMxLength(ROW_DATA['mx'] || []) < 2) {
                    if (jjsfssl) {
                        ROW_DATA['jjsl'] = parseFloat(tmpJjsl || 0);
                    } else {
                        // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
                    }
                }

                $('#sl').val(ROW_DATA['zsl']);
                $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);
                // $('#jjsl').val(ROW_DATA['jjsl']);

                //记录行匹数小于2时，则 计价数量允许反算出数量
                if (__getMxLength(ROW_DATA['mx'] || []) < 2) {
                    //有开启 计价数反算出数量

                    if (showFs && jjsfssl) {
                        backCalc();

                        function backCalc() {
                            if ($.nui.isEmpty(ROW_DATA['jjsl'])) return;
                            if ($.nui.isEmpty(ROW_DATA['cp_id']) || $.nui.isTrue(ROW_DATA['ckd_jl_id'])) return;
                            if (ROW_DATA['ps'] > 1 && !$.nui.isEmpty(ROW_DATA['mx'])) return;
                            // 记录行被调用不进行反算
                            if ($.nui.isTrue(ROW_DATA['is_has']) || $.nui.isTrue(ROW_DATA['is_has_cgdd']) ||
                                $.nui.isTrue(ROW_DATA['is_has_wwjg']) || $.nui.isTrue(ROW_DATA['is_has_cglhd']) ||
                                $.nui.isTrue(ROW_DATA['is_has_cglhjs']) || $.nui.isTrue(ROW_DATA['is_has_jgthd']) ||
                                $.nui.isTrue(ROW_DATA['is_has_jgthjs'])) return;

                            var num = fun.dwhsIsBack({
                                dw: ROW_DATA['dw_mc'] || '',
                                jjdw: ROW_DATA['jjdw_mc'] || '',
                                jjsl: ROW_DATA['jjsl'] || 0,
                                kcms: ROW_DATA['kcms'] || '+',
                                kc: ROW_DATA['kc'] || 0,
                                fk: ROW_DATA['fk'] || '',
                                kz: ROW_DATA['kz'] || '',
                                ps: parseInt(ROW_DATA['ps'] || 0),
                                is_back: true
                            });

                            num = num.fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);

                            ROW_DATA['zsl'] = num;//.fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                            ROW_DATA['jjsl'] = parseFloat(tmpJjsl || 0) || 0;

                            $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);
                            $('#sl').val(ROW_DATA['zsl']);
                            setJjslColor();

                            var t_mx = ROW_DATA['mx'] || [];
                            var t_data = {};

                            if ($.nui.isEmpty(t_mx)) {
                                t_data = { zsl: num/*, is_fs: 1*/, no_calc_jjsl: 1 };
                                if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                                    t_data['ps'] = 1;
                                    t_data['mx'] = [{ px: 1, ph: 1, sl: num }];
                                }
                            } else {
                                var isPush = true;
                                var t_ps = 0;
                                for (var i = 0; i < t_mx.length; i++) {
                                    if ($.nui.isTrue(t_mx[i]['is_delete'])) continue;
                                    t_ps += 1;
                                    if ((t_mx[i]['tm_sl'] > 0) && (num > 0)) {
                                        // 如果当前仓库有开启：不负库存
                                        // 当用户修改的数量大于该布匹对应的库存数时，修改无效。
                                        if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_minus'))) {
                                            if (num > t_mx[i]['tm_sl']) num = t_mx[i]['sl'] || 0;
                                        }
                                    }
                                    t_mx[i]['sl'] = num;
                                    isPush = false;
                                }

                                t_data = { zsl: num/*, is_fs: 1*/, no_calc_jjsl: 1 };

                                if (isPush && $.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                                    t_mx.push({ px: 1, ph: 1, sl: num });
                                }

                            }

                            __setRowData(null, t_data, { hsdj_fixed: hsdj_fixed });

                            $('#ps').val(ROW_DATA['ps']);
                            $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);
                            $('#sl').val(ROW_DATA['zsl']);

                            /*总数需要可以输明细*/
                            // if (__PAGE_DATA['bj_type'] == 'mx') {
                            showMxList(ROW_DATA['mx'] || []);
                            // }
                        }
                    }
                }
                // if (__PAGE_DATA['bj_type'] == 'mx') calcPsAndSl();
                setJjslColor();

                if ((cache_data['jjdw_id'] != ROW_DATA['jjdw_id'])) {
                    updateDj();
                }

                $('.cloth-mx-item.choice-cloth') && $('.cloth-mx-item.choice-cloth').removeClass('choice-cloth bpck-choice');

                // 如果当前 记录行 实售空差 的值 = 确认前的空差，同时还需要将空差更新给 实售空差
                alertObj.setRowKcAfter();

                layer.closeAll();
            });
        },
        end: function () {
            $('#jjsl').removeClass('ipt-change');
        }
    });
    fun.inputType();
});

// 实售数
$('body').on('click', '#sss', function (e) {
    e.stopPropagation();
    if (!__PAGE_DATA['__PAGE_EDIT']) return;
    var html = [];
    style = 'width:92%;height:10.5rem;border:none;background:#fff; border-radius: 0.5rem; position:absolute; top: 30%; left: 4%;';
    html.push('<span class="title">实售</span>');
    html.push('<ul class="list-group">');
    html.push('     <li class="item">');
    html.push('     		<div class="text-box"><span>实空差</span></div>');
    html.push('     		<div class="right"><div class="symbol" data-type="+"><span>+</span></div>');
    html.push('     		<div class="symbol" data-type="-"><span>-</span></div>');
    html.push('     		<div class="symbol" data-type="×" data-type2="*"><span>×</span></div>');
    html.push('     		<div class="symbol" data-type="÷" data-type2="/"><span>÷</span></div>');
    // ss 实售      
    html.push('     		<input id="sskc" type="text" class="input-box equal num-input" num_type="2" decimal_digits="4"/></div>');
    html.push('     </li>');
    html.push('     <li class="item">');
    html.push('          <div class="text-box"><span>实售数</span></div>');
    html.push('          <input id="reality_num" type="text" class="input-box num-input reality-num" num_type="2" decimal_digits="4"/>');
    html.push('     </li>');
    html.push('</ul>');
    html.push('<button id="confirm" class="confirm button">确认</button>');
    html.push('<button class="cancel button">取消</button>');
    layer.open({
        type: 1,
        content: html.join(''),
        style: style,
        skin: 'jj-info',
        shadeClose: false,
        success: function (layero, index) {
            var mode = ROW_DATA['kcms'] || '+';
            var alertObj = {
                modeIsMulOrDiv: function (mode) {
                    return mode === '*' || mode === '÷' || mode === '×' || mode === '/';
                },
                modeIsAdd: function (mode) {
                    return mode === '+' || mode === '-';
                },
                init: function () {
                    // if (alertObj.modeIsMulOrDiv(mode)) {
                    //     // 如果 当前记录行模式 = × 或 ÷，则该页面的模式变为不可用状态
                    //     $('.symbol').removeClass('active');
                    // } else if (alertObj.modeIsAdd(mode)) {
                    //     // 如果 当前记录行模式 = + -，则该页面的模式 * 和 模式 ➗ 变为不可用状态
                    //     $('.symbol[data-type="' + mode + '"]').addClass('active').siblings().removeClass('active')
                    // }
                    if ('+-*×/÷'.indexOf(ROW_DATA['kcms'] || '+') > -1) {
                        $('.symbol[data-type2="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
                        $('.symbol[data-type="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
                    } else {
                        $('.symbol[data-type2="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
                        $('.symbol[data-type="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
                    }

                    if (ROW_DATA['sskc'] < 0) {
                        $('.symbol[data-type="-"]').addClass('active').siblings().removeClass('active');
                    }

                    $('#sskc').val(Math.abs(ROW_DATA['sskc'] || 0));
                    $('#reality_num').val(ROW_DATA['sssl'] || 0);
                },
                assign: function () {
                    $('#sss').val(ROW_DATA['sssl']);
                    $('#ssje').val(billZsmx.computedSszje());
                    ROW_DATA['ssje'] = billZsmx.computedSsje();
                    ROW_DATA['sszje'] = billZsmx.computedSszje();
                    $('#hk').val(billZsmx.computedHk());
                }
            };
            alertObj.init();


            // 选择空差模式
            $('.symbol').on('tap', function (e) {
                var modeType = $(this).data('type');
                if (alertObj.modeIsMulOrDiv(mode)) { // × 或 ÷
                    return;
                } else if (alertObj.modeIsAdd(mode) && alertObj.modeIsMulOrDiv(modeType)) { // 当前模式为 + 或 -，并且点击的是 * 或 x 或 / 或 ÷
                    return;
                }
                $(this).addClass('active').siblings().removeClass('active');
            });

            // 点击取消
            $('.cancel').on('click', function (e) {
                layer.closeAll();
            });

            // 点击确定
            $('#confirm').on('click', function (e) {
                var sssl = fun.toNumber($('#reality_num').val().trim()) || 0; // 实售数量
                var sskc = fun.toNumber($('#sskc').val().trim()) || 0; // 实售空差
                ROW_DATA['kcms'] = $('.symbol.active').data('type') || '+';

                // if (ROW_DATA['kcms'] === '-') {
                //     ROW_DATA['kcms'] = '+';
                //     ROW_DATA['sskc'] = -parseFloat(sskc || 0);
                //     sskc = -sskc; // 初始为 +，默认更改为 -，空差则算发生变化
                // } else {
                //     ROW_DATA['sskc'] = parseFloat(sskc || 0);
                // }

                if (ROW_DATA['kcms'] === '-') {
                    ROW_DATA['kcms'] = '+';
                    sskc = -sskc; // 初始为 +，默认更改为 -，空差则算发生变化
                }

                // 如果同时修改到了，实售空差和实售数量，则优先认实售空差换算的值
                if (sskc !== fun.toNumber(ROW_DATA['sskc'])) { // 修改到了实售空差
                    ROW_DATA['sssl'] = fun.toNumber(fun.dwhs({
                        zsl: ROW_DATA['bqsl'] || 0,
                        ps: ROW_DATA['ps'] || 0,
                        fk: ROW_DATA['fk'] || '',
                        kz: ROW_DATA['kz'] || '',
                        dw: ROW_DATA['dw_mc'] || '',
                        jjdw: ROW_DATA['jjdw_mc'] || '',
                        kc: parseFloat(sskc || 0),
                        kcms: ROW_DATA['kcms'] || '+',
                        mx: []
                    }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                } else if (sssl !== fun.toNumber(ROW_DATA['sssl'])) {
                    ROW_DATA['sssl'] = sssl;
                }
                if ('-'.indexOf(sskc) > -1) {
                    ROW_DATA['sskc'] = -parseFloat(sskc || 0);
                } else {
                    ROW_DATA['sskc'] = parseFloat(sskc || 0);
                }
                alertObj.assign();
                layer.closeAll();
            });
        },
        end: function () {
        }
    });
    fun.inputType();
})

// 显示明细数按钮
function showAddItemBtn() {
    if ($.nui.isTrue(ROW_DATA['is_yy_tm'])) {
        var __mx = [];
        for (var i = 0; i < (ROW_DATA['mx'] || []).length; i++) {
            if ($.nui.isEmpty(ROW_DATA['mx'][i]['is_delete']) && $.nui.isTrue(ROW_DATA['mx'][i]['tm'])) {
                __mx.push(ROW_DATA['mx'][i]);
            }
        }

        if (!__mx.length) {
            $('.add-item').show();
        }
        if (fun.getHouseValue(ROW_DATA.ck_id, 'is_bar')) {
            $('.add-item').hide();
        }
    }
}

//点击删除布匹
$('body').on('tap', '#del_cloth', function (e) {
    e.stopPropagation();
    cache_data['bj_ele'] = 'mx';
    $this_height = $('.choice-cloth').length && $('.choice-cloth').offset().top || 0;
    var $dom = $('.cloth-mx-item.choice-cloth');

    var enabledEdit = !($.nui.isTrue(ROW_DATA['ckd_dj_id']));// || $.nui.isTrue(ROW_DATA['is_yy_tm'])

    if ($dom.length) {
        var val = $dom.find('.item-mx').text().trim();
        var row = $dom.data('mx_data') || {};

        if ($.nui.isEmpty(row)) {
            $dom.remove();
            $('#value').val('');
            if (enabledEdit) {
                if (billZsmx.checkCkWinAndTm()) {
                    setPanelHide();
                } else {
                    $('.add-item').before('<div class="cloth-item cloth-mx-item choice-cloth ' + fun.is_value(billZsmx.addMxActive()) + '"><span class="item-mx"></span></div>');
                }
            }

            showAddItemBtn();

            $('.content-wrap').scrollTop(100000);

            setPsAndSlDisabled();
        } else {
            // fun.dialog({
            //     content: '您确定要删除【' + (row['sl']) + '】这匹布吗？',
            //     btn: ['删除', '取消'],
            //     yes: function () {
            var index = __PAGE_DATA['row_index'] || 0;
            __delRowMxValue(row, index);

            $('#value').val('');

            showMxList(ROW_DATA['mx'] || []);
            calcPsAndSl();

            showFs = (__getMxLength(ROW_DATA['mx'] || []) < 2);

            showAddItemBtn();
            // 20191213
            if (enabledEdit) {
                if (billZsmx.checkCkWinAndTm()) {
                    setPanelHide();
                } else {
                    $('.add-item').before('<div class="cloth-item cloth-mx-item choice-cloth ' + fun.is_value(billZsmx.addMxActive()) + '"><span class="item-mx"></span></div>');
                }
            }
            $('.content-wrap').scrollTop(100000);
            setPsAndSlDisabled();
            //     },
            //     no: function () {
            //         var prevMxData = $dom.prev('.cloth-mx-item:visible').data('mx_data') || {};
            //         var __px = prevMxData['px'] || 1;
            //         var __ph = (prevMxData['ph'] || 0) + 1;
            //         if (__ph > 10) {
            //             __ph = 1;
            //             __px++;
            //         }

            //         var _data = {
            //             "__jl_index": __PAGE_DATA['row_index'] || 0,
            //             "px": __px,
            //             "ph": __ph,
            //             "sl": parseFloat(row['sl'] || 0)
            //         };

            //         var _data1 = $.extend({}, _data, { "sl": parseFloat(row['sl'] || 0) });
            //         //修改布匹
            //         $('#value').val('');
            //         $('.cloth-mx-item.choice-cloth .item-mx').text(row['sl']);
            //         $('.cloth-mx-item.choice-cloth').data('mx_data', _data1);
            //     }
            // });
        }

        // if (val) {
        //     fun.dialog({
        //         content: '您确定要删除【' + (val) + '】这匹布吗？',
        //         btn: ['删除', '取消'],
        //         yes: function () {
        //             if ($.nui.isEmpty(row)) {
        //                 $('.cloth-mx-item.choice-cloth').remove();
        //             }
        //
        //             var index = __PAGE_DATA['row_index'] || 0;
        //             __delRowMxValue(row, index);
        //
        //             // $('.cloth-mx-item').each(function (index, obj) {
        //             //     if ($(obj).hasClass('choice-cloth')) {
        //             //         $(obj).remove();
        //             //         $('#value').val('');
        //             //         calcPsAndSl();
        //             //     }
        //             // })
        //             $('#value').val('');
        //
        //             showMxList(ROW_DATA['mx'] || []);
        //             calcPsAndSl();
        //         }
        //     });
        // } else {
        //     $('.cloth-mx-item.choice-cloth').remove();
        // }
    }
    return false;
});

// 点击规格
$('body').on('tap', '.gg-wrap', function (e) {
    e.stopPropagation();
    if ($(this).find('#gg').attr('disabled')) return;
    var cp_title = (ROW_DATA['cp_bh'] || '') + (ROW_DATA['cp_mc'] || '');
    var cp_id = $('#header_title').data('cp_id') || 0;
    var gg_name = $('#gg').val().trim();

    fun.showPageFull({
        page_url: page_arr.specifications,
        pageParam: {
            html_name: html_name,
            cp_title: cp_title,
            cp_id: cp_id,
            gg_name: gg_name
        }
    });
});


$('body').on('tap', '.saoma-item', function (e) {
    e.stopPropagation();
    fun.openScanner({
        callback: function (value) {
            if (!!value) {
                var mx = ROW_DATA['mx'] || [];
                if (mx.length) {
                    for (var i = 0; i < mx.length; i++) {
                        var val = mx[i];
                        if ($.nui.isTrue(val['is_delete'])) continue;
                        if (mx[i]['tm'] == value) {
                            __delRowMxValue(val, i);
                            __JL_DATA[__PAGE_DATA['row_index']] = ROW_DATA;
                            showMxList(ROW_DATA['mx'] || []);

                            $('#value').val('');

                            calcPsAndSl();

                            showFs = (__getMxLength(ROW_DATA['mx'] || []) < 2);

                            $('.content-wrap').scrollTop(100000);
                            setPsAndSlDisabled();

                            if (!__getMxLength(ROW_DATA['mx'] || [])) {
                                ROW_DATA['ph'] = '';
                            }
                            if (page_data.djlx === 'kc_bptbd' && !__getMxLength(ROW_DATA['mx'] || [])) {
                                $('#cloth_wrap').removeAttr('disabled');
                            }
                            return true;
                        }
                    }
                    return fun.toast('当前页面找不到该条码。');
                } else {
                    return fun.toast('无明细布匹。');
                }
            } else {
                return fun.toast('扫码失败！');
            }
        }
    });
});

// }


// 调用仓库单后设置页面字段不可编辑
function setDomDisabledByCallCkd() {
    $('#color_search,#color,#ps,#sl,#dw,#lx,#fk,#kz,#gg,#gh,#cloth_wrap').attr('disabled', true);
    $('.show-xs-tips').hide();
}

// 调用验布记录后设置页面字段不可编辑
function setDomDisabledByCallYbjl() {
    $('#color_search,#color,#ps,#sl,#dw,#lx,#fk,#kz,#gg,#gh,#cloth_wrap').attr('disabled', true);
    $('.show-xs-tips').hide();
}

// 调用仓库单、验布记录后设置页面字段不可编辑
function setCommonDomDisabled() {
    $('#color_search,#color,#ps,#sl,#dw,#lx,#fk,#kz,#gg,#gh,#cloth_wrap').attr('disabled', true);
    $('.show-xs-tips').hide();
}

// 调用库存设置页面字段不可编辑
function setDomDisabledByCallStock() {
    $('#lx').attr('disabled', true);
}

// 半匹出库底色变化检测
billZsmx.bpckSeleteStatus = function (data, addClassName) {
    if ($.nui.isTrue(billZsmx.enabledMxgl(data)) && billZsmx.djlxIsXscgthjs()) {
        if (fun.toNumber(data.sl) === fun.toNumber(data.tm_sl)) {
            $('.cloth-mx-item.choice-cloth').removeClass('bpck-choice bpck-color');
        } else {
            $('.cloth-mx-item.choice-cloth').addClass(addClassName);
        }
    }
}

// 出库窗口
billZsmx.checkCkWin = function () {
    return ['bp_xsfhjs', 'bp_cgthjs', 'kc_bptbd'].indexOf(page_data.djlx) > -1;
}

// 出库窗口 且条码仓
billZsmx.checkCkWinAndTm = function () {
    return billZsmx.checkCkWin() && fun.getHouseValue(ROW_DATA.ck_id, 'is_bar')
}

// 更新盘盈单成本价
billZsmx.updatePydCbj = function(){
    __getDj({
        data: {
            "djlx": Bills['djlx'],
            "cp_id": ROW_DATA['cp_id'] || 0,
            "cp_ys_id": ROW_DATA['cp_ys_id'] || 0,
            // 获取成本价 需要用到 仓库、单位
            "ck_id": __PAGE_DATA['ck_info']['id'] || 0,
            "dw_id": ROW_DATA['dw_id'] || 0,
            'ph': ROW_DATA['ph'] || '',
        },
        callback: function (res) {
            if (res['status'] == 0) {
                var dj_data = {
                    cbj: res['data']['dj'] || 0
                };

                if (page_data['djlx'] === 'kc_bppyd') {
                    dj_data['dj'] = dj_data['cbj'];
                    dj_data['hsdj'] = dj_data['cbj'];
                }

                __setRowData(null, dj_data, { hsdj_fixed: hsdj_fixed, setSsj: true, upDateSssl: false, upDateBqsl: false, upDateSsdj: true });

                $('#dj').val(ROW_DATA['hsdj'] || 0);
                // 获取上次价
                if (__PAGE_DATA.loadScdj) {
                    ROW_DATA.scdj = res.data.scdj;
                }
            }
        }
    });
}
