var html_name = page_arr.cg_cgbj_batch;
var jjdw_list = [];
var SYS_CONFIG = {};
var __JL_DATA = null; // 记录数据
var xscg = {
    isSeriesMode: function () { // 系统设置是否开启色系报价
        return !!Number(fun.getItem('sys_config').qysexibjms_bp);
    },
    hasSeries: function (number) {
        var seriesArr = ['统色', '浅色', '中色', '深色'];
        return seriesArr.indexOf(number) > -1;
    }
};

// 初始化
page_init = function () {
    jjdw_list = fun.getItem('jjdw_list') || [];
    SYS_CONFIG = fun.getItem('sys_config') || {};

    // fun.keyboardEject('.sub');
    __JL_DATA = page_data['jl_data'];

    switch (page_data['djlx']) {
        case 'bp_cgbj':
            Bills['AJAX_URL'] = { getDj: AJAX_URL.getBpCgDjAndScdj };
            Bills['djlx'] = 'bp_cgbj';
            break;
        case 'bp_xsbj':
            Bills['AJAX_URL'] = { getDj: AJAX_URL.getBpXsDjAndScdj };
            Bills['djlx'] = 'bp_xsbj';
            break;
    }

    $('#header').header({ // 头部初始化
        back: true,
        title: page_data['pageData']['cp_bh_mc'],
        appendBackBtnEvt: sendBackEvent
    });

    // 更新本地存储数据
    fun.load_DATA_LIST(['sys_config', 'jjdw'], function () {
        SYS_CONFIG = fun.getItem('sys_config') || {};
        jjdw_list = fun.getItem('jjdw_list') || [];
    }, {
        showLoad: true,
        hideLoad: false,
        close: false
    });

    getBpXsDjAndScdj(); // 读取单价、上次单价
    loadPsAndSl();

    // api.addEventListener({
    //     name: 'complete'
    // }, function (ret, err) {
    //     var status = ret['value']['status'];
    //     if (status) {
    //         showList();
    //     }
    // })

    api.addEventListener({ name: html_name }, xscg.addEventListener)
    fun.inputType();
}

xscg.addEventListener = function (ret, err) {
    var value = ret['value'];
    if (value.status === 'select_list') {
        if (value.data.page_type === 'jjdw') {
            $(page_data['jl_data']).each(function (idx, item) {
                if (fun.toNumber(item['jjdw_id']) !== fun.toNumber(value.data.list_data.id)) {
                    item['jjdw_id'] = value.data.list_data.id;
                    item['jjdw_mc'] = value.data.list_data.name;
                    $('.unit-name').eq(idx).text('元/ ' + item['jjdw_mc']);
                    $('.batch-set-unit').text('元/ ' + item['jjdw_mc']);
                }
            })
            getBpXsDjAndScdj();
        }
    }
}

// 返回事件
function sendBackEvent() {
    api.sendEvent({
        name: 'backEvent',
        extra: { // 批量设置价格界面点击返回的数据
            skipData: page_data['skipData'],
            CHECK_STATUS_ARR: page_data['CHECK_STATUS_ARR']
        }
    })

    setTimeout(function (idx, item) {
        api.closeWin();
    }, 200)
}

// 读取单价，上次单价
function getBpXsDjAndScdj() {
    __getDjInfo = function () {
        return {
            djlx: page_data['djlx'],
            wldw_id: page_data['__DJ_DATA']['wldw_id']
        }
    };

    __getJlData = function () {
        return __JL_DATA;
    };

    // 更新成本价
    __updateJlDataByIndex = function (item) {
        var idx = item.index;

        var upateItem = __JL_DATA[idx];

        upateItem.hsdj = item.data.dj; // 上次单价
        upateItem.dj = item.data.dj; // 单价

        // 计算汇总金额hsje
        if (upateItem.jjsl && upateItem.hsdj) {
            upateItem.hsje = upateItem.jjsl * upateItem.hsdj;
        } else {
            upateItem.hsje = 0;
        }

        // upateItem.je = item.hsje;
        // upateItem.zje = item.hsje;
        // upateItem.hszje = item.hsje;

        __JL_DATA[idx]['scdj'] = item['data']['scdj']; // 上次单价
        __JL_DATA[idx]['bzj'] = item['data']['bzj']; // 标准价
        __JL_DATA[idx]['jjsl'] = 0; // 计价数量
        __JL_DATA[idx]['hszje'] = 0; // 含税总金额
        __JL_DATA[idx]['dzts'] = ''; // 定做天数
        __JL_DATA[idx]['lx'] = ''; // 类型

    };

    __getAllDj({
        get_dj: true,
        get_scdj: true,
        hideLoad: false,
        callback: function () {
            showList();
        }
    });
}

// 创建产品信息
function showList() {
    var html = [];
    var cpbj_info = page_data['pageData']['cpbj_info']; // 产品信息

    cpbj_info['wldw_id'] = page_data['__DJ_DATA']['wldw_id'];
    cpbj_info['wldw_mc'] = page_data['__DJ_DATA']['wldw_mc'];

    $('#batch_unit').text('元/ ' + (__JL_DATA[0]['jjdw_mc'] || ' '));
    $('#batch_set').val('');

    // html.push('<div>');

    $(__JL_DATA).each(function (idx, item) {
        var dj = item['dj'] || '';
        var name = item['number'] + ' ' + item['name'];
        if ($.nui.isEmpty(page_data['__DJ_DATA']['wldw_id'])) { // 没客户情况下，单价自动读取产品报价标准价
            dj = fun.is_value(item['bzj']);
        }

        html.push('<li class="lower-border-line li-wh">');

        if (xscg.isSeriesMode() && page_data['djlx'] === 'bp_xsbj' && xscg.hasSeries(item['color_type'])) {
            name = item['color_type'] || '';
        }
        html.push('    <span class="li1-left span1 ys-name">' + name + '</span>');

        html.push('    <p class="p2">');
        html.push('        <input type="text" id="set_price_' + idx + '" name="text" class="input1 num-input" num_type="2" decimal_digits="4" value="' + dj + '" ');
        html.push('            decimal_digits="4">');
        html.push('        <span class="color-gray font-lls batch-unit unit-name">元/ ' + (item['jjdw_mc'] || ' ') + ' </span>');
        html.push('        <span class="iconfont icon-delete font-lls"></span>');
        html.push('    </p>');
        html.push('</li>');
    })

    $('#show_list').html(html.join(''));
}

// 获取库存匹数和数量的请求参数
function getAjaxPsAndSl() {
    var ajax_data = [];
    $(page_data['jl_data']).each(function (idx, item) {
        ajax_data.push({
            'ck_id': '',
            'md_id': fun.getItem('user_info')['store_id'] || 0,
            'cp_ys_id': item.cp_ys_id,
            'cp_id': item.cp_id,
            'fk': item.fk,
            'kz': item.kz,
            'gg': item.gg,
            'dw_id': item.dw_id
        })
    });
    return {
        list: ajax_data
    };
}

// 设置单价、含税单价
function setHsdjAndDj() {
    $(__JL_DATA).each(function (idx, item) {
        var price = $('.input1').eq(idx).val() || 0;
        item['hsdj'] = price;  // 单价
        item['dj'] = (price / (1 + (parseFloat(0)) / 100.00)).fixed(4);
        delete item['id'];
    })
}

// 获取库存匹数和数量
function loadPsAndSl() {
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getKcslBatch,
        data: getAjaxPsAndSl(),
        success: function (res) {
            if (res.status === 0) {
                if (res.data) {
                    $(__JL_DATA).each(function (idx, item) {
                        item['kcps'] = $.nui.isEmpty(res.data[idx]['ps']) ? 0 : res.data[idx]['ps'];
                        item['kczsl'] = $.nui.isEmpty(res.data[idx]['zsl']) ? 0 : res.data[idx]['zsl'];
                    })
                } else {
                    $(__JL_DATA).each(function (idx, item) {
                        item['kcps'] = 0;
                        item['kczsl'] = 0;
                    })
                }
            }
        }
    });
};

// 批量设置价格
$('body').on('input', '#batch_set', function () {
    var iptVal = $(this).val();
    $('.input1').val(iptVal);
});

// 垃圾桶点击删除
$('body').on('tap', '.icon-delete', function () {
    $that = $(this);
    var CHECK_STATUS_ARR = page_data['CHECK_STATUS_ARR'];
    var delIdx = $(this).index('.icon-delete');
    var selIdx = $(this).parents('.li-wh').index();
    var delStatusIdx = fun.findSelIdx(CHECK_STATUS_ARR, page_data['skipData'][selIdx]);

    var delMsg = $(this).parent().siblings('.li1-left').text();
    fun.dialog({
        content: '你确定要删除' + '【' + delMsg + '】' + '吗？',
        btn: ['删除', '取消'],
        yes: function () { // 删除事件
            $that.parents('.li-wh').remove();
            __JL_DATA.splice(delIdx, 1); // 删除对应的数据
            page_data['skipData'].splice(selIdx, 1);
            CHECK_STATUS_ARR[delStatusIdx]['status'] = false;
        }
    });
})

// 批量选中单位
$('body').on('tap', '#unit_edit', function () {
    if (!page_data['__IS_EDIT']) {
        return false;
    }
    fun.showPageFull({
        page_url: page_arr.select_jjdw_list,
        pageParam: {
            return_page: html_name,
            page_type: 'jjdw',
        }
    });
})

// 确定按钮点击事件
$('body').on('tap', '#confirm', function () {
    setHsdjAndDj();

    __JL_DATA = page_data['__JL_DATA'].concat(__JL_DATA);

    // console.log(__JL_DATA);

    switch (page_data['djlx']) {
        case 'bp_cgbj':
            if ($.nui.isTrue(page_data.__route)) {
                if (page_data.from_page !== page_arr.cg_cgbj_kd) {  // 采购报价查询页面进入，跳转开单编辑页面
                    PageShow.gotoNextPage({
                        html_name: html_name,
                        page_data: $.extend(page_data, {
                            data: {
                                list: __JL_DATA
                            },
                            wldw: page_data['pageData']['wldw']
                        })
                    });
                } else {
                    api.sendEvent({
                        name: page_arr.cg_cgbj_kd,
                        extra: {
                            status: 'update_rows',
                            data: {
                                __JL_DATA: __JL_DATA
                            },
                            wldw: page_data['pageData']['wldw']
                        }
                    });

                    setTimeout(function () {
                        api.closeToWin({ name: page_arr.cg_cgbj_kd });
                    }, 200);
                }
            } else {
            }
            break;
        case 'bp_xsbj':
            if ($.nui.isTrue(page_data.__route)) {
                if (page_data.from_page !== page_arr.xs_xsbj_kd) {  // 销售报价查询页面进入，跳转开单编辑页面
                    PageShow.gotoNextPage({
                        html_name: html_name,
                        page_data: $.extend(page_data, {
                            data: {
                                list: __JL_DATA
                            },
                            wldw: page_data['pageData']['wldw']
                        })
                    });
                } else {
                    api.sendEvent({
                        name: page_arr.xs_xsbj_kd,
                        extra: {
                            status: 'update_rows',
                            data: {
                                __JL_DATA: __JL_DATA
                            },
                            wldw: page_data['pageData']['wldw']
                        }
                    });

                    setTimeout(function () {
                        api.closeToWin({ name: page_arr.xs_xsbj_kd });
                    }, 200);
                }
            } else {
            }
            break;
    }


    // if ($.nui.isTrue(page_data.__route)) {
    //     if (page_data.from_page !== page_arr.cg_cgbj_kd) {  // 销售报价查询页面进入，跳转开单编辑页面
    //         PageShow.gotoNextPage({
    //             html_name: html_name,
    //             page_data: $.extend(page_data, {
    //                 data: {
    //                     list: __JL_DATA
    //                 }
    //             })
    //         });
    //     } else {
    //         api.sendEvent({
    //             name: page_arr.cg_cgbj_kd,
    //             extra: {
    //                 status: 'update_rows',
    //                 data: {
    //                     __JL_DATA: __JL_DATA
    //                 }
    //             }
    //         });

    //         setTimeout(function () {
    //             api.closeToWin({ name: page_arr.cg_cgbj_kd });
    //         }, 200);
    //     }
    // } else {
    //     //  // 如果记录没有修改
    //     //  if ($.nui.isObjEquals(back_ori_data, __ROW_DATA)) {
    //     //     // cgbj.closeAndSendEvent();
    //     //     return false;
    //     // }

    //     // api.sendEvent({
    //     //     name: page_arr.cg_cgbj_kd,
    //     //     extra: {
    //     //         status: 'update',
    //     //         row: __ROW_DATA
    //     //     }
    //     // });

    //     // setTimeout(function () {
    //     //     api.closeWin();
    //     // }, 300);
    // }


    // PageShow.gotoNextPage({
    //     html_name: html_name,
    //     page_data: $.extend(page_data, {
    //         data: {
    //             list: __JL_DATA
    //         }
    //     })
    // });
})