var html_name = page_arr.cg_dycgdd;
var date_arr = fun.getMonthArr(6),
    to_month = fun.getMonthArr(1)[0];

var page_list = [];
var total_data = {};

var Bills = Bills || {};
var hjText = {};

var USER_INFO = {};
var SYS_CONFIG = {};
var wldw_gys_list = [];

var __PAGE_PARAM = {};
var begin_date = fun.Date(to_month['begin_date']).Format('yy.mm.dd');
var end_date = fun.Date(to_month['end_date']).Format('yy.mm.dd');

$('#date_range').text(begin_date + ' ~ ' + end_date);

var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    "ycjd": 0,
    "ycywc": 0,
    "xscq": 0,
    "is_mobile": 1
};
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd')
};

var selData = [];      // 选中的数据

var headerTitle = '', __DJ_DATA, __JL_DATA; // 单据信息
var fieldConfig = {};

// 加载上次价时，需要传递 __DJ_DATA
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    SYS_CONFIG = fun.getItem('sys_config') || {};

    if ($.nui.isTrue(page_data['__route'])) {
        __PAGE_PARAM = page_data['xsdykhdd_tmp'];
    } else {
        __PAGE_PARAM = page_data;
    }

    __DJ_DATA = page_data.__DJ_DATA || {};
    __JL_DATA = page_data.__JL_DATA || [];

    Bills.djlx = page_data.djlx;
    if (page_data.loadScdj) {
        Bills.AJAX_URL = {getDj: page_data.getDjUrl}
    }

    fun.load_DATA_LIST(['wldw_gys'], function () {
        wldw_gys_list = fun.getItem('wldw_gys_list') || [];
    });

    switch (__PAGE_PARAM['djlx']) {
        case 'bp_cglhjs':
            hjText['wfps'] = '未来匹';
            hjText['wfsl'] = '未来数';
            headerTitle = '未来货的订单';
            fieldConfig['wlps'] = 'wlps';
            fieldConfig['wlsl'] = 'wlsl';
            break;
        case 'bp_cgthjs':
            hjText['wfps'] = '已来匹';
            hjText['wfsl'] = '已来数';
            headerTitle = '已来货的订单';
            fieldConfig['wlps'] = 'lhps';
            fieldConfig['wlsl'] = 'lhsl';
            break;
    }

    $('#header').header({
        back: true,
        filter: true,
        title: headerTitle
    });


    $('#wfps').text(hjText['wfps']);
    $('#wfsl').text(hjText['wfsl']);

    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');

    var hn = html_name + '_';
    // 页面加载，要先读取有记忆的搜索条件
    search_storage = $.extend(true, {
        // 'ycjd': fun.getItem(hn + 'ycjd', 1)
        'xsjd': fun.getItem(hn + 'xsjd', 0)
    }, search_storage);


    search_data['wldw_id'] = __PAGE_PARAM['wldw_id'] || 0;
    search_data['is_dy'] = 1;
    search_data['gxlx_id'] = (__PAGE_PARAM['gxlx_id'] || 0);
    search_data['is_dy_djlx'] = __PAGE_PARAM['djlx'];
    search_data['jl_id_notin'] = __PAGE_PARAM['jl_id_notin'] || [];
    // search_data['ycjd'] = search_storage['ycjd'] || 0;
    search_data['xsjd'] = search_storage['xsjd'] || 0;
    getList(search_data);

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var param = ret.value.data;
        search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
        search_data['begin_time'] = param.begin_date;                   //开始时间
        search_data['end_time'] = param.end_date;                       //结束时间
        search_data['wldw_id'] = param.gys['id'] || 0;                 //供应商
        search_data['cp_id'] = param.cp['id'] || 0;                    //产品
        search_data['md_id'] = param.md['id'] || 0;                    //门店
        // search_data['ycjd'] = param['ycjd'];                //隐藏已结单记录
        search_data['xsjd'] = param['xsjd'];                //隐藏已结单记录

        search_storage['keyword'] = param['LIKE_DATA'] || '';
        search_storage['begin_date'] = param.begin_date;                   //开始时间
        search_storage['end_date'] = param.end_date;                       //结束时间
        // search_storage['ycjd'] = param['ycjd'];                //隐藏已结单记录
        search_storage['xsjd'] = param['xsjd'];                //隐藏已结单记录

        search_storage['gys'] = param.gys;
        search_storage['cp'] = param.cp;
        search_storage['md'] = param.md;

        $('#date_range').text(fun.Date(param.begin_date).Format('yy.mm.dd') + ' ~ ' + fun.Date(param.end_date).Format('yy.mm.dd'));

        //缓存按钮开关
        // fun.setItem(hn + 'ycjd', param['ycjd']);
        fun.setItem(hn + 'xsjd', param['xsjd']);

        fun.setItem(html_name + 'sideslip', true);

        $('#order_list').empty();
        getList(search_data);
    });

};

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

function getList(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpCgddtj,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#zps').text(0);
                    $('#zsl').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                total_data = res['info'];
                page_list = convertData(res.data);
                showList(page_list);
            } else {
                fun.alert({msg: '网络异常！'});
            }
        }
    })
}

function convertData(apidata) {
    if ($.nui.isEmpty(apidata)) return [];
    if ((!(apidata instanceof Array))) {
        return "参数错误";
    }
    var list = [], tmp = {};
    $(apidata).each(function (i, obj) {
        if (!tmp[obj["dh"]]) {
            tmp[obj["dh"]] = {
                "dh": obj['dh'],
                "kdsj": obj['kdsj'],
                "zdr_mc": obj['zdr_mc'],
                "wldw_mc": obj['wldw_mc'],
                "md_mc": obj['md_mc'],
                dj_wlps: obj['dj_wlps'],
                dj_wlsl: obj['dj_wlsl'],
                dj_lhps: obj['dj_lhps'],
                dj_lhsl: obj['dj_lhsl'],
                zdw_mc: obj['zdw_mc'],
                // "dj_ps": fun.is_value(obj['dj_ps'],0),
                // "dj_zsl": fun.is_value(obj['dj_zsl'],0),
                // "zdw_mc_tmp": fun.is_value(obj['zjjdw_mc']),  // 总计价单位名称
            };
            tmp[obj["dh"]]['list'] = [];
        }
        tmp[obj["dh"]]['list'].push(obj);
    });
    for (var i in tmp) {
        list.push(tmp[i]);
    }

    return list;
}

function showList(data) {
    var t_ps = 0, t_sl = 0;
    switch (__PAGE_PARAM['djlx']) {
        case 'bp_cglhjs':
            if (!$.nui.isEmpty(total_data)) {
                t_ps = total_data.wlps || 0;
                t_sl = total_data.wlsl || 0;
            }
            break;
        case 'bp_cgthjs':
            if (!$.nui.isEmpty(total_data)) {
                t_ps = total_data.lhps || 0;
                t_sl = total_data.lhsl || 0;
            }
            break;
    }

    $('#zps').text(t_ps);
    $('#zsl').text(t_sl);


    $('#order_list').OrderList({
        data: data,
        bindevent: false,
        render: {
            titlebar: function (res) {
                var style = [];
                style.push('<div class="title-bar-row">');
                style.push('    <span class="check-box"><i class="iconfont icon-check"></i></span>');
                style.push('    <div><span  class="font-bold font-ls">&nbsp;' + fun.is_value(res['wldw_mc']) + '</span></div>');
                style.push('    <div class="align-right time-option" ><a>' + fun.is_value(res['md_mc']) + '</a>');
                style.push('<span class="font-ss"><a>' + fun.formatTime(res['kdsj']) + '</a></span>');
                style.push('&nbsp;<span class="font-ss"><a>' + fun.is_value(res['zdr_mc']) + '</a></span></div>');
                style.push('</div>');
                style.push('<div class="title-bar-row">');
                style.push('<div style="width: 55%;"><span class="color-gray">'+hjText['wfps'].substring(0,2)+'&nbsp;</span>');
                style.push('<span>' + fun.is_value(res['dj_' + fieldConfig['wlps']], 0) + '匹&nbsp;</span>');
                style.push('<span>' + fun.is_value(res['dj_' + fieldConfig['wlsl']], 0) + fun.is_value(res['zdw_mc']) + '</span></div>');
                style.push('    <div style="width: 40%" class="align-right number font-ss fixed-right" ><a>' + fun.is_value(res['dh']) + '</a></div>');

                style.push('</div>');
                return style.join('');
            },
            subtitle: function (res) {
                var title_html = [],
                    fkkz = fun.is_value(res['fk']) + (res['fk'] && res['kz'] ? "×" : "") + fun.is_value(res['kz']);
                title_html.push('<div class="row" data-list_data=\'' + fun.formatString(JSON.stringify(res)) + '\'>');
                title_html.push('<div>');
                title_html.push('<span class="check-box checkbox-option"><i class="iconfont icon-check"></i></span>');
                title_html.push('<span class="row-select">' + fun.is_value(res['cp_bh']) + ' ' + fun.is_value(res['cp_mc']) + '&nbsp;' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</span></div>');

                title_html.push('</div>');
                // title_html.push('<div class="row">');
                // title_html.push('     <div>' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</div>');
                // if (!!res['fk'] || !!res['kz']) {
                //     title_html.push('     <div class="align-right"><a>幅\\克</a>' + fkkz + '</div>');
                // }
                // title_html.push('</div>');
                return title_html.join('');
            },
            subdata: function (res) {
                var s_ps = 0, s_sl = 0;
                switch (__PAGE_PARAM['djlx']) {
                    case 'bp_cglhjs':
                        s_ps = res['wlps'] || 0;
                        s_sl = res['wlsl'] || 0;
                        break;
                    case 'bp_cgthjs':
                        s_ps = res['lhps'] || 0;
                        s_sl = res['lhsl'] || 0;
                        break;
                }

                return [
                    '<div class="row row-option bg-gray top-margin">',
                    '    <div><span class="color-gray padd-left">订单匹</span><span>' + (res['ps'] || 0) + '</span></div>',
                    '    <div><span class="color-gray">' + hjText['wfps'] + '</span><span>' + (s_ps || 0) + '</span></div>',
                    '</div>',
                    '<div class="row row-option bg-gray border-radius">',
                    '    <div><span class="color-gray padd-left">订单数</span><span>' + (res['zsl'] || 0) + '</span></div>',
                    '    <div><span class="color-gray">' + hjText['wfsl'] + '</span><span>' + (s_sl || 0) + '</span></div>',
                    '</div>',
                ].join('');
            }
        },
    });

    $('.title-bar').off('tap');

    $('.check-box').removeClass('check-choice');
    setSelCount();

}

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').off('tap').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var disabled = $.nui.isTrue(__PAGE_PARAM['wldw_id']);
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'],
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage['begin_date'],
            "end_date": search_storage['end_date']
        },
        "choose_merchants": [
            {
                key: "gys",
                "text": "供应商",
                "value": fun.getValByKey(wldw_gys_list || [], __PAGE_PARAM['wldw_id'], 'merchant_name') || getTwo('gys', 'text'),
                "id": __PAGE_PARAM['wldw_id'] || getTwo('gys', 'id'),
                "disabled": disabled
            }, {
                key: "cp",
                "text": "产品",
                "value": getTwo('cp', 'text'),
                "id": getTwo('cp', 'id'),
            }, {
                key: "md",
                "text": "门店",
                "value": getTwo('md', 'text'),
                "id": getTwo('md', 'id'),
            },
        ],
        "switch": [
            {
                "text": "显示结单记录",
                "max_width": true,
                "key": "xsjd",
                "value": search_storage['xsjd']
            }
        ]
    };
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});


$('body').on('tap', '.check-box', function (e) {
    e.stopPropagation();
    if ($(this).hasClass('check-choice')) {
        $(this).removeClass('check-choice');
    } else {
        $(this).addClass('check-choice');
    }
});


$('body').on('tap', '#selAll', function (e) {
    if ($(this).hasClass('check-choice')) {
        $('.check-box').addClass('check-choice');
    } else {
        $('.check-box').removeClass('check-choice');
    }
    setSelCount();
});

$('body').on('tap', '.title-bar .check-box', function (e) {
    e.stopPropagation();
    if ($(this).hasClass('check-choice')) {
        $(this).closest('li').find('.summary-title .check-box').addClass('check-choice');
    } else {
        $(this).closest('li').find('.summary-title .check-box').removeClass('check-choice');
    }
    setSelCount();

    setSelAllState();
});


$('body').on('tap', '.summary-title .check-box', function (e) {
    e.stopPropagation();
    var $closeLi = $(this).closest('li');
    var totalCount = $closeLi.find('.summary-title .check-box').length;
    var selCount = $closeLi.find('.summary-title .check-box.check-choice').length;

    if (totalCount == selCount) {
        $closeLi.find('.title-bar .check-box').addClass('check-choice');
    } else {
        $closeLi.find('.title-bar .check-box').removeClass('check-choice');
    }
    setSelCount();

    setSelAllState();
});

$('body').on('tap', '.title-bar', function (e) {
    e.stopPropagation();
    var cb = $(this).find('.check-box');
    if (cb.hasClass('check-choice')) {
        cb.removeClass('check-choice');
        $(this).closest('li').find('.summary-title .check-box').removeClass('check-choice');
    } else {
        cb.addClass('check-choice');
        $(this).closest('li').find('.summary-title .check-box').addClass('check-choice');
    }
    setSelCount();
    setSelAllState();
});

$('body').on('tap', '.summary-title', function (e) {
    e.stopPropagation();

    var cb = $(this).find('.check-box');
    if (cb.hasClass('check-choice')) {
        cb.removeClass('check-choice');
    } else {
        cb.addClass('check-choice');
    }

    var $closeLi = $(this).closest('li');
    var totalCount = $closeLi.find('.summary-title .check-box').length;
    var selCount = $closeLi.find('.summary-title .check-box.check-choice').length;

    if (totalCount == selCount) {
        $closeLi.find('.title-bar .check-box').addClass('check-choice');
    } else {
        $closeLi.find('.title-bar .check-box').removeClass('check-choice');
    }

    setSelCount();
    setSelAllState();
});


function setSelAllState() {
    var titleBox = $('.title-bar .check-box').length;
    var titleSelBox = $('.title-bar .check-box.check-choice').length;

    if (titleBox == titleSelBox) {
        $('#selAll').addClass('check-choice');
    } else {
        $('#selAll').removeClass('check-choice');
    }
}


function setSelCount() {
    selData = getSelectedData();

    var count = 0;
    for (var i = 0; i < selData.length; i++) {
        switch (__PAGE_PARAM['djlx']) {
            case 'bp_cglhjs':
                count += selData[i]['wlps'];
                break;
            case 'bp_cgthjs':
                count += selData[i]['lhps'];
                break;
        }
    }
    $('#sel_ps').text(count);
}

// 调用处理
$('body').on('tap', '#save', function (e) {
    e.stopPropagation();
    // 只能选择同个供应商的数据
    var gysIds = [];
    var sendData = [];  // 发送的数据集合
    // var selData = getSelectedData();

    var selData = callByBpcg();
    
    if ($.nui.isEmpty(selData)) return;

    for (var i = 0; i < selData.length; i++) {
        var item = selData[i];
        if (gysIds.indexOf(item.wldw_id) === -1) {
            gysIds.push(item.wldw_id);
        }
        // console.log(item)
        // 数据格式化
        sendData.push({
            "is_dy": 1,
            "ck_id": item.ck_id,
            "ck_mc": item.ck_mc,
            "cp_id": item.cp_id,
            "cp_bh": item.cp_bh,
            "cp_mc": item.cp_mc,
            "cp_ys_bh": item.cp_ys_bh,
            "cp_ys_mc": item.cp_ys_mc,
            "cp_ys_id": item.cp_ys_id,
            "ckd_dh": item.ckd_dh,
            "ckd_kdsj": item.ckd_kdsj,
            "ckd_dj_id": item.ckd_dj_id,
            "ckd_jl_id": item.ckd_jl_id,

            
            "fhjs_dh": item.fhjs_dh,
            "fhjs_dj_id": item.fhjs_dj_id,
            "fhjs_jl_id": item.fhjs_jl_id,

            "fk": item.fk,
            "kz": item.kz,
            "gg": item.gg,
            "gh": item.gh,
            "jh": item.jh,
            "ph": item.ph,
            "kcms": item.kcms,
            "kc": item.kc,
            "ps": item.ps,
            "dw_id": item.dw_id,
            "dd_dh": item.dd_dh,
            "dd_dj_id": item.dd_dj_id,
            "dd_jl_id": item.dd_jl_id,

            "zsl": item.zsl,
            "dw2_id": item.dw2_id,
            "jjdw_id": item.jjdw_id,
            "jjdw_mc": item.jjdw_mc,
            "jjsl": item.jjsl,
            "zydj": item.zydj,
            "scdj": item.scdj,
            "dj": item.dj,
            "je": item.je,
            "shuilv": item.shuilv,
            "hsdj": item.hsdj,
            "hsje": item.hsje,
            "hszje": item.hsje,
            "shuie": item.shuie,
            "fy_zdy1": item.fy_zdy1,
            "fy_zdy2": item.fy_zdy2,
            "fy_zdy3": item.fy_zdy3,
            "fy_zdy4": item.fy_zdy4,
            "fy_zdy5": item.fy_zdy5,
            "zje": item.zje,
            "bz": "",
            "fzbh": item.fzbh,
            "fzmc": item.fzmc,
            "fzys": item.fzys,
            "fzsh": item.fzsh,
            "ywy_id": item.ywy_id,
            "ywy_mc": item.ywy_mc,

            "kh_id": item.kh_id,
            "kh_mc": item.kh_mc,
            "kh_dd_dh": item.kh_dd_dh,
            "kh_dd_kdsj": item.kh_dd_kdsj,
            "kh_dd_dj_id": item.kh_dd_dj_id,
            "kh_dd_jl_id": item.kh_dd_jl_id,

            ck_zdy1: item['ck_zdy1'],
            ck_zdy2: item['ck_zdy2'],
            ck_zdy3: item['ck_zdy3'],
            ck_zdy4: item['ck_zdy4'],
            ck_zdy5: item['ck_zdy5'],

            "kd_zdy1": item.kd_zdy1,
            "kd_zdy2": item.kd_zdy2,
            "kd_zdy3": item.kd_zdy3,
            "kd_zdy4": item.kd_zdy4,
            "kd_zdy5": item.kd_zdy5,
            "is_delete": 0,
            "dw_mc": item.dw_mc,
            "dw2_mc": null,
            "mx": []
        })
    }

    if (gysIds.length > 1) {
        return fun.toast('请选择相同供应商的单据');
    }

    // 具体供应商信息
    var wldw = fun.getListInfoByKey(wldw_gys_list, selData[0].wldw_id);

    // 判断是否加载上次价
    if (page_data.loadScdj) {
        __getDjInfo = function () {
            return {
                wldw_id: wldw.id,
                kdsj: __DJ_DATA.kdsj || fun.formatDate(new Date())
            };
        };

        __getJlData = function () {
            return sendData;
        };

        __updateJlDataByIndex = function (item) {
            var list_item = sendData[item.index];
            list_item.scdj = item.data.scdj;
            if (list_item.dj === 0) {
                list_item.hsdj = list_item.dj = item.data.dj;
                list_item.hszje = fun.sswr(list_item.hsdj * list_item.jjsl);
            }
        };

        __getAllDj({
            get_dj: true,
            get_scdj: true,
            update_all: true,
            callback: function () {
                dycgdd_finish(sendData, wldw , selData);
            }
        })
    } else {
        dycgdd_finish(sendData, wldw ,selData);
    }
});

function dycgdd_finish(sendData, wldw,selData) {
    __JL_DATA = __JL_DATA.concat(sendData);     // 拼接原有数据
    if ($.nui.isTrue(page_data['__route'])) {   // 新增时调用，打开新页面
        fun.showPageFull({
            page_url: __PAGE_PARAM['goto_page'],
            pageParam: {
                wldw: wldw,
                data: {
                    list: __JL_DATA,
                    jl_list: selData
                },
                return_page: page_arr.cg_lthjs_tj,
                LIST_PAGE: page_data['LIST_PAGE']
            }
        });
    } else {                                    // 编辑时调用，发送事件
        var eventStatus = 'update_rows';
        // 修改采购来退货事件通知名,跟选择产品返回重名
        if (['bp_cglhjs', 'bp_cgthjs'].indexOf(page_data.djlx) > -1) {
            eventStatus = 'cg_dycgdd';
        }
        api.sendEvent({
            name: __PAGE_PARAM['goto_page'],
            extra: {
                'status': eventStatus,
                'data': {
                    wldw: wldw,
                    __JL_DATA: __JL_DATA
                }
            }
        });

        setTimeout(function () {
            api.closeToWin({name: __PAGE_PARAM.goto_page});
        }, 200);
    }
}

function getSelectedData() {
    var data = [];
    for (var i = 0; i < $('.summary-title .check-box').length; i++) {
        var $ele = $('.summary-title .check-box').eq(i);
        var $row = $ele.closest('.row');

        if ($ele.hasClass('check-choice')) {
            data.push($row.data('list_data'));
        }
    }
    return data;
}

//被采购模块调用
function callByBpcg() {
    // if ($.nui.isEmpty(__params)) return true;
    var selData = getSelectedData();
    if ($.nui.isEmpty(selData)) return []; //无选择记录则不执行任何操作

    var __data = {list: [], wldw_id: 0, ck_id: 0, fp_id: 0};

    var msg = '';
    var dj_id = 0;
    for (var i = 0; i < selData.length; i++) {
        if (i !== 0) {
            if (__data['wldw_id'] != selData[i]['wldw_id'])
                return (fun.toast('只能选择相同供应商的单据。') && false);

            // // 采集器判断只能选择同一张单据
            // if ($.nui.isTrue(__params['is_cj']) && (dj_id !== selData[i]['dj_id'])) {
            //     return fun.toast('只能选择同一张单据。') && false;
            // }
            //
            // if (!$.nui.isTrue(__params['is_cj']) &&
            //     ($.inArray(__params['djlx'], ['bp_cglhjs', 'bp_cgthjs']) !== -1) &&
            //     $.nui.isTrue(selData[i]['fp_id']) && (__data['fp_id'] != selData[i]['fp_id']))
            // {
            //     msg = '你所选记录有多个不同的发票类型，<br/><br/>调用过去【发票类型】不会自动赋值。';
            //     __data['fp_id'] = undefined;
            // }
            //
            // if (!$.nui.isTrue(__params['is_cj']) && $.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']]) && $.nui.isEmpty(SYS_CONFIG[Bills['config']['dbtckjs']])) {
            //     if (__data['ck_id'] != selData[i]['ck_id']) {
            //         msg = '你所选记录有多个不同的仓库，<br/><br/>调用过去【仓库】不会自动赋值。';
            //         __data['ck_id'] = undefined;
            //     }
            // }
        }
        dj_id = selData[i]['dj_id'];
        __data['wldw_id'] = selData[i]['wldw_id'];
        (__data['ck_id'] === 0) && (__data['ck_id'] = selData[i]['ck_id']);
        (__data['fp_id'] === 0) && (__data['fp_id'] = selData[i]['fp_id']);

        var rmpRow = {
            'yy_djlx': selData[i]['djlx'],
            'ps': ($.inArray(__PAGE_PARAM['djlx'], ['bp_cgthd', 'bp_cgthjs']) !== -1) ? selData[i]['lhps'] : selData[i]['wlps'],
            'zsl': ($.inArray(__PAGE_PARAM['djlx'], ['bp_cgthd', 'bp_cgthjs']) !== -1) ? selData[i]['lhsl'] : selData[i]['wlsl'],
            'dd_dh': selData[i]['dh'],
            'dd_dj_id': selData[i]['dj_id'],
            'dd_jl_id': selData[i]['jl_id']
        };

        rmpRow['ps'] = (rmpRow['ps'] < 0) ? 0 : rmpRow['ps'];
        rmpRow['zsl'] = (rmpRow['zsl'] < 0) ? 0 : rmpRow['zsl'];

        var toCgData = $.extend(true, {}, selData[i], rmpRow);

        updateRowDataAmountAndMoney(null, toCgData);

        __data['list'].push(toCgData);
    }

    return __data['list'];
}

// //更新记录数据
// function updateJLData(tmpData, index) {
//     if (typeof index !== 'undefined' && index !== null) {
//         __JL_DATA.splice(index, 1);
//         updateRowDataAmountAndMoney(index, tmpData);
//         __JL_DATA.push(tmpData);
//     } else {
//         updateRowDataAmountAndMoney(index, tmpData);
//         __JL_DATA.push(tmpData);
//     }
//     return __JL_DATA;
// }
