var Bills = Bills || {};

Bills['config'] = {
    dckms: 'dckms_bp',
    dbtckjs: 'dbtckjs_bp'
};

Bills['wldw'] = Bills['wldw'] || {};
Bills['WldwSubInfo'] = Bills['WldwSubInfo'] || {};
Bills['getWldwSubInfoConfig'] = { ljqk: true, fz_cp: true, fz_ys: true, lxr: false };

Bills['ck'] = Bills['ck'] || {};
Bills['config'] = {
    'dwgshsbl': 'dwgshsbl_bp'
};

Bills['print_config'] = {};

// 删除行记录，判断需排除的字段
Bills['del_row_exclude_col'] = ['dd_jl_id', 'ckd_jl_id'];//'is_yy_tm'

Bills['__post_sign'] = $.nui.getRandomNum();

var USER_INFO = fun.getItem('user_info') || {};
var SYS_CONFIG = fun.getItem('sys_config') || {};
var DH_CONFIG = fun.getItem('dh_config') || {};//单号设置

//判断单据数据 是否追加明细
function __checkDjData(param) {
    for (var i = 0; i < param['arr'].length; i++) {
        // console.log(i, param['old_data'][param['arr'][i]])
        // console.log(i, param['new_data'][param['arr'][i]])
        if (param['old_data'][param['arr'][i]] !== param['new_data'][param['arr'][i]]) {
            return false;
        }
    }
    return true;
}

// 金额-四舍五入
function __jeSswr(value) {
    return fun.sswr(value, SYS_CONFIG[Bills['config']['jesswr']]);
}

// 本单金额-四舍五入
function __bdjeSswr(value) {
    return fun.sswr(value, SYS_CONFIG[Bills['config']['bdjesswr']]);
}

// 判断 记录行的-明细信息 有没 未删除的 匹数
function __isEmptyMx(data) {
    var _data = data || [];
    for (var i = 0; i < _data.length; i++) {
        if ($.nui.isTrue(_data[i]['is_delete'])) continue;
        return false;
    }
    return true;
}

// 判断 记录是否有 正确数据
// 正确数据是指: 有选择 产品、并且 (匹数> 或 数量>0)
function __grid1HasRightData() {
    var rows = __JL_DATA || [];
    for (var i = 0; i < rows.length; i++) {
        if ($.nui.isTrue(rows[i]['cp_id']) && ($.nui.isTrue(rows[i]['ps']) || $.nui.isTrue(rows[i]['zsl']))) return true;
    }
    return false;
}

// // 颜色下拉 有辅助色号、辅助颜色 所以需要单独写一个
// function __getYsComboBoxData(options) {
//     var data = __getSubComboBoxData(options), _data = [];
//     for (var i = 0; i < data.length; i++) {
//         var id = data[i]['id'];
//         var fz_data = {assistant_number: '', assistant_name: '', assistant_name_simple: '', order_amount: 0};
//         if (Bills['WldwSubInfo'] && Bills['WldwSubInfo']['fz_ys'] &&
//             Bills['WldwSubInfo']['fz_ys'][id] !== undefined
//         ) {
//             fz_data['assistant_number'] = Bills['WldwSubInfo']['fz_ys'][id]['assistant_number'];
//             fz_data['assistant_name'] = Bills['WldwSubInfo']['fz_ys'][id]['assistant_name'];
//             fz_data['assistant_name_simple'] = Bills['WldwSubInfo']['fz_ys'][id]['simple'];
//             fz_data['order_amount'] = Bills['WldwSubInfo']['fz_ys'][id]['order_amount'];
//         }
//         _data.push($.extend(true, {}, data[i], fz_data));
//     }
//     return _data;
// }

// 子信息的 下拉数据
function __getSubComboBoxData(options) {
    var _opt = $.extend(true, { data: [], keyName: '', keyValue: '' }, options);
    var _data = [];
    for (var i = 0; i < _opt['data'].length; i++) {
        if (_opt['keyValue'] == _opt['data'][i][_opt['keyName']]) {
            _data.push(_opt['data'][i]);
        }
    }
    return _data;
}


// 数据是否发生改变判断
function isDataChange() {
    Bills['save_data'] = getSaveData();

    if (!$.nui.isObjEquals(Bills['origin_data'], Bills['save_data'])) {
        if ($('body').find('.data-change-skin').length) return;
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData();
            },
            no: function () {
                api.closeWin();
            }
        });
    } else {
        api.closeWin();
    }
}

// 获取 当前选择的 仓库ID
function __getCkID(ck_id) {
    var _ck_id = ck_id;
    // if ($.nui.isEmpty(ck_id)) {
    //     _ck_id = ROW_DATA['ck_id'] || 0;
    // }
    return _ck_id || 0;
}

function __createPiHao(ck_id) {
    if ($.nui.isTrue(fun.getHouseValue(__getCkID(ck_id), 'is_batch'))) {
        if ($.nui.isEmpty($('#kdsj').text().trim())) return '';
        return fun.formatDate($('#kdsj').text().trim(), 'YYYYMMDD');
    }
    return '';
}

// 记录行是否需要生成批号
function __setRowDataPH(_data) {
    var djlx = page_data['djlx'];
    var Bills = Bills || {};
    switch (djlx) {
        case 'bp_xsfhjs':
        case 'bp_cgthjs':
        case 'kc_bptbd':
        case 'kc_bpmxpkd':
            Bills['win_type'] = 'is_ck';
            break;
        case 'bp_xsthjs':
        case 'bp_cglhjs':
        case 'kc_bppyd':
            Bills['win_type'] = 'is_rk';
            break;
    }

    if (Bills['win_type'] === 'is_rk') {
        if ($.nui.isTrue(fun.getHouseValue(_data['ck_id'], 'is_batch'))) {
            if ($.nui.isTrue(_data['cp_id']) && $.nui.isEmpty(_data['ph'])) {
                var ph = __createPiHao(_data['ck_id']);
                (_data['ph'] !== ph) && (_data['ph'] = ph);
            }
        } else {
            _data['ph'] = '';
            _data['ywy_id'] = 0;
            _data['ywy_mc'] = '';
            _data['bp_kh_id'] = 0;
            _data['bp_kh_mc'] = '';
            _data['bp_gys_id'] = 0;
            _data['bp_gys_mc'] = '';
            _data['bp_jgs_id'] = 0;
            _data['bp_jgs_mc'] = '';
        }
    }
}

//单位换算更新数据
function updateDataAfterDwhs(_data) {
    // 修改: 幅宽、克重、空差、空差模式、单位、计价单位、数量、匹数 则 计价数量 要重新算
    if (typeof _data['fk'] !== "undefined" || typeof _data['kz'] !== "undefined" ||
        typeof _data['zsl'] !== "undefined" || typeof _data['ps'] !== "undefined" ||
        typeof _data['kc'] !== "undefined" || typeof _data['kcms'] !== "undefined" ||
        typeof _data['dw_id'] !== "undefined" || typeof _data['dw_mc'] !== "undefined" ||
        typeof _data['jjdw_id'] !== "undefined" || typeof _data['jjdw_mc'] !== "undefined" ||
        typeof _data['dw2_id'] !== "undefined" || typeof _data['dw2_mc'] !== "undefined" ||
        typeof _data['bqkc'] !== "undefined"
    ) {
        var sl_arr = [],
            bqsl_arr = [],
            mx = _data['mx'] || [],
            zps = 0;

        for (var i = 0; i < mx.length; i++) {
            if ($.nui.isTrue(mx[i]['is_delete'])) continue;
            // 数量
            var _sl = parseFloat(mx[i]['sl'] || 0);
            // 标签数量
            var _bqsl = Number(_sl + parseFloat(_data['bqkc'] || 0)).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
            // 半匹出库，则匹数不+1
            // if (_sl >= parseFloat(mx[i]['tm_sl'] || 0)) zps++;
            zps++;

            // 标签数量
            mx[i]['bqsl'] = _bqsl;
            // 计价数量
            mx[i]['jjsl'] = Number((fun.dwhs({
                zsl: _bqsl,
                ps: 1,
                fk: _data['fk'] || '',
                kz: _data['kz'] || '',
                dw: _data['dw_mc'] || '',
                jjdw: _data['jjdw_mc'] || '',
                kc: parseFloat(_data['kc'] || 0),
                kcms: _data['kcms'] || '+',
                mx: [_bqsl]
            }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']])); // _bqsl

            // 数量2
            if ($.nui.isTrue(_data['dw2_mc'])) {
                var __sl2 = Number((fun.dwhs({
                    zsl: _sl,
                    ps: 1,
                    fk: _data['fk'] || '',
                    kz: _data['kz'] || '',
                    dw: _data['dw_mc'] || '',
                    jjdw: _data['dw2_mc'] || '',
                    kc: 0,
                    kcms: '+',
                    mx: [_sl]
                }) || _sl).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]));
                if (Bills['win_type'] === 'is_ck') {
                    if ($.nui.isEmpty(mx[i]['sl2'])) mx[i]['sl2'] = __sl2;
                    else {
                        mx[i]['sl2'] = (mx[i]['sl2'] * (_sl / 100.0000)).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                    }
                } else {
                    mx[i]['sl2'] = __sl2;
                }
            } else _data['mx'][i]['sl2'] = 0;

            // 净重
            mx[i]['jz'] = Number(fun.jsjz({
                sl: _sl || 0,
                kc: parseFloat(_data['kc'] || 0),
                kcms: _data['kcms'] || '+',
            }) || _sl || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);

            sl_arr.push(_sl);
            bqsl_arr.push(_bqsl);
        }

        sl_arr.length && (_data['ps'] = zps);

        // 总标签数量
        _data['bqsl'] = Number(fun.dwhs({
            zsl: _data['zsl'] || 0,
            ps: _data['ps'] || 0,
            fk: _data['fk'] || '',
            kz: _data['kz'] || '',
            dw: _data['dw_mc'] || '',
            jjdw: _data['dw_mc'] || '',
            kc: parseFloat(_data['bqkc'] || 0),
            kcms: '+',
            mx: bqsl_arr
        }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]); //_data['zsl']

        // 总计价数量
        _data['jjsl'] = Number(fun.dwhs({
            zsl: _data['bqsl'] || 0,
            ps: _data['ps'] || 0,
            fk: _data['fk'] || '',
            kz: _data['kz'] || '',
            dw: _data['dw_mc'] || '',
            jjdw: _data['jjdw_mc'] || '',
            kc: parseFloat(_data['kc'] || 0),
            kcms: _data['kcms'] || '+',
            mx: sl_arr
        }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]); //_data['bqsl']


        // 总数量2
        if ((parseInt(_data['ps']) === 1) && $.nui.isTrue(_data['dw2_mc'])) {
            _data['zsl2'] = Number(fun.dwhs({
                zsl: _data['zsl'] || 0,
                ps: _data['ps'] || 0,
                fk: _data['fk'] || '',
                kz: _data['kz'] || '',
                dw: _data['dw_mc'] || '',
                jjdw: _data['dw2_mc'] || '',
                kc: 0,
                kcms: '+',
                mx: sl_arr
            }) || _data['zsl'] || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
        } else _data['zsl2'] = 0;

        // 总净重
        _data['zjz'] = Number(fun.dwhs({
            zsl: _data['zsl'] || 0,
            ps: _data['ps'] || 0,
            fk: _data['fk'] || '',
            kz: _data['kz'] || '',
            dw: _data['dw_mc'] || '',
            jjdw: _data['dw_mc'] || '',
            kc: parseFloat(_data['kc'] || 0),
            kcms: _data['kcms'] || '+',
            mx: sl_arr
        }) || _data['zsl'] || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);

        // 实售数量
        _data['sssl'] = Number(fun.dwhs({
            zsl: _data['bqsl'] || 0, // 实售数量拿标签数量换算
            ps: _data['ps'] || 0,
            fk: _data['fk'] || '',
            kz: _data['kz'] || '',
            dw: _data['dw_mc'] || '',
            jjdw: _data['jjdw_mc'] || '',
            kc: parseFloat(_data['kc'] || 0),
            kcms: _data['kcms'] || '+',
            mx: sl_arr
        }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
    }
    return _data;
}


//获取单价、上次价
function __getDj(options) {
    console.log('------------1111111111111');
    console.log(options['data']);
    console.log('-------------1111111111111');
    if ($.nui.isEmpty(Bills['AJAX_URL']['getDj'])) {
        if (typeof options['callback'] === 'function') options['callback']({ data: {} });
        return;
    }
    
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: Bills['AJAX_URL']['getDj'],
        data: options['data'],
        success: function (res) {
            console.log('------------222222222222');
            console.log(res);
            console.log('------------222222222222');
            if (typeof options['callback'] === 'function') options['callback'](res);
        }
    });
}

//批量 获取单价、上次价
function __getAllDj(options) {
    var __opt = $.extend(true, {
        'get_dj': 1,
        'get_scdj': 1,
        'get_cpbj': 1,
        'update_all': 1,
        '__update_dj_key': '',
        hideLoad: true
    }, options);

    var isXsbj = page_data['djlx'] === 'bp_xsbj'; // 是否是销售报价

    if ($.nui.isEmpty(Bills['AJAX_URL']['getDj'])) {
        if (typeof __opt['callback'] === 'function') __opt['callback']();
        return;
    }

    // fun.showLoad();

    var list = [];
    var dj_info = {};
    if (typeof __getDjInfo === 'function') {
        dj_info = __getDjInfo() || {};
    }
    var jl_rows = [];
    if (typeof __getJlData === 'function') {
        jl_rows = __getJlData() || [];
    }

    for (var i = 0; i < jl_rows.length; i++) {
        var __row = jl_rows[i];
        var isXsbjSeries = function () { // 销售报价色系报价(色系报价__row对象里没有color_type 字段)
            return isXsbj && 'color_type' in __row;
        };
        __row['__index'] = i;
        if ($.nui.isTrue(__opt['__update_dj_key']) && (__opt['__update_dj_key'] != __row['__update_dj_key'])) continue;

        // 当是销售报价 有开启色系报价时，cp_ys_id 为 0，这时候cp_ys_id不做检测
        if ($.nui.isEmpty(__row['cp_id']) || !isXsbjSeries() && $.nui.isEmpty(__row['cp_ys_id']) || $.nui.isEmpty(__row['jjdw_id'])) continue;

        // 当 update_all=false 则代表只更新 单价 为 0 的记录
        if ($.nui.isEmpty(__opt['update_all']) && ((__row['dj'] || 0) > 0)) continue;
        list.push({
            "djlx": Bills['djlx'],
            "__key": __row['__index'],
            "__get_dj": __opt['get_dj'],
            "__get_scdj": __opt['get_scdj'],
            "wldw_id": dj_info['wldw_id'] || 0,
            "cp_id": __row['cp_id'] || 0,
            "cp_ys_id": __row['cp_ys_id'] || 0,
            "jjdw_id": __row['jjdw_id'] || 0,
            "dj_info": __row['dj_info'] || {},
            "dd_dj_id": __row['dd_dj_id'] || 0,
            "dd_jl_id": __row['dd_jl_id'] || 0,
            "gx_id": __row['gx_id'] || 0,
            "kdsj": dj_info['kdsj'] || fun.formatDate(new Date()),
            "dj": __row['dj'] || 0,

            // 获取成本价 需要用到 仓库、单位
            "ck_id": __row['ck_id'] || 0,
            "dw_id": __row['dw_id'] || 0,
            // 标准价 最低价 需要用到类型
            "jg_lx": fun.getValByKey(fun.getSaleLxData({ showAll: true }) || [], __row['jg_lx_mc'], 'simple', 'name') || 'dh'
        });

        // 销售报价，增加色系报价 2020-04-10
        if (isXsbjSeries()) {
            list[i]['color_type'] = __row['color_type'];
        }
    }

    fun.ajax({
        showLoad: false,
        hideLoad: __opt['hideLoad'],
        url: Bills['AJAX_URL']['getDj'],
        data: { list: list },
        success: function (res) {
            for (var key in res['data']) {
                var __tmpData = {};
                $.nui.isTrue(__opt['get_scdj']) && (__tmpData['scdj'] = res['data'][key]['scdj']);
                if ($.nui.isTrue(__opt['get_dj'])) {
                    __tmpData['dj'] = res['data'][key]['dj'];
                    __tmpData['ssdj'] = res['data'][key]['ssdj'];
                }
                if ($.nui.isTrue(__opt['get_cpbj'])) {
                    __tmpData['bzj'] = res['data'][key]['bzj'];
                    __tmpData['zdj'] = res['data'][key]['zdj'];
                }
                // 扩展方法, 不同模块 有 特殊的 价格字段需要赋值
                // 销售: ssdj:实售价、bzj:标准价、zdj:最低价
                // 加工: dj_info: 工序单价
                if (typeof __setDj === 'function') __setDj({
                    __data: __tmpData,
                    res: res['data'][key]
                });

                // updateRowDataMoney(key, __tmpData);

                if (typeof __updateJlDataByIndex === 'function') __updateJlDataByIndex({
                    index: key,
                    data: __tmpData
                });
            }

            if (html_name == page_arr.xs_fhjs_kd) {
                showJlList(formatData(__JL_DATA));
                getTotalInfo(__JL_DATA);
                setYsje();
            }

            if (typeof __opt['callback'] === 'function') __opt['callback']();
            fun.hideLoad();
        }
    });
}

// 判断 记录是否有 正确数据
// 正确数据是指: 有选择 产品、并且 (匹数> 或 数量>0)
function hasRightData() {
    var rows = __JL_DATA || [];
    for (var i = 0; i < rows.length; i++) {
        if ($.nui.isTrue(rows[i]['cp_id']) && ($.nui.isTrue(rows[i]['ps']) || $.nui.isTrue(rows[i]['zsl']))
        ) return true;
    }
    return false;
}


//调库存
function __dkc_callback(params, r_index, notify_page) {
    var data = params['list'];
    var row = params['row'] || {};

    //暂时先注释掉
    __delEmptyRow();
    // 如果当前 右键的行 是属于 新增行，并且 明细为空，则删除当前行

    // 总数没有明细
    // 总数有明细但没有有效明细匹
    if (data.length
        && $.nui.isTrue(row)
        // && $.nui.isEmpty(row['id'])   // 无论新增或者编辑行，都需要删除
        && ($.nui.isEmpty(row['mx']) || (!fun.getHouseValue(row['ck_id'], 'is_detail') && !__getMxLength(row['mx'])))
        // && $.nui.isTrue(row['__row_key'])
    ) {
        if (typeof r_index !== 'undefined' && typeof r_index !== 'object') {
            var del_data = __JL_DATA.splice(r_index, 1);
            var del_row = del_data[0];
            if (del_row && del_row.id && notify_page) {
                api.sendEvent({
                    name: notify_page,
                    extra: {
                        status: 'dkc_edit_del',
                        data: {
                            row_data: del_row,
                            row_index: r_index
                        }
                    }
                });
            }
        }
    }

    if ($.nui.isTrue(data[0]) && $.nui.isTrue(data[0]['kcms'])) {
        if (!$.nui.isTrue(row['kc'])) {
            row['kcms'] = data[0]['kcms'];
            row['kc'] = data[0]['kc'] || '';
        }
    }

    for (var i = 0; i < data.length; i++) {
        var is_up = false;
        var check_arr = ['ck_id', 'cw_id', 'cp_id', 'cp_ys_id', 'fk', 'kz', 'gg', 'gh', 'jh', 'ph', 'ck_zdy1', 'ck_zdy2', 'ck_zdy3',
            'ck_zdy4', 'ck_zdy5', 'dw_id', 'dw2_id', 'ywy_id', 'bp_kh_id', 'bp_gys_id', 'bp_jgs_id'];

        if ($.nui.isTrue(data[i])) {
            data[i]['kcms'] = data[i]['kcms'] || '+';
            data[i]['kc'] = data[i]['kc'] || '';
        }

        if ($.nui.isTrue(data[i]['kcms'])) {
            check_arr.push('kcms');
            check_arr.push('kc');
        }

        if ($.nui.isTrue(row['is_yy_tm'])
            && __checkDjData({ arr: check_arr, old_data: row, new_data: data[i] })
        ) {
            is_up = true;
        }
        /*
            调订单、调非结算单、调库存记录、调采集记录、调采集文件生成开单记录行时
            自动将计价数赋值给实售数量 sssl = jjsl
            自动将空差赋值给实售空差 sskc = kc
        */
        var cpData = {
            yy_djlx: data[i]['yy_djlx'],
            is_dy: $.nui.isTrue(data[i]['yy_djlx']) ? 1 : 0,
            ck_id: data[i]['ck_id'],
            ck_mc: data[i]['ck_mc'],
            cw_id: data[i]['cw_id'],
            cw_mc: data[i]['cw_mc'],
            cp_id: data[i]['cp_id'],
            cp_bh: data[i]['cp_bh'],
            cp_mc: data[i]['cp_mc'],
            cp_ys_id: data[i]['cp_ys_id'],
            cp_ys_bh: data[i]['cp_ys_bh'],
            cp_ys_mc: data[i]['cp_ys_mc'],
            fk: data[i]['fk'],
            kz: data[i]['kz'],
            gg: data[i]['gg'],
            gh: data[i]['gh'],
            jh: data[i]['jh'],
            ph: data[i]['ph'],
            kcms: data[i]['kcms'] || '+',
            kc: data[i]['kc'],
            sskc: data[i]['kc'],
            sssl: data[i]['jjsl'],
            ps: data[i]['ps'],
            zsl: data[i]['zsl'],
            zsl2: data[i]['zsl2'],
            jcs: data[i]['jcs'],
            dw_id: data[i]['dw_id'],
            dw_mc: data[i]['dw_mc'],
            dw2_id: data[i]['dw2_id'],
            dw2_mc: data[i]['dw2_mc'],
            jjdw_id: data[i]['jjdw_id'] || data[i]['dw_id'],
            jjdw_mc: data[i]['jjdw_mc'] || data[i]['dw_mc'],
            bz: data[i]['jl_bz'],

            ck_zdy1: data[i]['ck_zdy1'],
            ck_zdy2: data[i]['ck_zdy2'],
            ck_zdy3: data[i]['ck_zdy3'],
            ck_zdy4: data[i]['ck_zdy4'],
            ck_zdy5: data[i]['ck_zdy5'],

            ywy_id: data[i]['ywy_id'],
            ywy_mc: data[i]['ywy_mc'],
            bp_kh_id: data[i]['bp_kh_id'],
            bp_kh_mc: data[i]['bp_kh_mc'],
            bp_gys_id: data[i]['bp_gys_id'],
            bp_gys_mc: data[i]['bp_gys_mc'],
            bp_jgs_id: data[i]['bp_jgs_id'],
            bp_jgs_mc: data[i]['bp_jgs_mc'],
            is_yy_tm: data[i]['is_yy_tm']
        };

        var __ck_list = fun.getItem('ck_list') || [];

        if (fun.getValByKey(__ck_list, cpData['ck_id'], 'type') === 'skyb' && cpData['cp_ys_bh'] === '色卡') {
            cpData.jjdw_id = cpData['dw_id'];
            cpData.jjdw_mc = cpData['dw_mc'];
            cpData.jg_lx = 'sk';
            cpData.jg_lx_mc = '色卡';
        }

        var __extendRow = {};

        if ($.nui.isTrue(row['is_delete'])) {
            __extendRow = {
                __index: row.__index,
                mx: row.mx,
            };
        } else {
            __extendRow = row;
        }

        var tmpData = $.extend(true, {}, row, cpData);

        // 如果仓库是总数模式，需要删除mx数据
        if ($.nui.isTrue(tmpData['ck_id'])) {

            if (!fun.getHouseValue(tmpData['ck_id'], 'is_detail')) {
                // delete tmpData['mx'];
                tmpData['mx'] = [];
            }
        }

        if ($.nui.isTrue(data[i]['mx'])) {
            var mx = data[i]['mx'], tmpMx = [];
            if (is_up) tmpMx = row['mx'];
            for (var j = 0; j < mx.length; j++) {
                tmpMx.push($.extend(true, {
                    dj_id: 0,
                    jl_id: 0,
                    id: 0
                }, mx[j], { px: parseInt(__getMxLength(tmpMx) / 10) + 1, ph: (__getMxLength(tmpMx) % 10) + 1 }));
            }
            tmpData['mx'] = tmpMx;

            var zsl = 0;
            for (var j = 0; j < tmpMx.length; j++) {
                if ($.nui.isTrue(tmpMx[j]['is_delete'])) continue;
                zsl += tmpMx[j]['sl'];
            }
            zsl = zsl.fixed();

            tmpData['zsl'] = zsl;
        }

        if (typeof dkc_callback === "function") dkc_callback(tmpData, data[i]);

        delete tmpData['id'];
        delete tmpData['__status'];
        delete tmpData['__row_key'];
        delete tmpData['__index'];
        delete tmpData['__select'];

        tmpData = updateDataAfterDwhs(tmpData);

        ROW_DATA = tmpData;
        // if (typeof updateJLData === "function") updateJLData(tmpData, is_up ? r_index : undefined);
        __setRowData(is_up ? row.__index : null, tmpData);

        // if (typeof r_index !== 'undefined') {
        //     jl_data.splice(r_index, 1, tmpData);
        // } else {
        //     jl_data.push(tmpData);
        // }
    }

    if (typeof setDomDisabled === 'function') setDomDisabled();
    __getAllDj({ 'update_all': false });
}

function __getWldwSubInfo(options) {
    var _opt = $.extend(true, Bills['getWldwSubInfoConfig'], options);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMerchantBillsData,
        data: {
            'wldw_id': Bills['wldw']['id'] || 0,
            'sj': fun.formatDate($('#kdsj').text().trim()),
            'ljqk': _opt['ljqk'],
            'fz_cp': _opt['fz_cp'],
            'fz_ys': _opt['fz_ys'],
            'lxr': _opt['lxr'],
        },
        success: function (res) {
            fun.hideLoad();
            Bills['WldwSubInfo'] = res;
            Bills['__cp_list'] = undefined;
            Bills['__cp_list_obj'] = undefined;
            if (typeof _opt['callback'] === 'function') _opt['callback'](res);
        }
    });
}


//设置记录行数据
function __setRowData(index, data, opt) {
    var _opt = $.extend({ returnObjFromArr: false, calcMoney: true, hsdj_fixed: 4, setSsj: false, upDateSssl: true }, opt);

    if (typeof getRowSaveData === 'function') getRowSaveData();

    //深拷贝 删除的话会变成一样的
    //浅拷贝 明细会少
    var _data = $.extend({}, (index !== null && index != undefined && _opt['returnObjFromArr']) ? __JL_DATA[index] : ($.extend({}, ROW_DATA) || {}), $.extend({}, data));

    if ($.nui.isEmpty(_data['ck_id'])) _data['ck_id'] = page_data['ck_info'] ? page_data['ck_info']['ck_id'] : 0;

    // 如果有选择产品 则需判断 单位、单位2、空差模式 是否有值, 没则需要赋值 档案的默认信息
    if ($.nui.isTrue(_data['cp_id'])) {
        var goods_list = fun.getItem('cp_list') || [];
        var goods_info = fun.getListInfoByKey(goods_list || [], _data['cp_id']);

        if ($.nui.isEmpty(_data['dw_id'])) {
            _data['dw_id'] = goods_info['unit_id'];
            _data['dw_mc'] = fun.getValByKey(fun.getItem('jjdw_list') || [], _data['dw_id']);
        }

        if ($.nui.isEmpty(_data['jjdw_id'])) {
            switch (Bills['wldw_type']) {
                case 'kh':
                    _data['jjdw_id'] = goods_info['unit_options'] ? goods_info['unit_options']['xsdw_id'] : 0;
                    break;
                case 'gys':
                    _data['jjdw_id'] = goods_info['unit_options'] ? goods_info['unit_options']['cgdw_id'] : 0;
                    break;
                case 'jgs':
                    _data['jjdw_id'] = goods_info['unit_options'] ? goods_info['unit_options']['jgdw_id'] : 0;
                    break;
            }
            _data['jjdw_mc'] = fun.getValByKey(fun.getItem('jjdw_list') || [], _data['jjdw_id']);

            if ($.nui.isEmpty(_data['jjdw_id'])) {
                _data['jjdw_id'] = _data['dw_id'];
                _data['jjdw_mc'] = _data['dw_mc'];
            }
        }

        // 有开启 一匹多单位 才需要赋值 dw2 信息
        if ($.nui.isTrue(SYS_CONFIG['ypbddwgl']) && $.nui.isEmpty(_data['dw2_id'])) {
            _data['dw2_id'] = goods_info['unit_options'] ? goods_info['unit_options']['dw2_id'] : 0;
            _data['dw2_mc'] = fun.getValByKey(fun.getItem('jjdw_list') || [], _data['dw2_id']);
        }

        if ($.nui.isEmpty(_data['kcms'])) _data['kcms'] = (goods_info['diff'] || '+');

        switch (_data['jg_lx']) {
            case 'jy':
                _data['jg_lx_mc'] = '剪样';
                break;
            case 'yb':
                _data['jg_lx_mc'] = '样版';
                break;
            case 'sk':
                _data['jg_lx_mc'] = '色卡';
                break;
        }

        // 如果记录行 类型 为空则默认赋值 大货
        if ($.nui.isEmpty(_data['jg_lx'])) {
            _data['jg_lx_mc'] = '大货';
            _data['jg_lx'] = 'dh';
        }
    }

    if (typeof setRowDataJjsl === 'function') {
        setRowDataJjsl(index, data, _opt, _data)
    } else {
        __setRowDataJjsl(index, data, _opt, _data)
    };

    var hasJe = false;

    switch (page_data['djlx']) {
        case 'bp_xsfhjs':
        case 'bp_xsthjs':
        case 'bp_cglhjs':
        case 'bp_cgthjs':
        case 'bp_xsdd':
        case 'bp_cgdd':
        case 'bp_xsbj':
        case 'bp_cgbj':
            hasJe = true;
            break;
        case 'kc_bppyd':
        case 'kc_bptbd':
        case 'kc_bpzspd':
        case 'kc_bpmxpkd':
            delete _data['jjdw_id'];
            break;
    }

    // 结算金额
    if (hasJe && $.nui.isTrue(_opt['calcMoney'])) {
        _data['dj'] = parseFloat(_data['dj'] || 0);
        _data['hsdj'] = parseFloat(_data['hsdj'] || 0);
        if (typeof data['hsdj'] !== "undefined") {
            _data['dj'] = (_data['hsdj'] / (1 + (parseFloat(_data['shuilv'] || 0)) / 100.00)).fixed(_opt.hsdj_fixed);
        } else {
            _data['hsdj'] = (_data['dj'] * (1 + (parseFloat(_data['shuilv'] || 0)) / 100.00)).fixed(_opt.hsdj_fixed);
        }

        _data['je'] = (_data['dj'] * (_data['jjsl'] || 0)).fixed();
        _data['zydj'] = ($.nui.isEmpty(_data['zsl'])) ? 0 : (_data['je'] / parseFloat(_data['zsl'])).fixed();

        _data['hsje'] = ((_data['hsdj'] || 0) * (_data['jjsl'] || 0)).fixed();
        _data['shuie'] = ((_data['hsje'] || 0) - (_data['je'] || 0)).fixed();

        _data['zje'] = _data['je'];
        _data['hszje'] = _data['hsje'];
        for (var i = 1; i <= 5; i++) {
            // 自定义费用
            _data['zje'] += parseFloat(_data['fy_zdy' + i] || 0);
            _data['hszje'] += parseFloat(_data['fy_zdy' + i] || 0);
        }
        _data['zje'] = __jeSswr(_data['zje']);
        _data['hszje'] = __jeSswr(_data['hszje']);
    }

    if (typeof setRowData === 'function') setRowData(index, data, _opt, _data);

    if (_opt['returnObjFromArr']) {
        // if (index === null) __JL_DATA.push(_data);
        // else __JL_DATA.splice(index, 1, _data);
        // if (typeof setYsje === 'function') setYsje();
    } else {
        if (typeof updateJLData === "function") updateJLData(_data, index);
        ROW_DATA = $.extend({}, ROW_DATA, _data);
        // ROW_DATA = $.extend({}, ROW_DATA);
        if (typeof afterGetRowData === 'function') afterGetRowData(ROW_DATA);

        return ROW_DATA;
    }

}


function setRowData(index, data, opt, _data) {
    switch (Bills['djlx']) {
        case 'bp_xsdd':
        case 'bp_xsfhjs':
        case 'bp_xsthjs':
            // _data['ssdj'] = parseFloat(_data['ssdj'] || 0);
            // if ((typeof data['ssdj'] === 'undefined') && ((typeof data['dj'] !== 'undefined'))) _data['ssdj'] = _data['dj'];
            // _data['ssdj'] = parseFloat(_data['dj'] || 0);
            // _data['ssje'] = (_data['ssdj'] * (_data['jjsl'] || 0)).fixed();
            // _data['sszje'] = (_data['ssdj'] * (_data['jjsl'] || 0)).fixed();
            // // 自定义费用
            // for (var i = 1; i <= 5; i++) _data['sszje'] += parseFloat(_data['fy_zdy' + i] || 0);
            // _data['sszje'] = __jeSswr(_data['sszje']);

            //如果没有开启实售价 则拿单价字段
            if ($.nui.isEmpty(SYS_CONFIG['qyssjms_bp'])) {// || opt['setSsj']
                console.log('------------------------------------------------------------1---------------------------------------------------------')
                _data['ssdj'] = _data['dj'];
            } else {
                console.log('------------------------------------------------------------2---------------------------------------------------------')
                // if (typeof _data['ssdj'] === 'undefined') {
                //     _data['ssdj'] = parseFloat(_data['dj'] || 0);
                // } else {
                _data['ssdj'] = parseFloat(_data['ssdj'] || 0);
                // }
            }
            // _data['ssje'] = (_data['ssdj'] * (_data['jjsl'] || 0)).fixed();
            _data['ssje'] = (_data['ssdj'] * (_data['sssl'] || 0)).fixed();

            if (page_data.djlx != 'bp_xsdd') {
                _data['ssje'] = __jeSswr(_data['ssje']);
                _data['sszje'] = (_data['ssdj'] * (_data['sssl'] || 0)).fixed();
                // 自定义费用
                for (var i = 1; i <= 5; i++) _data['sszje'] += parseFloat(_data['fy_zdy' + i] || 0);
                _data['sszje'] = __jeSswr(_data['sszje']);
            } else {
                // 自定义费用
                for (var i = 1; i <= 5; i++) _data['ssje'] += parseFloat(_data['fy_zdy' + i] || 0);
                _data['ssje'] = __jeSswr(_data['ssje']);
            }
            break;
    }
}


// 设置 记录行的 计价数量
function __setRowDataJjsl(index, data, opt, _data) {
    // 修改: 幅宽、克重、空差、空差模式、单位、计价单位、数量、匹数 则 计价数量 要重新算

    if (typeof data['fk'] !== "undefined" || typeof data['kz'] !== "undefined" ||
        typeof data['zsl'] !== "undefined" || typeof data['ps'] !== "undefined" ||
        typeof data['kc'] !== "undefined" || typeof data['kcms'] !== "undefined" ||
        typeof data['dw_id'] !== "undefined" || typeof data['dw_mc'] !== "undefined" ||
        typeof data['jjdw_id'] !== "undefined" || typeof data['jjdw_mc'] !== "undefined" ||
        typeof data['dw2_id'] !== "undefined" || typeof data['dw2_mc'] !== "undefined" ||
        typeof data['bqkc'] !== "undefined"
    ) {

        if ($.nui.isTrue(_data['is_fs'])/* || $.nui.isTrue(_data['no_calc_jjsl'])*/) return; // 计价数反算数量不用重新计算计价数量

        var sl_arr = [], bqsl_arr = [], mx = _data['mx'] || [], zps = 0;
        // 循环明细表的数据合算出 总数量、总计价数
        zps = 0;

        for (var i = 0; i < mx.length; i++) {
            if ($.nui.isTrue(mx[i]['is_delete'])) continue;
            // 数量
            var _sl = parseFloat(mx[i]['sl'] || 0);
            // 标签数量
            var _bqsl = Number(_sl + parseFloat(_data['bqkc'] || 0)).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
            // 半匹出库，则匹数不+1
            // if (_sl >= parseFloat(mx[i]['tm_sl'] || 0)) zps++;
            zps++;

            // 标签数量
            mx[i]['bqsl'] = _bqsl;
            // 计价数量
            mx[i]['jjsl'] = Number((fun.dwhs({
                zsl: _bqsl,
                ps: 1,
                fk: _data['fk'] || '',
                kz: _data['kz'] || '',
                dw: _data['dw_mc'] || '',
                jjdw: _data['jjdw_mc'] || '',
                kc: parseFloat(_data['kc'] || 0),
                kcms: _data['kcms'] || '+',
                mx: [_bqsl]
            }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]));  // _bqsl

            // 数量2
            if ($.nui.isTrue(_data['dw2_mc'])) {
                var __sl2 = Number((fun.dwhs({
                    zsl: _sl,
                    ps: 1,
                    fk: _data['fk'] || '',
                    kz: _data['kz'] || '',
                    dw: _data['dw_mc'] || '',
                    jjdw: _data['dw2_mc'] || '',
                    kc: 0,
                    kcms: '+',
                    mx: [_sl]
                }) || _sl).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]));
                if (Bills['win_type'] === 'is_ck') {
                    if ($.nui.isEmpty(mx[i]['sl2'])) mx[i]['sl2'] = __sl2;
                    else {
                        mx[i]['sl2'] = (mx[i]['sl2'] * (_sl / 100.0000)).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                    }
                } else {
                    mx[i]['sl2'] = __sl2;
                }
            } else _data['mx'][i]['sl2'] = 0;

            // 净重
            mx[i]['jz'] = Number(fun.jsjz({
                sl: _sl || 0,
                kc: parseFloat(_data['kc'] || 0),
                kcms: _data['kcms'] || '+',
            }) || _sl || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);

            sl_arr.push(_sl);
            bqsl_arr.push(_bqsl);
        }
        sl_arr.length && (_data['ps'] = zps);

        // 总标签数量
        _data['bqsl'] = Number(fun.dwhs({
            zsl: _data['zsl'] || 0,
            ps: _data['ps'] || 0,
            fk: _data['fk'] || '',
            kz: _data['kz'] || '',
            dw: _data['dw_mc'] || '',
            jjdw: _data['dw_mc'] || '',
            kc: parseFloat(_data['bqkc'] || 0),
            kcms: '+',
            mx: bqsl_arr
        }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]); //_data['zsl']

        if (!$.nui.isTrue(_data['no_calc_jjsl'])) {
            // 总计价数量
            _data['jjsl'] = Number(fun.dwhs({
                zsl: _data['bqsl'] || 0,
                ps: _data['ps'] || 0,
                fk: _data['fk'] || '',
                kz: _data['kz'] || '',
                dw: _data['dw_mc'] || '',
                jjdw: _data['jjdw_mc'] || '',
                kc: parseFloat(_data['kc'] || 0),
                kcms: _data['kcms'] || '+',
                mx: sl_arr
            }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]); //_data['bqsl']
        }

        delete _data['no_calc_jjsl'];

        // 总数量2
        if ((parseInt(_data['ps']) === 1) && $.nui.isTrue(_data['dw2_mc'])) {
            _data['zsl2'] = Number(fun.dwhs({
                zsl: _data['zsl'] || 0,
                ps: _data['ps'] || 0,
                fk: _data['fk'] || '',
                kz: _data['kz'] || '',
                dw: _data['dw_mc'] || '',
                jjdw: _data['dw2_mc'] || '',
                kc: 0,
                kcms: '+',
                mx: sl_arr
            }) || _data['zsl'] || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
        } else _data['zsl2'] = 0;

        // 总净重
        _data['zjz'] = Number(fun.dwhs({
            zsl: _data['zsl'] || 0,
            ps: _data['ps'] || 0,
            fk: _data['fk'] || '',
            kz: _data['kz'] || '',
            dw: _data['dw_mc'] || '',
            jjdw: _data['dw_mc'] || '',
            kc: parseFloat(_data['kc'] || 0),
            kcms: _data['kcms'] || '+',
            mx: sl_arr
        }) || _data['zsl'] || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);

        if (opt['upDateSssl']) {
            // 实售数量
            _data['sssl'] = Number(fun.dwhs({
                zsl: _data['bqsl'] || 0,
                ps: _data['ps'] || 0,
                fk: _data['fk'] || '',
                kz: _data['kz'] || '',
                dw: _data['dw_mc'] || '',
                jjdw: _data['jjdw_mc'] || '',
                kc: parseFloat(_data['kc'] || 0),
                kcms: _data['kcms'] || '+',
                mx: sl_arr
            }) || _data['zsl'] || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
        }
    }
}


// 是否存在条码
function existTm(data) {
    for (var i = 0; i < data.length; i++) {
        // 20200313 条码排除已删除 && $.nui.isEmpty(data[i]['is_delete'])
        if ($.nui.isTrue(data[i]['tm'])) {
            return true;
        }
    }
    return false;
}


function __delRowMxValue(row, index) {
    var TMP_ROW_DATA = $.extend({}, ROW_DATA);
    var tmpMx = TMP_ROW_DATA['mx'] || [];
    tmpMx = tmpMx.slice(0);

    for (var i = 0; i < tmpMx.length; i++) {
        var val = tmpMx[i];
        if ($.nui.isTrue(val['is_delete'])) continue;
        if ((val['px'] == row['px']) && (val['ph'] == row['ph'])) {
            val['is_delete'] = 1;
            (typeof delMxData !== 'undefined') && delMxData.push(val);
            break;
        }
    }

    var zps = 0, zsl = 0;
    for (var i = 0; i < tmpMx.length; i++) {
        var val = tmpMx[i];
        if ($.nui.isTrue(val['is_delete'])) continue;
        if (((val['px'] == row['px']) && (val['ph'] > row['ph'])) || (val['px'] > row['px'])) {
            val['ph'] = get(val['ph'] - 1);
            if ($.nui.isEmpty(val['ph'])) {
                val['px'] = (val['px'] - 1);
                val['ph'] = get(10);
            }
        }
        zps = zps + 1;
        zsl = (zsl + val['sl']).fixed();
    }

    __setRowData(index, { ps: zps, zsl: zsl, mx: tmpMx.slice(0) }, { returnObjFromArr: false });

    if (typeof setPsAndSlDisabled === 'function') setPsAndSlDisabled();

    function get(ph) {
        if (ph <= 0) return 0;
        return ph;
    }
}

// 设置控件状态不可用
function __setDisable(value) {
    if (value) $('#kdsj,#remark,#wldw').attr('disabled', true);
    else $('#kdsj,#remark,#wldw').removeAttr('disabled');
    if (typeof setDisable === 'function') setDisable(value);
}

function __setGrid1ColunmDisable(row, index, data) {
    $('input').attr('disabled', true);
    // 如果当前记录行有明细数据, 匹数 不能修改
    if (__isEmptyMx(row['mx'])) {
        $('#ps').attr('disabled', true);
    } else {
        $('#ps').removeAttr('disabled');
    }

    // 如果当前记录行有明细数据, 匹数 不能修改
    if ((__isEmptyMx(row['mx']) || (parseInt(row['ps']) <= 1))) {
        $('#sl').attr('disabled', true);
    } else {
        $('#sl').removeAttr('disabled');
    }

    if (typeof setGridColunmDisable === 'function') setGridColunmDisable(row, index, data);
}


function getDykcParam(row) {
    if (row && $.nui.isTrue(row['ckd_dj_id'])) return false;

    var ck_id = 0;

    if (row && $.nui.isTrue(row['cp_id'])) {
        if ($.nui.isEmpty(row['ck_id'])) return fun.toast('请选择仓库！');
        if ($.nui.isEmpty(row['cp_ys_id'])) return fun.toast('请选择颜色！');
    }

    // 有开启【系统设置-多仓库模式】时认记录表的仓库
    if ($.nui.isTrue(SYS_CONFIG[Bills['config']['dckms']])) {
        ck_id = row['ck_id'];
    }

    var tm_arr = [];
    for (var i = 0; i < __JL_DATA.length; i++) {
        var jl_data = __JL_DATA[i];
        if ($.nui.isTrue(jl_data['is_delete'])) continue;
        if ($.nui.isTrue(jl_data['mx'])) {
            if ($.nui.isTrue(jl_data['tm'])) tm_arr.push(jl_data['tm']);
            for (var j = 0; j < jl_data['mx'].length; j++) {
                var mx_data = jl_data['mx'][j];
                if ($.nui.isTrue(mx_data['is_delete'])) continue;
                if ($.nui.isTrue(mx_data['tm'])) {
                    tm_arr.push(mx_data['tm']);
                }
            }
        }
    }

    return {
        ck_id: ck_id,
        tm_arr: tm_arr
    }
}

// 删除 没商品编号、匹数=0、数量=0 的记录行
// keys: 当数组里的某个key值为真, 则行不删除
function __delEmptyRow(options) {
    var tmp_exclude = Bills['del_row_exclude_col'] || [];
    var _opt = $.extend(true, { 'keys': tmp_exclude }, options);
    var rows = __JL_DATA.slice();
    for (var i = rows.length - 1; i >= 0; i--) {
        if ($.nui.isEmpty(rows[i]['cp_id']) || ($.nui.isEmpty(rows[i]['ps']) && $.nui.isEmpty(rows[i]['zsl']))) {
            var isDel = true;
            for (var j = 0; j < _opt['keys'].length; j++) {
                var key = _opt['keys'][j];
                if ($.nui.isTrue(rows[i][key])) {
                    isDel = false;
                    break;
                }
            }
            isDel && __JL_DATA.splice(i, 1);
        }
    }
}

// 删除单据
$('body').on('tap', '#del_btn', function (e) {
    e.stopPropagation();
    e.preventDefault();
    $('.collapse-more.collapse-wrap').removeClass('open');
    var dj = __PAGE_DATA['dj'];

    Bills['save_data'] = getSaveData();

    if (!$.nui.isObjEquals(Bills['origin_data'], Bills['save_data'])) {
        return fun.toast('单据已修改，未保存，不能删除！');
    }

    if ($.nui.isEmpty(dj['id'])) return console.log('无 dj_id');
    if (!Auth.check(Bills['auth'], 'delete')) return false;
    if (!Auth.qfmd({ 'key': 'delete', 'md_id': dj['md_id'] })) return false;
    if (!Auth.qfczy({ 'key': 'delete', 'zdr_id': dj['zdr_id'] })) return false;
    // if (State['is_deling']) return;
    // State['is_deling'] = 1;

    fun.dialog({
        content: '您确定要删除当前单据吗？',
        btn: ['删除', '取消'],
        yes: function () {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: Bills['AJAX_URL']['save'],
                data: {
                    status: 'delete',
                    scr_id: USER_INFO['id'],
                    dj_id: dj['id'],
                    __post_sign: Bills['__post_sign']
                },
                success: function (res) {
                    Bills['__post_sign'] = $.nui.getRandomNum();
                    // State['is_deling'] = 0;
                    switch (res['status']) {
                        case 0:
                            fun.toast('删除成功。');
                            closePage(true);
                            break;
                        case 'WDYJE_LESS_BCDY':
                            fun.toast('超出了订金，无法删除单据。');
                            break;
                        case 'IS_NOT_FIND':
                            fun.toast(res['msg']);
                            // fun.toast('单据已被其他操作人员删除，无法删除');
                            // api.sendEvent({
                            //     name: page_data['return_page'],
                            //     extra: {
                            //         'status': 'refresh',
                            //     }
                            // });
                            // fun.alert({msg:res['msg']}, function () {
                            //     closePage();
                            // });
                            break;
                        case 'IS_PAY':
                            fun.toast('请先取消线上支付。');
                            break;
                        default:
                            // if (res['status'] == 'IS_AUDIT') {
                            //     if (res['msg'] == '订金已审核，无法删除。') {
                            //         fun.toast('单据已被【' + (res['data'] && res['data']['shr_mc'] || '其他操作员') + '】复核，无法删除。');
                            //     } else {
                            //         fun.toast(res['msg']);
                            //     }
                            // } else {
                            //     fun.toast(res['msg']);
                            // }
                            fun.toast(res['msg']);
                            // fun.alert({msg: res['msg']}, function () {
                            //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) closePage();
                            // });
                            break;
                    }
                }
            });
        }
    });
    return false;
});

// 审核单据
$('body').on('tap', '#kd_audit', function (e) {
    $('.collapse-more.collapse-wrap').removeClass('open');
    var this_id = this.id;
    var dj = __PAGE_DATA['dj'];

    Bills['save_data'] = getSaveData();

    if (!$.nui.isObjEquals(Bills['origin_data'], Bills['save_data'])) {
        return fun.toast('单据已修改，未保存，不能审核！');
    }

    if ($.nui.isEmpty(dj['id'])) return console.log('无 dj_id');
    if (!Auth.check(Bills['auth'], 'check')) return false;
    if (!Auth.qfmd({ 'key': 'check', 'md_id': dj['md_id'] })) return false;
    if (!Auth.qfczy({ 'key': 'check', 'zdr_id': dj['zdr_id'] })) return false;
    // if (State['is_shing']) return;
    // State['is_shing'] = 1;

    fun.dialog({
        content: '您确定要审核当前单据吗？',
        btn: ['确定', '取消'],
        yes: function () {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                loadTitle: '审核中...',
                url: Bills['AJAX_URL']['save'],
                data: {
                    status: 'audit',
                    shr_id: USER_INFO['id'],
                    dj_id: dj['id'],
                    __post_sign: Bills['__post_sign']
                },
                success: function (res) {
                    // State['is_shing'] = 0;
                    Bills['__post_sign'] = $.nui.getRandomNum();
                    switch (res['status']) {
                        case 0:
                            fun.toast('审核成功！');
                            closePage();
                            break;
                        case 'IS_ZS_FKC':
                            var list = res['data']['list'][0];
                            var ps_display = list['bz_ps'] > 0;
                            var sl_display = list['bz_sl'] > 0;
                            var msg = [
                                list['cp_bh'] + list['cp_mc'] + '\r\n',
                                list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                                '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                                '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                            ].join('');
                            fun.toast(msg);
                            break;
                        case 'IS_TM_FKC':
                            var list = res['data']['list'][0];
                            fun.toast('条码' + list['tm'] + '和库存信息不一致');
                            break;
                        case 'IS_MX_FKC':
                            var list = res['data']['list'][0];
                            var msg = [
                                list['cp_bh'] + list['cp_mc'] + '\r\n',
                                list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                                '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                            ].join('');
                            fun.toast(msg);
                            break;
                        case 'DCK_LIST':
                            var list = res['dck_list'][0];
                            fun.toast('条码' + list['tm'] + '已被调用或已出库');
                            break;
                        case 'IS_NOT_FIND':
                            fun.toast(res['msg']);
                            // fun.alert({msg: res['msg']}, function () {
                            //     closePage();
                            // });
                            break;
                        case 'IS_PAY':
                            fun.toast('请先取消线上支付。');
                            break;
                        default:
                            fun.toast(res['msg']);
                            // fun.alert({msg: res['msg']}, function () {
                            //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) closePage();
                            // });
                            break;
                    }
                }
            });
        }
    });
});

// 取消审核
// TODO 功能未做
$('body').on('tap', '#kd_cancel_audit', function (e) {
    var dj = __PAGE_DATA['dj'];
    $('.collapse-more.collapse-wrap').removeClass('open');
    if ($.nui.isEmpty(dj['id'])) return console.log('无 dj_id');

    fun.dialog({
        content: '您确定要取消当前单据的审核状态吗？',
        btn: ['确定', '取消'],
        yes: function () {

        }
    });
});

// 作废单据
$('body').on('tap', '#kd_invalid', function (e) {
    $('.collapse-more.collapse-wrap').removeClass('open');
    var dj = __PAGE_DATA['dj'];
    if ($.nui.isEmpty(dj['id'])) return console.log('无 dj_id');
    if (!Auth.check(Bills['auth'], 'invalid')) return false;
    if (!Auth.qfmd({ 'key': 'invalid', 'md_id': dj['md_id'] })) return false;
    if (!Auth.qfczy({ 'key': 'invalid', 'zdr_id': dj['zdr_id'] })) return false;
    // if (State['is_zfing']) return;
    // State['is_zfing'] = 1;
    fun.dialog({
        content: '您确定要作废当前单据吗？',
        btn: ['重新做单', '直接作废', '取消'],
        yes: function (datas) {
            zfData(datas.index);
        },
        no: function (datas) {
            zfData(datas.index);
        }
    });

    function zfData(is_scxd) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            loadTitle: '作废中...',
            url: Bills['AJAX_URL']['save'],
            data: {
                status: 'cancel',
                zfr_id: USER_INFO['id'],
                dj_id: dj['id'],
                zf_yy: '', // 作废原因
                scxd: (is_scxd == 0) ? 1 : 0, // 生成新单
                __post_sign: Bills['__post_sign']
            },
            success: function (res) {
                // if(is_scxd == 0){
                //   if (res['status'] == 0) {
                //     fun.toast('作废成功！');
                //     closePage();
                //   }else{
                //     fun.toast(res['msg']);
                //   }
                // }else{
                // State['is_zfing'] = 0;
                Bills['__post_sign'] = $.nui.getRandomNum();
                switch (res['status']) {
                    case 0:
                        fun.toast('作废成功！');
                        if (is_scxd == 0) {
                            page_data['id'] = res['data']['dj_id'];
                        }
                        closePage();
                        break;
                    case 'IS_ZS_FKC':
                        var list = res['data']['list'][0];
                        var ps_display = list['bz_ps'] > 0;
                        var sl_display = list['bz_sl'] > 0;
                        var msg = [
                            list['cp_bh'] + list['cp_mc'] + '\r\n',
                            list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                            '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                            '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                        ].join('');
                        fun.toast(msg);
                        break;
                    case 'IS_TM_FKC':
                        var list = res['data']['list'];
                        var listInfo = {};
                        if ($.nui.isTrue(list)) listInfo = list[0];
                        var msg = '条码' + (listInfo['tm'] || '') + '和库存信息不一致';
                        fun.toast(msg);
                        break;
                    case 'IS_MX_FKC':
                        var list = res['data']['list'][0];
                        var msg = [
                            list['cp_bh'] + list['cp_mc'] + '\r\n',
                            list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                            '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                        ].join('');
                        fun.toast(msg);
                        break;
                    case 'DCK_LIST':
                        var list = res['dck_list'][0];
                        fun.toast('条码' + list['tm'] + '已被调用或已出库');
                        break;
                    case 'IS_JS':
                        fun.toast('单据已被结算过，无法作废。');
                        break;
                    case 'WDYJE_LESS_BCDY':
                        fun.toast('超出了订金，无法作废单据。');
                        break;
                    case 'IS_NOT_FIND':
                        fun.toast(res['msg']);
                        // fun.alert({msg:res['msg']}, function () {
                        //     closePage();
                        // });
                        break;
                    default:
                        fun.toast(res['msg']);
                        // fun.alert({msg: res['msg']}, function () {
                        //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) closePage();
                        // });
                        break;
                }
                // }
            }
        });
    }
});

// 结单
$('body').on('tap', '.btn-finish', function (e) {
    e.stopPropagation();
    $('.collapse-more.collapse-wrap').removeClass('open');
    var dj = __PAGE_DATA['dj'];

    Bills['save_data'] = getSaveData();

    // console.log(JSON.stringify(Bills['origin_data']))
    // console.log(JSON.stringify(Bills['save_data']))

    if (!$.nui.isObjEquals(Bills['origin_data'], Bills['save_data'])) {
        return fun.toast('单据已修改，未保存，不能结单！');
    }

    if ($.nui.isEmpty(dj['id'])) return console.log('无 dj_id');
    if (!Auth.check(Bills['auth'], 'settle')) return false;
    if (!Auth.qfmd({ 'key': 'settle', 'md_id': dj['md_id'] })) return false;
    if (!Auth.qfczy({ 'key': 'settle', 'zdr_id': dj['zdr_id'] })) return false;
    var loadText = $(this).text().trim();
    var isSave = false;

    var alert_msg = '';
    if (loadText == '结单') {
        alert_msg = '您确定要整张单据结单吗？';
    } else {
        alert_msg = '您确定要取消结单吗？';
    }

    var post_data = {
        status: 'finish',
        is_jd: (loadText == '结单' ? 1 : 0),
        jdr_id: USER_INFO['id'],
        dj_id: dj['id'],
        isSave: isSave,
        __post_sign: Bills['__post_sign']
    };

    fun.dialog({
        content: alert_msg,
        btn: ['确定', '取消'],
        yes: function () {
            _finish();
        }
    });


    function _finish() {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            loadTitle: loadText + '中...',
            url: Bills['AJAX_URL']['save'],
            data: post_data,
            success: function (res) {
                Bills['__post_sign'] = $.nui.getRandomNum();
                switch (res['status']) {
                    case 0:
                        fun.toast(loadText + '成功。');
                        api.sendEvent({
                            name: page_data['return_page'],
                            extra: {
                                'status': 'refresh',
                                'data': {}
                            }
                        });
                        api.sendEvent({
                            name: html_name,
                            extra: {
                                'status': 'refresh_dj',
                                'data': {}
                            }
                        });
                        break;
                    case 'IS_NOT_FINISH':
                        fun.jdts({
                            content: '部分产品还没发完货，你确定要结单吗？',
                            yes: function () {
                                fun.ajax({
                                    showLoad: true,
                                    hideLoad: true,
                                    loadTitle: loadText + '中...',
                                    url: Bills['AJAX_URL']['save'],
                                    data: $.extend(true, { 'notCheckFinish': 1 }, post_data),
                                    success: function (res) {
                                        Bills['__post_sign'] = $.nui.getRandomNum();
                                        switch (res['status']) {
                                            case 0:
                                                fun.toast(loadText + '成功。');
                                                api.sendEvent({
                                                    name: page_data['return_page'],
                                                    extra: {
                                                        'status': 'refresh',
                                                        'data': {}
                                                    }
                                                });
                                                api.sendEvent({
                                                    name: html_name,
                                                    extra: {
                                                        'status': 'refresh_dj',
                                                        'data': {}
                                                    }
                                                });
                                                break;
                                            default:
                                                fun.toast(res['msg']);
                                                break;
                                        }
                                    }
                                });
                            }
                        });
                        // Show.jdWin({
                        //     data: res.data,
                        //     save_url: Bills['AJAX_URL']['save'],
                        //     post_data: post_data
                        // });
                        break;
                    case 'IS_ZS_FKC':
                        var list = res['data']['list'][0];
                        var ps_display = list['bz_ps'] > 0;
                        var sl_display = list['bz_sl'] > 0;
                        var msg = [
                            list['cp_bh'] + list['cp_mc'] + '\r\n',
                            list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                            '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                            '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                        ].join('');
                        fun.toast(msg);
                        break;
                    case 'IS_TM_FKC':
                        var list = res['data']['list'][0];
                        fun.toast('条码' + list['tm'] + '和库存信息不一致');
                        break;
                    case 'IS_MX_FKC':
                        var list = res['data']['list'][0];
                        var msg = [
                            list['cp_bh'] + list['cp_mc'] + '\r\n',
                            list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                            '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                        ].join('');
                        fun.toast(msg);
                        break;
                    case 'DDJ_NOT_EMPTY':
                        // fun.dialog({
                        //     content: '<div style="text-align:left;padding-left: 30px;"><br>未抵用订金：' + res['data']['wdyje'] + ' <br>您确定要结单吗？</div>',
                        //     btn: ['确定结单', '取消'],
                        //     callback: function () {
                        //         post_data['isSave'] = true;
                        //         _finish();
                        //     }
                        // });
                        fun.jdts({
                            content: '<div style="text-align:left;margin-top: -0.5rem;">未抵用订金：' + res['data']['wdyje'] + ' <br>您确定要结单吗？</div>',
                            btn: ['确定结单', '取消'],
                            yes: function () {
                                post_data['isSave'] = true;
                                _finish();
                            },
                            // no: function(){
                            //     for (var key in tmpSaveObj) {
                            //         for (var j = 0; j < __JL_DATA.length; j++) {
                            //             if (key == __JL_DATA[j]['id']) {
                            //                 __JL_DATA[j]['is_jd'] = !__JL_DATA[j]['is_jd'] ? 1 : 0;
                            //                 __JL_DATA[j]['jdr_id'] = !__JL_DATA[j]['is_jd'] ? USER_INFO['id'] : 0;
                            //                 __JL_DATA[j]['jdr_mc'] = !__JL_DATA[j]['is_jd'] ? USER_INFO['name'] : '';
                            //                 __JL_DATA[j]['jd_sj'] = !__JL_DATA[j]['is_jd'] ? fun.formatDate(new Date()) : '';
                            //             }
                            //         }
                            //     }

                            //     showJlList(formatData(__JL_DATA));

                            //     JD_FROM_JL = false;
                            // }
                        });
                        break;
                    default:
                        if (['IS_DBAUDIT'].indexOf(res['status']) > -1) {
                            fun.toast(res['msg']);
                            api.sendEvent({
                                name: page_data['return_page'],
                                extra: {
                                    'status': 'refresh',
                                    'data': {}
                                }
                            });
                            api.sendEvent({
                                name: html_name,
                                extra: {
                                    'status': 'refresh_dj',
                                }
                            });
                        } else {
                            fun.toast(res['msg']);
                        }
                        // fun.alert({msg: res['msg']}, function () {
                        //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) closePage();
                        // });
                        break;
                }
            }
        });
    }
});

$('body').on('tap', '.btn-fh,#collapse-ffh', function (e) {
    e.stopPropagation();
    $('.collapse-more.collapse-wrap').removeClass('open');
    var dj = __PAGE_DATA['dj'];

    Bills['save_data'] = getSaveData();
    var loadText = $(this).text().trim();
    var alert_msg = '';
    if (loadText == '复核') {
        alert_msg = '您确定要复核吗？';
    } else {
        alert_msg = '您确定要反复核吗？';
    }

    if (!$.nui.isObjEquals(Bills['origin_data'], Bills['save_data'])) {
        return fun.toast('单据已修改，未保存，不能' + loadText + '！');
    }

    if ($.nui.isEmpty(dj['id'])) return console.log('无 dj_id');
    if (!Auth.check(Bills['auth'], 'recheck')) return false;
    if (!Auth.qfmd({ 'key': 'recheck', 'md_id': dj['md_id'] })) return false;
    if (!Auth.qfczy({ 'key': 'recheck', 'zdr_id': dj['zdr_id'] })) return false;

    var post_data = {
        status: 'dbaudit',
        is_fh: (loadText === '复核' ? 1 : 0),
        fhr_id: USER_INFO['id'],
        dj_id: dj['id'],
        __post_sign: Bills['__post_sign']
    };

    fun.dialog({
        content: alert_msg,
        btn: ['确定', '取消'],
        yes: function () {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                loadTitle: loadText + '中...',
                url: Bills['AJAX_URL']['save'],
                data: post_data,
                success: function (res) {
                    Bills['__post_sign'] = $.nui.getRandomNum();
                    switch (res['status']) {
                        case 0:
                            fun.toast(loadText + '成功。');
                            closePage();
                            break;
                        default:
                            fun.toast(res['msg']);
                            // fun.alert({msg: res['msg']}, function () {
                            //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) closePage();
                            // });
                            break;
                    }
                }
            });
        }
    });
});

//更新行数据数量相关
function updateRowDataAmountAndMoney(index, _data, options) {
    var data;
    if (index == undefined || index == null) {
        data = $.extend({}, _data);
    } else {
        data = __JL_DATA[index] || {};
    }

    if ($.nui.isEmpty(data)) {
        data = $.extend({}, _data);
    }

    var _opt = $.extend({ calcMoney: true, calcJjsl: true, calcSssl: false }, options);

    // 如果有选择产品 则需判断 单位、单位2、空差模式 是否有值, 没则需要赋值 档案的默认信息
    if ($.nui.isTrue(_data['cp_id'])) {
        var goods_list = fun.getItem('cp_list') || [];
        var goods_info = fun.getListInfoByKey(goods_list || [], _data['cp_id']);

        if ($.nui.isEmpty(_data['dw_id'])) {
            _data['dw_id'] = goods_info['unit_id'];
            _data['dw_mc'] = fun.getValByKey(fun.getItem('jjdw_list') || [], _data['dw_id']);
        }

        if ($.nui.isEmpty(_data['jjdw_id'])) {
            switch (Bills['wldw_type']) {
                case 'kh':
                    _data['jjdw_id'] = goods_info['unit_options'] ? goods_info['unit_options']['xsdw_id'] : 0;
                    break;
                case 'gys':
                    _data['jjdw_id'] = goods_info['unit_options'] ? goods_info['unit_options']['cgdw_id'] : 0;
                    break;
                case 'jgs':
                    _data['jjdw_id'] = goods_info['unit_options'] ? goods_info['unit_options']['jgdw_id'] : 0;
                    break;
            }
            _data['jjdw_mc'] = fun.getValByKey(fun.getItem('jjdw_list') || [], _data['jjdw_id']);

            if ($.nui.isEmpty(_data['jjdw_id'])) {
                _data['jjdw_id'] = _data['dw_id'];
                _data['jjdw_mc'] = _data['dw_mc'];
            }
        }

        // 有开启 一匹多单位 才需要赋值 dw2 信息
        if ($.nui.isTrue(SYS_CONFIG['ypbddwgl']) && $.nui.isEmpty(_data['dw2_id'])) {
            _data['dw2_id'] = goods_info['unit_id']['dw2_id'];
            _data['dw2_mc'] = fun.getValByKey(fun.getItem('jjdw_list') || [], _data['dw2_id']);
        }
        if ($.nui.isEmpty(_data['kcms'])) _data['kcms'] = (goods_info['diff'] || '+');
    }

    if (typeof setRowDataJjsl === 'function') {
        setRowDataJjsl(index, data, _opt, _data);

    } else {
        if (!_opt.calcJjsl) { // 不重新计算计价数量
            _data.no_calc_jjsl = 1;
        }
        __setRowDataJjsl(index, data, _opt, _data);
    }

    // updateRowDataMoney(index, _data, _opt, data);

    // 结算金额
    if ($.nui.isTrue(_opt['calcMoney'])) {
        _data['dj'] = parseFloat(_data['dj'] || 0);
        _data['hsdj'] = parseFloat(_data['hsdj'] || 0);
        if (typeof data['hsdj'] !== "undefined") {
            _data['dj'] = (_data['hsdj'] / (1 + (parseFloat(_data['shuilv'] || 0)) / 100.00)).fixed();
        } else {
            _data['hsdj'] = (_data['dj'] * (1 + (parseFloat(_data['shuilv'] || 0)) / 100.00)).fixed();
        }

        _data['je'] = (_data['dj'] * (_data['jjsl'] || 0)).fixed();
        _data['zydj'] = ($.nui.isEmpty(_data['zsl'])) ? 0 : (_data['je'] / parseFloat(_data['zsl'])).fixed();

        _data['hsje'] = ((_data['hsdj'] || 0) * (_data['jjsl'] || 0)).fixed();
        _data['shuie'] = ((_data['hsje'] || 0) - (_data['je'] || 0)).fixed();

        _data['zje'] = _data['je'];
        _data['hszje'] = _data['hsje'];
        for (var i = 1; i <= 5; i++) {
            // 自定义费用
            _data['zje'] += parseFloat(_data['fy_zdy' + i] || 0);
            _data['hszje'] += parseFloat(_data['fy_zdy' + i] || 0);
        }
        _data['zje'] = __jeSswr(_data['zje']);
        _data['hszje'] = __jeSswr(_data['hszje']);
    }   

    if (_opt.calcSssl) { // 是否重新计算实售数量
        _opt.upDateSssl = true;
    }   

    if (typeof setRowData === 'function') setRowData(index, data, _opt, _data);
}

//更新行数据金额相关
function updateRowDataMoney(index, data, options, _data) {
    var _opt = $.extend({ refreshHsdj: false, calcMoney: true }, options);

    // if ($.nui.isEmpty(_data)) {
    //     if (index == undefined || index == null) {
    //         _data = $.extend({}, data);
    //     } else {
    //         _data = __JL_DATA[index];
    //         _data = $.extend({}, _data, data);
    //     }
    // }

    _data = $.extend({}, _data, data);

    // 结算金额
    if ($.nui.isTrue(_opt['calcMoney'])) {
        _data['dj'] = parseFloat(_data['dj'] || 0);
        _data['hsdj'] = parseFloat(_data['hsdj'] || 0);

        if (typeof data['hsdj'] !== "undefined") {
            _data['dj'] = (_data['hsdj'] / (1 + (parseFloat(_data['shuilv'] || 0)) / 100.00)).fixed();
        } else {
            _data['hsdj'] = (_data['dj'] * (1 + (parseFloat(_data['shuilv'] || 0)) / 100.00)).fixed();
        }

        _data['je'] = (_data['dj'] * (_data['jjsl'] || 0)).fixed();
        _data['zydj'] = ($.nui.isEmpty(_data['zsl'])) ? 0 : (_data['je'] / parseFloat(_data['zsl'])).fixed();

        _data['hsje'] = ((_data['hsdj'] || 0) * (_data['jjsl'] || 0)).fixed();
        _data['shuie'] = ((_data['hsje'] || 0) - (_data['je'] || 0)).fixed();

        _data['zje'] = _data['je'];
        _data['hszje'] = _data['hsje'];
        for (var i = 1; i <= 5; i++) {
            // 自定义费用
            _data['zje'] += parseFloat(_data['fy_zdy' + i] || 0);
            _data['hszje'] += parseFloat(_data['fy_zdy' + i] || 0);
        }
        _data['zje'] = __jeSswr(_data['zje']);
        _data['hszje'] = __jeSswr(_data['hszje']);
    }

    if (typeof setRowData === 'function') setRowData(index, data, _opt, _data);
    return _data;
}


/**
 * 设置产品单位
 * @param _data 记录数据
 * @param goods_info 产品信息
 */
function setGoodsUnit(_data, goods_info, type) {
    type = type || 'dw';
    if ($.nui.isEmpty(_data['jjdw_id'])) {

        switch (Bills['wldw_type']) {
            case 'kh':
                _data['jjdw_id'] = goods_info['unit_options'] ? goods_info['unit_options']['xsdw_id'] : 0;
                break;
            case 'gys':
                _data['jjdw_id'] = goods_info['unit_options'] ? goods_info['unit_options']['cgdw_id'] : 0;
                break;
            case 'jgs':
                _data['jjdw_id'] = goods_info['unit_options'] ? goods_info['unit_options']['jgdw_id'] : 0;
                break;
        }
        _data['jjdw_mc'] = fun.getValByKey(fun.getItem('jjdw_list') || [], _data['jjdw_id']);

        if ($.nui.isEmpty(_data['jjdw_id'])) {
            if (type == 'dw') {
                _data['jjdw_id'] = _data['dw_id'];
                _data['jjdw_mc'] = _data['dw_mc'];
            } else {
                _data['jjdw_id'] = goods_info['unit_id'];
                _data['jjdw_mc'] = goods_info['unit_name'];
            }
        }
    }
}

// 色号为色卡，切换仓库 重置单位
function __resetUnit(_data) {
    // 如果有选择产品 则需判断 单位、单位2、空差模式 是否有值, 没则需要赋值 档案的默认信息
    if ($.nui.isTrue(_data['cp_id'])) {
        var goods_list = fun.getItem('cp_list') || [];
        var goods_info = fun.getListInfoByKey(goods_list || [], _data['cp_id']);

        if ($.nui.isEmpty(_data['dw_id'])) {
            _data['dw_id'] = goods_info['unit_id'];
            _data['dw_mc'] = fun.getValByKey(fun.getItem('jjdw_list') || [], _data['dw_id']);
        }

        setGoodsUnit(_data, goods_info);

        // 有开启 一匹多单位 才需要赋值 dw2 信息
        if ($.nui.isTrue(SYS_CONFIG['ypbddwgl']) && $.nui.isEmpty(_data['dw2_id'])) {
            _data['dw2_id'] = goods_info['unit_options'] ? Number(goods_info['unit_options']['dw2_id']) : 0;
            _data['dw2_mc'] = fun.getValByKey(fun.getItem('jjdw_list') || [], _data['dw2_id']);
        }

        if ($.nui.isEmpty(_data['kcms'])) _data['kcms'] = (goods_info['diff'] || '+');

        switch (_data['jg_lx']) {
            case 'jy':
                _data['jg_lx_mc'] = '剪样';
                break;
            case 'yb':
                _data['jg_lx_mc'] = '样版';
                break;
            case 'sk':
                _data['jg_lx_mc'] = '色卡';
                break;
        }

        // 如果记录行 类型 为空则默认赋值 大货
        if ($.nui.isEmpty(_data['jg_lx']) || ($.nui.isTrue(_data['jg_lx']) && _data['jg_lx'] != 'dh')) {
            _data['jg_lx_mc'] = '大货';
            _data['jg_lx'] = 'dh';
        }
    }
}

// 设置货期天数
function __setHqts(row, value, index) {
    if (!value) value = 0;
    var kdsj = fun.formatDate($('#kdsj').text().trim() || new Date());
    var date = '';
    if ($.nui.isTrue(kdsj)) date = $.nui.dayjs(kdsj).add(value, 'day').format('YYYY-MM-DD');

    row['hqts'] = parseInt(value || 0);
    row['hq'] = date;
}

fun.getDaysBetween = function (startDate, endDate) {
    var start_date = new Date(fun.formatDate(startDate, 'YYYY/MM/DD')).getTime();
    var end_date = new Date(fun.formatDate(endDate, 'YYYY/MM/DD')).getTime();
    // var start_date = Date.parse(startDate);
    // var end_date = Date.parse(endDate);
    if (start_date < end_date) return 0;

    var days = Math.round(Math.abs(start_date - end_date) / (24 * 60 * 60 * 1000));
    if (!days) days = 0;
    return days;
}