var html_name = page_arr.contacter_search;
var wldw_type_mc = '';
var search_data = {};
var merchant_name;
var merchant_id;

page_init = function () {

    switch (page_data['page_type']) {
        case 'kh':
            wldw_type_mc = '客户';
            break;
        case 'gys':
            wldw_type_mc = '供应商';
            break;
        case 'jgs':
            wldw_type_mc = '加工商';
            break;
        case 'wl':
            wldw_type_mc = '物流';
            break;
    }

    //获取选择客户页面传过来的值
    if (!!page_data['wldw']) {
        merchant_name = page_data['wldw']['merchant_name']
        merchant_id = page_data['wldw']['id']
    }
    $('#header').header({
        back: true,
        edit: Auth.check(page_data['page_type'], 'edit'),
        title: merchant_name || page_data['wldw_mc'] || '客户',
        foot_input: {
            show: true,
            yuyin_icon: false,
            plader: '搜索'
        },
        appendBackBtnEvt: function () {
            // if (page_data['djlx'] === 'fans') {
            //     api.closeToWin({
            //         name: page_arr.shop_fans
            //     });
            // } else {
            api.closeWin();
            //}

        }
    });

    getList();

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'refresh':
                $('#list').empty();
                getList();
                break;
        }
    });

    fun.orderListHeight({ dom: '#list' });
};


function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getContactList,
        data: {
            "merchant_id": merchant_id || page_data['wldw_id'] || 0,
            "keyword": '',
            "keyword_key": ['name', 'simple', 'mobile'],
            "filter": page_data['bind_lxr_id'] || [],
        },
        success: function (res) {
            if (res['status'] == 0) {
                if (res['data'].length == 0) {
                    // $('.content').css({'height': 'calc(100% - 6.7rem)', 'position': 'fixed'});
                    // return $('#list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: '#list', btnShow: false, style: 'top:0;height:9rem;' });
                } else {
                    // $('.content').css({'height': 'auto', 'position': 'relative'});
                }
                showList(res.data);
            } else {
                fun.alert({ msg: '网络异常！' });
            }

        }
    });
}

function showList(data) {
    var listHtml = [];
    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        listHtml.push('<li data-list_data=\'' + fun.formatString(JSON.stringify(val)) + '\' class="account-list lower-border-line">');
        listHtml.push('<div class="list">');
        listHtml.push('<span class="name">' + (val['name'] || '') + '</span>');
        listHtml.push('</div>');
        // if (!($.nui.isEmpty(val['mobile']) && $.nui.isEmpty(val['position']))) {
        listHtml.push('<div class="column column2">');
        listHtml.push('<div class="left">');
        listHtml.push('<span class="number">' + (val['mobile'] || '') + '</span>');
        listHtml.push('</div>');
        listHtml.push('<div class="right">');
        listHtml.push('<span class="arrears">' + (val['position'] || '') + '</span>');
        listHtml.push('</div>');
        listHtml.push('</div>');
        // }

        listHtml.push('</li>');
    }
    $('#list').html(listHtml.join(''));
}


function sendBackData() {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'select_list',
            'data': {
                'id': 0,
                'page_type': 'xz_lxr',
                'list_data': {},
                'select_val': $('#foot_search').val().trim()
            }
        }
    });
    setTimeout(function () {
        api.closeWin();
    }, 200)
}


$('body').on('tap', '#edit_btn', function (e) {
    e.stopPropagation();

    fun.showPageFull({
        page_url: page_arr.custom_add,
        pageParam: {
            return_page: html_name,
            title: wldw_type_mc,
            type: page_data['page_type'],
            id: merchant_id || page_data['wldw_id'],
            opt: 'edit',
            tab: 'lx'
        }
    });
});

// 搜索框搜索
$('body').on('search', '#foot_search', function () {
    search_data['keyword'] = $(this).val();
    getList();
});
// 搜索图标搜索
$('body').on('tap', '#search_icon', function () {
    search_data['keyword'] = $('#foot_search').val();
    getList();
});
$('body').on('tap', '.account-list', function (e) {
    e.stopPropagation();
    var list_data = $(this).data('list_data');
    if (page_data['djlx'] == "fans" || page_data['djlx'] == "shop") {
        //2020-05-02 ai商城重构改动（绑定粉丝）
        $.ajax({
            type: 'PUT',
            url: AJAX_URL.automatic + '/' + Number(list_data['id']) +'?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
            headers: {
                "X-Requested-With": "XMLHttpRequest",
                "Accept": "application/json"
            },
            data:{
                "company_id": fun.getItem('company_info')['company_id'],
                "user_id": page_data['user_id']   //用户id
            },
            success: function (res) {
                fun.toast('绑定成功')
                setTimeout(function () {
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'bd_fans',
                            'kh_lxr_id': res['yby_id'],
                            'kh_lxr': res['name'],
                            'kh_id': res['customer']['yby_id'],
                            'kh_mc': res['customer']['name'],
                            'kh_phone': res['customer']['phone'],
                            'kh': res['customer']
                        }
                    })
                    fun.closeToWin(page_data['return_page']);
                }, 200)
            }
        })


        // fun.ajax({
        //     showLoad: true,
        //     hideLoad: true,
        //     url: AJAX_URL.saveConnectInfo,
        //     data: {
        //         'id': page_data['bdfans_id'] || 0,
        //         'book_id': Number(fun.getItem('book_info')['id']) || 0,
        //         'kh_id': Number(page_data['wldw']['id']) || 0,
        //         'kh_mc': page_data['wldw']['merchant_name'] || '',
        //         'kh_lxr_id': Number(list_data['id']) || 0,
        //         'kh_lxr': list_data['name'] || '',
        //         'kh_phone': list_data['mobile'] || '',
        //         'kh_lb_id': Number(page_data['wldw']['class_id']) || 0,
        //         'member_id': page_data['member_id'] || 0,
        //         'is_stop': page_data['wldw']['is_stop'] || 0,
        //     },
        //     success: function (res) {
        //         switch (res.status) {
        //             case 0:
        //                 fun.ajax({
        //                     showLoad: true,
        //                     hideLoad: true,
        //                     url: AJAX_URL.upShopIsHas,
        //                     data: {
        //                         new_kh_id: page_data['wldw']['id'] || 0,
        //                         old_kh_id: res['old_kh_id'] || 0,//page_data['old_bdkh_id']
        //                     },
        //                     success: function (res_two) {
        //                         if (res_two['status'] === 0) {
        //                             fun.toast('绑定成功')
        //                             setTimeout(function () {
        //                                 api.sendEvent({
        //                                     name: page_data['return_page'],
        //                                     extra: {
        //                                         'status': 'bd_fans',
        //                                         'data': {
        //                                             'id': page_data['bdfans_id'] || 0,
        //                                             'book_id': Number(fun.getItem('book_info')['id']) || 0,
        //                                             'kh_id': Number(page_data['wldw']['id']) || 0,
        //                                             'kh_mc': page_data['wldw']['merchant_name'] || '',
        //                                             'kh_lxr_id': Number(list_data['id']) || 0,
        //                                             'kh_lxr': list_data['name'] || '',
        //                                             'kh_phone': list_data['mobile'] || '',
        //                                             'kh_lb_id': Number(page_data['wldw']['class_id']) || 0,
        //                                             'member_id': page_data['member_id'] || 0,
        //                                         }
        //                                     }
        //                                 })
        //                                 fun.closeToWin(page_data['return_page']);
        //                             }, 200)
        //                         }
        //                     }
        //                 })
        //                 break;
        //             case 101:
        //                 fun.toast('【' + list_data['name'] + '】已绑定粉丝')
        //                 break;
        //             // case :   
        //             //     fun.toast('所选联系人不存在，请重新选择。')
        //             //     break;        
        //         }
        //     }
        // })


    } else {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'select_list',
                'data': {
                    'id': list_data['id'],
                    'page_type': 'xz_lxr',
                    'list_data': list_data,
                    'select_val': list_data['name']
                }
            }
        });
        setTimeout(function () {
            api.closeWin();
        }, 200)
    }

});

// var html_name = page_arr.contacter_search;
// var type = '';//搜索类型
// var merchant_list = [];//保存要查询的数据
// var page_title = '';//页面标题
//
// $('#header').header({
//     back: true,
//     edit: true,
//     title: 'XXX',
//     foot_input: {
//         show: true,
//         yuyin_icon: false,
//         plader: '搜索'
//     },
// });
//
// page_init = function () {
//     page_data['merchant_type'] = 'custom';
//     page_data['merchant_name'] = '客户aaa';
//     page_title = page_data['merchant_name'];
//     fun.showLoad();//加载数据
//     switch (page_data['merchant_type']) {
//         case 'custom':
//             type = 'kh';
//             break;
//         case 'supplier':
//             type = 'gys';
//             break;
//         case 'processor':
//             type = 'jgs';
//             break;
//         case 'logistics':
//             type = 'wl';
//             break;
//     }
//
//     //数据请求
//     // fun.ajax({
//     //   url:AJAX_URL.getMerchantList,
//     //   data:{
//     //     "type": type,
//     //     "is_stop": 0,
//     //     "merchant_name":merchant_name,
//     //   },
//     //   callback:function(res){
//     //      if (res.status != 0) return Public.alert({ msg: JSON.stringify(res) });
//     //      merchant_list.push(res['data']);
//     //   }
//     // });
//
//     //隐藏修改按钮,判断权限
//     $("#foot_search").select();
//     $("#header_title").text(page_title || '');
//     switch (type) {
//         case 'kh':
//             merchant_list.push({
//                     "id": 20,
//                     "date": "2018-12-17 15:00:00",
//                     "merchant_name": "客户aaa",
//                     "number": "007",
//                     "type": "kh",
//                     "goods_type": "布匹",
//                     "initial_balance": 0,
//                     "balance": -480.06,
//                     "audit_balance": 20,
//                     "credit": 0,
//                     "xygk": 0,
//                     "class_id": 0,
//                     "store_id": 0,
//                     "staff_id": 0,
//                     "label_id": "",
//                     "usable": 480.06,
//                     "class_name": null,
//                     "store_name": null,
//                     "staff_name": null,
//                     "section_name": null,
//                     "salesman": 0,
//                     "remark": "14215",
//                     "pay_method": null,
//                     "simple": "khaaa",
//                     "price_model": null,
//                     "is_has": 54,
//                     "is_stop": 0,
//                     "is_minus": 0,
//                     "is_bills": 0,
//                     "is_batch": 0,
//                     "is_default": 1,
//                     "is_multi": 0,
//                     "contact_name": "梁思成",
//                     "contact_simple": "lsc",
//                     "position": "",
//                     "mobile": "1987865653",
//                     "phone": "",
//                     "fax": "",
//                     "province": "",
//                     "city": "",
//                     "area": "",
//                     "address": "",
//                     "contact_remark": "",
//                     "bank_name": null,
//                     "card_number": null,
//                     "imgs": "",
//                     "sex": "男",
//                     "birthday": "",
//                     "people": null,
//                     "bank_remark": null,
//                     "bills_data": "{\"name\":\"\",\"number\":\"\",\"address\":\"\",\"bank\":\"\",\"account\":\"\",\"phone\":\"\"}",
//                     "bills_name": "",
//                     "bills_number": "",
//                     "bills_address": "",
//                     "bills_bank": "",
//                     "bills_account": "",
//                     "bills_phone": "",
//                     "birthday_day": null,
//                     "is_gz": 0
//                 },
//                 {
//                     "id": 20,
//                     "date": "2018-12-17 15:00:00",
//                     "merchant_name": "客户aaa",
//                     "number": "007",
//                     "type": "kh",
//                     "goods_type": "布匹",
//                     "initial_balance": 0,
//                     "balance": -480.06,
//                     "audit_balance": 20,
//                     "credit": 0,
//                     "xygk": 0,
//                     "class_id": 0,
//                     "store_id": 0,
//                     "staff_id": 0,
//                     "label_id": "",
//                     "usable": 480.06,
//                     "class_name": null,
//                     "store_name": null,
//                     "staff_name": null,
//                     "section_name": null,
//                     "salesman": 0,
//                     "remark": "14215",
//                     "pay_method": null,
//                     "simple": "khaaa",
//                     "price_model": null,
//                     "is_has": 54,
//                     "is_stop": 0,
//                     "is_minus": 0,
//                     "is_bills": 0,
//                     "is_batch": 0,
//                     "is_default": 1,
//                     "is_multi": 0,
//                     "contact_name": "曹志邦",
//                     "contact_simple": "czb",
//                     "position": "后端",
//                     "mobile": "13245612311",
//                     "phone": "06632812345",
//                     "fax": "0231657",
//                     "province": "",
//                     "city": "",
//                     "area": "",
//                     "address": "",
//                     "contact_remark": "1111",
//                     "bank_name": null,
//                     "card_number": null,
//                     "imgs": "",
//                     "sex": "男",
//                     "birthday": "",
//                     "people": null,
//                     "bank_remark": null,
//                     "bills_data": "{\"name\":\"\",\"number\":\"\",\"address\":\"\",\"bank\":\"\",\"account\":\"\",\"phone\":\"\"}",
//                     "bills_name": "",
//                     "bills_number": "",
//                     "bills_address": "",
//                     "bills_bank": "",
//                     "bills_account": "",
//                     "bills_phone": "",
//                     "birthday_day": null,
//                     "is_gz": 0
//                 });
//             break;
//         case 'gys':
//             merchant_list.push({
//                 "id": 12,
//                 "date": "2018-12-11 21:22:00",
//                 "merchant_name": "供应商9",
//                 "number": "004",
//                 "type": "gys",
//                 "goods_type": "布匹",
//                 "initial_balance": 0,
//                 "balance": 154.6,
//                 "audit_balance": 33,
//                 "credit": 0,
//                 "xygk": 0,
//                 "class_id": 16,
//                 "store_id": 0,
//                 "staff_id": 0,
//                 "label_id": "",
//                 "usable": -154.6,
//                 "class_name": "供A",
//                 "store_name": null,
//                 "staff_name": null,
//                 "section_name": null,
//                 "salesman": 0,
//                 "remark": "",
//                 "pay_method": null,
//                 "simple": "gys9",
//                 "price_model": null,
//                 "is_has": 59,
//                 "is_stop": 0,
//                 "is_minus": 0,
//                 "is_bills": 0,
//                 "is_batch": 0,
//                 "is_default": 0,
//                 "is_multi": 0,
//                 "contact_name": "天下无疆",
//                 "contact_simple": null,
//                 "position": null,
//                 "mobile": 19878654578,
//                 "phone": null,
//                 "fax": null,
//                 "province": null,
//                 "city": null,
//                 "area": null,
//                 "address": null,
//                 "contact_remark": null,
//                 "bank_name": null,
//                 "card_number": null,
//                 "imgs": "",
//                 "sex": null,
//                 "birthday": null,
//                 "people": null,
//                 "bank_remark": null,
//                 "bills_data": "{\"name\":\"\",\"number\":\"\",\"address\":\"\",\"bank\":\"\",\"account\":\"\",\"phone\":\"\"}",
//                 "bills_name": "",
//                 "bills_number": "",
//                 "bills_address": "",
//                 "bills_bank": "",
//                 "bills_account": "",
//                 "bills_phone": "",
//                 "birthday_day": ""
//             });
//             break;
//         case 'jgs':
//             merchant_list.push({
//                 "id": 1,
//                 "date": "2018-12-08 10:19:00",
//                 "merchant_name": "南园印染厂",
//                 "number": "001",
//                 "type": "jgs",
//                 "goods_type": "布匹",
//                 "initial_balance": 0,
//                 "balance": 1315.5,
//                 "audit_balance": 185.5,
//                 "credit": 0,
//                 "xygk": 0,
//                 "class_id": 2,
//                 "store_id": 0,
//                 "staff_id": 0,
//                 "label_id": "",
//                 "usable": -1315.5,
//                 "class_name": "普宁",
//                 "store_name": null,
//                 "staff_name": null,
//                 "section_name": null,
//                 "salesman": 0,
//                 "remark": "",
//                 "pay_method": null,
//                 "simple": "nyyrc",
//                 "price_model": null,
//                 "is_has": 114,
//                 "is_stop": 0,
//                 "is_minus": 0,
//                 "is_bills": 0,
//                 "is_batch": 0,
//                 "is_default": 0,
//                 "is_multi": 0,
//                 "contact_name": "A",
//                 "contact_simple": "A",
//                 "position": "管理",
//                 "mobile": "110",
//                 "phone": "120",
//                 "fax": "114",
//                 "province": "",
//                 "city": "",
//                 "area": "",
//                 "address": "",
//                 "contact_remark": "",
//                 "bank_name": null,
//                 "card_number": null,
//                 "imgs": "",
//                 "sex": "女",
//                 "birthday": "2018-12-24",
//                 "people": null,
//                 "bank_remark": null,
//                 "bills_data": "{\"name\":\"\",\"number\":\"\",\"address\":\"\",\"bank\":\"\",\"account\":\"\",\"phone\":\"\"}",
//                 "bills_name": "",
//                 "bills_number": "",
//                 "bills_address": "",
//                 "bills_bank": "",
//                 "bills_account": "",
//                 "bills_phone": "",
//                 "birthday_day": "354"
//             });
//             break;
//         case 'wl':
//             merchant_list.push({
//                 "id": 9,
//                 "date": "2018-12-11 11:31:00",
//                 "merchant_name": "W1",
//                 "number": "001",
//                 "type": "wl",
//                 "goods_type": "纱线",
//                 "initial_balance": 0,
//                 "balance": 110,
//                 "audit_balance": 90,
//                 "credit": 0,
//                 "xygk": 0,
//                 "class_id": 14,
//                 "store_id": 0,
//                 "staff_id": 0,
//                 "label_id": "",
//                 "usable": -110,
//                 "class_name": "L1",
//                 "store_name": null,
//                 "staff_name": null,
//                 "section_name": null,
//                 "salesman": 0,
//                 "remark": "",
//                 "pay_method": null,
//                 "simple": "W1",
//                 "price_model": null,
//                 "is_has": 5,
//                 "is_stop": 0,
//                 "is_minus": 0,
//                 "is_bills": 0,
//                 "is_batch": 0,
//                 "is_default": 0,
//                 "is_multi": 0,
//                 "contact_name": "曹志邦",
//                 "contact_simple": null,
//                 "position": null,
//                 "mobile": 13245612311,
//                 "phone": null,
//                 "fax": null,
//                 "province": null,
//                 "city": null,
//                 "area": null,
//                 "address": null,
//                 "contact_remark": null,
//                 "bank_name": null,
//                 "card_number": null,
//                 "imgs": "",
//                 "sex": null,
//                 "birthday": null,
//                 "people": null,
//                 "bank_remark": null,
//                 "bills_data": null,
//                 "bills_name": null,
//                 "bills_number": null,
//                 "bills_address": null,
//                 "bills_bank": null,
//                 "bills_account": null,
//                 "bills_phone": null,
//                 "birthday_day": ""
//             });
//             break;
//     }
//     loadList(merchant_list);
//     fun.hideLoad();
// }
//
// //显示数据列表
// function loadList(obj) {
//     var listHtml = [];
//     for (var i = 0; i < obj.length; i++) {
//         listHtml.push('<li class="account-list lower-border-line" value="' + (obj[i]['merchant_name'] || '') + '">');
//         listHtml.push('<div class="list">');
//         listHtml.push('<span class="name">' + (obj[i]['contact_name'] || '') + '</span>');
//         listHtml.push('</div>');
//         listHtml.push('<div class="column column2">');
//         listHtml.push('<div class="left">');
//         listHtml.push('<span class="number">' + (obj[i]['mobile'] || '') + '</span>');
//         listHtml.push('</div>');
//         listHtml.push('<div class="right">');
//         listHtml.push('<span class="arrears">' + (obj[i]['position'] || '') + '</span>');
//         listHtml.push('</div>');
//         listHtml.push('</div>');
//         listHtml.push('</li>');
//     }
//     $('#list').html(listHtml.join(''));
// }
//
// $("#foot_search").on("input", function () {
//     var value = $(this).val();
//     var merchant_lists;
//     var exp = /^[\x00-\xff]/;
//     if (exp.test(value)) {
//         merchant_lists = simpleFilter(value, merchant_list);
//     } else {
//         merchant_lists = nameFilter(value, merchant_list);
//     }
//     loadList(merchant_lists);
//     $(".list .name").each(function () {
//         var str = $(this).text();
//         if (str.indexOf(value) !== -1) {
//             var index = str.indexOf(value);
//             var strs = '';
//             for (var i = 0; i < str.length; i++) {
//                 if (i == index && !!value) {
//                     strs = strs + "<em style='color:red;'>" + str[i] + "</em>";
//                 } else {
//                     strs = strs + str[i];
//                 }
//             }
//             $(this).html(strs);
//         }
//     });
//     // $('.list .name').css('color','red');
// });
//
// //关键字筛选
// function nameFilter(param, arr) {
//     return arr.filter(function (ele, index) {
//         return ele.contact_name.indexOf(param) != -1 ? true : false;
//     });
// }
//
// //简码筛选
// function simpleFilter(param, arr) {
//     return arr.filter(function (ele, index) {
//         return ele.contact_simple.indexOf(param) != -1 ? true : false;
//     });
// }
