var html_name = page_arr.cost_type,
    // numbers,//数据编号
    page_type;//页面类型
var all = [],
    edits = {},
    return_data = [];//数据
var upDate = { del_id: [], up: [] };

function updatePrevPage() {
    var pageType = page_data['page_type'];
    upDate['page_type'] = pageType;
    switch (pageType) {
        default:
            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    status: 'update',
                    data: upDate,
                }
            });
            break;
    }
    api.closeWin();
}

page_init = function () {
    var title = "";
    switch (page_data.obj) {
        case 'cost':
            title = "费用类型";
            page_type = "fylx";
            break;
        case 'income':
            title = "收入类型";
            page_type = "srlx";
            break;
    }
    $('#header').header({
        back: true,
        title: title,
        add: Auth.check(page_type, 'edit'),
        appendBackBtnEvt: updatePrevPage
    });
    // var equipment = navigator.userAgent;
    // if(equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1){
    //     $('.content').css('top',$('#header').outerHeight()+30);
    //   }

    if (!Auth.check(page_type, 'edit')) {
        $('.swipe-delete').removeClass('swipe-delete');
        $('.icon-tianjia').attr('disabled', true);
        $('.icon-tianjia').hide();
    }
    getData(page_type);

    fun.orderListHeight({dom:'.content'});

    if(page_data.type == "add"){
        if ($('#add_btn').attr('disabled')) return;
        layer.closeAll();
        var _this = $('#add_btn');
        addData({
            "state": "add",
            "obj": _this,
            "type": page_type,
            "stype": 0
        });
    }
}

function addData(param) {
    var list_id, placeholder;
    var obj = $(param['obj']).parent().parent(),//获得对象
        pt = $(obj).attr('ptype') || 0,
        stype = $(obj).attr('stype') || param['stype'],
        type = $(obj).attr('type') || param['type'];

    if ($(param['obj']).hasClass("icon-jia") || $(param['obj']).hasClass("icon-tianjia")) {
        placeholder = '新增类型';
        list_id = 0;
        if (!!page_data) getNumber(type, stype);
        edits['parent_id'] = stype;
    } else if ($(param['obj']).hasClass("edit-btn")) {
        placeholder = '修改类型';
        list_id = $(obj).attr('id');
        edits['parent_id'] = edits['parent_id'];
    }
    if (param['state'] == 'edit') {
        getInfo({
            'id': $(obj).attr('id'),
            'type': type,
            'status': 'edit'
        });
    }
    var style = [
        '<div style="display:inline-block;width:100%;height:6rem;" >',
        '   <span class="title">' + placeholder + '</span>',
        '   <input type="text" class="input-box" name="type" id="type" style="color: #333;"/></li>',
        '</div>'
    ].join('');
    fun.dialog({
        content: style,
        btn: ['保存', '取消'],
        isClose: false,
        success: function () {
            setTimeout(function () {
                $('#type').select();
            }, 300);
        },
        yes: function () {
            var name = $("#type").val().trim();
            params_data = {
                "id": list_id,
                "name": name,
                "parent_id": edits['parent_id'],
                "save_type": "save",
                "type": edits['type'] || type,
                "number": edits['number'] || page_data['numbers'] || '',
                "remark": edits['remark'] || "",
                "is_stop": 0
            };

            switch (param['state']) {
                case 'add':
                    if (!$('#type').val().trim()) {
                        return fun.toast('请输入类型！');
                    } else if (typeExist(param['obj'], name)) {
                        return fun.toast("【" + name + "】类型已存在！");
                    } else {
                        saveData(params_data);
                        layer.closeAll();
                    }
                    layer.closeAll();
                    break;
                case 'edit':
                    var names = edits['name'],
                        typess = $("#type").val();
                    if (!typess) {
                        return fun.toast('请输入类型！');
                    } else {
                          upDate['up'].push({
                            "id": params_data['id'] || 0,
                            "name": params_data['name'] || ""
                          });
                        params_data['name'] = filter(params_data['name']);
                        $("[name='" + names + "']").find('.color-number').text(params_data['name']);
                        $("[name='" + names + "']").attr('name', params_data['name']);
                        saveData(params_data);
                        layer.closeAll();
                    }
                    break;
            }

            // switch (state) {
            //     case 'add':
            //         if (!$("[name='" + name + "']").attr('stype')) {
            //             if (!$('.input-box').val()) {
            //                 fun.toast('请输入类型！');
            //                 return false;
            //             }
            //             saveData(datas);
            //         } else {
            //             fun.toast("【" + name + "】类型已存在！");
            //         }
            //         layer.closeAll();
            //         break;
            //     case 'edit':
            //         var names = edits['name'];
            //         var typess = $("#type").val();
            //         if (!!$("[name='" + name + "']").attr('stype')) {
            //             fun.toast("修改失败，该类型已存在！");
            //             return true;
            //         }
            //         if (typess && typess != names) {
            //             datas['name'] = filter(datas['name']);
            //             $("[name='" + names + "']").find('.color-number').text(datas['name']);
            //             $("[name='" + names + "']").attr('name', datas['name']);
            //             saveData(datas);
            //             layer.closeAll();
            //         }
            //         break;
            // }
        },
        no: function () {
            $('.content').css('position','relative');
        }
    });
    // $('.lay-warm-content').css('display', 'block');
}

function getData(page_type) {
    setTimeout(function () {
        fun.showLoad();
    },200);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getCostList,
        data: { type: page_type },
        success: function (res) {
            if (res.status != 0) return fun.toast('该数据不存在！');
            all = [];
            $('.content').empty();
            $('.content').html('');
            var info_list = res.data;

            showData(getAllSon(ceilFormat(sortByKey(info_list))));


            setTimeout(function () {
                fun.hideLoad();
            },400);
        }
    });
    // fun.load_DATA_LIST([page_type]);
}

//如果是选择类型时，点击返回数据
$('body').on('tap', '.account-list', function (e) {
    e.stopPropagation();
    if ((page_type == "fylx" || page_type == "srlx") && !!page_data['return_page']) {
        if ($(this).attr('son') == '') {
            var row = $(this).data('row');
            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    'status': 'select_lx',
                    'data': {
                        id: row['id'],
                        page_type: page_data.obj,
                        select_val: row['name'],
                        list_data: row,
                    }
                }
            });
            api.closeWin();
        }
    } else {
        if ($(this).attr('son') == '') {
            if (!!page_data.page_type) {
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        'status': 'select_list',
                        'data': {
                            'id': $(this).attr('id'),
                            "page_type": page_data['page_type'],
                            "select_val": $(this).attr('name'),
                            "list_data": {
                                "id": $(this).attr('id'),
                                "type": $(this).attr('type'),
                                "name": $(this).attr('name'),
                                "number": "",
                                "simple": $(this).children('.le').attr('simple'),
                                "parent_id": $(this).attr('ptype'),
                                "sort": $(this).children('.le').attr('sort'),
                                "remark": "",
                                "config": [],
                                "is_default": 0,
                                "is_stop": 0,
                                "is_sys": 0,
                                "is_delete": 0,
                                "is_has": 9,
                                "create_time": $(this).children('.le').attr('create_time'),
                                "update_time": $(this).children('.le').attr('update_time')
                            }
                        }
                    },
                });
                api.closeWin();
            }
        }
    }


});

$('body').on('touchstart', '.edit-btn', function (e) {
    e.stopPropagation();
    e.preventDefault();
    layer.closeAll();
    var _this = $(this);
    addData({
        "state": "edit",
        "obj": _this
    });
    return false;
});

$('body').on('click', '#add_btn', function () {
    if ($(this).attr('disabled')) return;
    layer.closeAll();
    var _this = $(this);
    addData({
        "state": "add",
        "obj": _this,
        "type": page_type,
        "stype": 0
    });
});

$('body').on('tap', ".icon-tianjia", function (e) {
    e.stopPropagation();
    $('.content').css('position','fixed');
    // $('body').css('position','fixed');
    // if ($(this).attr('disabled')) return;
    // var datas = $(this).parents('.account-list').attr('data-row');
    // if(datas.is_has > 0) {
    //     fun.toast('已被调用，无法添加子节点。');
    // }else {
        var _this = $(this);
        addData({
            "state": "add",
            "obj": _this
        });
    // }
    return false;
});

//删除
// $('body').on('tap', 'li .delete-btn', function (e) {
//     e.stopPropagation();
//     var stype, ptype;
//     var objs = $(this).parent().parent();//获得对象
//     fun.dialog({
//         content: '是否要删除所选类型？',
//         btn: ['删除', '取消'],
//         yes: function () {
//             stype = objs.attr('stype');
//             ptype = objs.attr('ptype');
//             var param = {'id': objs.attr('id'), 'type': objs.attr('type'), 'status': 'delete'};
//             getInfo(param);
//         }
//     });
// })

//删除
$('body').on('touchstart', 'li .delete-btn', function (e) {
    e.stopPropagation();
    e.preventDefault();
    var obj = $(this).parent().parent();//获得对象
    var parent_list = $($(this).parents('.swipe-delete')[0]);

    fun.dialog({
        content: '是否要删除所选类型？',
        btn: ['删除', '取消'],
        yes: function () {
            var param = {
                'id': [obj.attr('id')],
                'type': obj.attr('type'),
                'subLevel': false,
                'save_type': 'delete'
            };
            //   if(!!page_data.page_type){
            //       param['save_type'] = 'delClass';
            //       param['is_delete'] = 1;
            //   }
            //存在子类别
            if (parent_list.children().filter('.swipe-delete').length > 0) {
                param['subLevel'] = true;
            }
            delData(param);
        }
    });
    return false;
})

//获取编号
function getNumber(type, parent_id) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getNumber,
        data: { "type": type, "parent_id": parent_id },
        success: function (res) {
            if (res.status != 0) return fun.toast('获取编号失败！');
            page_data['numbers'] = res.data;
        }
    });
}

//保存数据
function saveData(params) {
    $('.content').css('position','relative');
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveCost,
        data: params,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    var info_list = res.data || {}, info_data = [];
                    if (!params['id'] && !!info_data) { //是添加数据
                        if (!!info_list) {
                            info_data.push({
                                'id': info_list['id'] || 0,
                                'name': info_list['data']['name'],
                                'simple': info_list['data']['simple'],
                                'number': info_list['data']['number'],
                                'type': info_list['data']['type'],
                                'remark': info_list['data']['remark'],
                                'parent_id': info_list['data']['parent_id'],
                                'is_stop': info_list['data']['is_stop'],
                                'sort': info_list['data']['sort']
                            });
                        }
                        // showData(info_data);
                        fun.toast("类型添加成功！");
                    }
                    //  else if (params.save_type == 'delete') { //删除数据
                        // UPDATE['del_id'].push(params['id'][0] || 0);
                        // $("[stype='" + params['id'] + "']").parent().remove();
                        // fun.toast("删除成功！");
                    // }
                    else if (params.save_type == 'edit'){ //修改数据
                        fun.toast("类型修改成功！");
                    }

                    getData(page_type);
                    break;
                case 103:
                    // if (!!params['subLevel']) {
                    //     return fun.toast('有部分节点已被调用，无法删除。');
                    //     // return $.nuiTips({msg: '【' + classTree.getSelected()['name'] + '】', type: 1});
                    // } else {
                        return fun.toast('已被调用，无法添加子节点。');
                    // }
                    break;
                case 104:
                    return fun.toast('类型已存在。');
                    break;
                default:
                    fun.toast(res.msg);
                    break;
            }

            // if (params.save_type == 'delete') {
            //     if (res.status == 0) return fun.toast('删除成功！');
            // }
            // if (res.status != 0) return fun.toast(res.msg);
            // var info_list = res.data, data = [];
            // if (!!info_list) {
            //     data.push({
            //         'id': info_list['id'],
            //         'name': info_list['data']['name'],
            //         'simple': info_list['data']['simple'],
            //         'number': info_list['data']['number'],
            //         'type': info_list['data']['type'],
            //         'remark': info_list['data']['remark'],
            //         'parent_id': info_list['data']['parent_id'],
            //         'is_stop': info_list['data']['is_stop'],
            //         'sort': info_list['data']['sort']
            //     });
            // }
            // if (!params['id']) {//是添加数据
            //     if (!!data) {
            //         fun.toast("类型添加成功！");
            //         showData(data);
            //     }
            // } else {//修改数据
            //     fun.toast("类型修改成功！");
            // }
        }
    });
}

//获取单个数据
// function getInfo(params) {
//     fun.ajax({
//         showLoad: true,
//         hideLoad: true,
//         url: AJAX_URL.getCostInfo,
//         data: {id: params.id, type: params.type},
//         success: function (res) {
//             if (res.status != 0) return fun.toast('获取修改数据失败！');
//             var info_list = res.data, data = [];
//             switch (params.status) {
//                 case 'edit':
//                     $("#type").val(info_list['name']);
//                     edits = info_list;
//                     break;
//                 case 'delete':
//                     delData(info_list);
//                     break;
//             }
//         }
//     });
// }

function getInfo(params) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getCostInfo,
        data: {
            id: params.id,
            type: params.type
        },
        success: function (res) {
            if (res.status != 0) return fun.toast('获取修改数据失败！');
            var info_list = res.data || {};
            // switch (params.status) {
                // case 'edit':
                    $("#type").val(info_list['name']);
                    edits = info_list;
                    // break;
                // case 'delete':
                //     delData(info_list);
                //     // saveData({
                //     //     "save_type": "delete",
                //     //     "id": [info_list['id']],
                //     //     "type": info_list['type'],
                //     //     "subLevel": params['subLevel']
                //     // });
                //     break;
            // }
        }
    });
}

//删除数据
function delData(data) {
    if(data['subLevel'] === true) {
        fun.toast('有下一类型，无法删除。');
    }else {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.saveCost,
            data: data,
            success: function (res) {
                switch (res['status']) {
                    case 0:
                        $("[stype='" + data['id'] + "']").parent().remove();
                        var delId =  $.isArray(data['id']) ? data['id'][0] : data['id'];
                        upDate['del_id'].push(delId);
                        fun.toast('删除成功。');
                        getData(page_type);
                        break;
                    case 103:
                        fun.toast('【'+res['name']+'类型】已被调用过，无法删除。');
                        break;
                    case 104:
                        fun.toast('删除失败。');
                        break;
                }
            }
        });
    }
    // var datas;
    // var names = $("[stype='" + data['id'] + "']").attr('name');
    // // if (!!$("[ptype='" + data['id'] + "']").attr('stype')) {
    // if (data['subLevel']) {
    //     fun.toast(names + '类型已被调用过，无法删除!');
    //     // layer.closeAll();
    // } else if(data['is_has'] > 1) {
    //     fun.toast(names + '类型已被调用过，无法删除!');
    //     // datas = {
    //     //     "save_type": "delete",
    //     //     "id": [data['id']],
    //     //     "type": data['type'],
    //     // }
    //     // delData(datas);
    // }else {
    //     $("[stype='" + data['id'] + "']").parent().remove();
    //     fun.toast("删除成功！");
    //     // saveData();
    //     // layer.closeAll();
    // }

}

//显示数据
function showData(data) {
    $('.content').empty();
    var list = [];
    for (var x = 0; x < data.length; x++) {
        var steps;//判断层级
        var ptype = data[x]['parent_id'];
        if (!ptype) {//如果父级为空，则为第一级
            steps = 1;
            create(steps, data[x]);
        } else {
            var step = $("[stype='" + ptype + "']").parent().attr('step');
            var objs = $("[stype='" + ptype + "']");
            if (ptype == objs.attr('stype')) {
                step++;
                create(step, data[x]);
            }
        }
    }

    function create(st, datas) {
        var son = datas['son'];
        var list = [];
        list.push('<ul class="swipe-delete swipe-delete' + st + '" step=' + st + '>');
        list.push('<li class="account-list lower-border-line" data-row=\'' + fun.formatString(JSON.stringify(datas)) + '\' son="' + son + '" type="' + datas.type + '" id="' + datas.id + '" name="' + datas.name + '" stype="' + datas.id + '" ptype="' + datas.parent_id + '">');
        list.push('<div class="le" sort="' + datas.sort + '" simple="' + datas.simple + '" create_time="' + datas.create_time + '" update_time="' + datas.update_time + '">');
        list.push('<span class="color-number" style="margin-left:' + st + 'rem" number="' + datas.number + '">' + datas.name + '</span>');
        if (Auth.check(page_type, 'edit')) {
            list.push('<i class="iconfont icon-tianjia"></i>');
        }
        list.push('<div class="slids edit dels1 edit-btn">修改</div>');
        list.push('<div class="delete dels1 delete-btn">删除</div>');
        list.push('</div>');
        list.push('</li>');
        list.push('</ul>');
        switch (st) {
            case 1:
                $('.content').append(list.join(''));
                list = [];
                break;
            default:
                $("[stype='" + ptype + "']").parent().append(list.join(''));
                list = [];
                break;
        }
    }

    if (!Auth.check(page_type, 'edit')) {
        $('.swipe-delete').removeClass('swipe-delete');
        $('.icon-tianjia').attr('disabled', true);
    }
    // if ((page_type == "fylx" || page_type == "srlx") && !!page_data['return_page']) {
    //     $('.account-list').on('tap', function (e) {
    //         if($(this).attr('son') == '') {
    //             var row = $(this).data('row');
    //             api.sendEvent({
    //                 name: page_data['return_page'],
    //                 extra: {
    //                     'status': 'search',
    //                     'data': row
    //                 }
    //             });
    //             api.closeWin();
    //         }
    //         // else {
    //         //     fun.toast("请选择子节点！");
    //         // }
    //     })
    // }
    // 暂无数据提示
    if (data.length != 0) {
        // $('.content').css({ 'height': 'auto', 'position': 'unset' });
    } else {
        // $('.content').css({ 'height': '100%', 'position': 'fixed' });
        // $('.content').html('<p class="empty_text">暂无数据！</p>');
        fun.createDataEmptyTips({dom:'.content',btnText:'新增'+(page_data.obj=='cost'?'费用类型':'收入类型'),style:'top:4rem;',auth:page_type,isDa:true});
    }
}

//对得到得数据进行排序
function sortByKey(array, key) {
    return array.sort(function (a, b) {
        var x = a[key];
        var y = b[key];
        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    });
}


function getAllSon(ars) {
    for (var j = 0; j < ars.length; j++) {
        all.push(ars[j]);
        if (!!ars[j]['son'][0]) {
            getAllSon(sortByKey(ars[j]['son'], 'sort'));
        }
    }
    return all;
}

//排序格式化
function ceilFormat(arr) {
    var p_arrs = [], c_arrs = [];
    for (var i = 0; i < arr.length; i++) {
        if (arr[i]['parent_id'] == 0) {
            p_arrs.push(arr[i]);
        } else {
            c_arrs.push(arr[i]);
        }
    }

    for (var i = 0; i < c_arrs.length; i++) {
        c_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (c_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                c_arrs[i]['son'].push(c_arrs[j]);
                // all.push(c_arrs[j]);
            }
        }
    }

    for (var i = 0; i < p_arrs.length; i++) {
        p_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (p_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                p_arrs[i]['son'].push(c_arrs[j]);
            }
        }
    }

    return sortByKey(p_arrs, 'sort');
    //sort按照升序
}

function filter(str) {
    var pattern = /[`~!@#$^&*()=|{}':;',\\\[\]\.<>\/?~！@#￥……&*（）——|{}【】'；：""'。，、？]/g;
    return str.replace(pattern, "");
}

//  判断类别是否存在
function typeExist(obj, value) {
    var name_arr = [];
    if ($(obj).hasClass("icon-tianjia")) {
        //当前子类别
        var swipe = $(obj).parents('.swipe-delete');
        var node_arr = $(swipe[0]).parent().children();
        if ($(swipe).attr('step') == 1) {
            node_arr = $(swipe).children();
        }
        $(node_arr.filter('.swipe-delete')).each(function (i, arr) {
            name_arr.push($(arr).children('.account-list').attr('name'));
        })
    } else if ($(obj).hasClass("icon-jia")) {
        //父类别
        var node_arr = $('.content > ul');
        $(node_arr).each(function (i, arr) {
            name_arr.push($(arr).children('.account-list').attr('name'));
        })
    }
    if (name_arr.indexOf(value) > - 1) return true;
    return false;
}

$('body').off('click', '.empty-tips-btn').on('click', '.empty-tips-btn', function (e) {
    e.stopPropagation();
    $('#add_btn').trigger('click');
});