var html_name = page_arr.customer_search;
var page_title, return_data = {}, search_data = {};
var merchant_list, temps;
var __PAGE_INFO = {};

var target_page = '';
var back_page = '';
var customer_search = {};
var kh_class = [];
var class_id = {};
var page_list = [];
var last_lb_id = 0, last_lb_mc = '', last_lx = '';
var number;
var SYS_CONFIG = {};

var USER_INFO = {};
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');

    SYS_CONFIG = fun.getItem('sys_config') || {};
    //ios头部穿透
    // fun.pierceThrough('.account-list');
    fun.load_DATA_LIST(['ck', 'sys_config'],function(){
        SYS_CONFIG = fun.getItem('sys_config') || {};
    });

    switch (page_data['djlx']) {
        case 'bp_xsfhjs':
            target_page = page_arr.xs_fhjs_kd;
            back_page = page_data['LIST_PAGE'] || page_arr.xs_fthjs_tj;
            break;
        case 'bp_xsthjs':
            target_page = page_arr.xs_thjs_kd;
            back_page = page_data['LIST_PAGE'] || page_arr.xs_fthjs_tj;
            break;
        case 'bp_xsdd':
            target_page = page_arr.xs_khdd_kd;
            back_page = page_data['LIST_PAGE'] || page_arr.xs_khdd_tj;
            break;
        case 'bp_xsbj':
            target_page = page_arr.xs_xsbj_kd;
            back_page = page_data['LIST_PAGE'] || page_arr.xs_xsbj_cx;
            break;
        case 'bp_cgbj':
            target_page = page_arr.cg_cgbj_kd;
            back_page = page_data['LIST_PAGE'] || page_arr.cg_cgbj_cx;
            break;
        case 'bp_cgdd':
            target_page = page_arr.cg_cgdd_kd;
            back_page = page_data['LIST_PAGE'] || page_arr.cg_cgdd_tj;
            break;
        case 'bp_cglhjs':
            target_page = page_arr.cg_lhjs_kd;
            back_page = page_data['LIST_PAGE'] || page_arr.cg_lthjs_tj;
            break;
        case 'bp_cgthjs':
            target_page = page_arr.cg_thjs_kd;
            back_page = page_data['LIST_PAGE'] || page_arr.cg_lthjs_tj;
            break;
        case 'fans':
            target_page = page_arr.shop_fans;
            back_page = page_arr.apply;
            break;
    }


    $('#header').header({
        back: true,
        add: true,
        filter: true,
        title: '客户',
        foot_input: {
            show: true,
            yuyin_icon: false,
            plader: '搜索'
        },
        appendBackBtnEvt: backEvent
    });
    page_data.keyback = backEvent;

    if (!Auth.check(page_data['page_type'], 'edit')) {
        $('#add_btn').hide();
    }

    if(page_data['goods_type']==='sx'){
        $('#add_btn').hide();
    }

    getList();
    var plader_text = '搜索';
    switch (page_data['page_type']) {
        case 'kh':
            page_title = '客户';
            plader_text = '搜索或添加客户';
            break;
        case 'gys':
            page_title = '供应商';
            plader_text = '搜索或添加供应商';
            break;
        case 'jgs':
            page_title = '加工商';
            break;
        case 'wl':
            page_title = '物流';
            break;
    }
    $("#header_title").text(page_title || '');
    $('#foot_search').attr('placeholder', plader_text)
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'search':
                search_data['md_id'] = temp['data']['md']['id'] || '';
                search_data['md_mc'] = temp['data']['md']['text'] || '';
                search_data['class_id'] = temp['data'][page_data['page_type'] + '_lb']['id'] || '';//类别
                search_data['class_name'] = temp['data'][page_data['page_type'] + '_lb']['text'] || '';
                if (page_data['page_type'] == 'kh') {
                    search_data['ywy_id'] = temp['data']['ywy']['id'] || '';//业务员
                    search_data['ywy_mc'] = temp['data']['ywy']['text'] || '';
                }

                fun.setItem(html_name + 'sideslip', true);

                $('#list').empty();
                getList();
                break;
            case 'updata':
                if ((temp['type'] == 'kh' || temp['type'] == 'gys') && $.nui.isTrue(temp['tc_type'])) {
                    setTimeout(function () {
                        getSkipData(temp['tmp_id']);
                    }, 200)
                }
                break;
            case 'refresh':
                if (!temp['tc_type']) {
                    getList();
                }
                break;
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list));
        } else {
            fun.createBottomLine('list', ".account-list");
        }
    });

    fun.orderListHeight({ dom: '#list' });
};

function backEvent() {
    if ($.nui.isTrue(page_data['__route'])) {
        var pageParam = {
            return_page: back_page,
            id: 0,
            LIST_PAGE: back_page,
            BILL_PAGE: target_page
        };
        if (page_data.djlx === 'fans' || page_data.djlx === 'shop') {
            api.closeToWin({ name: page_data.return_page, });
        } else {
            if ((page_data.djlx === 'bp_xsbj' || page_data.djlx === 'bp_cgbj') && page_data.wldw) {
                pageParam.__DJ_DATA = {
                    wldw_id: page_data.wldw.id,
                    wldw_mc: page_data.wldw.merchant_name
                }
            }

            if (page_data.djlx === 'bp_cgdd' && page_data.wldw) {
                pageParam.wldw = page_data.wldw;
            }

            fun.showPageFull({
                page_url: target_page,
                pageParam: pageParam
            });
        }
    } else if (page_data['page_status'] == 'class_edit') {
        kh_class = []
        $.each(class_id, function (key, value) {
            kh_class.push(value)
        })
        sendEvent(data = { kh_class: kh_class, type: 'zdkhs' })
    } else {
        api.closeWin();
    }
}


//新单状态下，页面默认信息获取
function getPageDefInfo(callback) {

    var tmp_djlx = page_data['wldw_tmp']['djlx'];

    var tmp_table = tmp_djlx+'_dj';

    switch(tmp_djlx){
        case 'bp_cglhjs':
            tmp_table = 'cglhjs_dj';
            break;
        case 'bp_cgthjs':
            tmp_table = 'cgthjs_dj';
            break;
    }

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: page_data['wldw_tmp']['getBillsPageDefInfo'],
        data: {
            djlx: page_data['wldw_tmp']['djlx'],
            table: tmp_table
        },
        success: function (res) {
            if (res['status'] == 0) {
                __PAGE_INFO = res['data'];
                if (typeof callback === 'function') callback();
            }
        }
    });
}


function getList() {
    if ($.nui.isTrue(page_data['__route']) && page_data['djlx'] != 'shop' && page_data['djlx'] != 'fans') {
        getPageDefInfo();
    }

    temps = $.extend({}, {
        "type": page_data['page_type'],
        "is_multi": 1,
        "no_contact": 1,
        "keyword": "",
        "keyword_key": ['name', 'mobile', 'phone', 'simple'],
        "order_default": 1,
        "is_stop": 0,
        'goods_type': page_data['goods_type'] || 'bp',//区分是纱线客户还是布匹客户
        // "order":{"rq": true}
    }, search_data);

    if(page_data['page_type'] !== 'wl' && $.nui.isTrue(SYS_CONFIG['bpsxbqf_'+page_data['page_type']])){
        delete temps['goods_type'];
		
		//是和否显示开启多身份的数据
        if($.nui.isTrue(page_data['notShowMulti'])) {
            temps['is_multi'] = 0;
        }
    }

    if (page_data['page_type'] == 'wl'){ 
        temps['is_multi'] = 0;
        delete temps['goods_type'];
    }

    if ($.nui.isTrue(page_data['showAllWldw'])){ 
        delete temps['goods_type'];
    }

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMerchantList,
        data: temps,
        // data:{
        //     type:page_data['page_type'],
        //     is_multi:1
        // },
        success: function (res) {
            $('#list').empty();
            if (res['status'] == 0) {
                if (!!res['data'] && !res['data'].length) {
                    if (temps['keyword'] != '') {
                        $('#foot_search').blur();
                        if (page_data['page_type'] == 'kh') {
                            if(page_data['goods_type']!=='sx' && Auth.check(page_data['page_type'], 'edit')) search_tc();
                        } else if (page_data['page_type'] == 'gys') {
                            if(page_data['goods_type']!=='sx' && Auth.check(page_data['page_type'], 'edit')) search_tc({
                                text: '供应商'
                            });
                        }
                    }

                    page_list = [];
                    // $('.account-wrap').css({ 'height': 'auto', 'position': 'unset' });
                    // $('.account-wrap').css({ 'height': 'calc(100% - 6.7rem)', 'position': 'fixed' });
                    // return $('#list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({
                        dom: '#list',
                        btnShow: (page_data['goods_type']!=='sx' && true),
                        btnText: '新增' + page_title,
                        auth: page_data['page_type'],
                        style: 'top:0rem;',
                        sameAsTj: true,
                        isDa: true
                    });
                } else {
                    // $('.account-wrap').css({ 'height': 'auto', 'position': 'unset' });
                }
                // page_list = res['data'];
                // customer_search.apiData = page_list.slice(0);
                page_list = fun.createApiDataIndex(res.data);

                var info_list = res['data'].slice(0);
                last_lb_id = info_list[info_list.length - 1]['class_id'];
                last_lb_mc = info_list[info_list.length - 1]['class_name'];
                last_lx = info_list[info_list.length - 1]['goods_type'];

                showList(fun.PagingData(page_list));
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}


//显示数据列表
// function showList(data){
//   var listHtml=[];
//   // var bgs=["#AA98C1","#4281D0","#FF7373","#A1FF73","#85CA8D", "#98C1F3", "#FCC1AB", "#80DED0", "#FFB0D4", "#D95758", "#FCB65B"];
//   $.each(data, function (x, obj) {
//     listHtml.push('<li class="account-list lower-border-line" value="'+(obj['merchant_name'] || '')+'">');
//     listHtml.push('<div class="round" style="background-color:'+(bgs[x] || '')+'">');
//     if(!!obj['imgs']){
//       listHtml.push('<img src="'+fun.getImgPath(obj['imgs'])+'" class="imgs">');
//     }else{
//       listHtml.push('<span class="text">'+fun.getLastName(obj['merchant_name'])+'</span>');
//     }
//     listHtml.push('</div>');
//     listHtml.push('<div class="list">');
//     listHtml.push('<span class="name">'+(obj['merchant_name'] || '')+'</span>');
//     if(type=='kh' && !!obj['is_default']){
//       listHtml.push('<div class="default"><span>默认</span></div>');
//     }
//     listHtml.push('</div>');
//     listHtml.push('<div class="column column2">');
//     listHtml.push('<div class="left">');
//     listHtml.push('<span class="number">'+(obj['mobile'] || '')+'</span>');
//     listHtml.push('<span class="hand-man">'+(obj['contact_name'] || '')+'</span>');
//     listHtml.push('</div>');
//     listHtml.push('<div class="right">');
//     listHtml.push('<span class="arrears">累欠：</span>');
//     listHtml.push('<span class="sum">'+(obj['balance'] || '')+'</span>');
//     listHtml.push('</div>');
//     listHtml.push('</div>');
//     if(type=='kh'){
//       listHtml.push('<div class="column">');
//       listHtml.push('<span class="store">'+obj['store_name']+'</span>');
//       listHtml.push('<span class="xxfz">'+(obj['salesman'] || '')+'负责</span>');
//       listHtml.push('</div>');
//     }
//     listHtml.push('</li>');
//   });
//   $('#list').html(listHtml.join(''));
//   if(type!='kh'){$('.list').addClass('adds');}
//   $('.sum').each(function(){
//     var str=$(this).text();
//     var exp = /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/; 
//     if(exp.test(str)) {
//       $(this).css('color','#FF2B29');
//     } else {
//       $(this).css('color','#4DC46F');
//     }
//   });
// }

function showList(data) {
    var html = [];
    // var store_id = (fun.getItem('user_info') ? fun.getItem('user_info')['store_id'] : 0);
    // customer_search.apiData = data;

    $(data).each(function (i, obj) {
        var colour = order_color[i % order_color.length];
        var mer_val = obj['merchant_name'] || '';
        if (page_data['page_type'] !== 'kh') {
            obj['store_name'] = '';
            obj['staff_name'] = '';
        }
        // if (mer_val.indexOf('"') > -1) {
        //     mer_val = mer_val.replace(/\"/g, "\"");
        // }
        // if (mer_val.indexOf("'") > -1) {
        //     mer_val = mer_val.replace(/\'/g, "\'");
        // }

        html.push('<li data-index="' + data[i].__index + '" data-list=\'' + fun.formatString(JSON.stringify(obj)) + '\' class="account-list lower-border-line" id="' + fun.is_value(obj['id']) + '" value="' + fun.is_value(mer_val) + '">');
        html.push('<div class="round" style="background-color:' + colour + ';">');
        if (!!obj['imgs']) {
            html.push('<img src="' + fun.getImgPath(obj['imgs']) + '" class="imgs">');
        } else {
            html.push('<span class="text">' + (fun.getLastName(obj['merchant_name']) || "") + '</span>');
        }
        html.push('  </div>');

        if ($.nui.isEmpty(obj['store_name']) && $.nui.isEmpty(obj['staff_name']) && $.nui.isEmpty(obj['mobile']) && $.nui.isEmpty(obj['contact_name'])) {
            html.push('                <div class="list"  style="padding-top:1.5rem;">');
        } else if ($.nui.isEmpty(obj['store_name']) && $.nui.isEmpty(obj['staff_name'])) {
            html.push('                <div class="list"  style="padding-top:1rem;">');
        } else if ($.nui.isEmpty(obj['mobile']) && $.nui.isEmpty(obj['contact_name'])) {
            html.push('                <div class="list"  style="padding-top:1rem;">');
        } else {
            html.push('                <div class="list">');
        }
        html.push('      <span class="name">' + (fun.redFont(fun.is_value(obj['merchant_name']), search_data['keyword']) || "") + '');
        if (!!obj['is_gz']) {//如果当前用户有关注该客户，则显示该图标。反之，则不显示。
            html.push('<i class="iconfont icon-shoucang sup"></i>');
        }
        html.push('</span>');
        if ($.nui.isEmpty(obj['mobile']) && $.nui.isEmpty(obj['contact_name'])) {
            html.push('                      <div class="right">');
            html.push('                          <span class="arrears">累欠：</span>');
            html.push('                          <span class="sum">' + (obj['balance'] || 0) + '</span>');
            html.push('                      </div>');
        }
        // if (obj['is_default'] === 1) {
        //     html.push('<div class="default"><span>默认</span></div>');
        // }
        html.push('                </div>');
        if ($.nui.isTrue(obj['mobile']) || $.nui.isTrue(obj['contact_name'])) {
            html.push('                <div class="column column2">');
            html.push('                        <div class="number-box">');
            if ($.nui.isTrue(obj['mobile'])) {
                html.push('                             <span class="number">' + fun.is_value(obj['mobile']) + '</span>');
            }
            if ($.nui.isTrue(obj['contact_name'])) {
                html.push('                             <span class="hand-man">' + fun.is_value(obj['contact_name']) + '</span>');
            }
            html.push('                        </div>');
            html.push('                      <div class="right">');
            html.push('                          <span class="arrears">累欠：</span>');
            html.push('                          <span class="sum">' + (obj['balance'] || 0) + '</span>');
            html.push('                      </div>');
            html.push('                </div>');
        }
        if ($.nui.isTrue(obj['store_name']) || $.nui.isTrue(obj['staff_name'])) {
            html.push('                <div class="column column3">');
            if ($.nui.isTrue(obj['store_name'])) {
                html.push('                     <span class="store">' + fun.is_value(obj['store_name']) + '</span>');
            }
            if ($.nui.isTrue(obj['staff_name'])) {
                html.push('                     <span class="xxfz">' + fun.is_value(obj['staff_name']) + ' 负责</span>');
            }
            html.push('                </div>');
        }
        html.push('            </li>');
    })

    $('#list').append(html.join(''));
    //累欠颜色样式
    $('.sum').each(function () {
        var str = $(this).text();
        // var exp = /(^[1-9]([0-9]+)?(\.[0-9]{1,2})?$)|(^(0){1}$)|(^[0-9]\.[0-9]([0-9])?$)/;
        if ((str || 0) >= 0) {
            // if (!exp.test(str)) {
            // $(this).css('color', '#FF2B29');
            $(this).css('color', 'red');
        } else {
            // $(this).css('color', '#4DC46F');
            $(this).css('color', 'green');
        }
    });
    initPage();
    if (page_data['auth_val'] != 'null' && !($.nui.isEmpty(page_data['auth_val']))) {
        class_edits();
    }
    if (page_data['page_status'] == 'class_edit') {
        $('.account-list').removeClass('account')
    }
}

function initPage() {
    switch (page_data['page_type']) {
        case 'kh':
            break;
        default:
            $('.column3').hide();
            // $('.list').css('line-height', '1.5rem');
            // $('.column2').css('line-height', '1.5rem');
            break;
    }
}


//关键字筛选
function nameFilter(param, arr) {
    return arr.filter(function (ele, index) {
        return ele.merchant_name.indexOf(param) != -1 ? true : false;
    });
}

//简码筛选
function simpleFilter(param, arr) {
    return arr.filter(function (ele, index) {
        return ele.simple.indexOf(param) != -1 ? true : false;
    });
}

//返回上一页并返回值
$('body').on('click', '.account-list', function (e) {
    e.stopPropagation();
    var index = Number($(this).data('index'));
    var id = $(this).attr('id');
    var merchant = false;
    var currentRowList = $(this).data('list');
    if (page_data['type'] == 'dk_bj' && !$.nui.isEmpty(page_data['verify_data'])) {
        $(page_data['verify_data']).each(function (i, item) {
            if (item['merchant_name'] == fun.apiData[index]['merchant_name'] && page_data['current'] != fun.apiData[index]['merchant_name']) {
                merchant = false
                fun.toast('【' + item['merchant_name'] + '对象名称】已添加过。')
                return false;
            } else {
                merchant = true
            }

        })
        if (merchant) {
            return_data = {
                id: $(this).attr('id'),
                page_type: page_data['page_type'],
                select_val: (fun.apiData[index]['merchant_name'] && fun.apiData[index]['merchant_name'] || '') || '',
                list_data: fun.apiData[index] || {},
                set_where: page_data['set_where'] || '',
            };
            sendEvent(return_data);
        }

    } else if (page_data['page_status'] == 'class_edit') {
        $(this).removeClass('account')
        if ($(this).hasClass('bg-blue')) {
            $(this).removeClass('bg-blue')
            class_id[id] = Number(JSON.parse(JSON.stringify(class_id[id])))
            delete class_id[id]
        } else {
            class_id[id] = {
                id: Number(id),
                // page_type: page_data['page_type'],
                select_val: (fun.apiData[index]['merchant_name'] && fun.apiData[index]['merchant_name'] || '') || '',
                // list_data: fun.apiData[index] || {},
                //list_data: customer_search.apiData[index],
                //set_where: page_data['set_where'] || ''
            }
            $(this).addClass('bg-blue')
        }
    } else if ('djlx' in page_data && page_data['djlx'] === 'khtx') { // 应用页面打开进入选客户界面
        fun.showPageFull({
            page_url: page_data['BILL_PAGE'],
            pageParam: {
                return_page: page_data['return_page'],
                page_index: 'xfxg',
                wldw_id: currentRowList['id'],
                wldw_mc: currentRowList['merchant_name'],
                closeAll: true
            }
        })
    } else {
        return_data = {
            id: $(this).attr('id'),
            page_type: page_data['page_type'],
            select_val: (fun.apiData[index]['merchant_name'] && fun.apiData[index]['merchant_name'] || '') || '',
            list_data: fun.apiData[index] || {},
            set_where: page_data['set_where'] || ''
        };
        sendEvent(return_data);
    }


});

function sendEvent(data) {

    // if(page_data['page_type']=='kh'){
    //     if(page_data['goto_page']){
    //         api.sendEvent({
    //             name: page_data['final_page'],
    //             extra:{
    //                 'status': 'select_list',
    //                 'data': data
    //             }
    //         });
    //
    //         fun.showPageFull({
    //             page_url: page_arr.choice_product,
    //             pageParam: {
    //                 'return_page': html_name,
    //                 'goto_page': page_arr.xs_fhjs_kd,
    //                 'final_page': page_arr.xs_fhjs_kd,
    //                 'jl_data': [],
    //                 __PAGE_INFO: {},
    //                 kddj_info: {},
    //                 wldw_data: data['list_data'],
    //                 __PAGE_EDIT: true
    //             }
    //         });
    //         api.closeWin();
    //         return;
    //     }else{
    //         api.sendEvent({
    //             name: page_data['return_page'],
    //             extra:{
    //                 'status': 'select_list',
    //                 'data': data
    //             }
    //         });
    // }
    // }
    if ($.nui.isTrue(page_data['__route'])) {
        var __opt = { html_name: html_name, page_data: page_data };

        // page_data['']
        // LIST_PAGE: back_page,
        // BILL_PAGE: target_page

        page_data['wldw'] = data['list_data'];
        __opt.page_data['cp_tmp'] = {
            djlx: page_data['wldw_tmp']['djlx'],
            __JL_DATA: [],
            __PAGE_INFO: __PAGE_INFO || {},
            __DJ_DATA: {},
            __PAGE_EDIT: true,
        };
        if (page_data.djlx === 'bp_cglhjs' || page_data.djlx === 'bp_cgthjs') {
            __opt.closeWin = true;
        }

        if (page_data.djlx === 'bp_cglhjs' || page_data.djlx === 'bp_cgthjs') {  // 来/退货结算需要传递__PAGE_INFO
            __opt.page_data.cp_tmp.__PAGE_INFO = $.extend({}, page_data.__PAGE_INFO, __PAGE_INFO);
        }
        // if (page_data.djlx === 'shop') {
        //     // fun.ajax({
        //     //     showLoad: true,
        //     //     hideLoad: true,
        //     //     url: AJAX_URL.getBindingKhInfo,
        //     //     data: {
        //     //         kh_id: Number(page_data['wldw']['id']),
        //     //     },
        //     //     success: function (res) {
        //     //         if (res.status === 0) {
        //     //             __opt.page_data['bind_lxr_id'] = res.data;
        //                 PageShow.gotoNextPage(__opt);
        //     //         }
        //     //     }
        //     // })
        // } else {
            PageShow.gotoNextPage(__opt);
        // }

    } else {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'select_list',
                'data': data
            }
        });
        api.closeWin();
    }
}

//点击键盘搜索
$('body').bind('search', "#foot_search", function (e) {
    search_data["keyword"] = $('#foot_search').val().trim();
    // if (e.keyCode === 13) {
    // $(this).select();
    // $('#swipe').empty();
    $('#list').empty();
    getList();
    // }
});

fun.setItem(html_name + 'sideslip', true);
// 打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var choose_merchants = [
        {
            key: page_data['page_type'] + "_lb",
            "text": "类别",
            "value": (temps && temps['class_name'] ? temps['class_name'] : ''),
            "id": (temps && temps['class_id'] ? temps['class_id'] : '')
        },
        {
            key: "md",
            "text": "门店",
            "value": (temps && temps['md_mc'] ? temps['md_mc'] : ''),
            "id": (temps && temps['md_id'] ? temps['md_id'] : '')
        },
    ];


    if (page_data['page_type'] == 'kh') {
        choose_merchants.push({
            key: "ywy",
            "text": "业务员",
            "value": (temps && temps['ywy_mc'] ? temps['ywy_mc'] : ''),
            "id": (temps && temps['ywy_id'] ? temps['ywy_id'] : '')
        });
    }

    var options = {
        "choose_merchants": choose_merchants,
    };
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

$('body').delay('tap', '#add_btn', function (e) {
    var search_val = $('#foot_search').val().trim();
    var jvals = fun.judgeLastStr(search_val);
    if (search_val == '') {
        openPage(jvals, true);
    } else {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.getInfoByKeyword,
            data: {
                "type": page_data['page_type'],
                "keyword": jvals.name_str
            },
            success: function (res) {
                switch (res['status']) {
                    case 0:
                        openPage(jvals, true);
                        break;
                    case 104:
                        layer.closeAll();
                        fun.dialog({
                            content: '【' + jvals.name_str + '】已存在，是否继续添加？',
                            btn: ['确定', '取消'],
                            shadeClose: false,
                            className: 'data-change-skin',
                            yes: function () {
                                openPage({
                                    num_str: '',
                                    name_str: ''
                                }, true);
                            },
                            no: function () {
                                search_data["keyword"] = search_val;
                                $('#list').empty();
                                getList();
                            }
                        });
                        break;
                    default:
                        fun.toast(res['msg']);
                        break;
                }
            }
        })
    }

});

function openPage(jvals, flag) {
    var tmpParam = {
        return_page: html_name,
        title: page_title,
        type: page_data['page_type'],
        // tc_type: page_data['page_type'],
        opt: 'append',
        last_lb_id: last_lb_id,
        last_lb_mc: last_lb_mc,
        last_lx: last_lx,
        name: jvals.name_str,
        contact_mobile: jvals.num_str
    };
    if (!flag) {
        tmpParam['tc_type'] = page_data['page_type'];
    }
    fun.showPageFull({
        page_url: page_arr.custom_add,
        pageParam: tmpParam
    });
}
// function __checkData() {
//     if (!fun.dataIsRead(['ck'])) {
//         setTimeout(__checkData, 250);
//     } else {
//         setTimeout(function () {
//             if (typeof page_init === "function") page_init();
//         }, 100);
//     }
// }
function class_edits() {
    //auth_val.indexOf(id)
    for (var i = 0; i < page_data['auth_val'].length; i++) {
        var id = page_data['auth_val'][i];
        // if ($('.account-list').prop(id) != 'undefined') {
        var index = $('#' + id).data('index');
        if (index != null) {
            class_id[id] = {
                id: Number(id),
                // page_type: page_data['page_type'],
                select_val: fun.apiData[index]['merchant_name'],//customer_search.apiData[index]['merchant_name'],
                // list_data: customer_search.apiData[index],
                //set_where: page_data['set_where'] || ''
            }
        }
        $('#' + id).addClass('bg-blue')
        // }
    }
}


function search_tc(position) {
    var _opt = $.extend({
        text: '客户'
    }, position)
    var html = [];
    html.push(' <div>');
    html.push('     <p>搜索不到，是否需要新增？</p>');
    html.push('     <div class="search-val">');
    html.push('         <span><span>*</span>');
    html.push('             ' + _opt['text'] + '名称</span>');
    html.push('          <input type="text" id="search_kh">');
    html.push('     </div>');
    html.push('     <div class="search-val">');
    html.push('         <span>联系人</span>');
    html.push('         <input type="text" id="search_lxr">');
    html.push('     </div>');
    html.push('     <div class="search-val">');
    html.push('         <span>手机</span>');
    html.push('         <input type="text" id="search_sj">');
    html.push('     </div>');
    html.push(' </div>');
    html.push('     <div class="search-btn">');
    html.push('         <span><button class="layer_btn">取消</button></span>');
    html.push('         <span><button class="layer_cancel">明细新增</button></span>');
    html.push('         <span><button class="layer_save">新增</button></span>');
    html.push('     </div>');
    layer.open({
        content: html.join(''),
        style: 'width:80%;',
        className: 'search-layer',
        shadeClose: false,
        success: function (layero) {
            var layer_index = $(layero).attr('index');
            $('#search_kh').val($('#foot_search').val());
            $('#search_sj').on('input', function (e) {
                this.value = this.value.replace(/[^\d-]/g, '');
            });

            $('.layer_save').off().on('click', function (e) {//新增
                e.preventDefault();
                e.stopPropagation();
                var kh_val = $('#search_kh').val().trim();
                var lxr_val = $('#search_lxr').val().trim();
                var sj_val = $('#search_sj').val().trim();
                if (kh_val == '') return fun.toast('请输入客户名称。');
                if (sj_val && !fun.regCheck(sj_val, 'phone')) {
                    return fun.toast('手机号码格式错误，请重输！');
                }
                var data = {
                    "save_type": "addMerchant",
                    "type": page_data['page_type'] || '',   // 客商类型
                    "name": kh_val || '',                   // 名称
                    "contact": lxr_val || '',               // 联系人
                    "mobile": sj_val || ''                  // 手机
                }
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.saveMerchant,
                    data: data,
                    success: function (res) {
                        switch (res['status']) {
                            case 0:
                                fun.load_DATA_LIST(['khh', 'wldw_' + page_data['page_type']], function () {
                                    fun.toast('保存成功。');
                                    layer.close(layer_index);
                                    getSkipData(res['data']['id']);
                                });
                                break;
                            case 104:
                                var msg;
                                if (res['data']['type'] == 'name') {
                                    msg = _opt['text'];
                                } else if (res['data']['type'] == 'house') {
                                    msg = '加工商';
                                } else {
                                    msg = '编号';
                                }
                                var msg2 = (res['data']['wldw_type'] == _opt['text']) ? '该' + msg + '已存在。' : '该' + msg + '在' + res['data']['wldw_type'] + '里已存在。';
                                return fun.toast(msg2);
                                break;
                            case 'IS_NOT_AMEND':
                                fun.alert({ msg: res['msg'] });
                                break;
                            default:
                                fun.toast(res['msg']);
                                break;
                        }
                    }
                })
            })

            $('.layer_cancel').on('click', function (e) {//明细新增
                e.preventDefault();
                e.stopPropagation();
                var kh_val = $('#search_kh').val().trim();
                var lxr_val = $('#search_lxr').val().trim();
                var sj_val = $('#search_sj').val().trim();
                if (kh_val == '') return fun.toast('请输入客户名称。');
                layer.close(layer_index);
                fun.showPageFull({
                    page_url: page_arr.custom_add,
                    pageParam: {
                        return_page: html_name,
                        title: page_title,
                        type: page_data['page_type'],
                        opt: 'append',
                        last_lb_id: last_lb_id,
                        last_lb_mc: last_lb_mc,
                        last_lx: last_lx,
                        name: kh_val,
                        lxr_name: lxr_val,
                        contact_mobile: sj_val,
                        tc_type: true,
                    }
                });
            })

            $(layero).find('.layer_btn').on('click', function (e) {
                e.preventDefault();
                layer.close(layer_index);
                return false;
            })
        }
    })
}

function getSkipData(id) {
    setTimeout(function () {
        fun.showLoad();
    }, 200);

    var temps = {
        "type": page_data['page_type'],
        "is_multi": 1,
        "no_contact": 1,
        "keyword": "",
        "keyword_key": ['name', 'mobile', 'phone', 'simple'],
        "order_default": 1,
        "is_stop": 0,
        'merchant_id': id,
    }

    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: AJAX_URL.getMerchantList,
        data: temps,
        success: function (res) {
            if (res['status'] == 0) {
                return_data = {
                    id: res['data'][0]['id'],
                    page_type: page_data['page_type'],
                    select_val: res['data'][0]['merchant_name'] || '',
                    list_data: res['data'][0],
                    set_where: page_data['set_where'] || ''
                };
                sendEvent(return_data);
                setTimeout(function () {
                    fun.hideLoad();
                }, 200);
            }
        }
    });
}