var html_name = page_arr.cw_cbhs_zero;
var search_data = {
  "lcbjs": 0,
  "is_mobile": 1,
  "zdy_bpxsthjs_cbj": 0,
  "zdy_bpxsthjs_cbj_list": [],
  "status": "save"
};
var search_storage = {};
var page_list = [],
  page_str = '',
  type_arr = [
    { 'name': '相同产品相同成本', 'id': 'cpcb', type: 'cpcb', is_choose: 0 },// is_choose: 1
    { 'name': '相同产品相同颜色相同成本', 'id': 'cpyscb', type: 'cpyscb', is_choose: 0 },
  ];

$('#header').header({
  back: true,
  title: '以下成本为0',
  set: true,
  filter: true,
  appendBackBtnEvt: closePage
});

page_init = function () {
  $('#content').css('min-height', 'auto');
  fun.keyboardEject('.operation');
  search_storage = $.extend(true, {
    'xs0cb': fun.getItem(html_name + '_xs0cb', 1),
    'hldj': fun.getItem(html_name + '_hldj', 0),
    'xsmx': fun.getItem(html_name + '_xsmx', 0),
  }, search_storage);

  search_data = $.extend({}, search_data, search_storage);
  getIdarr();
  getList();
  //接收搜索页值 
  api.addEventListener({
    name: html_name
  }, function (ret, err) {
    var temp = ret['value'];
    console.log('-----');
    console.log(temp);
    switch (temp['status']) {
      case 'search':
        var param = ret.value.data;

        search_data['xs0cb'] = param['xs0cb'];                        //只显示成本为0记录
        search_data['hldj'] = param['hldj'];                          //合拢单据
        search_data['xsmx'] = param['xsmx'];                          //显示明细数据


        //搜索菜单需要缓存的数据
        search_storage['xs0cb'] = search_data['xs0cb'];

        search_storage['hldj'] = search_data['hldj'];
        search_storage['xsmx'] = search_data['xsmx'];

        // fun.setItem(html_name + '_ycysh', search_storage['ycysh']);
        fun.setItem(html_name + '_hldj', search_storage['hldj']);
        fun.setItem(html_name + '_xsmx', search_storage['xsmx']);
        fun.setItem(html_name + '_xs0cb', search_storage['xs0cb']);

        fun.setItem(html_name + 'sideslip', true);

        $('#content').empty();
        page_list = [];
        getList();
        break;
    }
  });
  fun.inputType();
}

function getList() {
  fun.ajax({
    showLoad: true,
    hideLoad: true,
    url: AJAX_URL.saveCwCbhsInfo,
    timeout: 3600000,
    data: $.extend({
      begin_time: page_data.begin_time,
      end_time: page_data.end_time
    }, search_data),
    success: function (res) {
      if (res['status'] == 'LCB_TS') {
        if (!res['data'] || res['data'].length == 0) {
          // return $('#content').html('<p class="empty_text cpfx_text">暂无数据！</p>');
          return fun.createDataEmptyTips({ dom: '#content', btnShow: false });
        }
        page_list = res.data;
        $('#content').empty();
        // showList(formatData(page_list || []));
        showList(formatData(page_list || []));
        // showData(page_list || []);
      } else if (res['status'] == 0) {
        fun.toast('保存成功！');
        closePage();
      } else {
        return fun.alert({ msg: '网络异常！' });
      }
    }
  });
}

// 格式化数据
function formatData(data) {
  // console.log(JSON.stringify(data))

  if ($.nui.isEmpty(data)) {
    return [];
  }
  var list = [],
    tmp = {};
  for (var i = 0; i < data.length; i++) {
    var val = data[i];
    var key = val['cp_id'] + '_' + val['ck_id'] + '_' + val['cp_ys_id'] + '_' + val['dw_id'] + '_' + val['gg'] + '_' + val['ph'];
    if (!tmp[key]) {
      tmp[key] = {
        "ck_id": val['ck_id'] || 0,
        "ck_mc": val['ck_mc'] || '',
        "cp_id": val['cp_id'] || 0,
        "cp_mc": val['cp_mc'] || '',
        "cp_bh": val['cp_bh'] || '',
        "cp_ys_id": val['cp_ys_id'] || 0,
        "cp_ys_mc": val['cp_ys_mc'] || '',
        "cp_ys_bh": val['cp_ys_bh'] || '',
        "gg": val['gg'] || '',
        "dw_id": val['dw_id'] || 0,
        "dw_mc": val['dw_mc'] || '',
        "zsl": val['zsl'] || 0,
        "ph": val['ph'] || '',
        "zdy_cbj": val['zdy_cbj'] || 0,
        list: []
      }
    }
    tmp[key]['list'].push(val);
  }
  for (var i in tmp) {
    list.push(tmp[i]);
  }
  // console.log(JSON.stringify(tmp))
  // console.log(JSON.stringify(list))
  return list;
}

function showList(data) {
  // console.log(JSON.stringify(data))
  var hldj = fun.getItem(html_name + '_hldj', 1);
  var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;
  var xs0cb = fun.getItem(html_name + '_xs0cb') == 1 ? true : false;

  var order_data = [];
  if (xs0cb) {
    for (var i = 0; i < data.length; i++) {
      if (data[i]['zdy_cbj'] == 0) {
        order_data.push(data[i]);
      }
    }
  } else {
    order_data = data;
  }
  $('#content').OrderList({
    data: order_data,
    schedule: false,
    isExpand: !hldj,
    isNoExpand: xsmx,
    render: {
      titlebar: function (res) {
        // console.log(JSON.stringify(res))
        // var info = res['list'][0];
        var Html = [];
        var data_gg = res['gg'] || '';
        var data_ph = res['ph'] || '';
        var data_cp = fun.is_value(res['cp_bh']) + ' ' + fun.is_value(res['cp_mc']);
        var data_ys = fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']);
        // 计算总数
        var zsl = 0, dw_mc = res['dw_mc'];
        var dw = [], dw_id = [], zdy_cbj = [], zdy_cbj2 = [];
        var cbj = res['zdy_cbj'];
        $(res['list']).each(function (i, obj) {
          zsl += obj['zsl'];
          dw.push(obj['dw_id']);
          dw_id.push(obj['dw_id']);
          zdy_cbj.push(obj['zdy_cbj']);
          zdy_cbj2.push(obj['zdy_cbj']);
        })
        //同组单位不同，不显示单位
        for (var k = 0; k < dw_id.length; k++) {
          if (dw[0] != dw_id[k]) {
            dw_mc = '';
          }
        }
        //同组成本价，不同显示0
        for (var k = 0; k < zdy_cbj.length; k++) {
          if (zdy_cbj2[0] != zdy_cbj[k]) {
            cbj = 0;
          }
        }
        Html.push('<div class="list-drck store-name" >' + data_cp + ' ');
        Html.push('   <i>' + data_ys + '</i>');
        Html.push('</div>');
        if (data_gg || data_ph) {
          Html.push('<div class="list-drck">');
          Html.push('   <span class="list-span"><i class="info-title">规格</i><i class="info-date">' + data_gg + '</i></span>');
          Html.push('   <span class="list-span"><i class="info-title">批号</i><i class="info-date">' + data_ph + '</i></span>');
          Html.push('</div>');
        }
        Html.push('<div class="list-drck">');
        Html.push('   <span class="list-span"><i class="info-title">仓库</i><i class="info-date">' + fun.is_value(res['ck_mc']) + '</i></span>');
        Html.push('   <span class="list-span"><i class="info-title">总数</i><i class="info-date">' + zsl + ' ' + dw_mc + '</i></span>');
        Html.push('</div>');
        Html.push('<div class="list-drck">');
        Html.push('   <span class="list-span"><i class="info-title">成本</i><input type="text" id="' + 'cb_' + $.nui.getRandomNum() + '" class="info-date unitprice num-input" num_type="2" decimal_digits="6" value="' + cbj + '" data-cpid="' + res['cp_id'] + '" data-cpysid="' + res['cp_ys_id'] + '" data-list=\'' + fun.formatString(JSON.stringify(res)) + '\'/></span>');
        Html.push('</div>');
        return Html.join('');
      },
      subtitle: function (res) {
        var htmlArr = [];
        htmlArr.push('<div class="list-drck list-drck2" data-res=\'' + fun.formatString(JSON.stringify(res)) + '\'>');
        htmlArr.push('   <span class="list-span">' + fun.is_value(res['wldw_mc']) + '</span>');
        htmlArr.push('   <span class="list-span list-zdr">' + fun.is_value(res['kdsj']) + ' ' + fun.is_value(res['zdr_mc']) + '</span>');
        htmlArr.push('</div>');
        return htmlArr.join('');
      },
      subdata: function (res) {
        var htmldrck = [];
        htmldrck.push('<div class="list-drck list-info">');
        htmldrck.push('   <span class="list-span">' + fun.is_value(res['djlx_mc']) + '</span>');
        htmldrck.push('   <span class="list-span list-right">' + (res['zsl'] || 0) + ' ' + fun.is_value(res['dw_mc']) + '</span>');
        htmldrck.push('</div>');
        return htmldrck.join('');
      }
    },
  });

  if (data.length == 0) {
    return fun.createDataEmptyTips({ dom: '#content', btnShow: false });
  }

  $('#content li').each(function (i, obj) {
    $(obj).css({
      border: '1px solid #fff',
    });
    if ($(obj).find(".unitprice").val() == 0) {
      $(obj).css({
        border: '1px solid #B2D5F9',
      });
    }
  });
}

//设置事件
$('body').on('touchend', '#set_btn', function (e) {
  e.preventDefault();
  fun.showBookList({
    width: '280px',
    shadeClose: true,
    list: type_arr,
    choose: function (res) {
      // console.log(JSON.stringify(res))
      fun.setItem(html_name + '_id', res['id']);
      getIdarr();
    }
  })
});

function getIdarr() {
  var get_id = fun.getItem(html_name + '_id') || [];
  $(type_arr).each(function (i, obj) {
    obj['is_choose'] = 0;
    if (get_id.indexOf(String(obj['id'])) > -1) {
      obj['is_choose'] = 1;
    }
  })

}
//获取
$("body").off('click tap focus', '.title-bar .unitprice').on('click', '.title-bar .unitprice', function (e) {
  e.stopPropagation();
});
//明细数据没开启。点击记录无效
$('body').on('click', '.row-list', function () {
  if (fun.getItem(html_name + '_xsmx', 0)) return;
})
function cssTyst(data, sun) {
  var curValue = sun || 0;
  if (curValue == 0) {
    $(data).parents('li').css({
      border: '1px solid #B2D5F9',
    });
  } else if (curValue > 0) {
    $(data).parents('li').css({
      border: '1px solid #fff',
    });
  }
}
//失去焦点
$("body").on('blur', '.unitprice', function () {
  var curValue = $(this).val();
  var list = $(this).data('list');
  // console.log(JSON.stringify(list))
  var ck_mc = list['ck_mc'];
  var cp_mc = list['cp_id'];
  var cp_ys = list['cp_ys_mc'];
  var dw_mc = list['dw_mc'];
  var ph_mc = list['ph'];
  cssTyst(this, curValue);
  var sz_id = fun.getItem(html_name + '_id') || [];
  $('.unitprice').each(function (i, obj) {
    var data = $(this).data('list');
    var ck = data['ck_mc'];
    var cp = data['cp_id'];
    var ys = data['cp_ys_mc'];
    var dw = data['dw_mc'];
    var ph = data['ph'];

    if (sz_id == "cpyscb") {
      if (cp === cp_mc && ys === cp_ys && ck === ck_mc && dw === dw_mc && ph === ph_mc) {
        $(obj).val(curValue);
        cssTyst(obj, curValue);
      }
    } else if (sz_id == "cpcb") {
      if (cp === cp_mc && ck === ck_mc && dw === dw_mc && ph === ph_mc) {
        $(obj).val(curValue);
        cssTyst(obj, curValue);
      }
    }
  });
});

//成本计算
$('body').on('tap', '.cbjs', function () {
  saveCbhs();
});

//保存
$('body').on('tap', '.save', function () {
  var cb_count = 0;
  $('.unitprice').each(function (i) {
    if ($(this).val() == 0) cb_count++;
  });

  if (cb_count > 0) {
    return fun.toast('成本价不能为0');
  }
  saveCbhs();
});

function saveCbhs() {
  var data_list = [];
  var data_val = [];
  var data_sea = [];
  $('.unitprice').each(function (i, obj) {
    // data_val.push($(obj).data('list'));
    data_val.push({
      val: $(obj).val(),
      list: $(obj).data('list'),
      // cp_id: $(obj).data('cpid'),
      // cp_ys_id: $(obj).data('cpysid'),
    })
  });
  $('.summary-title').each(function (k, obj) {
    data_list.push($(obj).data('list'));
  })
  // console.log(JSON.stringify(data_list));
  // console.log(JSON.stringify(data_val));

  for (var i = 0; i < data_list.length; i++) {
    for (var k = 0; k < data_val.length; k++) {
      var list = data_list[i];
      var val = data_val[k]['list'];
      if (list['cp_id'] === val['cp_id']) {
        if (list['ck_id'] === val['ck_id']) {
          if (list['cp_ys_id'] === val['cp_ys_id']) {
            if (list['dw_id'] === val['dw_id']) {
              if (list['gg'] === val['gg']) {
                if (list['ph'] === val['ph']) {
                  list['zdy_cbj'] = data_val[k]['val'] || 0;
                }
              }
            }
          }
        }
      }
      // if (data_list[i]['cp_id'] == data_val[k]['cp_id']) {
      //   if (data_list[i]['cp_ys_id'] == data_val[k]['cp_ys_id']) {
      //     data_list[i]['zdy_cbj'] = data_val[k]['val'] || 0;
      //   }
      // }
    }
    data_sea.push({
      djlx: list['djlx'],
      dj_id: list['dj_id'],
      jl_id: list['jl_id'],
      zdy_cbj: list['zdy_cbj'] || 0,
    });
  }
  search_data['zdy_bpxsthjs_cbj'] = 1;
  search_data['zdy_bpxsthjs_cbj_list'] = data_sea;
  getList();
  // console.log(JSON.stringify(data_sea));
}

function closePage() {
  setTimeout(function () {
    api.closeWin();
  }, 500);
}

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
  var sideslip = fun.getItem(html_name + 'sideslip')
  var options = {
    "switch": [
        {
        "text": "只显示成本为0记录",
        "max_width": true,
        "key": "xs0cb",
        "value": search_storage['xs0cb']
      },
      { "text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_storage['xsmx'] },
      {
        "text": "合拢单据",
        "max_width": true,
        "key": "hldj",
        "value": search_storage['hldj']
      }],
  }
  if (sideslip) {
    fun.setItem(html_name + 'sideslip', false);
    fun.openFrame({
      frame_url: page_arr.search,
      pageParam: {
        "return_page": html_name,
        "search_data": options
      },
      // y: fun.fontUnit(header)
    });
  }
});