var html_name = page_arr.cw_nbzz_kd;
var begin_lCalendar = new lCalendar();
var origin_data = {}, save_data = {}, data_list = {};
var id, dh;
var fsh = fun.getItem('sys_config')['fsh'];
//Auth.check('cw_nbzz', 'edit')
$('#header').header({
    back: true,
    title: '内部转账',
    del: Auth.check('cw_nbzz', 'edit'),
    subtitle: page_data['dh'] || '&nbsp;',
    order_info: {
        show: true,
        person: page_data['zdr_mc'] || fun.getItem('user_info')['name'],
        dateText: page_data['kdsj'] || fun.formatDate(new Date())
    },
    print: true,
    appendBackBtnEvt: isDataChange
});
// $("input").attr("disabled", "disabled");// 不可编辑，可以传值
fun.clearItem('zh_list');
$("button").hide();
$('#del_btn,#print_btn').hide();
var Bills = {djlx: 'cw_nbzz'};
Bills['print_config'] = {};

Bills['__post_sign'] = $.nui.getRandomNum();

var __Fun = {};

page_init = function () {
    // fun.load_DATA_LIST(['zh']);
    id = page_data['id'];


    $('#print_btn').hide();
    //【账户-显示存款】没有开启
    if(!Auth.check('zh_xsck','view')) {
        $('.deposit').hide();
    }
    //监听返回键
    page_data.keyback = function () {
        isDataChange();
    };

    //监听页面返回值
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'] || {},
            data = temp['data'] || {};
        switch (temp['status']) {
            case 'select_list':
                setSelectVal(temp['data']);

                if ((origin_data['dj']['zczh'] != data['select_val']) || (origin_data['dj']['zrzh'] != data['select_val'])) {
                    $('.audit').hide();
                    $('.saves').show();
                }
                break;
            case 'refresh_dj'://保存、审核、作废 不关闭页面，只更新状态
                init();
                break;
        }
    });
    //时间控件
    begin_lCalendar.init({
        'trigger': '#kdsj',
        'type': 'datetime',
        'callback': function (date) {
            $('#kdsj').text(fun.formatDate(date));

            if (origin_data['dj']['kdsj'] != date) {
                $('.audit').hide();
                $('.saves').show();
            }
        }
    });

    init();
}


function init() {
    $('button').hide();
    if (!(Auth.check('cw_nbzz', 'edit'))) {
        $("input,#bz").attr("disabled", true);
        $('#del_btn').hide()
        $('.operation').hide();
    }

    if ($.nui.isTrue(page_data['id'])) {
        $('#print_btn').show();
        getData(page_data);
    } else {
        getDh();//获取单号
        jezhz();//金额转汉字
        takeData();//账户操作
        $('#del_btn').hide();
        $('.saves').show();
        $('#wz').val('');
    }
}

/**
 * 方法
 */
//监听后获得数据处理
function setSelectVal(data) {
    var icon = data['list_data']['icon'];
    switch (data['page_name']) {
        case 'zczh':
            if (data['id'] != $('#zczh').data('id') && data['id'] != $('#zrzh').data('id')) {
                $('#zczh').val(data['select_val']).data('id', data['id']);
                icon && $('#cimg').attr('src', '../img/bank/' + icon).show();
                getZhxx(data);
            }
            if (data['id'] == $('#zrzh').data('id')) {
                fun.toast('转出账户不能与转入账户一致');
            }
            break;
        case 'zrzh':
            if (data['id'] != $('#zrzh').data('id') && data['id'] != $('#zczh').data('id')) {
                $('#zrzh').val(data['select_val']).data('id', data['id']);
                icon && $('#rimg').attr('src', '../img/bank/' + icon).show();
                getZhxx(data);
            }
            if (data['id'] == $('#zczh').data('id')) {
                fun.toast('转出账户不能与转入账户一致');
            }
            break;
    }
}

//获取账户子列表信息
function getZhxx(data) {
    fun.getBankSubInfo({
        'zh_id': data['id'],
        'sj': $('#kdsj').text().trim(),
        'callback': function (res) {
            var data_name = {'zh': data['page_name'], 'ljck': res['ljck']}
            setQqje(data_name);
        }
    })
}

//前存&前欠
function setQqje(data) {
    switch (data['zh']) {
        case 'zczh':
            $('#cqc').val(data['ljck']);
            setClcje(data['zh']);
            break;
        case 'zrzh':
            $('#rqc').val(data['ljck']);
            setRlcje(data['zh']);
            break;
    }
}

//转出账号累存
function setClcje() {
    var qqje = parseFloat($('#cqc').val() || 0),
        je = parseFloat($('#money').val() || 0),
        csxf = parseFloat($('#csxf').val() || 0),
        ljqk = 0;
    if (isNaN(je)) je = 0;
    if (isNaN(csxf)) csxf = 0;
    ljqk = (qqje - je - csxf);
    $('#clc').val(ljqk.fixed());
}

//转入账号累存
function setRlcje() {
    var qqje = parseFloat($('#rqc').val() || 0),
        je = parseFloat($('#money').val() || 0),
        ljqk = 0;
    if (isNaN(je)) je = 0;
    ljqk = (qqje + je);
    $('#rlc').val(ljqk.fixed());
}

//获取单号
function getDh() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBillsPageDefInfo,
        data: {
            'djlx': 'cw_nbzz',
            'table': 'nbzz_dj'
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    dh = res.data.dh;
                    $('.subtitle').text(dh)
                    break;
                default:
                    fun.alert({msg: '网络异常'});
                    break;
            }

            origin_data = getSaveData();
        }
    })

}

//获取数据
function getData(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getNbzzInfo,
        data: {
            id: page_data['id']
        },
        success: function (res) {
            if (res.status != 0) return fun.alert({msg: '网络异常！'});
            data_list = res.data.dj
            showData(data_list);
        }
    });
}

//获取的数据进行加载
function showData(data) {
    $('input,#kdsj,#bz').removeAttr('disabled');
    begin_lCalendar.disabled = false;
    
    if (Auth.check('cw_nbzz', 'edit') && data['is_sh'] == 0) {//有权限或者单据未审核
        takeData();
        $('#del_btn').show();
        // $('.revocatory,.obsolete').hide();
        // $('.audit,.saves,#del_btn').show();
        // if (!Auth.check('cw_nbzz', 'check')) {//没有审核权限
        //     $('.audit').hide();
        // }
        $('.audit').show();

        $(':input').on('input propertychange', function(){
            $('.audit').hide();
            $('.saves').show();
        })

        if (Auth.check('cw_nbzz', 'check')) {//没有审核权限
            // $(':input').on('input propertychange', function(){
            //     $('.audit').hide();
            //     $('.saves').show();
            // })
        } else {
            $('.audit').hide();
        }
    } else if (Auth.check('cw_nbzz', 'edit') && data['is_sh'] == 1) {//有权限并且单据已审核
        $('#money,#bz').attr('disabled', true);
        // $('.audit,.saves').hide();
        begin_lCalendar.disabled = true;
        $('#kdsj').attr('disabled', true);
        $('#del_btn,.saves').hide();
        if ((!data['is_zf']) && Auth.check('cw_nbzz', 'invalid')) {//未作废、有作废权限并且【系统设置-反审核】有开启
            // $('.revocatory').hide();
            $('.obsolete').show();
        }
        if ((!data['is_zf']) && Auth.check('cw_nbzz', 'invalid')) {//未作废、有作废权限并且【系统设置-反审核】没有开启
            // $('.obsolete').hide();
            $('.revocatory').show();
        }
    }

    if (!Auth.check('cw_nbzz', 'edit')) {
        $('input').attr('disabled', true);
        $('#kdsj').attr('disabled', true);
        begin_lCalendar.disabled = true;
        $('#kdsj').attr('disabled', true);

        $('#del_btn,.saves').hide();

        if ((!data['is_zf']) && Auth.check('cw_nbzz', 'invalid') && data['is_sh']) {//未作废、有作废权限并且【系统设置-反审核】有开启
            // $('.revocatory').hide();
            $('.obsolete').show();
        }

        if(!data['is_sh'] && Auth.check('cw_nbzz', 'check')) {
            $('.audit').show();
        }
    }

    if (!Auth.check('cw_nbzz', 'invalid')) {
        $('.obsolete').hide();
    }
    if (!Auth.check('cw_nbzz', 'check')) {
        $('.audit').hide();
    }

    if (data['is_zf']) {
        fun.seal({type: 'zf'});
    } else if (data['is_sh']) {
        fun.seal({type: 'sh'});
    } else {
        if ($('body').find('#state_icon').length) $('body').find('#state_icon').remove();
    }

    if (data['is_sh']) {
        $("input,#bz").attr("disabled", true);
    }

    var zc_icon = fun.getValByKey(fun.getItem('zh_list') || [], data['zc_zh_id'], 'icon');
    var zr_icon = fun.getValByKey(fun.getItem('zh_list') || [], data['zr_zh_id'], 'icon');

    $('.subtitle').text(data['dh'] || '');

    $('#zdr').text(data['zdr_mc'] || fun.getItem('user_info')['name']);

    zc_icon && $('#cimg').attr('src', '../img/bank/' + zc_icon).show();//转出账户图片
    $('#zczh').val(fun.is_value(data['zc_zh_mc']) || '');//转出账户
    $('#zczh').data('id', data['zc_zh_id']);//转出账户id
    $('#cqc').val(fun.is_value(data['zc_qcje']) || 0);//前存
    $('#clc').val(fun.is_value(data['zc_ljqk']) || 0);//累存
    $('#money').val(fun.is_value(data['je']) || 0);//转出金额
    jezhz();
    $('#csxf').val(fun.is_value(data['sxf']) || 0);//手续费
    //转入账户
    zr_icon && $('#rimg').attr('src', '../img/bank/' + zr_icon).show();//转出账户图片
    $('#zrzh').val(fun.is_value(data['zr_zh_mc']) || '');//转出账户
    $('#zrzh').data('id', data['zr_zh_id']);//转出账户id
    $('#rqc').val(fun.is_value(data['zr_qcje']) || 0);//前存
    $('#rlc').val(fun.is_value(data['zr_ljqk']) || 0);//累存
    $('#bzs').val(fun.is_value(data['bz']) || '');//备注
    __Fun.btnCheckShow();
    origin_data = getSaveData();
}

//获取数据
function getSaveData() {
    var dj = {};
    dj = {
        id: page_data['id'] || 0,
        save_time: data_list['save_time'] || '',//保存日期
        jsr_id: data_list['jsr_id'] || 0,//
        zdr_id: fun.getItem('user_info')['id'] || 0,//制单人id
        md_id: fun.getItem('user_info')['store_id'] || '',//门店id
        kdsj: $('#kdsj').text().trim(),//开单时间
        lsh: data_list['dj_lsh'] || '',//流水号
        dh: $('.subtitle').text().trim() || '',//单号
        zc_zh_id: $('#zczh').data('id') || 0,//转出账户id
        zr_zh_id: $('#zrzh').data('id') || 0,//转入账户id
        je: parseFloat($('#money').val() || 0),//转出金额
        sxf: parseFloat($('#csxf').val() || 0),//手续费
        bz: $('#bzs').val() || '',//备注
        zczh: $('#zczh').val().trim() || "",
        zrzh: $('#zrzh').val().trim() || "",
    }
    var data = {dj: dj, jl: []};
    return data;
}

//保存
function saveData() {
    var dj = {}
    var save_data = getSaveData();
    dj = save_data['dj']
    if ($.nui.isEmpty(dj['kdsj'])) return fun.toast('日期不能为空');
    if ($.nui.isEmpty(dj['dh'])) return fun.toast('单号不能为空');
    if (!Check.kzrq({sj: dj['kdsj']})) return false;
    if (!Check.yjrq({sj: dj['kdsj']})) return false;
    if (dj['zc_zh_id'] == '') return fun.toast('转出账户不能为空');
    if (fun.Splitdate(dj['kdsj']) < fun.Splitdate(fun.getValByKey(fun.getItem('zh_list') || [], dj['zc_zh_id'], 'date'))) {
        return fun.toast(tips_arr['小于建立日期提示-账户']);
    }
    if (dj['zr_zh_id'] == '') return fun.toast('转入账号不能为空');
    if (fun.Splitdate(dj['kdsj']) < fun.Splitdate(fun.getValByKey(fun.getItem('zh_list') || [], dj['zr_zh_id'], 'date'))) {
        return fun.toast(tips_arr['小于建立日期提示-账户']);
    }
    if (dj['zc_zh_id'] == dj['zr_zh_id']) return fun.toast('转出账户和转入账户不能相同');
    if (dj['je'] <= 0) return fun.toast(tips_arr['空单提示']);
    var data = {status: 'save', dj: dj, jl: [],__post_sign: Bills['__post_sign']};
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveNbzzInfo,
        data: data,
        success: function (res) {
            if(res['status'] !== 0)  Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('保存成功。');
                    page_data['id'] = res['data']['dj_id'];
                    id = page_data['id'];
                    closePage();
                    break;
                case 'ZH_SJ_IS_LESS':
                    if (res['data']['zh_lx'] == 'zc_zh') {
                        fun.toast(tips_arr['小于建立日期提示-账户'])
                    } else if (res['data']['zh_lx'] == 'zr_zh') {
                        fun.toast(tips_arr['小于建立日期提示-账户'])
                    }
                    break;
                case 'IS_EDITED':
                case 'IS_DELETE':
                case 'IS_AUDIT':
                    fun.toast(res['msg']);
                    // fun.dialog({
                    //     content:res['msg'],
                    //     btn: ['确定'],
                    //     yes:function(){
                    //         closePage();
                    //     }
                    // });
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
            fun.hideLoad();
        }
    })
}

//删除
function delData(data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('cw_nbzz', 'delete')) return false;
    if (!Auth.qfmd({'key': 'delete', 'md_id': data_list['md_id']})) return false;
    if (!Auth.qfczy({'key': 'delete', 'zdr_id': data_list['zdr_id']})) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveNbzzInfo,
        data: {status: 'delete', scr_id: fun.getItem('user_info')['id'], dj_id: data['id'][0],__post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('删除成功。');
                    // closePage();
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });
                    setTimeout(function () {
                        api.closeWin();
                    }, 200);
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.dialog({
                    // 	content:res['msg'],
                    // 	btn: ['确定'],
                    // 	yes:function(){
                    // 		if(['IS_DELETE'].indexOf(res['status'] > - 1)){
                    // 			closePage();
                    // 		}
                    // 	}
                    // });
                    break;
            }
            fun.hideLoad();
        }
    })
}

//审核事件
function audit(data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('cw_nbzz', 'check')) return false;
    if (!Auth.qfmd({'key': 'check', 'md_id': data_list['md_id']})) return false;
    if (!Auth.qfczy({'key': 'check', 'zdr_id': data_list['zdr_id']})) return false;
    fun.ajax({
        url: AJAX_URL.saveNbzzInfo,
        data: {status: 'audit', shr_id: fun.getItem('user_info')['id'], dj_id: data['id'][0],__post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('审核成功。');
                    closePage();
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.dialog({
                    // 	content:res['msg'],
                    // 	btn: ['确定'],
                    // 	yes:function(){
                    // 		if(['IS_AUDIT'].indexOf(res['status'] > - 1)){
                    // 			closePage();
                    // 		}
                    // 	}
                    // });
                    break;
            }
            fun.hideLoad();
        }
    })
}

//作废事件
function obsolete(data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('cw_nbzz', 'invalid')) return false;
    if (!Auth.qfmd({'key': 'invalid', 'md_id': data_list['md_id']})) return false;
    if (!Auth.qfczy({'key': 'invalid', 'zdr_id': data_list['zdr_id']})) return false;
    fun.ajax({
        url: AJAX_URL.saveNbzzInfo,
        data: {
            status: 'cancel',
            zfr_id: fun.getItem('user_info')['id'],
            dj_id: data['id'][0],
            zf_yy: '',
            scxd: (data.index == 0) ? 1 : 0,
            __post_sign: Bills['__post_sign']
        },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('作废成功。');
                  
                    if (data.index == 0) {
                        page_data['id'] = res['data']['dj_id'];
                        id = page_data['id'];
                    }else{
                        $('.operation').hide();
                        $('.contents').css('padding-bottom',0);
                    }

                    closePage();
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
            fun.hideLoad();
        }
    })
}

//关闭当前窗口
function closePage() {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh',
        }
    });
    api.sendEvent({
        name: html_name,
        extra: {
            'status': 'refresh_dj',
        }
    });
    // setTimeout(function () {
    // 	api.closeWin();
    // }, 200);
}

//返回事件
function isDataChange() {
    save_data = getSaveData();
    if (!$.nui.isObjEquals(origin_data, save_data)) {
        if ($('body').find('.data-change-skin').length) return;
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData();
            },
            no: function () {
                // api.sendEvent({
                // 	name: page_data['return_page'],
                // 	extra: {
                // 		'status': 'refresh',
                // 	}
                // });
                api.closeWin();
            }
        });
    } else {
        // api.sendEvent({
        // 	name: page_data['return_page'],
        // 	extra: {
        // 		'status': 'refresh',
        // 	}
        // });
        api.closeWin();
    }
}

/**
 * 点击事件
 */
function takeData() {
    $('#zczh').on('tap', function () {
        if ($(this).attr('disabled')) return;
        fun.showPageFull({
            page_url: page_arr.select_bank_list,
            pageParam: {
                return_page: html_name,
                page_type: 'zh',
                page_name: 'zczh'
            }
        });
    })
    $('#zrzh').on('tap', function () {
        if ($(this).attr('disabled')) return;
        fun.showPageFull({
            page_url: page_arr.select_bank_list,
            pageParam: {
                return_page: html_name,
                page_type: 'zh',
                page_name: 'zrzh'
            }
        });
    })
    // //时间控件
    // begin_lCalendar.init({
    // 	'trigger': '#kdsj',
    // 	'type': 'datetime',
    // 	'callback': function (date) {
    // 		$('#kdsj').text(fun.formatDate(date));
    // 	}
    // });
}

//隐藏键盘
// fun.keyboardEject('.operation');

//金额转汉字
function jezhz() {
    var money = $('#money').val();
    if (money == 0) {
        $('#wz').val('')
    } else {
        $('#wz').val(fun.amountLtoU(money));
    }
    $('#money').bind('keyup', function () {
        money = $(this).val();
        if (isNaN(money)) {
            return;
        }
        if (money == 0) {
            $('#wz').val('')
        } else {
            $('#wz').val(fun.amountLtoU(money));
        }
        setClcje();
        setRlcje();
    });
}

$('#csxf').on('keyup', function () {
    setClcje();
})


/**
 * 按钮
 */
//保存
$('body').delay('tap', '.saves', function () {
    saveData();
})
//删除
$('body').on('tap', '#del_btn', function (e) {
    e.stopPropagation();
    save_data = getSaveData();
    if (!$.nui.isObjEquals(origin_data, save_data)) {
        return fun.toast('单据已修改，未保存，不能删除！');
    }
    fun.dialog({
        content: '您确定要删除当前单据吗？',
        btn: ['删除', '取消'],
        yes: function () {
            delData({id: [page_data['id']]});
        }
    });
});
//审核
$('body').on('tap', '.audit', function (e) {
    e.stopPropagation();
    save_data = getSaveData();
    if (!$.nui.isObjEquals(origin_data, save_data)) {
        return fun.toast('单据已修改，未保存，不能审核！');
    }
    fun.dialog({
        content: '您确定要审核当前单据吗？',
        btn: ['确定', '取消'],
        yes: function () {
            audit({id: [page_data['id']]});
        }
    });
});
//取消审核
$('body').on('tap', '.revocatory', function (e) {
    e.stopPropagation();
    fun.dialog({
        content: '您确定要取消当前单据的审核状态吗？',
        btn: ['确定', '取消'],
        yes: function () {
            /////////
        }
    });
});
//作废
$('body').on('tap', '.obsolete', function (e) {
    e.stopPropagation();
    fun.dialog({
        content: '您确定要作废当前单据吗？',
        btn: ['重新做单', '直接作废', '取消'],
        yes: function (datas) {
            obsolete({id: [page_data['id']], index: datas['index']});
        },
        no: function (datas) {
            obsolete({id: [page_data['id']], index: datas['index']});
        }
    });
});


function __checkData() {
    if (!fun.dataIsRead(['zh'])) {
        setTimeout(__checkData, 250);
    } else {
        setTimeout(function () {
            if (typeof page_init === "function") page_init();
        }, 100);
    }
}


// 
__Fun.setButtonWidth = function () {

};

// 
__Fun.btnCheckShow = function () {
    var Auth_edit = Auth.check('cw_nbzz', 'edit');
    var Auth_check = Auth.check('cw_nbzz', 'check');
    var Auth_invalid = Auth.check('cw_nbzz', 'invalid');

    if (!Auth_check) $('.audit').hide();
    if (!Auth_invalid) $('.obsolete').hide();
    if (!Auth_check && !Auth_invalid && Auth_edit) $('.saves').hide();
    if (!Auth_edit) $('.saves').hide();
};