var html_name = page_arr.cw_qtsr_kd;
var begin_lCalendar = new lCalendar();
var origin_data = {}, save_data = {}, data_dj = {}, data_jl = {};
var id, dh;
var fsh = fun.getItem('sys_config')['fsh'];

var Bills = {djlx: 'cw_srd'};
Bills['print_config'] = {};

Bills['__post_sign'] = $.nui.getRandomNum();

var __Fun = {};

page_init = function () {
    fun.load_DATA_LIST(['zh'], function () {

    });
    $('button,#del_btn').hide();
    id = page_data['id'];
    $('#header').header({
        back: true,
        appendBackBtnEvt: isDataChange,
        title: '其他收入',
        del: true,
        subtitle: page_data['dh'] || '&nbsp;',
        order_info: {
            show: true,
            person: page_data['zdr_mc'] || fun.getItem('user_info')['name'],
            dateText: page_data['kdsj'] || fun.formatDate(new Date())
        },
        print: true
    });

    $('#print_btn').hide();
    //【账户-显示存款】没有开启
    if(!Auth.check('zh_xsck','view')) {
        $('.deposit').hide();
    }
    //监听返回键
    page_data.keyback = function () {
        isDataChange();
    };


    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'] || {},
            data = temp['data'] || {};
        switch (temp['status']) {
            case 'select_list':
                setSelectVal(temp['data']);

                if ((origin_data['dj']['zh_mc'] != data['select_val']) && data['page_type'] == "zh") {
                    $('.audit').hide();
                    $('.saves').show();
                }
                break;
            // case 'search':
            // 	setSelectVal(temp['data']);
            // 	break;
            case "select_lx":
                $('#lx').val(temp['data']['select_val'] || "").data('id', temp['data']['id'] || 0);

                if ((origin_data['dj']['lx_mc'] != data['select_val']) && data['page_type'] == "income") {
                    $('.audit').hide();
                    $('.saves').show();
                }
                break;
            case 'refresh_dj'://保存、审核、作废 不关闭页面，只更新状态
                init();
                break;
            case 'update':
                var backUpDateArr = [
                    { // 门店
                        pageType: 'income',
                        idName: 'id'
                    }
                ];
                fun.upDateBackSelRow({
                    backSelRow: data,
                    backUpDateArr: backUpDateArr,
                    storageMode: 'data', // 自定义属性存储方式
                    assignMode: 'val' // 赋值方式
                });
                break;
        }
    });

    begin_lCalendar.init({
        'trigger': '#kdsj',
        'type': 'datetime',
        'callback': function (date) {
            $('#kdsj').text(fun.formatDate(date));

            if (origin_data['dj']['kdsj'] != date) {
                $('.audit').hide();
                $('.saves').show();
            }
        }
    });

    init();
}

function init() {
    $('button').hide();
    if (!(Auth.check('cw_srd', 'edit'))) {
        $("input,#bz").attr("disabled", true);
        $('#del_btn').hide();
        $('.operation').hide();
        begin_lCalendar.disabled = true;
        $('#kdsj').attr('disabled', true);
    }
    if ($.nui.isTrue(page_data['id'])) {
        $('#print_btn').show();
        getData(page_data['id']);
    } else {
        getDh();
        jezhz();
        takeData();
        $('.gys,#del_btn').hide();
        $('.saves').show();
    }
}

/**
 * 方法
 */
//获取单号
function getDh() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBillsPageDefInfo,
        data: {
            'djlx': 'cw_srd',
            'table': 'srd_dj'
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    dh = res.data.dh;
                    $('.subtitle').text(dh);
                    var icon = fun.getValByKey(fun.getItem('zh_list') || [], res['data']['zh_id'], 'icon'),
                        zh_mc = fun.getValByKey(fun.getItem('zh_list') || [], res['data']['zh_id'], 'name');
                    icon && $('#zhimg').attr('src', "../img/bank/" + icon).show();
                    $('#skzh').val(zh_mc || "").data('id', res['data']['zh_id'] || "");
                    var id = res['data']['zh_id']
                    getZhxx({'id': id});
                    break;
                default:
                    fun.alert({msg: '网络异常'});
                    break;
            }
            origin_data = getSaveData();
        }
    })

}

//处理返回值
function setSelectVal(data) {
    switch (data['page_type']) {
        case 'zh':
            var icon = data['list_data']['icon'];
            icon && $('#zhimg').attr('src', '../img/bank/' + icon).show();
            $('#skzh').val(data['select_val']).data('id', data['id']);
            getZhxx(data);
            break;
        // case 'gys':
        // 	$('#gys').val(data['select_val']).data('id', data['id']);
        // 	getGysxx(data);
        // 	break;


    }
    // switch (data['type']) {
    // 	case 'srlx':
    // 		$('#lx').val(data['name']).data('id', data['id']);
    // 		break;
    // }
}

//获得账户信息
function getZhxx(data) {
    fun.getBankSubInfo({
        'zh_id': data['id'],
        'sj': fun.formatDate(page_data['kdsj'] || $('#kdsj').text().trim(), 'YYYY-MM-DD HH:mm'),
        'callback': function (res) {
            setYhqc(res.ljck)
        }
    })
}

// //获得类型信息
// function getGysxx(data) {
// 	fun.getWldwSubInfo({
// 		'wldw_id': data['id'],
// 		'sj': $('#kdsj').text().trim(),
// 		'ljqk': 1,
// 		'zh': 1,
// 		'callback': function (res) {
// 			setQq(res['ljqk']);
// 		}
// 	})
// }
//银行前存
function setYhqc(data) {
    $('#yhqc').val(data);
    setYhlc();
}

//银行累存
function setYhlc() {
    var yhqc = parseFloat($('#yhqc').val() || 0),
        je = parseFloat($('#money').val() || 0),
        yhlc = 0;
    if (isNaN(je)) je = 0;
    yhlc = (yhqc + je)
    $('#yhlc').val(yhlc.fixed());
}

//供应商累欠
function setLq() {
    if ($('#gys').val() != '') {
        var qq = parseFloat($('#qq').val() || 0),
            je = parseFloat($('#money').val() || 0),
            ysje = parseFloat(data_dj['bdje'] || 0);
        lq = 0;
        if (isNaN(je)) je = 0;
        lq = (qq + ysje - je);
        $('#lq').val(lq.fixed());
    }
}

//获取单据数据
function getData(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSrdInfo,
        data: {id: data},
        success: function (res) {
            if (res.status != 0) return fun.alert({msg: '网络异常！'});
            data_dj = res.data.dj;
            data_jl = res.data.jl
            showData(data_dj);
        }

    })
}

//加载数据
function showData(data) {
    $('input,#kdsj,#bz').removeAttr('disabled');
    begin_lCalendar.disabled = false;

    if (Auth.check('cw_srd', 'edit') && data['is_sh'] == 0) {//有权限或者单据未审核
        takeData();
        $('#del_btn').show();
        // $('.revocatory,.obsolete').hide();
        // $('.audit,.saves,#del_btn').show();
        // if (!Auth.check('cw_srd', 'check')) {//没有审核权限
        //     $('.audit').hide();
        // }
        $('.audit').show();
        $(':input').on('input propertychange', function(){
            $('.audit').hide();
            $('.saves').show();
        })
        if (Auth.check('cw_srd', 'check')) {//没有审核权限
            // $(':input').on('input propertychange', function(){
            //     $('.audit').hide();
            //     $('.saves').show();
            // })
        } else {
            $('.audit').hide();
        }
    } else if (Auth.check('cw_srd', 'edit') && data['is_sh'] == 1) {//有权限并且单据已审核
        $('#money,#bz').attr('disabled', true);
        begin_lCalendar.disabled = true;
        $('#kdsj').attr('disabled', true);

        // $('.audit,.saves').hide();
        $('#del_btn').hide();
        if ((!data['is_zf']) && Auth.check('cw_srd', 'invalid')) {//未作废、有作废权限并且【系统设置-反审核】有开启
            $('.obsolete').show();
        }
    }

    if (!Auth.check('cw_srd', 'edit')) {
        $('input,#money,#bz').attr('disabled', true);
        begin_lCalendar.disabled = true;
        $('#kdsj').attr('disabled', true);

        $('#del_btn,#save').hide();
        if ((!data['is_zf']) && Auth.check('cw_srd', 'invalid') && data['is_sh']) {
            $('.obsolete').show();
        }

        if(!data['is_sh'] && Auth.check('cw_srd', 'check')) {
            $('.audit').show();
        }
    }

    if (!Auth.check('cw_srd', 'invalid')) {
        $('.obsolete').hide();
    }
    if (!Auth.check('cw_srd', 'check')) {
        $('.audit').hide();
    }

    if (data['is_zf']) {
        fun.seal({type: 'zf'});
    } else if (data['is_sh']) {
        fun.seal({type: 'sh'});
    } else {
        if ($('body').find('#state_icon').length) $('body').find('#state_icon').remove();
    }

    if (data['is_sh']) {
        $("input,#bz").attr("disabled", true);
    }


    $('#zdr').text(data['zdr_mc'] || fun.getItem('user_info')['name']);
    $('.subtitle').text(data['dh'] || '');

    $('#lx').val(data['srlx_mc']).data('id', data['srlx_id']);//类型
    //拿到账户的图片
    var icon = fun.getValByKey(fun.getItem('zh_list') || [], data['zh_id'], 'icon');
    icon && $('#zhimg').attr('src', '../img/bank/' + icon).show();
    $('#skzh').val(data['zh_mc']).data('id', data['zh_id']);//收款账户
    $('#money').val(data['zh_sjfse'])//收款金额
    jezhz();
    $('#yhqc').val(data['zh_qcje']);//账户前存
    $('#yhlc').val(data['zh_ljck']);//账户累存
    if (data['wldw_id'] != 0) {
        $('#gys').val(data['wldw_mc']);//供应商
        $('#qq').val(data['wldw_qqje']);//前欠
        $('#lq').val(data['wldw_ljqk']);//累欠
    } else {
        $('.gys').hide();
    }
    $('#bz').val(data['bz'])
    __Fun.btnCheckShow();
    origin_data = getSaveData();
}

function getSaveData() {
    var dj = {};
    dj = {
        id: page_data['id'] || 0,
        save_time: data_dj['save_time'] || '',//保存时间
        jsr_id: data_dj['jsr_id'] || 0,//经手人id
        wldw_id: data_dj['wldw_id'] || 0,//类型id
        zdr_id: fun.getItem('user_info')['id'] || 0,//制单人id
        md_id: fun.getItem('user_info')['store_id'],//门店id
        kdsj: $('#kdsj').text().trim(),//开单时间
        lsh: data_dj['lsh'] || '',//流水号
        dh: $('.subtitle').text().trim() || '',//单号
        zh_id: $('#skzh').data('id') || 0,//账户id
        zh_mc: $('#skzh').val().trim() || "",
        je: parseFloat($('#money').val() || 0),//收款金额
        bdje: data_dj['bdje'] || 0,//本单金额
        srlx_id: $('#lx').data('id'),//收入类型id
        bz: $('#bz').val() || '',//备注
        store_id: data_dj['store_id'] || 0,//
        lx_mc: $('#lx').val().trim() || "",
    }
    var data = {dj: dj, jl: []};
    return data;
}

//保存
function saveData() {
    var dj = {}
    var save_data = getSaveData();
    dj = save_data['dj'];
    if ($.nui.isEmpty(dj['dh'])) return fun.toast('单号不能为空。');

    if ($.nui.isEmpty(dj['kdsj'])) return fun.toast('日期不能为空。');

    if (!Check.kzrq({sj: dj['kdsj']})) return false;
    if (!Check.yjrq({sj: dj['kdsj']})) return false;

    if ($.nui.isEmpty(dj['srlx_id'])) return fun.toast('类型不能为空。');
    if ($.nui.isEmpty(dj['zh_id'])) return fun.toast('收款账户不能为空。');
    if (fun.Splitdate(dj['kdsj']) < fun.Splitdate(fun.getValByKey(fun.getItem('zh_list') || [], dj['zh_id'], 'date'))) {
        return fun.toast(tips_arr['小于建立日期提示-账户']);
    }
    if ($.nui.isEmpty(dj['je'])) return fun.toast(tips_arr['空单提示']);
    var data = {status: 'save', dj: dj, jl: data_jl,__post_sign: Bills['__post_sign']};
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveSrdInfo,
        data: data,
        success: function (res) {
            if(res['status'] !== 0)  Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('保存成功。');
                    page_data['id'] = res['data']['dj_id'];
                    id = page_data['id'];
                    closePage();
                    break;
                case 'ZH_SJ_IS_LESS':
                    fun.toast(tips_arr['小于建立日期提示-账户']);
                    break;
                case 'WLDW_SJ_IS_LESS':
                    fun.toast('结算日期不能小于供应商的建立日期。');
                    break;
                case 'IS_EDITED':
                case 'IS_DELETE':
                case 'IS_AUDIT':
                    fun.toast(res['msg']);
                    // fun.dialog({
                    //     content:res['msg'],
                    //     btn: ['确定'],
                    //     yes:function(){
                    //         closePage();
                    //     }
                    // });
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
            fun.hideLoad();
        }
    })
}

//删除
function delData(data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('cw_srd', 'delete')) return false;
    if (!Auth.qfmd({'key': 'delete', 'md_id': data_dj['md_id']})) return false;
    if (!Auth.qfczy({'key': 'delete', 'zdr_id': data_dj['zdr_id']})) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveSrdInfo,
        data: {status: 'delete', scr_id: fun.getItem('user_info')['id'], dj_id: data['id'][0],__post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('删除成功。');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });
                    setTimeout(function () {
                        api.closeWin();
                    }, 200);
                    // closePage();
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.dialog({
                    // 	content:res['msg'],
                    // 	btn: ['确定'],
                    // 	yes:function(){
                    // 		if(['IS_DELETE'].indexOf(res['status'] > - 1)){
                    // 			closePage();
                    // 		}
                    // 	}
                    // });
                    break;
            }
            fun.hideLoad();
        }
    })
}

//审核事件
function audit(data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('cw_srd', 'check')) return false;
    if (!Auth.qfmd({'key': 'check', 'md_id': data_dj['md_id']})) return false;
    if (!Auth.qfczy({'key': 'check', 'zdr_id': data_dj['zdr_id']})) return false;
    fun.ajax({
        url: AJAX_URL.saveSrdInfo,
        data: {status: 'audit', shr_id: fun.getItem('user_info')['id'], dj_id: data['id'][0],__post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('审核成功。');
                    closePage();
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.dialog({
                    // 	content:res['msg'],
                    // 	btn: ['确定'],
                    // 	yes:function(){
                    // 		if(['IS_AUDIT'].indexOf(res['status'] > - 1)){
                    // 			closePage();
                    // 		}
                    // 	}
                    // });
                    break;
            }
            fun.hideLoad();
        }
    })
}

//作废事件
function obsolete(data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('cw_srd', 'invalid')) return false;
    if (!Auth.qfmd({'key': 'invalid', 'md_id': data_dj['md_id']})) return false;
    if (!Auth.qfczy({'key': 'invalid', 'zdr_id': data_dj['zdr_id']})) return false;
    fun.ajax({
        url: AJAX_URL.saveSrdInfo,
        data: {
            status: 'cancel',
            zfr_id: fun.getItem('user_info')['id'],
            dj_id: data['id'][0],
            zf_yy: '',
            scxd: (data.index == 0) ? 1 : 0,
            __post_sign: Bills['__post_sign']
        },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('作废成功。');
                  
                    if ((data.index == 0)) {
                        page_data['id'] = res['data']['dj_id'];
                        id = page_data['id'];
                    }else{
                        $('.operation').hide();
                        $('.contents').css('padding-bottom', 0);
                    }
                    closePage();
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.dialog({
                    // 	content:res['msg'],
                    // 	btn: ['确定'],
                    // 	yes:function(){
                    // 		if(['IS_CANCEL'].indexOf(res['status'] > - 1)){
                    // 			closePage();
                    // 		}
                    // 	}
                    // });
                    break;
            }
            fun.hideLoad();
        }
    })
}

//返回
function isDataChange() {
    save_data = getSaveData();
    if (!$.nui.isObjEquals(origin_data, save_data)) {
        if ($('body').find('.data-change-skin').length) return;
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData();
            },
            no: function () {
                // api.sendEvent({
                // 	name: page_data['return_page'],
                // 	extra: {
                // 		'status': 'refresh',
                // 	}
                // });
                api.closeWin();
            }
        });
    } else {
        // api.sendEvent({
        // 	name: page_data['return_page'],
        // 	extra: {
        // 		'status': 'refresh',
        // 	}
        // });
        api.closeWin();
    }
}

//将extra广播出去并关闭当前win
function closePage() {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh',
        }
    });
    api.sendEvent({
        name: html_name,
        extra: {
            'status': 'refresh_dj',
        }
    });
    // setTimeout(function () {
    // 	api.closeWin();
    // }, 200);
}

//关闭
/**
 * 点击事件
 */
//选择事件
function takeData() {
    //选择账户
    $('#skzh').on('tap', function () {
        if ($(this).attr('disabled')) return;
        fun.showPageFull({
            page_url: page_arr.select_bank_list,
            pageParam: {
                return_page: html_name,
                page_type: 'zh'
            }
        });
    })
    //选择类型
    $('#lx').on('tap', function () {
        if ($(this).attr('disabled')) return;
        fun.showPageFull({
            page_url: page_arr.cost_type,
            pageParam: {
                return_page: html_name,
                page_type: 'income',
                obj: 'income',
            }
        })
    })

    // begin_lCalendar

}

//选择供应商
// function gysSelect(){
// 	$('#gys').on('tap', function () {
// 		fun.showPageFull({
// 			page_url: page_arr.customer_search,
// 			pageParam: {
// 				return_page: html_name,
// 				page_type: 'gys'
// 			}
// 		})
// 	})
// }
//供应商前欠
// function setQq(data) {
// 	$('#qq').val(data);
// 	setLq();
// }
//金额转汉字
function jezhz() {
    var money = $('#money').val();
    if (money == 0) {
        $('#wz').val('')
    } else {
        $('#wz').val(fun.amountLtoU(money));
    }
    $('#money').bind('keyup', function () {
        money = $(this).val();
        if (isNaN(money)) {
            return;
        }

        if (money == 0) {
            $('#wz').val('')
        } else {
            $('#wz').val(fun.amountLtoU(money));
        }
        setYhlc();
        setLq();
    });
}

//隐藏键盘
// fun.keyboardEject('.operation');

//保存
$('body').delay('tap', '.saves', function (e) {
    saveData();
})
//删除
$('body').on('tap', '#del_btn', function (e) {
    e.stopPropagation();
    save_data = getSaveData();
    if (!$.nui.isObjEquals(origin_data, save_data)) {
        return fun.toast('单据已修改，未保存，不能删除！');
    }
    fun.dialog({
        content: '您确定要删除当前单据吗？',
        btn: ['删除', '取消'],
        yes: function () {
            delData({id: [page_data['id']]});
        }
    });
});
//审核
$('body').on('tap', '.audit', function (e) {
    e.stopPropagation();
    save_data = getSaveData();
    if (!$.nui.isObjEquals(origin_data, save_data)) {
        return fun.toast('单据已修改，未保存，不能审核！');
    }
    fun.dialog({
        content: '您确定要审核当前单据吗？',
        btn: ['确定', '取消'],
        yes: function () {
            audit({id: [page_data['id']]});
        }
    });
});
//取消审核
$('body').on('tap', '.revocatory', function (e) {
    e.stopPropagation();
    fun.dialog({
        content: '您确定要取消当前单据的审核状态吗？',
        btn: ['确定', '取消'],
        yes: function () {
            /////////
        }
    });
});
//作废
$('body').on('tap', '.obsolete', function (e) {
    e.stopPropagation();
    fun.dialog({
        content: '您确定要作废当前单据吗？',
        btn: ['重新做单', '直接作废', '取消'],
        yes: function (datas) {
            obsolete({id: [page_data['id']], index: datas['index']});
        },
        no: function (datas) {
            obsolete({id: [page_data['id']], index: datas['index']});
        }
    });
});

// 
__Fun.setButtonWidth = function () {

};

// 
__Fun.btnCheckShow = function () {
    var Auth_edit = Auth.check('cw_srd', 'edit');
    var Auth_check = Auth.check('cw_srd', 'check');
    var Auth_invalid = Auth.check('cw_srd', 'invalid');

    if (!Auth_check) $('.audit').hide();
    if (!Auth_invalid) $('.obsolete').hide();
    if (!Auth_check && !Auth_invalid && Auth_edit) $('.saves').hide();
    if (!Auth_edit) $('.saves').hide();
};