var html_name = page_arr.cw_ybb;
var search_data = {};
var data_list, year, month;
var md_id;
var cwYbb = {};

cwYbb.initBefore = function () {
    //改变头部时间的样式
    $('#pre_time').css('float', 'none').parent().css({ 'left': 0, 'width': '100%', 'text-align': 'center' });
    $('.show-all3>span').attr('data-type', 'md');

    $('.show-all3').addClass('ybb-header-shop-left');
    $('.icon-search').addClass('ybb-header-search-icon');
    $('.icon-search + span').addClass('ybb-header-shop-titie');
}

$('#header').header({
    back: true,
    title: '月报表',
    more: true,
    ybb: {
        show: true,
    }
});

page_init = function () {
    // api.setCustomRefreshHeaderInfo({
    //     bgColor: '#C0C0C0',
    //     image: {
    //         icon: 'widget://image/refresh/miao.png',
    //         borderColor: '#f00'
    //     }
    // }, function() {
    //     api.addEventListener({
    //         name: 'shake'
    //     }, function(ret, err) {
    //         api.refreshHeaderLoadDone()
    //     });
    // });
    cwYbb.initBefore();
    //获取数据列表
    getList();
    //监听页面返回值
    api.addEventListener({
        name: page_name
    }, function (ret, err) {
        console.log('----------');
        console.log(ret);
        console.log('----------');
        var temp = ret['value'],
            temp_data = temp['data'];
        switch (temp['status']) {
            case 'location':
                if ($('#' + temp_data['index']).length) {
                    $('body,html').animate({
                        scrollTop: $('#' + temp_data['index']).offset().top - 110 - api.safeArea.top
                    }, 500);
                }
                break;
            case 'select_list':
                md_id = temp_data['id'];
                $('.show-all3>span').text(temp_data['select_val']).data('id', temp_data['id']);
                $('.contents').empty();
                getList();
                break;
            case 'update': // TODO 有问题（未完成，需要重新检查）
                var backUpDateArr = [
                    { // 门店
                        pageType: 'md',
                        idName: 'id'
                    }
                ];
                fun.upDateBackSelRow({
                    backSelRow: temp_data,
                    backUpDateArr: backUpDateArr,
                    storageMode: 'data', // 自定义属性存储方式
                    assignMode: 'text' // 赋值方式
                });
                upDateAfter();
                function upDateAfter() {
                    if ($.nui.isEmpty($('.show-all3>span').text().trim())) {
                        $('.show-all3>span').text('全部门店').data('id', 0);
                        md_id = 0;
                        getList();
                    }
                }
                break;
        }
    });
}
//获得数据
function getList() {
    search_data['md_id'] = md_id || fun.getItem('user_info')['store_id'] || 0;
    if (fun.getItem('user_info')['store_id'] && !Auth.check('yxckqtmd','view')) {
        $('body').off('click', '.show-all3');
        $('.show-all3>span').text(fun.is_value(fun.getItem('user_info')['store_name']));
    }
    search_data['year'] = year;
    search_data['month'] = month;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getYbb,
        data: search_data,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    data_list = res.data;
                    Billbox(res.data);
                    break;
                default:
                    fun.alert({ msg: res['msg'] });
                    break;
            }
        }
    })
}
//加载数据
function Billbox(data) {
    var bills_box_html = [];
    for (var i = 0; i < data.length; i++) {
        var val = data[i]
        var titleName;
        var idName;
        var tmp_wording;
        switch (val['type']) {
            case 'kh':
                titleName = '客户情况';
                idName = 'today_sale';
                break;
            case 'gys':
                titleName = '供应商情况';
                idName = 'toolbar';
                break;
            case 'jgs':
                titleName = '加工商情况';
                idName = 'today_income';
                break;
            case 'wl':
                titleName = '物流情况';
                idName = 'today_pay';
                break;
            case 'xs':
                titleName = '布匹销售';
                idName = 'back_goods';
                break;
            case 'ywy':
                titleName = '业务员情况';
                idName = 'account_deposit';
                break;
            case 'cg':
                titleName = '布匹采购';
                idName = 'customer_balance';
                break;
            case 'jg':
                titleName = '布匹加工';
                idName = 'product_sale';
                break;
            case 'xz':
                titleName = '布匹下织';
                idName = 'product_xz';
                break;
            case 'sx_xs':
                titleName = '纱线销售';
                idName = 'customer_sale';
                tmp_wording = '销售';
                break;
            case 'sx_ywy':
                titleName = '纱线业务员情况';
                idName = 'sxaccount_deposit';
                break;
            case 'sx_cg':
                titleName = '纱线采购';
                idName = 'sales_trend';
                tmp_wording = '采购';
                break;
            case 'sx_jg':
                titleName = '纱线加工';
                idName = 'sluggish_sale';
                tmp_wording = '加工';
                break;
            case 'cw':
                titleName = '财务情况';
                idName = 'stock_situation';
                break;
            case 'lr':
                titleName = '利润情况';
                idName = 'profit_situation';
                break;
            case 'pb':
                titleName = '坯布库存';
                idName = 'unsalable';
                tmp_wording = '匹';
                break;
            case 'cp':
                titleName = '成品库存';
                idName = 'finished_product';
                tmp_wording = '匹';
                break;
            case 'sx':
                titleName = '纱线库存';
                idName = 'yarn_stock';
                tmp_wording = '粒';
                break;
            default:
                titleName = '';
                idName = '';
                tmp_wording = '';
                break;
        }
        switch (titleName) {
            case '客户情况':
                bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                bills_box_html.push('	<div class="info-list">');
                bills_box_html.push('		<ul>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">人数</span><em class="lists-data color1">' + val['sl'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sl_bsy']) + val['sl_bsy'] + '<i>人</i></em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">客户流失</span><em class="lists-data color1">' + val['lssl'] + '<i>人</i></em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">上月累欠</span><em class="lists-data color1">' + val['sylq'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">本月累欠</span><em class="lists-data color1">' + val['bylq'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['lq_bsy']) + val['lq_bsy'] + '</em></li>');
                bills_box_html.push('		</ul>');
                bills_box_html.push('	</div>');
                bills_box_html.push('</div>');
                break;
            case '供应商情况':
            case '加工商情况':
            case '物流情况':
                if(titleName==='加工商情况' && AuthVersionCheck.checkHide('ycjgs')) continue; 
                if(titleName==='物流情况' && AuthVersionCheck.checkHide('hy')) continue; 
                bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                bills_box_html.push('	<div class="info-list">');
                bills_box_html.push('		<ul>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">人数</span><em class="lists-data color1">' + val['sl'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sl_bsy']) + val['sl_bsy'] + '<i>人</i></em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">上月累欠</span><em class="lists-data color1">' + val['sylq'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title"></span><em class="lists-data color1"></em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">本月累欠</span><em class="lists-data color1">' + val['bylq'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['lq_bsy']) + val['lq_bsy'] + '</em></li>');
                bills_box_html.push('		</ul>');
                bills_box_html.push('	</div>');
                bills_box_html.push('</div>');
                break;
            case '布匹销售':
                if (AuthVersionCheck.checkHide('yccp')) continue; 
                bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                bills_box_html.push('	<div class="info-list">');
                bills_box_html.push('		<ul>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总销售匹</span><em class="lists-data color1">' + val['zps'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ps_bsy']) + val['ps_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总销售数</span><em class="lists-data color1">' + val['zsl'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sl_bsy']) + val['sl_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总销售额</span><em class="lists-data color1">' + val['zje'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['je_bsy']) + val['je_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总挂账</span><em class="lists-data color1">' + val['zgz'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['gz_bsy']) + val['gz_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">销售成本</span><em class="lists-data color1">' + val['zcb'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['cb_bsy']) + val['cb_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总毛利</span><em class="lists-data color1">' + val['zml'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ml_bsy']) + val['ml_bsy'] + '</em></li>');
                bills_box_html.push('		</ul>');
                bills_box_html.push('	</div>');
                bills_box_html.push('</div>');
                break;
            case '业务员情况':
            case '纱线业务员情况':
                if (titleName == '业务员情况' && AuthVersionCheck.checkHide('yccp')) continue;    
                if (titleName == '纱线业务员情况' && AuthVersionCheck.checkHide('ycsx')) continue;
                bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                bills_box_html.push('	<div class="info-list">');
                bills_box_html.push('		<ul>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">上月业绩</span><em class="lists-data color1">' + val['syyj'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title"></span><em class="lists-data color1"><i></i></em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">本月业绩</span><em class="lists-data color1">' + val['byyj'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['yj_bsy']) + val['yj_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">本月目标</span><em class="lists-data color1">' + val['bymb'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">相差</span><em class="lists-data color1">' + val['xc'] + '</em></li>');
                bills_box_html.push('		</ul>');
                bills_box_html.push('	</div>');
                bills_box_html.push('</div>');
                break;
            case '布匹采购':
                if (AuthVersionCheck.checkHide('yccp')) continue;    
                bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                bills_box_html.push('	<div class="info-list">');
                bills_box_html.push('		<ul>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总采购匹</span><em class="lists-data color1">' + val['zps'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ps_bsy']) + val['ps_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总采购数</span><em class="lists-data color1">' + val['zsl'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sl_bsy']) + val['sl_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总采购额</span><em class="lists-data color1">' + val['zje'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['je_bsy']) + val['je_bsy'] + '</em></li>');
                bills_box_html.push('		</ul>');
                bills_box_html.push('	</div>');
                bills_box_html.push('</div>');
                break;
            case '布匹加工':
                if (AuthVersionCheck.checkHide('yccp')) continue; 
                if (AuthVersionCheck.checkHide('ycjgs')) continue; 
                if (AuthVersionCheck.checkHide('ycbpjg')) continue; 
                bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                bills_box_html.push('	<div class="info-list">');
                bills_box_html.push('		<ul>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总加工匹</span><em class="lists-data color1">' + val['zps'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ps_bsy']) + val['ps_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总加工数</span><em class="lists-data color1">' + val['zsl'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sl_bsy']) + val['sl_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总加工额</span><em class="lists-data color1">' + val['zje'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['je_bsy']) + val['je_bsy'] + '</em></li>');
                bills_box_html.push('		</ul>');
                bills_box_html.push('	</div>');
                bills_box_html.push('</div>');
                break;
            case '布匹下织':
                if (AuthVersionCheck.checkHide('yccp')) continue;    
                if (!AuthVersionCheck.checkHide('ycxz')) {
                    bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                    bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                    bills_box_html.push('	<div class="info-list">');
                    bills_box_html.push('		<ul>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总加工匹</span><em class="lists-data color1">' + val['zps'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ps_bsy']) + val['ps_bsy'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总加工数</span><em class="lists-data color1">' + val['zsl'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sl_bsy']) + val['sl_bsy'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总加工额</span><em class="lists-data color1">' + val['zje'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['je_bsy']) + val['je_bsy'] + '</em></li>');
                    bills_box_html.push('		</ul>');
                    bills_box_html.push('	</div>');
                    bills_box_html.push('</div>');
                }
                break;
            case '纱线销售':
            case '纱线采购':
            case '纱线加工':
                if (!AuthVersionCheck.checkHide('ycsx')) {
                    bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                    bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                    bills_box_html.push('	<div class="info-list">');
                    bills_box_html.push('		<ul>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总' + tmp_wording + '粒</span><em class="lists-data color1">' + val['zps'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ps_bsy']) + val['ps_bsy'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总' + tmp_wording + '数</span><em class="lists-data color1">' + val['zsl'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sl_bsy']) + val['sl_bsy'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总' + tmp_wording + '额</span><em class="lists-data color1">' + val['zje'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['je_bsy']) + val['je_bsy'] + '</em></li>');
                    if (titleName == '纱线采购' || titleName == '纱线加工') {
                        bills_box_html.push('		</ul>');
                        bills_box_html.push('	</div>');
                        bills_box_html.push('</div>');
                        break;
                    }
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总挂账</span><em class="lists-data color1">' + val['zgz'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['gz_bsy']) + val['gz_bsy'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">销售成本</span><em class="lists-data color1">' + val['zcb'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['cb_bsy']) + val['cb_bsy'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总毛利</span><em class="lists-data color1">' + val['zml'] + '</em></li>');
                    bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ml_bsy']) + val['ml_bsy'] + '</em></li>');
                    bills_box_html.push('		</ul>');
                    bills_box_html.push('	</div>');
                    bills_box_html.push('</div>');
                }
                break;
            case '财务情况':
                bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                bills_box_html.push('	<div class="info-list">');
                bills_box_html.push('		<ul>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">费用开支</span><em class="lists-data color1">' + val['fyje'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['fy_bsy']) + val['fy_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">其他收入</span><em class="lists-data color1">' + val['srje'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sr_bsy']) + val['sr_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总利润</span><em class="lists-data color1">' + val['zlr'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['lr_bsy']) + val['lr_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总收款</span><em class="lists-data color1">' + val['skje'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">付款</span><em class="lists-data color1">' + val['fkje'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">应收调账</span><em class="lists-data color1">' + (val['cw_ystz'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['cw_ystz_bsy'] || 0) + (val['cw_ystz_bsy'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">应付调账</span><em class="lists-data color1">' + (val['cw_yftz'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['cw_yftz_bsy'] || 0) + (val['cw_yftz_bsy'] || 0 )+ '</em></li>');
                // bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总调账</span><em class="lists-data color1">' + val['tzje'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">上月存款</span><em class="lists-data color1">' + val['syck'] + '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">本月存款</span><em class="lists-data color1">' + val['byck'] + '</em></li>');
                // bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ck_bsy']) + val['ck_bsy'] + '</em></li>');
                bills_box_html.push('		</ul>');
                bills_box_html.push('	</div>');
                bills_box_html.push('</div>');
                break;
            case '利润情况':
                bills_box_html.push('<div class="custom-info" id=\'' + idName + '\'>');
                bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                bills_box_html.push('	<div class="info-list">');
                bills_box_html.push('		<ul>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">无分摊费用</span><em class="lists-data color1">' + (val['lr_wftfy'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['lr_wftfy_bsy'] || 0) + (val['lr_wftfy_bsy'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">无分摊收入</span><em class="lists-data color1">' + (val['lr_wftsr'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['lr_wftsr_bsy'] || 0) + (val['lr_wftsr_bsy'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">无分摊其他额</span><em class="lists-data color1">' + (val['lr_wftqte'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['lr_wftqte_bsy'] || 0) + (val['lr_wftqte_bsy'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总毛利</span><em class="lists-data color1">' + (val['lr_zml'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['lr_zml_bsy'] || 0) + (val['lr_zml_bsy'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">总净利</span><em class="lists-data color1">' + (val['lr_zjl'] || 0 )+ '</em></li>');
                bills_box_html.push('			<li class="lists lower-border-line"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['lr_zjl_bsy'] || 0) + (val['lr_zjl_bsy'] || 0 )+ '</em></li>');
                bills_box_html.push('		</ul>');
                bills_box_html.push('	</div>');
                bills_box_html.push('</div>');
                break;
            case '坯布库存':
            case '成品库存':
                var ykcb,ykcb_bsy;
                if (AuthVersionCheck.checkHide('yccp')) continue; 
                bills_box_html.push('<div class="sale-info" id=\'' + idName + '\'>');
                bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                bills_box_html.push('	<div class="info-list">');
                bills_box_html.push('		<ul>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">上月' + tmp_wording + '数</span><em class="lists-data color1">' + val['syps'] + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title"></span><em class="lists-data color1"></em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">库存' + tmp_wording + '数</span><em class="lists-data color1">' + val['byps'] + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ps_bsy']) + val['ps_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">上月数量</span><em class="lists-data color1">' + val['sysl'] + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title"></span><em class="lists-data color1"></em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">库存数量</span><em class="lists-data color1">' + val['bysl'] + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sl_bsy']) + val['sl_bsy'] + '</em></li>');
                if (titleName == '坯布库存') {
                    ykcb = val['pb_ykcb'] || 0;
                    ykcb_bsy = val['pb_ykcb'] || 0;
                }
                if (titleName == '成品库存') {
                    ykcb = val['cp_ykcb'] || 0;
                    ykcb_bsy = val['cp_ykcb_bsy'] || 0;
                }
                bills_box_html.push('			<li class="lists"><span class="lists-title">盈亏成本</span><em class="lists-data color1">' + ykcb + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(ykcb_bsy) + ykcb_bsy + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">上月成本</span><em class="lists-data color1">' + val['sycb'] + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title"></span><em class="lists-data color1"></em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">库存成本</span><em class="lists-data color1">' + val['bycb'] + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['cb_bsy']) + val['cb_bsy'] + '</em></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title">滞销品种</span><em class="lists-data color1">' + val['zxpz'] + '</em><span style="color: #7A8086;">&nbsp;个</span></li>');
                bills_box_html.push('			<li class="lists"><span class="lists-title"></span><em class="lists-data color1"></em></li>');
                bills_box_html.push('		</ul>');
                bills_box_html.push('	</div>');
                bills_box_html.push('</div>');
                break;
            case '纱线库存':
                if (!AuthVersionCheck.checkHide('ycsx')) {
                    bills_box_html.push('<div class="sale-info" id=\'' + idName + '\'>');
                    bills_box_html.push('	<p class="info-head"><span class="head-title">' + titleName + '</span></p>');
                    bills_box_html.push('	<div class="info-list">');
                    bills_box_html.push('		<ul>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">上月' + tmp_wording + '数</span><em class="lists-data color1">' + val['syps'] + '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title"></span><em class="lists-data color1"></em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">库存' + tmp_wording + '数</span><em class="lists-data color1">' + val['byps'] + '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['ps_bsy']) + val['ps_bsy'] + '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">上月数量</span><em class="lists-data color1">' + val['sysl'] + '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title"></span><em class="lists-data color1"></em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">库存数量</span><em class="lists-data color1">' + val['bysl'] + '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sl_bsy']) + val['sl_bsy'] + '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">盈亏成本</span><em class="lists-data color1">' + (val['sx_ykcb'] || 0 )+ '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['sx_ykcb_bsy'] || 0) + (val['sx_ykcb_bsy'] || 0 )+ '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">上月成本</span><em class="lists-data color1">' + val['sycb'] + '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title"></span><em class="lists-data color1"></em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">库存成本</span><em class="lists-data color1">' + val['bycb'] + '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">比上月</span><em class="lists-data color1">' + getChar(val['cb_bsy']) + val['cb_bsy'] + '</em></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title">滞销品种</span><em class="lists-data color1">' + val['zxpz'] + '</em><span style="color: #7A8086;">&nbsp;个</span></li>');
                    bills_box_html.push('			<li class="lists"><span class="lists-title"></span><em class="lists-data color1"></em></li>');
                    bills_box_html.push('		</ul>');
                    bills_box_html.push('	</div>');
                    bills_box_html.push('</div>');
                }
                break;
        }
    }
    function getChar(sum) {
        return sum > 0 ? '+' : '';
    }
    $('.contents').html(bills_box_html.join(''));
}


var page_name = page_arr.cw_ybb;
//打开侧边菜单
$('#more_btn').on('click', function () {
    var typeArr = getDataType(data_list);
    flat_menu = 1;
    fun.openFrame({
        frame_url: page_arr.ybb_side,
        pageParam: {
            page_name: page_name,
            typeArr: typeArr,
        },
        hide_anima: true,
        y: 0,
        setZero: true
    });
});

function getDataType(data) {
    var typeArr = [];
    for (var i = 0; i < data.length; i++) {
        if (['sx_xs', 'sx_ywy', 'sx_cg', 'sx_jg'].indexOf(data[i]['type']) > -1 && !AuthVersionCheck.checkHide('ycsx')) {
            typeArr.push(data[i]['type']);
        }
        else if (data[i]['type'] === 'jgs' && AuthVersionCheck.checkHide('ycjgs')) {
            continue;
        }
        else if (data[i]['type'] === 'wl' && AuthVersionCheck.checkHide('hy')) {
            continue;
        }
        else if (data[i]['type'] === 'xs' && AuthVersionCheck.checkHide('yccp')) {
            continue;
        }
        else if (data[i]['type'] === 'ywy' && AuthVersionCheck.checkHide('yccp')) {
            continue;
        }
        else if (data[i]['type'] === 'sx_ywy' && AuthVersionCheck.checkHide('ycsx')) {
            continue;
        }
        else if (data[i]['type'] === 'cg' && AuthVersionCheck.checkHide('yccp')) {
            continue;
        }
        else if (data[i]['type'] === 'jg' && (AuthVersionCheck.checkHide('yccp') ||
            AuthVersionCheck.checkHide('ycjgs') || AuthVersionCheck.checkHide('ycbpjg'))) {
            continue;
        }
        else if (data[i]['type'] === 'xz') {
            if (AuthVersionCheck.checkHide('yccp')) continue;
            if (!AuthVersionCheck.checkHide('ycxz')) {
                typeArr.push(data[i]['type']);
            }
        }
        else if (data[i]['type'] === 'cp' && AuthVersionCheck.checkHide('yccp')) {
            continue;
        }
        else if (data[i]['type'] === 'sx' && AuthVersionCheck.checkHide('ycsx')) {
            continue;
        }
        else {
            typeArr.push(data[i]['type']);
        }
    }
    return typeArr;
}

//当前日期
var cur_time = fun.getNowFormatDate();
$('.date').text(cur_time.slice(0, 7));
year = parseInt(cur_time.slice(0, 4));
month = parseInt(cur_time.slice(5, 7));


//切换时间
$(".cuttime").on('tap', function () {
    var id = $(this)[0].id;
    var dateval = $('.date').text();
    var ss = getCutTime(id, dateval);
    $('.date').text(ss);
    $('.contents').empty();
    getList();
});

//获得相应月份
function getCutTime(id, cur_times) {
    //获得当前年月日
    var cur_year = parseInt(cur_times.slice(0, 4));
    var cur_month = parseInt(cur_times.slice(5, 7));
    var str;
    //判断是前一月还是下一月时间
    switch (id) {
        case 'pre_time':
            if (cur_month == 1) {
                cur_year--;//如果当前月份为1月，则年份减1
                cur_month = 12;
                year = cur_year;
                month = cur_month;
            } else {
                cur_month--;
                year = cur_year;
            }
            break;
        case 'next_time':
            if (cur_month == 12) {
                cur_year++;//如果当前月份为12月，则年份加1
                cur_month = 1;
                year = cur_year;
                month = cur_month;
            } else {
                cur_month++;
                year = cur_year;
            }
            break;
        default: break;
    }
    if (cur_month.toString().length == 1) {
        month = '0' + cur_month;
    } else {
        month = cur_month;
    }
    str = year + '-' + month;
    return str;
}
//得到日期
var ds;
var begin_lCalendar = new lCalendar();
begin_lCalendar.init({
    'trigger': '#begin_date',
    'type': 'date',
    callback: function (date) {
        ds = date.slice(0, 7);
        $('.date').text(ds);
        year = parseInt(ds.slice(0, 4));
        month = parseInt(ds.slice(5, 7));
        $('.contents').empty();
        getList();
    }
});

//月结
$('body').on('click', '.show-all2', function (e) {
    fun.load_DATA_LIST(['sys_config'], function () {
        if (!fun.checkKz()) return;
        fun.showPageFull({
            page_url: page_arr.monthly_statement,
            pageParam: {
                return_page: html_name,
                // opt_type:'add',
            }
        })
    });
})

//门店
$('body').on('click', '.show-all3', function () {
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            'return_page': html_name,
            'page_type': 'md',
        }
    })
})