var html_name = page_arr.cw_zhdz,
    date_arr = fun.getDateArr(),
    to_month = fun.getLatelyTime(1,false),
    search_data = {
        "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd')
    },
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd'); 
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            $('#order_list').empty();
            getList();
        }
    }),
    global_search = {},
    page_list = [], ztj_data = [];

$('#header').header({
    back: true,
    title: '账户对账',
    filter: true,
    foot_input: {
        show: true,
        fork_icon: true,
        plader: '搜索'
    },
});
var USER_INFO = {};
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    $("#foot_search").attr("readonly", "readonly");//输入框不可编辑
    $('.contents').css('paddingTop', api.safeArea.top + 'px');
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    //首页跳转过来，赋值今日日期
    if (!!page_data['today']) {
        search_data['md_id'] = page_data['md_id'];
        search_data['md_mc'] = page_data['md_mc'];
        // search_storage['md'] = {
        //     id: page_data['md_id'],
        //     text: page_data['md_mc']
        // };
        search_data['begin_time'] = page_data['today'];
        search_data['end_time'] = page_data['today'];
        date_bar.setDate({
            "begin_date": page_data['today'],
            "end_date": page_data['today']
        });
    }
    //首页跳转过来，赋值本月日期(新版首页)
    if (!!page_data['begin_time'] && !!page_data['end_time']) {
        search_data['md_id'] = page_data['md_id'];
        search_data['md_mc'] = page_data['md_mc'];
        // search_storage['md'] = {
        //     id: page_data['md_id'],
        //     text: page_data['md_mc']
        // };
        search_data['begin_time'] = page_data['begin_time'];
        search_data['end_time'] = page_data['end_time'];
        date_bar.setDate({
            "begin_date": page_data['begin_time'],
            "end_date": page_data['end_time']
        });
    }

    //上个页面（首页-账户存款记录行）
    if (!!page_data['data'] && page_data['data']['zh_mc'] !== '其他') {
        search_data['md_id'] = page_data['md_id'];
        search_data['md_mc'] = page_data['md_mc'];
        $('#foot_search').val(page_data['data']['zh_mc']);
        search_data['zh_id'] = page_data['data']['zh_id'];
        search_data['zh_mc'] = page_data['data']['zh_mc'];
    }

    //上个页面（首页-账户存款）
    if (!!page_data['type'] && page_data['type'] == 'zhck') {
        search_data['md_id'] = page_data['md_id'];
        search_data['md_mc'] = page_data['md_mc'];
    }
    //【账户-显示存款】没有开启
    if(!Auth.check('zh_xsck','view')) {
        $('.deposit').hide();
    }
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        // console.log(JSON.stringify(temp))
        switch (temp['status']) {
            case 'search'://筛选返回数据
                search_data['begin_time'] = temp['data']['begin_date'];
                search_data['end_time'] = temp['data']['end_date'];
                search_data['md_id'] = temp['data']['md']['id'];
                search_data['md_mc'] = temp['data']['md']['text'];
                        date_bar.setDate({
                    begin_date: search_data['begin_time'],
                    end_date: search_data['end_time']
                });
                fun.setItem(html_name + 'sideslip', true);
                $('#order_list').empty();
                getList();
                break;
            case 'select_list'://输入框客户搜索返回数据
                search_data['zh_id'] = temp['data']['id'];
                search_data['zh_mc'] = temp['data']['select_val'];
                $('#foot_search').val(temp['data']['select_val']);
                $('#order_list').empty();
                getList();
                break;
            case 'refresh':
                $('#order_list').empty();
                getList();
                break;
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            fun.createBottomLine('order_list', ".bank-info");
        }
    });

    getList();

    fun.orderListHeight({dom:'#order_list'});
}


function getList() {
    
    //滚动条位置设置为0
    $(".contents").scrollTop(0);
    page_list = [];

    global_search = $.extend({}, {
        "begin_time": "",
        "end_time": "",
        "keyword": "",
        "keyword_key": ['zh_mc', 'zh_kh'],
        "xsty": false,
        "xszf": false,
        "type": "dzb_zh"
    }, search_data);

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getXjyhDzb,
        data: $.extend({}, {
            "begin_time": "",
            "end_time": "",
            "keyword": "",
            "keyword_key": ['zh_mc', 'zh_kh'],
            "xsty": false,
            "xszf": false,
            "type": "dzb_zh"
        }, search_data),
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj_qc').text(0);
                    $('#tj_sr').text(0);
                    $('#tj_zc').text(0);
                    $('#tj_lc').text(0);
                    $('.bank').css({  'position': 'fixed' });
                    // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    fun.createDataEmptyTips({dom:'#order_list',btnShow:false,style:'top:0.5rem;height:9rem;'});
                } else {
                    $('#order_list').empty();
                    $('.bank').css({ 'position': 'unset' });
                    page_list = res['data'];
                    ztj_data = res['info'];
                    showList(fun.PagingData(page_list));
                }
            }
        }
    })
}

function showList(data) {
    $('#tj_qc').text(ztj_data['zh_qcje'] || 0);
    $('#tj_sr').text(ztj_data['srje'] || 0);
    $('#tj_zc').text(ztj_data['zcje'] || 0);
    $('#tj_lc').text(ztj_data['zh_ljck'] || 0);
    var html = [];
    $(data).each(function (i, obj) {
        var index = getIndexs(bank_icon, fun.is_value(obj['zh_tb']));
        html.push('    <li zh_id="' + obj['zh_id'] + '" zh_mc="' + obj['zh_mc'] + '" style="background:linear-gradient(to right,' + (!!fun.is_value(bank_color[index]) ? bank_color[index][0] : '') + ', ' + (!!fun.is_value(bank_color[index]) ? bank_color[index][1] : '') + ');" class="bank-info">');
        html.push('    <div class="bankImg">');
        html.push('    <img src="../img/bank/' + fun.is_value(obj['zh_tb']) + '" alt="">');
        html.push('    </div>');
        html.push('    <div class="bankCon">');
        html.push('    <span class="bank-name">' + fun.is_value(obj['zh_mc']) + '</span>');
        html.push('    <div class="service-type">');
        html.push('        <div class="rows"><span class="service lefts">收入 <em class="service-money">' + (obj['srje'] || 0) + '</em></span>');
        html.push('        <span class="service rights">支出 <em class="service-money">' + (obj['zcje'] || 0) + '</em></span></div>');
        //【账户-显示存款】有开启
        if(Auth.check('zh_xsck','view')) {
            html.push('    <div class="rows" ><span class="service lefts">前存 <em class="service-money">' + (obj['zh_qcje'] || 0) + '</em></span>');
            html.push('    <span class="service rights">累存 <em class="service-money">' + (obj['zh_ljck'] || 0) + '</em></span></div>');
        }
        html.push('    </div>');
        if (!!obj['zh_kh']) {
            html.push('<p><span class="bank-card">' + fun.dealCard(obj['zh_kh']) + '</span></p>');
        }
        html.push('    <img style="opacity:.2;" src="../img/bank2/' + fun.is_value(obj['zh_tb']) + '" alt="">');
        html.push('    </div>');
        html.push('</li>');

    })
    $('#order_list').append(html.join(''));
}
fun.setItem(html_name + 'sideslip', true);
//打开搜索框
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "time": {
            "begin_date": search_data['begin_time'],
            "end_date": search_data['end_time']
        },
        "choose_merchants": [
            // {
            //     "id": (search_data && search_data['zh_id'] ? search_data['zh_id'] : 0),
            //     "key": "zh",
            //     "text": "账户",
            //     "value": (search_data && search_data['zh_mc'] ? search_data['zh_mc'] : "")
            // },
            {
                "id": (search_data && search_data['md_id'] ? search_data['md_id'] : 0),
                "key": "md",
                "text": "门店",
                "value": (search_data && search_data['md_mc'] ? search_data['md_mc'] : "")
            }
        ]
    };
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

//点击输入框跳转
$('body').on('tap', "#foot_search", function () {
    fun.showPageFull({
        page_url: page_arr.select_bank_list,
        pageParam: {
            page_type: 'zh',
            return_page: html_name
        }
    });
});
// $('body').bind('search', "#foot_search", function () {
// search_data['keyword'] = $('#foot_search').val().trim();
// $('#order_list').empty();
// getList();
// });

//输入框清除按钮
$('body').on('tap', ".icon-fork", function () {
    search_data['zh_id'] = 0;
    search_data['zh_mc'] = '';
    $('#foot_search').val('');
    $('#order_list').empty();
    getList();
});

$('body').on('tap', '.bank-info', function () {
    if (AuthVersionCheck.checkHide('zhdzmx'))  return;
    fun.showPageFull({
        page_url: page_arr.cw_zhdz_mx,
        pageParam: {
            return_page: html_name,
            begin_time: search_data['begin_time'],
            end_time: search_data['end_time'],
            zh_id: $(this).attr('zh_id'),
            zh_mc: $(this).attr('zh_mc'),
            global_search: global_search
        }
    });
})
