var html_name = page_arr.detailed_stock2;

var Bills = {};
Bills['config'] = {
    ck_zdy: 'bpckzdygl',
    dckms: 'dckms_bp',
    dbtckjs: 'dbtckjs_bp'
};
Bills['dykc_config'] = {};
Bills['del_row_exclude_col'] = ['dd_jl_id', 'ckd_jl_id'];  // 删除行记录，判断需排除的字段 'is_yy_tm', 
var SYS_CONFIG = {};
fun.clearItem('ck_list');
var only_ck_id = 0, only_ck_mc = '', selected = false, __JL_DATA = [], __tmp_jl_data = [], __DJ_DATA = {}, ck_list = [];
var page_list = [];
var recordCk = {};//记录仓库

var PAGE_INIT_CK_ID = 0;

var selDataObj = {};

var __EDIT_ROW;  // 标记是否记录调用库存

// 存储数据
var __STORE_DATA = {
    execFun: null,
    execTm: ''
};

// $('.tm-show').hide();
var search_data = {
    "ck_id": 0,
    "cp_id": 0,
    "cp_ys_id": 0,
    "dw_id": 0,
    "sl": 0,
    "xj": 0,
    "type": "mxb",
    "tm_arr": [],
    "xsdck": 0,//显示待出库
    "has_tm": 0,
    "not_has_tm": 0,
    // "djlx": "bp_xsfhjs",
    "is_dy": true,
    "fk": '',
    "kz": '',
    "gh": '',
    "tm": ''
};
var search_storage = {
    order: '',
    fk: {},
    kz: {},
    gg: {},
    gh: {},
    ph: {},
    jh: {},
    ck: {},
    cw: {},
};
var detailed_stock_rows = []; // 继续调用时临时存储数组
$('#header').header({
    back: true,
    title: '调库存',
    scan: true,
    much: true,
    filter: true,
    appendBackBtnEvt: isDataChange
});


// 表格
var params = {
    // show_sum: false,
    // roll_height: '100%',
    // roll_height: $(document).height() - fun.fontUnit(3.5) - fun.fontUnit(8.5) - 42 - fun.fontUnit(2.5),
    // roll_height: 280,
    // multiChoose: true,
    title: [
        // {name: '条码', key: 'tm', width: 120},
        // {name: '规格', key: 'gg', width: 80}
    ],
    data: [],
    // onClick: function (params) {
    //     selDataObj = params['selData'];
    //     setBpNum();
    // }
};

var stock = {
    jlData: [],
    showListBScroll: {
        timer: null,
        bScroll: null,
        options: {
            click: true,
            tap: true,
            pullUpLoad: {
                threshold: -10, // 在上拉到超过底部 10px 时，触发 pullingUp 事件
            }
        },
        isCreateBScroll: false
    },
};

var comBScroll = null;

// 页面适配代码
stock.pageAdaptive = function () {
    $('.debts').css({
        top: $('#header').outerHeight()
    })
    $('.list-group').css({
        top: fun.getCssVal('.debts', 'top') + $('.debts').outerHeight()
    })
    $('.content').css({
        top: $('.list-group').outerHeight() + fun.is_value(fun.getCssVal('.list-group', 'top'), 0),
        bottom: $('.footer').outerHeight()
    })
}

// 获取可视列表高度
stock.getVisualListHeight = function () {
    return window.screen.height - fun.is_value(fun.getCssVal('.content', 'top'), 0) - fun.is_value(fun.getCssVal('.content', 'paddingTop'), 0);
}

// 列表在可视区域之内
stock.listAtVisualOut = function () {
    return $('#params').outerHeight() >= stock.getVisualListHeight();
}

// 加载暂无数据样式
stock.createBottomLine = function () {
    if ($.nui.isTrue($('.empty_bottom').length)) return;
    if ($.nui.isEmpty(page_list)) {
        if (stock.listAtVisualOut()) { // 列表数据大于列表可视区域高度
            fun.createBottomLine('params', ".params_info");
            $('.empty_bottom').show();
        }
    }
}

// 空数据样式重置
stock.emptyDataContainerStyleReset = function () {
    $('#params').css({
        height: stock.getVisualListHeight()
    })
}

// 分页加载方法
stock.pullingUp = function () {
    clearTimeout(stock.showListBScroll.timer);
    stock.showListBScroll.timer = setTimeout(function () {
        if ($.nui.isTrue(page_list)) {
            showList(fun.PagingData(page_list, 5) || []);
        } else {
            if ($.nui.isTrue($('.empty_bottom').length)) return;
        }
    }, 1000);
}

// 列表初始化分页加载
stock.enabledListScroll = function () {
    var that = this;
    if (!that.showListBScroll.isCreateBScroll) {
        comBScroll = that.showListBScroll.bScroll = new BScroll($('.content')[0], that.showListBScroll.options);
        that.showListBScroll.isCreateBScroll = true;
    }
    showList(fun.PagingData(page_list, 10) || []);
    that.showListBScroll.bScroll.off('pullingUp', that.pullingUp);
    that.showListBScroll.bScroll.on('pullingUp', that.pullingUp);
}

// 1. 其他页面可以传递已有数据，使用 __JL_DATA 数组
// 2. 编辑行记录时调库存，__EDIT_ROW设置为true, 传递__JL_DATA数组、编辑行记录对应下标row_index
page_init = function () {
    SYS_CONFIG = fun.getItem('sys_config') || {};
    // hideButton('#fixtabbar');
    stock.pageAdaptive();
    // $('.content').css('bottom', ($('#fixtabbar:visible').height() + api.safeArea.bottom + 'px'));
    var goodsGridColumns = [
        { name: '仓库', key: 'ck_mc', width: 100 },
        { name: '色号', key: 'cp_ys_bh', width: 60 },
        { name: '颜色', key: 'cp_ys_mc', width: 80 },
        { name: '幅宽', key: 'fk', width: 60 },
        { name: '克重', key: 'kz', width: 60 },
        { name: '匹数', key: 'ps', width: 80 },
        { name: '数量', key: 'sl', width: 80 },
        { name: '单位', key: 'dw_mc', width: 60 },
        { name: '缸号', key: 'gh', width: 80 },
        { name: '卷号', key: 'jh', width: 80 },
        { name: '批号', key: 'ph', width: 120 }
    ];

    __EDIT_ROW = $.nui.isTrue(page_data.__EDIT_ROW);

    if (['bp_xsdd', 'bp_xsfhjs', 'bp_xsthjs'].indexOf(page_data['djlx']) > -1) {
        __EDIT_ROW = false;
    }

    if (__EDIT_ROW) {
        Bills['AJAX_URL'] = { getDj: '' };
        Bills['djlx'] = page_data.djlx;
    }
    // //开单的偏好设置-规格未打钩则隐藏
    // if(!fun.getKdSetting('gg')){
    //     $('.gg-list').hide();
    //     $('.gh-list').css('float','left');
    //     //开单的偏好设置-规格、缸号未打钩都隐藏
    //     if(!fun.getKdSetting('gh')){
    //         $('#show_list').hide();
    //         $('.content').css('top','8rem');
    //     }
    // }
    // //开单的偏好设置-缸号未打钩则隐藏
    // if(!fun.getKdSetting('gh')){
    //     $('.gh-list').hide();
    // }

    if (fun.getKdSetting('gg') || fun.getKdSetting('gh')) {
        $('#show_list').show();
        if (!fun.getKdSetting('gg')) {
            $('.gg-list').hide();
            $('.gh-list').css({
                'float': 'left',
                'paddingLeft': '0.5rem'
            });
        }
        if (!fun.getKdSetting('gh')) {
            $('.gh-list').hide();
        }
    } else {
        $('#show_list').hide();
        // $('.content').css('top', '8rem');
    }

    console.log('---', page_data);

    // fun.keyboardEject('.footer');

    fun.load_DATA_LIST(['cp']);
    
    fun.load_DATA_LIST(['ck', 'wldw_kh', 'wldw_gys']);

    page_data['tm_arr'] = page_data['tm_arr'] || [];

    if ($.nui.isTrue(page_data['__JL_DATA'])) {
        __JL_DATA = page_data['__JL_DATA'];

        if ($.isArray(__JL_DATA)) {
            only_ck_id = __JL_DATA[0].ck_id;
            PAGE_INIT_CK_ID = __JL_DATA[0].ck_id;
            only_ck_mc = __JL_DATA[0].ck_mc;
        }

        __tmp_jl_data = __JL_DATA || [];
    }

    if ($.nui.isTrue(page_data['__DJ_DATA'])) {
        __DJ_DATA = page_data['__DJ_DATA'] || {};
    }

    if ($.nui.isTrue(page_data['has_tm'])) {
        search_data['has_tm'] = page_data['has_tm'];
    }
    search_data['djlx'] = page_data['djlx'];
    switch (page_data['djlx']) {
        case 'kc_bptbd':
            goodsGridColumns.push({ name: '条码', key: 'tm', width: 150 });
            $('.tm-show').show();
            break;
        case 'kc_bpzspd':
            search_data['has_tm'] = 0;
            search_data['not_has_tm'] = true;
            $('.tm-show').hide();
            break;
        default:
            goodsGridColumns.push({ name: '条码', key: 'tm', width: 120 });
            $('.tm-show').show();
            break;
    }

    goodsGridColumns.push({ name: '规格', key: 'gg', width: 80 });

    params.title = goodsGridColumns;


    if ($.nui.isTrue(page_data['cp_info'])) {
        var cp_info = page_data['cp_info'];
        $('#cp').val(cp_info['number'] + ' ' + cp_info['name']).data('cp_id', cp_info['id'] || 0);
    }

    if ($.nui.isTrue(page_data['ck_id'])) {
        var ck_id = page_data['ck_id'];
        $('#ck').val(fun.getHouseValue(ck_id, 'name')).data('ck_id', ck_id || 0);
        $('#ck').next().show();
    }

    if ($.nui.isTrue(page_data['cp_ys_info'])) {
        var cp_ys_info = page_data['cp_ys_info'];
        var cp_ys_id = cp_ys_info['cp_ys_id'] || 0;
        if ($.nui.isTrue(cp_ys_id)) {
            $('#cp_ys').val(cp_ys_info['cp_ys_bh'] + ' ' + cp_ys_info['cp_ys_mc']).data('cp_ys_id', cp_ys_id);
            $('#cp_ys').next().show();
        }
    }

    if ($.nui.isTrue(page_data['disabledCpCkYs'])) {
        if ($.nui.isTrue($('#cp').data('cp_id'))) {
            $('#cp').attr('disabled', true);
        }
        // if ($.nui.isTrue($('#ck').data('ck_id'))) {
        //     $('#ck').attr('disabled', true);
        //     $('#ck').next().hide();
        // }
        if ($.nui.isTrue($('#cp_ys').data('cp_ys_id'))) {
            $('#cp_ys').attr('disabled', true);
            $('#cp_ys').next().hide();
        }
        $('.list-icon').hide();
    }

    if ($.nui.isTrue(page_data['ck_is_disabled'])) {
        $('#ck').attr('disabled', true);
        $('#ck').next().hide();
    }

    if ($.nui.isTrue(page_data['__row_data'])) {
        var __r_data = page_data['__row_data'];
        $('#gg').val(__r_data['gg'] || '');

        if ($.nui.isTrue(__r_data['gg'])) {
            $('#gg').next().show();
        } else {
            $('#gg').next().hide();
        }

        $('#gh').val(__r_data['gh'] || '');
    }

    // fun.keyboardEject('.footer');

    page_data.keyback = isDataChange;

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];

        switch (temp['status']) {
            case 'select_list':
                var tmp_data = temp['data'];
                setValue(tmp_data);
                break;
            case 'update':
                update_sel_row(temp['data']);
                break;
            // case 'goodsdata':
            //     $('#gg').val(temp['name']).attr('gg-id', temp['id']);
            //     if ($.nui.isTrue(temp['name'])) {
            //         $('#gg').next().show();
            //     } else {
            //         $('#gg').next().hide();
            //     }
            //     getList();
            //     break;
            case 'search':
                fun.setItem(html_name + 'sideslip', true);
                var tmp_data = temp['data'];
                //判断值不为空再赋值，防止偏好设置没开启，没值报错
                // TODO 可优化
                if ($.nui.isTrue(tmp_data['fk'])) {//幅宽
                    search_data['fk'] = tmp_data['fk']['text'] || '';
                    search_storage['fk']['text'] = tmp_data['fk']['text'] || '';
                } else {
                    search_data['fk'] = '';
                    search_storage['fk']['text'] = '';
                }

                if ($.nui.isTrue(tmp_data['kz'])) {//克重
                    search_data['kz'] = tmp_data['kz']['text'] || '';
                    search_storage['kz']['text'] = tmp_data['kz']['text'] || '';
                } else {
                    search_data['kz'] = '';
                    search_storage['kz']['text'] = '';
                }

                if ($.nui.isTrue(tmp_data['gg'])) {//规格
                    search_data['gg'] = tmp_data['gg']['text'] || '';
                    search_storage['gg']['text'] = tmp_data['gg']['text'] || '';
                } else {
                    search_data['gg'] = '';
                    search_storage['gg']['text'] = '';
                }

                if ($.nui.isTrue(tmp_data['ph'])) {//批号
                    search_data['ph'] = tmp_data['ph']['text'] || '';
                    search_storage['ph']['text'] = tmp_data['ph']['text'] || '';
                } else {
                    search_data['ph'] = '';
                    search_storage['ph']['text'] = '';
                }

                if ($.nui.isTrue(tmp_data['gh'])) {//缸号
                    search_data['gh'] = tmp_data['gh']['text'] || '';
                    search_storage['gh']['text'] = tmp_data['gh']['text'] || '';
                } else {
                    search_data['gh'] = '';
                    search_storage['gh']['text'] = '';
                }

                if ($.nui.isTrue(tmp_data['jh'])) {//卷号
                    search_data['jh'] = tmp_data['jh']['text'] || '';
                    search_storage['jh']['text'] = tmp_data['jh']['text'] || '';
                } else {
                    search_data['jh'] = '';
                    search_storage['jh']['text'] = '';
                }

                if ($.nui.isTrue(tmp_data['cw'])) {//仓位
                    search_data['cw'] = tmp_data['cw']['text'] || '';
                    search_storage['cw']['text'] = tmp_data['cw']['text'] || '';
                    search_data['cw_id'] = tmp_data['cw']['id'] || 0;
                    search_storage['cw']['id'] = tmp_data['cw']['id'] || 0;
                } else {
                    search_data['cw'] = '';
                    search_storage['cw']['text'] = '';
                }

                /*仓库*/
                search_data['ck'] = tmp_data['ck']['text'] || '';
                search_data['ck_id'] = tmp_data['ck']['id'] || 0;
                search_storage['ck']['text'] = tmp_data['ck']['text'] || '';
                search_storage['ck']['id'] = tmp_data['ck']['id'] || 0;
                $('#ck').val(tmp_data['ck']['text']).data('ck_id', tmp_data['ck']['id']);
                //删除按钮显示隐藏
                if ($.nui.isTrue(tmp_data['ck']['text'])) {
                    $('#ck').next().show();
                } else {
                    $('#ck').next().hide();
                }

                $('#much_btn,.icon-saoma').show();

                /* 数量排序 */
                search_data['order'] = {
                    sl: tmp_data['sl'] || '',
                };
                search_storage['order'] = {
                    sl: tmp_data['sl'] || '',
                };

                getList();
                break;
        }
    });

    getList();
    // scrollTop();
    // fun.scrolltobottom('.content', function () {
    //     if (page_list.length > 0) {
    //         showList(fun.PagingData(page_list, 10) || []);
    //     } else {
    //         // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
    //         fun.createBottomLine('params', ".params_info");
    //     };
    // });
    // fun.scrollToBottom({}, function () {
    //     if (page_list.length > 0) {
    //         showList(fun.PagingData(page_list) || []);
    //     } else {
    //         // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
    //         fun.createBottomLine('params', ".params_info");
    //     }
    // });

};


/************************ 方法 ***********************/
function hideButton(obj) {
    var winHeight = $(window).height();//获取当前页面高度
    var isAndroid = navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1;
    if (isAndroid) {
        window.addEventListener('resize', function () {
            var thisHeight = $(this).height();
            if (winHeight - thisHeight > 50) {
                $(obj).css("display", "none");
            } else {
                $(obj).css("display", "block");
            }
        });
    }
}
//设置值
function setValue(data) {
    switch (data['page_type']) {
        case 'cp':
            $('#cp').val(data['select_val']).data('cp_id', data['id']);
            $('#cp_ys').val('').data('cp_ys_id', 0);
            $('#cp_ys').next().hide();
            break;
        case 'cp_ys':
            $('#cp_ys').val(data['select_val']).data('cp_ys_id', data['id']);
            $('#cp_ys').next().show();
            break;
        case 'ck':
            $('#ck').val(data['select_val']).data('ck_id', data['id']);
            $('#ck').next().show();
            break;
    }
    getList();
}

//数据发生改变
function isDataChange() {
    console.log($('.sel').length)
    if ($('.sel').length > 0) {
        if ($('body').find('.data-change-skin').length) return;
        fun.dialog({
            content: '要将所选的布匹生成到单据吗？',
            btn: ['生成', '不生成', '取消'],
            shadeClose: true,
            className: 'data-change-skin',
            yes: function () {
                saveData({
                    callback: function (eventData) {
                        setTimeout(function () {
                            detailedStockBack(eventData);
                        }, 200);
                    }
                });
            },
            no: function () {
                detailedStockBack();
            },
            // success: function (layero, index) {
            //     $('html').css({ "height": "100%", "overflow": "hidden" });
            //     $('body,.content').css({ "height": "100%", "overflow": "hidden" });
            // },
            // end: function () {
            //     $('html').css({ "overflow": "unset" });
            //     $('body,.content').css({ "overflow": "unset" });
            // }
        });
    } else {
        detailedStockBack();
    }
}

//获取库存数据
function getList() {
    stock.enabledListScroll();

    selDataObj = {};
    search_data['ck_id'] = $('#ck').data('ck_id') || 0;
    search_storage['ck'] = {
        id: $('#ck').data('ck_id') || 0,
        text: $('#ck').val() || ''
    };
    search_data['cp_id'] = $('#cp').data('cp_id') || 0;
    search_data['cp_ys_id'] = $('#cp_ys').data('cp_ys_id') || 0;
    // search_data['fk'] = $('#fk').val().trim();
    // search_data['kz'] = $('#kz').val().trim();
    // search_data['gh'] = $('#gh').val().trim();
    // search_data['gg'] = $('#gg').val().trim();
    // search_data['tm'] = $('#tm').val().trim();
    search_data['tm_arr'] = page_data['tm_arr'] || [];
    search_data['dw_id'] = page_data['dw_id'] || 0;

    clearContent();

    // if ($.nui.isEmpty(search_data['cp_id'])) {// || $.nui.isEmpty(search_data['cp_ys_id'])
    if ($.nui.isEmpty(search_data['tm']) && $.nui.isEmpty(search_data['cp_id'])) {
        fun.toast('请先选择产品！');
        params['data'] = [];
        $('#tj_sl').text(0);
        $('#tj_ps').text(0);
        return showList(params['data']);
    }

    // fun.showLoad();
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpkccxList,
        data: search_data,
        success: function (res) {
            __STORE_DATA['execFun'] = 'getList';
            // fun.hideLoad();
            clearContent();
            recordCk = {};
            // console.log(JSON.stringify(res));
            if (res['status'] == 0) {
                $('#tj_sl').text(res['info']['zsl'] || 0);
                $('#tj_ps').text(res['info']['zps'] || 0);

                stock.jlData = JSON.parse(JSON.stringify(res.data || []));

                var slice_data = res['data'].slice(0);

                params['data'] = res['data'];
                page_list = params['data'];

                // console.log(formatData(res['data']))

                showList(fun.PagingData(page_list));

                $('#sel_ps').text('0匹');
                $('#sel_sl').text(0);

                if (slice_data.length === 1 && $.nui.isTrue(search_data['tm'])) {//
                    $('.info_ckcp').addClass('sel');
                    $('.info_ckcp').addClass('mask');

                    var index = $('.info_ckcp').data('index'),
                        key = $('.info_ckcp').data('key');
                    var list = $('.info_ckcp').data('list');
                    selDataObj[key] = list;
                    setBpNum();
                }
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    });
}

function formatData(data) {
    if ($.nui.isEmpty(data)) {
        return [];
    }
    var list = [],
        tmp = {};
    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        if (!tmp[val['ck_id']]) {
            tmp[val['ck_id']] = {
                ck_id: val['ck_id'],
                ck_mc: val['ck_mc'],
                list: []
            }
        }
        tmp[val['ck_id']]['list'].push(val);
    }
    for (var i in tmp) {
        list.push(tmp[i]);
    }

    return list;
}

//渲染数据
function showList(data) {
    ck_list = [];
    var Html = [];
    $.each(data, function (i, obj) {
        var cp_ys_str = (obj['cp_ys_bh'] || '') + ' ' + (obj['cp_ys_mc'] || '');
        var cp_gg_str = (obj['ps'] || 0) + '匹 ' + (obj['sl'] || 0) + fun.is_value(obj['dw_mc']);
        var ck_name = (obj['ck_mc'] || '');
        var ck_id = (obj['ck_id'] || 0);
        Html.push('<div class="params_info">');
        // if (ck_list.indexOf(ck_name) == -1) {
        //     Html.push('  <p class="info_ckmc">' + ck_name + '</p>');
        //     ck_list.push(ck_name);
        // }
        if (!recordCk.hasOwnProperty(ck_id)) {
            Html.push('  <p class="info_ckmc">' + ck_name + '</p>');
            recordCk[ck_id] = ck_id;
        }

        Html.push('<div class="info_ckcp" data-key="' + obj['id'] + '" data-index="info' + i + '" index="' + i + '" data-tm="' + (obj['tm'] || '') + '" data-list=\'' + fun.formatString(JSON.stringify(obj)) + '\'>');
        Html.push('<div class="list-mask info' + i + '"></div>');
        Html.push('<p class="ckxp_f"><span class="cp_in cpmc">' + cp_ys_str + '</span><span class="cp_in cpcd">' + cp_gg_str + '</span>');
        // Html.push('<p class="ckxp_f cks">');
        isAddCks() && Html.push('<input type="text" class="cks-ipt num-input" id="' + getRandomId(1, 99) + '" decimal_digits="4" num_type="2" placeholder="出库数" data-ck-id="' + obj.ck_id + '"  data-origin-sl="' + fun.is_value(fun.toNumber(obj.sl), 0) + '">');
        fun.getKcSetting('fk') ? Html.push('<span class="cp_in"><em class="cp_in_mc">幅宽</em><em class="cp_in_val">' + (obj['fk'] || '') + '</em></span>') : '';
        fun.getKcSetting('kz') ? Html.push('<span class="cp_in"><em class="cp_in_mc">克重</em><em class="cp_in_val">' + (obj['kz'] || '') + '</em></span>') : '';
        fun.getKcSetting('gg') ? Html.push('<span class="cp_in"><em class="cp_in_mc">规格</em><em class="cp_in_val">' + (obj['gg'] || '') + '</em></span>') : '';
        // Html.push('<p class="ckxp_f cks">');
        fun.getKcSetting('gh') ? Html.push('<span class="cp_in monopoly"><em class="cp_in_mc">缸号</em><em class="cp_in_val">' + (obj['gh'] || '') + '</em></span>') : '';
        fun.getKcSetting('ph') ? Html.push('<span class="cp_in monopoly"><em class="cp_in_mc">批号</em><em class="cp_in_val">' + (obj['ph'] || '') + '</em></span>') : '';
        fun.getKcSetting('jh') ? Html.push('<span class="cp_in"><em class="cp_in_mc">卷号</em><em class="cp_in_val">' + (obj['jh'] || '') + '</em></span>') : '';
        fun.getKcSetting('cw') ? Html.push('<span class="cp_in monopoly"><em class="cp_in_mc">仓位</em><em class="cp_in_val">' + (obj['cw_mc'] || '') + '</em></span>') : '';
        // Html.push('<p class="ckxp_f cks"><span class="cp_in" style="width: 100%"><em class="cp_in_mc" style="font-size: 0.6rem">' + (obj['tm'] || '') + '</em></span></p>');
        Html.push('</p></div>');

        Html.push('</div>');
    });
    $('#params').append(Html.join(''));
    stock.createBottomLine();
    stock.showListBScroll.bScroll.refresh();
    stock.showListBScroll.bScroll.finishPullUp();
    $('.info_ckmc ~ .info_ckcp').css('margin-top', '0rem');
    // 如果：条码查询条件不为空 且 查询出来有1条记录，则默认为选中状态
}
//获取选中数据
function getSelectedData(is_clear) {
    var selData = [];

    for (var i in selDataObj) {
        selData.push(selDataObj[i]);
    }

    // 继续调用的话，清空内容。否则会出现重复数据。
    // if (is_clear) {
    //     selDataObj = {};
    // }
    // for (var i = 0; i < $('.grid_content tr').length; i++) {
    //     var $ele = $('.grid_content tr').eq(i);
    //     if ($ele.hasClass('active')) {
    //         selData.push($ele.data('list'));
    //     }
    // }
    return selData;
}

//设置匹数数量
function setBpNum() {
    var zps = 0;
    var zsl = 0;
    var rows = getSelectedData();

    for (var i = 0; i < rows.length; i++) {
        var ps = parseInt(rows[i]['ps']) || 0;
        var sl = parseFloat(rows[i]['sl']) || 0;
        var dys = parseFloat(rows[i]['dys']) || 0;

        if ($('.info_ckcp:visible').length) {
            if($('.info_ckcp[data-key=' + rows[i].id + ']').find('.cks-ipt').length){
                var val = fun.toNumber($('.info_ckcp[data-key=' + rows[i].id + ']').find('.cks-ipt').val().trim());
                if ($.nui.isTrue(val)) {
                    sl = val;
                }
            }
        }

        if ($.nui.isTrue(dys)) sl = dys;
        if ($.nui.isTrue(dys) && (dys < parseFloat(rows[i]['sl']))) {
            if ($('.info_ckcp:visible').length) {
                if($('.info_ckcp[data-key=' + rows[i].id + ']').find('.cks-ipt').length){
                    var val = fun.toNumber($('.info_ckcp[data-key=' + rows[i].id + ']').find('.cks-ipt').val().trim());
                    if ($.nui.isEmpty(val)) {
                        ps = 0;
                    }
                }
            } else {
                ps = 0;
            }
        };

        zps = (parseInt(zps) + ps).fixed();
        zsl = (parseFloat(zsl) + sl).fixed();
    }
    $('#sel_ps').text(zps + '匹');
    $('#sel_sl').text(zsl);
}


//调用并生成
function saveData(opt) {
    var _params = $.extend({
        is_showLoad: false,
        is_continue: false,
        callback: null,
        type: 'select',
        scanData: null
    }, opt);

    var selData = [];

    if (_params['type'] == 'select') {
        selData = getSelectedData(true);
    } else if (_params['type'] == 'scan') {
        selData.push(_params['scanData']);
    }

    updateCks(selData);

    if ($('.sel').length && $.nui.isEmpty(selData)) return fun.toast('请选择库存记录'); //无选择记录则不执行任何操作

    if ($.nui.isEmpty(selData) && !_params['is_continue']) {
        detailedStockBack();
        return;
    }

    var __key_arr = {};
    var __data = [];
    var zsl = 0;
    var ck_id = 0;

    for (var i = 0; i < selData.length; i++) {
        // 当所选记录行 为 待出库 布匹时，则跳过该布匹
        if ($.nui.isTrue(selData[i]['is_dck'])) {
            ck_id = selData[i]['ck_id'];
            continue;
        }

        if ($.nui.isTrue(fun.getHouseValue(selData[i]['ck_id'], 'is_detail'))) {
            // 当所选记录行 的 匹数 或 调用数 为负数时，则跳过该布匹。（盘亏单允许调用，其他窗口不允许调用负数）
            if ((page_data['djlx'] !== 'kc_bpmxpkd') && ((selData[i]['ps'] < 0) || (selData[i]['dys'] < 0))) continue;
        } else {
            if (page_data['djlx'] !== 'kc_bpzspd' && page_data['djlx'] !== 'kc_bpmxpkd') {
                if (selData[i]['ps'] < 0) selData[i]['ps'] = 0;
                if (selData[i]['sl'] < 0) selData[i]['sl'] = 0;
            }
        }

        if ($.nui.isEmpty(SYS_CONFIG['dckms_bp'])) {
            for (var m = 0; m < __JL_DATA.length; m++) {
                if (selData[i]['ck_id'] != __JL_DATA[m]['ck_id']) {
                    return fun.toast('不允许调用多个仓库的布匹。');
                }
            }
        }

        if ((i !== 0) && $.nui.isEmpty(SYS_CONFIG['dckms_bp'])) {
            if (ck_id != selData[i]['ck_id']) {
                // only_ck_id = 0;
                only_ck_id = PAGE_INIT_CK_ID;
                return fun.toast('不允许调用多个仓库的布匹。');
            }
        }


        // if($.nui.isTrue(is_continue)){
        // 如果是 继续添加 的情况判断仓库是否和上一次一样
        if ($.nui.isEmpty(SYS_CONFIG['dckms_bp']) &&
            $.nui.isTrue(only_ck_id) && only_ck_id != selData[i]['ck_id']) {
            // only_ck_id = 0;
            // only_ck_id = PAGE_INIT_CK_ID;
            return fun.toast('不允许调用多个仓库的布匹。');
        }
        // }

        var sl = selData[i]['dys'] ? selData[i]['dys'] : selData[i]['sl'];
        ck_id = selData[i]['ck_id'];
        only_ck_id = selData[i]['ck_id'];
        // PAGE_INIT_CK_ID = selData[i]['ck_id'];
        only_ck_mc = selData[i]['ck_mc'];
        zsl = zsl + parseFloat(sl);

        var data2 = {
            'is_yy_tm': (selData[i]['tm'] ? 1 : 0),
            'ck_id': selData[i]['ck_id'],
            'ck_mc': selData[i]['ck_mc'],
            'cw_id': selData[i]['cw_id'],
            'cw_mc': selData[i]['cw_mc'],
            'cp_id': selData[i]['cp_id'],
            'cp_bh': selData[i]['cp_bh'],
            'cp_mc': selData[i]['cp_mc'],
            'cp_ys_id': selData[i]['cp_ys_id'],
            'cp_ys_bh': selData[i]['cp_ys_bh'],
            'cp_ys_mc': selData[i]['cp_ys_mc'],
            'fk': selData[i]['fk'],
            'kz': selData[i]['kz'],
            'gg': selData[i]['gg'],
            'gh': selData[i]['gh'],
            'jh': selData[i]['jh'],
            'ph': selData[i]['ph'],
            'ck_zdy1': selData[i]['ck_zdy1'],
            'ck_zdy2': selData[i]['ck_zdy2'],
            'ck_zdy3': selData[i]['ck_zdy3'],
            'ck_zdy4': selData[i]['ck_zdy4'],
            'ck_zdy5': selData[i]['ck_zdy5'],
            'dw_id': selData[i]['dw_id'],
            'dw_mc': selData[i]['dw_mc'],
            'dw2_id': selData[i]['dw2_id'],
            'dw2_mc': selData[i]['dw2_mc'],
            // 'bz': selData[i]['jl_bz'],
            'jl_bz': selData[i]['bz'],
            'ywy_id': selData[i]['ywy_id'],
            'ywy_mc': selData[i]['ywy_mc'],
            'bp_kh_id': selData[i]['bp_kh_id'],
            'bp_kh_mc': selData[i]['bp_kh_mc'],
            'bp_gys_id': selData[i]['bp_gys_id'],
            'bp_gys_mc': selData[i]['bp_gys_mc'],
            'bp_jgs_id': selData[i]['bp_jgs_id'],
            'bp_jgs_mc': selData[i]['bp_jgs_mc'],
            'dd_dh': '',
            'dd_kdsj': '',
            'dd_dj_id': '',
            'dd_jl_id': '',
        };

        // 明细盘亏,添加需要字段
        if (page_data.djlx === 'kc_bpmxpkd') {
            data2.tm = selData[i]['tm'];
            data2.kcms = selData[i]['kcms'];
            data2.kc = selData[i].kc;
            data2.jcs = selData[i].jcs;
            data2.kc_sl = selData[i].sl;
            data2.zjz = selData[i].jz;
            data2.kc_sl2 = selData[i].sl2;
            data2.rk_sj = selData[i].rksj;
            data2.rk_djlx_mc = selData[i].rkfs_djlx_mc;
            data2.rk_djlx = selData[i].rkfs_djlx;
        } else if (page_data.djlx === 'bp_cgthjs') {  // 采购退货调库存
            data2.dd_kdsj = selData[i].dd_kdsj;
            data2.dd_lb_mc = selData[i].dd_lb_mc;
            data2.dd_lb_id = selData[i].dd_lb_id;
            data2.dd_dj_id = selData[i].dd_dj_id;
            data2.dd_jl_id = selData[i].dd_jl_id;
        }

        // if (page_data.get_jjdw && page_data.__row_data) {
        //     data2.jjdw_id = page_data.__row_data.jjdw_id;
        //     data2.jjdw_mc = page_data.__row_data.jjdw_mc;
        // } else {
        var key = $.nui.md5(JSON.stringify(data2));
        var index = __key_arr[key];


        var cp_list = fun.getItem('cp_list') || [];
        var wldw_list = [];
        var jjdw_list = fun.getItem('jjdw_list') || [];


        var wldw_type = '';

        // 根据 往来单位类型, 赋值 档案 预设的 计价单位
        var unit_options = fun.getValByKey(cp_list, data2['cp_id'], 'unit_options');

        switch (page_data['djlx']) {
            case 'bp_xsfhjs':
                wldw_type = 'kh';
                wldw_list = fun.getItem('wldw_kh_list') || [];
                break;
            case 'bp_cgthjs':
                wldw_type = 'gys';
                wldw_list = fun.getItem('wldw_gys_list') || [];
                break;
        }

        if (['bp_xsfhjs', 'bp_cgthjs'].indexOf(page_data['djlx']) > -1) {
            wldw_type = fun.getValByKey(wldw_list, __DJ_DATA['wldw_id'] || 0, 'type') || '';
        }

        switch (wldw_type) {
            case 'kh':
                data2['jjdw_id'] = unit_options['xsdw_id'];
                break;
            case 'gys':
                data2['jjdw_id'] = unit_options['cgdw_id'];
                break;
            case 'jgs':
                data2['jjdw_id'] = unit_options['jgdw_id'];
                break;
        }

        data2['jjdw_mc'] = fun.getValByKey(jjdw_list || [], data2['jjdw_id'], 'name');

        if ($.nui.isEmpty(data2['jjdw_id'])) {
            data2['jjdw_id'] = data2['dw_id'] || 0;
            data2['jjdw_mc'] = data2['dw_mc'] || '';
        }

        if (page_data.get_jjdw && page_data.__row_data) {
            data2.jjdw_id = page_data.__row_data.jjdw_id;
            data2.jjdw_mc = page_data.__row_data.jjdw_mc;
        }
        // }

        var __ck_list = fun.getItem('ck_list') || [];

        if (fun.getValByKey(__ck_list, data2['ck_id'], 'type') === 'skyb' && data2['cp_ys_bh'] === '色卡') {
            data2.jjdw_id = data2['dw_id'];
            data2.jjdw_mc = data2['dw_mc'];
            data2.jg_lx = 'sk';
            data2.jg_lx_mc = '色卡';
        }


        updateRowDataAmountAndMoney(null, data2);

        if (page_data.djlx === 'kc_bpmxpkd') {
            data2.zjz = selData[i].jz;
            data2.yy_djlx = selData[i]['yy_djlx'];
            data2.is_dy = $.nui.isTrue(selData[i]['yy_djlx']) ? 1 : 0;
        }

        if (['kc_bpzspd', 'kc_bpmxpkd', 'kc_bptbd', 'kc_bppyd'].indexOf(page_data['djlx']) > -1) {
            delete data2.jjdw_id;
        }


        if (index === undefined) {
            __key_arr[key] = __data.length;

            var tmpData = $.extend(true, {}, data2, {
                'ps': selData[i]['ps'],
                'zsl': sl
            });

            // 如果有开启 明细管理 则 要插入 明细表 信息
            if ($.nui.isTrue(fun.getHouseValue(selData[i]['ck_id'], 'is_detail'))) {
                tmpData['tm'] = selData[i]['tm'];
                tmpData['mx'] = [{
                    px: 1, ph: 1, tm: selData[i]['tm'],
                    sl: parseFloat(sl),
                    tm_sl: parseFloat(selData[i]['sl'] || 0),
                    yy_tm_info: selData[i]
                }];
            }
            __data.push(tmpData);
        } else {
            __data[index]['zsl'] = (__data[index]['zsl'] + sl).fixed();
            __data[index]['ps'] = (__data[index]['ps'] + selData[i]['ps']).fixed();

            // 如果有开启 明细管理 则 要插入 明细表 信息
            if ($.nui.isTrue(fun.getHouseValue(selData[i]['ck_id'], 'is_detail'))) {
                var __item = {
                    tm: selData[i]['tm'], tm_sl: parseFloat(selData[i]['sl']),
                    sl: parseFloat(sl), yy_tm_info: selData[i],
                };
                if (__data[index]['mx'].length >= 10) {
                    __item['ph'] = (__data[index]['mx'].length % 10) + 1;
                } else {
                    __item['ph'] = (__data[index]['mx'].length + 1);
                }
                __item['px'] = parseInt(__data[index]['mx'].length / 10) + 1;
                __data[index]['mx'].push(__item);
            }
        }

        if ($.nui.isTrue(selData[i]['tm'])) {
            page_data['tm_arr'].push(selData[i]['tm']);
        }
    }

    page_data['__row_data'] = $.extend({}, page_data['__row_data'], { __index: page_data['row_index'] });


    if (_params['is_continue']) selDataObj = {};

    _params['is_showLoad'] && fun.showLoad();

    __tmp_jl_data = __tmp_jl_data.concat(__data);

    var eventExtraData = {
        'status': 'fhjs_dkc',//发货结算调库存
        'data': {
            row: page_data['__row_data'] || {},
            ck_id: ck_id,
            list: __data,
            row_index: page_data['row_index']
        }
    };

    // 总数盘点单新增，发送事件无效，需要先记录继续调用的库存记录
    // 明细盘亏新增也是这样
    if (['kc_bpzspd', 'kc_bpmxpkd'].indexOf(page_data.djlx) > -1 && $.nui.isTrue(page_data.__IS_NEW) && _params.is_continue) {
        detailed_stock_rows = detailed_stock_rows.concat(__data);
    }

    // 编辑行记录时调库存处理
    if (__EDIT_ROW) {
        adjustStockInEdit(eventExtraData.data);
    } else {
        api.sendEvent({
            name: page_data['goto_page'],
            extra: eventExtraData
        });
    }

    // search_data = {
    //     "ck_id": 0,
    //     "cp_id": 0,
    //     "cp_ys_id": 0,
    //     "dw_id": 0,
    //     "sl": 0,
    //     "xj": 0,
    //     "type": "mxb",
    //     "tm_arr": page_data['tm_arr'] || [],
    //     "xsdck": 0,
    //     "has_tm": 0,
    //     "not_has_tm": 0,
    //     "djlx": "bp_xsfhjs",
    //     "is_dy": true,
    //     "fk": '',
    //     "kz": '',
    //     "gh": '',
    //     "tm": '',
    // };

    // $('#cp').val('').data('cp_id', 0);
    // $('#cp_ys').val('').data('cp_ys_id', 0);
    // $('#ck').val('').data('ck_id', 0);
    //
    // $('.list-icon').hide();
    //
    // $('#fk').val('');
    // $('#kz').val('');
    // $('#gh').val('');
    // $('#tm').val('');

    // getList();

    params['data'] = [];
    // 重新渲染数据
    // showList(params['data']);

    clearContent({ clearHeader: false });
    if (_params['is_continue']) {
        getList();
    }

    if (typeof _params['callback'] === 'function') _params['callback'](eventExtraData);
    return eventExtraData;
}

// 设置库存偏好设置
function setKcph(data) {
    var tmp_list = [];
    var _data = data || [];

    for (var i = 0; i < _data.length; i++) {
        tmp_list.push(_data[i]['id']);
    }

    var save_data = {
        "type": "sys",
        "list": [
            { "key": "kcphsz", "value": tmp_list.join(',') }
        ]
    };
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveSysConfig,
        data: save_data,
        success: function (res) {
            if (res['status'] == 0) {
                fun.load_DATA_LIST(['sys_config'], function () {
                    // 不一定执行getList，有可能执行扫码
                    if (__STORE_DATA['execFun'] === 'getList') {
                        getList();
                    } else if (__STORE_DATA['execFun'] === 'scanCode') {
                        scanCodeCallback(__STORE_DATA['execTm']);
                    }
                }, { showLoad: false });
            } else {
                fun.toast('保存失败');
            }
        }
    });
}

/************************ 事件绑定 ***********************/
fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function (e) {
    e.stopPropagation();
    var sideslip = fun.getItem(html_name + 'sideslip');
    $('.collapse-wrap').removeClass('open');
    $('#much_btn,.icon-saoma').hide();
    var options = {
        "sort": [
            {
                "text": "数量",
                "key": "sl",
                "value": search_storage['order'] && search_storage['order']['sl'] || ""
            },
        ],
        "stock_input": [{
            key: "fk",
            "text": "幅宽",
            "value": (search_storage['fk'] && search_storage['fk']['text']) || "",
        }, {
            key: "kz",
            "text": "克重",
            "value": (search_storage['kz'] && search_storage['kz']['text']) || "",
        }, {
            key: "gg",
            "text": "规格",
            "value": (search_storage['gg'] && search_storage['gg']['text']) || "",
        }, {
            key: "ph",
            "text": "批号",
            "value": (search_storage['ph'] && search_storage['ph']['text']) || "",
        }, {
            key: "gh",
            "text": "缸号",
            "value": (search_storage['gh'] && search_storage['gh']['text']) || "",
        }, {
            key: "jh",
            "text": "卷号",
            "value": (search_storage['jh'] && search_storage['jh']['text']) || "",
        },
        ],
        "choose_merchants": [
            {
                key: "ck",
                "text": "仓库",
                "value": (search_storage['ck'] && search_storage['ck']['text']) || "",
                "id": (search_storage['ck'] && search_storage['ck']['id']) || 0,
                "is_sum": page_data['djlx'] === 'kc_bpzspd' ? true : false,
                "is_detail": page_data['djlx'] === 'kc_bpmxpkd' ? true : false,
            }, {
                key: "cw",
                "text": "仓位",
                "value": (search_storage['cw'] && search_storage['cw']['text']) || "",
                "id": (search_storage['cw'] && search_storage['cw']['id']) || 0,
            }
        ]
    }
    if (api.systemType !== 'android') {
        fun.ajax({
            showLoad: false,
            hideLoad: true,
            url: AJAX_URL.getSysList,
            data: {},
            success: function (res) {
                if (res['status'] == 0) {
                    if (sideslip) {
                        fun.setItem(html_name + 'sideslip', false);
                        fun.openFrame({
                            frame_url: page_arr.search,
                            pageParam: {
                                "return_page": html_name,
                                "SYS_CONFIG_kcphsz": res['data']['kcphsz'] || '',
                                "search_data": options
                            },
                        });
                    }
                }
            }
        });
    } else {
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    "return_page": html_name,
                    "SYS_CONFIG_kcphsz": '',
                    "search_data": options
                },
            });
        }
    }

});

$('body').on('click', '.info_ckcp', function (e) {
    e.stopPropagation();
    var index = $(this).data('index'),
        key = $(this).data('key');
    var list = $(this).data('list');
    var objs = $(this).find('.list-mask');

    if (!$(this).hasClass('mask')) {
        $(this).addClass('mask');
        $(this).addClass('sel');
        selDataObj[key] = list;
    } else {
        $(this).removeClass('mask');
        $(this).removeClass('sel');
        delete selDataObj[key];
    }

    console.log(selDataObj)
    setBpNum();
});
//点击跳转搜索页
$('body').on('tap', '.list-type', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;
    var list_type = $(this).data('type');
    var url = '';
    var param = {
        return_page: html_name,
        page_type: list_type
    };
    switch (list_type) {
        case 'cp':
            url = page_arr.product_search;
            break;
        case 'cp_ys':
            if (!$('#cp').data('cp_id')) return fun.toast('请先选择产品！');
            url = page_arr.select_list;
            param['cp_id'] = $('#cp').data('cp_id');
            var cp_list = fun.getItem('cp_list') || [];
            var tmp_data = fun.getListInfoByKey(cp_list, param['cp_id']) || {};
            tmp_data['imgs'] = tmp_data['imgs'] || '';
            param['cpbj_info'] = {
                cp_id: tmp_data['id'] || 0,
                cp_bh: tmp_data['number'] || '',
                cp_mc: tmp_data['name'] || '',
                cp_ys_id: 0,
                cp_ys_bh: '',
                cp_ys_mc: '',
                fzsh: '',
                fzys: '',
                kcms: tmp_data['diff'] || '+',
                imgs: tmp_data['imgs'].split(',')[0] || '',
                dw_id: tmp_data['unit_id'] || 0,
                dw_mc: tmp_data['unit_name'] || '',
                fk: tmp_data['width'] || '',
                kz: tmp_data['weight'] || '',
                gg: tmp_data['spec'] || '',
                cf: tmp_data['component'] || ''
            };

            param['__JL_DATA'] = __tmp_jl_data;
            param['djlx'] = page_data.djlx;

            if (['bp_xsfhjs', 'bp_cgthjs', 'kc_bptbd', 'kc_bpmxpkd', 'kc_bpzspd'].indexOf(page_data['djlx']) > -1) {
                if ($.nui.isTrue($('#ck').data('ck_id'))) {
                    param['ck_id'] = $('#ck').data('ck_id');
                    param['is_ck'] = true;
                }
            }

            break;
        case 'ck':
            url = page_arr.select_list;

            if (page_data['djlx'] === 'kc_bpzspd') {
                param['is_sum'] = true;//只查总数
            }
            if (page_data['djlx'] === 'kc_bpmxpkd') {
                param['is_detail'] = true;
            }

            break;
    }
    fun.showPageFull({
        page_url: url,
        pageParam: param
    });
});

//跳转到规格搜索页
// $('body').on('tap', '.list-goods', function (e) {
//     var cp_title = $('#cp').val();
//     var cp_id = $('#cp').data('cp_id') || 0;
//     var gg_name = $('#gg').val();
//     if ($.nui.isTrue(cp_title) && cp_id > 0) {
//         fun.showPageFull({
//             page_url: page_arr.specifications,
//             pageParam: {
//                 html_name: html_name,
//                 cp_title: cp_title,
//                 cp_id: cp_id,
//                 gg_name: gg_name
//             }
//         });
//     } else {
//         fun.toast('请先选择产品！');
//     }
// });

//失去焦点
// $('#fk,#kz,#gh').on('blur', function (e) {
//     var id = this.id;
//     if (search_data[id] != $(this).val().trim()) {
//         getList();
//     }
// });

// $('#tm').on('change', function (e) {
//     var id = this.id;
//     var value = $(this).val().trim();
//     if (value) {
//         scanCodeCallback(value);
//     } else {
//         getList();
//     }
// });

//确定按钮事件
$('body').delay('tap', '#confirm', function (e) {
    e.stopPropagation();
    e.preventDefault();
    clearTimeout(this.timer);
    this.timer = setTimeout(function () {
        saveData({
            is_showLoad: true,
            callback: function (eventData) {
                if (eventData) {
                    setTimeout(function () {
                        fun.hideLoad();
                        detailedStockBack(eventData);
                    }, 200);
                }
            }
        });
    }, 200);
});

//继续调用
$('body').on('click', '#save', function (e) {
    e.stopPropagation();
    clearTimeout(this.timer);
    this.timer = setTimeout(function () {
        saveData({ is_continue: true });
    }, 200);
});

//清除选中值
$('body').on('tap', '.list-icon', function (e) {
    e.stopPropagation();
    var list_type = $(this).prev().data('type');
    switch (list_type) {
        case 'cp':
            $('#cp').val('').data('cp_id', 0);
            $('#cp_ys').val('').data('cp_ys_id', 0);
            break;
        case 'cp_ys':
            $('#cp_ys').val('').data('cp_ys_id', 0);
            break;
        case 'ck':
            $('#ck').val('').data('ck_id', 0);
            break;
        case 'gg':
            $('#gg').val('').data('ck_id', 0);
            break;
    }
    $(this).hide();
    getList();
});
//扫描
$('body').on('tap', ".icon-saoma", function () {
    $('.collapse-wrap').removeClass('open');
    QuestPermission.requestPermission('camera', null, function () {
        openScanner({
            close_win: false,
            callback: function (value) {
                value = $.trim(value);
                // $('#tm').val(value);
                scanCodeCallback(value);
            }
        });
    });
});
//更多
$('body').on('tap', '#much_btn', function (e) {
    e.stopPropagation();
    $('.collapse-wrap').css('top', api.safeArea.top - 17 + 'px');
    if ($('.collapse-wrap').hasClass('open')) {
        $('.collapse-wrap').removeClass('open');
    } else {
        $('.collapse-wrap').addClass('open');
    }
});
//点击其他区域，关闭更多
$('body,html').on('tap', function (e) {
    $('.collapse-wrap').removeClass('open');
});
//偏好设置
$('body').on('touchend', '#phsz', function (e) {
    e.preventDefault();
    e.stopPropagation();
    // getRowSaveData();
    var list_data = [
        { name: '幅宽/克重', id: 'fk,kz' },
        { name: '规格', id: 'gg' },
        { name: '批号', id: 'ph' },
        { name: '缸号', id: 'gh' },
        { name: '卷号', id: 'jh' },
        { name: '仓位', id: 'cw' }
    ];

    for (var i = 0; i < list_data.length; i++) {
        if (fun.getKcSetting(list_data[i]['id'])) {
            list_data[i]['is_choose'] = 1;
        }
    }
    fun.showBookList({
        width: '280px',
        shadeClose: false,
        checkbox: true,
        list: list_data,
        choose: function (data) {
            setKcph(data);
        }
    });
    $('.collapse-wrap').removeClass('open');
    return false;
});

// 出库数点击聚焦阻止事件冒泡
$('body').on('focus tap click', '.cks-ipt', function (e) {
    e.stopPropagation();
    var u = navigator.userAgent;
    var isAndroid = u.indexOf("Android") > -1 || u.indexOf("Adr") > -1; // android终端
    if (isAndroid) {
        $(this).addClass('cks-focus');
    }
})

// 出库数失去焦点检测
$('body').on('blur', '.cks-ipt', function (e) {
    e.stopPropagation();
    if (!isAddCks()) return;
    checkCks.call(this);
})

//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: false   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');

    FNScanner.openScanner({
        autorotation: true,
        encoding: 1
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            } else if (ret.eventType == 'fail') {
                fun.alert({ msg: '图片识别失败！' });
            }
        }
    });

    // FNScanner.open({
    //     autorotation: false
    // }, function (ret, err) {
    //     // if (ret) {
    //     //     if (ret.eventType == 'success') {
    //     //         if (typeof _options.callback === 'function') _options.callback(ret.content);
    //     //         if (_options.close_win) FNScanner.closeView();
    //     //     }
    //     // }
    // });

}


// 返回操作处理，兼容开窗跳转到下一个窗口
function detailedStockBack(appendData) {
    appendData = appendData || {};
    if ($.nui.isTrue(page_data['__route'])) {
        // 总数盘点、明细盘亏新增,添加之前继续调用的数据
        if (['kc_bpzspd', 'kc_bpmxpkd'].indexOf(page_data.djlx) > -1 && $.nui.isTrue(page_data.__IS_NEW)) {
            if (!appendData.data) {
                appendData.data = { list: [] };
            } else if (!appendData.data.list) {
                appendData.data.list = [];
            }
            appendData.data.list = appendData.data.list.concat(detailed_stock_rows);
        }
        PageShow.gotoNextPage({ html_name: html_name, page_data: $.extend(page_data, appendData), closeWin: true });
    } else {
        api.closeToWin({ name: page_data['goto_page'] });
    }
}


function update_sel_row(data) {
    var obj = $('[data-type="' + data['page_type'] + '"]');
    var attrId = data['page_type'] || "";
    var row_id = $(obj).data(attrId + '_id');
    if (data['del_id'].length != 0) {
        data['del_id'] = convert(data['del_id']);
        if (data['del_id'].indexOf(row_id) > -1) {
            $(obj).data(attrId + '_id', 0).val("");
            $(obj).next('.icon-close').hide();
        }
    }
    if (data['up'].length != 0) {
        for (var i = 0; i < data['up'].length; i++) {
            if (data['up'][i]['id'] == row_id) $(obj).data(attrId + '_id', data['up'][i]['id']).val(data['up'][i]['name'] || "");
        }
    }

    //数组值转字符串
    function convert(arr) {
        return String(arr).split();
    }
}


function scanCodeCallback(value) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileTmInfo,
        data: { tm: value },
        success: function (res) {
            __STORE_DATA['execFun'] = 'scanCode';
            __STORE_DATA['execTm'] = value;
            // clearContent();
            selDataObj = {};
            // if (res['status'] != 0) return fun.toast('不存在该条码！');
            if (res['status'] != 0) return fun.toast('找不到该条码。');
            var tmpData = res['data'];

            if ($.nui.isTrue(tmpData['is_dck'])) return fun.toast('待出库布匹无法重复采集');
            if ($.nui.isTrue(tmpData['is_ck'])) return fun.toast('该条码已经出库');

            for (var i = 0; i < page_data['tm_arr'].length; i++) {
                if (page_data['tm_arr'][i] == value) return fun.toast('已被当前单据调用');
            }

            // for (var i = 0; i < __JL_DATA.length; i++) {
            //     var mx = __JL_DATA[i]['mx'] || [];
            //     for (var j = 0; j < mx.length; j++) {
            //         if(mx[j]['is_delete']) continue;
            //         if (mx[j]['tm'] == value) return fun.toast('已被当前单据调用');
            //     }
            // }

            var USER_INFO = fun.getItem('user_info') || {};

            if ($.nui.isTrue(USER_INFO['store_id']) && $.nui.isTrue(tmpData['md_id'])
                && USER_INFO['store_id'] != tmpData['md_id']) {
                return fun.toast('你没有权限采集其他门店的条码');
            }

            var SYS_CONFIG = fun.getItem('sys_config') || {};

            // if ($.nui.isEmpty(SYS_CONFIG['dckms_bp'])) {
            //     if ($.nui.isTrue(__JL_DATA) && (__JL_DATA[0]['ck_id'] != tmpData['ck_id'])) {
            //         fun.toast('不允许调用多个仓库的布匹');
            //     }
            // }
            recordCk = {};

            var tmpList = [tmpData];
            clearContent();
            selDataObj = {};
            showList(tmpList);

            $('#cp').val(tmpData['cp_bh'] + '' + tmpData['cp_mc']).data('cp_id', tmpData['cp_id']);
            $('#cp_ys').val(tmpData['cp_ys_bh'] + '' + tmpData['cp_ys_mc']).data('cp_ys_id', tmpData['cp_ys_id']);
            $('#cp_ys').next().show();
            $('#ck').val(tmpData['ck_mc']).data('ck_id', tmpData['ck_id']);
            $('#ck').next().show();
            search_data['ck_id'] = $('#ck').data('ck_id') || 0;
            search_storage['ck'] = {
                id: $('#ck').data('ck_id') || 0,
                text: $('#ck').val() || ''
            };
            search_data['cp_id'] = $('#cp').data('cp_id') || 0;
            search_data['cp_ys_id'] = $('#cp_ys').data('cp_ys_id') || 0;
            search_data['gg'] = '';
            search_storage['gg']['text'] = '';

            $('#tj_sl').text(tmpData['sl'] || 0);
            $('#tj_ps').text(tmpData['ps'] || 0);

            var slice_data = tmpList.slice(0);

            $('#sel_ps').text('0匹');
            $('#sel_sl').text(0);

            if (slice_data.length === 1) {
                $('.info_ckcp').addClass('sel');
                $('.info_ckcp').addClass('mask');

                var index = $('.info_ckcp').data('index'),
                    key = $('.info_ckcp').data('key');
                var list = $('.info_ckcp').data('list');
                selDataObj[key] = list;
                setBpNum();
            }

            // saveData({type: 'scan', is_continue: true, scanData: tmpData});
        }
    });
}

function __checkData() {
    if (!fun.dataIsRead(['ck'])) {
        setTimeout(__checkData, 250);
    } else {
        setTimeout(function () {
            if (typeof page_init === "function") page_init();
        }, 100);
    }
}

/**
 * 编辑行记录时调库存处理
 */
function adjustStockInEdit(data) {
    updateJLData = function (tmpData, index) {
        if (typeof index !== 'undefined' && index !== null) {
            updateRowDataAmountAndMoney(index, tmpData);
            __JL_DATA[index] = tmpData;
        } else {
            updateRowDataAmountAndMoney(index, tmpData);
            __JL_DATA.push(tmpData);
        }
    };

    // 调库存不处理成本价问题，具体页面具体处理
    __dkc_callback(data, data.row_index, page_data.goto_page);

    // 发送事件通知
    // 目前通知页面：调拨单、采购退货结算

    api.sendEvent({
        name: page_data['goto_page'],
        extra: {
            status: 'dkc_add',
            data: {
                __JL_DATA: __JL_DATA,
                row_index: data.row_index
            }
        }
    });
}

function clearContent(options) {
    var _options = $.extend({ clearHeader: true }, options);
    if (_options['clearHeader']) {
        $('#tj_sl').text(0);
        $('#tj_ps').text(0);
    }
    setBpNum();
    $('#params').html('');
    page_list = [];
}

/**
 * 获取随机id值
 */
function getRandomId(x, y) {
    return Date.now() + Math.floor(Math.random(y - x + 1) + x);
}

function isAddCks() {
    var djlxArr = ['kc_bpmxpkd', 'bp_xsfhjs', 'bp_cgthjs'];
    return djlxArr.indexOf(page_data['djlx']) > -1;
}

// 更新出库数
function updateCks(selData) {
    selData.forEach(function (item, idx) {
        if($('.info_ckcp[data-key=' + item.id + ']').find('.cks-ipt').length){
            var val = fun.toNumber($('.info_ckcp[data-key=' + item.id + ']').find('.cks-ipt').val().trim());
            // 如果出库数 = 空，则将数量作为出库数。
            // 如果出库数不为空，则将出库数作为出库数。
            if ($.nui.isTrue(val)) {
                item.dys = val;
            }
        }
    })
};

(function () {
    var u = navigator.userAgent;
    var isAndroid = u.indexOf("Android") > -1 || u.indexOf("Adr") > -1; // android终端
    if (isAndroid) { // 安卓软键盘主动收起，需要检测出库数
        $(window).on('resize', function () {
            if ($(window).outerHeight() === window.screen.height) { // 安卓软键盘收起
                checkCks.call($('.cks-focus'));
            }
        })
    }
})();

/**
 * 出库数检测
 */
function checkCks() {
    var index = $('.cks-ipt').index($(this));
    if (index <= -1) return; // 存在失去焦点和键盘收起同时执行的情况
    var jlData = stock.jlData[index];
    var val = fun.toNumber($(this).val().trim());
    var $parents = $(this).parents('.info_ckcp');
    if ($.nui.isTrue(val)) {
        // 当前数量大于库存数，则恢复原来的值 且 淡出提示：
        var kcSl = fun.toNumber($(this).data('origin-sl'));
        var callKcSl = fun.toNumber(jlData.sl);
        if (val > callKcSl) {
            $(this).val(kcSl).data('origin-sl', kcSl);
            $(this).removeClass('cks-focus');
            fun.toast('该布匹最多只能发：' + fun.is_value(callKcSl, 0) + fun.is_value(jlData['dw_mc']) + '');
            addRowMark($parents);
            setBpNum();
            return;
        };
        $(this).data('origin-sl', val);
        addRowMark($parents);
    };
    setBpNum();
    $(this).removeClass('cks-focus');
}

/**
 * 
 */
function addRowMark(parents) {
    parents.addClass('mask sel');
    selDataObj[parents.data('key')] = parents.data('list');
}