var html_name = page_arr.employee,
    search_data = {},
    temps,
    page_list = [],
    is_edit = false,
    ztj_data = [];
var UPDATE = { del_id:[], up:[] };
var USER_INFO = {};
var create_time = {};

// 头部
$('#header').header({
    back: true,
    title: '员工',
    add: Auth.check('yg', 'edit'),
    filter: true,
    foot_input: {
        show: true,
        plader: '搜索员工',
        yuyin_icon: false,
    },
    appendBackBtnEvt: updatePrevPage
});

page_init = function () {
    USER_INFO = fun.getItem('user_info')||{};
    if (!page_data.page_type) {
        $('.cut-con .debt-info').css('display', 'block');
    } else {
        // if (!Auth.check('yg', 'edit')) {
        //     $('#add_btn').hide();
        //     $('#list_wrap').removeClass('swipe-delete');
        // }
        $('#list_wrap').removeClass('swipe-delete');
    }
    if (!Auth.check('yg', 'edit')) {
        $('#add_btn').hide();
        $('#list_wrap').removeClass('swipe-delete');
    }

    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['store_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['store_name'] = (disabled ? (USER_INFO['store_name']) : '');

    page_data.keyback = updatePrevPage;//  监听返回键

    fun.orderListHeight({dom:'#list_wrap'});

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'search':
                search_data['store_id'] = temp['data']['md']['id'] || '';//门店
                search_data['store'] = temp['data']['md']['text'] || '';

                search_data['section_id'] = temp['data']['xz_bm']['id'] || '';//部门
                search_data['section'] = temp['data']['xz_bm']['text'] || '';
                search_data['position_id'] = temp['data']['xz_zw']['id'] || '';//职位
                search_data['position'] = temp['data']['xz_zw']['text'] || '';

                search_data['is_stop'] = temp['data']['is_stop'] || '';//隐藏0欠款
                // search_data['birthday']=temp['data']['birthday'] || '';
                fun.setItem(html_name + '_isStop', temp['data']['is_stop']);
                // fun.setItem(html_name + '_birthday', temp['data']['birthday']);
                fun.setItem(html_name + 'sideslip', true);
                getList();
                break;
            case 'refresh':
                getList();
                break;
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list, 5) || []);
        } else {
            fun.createBottomLine('list_wrap', ".person-list");
        }
    });
    getList();
}

function getList() {
    page_list = [];
    temps = $.extend({
        "keyword": "",
        "keyword_key": ['name','simple'],
        "store_id": 0,
        "store": "",
        "section_id": 0,
        "section": "",
        "position_id": 0,
        "position": "",
        "is_stop": fun.getItem(html_name + '_isStop') || '',
        // "birthday":fun.getItem(html_name + '_birthday') || '',
    }, search_data);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getStaffList,
        data: temps,
        success: function (res) {
            // if (!res['data'] || res['data'].length == 0) {
            //     $('.empty').show();
            // } else {
            //     $('.empty').hide();
            // }
            if (res['status'] == 0) {
                $('#list_wrap').empty();
                $('#list_wrap').html('');
                if(res['data'].length == 0){
                    // return $('#list_wrap').html('<p class="empty_text">暂无数据！</p>');
                    $('#tj_zrs').text(0);
                    return fun.createDataEmptyTips({dom:'#list_wrap',btnText:'新增员工',auth:'yg',style:'top:0rem;',sameAsTj:false,isDa:true});
                }
                ztj_data = res['info'];
                $('#tj_zrs').text(ztj_data['count'] || 0);
                // if (res['data']) {
                    page_list = res['data'];
                    showList(fun.PagingData(page_list));
                // }
            }
        }
    })
    fun.load_DATA_LIST(['yg']);
}


function __getTmpOtherHeight(){
    return $('.debt-info').height()||0;
}

function showList(data) {
    var html = [];
    $(data).each(function (i, obj) {
        create_time = data[i]['create_time']
        var colour = order_color[i % order_color.length];
        html.push('<li class="person-list lower-border-line" data-list=\'' + fun.formatString(JSON.stringify(obj)) + '\' id="' + fun.is_value(obj['id']) + '" name="' + fun.is_value(obj['name']) + '" >');
        html.push('<div class="le">');
        html.push('    <div class="opt">');
        if (!!data[i]['imgs']) {
            html.push('<img src="'+fun.getImgPath(data[i]['imgs'])+'" class="person-img">');
        } else {
            //判断是否离职状态
            if (data[i]['is_stop'] == 1 || data[i]['out_date']) {
                html.push('        <span style="background-color:#717171;" class="person-img">' + (fun.getLastName(obj['name']) || "") + '</span>');
            }else {
                html.push('        <span style="background-color:' + colour + ';" class="person-img">' + (fun.getLastName(obj['name']) || "") + '</span>');
            }
        }
        html.push('        <div class="person">');
        if (!fun.is_value(obj['mobile']) && !fun.is_value(obj['section']) && !fun.is_value(obj['position'])) {
            html.push('            <div class="top" style="top:0.5rem;">');
        } else {
            html.push('            <div class="top">');
        }
        html.push('                <span class="person-name">' + (fun.redFont(fun.is_value(obj['name']) ,search_data['keyword']) || "") + '</span>');
        html.push('                <span class="shop">' + fun.is_value(obj['store']) + '</span>');
        html.push('            </div>');
        html.push('            <div class="bottom">');
        if($.nui.isTrue(obj['mobile'])){
            html.push('                <span class="person-phone">' + fun.is_value(obj['mobile']) + '</span>');
            html.push('                <div class="person-box">');
            if($.nui.isTrue(obj['position'])){
                html.push('                    <span class="person-development">' + fun.is_value(obj['position']) + '</span>');
            }
            if($.nui.isTrue(obj['section'])){
            html.push('                    <span class="debt-profession">' + fun.is_value(obj['section']) + '</span>');
            }
            html.push('                </div>');
        }else{
            html.push('                <div class="person-box">');
            if($.nui.isTrue(obj['position'])){
                html.push('                    <span class="person-development" style="text-align: left;float: left;">' + fun.is_value(obj['position']) + '</span>');
            }
            if($.nui.isTrue(obj['section'])){
            html.push('                    <span class="debt-profession" style="text-align: left;float: left;">' + fun.is_value(obj['section']) + '</span>');
            }
            html.push('                </div>');
        }
        
        html.push('            </div>');
        html.push('        </div>');
        html.push('    </div>');
        page_data['page_type'] == "ywy" ? '' : html.push('    <div class="delete dels1 delete-btn">删除</div>');
        html.push('</div>');
        html.push('</li>');
    })
    $('#list_wrap').append(html.join(''));
}

//点击键盘搜索
$('body').bind('search', "#foot_search", function (e) {
    search_data["keyword"] = $('#foot_search').val().trim();
    // if (e.keyCode === 13) {
        // $(this).select();
        // $('#list-group').empty();
		// $('#list_wrap').empty();
        getList();
    // }
});
fun.setItem(html_name+'sideslip',true);
//打开搜索框
$('body').on('tap', '#filter_btn', function () {
    var sideslip=fun.getItem(html_name+'sideslip');
    var options = {
        "choose_merchants": [
            {
                key: "md",
                "text": "门店",
                "value": (temps && temps['store'] ? temps['store'] : ""),
                "id": (temps && temps['store_id'] ? temps['store_id'] : 0),
            },
            {
                key: "xz_bm",
                "text": "部门",
                "value": (temps && temps['section'] ? temps['section'] : ''),
                "id": (temps && temps['section_id'] ? temps['section_id'] : '')
            },
            {
                key: "xz_zw",
                "text": "职位",
                "value": (temps && temps['position'] ? temps['position'] : ''),
                "id": (temps && temps['position_id'] ? temps['position_id'] : '')
            },
        ],
        "switch": [
            // {
            //   "text": "天内生日",
            //   "max_width":true,
            //   "input":true,
            //   "input_value":"30",
            //   "key": "birthday",
            //   "value": (temps && fun.getItem(html_name + '_birthday') ? fun.getItem(html_name + '_birthday') :'')
            // },
            {
                "text": "显示离职",
                "max_width": true,
                "key": "is_stop",
                "value": (temps && fun.getItem(html_name + '_isStop') ? fun.getItem(html_name + '_isStop') : '')
            },

        ],
    };
    if(sideslip){

        fun.setItem(html_name+'sideslip',false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});


//删除员工
$('#list_wrap').on('tap', '.delete-btn', function (e) {
    e.stopPropagation();
    var list = $(this).parent().parent();
    var id = list.attr('id');
    var name = list.attr('name');
    fun.dialog({
        content: '你确定要删除【' + name + '】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            delStaff({id: [id]});
        }
    });
});

function delStaff(data, stop) {
    data = $.extend({}, data, {save_type: 'delete'});
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveStaff,
        data: data,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    var msg = stop ? '停用' : '删除';
                    UPDATE['del_id'].push(data['id'][0]);
                    fun.toast(msg + '成功。');
                    // $('#list_wrap').empty();
                    getList();
                    break;
                case 103:
                    var html = [];
                    html.push('<span class="title">' + '【' + res['name'] + '】被调用，不允许删除。 您可以将此员工转为：离职状态。' + '</span>');
                    html.push('<span class="lzrq">离职日期：</span><input type="text" class="input-box" name="leave" id="leave" value="" readonly/>');
                    fun.dialog({
                        shade: false,
                        content: html.join(''),
                        btn: ['转为离职状态', '我知道了'],
                        // style: 'width: 80%;background-color: #fff;border: 2px solid #fff;border-radius: 5px;',
                        success: function(layero){
                            $(layero).find('.lay-warm-content').css({
                                minHeight:'7rem',
                                maxHeight:'7rem',
                            })
                        },
                        yes: function () {
                            var out_date = $('#leave').val();
                            if (create_time > out_date) {
                                fun.toast("入职日期不能大于离职日期。");
                            }else {
                                data = $.extend({is_has: true, out_date:out_date}, data);
                                delStaff(data, true);
                            }
                        }
                    });

                    $('.lay-warm .lay-warm-content').css({"display": "block", "padding": "1rem 0.2rem"});
                    $('#leave').val(fun.getNowFormatDate().substr(0, fun.getNowFormatDate().length - 8));
                    var begin_lCalendar = new lCalendar();
                    begin_lCalendar.init({
                        'trigger': '#leave',
                        'type': 'date',
                        callback: function (date) {
                            $('#leave').val(date);
                        }
                    });
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    });
}


$('body').on('tap', '.person-list', function (e) {
    e.stopPropagation();
    if (page_data['page_type'] == "ywy") {
        var data = {
            'id': $(this).attr('id'),
            'page_type': page_data['page_type'],
            'select_val': $(this).attr('name'),
            'list_data': $(this).data('list')
        }
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'select_list',
                'data': data
            }
        });
        api.closeWin();
        return;
    } else {
        fun.showPageFull({
            page_url: page_arr.employee_add,
            pageParam: {
                'id': $(this).attr('id'),
                "return_page": html_name
            }
        });
    }

});

//员工编辑
$('body').on('tap','#add_btn', function () {
    fun.showPageFull({
        page_url: page_arr.employee_add,
        pageParam: {
            "return_page": html_name
        }
    });
});

//更新上页选中值
function updatePrevPage(){
    UPDATE['page_type'] = page_data['page_type'];
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'update',
            'data': UPDATE
        }
    });
    api.closeWin();
}
