var html_name = page_arr.err_commit_page,
    msg,
    line,
    file_name,
    book_info = fun.getBookInfo(),
    user_info = fun.getUserInfo(),
    login_info = fun.getLoginInfo();
page_init = function () {
    msg = page_data['msg'];
    line = page_data['line'];
    file_name = page_data['url'].split('/');
    file_name = file_name[file_name.length - 1];

    var dbb_version = $.nui.isTrue(fun.getItem('COMPANY_APP_VERSION'))?'（'+fun.getItem('COMPANY_APP_VERSION')+'）':'';

    var html = [];
    if ($.nui.isTrue(book_info) && $.nui.isTrue(user_info)) {
        var cut_db_name = (book_info['db_name'] || '').replace(/bh_web_|yby_/ig,'');
        html.push('<p>账本：' + book_info['name'] + ' （' + cut_db_name + '）</p>');
        html.push('<p>帐号：' + user_info['name'] + ' （' + user_info['account'] + '）</p>');
    }
    html.push('<p>版本：' + APP_VERSION + ' （' + api.appVersion + '）' + dbb_version + '</p>');
    html.push('<p>信息：' + msg + '</p>');
    html.push('<p>位置：' + file_name + ' line:' + line + '</p>');
    html.push('<p>系统：' + api.systemType + ' ' + api.systemVersion + ' ' + api.connectionType + '</p>');
    html.push('<p>设备型号：' + api.deviceModel + '</p>');
    html.push('<p>很抱歉，当前操作出现异常，请点击【提交】联系我司客服处理。</p>');

    // console.log(html.join(''))

    $('#msg_box').append(html.join(''));
};

$('#cancel').on('tap', function () {
    fun.closeFrame();
});

$('#upload').on('tap', function () {
    if (msg && file_name && line) {
        var cut_db_name = (book_info['db_name'] || '').replace(/bh_web_|yby_/ig,'');

        var dbb_version = $.nui.isTrue(fun.getItem('COMPANY_APP_VERSION'))?'（'+fun.getItem('COMPANY_APP_VERSION')+'）':'';

        var err_data = {
            html_name: html_name,//页面名称
            book_info: book_info['name'] + ' （' + cut_db_name + '）',//账本
            user_info: user_info['account'] + ' （' + user_info['name'] + '）',//帐号
            edition: APP_VERSION + ' （' + api.appVersion + '）' + dbb_version,//版本
            information: msg,//信息
            position: file_name + ' line:' + line,//位置
            system: api.systemType + ' ' + api.systemVersion + ' ' + api.connectionType,//系统
            equipment: api.deviceModel,//设备
        }
        fun.showPageFull({
            page_url: page_arr.empower,
            pageParam: err_data,
        })

        // fun.toast('提交成功！');
        setTimeout(function(){
            api.closeFrame();  
        }, 500);

        // fun.ajax({
        //     showLoad:true,
        //     hideLoad: true,
        //     url: AJAX_URL.saveErr,
        //     data: {
        //         app_version: APP_VERSION,
        //         err: {
        //             msg: msg,
        //             file: file_name,
        //             line: line,
        //             book_name: (book_info ? book_info['name'] : ""),
        //             book_dbname: (book_info ? book_info['db_name'] : ""),
        //             user_name: (user_info ? user_info['name'] : ""),
        //             user_mobile: (user_info ? user_info['account'] : ""),
        //             systemType: api.systemType || "",
        //             systemVersion: api.systemVersion || "",
        //             deviceModel: api.deviceModel || "",
        //             connectionType: api.connectionType || ""
        //         }
        //     },
        //     success: function (res) {
        //         fun.hideLoad();
        //         api.toast({msg: res['msg']});
        //         api.closeFrame();
        //     }
        // });


    }
});
