// 头部
$('#header').header({
    back: true, //返回
    title: '费用分析', //标题
    text_btn: true, //文字按钮
    text_val: 'TOP 10', //文字按钮值
});

// 环形图
var myChart = echarts.init(document.getElementById('chart'));
var option = {
    title: [{
                  text: '总XXX',
                  x: 'center',
                  top: '40%',
                  textStyle:{
                      color:'#a5a5a5',
                      fontStyle:'normal',
                      fontWeight:'600',
                      fontFamily:'sans-serif',
              　　　　fontSize:13
                  }
              },{
                  text: "1232552.32",
                  x: 'center',
                  top: '50%',
                  textStyle:{
                      color:'#000',
                      width: '50%',
                      fontStyle:'normal',
                      fontWeight:'400',
                      fontFamily:'sans-serif',
              　　　　 fontSize:16
                  }
              }],
    tooltip: {
        trigger: 'item',
        formatter: "{a} <br/>{b}: {c} ({d}%)"
    },
    series: [{
        name: '产品销售额',
        type: 'pie',
        color: ['#FF5A40', '#8EC52D', '#2EC67A', '#5DA5FF', '#FFB32E', '#F95656', '#13BEF8', '#8E75AC',
            '#B37942', '#19CAAF', '#F68324', '#00AD98', '#A069FF', '#EB467E', '#EF6242', '#47769E'
        ],
        radius: ['60%', '80%'],
        avoidLabelOverlap: true,
        labelLine: {
            normal: {
                show: false
            }
        },
        data: [{
            value: 335,
        }, {
            value: 410,
        }, {
            value: 734,
        }, {
            value: 535,
        }, {
            value: 548,
        }]
    }]
};
myChart.setOption(option);
