var html_name=page_arr.import_custom;
$('#header').header({
    back: true,
    title: '批量导入客户',
    foot_input: {
        show: true,
        yuyin_icon: true,
        plader: '搜索N位联系人'
    },
});

page_init=function(){
    getList();
}
//从手机通讯录获取数据
function getList(key){
    fun.showLoad();
    // var systemVersion = api.systemVersion;
    var contacts=api.require('contacts');//加载模块
    contacts.queryByPage({
        count:1000,//读取联系人的数量
        pageIndex:0
    },function(ret,err){
        if(ret){
            data_arr=ret['contacts'];
            var data_length=data_arr.length;
            if(key==undefined){
                key='';
            }
            var arr=[];
            if(key!=''){
                for(var i=0;i<data_arr.length;i++){
                    if(data_arr[i]['fullName'].indexOf(key)>=0){
                        arr.push(data_arr[i])
                    }
                }
            fun.toast('搜索【'+arr.length+'/'+data_length+'】位联系人');
            }else{
                arr=data_arr;
            }
            setList(arr);
            fun.hideLoad();
        }
    })
}
//加载数据到页面
function setList(data){
    $('.import_custom-ul').empty();
    var html=[];
    for(var i=0;i<data.length;i++){
        var colour = order_color[i % order_color.length];
        var name=fun.getLastName(data[i]['fullName']);
        html.push(' <li class="import_custom-linkman" data-list=\''+fun.formatString(JSON.stringify(data[i]))+'\'>');
        html.push('     <span style="background-color:'+colour+'">'+name+'</span>');
        html.push('     <label>'+data[i]['fullName']+'</label>');
        html.push('     <div class="check-box boxs ck-one"><i class="iconfont icon-check"></i></div>');
        html.push(' </li>');
    }
    $('.import_custom-ul').append(html.join(''));
}


//多选
$('body').on('tap', '.ck-one', function (e) {
    e.stopPropagation();
    getCheckedCount();
});

$('body').on('tap', '.ck-all', function (e) {
    e.stopPropagation();
    if ($(this).hasClass('check-choice')) {
        $('.ck-one').addClass('check-choice');
    } else {
        $('.ck-one').removeClass('check-choice');
    }
    getCheckedCount();
});

$('body').on('tap', '#check_all', function (e) {
    e.stopPropagation();

    if ($(this).find('.ck-all').hasClass('check-choice')) {
        $(this).find('.ck-all').removeClass('check-choice');
        $('.ck-one').removeClass('check-choice');
    } else {
        $(this).find('.ck-all').addClass('check-choice');
        $('.ck-one').addClass('check-choice');
    }
    getCheckedCount();
});

function getCheckedCount() {
    var allCount = $('.ck-one').length;
    var checkedCount = $('.ck-one.check-choice').length;

    if (allCount === checkedCount) {
        $('.ck-all').addClass('check-choice');
    } else {
        $('.ck-all').removeClass('check-choice');
    }

    $('#select_count').text('已选'+checkedCount+'人');
}
//导入按钮
$('#dr').on('tap',function(){
    var linkman_arr=[];
    for(var i=0;i<$('.import_custom-linkman').length;i++){
        if($('.import_custom-linkman').eq(i).children('div').hasClass('check-choice')){
            linkman_arr.push($('.import_custom-linkman').eq(i).data('list'));
        }
    }
    fun.showPageFull({
        page_url: page_arr.loadimg,
        pageParam: {
            return_page: html_name,
        }
    });
})
//搜索
$('body').bind('search', '#foot_search', function () {
    var key = $('#foot_search').val().trim();
    getList(key);
})
