var html_name = page_arr.is_bdwx;
page_init = function () {
    if($.nui.isEmpty(fun.getItem('account_info'))){
        fun.setItem('account_info',page_data['frame_account_info']);
        fun.setItem('company_info',page_data['frame_company_info']);
        fun.setItem('token',page_data['token']);
    }

    bindEvent();
}

function bindEvent() {
    // 暂不绑定
    $('.bdwx-zbbd').click(function () {
        fun.setItem('wxdlTips', 1);
        if (!$.nui.isEmpty(fun.getItem('wxdlTips'))) {
            fun.setItem('wxdlTipsTime', $.nui.dayjs().format('YYYY-MM-DD'));
        } else {
            fun.clearItem('wxdlTipsTime');
        }
        fun.closeFrame(html_name);
    })

    // 允许
    $('.bdwx-yx').click(function () {
        var wx = api.require('wxPlus');
        if (!checkWxUseable(wx)) return false;
        wx.auth({
            apiKey: '' //wx_appid  已从config获取
        }, function (ret, err) {
            if (ret.status) { // 成功登陆
                fun.ajax({
                    showLoad: false,
                    hideLoad: false,
                    url: AJAX_URL.wxUser,
                    data: {
                        type: 'bd',
                        code: ret.code,
                        login_type: 'app'
                    },
                    success: function (res) {
                        if (res['status'] == 0) {
                            api.sendEvent({
                                name: page_data['page_name'],
                                extra: {
                                    'status': 'is_wx',
                                }
                            });
                            if ($.nui.isTrue(res.data) && $.nui.isTrue(res.data.wx_headimg_url)) { // 有数据有读取到微信头像
                                fun.setItem('wx_headimg_url', res.data.wx_headimg_url);
                                // }
                            } else { // 没数据或者，没读取到微信头像，给默认值
                                fun.setItem('wx_headimg_url', '../img/cp.png');
                            }

                            fun.setItem('hasBindWeChat', true); // 绑定成功更新状态
                            // if (!$.nui.isTrue(fun.getItem('wx_headimg_url'))) {

                        }
                        fun.toast(res.msg);
                        fun.closeFrame(html_name);
                    }
                });
            } else {
                switch (err.code) {
                    case -2:
                    case 1:
                        fun.toast('取消授权');
                        break;
                    case 2:
                        fun.toast('拒绝授权');
                        break;
                    case 3:
                        fun.toast('未安装微信');
                        break;
                    default:
                        fun.toast('操作异常, 请稍后重试!');
                        break;
                }
                fun.closeFrame(html_name);
            }
            api.sendEvent({
                name: page_arr.analysis,
                extra: {
                    'status': 'setHeader',
                    'state': false
                }
            });
        });
    })
}

