var html_name = page_arr.jg_wwjg_tj;

//默认开始显示数据
var to_month = fun.getLatelyTime(1,false);
var page_list = [], ztj_data = [];
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    is_mobile: 1,
    // ycycl:1

    jjcd_id: 0,
    zt_id: 0
};

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};
var USER_INFO = {};
//接收查询后的参数
// 系统设置
var SYS_CONFIG = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    //接收查询后的参数
    // 系统设置
    SYS_CONFIG = fun.getItem('sys_config') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(html_name + '_' + 'hz') || '');
    var hn = html_name + '_';
    var hnt = html_name + '_type_';
    var hnh = hn + 'hz' + '_';
    // 页面加载，要先读取有记忆的搜索条件
    search_storage = $.extend(true, {
        'ycjd': fun.getItem(hn + 'ycjd', 1),
        'ycywc': fun.getItem(hn + 'ycywc', 0),
        'xscq': fun.getItem(hn + 'xscq', 0),
        'xsgg': fun.getItem(hn + 'xsgg', 0),
        'hldj': fun.getItem(hn + 'hldj', 0),
        'xsmx': fun.getItem(hn + 'xsmx', 1),
        'type': {
            'number': fun.getItem(hnt + 'number', 1),
            'horse': fun.getItem(hnt + 'horse', 0),
        },
        "hz": {
            "choose": {
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "dh": fun.getItem(hnh + 'dh', 0),
                "wldw": fun.getItem(hnh + 'wldw', 0),
                "cp": fun.getItem(hnh + 'cp', 0),
                "cp_ys": fun.getItem(hnh + 'cp_ys', 0),
            },
            "text": fun.getItem(hnh + 'text', ""),
        }
    }, search_storage);
    search_data = $.extend({}, search_data, search_storage);
    getList(search_data);

    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {

        console.log(ret)
        switch (ret['value']['status']) {
            case 'refresh':
                getList(search_data);
                break;
            case 'search':
                var param = ret.value.data;

                search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
                search_data['begin_time'] = param.begin_date;                   //开始时间
                search_data['end_time'] = param.end_date;                       //结束时间
                search_data['wldw_id'] = param.jgs['id'] || 0;                 //供应商
                search_data['cp_id'] = param.cp['id'] || 0;                    //产品
                search_data['cp_lb_id'] = param.cp_lb['id'] || 0;             //产品类别
                search_data['ck_id'] = param.ck['id'] || 0;                    //仓库
                search_data['md_id'] = param.md['id'] || 0;                    //门店
                search_data['ycjd'] = param['ycjd'];                            //隐藏已结单记录
                search_data['ycywc'] = param['ycywc'];                          //隐藏已发完记录
                search_data['xscq'] = param['xscq'];
                search_data['kh_id'] = param.kh.id || 0;                        //客户id
                search_data['xsgg'] = param['xsgg'];                            //显示规格
                search_data['hldj'] = param['hldj'];                            //合拢单据
                search_data['xsmx'] = param['xsmx'];                            //显示明细数据
                search_data['dh'] = param['dh'] || '';                          // 订单单号

                search_data['jjcd_id'] = param.jjcd['id'];                   //紧急程度
                search_data['zt_id'] = param.zt['id'];                          //状态

                //搜索菜单需要缓存的数据
                search_storage['keyword'] = search_data['keyword'];
                search_storage['begin_date'] = search_data['begin_time'];
                search_storage['end_date'] = search_data['end_time'];
                search_storage['type'] = param['type'];                //数量
                search_storage['ycjd'] = param['ycjd'];                //隐藏已结单记录
                search_storage['ycywc'] = param['ycywc'];              //隐藏已发完记录
                search_storage['xscq'] = param['xscq'];                //只显示超期产品
                search_storage['xsgg'] = param['xsgg'];
                search_storage['hldj'] = param['hldj'];
                search_storage['xsmx'] = param['xsmx'];
                search_storage['dh'] = search_data['dh'];

                search_storage['jgs'] = param.jgs;
                search_storage['cp'] = param.cp;
                search_storage['cp_lb'] = param.cp_lb;
                search_storage['ck'] = param.ck;
                search_storage['md'] = param.md;
                search_storage['kh'] = param.kh;                     // 客户信息

                search_storage['jjcd'] = param.jjcd;                            //紧急程度
                search_storage['zt'] = param.zt;                                //状态

                //设置时间控件
                date_bar.setDate(search_storage);

                fun.setItem(html_name + '_number', search_storage['type']['number']);
                fun.setItem(html_name + '_horse', search_storage['type']['horse']);
                fun.setItem(html_name + '_ycjd', search_storage['ycjd']);
                fun.setItem(html_name + '_ycywc', search_storage['ycywc']);
                fun.setItem(html_name + '_xscq', search_storage['xscq']);
                fun.setItem(html_name + '_xsgg', param['xsgg']);
                fun.setItem(html_name + '_hldj', param['hldj']);
                fun.setItem(html_name + '_xsmx', param['xsmx']);

                //汇总功能
                search_data['group'] = param.hz['group'] || '';
                search_storage['hz'] = param.hz;
                var hc = param['hz']['choose'];
                fun.setItem(hnt + 'number', param['type']['number']);
                fun.setItem(hnt + 'horse', param['type']['horse']);
                fun.setItem(hnh + 'md_mc', hc['md_mc']);
                fun.setItem(hnh + 'dh', hc['dh']);
                fun.setItem(hnh + 'wldw', hc['wldw']);
                fun.setItem(hnh + 'cp', hc['cp']);
                fun.setItem(hnh + 'cp_ys', hc['cp_ys']);
                fun.setItem(hnh + 'text', param.hz['text']);
                fun.setGroupCondition(search_data, 'jjdw_id,jjdw_mc,dw_id,dw_mc');
                // if (!!search_data['group']) {
                //     var group_data = search_data['group'];
                //     group_data += ',dw_id,dw_mc';
                //     search_data['group'] = group_data;
                // }

                fun.setItem(html_name + '_' + 'hz', search_data['group']);
                fun.setItem(html_name + 'sideslip', true);
                //设置时间控件时间
                date_bar.setDate(search_storage);

                getList(search_data);
                break;
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });

}

$('#header').header({
    back: true,
    filter: true,
    title: '委外加工统计'
});

function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function (e) {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'],
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "dh_wrap": {
            "key": "dh",
            "value": search_storage['dh'] || "",
            "placeholder": "订单单号"
        },
        "choose_merchants": [
            {
                key: "jgs",
                "text": "加工商",
                "value": getTwo('jgs', 'text'),
                "id": getTwo('jgs', 'id'),
            }, {
                key: "cp",
                "text": "产品",
                "value": getTwo('cp', 'text'),
                "id": getTwo('cp', 'id'),
            }, {
                key: "cp_lb",
                "text": "产品类别",
                "value": getTwo('cp_lb', 'text'),
                "id": getTwo('cp_lb', 'id'),
            }, {
                key: "ck",
                "text": "仓库",
                "value": getTwo('ck', 'text'),
                "id": getTwo('ck', 'id'),
            }, {
                key: "md",
                "text": "门店",
                "value": getTwo('md', 'text'),
                "id": getTwo('md', 'id'),
            },
            {
                key: 'kh',
                text: '客户',
                value: getTwo('kh', 'text'),
                id: getTwo('kh', 'id')
            },
            {
                key: "zt",
                text: "状态",
                value: getTwo('zt', 'text'),
                id: getTwo('zt', 'id'),
                loadData: true,
                loadDataType: 'wwjg',
                list: []
            },
            {
                key: "jjcd",
                text: "紧急",
                value: getTwo('jjcd', 'text'),
                id: getTwo('jjcd', 'id'),
                loadData: true,
                list: []
            },
            {
                key: "hz",
                "text": "汇总",
                //加工商、单号、门店、产品、颜色
                group: [
                    // {key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc')},
                    { key: 'dh', name: '单号', columns: 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc', choose: getHz('dh') },
                    { key: 'wldw', name: '加工商', columns: 'wldw_id,wldw_mc', choose: getHz('wldw') },
                    { key: 'cp', name: '产品', columns: 'cp_bh, cp_mc', choose: getHz('cp') },
                    { key: 'cp_ys', name: '颜色', columns: 'cp_ys_bh, cp_ys_mc', choose: getHz('cp_ys') },
                ],
                "value": getTwo('hz', 'text'),
            }
        ],
        'type': [
            {
                key: "number",
                "text": "数量",
                "value": getTwo('type', 'number'),
            }, {
                key: "horse",
                "text": "匹数",
                "value": getTwo('type', 'horse'),
            }
        ],

        "switch": [
            {
                "text": "隐藏已结单记录",
                "max_width": true,
                "key": "ycjd",
                "value": search_storage['ycjd']
            }, {
                "text": "隐藏已发完记录",
                "max_width": true,
                "key": "ycywc",
                "value": search_storage['ycywc']
            }, {
                "text": "只显示超期产品",
                "max_width": true,
                "key": "xscq",
                "value": search_storage['xscq']
            },
            { "text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_storage['xsmx'] },
            { "text": "合拢单据", "max_width": true, "key": "hldj", "value": search_storage['hldj'] },
            { "text": "显示规格", "max_width": true, "key": "xsgg", "value": search_storage['xsgg'] }
        ],
    }
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});


var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getList(search_data);
        }
    });

/** 生成 剩/超 天 字符串
 * @param {*} hqts 货期天数
 */
function hqtsStr(hqts) {
    if (hqts < 0)
        return "超" + Math.abs(hqts) + "天";
    else if ((hqts > 0)) {
        return "剩" + hqts + "天";
    }
    return "";
}

/** 数量和匹数转换
 * @param {*} isNumber 是否选择数量
 * @param {*} res 数据源
 */
function numberHorse(isNumber, res) {
    if (isNumber) {
        return {
            title: {
                "0": "数量",
                "1": "来货",
                "2": "未来",
            },
            value: {
                "0": $.nui.decimalAdd(Number(res['zsl']) ,Number(res['cxsl'])).fixed() || "",
                "1": (res['lhsl']) || "",
                "2": (res['wlsl']) || "",
            },
            title2: {
                "0": "预投数",
                "1": "实投数",
                "2": "未投数",
            },
            value2: {
                "0": $.nui.decimalAdd(Number(res['jgq_zsl']) ,Number(res['jgq_cxsl'])).fixed() || "",
                "1": (res['jgq_stsl']) || "",
                "2": (res['jgq_wtsl']) || "",
            }
        }
    }

    var ps = $.nui.decimalAdd(parseInt(res['ps']) , parseInt(res['cxps'])).fixed();
    if (ps) {
        ps = ps + '匹';
    }

    return {
        title: {
            "0": "匹数",
            "1": "来货",
            "2": "未来",
        },
        value: {
            "0": ps,
            "1": res['lhps'] || "",
            "2": res['wlps'] || "",
        },
        title2: {
            "0": "预投匹",
            "1": "实投匹",
            "2": "未投匹",
        },
        value2: {
            "0": (parseInt(res['jgq_ps']) + parseInt(res['jgq_cxps'])).fixed() || "",
            "1": res['jgq_stps'] || "",
            "2": res['jgq_wtps'] || "",
        }
    }
}

// var order_data = [{
//     wldw_mc: '加工商',
//     md_mc: '门店',
//     zdr_mc: '制单人',
//     kdsj: '2018-05-28 15:30',
//     dh: 'CDD1812270006',
//     lx: 'XX类型',
//     list: [{
//         cp_bh: '编号',
//         cp_mc: '名称',
//         cp_sh: '色号',
//         cp_ys: '颜色',
//         fk: 170,
//         kz: 190,
//         fh_sj: '2018-05-28',
//         cq: '超3天',
//         dw: '单位',
//         cp: '',
//         zt: '10%',
//         yss: 10,
//         sss: 10,
//         wss: 10,
//         hss: 11,
//         hsl: '10%',
//         ehs: 1,
//         pp: '',
//         yts: 10,
//         sts: 2,
//         wts: 8,
//         dj: 4,
//         je: 30,
//     }, {
//
//         btdj: '定金',
//         btje: '¥50000',
//         tb_url: '../img/bank/6zhonghang.png',
//         btzh: 'XXXX',
//         cp_bh: '编号',
//         cp_mc: '名称',
//         cp_sh: '色号',
//         cp_ys: '颜色',
//         fk: 170,
//         kz: 190,
//         fh_sj: '2018-05-28',
//         cq: '超3天',
//         dw: '单位',
//         cp: '',
//         zt: '10%',
//         yss: 10,
//         sss: 10,
//         wss: 10,
//         hss: 11,
//         hsl: '10%',
//         ehs: 1,
//         pp: '',
//         yts: 10,
//         sts: 2,
//         wts: 8,
//         dj: 4,
//         je: 30,
//     }],
// },];

// showList(order_data);

function showList(data) {
    var hj_type = search_storage['type'];
    $.each(hj_type, function (key, val) {
        if (!!val) {
            if (key == 'number') {//类型 = 数量
                $('#tj1').text($.nui.decimalAdd(Number(ztj_data[0]['zsl']), Number(ztj_data[0]['cxsl'])) || 0);
                $('#tj2').text(ztj_data[0]['lhsl'] || 0);
                $('#tj3').text(ztj_data[0]['wlsl'] || 0);
            } else {//类型 = 匹数
                $('#tj1').text($.nui.decimalAdd(Number(ztj_data[0]['ps']), Number(ztj_data[0]['cxps'])) || 0);
                $('#tj2').text(ztj_data[0]['lhps'] || 0);
                $('#tj3').text(ztj_data[0]['wlps'] || 0);
            }
        }
    });
    // var i;
    $('#order_list').OrderList({
        data: data,
        isExpand: !search_storage['hldj'],
        isNoExpand: search_storage['xsmx'],
        // schedule:true,
        render: {
            titlebar: function (res) {
                var is_ddfh = fun.getKzValue('ddfh', 'bp_wwjg'); // 订单复核

                return statistics.order.createTitlebar(res, {
                    group: search_data.group,
                    other_condition: (is_ddfh || 0) && !res.is_fh,
                    dd_lx_fh: $.nui.isTrue(res.dd_lx_fh),
                    is_jg: true,
                    type: res.gxlx_mc
                });
            },
            subtitle: function (res) {
                return statistics.order.createSubtitle(res, {
                    group: search_data.group,
                    search_data: search_data,
                    showIcon: true
                });
            },
            subdata: function (res) {
                var isSelectNum = search_storage['type']['number'] ? search_storage['type']['number'] : 0;
                var numberHorseVal = numberHorse(isSelectNum, res);

                return statistics.order.createSubdata(res, {
                    group: search_data.group,
                    search_storage: search_storage,
                    title: numberHorseVal.title,
                    value: numberHorseVal.value,
                    isSelectNum: isSelectNum,
                    showWaste: true,            // 是否显示损耗
                    showJd: false,
                    renderJdHtml: true
                });
            }

        },


    });
}


/** 获取发退货结算数据
 * @param {*} data
 */
function getList(data) {
    page_list = [];
    var tmpdata = $.extend(true, {}, data);
    tmpdata['ycycl'] = 0;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL['getBpWwjgtj'],
        data: tmpdata,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj1').text(0);
                    $('#tj2').text(0);
                    $('#tj3').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                ztj_data = res['info'];
                fun.clearPage($('#order_list'));
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createKeysValueFun: function(obj) {
                        return {
                            "wldw_mc": obj['wldw_mc'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "md_id": obj['md_id'],
                            "dj_ps": fun.is_value(obj['dj_ps'], 0),
                            "dj_zsl": fun.is_value(obj['dj_zsl'], 0),
                            "dj_je": fun.is_value(obj['dj_je'], 0),         // 单据金额
                            "zdw_mc_tmp": fun.is_value(obj['zjjdw_mc']),                 // 总计价单位名称
                            // 审核状态
                            "is_fh": obj["is_fh"],
                            "is_jd": obj["is_jd"],
                            "dj_jd": obj["dj_jd"],
                            "gxlx_mc": obj["gxlx_mc"],

                            dd_lx_fh: obj["dd_lx_fh"],
                            dd_lx_mc: obj["dd_lx_mc"]
                        };
                    }
                });

                console.log(JSON.parse(JSON.stringify(page_list)))

                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}


fun.tjContentTap(function (indent_data) {
    if ($.nui.isTrue(search_data.group)) return;

    fun.showPageFull({
        page_url: page_arr.jg_wwjg_xqy,
        pageParam: {
            return_page: html_name,
            data: indent_data,
        }
    });
});

$('body').on('click','.row-list',function(){
    if(fun.getItem(html_name + '_xsmx', 1)) return;
    if($.nui.isEmpty(search_storage['xsmx']) || ($.nui.isTrue(search_storage['xsmx']) && $.nui.isTrue(search_storage['hldj']))) return;
    if (!fun.checkKz()) return;
    var data_list = $(this).children('.summary').children('.summary-content').data('list');
    fun.showPageFull({
        page_url: page_arr.jg_wwjg_xqy,
        pageParam: {
            return_page: html_name,
            data: data_list,
        }
    });
})