var html_name = page_arr.kc_ck,
    obj, headerH,
    page_list = [],
    //data: {"yxckjgskc":1,"xsdck":1,"yjfs":0,"yjlx":0,"zdtcyj":false,"zxsyjjl":false,"xslkc":false,
    //       "ck_id":0,"cp_id":0,"cp_ys_id":0,"cp_lb_id":0,"group":"md_id,md_mc,
    //        ck_id,ck_mc,cp_lb_mc,fk,kz,ck_zdy1,dw_id,dw_mc","type":"kcqk"}
    search_data = {
        ck_id: 0,
        md_id: 0,
        typy: (fun.getItem(html_name + 'type') || ''),
        ycjgsck: (fun.getItem(html_name + '_ycjgsck') || 0),
        "xs_type": fun.getItem(html_name + 'xs_type'),
        "xs_text": fun.getItem(html_name + 'xs_text')
    };
var USER_INFO = {};
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));
    // var cost = ();
    //没有查看布匹成本价权限
    if (!Auth.check('yxckbpcbj', 'view')) {
        $('.line2').hide();
        $('.line1').css('width', '100%');
        $('.line1').removeClass('line');
    }
    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['xs'] = (fun.getItem(html_name + 'xs_type') || 'kcs');
    search_data['xs_text'] = (fun.getItem(html_name + 'xs_text') || '');

    if (!!page_data['md_id'] && !!page_data['md_mc']) {
        search_data['md_id'] = page_data['md_id'];
        search_data['md_mc'] = page_data['md_mc'];
    }

    getList();
    obj = page_data.obj;
    $('.grain').css('display', 'none');
    $('#header').header({
        back: true,
        title: '全部库存',
        filter: true,
        perchart: !AuthVersionCheck.checkHide('kcgk'),
    });


    api.addEventListener({
        name: html_name,
    }, function (res) {
        if (!!res) {
            switch (res.value.status) {
                case "search":
                    var temp = res['value']['data'];
                    console.log(temp)

                    search_data['ck_id'] = temp['ck']['id'];
                    search_data['md_id'] = temp['md']['id'];
                    search_data['md_mc'] = temp['md']['text'];
                    // search_data['xs_id'] = temp['cp_gy']['id'];
                    search_data['ck_name'] = temp['ck']['text'];
                    search_data['md_name'] = temp['md']['text'];
                    search_data['xs'] = temp['xs']['type'];
                    search_data['xs_text'] = temp['xs']['text'];
                    search_data['ycjgsck'] = temp['ck_hidezero'];
                    if (search_data['ck_id'] == '') {
                        $('#perchart_btn').css('display', 'block');
                    } else {
                        $('#perchart_btn').css('display', 'none');
                    }
                    fun.setItem(html_name + 'xs_type', temp['xs']['type']);
                    fun.setItem(html_name + 'xs_text', temp['xs']['text']);
                    fun.setItem(html_name + '_ycjgsck', (temp['ck_hidezero'] || 0));
                    fun.setItem(html_name + 'sideslip', true);
                    // page_list = [];
                    $('#store_list').empty();
                    getList();
                    break;
                default:

            }
        }
    });


    fun.scrollToBottom({}, function () {
        // $('#header').css('pointer-events','none');
        if (page_list.length > 0) {
            appendList(fun.PagingData(page_list, 5));
        } else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('store_list', ".store");
        }
    });

    //ios头部穿透
    // fun.pierceThrough('.store'); 
    
    // fun.gouHeader();
    // if(Auth.check('yxckbpcbj','view')){
    //     $('#bp_cb').show();
    // }

}


function getList() {
    page_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileQbkc,
        data: search_data,
        success: function (res) {
            if (res['status'] == 0) {
                if ($.nui.isEmpty(res['data']) || !res['data']['list'].length) {
                    $('#bp_cb').text(0);
                    $('#zo_ps').text(0);
                    $('#zo_mi').text(0);
                    $('#zo_ma').text(0);
                    $('#zo_kg').text(0);
                    $('#store_list').css({'height': '60%', 'position': 'fixed'});
                    // return $('#store_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#store_list',btnShow:false,style:'top:2rem;height:10rem;'});
                } else {
                    $('#store_list').css({'height': 'auto', 'position': 'relative'});
                }
                showData(res.data);
            } else {
                fun.alert({msg: '网络异常！'});
            }
        }
    })
}

//查库存
$('body').on('tap', '.store', function (e) {
    fun.showPageFull({
        page_url: page_arr.kc_ckc,
        pageParam: {
            ck_id: $(this).attr('ck_id'),
            ck_mc: $(this).attr('ck_mc'),
            md_id: (search_data['md_id'] || 0),
            md_mc: search_data['md_mc'],
            xs_type: search_data['xs'],
            xs_text: search_data['xs_text'],
        }
    });
});
// 库存分析
$('body').on('tap', '#perchart_btn', function () {
    fun.showPageFull({
        page_url: page_arr.kc_kcfx,
        pageParam: {
            obj: 'cloth',
            xs: search_data['xs']
        }
    });
});

//显示数据
function showData(data) {
    var hj = data['hj'];
    $('#zo_ps').text(hj['ps']);
    // $('#bp_cb').text(Number(hj['zcb'] || 0).fixed(2));
    $('#bp_cb').text(Math.round((hj['zcb'] || 0) * 10) / 10);
    $('#zo_mi').text(Math.round((hj['sl_m'] || 0) * 10) / 10);
    $('#zo_ma').text(Math.round((hj['sl_y'] || 0) * 10) / 10);
    $('#zo_kg').text(Math.round((hj['sl_kg'] || 0) * 10) / 10);
    page_list = data['list'];
    $('#store_list').empty();
    appendList(fun.PagingData(page_list));
}

function appendList(list) {
    var listHtml = [];
    for (var i = 0; i < list.length; i++) {
        var colour = order_color[i % order_color.length];
        var ck_name = list[i]['ck_mc'].substr(0, 2);
        var portrait = (Auth.check('yxckbpcbj', 'view'));
        listHtml.push('<div class="store" ck_id="' + list[i]['ck_id'] + '" ck_mc="' + list[i]['ck_mc'] + '" >');
        listHtml.push('    <div class="store-left">');
        if (portrait) {
            listHtml.push('       <span class="left-title"  style="background:' + colour + ';">' + ck_name + '</span>');
        } else {
            listHtml.push('       <span class="left-title"  style="background:' + colour + ';top:35%;">' + ck_name + '</span>');
        }
        listHtml.push('    </div>');
        listHtml.push('    <div class="store-right">');
        listHtml.push('       <div class="right-top">');
        listHtml.push('           <h3 class="store-title">' + list[i]['ck_mc'] + '</h3>');
        listHtml.push('       </div>');
        listHtml.push('       <div class="right-bot">');
        listHtml.push('           <p class="bot-list hide"><span class="list-name">总匹数</span><em class="zps">' + (list[i]['ps'] || 0) + '</em></p>');
        listHtml.push('           <p class="bot-list hide"><span class="list-name">总米数</span><em class="zps">' + (list[i]['sl_m'] || 0)+ '</em></p>');
        listHtml.push('           <p class="bot-list"><span class="list-name name1">总码数</span><em class="zps">' + (list[i]['sl_y'] || 0)+ '</em></p>');
        listHtml.push('           <p class="bot-list"><span class="list-name name2">总公斤</span><em class="zps">' + (list[i]['sl_kg'] || 0)+ '</em></p>');
        if (portrait) {
            listHtml.push('           <p class="bot-list"><span class="list-name">总成本</span><em class="zps">' + Number(list[i]['zcb'] || 0).fixed(2) + '</em></p>');
            //listHtml.push('           <p class="bot-list"><span class="list-name">总成本</span><em class="zps">' + Math.round((list[i]['zcb'] || 0) * 10) / 10 + '</em></p>');
        }
        listHtml.push('       </div>');
        listHtml.push('    </div>');
        listHtml.push('</div>');
    }

    $("#store_list").append(listHtml.join(''));
}
// $('body').on('touchend',function(){
//     setTimeout(function(){
//         $('#header').css('pointer-events','auto');
//     },300)
// })
fun.setItem(html_name + 'sideslip', true);
//打开搜索框
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "choose_merchants": [{
            key: "ck",
            "text": "仓库",
            "id": (search_data['ck_id'] || 0),
            "value": (search_data['ck_name'] || "")
        }, {
            key: "md",
            "text": "门店",
            "id": (search_data['md_id'] || 0),
            "value": (search_data['md_name'] || "")
        }],
        'xs': [{
            key: "xs",
            "text": "显示",
            "xsType": (search_data['xs'] || 'kcs'),
            "list": [
                {'name': '可用数', 'column': 'kys', 'is_choose': 0},
                {'name': '库存数', 'column': 'kcs', 'is_choose': 1},
            ],
            "alone": true,
            "value": (search_data['xs_text'] || "库存数"),
        }],
        "switch": [{
            "text": "隐藏加工商仓库",
            "max_width": true,
            "key": "ck_hidezero",
            "value": (fun.getItem(html_name + '_ycjgsck') || 0)
        },],

    };
    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});
