var html_name = page_arr.kc_ckc,
    opt_val = {};
    search_data = {},
    photoBrowser = {},
    page_list = [];
var USER_INFO = {};
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    
    search_data['ck_id'] = (page_data['ck_id'] || 0);
    search_data['ck_mc'] = (page_data['ck_mc'] || '');
    search_data['md_id'] = (page_data['md_id'] || 0);
    search_data['md_mc'] = (page_data['md_mc'] || '');
    search_data['xs'] = page_data['xs_type'] || (fun.getItem(html_name + 'xs') || 'kcs');
    search_data['xs_text'] = page_data['xs_text'] || (fun.getItem(html_name + 'xs_text') || '库存数');
    search_data['qbkc'] = (fun.getItem(html_name + 'qbkc') || 0);
    /**/
    opt_val['md_val'] = page_data['md_mc'] || '';
    // console.log(search_data)

    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));
    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : (page_data['md_id'] || 0));
    photoBrowser = api.require('photoBrowser');

    $('#header').header({
        back: true,
        title: (page_data['ck_mc'] || "全部库存"),
        filter: true,
        foot_input: {
            show: true,
            scan_icon: true,
            plader: "产品编号、产品名称"
        },
    });



    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'],
            data = temp['data'];

        // console.log(ret);

        switch (temp['status']) {
            case 'search':
                (data['ck']['text'] != "") ? $('#header_title').text(data['ck']['text']) : $('#header_title').text('全部库存');
                page_data['ck_mc'] = data['ck']['text'];
                page_data['ck_id'] = data['ck']['id'];
                search_data['ck_id'] = data['ck']['id'];
                search_data['ck_mc'] = data['ck']['text'];
                search_data['md_id'] = data['md']['id'];
                search_data['cp_lb_id'] = data['cp_lb']['id'];
                search_data['qbkc'] = data['qbkc'];//隐藏0库存
                search_data['order'] = {
                    ps: (data['ps_sort'] || ""),
                    sl: (data['sl_sort'] || "")
                };

                search_data['xs'] = data['xs']['type'];
                search_data['xs_text'] = data['xs']['text'];
                // search_data['qbkc'] = data['qbkc'];
                fun.setItem(html_name + 'xs',search_data['xs'])
                fun.setItem(html_name + 'xs_text',search_data['xs_text'])
                fun.setItem(html_name + 'qbkc', data['qbkc']);
                opt_val['ck_val'] = data['ck']['text'];
                opt_val['md_val'] = data['md']['text'];
                opt_val['cplb_val'] = data['cp_lb']['text'];
                fun.setItem(html_name + 'sideslip', true);

                getList();
                break;
            case 'refresh':
                fun.setItem('sideslip', true);
                break;
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('product_list', ".list-info");
        }
    });

    fun.orderListHeight({dom:'#product_list'});

    getList();


}

function getList() {
    // console.log(JSON.stringify(search_data))
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileCkc,
        data: $.extend({}, {
            "cp_lb_id": 0,
            "md_id": 0,
            "ck_id": 0,
            "ck_mc": "",
            "order": {
                "ps": "",
                "sl": ""
            },
            "keyword": "",
            "keyword_key": ['cp_bh', 'cp_mc'],
            "xsyj": 0,
        }, search_data),
        success: function (res) {
            if (res['status'] == 0) {
                var list = res['list'] || [],
                    hj = res['hj'] || {};

                if (list.length == 0) {
                    // showSum(hj);
                    $('#hj_zms').text(0);
                    $('#hj_zmas').text(0);
                    $('#hj_zgj').text(0);
                    $('#hj_zps').text(0);
                    $('#product_list').css({ 'height': '60%', 'position': 'fixed' });
                    // return $('#product_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#product_list',btnShow:false,style:'top:0rem;height:10rem;'});
                } else {
                    $('#product_list').css({ 'height': 'auto', 'position': 'unset' });
                }
                showSum(hj);
                page_list = list;
                $('#product_list').empty();
                showList(fun.PagingData(page_list));
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}

function showList(data) {
    var html = [];
    // console.log(search_data)
    // console.log(data);
    $(data).each(function (i, obj) {
        var img_url = ((!!obj['cp_imgs']) ? fun.getImgPath(obj['cp_imgs']) : "../img/logo.png");
        var large_url = (obj['cp_imgs']) ? fun.getImgPath(obj['cp_imgs'], true) : "../img/logo.png";
        //var obj_sl = Math.round((obj['sl'] || 0) * 10) / 10;
        html.push('<div info="' + fun.is_value(obj['cp_bh']) + ' ' + fun.is_value(obj['cp_mc']) + '" ck_id="' + obj['ck_id'] + '" cp_id="' + obj['cp_id'] + '" dw_id="'+obj['dw_id']+'" class="list-info lower-border-line">');
        html.push('<div class="info-top">');
        html.push('    <div class="top-left">');
        if (img_url === "../img/logo.png") {
            html.push('        <span class="pic mr-bj">');
            html.push('            <img src="' + img_url + '"  class="cp-img">');
        } else {
            html.push('        <span class="pic">');
            html.push('            <img src="../img/mask.png" class="mask">');
            html.push('            <img src="' + img_url + '" large-url="' + large_url + '" class="large">');
        }
        // !!obj['cp_imgs'] && html.push('<img src="../img/mask.png" class="mask">');
        html.push('        </span>');
        html.push('    </div>');
        html.push('    <div class="top-right">');
        html.push('        <p class="pro-title">' + (fun.redFont((fun.is_value(obj['cp_bh']) + ' ' + fun.is_value(obj['cp_mc'])), search_data['keyword']) || "") + '</p>');
        html.push('        <p class="pro-info">');
        html.push('        <span class="pros ps">' + obj['ps'] + '匹</span><span class="pros gj">' + (obj['sl'] || 0) + ' ' + fun.is_value(obj['dw_mc']) + '</span>');
        html.push('        </p>');
        html.push('    </div>');
        html.push('</div>');

        html.push('</div>');
    })
    $('#product_list').append(html.join(''));
}

fun.setItem(html_name + 'sideslip', true);
// 打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var soft = {
        ps: (search_data && search_data['order']) ? search_data['order']['ps'] : "",
        sl: (search_data && search_data['order']) ? search_data['order']['sl'] : "",
    }
    var options = {
        "choose_merchants": [
            {
                "key": "ck",
                "id": ((search_data && search_data['ck_id']) ? search_data['ck_id'] : 0),
                "text": "仓库",
                "value": ((search_data && search_data['ck_mc']) ? search_data['ck_mc'] : "")
            },
            {
                "key": "cp_lb",
                "id": ((search_data && search_data['cp_lb_id']) ? search_data['cp_lb_id'] : 0),
                "text": "类别",
                "value": ((opt_val && opt_val['cplb_val']) ? opt_val['cplb_val'] : "")
            },
            {
                "key": "md",
                "id": ((search_data && search_data['md_id']) ? search_data['md_id'] : 0),
                "text": "门店",
                "value": ((opt_val && opt_val['md_val']) ? opt_val['md_val'] : "")
            },
        ],
        'xs': [
            {
                "key": "xs",
                "text": "显示",
                "xsType": (search_data['xs'] || 'kcs'),
                "list": [
                    { 'name': '可用数', 'column': 'kys', 'is_choose': 0 },
                    { 'name': '可发货', 'column': 'kfh', 'is_choose': 0 },
                    { 'name': '库存数', 'column': 'kcs', 'is_choose': 1 },
                ],
                "alone": true,
                "value": (search_data['xs_text'] || "库存数"),
            },
        ],
        "switch": [
            {
                "text": "显示0库存",
                "max_width": true,
                "auxiliary": true,
                "key": "qbkc",
                "value": (fun.getItem(html_name + 'qbkc') || 0)
            }
        ],
        "sort": [
            { "text": "匹数", "key": "ps_sort", "value": soft['ps'] },
            { "text": "数量", "key": "sl_sort", "value": soft['sl'] }
        ]
    };
    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});
//跳转 库存详情
$('body').on('tap', '.list-info', function (e) {
    e.preventDefault();

    fun.showPageFull({
        page_url: page_arr.kc_kcxq,
        pageParam: {
            return_page: html_name,
            info: $(this).attr('info'),
            cp_id: $(this).attr('cp_id'),
            ck_id: ((search_data && search_data['ck_id']) ? search_data['ck_id'] : 0),
            ck_mc: ((search_data && search_data['ck_mc']) ? search_data['ck_mc'] : ''),
            md_id: ((search_data && search_data['md_id']) ? search_data['md_id'] : 0),
            md_mc: ((opt_val && opt_val['md_val']) ? opt_val['md_val'] : ''),
            dw_id:$(this).attr('dw_id'),
            xs: search_data['xs'],
            xs_text: search_data['xs_text'],
            qbkc: search_data['qbkc'],
        }
    });
    // return false;
});

//列表模式 点击预览图片
$('body').on('tap', '.large,.mask', function (e) {
    e.preventDefault();
    e.stopPropagation();
    var index = $(this).attr('index');
    if($(this).hasClass('mask')){
        index = $(this).next().attr('index');
    }

    var img_arr = [];
    $('.large').each(function (i, obj) {
        img_arr.push($(this).attr('large-url'));
        $(obj).attr('index', i);
    })
    if (img_arr.length == 0) return;

    photoBrowser.open({
        images: img_arr,
        activeIndex: index || 0,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        } else {
            console.log(JSON.stringify(err));
        }
    });
    return false;
})

//点击键盘搜索
$('body').bind('search', "#foot_search", function () {
    search_data['keyword'] = $('#foot_search').val().trim();
    getList();
});

//显示合计
function showSum(hj) {
    $('#hj_zms').text(Math.round((hj['sl_m'] || 0) * 10) / 10);
    $('#hj_zmas').text(Math.round((hj['sl_y'] || 0) * 10) / 10);
    $('#hj_zgj').text(Math.round((hj['sl_kg'] || 0) * 10) / 10);
    $('#hj_zps').text(hj['ps'] || 0);
}

$('body').on('tap', ".icon-saoma", function (e) {
    e.stopPropagation();
    QuestPermission.requestPermission('camera', null,function () {
        openScanner({
            callback: function (value) {
                $("#foot_search").val(value);
                if (!!$("#foot_search").val().trim()) {
                    search_data['keyword'] = $('#foot_search').val().trim();
                    $('#product_list').empty();
                    getList();
                    return true;
                } else {
                    fun.toast('扫码失败！');
                    return true;
                }
            }
        });
    });
});


//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });

}

// function setOption(obj) {
//     switch (obj) {
//         case 'yarn':
//             $('.hide').css('display','none');
//             $('.pro-title').text('纱线名称');
//             $('.all').addClass('broad');
//             $('.name1').text('下限粒');
//             $('.name2').text('上限粒');
//             $('.name3').text('不足粒');
//             $('.all1').text('总粒数');
//             $('.all2').text('总数量');
//             options = {
//                 "choose_merchants":[
//                     {key:"ck","text":"仓库","value":""},
//                     {key:"lb","text":"类别","value":""},
//                     {key:"md","text":"门店","value":""},
//                     {key:"xs","text":"显示","value":""},
//                     {key:"yjfs","text":"预警方式","value":""},
//                     {key:"yjlx","text":"预警类型","value":""},
//                 ],
//                 "switch": [
//                     {"text": "只显示预警","max_width":true,"key": "ck_hidezero", "value": 0},
//                     {"text": "只显示0库存","max_width":true,"key": "ck_hidezero", "value": 0},
//                 ],
//                 "sort": [
//                     {"text": "粒数", "key": "JE_SORT", "value": "desc"},
//                     {"text": "数量", "key": "JE_SORT", "value": "desc"},
//                 ]
//             };
//             break;
//         case 'cloth':
//             $('.all-line').addClass('line');
//               options = {
//                   "choose_merchants":[
//                     {key:"ck","text":"仓库","value":""},
//                     {key:"lb","text":"类别","value":""},
//                     {key:"md","text":"门店","value":""},
//                     {key:"xs","text":"显示","value":""}
//                   ],
//                   "switch": [
//                     {"text": "视图模式","max_width":false,"key": "ck_hidezero", "value": 0},
//                    ],
//                   "sort": [
//                         {"text": "匹数", "key": "JE_SORT", "value": "desc"},
//                         {"text": "数量", "key": "JE_SORT", "value": "desc"},
//                   ], 4
//                   "sort": [
//                       {"text": "日期", "key": "JE_SORT", "value": "desc"},
//                   ]
//               };
//             break;
//           default:
//     }
// }
