var html_name = page_arr.kc_kcfx,
    obj, text_val,
    list = [];
search_data = {
    type: (!Auth.check('yxckbpcbj', 'view')) ? 'ps' : 'cb',       //类型
    limit: fun.getItem('kc_top') ? fun.getItem('kc_top')['id'] : 10,       //条数
    top: fun.getItem('kc_top') ? fun.getItem('kc_top')['id'] : 10,      //数量

};
var USER_INFO = {};
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));
    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    if(!Auth.check('yxckbpcbj', 'view')) {
        $('.cb-line,.cb-cost').hide();
        $('.ps-line').addClass('active').siblings().removeClass('active');
    }
    search_data['xs'] = page_data['xs'];
    $('body').on('touchend', '#complete_btn', function (e) {
        e.preventDefault();
        var list = [
            {id: 10, name: "TOP 10", is_choose: 1},
            {id: 20, name: "TOP 20", is_choose: 0},
            {id: 30, name: "TOP 30", is_choose: 0}
        ];
        for (var i = 0; i < list.length; i++) {
            if (!fun.getItem('kc_top')) break;
            if (list[i]['id'] == fun.getItem('kc_top')['id']) {
                list[i]['is_choose'] = 1;
            } else {
                list[i]['is_choose'] = 0;
            }
        }
        fun.showBookList({
            list: list,
            choose: function (res) {
                search_data['limit'] = res['id'];
                fun.setItem('kc_top', {'id': res['id'], 'name': res['name']});
                $('#complete_btn').text(res['name']);
                getList();
            }
            // return true;
        });
    })
    getList();
    obj = page_data.obj;
    $('#header').header({
        back: true,
        title: '全部库存',
        text_btn: true, //文字按钮
        text_val: fun.getItem('kc_top') ? fun.getItem('kc_top')['name'] : 'TOP 10' //文字按钮值
    });

    // if(Auth.check('yxckbpcbj','view')){
    //     $('#bp_cb').show();
    // }

    $('.cut > li:visible').eq(0).addClass('active');
    $('.cut > li:visible').eq(0).addClass('set-radius');

    //切换，
    $('.show-list').on('tap', function () {
        $(this).addClass('active').siblings().removeClass('active');
        goods_id = $('.active').attr('gooas-id');
        switch (goods_id) {
            case 'ps':
                search_data['type'] = goods_id;
                break;
            case 'm':
                search_data['type'] = goods_id;
                break;
            case 'y':
                search_data['type'] = goods_id;
                break;
            case 'kg':
                search_data['type'] = goods_id;
                break;
            case 'cb':
                search_data['type'] = goods_id;
                break;
            default:
        }
        getList();
        var index = $(this).index();
        number = index;
        $('.empty_bottom').remove();
        $('.content').hide();
        $('.content:eq(' + index + ')').show();
    });
    initPage(obj);
    //滚动到底提示
    fun.scrollToBottom({}, function () {
        if (list.length > 0) {
            appendList(fun.PagingData(list, 5)); 
        }
        else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('content_list', ".store");
        }
    });
}


function getList() {
    // console.log('==>'+JSON.stringify(search_data));
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileKcfx,
        data: search_data,
        success: function (res) {
            showData(res || '');
        }
    })
}

function showData(data) {
    var listPs = [];
    var list = data['list'];
    //合计
    var total = Math.round((data['hj'] || 0) * 10) / 10;
    var text = '';
    var ck_data = [];
    var text_arr = {'ps': '总匹数', 'm': '总米数', 'y': '总码数', 'kg': '总公斤', 'cb': '总成本'};
    var text_dw = {'ps': '匹', 'm': '米', 'y': '码', 'kg': '公斤', 'cb': '元'};
    if (list != null) {
        //调整临时高度
        $('.content').css({'height': 'auto', 'position': 'unset'});
        // for (var i = 0; i < list.length; i++) {
        //     var colour_tb = order_color[i % order_color.length];
        //     var ck_name = list[i]['ck_mc'];
        //
        //     var arr = colour_tb.split(',');
        // }
        var close = [];//存负数数据
        // var negative = [];//存全部数据
        for (var i = 0; i < list.length; i++) {
            var value = (list[i]['value'] || 0);
            var colour = order_color[i % order_color.length];
            listPs.push('<div class="store lower-border-line">');
            listPs.push('   <div class="store-top">');
            listPs.push('       <span class="store-id">' + (i + 1) + '.</span>');
            listPs.push('       <div class="store-box" style="background:' + colour + ';"></div>');
            listPs.push('       <span class="store-title dot">' + list[i]['ck_mc'] + '</span>');
            listPs.push('   </div>');
            listPs.push('   <div class="bot">');
            // listPs.push('       <span class="all">' + text_arr[data['type']] + ':</span>');
            listPs.push('       <span class="all-m">' + value + text_dw[data['type']] + '</span>');
            listPs.push('   </div>');
            listPs.push('</div>');

            if (value < 0 || value === 0) {
                close.push({'value': value, 'name': list[i]['ck_mc']});
                // if(list.length != close.length){
                    // list[i]['value'] = 0;
                // }
            }else {
                // list[i]['value'] = value;
                ck_data.push({'value': value, 'name': list[i]['ck_mc']});

            }
            // negative.push({'value': value, 'name': list[i]['ck_mc']});

        }
    } else {
        //调整临时高度
        $('.content').css({'height': '40%', 'position': 'fixed'});
        // $('.content').html('<p class="empty_text">暂无数据！</p>');
        return fun.createDataEmptyTips({dom:'.content',btnShow:false});
    }
    switch (data['type']) {
        case 'ps':
            $('#ps_list').empty();
            $('#ps_list').append(listPs.join(''));
            break;
        case 'm':
            $('#mi_list').empty();
            $('#mi_list').append(listPs.join(''));
            break;
        case 'y':
            $('#ma_list').empty();
            $('#ma_list').append(listPs.join(''));
            break;
        case 'kg':
            $('#kg_list').empty();
            $('#kg_list').append(listPs.join(''));
            break;
        case 'cb':
            $('#cb_list').empty();
            $('#cb_list').append(listPs.join(''));
            break;
        default:
    }
    ck_data = (list.length === close.length) ? close : ck_data;
    var myChart = echarts.init(document.getElementById('cost'));
    var option = {
        title: [{
            text: text_arr[data['type']],
            x: 'center',
            top: '45%',
            textStyle: {
                color: '#a5a5a5',
                fontStyle: 'normal',
                fontWeight: '600',
                fontFamily: 'sans-serif',
                fontSize: 12
            }
        }, {
            text: total,
            x: 'center',
            top: '50%',
            textStyle: {
                color: '#000',
                width: '50%',
                fontStyle: 'normal',
                fontWeight: '400',
                fontFamily: 'sans-serif',
                fontSize: 16
            }
        }],
        tooltip: {
            trigger: 'item',
            formatter: "{b} ({d}%)<br/>{a}: {c} "
        },
        series: [{
            name: text_arr[data['type']],
            type: 'pie',
            color: order_color,
            radius: ['60%', '80%'],
            avoidLabelOverlap: true,
            label: {
                normal: {
                    show: false,
                    position: 'center'
                }

            },
            labelLine: {
                normal: {
                    show: false
                }
            },
            data: ck_data
        }]
    };
    // pie = echarts.init(obj);
    myChart.setOption(option);
    myChart.on('click', function (param) {//不监听会报错
        return;
    });
}

function initPage(obj) {
    switch (obj) {
        case 'yarn':
            $('.hide').css('display', 'none');
            $('.line1').text("粒数");
            $('.line2').text("数量");
            $('.cut').addClass('wide');
            $('.show-list').addClass('broad');
            break;
        case 'cloth':
            $('.cloth-hide').css('display', 'none');
            break;
        default:

    }
}
