var html_name = page_arr.kc_mxpk;
var to_month = fun.getLatelyTime(1,false);//获取时间
//要查询的数据
//{"begin_time":"2019-03-04","end_time":"2019-04-03","ck_id":0,"cp_id":0,"cp_ys_id":0,"cp_lb_id":0,"group":"","xszf":false}
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    "ck_id": 0,
    "cp_id": 0,
    "cp_ys_id": 0,
    "cp_lb_id": 0,
    "group": "",
    "xszf": false,
};
//搜索页数据
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

//头部样式
$('#header').header({
    back: true,
    filter: true,
    add: Auth.check('kc_bpmxpkd', 'edit'), //添加
    title: '明细盘亏'
});

var page_list = [];
var USER_INFO = {};

var hz_group_columns = {
    'dh': 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc,ck_id,ck_mc',
    'ck': 'ck_id,ck_mc',
    'cp': 'cp_bh,cp_mc',
    'cp_ys': 'cp_ys_bh,cp_ys_mc',
    "hsdj": 'hsdj',
    "fkkz": 'fk,kz',
    "gg": 'gg'
};

//页面加载完后加载
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var hnh = html_name + '_';
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));
    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(html_name + '_' + 'hz') || '')
    // initPage();

    search_storage = $.extend(true, {
        "hz": {
            "choose": {
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "dh": fun.getItem(hnh + 'dh', 1),
                "ck": fun.getItem(hnh + 'ck', 1),
                "cp": fun.getItem(hnh + 'cp', 1),
                "cp_ys": fun.getItem(hnh + 'cp_ys', 1),
                "fkkz": fun.getItem(hnh + 'fkkz', 0),
                "gg": fun.getItem(hnh + 'gg', 0)
            },
            "text": fun.getItem(hnh + 'text', ""),
        }
    }, search_storage);

    search_data = $.extend({}, search_data, search_storage);
    fun.initGroupOfSearchData(search_data, search_storage.hz.choose, hz_group_columns, ',dw_id,dw_mc');
    getList(search_data);

    //接收搜索页的数据
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret.value;

        switch (temp['status']) {
            case 'search':
                var param = ret.value.data;

                search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
                search_data['begin_time'] = param.begin_date;                   //开始时间
                search_data['end_time'] = param.end_date;                       //结束时间
                search_data['cp_id'] = param.cp['id'] || '';                    //产品
                search_data['cp_lb_id'] = param.cp_lb['id'] || 0;             //产品类别
                search_data['ck_id'] = param.ck['id'] || '';                    //仓库
                search_data['md_id'] = param.md['id'] || '';                    //门店
                search_data['xszf'] = param['xszf'];                            //作废单据
                search_data['hldj'] = param['hldj'];                            //合拢单据
                search_data['xsmx'] = param['xsmx'];                            //显示明细数据

                //搜索菜单需要缓存的数据
                search_storage['keyword'] = search_data['keyword'];
                search_storage['begin_date'] = search_data['begin_time'];
                search_storage['end_date'] = search_data['end_time'];
                search_storage['cp'] = param.cp;
                search_storage['cp_lb'] = param.cp_lb;
                search_storage['ck'] = param.ck;
                search_storage['md'] = param.md;
                search_storage['xszf'] = search_data['xszf'];
                search_storage['hldj'] = search_data['hldj'];
                search_storage['xsmx'] = search_data['xsmx'];

                //设置时间控件时间
                date_bar.setDate(search_storage);
                fun.setItem(html_name + '_xszf', search_storage['xszf']);
                fun.setItem(html_name + '_hldj', search_storage['hldj']);
                fun.setItem(html_name + '_xsmx', search_storage['xsmx']);

                //汇总功能
                search_data['group'] = param.hz['group'] || '';
                search_storage['hz'] = param.hz;
                var hc = param['hz']['choose'];
                fun.setItem(hnh + 'md_mc', hc['md_mc']);
                fun.setItem(hnh + 'dh', hc['dh']);
                fun.setItem(hnh + 'ck', hc['ck']);
                fun.setItem(hnh + 'cp', hc['cp']);
                fun.setItem(hnh + 'cp_ys', hc['cp_ys']);
                fun.setItem(hnh + 'fkkz', hc['fkkz']);
                fun.setItem(hnh + 'gg', hc['gg']);
                fun.setItem(hnh + 'text', param.hz['text']);
                fun.setGroupCondition(search_data, 'dw_id,dw_mc');

                // if (!!search_data['group']) {
                //     var group_data = search_data['group'];
                //     group_data += ',dw_id,dw_mc';
                //     search_data['group'] = group_data;
                // }
                fun.setItem(html_name + '_' + 'hz', search_data['group']);
                fun.setItem(html_name + 'sideslip', true);
                getList(search_data);
                break;
            case 'refresh':
                
                getList(search_data);
                break;
        }
    });
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
}

//获取最近6个月
var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getList(search_data);
        }
    });

//获取数据
function getList(data) {
    page_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBppkdtj,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#zps').text(0);
                    $('#zsl').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnText:'新增明细盘亏单',auth:'kc_bpmxpkd'});
                }
                ztj_data = res['info'];
                $('#order_list').empty();
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    hzDhFun: function (obj) {
                        return obj['dh'] + '_' + obj['ck_mc'];
                    },
                    hzCpOrYsFun: function (obj) {
                        return obj['ck_mc'] + '_' + obj['md_mc'] + '_' + obj['zdr_mc'] + '_' + obj["kdsj"] + '_' + obj["dh"] + '_' + obj['md_id'] + '_' + obj["cp_bh"] + '_' + obj["cp_mc"] + '_' + obj["cp_ys_bh"] + '_' + obj["cp_ys_mc"];
                    },
                    hzOthersFun: function (obj) {
                        return obj['ck_mc'] + '_' + obj['md_mc'] + '_' + obj['zdr_mc'] + '_' + obj["kdsj"] + '_' + obj["dh"] + '_' + obj['md_id'];
                    },
                    createKeysValueFun: function(obj) {
                        return {
                            "ck_mc": obj['ck_mc'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "md_id": obj['md_id'],
                            "list": [],
                            "is_sh": obj['is_sh'],
                            "dj_zsl": obj["dj_zsl"],
                            "dj_ps": obj["dj_ps"],
                            "zdw_mc": obj["zdw_mc"]
                        }
                    }
                });
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}

//动态加载数据
function showList(data) {
    $('#zps').text(ztj_data['zps'] || 0);
    $('#zsl').text(ztj_data['zsl'] || 0);
    var i;
    var hldj = fun.getItem(html_name + '_hldj', 0);
    var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        // showLog:true,
        isExpand: !hldj,
        isNoExpand: xsmx,

        render: {
            titlebar: function (res) {
                i = 1;
                var hCK = !!fun.is_value(res['ck_mc']),
                    hMD = !!fun.is_value(res['md_mc']) || fun.is_value(res['zdr_mc']);
                if (!!res['md_id'] || res['md_id'] == 0) hMD = true;
                var ckmd = hCK || hMD;
                var Html = [];
                Html.push(ckmd ? '<div class="title-bar-row title-bar-mxpk">' : '');
                Html.push(hCK ? '    <div><span class="font-bold">' + fun.is_value(res['ck_mc']) + '</span></div>' : ckmd ? '' : '');
                var align;
                var is_show = '';
                if (!hCK) {
                    align = 'align-left';
                } else {
                    align = "align-right"
                }

                if (!search_data.group || (/dh/i.test(search_data.group) && res['is_sh'] !== undefined)) {
                    is_show = fun.createIsShLabelHtml(res['is_sh'])
                }

                Html.push(hMD ? '    <div class="' + align + ' font-ss color-gray" >' + fun.formatTime(res['kdsj']) + '&nbsp;' + fun.is_value(res['zdr_mc']) + '<span>&nbsp;' + is_show + '</span></div>' : '');
                Html.push(ckmd ? '</div>' : '');


                var zdw_mc = fun.getHzUnitName(search_data['group'], res, 'zdw_mc');

                Html.push('<div class="title-bar-row title-bar-mxpk">');
                Html.push('    <div><span class="color-gray">共</span>&nbsp;&nbsp;<span>' + fun.is_value(res.dj_ps, 0) + '匹</span>&nbsp;<span>' + fun.is_value(res.dj_zsl, 0) + fun.is_value(zdw_mc) + '</span></div>');
                Html.push('</div>');
                return Html.join('');
            },
            subtitle: function (res) {
                var cp_bh = fun.is_value(res["cp_bh"]);
                var cp_mc = fun.is_value(res["cp_mc"]);
                var cp_ys_bh = fun.is_value(res["cp_ys_bh"]);
                var cp_ys_mc = fun.is_value(res["cp_ys_mc"]);

                var htmlArr = [];
                if (!($.nui.isEmpty(cp_bh) && $.nui.isEmpty(cp_mc) && $.nui.isEmpty(cp_ys_bh) && $.nui.isEmpty(cp_ys_mc))) {
                    htmlArr.push('  <div class="row">');
                    htmlArr.push('      <div>' + fun.is_value(res["cp_bh"]) + ' ' + fun.is_value(res["cp_mc"]) + ' ' + fun.is_value(res["cp_ys_bh"]) + ' ' + fun.is_value(res["cp_ys_mc"]) + '</div>');
                    htmlArr.push('  </div>');
                }
                htmlArr.push(fun.createFkKzGgHtml(search_data, res));
                return htmlArr.join('');
            },
            subdata: function (res) {
                // 获取汇总单位名称
                var dwmc = fun.getUnitName(search_data['group'], res, 'dw_mc');

                var htmlArr = [];
                htmlArr.push(' <div class="row bg-gray row-kc-mxpk" data-list=\'' + fun.formatString(JSON.stringify(res)) + '\'>');
                htmlArr.push('      <div><span>' + (fun.is_value(res['ps']) + '匹') + '</span><span>' + (fun.is_value(res['zsl']) + dwmc) + '</span></div>');
                htmlArr.push('</div>');
                return htmlArr.join('');
            }
        },
    });
}

//存储一个值用于判定是否打开搜索页//值为false即为打开
fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var n = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [{
            key: "cp",
            "text": "产品",
            "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
            "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
        }, {
            key: "cp_lb",
            "text": "产品类别",
            "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
            "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
        }, {
            key: "ck",
            "text": "仓库",
            "value": (search_storage['ck'] && search_storage['ck']['text']) || "",
            "id": (search_storage['ck'] && search_storage['ck']['id']) || 0,
            "is_detail": true
        }, {
            key: "md",
            "text": "门店",
            "value": (search_storage['md'] && search_storage['md']['text']) || "",
            "id": (search_storage['md'] && search_storage['md']['id']) || 0,
        },
        {
            key: "hz",
            "text": "汇总",
            //加工商、单号、门店、产品、颜色
            group: [
                // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                { key: 'dh', name: '单号', columns: hz_group_columns.dh, choose: getHz('dh') },
                { key: 'ck', name: '仓库', columns: hz_group_columns.ck, choose: getHz('ck') },
                { key: 'cp', name: '产品', columns: hz_group_columns.cp, choose: getHz('cp') },
                { key: 'cp_ys', name: '颜色', columns: hz_group_columns.cp_ys, choose: getHz('cp_ys') },
                //    { key: "hsdj", name: '单价', columns: hz_group_columns.hsdj, choose: getHz('hsdj')},
                { key: "fkkz", name: '幅宽克重', columns: hz_group_columns.fkkz, choose: getHz('fkkz') },
                { key: "gg", name: '规格', columns: hz_group_columns.gg, choose: getHz('gg') }
            ],
            "value": getTwo('hz', 'text'),
        }
        ],
        "switch": [{
            "text": "显示明细数据",
            "max_width": true,
            "key": "xsmx",
            "value": (!!fun.getItem(html_name + '_xsmx') ? fun.getItem(html_name + '_xsmx') : 0),
        },{
            "text": "合拢单据",
            "max_width": true,
            "key": "hldj",
            "value": (!!fun.getItem(html_name + '_hldj') ? fun.getItem(html_name + '_hldj') : 0),
        },]
    }
    if (n) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});
function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

// 添加明细盘亏单
$('body').on('tap', '#add_btn', function () {
    if (!fun.checkKz()) return;
    // 跳转顺序: 调库存 -> 明细盘亏编辑
    const __route = [ // 定义页面顺序
        {
            url: page_arr.detailed_stock2,
            page_data: {
                djlx: 'kc_bpmxpkd',
                return_page: html_name,
                has_tm: true,   // 只查询开启明细的产品
                __IS_NEW: true    // 标记新增
            }
        },
        {
            url: page_arr.kc_mxpk_edit,
            page_data: {
                djlx: 'kc_bpmxpkd',
                return_page: html_name,
            }
        },
    ];
    var opt = {
        page_url: __route[0]['url'],
        pageParam: $.extend(true, { __route: __route }, __route[0]['page_data'])
    };
    fun.showPageFull(opt);
});

// 查看明细盘亏详情
fun.tjContentTap(function (data_list) {
    if (!fun.checkKz()) return;

    if ($.nui.isTrue(data_list['dj_id'])) {
        var id = data_list['dj_id'];
        var dh = data_list['dh'];
        var kdsj = data_list['kdsj'];
        var zdr = data_list['zdr_mc'];
        fun.showPageFull({
            page_url: page_arr.kc_mxpk_edit,
            pageParam: {
                return_page: html_name,
                id: id,
                dh: dh,
                kdsj: kdsj,
                zdr: zdr
            }
        });
    }
});

$('body').on('click','.row-list',function(){
    if(fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var data_list = $(this).children('.summary').children('.summary-content').data('list');
    if ($.nui.isTrue(data_list['dj_id'])) {
        var id = data_list['dj_id'];
        var dh = data_list['dh'];
        var kdsj = data_list['kdsj'];
        var zdr = data_list['zdr_mc'];
        fun.showPageFull({
            page_url: page_arr.kc_mxpk_edit,
            pageParam: {
                return_page: html_name,
                id: id,
                dh: dh,
                kdsj: kdsj,
                zdr: zdr
            }
        });
    }
})