var html_name = page_arr.kc_tmcx;
var tm_info;
$('#header').header({
    back: true,
    title: '条码查询',
    foot_input: {
        show: true,
        scan_icon: true,
        plader: '搜索条码',
    },
});

// $(".bp-info input").attr("disabled","disabled");// 不可编辑，可以传值

page_init = function () {
    $("#foot_search").select();
    // $('.contents').hide();
    // getData('190112000001');

    if (Auth.check('gdckxskgjje', 'view')) {
        $('#bk,#bg,#bj').parent().show();
    } else {
        $('#by').parent().css({width: '100%'});
        $('#by').prev().css('marginLeft', '3.5%');
    }

    if (!!page_data && page_data['type'] == 'mxkc') {
        $('#foot_search').val(page_data['tm']);
        $('#foot_search').select();
        getData(page_data['tm']);
    }

}


//点击键盘搜索
$('body').bind('search', "#foot_search", function (e) {
    var tm = $('#foot_search').val().trim();
    // if (e.keyCode === 13 && tm) {
    // $(this).select();
    if (tm) getData(tm);
    else {
        $('.contents').data('oriShow', 'display:hide;').hide();
    }
    // }
});

//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });

}

//点击图片放大
$('body').on('tap', '.pro-img', function () {
    var imgs = $(this).children('#cpImg').attr('src');
    if(imgs == '../img/logo.png') return;
    var photoBrowser = api.require('photoBrowser');
    photoBrowser.open({
        images: [
            imgs,
        ],
        placeholderImg: 'widget://res/img/apicloud.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') photoBrowser.close();
        } else {
            fun.toast('图片打开失败！');
            photoBrowser.close();
        }
    });
});


$('.foot-input-box').on('click', ".icon-saoma", function () {
    QuestPermission.requestPermission('camera', null,function () {
        openScanner({
            callback: function (value) {
                $("#foot_search").val(value);
                $("#foot_search").select();
                if (!!$("#foot_search").val().trim()) {
                    getData(value);
                    return true;
                } else {
                    fun.toast('扫码失败！');
                    return true;
                }
            }
        });
    });
    
});

function getData(param) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileTmInfo,
        data: {tm: param},
        success: function (res) {
            if (res.status != 0) {
                $('.contents').data('oriShow', 'display:hide;').hide();
                return fun.toast('不存在该条码！');
            }
            // $('.contents').show();
            var info_list = res.data;
            showData(info_list);
        }
    });
}

function showData(data) {
    if (typeof data['other_info'] === 'string') data['other_info'] = JSON.parse(data['other_info']);
    var other_info = (data['other_info'] || {});
    $('.contents').data('oriShow', 'display:block;').show();
    $('.bp-info,.dcks,.cks').hide();
    $('#cpImg').attr('src', (fun.getImgPath(data['cp_imgs']) || "../img/logo.png"));
    if ($('#cpImg').attr('src') !== fun.getImgPath(data['cp_imgs'])) {
        $('.pro-img').css({
            'background': '#f5f5f5',
            'border-radius': '0.25rem'
        });
        $('#cpImg').css({
            'opacity':'0.3',
            'width' : '70%',
            'height': '70%',
            'margin-top': '15%'
        });
    } else {
        $('#cpImg').css('opacity', '1');
        $('.img-mask').show();
    }
    $('#pro-title').text((data['cp_bh'] + ' ' + data['cp_mc']) || '');
    $('#fea-color').text((data['cp_ys_bh'] + ' ' + data['cp_ys_mc']) || '');
    $('#fea-gj').text((data['sl'] + data['dw_mc']) || '');
    $('#store-title').text(data['ck_mc'] || '');

    if (!data['is_delete']) {
        $('.bp-info').show();
        // $('#rk').text((data['rk_djlx_mc'] + ' ' + other_info['rkfs']['dh']) || '');
        $('#rk').text((data['rk_djlx_mc'] || '') + ' ' + (data['rk_dh'] || ''));

        // data['rk_sj'] && $('#rksj').text(fun.formatDate(data['rk_sj']) || '');
        if ($.nui.isTrue(data['rk_sj'])) {
            $('#rksj').text(fun.formatDate(data['rk_sj']) || '');
        } else {
            $('#rksj').text('');
        }
    }
    if (!!data['is_zf']) {//是否是已作废
        $('#store-bot').text('已作废');
        $('#store-bot').css('background', '#8D8D8D');
    } else if (!!data['is_dck']) {//如果是待出库
        $('#store-bot').text('待出库');
        $('#store-bot').css('background', '#FF2E2E');  //#FF2E2E
    } else if (!!data['is_ck']) {//否则就是已经出库
        $('#store-bot').text('已出库');
        $('#store-bot').css('background', '#F68324');//#F68324
    } else if (!data['is_zf'] && !data['is_ck'] && !data['is_dck']) {
        $('#store-bot').text('在仓库');
        $('#store-bot').css('background', '#44A3FF');    //#44A3FF
    }

    var otherInfoRkfs = other_info['rkfs'] || {};

    $('#fk').text(data['fk'] || '');//幅宽
    $('#kz').text(data['kz'] || '');
    $('#gh').text(data['gh'] || '');
    $('#jh').text(data['jh'] || '');
    $('#gg').text(data['gg'] || '');
    $('#ph').text(data['ph'] || '');//批号
    $('#cw').text(data['cw_mc'] || '');
    $('#pha').text((other_info['rkfs'] && otherInfoRkfs['ph']) || '');//匹号
    $('#by').text(data['ywy_mc'] || '');
    $('#bk').text(data['bp_kh_mc'] || '');
    $('#bg').text(data['bp_gys_mc'] || '');
    $('#bj').text(data['bp_jgs_mc'] || '');

    if ($.nui.isTrue(data['kl'])) $('#kl').text((data['kl'] || '') + '/天');//库龄
    else $('#kl').text('');//库龄
    if (!!fun.getItem('sys_config')['ypbddwgl'] && !!data['dw2_mc'] && !!data['dw_mc'] && data['dw2_mc'] != data['dw_mc']) {
        $('#sl2').text(data['sl2'] || '');
        $('#dw2').text(data['dw2_mc'] || '');
    }
    // 仓库自定义字段
    for (var i = 1; i <= 5; i++) {
        var display = fun.getItem('sys_config')['bpckzdygl' + i];
        if ($.nui.isTrue(display)) {
            if (!!data['ck_zdy' + i]) {
                $('.zdysx' + i).css('display', 'block');
                $('#zdysx' + i).text(data['ck_zdy' + i] || '');
            }
        }
    }

    if (!!data['dck_djlx_mc']) {
        $('.dcks').show();
        $('#dck').text((data['dck_djlx_mc'] + ' ' + (data['dck_dh'] || '')) || '');
    }

    // 如果当前条码 已出库
    if (!!data['ck_djlx_mc']) {
        $('.cks').show();
        $('.dcks').hide();
        // $('#ck').text((data['ck_djlx_mc'] + ' ' + other_info['ckfs']['dh']) || '');
        // other_info['ckfs']['kdsj'] && $('#cksj').text(fun.formatDate(other_info['ckfs']['kdsj']) || '');

        $('#ck').text((data['ck_djlx_mc'] || '' + ' ' + data['ck_dh'] || '') || '');

        if ($.nui.isTrue(data['ck_sj'])) {
            $('#cksj').text(fun.formatDate(data['ck_sj']) || '');
        } else {
            $('#cksj').text('');
        }

    } else {
        $('.cks').hide();
    }

    if ($.nui.isTrue(data['ybr_mc']) || $.nui.isTrue(data['yb_xc_dj'])
        || $.nui.isTrue(data['yb_xc_fs']) || $.nui.isTrue(data['yb_xc_mc'])) {
        $('.yb').css('display','inline-block');

        $('#yb_ybr').text(data['ybr_mc'] || '');
        $('#yb_dj').text(data['yb_xc_dj'] || '');
        $('#yb_k').text(data['yb_xc_fs'] || 0);
        $('#yb_xc').text(data['yb_xc_mc'] || '');
    } else {
        $('.yb').hide();
    }
}


function getData2(param) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileTmInfo,
        data: {tm: param},
        success: function (res) {
            // if (res.status != 0) {
            //     $('.contents').hide();
            //     return fun.toast('不存在该条码！');
            // }
            // $('.contents').show();
            // var info_list = res.data;
            // showData2(info_list);
        }
    });
}

//ios设置头部带输入框的页面，软键盘弹起后头部定位失效问题
fun.setHeaderLocation = function (wrap_obj) {
    var systemType = api.systemType;
    if (systemType == "ios") {
        $('#foot_search').on('touchstart', function (e) {
            // $('#header').css('position','absolute');
            var oriStyle = ($(wrap_obj).data('oriStyle') || '') || ($(wrap_obj).attr('style') || '');
            $(wrap_obj).css({
                "position": "fixed",
                "left": 0,
                "right": 0,
                "top": 0,
                "width": "100%",
                "height": $(document).height() - $('#header').innerHeight(),
                "overflow": "auto"
            }).data('oriStyle', oriStyle);
        })
        $('body').on('touchstart', function (e) {
            if (e.target.id != "foot_search") {
                // $('#header').css('position','fixed');
                var oriShow = $(wrap_obj).data('oriShow')||'';
                var oriStyle = $(wrap_obj).data('oriStyle')||'';
                $(wrap_obj).attr('style') != "" && $(wrap_obj).attr('style', ((oriShow+oriStyle) || ''));
            }
        })
    }
}
