html_name = page_arr.kc_zspd_edit;
Bills['AJAX_URL'] = { 'save': AJAX_URL.saveBpzspdInfo, 'getDj': AJAX_URL.getKccpCbj };
Bills['djlx'] = 'kc_bpzspd';
Bills['auth'] = 'kc_bpzspd';

// Bills['print_config'] = {'has_bar': 1};
Bills['print_config'] = {};
// 定义页面操作对象，防止变量重名
var kcZspdEdit = {
    id: 0,
    dh: 0,
    getData: {
        dj: { zps: 0, zsl: 0, bz: '' },
        jl: []
    },
    data_text: {
        ck_id: 0,
    },
    origin_data: { dj: { bz: '' }, jl: [] },
    save_data: {},
    fsh: fun.getItem('sys_config')['fsh'],
    begin_lCalendar: new lCalendar(),
    showedDw: '', // 需要显示的单位
    authViewCbj: Auth.check('yxckbpcbj', 'view'),  // 是否有查看成本权限
    deleteRows: [],                  // 需要删除的数组
    // ps_pd sl_pd
    zps_pd: 0,                       // 盘点总匹数
    zsl_pd: 0                        // 盘点总数量
};

var AUTH_EDIT = Auth.check('kc_bpzspd', 'edit');
var AUTH_SH = Auth.check('kc_bpzspd', 'check');
var AUTH_ZF = Auth.check('kc_bpzspd', 'invalid');

//盘点弹窗
fun.pd = function (params) {
    var option = $.extend({
        content: {
            kcp: 0,
            pdp: 0,
            kcs: 0,
            pds: 0,
            cb: 0,
            je: 0,
        },
        title: '盘点',
        className: (kcZspdEdit.authViewCbj) ? 'check-list2' : 'check-list',
        btn: ['确定', '取消'],
        yes: null,
        no: null,
        success: null,
    }, params);
    var boxHtml = [],
        data = option['content'];
    boxHtml.push('<div class="check-body">');
    boxHtml.push('  <span class="check-title">' + option['title'] + '</span>');
    boxHtml.push('  <div>');
    boxHtml.push('      <ul>');
    boxHtml.push('          <li>');
    boxHtml.push('              <div class="block">');
    boxHtml.push('                  <span class="check-left" >库存匹</span><span class="check-right" id="kcp">' + data['kcp'] + '</span>');
    boxHtml.push('              </div>');
    boxHtml.push('              <div class="block">');
    boxHtml.push('                  <span class="check-left">盘点</span><input value=\'' + data['pdp'] + '\' id="pdp" class="info-input num-input" num_type="4"> ');
    boxHtml.push('              </div>');
    boxHtml.push('              <div class="block">');
    boxHtml.push('                  <span class="check-left" >盈亏</span><span class="check-right" id="ykp">' + ((data['pdp'] - data['kcp']) || 0) + '</span>');
    boxHtml.push('              </div>');
    boxHtml.push('          </li>');
    boxHtml.push('          <li>');
    boxHtml.push('              <div class="block">');
    boxHtml.push('                  <span class="check-left">库存数</span><span class="check-right" id="kcs">' + data['kcs'] + '</span>');
    boxHtml.push('              </div>');
    boxHtml.push('              <div class="block">');
    boxHtml.push('                  <span class="check-left">盘点</span><input value=\'' + data['pds'] + '\' id="pds" class="info-input num-input" num_type="2" decimal_digits="4">');
    boxHtml.push('              </div>');
    boxHtml.push('              <div class="block">');
    boxHtml.push('                  <span class="check-left">盈亏</span><span class="check-right" id="yks">' + ((data['pds'] - data['kcs']) || 0) + '</span>');
    boxHtml.push('              </div>');
    boxHtml.push('          </li>');
    if (kcZspdEdit.authViewCbj) {
        boxHtml.push('          <li>');
        boxHtml.push('              <div class="block">');
        boxHtml.push('                  <span class="check-left">成本</span><input value=\'' + data['cb'] + '\' id="cb" class="info-input num-input" num_type="2" decimal_digits="4">');
        boxHtml.push('              </div>');
        boxHtml.push('              <div class="block">');
        boxHtml.push('                  <span class="check-je" id="je">￥' + data['je'] + '</span>');
        boxHtml.push('              </div>');
        boxHtml.push('          </li>');
    }
    boxHtml.push('      </ul>');
    boxHtml.push('  </div>');
    boxHtml.push('</div>');

    option.content = boxHtml.join('');

    option.success = function () {
        $('body').bind('keyup', '#pdp', function () {
            var pdp = $('#pdp').val(),
                kcp = parseFloat($('#kcp').text()),
                ykp = 0;
            if (isNaN(pdp)) {
                return;
            }
            if (pdp != '') {
                ykp = (pdp - kcp);
            } else {
                ykp = '';
            }
            $('#ykp').text(ykp);
        })
        $('body').bind('keyup', '#pds', function () {
            var pds = $('#pds').val(),
                kcs = parseFloat($('#kcs').text()),
                yks = 0;
            if (isNaN(pds)) {
                return;
            }
            if (pds != '') {
                yks = (pds - kcs);
            } else {
                yks = '';
            }
            $('#yks').text(yks);
        })
        $('body').bind('keyup', '#cb', function () {
            var yks = Number($('#yks').text() || 0),
                cb = Number($('#cb').val() || 0);

            if (isNaN(yks)) {
                return
            }

            if (isNaN(cb)) {
                return
            }

            $('#je').text('￥' + parseFloat($.nui.decimalMul(yks, cb)).fixed());
        })
    };
    // 点击确认回调事件
    option.yes = function () {
        params.yes({
            kcp: parseFloat($('#kcp').text().trim() || 0),
            pdp: parseFloat($('#pdp').val().trim() || 0),
            ykp: parseFloat($('#ykp').text().trim() || 0),
            kcs: parseFloat($('#kcs').text().trim() || 0),
            pds: parseFloat($('#pds').val().trim() || 0),
            yks: parseFloat($('#yks').text().trim() || 0),
            cb: $('#cb').length ? parseFloat($('#cb').val().trim() || 0) : data['cb'],
            je: parseFloat($('#je').text().replace('￥', '').trim() || 0),
        });
    };
    fun.dialog(option);
}
// 权限控制
// 1. 如果当前用户没有【允许查看布匹成本价】的浏览权限，不显示成本，不显示金额。
// 2. 如果当前用户没有该页面的修改权限 或 当前单据已审核时，不显示新增按钮
// 3. 添加按钮，新增或者编辑时都可以使用。新增时，从调库存页面进入。编辑时，从盘点页面进入。两者获取盘点记录的数据源不一致。
//
page_init = function () {
    // fun.keyboardEject('.base');
    kcZspdEdit.id = page_data['id'];
    $('.choice').hide();

    var date = new Date();
    // 新单时，设置默认开单时间
    if (!page_data.id) {
        date.setSeconds(0, 0);
        var current_date = fun.formatDate(date, 'YYYY-MM-DD HH:mm:ss');
        kcZspdEdit.origin_data.dj.kdsj = current_date;
        kcZspdEdit.getData.dj.kdsj = current_date;
    }

    $('#header').header({
        back: true,
        appendBackBtnEvt: kcZspdEdit.isDataChange,
        title: '总数盘点',
        subtitle: page_data['dh'] || '&nbsp;',
        // print: $.nui.isTrue(kcZspdEdit.id), // TODO: 打印暂时不做
        del: AUTH_EDIT,
        order_info: {
            show: true,
            person: page_data['zdr'] || fun.getItem('user_info')['name'],
            dateText: page_data['kdsj'] || fun.formatDate(date),
        },
        print: true
    });
    $('.custom-money').css('padding-left', $('.common').width());
    var isAndroid = navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1;
    if (!isAndroid) {
        document.body.addEventListener('focusin', function (e) {
            if (!isAndroid) {
                if ($(e.target).attr('id') == 'bz') return false;
                for (var i = 0; i < document.querySelectorAll('.scroll-wrap').length; i++) {
                    overscroll(document.querySelectorAll('.scroll-wrap')[i]);
                }
                document.body.addEventListener('touchmove', preventDefault, { passive: false });
            }
        });
        //软键盘收起的事件处理
        document.body.addEventListener('focusout', function () {
            if (!isAndroid) {
                document.body.removeEventListener('touchstart', preventDefault, { passive: false });
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            }
        })
    }
    $('#print_btn,#del_btn').hide();

    page_data.keyback = function () {
        kcZspdEdit.isDataChange();
    };
    kcZspdEdit.initTimePicker();
    init();

    // 事件监听，处理添加新行结束事件
    api.addEventListener({ name: html_name }, kcZspdEdit.addKcListener);
    fun.inputType();
};

function init() {
    $('button').hide();
    if ($.nui.isTrue(kcZspdEdit.id)) {
        $('#print_btn').show();
        kcZspdEdit.getPageData(page_data);
    } else {
        // kcZspdEdit.initTimePicker();
        kcZspdEdit.getDh();
        // 获取传递到数据
        if (page_data.data && page_data.data.list) {
            kcZspdEdit.getData.jl = page_data.data.list;
            kcZspdEdit.initData();
        } else {
            kcZspdEdit.initData();
        }
        page_data['return_page'] = page_arr.kc_zspd;
    }
    // 初始化dom触发事件
    kcZspdEdit.initOperationEvent();
}

//获得单号
kcZspdEdit.getDh = function () {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBillsPageDefInfo,
        data: {
            'djlx': 'kc_bpzspd',
            'table': 'kc_bpzspd_dj'
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    $('.subtitle').text(res.data.dh);
                    break;
                default:
                    fun.alert({ msg: '网络异常' });
                    break;
            }
        }
    })

};
//获得页面数据
kcZspdEdit.getPageData = function (data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpzspdInfo,
        data: {
            id: data['id'],
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    kcZspdEdit.data_text = res.data.dj;
                    kcZspdEdit.getData = res.data;

                    // kcZspdEdit.origin_data = JSON.parse(JSON.stringify(res.data));

                    $('.subtitle').text(res.data.dj.dh);

                    page_data['dj_is_sh'] = res.data.dj['is_sh'];

                    kcZspdEdit.begin_lCalendar.disabled = false;
                    $('input,#kdsj').removeAttr('disabled');

                    kcZspdEdit.showData1(res.data.dj);
                    kcZspdEdit.showData2(kcZspdEdit.convertData(res.data.jl));

                    if (!kcZspdEdit.isInEdit(res.data.dj)) {
                        console.log('00000000000000----------------')
                        kcZspdEdit.begin_lCalendar.disabled = true;
                        $('#kdsj').attr('disabled', true);
                        // kcZspdEdit.initTimePicker();
                    }
                    kcZspdEdit.getData.jl = res.data.jl || [];

                    kcZspdEdit.origin_data = kcZspdEdit.getSaveData();

                    break;
                default:
                    fun.alert({ msg: '网络异常' });
                    break;
            }
        }
    })
};

/**
 *  判断是否可以编辑
 */
kcZspdEdit.isInEdit = function (dj) {
    var AUTH_EDIT = Auth.check('kc_bpzspd', 'edit');
    return AUTH_EDIT ? !dj['is_sh'] : false;
};

//固定数据
kcZspdEdit.showData1 = function (data) {
    if (!(Auth.check('kc_bpzspd', 'edit') && data['is_sh'])) { // 有权限或者单据未审核
        $('.saves').show();
        $('.choice').show();

        if (kcZspdEdit.id) $('#del_btn').show();

        $('.choice').css('display', 'inline-block');
        if (Auth.check('kc_bpzspd', 'check') && page_data.id) { // 有审核权限
            $('.audit').show();
            $('.saves').hide();
        }
        kcZspdEdit.inputBindEvent();
    } else {//有权限并且单据已审核
        $('#bz').attr('disabled', 'disabled');
        $('#del_btn,.saves,.choice').hide();
        if ((!data['is_zf']) && Auth.check('kc_bpzspd', 'invalid') && kcZspdEdit.fsh) { // 未作废、有作废权限并且【系统设置-反审核】有开启
            $('.obsolete').show();
        }
        if ((!data['is_zf']) && Auth.check('kc_bpzspd', 'invalid') && !kcZspdEdit.fsh) { // 未作废、有作废权限并且【系统设置-反审核】没有开启
            $('.revocatory').show();
        }
    }
    data['bz'] && $('#bz').val(data['bz'] || '');
    $('#zps').text((data['yk_zps'] || 0) + '匹');
    $('#zsl').text((data['yk_zsl'] || 0) + kcZspdEdit.showedDw);

    if (data['is_zf']) {
        fun.seal({ type: 'zf' });
    } else if (data['is_sh']) {
        fun.seal({ type: 'sh' });
    } else {
        if ($('body').find('#state_icon').length) $('body').find('#state_icon').remove();
    }

    if (data['is_sh']) {
        $('.obsolete').show();
        $('.audit').hide();
        $('input').attr('disabled', true);
    } else {
        $.nui.isTrue(kcZspdEdit.id) && $('.audit').show();
    }

    if (data['is_zf']) {
        $('button').hide();
    }

    if (!AUTH_EDIT) {
        $('#del_btn,.choice,.saves').hide();
        $('input').attr('disabled', true);
        $('.right').hide();
    }

    if (!AUTH_SH) $('.audit,.revocatory').hide();
    if (!AUTH_ZF) $('.obsolete').hide();
};


kcZspdEdit.showData2 = function (data) {
    console.log(data);
    var Html = [];
    // 计算盈亏总匹数、总数量、总金额
    var zps = 0;
    var zsl = 0;
    var dws = {};
    var zje = 0;
    var zps_pd = 0;
    var zsl_pd = 0;

    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        Html.push('<a class="store-title">' + (val['ck_mc'] || ' ') + '</a>');
        Html.push('<ul class="swipe-delete">');
        for (var j = 0; j < val['list'].length; j++) {
            var data_list = val['list'][j];
            // 计算匹数盈亏ps_yk、数量盈亏sl_yk
            data_list.ps_yk = (data_list.ps_pd - data_list.ps).fixed();
            data_list.sl_yk = (data_list.sl_pd - data_list.zsl).fixed();
            data_list.zps = data_list.ps;
            zps_pd += data_list.ps_pd;
            zsl_pd += data_list.sl_pd;

            zps = zps + parseInt(data_list.ps_yk);
            zsl = (zsl + parseFloat(data_list.sl_yk)).fixed();
            console.log('zps', zps, 'zsl', zsl)
            // 统计显示单位名称
            if (!dws[data_list.dw_id]) {
                dws[data_list.dw_id] = data_list.dw_mc;
            }

            Html.push('	<li class="store-info fixed">');
            if (Auth.check('yxckbpcbj', 'view')) Html.push('		<div class="le" ">');
            else Html.push('		<div class="le" data-list=\'' + fun.formatString(JSON.stringify(data_list)) + '\'>')

            Html.push('<div class="store-content" data-list=\'' + fun.formatString(JSON.stringify(data_list)) + '\' ">');
            Html.push('			<p class="store-name">' + data_list['cp_bh'] + data_list['cp_mc'] + ' <i>' + data_list['cp_ys_bh'] + data_list['cp_ys_mc'] + '</i> </p>');

            Html.push('			<span>匹数<i class="info-date">' + fun.is_value(data_list['ps'], 0) + '</i></span>');
            Html.push('			<span>盘点<i class="info-date">' + fun.is_value(data_list['ps_pd'], 0) + '</i></span>');
            Html.push('			<span>盈亏<i class="info-date">' + fun.is_value(data_list['ps_yk'], 0) + '</i></span>');
            Html.push('			<span>数量<i class="info-date">' + fun.is_value(data_list['zsl'], 0) + fun.is_value(data_list.dw_mc) + '</i></span>');
            Html.push('			<span>盘点<i class="info-date">' + fun.is_value(data_list['sl_pd'], 0) + '</i></span>');
            Html.push('			<span>盈亏<i class="info-date">' + fun.is_value(data_list['sl_yk'], 0) + '</i></span>');
            if (kcZspdEdit.authViewCbj) {
                var je = data_list['sl_yk'] * data_list['cbj'];
                zje += parseFloat(je);
                Html.push('			<span>成本<i class="info-date  color1">' + data_list['cbj'] + '</i></span>');
                Html.push('			<span><i class="info-date color3">￥' + je.fixed() + '</i></span>');
            }
            Html.push('<br/>');
            if (fun.getKdSetting('fk')) {
                Html.push('<span>幅宽<i class="info-date">' + fun.is_value(data_list['fk']) + '</i></span>');
            }
            if (fun.getKdSetting('kz')) {
                Html.push('<span>克重<i class="info-date">' + fun.is_value(data_list['kz']) + '</i></span>');
            }
            if (fun.getKdSetting('gg')) {
                Html.push('<span>规格<i class="info-date">' + fun.is_value(data_list['gg']) + '</i></span>');
            }
            if (fun.getKdSetting('gh')) {
                Html.push('<span>缸号<i class="info-date">' + fun.is_value(data_list['gh']) + '</i></span>');
            }
            Html.push('</div>');
            if ($.nui.isEmpty(kcZspdEdit.getData.dj.is_sh)) {
                Html.push('			<div class="delete dels1 delete-btn" data-list=\'' + fun.formatString(JSON.stringify(data_list)) + '\' "><b class="swipe-span">删除</b></div>');
            }
            Html.push('		</div>');
            Html.push('	</li>');
        }
        Html.push('</ul>')
    }

    // Html.push('         <div class="add-product"><i class="iconfont icon-tianjia"></i>&nbsp;添加产品</div>');

    $('.storehouse').html(Html.join(''));

    if (!AUTH_EDIT) {
        $('.swipe-delete').removeClass('swipe-delete');
    }

    // if (!Auth.check('yxckbpcbj', 'view')) $('.ds').css({ 'line-height': ' 7.7rem', 'height': '7.7rem' });

    kcZspdEdit.zps_pd = zps_pd;
    kcZspdEdit.zsl_pd = zsl_pd;
    // 总匹数、总数量以盘点总匹数、总数量的为准
    // kcZspdEdit.origin_data.dj.zps = zps;
    // kcZspdEdit.origin_data.dj.zsl = zsl;

    kcZspdEdit.getData.dj.yk_zps = zps;
    kcZspdEdit.getData.dj.yk_zsl = zsl;
    // 只有一个单位时显示，多个时不显示
    var showedDw = [];
    for (var dwId in dws) {
        showedDw.push(dws[dwId]);
    }
    if (showedDw.length === 1) {
        kcZspdEdit.showedDw = showedDw[0];
    }

    if (kcZspdEdit.authViewCbj) {
        $('#zje').html(Number(zje).fixed() + '元');
    } else {
        $('.le3').css({ 'height': '6.6rem' });
        $('.text-group2').css({ 'line-height': ' 2.5rem', 'height': '2.5rem' })
    }
    kcZspdEdit.showData1(kcZspdEdit.getData.dj);
};
kcZspdEdit.convertData = function (apidata) {
    if (JSON.stringify(apidata) == "[]")
        return [];
    if ((!(apidata instanceof Array))) {
        return "参数错误";
    }

    var list = [], tmp = {};
    $(apidata).each(function (i, obj) {
        obj.__uuid = $.nui.getRandomNum();
        if (!tmp[obj['ck_id']]) {
            tmp[obj['ck_id']] = {
                'ck_id': obj['ck_id'],
                'ck_mc': obj['ck_mc'],
                'list': []
            }
        }
        tmp[obj['ck_id']]['list'].push(obj)
    });

    var ckIds = [];
    for (var i in tmp) {
        list.push(tmp[i]);
        ckIds.push(i);
    }

    if ($.nui.isEmpty(fun.getItem('sys_config')['dckms_bp'])) {
        kcZspdEdit.data_text.ck_id = ckIds[0];
    } else {
        kcZspdEdit.data_text.ck_id = 0;
    }

    return list;
};
//获得保存数据
kcZspdEdit.getSaveData = function () {
    var USER_INFO = fun.getItem('user_info') || {};
    var dj = {
        id: Number(page_data['id'] || 0),
        save_time: (!$.nui.isEmpty(kcZspdEdit.data_text) ? kcZspdEdit.data_text['save_time'] : ''),//保存时间
        jsr_id: (!$.nui.isEmpty(kcZspdEdit.data_text) ? kcZspdEdit.data_text['jsr_id'] : 0),//经手人id
        zdr_id: USER_INFO['id'],//制单人id kcZspdEdit.getData.dj.zdr_id ||
        md_id: USER_INFO['store_id'] || 0,//门店id
        kdsj: fun.formatDate($('#kdsj').text().trim(), 'YYYY-MM-DD HH:mm:ss'),//开单时间
        dj_lsh: (!$.nui.isEmpty(kcZspdEdit.data_text) ? kcZspdEdit.data_text['dj_lsh'] : 0),//单据流水号
        dh: $('.subtitle').text().trim() || '',//单号
        ck_id: (!$.nui.isEmpty(kcZspdEdit.data_text) ? Number(kcZspdEdit.data_text['ck_id']) : 0),
        bz: $('#bz').val().trim() || '',
        zps: kcZspdEdit.zps_pd,
        zsl: kcZspdEdit.zsl_pd,
    };

    for (var i = 0; i < (kcZspdEdit.getData.jl || []).length; i++) {
        delete kcZspdEdit.getData.jl[i]['jjdw_id'];
    }

    return {
        dj: $.extend({}, kcZspdEdit.origin_data.dj, dj),
        jl: kcZspdEdit.getData.jl.slice(0)
    };
};
//保存数据
kcZspdEdit.saveData = function () {
    var dj = {}, jl = [];
    var real_save_data = kcZspdEdit.getSaveData();
    dj = real_save_data['dj'];
    jl = kcZspdEdit.getData['jl'];
    real_save_data['jl'] = jl;
    if (!Check.kzrq({ sj: dj['kdsj'] })) return false;
    if (!Check.yjrq({ sj: dj['kdsj'] })) return false;

    if (dj['dh'] == '') return fun.toast('单号不能为空');

    if ($.nui.isEmpty(real_save_data['jl'])) return fun.toast(tips_arr['空单提示']);

    // 没开启【系统设置-多仓库模式】时，需约束：仓库不能为空。
    if ($.nui.isEmpty(fun.getItem('sys_config')['dckms_bp']) && $.nui.isEmpty(dj['ck_id'])) return fun.toast('仓库不能为空');

    var tempArr = real_save_data['jl'];
    var ckIds = [];
    for (var i = 0; i < tempArr.length; i++) {
        if (ckIds.indexOf(tempArr[i].ck_id) === -1) {
            ckIds.push(tempArr[i].ck_id);
        }
    }
    if ($.nui.isEmpty(fun.getItem('sys_config')['dckms_bp']) && !$.nui.isFieldValEqual('ck_id', tempArr)['res']) {
        fun.toast('不允许调用多个仓库的布匹。');
        return false;
    }

    real_save_data.jl = real_save_data.jl.concat(kcZspdEdit.deleteRows);

    var data = $.extend(true, { status: 'save', __post_sign: Bills['__post_sign']}, real_save_data);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveBpzspdInfo,
        data: data,
        success: function (res) {
            if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('保存成功。');

                    kcZspdEdit.deleteRows = [];

                    page_data.id = res['data']['dj_id'];
                    kcZspdEdit.id = res['data']['dj_id'];

                    kcZspdEdit.closePage();
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.alert({msg: res['msg']}, function () {
                    //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) kcZspdEdit.closePage();
                    // });
                    break;
            }
        }
    })
};
//删除
kcZspdEdit.delData = function (data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('kc_bpzspd', 'delete')) return false;
    if (!Auth.qfmd({ 'key': 'delete', 'md_id': kcZspdEdit.getData.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'delete', 'zdr_id': kcZspdEdit.getData.dj.zdr_id })) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveBpzspdInfo,
        data: { status: 'delete', scr_id: fun.getItem('user_info')['id'], dj_id: data['id'][0], __post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            // console.log(data);
            switch (res['status']) {
                case 0:
                    fun.toast('删除成功。');
                    // kcZspdEdit.closePage();
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });

                    setTimeout(function () {
                        fun.useBack();
                        api.closeToWin({ name: page_arr.kc_zspd });
                    }, 200);
                    break;
                case 'WDYJE_LESS_BCDY':
                    fun.toast('超出了订金，无法删除单据。');
                    break;
                case 'IS_NOT_FIND':
                    fun.toast(res['msg']);
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
            fun.hideLoad();
        }
    })
};
//审核
kcZspdEdit.audit = function (data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('kc_bpzspd', 'check')) return false;
    if (!Auth.qfmd({ 'key': 'check', 'md_id': kcZspdEdit.getData.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'check', 'zdr_id': kcZspdEdit.getData.dj.zdr_id })) return false;
    fun.ajax({
        url: AJAX_URL.saveBpzspdInfo,
        data: { status: 'audit', shr_id: fun.getItem('user_info')['id'], dj_id: data['id'][0], __post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('审核成功。');
                    kcZspdEdit.closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'][0];
                    fun.toast('条码' + list['tm'] + '和库存信息不一致');
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_NOT_FIND':
                    fun.toast(res['msg']);
                    // fun.alert({msg: res['msg']}, function () {
                    //     kcZspdEdit.closePage();
                    // });
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.alert({msg: res['msg']}, function () {
                    //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) kcZspdEdit.closePage();
                    // });
                    break;
            }
            fun.hideLoad();
        }
    })
};
//作废
kcZspdEdit.obsolete = function (data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('kc_bpzspd', 'invalid')) return false;
    if (!Auth.qfmd({ 'key': 'invalid', 'md_id': kcZspdEdit.getData.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'invalid', 'zdr_id': kcZspdEdit.getData.dj.zdr_id })) return false;
    fun.ajax({
        url: AJAX_URL.saveBpzspdInfo,
        data: {
            status: 'cancel',
            zfr_id: fun.getItem('user_info')['id'],
            dj_id: data['id'][0],
            zf_yy: '', // 作废原因
            scxd: (data.index == 0) ? 1 : 0, // 生成新单
            __post_sign: Bills['__post_sign']
        },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            // if(data.index == 0){
            //   if (res['status'] == 0) {
            //     fun.toast('作废成功！');
            //     kcZspdEdit.closePage();
            //   }else{
            //     fun.toast(res['msg']);
            //   }
            // }else{
            switch (res['status']) {
                case 0:
                    fun.toast('作废成功!');
                    if (data.index == 0) {
                        page_data.id = res['data']['dj_id'];
                        kcZspdEdit.id = res['data']['dj_id'];
                    }
                    kcZspdEdit.closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'][0];
                    var msg = '条码' + list['tm'] + '和库存信息不一致';
                    fun.toast(msg);
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_JS':
                    fun.toast('单据已被结算过，无法作废。');
                    break;
                case 'WDYJE_LESS_BCDY':
                    fun.toast('超出了订金，无法作废单据。');
                    break;
                case 'IS_NOT_FIND':
                    fun.toast(res['msg']);
                    // fun.alert({msg:res['msg']}, function () {
                    //     kcZspdEdit.closePage();
                    // });
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.alert({msg: res['msg']}, function () {
                    //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) kcZspdEdit.closePage();
                    // });
                    break;
            }
            // }
            fun.hideLoad();
        }
    })
};
// 反审核
kcZspdEdit.revocatory = function (id) {
    if ($.nui.isEmpty(id)) return fun.toast('无单据id');
    if (!Auth.check('kc_bpzspd', 'check')) return false;
    if (!Auth.qfmd({ 'key': 'check', 'md_id': kcZspdEdit.getData.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'check', 'zdr_id': kcZspdEdit.getData.dj.zdr_id })) return false;
    fun.ajax({
        url: AJAX_URL.saveBpzspdInfo,
        data: {
            status: 'dbaudit',
            fhr_id: fun.getItem('user_info')['id'],
            dj_id: [id],
            is_fh: 0, // 生成新单
            __post_sign: Bills['__post_sign']
        },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('取消审核成功。');
                    kcZspdEdit.closePage();
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
            fun.hideLoad();
        }
    })
};

//关闭当前窗口
kcZspdEdit.closePage = function () {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh'
        }
    });
    api.sendEvent({
        name: html_name,
        extra: {
            'status': 'refresh_dj'
        }
    });
    // setTimeout(function () {
    //     api.closeToWin({name: page_arr.kc_zspd});
    // }, 200);
};
//返回事件
kcZspdEdit.isDataChange = function () {
    // 已审核的跳过
    if (kcZspdEdit.getData.dj.is_sh) {
        // api.sendEvent({
        //     name: page_arr.kc_zspd,
        //     extra: {
        //         'status': 'refresh',
        //     }
        // });
        fun.useBack();
        api.closeToWin({ name: page_arr.kc_zspd });
        return;
    }

    if (kcZspdEdit.checkDataChange()) {
        if ($('body').find('.data-change-skin').length) return;

        // 新单时，如果数据需要保存的记录行数据为0，并且没有填写单据信息，没有删除过行记录
        if ($.nui.isEmpty(page_data.id) && kcZspdEdit.getData.jl.length === 0 && kcZspdEdit.deleteRows.length === 0 && !kcZspdEdit.isDjDataChange() && !kcZspdEdit.isDeleteRows) {
            // api.sendEvent({
            //     name: page_arr.kc_zspd,
            //     extra: {
            //         'status': 'refresh',
            //     }
            // });
            fun.useBack();
            api.closeToWin({ name: page_arr.kc_zspd });
            return false;
        }

        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                kcZspdEdit.saveData();
            },
            no: function () {
                // api.sendEvent({
                //     name: page_arr.kc_zspd,
                //     extra: {
                //         'status': 'refresh',
                //     }
                // });
                fun.useBack();
                api.closeToWin({ name: page_arr.kc_zspd });
            }
        });
    } else {
        // api.sendEvent({
        //     name: page_arr.kc_zspd,
        //     extra: {
        //         'status': 'refresh',
        //     }
        // });
        fun.useBack();
        api.closeToWin({ name: page_arr.kc_zspd });
    }
};

// 检查单据是否修改
kcZspdEdit.isDjDataChange = function () {
    return kcZspdEdit.origin_data.dj.bz !== kcZspdEdit.getData.dj.bz || kcZspdEdit.origin_data.dj.kdsj !== kcZspdEdit.getData.dj.kdsj;
};

// 检查数据是否修改
kcZspdEdit.checkDataChange = function () {
    kcZspdEdit.save_data = kcZspdEdit.getSaveData();
    var tmpSaveData = JSON.parse(JSON.stringify(kcZspdEdit.save_data));
    for (var i = 0; i < tmpSaveData.jl.length; i++) {
        delete tmpSaveData.jl[i].__index;
        delete tmpSaveData.jl[i].__uuid;
    }

    var tmpOriginData = JSON.parse(JSON.stringify(kcZspdEdit.origin_data));

    for (var i = 0; i < tmpOriginData.jl.length; i++) {
        delete tmpOriginData.jl[i].__index;
        delete tmpOriginData.jl[i].__uuid;
    }


    console.log(JSON.stringify(tmpOriginData));
    console.log(JSON.stringify(tmpSaveData));
    return !$.nui.isObjEquals(tmpOriginData, tmpSaveData);
};

/**
 * 按钮
 */
// 先解除bill.js的同名绑定事件
$('body').off('tap', '#del_btn');
//删除
$('body').on('tap', '#del_btn', function (e) {
    e.stopPropagation();
    if (kcZspdEdit.checkDataChange()) {
        return fun.toast('单据已修改，未保存，不能删除！');
    }
    fun.dialog({
        content: '您确定要删除当前单据吗？',
        btn: ['删除', '取消'],
        yes: function () {
            kcZspdEdit.delData({ id: [kcZspdEdit.id] });
        }
    });
});
//审核
$('body').on('tap', '.audit', function (e) {
    e.stopPropagation();
    if (kcZspdEdit.checkDataChange()) {
        return fun.toast('单据已修改，未保存，不能审核！');
    }
    fun.dialog({
        content: '您确定要审核当前单据吗？',
        btn: ['确定', '取消'],
        yes: function () {
            kcZspdEdit.audit({ id: [kcZspdEdit.id] });
        }
    });
});
//取消审核
$('body').on('tap', '.revocatory', function (e) {
    e.stopPropagation();
    fun.dialog({
        content: '您确定要取消当前单据的审核状态吗？',
        btn: ['确定', '取消'],
        yes: function () {
            kcZspdEdit.revocatory(kcZspdEdit.id);
        }
    });
});
//作废
$('body').on('tap', '.obsolete', function (e) {
    e.stopPropagation();
    if (kcZspdEdit.checkDataChange()) {
        return fun.toast('单据已修改，未保存，不能作废！');
    }

    fun.dialog({
        content: '您确定要作废当前单据吗？',
        btn: ['重新做单', '直接作废', '取消'],
        yes: function (datas) {
            kcZspdEdit.obsolete({ id: [kcZspdEdit.id], index: datas['index'] });
        },
        no: function (datas) {
            kcZspdEdit.obsolete({ id: [kcZspdEdit.id], index: datas['index'] });
        },
    });
});

//保存
$('body').delay('tap', '.saves', function (e) {
    e.preventDefault();
    kcZspdEdit.saveData();
});

//当前页面处于编辑状态下，点击才有效
$('body').on('tap', '.store-content', function (e) {
    // 单据已经审核
    if (kcZspdEdit.getData.dj.is_sh || !AUTH_EDIT) {
        e.preventDefault();
        return false;
    }
    var data = $(this).data('list');

    const index = kcZspdEdit.findIndex(function (item) {
        return item.__uuid === data.__uuid;
    });

    var data_list = kcZspdEdit.getData.jl[index];
    fun.pd({
        content: {
            kcp: data_list['ps'] || 0,
            pdp: data_list['ps_pd'] || 0,
            kcs: data_list['zsl'] || 0,
            pds: data_list['sl_pd'] || 0,
            cb: data_list['cbj'] || 0,
            je: (fun.is_value(data_list['sl_yk'], 0) * fun.is_value(data_list['cbj'], 0)).fixed()
        },
        yes: function (data) {
            data_list['ps'] = data.kcp || 0;
            data_list['ps_pd'] = data.pdp || 0;
            data_list['zsl'] = data.kcs || 0;
            data_list['sl_pd'] = data.pds || 0;
            data_list['cbj'] = data.cb || 0;
            data_list['je'] = data.je || 0;

            // 重新显示数据
            kcZspdEdit.showData2(kcZspdEdit.convertData(kcZspdEdit.getData.jl));
            kcZspdEdit.dataChangeShowSaveBtn(); // 总数盘点弹窗确定检查数据有没有修改,有的话显示保存按钮
        }
    })
})

// 格式化添加时需要显示的库存数据, // 如果当前用户没有【允许查看布匹成本价】的浏览权限，不加载成本数据
kcZspdEdit.initData = function () {
    if (Auth.check('yxckbpcbj', 'view')) {
        // 	读取对应仓库、产品、颜色、单位的成本赋值给：成本字段
        // 批量获取单价处理
        __getJlData = function () {
            // 处理定价单位id
            for (var i = 0; i < kcZspdEdit.getData.jl.length; i++) {
                kcZspdEdit.getData.jl[i]['jjdw_id'] = kcZspdEdit.getData.jl[i]['dw_id'];
            }
            return kcZspdEdit.getData.jl;
        };

        // 更新成本价
        __updateJlDataByIndex = function (item) {
            kcZspdEdit.getData.jl[item.index]['cbj'] = item.data.dj;
        };

        // 获取成本价
        __getAllDj({
            get_dj: true, callback: function () {
                kcZspdEdit.initShowDataWhenAdd();
            }
        });
    } else {
        kcZspdEdit.initShowDataWhenAdd();
    }
};
// 新增时初始化显示数据
kcZspdEdit.initShowDataWhenAdd = function () {
    for (var i = 0; i < kcZspdEdit.getData.jl.length; i++) {
        // 盘点匹、盘点数赋值为0，总数量字段转换
        kcZspdEdit.getData.jl[i] = $.extend({
            ps_pd: 0,
            sl_pd: 0,
            bz: '',
            is_delete: 0
        }, kcZspdEdit.getData.jl[i]);
    }

    kcZspdEdit.showData2(kcZspdEdit.convertData(kcZspdEdit.getData.jl));
    kcZspdEdit.dataChangeShowSaveBtn();
};

// 初始化时间选择控件
kcZspdEdit.initTimePicker = function () {
    //时间控件
    kcZspdEdit.begin_lCalendar.init({
        'trigger': '#kdsj',
        'type': 'datetime',
        'callback': function (date) {
            $('#kdsj').text(fun.formatDate(date));
            kcZspdEdit.dataChangeShowSaveBtn();
        }
    });
};
// 事件初始化
kcZspdEdit.initOperationEvent = function () {
    // 删除记录行
    $('body').off('touchend', '.delete-btn').on('touchend', '.delete-btn', function (e) {
        e.preventDefault();
        if (!AUTH_EDIT) return;
        var data = $(this).data('list');
        fun.dialog({
            content: '你确定要删除当前记录吗？',
            btn: ['删除', '取消'],
            yes: function () {
                const index = kcZspdEdit.findIndex(function (item) {
                    return item.__uuid === data.__uuid;
                });

                var delArr = kcZspdEdit.getData.jl.splice(index, 1);
                kcZspdEdit.rowDeleteHandler(delArr[0]);
                kcZspdEdit.initShowDataWhenAdd(page_data);
                kcZspdEdit.showSaveBtn();
            }
        });
    });
    // 添加，跳转到调库存页面
    $('body').off('click', '.icon-tianjia,.choice').on('click', '.icon-tianjia,.choice', function (e) {
        fun.showPageFull({
            page_url: page_arr.detailed_stock2,
            pageParam: {
                djlx: 'kc_bpzspd',
                goto_page: page_arr.kc_zspd_edit,
                __IS_NEW: false,
                __JL_DATA: kcZspdEdit.getData.jl
            }
        });
    });
};

/**
 * 根据id，检查删除的行记录是否需要上传后台
 * @param row 行记录
 * @param key 查询的主键，默认是id
 */
kcZspdEdit.rowDeleteHandler = function (row, key) {
    kcZspdEdit.isDeleteRows = true;

    if ($.nui.isEmpty(key)) {
        key = 'id';
    }
    if (row && $.nui.isTrue(row[key])) {
        row.is_delete = 1;
        if (row.mx && row.mx.length) { // 明细记录也设置删除状态
            for (var i = 0; i < row.mx.length; i++) {
                row.mx[i].is_delete = 1;
            }
        }

        kcZspdEdit.deleteRows.push(row);
    }
};

// 添加新行处理事件
kcZspdEdit.addKcListener = function (ret, err) {
    console.log(ret)
    if (ret && ret.value) {
        var tmp_data = ret.value;

        switch (tmp_data['status']) {
            case 'fhjs_dkc':
                kcZspdEdit.getData.jl = kcZspdEdit.getData.jl.concat(ret.value.data.list);
                // 重新初始化显示数据
                kcZspdEdit.initData();
                kcZspdEdit.dataChangeShowSaveBtn();
                break;
            case 'refresh_dj':
                init();
                break;
        }
    }
};

kcZspdEdit.findIndex = function (callback) {
    for (var i = 0; i < kcZspdEdit.getData.jl.length; i++) {
        if (callback(kcZspdEdit.getData.jl[i])) {
            return i;
        }
    }
    return -1;
};

var overscroll = function (el) {
    el.addEventListener('touchstart', function () {
        var top = el.scrollTop;
        var totalScroll = el.scrollHeight;
        var currentScroll = top + el.offsetHeight;
        if (top === 0) {
            el.scrollTop = 1;
        } else if (currentScroll === totalScroll) {
            el.scrollTop = top - 1;
        }
    });
    el.addEventListener('touchmove', function (evt) {
        if (el.offsetHeight < el.scrollHeight) {
            evt._isScroller = true;
        }
    });
}

function preventDefault(e) {
    // e.preventDefault(); //阻止默认的处理方式(阻止下拉滑动的效果)
    if (!e._isScroller) {
        e.preventDefault();
    }
}

// 显示保存按钮
kcZspdEdit.showSaveBtn = function () {
    console.log('我触发了');

    if ($('.audit:visible').length) {
        $('.audit').hide();
    }
    if ($('.saves:visible').length || kcZspdEdit.getData.dj.is_sh) return;
    $('.saves').show();
}

// 数据发生改变显示保存按钮
kcZspdEdit.dataChangeShowSaveBtn = function () {
    if (kcZspdEdit.checkDataChange()) kcZspdEdit.showSaveBtn();
}

// // 根据返回状态检测数据判断显示保存按钮
// kcZspdEdit.checkStatusShowSaveBtn = function (status) {
//     var statusArr = [ // 返回状态数组
//         'update_rows',
//         'select_list',
//         'close_win'
//     ];
//     if (statusArr.indexOf(status) > -1) kcZspdEdit.dataChangeShowSaveBtn();
// }

// input输入框绑定事件
kcZspdEdit.inputBindEvent = function () {
    // 未审核数据改变显示保存按钮
    $('body').off('input propertychange', ':input').on('input propertychange', ':input', fun.throttle(kcZspdEdit.showSaveBtn, 200));
}