$('#header').header({
    back:true,
    title:'修改密码'
});

fun.keyboardEject('.sub');
$('#old_pwd').focus();

$('#save_btn').on('tap',function(){
    var old_pwd = $('#old_pwd').val(),
        new_pwd = $('#new_pwd').val(),
        confirm_pwd = $('#confirm_pwd').val();
        if(old_pwd.length == 0){
            return fun.toast('旧密码不能为空。');
        }else if(new_pwd.length == 0){
            return fun.toast('新密码不能为空。');
        }else if(confirm_pwd.length == 0){
            return fun.toast('确认密码不能为空。');
        }else if(new_pwd != confirm_pwd){
            return fun.toast('新密码不一致。');
        }
        getdata({
            "old_pwd":old_pwd,
            "pwd":new_pwd
        });
})

function getdata(opt){
    fun.ajax({
		showLoad:true,
		hideLoad:true,
		url:AJAX_URL.saveAccount,
		data:$.extend({},{
            "id":(fun.getItem('account_info')['account_id'] || 0),
            "type":"pwd",
            "old_pwd":"",
            "pwd":""
        },(opt || {})),
		success:function(res){
            switch(res['status']){
                case 0:
                        fun.toast('修改成功。'); 
                        setTimeout(function(){
                            api.closeWin();
                        },1000)
                    break;
                case 104:
                        fun.toast('旧密码错误。');
                    break;
            }
		}
	})
}