var html_name = page_arr.monthly_statement,
    overall_year, overall_month,
    makeBill;
$('#header').header({
    back: true,
    title: '月结',
    add: true
});
page_init = function () {
    getList();

}

//获取数据
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getYueJieInfo,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    if (!res['data'] || res['data'].length == 0) {
                        // $('#tj1').text(0);
                        getKzList();
                        // return $('.monthly_statement-top').html('<p class="empty_text">暂无数据！</p>');
                        return fun.createDataEmptyTips({dom:'.monthly_statement-top',btnShow:false,style:'top:0;height:10rem;'});
                    }
                    $('.monthly_statement-top').empty();
                    var data = res['data'];
                    setList(data);
                    break;
            }
        }
    })
}

//加载
function setList(data) {
    var html = [];
    html.push('<ul>');
    for (var i = data.length - 1; i >= 0; i--) {
        var colour = order_color[i % order_color.length];
        var month1 = data[i]['month'];
        var month2;
        month2 = Number(month1) > 9 ? month1 : '0' + month1;
        html.push(' <li class="lower-border-line">');
        html.push('     <div class="monthly_statement-list">');
        html.push('         <div class="dot" style="background:' + colour + '"></div>');
        html.push('         <p>' + data[i]['year'] + '-' + month2 + '</p>');
        html.push('         <span>' + data[i]['czy_mc'] + '</span>');
        html.push('         <span>' + data[i]['save_time'] + '</span>');
        html.push(data[i]['remark'] ? '         <p class="remark">' + data[i]['remark'] + '</p>' : '');
        html.push('     </div>');
        if (i == data.length - 1) {
            html.push('<div id="fyj" class="fyj" data-list=\'' + fun.formatString(JSON.stringify(data[i])) + '\'><button>反月结</button></div>');
        }
        html.push(' </li>');
    }
    html.push('</ul>');
    $('.monthly_statement-top').html(html.join(''));
}

//添加月结
$('body').on('tap', '#add_btn', function () {
    if ($('.bill_add').length) return;
    bill_add();
})

function bill_add() {
    var list = $('#fyj').data('list');
    overall_year = list ? list['year'] : '';
    overall_month = list ? list['month'] : '';
    var html = [];
    html.push('<div class="bill_add-body">');
    html.push(' <p>月结</p>')
    html.push(' <div>');
    html.push('     <span>日期</span>');
    if (overall_year != '' && overall_month != '') {
        if (overall_month == 12) {
            overall_year = Number(overall_year) + 1;
            overall_month = 1;
        } else if (overall_month >= 9 && overall_month < 12) {
            overall_month = Number(overall_month) + 1;
        } else if (overall_month < 9) {
            overall_month = '0' + (Number(overall_month) + 1);
        }
        overall_month = toTwo(overall_month);
        html.push('     <input id="rq" readonly="readonly" value="' + overall_year + '-' + overall_month + '">');
    } else {
        // overall_year=new Date().getFullYear();
        // overall_month=new Date().getMonth();
        // if(overall_month==0){
        //     overall_year=overall_year-1;
        //     overall_month=12;
        // }
        var make_split = makeBill.split('-');
        // console.log(make_split);
        overall_year = make_split[0];
        overall_month = make_split[1];
        overall_month = toTwo(overall_month);
        html.push('     <input id="rq" readonly="readonly" value="' + overall_year + '-' + overall_month + '">');
    }

    html.push(' </div>');
    html.push(' <div>');
    html.push('     <span>备注</span>');
    html.push('     <input id="bz" value="">');
    html.push(' </div>');
    html.push('</div>');
    fun.dialog({
        style: 'width: 15rem; height: 10rem; border:none; border-radius: 0.5rem;',
        className: 'bill_add',
        content: html.join(''),
        yes: function () {
            //月结
            if (makeBill != undefined) {
                var make_date = fun.dateFormat("yyyy-MM", makeBill);//开账日期
                var month_date = fun.dateFormat("yyyy-MM", $('#rq').val().trim());//月结日期
                if (month_date < make_date) return fun.toast('开账日期：' + make_date + '不能小于月结日期：' + month_date);
            }

            var data;
            var date_rq = $('#rq').val().split('-');
            var bill_year = date_rq[0];
            var bill_month = date_rq[1];
            bill_month = Number(bill_month) < 10 ? (date_rq[1]).slice(1) : date_rq[1];
            bill_month = toTwo(bill_month);
            data = {
                year: bill_year,
                month: bill_month,
                remark: $('#bz').val() || '',
                czy_id: fun.getItem('user_info')['id'],
                type: 'yj',
            };
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.saveYueJieInfo,
                data: data,
                success: function (res) {
                    switch (res['status']) {
                        case 0:
                            fun.toast('月结成功');
                            fun.load_DATA_LIST(['sys_config']);
                            getList();
                            break;
                        case 'IS_NOT_SH':
                            var data = res['data'];
                            fun.showPageFull({
                                page_url: page_arr.monthly_wsh,
                                pageParam: {
                                    return_page: html_name,
                                    data: data
                                }
                            })
                            break;
                        default:
                            fun.toast(res['msg']);
                            fun.load_DATA_LIST(['sys_config']);
                            getList();
                            break;
                    }
                }
            })
        },
        success: function () {
            //时间控件
            new lCalendar().init({
                'trigger': '#rq',
                'type': 'date_month',
                'callback': function (date) {
                    var year = date.split('-')[0];
                    var month = date.split('-')[1];
                    month = toTwo(month);
                    $('#rq').val(year + '-' + month);
                }
            });
        }
    })
}

//反月结
$('body').on('tap', '#fyj', function () {
    var data_list = $(this).data('list');
    fun.dialog({
        content: '你确定要反月结：【' + data_list['year'] + '年' + data_list['month'] + '月】吗？',
        btn: ['确定', '取消'],
        yes: function () {
            fyj(data_list);
        }
    });
})

function fyj(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveYueJieInfo,
        data: {
            id: data['id'],
            year: data['year'],
            month: data['month'],
            czy_id: data['czy_id'],
            remark: data['remark'],
            type: 'fyj',
        },
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.toast('反月结成功');
                    fun.load_DATA_LIST(['sys_config']);
                    getList();
                    break;
                case 'IS_FYJ':
                    fun.toast(res['msg']);
                    fun.load_DATA_LIST(['sys_config']);
                    getList();
                    break;
                default:
                    fun.toast(res['msg']);
                    fun.load_DATA_LIST(['sys_config']);
                    getList();
                    break;
            }
        }
    })
}


/**获取开账信息*/
function getKzList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMakeBillsInfo,
        data: {},
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.load_DATA_LIST(['sys_config']);
                    if (!$.nui.isEmpty(res['data']['kzxx'])) {
                        console.log(res);
                        makeBill = res['data']['kzrq'];
                    }
                    break;
            }
        }
    })
}

// 转换；两位数
function toTwo (val) {
    return Number(val) < 10? ('0'+ val) : val;
}