var html_name = page_arr.more_set;

var is_wx;
var logout = {};

// 退出解绑机关推送
logout.unBindJg = function (options) {
    options = options || {};
    $.ajax({
        type: "POST",
        url: AJAX_URL.setBind,
        data: {
            data: fun.getSetBindAjaxData()
        },
        success: function (res) {
            if (res.status === 0) {
                if (typeof options.callBack === 'function') {
                    options.callBack();
                }
            } else {
                fun.toast(res.msg);
                if (typeof options.callBack === 'function') {
                    options.callBack();
                }
            }
        },
        error: function (err) {
            console.log(err);
            if (typeof options.callBack === 'function') {
                options.callBack();
            }
        }
    });
}

/******头部显示******/
$("#header").header({
    back: true,
    title: '更多设置',
    appendBackBtnEvt: function () {
        api.sendEvent({
            name: page_data['return_page'] || '',
            extra: {
                status: 'personalCard'
            }
        })
        api.closeWin();
    }
});

var LOGIN_INFO = fun.getItem('login_info') || {};

page_init = function () {
    // if($.nui.isTrue(LOGIN_INFO) && $.nui.isEmpty(LOGIN_INFO['is_site'])) ZDKZ_ZXLB = false;
    // $('.zxlb_opt').hide();
    //iphoneX适配
    $('.sub').css('padding-bottom', api.safeArea.bottom);

    if (!!Auth.check('czrz', 'view')) $('.czrz_opt').show();
    $('#qhzt').text((fun.getItem('book_name') || ""));//显示账套
    if (!AuthVersionCheck.checkHide('gjsz')) {
        $('.gjsz-info').show();
    }
    //切换账套显示隐藏
    var book_data = fun.getItem('account_set_data');
    if ($.nui.isTrue(book_data) && book_data.length == 1) {
        $('.set_book').hide();
    }
    if (!SHOW_WX) {
        $('.set_info.binding—wechat').hide();
    } else {
        $('.set_info.binding—wechat').show();
    }

    // //是否有在线列表浏览权限 且 是否是授权登录
    // if(ZDKZ_ZXLB && Auth.check('zxlb', 'view') && !LOGIN_INFO['is_temp']){
    //     $('.zxlb_opt').show();
    // }

    if(DBB_FIXED){
        $("[data-url='check_package']").show();
        $("[data-url='clear_package']").show();
    }else{
        $("[data-url='check_package']").hide();
        $("[data-url='clear_package']").hide();
    }

    // $('#dqbb').text(APP_VERSION + '（' + api.appVersion + '）');

    if (SHOW_WX) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.wxUser,
            data: {
                type: 'is_wx',
            },
            success: function (res) {
                console.log(JSON.stringify(res));
                is_wx = res.status
                if (is_wx !== 0) {
                    $('#is_wx').hide();
                } else {
                    $('#is_wx').css('display', 'inline-block');
                }
                // return fun.toast(res.msg);
            },
        });
    }

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temps = ret.value;
        console.log(ret);
        switch (temps['status']) {
            case 'refresh':
                fun.load_DATA_LIST(['sys_config'], function (res) {
                });
                break;

            case 'is_wx':
                is_wx = 0;
                $('#is_wx').css('display', 'inline-block');
                break;
        }
    });

    // fun.checkBaseVersion({
    //     callback: function(){
    //         $('#icon_new').show();
    //     }
    // });

}

$('body').on('click', '.set_info', function (e) {
    e.stopPropagation();
    var name = $(this).data('url');
    var url = '';
    switch (name) {
        case 'zhyaq':
            url = page_arr.set_zhyaq;
            break;
        case 'qhzt':
            //切换账套
            fun.getBookList(function (params) {
                getUserInfo(params);
                return true;
            }, { not_alert: false });
            break;
        case 'czrz':
            //操作日志
            url = page_arr.operation_log;
            break;
        case 'zxlb':
            //在线列表
            url = page_arr.online_list;
            break;
        case 'gjsz':
            //高级设置
            url = page_arr.set_gjsz;
            break;
        case 'about_software':
            url = page_arr.about_software;
            break;
        case 'dqbb':
            //当前版本
            // url = page_arr.version;
            // fun.upApp('V2.111','<ul><li>1.更新通知</li><li>2.请更新app</li><li>3.新版本更好用</li></ul>');
            // if($('#icon_new').is(':visible')){
            //     fun.checkBaseVersion({showTipsAlert:true});
            // }else{
            //     fun.toast('您使用的已是最新的版本。');
            // }
            return;
            break;
        case 'dysz':
            url = page_arr.printer_list;
            break;
        case 'jcsj':
            // if (api.systemType == "android") {
            //     api.download({
            //         // url : 'https://downloadpkg.app3c.cn/app/download?path=http://A6092659618839.qiniucdn.apicloud-system.com/35c38182f88b655b661fb258e590a0f8_d',
            //         url : 'https://downloadpkg.apicloud.com/app/download?path=http://A6092659618839.qiniucdn.apicloud-system.com/ca3f0a74aa8827682397f02f8e2dfa70.apk',
            //         report : true,
            //         savePath: 'fs://yunbuye/'+$.nui.getRandomNum()+'.apk'
            //     }, function(ret, err) {
            //         console.log(ret)
            //         if (ret && 0 == ret.state) {/* 下载进度 */
            //             fun.toast("正在下载应用" + ret.percent + "%",{duration: 1000});
            //         }
            //         if (ret && 1 == ret.state) {/* 下载完成 */
            //             fun.hideLoad();
            //             var savePath = ret.savePath;
            //             api.installApp({
            //                 appUri : savePath
            //             });
            //         }
            //     });
            // }

            // fun.upApp(api.appVersion,'<ul><li>1.更新通知</li><li>2.请更新app</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li><li>3.新版本更好用</li></ul>');

            // var UIActionProgress, value = 0;
            // UIActionProgress = api.require('UIActionProgress');

            // openUIActionProgress();

            // //打开模块
            // function openUIActionProgress() {
            //     UIActionProgress.open({
            //         maskBg: 'rgba(0,0,0,0.4)',
            //         styles: {
            //             h: 108,
            //             bg: '#fff',
            //             title: {
            //                 size: 14,
            //                 color: '#000',
            //                 marginT: 10
            //             },
            //             msg: {
            //                 size: 12,
            //                 color: '#666',
            //                 marginT: 5
            //             },
            //             lable: {
            //                 size: 12,
            //                 color: '#696969',
            //                 marginB: 5
            //             },
            //             progressBar: {
            //                 size: 4,
            //                 normal: '#ccc',
            //                 active: '#03a9f4',
            //                 marginB: 15,
            //                 margin: 5
            //             }
            //         },
            //         data: {
            //             title: '下载中...',
            //             msg: ' ',
            //             value: 0
            //         }
            //     }, function (ret) {
            //         if (ret.eventType == 'show') {
            //             api.download({
            //                 // url : 'https://downloadpkg.app3c.cn/app/download?path=http://A6092659618839.qiniucdn.apicloud-system.com/35c38182f88b655b661fb258e590a0f8_d',
            //                 url: 'https://downloadpkg.apicloud.com/app/download?path=http://A6092659618839.qiniucdn.apicloud-system.com/ca3f0a74aa8827682397f02f8e2dfa70.apk',
            //                 report: true,
            //                 savePath: 'fs://yunbuye/' + $.nui.getRandomNum() + '.apk'
            //             }, function (ret, err) {
            //                 if (ret && 0 == ret.state) {/* 下载进度 */
            //                     setData(ret.percent);
            //                 }
            //                 if (ret && 1 == ret.state) {/* 下载完成 */
            //                     UIActionProgress.setData({
            //                         data: {
            //                             title: '下载完成',
            //                             msg: ' ',
            //                             value: 100
            //                         }
            //                     });
            //                     //关闭进度条模块
            //                     closeUIActionProgress();
            //                     fun.hideLoad();
            //                     var savePath = ret.savePath;
            //                     api.installApp({
            //                         appUri: savePath
            //                     });
            //                 }
            //             });
            //         }
            //     });
            // };
            // //修改参数
            // function setData(value) {
            //     //修改进度条参数
            //     UIActionProgress.setData({
            //         data: {
            //             title: '下载中...',
            //             msg: ' ',
            //             value: value
            //         }
            //     });
            // };
            // //关闭模块
            // function closeUIActionProgress() {
            //     UIActionProgress.close();
            // };

            return;
            break;
        case 'modify_pwd':
            url = page_arr.modify_pwd;
            break;
        case 'replace_mobile':
            url = page_arr.replace_mobile;
            break;
        case 'make_bill':
            url = page_arr.make_bill;
            break;
        case 'check_package':
            DBB_FIXED && VersionManager.checkDownload({showTips: true,notSetTime: true});
            return;
            break;
        case 'clear_package':
            DBB_FIXED && VersionManager.removeAllPackage();
            return;
            break;
        case 'monthly_statement':
            url = page_arr.monthly_statement;

            fun.load_DATA_LIST(['sys_config'], function () {
                if (!fun.checkKz()) return;
                fun.showPageFull({
                    page_url: url,//产品类别编辑页面
                    pageParam: {
                        return_page: html_name,
                        // opt_type:'add',
                    }
                });
            });
            return;
            break;
    }
    if (!!url) {
        fun.showPageFull({
            page_url: url,//产品类别编辑页面
            pageParam: {
                return_page: html_name,
                // opt_type:'add',
            }
        });
    }
});

//获取用户信息
function getUserInfo(params) {
    if ($.nui.isEmpty(LOGIN_INFO)) {
        return;
    }
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getUserInfo,
        data: {
            type: 'login',
            account_id: LOGIN_INFO['account_id']
        },
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data']['mobile_auth']) {
                    fun.dialog({
                        content: "此账套没有手机端权限,请联系管理员开通权限！",
                        btn: ["确定"],
                        yes: function () {
                            fun.setBook(fun.getItem('old_book'));
                        }
                    });
                    return;
                }
                // fun.delAllItem(['theme_color', 'account_info', 'company_info','book_id','book_name','token','old_book']);
                fun.setItem('user_info', res['data']);
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getSysList,
                    data: {},
                    success: function (res) {
                        if (res['status'] == 0) {
                            fun.setItem('sys_config', res['data']);
                        }
                    }
                });
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getBillsNumList,
                    data: {},
                    success: function (res) {
                        if (res['status'] == 0) {
                            fun.setItem('dh_config', res['data']);
                        }
                    }
                });
                fun.load_DATA_LIST(['zh', 'ck', 'khh']);
                $('#qhzt').text((params['name'] || ""));
                api.sendEvent({
                    name: page_arr.index,
                    extra: { 'status': 'reload' }
                });
            }
        }
    });
}

//安全退出
$('#logout').on('tap', function (e) {
    // e.preventDefault();
    fun.dialog({
        content: '您确定退出登录吗？',
        btn: ['确定', '取消'],
        yes: function () {
            fun.showLoad('退出中...');
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.logout,
                data: {},
                success: function (res) {
                    if (res['status'] == 0) {
                        if (H5PAY) {
                            logout.unBindJg({
                                callBack: fun.logoutToLogin
                            })
                        } else {
                            fun.logoutToLogin();
                        }
                    } else {
                        fun.alert({
                            msg: res.msg,
                            callback: function () {
                                if(H5PAY){
                                    logout.unBindJg({
                                        callBack: fun.logoutToLogin
                                    })
                                }else{
                                    fun.logoutToLogin();
                                }
                            }
                        })
                    }
                },
                error: function () {
                    if(H5PAY){
                        logout.unBindJg({
                            callBack: fun.logoutToLogin
                        })
                    }else{
                        fun.logoutToLogin();
                    }
                }
            });

        }
    });
    return false;
})

$('.binding—wechat').on('click', function (e) {
    e.preventDefault();
    if (is_wx === 0) {
        fun.dialog({
            content: '你确定要解绑微信吗?',
            btn: ['确定', '取消'],
            yes: function () {
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.wxUser,
                    data: {
                        type: 'jb',
                        // code: ret.code,
                        login_type: 'app'
                    },
                    success: function (res) {
                        console.log(JSON.stringify(res));
                        if (res['status'] == 0) {
                            is_wx = 1;
                            $('#is_wx').hide();
                        }
                        return fun.toast(res.msg);
                    },
                    error: function (res) {

                    }
                });
            }
        });
    } else {
        // fun.dialog({
        //     content: '绑定微信?',
        //     btn: ['确定', '取消'],
        //     yes: function () {
        //         var wx = api.require('wxPlus');
        //         wx.auth({
        //             apiKey: '' //wx_appid  已从config获取
        //         }, function (ret, err) {
        //             console.log(ret);
        //             console.log(err);
        //             if (ret.status) { //成功登陆
        //                 fun.ajax({
        //                     showLoad: true,
        //                     hideLoad: true,
        //                     url: AJAX_URL.wxUser,
        //                     data: {
        //                         type: 'bd',
        //                         code: ret.code,
        //                         login_type: 'app'
        //                     },
        //                     success: function (res) {
        //                         console.log(JSON.stringify(res));
        //                         if (res['status'] == 0) {
        //                             is_wx = 0;
        //                             $('#is_wx').css('display', 'inline-block');
        //                         }
        //                         return fun.toast(res.msg);
        //                     },
        //                     error: function (res) {

        //                     }
        //                 });
        //             } else {
        //                 if (err.code == 1) {
        //                     return fun.toast('取消授权');
        //                 } else if (err.code == 2) {
        //                     return fun.toast('拒绝授权');
        //                 } else if (err.code == 3) {
        //                     return fun.toast('未安装微信');
        //                 }
        //             }
        //         });
        //     }
        // });
        fun.openFrame({
            setZero: true,
            bgColor: 'rgba(0, 0, 0, 0.5)',
            frame_url: page_arr.is_bdwx,
            hide_anima: true,
            pageParam: {
                page_name: html_name
            }
        })
        // fun.bdWXLoginTips({
        //     yes: function () {
        //         var wx = api.require('wxPlus');
        //         wx.auth({
        //             apiKey: '' //wx_appid  已从config获取
        //         }, function (ret, err) {
        //             console.log(ret);
        //             console.log(err);
        //             if (ret.status) { //成功登陆
        //                 fun.ajax({
        //                     showLoad: true,
        //                     hideLoad: true,
        //                     url: AJAX_URL.wxUser,
        //                     data: {
        //                         type: 'bd',
        //                         code: ret.code,
        //                         login_type: 'app'
        //                     },
        //                     success: function (res) {
        //                         console.log(JSON.stringify(res));
        //                         if (res['status'] == 0) {
        //                             is_wx = 0;
        //                             $('#is_wx').css('display', 'inline-block');
        //                         }
        //                         return fun.toast(res.msg);
        //                     },
        //                     error: function (res) {

        //                     }
        //                 });
        //             } else {
        //                 if (err.code == 1) {
        //                     return fun.toast('取消授权');
        //                 } else if (err.code == 2) {
        //                     return fun.toast('拒绝授权');
        //                 } else if (err.code == 3) {
        //                     return fun.toast('未安装微信');
        //                 }
        //             }
        //         });
        //     }
        // });
    }


    return false;
});
