var html_name = page_arr.personal_card;
var origin_data, save_data;
var photoBrowser = null; // 拍照
var is_add = false;


//初始化
page_init = function () {
    $('#header').header({
        back: true,
        title: '个人名片',
        // print: !AuthVersionCheck.checkHide('cpdy') ? true : false,
        share: !AuthVersionCheck.checkHide('xsdp') ? true : false,
        appendBackBtnEvt: isDataChange
    });
    if (!AuthVersionCheck.checkHide('xsdp')) {
        $('#mall,#mall_friend').show();
    }
    aiMethods(); //  当前用户有开通：AI商城功能 且 web商城设置有设置：AI商城的XX参数,则显示商城样式
    init();
    page_data['keyback'] = isDataChange; // 监听安卓返回键
    getList();
    fun.keyboardEject('#fz_cw');
}

function init() {
    $('.business-card').css({
        paddingTop: api.safeArea.top + $('#header').outerHeight() - parseFloat($('html').css('fontSize')),
    })

    //iphoneX适配
    $('.btn-bc').css('padding-bottom', api.safeArea.bottom);

    // $('#img').css('src', fun.getItem(''))
}


//返回
function isDataChange() {
    save_data = JSON.parse(JSON.stringify(getSaveData()));
    if ($.nui.isObjEquals(origin_data, save_data)) {
        api.closeWin();
    } else {
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData(true);
            },
            no: function () {
                api.closeWin();
            }
        });
    }
}

function getSaveData() {
    var data = {};
    data = {
        sj: $('#sj').val().trim() || '',
        xm: $('#xm').val().trim() || '',
        // wx: $('#wx').val().trim() || '',
        yx: $('#yx').val().trim() || '',
        img: $('#img').data('img') || '',
        imgCode: $('.img-code').data('img') || ''
    };

    return data;
}

function saveData(callback) {
    save_data = JSON.parse(JSON.stringify(getSaveData()));
    if (!($.nui.isObjEquals(origin_data, save_data))) {
        var data = getSaveData();
        if (data['xm'] == '') {
            return fun.toast('姓名不能为空！');
        } else if (data['sj'] == '') {
            return fun.toast('手机不能为空！');
        } else if ($.nui.isEmpty(data['imgCode']) || data['imgCode'] == '../img/null.png') {
            return fun.toast('微信二维码不能为空！');
        }
        var reg = /^[A-Za-z0-9\u4e00-\u9fa5]+@[a-zA-Z0-9_-]+(\.[a-zA-Z0-9_-]+)+$/;
        var save_data = {};
        if (reg.test(data['yx'])) {
            save_data = {
                "name": data['xm'],
                "mobile_phone": data['sj'],
                "email": data['yx'],
                "avatar_url": data['img'],
                "wechat_qr_code_url": data['imgCode']
            };
        } else if ($.nui.isTrue(data['yx'])) {
            return fun.toast('邮箱格式不正确！');
        } else {
            save_data = {
                "name": data['xm'],
                "mobile_phone": data['sj'],
                "avatar_url": data['img'],
                "wechat_qr_code_url": data['imgCode']
            };
        }
        $.ajax({
            type: "PUT",
            url: AJAX_URL.businessCards + '/' + fun.getItem('account_info')['account_id'] + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
            headers: {
                "X-Requested-With": "XMLHttpRequest",
                "Accept": "application/json"
            },
            data: save_data,
            success: function () {
                fun.toast('保存成功。');
                fun.setItem('hasBindWeChat', false);
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        status: 'my',
                        data: data,
                        imgs: $('#img').data('img')
                    }
                })
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        status: 'refresh',
                    }
                })
                if (typeof (callback) != 'function') {
                    setTimeout(function () {
                        api.closeWin();
                    }, 400);
                }
            }
        })
    } else {
        if (typeof (callback) != 'function') {
            setTimeout(function () {
                api.closeWin();
            }, 400);
        }
    }

    if (typeof (callback) === 'function') {
        var data = getSaveData();
        if (data['xm'] == '') {
            return fun.toast('姓名不能为空！');
        } else if (data['sj'] == '') {
            return fun.toast('手机不能为空！');
        } else if ($.nui.isEmpty(data['imgCode']) || data['imgCode'] == '../img/null.png') {
            return fun.toast('微信二维码不能为空！');
        }
        callback();
    }
}

function getList() {
    $.ajax({
        type: 'GET',
        url: AJAX_URL.businessCards + '/' + fun.getItem('account_info')['account_id'] + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        success: function (res) {
            showList(res)
        }
    })
}

function showList(res) {
    $('#xm').val(res['name'] || '');
    $('#sj').val(res['mobile_phone'] || '');
    // $('#wx').val(res['weixin'] || '');
    $('#yx').val(res['email'] || '');
    var imgSrc = res['avatar_url'] || '';
    var codeSrc = res['wechat_qr_code_url'] || '';

    var be = new RegExp(UPLOAD_IMG_PATH);
    if (/http/.test(codeSrc)) {
        if (be.test(codeSrc)) {
            $('.img-code').attr('src', codeSrc).data('img', codeSrc);
        } else {
            var interception = codeSrc.substring(codeSrc.lastIndexOf("/") + 1);
            $('.img-code').attr('src', fun.getImgPath(interception, true, { url: UPLOAD_IMG_PATH })).data('img', interception);
        }
    } else {
        $('.img-code').attr('src', fun.getImgPath(codeSrc, true, { url: UPLOAD_IMG_PATH })).data('img', codeSrc);
    }

    if (fun.getItem('hasBindWeChat')) { // 绑定微信
        $('#img').attr('src', fun.getItem('wx_headimg_url'));
    } else { // 拿个人名片修改图片
        if (/http/.test(imgSrc)) {
            if (be.test(imgSrc)) {
                $('#img').attr('src', imgSrc).data('img', imgSrc);
            } else {
                var intercep = imgSrc.substring(imgSrc.lastIndexOf("/") + 1);
                $('#img').attr('src', fun.getImgPath(intercep, true, { url: UPLOAD_IMG_PATH })).data('img', intercep);
            }
        } else {
            $('#img').attr('src', fun.getImgPath(imgSrc, true, { url: UPLOAD_IMG_PATH })).data('img', imgSrc);
        }
    }

    origin_data = JSON.parse(JSON.stringify(getSaveData()));

}

function imgAdd(data) {
    fun.showLoad();

    var fileData = {
        data: data,
        index: 0
    };

    fun.fileUpload(fileData, function (imgName) {
        var imgUrl = fun.is_value(data.data);
        if (is_add) {
            var imgItem = [];
            imgItem.push('<img class="img-code" src="' + imgUrl + '" data-img="' + imgName + '">');
            $('.img-box').html(imgItem.join(''));
            is_add = false;
        } else {
            var imgItemNode = [];
            imgItemNode.push('<div>');
            imgItemNode.push('     <img src="' + imgUrl + '" id="img" data-img="' + imgName + '">');
            imgItemNode.push('     <i class="iconfont icon-camera camera"></i>');
            imgItemNode.push('</div>');
            $('.card-img').html(imgItemNode.join(''));
        }
        $('#openCamera,.box').hide();
    });
}

//查看步骤
$('body').on('click', '.look', function () {
    fun.showPageFull({
        page_url: page_arr.wechat_code,
    })
})

//点击添加图片
$('body').on('click', '.img-code', function (e) {
    e.preventDefault();
    is_add = true;
    $('#openCamera,.box').show();
})

// //打印
// $('body').on('tap', '#print_btn', function (e) {
//     e.stopPropagation();
//     saveData(false);
// })

//分享按钮
$('body').on('tap', '#share_btn', function (e) {
    e.stopPropagation();

    if ($('.collapse-wrap').hasClass('open')) {
        $('.collapse-wrap').removeClass('open');
    } else {
        $('.collapse-wrap').addClass('open');
    }
    // saveData(false);
    // fun.showPageFull({
    //     page_url:page_arr.business_cards,
    //     pageParam: {
    //         'type': 'shop'
    //     }
    // })
    // $('.collapse-wrap').removeClass('open');
});

//点击其他区域，关闭分享
$('body').on('tap', function (e) {
    $('.collapse-wrap').removeClass('open');
});

//分享店铺+好友样式
$('body').on('tap', '#mall_friend,#shop_friend', function (e) {
    var _this = $(this);
    e.stopPropagation();
    saveData(function () {
        fun.showPageFull({
            page_url: page_arr.business_cards,
            pageParam: {
                type: _this.data('type'),
                details: 'friend'
            }
        })
        $('.collapse-wrap').removeClass('open');
    });
})

//分享店铺样式
$('body').on('tap', '#mall,#shop', function (e) {
    var _this = $(this);
    e.stopPropagation();
    saveData(function () {
        fun.showPageFull({
            page_url: page_arr.business_cards,
            pageParam: {
                type: _this.data('type'),
                details: 'mall_shop'
            }
        })
        $('.collapse-wrap').removeClass('open');
    });
})

// 拍照
$('#paizhao').on('click', function () {
    $('#openCamera,.box').hide();
    QuestPermission.requestPermission('camera', null, function () {
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 50,   //图片质量
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if (ret.data) {
                    imgAdd(ret);
                }
            } else {
            }
        });
    });

});

//相册
$('#selectPhoto').off('tap').on('tap', function () {
    $('#openCamera,.box').hide();
    QuestPermission.requestPermission('camera', null, function () {
        api.getPicture({
            sourceType: 'album',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: false,
            quality: 50,   //图片质量
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if (ret.data) {
                    imgAdd(ret);
                }
            } else {
            }
        });
    });

})

//显示拍照/相册/取消
$('body').delegate('#img,.camera', 'tap', function (e) {
    e.preventDefault();
    $('#openCamera,.box').show();
})

//取消
$('#cancelPhoto').on('tap', function (e) {
    e.preventDefault();
    $('#openCamera,.box').hide();
});

//保存
$('#bc').on('tap', function (e) {
    e.preventDefault();
    saveData(true);
})

//请求web商城设置有设置：AI商城的XX参数
function aiMethods() {
    $.ajax({
        type: "GET",
        url: AJAX_URL.companies + '/' + fun.getItem('company_info')['company_id'] + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        success: function (res) {
            if (!AuthVersionCheck.checkHide('aisc') && $.nui.isTrue(res['company']['wechat_setting']['miniprogram_app_id']) && $.nui.isTrue(res['company']['wechat_setting']['miniprogram_app_secret'])) {
                $('#header').header({
                    back: true,
                    title: '个人名片',
                    // print: !AuthVersionCheck.checkHide('cpdy') ? true : false,
                    share: true,
                    appendBackBtnEvt: isDataChange
                });
                $('#shop,#shop_friend').show();
            }
        }
    })
}

/*
    1. 一开始没绑定，刚登录app，个人名片拿什么头像:拿默认的图片
    2. 如果解绑，再重新绑定，那么默认拿最新的那张，
    3. 如果绑定了，进去页面重新更换保存，那么拿最新的那张
*/