var html_name = page_arr.shop_product_qtcs;
var params_data = [];
var AUTH_EDIT;
AUTH_EDIT = Auth.check('cp', 'edit');

$("#header").header({
    back: true,
    title: "其他参数",
    add: AUTH_EDIT,
    appendBackBtnEvt: function () {
        paramData();
        console.log(JSON.stringify(params_data));
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'cpzl_data',
                'page_type': 'qtcs',
                'list': params_data,//列表数据
            }
        });
        api.closeWin();
    }
})

page_init = function () {

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'] || {};
        var data = temp['data'] || {};
        params_data = temp['params_data'] || {};
        switch (temp['status']) {
            case 'select_list':
                switch (data['page_type']) {
                    case 'params':
                        $('.content').empty();
                        getList(params_data);
                        break;
                    case 'params_opt':
                        for (var i = 0; i < params_data.length; i++) {
                            if (params_data[i]['param_id'] == data['list_data']['param_id']) {
                                params_data[i]['value'] = data['list_data']['name'];
                            }
                        }
                        $('.content').empty();
                        getList(params_data)
                        break;
                }
                break;
            case 'update':
                // console.log('update',params_data)
                // if ($.nui.isEmpty(temp['select_val'])) return;
                // if ('sort' in temp) {
                //     params_data[temp['sort']]['value'] = temp['select_val']
                // }
                $('.content').empty();
                getList(params_data)
                break;
        }
        bindEvent();
    })

    var params_datas = page_data.list;
    getList(params_datas);
    bindEvent()
}

function getList(opt) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getParamOptions,
        data: {
            "type": "cp"
        },
        success: function (res) {

            if (res['status'] == 0) {
                var param_data = res['data']['param'];
                for (var i = 0; i < param_data.length; i++) {
                    for (var n = 0; n < opt.length; n++) {
                        if (param_data[i]['param_id'] == opt[n]['param_id']) {
                            param_data[i]['id'] = opt[n]['id'];
                            param_data[i]['value'] = opt[n]['value'] || '';
                            param_data[i]['name'] = opt[n]['name'] || '';
                        }
                    }
                }
                showList(param_data)
                //没有产品编辑权限
                if (!AUTH_EDIT) {
                    $('input').attr('disabled', true);
                    $('.params-list-icon').hide();
                }

            }
        }
    });

}

//渲染数据
function showList(data) {
    for (var i = 0; i < data.length; i++) {
        var html = [];
        html.push('<li class="data-list clearfix" data-index="' + i + '" data-list=\'' + JSON.stringify(data[i]) + '\'>');
        // html.push('     <span class="parameter color-gray">' + data[i]['name'] + '</span>');
        // html.push('     <input type="text" value="' + (data[i]['value'] || '') + '" class="parameter-info">');
        // html.push('     <i class="iconfont icon-xia params-list-icon"></i>');
        html.push('		<div class="le" data-list=\'' + JSON.stringify(data[i]) + '\' data-index="' + i + '">');
        html.push('			<div class="gy_name float-left" >' + data[i]['name'] + '</div>');
        html.push('			<div class="gy_text float-left" >' + (data[i]['value'] || '') + '</div>');
        html.push('         <div class="iconfont icon-fork params-list-icon float-left"></div>');
        html.push('		</div>');
        html.push('</li>');
        $('.content').append(html.join(''));
        if ($.nui.isEmpty(data[i]['value'])) {
            $('.params-list-icon').eq(i).hide()
        }
    }
    // paramData()
}

//获取记录行数据
function paramData() {
    params_data = []
    for (var i = 0; i < $('.data-list').length; i++) {
        var res = {
            'id': $('.data-list').eq(i).data('list').id || 0,
            'param_id': $('.data-list').eq(i).data('list').param_id,
            'name': $('.data-list').eq(i).data('list').name,
            'value': $('.data-list').eq(i).find('.gy_text').text(),
        }
        params_data.push(res)
    }
    console.log(params_data)
}

//事件的公用方法，事件统一写里面
function bindEvent() {
    //跳转参数的内容
    $('body').on('tap', '.gy_text', function () {
        var param_list = $(this).parents('.data-list').data("list");
        var sort = $(this).parent('.le').data('index');
        var select_valInput = $(this).text()
        var list_type = 'params_opt';
        paramData();
        fun.showPageFull({
            page_url: page_arr.select_list,
            pageParam: {
                'return_page': html_name,
                'page_type': list_type,
                'params_type': 'cp',
                'params_id': param_list.param_id,
                'params_name': param_list.name,
                'params_data': params_data,
                'sort': sort,
                'select_valInput': select_valInput, // 把当前记录行的值传过去，做判断，如果用户不做操作直接返回则拿原来的值
                'type': 'Other_Params'
            }
        });
    });

    //如果中间有值，则点击X时，消除里面的值
    $('body').on('tap', '.params-list-icon', function () {
        var index = $('.params-list-icon').index(this);
        $('.gy_text').eq(index).text('')
        $(this).hide();
    })

    //跳转参数id页
    $('body').on('tap', '#add_btn', function () {
        //添加自定义参数、添加自定义参数配置
        var add_type = 'params';
        paramData();
        fun.showPageFull({
            page_url: page_arr.select_list,
            pageParam: {
                'return_page': html_name,
                'page_type': add_type,
                'params_type': 'cp',
                'params_data': params_data,
            }
        });
    })
}
