var html_name = page_arr.quick_toolbar;
var window_data = [];
// var gjlHtml = [];
// var ckdata = [];

var Sortable = new Sortable($('#toolbar')[0], {
    // animation: 150,
    draggable: '.icon-list',
    // delay: 400,
    // disabled: false,
    // onEnd: function (evt) { //拖拽完毕之后发生该事件
    //     Sortable.options.disabled = false;
    //     //  is_sort = true;
    // }
});

page_init = function () {
    $('#header').header({
        back: true,
        title: page_data['category'] == 'yarn' ? '常用应用/纱' :'常用应用',
        appendBackBtnEvt: isDataChange,
    });
    if (page_data['data']) {
        window_data = page_data['data'];
        // gjlHtml = [];
        getData(window_data);
    }
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret['value'] || {};
        // console.log(JSON.stringify(ckdata))
        // console.log(JSON.stringify(temp['data']))
        var window_html = [];
        if (temp['status'] === "add") {
            window_data = [];
            if (page_data['category'] && page_data['category'] == 'yarn') {
                window_html = fun.getItem('yarn_toolbar_data');
            } else {
                window_html = fun.getItem('quick_toolbar_data');
            }

            //取数组里相同的对象
            for (var i = 0; i < window_html.length; i++) {
                for (var j = 0; j < temp['data'].length; j++) {
                    if (window_html[i]['type'] == temp['data'][j]['type'] && temp['data'][j]['state']) {
                        window_data.push(window_html[i]);
                    }
                }
            }
            //获取除原有的对象外，新增对象
            temp['data'] = temp['data'].filter(function (item) {
                return !window_html.some(function (data) {
                    return data.type === item.type;
                });
            });
            // console.log(JSON.stringify(temp['data']))
            for (var i = 0; i < temp['data'].length; i++) {
                window_data.push(temp['data'][i]);
            }
            getData(window_data);
            // console.log(JSON.stringify(window_data))
        }
    });

    // 监听安卓返回键
    page_data.keyback = function () {
        isDataChange();
    }
}

function getData(data) {
    var gjlHtml = [];
    $('#toolbar').empty();
    for (var i = 0; i < data.length; i++) {
        gjlHtml.push('<li class="cloth-term icon-list" data-type="' + data[i]['type'] + '" data-serial="' + i + '" data-list=\'' + JSON.stringify(data[i]) + '\'>');
        gjlHtml.push('    <div class="cloth-box">');
        gjlHtml.push('         <svg class="icon" aria-hidden="true"><use xlink:href="#' + data[i]['icon'] + '"></use></svg>');
        gjlHtml.push('         <div class="delete">');
        gjlHtml.push('              <i class="iconfont  icon-fork fork"></i>');
        gjlHtml.push('         </div>');
        gjlHtml.push('    </div>');
        gjlHtml.push('    <span>' + data[i]['text'] + '</span>');
        gjlHtml.push('</li>');
    }

    $('#toolbar').html(gjlHtml.join(''));
    $('body').find('#add_cloth').remove();
    if (i < 16 && $('#add_cloth').length == 0) {
        $('#toolbar').append('<li class="cloth-term" id="add_cloth"><i class="iconfont icon-add-to add-to" id="add"></i></li>')
    }
}

//添加
$('body').on('tap', '#add', function () {
    getShowData();
    // console.log('**********添加**********')
    // console.log(page_data['category'])
    var category;
    if (page_data['category'] && page_data['category'] == 'yarn') {
        fun.setItem('yarn_toolbar_data', window_data);
        category = 'yarn';
    } else {
        fun.setItem('quick_toolbar_data', window_data);
        category = 'cloth';
    }
    fun.showPageFull({
        page_url: page_arr.toolbar_search,
        pageParam: {
            html_name: page_data['html_name'],
            category: category
        }
    })
});

//返回上一页并返回值
function isDataChange() {
    getShowData();
    // console.log('****返回**')
    // console.log(page_data['category'] && page_data['category'] == 'yarn')
    if (page_data['category'] && page_data['category'] == 'yarn') {
        fun.setItem('yarn_toolbar_data', window_data);
    } else {
        fun.setItem('quick_toolbar_data', window_data);
    }
    api.sendEvent({
        name: page_data['html_name'],
        extra: {
            'status': 'return',
            'category': page_data['category'] || 'cloth',
            'data': window_data,
        }
    });
    setTimeout(function () {
        api.closeWin();
    }, 200);
}

//删除
$('body').on('tap', '.delete', function () {
    // console.log(JSON.stringify(data))
    var _this = this;
    var list = $(this).closest('li').data('list') || {};
    var type = $(this).closest("li").data('type');
    // console.log(JSON.stringify(list))
    fun.dialog({
        content: '你确定要删除【' + list['text'] + '】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            var grt_toolbar = [];
            if (page_data['category'] && page_data['category'] == 'yarn') {
                grt_toolbar = fun.getItem('yarn_toolbar_search');
            } else {
                grt_toolbar = fun.getItem('toolbar_search.html_data');
            }
            // console.log(JSON.stringify(grt_toolbar))
            for (var i = 0; i < grt_toolbar.length; i++) {
                if (grt_toolbar[i]['type'] == type) {
                    grt_toolbar[i]['state'] = 'false';
                }
            }
            window_data = grt_toolbar;
            // console.log(JSON.stringify(grt_toolbar))
            if (page_data['category'] && page_data['category'] == 'yarn') {
                fun.setItem('yarn_toolbar_search', grt_toolbar);
            } else {
                fun.setItem('toolbar_search.html_data', grt_toolbar);
            }

            $(_this).closest('li').remove();
            if ($('.cloth-term').length < 16 && $('#add_cloth').length == 0) {
                $('#toolbar').append('<li class="cloth-term" id="add_cloth"><i class="iconfont icon-add-to add-to" id="add"></i></li>')
            }
        }
    });
})

function getShowData() {
    var getData = [];
    for (var i = 0; i < $('.icon-list').length; i++) {
        getData.push($('.icon-list').eq(i).data('list'));
    }
    window_data = getData;
    // console.log(JSON.stringify(ckdata))
    // console.log(JSON.stringify(getData))
}
