var html_name = page_arr.report_printer;
// var printer_name = fun.getItem('printer_cloud') || [];
var printerCloud = fun.getItem('printer_cloud') || [];
var Bills = {};

Bills['print_config'] = {};

var maxVal = 10;

for (var i = 0; i < printerCloud.length; i++) {
    printerCloud[i]['is_cloud'] = 1;
}

page_init = function () {
    var window_name;
    switch (page_data['djlx']) {
        case 'bp_xsdd':
            window_name = '客户订单';
            break;
        case 'bp_xsfhjs':
            window_name = '销售开单';
            Bills['print_config'] = {has_bar:1};
            break;
        case 'bp_xsthjs':
            window_name = '销售退单';
            Bills['print_config'] = {has_bar:1};
            break;
        case 'bp_cgdd':
            window_name = '采购订单';
            break;
        case 'bp_cglhjs':
            window_name = '来货结算';
            Bills['print_config'] = {has_bar:1};
            break;
        case 'bp_cgthjs':
            window_name = '退货结算';
            break;
        case 'kc_bppyd':
            window_name = '盘盈单';
            Bills['print_config'] = {has_bar:1};
            break;
        case 'kc_bpzspd':
            window_name = '总数盘点';
            break;
        case 'kc_bpmxpkd':
            window_name = '明细盘亏';
            break;
        case 'kc_bptbd':
            window_name = '调拨单';
            Bills['print_config'] = {has_bar:1};
            break;
        case 'cw_skd':
            window_name = '收款单';
            break;
        case 'cw_fkd':
            window_name = '付款单';
            break;
        case 'cw_ywtz':
            window_name = '业务调账';
            break;
        case 'cw_fyd':
            window_name = '费用单';
            break;
        case 'cw_qtsr':
            window_name = '其他收入';
            break;
        case 'cw_nbzz':
            window_name = '内部转账';
            break;
        case 'cp':
            window_name = '产品';
            break;
    }

    $('#header').header({
        back: true,
        title: window_name + '报表',
        setup: true,
    });

    //加载云打印机列表
    fun.load_printer_cloud(function () {
        printerCloud = fun.getItem('printer_cloud') || [];
        for (var i = 0; i < printerCloud.length; i++) {
            printerCloud[i]['is_cloud'] = 1;
        }
    });

    //获取云报表
    getCloudList();

    //获取本地报表
    if (!$.nui.isEmpty(page_data['ip'])) {
        getLocalList();
    }

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        console.log(ret);
        var temp = ret['value'] || {},
            data = temp['data'] || {};
        switch (temp['status']) {
            case "select_device":
                $('#slids_PName').val(data['name']).data('id', data['id']);
                break;
        }
    })
}
//获取云打印机名称
function getCloudList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getPrintReportList,
        data: { "flag": "getReportList", "type": page_data['djlx'] ,has_bar: Bills['print_config']['has_bar'] || 0},
        success: function (res) {
            var __data = res.data;
            if (!Array.isArray(__data)) __data = [];
            for (var i = 0; i < __data.length; i++) {
                __data[i]['config'] = JSON.parse(__data[i]['config'] || '{}');
                __data[i] = $.extend(true, { is_cloud: true }, __data[i]['config'], __data[i]);
            }

            if (res['status'] == 0) {
                showList(__data, 'cloud');
            }
        }
    })
}
//获取报表名称
function getPrinterName() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getPrintDeviceList,
        data: { "flag": "getDeviceID" },
        success: function (res) {
            if (res['status'] == 0) {
                return res['data'];
            }
        }
    })
};
//获取本地报表
function getLocalList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: 'http://' + page_data['list']['ip'] + ':' + page_data['list']['port'] + '/',
        data: { "flag": "getReportList", "type": page_data['djlx'] ,has_bar: Bills['print_config']['has_bar'] || 0},
        success: function (res) {
            console.log('本地报表')
            console.log(res)
            if (res['status'] == 'ok') {
                showList(res['data']['list'], 'wrap')
            }
        }
    })
};
//加载报表列表
function showList(data, cloud) {
    console.log('加载数据列表' + cloud)
    console.log(data, cloud)
    var html = [];

    for (var i = 0; i < data.length; i++) {
        var data_list = data[i];
        var text = '开启',
            text_color = 'blue';
        if (cloud) {
            for (var j = 0; j < printerCloud.length; j++) {
                if (data_list['print_device_id'] == printerCloud[j]['id']) {
                    data_list['cloud_name'] = printerCloud[j]['device_name'];
                    data_list['cloud_id'] = printerCloud[j]['id'];
                }
            }
        }
        if (data_list['is_hide'] == 0) {
            text = '隐藏';
            text_color = 'gray';
        }
        var icon;
        var sortClass = '';
        var oneClass = '';
        switch (cloud) {
            case 'cloud':
                icon = 'icon-cloud';
                sortClass = 'sortable-list1';
                break;
            case 'wrap':
                icon = 'icon-pc';
                sortClass = 'sortable-list2';
                break
        }

        if($.nui.isEmpty(data_list['cloud_name'])){
            oneClass = 'one';
        }


        html.push('<li class="li-list sortable-list ' + (cloud) + ' '+sortClass+'" data-list=\'' + (fun.formatString(JSON.stringify(data_list))) + '\'>');
        html.push('    <div class="le slide-li">');
        html.push('        <div class="'+oneClass+'">');
        html.push('            <i class="iconfont   ' + (icon) + ' i-size"></i>');
        html.push('            <span class="' + (data_list['is_hide'] == 0 ? '' : 'color-ash color-scribing') + '">' + data_list['name'] + '</span>');
        data_list['is_bar'] ? html.push('            <i class="iconfont icon-erweima erweima"></i>') : '';
        html.push('        </div>');
        if($.nui.isTrue(data_list['cloud_name'])){
            html.push('        <div>');
            html.push('            <span id="dy-name" class="color-ash">' + (data_list['cloud_name'] ? data_list['cloud_name'] : '') + '</span>');
            html.push('        </div>');
        }
      
        html.push('        <span class="dels1 slids orange">修改</span>');

        html.push('        <span class="dels1 hide ' + text_color + '">' + text + '</span>');
        html.push('    </div>');
        html.push('</li>');
    }

    var $html = $('#' + cloud);
    $html.html(html.join(''));
}
//报表设置
function setup() {
    var html = [];
    html.push('<div>');
    html.push(' <p class="setup-title">本地报表打印设置</p>');
    html.push(' <div class="setup-box">');
    html.push('     <span>列数</span>');
    html.push('     <input type="text" id="setup_ls" class="num-input" num_type="4" decimal_digits="0">');
    html.push(' </div>');
    html.push(' <div class="setup-box">');
    html.push('     <span>明细</span>');
    html.push('     <input type="text" id="setup_mx" readonly>');
    html.push(' </div>');
    html.push('</div>');

    fun.dialog({
        type: 1,
        className: 'setup-layer',
        content: html.join(''),
        isClose: true,
        btn: ['保存', '取消'],
        success: function () {
            $('#setup_ls').on('keyup', function () {
                if ($(this).val() === 0 || $(this).val() === '0') {
                    $(this).val(1)
                }
                if ($(this).val() > maxVal) {
                    $(this).val(maxVal)
                }
            })
            $('#setup_ls').on('blur', function () {
                var oriLs = $(this).data('oriLs');

                if($.nui.isEmpty($(this).val())){
                    $(this).val(oriLs);
                }
            });
            var SYS_CONFIG = fun.getItem('sys_config');
            var dy_ls = SYS_CONFIG['dy_ls'];
            var dy_mx = SYS_CONFIG['dy_mx'];
            var _dy_mx = dy_mx.split('"');
            var data1 = [
                // TODO
                { name: '空差', db_name: 'kc', is_choose: 0 },
                { name: '幅宽', db_name: 'fk', is_choose: 0 },
                { name: '克重', db_name: 'kz', is_choose: 0 },
                { name: '规格', db_name: 'gg', is_choose: 0 },
                { name: '缸号', db_name: 'gh', is_choose: 0 },
                { name: '卷号', db_name: 'jh', is_choose: 0 },
                { name: '记录行备注', db_name: 'bz', is_choose: 0 },
            ];

            // 仓库自定义字段
            for (var i = 1; i <= 5; i++) {
                var display = SYS_CONFIG['bpckzdygl' + i];
                if ($.nui.isTrue(display)) {
                    data1.push({ db_name: "ck_zdy" + i, name: display, is_choose: 0 });
                }
            }

            // 开单自定义字段
            for (var i = 1; i <= 5; i++) {
                var display = SYS_CONFIG['bpkdzdyzd' + i];
                if ($.nui.isTrue(display)) {
                    data1.push({ db_name: "kd_zdy" + i, name: display, is_choose: 0 });
                }
            }
            var setup_mx = [];
            for (var i = 1; i < _dy_mx.length; i += 2) {
                for (var j = 0; j < data1.length; j++) {
                    if (_dy_mx[i] == data1[j]['db_name']) {
                        data1[j]['is_choose'] = 1;
                        setup_mx.push(data1[j]['name']);
                    }
                }
            }
            $('#setup_ls').val(dy_ls).data('oriLs', dy_ls);
            $('#setup_mx').val(setup_mx.join(';')).data('db_name', dy_mx);
            $('#setup_mx').on('click', function () {
                var $this = $(this);
                fun.showBookList({
                    width: '280px',
                    checkbox: true,
                    shadeClose: true,
                    list: data1,
                    choose: function (res) {
                        $(data1).each(function (i, item) {
                            data1[i]['is_choose'] = 0;
                        })
                        var nameArr = [];
                        var db_nameArr = [];
                        $(res).each(function (i, arr) {
                            $(data1).each(function (j, item) {
                                if (arr['db_name'] == item['db_name']) {
                                    data1[j]['is_choose'] = 1;
                                }
                            })
                            nameArr.push(arr['name']);
                            db_nameArr.push(arr['db_name']);
                        })
                        $this.val(nameArr.join(';')).data('db_name', JSON.stringify(db_nameArr));
                    }
                })
            })
        },
        yes: function () {
            var data = {
                type: 'sys',
                list: [
                    { key: 'dy_ls', value: $('#setup_ls').val().trim() || 1 },
                    { key: 'dy_mx', value: $('#setup_mx').data('db_name') },
                ]
            }
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.saveSysConfig,
                data: data,
                success: function (res) {
                    switch (res['status']) {
                        case 0:
                            fun.toast('保存成功。')
                            fun.load_DATA_LIST(['sys_config'], function () {
                                SYS_CONFIG = fun.getItem('sys_config') || {};
                                if (SYS_CONFIG['dy_ls']) fun.setPrintConfig('mx_col', SYS_CONFIG['dy_ls']);
                                if (SYS_CONFIG['dy_mx']) fun.setPrintConfig('group', JSON.parse(fun.formatParseJson(SYS_CONFIG['dy_mx'])));
                            }, { showLoad: false });
                            break;
                        case 103:
                            return fun.toast('保存失败。');
                            break;
                    }
                }
            });
        }
    });
}
//报表设置
function slids(option) {
    var _opt = $.extend({
        readonly: true,
        display: true,
        mx: false,
    }, option)
    var html = [];
    var readonly = _opt['readonly'] ? 'disabled' : '';
    html.push('<div class="slids-div">');
    html.push(' <p class="slids-title">报表设置</p>');
    html.push(' <div class="slids-box">');
    html.push('     <input type="text" id="slids_name" placeholder="名称" value="' + (_opt['data']['name']) + '" ' + readonly + '>');
    html.push(' </div>');
    html.push(' <div class="slids-box" style="display:' + (_opt['display'] ? 'none' : 'inline-block') + '">');
    html.push('     <input type="text" id="slids_PName" placeholder="绑定云打印机" value="' + (_opt['data']['cloud_name'] || '') + '" data-id="' + (_opt['data']['cloud_id'] || 0) + '" readonly>');
    html.push(' </div>');
    html.push(' <div class="slids-box">');
    html.push('     <span id="bar" class="slids-mx ' + (_opt['mx'] ? 'blue-color' : '') + '">标签 <i class="iconfont icon-erweima"></i></span>');
    html.push(' </div>');
    html.push('</div>');

    fun.dialog({
        type: 1,
        className: 'slids-layer',
        content: html.join(''),
        isClose: true,
        btn: ['保存', '取消'],
        success: function () {
            $('#bar').on('click', function () {
                $(this).toggleClass("blue-color");
            })
            $('#slids_PName').on('click', function () {
                fun.showPageFull({
                    page_url: page_arr.printer_list,
                    pageParam: {
                        return_page: html_name,
                        print_select: true,
                    }
                })
            })
        },
        yes: function () {
            var slids_ls = $('#slids_name').val().trim();
            var cloud_id = $('#slids_PName').data('id');
            var is_bar = $('#bar').hasClass('blue-color') ? 1 : 0;

            if (slids_ls == '') {
                slids_ls = _opt['data']['name'];
            }
            if (_opt['display'] == true) {//本地
                var data = { "is_bar": is_bar };
                var id = _opt['data']['id'];
                saveLocalPrint(data, id);

            } else if (_opt['display'] == false) {//云
                var data = {
                    "is_bar": is_bar,
                    "name": slids_ls,
                    "print_device_id": cloud_id
                };
                var id = _opt['data']['id'];
                saveCloudPrint(data, id);
            }
        }
    });
}

// //拖拽事件
// new Sortable($('#cloud')[0], {
//     animation: 150,
//     draggable: '.sortable-list1',
//     delay: 500,
//     dragClass: "sortable-drag",  // 正在被拖拽中的css类名
//     onStart: function (evt) {
//         saveDataArr = [];
//         var index = evt.oldIndex;
//         $('#cloud .sortable-list1').eq(index).css({ 'background': '#f5f5f5' });
//     },
//     onEnd: function (e) {
//         var index = e.newIndex;
//         $('#cloud .sortable-list1').eq(index).css({ 'background': '#fff' });
//     }
// });

// //拖拽事件
// new Sortable($('#wrap')[0], {
//     animation: 150,
//     draggable: '.sortable-list2',
//     dragClass: "sortable-drag",  // 正在被拖拽中的css类名
//     delay: 500,
//     onStart: function (evt) {
//         saveDataArr = [];
//         var index = evt.oldIndex;
//         // $('#wrap .sortable-list2').eq(index).css({ 'background': '#f5f5f5' });
//     },
//     onEnd: function (e) {
//         var index = e.newIndex;
//         // $('#wrap .sortable-list2').eq(index).css({ 'background': '#fff' });
//     }
// });



/**
 * 按钮
 */
//设置
$('body').on('click', '#setup_btn', function () {
    setup();
})
//修改
$('body').on('click', '.slids', function (e) {
    e.stopPropagation();
    var $this = $(this);
    var parents = $this.parents('.li-list');
    var data = parents.data('list');
    if (parents.hasClass('cloud')) {//云
        slids({
            parents: parents,
            readonly: false,
            display: false,
            mx: data['is_bar'] == 0 ? false : true,
            data: data,
        })
    } else {//本地
        slids({
            parents: parents,
            mx: data['is_bar'] == 0 ? false : true,
            data: data,
        })
    }

})
//隐藏(停用) / 开启
$('body').on('click', '.hide', function (e) {
    e.stopPropagation();
    var $this = $(this);
    var parents = $this.parents('.li-list');
    var data = parents.data('list');
    var id = data['id'];
    if ($(this).hasClass('gray')) { //点击了隐藏
        $(this).removeClass('gray').addClass('blue').text('开启');
        var data = { "is_hide": 1 };
    } else { //点击了开启
        $(this).removeClass('blue').addClass('gray').text('隐藏');
        var data = { "is_hide": 0 };
    }
    if (parents.hasClass('cloud')) {//云
        saveCloudPrint(data, id)
    } else {//本地
        saveLocalPrint(data, id)
    }
})

function saveCloudPrint(data, id) {//云保存
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.savePrintReportInfo,
        data: {
            "data": data,
            "condition": { "id": id }
        },
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.toast('保存成功。');
                    getCloudList();
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    })
}

function saveLocalPrint(data, id) {//本地保存
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: 'http://' + page_data['list']['ip'] + ':' + page_data['list']['port'] + '/',
        data: {
            "data": data,
            "flag": "setReport",
            "type": page_data['djlx'],///
            "report_id": id
        },
        success: function (res) {
            switch (res['status']) {
                case 'ok':
                    fun.toast('保存成功。');
                    getLocalList();
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    })
}


$('body').on('click', '.li-list', function (e) {
    e.stopPropagation();

    var list = $(this).data('list') || {};

    var is_cloud = list['is_cloud'];

    api.sendEvent({
        name: page_data['return_page'] + '_select_device',
        extra: {
            'status': 'report_form',
            'data': $(this).data('list'),
            'pattern': page_data['pattern'],
            'is_cloud': is_cloud
        }
    });

    setTimeout(function () {
        api.closeWin();
    }, 200);
})