var html_name = page_arr.search;
var search_data = {};
var begin_lCalendar = new lCalendar();
var end_lCalendar = new lCalendar();
begin_lCalendar.init({
    'trigger': '#begin_date',
    'type': 'date'
});
end_lCalendar.init({
    'trigger': '#end_date',
    'type': 'date'
});
var switch_style = "";

var USER_INFO = {};

if (!fun.isEmpty(fun.getItem('theme_color'))) {
    var colour = fun.getItem('theme_color')['theme_arr'] || [];
    switch_style = "border-color:" + colour[1] + ";background-color:" + colour[1] + " !important;"
}

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    // $('.reset').hide()
    fun.keyboardEject('.search-button');
    if (page_data['search_data'] && Object.keys(page_data['search_data']).length) {
        search_data = page_data['search_data'];
        console.log(search_data)
        init(search_data);
    }
    html_name += page_data['return_page'];
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        console.log(ret)
        var temp = ret['value'];
        var data = temp['data'] || {};
        switch (temp['status']) {
            case 'select_list':
                select_list_val(temp['data'])
                break;
            case 'select_sx_list':
                select_list_val(temp['data'])
                break;
            case 'select_lx':
                select_list_val(temp['data'])
                break;
            case 'update':
                updateRow(data);
                break;
            case 'label':
                upRowBq(temp['label_arr'], temp['type']);
                break;
        }
    });
    fun.inputType();
    // iphoneX
    try{
        $('.search-button').css('padding-bottom', api.safeArea.bottom / 3);
    }catch(e){

    }
};

//选择标签
function upRowBq(param, type) {
    label_arr = param;
    var lar = label_arr.split(',') || [];
    var tmp = new Array();
    for (var i = 0; i < lar.length; i++) {
        tmp[i] = Number(lar[i]);
    }
    lar = tmp;
    showBqList(lar, type);
}

function showBqList(lar, type) {
    if (lar.length == 1 && lar[0] == 0) return $(".logo-whole").html('').siblings('.iconfont').removeClass('icon-close').addClass('icon-youfanhui');
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getLabelList,
        data: {
            "type": type,
        },
        success: function (res) {
            if (res['status'] != 0) return fun.toast('获取标签失败。');
            // console.log(JSON.stringify(res));
            var info_list = res.data;
            var html = [];
            for (var i = 0; i < info_list.length; i++) {
                var val = info_list[i];
                if (lar.indexOf(val['id']) !== -1) {
                    html.push('<div class="pack" data-list = \'' + fun.formatString(JSON.stringify(val)) + '\' style="background-color: ' + val['colour'] + '">');
                    html.push('    <span>' + val['name'] + '</span>');
                    html.push('</div>');
                }
            }
            html.length != 0 ? $(".logo-whole").html(html.join('')).siblings('.iconfont').addClass('icon-close') : $(".logo-whole").html(html.join('')).siblings('.iconfont').removeClass('icon-close');
        }
    });
}

//选择列表赋值
function select_list_val(param) {
    if (param['page_type'] == 'md') {
        var tmp_id = $('.merchants-content[key="md"]').attr('id');
        if (param['id'] != tmp_id) {
            $('.merchants-content[key="xz_bm"]').length && $('.merchants-content[key="xz_bm"]').text('').attr('id', 0).next().removeClass('icon-close').addClass('icon-youfanhui');
            $('.merchants-content[key="xz_zw"]').length && $('.merchants-content[key="xz_zw"]').text('').attr('id', 0).next().removeClass('icon-close').addClass('icon-youfanhui');
        }
    } else if (param['page_type'] == 'xz_bm') {
        var tmp_id = $('.merchants-content[key="xz_bm"]').attr('id');
        if (param['id'] != tmp_id) {
            $('.merchants-content[key="xz_zw"]').length && $('.merchants-content[key="xz_zw"]').text('').attr('id', 0).next().removeClass('icon-close').addClass('icon-youfanhui');
        }

    }

    $('.merchants-content').each(function (i, obj) {
        if ($(obj).attr('key') == param['page_type']) {
            if (param['select_val'] != "") {
                $(obj).next().removeClass('icon-youfanhui').addClass('icon-close');//存在值则显示删除按钮
            }
            if (param['page_type'] == 'cp') { //重新选择纱线时，清空品牌、地区、规格的值
                if ($(obj).attr('id') != param['id']) {
                    $(".yarn").text('').attr('id', '').parent().children('.iconfont').removeClass('icon-close').addClass('icon-youfanhui');
                }
            }
            $(obj).text(param['select_val']);
            $(obj).attr('id', param['id']);
        }
    })
}

function init(search_data) {
    // 兼容IOS13
    var kcphsz = [];
    if(api.systemType !== 'android') {
        kcphsz = page_data['SYS_CONFIG_kcphsz'] || [];
    }else{
        var sys_config = fun.getItem('sys_config') || [];
        kcphsz = sys_config['kcphsz'] || '';
    }
    $.each(search_data, function (i, obj) {
        var elem = $('#' + i), list = [];
        elem.show();
        switch (i) {
            case 'type':
            case 'analysis':
                var switchs = [];
                switchs.push('<span class="list-switch-title">' + ((i == 'type') ? "类型" : "分析") + '</span>');
                $.each(obj, function (i, obj) {
                    var cssText = (obj['value'] == 1) ? switch_style : "";
                    switchs.push('<div style="' + cssText + '" switch-type="radio"  class="nui-switch nui-switch-md ' + (obj['value'] === 1 ? 'nui-active' : 'nui-unactive') + ' nui-switch-btn" key="' + obj['key'] + '" >');
                    switchs.push('<span class="switch-text">' + obj['text'] + '</span>');
                    switchs.push('<div class="nui-switch-handle"></div>');
                    switchs.push('</div>');
                })
                elem.empty();
                elem.html(switchs.join(''));
                break;
            case 'time':
                $('#begin_date').val(obj['begin_date'].replace(/\./g, '-'));
                $('#end_date').val(obj['end_date'].replace(/\./g, '-'));

                if ($.nui.isTrue(obj['text'])) { // 起始和结束时间显示文档修改
                    $('.start_date .date-title').text(obj['text']['begin_text']);
                    $('.end_date .date-title').text(obj['text']['end_text']);
                }
                break;
            case 'keywords':
                // $('#keyword').val('');
                elem.find('input').attr('key', obj['key']);
                elem.find('input').val(obj['value'] || '');
                elem.find('input').attr('placeholder', obj['placeholder']);
                // $('body').bind('search', '#keyword', function (e) {
                //     // if (e.keyCode === 13 && $('#keyword').val().trim()) search()
                //     if ($('#keyword').val().trim()) search()
                // });
                break;
            case 'dh_wrap':
                $('#dh').val('');
                elem.find('input').attr('key', obj['key']);
                elem.find('input').val(obj['value'] || '');
                elem.find('input').attr('placeholder', obj['placeholder']);
                // $('body').bind('search','#dh', function (e) {
                //     // if (e.keyCode === 13 && $('#dh').val().trim()) search()
                //     if ($('#dh').val().trim()) search()
                // });
                break;
            case 'stock_input':
                var info_html = [];
                $.each(obj, function (index, list) {
                    var key = list['key'];
                    if (key == 'fk' && kcphsz.indexOf('fk') === -1) { //偏好设置没有开启幅宽
                        return true;
                    } else if (key == 'kz' && kcphsz.indexOf('kz') === -1) { //偏好设置没有开启克重
                        return true;
                    } else if (key == 'gg' && kcphsz.indexOf('gg') === -1) {//偏好设置没有开启规格
                        return true;
                    } else if (key == 'ph' && kcphsz.indexOf('ph') === -1) {//偏好设置没有开启批号
                        return true;
                    } else if (key == 'gh' && kcphsz.indexOf('gh') === -1) {//偏好设置没有开启缸号
                        return true;
                    } else if (key == 'jh' && kcphsz.indexOf('jh') === -1) {//偏好设置没有开启卷号
                        return true;
                    }
                    

                    info_html.push('<li>');
                    info_html.push('<span>' + list['text'] + '</span>');
                    info_html.push('<input key="' + list['key'] + '" class="lsfx-ts stock_content" value="' + (list['value'] || "") + '" type="text" />');
                    info_html.push('    </li>');
                    
                })
                elem.empty();
                elem.html(info_html.join(''));
                api.parseTapmode();
                break;
            case 'choose_merchants':
                var list_html = [];
                $.each(obj, function (index, list) {
                    var key = list['key'];
                    if (key == 'sx_pp' && !fun.getSxKdSetting('pp')) { //偏好设置没有开启品牌
                        return true;
                    } else if (key == 'sx_dq' && !fun.getSxKdSetting('dq')) { //偏好设置没有开启地区
                        return true;
                    } else if (key == 'gg' && !fun.getSxKdSetting('gg')) {//偏好设置没有开启规格
                        return true;
                    } else if (key == 'cw' && kcphsz.indexOf('cw') === -1) {//偏好设置没有开启仓位
                        return true;
                    }

                    list_html.push('<li>');

                    if (key == 'cp_lb' && list['is_yarn']) {
                        list['key'] = 'sx_lb';
                        key = 'sx_lb';
                    }

                    switch (key) {
                        case "hz":
                            var choose_text = [];

                            for (var i = 0; i < list['group'].length; i++) {
                                if ($.nui.isTrue(list['group'][i]['choose'])) {
                                    choose_text.push(list['group'][i]['name']);
                                }
                            }

                            choose_text = choose_text.join('、');

                            list_html.push('<span>' + list['text'] + '</span>');
                            list_html.push('<div id="' + (list['id'] || "") + '" key="' + list['key'] + '" data-group=\'' + fun.formatString(JSON.stringify(list['group'])) + '\' tapmode="active" onClick="clickList(this)" class="merchants-content">' + (choose_text || list['value']) + '</div>');
                            list_html.push('<i class="iconfont icon-youfanhui list-icon"></i>');
                            break;
                        case "thfs":
                            console.log(list['group']);
                            var choose_text = [];

                            for (var i = 0; i < list['group'].length; i++) {
                                if ($.nui.isTrue(list['group'][i]['choose'])) {
                                    choose_text.push(list['group'][i]['name']);
                                }
                            }

                            choose_text = choose_text.join('、');

                            list_html.push('<span>' + list['text'] + '</span>');
                            list_html.push('<div id="' + (list['id'] || "") + '" key="' + list['key'] + '" data-group=\'' + JSON.stringify(list['group']) + '\' tapmode="active" onClick="clickList(this)" class="merchants-content">' + (choose_text || list['value']) + '</div>');
                            list_html.push('<i class="iconfont icon-youfanhui list-icon"></i>');
                            break;
                        case "zd":
                            var choose_text = [];

                            for (var i = 0; i < list['group'].length; i++) {
                                if ($.nui.isTrue(list['group'][i]['choose'])) {
                                    choose_text.push(list['group'][i]['name']);
                                }
                            }

                            choose_text = choose_text.join('、');

                            list_html.push('<span>' + list['text'] + '</span>');
                            list_html.push('<div id="' + (list['id'] || "") + '" key="' + list['key'] + '" data-group=\'' + JSON.stringify(list['group']) + '\' tapmode="active" onClick="clickList(this)" class="merchants-content">' + (choose_text || list['value']) + '</div>');
                            list_html.push('<i class="iconfont icon-youfanhui list-icon"></i>');
                            break;
                        case "merchants":
                            $(list['merchants_list']).each(function (index, obj) {//客商选择列表
                                if (obj['is_choose'] == 1) {
                                    list_html.push('<span id="switch_merchants" data-merchants-list=\'' + fun.formatString(JSON.stringify(list['merchants_list'])) + '\'><span>' + obj['name'] + '</span><i class="iconfont icon-xia ks-jt"></i></span>');
                                    list_html.push('<div id="' + (list['id'] || "") + '" key="' + obj['column'] + '" tapmode="active" onClick="clickList(this)" class="merchants-content">' + list['value'] + '</div>');
                                }
                            })
                            list_html.push('<i class="iconfont list-icon ' + ((!!list['value']) ? "icon-close" : "icon-youfanhui") + '"></i>');
                            break;
                        case "input":
                            list_html.push('<span>' + list['title'] + '</span>');
                            list_html.push('<div key="' + list['key'] + '" tapmode="active" onClick="clickList(this)" class="merchants-content">');
                            list_html.push('<input id="lsfx_ts" class="lsfx-ts num-input" num_type="4" value="' + (list['value'] || "") + '" type="text" />');
                            list_html.push('<span class="lsfx-text">' + list['text'] + '</span></div>');
                            break;
                        case "dd_dh":
                            list_html.push('<span>' + list['title'] + '</span>');
                            list_html.push('<div key="' + list['key'] + '"  class="merchants-content">');
                            list_html.push('<input id="dd-dh" class="input_box" placeholder="' + list['placeholder'] + '" value="' + list['value'] + '" type="text" />');
                            list_html.push('</div>');
                            break;
                        case "md":
                            var _class = '', md_id, md_mc;
                            USER_INFO = fun.getItem('user_info') || {};
                            var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

                            var USER_INFO_store_id = USER_INFO['store_id'];
                            var USER_INFO_store_name = USER_INFO['store_name'];

                            // 兼容IOS13
                            if(api.systemType !== 'android') {
                                if($.nui.isTrue(page_data['USER_INFO_MD'])) {
                                    disabled = (page_data['USER_INFO_MD']['store_id'] && !page_data['USER_INFO_MD']['yxckqtmd']);
                                    USER_INFO_store_id = page_data['USER_INFO_MD']['store_id'];
                                    USER_INFO_store_name = page_data['USER_INFO_MD']['store_name'];
                                }
                            }

                            if (!list['disabled']) {
                                _class = (disabled ? 'disabled' : "");
                                md_id = (disabled ? (USER_INFO_store_id) : (list['id'] || 0));
                                md_mc = (disabled ? (USER_INFO_store_name) : (list['value'] || ""));
                            } else {
                                _class = '';
                                md_id = (list['id'] || 0);
                                md_mc = (list['value'] || "");
                            }
                            list_html.push('<span>' + list['text'] + '</span>');
                            list_html.push('<div id="' + (md_id || "") + '" key="' + list['key'] + '" tapmode="active" onClick="clickList(this)" class="merchants-content" ' + _class + '>' + md_mc + '</div>');
                            list_html.push('<i class="iconfont list-icon ' + ((!!md_mc) ? "icon-close" : "icon-youfanhui") + '"></i>');
                            break;
                        case 'bq':
                            var value_arr = list['value_arr']
                            list_html.push('<span class="logo-text">标签</span>');
                            list_html.push('<div class="logo-whole merchants-content" data-type="' + list['type'] + '" key="' + list['key'] + '">');
                            list_html.push('</div>');
                            list_html.push('<i class="iconfont list-icon ' + ((!!value_arr) ? "icon-close" : "icon-youfanhui") + '"></i>');
                            break;
                        default:
                            var disabled = list['disabled'] ? 'disabled' : '';
                            var loadData = (typeof list['loadData'] === 'undefined') ? false : list['loadData'];
                            var loadDataType = list['loadDataType'] || '';

                            var is_sum = list['is_sum'] ? 1 : 0;//
                            var is_detail = list['is_detail'] ? 1 : 0;//
                            var is_yarn = list['is_yarn'] ? 1 : 0;//是否是纱线
                            var sx_tmp = '';

                            if (key == 'sx_pp' || key == 'sx_dq' || key == 'gg') {
                                sx_tmp = 'yarn';
                            }

                            list_html.push('<span>' + list['text'] + '</span>');
                            list_html.push('<div data-is_yarn="' + is_yarn + '" data-is_detail="' + is_detail + '" data-is_sum="' + is_sum + '" data-load_data_type="' + loadDataType + '" data-list=\'' + fun.formatString(JSON.stringify(list['list'])) + '\' data-loaddata="' + loadData + '" id="' + (list['id'] || "") + '" key="' + list['key'] + '" tapmode="active" onClick="clickList(this)" class="merchants-content ' + sx_tmp + '" ' + disabled + '>' + list['value'] + '</div>');
                            list_html.push('<i class="iconfont list-icon ' + ((!!list['value']) ? "icon-close" : "icon-youfanhui") + '"></i>');
                            break
                    }
                    list_html.push('    </li>');
                    // if(!!list['value'] && list['key']!="hz"){
                    //     list_html.push('<i class="iconfont icon-close list-icon"></i></li>');
                    // }else{
                    //     list_html.push('<i class="iconfont icon-youfanhui list-icon"></i></li>');
                    // }
                })
                elem.empty();
                elem.html(list_html.join(''));
                api.parseTapmode();
                break;
            case 'xs':
                $.each(obj, function (i, obj) {
                    var keys_initial = {};
                    for (var j = 0; j < obj['list'].length; j++) {
                        var keys_name = obj['list'][j];
                        keys_name['is_choose'] == 1 ? keys_initial[keys_name['column']] = 1 : keys_initial[keys_name['column']] = 0;
                    }
                    var show_style = '';
                    if (obj.hasOwnProperty('auth_hide')) {
                        show_style = obj['auth_hide'] ? 'display:none;' : '';
                    }

                    list.push(' <div class="select-div" style="' + show_style + '">');
                    list.push('     <span>' + obj['text'] + '</span>');
                    list.push('     <input type="text" class="select-input" data-i="' + i + '" key="' + obj['key'] + '" keys=\'' + fun.formatString(JSON.stringify(keys_initial)) + '\' data-type="' + obj['xsType'] + '" data-alone="' + obj['alone'] + '" value="' + (obj['value'] || "") + '" readonly="readonly">');
                    list.push('     <i class="iconfont icon-youfanhui list-icon"></i>');
                    list.push(' </div>');
                })
                elem.empty();
                elem.html(list.join(''));
                $('body').on('click', '.select-input', function () {
                    var val = $(this).val();
                    var ithis = $(this);
                    var i = $(this).data('i');
                    if (ithis.data('alone')) {
                        var merchants_list = obj[i]['list'];
                        $(merchants_list).each(function (i, arr) {
                            if (arr['name'] == val) {
                                merchants_list[i]['is_choose'] = 1;
                            } else {
                                merchants_list[i]['is_choose'] = 0;
                            }
                        });
                        fun.showBookList({
                            list: merchants_list,
                            choose: function (res) {
                                ithis.val('')/*清空*/.val(res['name'])/*赋值*/.data('type', res['column'])/*被选中的值*/;
                            }
                        })
                    } else {
                        var list = ithis.data('list');
                        var merchants_list;
                        if($.nui.isEmpty(list)){
                            merchants_list =obj[i]['list'];
                        }else{
                            merchants_list = JSON.parse(list);
                        }
                        fun.showBookList({
                            list: merchants_list,
                            checkbox: true,
                            choose: function (res) {
                                console.log(res)
                                var group_key = [], group_name = [], keys = {};
                                if($.nui.isEmpty(res)){
                                    $(merchants_list).each(function (i, obj){
                                        obj['is_choose'] = 1;
                                    })
                                }else{
                                    $(merchants_list).each(function (i, obj) {
                                        var store = true;
                                        $(res).each(function (j, obj_1) {
                                            if (store) {
                                                if (obj['column'] == obj_1['column']) {
                                                    obj['is_choose'] = 1;
                                                    keys[obj['column']] = 1;
                                                    store = false;
                                                    return
                                                } else {
                                                    keys[obj['column']] = 0;
                                                    obj['is_choose'] = 0;
                                                }
                                            }
                                        })
                                    })
                                }
                               
                                $(res).each(function (i, obj) {
                                    group_key.push(obj['column']);
                                    group_name.push(obj['name']);
                                })
                                ithis.val('').val(group_name.join('、')).data('type', group_key.join(',')).attr('keys', fun.formatString(JSON.stringify(keys))).data('list',JSON.stringify(merchants_list));
                            }
                        })
                    }
                    return false;
                })
                break;
            // case 'group':
            //     $.each(obj, function (g, obj_group) {
            //         list.push('<button class="btn_type ' + (obj_group['value'] === 1 ? "main-color" : "") + ' " key="' + obj_group['key'] + '">' + obj_group['text'] + '</button>');
            //     });
            //     elem.find('.single_box').html(list.join(''));
            //     bindEvent(i, 1);
            //     break;
            case 'sort':
                $.each(obj, function (s, obj_sort) {
                    var index = 1;
                    if (obj_sort['value'] === 'asc') index = "2";
                    if (obj_sort['value'] === 'desc') index = "3";
                    list.push('<div index="' + index + '" class="sort_btn time_order " key="' + obj_sort['key'] + '">');
                    list.push('<span class="text ' + (index !== 1 ? "theme-font-color" : "") + '">' + obj_sort['text'] + '</span>');
                    list.push('<div class="right-icon-box" >');
                    list.push('	<i class="iconfont icon-shang asc-icon ' + (index == "2" ? "theme-font-color" : "") + '"></i>');
                    list.push('	<i class="iconfont icon-xia desc-icon  ' + (index == "3" ? "theme-font-color" : "") + '" ></i>');
                    list.push('</div>');
                    list.push('</div>');
                });
                elem.find('.sort_btn_box').html(list.join(''));
                $('.sort_btn').on('tap', function () {
                    var index = $(this).attr('index');
                    setState('3', $(this));
                    setState(index, $(this));
                });
                $('.sort_btn').length > 2 ? $('.sort_bg').css('height', '5rem') : '';
                break;
            case 'switch':
                var relation;
                var radios;
                var early;
                $.each(obj, function (g, obj_group) {
                    var cssText = (obj_group['value'] == 1) ? switch_style : "";
                    relation = obj_group['relation'] == true ? true : false;
                    radios = obj_group['radios'] == true ? true : false;
                    early = obj_group['early'] == true ? true : false;
                    var show_style = '';
                    if (obj_group.hasOwnProperty('auth_hide')) {
                        show_style = obj_group['auth_hide'] ? 'display:none;' : '';
                    }

                    list.push('<div class="list_pattern" style="' + show_style + '">');
                    list.push('     <label class="' + (obj_group['max_width'] ? "large" : "") + '">');
                    if (obj_group['input']) {
                        list.push('<input type="text" value="' + (obj_group['input_value'] || "") + '" class="birthday" />');
                    }
                    list.push(obj_group['text']);
                    list.push('</label>');
                    var leading = obj_group['leading'] ? 'leading' : '';
                    var auxiliary = obj_group['auxiliary'] ? 'auxiliary' : '';


                    list.push('     <div style="' + show_style + cssText + '" class="nui-switch nui-switch-md ' + (obj_group['value'] === 1 ? 'nui-active' : 'nui-unactive') + ' nui-switch-btn " key="' + obj_group['key'] + '" id= ' + (leading) + '' + (auxiliary) + '>');
                    list.push('         <div class="nui-switch-handle"></div>');
                    list.push('     </div>');
                    list.push('</div>');

                });
                elem.empty();
                elem.html(list.join(''));

                // 20191214
                if ($('.nui-switch[key="xsmx"]').hasClass('nui-active')) {
                    $('.nui-switch[key="hldj"]').parent().show();
                } else {
                    $('.nui-switch[key="hldj"]').parent().hide();
                }

                if($('.nui-switch[key="xsyj"]').length != 0){
                    if ($('.nui-switch[key="xsyj"]').hasClass('nui-active')) {
                        $('.nui-switch[key="qbkc"]').addClass('nui-active').removeClass('nui-unactive').attr('disabled', 'disabled');
                    } else {
                        $('.nui-switch[key="qbkc"]').addClass('nui-unactive').removeClass('nui-active').removeAttr('disabled');
                    }
                }
                
                $('body').on('click', 'label', function () {
                    $(this).next().click()
                });
                if (relation == true) {
                    $('body').on('tap', '#leading', function (e) {
                        e.preventDefault();
                        if ($(this).hasClass('nui-active')) {
                            $('#auxiliary').addClass('nui-unactive').removeClass('nui-active');
                        } else {
                            $('#auxiliary').addClass('nui-active').removeClass('nui-unactive');
                        }
                    })
                    $('body').on('tap', '#auxiliary', function (e) {
                        e.preventDefault();
                        if ($(this).hasClass('nui-active')) {
                            $('#leading').addClass('nui-unactive').removeClass('nui-active');
                        } else {
                            $('#leading').addClass('nui-active').removeClass('nui-unactive');
                        }
                    })
                } else if (radios == true) {
                    $('body').on('tap', '#leading', function (e) {
                        e.preventDefault();
                        if ($(this).hasClass('nui-active')) {
                            $('#auxiliary').addClass('nui-unactive').removeClass('nui-active');
                        }
                    })
                    $('body').on('tap', '#auxiliary', function (e) {
                        e.preventDefault();
                        if ($(this).hasClass('nui-active')) {
                            $('#leading').addClass('nui-unactive').removeClass('nui-active');
                        }
                    })
                } else if (early  == true) {
                    $('body').on('tap', '#leading', function (e) {
                        e.preventDefault();
                        if ($(this).hasClass('nui-active')) {
                            $('#auxiliary').addClass('nui-active').removeClass('nui-unactive').attr('disabled', 'disabled');
                        } else {
                            $('#auxiliary').addClass('nui-unactive').removeClass('nui-active').removeAttr('disabled');
                        }
                    });
                } else {
                    $('body').on('tap', '#leading', function (e) {
                        e.preventDefault();
                        if ($(this).hasClass('nui-active')) {
                            if ($('#auxiliary').hasClass('nui-active')) {
                                $('#auxiliary').attr('disabled', true);
                            } else {
                                $('#auxiliary').addClass('nui-active').attr('disabled', true)
                            }
                        } else {
                            $('#auxiliary').removeAttr('disabled');
                        }
                    });
                }
                break;
        }
    })
    if (page_data['is_restbutton'] == true) {

        // $(".time_wc,.time_wc2").css('width', '40%').show()

    }
    var lar = [0], type;
    $(page_data['search_data']['choose_merchants']).each(function (i, item) {
        if (item['key'] == 'bq') {
            lar = item['value_arr'];
            type = item['type'];
            upRowBq(lar, type);
        }
    })

}
/* 点击重置除记忆之外的值 */
$('#reset').on('click', function () {
    fun.showLoad();
    reset();
    // 关闭分析搜索页
    fxPageReset();
    fun.hideLoad();
})

// 关闭分析搜索页
function fxPageReset() {
    switch (page_data && page_data['type']) {
        case 'shop_dp_fkfx': // 访客分析
        case 'shop_dp_xsqk': // 销售情况
        case 'shop_dp_nyjl': // 拿样记录
        case 'xs_nyfx': // 拿样分析
        case 'xs_nyfx_cpxq': // 拿样分析-产品详情
        case 'shop_xq_fx': // 兴趣分析
            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    'status': 'reset',
                    'data': page_data['reset']
                }
            });
            fun.closeFrame();
            break;
    }
    //针对粉丝页面
    if(page_data['type'] === 'shop_fans'){
        $('#auxiliary').removeClass('nui-active').addClass('nui-unactive');
        $('#leading').removeClass('nui-active').addClass('nui-unactive');
    }
}

/* 点击搜索按钮 */
$('body').delay('click', '#select,.time_bg', function (e) {
    search();
});

// // 重置按钮点击事件
// $("body").on('tap', '.reset', function () {
//     reset();
// })

/**
 * 绑定按钮点击事件
 * @param id 按钮id
 * @param multiple 是否多选 （null/0：单选、1：多选）
 */
function bindEvent(id, multiple) {
    $('body').on('tap', '#' + id + ' .btn_type', function () {
        if (multiple) {
            if ($(this).hasClass('main-color')) {
                $(this).removeClass('main-color')
            } else {
                $(this).addClass('main-color');
                if ($('#' + id + ' .btn_all').length) $('#' + id + ' .btn_all').removeClass('main-color')
            }
        } else {
            $(this).hasClass('main-color') ? $(this).removeClass('main-color').siblings().removeClass('main-color') : $(this).addClass('main-color').siblings().removeClass('main-color');
        }
    });
}

/**
 * 设置排序按钮状态
 * @param index
 * @param obj
 * @returns {boolean}
 */
function setState(index, obj) {
    switch (index) {
        case '1':
            obj.find('.desc-icon').removeClass('theme-font-color');
            obj.find('.asc-icon').addClass('theme-font-color');
            obj.find('.text').addClass('theme-font-color');
            obj.attr('index', '2');
            break;
        case '2':
            obj.find('.desc-icon').addClass('theme-font-color');
            obj.find('.asc-icon').removeClass('theme-font-color');
            obj.find('.text').addClass('theme-font-color');
            obj.attr('index', '3');
            break;
        case '3':
            obj.find('.desc-icon').removeClass('theme-font-color');
            obj.find('.asc-icon').removeClass('theme-font-color');
            obj.find('.text').removeClass('theme-font-color');
            obj.attr('index', '1');

            break;
    }
    return true;
}

//流失天数
// $("body").on('blur','#lsfx_ts',function(){
//     var lsts = $('#lsfx_ts').val();
//     fun.setItem(html_name + '_lsts', lsts);
//     console.log(lsts)
//     console.log(fun.getItem(html_name + '_lsts'))
// });
/*  选择列表页跳转    */

function clickList(element) {
    if ($(element).attr('disabled')) return true;
    var _this = $(element);
    var key = $(_this).attr('key');

    if (key == 'gg' && $.nui.isEmpty($('.merchants-content[key="cp"]').attr('id'))) {
        return fun.toast('请先选择纱线');
    }
    if (key == 'cw' && $.nui.isEmpty($('.merchants-content[key="ck"]').attr('id'))) {
        return fun.toast('请先选择仓库');
    }
    var loadDataFlag = $(_this).data('loaddata');
    var loadDataType = $(_this).data('load_data_type');

    var isYarn = $.nui.isTrue($(_this).data('is_yarn'));

    if ($.nui.isTrue(loadDataFlag)) {
        var load_list = [];
        switch (key) {
            case 'jd':
                break;
            case 'zt':
                if (loadDataType == 'xsdd') {
                    load_list = ['xs_zt'];
                } else if (loadDataType == 'sx_xsdd') {
                    load_list = ['sxxs_zt'];
                } else if (loadDataType == 'wwjg') {
                    load_list = ['jg_zt'];
                } else if (loadDataType == 'sx_wwjg') {
                    load_list = ['sxjg_zt'];
                } else if (loadDataType == 'cgdd') {
                    load_list = ['cg_zt'];
                } else if (loadDataType == 'sx_cgdd') {
                    load_list = ['sxcg_zt'];
                } else if (loadDataType == 'sx_xzd') {
                    load_list = ['sx_xzd'];
                }
                break;
            case 'jjcd':
                load_list = ['jjcd'];
                break;
            case 'sx_jjcd':
                load_list = ['sx_jjcd'];
                break;
        }

        function showDialog(options) {
            var _options = $.extend({ timeout: false, list: [] }, options);
            var list = _options['list'];
            if ($.nui.isEmpty(list)) return;
            var val = $(_this).text().trim();
            $(list).each(function (i, arr) {
                if (arr['name'] == val) {
                    list[i]['is_choose'] = 1;
                } else {
                    list[i]['is_choose'] = 0;
                }
            });

            function showBookList() {
                fun.showBookList({
                    list: list,
                    choose: function (res) {
                        console.log(res);
                        if ($.nui.isTrue(res['name'])) {
                            $(_this).next().removeClass('icon-youfanhui').addClass('icon-close');//存在值则显示删除按钮
                        }
                        $(_this).text(res['name']).attr('id', res['id']);
                    }
                })
            }

            if (_options['timeout']) {
                setTimeout(function () {
                    showBookList();
                }, 200);
            } else {
                showBookList();
            }
        }

        if ($.nui.isTrue(load_list)) {
            if (key == 'zt') {
                fun.showPageFull({
                    page_url: page_arr.urgent_level,
                    pageParam: {
                        return_page: html_name,
                        page_type: key,
                        list_id: $('.merchants-content[key="zt"]').attr('id') || 0,
                        url_type: loadDataType,
                    }
                });
                return false;
            }
            fun.load_DATA_LIST(load_list, function () {
                var list = fun.getItem(load_list[0] + '_list') || [];

                showDialog({ list: list });

            }, { showLoad: false });
        } else {
            var list = $(_this).data('list') || [];
            showDialog({ timeout: true, list: list });
        }
        return;
    }

    var Param = {
        "return_page": html_name,
        "page_type": key
    };
    var page_url = page_arr.select_list;
    if (key == 'hz') {
        var group = $(_this).data('group') || [];
        setTimeout(function () {
            fun.SummaryList({
                list: group,
                choose: function (params) {
                    console.log(params);
                    var group_key = [], group_name = [], keys = {};
                    $(params).each(function (i, obj) {
                        var word = ((params.length == i) ? "" : "");
                        if (obj['choose'] == 1) {
                            group_key.push(obj['columns']);
                            group_name.push(obj['name'] + word);
                            keys[obj['key']] = 1;
                        } else {
                            keys[obj['key']] = 0;
                        }
                    })
                    $(_this).text(group_name.join('、'));
                    $(_this).attr('group_key', group_key.join(','));
                    $(_this).attr('keys', fun.formatString(JSON.stringify(keys)));
                    $(_this).data('group', params);
                }
            })
        }, 50)
        return true;
    }
    if (key == 'thfs') {
        var group = $(_this).data('group') || [];
        setTimeout(function () {
            fun.SummaryList({
                list: group,
                choose: function (params) {
                    console.log(params);
                    var group_key = [], group_name = [], keys = {};
                    $(params).each(function (i, obj) {
                        var word = ((params.length == i) ? "" : "");
                        if (obj['choose'] == 1) {
                            group_key.push(obj['columns']);
                            group_name.push(obj['name'] + word);
                            keys[obj['key']] = 1;
                        } else {


                            keys[obj['key']] = 0;
                        }
                    })
                    $(_this).text(group_name.join('、'));
                    $(_this).attr('group_key', group_key.join(','));
                    $(_this).attr('keys', fun.formatString(JSON.stringify(keys)));
                    $(_this).data('group', params);
                }
            })
        }, 50)
        return true;
    }
    if (key == 'zd') {
        var group = $(_this).data('group') || [];
        setTimeout(function () {
            fun.SummaryList({
                list: group,
                choose: function (params) {
                    console.log(params);
                    var group_key = [], group_name = [], keys = {};
                    $(params).each(function (i, obj) {
                        var word = ((params.length == i) ? "" : "");
                        if (obj['choose'] == 1) {
                            group_key.push(obj['columns']);
                            group_name.push(obj['name'] + word);
                            keys[obj['key']] = 1;
                        } else {
                            keys[obj['key']] = 0;
                        }
                    })
                    $(_this).text(group_name.join('、'));
                    $(_this).attr('group_key', group_key.join(','));
                    $(_this).attr('keys', fun.formatString(JSON.stringify(keys)));
                    $(_this).data('group', params);
                }
            })
        }, 50)
        return true;
    }
    if (key == 'input') return true;
    switch (key) {
        case "cp":
            if (isYarn) {
                page_url = page_arr.sx_search; //  纱线搜索
            } else {
                page_url = page_arr.product_search; //  产品搜索
            }
            break;
        case "kh":
        case "gys":
        case "jgs":
        case "wl":
            page_url = page_arr.customer_search; // 客商搜索
            Param['goods_type'] = isYarn ? 'sx' : 'bp';
            break;
        case "jjdw":
        case "cp_jd":
        case "cp_gy":
            page_url = page_arr.select_list;     // 产品工艺
            break;
        case "sx_pp":
        case "sx_dq":
        case "sx_xz":
            page_url = page_arr.select_sx_list; //纱线选择页
            break;
        case 'gg':
            page_url = page_arr.specifications; //规格选择页
            var temp_cp = $('.merchants-content[key="cp"]');
            Param = {
                html_name: html_name,
                cp_title: temp_cp.text(),
                cp_id: temp_cp.attr('id'),
                gg_name: $(_this).text() || '',
                status: 'select_list',
                key: key,
            }
            break;
        case "ck":                               // 仓库搜索
            page_url = page_arr.select_list;
            Param['is_sum'] = $(_this).data('is_sum');
            Param['is_detail'] = $(_this).data('is_detail');
            if (isYarn) {
                Param['type'] = 'sx';
            }
            break;
        case "dcck":                               // 仓库搜索
            page_url = page_arr.select_list;
            if (isYarn) {
                Param['type'] = 'sx';
            }
            break;
        case 'cw':
            page_url = page_arr.select_list; //仓位搜索
            var temp_ck = $('.merchants-content[key="ck"]');
            Param = {
                html_name: html_name,
                ck_title: temp_ck.text(),
                ck_id: temp_ck.attr('id'),
                return_page: html_name,
                page_type: 'cw',
            }
            break;
        case "md":
            page_url = page_arr.select_list;     // 门店搜索
            break;
        case "ywy":
            page_url = page_arr.employee;        // 业务员搜索
            break;
        case 'sx_lb':
        case 'cp_lb':
        case 'kh_lb':
        case 'gys_lb':
        case 'jgs_lb':
        case 'wl_lb':
        case 'fymx_lb':
            if (key == 'cp_lb' && isYarn) {
                Param['page_type'] = 'sx_lb';
            }
            page_url = page_arr.select_type;     // 产品类别搜索
            break;
        case 'ywtz_lb':
            page_url = page_arr.select_list;     // 类别搜索
            break;
        case "zh":
            page_url = page_arr.select_bank_list;     // 往来单位账户搜索
            break;
        case "cp_ys":                            // 产品颜色搜索
            page_url = page_arr.select_list;
            Param['cp_id'] = page_data['cp_id'];
            break;
        case "xz_bm":                            // 选择部门
            if ($("[key='md']").attr('id') == "") {
                return fun.toast('请选择门店。');
            }
            Param['md_id'] = $("[key='md']").attr('id');
            break;
        case "xz_zw":                            // 选择职位
            if ($("[key='xz_bm']").attr('id') == "" || $("[key='xz_bm']").attr('id') == 0) {
                return fun.toast('请选择部门。');
            }
            Param['md_id'] = $("[key='md']").attr('id');
            Param['bm_id'] = $("[key='xz_bm']").attr('id');
            break;
        case "cost":
            Param['obj'] = "cost";
        case "income":
            if (key == 'income') Param['obj'] = "income";
            page_url = page_arr.cost_type;     // 收入类型费用类型搜索
            break;
        case "fans":
            page_url = page_arr.shop_fans;     // 粉丝页面
            break;
    }
    fun.showPageFull({
        page_url: page_url,
        pageParam: Param
    });
}

//选择标签
$('body').on('tap', '.logo-whole', function (e) {
    var label_arr = '0';
    var bq_type = $(this).data('type')
    for (var i = 0; i < $('.pack').length; i++) {
        label_arr += ',' + $('.pack').eq(i).data('list')['id'];
    }
    var params = {
        "return_page": html_name,
        "label_arr": label_arr || '',
        "id": 0,
        "page_type": bq_type,
        "opt": 'append',
        "type": bq_type,
    };
    fun.showPageFull({
        page_url: page_arr.label,
        pageParam: params
    });
});

// $('body').on('tap', '.merchants-content', function () {
//     if ($(this).attr('disabled')) return true;
//     var key = $(this).attr('key');
//     var _this = $(this);
//     var Param = {
//         "return_page": html_name,
//         "page_type": key
//     };
//     var page_url = page_arr.select_list;
//     if (key == 'hz') {
//         var group = $(this).data('group') || [];
//         setTimeout(function(){
//             fun.SummaryList({
//                 list: group,
//                 choose: function (params) {
//                     var group_key = [], group_name = [], keys = {};
//                     $(params).each(function (i, obj) {
//                         var word = ((params.length == i) ? "" : "");
//                         if (obj['choose'] == 1) {
//                             group_key.push(obj['columns']);
//                             group_name.push(obj['name'] + word);
//                             keys[obj['key']] = 1;
//                         } else {
//                             keys[obj['key']] = 0;
//                         }
//                     })
//                     $(_this).text(group_name.join('、'));
//                     $(_this).attr('group_key', group_key.join(','));
//                     $(_this).attr('keys', JSON.stringify(keys));
//                     $(_this).data('group',params);
//                 }
//             })
//         },50)
//         return true;
//     }
//     if (key == 'input') return true;
//         switch (key) {
//             case "cp":
//                 page_url = page_arr.product_search; //  产品搜索
//                 break;
//             case "kh":
//             case "gys":
//             case "jgs":
//             case "wl":
//                 page_url = page_arr.customer_search; // 客商搜索
//                 break;
//             case "jjdw":
//             case "cp_jd":
//             case "cp_gy":
//                 page_url = page_arr.select_list;     // 产品工艺
//                 break;
//             case "ck":                               // 仓库搜索
//                 page_url = page_arr.storehouse;
//                 break;
//             case "md":
//                 page_url = page_arr.select_list;     // 门店搜索
//                 break;
//             case "ywy":
//                 page_url = page_arr.employee;        // 业务员搜索
//                 break;
//             case 'cp_lb':
//             case 'kh_lb':
//             case 'gys_lb':
//             case 'jgs_lb':
//             case 'wl_lb':
//             case 'fymx_lb':
//                 page_url = page_arr.select_type;     // 产品类别搜索
//                 break;
//             case 'ywtz_lb':
//                 page_url = page_arr.select_list;     // 类别搜索
//                 break;
//             case "zh":
//                 page_url = page_arr.select_bank_list;     // 往来单位账户搜索
//                 break;
//             case "cp_ys":                            // 产品颜色搜索
//                 page_url = page_arr.select_list;
//                 Param['cp_id'] = page_data['cp_id'];
//                 break;
//             case "xz_bm":                            // 选择部门
//                 if ($("[key='md']").attr('id') == "") {
//                     return fun.toast('请选择门店。');
//                 }
//                 Param['md_id'] = $("[key='md']").attr('id');
//                 break;
//             case "xz_zw":                            // 选择职位
//                 if ($("[key='xz_bm']").attr('id') == "") {
//                     return fun.toast('请选择部门。');
//                 }
//                 Param['md_id'] = $("[key='md']").attr('id');
//                 Param['bm_id'] = $("[key='xz_bm']").attr('id');
//                 break;
//             case "cost":
//                 Param['obj'] = "cost";
//             case "income":
//                 if(key == 'income') Param['obj'] = "income";
//                 page_url = page_arr.cost_type;     // 收入类型费用类型搜索
//                 break;
//         }
//         fun.showPageFull({
//             page_url: page_url,
//             pageParam: Param
//         });
// })

//清除客商选中值
$('body').on('tap', '.icon-close', function () {
    if ($(this).prev().attr('disabled')) return;
    var key = $(this).prev().attr('key');
    if (key == 'md') {
        if ($('.merchants-content[key="xz_bm"]').length) $('[key="xz_bm"]').text('').attr('id', '').next('.list-icon').removeClass('icon-close').addClass('icon-youfanhui');
        if ($('.merchants-content[key="xz_zw"]').length) $('[key="xz_zw"]').text('').attr('id', '').next('.list-icon').removeClass('icon-close').addClass('icon-youfanhui');
    } else if (key == 'xz_bm') {
        if ($('.merchants-content[key="xz_zw"]').length) $('[key="xz_zw"]').text('').attr('id', '').next('.list-icon').removeClass('icon-close').addClass('icon-youfanhui');
    }
    if (key == 'cp') {
        if ($('.merchants-content[key="gg"]').length) $('[key="gg"]').text('').attr('id', '').next('.list-icon').removeClass('icon-close').addClass('icon-youfanhui');
    }
    $(this).prev().text('');
    $(this).prev().attr('id', '');
    $(this).removeClass('icon-close').addClass('icon-youfanhui');//存在值则显示删除按钮
})

//选择客商类型
$('body').on('touchend', '#switch_merchants', function (e) {
    var merchants_list = $(this).data('merchants-list');
    var _this = $(this);
    fun.showBookList({
        list: merchants_list,
        choose: function (res) {
            $(_this).next().text('');
            $(_this).children('span').text(res['name']);
            $(_this).next().attr('key', res['column']);
            $(merchants_list).each(function (i, arr) {
                if (arr['column'] == res['column']) {
                    arr['is_choose'] = 1;
                } else {
                    arr['is_choose'] = 0;
                }
            })
            $(_this).attr('merchants-list', fun.formatString(JSON.stringify(merchants_list)));
        }
    })
    e.preventDefault();
})
/**
 * 重置所有条件
 */
function reset() {
    var data = getSeachData();
    init(data);
}
/**
 * 统计所有条件并发送
 */
function search() {
    var data = {};
    var start = !!$("#begin_date").val() ? fun.Date($("#begin_date").val()).getTime() : 0,
        end = !!$("#end_date").val() ? fun.Date($("#end_date").val()).getTime() : 0;
    if (start > end) {
        return fun.toast('开始日期不能大于结束日期!');
    }
    $.each($('.module:visible'), function (i, obj) {
        var elem = $(obj), key = $(obj).attr('id');
        switch (key) {
            case "keywords":
                if (elem.find('input').val().trim()) data[elem.find('input').attr('key')] = elem.find('input').val().trim();
                break;
            case "dh_wrap":
                if (elem.find('input').val().trim()) data[elem.find('input').attr('key')] = elem.find('input').val().trim();
                break;
            case "time":
                data['begin_date'] = $('#begin_date').val().trim();
                data['end_date'] = $('#end_date').val().trim();
                break;
            case "stock_input":
                $.each(elem.find('.stock_content'), function (k, list) {
                    data[$(list).attr('key')] = {
                        id: $(list).attr('key'),
                        text: $(list).val()
                    };
                });
                break;    
            case 'choose_merchants':
                $.each(elem.find('.merchants-content'), function (k, list) {
                    switch ($(list).attr('key')) {
                        case "hz":
                            var choose_val = {}, group_result = [], group = $(list).data('group') || [];
                            $(group).each(function (i, obj) {
                                ((obj['choose'] == 1) ? choose_val[obj['key']] = 1 : choose_val[obj['key']] = 0);
                                (obj['choose'] == 1 && group_result.push(obj['columns']));
                            })
                            data['hz'] = {
                                group: ($(list).attr('group_key') || group_result.join(',') || ""),
                                text: $(list).text(),
                                choose: JSON.parse($(list).attr('keys') || fun.formatString(JSON.stringify(choose_val)) || "{}")
                            };
                            break;
                        case "thfs":
                            var choose_val = {}, group_result = [], group = $(list).data('group') || [];
                            $(group).each(function (i, obj) {
                                ((obj['choose'] == 1) ? choose_val[obj['key']] = 1 : choose_val[obj['key']] = 0);
                                (obj['choose'] == 1 && group_result.push(obj['columns']));
                            })
                            data['thfs'] = {
                                group: ($(list).attr('group_key') || group_result.join(',') || ""),
                                text: $(list).text(),
                                choose: JSON.parse($(list).attr('keys') || fun.formatString(JSON.stringify(choose_val)) || "{}")
                            };
                            break;
                        case "zd":
                            var choose_val = {}, group_result = [], group = $(list).data('group') || [];
                            $(group).each(function (i, obj) {
                                ((obj['choose'] == 1) ? choose_val[obj['key']] = 1 : choose_val[obj['key']] = 0);
                                (obj['choose'] == 1 && group_result.push(obj['columns']));
                            })
                            data['zd'] = {
                                group: ($(list).attr('group_key') || group_result.join(',') || ""),
                                text: $(list).text(),
                                choose: JSON.parse($(list).attr('keys') || fun.formatString(JSON.stringify(choose_val)) || "{}")
                            };
                            break;
                        case "kh":
                        case "gys":
                        case "jgs":
                        case "wl":
                            if ($('#switch_merchants').length > 0) {
                                var merchants_list = $('#switch_merchants').data('merchants-list');
                                $(merchants_list).each(function (index, arr) {
                                    if (arr['column'] == $(list).attr('key')) {
                                        data['merchants'] = {
                                            wldw_id: $(list).attr('id'),
                                            wldw_mc: $(list).text(),
                                            list: merchants_list
                                        };
                                    }
                                })
                                return;
                            }
                            data[$(list).attr('key')] = {
                                id: $(list).attr('id'),
                                text: $(list).text()
                            };
                            break;
                        case "input":
                            data[$(list).attr('key')] = {
                                value: $('#lsfx_ts').val(),
                            };
                            break;
                        case "dd_dh":
                            data[$(list).attr('key')] = {
                                value: $('#dd-dh').val(),
                            };
                            break;
                        case "bq":
                            var label_arr = '0';
                            for (var i = 0; i < $('.pack').length; i++) {
                                label_arr += ',' + $('.pack').eq(i).data('list')['id'];
                            }
                            data[$('.logo-whole').attr('key')] = {
                                value: label_arr
                            }
                            break;
                        default:
                            data[$(list).attr('key')] = {
                                id: $(list).attr('id'),
                                text: $(list).text()
                            };
                            break;
                    }
                });
                break;
            case 'xs':
                $.each(elem.find('.select-input'), function (s, obj_sort) {
                    var keys_val = JSON.parse($('.select-input').eq(s).attr('keys'));
                    data[elem.find('.select-input').eq(s).attr('key')] = {
                        type: $('.select-input').eq(s).data('type'),
                        text: $('.select-input').eq(s).val(),
                        keys: keys_val,
                    }
                });
                break;
            case "sort":
                $.each(elem.find('.sort_btn'), function (s, obj_sort) {
                    var result = '';
                    if (elem.find('.sort_btn').eq(s).attr('index') === '2') result = 'asc';
                    if (elem.find('.sort_btn').eq(s).attr('index') === '3') result = 'desc';
                    data[elem.find('.sort_btn').eq(s).attr('key')] = result;

                });
                break;
            case "switch":
                $.each(elem.find('.nui-switch'), function (w, obj_switch) {
                    data[elem.find('.nui-switch').eq(w).attr('key')] = elem.find('.nui-switch').eq(w).hasClass('nui-active') ? 1 : 0;
                    if ($('.birthday').length > 0) {
                        elem.find('.nui-switch').eq(w).prev().find('.birthday').val();
                        data[elem.find('.nui-switch').eq(w).attr('key') + '_val'] = $('.birthday').val() || "";
                    }
                });
                break;
            case "type":
            case "analysis":
                var temp = {};
                $.each(elem.find('.nui-switch'), function (x, obj) {
                    temp[$(obj).attr('key')] = ($(obj).hasClass('nui-active') ? 1 : 0);
                })
                data[key] = temp;
                break;
            case "group":
                $.each(elem.find('.btn_type'), function (g, obj_group) {
                    data[elem.find('.btn_type').eq(g).attr('key')] = elem.find('.btn_type').eq(g).hasClass('main-color') ? 1 : 0;
                });
                break;
        }
    });
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'search',
            'data': data
        }
    });
    fun.closeFrame();
}

/* 数据分析reset方法 */
// function sjfxReset() {
//     var data = {};
//     $('#begin_date').val(page_data['reset']['begin_date']);
//     $('#end_date').val(page_data['reset']['end_date']);
//     data['begin_date'] = $('#begin_date').val().trim();
//     data['end_date'] = $('#end_date').val().trim();
//     switch (page_data['type']) {
//         case 'shop_store_dd': // 商城订单
//             $('[key="fans"]').attr('id', '').text('').next('.list-icon').removeClass('icon-close').addClass('icon-youfanhui');
//             $('#dd-dh').val('');
//             break;
//         case 'shop_dp_fkfx': // 访客分析
//         case 'shop_dp_xsqk': // 销售情况
//         case 'shop_dp_nyjl': // 拿样记录
//             $('.merchants-content').text('');
//             break;
//         case 'shop_xq_fx': // 兴趣分析
//             // ...code
//             break;
//         // 没有default
//     }

//     api.sendEvent({
//         name: page_data['return_page'],
//         extra: {
//             status: 'reset',
//             data: data
//         }
//     })
//     fun.closeFrame();
// }

function getSeachData() {
    var data = search_data;
    $.each($('.module:visible'), function (i, obj) {
        var elem = $(obj), key = $(obj).attr('id');
        switch (key) {
            case "keywords":
                data['keywords']['value'] = '';
                break;
            case "dh_wrap":
                data['dh_wrap']['value'] = '';
                break;
            case "time":
                var date = fun.getMonthArr(1);
                date[0]['begin_date'] = String(date[0]['begin_date']).replace(/['.']/g, '-');
                date[0]['end_date'] = String(date[0]['end_date']).replace(/['.']/g, '-');
                data['time']['begin_date'] = date[0]['begin_date'];
                data['time']['end_date'] = date[0]['end_date'];
                switch (page_data['type']) {
                    case 'shop_dp_fkfx':
                    case 'shop_dp_xsqk':
                    case 'shop_dp_nyjl':
                    case 'shop_xq_fx':
                        data['time']['begin_date'] = page_data['reset']['begin_date'];
                        data['time']['end_date'] = page_data['reset']['end_date'];
                        break;
                }
                break;
            case 'stock_input':
                    var choose = data['stock_input'];
                    for (var j = 0; j < choose.length; j++) {
                        choose[j]['value'] = '';
                    }
                break;    
            case 'choose_merchants':
                $.each(elem.find('.merchants-content'), function (k, list) {
                    var choose = data['choose_merchants'];
                    switch ($(list).attr('key')) {
                        case "hz":
                            for (var j = 0; j < choose.length; j++) {
                                if (choose[j]['key'] == 'hz') {
                                    var group = $(list).data('group') || [];
                                    choose[j]['group'] = group;
                                    choose[j]['value'] = $(list).text();
                                }
                            }
                            break;
                        case 'jjcd':
                            for (var j = 0; j < choose.length; j++) {
                                if (choose[j]['key'] == 'jjcd') {
                                    choose[j]['list'] = '';
                                    choose[j]['id'] = '';
                                    choose[j]['value'] = '';
                                }
                            }
                            break;
                        case 'sx_jjcd':
                            for (var j = 0; j < choose.length; j++) {
                                if (choose[j]['key'] == 'sx_jjcd') {
                                    choose[j]['list'] = '';
                                    choose[j]['id'] = '';
                                    choose[j]['value'] = '';
                                }
                            }
                            break;
                        case "bq":
                            for (var j = 0; j < choose.length; j++) {
                                if (choose[j]['key'] == 'bq') {
                                    choose[j]['value_arr'] = '0';
                                }
                            }
                            break;
                        case 'fans':
                            switch (page_data['type']) {
                                case 'shop_store_dd':
                                    for (var j = 0; j < choose.length; j++) {
                                        var key = choose[j]['key'];
                                        if (key === 'fans') {
                                            choose[j]['id'] = '';
                                            choose[j]['value'] = '';
                                        } else if (key == 'dd_dh') {
                                            choose[j]['id'] = '';
                                            choose[j]['value'] = '';
                                        }
                                    }
                                    $('[key="fans"]').attr('id', '').text('').next('.list-icon').removeClass('icon-close').addClass('icon-youfanhui');
                                    // $('#dd-dh').val('');
                                    break;
                            }
                            break;
                        default:
                            for (var j = 0; j < choose.length; j++) {
                                if (choose[j]['key'] == $(list).attr('key')) {
                                    choose[j]['id'] = '';
                                    choose[j]['value'] = '';
                                }
                            }
                            break;
                    }
                });
                break;
            case 'xs':
                var xs = data['xs'][0];
                var text_arr = [], xsType = [];
                console.log(JSON.stringify(xs))
                if (xs['key'] == 'djlx') {
                    for (var j = 0; j < xs['list'].length; j++) {
                        text_arr.push(xs['list'][j]['name']);
                        xsType.push(xs['list'][j]['column']);
                        xs['list'][j]['is_choose'] = 1
                    }
                    xs['value'] = text_arr.join('、');
                    xs['xsType'] = xsType.join(',');
                } else if (xs['key'] == 'xs') {
                    $.each(elem.find('.select-input'), function (s, obj_sort) {
                        data['xs'][s]['value'] = $('.select-input').eq(s).val();
                        data['xs'][s]['xsType'] = $('.select-input').eq(s).data('type');
                    });
                    // for (var j = 0; j < xs['list'].length; j++) {
                    //     if (xs['list'][j]['column'] == 'kys') {
                    //         if(xs['list'][j]['is_choose'] === 1){
                    //             text_arr.push(xs['list'][j]['name']);
                    //             xsType.push(xs['list'][j]['column']);
                    //             xs['list'][j]['is_choose'] = 1
                    //         }
                    //     } else {
                    //         xs['list'][j]['is_choose'] = 0;
                    //     }
                    // }
                    // xs['value'] = text_arr.join('');
                    // xs['xsType'] = xsType.join('');
                } else if (xs['key'] == 'yjfs') {
                    $.each(elem.find('.select-input'), function (s, obj_sort) {
                        data['xs'][s]['value'] = $('.select-input').eq(s).val();
                        data['xs'][s]['xsType'] = $('.select-input').eq(s).data('type');
                    });
                }

                break;
            case "sort":
                for (var j = 0; j < data['sort'].length; j++) {
                    data['sort'][j]['value'] = '';
                }
                break;
            case "switch":
                $.each(elem.find('.nui-switch'), function (w, obj_switch) {
                    $.each(data['switch'], function (m, obj_m) {
                        if (data['switch'][m]['key'] == elem.find('.nui-switch').eq(w).attr('key')) {
                            data['switch'][w]['value'] = elem.find('.nui-switch').eq(w).hasClass('nui-active') ? 1 : 0;
                        }
                    })
                });
                break;
            case "type":
            case "analysis":
                $.each(data['type'], function (x, obj) {
                    if (data['type'][x]['text'] == '数量') {
                        data['type'][x]['value'] = 1;
                    } else {
                        data['type'][x]['value'] = 0;
                    }
                })
                break;
            // case "group":
            //     $.each(elem.find('.btn_type'), function (g, obj_group) {
            //         data[elem.find('.btn_type').eq(g).attr('key')] = elem.find('.btn_type').eq(g).hasClass('main-color') ? 1 : 0;
            //     });
            //     break;
        }
    });
    return data;
}

function updateRow(data) {
    data = $.extend({}, { del_id: [], up: [] }, data);
    var obj = $('[key="' + data['page_type'] + '"]');
    var row_id = $(obj).attr('id') || 0;
    //删除
    if (data['del_id'].length != 0) {
        data['del_id'] = convert(data['del_id']);
        if (data['del_id'].indexOf(row_id) > -1) {
            $(obj).attr('id', 0).text("");
            $(obj).next().removeClass('icon-close').addClass('icon-youfanhui');
        }
    }
    //修改
    if (data['up'].length != 0) {
        for (var i = 0; i < data['up'].length; i++) {
            if (data['up'][i]['id'] == row_id) $(obj).attr('id', data['up'][i]['id']).text(data['up'][i]['name'] || "");
        }
    }

    //数组值转字符串
    function convert(arr) {
        return String(arr).split();
    }
}

// 20191214
$('body').on('tap', '.nui-switch[key="xsmx"]', function (e) {
    e.stopPropagation();
    if ($(this).hasClass('nui-active')) {
        $('.nui-switch[key="hldj"]').parent().show();
    } else {
        $('.nui-switch[key="hldj"]').parent().hide();
    }
});


/*
示例:
{
	"keywords": {
        "key": "LIKE_DATA",
        "value": "",
        "placeholder": "这是默认值"
    },
	"sort": [
        {"text": "金额", "key": "JE_SORT", "value": "desc"},
        {"text": "库存", "key": "KC_SORT", "value": ""}
    ],
    "time": {"begin_date": "2017-01-02", "end_date": "2017-01-31"},
    "choose_merchants":[
    	{key:"kh","text":"客户","value":"123"},
    	{key:"gys","text":"供应商","value":"1231122"}
    ],
    'type':[
    	{key:"money","text":"金额","value":0},
    	{key:"number","text":"匹数","value":1}
    ],
    'analysis':[
    	{key:"money","text":"金额","value":0},
    	{key:"number","text":"数量","value":1}
    ],
    "switch": [
    	{"text": "隐藏库存","max_width":false,"key": "ck_hidezero", "value": 1},
    	{"text": "隐藏停用","max_width":false,"key": "hide_disable", "value": 0}
	],
    "group": [
        {"text": "联系人", "key": "BXR_GROUP", "value": 1},
        {"text": "账户", "key": "YHZH_GROUP", "value": 0}
    ]
}

 */
// var page_data = {};
//     page_data['search_data'] = {
//
//        "keywords": {
//            "key": "LIKE_DATA",
//            "value": "",
//            "placeholder": "这是默认值"
//        },
//        "sort": [
//            {"text": "金额", "key": "JE_SORT", "value": "desc"},
//            {"text": "库存", "key": "KC_SORT", "value": ""}
//        ],
//        "time": {"begin_date": "2017-01-02", "end_date": "2017-01-31"},
//        "choose_merchants":[
//            {key:"kh","text":"客户","value":"123"},
//            {key:"gys","text":"供应商","value":"1231122"}
//        ],
//        'type':[
//            {key:"money","text":"金额","value":0},
//            {key:"number","text":"匹数","value":1}
//        ],
//        'analysis':[
//            {key:"money","text":"金额","value":0},
//            {key:"number","text":"数量","value":1}
//        ],
//        "switch": [
//            {"text": "隐藏库存","max_width":false,"key": "ck_hidezero", "value": 1},
//            {"text": "天内生日","max_width":true,"input":true,"input_value":"30","key": "birthday", "value": 0},
//        ],
//        "group": [
//            {"text": "联系人", "key": "BXR_GROUP", "value": 1},
//            {"text": "账户", "key": "YHZH_GROUP", "value": 0}
//        ]
//     }
//
//     init();
