var html_name = page_arr.select_bank_list;
var page_url, page_title;
var KHH_LIST = [];

var search_data = {keyword:''};

function judgeAuth() {
    var auth_name = '';
    switch (page_data['page_type']) {
        case 'zh':
            auth_name = 'zh';
            break;
        case "dfzh":
            break;
    }

    if (!!auth_name) {
        return Auth.check(auth_name, 'edit');
    }

    return true;
}

page_init = function () {
    //ios头部穿透
    // fun.pierceThrough('.account-list');
    KHH_LIST = fun.getItem('khh_list') || [];
    switch (page_data['page_type']) {
        case "zh":
            page_url = AJAX_URL.getBankList;//含简称
            page_title = "账户";
            getList();
            break;
        case "dfzh":
            page_title = "对方账户";
            fun.getWldwSubInfo({
                'wldw_id': page_data['wldw_id'] || 0,
                'sj': page_data['date'] || "",
                'ljqk': 1,
                'zh': 1,
                'callback': function (res) {
                    showList(res['zh'] || []);
                }
            });
            break;
    }

    $('#header').header({
        back: true,
        add: judgeAuth(),
        title: page_title,
        foot_input: {
            show: true,
            plader: '搜索'
        },
    });

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'refresh':
                getList();
                break;
            case 'select_list':
                var data = temp['data'];
                $('#bank_khh').val(data['list_data']['name']).data({
                    'bank_list_id': data['list_data']['id'] || 0,
                    'icon': data['list_data']['icon'],
                    'name': data['list_data']['name']
                });
                data['list_data']['icon'] && $('.edit_imgs').attr('src', '../img/bank/' + data['list_data']['icon']);
                break;
        }
    });

    fun.orderListHeight({dom:'#list'});
}

// function __touchStartSearch(){
//     return $('.middle_show_contents').css('marginTop',0);
// }

function xzzh(option) {
    options = $.extend({
        title: '新增账户',
        data: null,
    }, option)
    var data = options['data'];
    var html = [];
    html.push('<div class="warms">');
    html.push('<div class="warms-content" style="max-height:auto;min-height:auto;">');
    html.push('<div class="warms-title">');
    html.push('<span class="title">' + options.title + '</span>');
    html.push('</div>');
    html.push('<div class="warms-con">');
    html.push('<ul>');
    html.push('<li class="obj-title"><i>开户行</i>');
    html.push('<input id="bank_khh" class="bank-khh" type="text" name="obj-type" readonly="readonly" value="" data-name="" data-icon="" data-bank_list_id="">');
    html.push('<img src="" alt="" class="edit_imgs"><span class="bankN"></span>');
    html.push('</li>');
    html.push('<li class="obj-title"><i>卡号</i>');
    html.push('<input id="bank_card" class="bank-ipt" type="text" name="obj-card" value="" maxlength="19">');
    html.push('</li>');
    html.push('<li class="obj-title"><i>开户人</i>');
    html.push('<input id="bank_khr" class="bank-ipt" type="text" name="obj-person" value="">');
    html.push('</li>');
    html.push('</ul>');
    html.push('</div>');
    html.push('</div>');
    html.push('</div>');

    fun.dialog({
        content: html.join(''),
        btn: ['保存', '取消'],
        isClose: false,
        style: 'width: 85%; padding-top:0.3rem; border:none; background: #fff; border-radius: 0.5rem; ',//position: absolute; top: 30%; left: 7.5%;
        success: function () {
            $('#bank_khh').on('tap', function (e) {
                e.stopPropagation();
                var page_url = page_arr.select_bank;
                fun.showPageFull({
                    page_url: page_url,
                    pageParam: {
                        "page_type": 'xz_zh',
                        "return_page": html_name
                    }
                });
            });
            $('body').on('input', '#bank_card', function (e) {
                this.value = this.value.replace(/[^\d]/g, '');
            });
            $('body').on('blur', '#bank_card', function (e) {
                var len = $(this).val().length;
                // if (len != 0 && len < 15) {
                //     return fun.toast('卡号不能小于16位数字。');
                // }
            })
            // $('body').on('keyup', '#bank_card', function (e) {
            //     var len = $(this).val().length;
            //     if (e.keyCode != 8) {//vk_back(8)退回键
            //         // if (len > 18) {
            //         //     var val = $(this).val().substring(0, 18);
            //         //     $(this).val(val);
            //         //     return fun.toast('卡号不能超过19位数字。');
            //         // }
            //     }
            // })
        },
        yes: function () {
            if ($('#bank_khh').val().trim() == '') return fun.toast('开户行不能为空。');
            if ($('#bank_card').val().trim() == '') return fun.toast('卡号不能为空。');
            // if ($('#bank_card').val().length < 15) return fun.toast('卡号不能小于16位数字。');
            var saveZh = {};
            saveZh['merchant_id'] = page_data['wldw_id'] || 0;
            saveZh['bank_list_id'] = $('#bank_khh').data('bank_list_id');
            saveZh['name'] = $('#bank_khh').val().trim() || '';
            saveZh['card_number'] = $('#bank_card').val().trim() || '';
            saveZh['people'] = $('#bank_khr').val().trim() || '';
            saveZh['zh_tb'] = $('#bank_khh').data('icon') || '';
                saveZh['remark'] = '';

            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.saveKsZh,
                data: saveZh,
                success: function (res) {
                    if (res['status'] == 0) {
                        fun.getWldwSubInfo({
                            'wldw_id': page_data['wldw_id'] || 0,
                            'sj': page_data['date'] || "",
                            'ljqk': 1,
                            'zh': 1,
                            'callback': function (res) {
                                showList(res['zh'] || []);
                            }
                        });
                        layer.closeAll();
                    } else {
                        fun.toast(res['msg']);
                    }
                }
            })
        }
    })
}

function getList(params) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: page_url,
        data: $.extend({}, {
            "keyword": "",
            "keyword_key": ['name','simple'],
            "is_stop": 0
        }, params),
        success: function (res) {
            if(res['status'] == 0){
                if(res['data'].length == 0){
                    $('.content').css({'height': 'auto', 'position': 'fixed'});
                    // return $('#list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#list',btnText:'新增账户',style:'top:0.5rem;',isDa:true,auth:'zh'});
                }else {
                    $('.content').css({'height': 'auto', 'position': 'unset'});
                }
                showList(res.data);
            } else {
                fun.alert({msg: '网络异常！'});
            }
        }
    })
}

function showList(data) {
    if(data.length == 0){
        // $('.content').css({'height': 'calc(100% - 6.7rem)', 'position': 'fixed'});
        // return $('#list').html('<p class="empty_text">暂无数据！</p>');
        return fun.createDataEmptyTips({dom:'#list',btnText:'新增账户',style:'top:0.5rem;',isDa:true,auth:'zh'});
    }else {
        // $('.content').css({'height': 'auto', 'position': 'relative'});
    }
    var html = [];
    $(data).each(function (i, obj) {
        var icon = fun.getValByKey(KHH_LIST, obj['bank_list_id'], 'icon');
        switch (page_data['page_type']) {
            case "zh":
                html.push('<li data-list_data=\'' + fun.formatString(JSON.stringify(obj)) + '\' id="' + (obj['id'] || 0) + '" name="' + fun.is_value(obj['name']) + '" class="account-list lower-border-line">');
                html.push('    <img src="../img/bank/' + obj['icon'] + '" class="bank">');
                html.push('    <span class="summary">' + fun.redFont(fun.is_value(obj['name']),search_data['keyword']||'') + '</span>');
                // html.push('    <div class="vessel">');
                // html.push('        <span class="text">公户</span>');
                // html.push('  </div>');
                html.push('</li>');
                break;
            case "dfzh":
                html.push('<li data-list_data=\'' + fun.formatString(JSON.stringify(obj)) + '\' id="' + (obj['id'] || 0) + '" name="' + (fun.is_value(obj['yh'])) + '" icon="' + icon + '" class="account-list lower-border-line">');
                html.push('    <img src="../img/bank/' + icon + '" class="bank">');
                html.push('    <span class="summary dfzh-width">' + fun.redFont(fun.is_value(obj['yh']) + ' ' + fun.is_value(obj['card_number']),search_data['keyword']||'') + '</span>');
                // html.push('    <div class="vessel">');
                // html.push('        <span class="text">公户</span>');
                // html.push('  </div>');
                html.push('</li>');
                break;
        }
    })
    $('#list').html(html.join(''));
}

//点击键盘搜索
$("body").bind('search', '#foot_search', function () {
    search_data['keyword'] = $('#foot_search').val().trim();
    if (page_data['page_type'] == "dfzh") {
        fun.getWldwSubInfo({
            'wldw_id': page_data['wldw_id'] || 0,
            'sj': page_data['date'] || "",
            'ljqk': 1,
            'zh': 1,
            "keyword": $('#foot_search').val().trim(),
            'callback': function (res) {
                showList(res['zh'] || []);
            }
        });
    } else {
        $('#list').empty();
        getList({
            "keyword": $('#foot_search').val().trim()
        });
    }
});

//添加按钮
$('body').on('tap', '#add_btn', function () {
    switch (page_data['page_type']) {
        case 'zh':
            fun.showPageFull({
                page_url: page_arr.account_add,
                pageParam: {
                    "return_page": html_name,
                    "status": 'add',
                    "page_type": page_data.page_type
                }
            });
            break;
        case 'dfzh':
            xzzh();
            break;
    }

});


// //员工编辑
// $('#add_btn').on('tap',function(){
//
// });

// 返回选中值
$('body').on('tap', '.account-list', function () {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'select_list',
            'data': {
                "id": $(this).attr('id'),
                "select_val": $(this).attr('name'),
                "page_type": page_data['page_type'],
                "list_data": $(this).data('list_data'),
                "page_name": page_data['page_name'] || '',
                "icon": (page_data['page_type'] == "dfzh") ? $(this).attr('icon') : undefined
            }
        }
    });
    api.closeWin();
})
