var html_name = page_arr.select_type,
    page_type = '',
    UPDATE = { del_id: [], up: [] };
var all = [],
    edits = [],
    return_data = [];//数据
var auth_var = [];
var class_val = {};

function judegAuth() {
    var auth_name = '';
    switch (page_data.page_type) {
        case 'fymx_lb':
            auth_name = 'fymx';
            break;
        default:
            auth_name = page_data['page_type'].split("_lb").join("");
            break;
    }

    if (!!auth_name) {
        return Auth.check(auth_name, 'edit');
    }

    return true;
}

page_init = function () {
    //ios头部穿透
    // fun.pierceThrough('.account-list');
    // console.log('page_data', page_data)
    switch (page_data.page_type) {
        case 'fymx_lb': //费用明细
            page_type = "fymx_lb";
            break;
        default:
            page_type = page_data['page_type'].split("_lb").join("");
            break;
    }
    $('#header').header({
        back: true,
        title: '类别',
        add: judegAuth(),
        appendBackBtnEvt: updatePrevPage
    });
    page_data.keyback = updatePrevPage;//  监听返回键
    getData(page_type);

    if (page_data['page_status'] == 'class_edit') {
        $('#add_btn').hide()
    }
    //iphoneX适应
    $('.content').css('padding-bottom', api.safeArea.bottom + 'px');
}

function addData(param) {
    var list_id, placeholder;
    var obj = $(param['obj']).parent().parent(),//获得对象
        pt = $(obj).attr('ptype') || 0,
        stype = $(obj).attr('stype') || param['stype'],
        type = $(obj).attr('type') || param['type'];

    if ($(param['obj']).hasClass("icon-jia") || $(param['obj']).hasClass("icon-tianjia")) {
        placeholder = '新增类别';
        list_id = 0;
        edits['parent_id'] = stype;
        //  if(page_data['page_type'] != 'cp_lb') getNumber(type,st);
    } else if ($(param['obj']).hasClass("edit-btn")) {
        placeholder = '修改类别';
        list_id = $(obj).attr('id');
        edits['parent_id'] = edits['parent_id'];
    }
    if (param['state'] == 'edit') {
        getInfo({
            'id': $(obj).attr('id'),
            'type': type,
            'status': 'edit'
        });
    }
    var style = [
        '<div style="display:inline-block;width:100%;height:6rem;" >',
        '   <span class="title">' + placeholder + '</span>',
        '   <input type="text" class="input-box" name="type" id="type" style="color: #333;"/></li>',
        '</div>'
    ].join('');
    fun.dialog({
        content: style,
        btn: ['保存', '取消'],
        isClose: false,
        success: function () {
            document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
            setTimeout(function () {
                $('#type').select();
            }, 300);
        },
        yes: function () {
            var name = $("#type").val().trim();
            var params_data = {
                "save_type": "saveClass",
                "type": page_type,
                "id": list_id,
                "name": name,
                "parent_id": edits['parent_id']
            };

            switch (param['state']) {
                case 'add':
                    if (!$('#type').val()) {
                        return fun.toast('请输入类别！');
                    } else if (typeExist(param['obj'], name)) {
                        return fun.toast("【" + name + "】已存在！");
                    } else {
                        $('.empty-tips-wrap').remove();
                        saveData(params_data);
                        layer.closeAll();
                    }
                    break;
                case 'edit':
                    var names = edits['name'];
                    if (!name) {
                        return fun.toast('请输入类别！');
                    } else {
                        params_data['callback'] = function () {
                            UPDATE['up'].push({
                                "id": params_data['id'] || 0,
                                "name": params_data['name'] || ""
                            });
                            param['obj'].siblings('.color-number').text(params_data['name']);
                            param['obj'].parents("[name='" + names + "']").attr('name', params_data['name']);
                            layer.closeAll();
                        }
                        saveData(params_data);
                    }
                    // else if(!!$("[name='" + name + "']").attr('stype')){
                    //     return fun.toast("修改失败，该类别已存在！");
                    // }
                    // else if(typess && typess != names){

                    // }
                    break;
            }
            document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        },
        no: function () {
            document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        }
    });
}

var info_list = []

function getData(page_type) {
    var ajax_url, search_data;
    switch (page_type) {
        case 'sx':
        case 'cp':
        case 'kh':
        case 'gys':
        case 'jgs':
        case 'wl':
        case 'fymx_lb':
            ajax_url = AJAX_URL.getSimpleRecordList;
            break;
        default:
            break;
    }
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: ajax_url,
        data: {
            type: page_type
        },
        success: function (res) {
            if (res.status != 0) return fun.toast('该数据不存在！');
            info_list = res.data;
            showData(getAllSon(ceilFormat(sortByKey(info_list))));
        }
    });
}

//如果是选择产品类型时，点击返回数据
$('body').on('tap', '.account-list', function (e) {
    e.stopPropagation();
    if (page_data.page_status != 'class_edit') {
        if (!!page_data.page_type) {
            var data = {
                'id': $(this).attr('id'),
                "page_type": page_data['page_type'],
                "select_val": $(this).attr('name'),
                "list_data": {
                    "id": $(this).attr('id'),
                    "type": $(this).attr('type'),
                    "name": $(this).attr('name'),
                    "number": "",
                    "simple": $(this).children('.le').attr('simple'),
                    "parent_id": $(this).attr('ptype'),
                    "sort": $(this).children('.le').attr('sort'),
                    "remark": "",
                    "config": [],
                    "is_default": 0,
                    "is_stop": 0,
                    "is_sys": 0,
                    "is_delete": 0,
                    "is_has": 9,
                    "create_time": $(this).children('.le').attr('create_time'),
                    "update_time": $(this).children('.le').attr('update_time')
                }
            }
            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    'status': 'select_list',
                    'data': data
                }
            });
            api.closeWin();
        }
    } else {
        var id = $(this).attr('id');
        class_edits(id)
    }

});

$('body').on('tap', '.edit-btn', function (e) {
    e.stopPropagation();
    var _this = $(this);
    addData({
        "state": "edit",
        "obj": _this
    });
});

$('body').on('tap', '#add_btn', function () {
    var _this = $(this);
    addData({
        "state": "add",
        "obj": _this,
        "type": page_type,
        "stype": 0
    });
});

$('body').on('tap', ".icon-tianjia", function (e) {
    e.stopPropagation();
    var _this = $(this);
    addData({
        "state": "add",
        "obj": _this
    });
});

//删除
// $('body').on('tap','li .delete-btn' ,function(e) {
//   e.stopPropagation();
//   var stype,ptype;
//   var objs=$(this).parent().parent();//获得对象
//   fun.dialog({
//       content:'是否要删除所选类别？',
//       btn: ['删除', '取消'],
//       yes: function () {
//         stype= objs.attr('stype');
//         ptype=objs.attr('ptype');
//         var param={'id':objs.attr('id'),'type':objs.attr('type'),'status':'delete'};
//         if(!!page_data.page_type){
//           param['save_type']='delClass';
//           param['is_delete']=1;
//         }
//         getInfo(param);
//       }
//   });
// })

//删除
$('body').on('tap', 'li .delete-btn', function (e) {
    e.stopPropagation();
    var obj = $(this).parent().parent();//获得对象
    var parent_list = $($(this).parents('.swipe-delete')[0]);
    fun.dialog({
        content: '是否要删除所选类别？',
        btn: ['删除', '取消'],
        success: function () {
            document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        },
        yes: function () {
            var param = {
                'id': obj.attr('id'),
                'type': obj.attr('type'),
                'subLevel': false,
                'status': 'delete'
            };
            if (!!page_data.page_type) {
                param['save_type'] = 'delClass';
                param['is_delete'] = 1;
            }
            //存在子类别
            if (parent_list.children().filter('.swipe-delete').length > 0) {
                param['subLevel'] = true;
            }
            if (param['subLevel'] === true) {
                fun.toast('【' + obj.attr('name') + '类别】已被调用过，无法删除。');
            } else {
                getInfo(param);
            }
            document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        },
        no: function () {
            document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        }
    });
})

//获取编号
function getNumber(type, parent_id) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getNumber,
        data: {
            "type": type,
            "parent_id": parent_id
        },
        success: function (res) {
            if (res.status != 0) return fun.toast('获取编号失败！');
            page_data['numbers'] = res.data;
        }
    });
}

//保存数据
function saveData(params) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveSimpleRecord,
        data: params,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    var info_list = res.data || {}, info_data = [];
                    info_data.push({
                        'id': info_list['id'] || 0,
                        'name': params['name'],
                        'type': params['type'],
                        'parent_id': params['parent_id'],
                    });
                    if (!params['id'] && !!info_data) { //是添加数据
                        showData(info_data);
                        fun.toast("类别添加成功！");
                    } else if (params.save_type == 'delClass') { //删除数据
                        var delId = $.isArray(params['id']) ? params['id'][0] : params['id'];
                        // UPDATE['del_id'].push(params['id'][0] || 0);
                        UPDATE['del_id'].push(delId || 0);
                        $("[stype='" + params['id'] + "']").parent().remove();
                        if ($('.swipe-delete').length == 0) {
                            $('.content').html('');
                            var _tmp_title = '';
                            switch (page_type) {
                                case 'cp':
                                    _tmp_title = '产品类别';
                                    break;
                                case 'sx':
                                    _tmp_title = '纱线类别';
                                    break;
                                case 'kh':
                                    _tmp_title = '客户类别';
                                    break;
                                case 'gys':
                                    _tmp_title = '供应商类别';
                                    break;
                                case 'jgs':
                                    _tmp_title = '加工商类别';
                                    break;
                                case 'wl':
                                    _tmp_title = '物流类别';
                                    break;
                                case 'fymx_lb':
                                    _tmp_title = '费用明细类别';
                                    break;
                                default:
                                    break;
                            }
                            fun.createDataEmptyTips({ dom: '.content', btnText: '新增类别', auth: page_type, isDa: true });
                        }
                        fun.toast("删除成功！");
                    } else { //修改数据
                        if (typeof params.callback == 'function') {
                            params.callback()
                        }

                        fun.toast("类别修改成功！");
                    }
                    break;
                case 103:
                    // if (!!params['subLevel']) {
                    //     return fun.toast('有部分节点已被调用，无法删除。');
                    //     return $.nuiTips({msg: '【' + classTree.getSelected()['name'] + '】', type: 1});
                    // } else {
                    return fun.toast('【' + res['data']['name'] + '】已被调用，无法删除。');
                    //}
                    break;
                case 104:
                    return fun.toast('【' + params['name'] + '】已存在。');
                    break;
                default:
                    return fun.toast(res.msg);
                    break;
            }
            // if (res.status != 0) return fun.toast(res.msg);
            // if (params.save_type == 'delete') {
            //     $("[stype='" + params['id'] + "']").parent().remove();
            //     // fun.toast('删除成功！');
            // }
            // var info_list = res.data,
            //   data = [];
            // if (!!info_list) {
            //   data.push({
            //     'id': info_list['id'],
            //     'name': params['name'],
            //     'type': params['type'],
            //     'parent_id': params['parent_id'],
            //   });
            // }
            // if (!params['id']) { //是添加数据
            //   if (!!data) {
            //     fun.toast("类别添加成功！");
            //     showData(data);
            //   }
            // } else if (params.save_type == 'delete') { //删除数据
            //   fun.toast("删除成功！");
            // } else { //修改数据
            //   fun.toast("类别修改成功！");
            // }
        }
    });
}

//获取单个数据
function getInfo(params) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getCostInfo,
        data: {
            id: params.id,
            type: params.type
        },
        success: function (res) {
            if (res.status != 0) return fun.toast('获取修改数据失败！');
            var info_list = res.data || {};
            switch (params.status) {
                case 'edit':
                    $("#type").val(info_list['name']);
                    edits = info_list;
                    break;
                case 'delete':
                    // delData(info_list);
                    saveData({
                        "save_type": "delClass",
                        // "id": [info_list['id']],
                        "id": info_list['id'],
                        "type": info_list['type'],
                        "subLevel": params['subLevel'],
                        'is_delete': 1
                    });
                    break;
            }
        }
    });
}

//删除数据
// function delData(data){
// var datas;
// if(!!$("[ptype='" + data['id'] + "']").attr('stype')){
//   var names=$("[stype='" + data['id'] + "']").attr('name');
//   fun.toast('【'+names+'】类别已被调用过，无法删除!');
// }else{
//     datas = {
//       "save_type":"delete",
//       "id":[data['id']],
//       "type":data['type'],
//     }
//     saveData(datas);
// }
// }

//显示数据
function showData(data) {

    console.log('---');
    console.log(data);
    console.log('---');


    // 暂无数据提示
    if (data.length == 0) {
        $('.content').html('');
        var _tmp_title = '';
        switch (page_type) {
            case 'cp':
                _tmp_title = '产品类别';
                break;
            case 'sx':
                _tmp_title = '纱线类别';
                break;
            case 'kh':
                _tmp_title = '客户类别';
                break;
            case 'gys':
                _tmp_title = '供应商类别';
                break;
            case 'jgs':
                _tmp_title = '加工商类别';
                break;
            case 'wl':
                _tmp_title = '物流类别';
                break;
            case 'fymx_lb':
                _tmp_title = '费用明细类别';
                break;
            default:
                break;
        }
        fun.createDataEmptyTips({ dom: '.content', btnText: '新增类别', auth: page_type, isDa: true });
    }
    for (var x = 0; x < data.length; x++) {
        var steps; //判断层级
        var ptype = data[x]['parent_id'];
        if (!ptype) { //如果父级为空，则为第一级
            steps = 1;
            create(steps, data[x]);//渲染在第一层
        } else {
            var step = $("[stype='" + ptype + "']").parent().attr('step');//获取父级是在哪层
            var objs = $("[stype='" + ptype + "']");
            var data_arr = objs.data('arr')
            if (ptype == objs.attr('stype')) {
                step++;
                create(step, data[x], data_arr);
            }//如果数据父级id 和 create中渲染好的id相等，渲染在该父级下
        }
    }

    /*st渲染在那一层，
    *datas 要渲染的数据
    *data_arr 所属父级id
    */
    function create(st, datas, data_arr) {
        var list = [];
        var parent = '';
        parent = datas.id;
        if (st != 1) {
            parent = '';
            parent = data_arr + ',' + datas.id//层级不顶层的父级id用逗号拼接
        }
        list.push('<ul class="swipe-delete swipe-delete' + st + '" step=' + st + '>');
        list.push('     <li class="account-list lower-border-line" type="' + datas.type + '" id="' + datas.id + '" name="' + datas.name + '" stype="' + datas.id + '" ptype="' + datas.parent_id + '" data-arr="' + parent + '">');
        list.push('         <div class="le" sort="' + datas.sort + '" simple="' + datas.simple + '" create_time="' + datas.create_time + '" update_time="' + datas.update_time + '">');
        list.push('             <span class="color-number" style="margin-left:' + st + 'rem">' + datas.name + '</span>');
        list.push('             <i class="iconfont icon-tianjia"></i>');
        list.push('             <div class="slids edit dels1 edit-btn">修改</div>');
        list.push('             <div class="delete dels1 delete-btn">删除</div>');
        list.push('         </div>');
        list.push('     </li>');
        list.push('</ul>');
        switch (st) {
            case 1:
                $('.content').append(list.join(''));   //如果为顶层拼在类content内
                list = [];
                break;
            default:
                $("[stype='" + ptype + "']").parent().append(list.join('')); //不为顶层拼在所属父级id下
                list = [];
                break;
        }

        if (!judegAuth()) {
            $('.swipe-delete').removeClass('swipe-delete');
            $('.icon-tianjia').hide();
        }
        if (page_data['page_status'] == 'class_edit') {
            $('#add_btn,.dels1,.icon-tianjia').hide()
        }
        if (page_data['auth_val'] != 'null' && !($.nui.isEmpty(page_data['auth_val']))) {
            $.each(page_data['auth_val'], function (key, value) {
                has_Class({
                    hasid: value,
                    hasClass: 'addClass'
                })
            })
        }
    }


}

//对得到得数据进行排序
function sortByKey(array, key) {
    return array.sort(function (a, b) {
        var x = a[key];
        var y = b[key];
        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    });
}

function getAllSon(ars) {
    for (var j = 0; j < ars.length; j++) {
        all.push(ars[j]);
        if (!!ars[j]['son'][0]) {
            getAllSon(sortByKey(ars[j]['son'], 'sort'));
        }
    }
    return all;
}

//排序格式化
function ceilFormat(arr) {
    var p_arrs = [],
        c_arrs = [];
    for (var i = 0; i < arr.length; i++) {
        if (arr[i]['parent_id'] == 0) {
            p_arrs.push(arr[i]);
        } else {
            c_arrs.push(arr[i]);
        }
    }
    for (var i = 0; i < c_arrs.length; i++) {
        c_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (c_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                c_arrs[i]['son'].push(c_arrs[j]);
                // all.push(c_arrs[j]);
            }
        }
    }
    for (var i = 0; i < p_arrs.length; i++) {
        p_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (p_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                p_arrs[i]['son'].push(c_arrs[j]);
            }
        }
    }
    return sortByKey(p_arrs, 'sort'); //sort按照升序
}


function updatePrevPage() {
    if (page_data.page_status == 'class_edit') {
        auth_val = []

        // $.each(class_id,function(key,value){
        //     auth_val.push(value)
        // }

        for (var i = 0; i < info_list.length; i++) {
            // if ($('#' + info_list[i].id).hasClass('bg-blue')) {
            //     var vals = {}
            //     vals = {
            //         id: $('#' + info_list[i].id).attr('id'),
            //         select_val: $('#' + info_list[i].id).attr('name'),
            //     }
            //     auth_val.push(vals)
            // }

            if ($('#' + info_list[i].id).hasClass('bg-blue') && $('#' + info_list[i].id).css('pointer-events') != 'none') {
                var vals = {}
                vals = {
                    id: Number($('#' + info_list[i].id).attr('id')),
                    select_val: $('#' + info_list[i].id).attr('name'),
                }
                auth_val.push(vals)
            }
        }
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'select_list',
                'data': {
                    zd_class: auth_val,
                    type: 'zdlb'
                }
            }
        });

    } else {
        UPDATE['page_type'] = page_data['page_type'];
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'update',
                'data': UPDATE
            }
        });
    }
    api.closeWin();
}

//  判断类别是否存在
function typeExist(obj, value) {
    var name_arr = [];
    if ($(obj).hasClass("icon-tianjia")) {
        //当前子类别
        var swipe = $(obj).parents('.swipe-delete');
        var node_arr = $(swipe[0]).parent().children();
        if ($(swipe).attr('step') == 1) {
            node_arr = $(swipe).children();
        }
        $(node_arr.filter('.swipe-delete')).each(function (i, arr) {
            name_arr.push($(arr).children('.account-list').attr('name'));
        })
    } else if ($(obj).hasClass("icon-jia")) {
        //父类别
        var node_arr = $('.content > ul');
        $(node_arr).each(function (i, arr) {
            name_arr.push($(arr).children('.account-list').attr('name'));
        })
    }
    if (name_arr.indexOf(value) > -1) return true;
    return false;
}


function class_edits(id) {
    // var this_ar = String($('#' + id).data('arr'));
    // var this_a = [];
    // this_a = this_ar.split(',')
    // var arr_index = this_a.indexOf(String(id))
    // var this_arr = []
    // if (this_ar.indexOf(',') > -1) {
    //     this_arr = []
    //     this_arr = this_a
    // }
    // this_arr = this_arr.slice(0, (arr_index + 1)) //获取选中的父级id
    //判断所点击的是否选中，如果是选中状态就删除选中状态的class，否则添加选中状态的class
    if ($('#' + id).hasClass('bg-blue')) {
        has_Class({
            hasid: id,//选中的id
            hasClass: 'removeClass'
        })
    } else {
        has_Class({
            hasid: id,
            hasClass: 'addClass'
        })
        // if (this_arr !== undefined) {
        //     $.each(this_arr, function (key, value) {
        //         $('#' + value).addClass('bg-blue')
        //     })
        //     //遍历选中的父级id,
        // }
    }
}


function has_Class(options) {
    for (var i = 0; i < info_list.length; i++) {
        var index = ''
        index = String($('#' + info_list[i].id).data('arr'))
        var id_arr = []
        //判断是否为顶层，顶层直接输出数组，否则用逗号分割为数组，让下面检索看是否有所属选中id的子元素
        if (index.indexOf(',') > -1) {
            id_arr = []
            id_arr = index.split(',')
        } else {
            id_arr.push(String(index))
        }

        if (id_arr.indexOf(String(options.hasid)) > -1) {
            if (options.hasClass == 'removeClass') {
                $('#' + info_list[i].id).removeClass('bg-blue').css('pointer-events', 'auto')
            } else if (options.hasClass == 'addClass') {
                $('#' + info_list[i].id).addClass('bg-blue').css('pointer-events', 'none')

            }
        }//检索所有子元素是否有选中的父级id,如果为选中删除class,否则添加选中class
    }
    $('#' + options.hasid).css('pointer-events', 'auto');
}
