var html_name = page_arr.set;
var book_name;
$('#header').header({
    back: true
});

var is_wx;
page_init = function () {
    if (!SHOW_IS_DOING) {
        // $('.list-item[page_url="operation_log"]').hide();
        // $('.list-item[page_url="make_bill"]').hide();
        // $('.list-item[page_url="monthly_statement"]').hide();
        // $('.list-item[page_url="help_center"]').hide();
        // $('.list-item[page_url="online_kf"]').hide();
        $('.list-item[page_url="help_video"]').hide();
    }
    if (!SHOW_WX) {
        $('.list-item.binding—wechat').hide();
    }

    var user_info = fun.getItem('user_info');
    $('#user_name').text(user_info['name']);
    $('#book_name').text((fun.getItem('book_name') || ""));
    book_name = fun.getItem('book_name');
    $('#ver_text').text(APP_VERSION + '（' + api.appVersion + '）');
    is_user_power();

    if (SHOW_WX) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.wxUser,
            data: {
                type: 'is_wx',
            },
            success: function (res) {
                console.log(JSON.stringify(res));
                is_wx = res.status
                if (is_wx !== 0) {
                    $('#is_wx').css('display', 'none');
                }
                // return fun.toast(res.msg);
            },
        });
    }


}

//判断账号管理权限
function is_user_power() {
    if (Auth.check('zhgl', 'view')) {
        $('#account_admin').show();
    } else {
        $('#account_admin').hide();
    }
}

function getUserInfo(params) {
    if (!fun.getItem('login_info')) {
        return;
    }
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getUserInfo,
        data: {
            type: 'login',
            account_id: fun.getItem('login_info')['account_id']
        },
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data']['mobile_auth']) {
                    fun.dialog({
                        content: "此账套没有手机端权限,请联系管理员开通权限！",
                        btn: ["确定"],
                        yes: function () {
                            fun.setBook(fun.getItem('old_book'));
                        }
                    });
                    return;
                }
                // fun.delAllItem(['theme_color', 'account_info', 'company_info','book_id','book_name','token','old_book']);
                fun.setItem('user_info', res['data']);
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getSysList,
                    data: {},
                    success: function (res) {
                        if (res['status'] == 0) {
                            fun.setItem('sys_config', res['data']);
                        }
                    }
                });
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getBillsNumList,
                    data: {},
                    success: function (res) {
                        if (res['status'] == 0) {
                            fun.setItem('dh_config', res['data']);
                        }
                    }
                });
                fun.load_DATA_LIST(['zh', 'ck', 'khh']);
                $('#user_name').text(res['data']['name']);
                $('#book_name').text((params['name'] || ""));
                is_user_power();
                api.sendEvent({
                    name: page_arr.index,
                    extra: {'status': 'reload'}
                });
            }
        }
    });
}


$('#setof_books').on('click', function (e) {
    e.preventDefault();
    e.stopPropagation();
    fun.getBookList(function (params) {
        getUserInfo(params);
        return true;
    });
})

$('#update').on('click', function () {
    var html = [];
    style = 'width: 85%;  border:none; background: linear-gradient(to bottom, rgba(255,255,255,0), #fff, #fff, #fff);  border-radius: 0.5rem;';
    html.push('<img src="../img/rocket.png" class="head">')
    html.push('<div class="backdrop">');
    html.push('<span class="title">发现新版本<span>V1.654</span></span>');
    html.push('<i class="iconfont icon-fork close" id="close"></i>');
    html.push('<ol class="list-li">');
    html.push(' <li>全新界面风格。  </li>');
    html.push(' <li>优化了用户体验。</li>');
    html.push(' <li>更人性化的操作。</li>');
    html.push(' <li>更人性化的操作。</li>');
    html.push(' <li>更人性化的操作。</li>');
    html.push(' <li>更人性化的操作。</li>');
    html.push(' <li>更人性化的操作。</li>');
    html.push('</ol>');
    html.push('<button class="upgrade">马上升级</button>');
    html.push('</div>')

    layer.open({
        type: 1,
        content: html.join(''),
        style: style,
        success: function (layero, index) {
            $('#close').on('click', function () {
                layer.closeAll()
            })
        }
    });
});

$('.binding—wechat').on('click', function (e) {
    e.preventDefault();
    if (is_wx === 0) {
        fun.dialog({
            content: '你确定要解绑微信吗?',
            btn: ['确定', '取消'],
            yes: function () {
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.wxUser,
                    data: {
                        type: 'jb',
                        // code: ret.code,
                        login_type: 'app'
                    },
                    success: function (res) {
                        console.log(JSON.stringify(res));
                        is_wx = 1;
                        $('#is_wx').css('display', 'none');
                        return fun.toast(res.msg);
                    },
                    error: function (res) {

                    }
                });
            }
        });
    } else {
        fun.dialog({
            content: '绑定微信?',
            btn: ['确定', '取消'],
            yes: function () {
                var wx = api.require('wxPlus');
                if (!checkWxUseable(wx)) return false;
                wx.auth({
                    apiKey: '' //wx_appid  已从config获取
                }, function (ret, err) {
                    console.log(ret);
                    console.log(err);
                    if (ret.status) { //成功登陆
                        fun.ajax({
                            showLoad: true,
                            hideLoad: true,
                            url: AJAX_URL.wxUser,
                            data: {
                                type: 'bd',
                                code: ret.code,
                                login_type: 'app'
                            },
                            success: function (res) {
                                console.log(JSON.stringify(res));
                                is_wx = 0;
                                $('#is_wx').css('display', 'inline-block');
                                return fun.toast(res.msg);
                            },
                            error: function (res) {

                            }
                        });
                    } else {
                        if (err.code == 1) {
                            return fun.toast('取消授权');
                        } else if (err.code == 2) {
                            return fun.toast('拒绝授权');
                        } else if (err.code == 3) {
                            return fun.toast('未安装微信');
                        }
                    }
                });
            }
        });
    }


    return false;
});

function openBrowser(url) {
    //判断操作系统
    if (api.systemType == 'android') {
        //Android中的使用方法如下：
        api.openApp({
            androidPkg: 'android.intent.action.VIEW',
            mimeType: 'text/html',
            // uri: 'https://help-ccs.aliyun.com/h5help.htm?tntInstId=_1QLFyp6&helpCode=SCE_00005841'//帮助中心
            // uri: 'https://cschat-ccs.aliyun.com/index.htm?tntInstId=_1QLFyp6&scene=SCE00004988'//在线客服
            uri: url
        }, function (ret, err) {
        });
    } else {
        //iOS中的使用方法如下：
        api.openApp({
            // iosUrl: 'https://help-ccs.aliyun.com/h5help.htm?tntInstId=_1QLFyp6&helpCode=SCE_00005841'//帮助中心
            // iosUrl: 'https://cschat-ccs.aliyun.com/index.htm?tntInstId=_1QLFyp6&scene=SCE00004988'//在线客服
            iosUrl: url
        });
    }
}


//跳转
$('.list-item').on('tap', function () {
    var page_url = $(this).attr('page_url');
    if (!page_url) return;

    if (page_url == 'monthly_statement') {
        if (!fun.checkKz()) return;
    } else if (page_url == 'help_center') {
        fun.openBrowser('https://help-ccs.aliyun.com/h5help.htm?tntInstId=_1QLFyp6&helpCode=SCE_00005841');
        return;
    } else if (page_url == 'online_kf') {
        // fun.openBrowser('https://cschat-ccs.aliyun.com/index.htm?tntInstId=_1QLFyp6&scene=SCE00004988');

        fun.showPageFull({
            page_url: page_arr.new_win
        });

        return;
    }


    fun.showPageFull({
        page_url: page_arr[page_url],
        pageParam: {}
    });
})

//退出登录
$('#exit_login').on('tap', function (e) {
    // e.preventDefault();
    fun.dialog({
        content: '您确定退出登录吗？',
        btn: ['确定', '取消'],
        yes: function () {
            fun.showLoad('退出中...');
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.logout,
                data: {},
                success: function (res) {
                    if (res['status'] == 0) {
                        fun.logoutToLogin();
                    } else {
                        fun.alert({
                            msg:res.msg,
                            callback: function () {
                                fun.logoutToLogin();
                            }
                        })
                    }
                },
                error: function () {
                    fun.logoutToLogin();
                }
            });
        }
    })
    return false;
})
