var html_name = page_arr.set_ghsj;

$("#header").header({
    back: true,
    title: '更换手机',
});

page_init = function () {
    var user_info_tel = '13567489071';
    $('#old_hm').text(covertDh(user_info_tel));//显示账套
}

//发送验证码
$('#fsyzm').on('click', function () {
    if (!$('#old_hm').text()) return fun.toast('请输入手机号码！');
    var timer = null,
        times = 60;
    var that = $(this);
    timer = setInterval(function () {
        times--;
        that.text(times + " 秒后重试");
        $('#fsyzm').css('pointer-events', 'none')
        if (times <= 0) {
            $('#fsyzm').css('pointer-events', 'auto')
            that.text("发送验证码");
            clearInterval(timer);
            times = 60;
        }
    }, 1000);
});

//转换手机号码
function covertDh(tel) {
    if (!tel) return '';
    if (!fun.regCheck(tel, 'phone')) {
        return '';
    } else {
        return tel.replace(/(\d{3})\d{4}(\d{4})/, '$1****$2');
    }
}

//点击下一步
$('#next').on('click', function () {
    var yzm = $('#yzm').val();
    var old_tel = $('#old_hm').text();
    if (!old_tel) return fun.toast('手机号码不能为空！');
    if (!yzm) return fun.toast('验证码不能为空！');

    fun.showPageFull({
        page_url: page_arr.set_ghsj_next,
        pageParam: {
            return_page: html_name,
        }
    });
});

//点击确认
$('#confirm').on('click', function () {
    var yzm = $('#yzm').val();
    var new_tel = $('#new_hm').val();
    if (!new_tel) return fun.toast('手机号码不能为空！');
    if (!yzm) return fun.toast('验证码不能为空！');

    if (new_tel && yzm) {
        fun.toast('更换成功！');

        setTimeout(function () {
            fun.closeToWin(page_arr.set_zhyaq);
        }, 300);
    }
});
