var html_name = page_arr.share_pictures;
$('#header').header({
    back: true,
    setup: true,
    title: '分享'
});

var fxtp_config = {
    'gs': true,
    'cf': false,
    'fk': true,
    'dj': true
};

var SYS_CONFIG = fun.getItem('sys_config') || {};

var assess_token_info = fun.getItem('assess_token_info') || {};
var assess_token_xcx = fun.getItem('assess_token_xcx') || {};
var mycanvas, canvas_pictures;
var width, height, prewin, prehei;
//判断设备类型
var equipment = navigator.userAgent;
page_init = function () {
    fun.load_DATA_LIST(['sys_config'], function () {
        SYS_CONFIG = fun.getItem('sys_config') || {};
    });

    fxtp_config = $.extend({}, fxtp_config, fun.getItem('fxtp_config') || {});

    // console.log(JSON.stringify(fxtp_config))
    getList();

}

//获取公司信息
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getCompanyList,
        data: {},
        success: function (res) {
            if (res['status'] === 0) {
                showData(res.data || []);
            }
        }
    });
}

//显示数据
function showData(data) {
    // console.log(JSON.stringify(page_data['data']))
    // console.log(JSON.stringify(data))
    // console.log(JSON.stringify(fxtp_config))
    // console.log(JSON.stringify(SYS_CONFIG))

    var product_data = page_data['data'];
    mycanvas = document.getElementById('mycanvas');
    width = screen.availWidth;
    height = screen.availHeight;
    prewin = width / 1080;
    prehei = height / 1920;
    // console.log(prewin)
    // console.log(prehei)
    //屏幕可用
    mycanvas.width = width;
    mycanvas.height = height * 0.90;

    //画服务号二维码
    if (fxtp_config['fwh']) {
        var fwhmy = SYS_CONFIG['fwhmy'];
        var fwhappid = SYS_CONFIG['fwhappid'];
        var url = 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=' + fwhappid + '&secret=' + fwhmy;
        // console.log(new Date().getTime())
        // console.log(assess_token_info['former_time'])
        // console.log(new Date().getTime() - assess_token_info['former_time'])
        if ($.nui.isTrue(assess_token_info) && assess_token_info['assess_token'] && (new Date().getTime() - assess_token_info['former_time']) < 7200000) {
            var ewm_url = 'https://api.weixin.qq.com/cgi-bin/qrcode/create?access_token=' + assess_token_info['assess_token'] + '&type=jsapi';
            setCode(ewm_url);
        } else {
            // console.log(JSON.stringify(url))
            $.ajax({
                url: url,
                type: "get",
                async: true,
                success: function (result) {
                    console.log(JSON.stringify(result))

                    if (result['errcode']) {
                        switch (result['errcode']) {
                            case 40013:
                                fun.toast('无效的服务号APPID!');
                                break;
                            case 40125:
                                fun.toast('无效的服务号密钥!');
                                break;
                            case -1:
                                fun.toast('系统繁忙,请稍后重试。');
                                break;
                            case 40001:
                                fun.toast('服务号密钥错误或者服务号密钥不属于这个公众号。');
                                break;
                            case 40002:
                                fun.toast('未知错误！');
                                break;
                            case 40164:
                                fun.toast('无效的ip！');
                                break;
                        }
                    } else {
                        //本地存储
                        fun.setItem('assess_token_info', {
                            assess_token: result['access_token'],
                            former_time: new Date().getTime()
                        });
                        var access_token = result['access_token'];
                        var ewm_url = 'https://api.weixin.qq.com/cgi-bin/qrcode/create?access_token=' + access_token + '&type=jsapi';
                        setCode(ewm_url);
                    }

                },

            });
        }

    }

    //画小程序图片
    if (fxtp_config['xcx']) {
        //获取系统设置
        var xscmy = SYS_CONFIG['xscmy'];
        var xcxappid = SYS_CONFIG['xcxappid'];
        // console.log(JSON.stringify(assess_token_xcx))
        console.log(new Date().getTime() - assess_token_xcx['former_time'])
        // console.log(JSON.stringify(assess_token_xcx))

        var url = 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=' + xcxappid + '&secret=' + xscmy;
        if ($.nui.isTrue(assess_token_xcx) && assess_token_xcx['assess_token'] && (new Date().getTime() - assess_token_xcx['former_time']) < 7200000) {
            ewm_url = assess_token_xcx['assess_token'];
            // var ewm_url = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token=' + assess_token_xcx['assess_token'] + '&type=jsapi';
            console.log('============')
            setSmall(ewm_url);
        } else {
            $.ajax({
                url: url,
                type: "get",
                async: true,
                success: function (result) {
                    console.log(JSON.stringify(111111111111111))
                    console.log(JSON.stringify(result))
                    if (result['errcode']) {
                        switch (result['errcode']) {
                            case 40013:
                                fun.toast('无效的服务号APPID!');
                                break;
                            case 40125:
                                fun.toast('无效的服务号密钥!');
                                break;
                            case -1:
                                fun.toast('系统繁忙,请稍后重试。');
                                break;
                            case 40001:
                                fun.toast('服务号密钥错误或者服务号密钥不属于这个公众号。');
                                break;
                            case 40002:
                                fun.toast('未知错误！');
                                break;
                            case 40164:
                                fun.toast('无效的ip！');
                                break;
                        }
                    } else {
                        //本地存储
                        console.log('本地存储')
                        fun.setItem('assess_token_xcx', {
                            assess_token: result['access_token'],
                            former_time: new Date().getTime()
                        });
                        var access_token = result['access_token'];
                        setSmall(access_token);
                    }

                },

            });
        }

    }

    // fun.ajax({
    //     showLoad: true,
    //     hideLoad: true,
    //     url: AJAX_URL.getBpcpbjList,
    //     data: {
    //         "type": "list",
    //         "cp_id": product_data['id']
    //     },
    //     success: function (res) {
    //         if (res['status'] == 0) {

    fun.ajax({
        showLoad:true,
        hideLoad:true,
        data:{
            path:"pages/bbxq/bbxq?cp_id="+page_data['data']['id']+'&book_id='+fun.getItem('book_id'),
        },
        url: AJAX_URL.wxImgCode,
        success:function(res){
            var temp = res;
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.getGoodsList,
            data: {
                'id': 93,
                'name': page_data['data']['name']
            },
            success: function (res) {
                console.log(111)
                console.log(res)
                if (res['status'] == 0) {       

                var imgs = mycanvas.getContext('2d');
                var product = new Image();
                product.src = fun.getImgPath(product_data['imgs']);
                // console.log(width)
                // console.log(height)
                product.onload = function () {
                    imgs.drawImage(product, 0, 0, width, height * 0.9);
                    // console.log('tp')
                    //公司选项开启
                    setTimeout(function () {
                        if (fxtp_config['gs']) {
                            var canvas1 = mycanvas.getContext('2d');
                            canvas1.fillStyle = "rgb(256,256,256)";
                            canvas1.fillRect(0, 0, width, 230 * prehei);
                            // console.log('jx1')
                            var text = mycanvas.getContext('2d');
                            text.fillStyle = "rgb(0,0,0)";
                            if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1) {
                                //安卓手机
                                text.font = ".9em sans-serif";
                            } else if (equipment.indexOf('iPhone') > -1) {
                                //苹果手机
                                text.font = ".9em sans-serif";
                            } else {
                                text.font = "1em sans-serif";
                            }

                            if ($.nui.isTrue(data['gstt'])) {
                                //抬头
                                var gstt_img = mycanvas.getContext('2d');
                                var gstt = new Image();
                                gstt.onload = function () {
                                    gstt_img.drawImage(gstt, 140 * prewin, 0, 800 * prewin, 230 * prehei);
                                    // console.log('tt')
                                }
                                gstt.src = fun.getImgPath(data['gstt']);
                            } else if ($.nui.isTrue(data['logo'])) {
                                var logo_img = mycanvas.getContext('2d');
                                var logo = new Image();
                                logo.src = fun.getImgPath(data['logo']);
                                logo.onload = function () {
                                    logo_img.drawImage(logo, 150 * prewin, 40 * prehei, 150 * prehei, 150 * prehei);
                                    // console.log('logo')
                                    //公司简称
                                    text.fillStyle = "rgb(0,0,0)";
                                    text.fillText(data['company'], 350 * prewin, 140 * prehei);
                                    text.globalCompositeOperation = "destination-over";
                                    // console.log('jc')
                                }
                            } else {
                                // console.log('jc2')
                                //公司简称
                                text.fillText(data['company'], 350 * prewin, 140 * prehei);
                            }
                        }
                    }, 300);

                    var canvas = mycanvas.getContext('2d');
                    canvas.fillStyle = "rgb(256,256,256)";
                    canvas.fillRect(0, 1380 * prehei, width, 350 * prehei);
                    // console.log('jx2')

                    var product_name = mycanvas.getContext('2d');
                    var component = mycanvas.getContext('2d');
                    var spec = mycanvas.getContext('2d');
                    var unit_price = mycanvas.getContext('2d');

                    var product_text = (product_data['number'] || '') + ' ' + (product_data['name'] || '');
                    if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1) {
                        console.log('安卓手机')
                        //安卓手机
                        // product_name.font = "22px sans-serif";
                        // component.font = "22px sans-serif";
                        // spec.font = "22px sans-serif";
                        // unit_price.font = "22px sans-serif";
                        product_name.font = ".9em sans-serif";
                        component.font = ".9em sans-serif";
                        spec.font = ".9em sans-serif";
                        unit_price.font = ".9em sans-serif";
                    } else if (equipment.indexOf('iPhone') > -1) {
                        console.log('苹果手机')
                        //苹果手机
                        product_name.font = ".9em sans-serif";
                        component.font = ".9em sans-serif";
                        spec.font = ".9em sans-serif";
                        unit_price.font = ".9em sans-serif";
                    } else {
                        console.log('其他')
                        product_name.font = "1em sans-serif";
                        component.font = "1em sans-serif";
                        spec.font = "1em sans-serif";
                        unit_price.font = "1em sans-serif";
                    }
                    product_name.fillStyle = "rgb(0,0,0)";
                    product_name.fillText(product_text, 50 * prewin, 1460 * prehei);
                    console.log(product_name.font)
                    // console.log('cp')

                    
                    //成分
                    if (fxtp_config['cf'] && $.nui.isTrue(product_data['component'])) {
                        component.fillStyle = "rgb(206,206,206)";
                        component.fillText((product_data['component'] || ''), 50 * prewin, 1530 * prehei);
                        // console.log('cf')
                    }
                    //幅克
                    if (fxtp_config['fk']) {
                        var fk = product_data['width'] || '';
                        var kz = product_data['weight'] || '';
                        var gram;
                        // console.log(JSON.stringify(product_data))
                        // console.log(JSON.stringify(product_data['width']))
                        // console.log(JSON.stringify(product_data['weight']))
                        if ($.nui.isTrue(fk) || $.nui.isTrue(kz)) {
                            if ($.nui.isTrue(fk) && $.nui.isTrue(kz)) {
                                gram = fk + (product_data['fk_dw'] || '') + '×' + kz + (product_data['kz_dw'] || '');
                            } else if ($.nui.isTrue(fk) && $.nui.isTrue(kz)) {
                                gram = fk + '×' + kz;
                            } else {
                                gram = fk + '' + kz;
                            }
                        }
                        // console.log(JSON.stringify(gram))
                        spec.fillStyle = "rgb(206,206,206)";
                        if (fxtp_config['cf'] && $.nui.isTrue(product_data['component'])) {
                            spec.fillText((gram || ''), 50 * prewin, 1600 * prehei);
                        } else {
                            spec.fillText((gram || ''), 50 * prewin, 1530 * prehei);
                        }
                        // console.log('fk')
                    }
                    //单价
                    if (fxtp_config['dj']) {

                        // var zdj = [];
                        // for (var i = 0; i < res['data'].length; i++) {
                        //     if (res['data'][i]['bz_bzj'] == null || res['data'][i]['bz_bzj'] === '') {
                        //         zdj.push(0);
                        //     } else {
                        //         zdj.push(res['data'][i]['bz_bzj']);
                        //     }
                        // }
                        // var min = Math.min.apply(null, zdj);
                        // if (zdj.length != 0) {
                        //     var dw;
                        //     if ($.nui.isTrue(product_data['xsdw_name'])) {
                        //         dw = product_data['xsdw_name'] || '';
                        //     } else {
                        //         dw = product_data['unit_name'] || '';
                        //     }
                        //     var tariff = '¥ ' + min + '/' + dw;
                        //     unit_price.fillStyle = "rgb(255,100,104)";
                        //     if (fxtp_config['cf'] && $.nui.isTrue(product_data['component']) && fxtp_config['fk']) {
                        //         if ($.nui.isTrue(product_data['width']) || $.nui.isTrue(product_data['weight'])) {
                        //             unit_price.fillText(tariff, 50 * prewin, 1670 * prehei);
                        //         } else {
                        //             unit_price.fillText(tariff, 50 * prewin, 1600 * prehei);
                        //         }
                        //     } else if (fxtp_config['fk'] === false && fxtp_config['cf']) {
                        //         if ($.nui.isTrue(product_data['component'])) {
                        //             unit_price.fillText(tariff, 50 * prewin, 1600 * prehei);
                        //         } else {
                        //             unit_price.fillText(tariff, 50 * prewin, 1530 * prehei);
                        //         }
                        //     } else if (fxtp_config['cf'] === false && fxtp_config['fk']) {
                        //         if ($.nui.isTrue(product_data['width']) || $.nui.isTrue(product_data['weight'])) {
                        //             unit_price.fillText(tariff, 50 * prewin, 1600 * prehei);
                        //         } else {
                        //             unit_price.fillText(tariff, 50 * prewin, 1530 * prehei);
                        //         }
                        //     } else {
                        //         unit_price.fillText(tariff, 50 * prewin, 150 * prehei);
                        //     }
                        // }
                        var zdj = [];
                        var producta = 'sl';
                        var producta_data = [{'qdl':3,'money':78},{'qdl':1,'money':12},{'qdl':2,'money':45}];
                        // if (product_data['jg_type'] == 'sl'){
                        //     for (var i = 0; i < product_data['jg_value'].length; i++) {
                        //     if (product_data['jg_value'][i]['money'] == null || product_data['jg_value'][i]['money'] === '') {
                        //         zdj.push(0);
                        //     } else {
                        //         zdj.push(product_data['jg_value'][i]['money']);
                        //     }
                        //     }
                        // }else if(product_data['jg_type'] == 'ys'){
                        //     $(product_data['jg_value']).each(function (idx, item) {
                        //         if (product_data['jg_value']['cp_ys_bh'] === '白坯#') {
                        //             return true;
                        //         } else if(product_data['jg_value']['dhj'] == null || product_data['jg_value']['dhj'] === ''){
                        //             zdj.push(0);
                        //         }else{
                        //             zdj.push(product_data['jg_value']['dhj']);
                        //         }
                        //     })
                        // }
                        if (producta == 'sl'){
                            for (var i = 0; i < producta.length; i++) {
                            if ($.nui.isEmpty(producta_data[i]['money'])) {
                                zdj.push(0);
                            } else {
                                zdj.push(producta_data[i]['money']);
                            }
                            }
                        }
                        // else if(producta == 'ys'){
                        //     $(producta).each(function (idx, item) {
                        //         if (product_data['jg_value']['cp_ys_bh'] === '白坯#') {
                        //             return true;
                        //         } else if(product_data['jg_value']['dhj'] == null || product_data['jg_value']['dhj'] === ''){
                        //             zdj.push(0);
                        //         }else{
                        //             zdj.push(product_data['jg_value']['dhj']);
                        //         }
                        //     })
                        // }
                        var min = Math.min.apply(null,zdj);
                        var max = Math.max.apply(null,zdj);
                        if (zdj.length != 0) {
                            var dw;
                            if ($.nui.isTrue(product_data['xsdw_name'])) {
                                dw = product_data['xsdw_name'] || '';
                            } else {
                                dw = product_data['unit_name'] || '';
                            }

                            if($.nui.isEmpty(min) || $.nui.isEmpty(max)){
                                var tariff = '¥ ' + 0 + '/' + dw;
                            }else if(min == max){
                                var tariff = '¥ ' + min + '/' + dw;
                            }else{
                                var tariff = '¥ ' + min + '~' + max + '/' + dw;
                            }
                            unit_price.fillStyle = "rgb(255,100,104)";
                            if (fxtp_config['cf'] && $.nui.isTrue(product_data['component']) && fxtp_config['fk']) {
                                if ($.nui.isTrue(product_data['width']) || $.nui.isTrue(product_data['weight'])) {
                                    unit_price.fillText(tariff, 50 * prewin, 1670 * prehei);
                                } else {
                                    unit_price.fillText(tariff, 50 * prewin, 1600 * prehei);
                                }
                            } else if (fxtp_config['fk'] === false && fxtp_config['cf']) {
                                if ($.nui.isTrue(product_data['component'])) {
                                    unit_price.fillText(tariff, 50 * prewin, 1600 * prehei);
                                } else {
                                    unit_price.fillText(tariff, 50 * prewin, 1530 * prehei);
                                }
                            } else if (fxtp_config['cf'] === false && fxtp_config['fk']) {
                                if ($.nui.isTrue(product_data['width']) || $.nui.isTrue(product_data['weight'])) {
                                    unit_price.fillText(tariff, 50 * prewin, 1600 * prehei);
                                } else {
                                    unit_price.fillText(tariff, 50 * prewin, 1530 * prehei);
                                }
                            } else {
                                unit_price.fillText(tariff, 50 * prewin, 150 * prehei);
                            }
                        }
                    }

                    //小程序码
                    if (fxtp_config['xcx']) {
                        var xiao_img = mycanvas.getContext('2d');
                        var xiao = new Image();
                        xiao.src = temp['path'];
                        xiao.onload = function () {
                            if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1) {
                                console.log('安卓手机')
                                //安卓手机
                                xiao_img.drawImage(xiao, 750 * prewin, 1420 * prehei, 290 * prewin, 250 * prehei);
                            } else if (equipment.indexOf('iPhone') > -1) {
                                console.log('苹果手机')
                                //苹果手机
                                xiao_img.drawImage(xiao, 750 * prewin, 1420 * prehei, 270 * prewin, 270 * prehei);
                            } else {
                                console.log('其他')
                                xiao_img.drawImage(xiao, 790 * prewin, 1400 * prehei, 220 * prewin, 290 * prehei);
                            }
                        // xiao_img.drawImage(xiao, 750 * prewin, 1420 * prehei, 270 * prewin, 250 * prehei);
                        }
                    }
                }
                

            }
        }
    });
    }
 });

}

function setImges(data) {

}

//获取服务号二维码
function setCode(data) {
    ewm_url = data;
    $.ajax({
        url: ewm_url,
        type: "POST",
        dataType: "json",
        data: JSON.stringify({
            "action_name": "QR_LIMIT_STR_SCENE",
            "action_info": {
                "scene": {
                    "scene_str": "test"
                }
            }
        }),
        async: true,
        success: function (data) {
            // console.log(JSON.stringify(data))
            if (data['ticket']) {
                //接口B：适用于需要的码数量极多的业务场景
                // var code_url = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token='+(data['ticket']);
                //接口A: 适用于需要的码数量较少的业务场景
                var code_url = 'https://mp.weixin.qq.com/cgi-bin/showqrcode?ticket=' + (data['ticket']);
                //接口C: 适用于需要的码数量较少的业务场景
                // var code_url = 'https://api.weixin.qq.com/cgi-bin/wxaapp/createwxaqrcode?access_token=' + (data['ticket']);
                var ewm_img = mycanvas.getContext('2d');
                var qr_code = new Image();
                qr_code.src = code_url;
                // console.log(JSON.stringify(code_url))
                qr_code.onload = function () {
                    ewm_img.drawImage(qr_code, 800 * prewin, 1480 * prehei, 210 * prehei, 210 * prehei);
                    // console.log('服务号ewm')
                    // ewm_img.globalCompositeOperation = "destination-over";
                }
            } else {
                fun.toast('获取二维码失败.');
                fun.setItem('assess_token_info', {});
                // getList();
            }
        },
    });
}

//获取小程序二维码
function setSmall(data) {
    var ewm_url = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token=' + data;
    console.log('-------------------')
    console.log(data)
    console.log(JSON.stringify(ewm_url))
    // console.log(JSON.stringify({access_token: data, scene: 123,is_hyaline: true,width:430,page:''  }))

    // ewm_url = data;
    $.ajax({
        url: ewm_url,
        type: "post",
        // dataType: "json",
        // data: JSON.stringify({}),
        data: JSON.stringify({
            "scene": "000",
            "page": "pages/index/index"
        }),
        async: true,
        contentType: 'image/jpeg',

        success: function (data) {
            if (data['errcode'] && data['errcode'] == 40001) {
                fun.toast('当前二维码不是最新的，请重新获取.');
                fun.setItem('assess_token_xcx', {});
                getList();
            }
            console.log(JSON.stringify(data))

            console.log('*****************************************')

            // function transformArrayBufferToBase64 (buffer) {
            //     var binary = '';
            //     var bytes = new Uint8Array(buffer);
            //     for (var len = bytes.byteLength, i = 0; i < len; i++) {
            //         binary += String.fromCharCode(bytes[i]);
            //     }
            //     return window.btoa(binary);
            // }
            // var img = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token='+JSON.stringify(data);
            // console.log(JSON.stringify(data))
            var xcx_img = mycanvas.getContext('2d');
            var xcz_code = new Image();
            xcz_code.src = data;
            $('#imgs').attr('src', data)
            xcz_code.onload = function () {
                xcx_img.drawImage(xcz_code, 520, 695, 125, 125);
                console.log('xcx1')
                // ewm_img.globalCompositeOperation = "destination-over";
            }
        },
        error: function (err) {
            console.log(JSON.stringify(666))
            console.log(JSON.stringify(err))
            var ewm_img = mycanvas.getContext('2d');
            var qr_code = new Image();
            qr_code.src = err;
            qr_code.onload = function () {
                ewm_img.drawImage(qr_code, 520, 695, 125, 125);
                console.log('xcx2')
                // ewm_img.globalCompositeOperation = "destination-over";
            }
            // $('#imgs').attr('src',err['responseText'])
        }
    });
}

$('#keep').on('tap', function () {
    // console.log(JSON.stringify(666))
    // getList();
    setImges();
})

//设置弹窗
$('body').on('click', '#setup_btn', function () {
    // console.log(JSON.stringify(SYS_CONFIG))
    var Html = [];
    style = 'width: 85%;  border:none; background-color: #fff; padding-top: 2rem; border-radius: 0.5rem;';
    Html.push('<div class="content-box">');
    // if ($.nui.isTrue(SYS_CONFIG['xcxappid']) && $.nui.isTrue(SYS_CONFIG['xscmy'])) {
        Html.push('     <div class="single">');
        Html.push('         <div class="single-box single-box3 single-election">');
        if (fxtp_config['xcx']) {
            Html.push('             <div data-value="xcx" class="radio-box boxs xcx radio-choice">');
        } else {
            Html.push('             <div data-value="xcx" class="radio-box boxs xcx">');
        }
        Html.push('                 <i class="iconfont icon-check"></i>');
        Html.push('             </div>');
        Html.push('         <label class="radio-text">小程序</label>');
        Html.push('         </div>');
    // }
    // if ($.nui.isTrue(SYS_CONFIG['fwhappid']) && $.nui.isTrue(SYS_CONFIG['fwhmy'])) {
        Html.push('         <div class="single-box single-box3 single-election">');
        if (fxtp_config['fwh']) {
            Html.push('             <div data-value="fwh" class="radio-box boxs fwh radio-choice">');
        } else {
            Html.push('             <div data-value="fwh" class="radio-box boxs fwh">');
        }
        Html.push('                 <i class="iconfont icon-check"></i>');
        Html.push('             </div>');
        Html.push('         <label class="radio-text">服务号</label>');
        Html.push('         </div>');
    // }
    Html.push('     </div> ');
    Html.push('     <div class="single2">');
    Html.push('         <div class="single-box single-box3 jianju">');
    if (fxtp_config['gs']) {
        Html.push('             <div data-value="gs" class="radio-box2 boxs gs radio-choice" id="gs">');
    } else {
        Html.push('             <div data-value="gs" class="radio-box2 boxs gs" id="gs">');
    }
    Html.push('                 <i class="iconfont icon-check"></i>');
    Html.push('             </div>');
    Html.push('         <label class="radio-text">公司</label>');
    Html.push('         </div>');

    Html.push('         <div class="single-box single-box3 single-box2 jianju">');
    if (fxtp_config['cf']) {
        Html.push('             <div data-value="cf" class="radio-box2 boxs cf radio-choice">');
    } else {
        Html.push('             <div data-value="cf" class="radio-box2 boxs cf" >');
    }
    Html.push('                 <i class="iconfont icon-check"></i>');
    Html.push('             </div>');
    Html.push('         <label class="radio-text">成分</label>');
    Html.push('         </div>');

    Html.push('         <div class="single-box single-box3 single-box2 jianju1">');
    if (fxtp_config['fk']) {
        Html.push('             <div data-value="fk" class="radio-box2 boxs fk radio-choice">');
    } else {
        Html.push('             <div data-value="fk" class="radio-box2 boxs fk">');
    }
    Html.push('                 <i class="iconfont icon-check"></i>');
    Html.push('             </div>');
    Html.push('         <label class="radio-text">幅/克</label>');
    Html.push('         </div>');

    Html.push('         <div class="single-box single-box3 single-box2 jianju">');
    if (fxtp_config['dj']) {
        Html.push('             <div data-value="dj" class="radio-box2 boxs dj radio-choice">');
    } else {
        Html.push('             <div data-value="dj" class="radio-box2 boxs dj">');
    }
    Html.push('                 <i class="iconfont icon-check"></i>');
    Html.push('             </div>');
    Html.push('         <label class="radio-text">单价</label>');
    Html.push('         </div>');

    Html.push('     </div>     ');

    Html.push('</div>');
    Html.push('<button id="confirm" class="confirm button">确认</button>');
    Html.push('<button id="cancel" class="cancel button">取消</button>');
    layer.open({
        type: 1,
        content: Html.join(''),
        style: style,
        success: function (layero, index) {
            //取消
            $('#cancel').on('tap', function () {
                layer.closeAll()
            });
            //确认
            $('#confirm').on('tap', function () {
                fxtp_config['xcx'] = $('.xcx').hasClass('radio-choice') ? true : false;
                fxtp_config['fwh'] = $('.fwh').hasClass('radio-choice') ? true : false;
                fxtp_config['gs'] = $('.gs').hasClass('radio-choice') ? true : false;
                fxtp_config['cf'] = $('.cf').hasClass('radio-choice') ? true : false;
                fxtp_config['fk'] = $('.fk').hasClass('radio-choice') ? true : false;
                fxtp_config['dj'] = $('.dj').hasClass('radio-choice') ? true : false;
                fun.setItem('fxtp_config', fxtp_config);
                getList();
                layer.closeAll()
            });
        }
    });
});
//微信好友
$('#friend').on('tap', function () {
    canvas_pictures = mycanvas.toDataURL('image/png');
    // console.log(JSON.stringify(66666666666))
    // console.log(JSON.stringify(canvas_pictures))
    var imgs;
    var wx = api.require('wxPlus');
    if (!checkWxUseable(wx)) return false;
    wx.isInstalled(function (ret, err) {
        if (ret.installed) {
            var wx = api.require('wxPlus');
            var trans = api.require('trans');
            //x上限，y下限
            var x = 100000000;
            var y = 0;
            var rand = parseInt(Math.random() * (x - y + 1) + y);
            var url_pictures = canvas_pictures.split(',')[1];
            // console.log(JSON.stringify(url_pictures))
            trans.saveImage({
                base64Str: url_pictures,
                album: false,
                imgPath: "widget://res",
                imgName: "cp" + rand + ".png"
            }, function (ret, err) {
                if (ret.status) {
                    imgs = "widget://res/cp" + rand + ".png";
                    if (!checkWxUseable(wx)) return false;
                    wx.shareImage({
                        apiKey: '',
                        scene: 'session',
                        contentUrl: imgs,
                    }, function (ret, err) {
                        console.log(JSON.stringify(ret))
                        if (ret.status) {
                        } else {
                            switch (err.code) {
                                case -1:
                                    fun.toast('未知错误！');
                                    break;
                                case 2:
                                    fun.toast('取消分析.');
                                    break;
                                case 3:
                                    fun.toast('发送失败！');
                                    break;
                                case 4:
                                    fun.toast('授权失败！');
                                    break;
                            }
                        }
                    });
                } else {
                    fun.toast(JSON.stringify(err));
                }
            });
        } else {
            return fun.toast('请您安装微信后重试');
        }
    });
})

//朋友圈
$('#circle').on('tap', function () {
    canvas_pictures = mycanvas.toDataURL('image/png');
    // console.log(JSON.stringify(canvas_pictures))
    var wx = api.require('wxPlus');
    if (!checkWxUseable(wx)) return false;
    wx.isInstalled(function (ret, err) {
        if (ret.installed) {
            var wx = api.require('wxPlus');
            var trans = api.require('trans');
            //x上限，y下限
            var x = 100000000;
            var y = 0;
            var rand = parseInt(Math.random() * (x - y + 1) + y);
            var url_pictures = canvas_pictures.split(',')[1];
            // console.log(JSON.stringify(url_pictures))
            trans.saveImage({
                base64Str: url_pictures,
                album: true,
                imgPath: "widget://res",
                imgName: "cp_pyq" + rand + ".png"
            }, function (ret, err) {
                if (ret.status) {
                    imgs = "widget://res/cp_pyq" + rand + ".png";
                    if (!checkWxUseable(wx)) return false;
                    wx.shareImage({
                        apiKey: '',
                        scene: 'timeline',
                        contentUrl: imgs,
                    }, function (ret, err) {
                        console.log(JSON.stringify(ret))
                        if (ret.status) {
                        } else {
                            switch (err.code) {
                                case -1:
                                    fun.toast('未知错误！');
                                    break;
                                case 2:
                                    fun.toast('取消分析.');
                                    break;
                                case 3:
                                    fun.toast('发送失败！');
                                    break;
                                case 4:
                                    fun.toast('授权失败！');
                                    break;
                            }
                        }
                    });
                } else {
                    fun.toast(JSON.stringify(err));
                }
            });
        } else {
            return fun.toast('请您安装微信后重试');
        }
    });
});

//保存图片
$('#keep').on('tap', function () {
    canvas_pictures = mycanvas.toDataURL('image/png');
    var trans = api.require('trans');
    //x上限，y下限
    var x = 100000000;
    var y = 0;
    var rand = parseInt(Math.random() * (x - y + 1) + y);
    var url_pictures = canvas_pictures.split(',')[1];
    trans.saveImage({
        base64Str: url_pictures,
        album: true,
        imgPath: "widget://res",
        imgName: "cp" + rand + ".png"
    }, function (ret, err) {
        if (ret.status) {
            fun.toast('保存成功');
        } else {
            fun.toast(JSON.stringify(err));
        }
    });
})


//弹窗单选
$('body').on('tap','.single-election',function(){
    $('.radio-box').removeClass('radio-choice')
    $(this).children(".radio-box").addClass('radio-choice');
})

$('body').on('tap', '.single-box3', function () {
    if ($(this).children(".radio-box2").hasClass('radio-choice')) {
        $(this).children(".radio-box2").removeClass('radio-choice');
    } else {
        $(this).children(".radio-box2").addClass('radio-choice');
    }
});
