$('#header').header({
    back: true,
    text_btn: true,   //文字按钮
    title: '产品颜色',
    text_val: '编辑',
    foot_input: {
        show: true,
        scan_icon: false,
        plader: '搜索'
    },
});

// 点击编辑出现可删除
$('.complete-btn').on('tap',function(){
    if($('.packs').css('display') == 'block'){
        $(this).text('编辑');
        $('.packs').css('display','none');
        
    }else{
        $(this).text('完成');
        $('.packs').css('display','block');     
    }
})

//监听搜索框的变化
$('#foot_search').bind('input propertychange',function(){
    var sousuo = $('#foot_search').val();
    if(sousuo == null || sousuo == ''){
        $('.packs').css('display','block');  
    }
});


//删除提示
$('.packs').on('tap',function(){
    fun.dialog({
        content: '你确定要删除【XX色号+XX颜色】吗？',
        btn: ['删除', '取消']
    });
})
//长按和点击事件
// $(".box-div").on({  
//     touchstart: function(e) { 
//         // 长按事件触发  
//         var boxindex = $(".box-div").index(this);
//         timeOutEvent = setTimeout(function() {  
//             timeOutEvent = 0;  
//             if($('.packs').eq(boxindex).css('display') == 'block')  {
//                 $('.packs').eq(boxindex).css('display','none');
//             }else if(boxindex == 0){
//                 $('.packs').eq(boxindex).css('display','none');
//             }else{
//                 $('.packs').eq(boxindex).css('display','block');
//             }                 
//         }, 400);
//         //长按400毫秒         
//     },  
//     touchmove: function() {  
//         clearTimeout(timeOutEvent);  
//         timeOutEvent = 0;  
//     },  
//     touchend: function() {  
//         clearTimeout(timeOutEvent);  
//         if (timeOutEvent != 0) {  
//             // 点击事件   
//             var index = $(".box-div").index(this);
//             if($('.complete-btn').text() == '完成'){
//                 $('.openCamera').css('display','none');
//             }else if ($('.box-div>img').eq(index).attr('src') == '../../img/null.png'){
//                 $('.openCamera').css('display','block');
//             }else if(!$('.box-div>img').eq(index).attr('src') == '../../img/null.png'){
//                 $('.openCamera').css('display','none');
//             };
//         }  
//         return false;  
//     }  
// })
//拍照
$('#paizhao').on('tap', function () {
    $('#openCamera,.picture,.box').hide();
    //解决tap穿透
    $('.cut').css('pointer-events', 'none');
    setTimeout(function(){
        $('.cut').css('pointer-events', 'auto');
    },200);
    QuestPermission.requestPermission('camera', null,function () {
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 100,
            targetWidth: 100,
            targetHeight: 100,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if(ret.data) addImgToImgs(ret);
            } else {
            }
        });
    });
    
});

//从相册中选择
$('#selectPhoto').on('tap', function () {
    $('#openCamera,.picture,.box').hide();
    //解决tap穿透
    $('.cut').css('pointer-events', 'none');
    setTimeout(function(){
        $('.cut').css('pointer-events', 'auto');
    }, 200);
    QuestPermission.requestPermission('camera', null,function () {
        api.getPicture({
            sourceType: 'album',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 100,
            // targetWidth: 100,
            // targetHeight: 100,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if(ret.data) addImgToImgs(ret);
            } else {
                // console.log(JSON.stringify(err));
            }
        });
    });
    
});

//取消拍照
$('#cancelPhoto').on('tap', function () {
    $('.openCamera').css('display','none');
});


//添加修改颜色
function addColour(opt) {
    var html = [];
    if (!opt) return;
    var val = opt.value || {},
    class_name = (val['is_stop'] && val['is_stop'] == 1) ? "nui-active" : "nui-unactive";
    if(opt.type != "pi"){
        html.push('  <div class="warm"> ');
        html.push('   <div class="warm-title"> ');
        html.push('    <span class="title" style="margin-left:5rem">' + ((opt.type == "add") ? "添加颜色" : "修改颜色") + '</span> ');
        if (opt.type != "add") {
            html.push('    <div class="shows"> ');
            html.push('     ');
            html.push('     <i id="ys_is_stop" class="gg-switch stp-btn nui-switch nui-switch-md nui-switch-btn ' + class_name + '"><i class="nui-switch-handle" id="st"></i><label for="ys_is_stop"  class="switch-label">停用</label> </i> ');
            html.push('    </div> ');
        }else{
            html.push('    <div class="shows" style="visibility: hidden;"> ');
            html.push('     ');
            html.push('     <i id="ys_is_stop" class="gg-switch stp-btn nui-switch nui-switch-md nui-switch-btn ' + class_name + '"><i class="nui-switch-handle" id="st"></i><label for="ys_is_stop"  class="switch-label">停用</label> </i> ');
            html.push('    </div> ');
        }
        html.push('   </div> ');
        html.push('   <div class="warm-con"> ');
        html.push('    <ul> ');
        html.push('     <li class="obj-title"> <span class="param">色号</span> <input id="colour_number" type="text" value="' + (val['number'] || "") + '" /> </li> ');
        html.push('     <li class="obj-title"> <span class="param">颜色</span> <input id="colour" type="text" value="' + (val['name'] || "") + '" /> </li> ');
        html.push('     <li class="obj-title"> <span class="param">色系</span> <input id="colour_series" type="text" readonly="readonly" value="' + (val['type'] || "") + '" /> <i class="iconfont icon-xia down-ico"></i> </li> ');
        html.push('     <li class="obj-title"> <span class="param">加工商</span> <input id="xz_jgs" type="text" readonly="readonly" jgs_id="' + (val['merchant_id'] || "") + '" value="' + (val['wldw_mc'] || "") + '" /> <i class="iconfont icon-xia down-ico"></i> </li> ');
        // html.push('     <li class="obj-title"> <span class="param">起订量</span> <input id="cp_qdl" class="num-input" num_type="2" decimal_digits="4" type="text" value="' + (val['order_amount'] || "") + '" /> </li> ');
        html.push('     <li class="obj-title"> <span class="param">图片</span><div class="photo"><img src="../../img/null.png" class="xiuimg"></div></li> ');
        $('body').on('tap','.photo',function(){
            $('.openCamera').css({'display':'block','z-index':'99999999'});
        })
        html.push('    </ul> ');

        html.push('   </div> ');
        html.push('   <div class="warm-operation"> ');
        html.push('    <button class="btn" id="cancel">取消</button>');
        html.push('    <button class="btn" id="confirm">确认</button> ');
        html.push('   </div> ');
        html.push('  </div>');
    }else{
        html.push('  <div class="warm"> ');
        html.push('   <div class="warm-title"> ');
        html.push('    <span class="title">' + '批量添加' + '</span> ');
        html.push('   </div> ');
        html.push('   <div class=rm-con"> ');
        html.push('    <ul> ');
        html.push('     <li class="obj-title"> <span class="param">色号</span> <input id="colour_number" style="width:34%" type="text" value="' + (val['number'] || "") + '" />&nbsp;&nbsp;-&nbsp;&nbsp;<input id="colour_number" style="width:34%" type="text" value="' + (val['number'] || "") + '" /></li> ');
        html.push('     <li class="obj-title"> <span class="param">前缀</span> <input id="colour" class="qian" type="text" value="' + (val['name'] || "") + '" /> </li> ');
        html.push('     <li class="obj-title"> <span class="param">后缀</span> <input id="colour" class="hou" type="text" value="#"/> </li> ');
        html.push('     <li class="obj-title"> <span class="param">色系</span> <input id="colour_series" type="text" readonly="readonly" value="' + (val['type'] || "") + '" /> <i class="iconfont icon-xia down-ico"></i> </li> ');
        html.push('    </ul> ');
        html.push('   </div> ');
        html.push('   <div class="warm-operation"> ');
        html.push('    <button class="btn" id="cancel">取消</button>');
        html.push('    <button class="btn" id="confirm">确认</button> ');
        html.push('   </div> ');
        html.push('  </div>');
        $('#confirm').on('tap',function(){
            var qian = $('.qian').val();
            var hou = $('.hou').val();
            if(qian != null || qian != ""){
                $('#colour_number1').prepend('qian');
            }else if (hou != null || hou != ""){
                $('#colour_number1').append('hou');
            }
        })
    }
    layer.open({
        type: 1,
        content: html.join(''),
        shadeClose: false,
        style: 'width: 90%; min-height: auto; border-radius: 0.5rem;background-color: #fff; overflow-y: hidden;',//position: fixed;top: 25%;left: 5%;
        success: function (ele) {
            var oriSHVal = $('#colour_number').val();
            //确定
            $('#confirm').on('tap', function () {
                if (typeof opt.callback == 'function') {
                    if (!$('#colour_number').val()) {
                        return fun.toast("色号不能为空。");
                    }
                    var param = {
                        "id": (val['id'] || 0),
                        "sort": (val['sort'] || ($('.color-list').length + 1)),
                        "number": ($('#colour_number').val().trim() || ""),
                        "name": ($('#colour').val().trim() || ""),
                        "type": ($('#colour_series').val().trim() || ""),
                        "wldw_mc": ($('#xz_jgs').val().trim() || ""),
                        "merchant_id": ($('#xz_jgs').attr('jgs_id') || 0),
                        "order_amount": ($('#cp_qdl').val().trim() || ""),
                        "is_stop": ($('#ys_is_stop').hasClass('nui-active')) ? 1 : 0,
                        "remark": val['remark'] || "",
                        "imgs": val['imgs'] || [],
                        "goods_material": val['goods_material'] || []
                    };
                    opt.callback(param);
                }
                if (existSh(param)) return;//颜色存在时，不让弹窗关闭
                setTimeout(function () {
                    layer.closeAll()
                }, 50)
            });
            $('#cancel').on('tap', function () {
                setTimeout(function () {
                    layer.closeAll()
                }, 50)
            });

            Select_color_series($('#colour_series'));

            //选择加工商
            $('#xz_jgs').on('tap', function () {
                fun.showPageFull({
                    "page_url": page_arr.customer_search,
                    "pageParam": {
                        "return_page": html_name,
                        "page_type": "jgs"
                    }
                });
            });
            $('#colour_number').on('blur', function (e) {
                if ($(this).val().trim() == '') {
                    $(this).val(oriSHVal);
                }
            });
        }
    });
}


$('.colornumber').on('tap', function (e) {
    if ($(this).attr('disabled')) return;
    if($('.packs').css('display') == 'none'){
        addColour({
            callback: function (param) {
                var html = [],
                    sort = $('#ys_list > li').length + 1,
                    sh_ys = (param['number'] || "") + " " + (param['name'] || "");
                html.push('  <li class="color-list lower-border-line item" data-list=\'' + JSON.stringify(param) + '\' > ');
                html.push('   <div class="top"> ');
                html.push('    <div class="check-box boxs ck-one">');
                html.push('     <i class="iconfont icon-check"></i>');
                html.push('    </div> ');
                html.push('<label for="color1"><i class="ys-list-sort">' + sort + '.</i><label class="color-info">' + sh_ys + '</label></label> ');
                html.push('    <span  class="phone iconfont icon-zhaoxiangji"></span> ');
                html.push('   </div> ');
                html.push('   <div class="ups"> ');
                html.push('    <div class="up"> ');
                html.push('     <span class="qdl-text" >起订量<em>' + (param['order_amount'] || 0) + '</em></span> ');
                html.push('     <span jgs_id="' + (param['merchant_id'] || 0) + '" class="jgs-text" >' + (param['wldw_mc'] || "") + '</span> ');
                html.push('    </div> ');
                html.push('   </div> ');
                html.push('</li>');

                if (existSh(param)) return fun.toast('色号已存在');
                // $('#ys_list').append(html.join(''));
                !IS_PAGE_EDIT && $('.phone,.color-list').attr('disabled', true);
            }
        });
    }
});

$('.shoudong').on('tap', function (e) {
    if ($(this).attr('disabled')) return;
    addColour({
        showLog: true,
        type: "add",
        callback: function (param) {
            var html = [],
                sort = $('#ys_list > li').length + 1,
                sh_ys = (param['number'] || "") + " " + (param['name'] || "");
            html.push('  <li class="color-list lower-border-line item" data-list=\'' + JSON.stringify(param) + '\' > ');
            html.push('   <div class="top"> ');
            html.push('    <div class="check-box boxs ck-one">');
            html.push('     <i class="iconfont icon-check"></i>');
            html.push('    </div> ');
            html.push('<label for="color1"><i class="ys-list-sort">' + sort + '.</i><label class="color-info">' + sh_ys + '</label></label> ');
            html.push('    <span  class="phone iconfont icon-zhaoxiangji"></span> ');
            html.push('   </div> ');
            html.push('   <div class="ups"> ');
            html.push('    <div class="up"> ');
            html.push('     <span class="qdl-text" >起订量<em>' + (param['order_amount'] || 0) + '</em></span> ');
            html.push('     <span jgs_id="' + (param['merchant_id'] || 0) + '" class="jgs-text" >' + (param['wldw_mc'] || "") + '</span> ');
            html.push('    </div> ');
            html.push('   </div> ');
            html.push('</li>');

            if (existSh(param)) return fun.toast('色号已存在');
            $('#ys_list').append(html.join(''));
           
            !IS_PAGE_EDIT && $('.phone,.color-list').attr('disabled', true);
        }
    });
});



$('.piliang').on('tap', function (e) {
    if ($(this).attr('disabled')) return;
    addColour({
        type: "pi",
        callback: function (param) {
            var html = [],
                sort = $('#ys_list > li').length + 1,
                sh_ys = (param['number'] || "") + " " + (param['name'] || "");
            html.push('  <li class="color-list lower-border-line item" data-list=\'' + JSON.stringify(param) + '\' > ');
            html.push('   <div class="top"> ');
            html.push('    <div class="check-box boxs ck-one">');
            html.push('     <i class="iconfont icon-check"></i>');
            html.push('    </div> ');
            html.push('<label for="color1"><i class="ys-list-sort">' + sort + '.</i><label class="color-info">' + sh_ys + '</label></label> ');
            html.push('    <span  class="phone iconfont icon-zhaoxiangji"></span> ');
            html.push('   </div> ');
            html.push('   <div class="ups"> ');
            html.push('    <div class="up"> ');
            html.push('     <span class="qdl-text" >起订量<em>' + (param['order_amount'] || 0) + '</em></span> ');
            html.push('     <span jgs_id="' + (param['merchant_id'] || 0) + '" class="jgs-text" >' + (param['wldw_mc'] || "") + '</span> ');
            html.push('    </div> ');
            html.push('   </div> ');
            html.push('</li>');

            if (existSh(param)) return fun.toast('色号已存在');
            $('#ys_list').append(html.join(''));
           
            !IS_PAGE_EDIT && $('.phone,.color-list').attr('disabled', true);
        }
    });
});

function Select_color_series(obj) {
    var series_data = [
        {id: 1, name: '', "is_choose": 1},
        {id: 2, name: '统色'},
        {id: 3, name: '浅色'},
        {id: 4, name: '中色'},
        {id: 5, name: '深色'}
    ];
    $(obj).on('touchend', function (e) {
        e.preventDefault();
        $('input').blur();
        var _this = $(this);
        fun.showBookList({
            width: '280px',
            shadeClose: true,
            list: series_data,
            choose: function (res) {
                $(series_data).each(function (i, arr) {
                    if (arr['id'] == res['id']) {
                        series_data[i]['is_choose'] = 1;
                    } else {
                        series_data[i]['is_choose'] = 0;
                    }
                })
                $(_this).val(res['name'] || "");
            }
        })
        return false;
    });
}
fun.keyboardEject('.sub');
//拖拽事件
var gridDemo = document.getElementById('gridDemo');
var Sortable = new Sortable(gridDemo, {
    animation: 150,
    handle: '.box',
}); 


$('body').on('touchstart','.box-div', function () {
    
    var bbxq_index = $("#gridDemo li").index(this);
    press_startTime = +new Date();
    press_Time = setTimeout(function () {
            
                // var newcircle = $("#bbxq-img .news-circle");
                // if (newcircle.eq(bbxq_index).css("display") == "none") {
                //     newcircle.eq(bbxq_index).css("display","block");
                // }else{
                //     newcircle.eq(bbxq_index).css("display","none");
                // }
            
                // if (press_endTime - press_startTime >= 500) {
                //     if($('.packs').eq(boxindex).css('display') == 'block')  {
                //         $('.packs').eq(boxindex).css('display','none');
                //     }else if(boxindex == 0){
                //         $('.packs').eq(boxindex).css('display','none');
                //     }else{
                //         $('.packs').eq(boxindex).css('display','block');
                //     }               
                // }
            
    }, 500);
});

$('body').on('touchend', '.box-div', function () {
    // var boxindex = $("#gridDemo li").index(this);
    press_endTime = +new Date()
    clearTimeout(press_Time)
    
});

$('body').on('click', '#gridDemo li', function () {
    press_endTime = +new Date();
    // var bbxq_index2 = $("#gridDemo li").index(this);
    clearTimeout(press_Time);
    if (press_endTime - press_startTime < 500) {
        var index = $("#gridDemo li").index(this);
            if($('.complete-btn').text() == '完成'){
                $('.openCamera').css('display','none');
            }else if ($('#gridDemo li img').eq(index).attr('src') == '../../img/null.png'){
                $('.openCamera').css('display','block');
            }else if(!$('#gridDemo li img').eq(index).attr('src') == '../../img/null.png'){
                $('.openCamera').css('display','none');
            };

    }
});