var html_name = page_arr.shop_dk_dkyl,
    photoBrowser,
    swiper, price,
    data;


page_init = function () {
    photoBrowser = api.require('photoBrowser');
    data = page_data['data'];
    price = getPrice(data);
    showData(data);
    //安卓返回键
    page_data.keyback = function () {
        isDataChange();
    };
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['page_type']) {
            case 'dk_bj':
                data = temp['data'];
                price = getPrice(data);
                showData(data);
                console.log(data)
                break;
        }

    });
    //iphoneX适应
    $('.bottom-space-evenly').css('padding-bottom', api.safeArea.bottom);
    $('.main').css('padding-bottom', api.safeArea.bottom);
    if (!Auth.check('cp', 'edit')) {
        $('.footer,.h-right').hide();
        $('.main').css({
            marginBottom: 0,
            paddingBottom: 0
        })
    }
    // $('.button').css('padding-bottom', api.safeArea.bottom + 'px');
    // $('.main').css('padding-bottom', api.safeArea.bottom + 'px');
}

//获取最低单价
function getPrice(data) {
    var _price = 0;
    if ('colour_assistant' in data) {
        $(data['colour_assistant']).each(function (index, colour_item) {
            if (index == 0) {
                _price = ((_price > Number(colour_item['price'])) ? _price : Number(colour_item['price']));
            } else {
                _price = ((_price < Number(colour_item['price'])) ? _price : Number(colour_item['price']));
            }
        })
    }
    return _price
}

//加载固定数据
function showData(data) {
    $('#number').text(data['number'] || '');
    $('#name').text(data['name']);
    if ($.nui.isEmpty($('#number').text()) && $.nui.isEmpty($('#name').text())) {
        $('.cpxx-title p:nth-child(1)').hide();
    } else {
        $('.cpxx-title p:nth-child(1)').show();
    }
    $('#je').text(price || 0);
    $('#unit').text((data['jjdw_mc'] || page_data['dw']) || '');
    $('#main_name').text((data['merchant_type'].indexOf('gys') > -1 ? '供应商' : (data['merchant_type'].indexOf('jgs') > -1 ? '加工商' : '客户')))
    $('#gys').text(data['merchant_name']).data('wldw_lx', data['merchant_id']);

    showPic(data['imgs']);
    //获取客商数据
    getMerchant(data);

    showColor(data['colour_assistant'], data['jjdw_mc'] || page_data['dw']);
}

// 渲染底卡主图
function showPic(imgs) {
    var html = [];
    if ($.nui.isEmpty(imgs)) {
        var tempHtml = [];
        tempHtml.push('<div class="swiper-slide">');
        tempHtml.push('    <img src="../img/logo.png" class="img" data-imgs="img/logo.png" />');
        tempHtml.push('</div>');
        $('#showPic').empty();
        $('#showPic').html(tempHtml.join(''));
        $('.img').css({
            'width': '70%',
            'height': '70%',
            'opacity': 0.3
        });
        return;
    }

    if ($.isArray(imgs)) {
        $(imgs).each(function (i, item) {
            var pic = fun.getImgPath(item, true, { url: UPLOAD_IMG_PATH });
            html.push('<div class="swiper-slide">');
            html.push('     <img src="' + pic + '" class="img" data-index="' + i + '" data-imgs="' + pic + '"/>');
            html.push('</div>')
        })
    } else {
        if (imgs.indexOf(',') < -1) {
            var pic = fun.getImgPath(item, true, { url: UPLOAD_IMG_PATH });
            html.push('<div class="swiper-slide">');
            html.push('     <img src="' + pic + '" class="img" data-index="' + i + '" data-imgs="' + pic + '"/>');
            html.push('</div>');
        } else {
            var Pic_arr = imgs.split(',');
            $(Pic_arr).each(function (i, item) {
                var pic = fun.getImgPath(item, true, { url: UPLOAD_IMG_PATH });
                html.push('<div class="swiper-slide">');
                html.push('     <img src="' + pic + '" class="img" data-index="' + i + '" data-imgs="' + pic + '"/>');
                html.push('</div>');
            })
        }
    }
    $('#showPic').empty();
    $('#showPic').html(html.join(''));
}

//获取客商数据
function getMerchant(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getContactList,
        data: {
            merchant_id: data['merchant_id'],
        },
        success: function (res) {
            if (res['status'] == 0) {
                showContacts(res['data']);
            }
        }
    })
}

//加在页面固定数据
function showContacts(data) {
    if ($.nui.isTrue(data)) {
        var temporary = data[0];
        $('#lxr').text(temporary['name'] || '');
        $('#zw').text(temporary['position'] || '');
        $('#sj').text(temporary['mobile'] || '');
        $('#call').data('list', data)
        $('#dh').text(temporary['phone'] || '');

        $('#cz').text(temporary['fax'] || '');
        $('#dq').text(temporary['province'] + temporary['city'] + temporary['area']).data('province', temporary['province']).data('city', temporary['city']).data('area', temporary['area'])
        $('#dz').text(temporary['address'] || '')
        //判断联系人为空时，隐藏图标
        if ($.nui.isTrue($('#lxr').text())) {
            $('#sex').show()
			//图标显示
            if (temporary['sex'] == "女") {
                $('#sex').removeClass('icon-nan').addClass('icon-nv');
            }else{
                $('#sex').addClass('icon-nan').removeClass('icon-nv');
            }
        } else {
            $('#sex').hide()
        }
        //判断号码为空时，隐藏图标
        if ($.nui.isTrue($('#sj').text())) {
            $('#mobile').show()
            $('#call').show()
        } else {
            $('#mobile').hide()
            $('#call').hide()
        }
        //电话、传真为空时，隐藏
        if ($.nui.isTrue(temporary['phone']) || $.nui.isTrue(temporary['fax'])) {
            if (temporary['phone'] == '') {
                $('#phone,#dh').remove();
            }
            if (temporary['fax'] == '') {
                $('#fax,#cz').hide();
            }
        } else {
            $('#mobile_fax').hide();
        }
        //地区为空时，隐藏
        if ($.nui.isTrue($('#dq').text())) {
            $('#region').show()
        } else {
            $('#region').hide()
        }
        //详细地址为空时，隐藏
        if ($.nui.isTrue($('#dz').text())) {
            $('#detailed').show()
        } else {
            $('#detailed').hide()
        }
    } else {
        $('#sex').hide()
        $('#mobile').hide()
        $('#call').hide()
        $('#mobile_fax').hide()
        $('#region').hide()
        $('#detailed').hide()
    }
}

//加载颜色记录行
function showColor(data, jj_dw) {
    if (data.length == 0) return;
    var html = [];
    for (var i = 0; i < data.length; i++) {
        var data_list = data[i];
        var through = $.nui.isTrue(data_list['is_stop']) ? 'through' : '';
        html.push(' <li data-list=\'' + JSON.stringify(data_list) + '\'>');
        html.push('     <span class="vertical-middle line-height-2rem over_hidden ' + through + '">' + (data_list['colour_number'] || '') + (data_list['colour_name'] || '') + '</span>');
        html.push('     <span class="vertical-middle line-height-2rem over_hidden">' + (data_list['number'] || '') + (data_list['name'] || '') + '</span>');
        html.push('     <span class="line-height-2rem vertical-middle">');
        html.push('         <span class="color-red yc_yc line-height-2rem vertical-middle">' + (data_list['price'] || 0) + '</span>');
        html.push('         <span class="over_hidden line-height-2rem vertical-middle overflow" style="max-width: 1.7rem" > /' + jj_dw || '' + '</span>');
        html.push('      </span>');
        html.push(' </li>');
    }
    $('.cpxx-content').empty();
    $('.cpxx-content').append(html.join(''));
}

//图片可左右滑动
swiper = new Swiper('.swiper-container', {
    initialSlide: 0,
    centeredSlides: true,
    observer: true,
    observeParents: true,
    preventClicks: false,/*滑动时禁止点击事件*/
});

//预览图片  
$('body').on('click', '.img', function (e) {
    var index = $(this).data('index');
    var img_arr = [];
    if ($('.img').length != 0) {
        for (var i = 0; i < $('.img').length; i++) {
            img_arr.push($('.img').eq(i).data('imgs'));
        }
    }
    if (img_arr.join('') == 'img/logo.png') return;
    photoBrowser.open({
        images: img_arr,
        activeIndex: index,
        placeholderImg: 'widget://img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                swiper = new Swiper('.swiper-container', {
                    initialSlide: ret.index,
                    centeredSlides: true,
                    observer: true,
                    observeParents: true,
                    preventClicks: false,/*滑动时禁止点击事件*/
                });
                photoBrowser.close();
            }
        } else {
        }
    });

    return false;
})

//顶部动画
$(window).scroll(function () {
    var h = $(this).scrollTop();
    if (h > 250) {
        $('.header').css({ 'animation': 'scroll250 0.4s ease-in forwards' })
    } else if (h < 250 && h > 100) {
        $('.header').css({ 'animation': 'scroll100 0.4s ease-in forwards' })
    } else if (h === 0) {
        $('.header').css({ 'animation': 'scroll0 0.4s ease-in forwards' })
    }
});

//点击删除
$('body').on('tap', '.h-right', function () {
    document.body.addEventListener('touchmove', preventDefault, { passive: false });
    fun.dialog({
        content: '您确定要删除吗?',
        btn: ['删除', '取消'],
        isClose: false,
        yes: function () {
            fun.showLoad();
            data['is_delete'] = 1;
            fun.toast('删除成功！');
            fun.hideLoad();
            // if($.nui.isTrue(data['id'])){
            //     var merchant_data = page_data['merchant_assistant'];
            //     var delete_merchant_assistant = []
            //     $(merchant_data).each(function(i,item){
            //         if($.nui.isTrue(merchant_data[i]['id'])){
            //             if(merchant_data[i]['id'] == data['id']){
            //                 merchant_data[i] = data
            //             }
            //             delete JSON.parse(JSON.stringify(merchant_data[i]['sort_index']))
            //         }else{
            //             merchant_data.splice(i,1)
            //         }
            //     })
            //     delete_merchant_assistant.push(data['id'])
            //     saveData(merchant_data,delete_merchant_assistant)
            // }else{
            isDataChange();
            // }
            layer.closeAll();
        },
        no: function () {
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
        }
    })
});

//点击编辑底卡
$('body').on('tap', '.button', function () {
    fun.showPageFull({
        page_url: page_arr.shop_dk_bj,
        pageParam: {
            return_page: html_name,
            data: data,
            dw: page_data['dw'],
            jjdw_id: page_data['jjdw_id'],
            type: 'edit',
            merchant_assistant: page_data['merchant_assistant'],
        }
    });
});

$('body').on('click', '#dh', function () {

    if ($.nui.isTrue($(this).text().trim())) {
        api.call({
            type: 'tel_prompt',
            number: $('#dh').text().trim()
        });
    }
})

//拨打电话
$('body').on('click', '#call', function () {
    var list = $(this).data('list');

    if ($.nui.isEmpty(list)) return fun.toast('未填写手机号码！');
    if (list.length === 1) {
        event.stopPropagation();
        var number = list[0]['mobile'];
        if ($.nui.isTrue(number) && fun.regCheck(number, 'phone')) {
            api.call({
                type: 'tel_prompt',
                number: number
            });
        } else {
            fun.toast('手机号码有误！无法拨打电话.');
        }
    } else {
        $('.contacts-list').css('display', 'block');
        var bddhHtml = [];
        bddhHtml.push('  <div class="phone-box">');
        for (var k = 0; k < list.length; k++) {
            bddhHtml.push('                    <ul class="phone-list">');
            bddhHtml.push('                        <li class="khqk-list">');
            bddhHtml.push('                            <span class="phone-lxr">联系人</span>');
            bddhHtml.push('                            <span class="phone-name">' + list[k]['name'] + '</span>');
            if (list[k]['sex'] === '男') {
                bddhHtml.push('                        <i class="iconfont icon-nan1 gender"></i>');
            } else if (list[k]['sex'] === '女') {
                bddhHtml.push('                        <i class="iconfont icon-nv1 gender nv"></i>');
            }
            bddhHtml.push('                            <span class="phone-zw">' + list[k]['position'] + '</span>');
            bddhHtml.push('                        </li>');
            if ($.nui.isTrue(list[k]['mobile'])) {
                bddhHtml.push('                        <li class="khqk-list">');
                bddhHtml.push('                            <span class="phone-lxr">手机</span>');
                bddhHtml.push('                            <span class="phone-name phone-address">' + list[k]['mobile'] + '</span>');
                bddhHtml.push('                            <i class="iconfont icon-dianhuatianchong1 phone-dh" data-dial="' + list[k]['mobile'] + '"></i>');
                bddhHtml.push('                        </li>');
            }
            if ($.nui.isTrue(list[k]['province'])) {
                bddhHtml.push('                        <li class="khqk-list">');
                bddhHtml.push('                            <span class="phone-lxr">地址</span>');
                bddhHtml.push('                            <span class="phone-name phone-address">' + (list[k]['province'] + list[k]['city'] + list[k]['area'] + list[k]['address'] || '') + '</span>');
                bddhHtml.push('                            <i class="iconfont icon-dizhitianchong phone-location" ></i>');
                bddhHtml.push('                        </li>');
            }
            if (k == 0) {
                bddhHtml.push('                        <li class="detail">');
            }
            bddhHtml.push('                        </li>');
            bddhHtml.push('                    </ul>');
        }
        bddhHtml.push('                </div>');
        bddhHtml.push('                <div class="silhouette"></div>');
        $('.contacts-list').html(bddhHtml.join(''));
        openModal();
    }

    return false;
});

$('body').on('click', '.phone-dh', function () {
    event.stopPropagation();
    var number = $(this).data('dial');
    if ($.nui.isTrue(number) && fun.regCheck(number, 'phone')) {
        api.call({
            type: 'tel_prompt',
            number: number
        });
    } else {
        fun.toast('手机号码有误！无法拨打电话.');
    }
    return false;
});

//解决穿透
var ModalHelper = (function (bodyCls) {
    var scrollTop;
    return {
        afterOpen: function () {
            scrollTop = document.scrollingElement.scrollTop; n
            document.body.classList.add(bodyCls);
            document.body.style.top = -scrollTop + 'px';
        },
        beforeClose: function () {
            document.body.classList.remove(bodyCls);
            document.scrollingElement.scrollTop = scrollTop;
        }
    }
})('modal-open');

function openModal() {
    ModalHelper.afterOpen();
}

function closeModal() {
    ModalHelper.beforeClose();
}

$('body').on('click', '.silhouette', function () {
    $('.contacts-list').css('display', 'none');
    closeModal();
    $('.contacts-list').html('');
});

$('body').on('click', '.h-left', function (e) {
    e.stopPropagation();
    e.preventDefault();
    isDataChange();
})

//返回执行
function isDataChange() {
    // if(page_data['type']=='add'){
    //     fun.showPageFull({
    //         page_url: page_arr.shop_dk_xx,
    //         pageParam: {
    //             return_page: html_name,
    //             data: data,
    //             price: price,
    //             type:'add',
    //             merchant_assistant: page_data['merchant_assistant'],
    //             color: page_data['color']
    //         }
    //     });
    // }else{
    console.log(data)
    api.sendEvent({
        // name: page_arr.shop_dk_xx,
        name: page_data['return_page'],
        extra: {
            'status': 'cpzl_data',
            'page_type': 'dk_dkyl',
            'type': page_data['type'],
            'data': data,
            'price': price,
        }
    });

    // }
    closePage();
}

//返回上一页
function closePage() {
    setTimeout(function () {
        api.closeWin({
            name: html_name,
        });
    }, 200);
}

function preventDefault(e) {
    e.preventDefault();
}

//// 删除数据
// function saveData(merchant_data,delete_merchant_assistant) {

//     var count_data = page_data['count_data']
//     if ($.nui.isEmpty(count_data['info']['imgs'])) {
//         count_data['info']['imgs'] = []
//     } else {
//         if (!$.isArray(count_data['info']['imgs'])) {
//             var imgs = count_data['info']['imgs']
//             if (imgs.indexOf(',') > -1) {
//                 count_data['info']['imgs'] = []
//                 count_data['info']['imgs'] = imgs.split(',');
//             } else {
//                 count_data['info']['imgs'] = []
//                 count_data['info']['imgs'].push(imgs)
//             }
//         }
//     }

//     if ($.nui.isEmpty(count_data['info']['bbxq'])) {
//         count_data['info']['bbxq'] = []
//     } else {
//         if (!$.isArray(count_data['info']['bbxq'])) {
//             var imgs = count_data['info']['bbxq']
//             if (imgs.indexOf(',') > -1) {
//                 count_data['info']['bbxq'] = []
//                 count_data['info']['bbxq'] = imgs.split(',');
//             } else {
//                 count_data['info']['bbxq'] = []
//                 count_data['info']['bbxq'].push(imgs)
//             }
//         }
//     }
//     if ($.nui.isEmpty(count_data['info']['color_card'])) {
//         count_data['info']['color_card'] = []
//     } else {
//         if (!$.isArray(count_data['info']['color_card'])) {
//             var imgs = count_data['info']['color_card']
//             if (imgs.indexOf(',') > -1) {
//                 count_data['info']['color_card'] = []
//                 count_data['info']['color_card'] = imgs.split(',');
//             } else {
//                 count_data['info']['color_card'] = []
//                 count_data['info']['color_card'].push(imgs)
//             }
//         }
//     }
//     var save_data = {
//         save_type: 'save',
//         id: count_data['info']['id'] || 0,
//         date: count_data['info']['date'] || '', // 时间
//         number: count_data['info']['number'] || '', // 编号
//         name: count_data['info']['name'] || '', // 名称
//         unit_id: count_data['info']['unit_id'], // 单位id
//         component: count_data['info']['component'] || '', // 成分
//         type: count_data['info']['type'], // 类型
//         diff: count_data['info']['diff'] || '+', // 空差模式
//         imgs: count_data['info']['imgs'], // 主图
//         color_card: count_data['info']['color_card'], // 色卡
//         bbxq: count_data['info']['bbxq'] || [], // 宝贝详情图
//         unit_options: count_data['info']['unit_options'],
//         class_id: count_data['info']['class_id'],
//         remark: count_data['info']['remark'], // 备注
//         label_id: count_data['info']['label_id'], // 标签id
//         is_stop: count_data['info']['is_stop'], // 是否停用
//         is_sj: count_data['info']['is_sj'], // 是否上架
//         craft: count_data['info']['craft'], // 工艺
//         gauze: count_data['info']['gauze'], // 纱布
//         density: count_data['info']['density'], // 门店
//         quarter: count_data['info']['quarter'], // 季度

//         jg_type: count_data['info']['jg_type'], // 价格类型
//         jg_value: JSON.stringify(count_data['info']['jg_value']), // 价格数据

//         goods_colour: count_data['goods_colour'], // 产品颜色
//         delete_colour: [], // 删除的产品颜色
//         delete_material: [],
//         goods_width_weight: count_data['goods_weight'], // 幅宽克重
//         delete_width_weight: [], // 删除的付款克重
//         goods_spec: count_data['goods_spec'], // 规格
//         delete_spec: [], // 删除的规格

//         merchant_assistant: merchant_data || [], // 底卡信息
//         delete_merchant_assistant: delete_merchant_assistant || [], // 删除的底卡信息

//         delete_colour_assistant: [],

//         goods_machining: count_data['goods_machining'], // 加工
//         delete_machining: [], // 删除的加工
//         delete_converter: [], //
//         delete_process: [],

//         goods_craft: count_data['goods_craft'] || [], // 工艺
//         delete_craft: [], // 删除工艺 

//         goods_param: count_data['param'], // 其他参数
//     };
//     fun.ajax({
//         showLoad: true,
//         hideLoad: true,
//         url: AJAX_URL.saveGoods,
//         data: save_data,
//         success: function (res) {
//             switch (res['status']) {
//                 case 0:
//                     fun.showLoad();
//                     isDataChange();
//                     fun.hideLoad();
//                     break;
//                 default:
//                     fun.toast('删除失败')
//                 // case 104:
//                 //     var msg = '';
//                 //     switch (res['data']['type']) {
//                 //         case 'number':
//                 //             msg = '该编号';
//                 //             break;
//                 //         case 'name':
//                 //             msg = '名称';
//                 //             break;
//                 //         case 'colour':
//                 //             msg = res['data']['name'] || '';
//                 //             break;
//                 //         case 'machining':
//                 //             msg = '加工流程-加工商记录表出现相同加工商。';
//                 //             break;
//                 //         case 'assistant':
//                 //             msg = '辅助对象不能出现2个一样的：客\\供\\加。';
//                 //             break;
//                 //     }
//                 //     return fun.toast((res['data']['type'] != 'assistant' && res['data']['type'] != 'machining') ? (msg + '已存在。') : msg);
//                 //     break;
//                 // case 101:
//                 //     fun.toast('保存失败。');
//                 //     break;
//                 // default:
//                 //     fun.toast(res['msg']);
//                 //     break;
//             }
//         }
//     });
// }