var html_name = page_arr.shop_cp_ys_bj; // 页面名称
var return_page = page_data['return_page']; // 需要返回的页面名称
var edit = ''; // 产品资料页面编辑权限
var photoBrowser = {}; // 大图预览 
var saveDataArr = []; // 保存数据数组
var flag = true;
var delete_colour = []; // 被删除的颜色
var backData = [];
var suffix_updata = '#' //批量添加后缀做记忆功能
var searchData = []; // 模糊搜索颜色数据
var add_sx = '';     // 添加颜色，色系做记忆
var editDelete = false; // 修改颜色删除图片

var wrapWidth = $('#gridDemo').css('width'); // 颜色列表宽度

var _origin_data = [], _save_data = [];
var is_delete = {};
var searchIdx = 0;

// 选择色系配置
var series_data = [
    { id: 1, name: '', "is_choose": 1 },
    { id: 2, name: '统色' },
    { id: 3, name: '浅色' },
    { id: 4, name: '中色' },
    { id: 5, name: '深色' }
];

var shopCpYsBj = {};
// 该方法为了处理，按颜色报价，价格填好返回，再重新新增颜色不进入报价页面，价格区间缺少新增颜色
shopCpYsBj.productPriceCheck = function () {
    var info = page_data['count_data']['info'];
    var jgValue = info['jg_value'] || [];
    if (jgValue.length === _save_data.length) {
        return false;
    }
    var tempColorArr = JSON.parse(JSON.stringify(jgValue));
    var tempArr = [];
    for (var i = 0; i < _save_data.length; i++) {
        var colorItem = _save_data[i];
        var mark = false;
        var nowTime = fun.dateFormat('yyyy-MM-dd hh:mm', new Date());
        mark = tempColorArr.some(function (item, idx) {
            return colorItem['number'] === item['cp_ys_bh'];
        })
        if (!mark) {
            tempArr.push({
                idx: i,
                data: colorItem
            });
        }
    }
    for (var i = 0; i < tempArr.length; i++) {
        var item = tempArr[i];
        tempColorArr.splice(item.idx, 0, {
            bz_bzj: 0,
            bz_sj: nowTime,
            cp_mc: info['name'] || '',
            cp_ys_bh: item['data']['number'],
            cp_ys_mc: item['data']['name'] || '',
            cp_ys_id: item['data']['id'] || 0,
            id: page_data['id'] || 0,
            jy_bzj: 0,
            jy_sj: nowTime
        })
    }
    return tempColorArr;
}

// 更新产品价格
shopCpYsBj.productPriceUpDate = function (data) {
    if (data['info']['jg_type'] !== 'ys') return;
    var newProductPrice = this.productPriceCheck();
    if ($.nui.isTrue(newProductPrice)) {
        data['info']['jg_value'] = newProductPrice;
    }
}


// 头部初始化
$('#header').header({
    back: true,
    text_btn: true,   //文字按钮
    title: '产品颜色',
    text_val: '编辑',
    foot_input: {
        show: true,
        scan_icon: false,
        plader: '搜索'
    },
    appendBackBtnEvt: isDataChange // 返回事件
});

// 页面初始化函数
page_init = function () {
    if (page_data['type'] == 'product_view') {
        _origin_data = page_data['count_data']['goods_colour'];
    }

    return_page = page_data['return_page']; // 返回页面
    photoBrowser = api.require('photoBrowser'); //大图预览
    edit = Auth.check('cp', 'edit'); // 页面编辑权限
    saveDataArr = fun.createApiDataIndex(page_data['data']); // 获取保存后的数据
    backData = JSON.parse(JSON.stringify(saveDataArr));

    bindEvent(); // 初始化事件
    init(); // 初始化
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret['value'],
            data = temp['data'];
        switch (temp['status']) {
            case 'select_list':
                //添加颜色弹窗 选择加工商 返回赋值
                $('#xz_jgs').val(data['select_val']).data('jgs_id', data['id']);
                break;
        }
    });
    //监听返回键
    page_data.keyback = function () {
        isDataChange();
    };
    // 解决软键盘弹出不消失的问题，ios关闭app，再次打开app键盘不消失
    api.addEventListener({
        name: 'pause'
    }, function (ret, err) {
        $('#foot_search').blur();
    });
    fun.setKeyBoard({ // 解决安卓和ios软键盘问题
        isIos: {
            showFn: iosKeyBoardShow,
            hideFn: iosKeyBoardHide,
        },
        isAnd: {
            showFn: boardShow,
            hideFn: boardHide,
        }
    });
    fun.inputType();
    //iphoneX适配
    $('#cancelPhoto').css('margin-bottom', api.safeArea.bottom);
    $('.sub').css('padding-bottom', api.safeArea.bottom);
}

// console.log($('#gridDemo').html());

// 没有产品资料页面编辑权限，所有内容不可编辑
function disabledEdit() {
    if ($.nui.isEmpty(edit)) {
        $('.complete-btn').hide(); // 没有编辑权限不显示
        $('.sub').hide();
        $('#gridDemo').removeClass('distance');
        $('.drag').removeClass('drag');
        $('.button').attr('disabled', 'disabled');
        $('#foot_search').attr('readOnly', 'readOnly');
        $('body').off();
    }
}

// 返回上一个页面传递数据
function isDataChange() {
    // saveDataArr = [];
    // $('#gridDemo li').each(function (idx, item) {
    //     var tempList = $(this).data('list');
    //     var list = typeof tempList === 'string' ? JSON.parse(tempList) : tempList;
    //     saveDataArr[idx] = list;
    //     if (!list.is_stop) {
    //         is_stop_count++;
    //     }
    // })

    var is_stop_count = 0;
    $(backData).each(function (idx, item) {
        if (!item['is_stop']) {
            is_stop_count++;
        }
    })
    $(backData).each(function (index, item) {
        delete item['__index'];
    })
    if (page_data['type'] == "product_view") { // 编辑页面进入
        _save_data = JSON.parse(JSON.stringify(backData));
        $(_save_data).each(function (i, item) {
            item['sort'] = i + 1;
        })
        if ($.nui.isObjEquals(_origin_data, _save_data)) {
            Pageclose();
        } else {
            if ($('body').find('.data-change-skin').length) return;
            fun.dialog({
                content: '您确定要保存吗？',
                btn: ['保存', '不保存', '取消'],
                shadeClose: false,
                className: 'data-change-skin',
                yes: function () {
                    api.sendEvent({
                        name: return_page,
                        extra: {
                            status: 'shop_cp_ys_bj',
                            //data: backData,
                            stop_count: is_stop_count,
                            //delete_colour: delete_colour,

                        }
                    })
                    saveData();
                },
                no: function () {
                    Pageclose();
                }
            });
        }
    } else { // 新增页面进入
        api.sendEvent({
            name: return_page,
            extra: {
                status: 'shop_cp_ys_bj',
                data: backData,
                stop_count: is_stop_count,
                delete_colour: delete_colour
            }
        })
        Pageclose();
    }
}

// 返回需要传递的数据，有更改的情况下才去拿
function backSaveData() {
    saveDataArr = [];
    $('#gridDemo li').each(function (idx, item) {
        saveDataArr[idx] = $(this).data('list');
    })
    backData = JSON.parse(JSON.stringify(saveDataArr));
}

// 编辑页面初始化
function init() {
    initPage();
    disabledEdit();
    showList(saveDataArr);
}

// 适配页面样式
function initPage() {
    $('.main').css({
        marginTop: api.safeArea.top + $('#header').outerHeight() - (fun.computedHtmlFontSize() / 2)
    })
}

// 渲染数据
function showList(saveDataArr, options) {
    var html = [];
    $(saveDataArr).each(function (idx, item) {
        var delColorShow = flag ? 'del-color-hide' : 'del-color-show'; // 根据右上角切换状态显示删除颜色图标
        var disabled = false;
        var colorName = item['name'] ? item['number'] + ' ' + item['name'] : item['number']; // 色号+颜色
        var alertEdit = 'alert-edit';
        var isStop = item['is_stop'] && item['is_stop'] >= 1 ? 'line-through' : '';
        var drag = 'drag';
        if (item['number'] === '白坯#') {
            drag = '';
            alertEdit = '';
            disabled = true;
        }

        if (typeof options === 'object') { // 搜索情况下，不能拖拽
            drag = '';
        }

        html.push('<li class="ys-item ' + drag + '"  data-list=\'' + fun.formatString(JSON.stringify(item)) + '\' data-index="' + item['__index'] + '">');
        html.push('    <div class="box">');
        if (item['number'] === '白坯#') {
            html.push('     <div class="delete-img">');
        } else {
            html.push('     <div class="delete-img ' + delColorShow + '">');
        }
        html.push('         <div class="packs" name="pack">');
        html.push('             <i class="iconfont icon-fork fork"></i>');
        html.push('         </div>');
        html.push('     </div>');
        html.push('     <div class="box-div">');
        if ($.nui.isTrue(item['imgs'])) {
            var src = fun.getImgPath(item['imgs'][0]);
            html.push('<img class="in-img" src="' + src + '" data-src="true" data-name="' + fun.getImgPath(item['imgs'][0], true) + '">');
        } else {
            html.push('<img class="nullimg" src="../img/null.png" data-src="false">');
            html.push('<span class="add font-ss">添加颜色图片</span>');
        }
        html.push('        </div>');
        html.push('        <div class="name-div">');
        html.push('             <span class="font-ms colornumber ' + isStop + ' ' + alertEdit + '" data-disabled="' + disabled + '">' + colorName + '</span>');
        html.push('        </div>');
        html.push('    </div>');
        html.push('</li>');
    })
    $('#gridDemo')
        .css({
            width: wrapWidth
        })
        .html(html.join(''))

}

// 拍照
function photoShowDisable() {
    $('.user-shade').hide();
    enableEit();
}

// 调用相机结束
function enableEit() {
    $('#foot_search').removeAttr('readOnly');
    $('#complete_btn').removeClass('disabled-edit'); // 编辑可用
    $('#foot_search').removeClass('disabled-ipt'); // 搜索框可用
}

//添加图片
function addImgToImgs(obj) {
    fun.showLoad();

    var ret_params = {
        data: obj
    }
    if (api.systemType == "ios") {
        showImgs(ret_params, obj);
    } else {
        fun.getUrlBase64(ret_params['data']['data'], 'jpeg', function (base64) {
            ret_params['data']['base64Data'] = base64
            showImgs(ret_params, obj);
        });
    }
}

function showImgs(ret_params, obj) {
    fun.fileUpload(ret_params, function (img) {
        var status = img ? true : false;
        // 如果有调用摄像头，选中，返回添加的图片，并把数据里的替换成对应的路径
        if ($('.box-div').hasClass('liImgNull')) {
            var $nowLi = $('.liImgNull').parents('li');
            var editIdx = $nowLi.index('li');
            var dataList = $nowLi.data('list');

            $('.liImgNull').html('<img class="in-img" src="' + obj.data + '" data-src="' + status + '" data-name="' + obj.data + '"></img>');
            dataList['imgs'][0] = img;
            $nowLi.data('list', dataList);
            $('.box-div').removeClass('liImgNull');
            saveDataArr[searchIdx - 1]['imgs'][0] = img;
            backData = JSON.parse(JSON.stringify(saveDataArr));
        }

        if ($('.photo').hasClass('add-img')) { // 手动添加 (添加图片)
            $('.photo .photo-add-img')
                .attr('src', obj.data)
                .data('img', img);
            $('.show-img').data('img', img);
            $('.arrows-del').html('<i class="iconfont icon-fork arrow"></i>')
            $('.arrows-del').show();
            $('.photo').removeClass('add-img');
        }

        if ($('.photo').hasClass('edit-img')) { // 修改(修改图片)
            $('.photo .photo-edit-img')
                .attr('src', obj.data)
                .data('img', img);
            $('.show-img').data('img', img);
            $('.photo').removeClass('edit-img');

            $('.arrows-del').show();
            $('.arrows-del').html('<i class="iconfont icon-fork arrow"></i>')
        }
        $('#openCamera').hide();
        $('.user-shade').hide();
        photoShowDisable();
        fun.hideLoad();
    })
}

// 添加修改颜色
function addColour(opt) {
    editDelete = false;
    var html = [];
    if (!opt) return;
    var val = opt.value || {};
    var class_name = (val['is_stop'] && val['is_stop'] > 0) ? "nui-active" : "nui-unactive";
    var imgUrl = '../img/null.png';
    // var series = $('.ys-item').eq(val['sort'] - 1).data('series');

    if ($.nui.isTrue(val['imgs'])) {
        imgUrl = fun.getImgPath(val['imgs'][0]);
    }
    if (opt.type !== "batch") {
        html.push('  <div class="warm">');
        html.push('   <div class="warm-title"> ');
        html.push('    <span class="title" style="margin-left:5rem">' + ((opt.type === "add") ? "添加颜色" : "修改颜色") + '</span> ');
        if (opt.type === "edit") { // 修改颜色
            html.push('    <div class="shows"> ');
            html.push('     ');
            html.push('     <i id="ys_is_stop" class="gg-switch stp-btn nui-switch nui-switch-md nui-switch-btn ' + class_name + '"><i class="nui-switch-handle" id="st"></i><label for="ys_is_stop" class="switch-label">停用</label> </i> ');
            html.push('    </div> ');
        } else { // 添加颜色
            html.push('    <div class="shows" style="visibility: hidden;"> ');
            html.push('     ');
            // html.push('     <i id="ys_is_stop" class="gg-switch stp-btn nui-switch nui-switch-md nui-switch-btn ' + class_name + '"><i class="nui-switch-handle" id="st"></i><label for="ys_is_stop" class="switch-label">停用</label> </i> ');
            html.push('    </div> ');
        }

        html.push(' </div> ');

        html.push('   <div class="warm-con"> ');
        html.push('    <ul class="clearfix"> ');
        html.push('     <li class="obj-title"> <span class="param">色号</span> <input id="colour_number" type="text" value="' + (val['number'] || "") + '" /> </li> ');
        html.push('     <li class="obj-title"> <span class="param">颜色</span> <input id="colour" type="text" value="' + (val['name'] || "") + '" /> </li> ');
        html.push('     <li class="obj-title"> <span class="param">色系</span> <input id="colour_series" type="text" readonly="readonly" value="' + (((opt.type === "add") ? opt['value'] : val['type']) || '') + '" /> <i class="iconfont icon-xia down-ico"></i> </li> ');
        html.push('     <li class="obj-title" style="margin-bottom:0.7rem;"> <span class="param">加工商</span> <input id="xz_jgs" type="text" readonly="readonly" data-jgs_id="' + (val['merchant_id'] || "") + '" value="' + (val['wldw_mc'] || "") + '" data-index=" ' + (val['sort'] - 1) + '"/> <i class="iconfont icon-xia down-ico"></i> </li> ');
        html.push('         <li class="obj-title">');
        html.push('              <span class="param">图片</span>');

        var imgStatus = '';
        switch (opt.type) {
            case 'add':
                html.push('     <div class="photo add-img">');
                imgStatus = 'photo-add-img';
                break;
            case 'edit':
                html.push('     <div class="photo edit-img">');
                imgStatus = 'photo-edit-img';
                break;
            default:
                html.push('     <div class="photo">');
                imgStatus = '';
                break;
        }


        if (val['type'] === 'edit') {
            html.push('         <img src="' + imgUrl + '" class="show-img ' + imgStatus + '" data-img="' + val['imgs'][0] + '"/>');
        } else {
            html.push('         <img src="' + (opt.name || imgUrl) + '" class="show-img ' + imgStatus + '"/>');
        }

        html.push('         <div class="arrows-del" style="height:0.8rem;width:0.8rem;line-height:0.8rem">');
        html.push('             <i class="iconfont icon-fork arrow"></i>');
        html.push('         </div>');

        html.push('              </div>');
        html.push('         </li>');
        html.push('    </ul> ');
        html.push('   </div> ');
        html.push('   <div class="warm-operation" style="margin-top: 0; position: static;"> ');
        html.push('    <button class="btn" id="cancel">取消</button>');
        html.push('    <button class="btn" id="confirm">确认</button> ');
        html.push('   </div> ');
        html.push('  </div>');
    } else { // 批量生成
        html.push('  <div class="warm"> ');
        html.push('   <div class="warm-title"> ');
        html.push('    <span class="title">' + '批量生成' + '</span> ');
        html.push('   </div> ');
        html.push('   <div class=rm-con"> ');
        html.push('    <ul class="clearfix"> ');

        html.push('<li class="obj-title">');
        html.push('     <span class="param">色号</span>');
        html.push('     <input id="colour_number_start" class="num-input" style="width:34%;" type="text" num_type="4" decimal_digits="4" value="' + $('#gridDemo li').length + '"/>');
        html.push('     <span style="margin: 0 .2rem; line-height: 1.5rem;">-</span>');
        // html.push('     &nbsp;&nbsp;-&nbsp;&nbsp;');
        html.push('     <input id="colour_number_end" class="num-input" style="width:34%;" type="text" num_type="4" decimal_digits="4"/>');
        html.push('</li">');
        // html.push('     <li class="obj-title"> <span class="param">色号</span> <input id="colour_number_start" class="num-input" num_type="2" decimal_digits="4" style="width:34%" type="text" value="' + $('#gridDemo li').length + '" />&nbsp;&nbsp;-&nbsp;&nbsp;<input id="colour_number_end" class="num-input" style="width:34%" type="text" num_type="2" decimal_digits="4" value="' + (val['number'] || "") + '" /></li> ');

        html.push('     <li class="obj-title"> <span class="param">前缀</span> <input id="prefix" type="text"/> </li> ');
        html.push('     <li class="obj-title"> <span class="param">后缀</span> <input id="suffix" type="text" value=' + suffix_updata + '> </li> ');
        html.push('     <li class="obj-title"> <span class="param">色系</span> <input id="colour_series" type="text" readonly="readonly" value="' + (((opt.type === "batch") ? opt['value'] : val['type']) || '') + '" /> <i class="iconfont icon-xia down-ico"></i> </li> ');
        html.push('    </ul> ');
        html.push('   </div> ');
        html.push('   <div class="warm-operation" style="margin-top: 0; position: static";> ');
        html.push('    <button class="btn" id="cancel">取消</button>');
        html.push('    <button class="btn" id="confirm">确认</button> ');
        html.push('   </div> ');
        html.push('  </div>');
    }
    layer.open({
        type: 1,
        content: html.join(''),
        shadeClose: false,
        style: 'width: 90%; min-height: auto; border-radius: 0.5rem;background-color: #fff; overflow-y: hidden;', // position: fixed;top: 25%;left: 5%;
        success: function () {
            document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
            $('#xz_jgs').val(val['wldw_mc']);
            var jgsMc = val['wldw_mc'];
            var ysType = val['type'];

            var oriSHVal = $('#colour_number').val(); // 选择的色号

            $('body').on('tap', '.photo', function (e) {
                e.stopPropagation();
                e.preventDefault();

                switch (opt.type) {
                    case 'add': // 手动添加
                        $(this).addClass('add-img');
                        break;
                    case 'edit': // 修改
                        $(this).addClass('edit-img');
                        break;
                    case 'batch': // 批量添加

                        break;
                    // 没有default:
                }
                $('.openCamera').css({
                    display: 'block',
                    zIndex: '99999999'
                });
                return false;
            })

            //确定 
            $('#confirm').on('tap', function () {
                $('#openCamera').hide();
                if (typeof opt.callback == 'function') {
                    switch (opt['type']) {
                        case 'add':
                        case 'edit':
                            if ($.nui.isEmpty($('#colour_number').val().trim())) {
                                $('#colour_number').val('');
                                return fun.toast("色号不能为空。");
                            }
                            if ($('#colour_number').val().trim() == '色卡') {
                                return fun.toast("色号不能为色卡。");
                            }
                            break;
                    }

                    var param = null;
                    switch (opt['type']) {
                        case 'add': // 手动添加
                            param = {
                                id: 0,
                                sort: $('#gridDemo li').length + 1,
                                number: $('#colour_number').val().trim() || "",
                                name: $('#colour').val().trim() || "",
                                type: $('#colour_series').val().trim() || "",
                                wldw_mc: $('#xz_jgs').val().trim() || "",
                                merchant_id: $('#xz_jgs').data('jgs_id') || 0,
                                order_amount: '',
                                is_stop: 0,
                                remark: '',
                                imgs: [],
                                goods_material: [],
                                yarn_material: [] // 2024-04-08 添加字段，不添加会报错
                                // __index: $('#gridDemo li').length
                            };
                            add_sx = $('#colour_series').val().trim() || "";

                            if (existSh(param['number'], saveDataArr, opt.type)) return fun.toast('色号已存在。');
                            if ($.nui.isEmpty(param['number'])) return fun.toast('色号不能为空。');
                            if ($.nui.isTrue($('.photo .photo-add-img').data('img'))) {
                                param['imgs'][0] = $('.photo .photo-add-img').data('img');
                                param['imgPath'] = $('.photo .photo-add-img').attr('src');
                                // $('.photo .photo-edit-img').removeClass('photo-add-img');
                            }
                            $('.empty_text').remove();
                            opt.callback(param);
                            break;
                        case 'edit': // 修改颜色
                            var coloNumber = $('#colour_number').val().trim();
                            param = {
                                number: $('#colour_number').val().trim() || "",
                                name: $('#colour').val().trim() || "",
                                type: $('#colour_series').val().trim() || "",
                                wldw_mc: $('#xz_jgs').val().trim() || "",
                                merchant_id: $('#xz_jgs').data('jgs_id') || 0,
                                is_stop: $('#ys_is_stop').hasClass('nui-active') ? 1 : 0,
                                imgs: val['imgs'] || [],
                            };

                            // 有图的情况下，删除掉图片，没删除掉
                            if ($.nui.isTrue($('.photo .photo-edit-img').data('img'))) {
                                param['imgs'][0] = $('.photo .photo-edit-img').data('img');
                                param['imgPath'] = $('.photo .photo-edit-img').attr('src');
                            } else {
                                if (editDelete) {
                                    param['imgs'] = [];
                                    // var idx = opt['value']['sort'] - 1;
                                    saveDataArr[searchIdx - 1]['imgs'] = [];
                                }
                            }
                            for (var i = 0; i < saveDataArr.length; i++) {
                                if (i === (val['sort'] - 1)) { // 判断自己之外的做比较
                                    continue;
                                } else {
                                    // 出现问题
                                    if (i === searchIdx - 1) {
                                        continue;
                                    }
                                }
                                if (coloNumber === saveDataArr[i]['number']) { // 修改的色号已存在
                                    return fun.toast('色号已存在。');
                                }
                            }
                            opt.callback(param);
                            break;
                        case 'batch': // 批量添加
                            var param = [];
                            var colorNumStart = fun.toNumber($('#colour_number_start').val().trim()); // 开始色号
                            var colorNumEnd = fun.toNumber($('#colour_number_end').val().trim()); // 结束色号
                            var prefix = fun.is_value($('#prefix').val().trim()); // 前缀
                            var suffix = fun.is_value($('#suffix').val().trim()); // 后缀
                            suffix_updata = suffix;
                            $('#suffix').val(suffix_updata);
                            add_sx = $('#colour_series').val().trim() || "";
                            if (!colorNumEnd) { // 开始有，结束没有
                                return fun.toast('批量生成的两个范围都要填。');
                            } else if (colorNumEnd < colorNumStart) { // 结束小于开始范围
                                return fun.toast('范围的格式输入有误。');
                            }

                            if (colorNumStart === colorNumEnd) { // 输入的相等
                                var createColorNum = (prefix + colorNumStart + suffix).trim(); // 是否包含前后缀的色号
                                var findTxtArr = [];

                                $(saveDataArr).each(function (idx, item) {
                                    var colorNum = item['number'];
                                    if (createColorNum === colorNum) {
                                        findTxtArr.push(true);
                                    } else {
                                        findTxtArr.push(false);
                                    };
                                })

                                // $('#gridDemo li').each(function (idx, ele) {
                                //     var colorNum = $(this).data('list')['number'];
                                //     if (createColorNum === colorNum) {
                                //         findTxtArr.push(true);
                                //     } else {
                                //         findTxtArr.push(false);
                                //     };
                                // });

                                // 添加的这条颜色，
                                var flag = findTxtArr.every(function (value) {
                                    return value === false;
                                })

                                if (flag) { // 存在（一条的情况下, eg：5 - 5,是否存在这条，不存在添加，反之
                                    // fun.toast('改颜色已存在');
                                    param = [{
                                        id: 0,
                                        sort: $('#gridDemo li').length,
                                        number: createColorNum,
                                        name: '',
                                        type: $('#colour_series').val().trim() || "",
                                        is_stop: 0,
                                        imgs: [],
                                        __index: $('#gridDemo li').length,
                                        wldw_mc: "",
                                        merchant_id: 0,
                                        order_amount: '',
                                        remark: '',
                                        goods_material: [],
                                        yarn_material: [] // 2024-04-08 添加字段，不添加会报错
                                    }];
                                } else { // 不存在添加进去
                                    layer.closeAll();
                                    return;
                                }
                                $('.empty_text').remove();
                                opt.callback(param, {
                                    lx: 'manual'
                                });
                            }

                            if (colorNumStart < colorNumEnd) { // 添加多条
                                var idx = 0;
                                var findTxtArr = []; // 找到页面所有页面
                                var param = [];
                                var addSum = colorNumEnd - colorNumStart + 1; // 需要添加多少条数据

                                if (addSum > 99) return fun.toast('一次最多只能生成99个色。');

                                $(saveDataArr).each(function (idx, item) {
                                    var colorNum = $.nui.isTrue(item['name']) ? item['number'] + ' ' + item['name'] : item['number'];
                                    findTxtArr.push(colorNum);
                                })

                                // $('#gridDemo li').each(function (idx, ele) {
                                //     var colorNum = $(this).find('.font-ms').text().trim();
                                //     findTxtArr.push(colorNum);
                                // });

                                for (var i = 0; i < addSum; i++) {
                                    var createColorNum = (prefix + (colorNumStart + i) + suffix).trim(); // 是否包含前后缀的色号

                                    var mark = valueInArr(createColorNum, findTxtArr);
                                    if (!mark) { // 不存在添加
                                        // sort 和 index 不知道怎么删除
                                        param.push({
                                            id: 0,
                                            // "sort": $('#gridDemo li').length - 1 + (idx++),
                                            number: createColorNum,
                                            name: '',
                                            type: $('#colour_series').val().trim() || "",
                                            is_stop: 0,
                                            imgs: [],
                                            wldw_mc: "",
                                            merchant_id: 0,
                                            order_amount: '',
                                            remark: '',
                                            goods_material: [],
                                            yarn_material: [] // 2024-04-08 添加字段，不添加会报错
                                        })
                                    }
                                }
                                $('.empty_text').remove();
                                opt.callback(param, {
                                    lx: 'batch'
                                });
                                // 批量添加多条，
                            }
                            break;
                    }
                }
                setTimeout(function () {
                    layer.closeAll()
                }, 50)
            });

            // 取消事件
            $('#cancel').on('tap', function () {
                $('#openCamera').hide();
                setTimeout(function () {
                    $('.ys-item.edit-jgs').removeClass('edit-jgs');
                    // series_data = [
                    //     { id: 1, name: '', "is_choose": 1 },
                    //     { id: 2, name: '统色' },
                    //     { id: 3, name: '浅色' },
                    //     { id: 4, name: '中色' },
                    //     { id: 5, name: '深色' }
                    // ];

                    if (opt['type'] === 'edit') {
                        saveDataArr[val['sort'] - 1]['wldw_mc'] = jgsMc;
                        saveDataArr[val['sort'] - 1]['type'] = ysType;
                    }

                    layer.closeAll();
                }, 50)
            });

            // 选择色系
            // if (opt['type'] === 'edit') {
            //     Select_color_series($('#colour_series'), series, opt);
            // } else {
            // }
            Select_color_series($('#colour_series'));

            // 选择加工商
            $('#xz_jgs').on('tap', function () {
                fun.showPageFull({
                    "page_url": page_arr.customer_search,
                    "pageParam": {
                        "return_page": html_name,
                        "page_type": "jgs"
                    }
                });
            });

            // 色号
            $('#colour_number').on('blur', function (e) {
                if ($(this).val().trim() == '') {
                    $(this).val(oriSHVal);
                }
            });
        },
        end: function () { // 阻止滑动
            document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        }
    });
    if (imgUrl.indexOf('../img/null.png')) {
        $('.arrows-del').show()
        $('.arrows-del .arrow').show()
    }
}

//是否存在色号
function existSh(number, saveDataArr, type) {
    if (type === 'add' || type === 'edit') {
        for (var i = 0; i < saveDataArr.length; i++) {
            var item = saveDataArr[i];
            if (number === item['number']) {
                return true;
            }
        }
        return false; // 不存在
    }
}

// var series_data = [
//     { id: 1, name: '', "is_choose": 1 },
//     { id: 2, name: '统色' },
//     { id: 3, name: '浅色' },
//     { id: 4, name: '中色' },
//     { id: 5, name: '深色' }
// ];

// 选择色系
function Select_color_series(obj) {
    // var tempSeries = series_data;

    // if (typeof opt === 'object' && opt['type'] === 'edit') { // 修改状态下，需要做色系选择记忆
    //     tempSeries = series;
    // }

    $(obj).on('touchend', function (e) {
        e.preventDefault();
        $('input').blur();
        var _this = $(this);
        var sxName = _this.val();
        $(series_data).each(function (i, arr) {
            if (arr['name'] === sxName) {
                series_data[i]['is_choose'] = 1;
            } else {
                series_data[i]['is_choose'] = 0;
            }
        })
        fun.showBookList({
            width: '280px',
            shadeClose: true,
            list: series_data,
            choose: function (res) {
                $(series_data).each(function (i, arr) {
                    if (arr['id'] === Number(res['id'])) {
                        series_data[i]['is_choose'] = 1;
                    } else {
                        series_data[i]['is_choose'] = 0;
                    }
                })
                $(_this).val(res['name'] || "");
            }
        })
        return false;
    });
}

fun.keyboardEject('.sub');

//拖拽事件
var sorTable = new Sortable($('#gridDemo')[0], {
    animation: 150,
    draggable: '.drag',
    delay: 500,
    // scroll: true,
    onStart: function (evt) {
        saveDataArr = [];
        // dragStartY = $(e.item).offset().top;
        var index = evt.oldIndex;
        $('.ys-item').eq(index).css({ 'transform': 'scale(1.1)' });
    },
    onEnd: function (e) {
        $('.ys-item').each(function (idx, item) {
            var list = $(this).data('list');
            saveDataArr.push(list);
        })
        var index = e.oldIndex;
        $('.ys-item').eq(index).css({ 'transform': 'scale(1)' });
        $(saveDataArr).each(function (idx, item) {
            item['sort'] = idx + 1;
            item['__index'] = idx;
        })

        backData = JSON.parse(JSON.stringify(saveDataArr));

        var thatHeight = $(e.item).outerHeight();
        var headerHeight = fun.fontUnit(6.75);
        var buttonHeight = $('.sub').outerHeight();
        var res = $(e.item).position().top - ((window.screen.height - headerHeight - buttonHeight - thatHeight) / 2);
        $('html,body').animate({
            scrollTop: res
        }, 500);
    }
});

// 判断是否是数组还是
function isArrayFn(value) {
    if (typeof Array.isArray === "function") {
        return Array.isArray(value);
    } else {
        return Object.prototype.toString.call(value) === "[object Array]";
    }
}

/**
 * Searcher.search(list, userInput); 前端模糊搜索
 * @param list 查询列表
 * @param keyword 查找关键字
 */
var Searcher = (function () {
    var escapeRegExp = /[\-#$\^*()+\[\]{}|\\,.?\s]/g;

    var escapeReg = function (reg) {
        return reg.replace(escapeRegExp, '\\$&');
    }

    // groupLeft 与 groupRight是对结果进一步处理所使用的分割符，可以修改
    // var groupLeft = '(',
    //     groupRight = ')';
    // var groupReg = new RegExp(escapeReg(groupRight + groupLeft), 'g');

    var groupExtractReg = new RegExp('[\\s\\S]+?', 'g');
    //从str中找到最大的匹配长度

    var findMax = function (str, keyword) {
        var max = 0;
        // keyword = groupLeft + keyword + groupRight;
        str.replace(groupExtractReg, function (m) {
            //keyword完整的出现在str中，则优秀级最高，排前面
            if (keyword == m) {
                max = Number.MAX_SAFE_INTEGER;
            } else if (m.length > max) {//找最大长度
                max = m.length;
            }
        });
        return max;
    };
    var keyReg = function (key) {
        var src = ['(.*?)('];
        var ks = key.split('');
        if (ks.length) {
            while (ks.length) {
                src.push(escapeReg(ks.shift()), ')(.*?)(');
            }
            src.pop();
        }
        src.push(')(.*?)');
        src = src.join('');
        var reg = new RegExp(src, 'i');
        var replacer = [];
        var start = key.length;
        var begin = 1;
        while (start > 0) {
            start--;
            replacer.push('$', begin, '$', begin + 1);
            begin += 2;
        }
        replacer.push('$', begin);

        info = {
            regexp: reg,
            replacement: replacer.join('')
        };
        return info;
    };

    return {
        search: function (list, keyword) {
            //生成搜索正则
            var kr = keyReg(keyword);
            var result = [];

            for (var i = 0; i < list.length; i++) {
                var e = list[i];
                //如果匹配
                if (kr.regexp.test(e)) {
                    //把结果放入result数组中
                    // result.push(e.replace(kr.regexp, kr.replacement)
                    //     .replace(groupReg, ''));
                    result.push(e.replace(kr.regexp, kr.replacement));
                }
            }

            //对搜索结果进行排序
            //1. 匹配关键字大小写一致的优先级最高，比如搜索up, 结果中的[user-page,beginUpdate,update,endUpdate]，update要排在最前面，因为大小写匹配
            //2. 匹配关键字长的排在前面

            result = result.sort(function (a, b) {
                return findMax(b, keyword) - findMax(a, keyword);
            });

            return result;
        }
    };
})();

// 判断值是否在数组中
function valueInArr(value, arr) {
    for (var i = 0; i < arr.length; i++) {
        var val = arr[i];
        if (val == value) return true;
    }
    return false;
};

// 调用相机和相册
function callCamera(sourceType) {
    $('#openCamera,.user-shade').hide();
    // 解决tap穿透
    $('.cut').css('pointer-events', 'none');
    setTimeout(function () {
        $('.cut').css('pointer-events', 'auto');
    }, 200);
    QuestPermission.requestPermission('camera', null, function () {
        api.getPicture({
            sourceType: sourceType,
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            // quality: 100,
            // targetWidth: 1000,
            // targetHeight: 1000,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                ret['data'] = ret['data'] || {};
                if (ret.data) {
                    fun.UploadRestriction(ret, function () {
                        addImgToImgs(ret);
                    })
                }
                if ($.nui.isEmpty(ret['data']['base64Data'])) { // 调用没选择直接返回
                    photoShowDisable();
                }
            } else {
                $('.box-div').removeClass('liImgNull')
            }
        });
    });

}

// 关闭页面
function Pageclose() {
    setTimeout(function () {
        api.closeToWin({ name: return_page }); // 关闭到上一个页面
    }, 200)
}

// 重置图片路径，字符串转数据（过滤空值）
function resetImgArr(info, name) {
    var tempArr = [];
    if ($.nui.isEmpty(info[name])) { // 没图片
        tempArr = [];
    }
    if ($.nui.isTrue(info[name])) {
        var imgs = info[name].split(',');
        $(imgs).each(function (idx, item) {
            if ($.nui.isTrue(item)) {
                tempArr.push(item);
            }
        })
    }
    return tempArr;
}

// 去除单双引号和空数组的值
function imgFormat(save_data, name) {
    var tempArr = [];
    $(save_data[name]).each(function (idx, item) {
        if ($.nui.isTrue(item)) {
            tempArr.push(item);
        }
    })
    return tempArr;
}

function saveData() {
    var data = page_data['count_data'];
    var delete_color = []; //删除颜色
    var delete_color_fzxx = [] //删除底卡信息颜色
    $(delete_colour).each(function (i, item) {
        delete_color.push(item['id'])
    })
    if (data && data['merchant_assistant'].length > 0) {
        $(data['merchant_assistant']).each(function (merchant_index, colour_item) {
            // var colour_length = colour_item['colour_assistant'].length;
            var parme_arr = [];
            $(_save_data).each(function (colour_index, item) {   //返回颜色通知底卡颜色改变
                var index = item['_index']
                //判断如果有新增的颜色则做加入，存在则做修改,如果存在，则colour_assistant数组长度是大于0的
                if (('_index' in item)) {
                    var colour_assistant = colour_item['colour_assistant'][index];
                }
                if (('_index' in item) && colour_item['colour_assistant'].length > 0 && colour_assistant != undefined && ('goods_colour_id' in colour_assistant)) {
                    var parme = {
                        colour_number: item['number'] || '',
                        colour_name: item['name'] || '',
                        id: colour_assistant['id'],
                        goods_id: item['goods_id'],
                        merchant_assistant_id: colour_assistant['merchant_assistant_id'],
                        goods_colour_id: item['id'],
                        number: colour_assistant['number'] || '',
                        name: colour_assistant['name'] || '',
                        simple: colour_assistant['simple'],
                        order_amount: colour_assistant['order_amount'] || 0,
                        price: colour_assistant['price'] || 0,
                        is_delete: colour_assistant['is_delete'],
                        create_time: colour_assistant['create_time'],
                        update_time: colour_assistant['update_time'],
                    }
                    parme_arr.push(parme)
                } else {
                    var parme = {
                        colour_name: item['name'],
                        colour_number: item['number'],
                        id: 0,
                        is_delete: 0,
                        name: '',
                        number: '',
                        order_amount: 0,   //如果底卡是新增的，但还没保存的情况下，则那新增时价格对应进去，如果有多余的，则取0
                        price: 0,
                    }
                    parme_arr.push(parme);
                }
            })
            if ($.nui.isTrue(delete_colour)) {
                $(delete_colour).each(function (idx, item) {
                    if (item['_index'] != '') {
                        if (colour_item['colour_assistant'] && colour_item['colour_assistant'][item['_index']]) {
                            delete_color_fzxx.push(colour_item['colour_assistant'][item['_index']]['id']);
                        }
                    }
                })
            }
            colour_item['colour_assistant'] = parme_arr;
            colour_item['imgs'] = $.nui.isTrue(colour_item['imgs']) ? colour_item['imgs'].split(',') : [];
        })
    }

    shopCpYsBj.productPriceUpDate(data);

    var save_data = {
        save_type: 'save',
        id: data['info']['id'] || 0,
        date: data['info']['date'] || '', // 时间
        number: data['info']['number'] || '', // 编号
        name: data['info']['name'] || '', // 名称
        unit_id: data['info']['unit_id'], // 单位id
        component: data['info']['component'] || '', // 成分
        type: data['info']['type'] === '成品' ? 'cp' : 'pb', // 类型
        diff: data['info']['diff'] || '+', // 空差模式
        imgs: resetImgArr(data['info'], 'imgs'), // 主图
        color_card: resetImgArr(data['info'], 'color_card'), // 色卡
        bbxq: resetImgArr(data['info'], 'bbxq'), // 宝贝详情图
        unit_options: data['info']['unit_options'],
        class_id: data['info']['class_id'],
        remark: data['info']['remark'], // 备注
        label_id: data['info']['label_id'], // 标签id
        is_stop: data['info']['is_stop'], // 是否停用
        is_sj: data['info']['is_sj'], // 是否上架
        craft: data['info']['craft'], // 工艺
        gauze: data['info']['gauze'], // 纱布
        density: data['info']['density'], // 门店
        quarter: data['info']['quarter'], // 季度
        jg_type: data['info']['jg_type'], // 价格类型
        jg_value: JSON.stringify(data['info']['jg_value']), // 价格数据
        goods_colour: _save_data, // 产品颜色
        delete_colour: delete_color || [], // 删除的产品颜色
        delete_material: [],
        goods_width_weight: data['goods_weight'], // 幅宽克重
        delete_width_weight: [], // 删除的付款克重
        goods_spec: data['goods_spec'], // 规格
        delete_spec: [], // 删除的规格

        merchant_assistant: data['merchant_assistant'], // 底卡信息
        delete_merchant_assistant: [], // 删除的底卡信息

        delete_colour_assistant: delete_color_fzxx || [],  // 删除的底卡信息颜色

        goods_machining: data['goods_machining'], // 加工
        delete_machining: [], // 删除的加工
        delete_converter: [], //
        delete_process: [],

        goods_craft: data['goods_craft'] || [], // 工艺
        delete_craft: [], // 删除工艺 

        goods_param: data['param'], // 其他参数

        // 纱线相关
        goods_xzgy: data['goods_xzgy'] || [],
        delete_yarn_material: data['delete_yarn_material'] || [],
        delete_xzgy: data['delete_xzgy'] || []
    };

    // 产品类型兼容
    save_data['type'] = fun.compatGoodsType(save_data['type']);

    console.log(JSON.stringify(save_data));

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveGoods,
        data: save_data,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.showLoad();
                    api.sendEvent({
                        name: page_arr.shop_product_view,
                        extra: {
                            status: 'refresh'
                        }
                    })
                    Pageclose();
                    fun.hideLoad();
                    break;
                case 104:
                    var msg = '';
                    switch (res['data']['type']) {
                        case 'number':
                            msg = '该编号';
                            break;
                        case 'name':
                            msg = '名称';
                            break;
                        case 'colour':
                            msg = res['data']['name'] || '';
                            break;
                        case 'machining':
                            msg = '加工流程-加工商记录表出现相同加工商。';
                            break;
                        case 'assistant':
                            msg = '辅助对象不能出现2个一样的：客\\供\\加。';
                            break;
                    }
                    return fun.toast((res['data']['type'] != 'assistant' && res['data']['type'] != 'machining') ? (msg + '已存在。') : msg);
                    break;
                case 101:
                    fun.toast('保存失败。');
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    });
}

// 获取编辑的下标
function findEditIdx(allData, seftData) {
    var index = 0;
    for (var i = 0; i < allData.length; i++) {
        if (seftData['number'] === allData[i]['number']) {
            index = allData[i]['sort'];
            break;
        }
    }
    return index;
}

// 键盘弹出
function boardShow() {
    $('.sub').hide();
    // 解决键盘弹起造成的地步空出多余的边距问题
    $('.ys-list').removeClass('distance').addClass('normal');
}

// 键盘收起
function boardHide() {
    $('.sub').show();
    $('.ys-list').removeClass('normal').addClass('distance');
}

// ios软键盘弹出显示样式
function iosKeyBoardShow() {
    fun.headerAbsolute('#header');
    $('.main').removeClass('scroll');
    boardShow();
}

// ios软键盘收起显示样式
function iosKeyBoardHide() {
    fun.headerFixed('#header');
    $('.main').addClass('scroll');
    boardHide();
}

// 绑定事件
function bindEvent() {
    // 解决穿透
    $('.user-shade').on('touchmove', function (event) {
        event.preventDefault();
    });

    $('body').on('tap', '.box-div', function (e) {
        e.stopPropagation();
        e.preventDefault();
        if ($('.ys-item').hasClass('edit-disabled')) return;
        var that = $(this);
        var mark = that.find('img').data('src');
        if (mark) { // 有图片
            photoBrowser.open({ // 调用大图预览
                images: [that.find('img').data('name')],
                placeholderImg: '../img/logo.png',
                bgColor: '#000'
            }, function (ret, err) {
                if (ret) {
                    if (ret['eventType'] == 'click') {
                        photoBrowser.close();
                    }
                } else {
                }
            });
        } else { // 没图片调用摄像机模块
            var list = that.parents('.ys-item').data('list');
            that.addClass('liImgNull');
            $('.user-shade').show();
            searchIdx = findEditIdx(saveDataArr, list);
            // 调用相机，页面元素不可编辑
            $('#foot_search').attr('readOnly', 'readOnly');
            $('#complete_btn').addClass('disabled-edit'); // 编辑
            $('#foot_search').addClass('disabled-ipt'); // 搜索框
            $('.openCamera').css('display', 'block'); // 调用相机模块
        }
    });

    // 点击编辑完成切换
    $('body').on('tap', '#complete_btn', function () {
        var _mark = '';
        if ($(this).hasClass('disabled-edit')) { // 调用相机时，页面无法编辑
            return;
        }
        if ($.nui.isEmpty(edit)) { // 没有编辑权限
            return;
        }

        var showTxt = flag ? '完成' : '编辑';
        $(this).text(showTxt);

        if ($.nui.isEmpty(searchData)) {
            _mark = saveDataArr.every((function (item) {
                return item['number'] !== '白坯#';
            }))
        } else {
            _mark = searchData.every((function (item) {
                return item['number'] !== '白坯#';
            }))
        }
        if (flag) { // 完成
            $('#foot_search').addClass('disabled-search');
            $('#foot_search').val('');
            $('.ys-item,.colornumber').addClass('edit-disabled'); // 完成状态下，图片和色号点击事件无效
            if (_mark) {
                var delColorShow = flag ? 'del-color-hide' : 'del-color-show'; // 根据右上角切换状态显示删除颜色图标

                $('.delete-img').removeClass('del-color-hide').addClass('del-color-show');
            } else {
                $('.delete-img:not(:first)').removeClass('del-color-hide').addClass('del-color-show');
            }
        } else { // 编辑
            $('.ys-item,.colornumber').removeClass('edit-disabled'); // 编辑状态下，恢复点击事件
            $('#foot_search').removeClass('disabled-search');
            $('.delete-img').removeClass('del-color-show').addClass('del-color-hide');
            // console.log($('.ys-list').html());
        }

        flag = !flag;
    })

    // 监听搜索框的变化
    $('#foot_search').on('search', function (e) {
        $('#gridDemo')
            .css({
                width: wrapWidth
            })
        e.stopPropagation();
        e.preventDefault();
        fun.showLoad('加载中...');
        $('#foot_search').hasClass('disabled-search')
        $('#foot_search').hasClass('disabled-ipt')
        if ($(this).hasClass('disabled-search') || $(this).hasClass('disabled-ipt')) { // 编辑切完成。不触发没值搜索渲染
            fun.hideLoad();
        }
        var matchArr = [];
        var saveMatchData = [];

        var searchVal = $('#foot_search').val().trim(); // 用户搜索值
        if (!searchVal) {
            searchData = saveDataArr;
            // 渲染数据
            showList(saveDataArr);
            fun.hideLoad();
            return;
        } else {
            for (var idx = 0; idx < saveDataArr.length; idx++) {
                var item = saveDataArr[idx];
                var val = $.nui.isTrue(item['name']) ? item['number'] + ' ' + item['name'] : item['number'];
                matchArr.push(val);
            }

            var target = Searcher.search(matchArr, searchVal); // 搜索匹配到的数据，结构为 数组形式 [1, 2]
            if ($.nui.isEmpty(target)) { // 有关键字，搜索不到数据，显示暂无数据!
                $('.ys-list').empty();
                // $('.ys-list').html('<p class="empty_text">暂无数据！</p>');
                fun.hideLoad();
                return fun.createDataEmptyTips({ dom: '.ys-list', btnShow: false });
            }

            for (var i = 0; i < target.length; i++) {
                var targetVak = target[i]; // 模糊搜索匹配到的每一条完整的数据
                for (var j = 0; j < saveDataArr.length; j++) {
                    var item = saveDataArr[j];
                    var matchTxt = $.nui.isTrue(item['name']) ? item['number'] + ' ' + item['name'] : item['number'];
                    if (targetVak === matchTxt) {
                        saveMatchData.push(item);
                        break;
                    }
                }
            }

            // for (var i = 0; i < saveMatchData.length; i++) {
            //     // saveMatchData[i]['__index'] = i;
            //     // saveMatchData[i]['sort'] = i + 1;
            // }

            if ($.nui.isEmpty(saveMatchData)) {
                fun.hideLoad();
                return showList(saveDataArr);
            };

            // 渲染搜索数据
            searchData = saveMatchData;
            $('.empty_text').remove();
            showList(saveMatchData, {
                drag: false
            });
        }
        fun.hideLoad();
    });

    // 删除提示pshop
    $('body').on('tap', '.delete-img', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var nowIdx = $('.delete-img').index($(this));
        var selColorNum = $('.colornumber').eq(nowIdx).text();
        var list = $('.ys-item').eq(nowIdx).data('list');
        searchIdx = findEditIdx(saveDataArr, list);
        fun.dialog({
            className: 'alert-height-auto',
            content: '你确定要删除【' + selColorNum + '】吗？',
            btn: ['删除', '取消'],
            yes: function () { // 确定删除颜色
                if (!!list['is_has']) {
                    return fun.toast(selColorNum + '已发生业务，不能删除。');
                }
                if (page_data && 'id' in page_data && $.nui.isTrue(list['id'])) {
                    var param = {
                        id: list['id'],
                        _index: list['_index'] || '',
                    }
                    delete_colour.push(param);
                }
                $('.ys-item').eq(nowIdx).remove();

                saveDataArr.splice(searchIdx - 1, 1);
                for (var i = 0; i < saveDataArr.length; i++) {
                    var item = saveDataArr[i];
                    if ('_index' in item) {
                        item['_index'] = i;
                    }
                    if ('__index' in item) {
                        item['__index'] = i;
                    }
                    item['sort'] = i + 1;
                }
                backData = JSON.parse(JSON.stringify(saveDataArr));
            }
        });
    })

    // 拍照
    $('#paizhao').on('tap', function () {
        callCamera('camera');
    });

    // 从相册中选择
    $('#selectPhoto').on('tap', function () {
        callCamera('album');
    });

    // 点击修改颜色
    $('body').on('tap', '.colornumber', function (e) {
        e.stopPropagation();
        e.preventDefault();
        if ($('.colornumber').hasClass('edit-disabled')) return;
        var disabled = $(this).data('disabled');
        if ($(this).data('disabled')) return;

        $(this).parents('li').addClass('edit-jgs');
        var nowIdx = $(this).parents('li').index();
        var list = $(this).parents('li').data('list');
        var name = $(this).parents('li').find('.in-img').data('name');
        var number = list.number;

        searchIdx = findEditIdx(saveDataArr, list);
        // 找到下标了

        switch (typeof list) {
            case 'object':
                value = list;
                break;
            case 'string':
                value = JSON.parse(list);
                break;
            // 没有default:
        }
        if ($(this).attr('disabled')) return;
        addColour({
            value: list,
            name: name,
            type: 'edit',
            callback: function (param) {
                var $nowLi = $('#gridDemo li').eq(nowIdx);
                var list = $nowLi.data('list');
                var editData = $.extend(true, saveDataArr[searchIdx - 1], param);
                var numberColor = $.nui.isTrue(editData['name']) ? editData['number'] + ' ' + editData['name'] : editData['number']; // 色号+颜色
                // 根据stop判断是否停用
                if (editData['is_stop'] && editData['is_stop'] > 0) {
                    $nowLi
                        .find('.colornumber')
                        .addClass('line-through')
                        .data('stop', true)
                } else {
                    $nowLi
                        .find('.colornumber')
                        .removeClass('line-through')
                        .data('stop', false)
                }

                $nowLi.find('.colornumber').text(numberColor);

                if ($.nui.isTrue(editData['imgs'])) { // 直接修改
                    var imgSrc = fun.getImgPath(editData['imgs'][0], true);
                    $nowLi.find('.box-div').html('<img class="in-img" src="' + (editData['imgPath'] || imgSrc) + '" data-src=true data-name="' + (editData['imgPath'] || imgSrc) + '">');
                } else {
                    $nowLi.find('.box-div').html('<img class="nullimg" src="../img/null.png" data-src="false"><span class="add font-ss">添加颜色图片</span>');
                }
                $nowLi.data('list', editData);
                saveDataArr[searchIdx - 1] = editData;
                backData = JSON.parse(JSON.stringify(saveDataArr));
            }
        });
    });

    // 手动添加
    $('.manually').on('tap', function (e) {
        if ($(this).attr('disabled')) return;
        $('#foot_search').blur();
        addColour({
            className: 'batch-height-16',
            showLog: true,
            type: "add",
            value: add_sx,   // 色系做记忆
            callback: function (param) {
                var html = [];
                var delColorShow = flag ? 'del-color-hide' : 'del-color-show'; // 根据右上角切换状态显示删除颜色图标
                var colorName = param['name'] ? param['number'] + ' ' + param['name'] : param['number']; // 色号+颜色
                var isStop = param['is_stop'] && param['is_stop'] >= 1 ? 'line-through' : '';
                html.push('<li class="ys-item drag" data-list=\'' + fun.formatString(JSON.stringify(param)) + '\' data-index="' + param['__index'] + '">');
                html.push('    <div class="box">');
                html.push('     <div class="delete-img ' + delColorShow + '">');
                html.push('         <div class="packs" name="pack">');
                html.push('             <i class="iconfont icon-fork fork"></i>');
                html.push('         </div>');
                html.push('     </div>');
                html.push('        <div class="box-div">');
                if ($.nui.isTrue(param['imgs'])) {
                    html.push('<img class="in-img" src="' + param['imgPath'] + '" data-src="true" data-name="' + param['imgPath'] + '">');
                } else {
                    html.push('<img class="nullimg" src="../img/null.png" data-src="false">');
                    html.push('<span class="add font-ss">添加颜色图片</span>');
                }
                html.push('        </div>');
                html.push('        <div class="name-div">');
                html.push('             <span class="font-ms colornumber ' + isStop + '">' + colorName + '</span>');
                html.push('        </div>');
                html.push('    </div>');
                html.push('</li>');

                param['__index'] = $('#gridDemo li').length;
                $('#gridDemo').append(html.join(''));
                $('.ys-list').eq($('#gridDemo li').length - 1).data('list', param);
                saveDataArr.push(param);
                backData = JSON.parse(JSON.stringify(saveDataArr));
            }
        });
    });

    // 删除图片
    $('body').on('tap', '.arrows-del', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var that = $(this);
        fun.dialog({
            content: '你确定要删除图片吗？',
            btn: ['删除', '取消'],
            yes: function (e) { // 确定删除颜色
                that.parents('.photo').find('img').attr('src', '../img/null.png');
                editDelete = true;
                $('.arrows-del').hide();
            }
        });
    })

    // 取消拍照
    $('#cancelPhoto').on('tap', function () {
        $('.box-div').removeClass('liImgNull');
        photoShowDisable();
        $('.openCamera').css('display', 'none');
    });

    // 批量添加
    $('.batch').on('tap', function (e) {
        console.log($(document).outerWidth());
        console.log($(window).outerWidth());
        if ($(this).attr('disabled')) return;
        $('#foot_search').blur();
        addColour({
            type: "batch",
            value: add_sx,   // 色系做记忆
            callback: function (param, batchObj) {
                var batchLx = batchObj['lx'];
                $(param).each(function (idx, item) {
                    var colorName = item['name'] ? item['number'] + ' ' + item['name'] : item['number']; // 色号+颜色
                    var delColorShow = flag ? 'del-color-hide' : 'del-color-show'; // 根据右上角切换状态显示删除颜色图标
                    var html = [];
                    switch (batchLx) {
                        case 'manual':
                            html.push('<li class="ys-item drag" data-list=\'' + fun.formatString(JSON.stringify(item)) + '\' data-index="' + item['__index'] + '">');
                            break;
                        case 'batch':
                            html.push('<li class="ys-item drag" data-list=\'' + fun.formatString(JSON.stringify(item)) + '\'>');
                            break;
                        // 没有default:
                    }
                    html.push('     <div class="box">');

                    html.push('     <div class="delete-img ' + delColorShow + '">');
                    html.push('         <div class="packs" name="pack">');
                    html.push('             <i class="iconfont icon-fork fork"></i>');
                    html.push('         </div>');
                    html.push('     </div>');
                    // html.push('         <div class="delete-img ' + delColorShow + '">');
                    // html.push('             <div class="packs" name="pack">');
                    // html.push('                 <i class="iconfont icon-fork fork"></i>');
                    // html.push('             </div>');
                    // html.push('         </div>');

                    html.push('         <div class="box-div">');
                    html.push('               <img class="nullimg" src="../img/null.png" data-src="false">');
                    html.push('               <span class="add font-ss">添加颜色图片</span>');
                    html.push('          </div>');
                    html.push('          <div class="name-div">');
                    html.push('               <span class="font-ms colornumber">' + colorName + '</span>');
                    html.push('          </div>');
                    html.push('     </div>');
                    html.push('</li>');
                    item['__index'] = $('#gridDemo li').length;
                    item['sort'] = $('#gridDemo li').length + 1;
                    $('#gridDemo').append(html.join(''));
                    $('#gridDemo .ys-item').eq($('#gridDemo li').length - 1).data('list', item);
                    saveDataArr.push(item); // 批量添加的添加进去
                })
                backData = JSON.parse(JSON.stringify(saveDataArr));
            }
        });
    });
}

// 阻止冒泡
function preventDefault(e) {
    e.preventDefault();
}