var html_name = page_arr['shop_dp_dt']; // 访客分析
var page_list = [];
var now_date = fun.formatDate(new Date(), 'YYYY-MM-DD');   //当前时间
var judge;   // 用于初始日历收缩
var mask;    // 用于当前日历是否需要收缩
var limit_count;  //限制字符的下标
var restrict = limit();
//初始化
page_init = function () {
    $('#header').header({
        back: true,
        title: '店铺动态'
    });

    getList();
    judge = true;
    mask = true;

    //分页
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('list', "");
        }
    });

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {

        var temp = ret.value.data;
        switch (ret.value.status) {
            case 'refresh':
                fun.showLoad();
                var jl_length = $('.account-list').length;

                for (var i = 0; i < jl_length; i++) {
                    var order_id = $('.account-list').eq(i).data('list')['order_id'];
                    if (temp['order_id'] === order_id) {
                        if (temp['submitted'] === true) {
                            $('.account-list').eq(i).remove();
                        } else if (temp['submitted'] === false && $.nui.isTrue(temp['product_info'])) {
                            $('.account-list').eq(i).find('#total_goods_count').text((temp['product_info']['total_goods_count'] || 0) + (temp['product_info']['dw_mc'] || ''));
                            $('.account-list').eq(i).find('#price').text('￥' + (temp['product_info']['zje'] || 0));
                        }
                        fun.hideLoad();
                        return;
                    }

                }
                break;
        }
    })
}

// calendar()

//获取数据
function getList(date) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getShopNewsList,
        data: {
            time: date || now_date,    //时间
            cur_page: 1,           //分页
            page_size: 100         //每页数量
        },
        success: function (res) {
            if (res['status'] == 0) {
                data = res['data'];
                befor_date = res['sum_info'];
                $('#visitor').text(res['sum_info']['visitor_count']);   //访客
                console.log(res['sum_info'])
                $('#order').text(res['sum_info']['order_count']);       //下单

                // 获取哪月哪天有数据
                var mark = {};
                $(befor_date['befor_date_data']).each(function (idx, item) {
                    mark[item] = '';
                })

                // 渲染日历
                $('#test1').empty();
                calendar(mark, date);

                //初始进来，日历收缩
                if (judge) {
                    $('tbody tr').hide();
                    $('.layui-laydate-header').hide();
                    $('.layui-this').parent().show();
                }

                //用于当前日历是否需要收缩
                if (mask) {
                    $('tbody tr').hide();
                    $('.layui-laydate-header').hide();
                    $('.layui-this').parent().show();
                }

                // 箭头方向(主要是应对重新加载日历)
                if ($('.layui-laydate-header').is(':hidden')) {
                    $('.laydate-footer-btns').find('i').removeClass('icon-shang');
                    $('.laydate-footer-btns').find('i').addClass('icon-xia');
                } else {
                    $('.laydate-footer-btns').find('i').removeClass('icon-xia');
                    $('.laydate-footer-btns').find('i').addClass('icon-shang');
                }

                //点击后日历的样式
                $('.laydate-footer-btns').click(function () {
                    if ($('.laydate-footer-btns').find('i').hasClass('icon-shang')) {
                        $('.laydate-footer-btns').find('i').removeClass('icon-shang');
                        $('.laydate-footer-btns').find('i').addClass('icon-xia');
                        $('tbody tr').hide();
                        $('.layui-laydate-header').hide();
                        $('.layui-this').parent().show();
                        mask = true;
                    } else {
                        $('.laydate-footer-btns').find('i').addClass('icon-shang');
                        $('.laydate-footer-btns').find('i').removeClass('icon-xia');
                        $('.layui-laydate-header').show();
                        $('tbody tr').show();
                        mask = false;
                    }
                })

                // 禁用
                if ($('.layui-this').hasClass('laydate-disabled')) {
                    $('.laydate-disabled').removeClass('layui-this');
                }

                //没有数据
                if ($.nui.isEmpty(data)) {
                    fun.createDataEmptyTips({ dom: '#list', btnShow: false });
                    fun.toast('这一天没有动态哦');
                    $('.empty-tips-wrap').css({
                        marginTop: $(window).height() * 0.5
                    })
                    return;
                    fun.createDataEmptyTips({ dom: '#list', btnShow: false });
                    $('.empty-tips-wrap').css({
                        marginTop: $(window).height() * 0.5
                    })
                    return;
                }
                page_list = fun.createApiDataIndex(data);
                showList(fun.PagingData(page_list, 20) || [])
                return befor_date = res['sum_info'];
            } else {
                fun.alert({ msg: '网络异常！' })
            }
        }
    });
}

// 渲染数据
function showList(data) {
    var html = [];
    console.log(data);
    $(data).each(function (idx, item) {

        html.push('<li class="account-list lower-border-line" data-type="' + (item['type'] || '') + '" data-list=\'' + JSON.stringify(item) + '\' >');
        html.push('    <div class="round">');
        //是否有头像
        if ($.nui.isTrue(item['avatar_url'])) {
            if (/http/.test(item['avatar_url'])) {
                html.push('        <img src="' + item['avatar_url'] + '" class="imgs">');
            } else {
                html.push('        <img src="' + IMG_PATH + 'shop/' + item['avatar_url'] + '" class="imgs">');
            }
        } else {
            html.push('        <img src="" class="imgs">');
        }
        html.push('    </div>');
        html.push('    <div class="left">');
        html.push('        <div class="weixin yby-color-black">');
        //是否绑定客户联系人
        if ($.nui.isTrue(item['kh_lxr'])) {
            html.push('            <span class="text-overflow kh-mc">' + (item['kh_mc'] || '') + '</span>');
            html.push('            <span class="linkman text-overflow kh-lxr">@' + (item['kh_lxr'] || '') + '</span>');
        } else {
            html.push('            <span class="text-overflow wx_name">' + (item['nickname'] || '') + '</span>');
        }
        html.push('         </div>');
        // 是否商城订单
        if (item['jl_type'] === 'order') {
            if (item['type'] === 'sk') {      // 色卡
                var sk_value = (item['total_goods_count'] || 0) + (item['dw'] || '份');
                html.push('        <div class="weixin yby-color-black sk">');
                html.push('            <span>购买&nbsp;:</span>');
                html.push('            <span>' + (item['goods_count'] || '') + '</span><span>个产品，</span>');
                html.push('            <span class="right-2">色卡</span><span>' + (sk_value || 0) + '</span>');
                html.push('        </div>');
            } else {     // 剪样、大货
                html.push('        <div class="weixin yby-color-black over">');
                html.push('            <span>购买:</span>');
                html.push('            <span>' + item['goods_count'] + '</span><span>个产品,</span>');
                html.push('            <span style="margin-right:0.2rem">数量</span><span class="limit rigth-2" id="total_goods_count">' + item['total_goods_count'] + '</span>');
                html.push('            <span class="yby-color-red limit_price" id="price">￥' + (item['dj_zje'] || 0) + '</span>');
                html.push('        </div>');
            }
            html.push('        <div class="weixin font-ss">');
            html.push('            <span>' + fun.formatDate(fun.Date(item['create_time'], true), 'HH:mm') + '</span>');
            html.push('            <span></span>');
            html.push('        </div>');
        } else {
            html.push('        <div class="weixin font-ss">');
            html.push('            <span>' + fun.formatDate(fun.Date(item['create_time'], true), 'HH:mm') + '</span>');
            html.push('            <span>访问您的店铺</span>');
            html.push('        </div>');
        }
        html.push('    </div>');
        html.push('</li>');
    })
    $('#list').append(html.join(''));
    restrict(data);
}

function limit() {
    limit_count = 0;
    return function (data) {
        // 限制字数
        $(data).each(function () {
            var strWidth = $('.kh-mc').eq(limit_count).width();
            var max_strWidth = $('.weixin').width() * 0.88;
            var total = $('.weixin').width() * 0.98;
            if (strWidth >= max_strWidth) {
                $('.kh-mc').eq(limit_count).css('max-width', max_strWidth);
                $('.kh-lxr').eq(limit_count).css('max-width', $('.weixin').width() * 0.1);
            } else {
                $('.kh-lxr').eq(limit_count).css('max-width', total - strWidth);
            }
            limit_count++;
        });
    }
}

// console.log($('#list').html());

//点击记录行进行跳转
$('body').on('click', '#list li', function (e) {
    e.stopPropagation();
    var type = $(this).data('type');
    var list = $(this).data('list');
    jump(type, list);
});

//根据类型跳转相应页面
function jump(type, list) {
    switch (type) {
        case 'jy':
        case 'dh':
        case 'sk':
            if ($.nui.isTrue(list.order_id)) {
                var search_data = {
                    member_id: '',
                    dh: '',
                    type: [],
                    delivery_type: [],
                    status: [],
                    search: '',
                    begin_time: '',
                    end_time: '',
                    kh_id: '',
                    order_id: list.order_id,
                };
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getShopOrderList,
                    data: search_data,
                    success: function (res) {
                        if (res['status'] === 0) {

                            var data_length = res['data'][0];
                            if (!$.nui.isEmpty(data_length) && !$.nui.isEmpty(data_length['order_info'])) {
                                if (data_length['order_info']['type'] != 'sk') {
                                    var jl = [];
                                    var tmp = {};
                                    var reservecp_key = '';

                                    for (var n = 0; n < data_length['order_info']['jl'].length; n++) {
                                        var jl_length = data_length['order_info']['jl'];
                                        var cp_info = jl_length[n]
                                        var cp_key = cp_info['goods_id'] + '_' + cp_info['cp_bh'];

                                        if (!tmp[cp_key]) {
                                            tmp[cp_key] = {
                                                count: 0,
                                                zsl: 0,
                                                zje: 0,
                                                cp_bh: cp_info['cp_bh'],
                                                cp_jjdw: cp_info['cp_jjdw'],
                                                cp_mc: cp_info['cp_mc'],
                                                cp_zt: cp_info['cp_zt'],
                                                color_info: []
                                            }
                                            tmp[cp_key]['color_info'].push(cp_info)
                                        }

                                        if (cp_key == reservecp_key) {
                                            tmp[cp_key]['color_info'].push(cp_info)
                                        }
                                        reservecp_key = cp_key

                                    }

                                    $.each(tmp, function (index, value) {
                                        jl.push(value)
                                    })

                                    data_length['order_info']['jl'] = jl
                                    for (var j = 0; j < data_length['order_info']['jl'].length; j++) {
                                        for (var k = 0; k < data_length['order_info']['jl'][j]['color_info'].length; k++) {
                                            var calculate = data_length['order_info']['jl'][j];
                                            var zje;
                                            var zsl;
                                            zje = calculate['color_info'][k]['zje'];
                                            zsl = calculate['color_info'][k]['zsl'];
                                            calculate['zje'] = parseFloat((calculate['zje'] + zje).toFixed(2));
                                            calculate['zsl'] = parseFloat((calculate['zsl'] + zsl).toFixed(2));;
                                            calculate['count']++;
                                        }


                                    }
                                }
                                var order_list = data_length;
                                fun.showPageFull({
                                    page_url: page_arr.shop_skddxq,
                                    pageParam: {
                                        return_page: html_name,
                                        order_id: order_list['id'],
                                        type: order_list['type'],
                                        order_list: order_list,
                                    }
                                })
                            } else {
                                fun.toast('订单不存在')
                            }


                        }

                    }
                })

            }
            break;
        case '':
            // fun.showLoad();
            // fun.showPageFull({
            //     page_url: page_arr.shop_chat,
            // })
            console.log('聊天页面')
            break;
        // 没有default
    };
}

// 日历
function calendar(mark, date) {
    laydate.render({
        elem: '#test1',
        show: true,
        showBottom: true,
        btns: ['clear'],
        position: 'static',
        mark: mark,
        // mark:{
        //     '2019-12-06':'',
        //     '2019-12-08':''
        // },
        max: now_date,
        value: date || now_date,
        'btnRender': function () {
            var edit = '<div class="laydate-footer-btns"><i class="iconfont icon-xia"></i></div>';
            return edit;
        },
        ready: function (date) {
        },
        done: function (value) {
            $('#list').html('');
            judge = false;
            limit_count = 0;
            // getList(value);
            if ($('.layui-this').hasClass('laydate-disabled')) {
                $('.laydate-disabled').removeClass('layui-this');
            }
        },
        change: function (value, date, endDate) {
            page_list = [];
            $('#list').html('');
            judge = false;
            limit_count = 0;
            getList(value)
            if ($('.layui-this').hasClass('laydate-disabled')) {
                $('.laydate-disabled').removeClass('layui-this');
            }
        }
    });
}