var html_name = page_arr.shop_fans;
var search_storage = {}, search_data = {};
var page_list = [], bind_lxr = [], bind_lxr_id = [];
var flag = false;
search_data = {
    page: 1,
    company_id: fun.getItem('company_info')['company_id'],
    associated: 'all',
    label: 'aishop',
    blacklist: fun.getItem(html_name + '_blacklist') ? 'yes' : 'no'
};

shopFans.updateHeaderInfo = function (fans_length) {
    $('#foot_search').attr('placeholder', '共' + (fans_length || 0) + '位粉丝');
};

page_init = function () {
    $('#header').header({
        back: true,
        title: '粉丝',
        filter: true,
        charts: true,  //修改成自动关联图标
        foot_input: {
            show: true,
            plader: ''
        }
    })

    $('#charts_btn').removeClass('icon-bintu').addClass('icon-zidongpipei2'); //更换图标
    $('#select').hide();  //默认隐藏标签页
    //头部适配
    if (!AuthVersionCheck.checkHide('xsdp') && !AuthVersionCheck.checkHide('aisc')) { //有线上店铺跟AI商城,出现标签页
        $('#select').show();
        $('#select').css({
            // marginTop: $('#header').outerHeight() + api.safeArea.top
            marginTop: $('#header').height() + api.safeArea.top - 1
        })
        $('#content').css({
            marginTop: $('#header').height() + $('#select').height() + api.safeArea.top
        })
    } else {
        $('#content').css({
            marginTop: $('#header').height() + api.safeArea.top
        })
    }

    //监听搜索页面
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        switch (ret['value'].status) {
            case 'search':
                fun.setItem(html_name + 'sideslip', true)
                var temp = ret['value']['data'];
                var not = temp['not'];
                var has = temp['has'];

                //关联赋值
                if (not) {
                    search_data['associated'] = 'no';
                } else if (has) {
                    search_data['associated'] = 'yes';
                } else {
                    search_data['associated'] = 'all';
                }

                //黑名单赋值
                if (temp['blacklist']) {
                    search_data['blacklist'] = 'yes';
                } else {
                    search_data['blacklist'] = 'no';
                }

                search_storage['not'] = temp['not'];
                search_storage['has'] = temp['has'];
                search_storage['blacklist'] = temp['blacklist'];
                fun.setItem(html_name + '_blacklist', temp['blacklist']);

            case 'bd_fans':
                $('.content').empty();
                flag = false;
                getList();
                break;
        }


    })
    $('#content').empty();
    flag = false;
    getList();
    bindEvent();

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            getList()
        }
    });

    fun.setItem(html_name + 'sideslip', true)

    //iphoneX适配
    $('#content').css('padding-bottom', api.safeArea.bottom + 'px');

}

//点击选项切换
$('body').on('tap', '.shop-box,.mall-box', fun.debounce(function () {
    if ($(this).find('span').hasClass('select-avtive')) return;
    $(this).find('span').addClass('select-avtive');
    $(this).siblings().find('span').removeClass('select-avtive');
    search_data.label = $(this).data('label');   //获取类型
    $('#content').empty();
    flag = false;
    getList();
}, 350))

//点击自动关联
$('body').on('tap', '#charts_btn', function () {
    document.addEventListener('touchmove', handler, { passive: false });
    fun.dialog({
        content: '自动关联未绑定客户的粉丝？',
        btn: ['确定', '取消'],
        yes: function () {
            $.ajax({
                type: 'POST',
                url: AJAX_URL.automatic + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
                headers: {
                    "X-Requested-With": "XMLHttpRequest",
                    "Accept": "application/json"
                },
                data: {
                    "company_id": fun.getItem('company_info')['company_id']
                },
                success: function (res) {
                    fun.toast('成功关联【' + res.count + '】位粉丝')
                    $('#content').empty();
                    flag = false;
                    getList(); //刷新当前页面数据
                },
                complete: function () {
                    document.removeEventListener('touchmove', handler, { passive: false });
                }
            })
        },
        no: function () {
            document.removeEventListener('touchmove', handler, { passive: false });
        }
    });
})

//绑定
$('body').on('tap', '.binding', function (e) {
    e.stopPropagation();
    if (!Auth.check('fs', 'edit')) return;
    var list = $(this).parents('.summary-content').data('list') || {};
    if (!!page_data['page_type']) {
        params = {
            page_type: page_data['page_type'],
            id: list['member_id'],
            select_val: list['kh_mc'] || list['nickname']
        }
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'select_list',
                'data': params
            }
        });
        api.closeWin();
    } else {
        // 页面 打开顺序
        var __route = [
            {
                url: page_arr.customer_search, page_data: {
                    'bdfans_id': list['id'],
                    'user_id': list['user']['id'],
                    // 'member_id': list['member_id'],
                    'djlx': 'fans',
                    'return_page': page_arr.shop_fans,
                    'page_type': 'kh',
                    'bind_lxr_id': bind_lxr_id || [],
                    'wldw_tmp': {
                        'getBillsPageDefInfo': AJAX_URL.getBillsPageDefInfo
                    },
                    'old_bdkh_id': list['kh_id'] || 0,
                }
            },
            {
                url: page_arr.contacter_search, page_data: {
                    return_page: page_arr.shop_fans,

                }
            }
        ];

        fun.showPageFull({
            page_url: __route[0]['url'],
            pageParam: $.extend(true, { __route: __route }, __route[0]['page_data'])
        });
    }
})

// 解绑
$('body').on('tap', '.unbundling', function (e) {
    var everyList = $(this).parents('.summary-content').data('list');
    var contactsId = everyList['user']['customers'][0]['contacts'][0]['yby_id'];   //联系人ID
    e.stopPropagation();
    document.addEventListener('touchmove', handler, { passive: false });
    fun.dialog({
        content: '你确定要将粉丝和客户进行解绑吗？',
        btn: ['确定', '取消'],
        yes: function () {
            $.ajax({
                type: 'PUT',
                url: AJAX_URL.automatic + '/' + Number(contactsId) + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
                headers: {
                    "X-Requested-With": "XMLHttpRequest",
                    "Accept": "application/json"
                },
                data: {
                    "company_id": fun.getItem('company_info')['company_id'],
                    "user_id": null
                },
                success: function (res) {
                    $('#content').empty();
                    flag = false;
                    getList(); //刷新当前页面数据
                },
                complete: function () {
                    document.removeEventListener('touchmove', handler, { passive: false });
                }
            })
        },
        no: function () {
            document.removeEventListener('touchmove', handler, { passive: false });
        }
    });
})

// 获取数据
function getList() {
    //根据版本修改筛选条件
    if (!AuthVersionCheck.checkHide('xsdp') && AuthVersionCheck.checkHide('aisc')) {
        search_data.label = 'mall';
    } else if (AuthVersionCheck.checkHide('xsdp') && !AuthVersionCheck.checkHide('aisc')) {
        search_data.label = 'aishop';
    }
    //传递页数
    var list_length = Number($('.summary-content').length) / 100;
    var page = Math.floor(list_length);
    search_data.page = page + 1;
    if (flag) return;
    $.ajax({
        type: 'GET',
        url: AJAX_URL.bindFans + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        data: search_data,
        success: function (res) {
            var fans_length = res['meta']['total'] || 0;
            // $('#header').header({
            //     back: true,
            //     title: '粉丝',
            //     filter: true,
            //     charts: true,  //修改成自动关联图标
            //     foot_input: {
            //         show: true,
            //         plader: '共' + (fans_length || 0) + '位粉丝'
            //     }
            // })

            shopFans.updateHeaderInfo(fans_length);

            if (Math.ceil(fans_length / 100) === search_data.page) {
                flag = true;
            }
            $('#charts_btn').removeClass('icon-bintu').addClass('icon-zidongpipei2'); //更换图标
            $('#foot_search').val((search_data['search'] || ''));
            if ($.nui.isTrue($('#foot_search').val().trim())) {
                $('#foot_search').focus()
            }

            if (res['data'].length === 0) {
                fun.createDataEmptyTips({ dom: '#content', btnShow: false });
                $('.empty-tips-wrap').css({
                    height: $('.empty-tips-wrap').height() - $('#header').height() - api.safeArea.top
                })
                return;
            }
            getbxrList();
            page_list = res['data'];
            showList(page_list)
        },
        error: function () {
            fun.toast('获取数据失败')
        }
    })
}

//获取已绑定联系人id
function getbxrList() {
    $.ajax({
        type: 'GET',
        url: AJAX_URL.automatic + '/bound?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        data: {
            company_id: fun.getItem('company_info')['company_id'],
            from: search_data.label
        },
        success: function (res) {
            bind_lxr_id = res || [];
        }
    })
}

// 渲染数据
function showList(data) {
    for (var i = 0; i < data.length; i++) {
        var html = [];
        var wechat_img = '';
        var item = data[i]['user'] || {};
        if ($.nui.isTrue(item['avatar_url'])) {
            // wechat_img = data[i]['user']['avatar_url'].indexOf('https://') > -1 ? data[i]['user']['avatar_url'] : IMG_PATH + 'shop/' + data[i]['user']['avatar_url'];
            wechat_img = item['avatar_url'];
        } else {
            wechat_img = '';
        }

        //由于名称存在表情用JSON.stringify转时会存在问题，故删除掉客户名称
        var list_data = JSON.parse(JSON.stringify(data[i]));
        delete list_data.nickname;
        delete list_data['user']['nickname'];
        if ($.nui.isTrue(item['customers'])) {
            delete list_data['user']['customers'][0]['name'];
            delete list_data['user']['customers'][0]['contacts'][0]['name'];
        }

        //定义unique_key的原因，是商城订单那边需要名称
        var unique_key = $.nui.getRandomNum();

        html.push('<div  class="lower-border-line fans-info summary-content clearfix clear" data-key="' + unique_key + '" data-list=\'' + JSON.stringify(list_data) + '\'>');
        html.push('     <img src="' + wechat_img + '" class="fans-img float-left" style="background-color:#f5f5f5;" alt="">');
        html.push('     <div class="float-right" style="width: calc(100% - 2.8rem)">');
        if ($.nui.isEmpty(item['customers'])) {
            html.push('        <div class="font-ms" style="margin-top:0.2rem"><span id= "' + unique_key + '" class="fans-mc">' + item['nickname'] + '</span></div>');
            html.push('        <div class="font-ss clear">');
            html.push('             <div class="font-ss color-money-red float-left">未关联</div>');
            // if(search_data.label === 'aishop'){  //AI商城显示图标
            //     html.push('             <div class="font-ss iconfont icon-gengduo1 float-right xq"></div>');
            // }
            if (Auth.check('fs', 'edit')) {
                html.push('             <div class="font-ss iconfont icon-bangding float-right binding"></div>');
            }
            html.push('        </div>');
        } else {
            html.push('        <div class="font-ms" style="margin-top:0.2rem"><span id= "' + unique_key + '" class="fans-mc">' + (item['customers'][0]['name'] || '') + '</span><span class="color-blue-light hidden"> @</span><span class="color-blue-light fans-mc hidden-width">' + (item['customers'][0]['contacts'][0]['name'] || '') + '</span></div>');
            html.push('        <div class="font-ss clear">');
            html.push('             <div class="font-ss color-gray fans-mc">' + item['nickname'] + '</div>');
            // if(search_data.label === 'aishop'){  //AI商城显示图标
            //     html.push('             <div class="font-ss iconfont icon-gengduo1 float-right xq"></div>');
            // }
            if (Auth.check('fs', 'edit')) {
                html.push('             <div class="font-ss iconfont icon-lianjie-duankai float-right unbundling"></div>');
            }
            html.push('        </div>');
        }
        html.push('    </div>');
        html.push('</div>');
        $('.content').append(html.join(''));
    }
}

function bindEvent() {
    //键盘搜索
    $('body').bind('search', '#foot_search', function () {
        search_data['search'] = $('#foot_search').val().trim();
        $('#content').empty();
        flag = false;
        getList();

    });

    //筛选
    $('body').on('tap', '#filter_btn', function (e) {
        e.stopPropagation();
        var sideslip = fun.getItem(html_name + 'sideslip')
        options = {
            "switch": [
                {
                    "text": "未关联",
                    "key": "not",
                    "value": search_storage['not'] || 0,
                    'radios': true,
                    'auxiliary': true
                },
                {
                    "text": "已关联",
                    "key": "has",
                    "value": search_storage['has'] || 0,
                    'radios': true,
                    'leading': true,
                },
                {
                    "text": "黑名单",
                    "key": "blacklist",
                    "value": fun.getItem(html_name + '_blacklist') || 0,
                    'radios': true,
                    'leading': false,
                }
            ]
        }
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    return_page: html_name,
                    search_data: options,
                    type: 'shop_fans'
                },
            });
        }
    });

    //绑定粉丝
    $('body').on('tap', '.summary-content', function (e) {
        e.stopPropagation();
        if (page_data.page_type != 'fans') return;
        if (!Auth.check('fs', 'edit')) return;
        var list_id = $(this).data('key');
        var list_name = $('#' + list_id + '').text();
        var list = $(this).data('list');
        //如果有绑定则传客户名称，否则则传微信昵称
        // if($.nui.isTrue(list['user']['customers'])){
        //     var paramsName = list['user']['customers'][0]['name'] || '';
        // }else{
        //     var paramsName = list['nickname'];
        // }
        var paramsName = list_name || '';
        if (!!page_data['page_type']) {
            params = {
                page_type: page_data['page_type'],
                id: list['user']['id'],
                select_val: paramsName
            }
            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    'status': 'select_list',
                    'data': params
                }
            });
            api.closeWin();
        }
    });

    // 粉丝详情
    $('body').on('tap', '.xq', function (e) {
        e.stopPropagation();
        fun.showPageFull({
            page_url: page_arr['shop_fans_xq'],
            pageParam: {
                return_page: html_name
            },
        })
    });
}

function handler() {
    event.preventDefault();
}