var html_name = page_arr.shop_kh_zdgjkh;
var search_data = {}, page_list = [];
var title = "",cur_page = 1;//cur_page访客递归加载参数

page_init = function () {
    switch (page_data['type']) {
        case 'zdgjkh':
            title = "重点跟进客户";
            $('#hint').text('实时跟踪订单动态，积极维护好客户关系能提高客户的复购率！')
            search_data = { type: "primary" } //primary
            break;
        case 'qzkh':
            title = "潜在客户";
            $('#hint').text('以下是最近领取了色卡\\剪样的客户，掌握客户动态让客户不再流失')
            search_data = { type: "potential" } //potential
            break;
        case 'fk':
            title = "访客";
            $('#hint').text('以下是浏览访问了店铺的客户，经常上新能获得更多的关注')
            search_data = { type: "visitor", "page_size": 30, "cur_page": 1 }//visitor 

            break;
        case 'hmd':
            title = "黑名单";
            $('#total > li').hide();
            $('#headline').parents('li').show().css({ 'float': 'none', 'margin': 'auto' });
            $('#hint').text('停用的客户，无法访问你的店铺');

            $('.total li:first').css('width', 'calc(100% - 2px').siblings().css('display', 'none')
            $('#headline').text('停用的客户')
            search_data = { type: "stop" }
            break;

    }
    $('#header').header({
        back: true,
        title: title,
        appendBackBtnEvt: isDataChange
    });

    init();

    page_data.keyback = isDataChange
}

function isDataChange() {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            status: 'refresh'
        }
    })
    api.closeWin()
}

function getList() {

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getStatusInfo,
        data: search_data,
        success: function (res) {
            if (res.status === 0) {

                if (page_data['type'] == 'hmd') {
                    $('#thirty').text(res['count'] || 0)
                } else {
                    var count_info = res['count_info'] || {};
                    $('#thirty').text(count_info['Nearly_thirty'] || 0)
                    $('#fifteen').text(count_info['Nearly_fifteen'] || 0)
                    $('#seven').text(count_info['Nearly_seven'] || 0)
                }
                if ($.nui.isEmpty(res['data']) && res['data'].length == 0) {
                    if( page_data['type'] == 'fk' && cur_page == 1){
                        return fun.createDataEmptyTips({ dom: '.content', btnShow: false ,style:'top:0rem;height:8.5rem;'});
                    }else if(page_data['type'] != 'fk'){
                        return fun.createDataEmptyTips({ dom: '.content', btnShow: false ,style:'top:0rem;height:8.5rem;'});
                    }
                }
                if (page_data['type'] == 'fk') {
                    page_list = res['data'];
                    showList(page_list)
                } else {
                    // page_list = fun.createApiDataIndex(res['data']);
                    page_list = res['data'];
                    showList(fun.PagingData(page_list) || [])
                }

            }
        }
    })
}

// var fk_time;//访客时间

function showList(data) {
    var html = [];
    for (var i = 0; i < data.length; i++) {
        var fan_kh_info = data[i];
        var datas = {}, times = {}, wechat_img = '';
        if (page_data['type'] == 'zdgjkh') {
            times = fan_kh_info['order_time'].substr(0, 16);
            datas = fan_kh_info['goods_count_info'][0];
        } else if (page_data['type'] == 'qzkh') {
            times = fan_kh_info['receive_sample_time'].substr(0, 16);
            datas = fan_kh_info['goods_count_info'][0];
        }

        if ($.nui.isTrue(fan_kh_info['avatar_url'])) {
            wechat_img = (fan_kh_info['avatar_url']).indexOf('https://') === 0 ? fan_kh_info['avatar_url'] : fun.getImgPath(fan_kh_info['avatar_url'], true, { url: SHOP_IMG, type: 'shop' });
        } else {
            wechat_img = '';
        }

        var hmd_bottom = page_data['type'] != 'hmd' ? '' : 'margin-bottom: 0 ; border-bottom: 1px solid #f5f5f5 ;';
        html.push('<li id="' + fan_kh_info['kh_id'] + '" style="padding:0.3rem 0; ' + hmd_bottom + '" class="fans-ms ' + (page_data['type'] == 'hmd' || $.nui.isTrue(fan_kh_info['kh_mc']) ? 'summary-content' : '') + '" data-index=\'' + JSON.stringify(fan_kh_info) + '\'>')
        html.push('	<div class="info">')
        html.push('		<div class="content-img"><img src="' + wechat_img + '" class="img-src"></div>')
        if (page_data['type'] != 'hmd') {
            html.push('	<div class="information">')
            html.push('<p class="font-ls" style="margin-top:0.3rem">')
            if ($.nui.isTrue(fan_kh_info['kh_mc'])) {
                html.push('<span class="text-overflow hidden-width2">' + (fan_kh_info['kh_mc']) + '</span>')
                if ($.nui.isTrue(fan_kh_info['kh_lxr'])) {
                    // html.push('<span class="color-blue-light hidden"></span>')
                    html.push('<span class="color-blue-light text-overflow" style="max-width:4.5rem">@' + (fan_kh_info['kh_lxr']) + '</span>')
                }
            } else {
                html.push('<span class="text-overflow hidden-width2" >' + (fan_kh_info['nickname']) + '</span>')
            }

            html.push('</p>')
            if (page_data['type'] == 'zdgjkh' || page_data['type'] == 'qzkh') {
                if (datas['type'] != 'sk') {
                    html.push('<p  style="font-size:0;">')
                    html.push('		<span class="hidden font-ms">购买 :</span>')
                    html.push('		<span class="text-overflow hidden-width3 font-ms je">' + (datas['goods_count']) + '</span>')
                    html.push('		<span class="hidden font-ms">个产品,</span><span style="margin-left: 0.3rem" class="font-ms hidden">数量 </span>')
                    html.push('		<span class="text-overflow hidden-width font-ms" style="margin-left: 0.1rem">' + parseFloat(datas['total_goods_count'].toFixed(2)) + '</span>')
                    html.push('		<span class="color-money-red je hidden font-ms" >￥</span>')
                    html.push('		<span class="color-money-red text-overflow hidden-width font-ms">' + parseFloat(datas['dj_zje'].toFixed(2)) + '</span>')
                } else {
                    html.push('<p class="font-ms">');
                    html.push('	<span class="hidden">购买：</span>');
                    html.push('	<span class="text-overflow">' + datas['goods_count'] + '</span>');
                    html.push('	<span class="hidden">个产品,</span><span style="margin-left: 0.3rem" class="font-ms hidden">色卡 </span>');
                    html.push('	<span class="text-overflow hidden-width" style="margin-left: 0.1rem">' + (datas['total_goods_count']) + '</span>');
                    html.push('	<span class="hidden">份</span>');
                }

                if ($.nui.isTrue(fan_kh_info['kh_mc'])) {
                    html.push('<span class="color-gray jt"><i class="iconfont icon-youfanhui"></i></span>')
                }
                html.push('</p>')
            } else {
                html.push('<p class="color-gray font-ss">')
                html.push('<span>' + fan_kh_info['create_time'].substr(0, 16) + ' 访问你的店铺</span>')
                if (!!fan_kh_info['kh_mc']) {
                    html.push('<span class="color-gray jt"><i class="iconfont icon-youfanhui"></i></span>')
                }
                html.push('</p>')
            }
            html.push('</div></div>')
            if (page_data['type'] == 'zdgjkh' || page_data['type'] == 'qzkh') {
                html.push('<div class="set-time">')
                html.push('<p class="color-gray font-ss">' + times + '</p>')
                html.push('</div>')
            }

        } else {
            html.push('<p class="font-ls blacklist">')
            if ($.nui.isTrue(fan_kh_info['kh_mc'])) {
                html.push('<span class="text-overflow hidden-width4">' + fan_kh_info['kh_mc'] + '</span>')
                if ($.nui.isTrue(fan_kh_info['kh_lxr'])) {
                    // html.push('<span class="color-blue-light hidden"></span>');
                    html.push('<span class="color-blue-light text-overflow" style="max-width:4.5rem">@' + fan_kh_info['kh_lxr'] + '</span>');
                }
            } else {
                html.push('<span class="text-overflow hidden-width4">' + fan_kh_info['nickname'] + '</span>')
            }
            html.push('<span class="color-gray jt"><i class="iconfont icon-youfanhui"></i></span>')
            html.push('</p>')
        }


        html.push('</li>')
    }
    $('.content').append(html.join(' '))
}

function bindEvent() {
    $('body').on('tap', '.summary-content', function (e) {
        var list = $(this).data('index');
        fun.showPageFull({
            page_url: page_arr.shop_zl_khyl,
            pageParam: {
                return_page: html_name,
                id: $.nui.isTrue(list['kh_id']) ? list['kh_id'] : list['fan_kh_info']['kh_id'],
                name: $.nui.isTrue(list['kh_mc']) ? list['kh_mc'] : list['fan_kh_info']['kh_mc'],
                member_id: list['member_id'],
                page_type: 'kg_gl',
            }
        })
    });
}

// 初始化
function init() {
    $('#total').css({
        marginTop: api.safeArea.top + $('#header').outerHeight() - parseFloat($('html').css('fontSize')) - 1
    })

    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret.value.data;
        switch (ret.value.status) {
            case 'CRM_refresh':
                // if ((page_data['type'] == 'zdgjkh' || page_data['type'] == 'qzkh') && temp.is_stop) {
                //     // if(page_data['type'] == 'zdgjkh'){
                //     //     var list_time = $('#' + String(temp.kh_id)).data('index')['order_time']
                //     // }else{
                //     //     var list_time = $('#' + String(temp.kh_id)).data('index')['receive_sample_time']
                //     // }
                //     $('#' + String(temp.kh_id)).remove();
                // } else if (page_data['type'] == 'hmd' && !temp.is_stop) {
                //     var hmd_count = Number($('#thirty').text().trim()) - 1;
                //     $('#thirty').text(hmd_count);
                //     $('#' + String(temp.kh_id)).remove();
                //     if (hmd_count === 0) {
                //         return fun.createDataEmptyTips({ dom: '.content', btnShow: false });
                //     }
                // }
               $('.content').empty()
                setTimeout(function(){
                    getList();
                },300)
                
                break;
        }
    })

    $('.content').empty()
    getList();
    bindEvent();

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            if (page_data['type'] == 'fk') {
                cur_page++
                search_data = { type: "visitor", "page_size": 30, "cur_page": cur_page }//visitor 
                getList()
            } else {
                showList(fun.PagingData(page_list) || []);
            }
        } else {
            fun.createBottomLine('content', '')
        }
    })
}
