var html_name = page_arr.shop_product_class_two,
    page_type;
/******头部显示******/
$("#header").header({
    back: true,
    title: '产品类别',
    //add: true
});

page_init = function () {
   
    var title = "";
    page_type = "cp";

    api.addEventListener({
        name: html_name,
    },function(ret,err){
        switch(ret['value']['status']){
            case 'refresh':
                $('.contents').empty();
                getData(page_type);
                break;
        }
    })

    getData(page_type);
    bindEvent();
}

//获取数据
function getData(page_type) {
    // setTimeout(function () {
    //     fun.showLoad();
    // },200);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSimpleRecordList,
        data: { type: page_type },
        success: function (res) {
            if (res.status === 0) {
                all = [];
                var info_list = res.data;
                // console.log(JSON.stringify(info_list))
                // console.log(JSON.stringify(getAllSon(ceilFormat(sortByKey(info_list)))))

                showData(getAllSon(ceilFormat(sortByKey(info_list))));
            } else {
                return fun.toast('该数据不存在！');
            }

            // setTimeout(function () {
            //     fun.hideLoad();
            // },400);
        }
    });
    // fun.load_DATA_LIST([page_type]);
}

function showData(data) {
    $('.contents').empty();
    var list = [];
    for (var x = 0; x < data.length; x++) {
        var steps;//判断层级
        var ptype = data[x]['parent_id'];
        if (!ptype) {//如果父级为空，则为第一级
            steps = 1;
            create(steps, data[x]);
        } else {
            var step = $("[stype='" + ptype + "']").parent().attr('step');
            var objs = $("[stype='" + ptype + "']");
            var parent_name = objs.attr('name');
            if (ptype == objs.attr('stype')) {
                step++;
                create(step, data[x],parent_name);
            }
        }
    }

    function create(st, datas,parent_name) {
        var son = datas['son'];
        var list = [];
        var tip_dis = (parseInt(st) + 0.7);
        var jurisdiction = !AuthVersionCheck.checkHide('cpdy');
        list.push('<ul class="swipe-delete swipe-delete' + st + '" step=' + st + '>');
        list.push('<li class="account-list lower-border-line" data-row=\'' + JSON.stringify(datas) + '\' son="' + son + '" type="' + datas.type + '" id="' + datas.id + '" name="' + datas.name + '" stype="' + datas.id + '" ptype="' + datas.parent_id + '" parent_name="'+parent_name+'" >');
        list.push('<div class="le" sort="' + datas.sort + '" simple="' + datas.simple + '" create_time="' + datas.create_time + '" update_time="' + datas.update_time + '">');
        list.push('<p class="le_top"><span class="color-number" style="margin-left:' + st + 'rem" number="' + datas.number + '">' + datas.name + '</span>');
        // if (Auth.check(page_type, 'edit')) {
        list.push('<i class="iconfont icon-tianjia"></i>');
        // }
        list.push('</p>');
        if(jurisdiction){
            list.push('<p class="le_btn font-ss">');
            if (st == 1) {
                if(datas.auth_type == 'all' || $.nui.isEmpty(datas.auth_type)){
                    list.push('<i class="iconfont icon-xxmm" style="left:' + st + 'rem"></i>');
                    list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">所有人可见</span>');
                }else if(datas.auth_type == 'zdkh'){
                    list.push('<i class="iconfont icon-lock" style="left:' + st + 'rem"></i>');
                    list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">指定客户可见</span>');
                }else if(datas.auth_type == 'zdlb'){
                    list.push('<i class="iconfont icon-lock" style="left:' + st + 'rem"></i>');
                    list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">指定类别可见</span>');
                }
            } else {
                if(datas.auth_type == 'all' || $.nui.isEmpty(datas.auth_type)){
                    list.push('<i class="iconfont icon-xxmm" style="left:' + st + 'rem"></i>');
                    list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">所有人可见</span>');
                }else if(datas.auth_type == 'zdkh'){
                    list.push('<i class="iconfont icon-lock" style="left:' + st + 'rem"></i>');
                    list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">指定客户可见</span>');
                }else if(datas.auth_type == 'zdlb'){
                    list.push('<i class="iconfont icon-lock" style="left:' + st + 'rem"></i>');
                    list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">指定类别可见</span>');
                }
            }
            list.push('</p>');
        }
        
        //   if(st == 1){
        //     list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">所有人可见</span>');
        //   }else{
        //     list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">指定客户可见</span>');
        //   }
       
        list.push('<div class="slids view dels1 view-btn" data-opt="views">查看产品</div>');
        list.push('<div class="slids edit dels1 edit-btn" data-opt="edit">编辑</div>');
        list.push('<div class="delete dels1 delete-btn" data-opt="delete">删除</div>');
        list.push('</div>');
        list.push('</li>');
        list.push('</ul>');
        switch (st) {
            case 1:
                $('.contents').append(list.join(''));
                list = [];
                break;
            default:
                $("[stype='" + ptype + "']").parent().append(list.join(''));
                list = [];
                break;
        }
        if(!jurisdiction){
            $('.account-list').css({'height':'3rem',"line-height": "3rem"});
        }
    }
    $('.dels1,.icon-tianjia').hide()
    $('#'+page_data['class_id']).parent().remove()
}



//对得到得数据进行排序
function sortByKey(array, key) {
    return array.sort(function (a, b) {
        var x = a[key];
        var y = b[key];
        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    });
}


function getAllSon(ars) {
    for (var j = 0; j < ars.length; j++) {
        all.push(ars[j]);
        if (!!ars[j]['son'][0]) {
            getAllSon(sortByKey(ars[j]['son'], 'sort'));
        }
    }
    return all;
}

//排序格式化
function ceilFormat(arr) {
    var p_arrs = [], c_arrs = [];
    for (var i = 0; i < arr.length; i++) {
        if (arr[i]['parent_id'] == 0) {
            p_arrs.push(arr[i]);
        } else {
            c_arrs.push(arr[i]);
        }
    }

    for (var i = 0; i < c_arrs.length; i++) {
        c_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (c_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                c_arrs[i]['son'].push(c_arrs[j]);
                // all.push(c_arrs[j]);
            }
        }
    }

    for (var i = 0; i < p_arrs.length; i++) {
        p_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (p_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                p_arrs[i]['son'].push(c_arrs[j]);
            }
        }
    }

    return sortByKey(p_arrs, 'sort');
    //sort按照升序
}

function filter(str) {
    var pattern = /[`~!@#$^&*()=|{}':;',\\\[\]\.<>\/?~！@#￥……&*（）——|{}【】'；：""'。，、？]/g;
    return str.replace(pattern, "");
}



//删除事件
function deleteClass(parent_list, obj) {
    fun.dialog({
        content: '你确定要删除【' + obj.attr('name') + '类别】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            var param = {
                'id': obj.attr('id'),
                "is_delete": 0,
                'subLevel': false,
                'save_type': 'delClass'
            };
            //存在子类别
            if (parent_list.children().filter('.swipe-delete').length > 0) {
                param['subLevel'] = true;
            }
            if (param['subLevel'] === true) {
                fun.toast('有下一类别，无法删除。');
            } else {
                param['is_delete'] = 1;
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.saveSimpleRecord,
                    data: param,
                    success: function (res) {
                        // console.log(JSON.stringify(res));
                        switch (res['status']) {
                            case 0:
                                $("[stype='" + param['id'] + "']").parent().remove();
                                fun.toast('删除成功。');
                                getData(page_type);
                                break;
                            case 103:
                                fun.toast('【' + res['name'] + '类别】已被调用过，无法删除。');
                                break;
                            case 104:
                                fun.toast('删除失败。');
                                break;
                        }
                    }
                });
            }
        }
    });
} 

function bindEvent(){
    //iphoneX
    $('.contents').css('padding-bottom', api.safeArea.bottom + 'px')

    //点击记录行
    $('body').on('tap', '.account-list', function (e) {
        var calss_id = $(this).attr('id');
        var calss_name = $(this).attr('name');
        if ($.nui.isTrue(page_data['type']) && page_data['type'] === 'yfl') {
        
            fun.dialog({
                content: '您确定将所选的产品移动到:【' + calss_name + '】吗？',
                btn: ['确定', '取消'],
                yes: function () {
                    fun.ajax({
                        showLoad: true,
                        hideLoad: true,
                        url: AJAX_URL.saveGoods,
                        data: {
                            "save_type": "move",
                            "class_id": calss_id,
                            "id": page_data['id']
                        },
                        success: function (res) {
                            console.log(JSON.stringify(res))
                            if (res['status'] == 0) {
                                api.sendEvent({
                                    name: page_arr.shop_cp_cpzl,
                                    extra: {
                                        'status': 'yfl',
                                    }
                                });
                                setTimeout(function () {
                                    api.closeWin();
                                }, 200);
                            } else {
                                fun.toast('移分类失败！');
                            }
                        }
                    })
                }
            })
        }else if(page_data['type']=="class_edit"){
            api.sendEvent({
                name: page_data['return_page'],
                extra:{
                    status: 'class',
                    data:{
                        class_id: calss_id,
                        class_name: calss_name 
                    }
                }
            })
            setTimeout(function () {
                api.closeWin();
            }, 200);
        
        }
    });

    //点击头部添加按钮
    $('body').on('tap', '#add_btn', function (e) {
        e.stopPropagation();
        fun.showPageFull({
            page_url: page_arr.shop_product_class_edit,//产品类别编辑页面
            pageParam: {
                return_page: html_name,
                opt_type: 'add'
            }
        });
    });

    //点击记录行添加按钮
    $('body').on('tap', ".icon-tianjia", function (e) {
        e.stopPropagation();
        var id = $(this).closest('li').attr('id');
        var name = $(this).closest('li').attr('name');
        var data_row = $(this).parents('.lower-border-line').data('row')
        console.log(id, name)
        fun.showPageFull({
            page_url: page_arr.shop_product_class_edit,//产品类别编辑页面
            pageParam: {
                "return_page": html_name,
                "class_id": id,
                "opt_type": 'add',
                "class_name": name,
                "auth_type": data_row['auth_type']
            }
        });
    });

    //按钮绑定事件（记录行左滑出现）
    $('body').on('tap', '.dels1', function (e) {
        var option_obj = $(this).data('opt');
        // var url = (option_obj == 'views') ? page_arr.shop_product_view : '';
        var obj = $(this).parent().parent();//获得对象
        var parent_list = $($(this).parents('.swipe-delete')[0]);
        switch (option_obj) {
            case 'views'://查看产品
                fun.showPageFull({
                    page_url: page_arr.shop_cp_cpzl,//产品资料
                    pageParam: {
                        type: 'cp_class',
                        return_page: html_name,
                        class_id: obj.attr('id'),
                        class_name: obj.attr('name')
                    }
                });
                break;
            case 'edit'://编辑
                fun.showPageFull({
                    page_url: page_arr.shop_product_class_edit,//产品类别编辑页面
                    pageParam: {
                        return_page: html_name,
                        opt_type: 'edit',
                        id: obj.attr('id'),
                        class_id: obj.data('row')['parent_id'],
                        class_name: obj.attr('name'),
                        auth_type: obj.data('row')['auth_type'],
                        parent_name:  obj.attr('parent_name') || '',
                    }
                });
                break;
            case 'delete'://删除
                deleteClass(parent_list, obj);
                break;
        }
    });    
}
