var html_name = page_arr.sx_search;
var search_data = {};
var page_list = [];

var last_lb_id = 0, last_dw_id = 0, last_dw_mc = '';

$('#header').header({
    back: true,
    add: false,
    filter: true,
    title: '纱线',
    foot_input: {
        show: true,
        // scan_icon:true,
        plader: '纱线搜索'
    },
});

page_init = function () {
    fun.keyboardEject('.sub');
    //ios头部穿透
    // fun.pierceThrough('.center-list'); 
    getList();
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'] || {},
            data = temp['data'];
        switch (temp['status']) {
            case "refresh":
                getList(search_data);
                break;
            case "search":
                search_data['class_id'] = data['cp_lb']['id'];
                search_data['class_name'] = data['cp_lb']['text'];
                search_data['sx_ppid'] = data['sx_pp']['id'];
                search_data['sx_pp'] = data['sx_pp']['text'];
                search_data['sx_xzid'] = data['sx_xz']['id'];
                search_data['sx_xz'] = data['sx_xz']['text'];

                search_data['keyword'] = $("#foot_search").val().trim();

                fun.setItem(html_name + 'sideslip', true);
                getList(search_data);
                break;
        }
    })


    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list, 5) || []);
        } else {
            // fun.createBottomLine('content', ".goods-item");
            fun.toast('产品数据已加载完');
        }
    });

    fun.orderListHeight({ dom: '.content' });
}

function getList(params) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getYarnList,
        data: $.extend({}, {
            "keyword": "",
            "keyword_key": ['name', 'number', 'simple'],
            "is_stop": 0,
            // "order":{"rq": true}
        }, params),
        success: function (res) {
            $('.content').empty();
            page_list = [];
            if (res['status'] == 0) {
                if ($.nui.isEmpty(res['data']) || res['data'].length == 0) {
                    page_list = [];
                    // return $('.content').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: '.content', btnShow: false});
                }
                page_list = res['data'];

                var tmp_rows = (res.data || []).slice(0).sort(function (a, b) {
                    return new Date(fun.compateIEDate(a['date'])).getTime() - new Date(fun.compateIEDate(b['date'])).getTime();
                });

                last_dw_id = tmp_rows[tmp_rows.length - 1]['unit_id'];
                last_dw_mc = tmp_rows[tmp_rows.length - 1]['unit_name'];
                last_lb_id = tmp_rows[tmp_rows.length - 1]['class_id'] || 0;

                showList(fun.PagingData(page_list));
            }
        }
    })
}

function showList(data) {
    var html = []
    $(data).each(function (i, obj) {
        var img_url = (obj['imgs']) ? fun.getImgPath(obj['imgs']) : "../img/logo.png";
        html.push('<li id="' + fun.is_value(obj['id']) + '" class="center-list lower-border-line">');
        html.push('<div class="le">');
        if (img_url === "../img/logo.png") {
            html.push('  <div class="picture mr-bj">');
            html.push('      <img src="' + img_url + '" class="product cp-img">');
        } else {
            html.push('  <div class="picture">');
            html.push('      <img src="' + img_url + '" class="product">');
        }
        // if (obj['imgs']) {
        //     html.push('      <img src="../img/mask.png" class="mask">');
        // }
        html.push('  </div>');
        html.push('  <div class="center-text">');
        html.push('      <div class="text">' + fun.is_value(obj['number']) + ' ' + fun.is_value(obj['name']) + '</div>');
        html.push('          <div>');
        html.push('              <span class="left">' + fun.is_value(obj['class_name'],' ') + '</span>');
        html.push('              <span class="right">' + fun.is_value(obj['brand'],' ') + '</span>');
        html.push('         </div>');
        html.push('          <div>');
        html.push('              <span class="left">' + fun.is_value(obj['date']) + '</span>');
        html.push('              <span class="right">' + fun.is_value(obj['nature']) + '</span>');
        html.push('         </div>');
        // html.push('          <span class="component">成分</span>');
        html.push('  </div>');
        // html.push('  <div class="slids dels1 shares share-btn">分享</div>');
        // html.push('  <div class="slids dels1 prices price-btn" id="offer">报价</div>');
        // html.push('  <div class="delete dels1 delete-btn" id="delete">删除</div>');
        html.push('</div>');
        html.push('</li>');
    })
    $('.content').append(html.join(''));
}

//点击键盘搜索
$("#foot_search").bind('search', function () {
    $('.content').empty();
    getList({
        "keyword": $(this).val().trim()
    });
});

$('.content').on('tap', '.center-list', function () {
    var params = {
        id: $(this).attr('id'),
        page_type: page_data['page_type'],
        select_val: $(this).find('.text').text()
    }
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'select_list',
            'data': params
        }
    });
    api.closeWin();
})

// //产品添加
// $('body').delay('tap', '#add_btn', function () {
//     var search_val = $('#foot_search').val().trim();
//     if (search_val == '') {
//         openPage(search_val)
//     } else {
//         fun.ajax({
//             showLoad: true,
//             hideLoad: true,
//             url: AJAX_URL.getInfoByKeyword,
//             data: {
//                 "type": 'cp',
//                 "keyword": search_val
//             },
//             success: function (res) {
//                 switch (res['status']) {
//                     case 0:
//                         openPage(search_val);
//                         break;
//                     case 104:
//                         layer.closeAll();
//                         fun.dialog({
//                             content: '【' + search_val + '】已存在，是否继续添加？',
//                             btn: ['确定', '取消'],
//                             shadeClose: false,
//                             className: 'data-change-skin',
//                             yes: function () {
//                                 openPage('');
//                             },
//                             no: function () {
//                                 search_data['keyword'] = search_val;
//                                 getList(search_data);
//                             }
//                         });
//                         break;
//                     default:
//                         fun.toast(res['msg']);
//                         break;
//                 }
//             }
//         })
//     }


//     function openPage(jvals) {
//         fun.showPageFull({
//             "page_url": page_arr.shop_product_compile,
//             "pageParam": {
//                 "return_page": html_name,
//                 "last_lb_id": last_lb_id,
//                 'last_dw_id': last_dw_id,
//                 'last_dw_mc': last_dw_mc,
//                 'cp_bh': jvals,
//             }
//         });
//     }
// })

//搜索页
fun.setItem(html_name + 'sideslip', true);
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "choose_merchants": [
            {
                key: "cp_lb",
                "text": "类别",
                "value": search_data['class_name'] || "",
                "id": search_data['class_id'] || 0,
            }, 
            {
                key: "sx_pp",
                "text": "品牌",
                "value": search_data['sx_pp'] || "",
                "id": search_data['sx_ppid'] || 0,
            }, 
            {
                key: "sx_xz",
                "text": "性质",
                "value": search_data['sx_xz'] || "",
                "id": search_data['sx_xzid'] || 0,
            }
        ]
    };
    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
})
