var html_name = page_arr.sxjg_lhd_xq;//页面名称

var dj_id, __DJ_DATA = {}, __JL_DATA = [];
var cp_list = [];
var USER_INFO = {}; //用户信息
var SYS_CONFIG = {};//系统设置
var DH_CONFIG = {};//单号设置
var zh_list = [];//账户
var ck_list = [];//仓库

var wldw_kh_list = [], wldw_wl_list = [];

var Bills = {};

Bills['config'] = {
    fy_zdy: 'sxjgzdyfy', // 布匹-销售自定义费用
    ck_zdy: 'sxckzdygl', // 仓库自定义字段
    kd_zdy: 'sxkdzdyzd', // 开单自定义字段
    dckms: 'dckms_sx',   // 多仓库模式
    adjs: 'adjs_sxjg',   // 按单结算
    dwgshsbl: 'dwgshsbl_sx', // 单位公式换算保留位数
    jesswr: 'jesswr_sxjg',   // 金额四舍五入
    bdjesswr: 'bdjesswr_sxjg', // 本单金额四舍五入
    dddjwlcddj: 'dddjwlcddj_sxjg', // 订单单价为0重读单价
    ssjms: 'qyssjms_sx', // 实售价模式
};

// 创建头部
$('#header').header({
    title: '来货单',
    much: true, //更多
    subtitle: '&nbsp;', //副标题
    order_info: {
        show: true,
        person: '&nbsp;',
        dateText: '&nbsp;'
    }
});
$('.hide').hide();
// apicloud初始化
page_init = function () {
    cp_list = fun.getItem('sx_list') || [];
    USER_INFO = fun.getItem('user_info') || {}; //用户信息
    SYS_CONFIG = fun.getItem('sys_config') || {};//系统设置
    DH_CONFIG = fun.getItem('dh_config') || {};//单号设置
    zh_list = fun.getItem('zh_list') || [];//账户
    ck_list = fun.getItem('ck_list') || [];//仓库

    wldw_kh_list = fun.getItem('wldw_kh_list') || [];
    wldw_wl_list = fun.getItem('wldw_wl_list') || [];

    //加载数据
    var load_list = ['ck', 'jjdw', 'wldw_kh', 'wldw_wl', 'sx', 'sys_config'];

    fun.load_DATA_LIST(load_list, function () {
        wldw_kh_list = fun.getItem('wldw_kh_list') || [];
        wldw_wl_list = fun.getItem('wldw_wl_list') || [];
        ck_list = fun.getItem('ck_list') || [];
        cp_list = fun.getItem('sx_list') || [];
    });

    dj_id = page_data['dj_id'] || 0;
    // list_data = page_data['list_data'] || {};

    getData();

    bindEvent();
};

// 获取数据
function getData() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSxJglhdInfo,
        data: { 'id': dj_id },
        success: function (res) {
            if (res['status'] == 0) {
                __DJ_DATA = res['data']['dj'];
                __JL_DATA = res['data']['jl'];
                showData(res['data']);
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    });
}

function showData(data) {
    var dj = data['dj'];
    var jl = data['jl'];
    $('.subtitle').text(dj['dh'] || ' ');
    $('#zdr').text(dj['zdr_mc'] || USER_INFO['name']);
    $('#kdsj').text(fun.formatDate(dj['kdsj']));

    if (dj['is_zf']) {
        fun.seal({ type: 'zf' });
    } else if (dj['is_sh']) {
        fun.seal({ type: 'sh' });
    } else {
        if ($('body').find('#state_icon').length) $('body').find('#state_icon').remove();
    }

    $('#zdr').data('zdr_id', dj['zdr_id'] || USER_INFO['id']);
    $('#wldw').val(dj['wldw_mc']).data('wldw_id', dj['wldw_id']);

    Bills['wldw'] = fun.getListInfoByKey(fun.getItem('wldw_kh_list') || [], dj['wldw_id']);

    // $('#wldw_qqje').val(dj['wldw_qqje']);
    // $('#wldw_ljqk').val(dj['wldw_ljqk']);
    // $('#fy').text(dj['fy_mc'] || '其他').data('fy_id', dj['fy_id']);
    // $('#fy_je').val(dj['fy_je'] || '');

    // $('#zh').val(dj['zh_mc']).data('zh_id', dj['zh_id']);
    // if ($.nui.isTrue(dj['zh_id'])) {
    //     var icon = fun.getValByKey(zh_list || [], dj['zh_id'], 'icon');
    //     icon && $('#zh_icon').attr('src', '../img/bank/' + icon).show();
    // } else {
    //     $('#zh_icon').attr('src', '').hide();
    // }
    $('#remark').val(dj['bz']);
    // $('#ddj').val(dj['ddj'] || '');
    $('#lxr').val(dj['lxr']);
    $('#lxr_dh').val(dj['lxr_dh']);
    $('#lxr_dz').val(dj['lxr_dz']);
    $('#hy').val(dj['hy_mc']).data('hy_id', dj['hy_id']);
    $('#yf').val(dj['hy_je'] || '');
    $('#hyd').val(dj['hy_dh']);

    Bills['hy'] = {
        hy_id: dj['hy_id'] || 0,
        hy_je: dj['hy_je'] || 0,
        hy_zh_id: dj['hy_zh_id'] || 0,
        hy_zh_je: dj['hy_zh_je'] || 0,
        hy_dh: dj['hy_dh'] || '',
        hy_lsh: dj['hy_lsh'] || '',
        hy_qqje: dj['hy_qqje'] || 0,
        hy_ljqk: dj['hy_ljqk'] || 0
    };

    showJlList(formatData(jl || []));

    getTotalInfo(jl);

    $('#zps').text(dj['zps'] || 0);
    $('#zjjsl').text(dj['zjjsl'] || 0);
    // $('#hszje').text(dj['hszje'] || 0);


}

//设置货运信息
function setHy(data) {
    Bills['hy'] = {
        hy_id: data['hy_id'] || 0,
        hy_je: data['hy_je'] || 0,
        hy_zh_id: data['hy_zh_id'] || 0,
        hy_zh_je: data['hy_zh_je'] || 0,
        hy_dh: data['hy_dh'] || '',
        hy_lsh: data['hy_lsh'] || '',
        hy_qqje: data['hy_qqje'] || 0,
        hy_ljqk: data['hy_ljqk'] || 0
    };

    wldw_wl_list = fun.getItem('wldw_wl_list') || [];

    $('#hy').val(fun.getValByKey(wldw_wl_list || [], Bills['hy']['hy_id'], 'merchant_name')).data('hy_id', Bills['hy']['hy_id']);
    $('#yf').val(Bills['hy']['hy_je']);
    $('#hyd').val(Bills['hy']['hy_dh']);
}

// 获取合计信息
function getTotalInfo(data, setText) {
    var _data = !$.nui.isEmpty(data) ? data : [];
    var tmp_total = {
        zps: 0,
        zsl: 0,
        zjjsl: 0,
        // bdje: 0,
        // hszje: 0,
        // hsje: 0,
        // zje: 0
    };

    for (var i = 0; i < _data.length; i++) {
        var val = _data[i];
        if ($.nui.isTrue(val['is_delete'])) continue;

        tmp_total['zps'] = $.nui.decimalAdd(tmp_total['zps'], parseFloat(val['ps'] || 0));
        tmp_total['zsl'] = $.nui.decimalAdd(tmp_total['zsl'], parseFloat(val['zsl'] || 0));
        tmp_total['zjjsl'] = $.nui.decimalAdd(tmp_total['zjjsl'], parseFloat(val['jjsl'] || 0));
        // tmp_total['bdje'] = $.nui.decimalAdd(tmp_total['bdje'], parseFloat(val['hszje'] || 0));
        // tmp_total['hszje'] = $.nui.decimalAdd(tmp_total['hszje'], parseFloat(val['hszje'] || 0));
        // tmp_total['hsje'] = $.nui.decimalAdd(tmp_total['hsje'], parseFloat(val['hsje'] || 0));
        // tmp_total['zje'] = $.nui.decimalAdd(tmp_total['zje'], parseFloat(val['zje'] || 0));
    }


    // tmp_total['bdje'] = __bdjeSswr(tmp_total['bdje']);
    // tmp_total['hszje'] = __bdjeSswr(tmp_total['hszje']);
    // tmp_total['zje'] = __bdjeSswr(tmp_total['zje']);

    if (!setText) {
        $('#zps').text(tmp_total['zps'] || 0);
        $('#zjjsl').text(tmp_total['zjjsl'] || 0);
        $('#jjdw').text($.nui.isFieldValEqual('jjdw_mc', _data)['val']);
        // $('#hszje').text(tmp_total['hszje'] || 0);
    }

    return tmp_total;
}

// 格式化数据
function formatData(data) {
    if ($.nui.isEmpty(data)) {
        return [];
    }
    var list = [],
        tmp = {};
    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        val['__del_index'] = i;
        if ($.nui.isEmpty(val['__key'])) {
            val['__key'] = $.nui.getRandomNum();
        }
        if ($.nui.isEmpty(val['__row_uuid'])) {
            val['__row_uuid'] = $.nui.getRandomNum();
        }
        if ($.nui.isTrue(val['is_delete'])) continue;
        if (!tmp[val['ck_id']]) {
            tmp[val['ck_id']] = {
                ck_id: val['ck_id'],
                ck_mc: val['ck_mc'],
                list: []
            }
        }
        tmp[val['ck_id']]['list'].push(val);
    }
    for (var i in tmp) {
        list.push(tmp[i]);
    }

    return list;
}

// 显示单据-记录列表
function showJlList(data) {
    var html = [];

    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        var delClass = '';
        html.push('<div class="storehouse ' + delClass + '">');
        html.push('     <a class="store-title ck off-tap" data-ck_id="' + (val['ck_id']) + '">' + (val['ck_mc']) + '</a>');
        html.push('     <ul>');
        for (var j = 0; j < val['list'].length; j++) {
            var item = val['list'][j];

            var jjslColor = (item['jjsl'] == item['zsl']) ? '#000' : '#17b3ec';
            var rtImg = fun.getJgLxImg(item);
            var sshk = item['sshk'] in item ? item['sshk'] : $.nui.decimalSub(item['hszje'] || 0, item['sszje'] || 0);

            html.push('         <li data-list_data=\'' + fun.formatString(JSON.stringify(item)) + '\' class="store-info fixed jl-item">');
            html.push('             <div class="le">');
            html.push(rtImg);
            (item['dd_dj_id']) && html.push('                 <div class="box"></div>');
            html.push('                 <p class="store-name">' + (item['cp_bh'] || '') + (item['cp_mc'] || '') + ' <i>' + (item['cp_ys_bh'] || '') + (item['cp_ys_mc'] || '') + '</i> </p>');
            html.push('                 <span>粒数<i class="info-date">' + (item['ps'] || 0) + '</i></span>');
            html.push('                 <span>数量<i class="info-date">' + (item['zsl'] || 0) + '<i>' + (item['dw_mc'] || '') + '</i></i></span>');
            html.push('                 <span>计价<i class="info-date text" style="color:' + jjslColor + '">' + (item['jjsl'] || 0) + '<i class="unit">' + (item['jjdw_mc'] || '') + '</i></i></span>');
            // html.push('                 <span><i class="info-date"></i></span>');

            if (fun.getSxKdSetting('pp')) {
                html.push('                 <span>品牌<i class="info-date">' + (item['sx_pp'] || '') + '</i></span>');
            }
            if (fun.getSxKdSetting('dq')) {
                html.push('                 <span>地区<i class="info-date">' + (item['sx_dq'] || '') + '</i></span>');
            }
            if (fun.getSxKdSetting('gg')) {
                html.push('                 <span>规格<i class="info-date">' + (item['gg'] || '') + '</i></span>');
            }
            if (fun.getSxKdSetting('xz')) {
                html.push('                 <span>性质<i class="info-date">' + (item['sx_xz'] || ' ') + '</i></span>');
            }

            html.push('                 <div class="delete dels1 delete-btn" data-del_index="' + (item['__del_index']) + '"><b class="swipe-span">删除</b></div>');
            html.push('             </div>');
            html.push('         </li>');
        }
        html.push('     </ul>');
        html.push('</div>');
    }
    $('#jl').html(html.join(''));
}

// 设置开单偏好设置
function setKdph(data, callback) {
    var tmp_list = [];
    var _data = data || [];

    for (var i = 0; i < _data.length; i++) {
        tmp_list.push(_data[i]['id']);
    }

    // if (SYS_CONFIG['kdphsz'] == tmp_list.join(',')) {
    //     return;
    // }

    var save_data = {
        "type": "sys",
        "list": [
            { "key": "sxkdphsz", "value": tmp_list.join(',') }
        ]
    };

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveSysConfig,
        data: save_data,
        success: function (res) {
            if (res['status'] == 0) {
                is_update_phsz = true;
                fun.load_DATA_LIST(['sys_config'], function () {
                    if (typeof callback === 'function') callback();
                }, { showLoad: false });
            } else {
                fun.toast('保存失败');
            }
        }
    });
}

// 绑定事件
function bindEvent() {
    // 显示、隐藏切换
    
    $('body').on('click', '.last', function () {
        if ($(this).find('.iconfont').hasClass('icon-xia')) {
            $(this).find('.iconfont').addClass('icon-shang').removeClass('icon-xia');
        } else {
            $(this).find('.iconfont').addClass('icon-xia').removeClass('icon-shang');
        }
        $('.hide').toggle();
    });

    //更多
    $('body').on('tap', '#much_btn', function (e) {
        e.stopPropagation();
        if ($('.collapse-wrap').hasClass('open')) {
            $('.collapse-wrap').removeClass('open');
        } else {
            $('.collapse-wrap').addClass('open');
        }
    });

    //偏好设置
    $('body').on('touchend', '#phsz', function (e) {
        e.preventDefault();
        e.stopPropagation();

        var list_data = [
            { name: '品牌', id: 'pp' },
            { name: '地区', id: 'dq' },
            { name: '规格', id: 'gg' },
            { name: '性质', id: 'xz' }
        ];

        for (var i = 0; i < list_data.length; i++) {
            if (fun.getSxKdSetting(list_data[i]['id'])) {
                list_data[i]['is_choose'] = 1;
            }
        }

        fun.showBookList({
            width: '280px',
            shadeClose: false,
            checkbox: true,
            list: list_data,
            choose: function (data) {
                setKdph(data, function () {
                    showJlList(formatData(__JL_DATA));
                    layer.closeAll();
                });
            }
        });
        $('.collapse-wrap').removeClass('open');
        return false;
    });

    //点击其他区域，关闭更多
    $('body').on('tap', function (e) {
        $('.collapse-wrap').removeClass('open');
    });
}

function __checkData() {
    if (!fun.dataIsRead(['ck'])) {
        setTimeout(__checkData, 250);
    } else {
        setTimeout(function () {
            if (typeof page_init === "function") page_init();
        }, 100);
    }
}