var html_name = page_arr.sxkc_pyd;
//data: {"begin_time":"2019-03-04","end_time":"2019-04-03","ck_id":0,"cp_id":0,"cp_ys_id":0,"cp_lb_id":0,"group":"","xszf":false}
var to_month = fun.getLatelyTime(1,false);//获取时间
//要查询的数据
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    "ck_id": 0,
    "cp_id": 0,
    "cp_ys_id": 0,
    "cp_lb_id": 0,
    "group": "",
    "xszf": false,
};
//搜索页数据
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};
var page_list = [];

//头部样式
$('#header').header({
    back: true,
    filter: true,
    title: '盘盈单'
});
var USER_INFO = {};

var hz_group_columns = {
    'dh': 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc,ck_id,ck_mc',
    'ck': 'ck_id,ck_mc',
    'cp': 'cp_bh,cp_mc',
    'cp_ys': 'cp_ys_bh,cp_ys_mc',
    "hsdj": 'hsdj',
    "sx_pp": 'sx_pp',
    "sx_dq": 'sx_dq',
    // "fkkz": 'fk,kz',
    "gg": 'gg'
};

//页面加载完后加载
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var hnh = html_name + '_';
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));
    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(html_name + '_' + 'hz') || '')
    // initPage();

    search_storage = $.extend(true, {
        "hldj": fun.getItem(html_name + '_hldj', 0),
        "xsmx": fun.getItem(html_name + '_xsmx', 0),
        "hz": {
            "choose": {
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "dh": fun.getItem(hnh + 'dh', 1),
                "ck": fun.getItem(hnh + 'ck', 1),
                "cp": fun.getItem(hnh + 'cp', 1),
                "cp_ys": fun.getItem(hnh + 'cp_ys', 1),
                "sx_pp": fun.getItem(hnh + 'sx_pp', 0),
                "sx_dq": fun.getItem(hnh + 'sx_dq', 0),
                // "fkkz": fun.getItem(hnh + 'fkkz', 0),
                "gg": fun.getItem(hnh + 'gg', 0)
            },
            "text": fun.getItem(hnh + 'text', ""),
        }
    }, search_storage);

    fun.initGroupOfSearchData(search_data, search_storage.hz.choose, hz_group_columns, ',dw_id,dw_mc');
    getList(search_data);

    //接收搜索页的数据1
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret.value;
        switch (temp['status']) {
            case 'search':
                var param = ret.value.data;

                search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
                search_data['begin_time'] = param.begin_date;                   //开始时间
                search_data['end_time'] = param.end_date;                       //结束时间
                search_data['cp_id'] = param.cp['id'] || '';                    //纱线
                search_data['cp_lb_id'] = param.sx_lb['id'] || 0;             //纱线类别
                search_data['ck_id'] = param.ck['id'] || '';                    //仓库
                search_data['md_id'] = param.md['id'] || '';                    //门店
                search_data['xszf'] = param['xszf'];                            //作废单据
                search_data['hldj'] = param['hldj'];                            //合拢单据
                search_data['xsmx'] = param['xsmx'];                            //显示明细数据

                //搜索菜单需要缓存的数据
                search_storage['keyword'] = search_data['keyword'];
                search_storage['begin_date'] = search_data['begin_time'];
                search_storage['end_date'] = search_data['end_time'];
                search_storage['cp'] = param.cp;
                search_storage['cp_lb'] = param.sx_lb;
                search_storage['ck'] = param.ck;
                search_storage['md'] = param.md;
                search_storage['xszf'] = search_data['xszf'];
                search_storage['hldj'] = search_data['hldj'];
                search_storage['xsmx'] = search_data['xsmx'];

                //设置时间控件时间
                date_bar.setDate(search_storage);
                fun.setItem(html_name + '_xszf', search_storage['xszf']);
                fun.setItem(html_name + '_hldj', search_storage['hldj']);
                fun.setItem(html_name + '_xsmx', search_storage['xsmx']);

                //汇总功能
                search_data['group'] = param.hz['group'] || '';
                search_storage['hz'] = param.hz;
                var hc = param['hz']['choose'];

                fun.setItem(hnh + 'md_mc', hc['md_mc']);
                fun.setItem(hnh + 'dh', hc['dh']);
                fun.setItem(hnh + 'ck', hc['ck']);
                fun.setItem(hnh + 'cp', hc['cp']);
                fun.setItem(hnh + 'cp_ys', hc['cp_ys']);
                // fun.setItem(hnh + 'fkkz', hc['fkkz']);
                fun.setItem(hnh + 'sx_pp', hc['sx_pp']);
                fun.setItem(hnh + 'sx_dq', hc['sx_dq']);
                fun.setItem(hnh + 'gg', hc['gg']);
                fun.setItem(hnh + 'text', param.hz['text']);
                fun.setGroupCondition(search_data, 'dw_id,dw_mc');

                // if (!!search_data['group']) {
                //     var group_data = search_data['group'];
                //     group_data += ',dw_id,dw_mc';
                //     search_data['group'] = group_data;
                // }
                fun.setItem(html_name + '_' + 'hz', search_data['group']);

                fun.setItem(html_name + 'sideslip', true);

                getList(search_data);
                break;
            case 'refresh':
                getList(search_data);
                break;
        }
    });
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
}

//获取最近6个月
var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getList(search_data);
        }
    });

//获取数据
function getList(data) {
    page_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSxpydtj,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#zls').text(0);
                    $('#zsl').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                ztj_data = res['info'];
                $('#order_list').empty();
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    hzDhFun: function (obj) {
                        return obj['dh'] + '_' + obj['ck_mc'];
                    },
                    hzCpOrYsFun: function (obj) {
                        return obj['ck_mc'] + '_' + obj['md_mc'] + '_' + obj['zdr_mc'] + '_' + obj["kdsj"] + '_' + obj["dh"] + '_' + obj['md_id'] + '_' + obj["cp_bh"] + '_' + obj["cp_mc"] + '_' + obj["cp_ys_bh"] + '_' + obj["cp_ys_mc"];
                    },
                    hzOthersFun: function (obj) {
                        return obj['ck_mc'] + '_' + obj['md_mc'] + '_' + obj['zdr_mc'] + '_' + obj["kdsj"] + '_' + obj["dh"] + '_' + obj['md_id'];
                    },
                    createKeysValueFun: function(obj) {
                        return {
                            "ck_mc": obj['ck_mc'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "md_id": obj['md_id'],
                            "list": [],
                            "is_sh": obj['is_sh'],
                            "dj_zsl": obj["dj_zsl"],
                            "dj_ps": obj["dj_ps"],
                            "zdw_mc": obj["zdw_mc"]
                        }
                    }
                });
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}

//动态加载数据
function showList(data) {
    $('#zls').text(ztj_data['zps'] || 0);
    $('#zsl').text(ztj_data['zsl'] || 0);
    var i;
    var hldj = fun.getItem(html_name + '_hldj', 0);
    var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;

    $('#order_list').OrderList({
        data: data,
        schedule: false,
        // showLog: false,
        isExpand: !hldj,
        isNoExpand: xsmx,
        render: {
            titlebar: function (res) {
                i = 1;
                var hCK = !!fun.is_value(res['ck_mc']),
                    hMD = !!fun.is_value(res['md_mc']) || fun.is_value(res['zdr_mc']);
                if (!!res['md_id'] || res['md_id'] == 0) hMD = true;
                var ckmd = hCK || hMD;
                var Html = [];
                Html.push(ckmd ? '<div class="title-bar-row title-bottom">' : '');
                Html.push(hCK ? '    <div><span class="weight font-ls">' + fun.is_value(res['ck_mc']) + '</span></div>' : '');
                var align;
                var sh = '';
                if (!hCK) {
                    align = 'align-left';
                } else {
                    align = 'align-right';
                }

                if (!search_data.group || (/dh/i.test(search_data.group) && res['is_sh'] !== undefined)) {
                    sh = fun.createIsShLabelHtml(res['is_sh']);
                }

                Html.push(hMD ? '    <div class="' + align + ' font-ss color-gray">' + fun.formatTime(res['kdsj']) + '&nbsp;' + fun.is_value(res['zdr_mc']) + '&nbsp;' + sh + '</div>' : '');
                Html.push(ckmd ? '</div>' : '');

                var zdw_mc = fun.getHzUnitName(search_data['group'], res, 'zdw_mc');

                Html.push('<div class="title-bar-row title-bottom">');
                Html.push('     <div><span class="color-gray">共</span>&nbsp;&nbsp;<span>' + fun.is_value(res.dj_ps, 0) + '粒</span>&nbsp;<span>' + fun.is_value(res.dj_zsl, 0) + fun.is_value(zdw_mc) + '</span></div>');
                Html.push('</div>');
                return Html.join('');
            },
            subtitle: function (res) {
                console.log('---');
                console.log(res);
                console.log('---');
                
                var hCP = !!fun.is_value(res["cp_bh"]) || fun.is_value(res["cp_mc"]),
                    hYS = !!fun.is_value(res["cp_ys_bh"]) || fun.is_value(res["cp_ys_mc"]),
                    yshz = hCP || hYS;
                var htmlArr = [];
                htmlArr.push(yshz ? '  <div class="row" data-list=\'' + fun.formatString(JSON.stringify(res)) + '\'>' : '');
                htmlArr.push(yshz ? '      <div>' + fun.is_value(res["cp_mc"]) + ' ' + fun.is_value(res["cp_ys_bh"]) + ' ' + fun.is_value(res["cp_ys_mc"]) + '</div>' : '');
                htmlArr.push(yshz ? '  </div>' : '');


                htmlArr.push(fun.createPpDqGgHtml(search_data, res, true));
                return htmlArr.join('');
            },
            subdata: function (res) {
                var dwmc = fun.getUnitName(search_data['group'], res, 'dw_mc');

                var htmlArr = [];
                htmlArr.push('<div class="row bg-gray" data-list=\'' + fun.formatString(JSON.stringify(res)) + '\'>');
                htmlArr.push('     <div><span>' + (fun.is_value(res['ps']) + '粒') + '</span><span>' + (fun.is_value(res['zsl']) + dwmc) + '</span></div>');
                htmlArr.push('</div>');
                return htmlArr.join('');
            }
        },
    });
}
//存储一个值用于判定是否打开搜索页//值为false即为打开
fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [{
            key: "cp",
            "text": "纱线",
            "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
            "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
            is_yarn: 1
        }, {
            key: "cp_lb",
            "text": "纱线类别",
            "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
            "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
            is_yarn: 1
        }, {
            key: "ck",
            "text": "仓库",
            "value": (search_storage['ck'] && search_storage['ck']['text']) || "",
            "id": (search_storage['ck'] && search_storage['ck']['id']) || 0,
            is_yarn: 1
        }, {
            key: "md",
            "text": "门店",
            "value": (search_storage['md'] && search_storage['md']['text']) || "",
            "id": (search_storage['md'] && search_storage['md']['id']) || 0,
        },
        {
            key: "hz",
            "text": "汇总",
            //加工商、单号、门店、纱线、颜色
            group: [
                // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                { key: 'dh', name: '单号', columns: hz_group_columns.dh, choose: getHz('dh') },
                { key: 'ck', name: '仓库', columns: hz_group_columns.ck, choose: getHz('ck') },
                { key: 'cp', name: '纱线', columns: hz_group_columns.cp, choose: getHz('cp') },
                { key: 'cp_ys', name: '颜色', columns: hz_group_columns.cp_ys, choose: getHz('cp_ys') },
                // { key: "fkkz", name: '幅宽克重', columns: hz_group_columns.fkkz, choose: getHz('fkkz') },
                { key: "sx_pp", name: '品牌', columns: hz_group_columns.sx_pp, choose: getHz('sx_pp') },
                { key: "sx_dq", name: '地区', columns: hz_group_columns.sx_dq, choose: getHz('sx_dq') },
                { key: "gg", name: '规格', columns: hz_group_columns.gg, choose: getHz('gg') },
            ],
            "value": getTwo('hz', 'text'),
        }
        ],
        // "switch": [{
        //     "text": "显示作废单据",
        //     "max_width": true,
        //     "key": "xszf",
        //     "value": (!!fun.getItem(html_name + '_xszf') ? fun.getItem(html_name + '_xszf') : 0)
        // },]
        "switch": [{
            "text": "显示明细数据",
            "max_width": true,
            "key": "xsmx",
            "value": search_storage['xsmx']
        },{
            "text": "合拢单据",
            "max_width": true,
            "key": "hldj",
            "value": search_storage['hldj']
        },]
    }
    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

// 新增盘盈单
$('body').on('tap', '#add_btn', function () {
    return
    if (!fun.checkKz()) return;
    // 跳转顺序: 仓库搜索 -> 选纱线 -> 选颜色 -> 开单编辑 -> 盘盈单编辑页面
    const __route = [ // 定义页面顺序
        {
            url: page_arr.select_list,
            page_data: {
                djlx: 'kc_bppyd',
                page_type: 'hdb_ck',
                __index: 0,
            },
        },
        {
            url: page_arr.choice_product,
            page_data: {
                djlx: 'kc_bppyd',
                NOT_OPEN_AGAIN: false
            },
        },
        {
            url: page_arr.select_list,
            page_data: {
                djlx: 'kc_bppyd',
                page_type: 'cp_ys',
                edit_row: false
            }
        },
        {
            url: NEW_BILLS?page_arr.bills_zsmx:page_arr.single_editor,
            page_data: {
                djlx: 'kc_bppyd',
                return_page: page_arr.choice_product,
                hsdj_fixed: 6
            }
        },
        {
            url: page_arr.kc_pyd_edit,
            page_data: {
                return_page: page_arr.sxkc_pyd,
            },
        }
    ];
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: $.extend(true, { __route: __route }, __route[0]['page_data'])
    });
});

function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

// 详情跳转
fun.tjContentTap(function (data_list) {
    return
    if (!fun.checkKz()) return;

    if (data_list['dj_id']) {
        fun.showPageFull({
            page_url: page_arr.kc_pyd_edit,
            pageParam: {
                return_page: html_name,
                id: data_list['dj_id'],
                dh: data_list['dh'],
                kdsj: data_list['kdsj'],
                zdr: data_list['zdr_mc']
            }
        });
    }
});

$('body').on('click','.row-list',function(){
    return
    if(fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var data_list = $(this).children('.summary').children('.summary-content').data('list');
    if (data_list['dj_id']) {
        fun.showPageFull({
            page_url: page_arr.kc_pyd_edit,
            pageParam: {
                return_page: html_name,
                id: data_list['dj_id'],
                dh: data_list['dh'],
                kdsj: data_list['kdsj'],
                zdr: data_list['zdr_mc']
            }
        });
    }
})