var html_name = page_arr.welcome_set; // 页面名称
var value = ''; //输入框的值
//头部
$('#header').header({
    back: true,
    title: '欢迎语',
    appendBackBtnEvt: isDataChange
});

// 初始化
page_init = function () {
    page_data['keyback'] = isDataChange;//监听安卓返回键
    $('.content').css({
        marginTop: api.safeArea.top + $('#header').outerHeight() - fun.computedHtmlFontSize(),
        height: ($(window).height() - $('#header').outerHeight()) * 0.5
    })
    getList();

    // 解绑禁止输入特殊符号事件
    $('body').off('keyup input', 'input[type="text"],input[type="search"],textarea');
    $('body').off('blur', 'input[type="text"],input[type="search"],textarea');
}

// 避免聚焦时错位
$('.textarea').on('focus', function () {
    $('.content').css('position', 'relative');
})

//获取数据
function getList() {
    $.ajax({
        type: "GET",
        header: {
            "X-Requested-With": XMLHttpRequest
        },
        url: AJAX_URL.welcomeTerms + '/'+ fun.getItem('company_info')['company_id'] +'?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        success: function (res) {
            if ($.nui.isEmpty(res['body'])) {
                $('.textarea').val('');
            } else {
                $('.textarea').val(uncodeUtf16(res['body'] || ''));
            }
        }
    })
}

//返回
function isDataChange() {
    value = $('.textarea').val();
    saveList(value)
    setTimeout(function () {
        api.closeWin();
    }, 200)
}

// 保存数据
function saveList(value) {
    value = utf16toEntities(value)
    $.ajax({
        type: "PUT",
        header: {
            "X-Requested-With": XMLHttpRequest
        },
        url: AJAX_URL.welcomeTerms + '/'+ fun.getItem('company_info')['company_id'] +'?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        data:{
            "body": value
        }
    })
}

// 表情转换成字符
function utf16toEntities(str) {
    var patt = /[\ud800-\udbff][\udc00-\udfff]/g; // 检测utf16字符正则 
    str = str.replace(patt, function (char) {
        var H, L, code;
        if (char.length === 2) {
            H = char.charCodeAt(0); // 取出高位 
            L = char.charCodeAt(1); // 取出低位 
            code = (H - 0xD800) * 0x400 + 0x10000 + L - 0xDC00; // 转换算法 
            return "&#" + code + ";";
        } else {
            return char;
        }
    });
    return str;
}

//字符转换成表情
function uncodeUtf16(str) {
    var reg = /\&#.*?;/g;
    var result = str.replace(reg, function (char) {
        var H, L, code;
        if (char.length == 9) {
            code = parseInt(char.match(/[0-9]+/g));
            H = Math.floor((code - 0x10000) / 0x400) + 0xD800;
            L = (code - 0x10000) % 0x400 + 0xDC00;
            return unescape("%u" + H.toString(16) + "%u" + L.toString(16));
        } else {
            return char;
        }
    });
    return result;
}



