var html_name = page_arr.xs_bfjl;
// 头部
$('#header').header({
    back: true, //返回
    title: '拜访记录', //标题
    add: true, //文字按钮
    filter:true,
    text_val: 'TOP 10', //文字按钮值
});

var date_arr = fun.getMonthArr(6),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            var begintime = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            var endtime = fun.Date(ret['end_date']).Format('yy-mm-dd');
        }
    });

var order_data = [
    {
    wldw_mc: '客户名称',
    lxr_mc: '联系人',
    zdr_mc: '制单人',
    kdsj: '2018-05-28 15:30',
    zysy: '主要事宜',
    khzt: '意向客户',
    bfjg: '',
    },{
    wldw_mc: '客户名称',
    lxr_mc: '联系人',
    zdr_mc: '制单人',
    kdsj: '2018-05-28 15:30',
    zysy: '主要事宜',
    khzt: '初次拜访',
    bfjg: '',
    },
];
showList(order_data);

function showList(data) {
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        render: {
            titlebar: function(res) {
                return [
                    '<div class="title-bar-row">',
                    '    <div><span style="color:' + res['color_val'] + '">' + fun.is_value(res['wldw_mc']) + '</span></div>',
                    '    <div class="align-right" ><a>' + fun.is_value(res['lxr_mc']) + '</a></div>',
                    '</div>',
                    '<div class="title-bar-row">',
                    '    <div><span>' + fun.is_value(res['kdsj']) + '</span></div>',
                    '    <div class="align-right" ><a>' + fun.is_value(res['zdr_mc']) + '</a></div>',
                    '</div>',
                ].join('');
            },
            subtitle: function(res) {
                return [
                    '<div class="row">',
                    '     <div>' + fun.is_value(res['zysy']) + '</div>',
                    '     <div class="sign0">' + fun.is_value(res['khzt']) + '</div>',
                    '</div>',
                ].join('')
            },
            subdata:function(res){
                return [
                    '<div class="row">',
                    '    <div><span>拜访结果</span><span>' + fun.is_value(res['bfjg']) + '</span></div>',
                    '</div>',
                ].join('');
            }

        },


    });
}

//打开编辑页
$('#add_btn').on('tap',function(){
    fun.showPageFull({
		page_url:page_arr.xs_bfjl_edit,
		pageParam:{}
	});
});

fun.setItem(html_name+'sideslip',true);
//打开搜索页
$('body').on('tap', '#filter_btn', function() {
    var sideslip=fun.getItem(html_name+'sideslip');
    var options = {

        "time": {
            "begin_date": "2017-01-02",
            "end_date": "2017-01-31"
        },
        "choose_merchants": [{
            key: "md",
            "text": "门店",
            "value": ""
        },{
            key: "kh",
            "text": "客户",
            "value": ""
        },{
            key: "ywy",
            "text": "业务员",
            "value": ""
        }],
    }
    if(sideslip) {
        fun.setItem(html_name+'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});
