var page_index = 'rxfx', page_list = [];
var photoBrowser = {};
var SYS_CONFIG ={};
var lastClick = 0;
// var flag = true;
// 日期选择
var html_name = page_arr.xs_cpfx,
    // date_arr = fun.getMonthArr(6), //获取最近6个月
    to_month = fun.getMonthArr(1)[0], //获取本月第一天和最后一天
    zxfx_data = {
        "type": "getZxfx",
        "cp_id": 0,
        "md_id": 0,
        "zxts": 1,
        "order": {
            "kcs": "",
            "zcb": ""
        },
    }
search_data = {
    "cp_id": 0,
    "lx_id": 0,
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    "pm_type": "je_xse",
    "md_id": 0,
    "cp_lb_id": 0,
    "cp_ys_id": 0,
    "group": "cp_id,cp_bh,cp_mc,tp",
    "cx_lx": "cp_pm",
    "order": {
        "xss": "",
        "xse": ""
    }
}
//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

var USER_INFO = {};

// 月份选择
var date_arr = fun.getMonthArr(6),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            $('#rxfx_box').empty();
            getList(search_data);
        }
    });

// 页面渲染
var showPage = (function () {
    return {
        showRxFx: function (data) { // 热销分析
            var listHtml = [];
            for (var i = 0; i < data.length; i++) {
                var item = data[i];
                var goods_text = ((item['cp_bh'] || '') + ' ' + (item['cp_mc'] || ''));
                // var goods_data = JSON.stringify(item);
                var img_url = (item['tp']) ? fun.getImgPath(item['tp']) : "../img/logo.png",
                    large_url = (item['tp']) ? fun.getImgPath(item['tp'], true) : "../img/logo.png";
                var ps = item['ps_xsp'] || 0;
                var sl = item['sl_xss'] || 0;
                var je = item['je_xse'] || 0;
                listHtml.push('<li class="heat-term lower-border-line record_line paging-list" data-index=\'' + fun.formatString(JSON.stringify(item)) + '\'>');
                listHtml.push('    <div class="heat-picture">');
                if (img_url === "../img/logo.png") {
                    listHtml.push('    <div class="heat-img">');
                    listHtml.push('       <img src="' + img_url + '" class="cp-img">');
                    listHtml.push('    </div>');
                } else {
                    listHtml.push('       <img src="' + img_url + '" large-url="' + large_url + '" class="product">');
                    listHtml.push('       <img src="../img/mask.png" class="heat-mask big-picture">');
                }
                listHtml.push('       </div>');
                listHtml.push('       <div class="heat-container">');
                listHtml.push('           <div class="heat-upper">');
                if (item['xh'] > 3) {
                    listHtml.push('               <div class="heat-ranking">' + item['xh'] + '.</div>');
                    // listHtml.push('               <div class="heat-ranking">' + i + '.</div>');
                } else {
                    listHtml.push('               <div class="heat-ranking"></div>');
                }
                listHtml.push('               <div class="heat-text-pack">' + goods_text + '</div>');
                listHtml.push('           </div>');
                listHtml.push('           <div class="heat-lower">');
                listHtml.push('               <span class="heat-sale">销售 </span>');
                listHtml.push('               <span class="heat-piece">' + ps + '匹</span>');
                listHtml.push('               <span class="heat-sale heat-xx">&nbsp;总数</span>');
                listHtml.push('               <span class="heat-weight">' + sl + '</span>');
                // listHtml.push('               <span class="heat-weight">'+fun.is_value(item['dw_mc'])+'</span>');
                listHtml.push('               <span class="heat-money">￥' + je + '</span>');
                listHtml.push('           </div>');
                listHtml.push('       </div>');
                listHtml.push('</li>');
            }
            return listHtml.join('');
        },
        showZxFx: function (data) { // 滞销分析
            var listZx = [];
            // console.log(JSON.stringify(data))
            for (var k = 0; k < data.length; k++) {
                var zx_text = ((data[k]['cp_bh'] || '') + ' ' + (data[k]['cp_mc'] || ''));
                // var zx_id = data[k]['cp_id'];
                // var goods_data = JSON.stringify(data[k]);
                var zx_img_url = (data[k]['tp']) ? fun.getImgPath(data[k]['tp']) : "../img/logo.png",
                    zx_large_url = (data[k]['tp']) ? fun.getImgPath(data[k]['tp'], true) : "../img/logo.png";

                var zx_color = ((data[k]['cp_ys_bh'] || '') + ' ' + (data[k]['cp_ys_mc'] || ''));
                var zx_sl = ((data[k]['sl'] || 0) + '' + (data[k]['dw_mc'] || ''));
                var zx_ts = data[k]['zxts'] || 0;
                var zx_ck = data[k]['ck_mc'] || '';
                var zx_cb = data[k]['zcb'] || 0;
                listZx.push('<li class="term lower-border-line record_line paging-list" data-index=\'' + fun.formatString(JSON.stringify(data[k])) + '\'>');
                listZx.push('    <div class="head">');
                listZx.push('         <span class="sequence">' + data[k]['xh'] + '.</span>');
                // listZx.push('         <span class="sequence">' + k + '.</span>');
                listZx.push('         <span class="product2">' + zx_text + '</span>');
                listZx.push('         <i class="iconfont icon-youfanhui youfanhui"></i>');
                listZx.push('    </div>');
                listZx.push('    <div class="picture " >');
                if (zx_img_url === "../img/logo.png") {
                    listZx.push('    <div class="zxfx-img">');
                    listZx.push('       <img src="' + zx_img_url + '" class="zx-img">');
                    listZx.push('    </div>');
                } else {
                    listZx.push('       <img src="' + zx_img_url + '" large-url="' + zx_large_url + '" class="product">');
                    listZx.push('       <img src="../img/mask.png" class="mask big-picture">');
                }
                // if(data['tp']){
                // }
                listZx.push('    </div>');
                listZx.push('       <div class="container">');
                listZx.push('           <div class="upper">');
                listZx.push('                <div class="text-pack">');
                listZx.push('                 <span class="number2">' + zx_color + '</span>');
                listZx.push('           </div>');
                listZx.push('           <div class="pack">');
                if (data[k]['fk'] != 0 && data[k]['kz'] != 0) {
                    listZx.push('               <span class="text3">幅\\克</span>');
                    listZx.push('               <span class="number3">' + (data[k]['fk'] + ((data[k]["fk"] && data[k]["kz"]) ? 'x' : "") + data[k]['kz'] || '') + '</span>');
                }
                listZx.push('           </div>');
                listZx.push('       </div>');
                listZx.push('       <div class="upper">');
                listZx.push('           <div class="text-pack">');
                listZx.push('                <span class="piece">' + data[k]['ps'] + '匹</span>');
                listZx.push('                <span class="heavy">' + zx_sl + '</span>');
                listZx.push('           </div>');
                listZx.push('           <div class="pack">');
                listZx.push('                <span class="text3">滞销</span>');
                listZx.push('                <span class="number3 count">' + zx_ts + '天</span>');
                listZx.push('           </div>');
                listZx.push('       </div>');
                listZx.push('       <div class="upper">');
                if (Auth.check('yxckbpcbj', 'view')) {
                    listZx.push('           <div class="text-pack">');
                    listZx.push('                <span class="text4">总成本</span>');
                    listZx.push('                <span class="number4 count2">' + zx_cb + '</span>');
                    listZx.push('           </div>');
                }
                listZx.push('           <div class="pack">');
                listZx.push('                <span class="warehouse">' + zx_ck + '</span>');
                listZx.push('           </div>');
                listZx.push('       </div>');
                listZx.push('   </div>');
                listZx.push('</li>');
            }
            return listZx.join('');
        },
        showData: function (data) { // 显示数据
            switch (page_index) {
                case 'rxfx':
                    $('#fx_list').append(this.showRxFx(data));
                    break;
                case 'zxfx':
                    $('#fx_list').append(this.showZxFx(data));
                    break;
                // 没有default
            }
        },
        showHeaderData: function (res) { // 渲染头部数据
            var info = res['info'];
            if (page_index == "rxfx") {
                // 热销分析-头部
                $('#rx_zps').text(info['ps'] || 0);
                $('#rx_zsl').text(info['sl'] || 0);
                $('#rx_zje').text(info['je'] || 0);
            } else {
                // 滞销分析-头部
                $('#zx_zps').text(info['zps'] || 0);
                $('.sum').text(info['zps'] || 0);
                $('#zx_zcb').text(info['zcb'] || 0);
                $('#zx_zmi').text(info['sl_m'] || 0);
                $('#zx_zy').text(info['sl_y'] || 0);
                $('#zx_zkg').text(info['sl_kg'] || 0);
            }
        },
        setListTop: function () { // 设置头像距离顶部距离
            switch (page_index) {
                case 'rxfx':
                    $('#fx_header').css({
                        top: $('.top-half').outerHeight() + parseFloat($('.top-half').css('top'))
                    })
                    $('#heat').css({
                        top: parseFloat($('#fx_header').css('top')) + $('#fx_header').outerHeight()
                    })
                    break;
                case 'zxfx':
                    $('#heat').css({
                        top: parseFloat($('#fx_header').css('top')) + $('#fx_header').outerHeight()
                    })
                    break;
                // 没有default
            }
        },
        rxHeaderShow: function () { // 热销头部显示
            $('#date_bar').show();
            $('.heat-total').show();
            $('.zxfx-header').hide();
            $('#zx_zsl').hide();
        },
        zxHeaderShow: function () { // 滞销头部显示
            $('.zxfx-header').show();
            $('#date_bar').hide();
            $('.heat-total').hide();
        },
        showFxHeader: function (res) { // 根据切换状态显示分析头部样式
            var info = res['info'];
            this.showHeaderData(res);
            switch (page_index) {
                case 'rxfx': // 热销分析
                    this.rxHeaderShow();
                    break;
                case 'zxfx': // 滞销分析
                    this.zxHeaderShow();
                    this.authPage();
                    break;
                // 没有default
            }
        },
        authPage: function () { // 权限控制
            if (!Auth.check('yxckbpcbj', 'view')) {
                $('.total1').hide();
                $('#zx_zsl').show();
                // $('#stagnation').css({
                //     "top": "10.25rem",
                //     "height": "calc(100% - 10.25rem)"
                // })
            }
        }
    }
})()

// 工具函数
var tool = (function () {
    return {
        recoverEvent: function () { // 恢复点击tab点击事件
            $('.layout').removeClass('disabled');
        },
        preventEvent: function () { // 阻止tab点击事件
            $('.layout').addClass('disabled');
        },
        find: function (str, cha, num) { // 获得指定字符出现几次的位置
            var x = str.indexOf(cha);
            for (var i = 0; i < num; i++) {
                x = str.indexOf(cha, x + 1);
            }
            return x;
        },
        convertData: function (data) {
            fun.apiData = JSON.parse(JSON.stringify(data));

            $(data).each(function (index, item) {
                item.__index = index;
            });

            return data;
        },
        // debounce: function (fn, time) { // 防抖函数
        //     var timer = null;
        //     return function () {
        //         var _that = this;
        //         var args = [].slice.call(arguments);
        //         clearTimeout(timer);
        //         timer = setTimeout(function () {
        //             fn.apply(_that, args);
        //         }, time)
        //     }
        // },
    }
})()

// 页面初始化
page_init = function () {
    SYS_CONFIG = fun.getItem('sys_config') || {};
    USER_INFO = fun.getItem('user_info') || {};

    $('#header').header({   // 头部
        back: true, //返回
        title: '产品分析', //标题
        filter: true, //筛选
    });

    // 判断是否从销售情况页面跳转过来
    if ('search_time' in page_data) {
        search_storage['begin_date'] = page_data.search_time['begin_time'];
        search_storage['end_date'] = page_data.search_time['end_time'];
        search_storage['cp'] = page_data.search_cpmc;
        search_data['begin_time'] = page_data.search_time['begin_time'];
        search_data['end_time'] = page_data.search_time['end_time'];
        $('.main-color').removeClass('main-color');
        date_bar.setDate(search_storage);
    };
    init();
    api.addEventListener({
        name: html_name,
    }, function (res) {
        var temp = res['value']['data'];
        if (!!res) {
            switch (res.value.status) {
                case "search":
                    console.log('~~~~~~')
                    console.log(temp)
                    if (page_index == 'rxfx') {
                        search_data['cp_id'] = temp['cp']['id'] || 0;
                        search_data['md_id'] = temp['md']['id'] || 0;
                        search_data['order']['xss'] = temp['XSS_SORT'];
                        search_data['order']['xse'] = temp['XSE_SORT'];
                        search_data['begin_time'] = temp['begin_date'];
                        search_data['end_time'] = temp['end_date'];

                        search_storage['cp'] = temp['cp']['text'];
                        search_storage['md'] = temp['md']['text'];
                        search_storage['begin_date'] = search_data['begin_time'];
                        search_storage['end_date'] = search_data['end_time'];
                    } else {
                        zxfx_data['cp_id'] = temp['cp']['id'];
                        zxfx_data['md_id'] = temp['md']['id'];
                        search_storage['md_mc'] = temp['md']['text'];
                        search_storage['cp_mc'] = temp['cp']['text'];
                        zxfx_data['order']['kcs'] = temp['KCS_SORT'];
                        zxfx_data['order']['zcb'] = temp['XSE_SORT'];
                        zxfx_data['zxts'] = temp['input']['value'] || 0;
                    }

                    fun.setItem(html_name + 'sideslip', true);

                    //设置时间控件时间
                    date_bar.setDate(search_storage);
                    $('#fx_list').html('');
                    getList();
                    break;
                default:

            }
        }
    });
    getList(); // 请求渲染数据
    fun.scrollToBottom({}, function () { // 滚动底部分页渲染
        if (page_list.length > 0) {
            showPage.showData(fun.PagingData(page_list, 5) || []);
        } else {
            if ($.nui.isTrue($('.empty_bottom').length)) return;
            var showListH = $(window).height() - parseFloat($('#heat').css('top')); // 除头部以区域
            var listH = $('#heat').outerHeight(); // 列表高度

            if (listH >= showListH) { // 超出区域
                fun.createBottomLine('fx_list', ".paging-list");
                $('.empty_bottom').show();
                return
            }
        }
    });
    bindEvent(); // 初始化事件
}

fun.setItem(html_name + 'sideslip', true);

// 获取数据
function getList() {
    var params = (page_index == "rxfx") ? search_data : zxfx_data;
    var url = (page_index == "rxfx") ? AJAX_URL.getCpfxList : AJAX_URL.getMobileCpfx;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: url,
        data: $.extend({}, {}, params),
        success: function (res) {
            if (res['status'] == 0) {
                showPage.showFxHeader(res);
                showPage.showHeaderData(res);
                showPage.setListTop();
                if ($.nui.isEmpty(res['data'])) {
                    tool.recoverEvent();
                    return fun.createDataEmptyTips({ dom: '#fx_list',style: 'margin-top:8rem;',btnShow: false });
                }
                page_list = res['data'];
                for (var i = 0; i < page_list.length; i++) {
                    page_list[i]['xh'] = (i + 1);
                }
                $('#fx_list').html('');
                showPage.showData(fun.PagingData(page_list || []));
                tool.recoverEvent();
            }
        }
    })
}

// 初始页页面参数
function init() {
    photoBrowser = api.require('photoBrowser');
    search_data['cp_id'] = page_data['cp_id'] || 0;
    search_data['order']['xse'] = 'desc';
    zxfx_data['cp_id'] = page_data['cp_id'] || 0;
    zxfx_data['zxts'] = SYS_CONFIG['bpzxts'] || 0;
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));
    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = search_storage['md'] = (disabled ? (USER_INFO['store_name']) : '');
    if (page_data['type']) {
        lastClick = $('.zxfx-layout').index();
        $('#fx_list').html('');
        $('.zxfx-layout').addClass('choice').siblings().removeClass('choice'); //  设置当前选中状态
        page_index = $('.zxfx-layout').data('type');
        // 没有允许查看布匹成本价权限
        tool.preventEvent();
        getList();

        // $('.zxfx-layout').addClass('choice').siblings().removeClass('choice');
        // page_index = $('.zxfx-layout').data('type');
        // var index = $('.zxfx-layout').index();
        // $('.switch').hide();
        // $('.switch').eq(index).show();
        // $('#rxfx_box').empty();
        // getList();
    }
}

// 绑定事件
function bindEvent() {
    //打开搜索页
    $('body').on('tap', '#filter_btn', function () {
        if (page_index == 'rxfx') {
            var sideslip = fun.getItem(html_name + 'sideslip');
            var options = {
                "time": {
                    "begin_date": search_storage['begin_date'],
                    "end_date": search_storage['end_date']
                },
                "choose_merchants": [{
                    key: "cp",
                    "text": "产品",
                    "value": search_storage['cp'] || '',
                    "id": search_data['cp_id'] || 0
                }, {
                    key: "md",
                    "text": "门店",
                    "value": search_storage['md'] || '',
                    "id": search_data['md_id'] || 0
                }],
                "sort": [{
                    "text": "销售数",
                    "key": "XSS_SORT",
                    "value": (search_data['order']['xss'] || '')
                }, {
                    "text": "销售额",
                    "key": "XSE_SORT",
                    "value": (search_data['order']['xse'] || '')
                }],

            };
        } else {
            var sideslip = fun.getItem(html_name + 'sideslip');
            var options = {
                "choose_merchants": [{
                    key: "cp",
                    "text": "产品",
                    "id": zxfx_data['cp_id'] || 0,
                    "value": search_storage['cp_mc'] || ''
                }, {
                    key: "md",
                    "text": "门店",
                    "id": zxfx_data['md_id'] || 0,
                    "value": search_storage['md_mc'] || ''
                }, {
                    "key": "input",
                    "id": 0,
                    "title": "滞销",
                    "text": "天",
                    "value": zxfx_data['zxts'] || 0
                }],
                "sort": [{
                    "text": "库存数",
                    "key": "KCS_SORT",
                    "value": (zxfx_data['order']['kcs'] || '')
                },
                {
                    "text": "总成本",
                    "key": "ZCB_SORT",
                    "value": (zxfx_data['order']['zcb'] || '')
                }
                ],
            }
        }

        if (sideslip) {

            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    "return_page": html_name,
                    "search_data": options
                },
                // y: fun.fontUnit(header)
            });
        }
    })

    // 销售-产品分析-详情
    $('body').on('tap', '.record_line', function (e) {
        e.stopPropagation();
        var times = fun.getMonthArr(3);
        // console.log(JSON.stringify(times))
        var index = $(this).closest('li').data('index');
        // console.log(JSON.stringify(index))
        var cp_id = index['cp_id'] || 0;
        var cp_bh = index['cp_bh'] || '';
        var cp_mc = index['cp_mc'] || '';

        var begin = (page_index == 'rxfx' ? search_storage['begin_date'] : fun.Date(times[0]['begin_date']).Format('yy-mm-dd'));
        var end = (page_index == 'rxfx' ? search_storage['end_date'] : fun.Date(times[2]['end_date']).Format('yy-mm-dd'));
        fun.showPageFull({
            page_url: page_arr.xs_cpfx_xq,
            pageParam: {
                type: page_index,
                cp_id: cp_id,
                cp_bh: cp_bh,
                cp_mc: cp_mc,
                // data: index,
                begin_time: begin,
                end_time: end,
            }
        });
    });

    // 列表模式 点击预览图片
    $('body').on('tap', '.product,.big-picture', function (e) {
        // e.preventDefault();
        // var img_arr = [];
        // if($(this).hasClass('mask')) {
        //     $(this).each(function (i, obj) {
        //         img_arr.push($(this).prev().attr('large-url'));
        //         $(obj).attr('index', i);
        //     })
        // }else{
        //     $(this).each(function (i, obj) {
        //         img_arr.push($(this).attr('large-url'));
        //         $(obj).attr('index', i);
        //     })
        // }

        // console.log(JSON.stringify(img_arr))
        // if (img_arr.length == 0) return;
        e.preventDefault();
        e.stopPropagation();
        var index = $(this).attr('index');
        if ($(this).hasClass('big-picture')) {
            index = $(this).next().attr('index');
        }

        var img_arr = [];
        $('.product').each(function (i, obj) {
            img_arr.push($(this).attr('large-url'));
            $(obj).attr('index', i);
        })
        var index = $(this).prev().attr('index');
        photoBrowser.open({
            images: img_arr,
            activeIndex: index || 0,
            placeholderImg: '../img/logo.png',
            bgColor: '#000'
        }, function (ret, err) {
            if (ret) {
                if (ret['eventType'] == 'click') {
                    photoBrowser.close();
                }
            } else {
                console.log(JSON.stringify(err));
            }
        });
        return false;
    })

    // 切换
    $('body').on('tap', '.layout', fun.debounce(function () {
        if (lastClick === $(this).index()) return;
        lastClick = $(this).index();
        $('#fx_list').html('');
        $(this).addClass('choice').siblings().removeClass('choice'); //  设置当前选中状态
        page_index = $(this).data('type');
        // 没有允许查看布匹成本价权限
        tool.preventEvent();
        getList();
        // if (!Auth.check('yxckbpcbj', 'view')) {
        //     $('.total1').hide();
        //     $('.hide').show();
        //     $('#stagnation').css({
        //         "top": "10.25rem",
        //         "height": "calc(100% - 10.25rem)"
        //     })
        // }
    }, 350))
}