var html_name = page_arr.xs_dydj;

var to_month = fun.getMonthArr(1)[0];
var page_list = [], total_data = [];
var search_data = {
    "begin_time": '',//fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": '',//fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    "type": "dj_zb",
    "ycjd": false,
};
var search_storage = {
    "begin_date": '',//fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": ''//fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};
var USER_INFO = {};
var SYS_CONFIG = {};

var recordData = [];

// $('#date_range').text(fun.Date(search_data['begin_time']).Format('yy.mm.dd') + ' ~ ' + fun.Date(search_data['end_time']).Format('yy.mm.dd'));

var displayObj = {};
var show_tips = false;

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    SYS_CONFIG = fun.getItem('sys_config') || {};

    $('.show-time').hide();

    search_data['wldw_id'] = page_data['wldw_id'] || 0;
    search_data['is_dy'] = 1;
    search_data['is_dy_djlx'] = page_data['djlx'];
    search_data['jl_id_notin'] = page_data['jl_id_notin'] || [];
    search_data['is_sh'] = 1;
    search_data['wdyje'] = true; //抵订金调用 未抵用要大于0

    $('#header').header({
        back: true, //返回
        title: page_data['wldw_mc'], //标题
        filter: false, //筛选
        appendBackBtnEvt: sendData
    });


    displayObj['bcdyje_display'] = '本次抵用';

    switch (page_data['djlx']) {
        case 'bp_xsfhjs':
        case 'cw_skd':
            displayObj['bcdyje_display'] = '本次抵用';
            displayObj['dyje_display'] = '未抵用';
            break;
        case 'cw_fkd':
            displayObj['bcdyje_display'] = '本次抵用';
            displayObj['dyje_display'] = '未抵用';
            break;
        case 'bp_xsthjs':
            displayObj['bcdyje_display'] = '本次返还';
            displayObj['dyje_display'] = '已抵用';
            $('#wdy_display').text('已抵用');
            break;
    }

    $('#bcdy_display').text(displayObj['bcdyje_display']);


    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var param = ret.value.data;

        search_data['begin_time'] = param.begin_date;                   //开始时间
        search_data['end_time'] = param.end_date;                       //结束时间

        //搜索菜单需要缓存的数据
        search_storage['begin_date'] = search_data['begin_time'];
        search_storage['end_date'] = search_data['end_time'];

        // $('.show-time').show();
        // $('#date_range').text(fun.Date(search_data['begin_time']).Format('yy.mm.dd') + ' ~ ' + fun.Date(search_data['end_time']).Format('yy.mm.dd'));

        $('#order_list').empty();
        getList(search_data);

    });

    // fun.scrollToBottom({}, function () {
    //     if (page_list.length > 0) {
    //         showList(fun.PagingData(page_list) || []);
    //     } else {
    //         // fun.createBottomLine('order_list', ".list-wrap");
    //     }
    // });

    if (!$.nui.isTrue(page_data['page_edit'])) {
        $('#filter_btn,#wdy_box,.show-time').hide();
        $('#bcdy_box').css('width', '100%');

        showList(page_data['djdymx'], 2);
        return;
    }

    if ($.nui.isTrue(page_data['djdymx'])) {
        $('#filter_btn,.show-time').hide();
    }

    getList(search_data);

    fun.orderListHeight({dom:'#order_list'});
    fun.inputType();
};

function sendData() {
    if (!$.nui.isTrue(page_data['page_edit'])) {
        setTimeout(function () {
            api.closeWin();
        }, 200);
        return;
    }
    show_tips = false;
    $('.num-input').blur();

    if (show_tips) {
        $('.num-input').addClass('sth-change');
        return;
    }

    var djdymx = [];
    var ddj = 0;

    if ($('.summary-content .row').length && $('.sth-change').length) {
        for (var i = 0; i < $('.summary-content .row').length; i++) {
            var $ele = $('.summary-content .row').eq(i);
            var dj_data = $ele.data('dj_data');

            var bcdy = parseFloat($ele.find('.num-input').val().trim() || 0);

            if ($.nui.isEmpty(dj_data['id']) && $.nui.isEmpty(bcdy)) continue;
            // var row = $.extend({}, dj_data, {bcdy: bcdy});
            var row = {
                'dd_dh': dj_data['dh'],
                'dd_dj_id': dj_data['dj_id'],
                'kdsj': dj_data['kdsj'],
                'zh_je': dj_data['dj'],
                'zje': dj_data['bdje'],
                'dyqje': ((page_data['djlx'] === 'bp_xsthjs') ? dj_data['ydyje'] : dj_data['wdyje']),
                'bcdy': bcdy,
                is_delete: $.nui.isEmpty(bcdy) ? 1 : 0
            };


            // ddj = fun.sswr(ddj + parseFloat(row['bcdy']), SYS_CONFIG['bdjesswr_bpxs']);
            ddj = ddj + parseFloat(row['bcdy']);

            row = $.extend({}, dj_data, row);

            if ($.nui.isEmpty(row['id'])) {
                row = {
                    'dd_dh': dj_data['dh'],
                    'dd_dj_id': dj_data['dj_id'],
                    'kdsj': dj_data['kdsj'],
                    'zh_je': dj_data['dj'],
                    'zje': dj_data['bdje'],
                    'dyqje': ((page_data['djlx'] === 'bp_xsthjs') ? dj_data['ydyje'] : dj_data['wdyje']),
                    'bcdy': bcdy,
                    is_delete: $.nui.isEmpty(bcdy) ? 1 : 0
                };
                row['__status'] = 'add';
            } else {
                row['__status'] = 'edit';
            }

            delete row['wdyje'];
            delete row['ydyje'];

            djdymx.push(row);
        }

        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'dydj',
                'data': {
                    ddj: ddj, //parseFloat($('#bcdy').text().trim() || 0),
                    djdymx: djdymx,
                    begin_time: search_data['begin_time'],
                    end_time: search_data['end_time']
                }
            }
        });
    } else {

    }

    setTimeout(function () {
        api.closeWin();
    }, 200);
}

function getList(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getDjcxtj,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0 && $.nui.isEmpty(page_data['djdymxObj'])) {
                    $('#wdy').text(0);
                    $('#bcdy').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false,style:'top:1rem;height:9rem;'});
                }
                total_data = res['info'] || {};
                page_list = res['data'] || [];
                recordData = (res['data'] || []).slice(0);

                if ($.nui.isTrue(page_data['djdymxObj'])) {
                    var tmpDydjmxObjIdArr = [];
                    var listDydjmxIdArr = [];

                    for (var key in page_data['djdymxObj']) {
                        if ($.nui.isTrue(page_data['djdymxObj'][key]['wldw_id']) && (page_data['djdymxObj'][key]['wldw_id'] != page_data['wldw_id'])) {
                            delete page_data['djdymxObj'][key];
                        }
                    }

                    for (var key in page_data['djdymxObj']) {
                        tmpDydjmxObjIdArr.push(Number(key));
                    }

                    for (var i = 0; i < page_list.length; i++) {
                        listDydjmxIdArr.push(Number(page_list[i]['dj_id']));
                    }

                    console.log('tmpDydjmxObjIdArr', tmpDydjmxObjIdArr)
                    console.log('listDydjmxIdArr', listDydjmxIdArr)

                    for (var i = 0; i < tmpDydjmxObjIdArr.length; i++) {
                        if (listDydjmxIdArr.indexOf(tmpDydjmxObjIdArr[i]) === -1) {
                            page_list.push(page_data['djdymxObj'][tmpDydjmxObjIdArr[i]]);
                        }
                    }

                    page_list.sort(function (a, b) {
                        return a.kdsj <= b.kdsj ? -1 : 1;
                    });
                }


                // console.log(JSON.stringify(page_list));
                // console.log(JSON.stringify(page_data['djdymx']));
                // console.log(JSON.stringify(page_data['djdymxObj']));


                console.log(res['data'])

                if ($.nui.isEmpty(recordData)) {
                    showList(page_list || [], 2);
                } else {
                    showList(page_list || []);
                }
            } else {
                fun.toast(res.msg);
            }
        }
    });
}


function showList(data, type) {
    type = type || 1;

    console.log('type', type)

    if (type == 1) {
        var hjName = 'wdyje';
        switch (page_data['djlx']) {
            case 'bp_xsfhjs':
                hjName = 'wdyje';
                break;
            case 'bp_xsthjs':
                hjName = 'ydyje';
                break;
            case 'cw_skd':
                hjName = 'wdyje';
                break;
            case 'cw_fkd':
                hjName = 'wdyje';
                break;
        }

        $('#wdy').text(total_data[0][hjName] || 0);//未抵用
    }

    console.log('ASD', data)

    $('#order_list').OrderList({
        data: data,
        schedule: false,
        render: {
            titlebar: function (res) {
                var valObj = {
                    dh: (type == 1) ? res['dh'] : res['dd_dh'],
                    bdje: (type == 1) ? res['bdje'] : res['zje'],
                    dj: (type == 1) ? res['dj'] : res['zh_je']
                };

                res['dyqje'] = ((page_data['djlx'] === 'bp_xsthjs') ? (res['ydyje'] || res['dyqje'] || 0) : (res['wdyje'] || res['dyqje']));

                return [
                    '<div class="title-bar-row">',
                    '    <div><span class="font-bold">' + fun.is_value(fun.formatDate(res['kdsj'])) + '</span></div>',
                    '    <div class="align-right" ><a>' + fun.is_value(valObj['dh']) + '</a></div>',
                    '</div>',
                    // '<div class="title-bar-row">',
                    // '    <div style="">总金额&nbsp;<a>' + fun.is_value(valObj['bdje']) + '</a></div>',
                    // '    <div class="align-right" style="">订金&nbsp;<a style="">' + (valObj['dj'] || 0) + '</a></div>',
                    // '</div>',
                ].join('');
            },
            subtitle: function (res) {
                var valObj = {
                    dh: (type == 1) ? res['dh'] : res['dd_dh'],
                    bdje: (type == 1) ? res['bdje'] : res['zje'],
                    dj: (type == 1) ? res['dj'] : res['zh_je']
                };
                return [
                    '<div class="row">',
                    '    <div style="" class="color-gray">总金额&nbsp;<a>' + fun.is_value(valObj['bdje'], 0) + '</a></div>',
                    '    <div class="align-right color-gray" style="">订金&nbsp;<a style="color: #000;">' + (valObj['dj'] || 0) + '</a></div>',
                    '</div>',
                ].join('');
            },
            subdata: function (res) {
                // console.log(JSON.parse(JSON.stringify(res)))
                // console.log(page_data['djdymxObj'][res['dj_id'] || res['dd_dj_id']])
                res = $.extend({}, res, page_data['djdymxObj'][res['dj_id'] || res['dd_dj_id']] || {});
                var inputDisabled = !page_data['page_edit'] ? 'disabled' : '';

                // 'dyqje': ((page_data['djlx'] === 'bp_xsthjs') ? dj_data['ydyje'] : dj_data['wdyje']),


                var tmpWdyje = ((page_data['djlx'] === 'bp_xsthjs') ? res['ydyje'] : res['wdyje']);

                var flagVal = ($.nui.isEmpty(recordData) || $.nui.isTrue(res['id'])) ? res['dyqje'] : tmpWdyje;

                if(res['use_latest']){
                    if($.nui.isEmpty(recordData)){
                        res['dyqje'] = ((page_data['djlx'] === 'bp_xsthjs') ? (res['ydyje'] || res['dyqje'] || 0) : 0);
                    }else{
                        res['dyqje'] = ((page_data['djlx'] === 'bp_xsthjs') ? (res['ydyje'] || res['dyqje'] || 0) : ((typeof res['wdyje']==='undefined')?res['dyqje'] :res['wdyje'] ));
                    }
                }

                var valObj = {
                    dh: (type == 1) ? res['dh'] : res['dd_dh'],
                    // wdyje: (type == 1) ? res['wdyje'] : res['dyqje'],
                    // wdyje: res['dyqje'] || ((page_data['djlx'] === 'bp_xsfhjs' || page_data['djlx'] === 'cw_skd' || page_data['djlx'] === 'cw_fkd') ? res['wdyje'] : res['ydyje']),
                    wdyje: res['dyqje'],
                };

                var max_val = valObj['wdyje'];

                return [
                    '<div class="row" style="" data-dj_data=\'' + fun.formatString(JSON.stringify(res)) + '\'>',
                    '    <div style=""><span class="color-gray">' + displayObj['dyje_display'] + '</span><span class="wdyjs">' + (valObj['wdyje'] || 0) + '</span></div>',
                    '    <div style=""><span class="color-gray">' + displayObj['bcdyje_display'] + '</span><input ' + inputDisabled + ' style="" id="' + (valObj['dh'] || $.nui.getRandomNum()) + '" class="ipt-bg num-input" value="' + (res['bcdy'] || '') + '" type="text" data-max_val="' + (max_val || 0) + '" num_type="2" decimal_digits="4"/><i ' + inputDisabled + ' class="iconfont icon-rmb fzdyj"></i></div>',
                    '</div>',
                ].join('');
            }
        },
    });


    if ($.nui.isTrue(page_data['page_edit']) && $.nui.isTrue(page_data['djdymx'])) {

    }

    setBcdyje();
    $('.title-bar').off('tap');
}

$('body').on('click', '.fzdyj', function (e) {
    if ($(this).attr('disabled')) return;
    var info = $(this).parents('.row');
    var inp_val = $(this).siblings('.ipt-bg');
    var wdy = info.find('.wdyjs').text();
    // console.log(inp_val.attr('id'));
    // console.log(wdy);
    inp_val.val(wdy);

    // var val = parseFloat(wdy || 0);
    // var max_val = parseFloat($(this).data('max_val') || 0);
    // if (val > max_val) {
    //     $(this).val(max_val);
    // }

    setBcdyje();

    inp_val.addClass('sth-change');

});

// function showDjdymxList(data, type) {
//     type = type || 2;
//
//     (type == 1) && $('#wdy').text(total_data[0]['wdyje'] || 0);//未抵用
//
//     $('#order_list').OrderList({
//         data: data,
//         schedule: false,
//         type: 'prepend',
//         render: {
//             titlebar: function (res) {
//                 var valObj = {
//                     dh: (type == 1) ? res['dh'] : res['dd_dh'],
//                     bdje: (type == 1) ? res['bdje'] : res['zje'],
//                     dj: (type == 1) ? res['dj'] : res['zh_je']
//                 };
//                 return [
//                     '<div class="title-bar-row">',
//                     '    <div><span style="color:' + res['color_val'] + '">' + fun.is_value(fun.formatDate(res['kdsj'])) + '</span></div>',
//                     '    <div class="align-right" ><a>' + fun.is_value(valObj['dh']) + '</a></div>',
//                     '</div>',
//                     '<div class="title-bar-row">',
//                     '    <div><a style="color: #aaa;">总金额&nbsp;' + fun.is_value(valObj['bdje']) + '</a></div>',
//                     '    <div class="align-right" ><a>订金&nbsp;' + (valObj['dj'] || 0) + '</a></div>',
//                     '</div>',
//                 ].join('');
//             },
//             subdata: function (res) {
//                 res = $.extend({}, res, page_data['djdymxObj'][res['dj_id']]);
//                 var inputDisabled = !page_data['page_edit'] ? 'disabled' : '';
//
//                 var valObj = {
//                     dh: (type == 1) ? res['dh'] : res['dd_dh'],
//                     // wdyje: (type == 1) ? res['wdyje'] : res['dyqje'],
//                     wdyje: res['dyqje'] || ((page_data['djlx'] === 'bp_xsfhjs' || page_data['djlx'] === 'cw_skd' || page_data['djlx'] === 'cw_fkd') ? res['wdyje'] : res['ydyje']),
//                 };
//
//                 var max_val = valObj['wdyje'];
//
//                 return [
//                     '<div class="row" data-dj_data=\'' + JSON.stringify(res) + '\'>',
//                     '    <div><span>' + displayObj['dyje_display'] + '</span><span>' + (valObj['wdyje'] || 0) + '</span></div>',
//                     '    <div><span>' + displayObj['bcdyje_display'] + '</span><input ' + inputDisabled + ' style="color: ' + res['color_val'] + ';" id="' + (valObj['dh'] || '') + '" class="ipt-bg num-input" value="' + (res['bcdy'] || '') + '" type="text" data-max_val="' + (max_val || 0) + '" num_type="2" decimal_digits="4"></div>',
//                     '</div>',
//                 ].join('');
//             }
//         },
//     });
//
//     setBcdyje();
//     $('.title-bar').off('tap');
// }


// function showList2(data) {
//     $('#order_list').OrderList({
//         data: data,
//         schedule: false,
//         render: {
//             titlebar: function (res) {
//                 return [
//                     '<div class="title-bar-row">',
//                     '    <div><span style="color:' + res['color_val'] + '">' + fun.is_value(res['kdsj']) + '</span></div>',
//                     '    <div class="align-right" ><a>' + fun.is_value(res['dd_dh']) + '</a></div>',
//                     '</div>',
//                     '<div class="title-bar-row">',
//                     '    <div><a style="color: #aaa;">总金额&nbsp;' + fun.is_value(res['zje']) + '</a></div>',
//                     '    <div class="align-right" ><a>订金&nbsp;' + (res['dj'] || 0) + '</a></div>',
//                     '</div>',
//                 ].join('');
//             },
//             subdata: function (res) {
//                 res = $.extend({}, page_data['djdymxObj'][res['dj_id']], res);
//                 var inputDisabled = !page_data['page_edit'] ? 'disabled' : '';
//
//                 return [
//                     '<div class="row" data-dj_data=\'' + JSON.stringify(res) + '\'>',
//                     '    <div><span>未抵用</span><span>' + (res['wdyje'] || 0) + '</span></div>',
//                     '    <div><span>本次抵用</span><input ' + inputDisabled + ' style="color: ' + res['color_val'] + ';" id="' + (res['dh'] || $.nui.getRandomNum()) + '" class="ipt-bg num-input" value="' + (res['bcdy'] || '') + '" type="text" data-max_val="' + (res['wdyje'] || 0) + '" num_type="2" decimal_digits="4"></div>',
//                     '</div>',
//                 ].join('');
//             }
//         },
//     });
//     setBcdyje();
//     $('.title-bar').off('tap');
// }

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function (e) {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        }
    };
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

$('body').on('focus', '.num-input', function (e) {
    $(this).addClass('sth-change');
});

$('body').on('blur', '.num-input', function (e) {
    e.stopPropagation();

    var val = parseFloat($(this).val().trim() || 0);
    var max_val = parseFloat($(this).data('max_val') || 0);

    var text1 = $(this).prev().text();
    var text2 = $(this).closest('div').prev().find('.color-gray').text();

    if (val > max_val) {
        fun.toast(text1 + '金额不能大于' + text2 + '金额，已自动赋值为' + max_val);
        $(this).val(max_val);
        show_tips = true;
    }

    setBcdyje();
});

$('body').on('change', '.num-input', function (e) {
    $(this).addClass('sth-change');
});


function setBcdyje() {
    var sum = 0;
    var wdy = 0;
    for (var i = 0; i < $('.num-input').length; i++) {
        sum = $.nui.decimalAdd(sum, parseFloat($('.num-input').eq(i).val().trim() || 0));
        wdy = $.nui.decimalAdd(wdy, parseFloat($('.num-input').eq(i).closest('.row').find('.wdyjs').text().trim() || 0));
    }

    $('#wdy').text(wdy);
    $('#bcdy').text(sum);
}


// var html_name = page_arr.xs_dydj;
// $('#header').header({
//     back: true, //返回
//     title: 'XX客户名称', //标题
//     filter: true //筛选
// });
//
// //打开搜索页
// $('body').on('tap', '#filter_btn', function () {
//     var options = {
//         "time": {
//             "begin_date": "2017-01-02",
//             "end_date": "2017-01-31"
//         },
//     };
//     fun.openFrame({
//         frame_url: page_arr.search,
//         pageParam: {
//             "return_page": html_name,
//             "search_data": options
//         },
//         // y: fun.fontUnit(header)
//     });
// })
//
// // 表格
// var params = {
//     show_sum: false,
//     roll_height: '100%',
//     auto_width: '100%',
//     title: [{
//         name: '单据',
//         key: 'dj',
//         width: '35'
//     }, {
//         name: '总金额',
//         key: 'zje',
//         width: '15'
//     }, {
//         name: '订金',
//         key: 'di',
//         width: '15'
//     }, {
//         name: '未抵用',
//         key: 'wdy',
//         width: '15'
//     }, {
//         name: '本次抵用',
//         key: 'bcdy',
//         width: '20'
//     }],
//     data: [{
//         'dj': '<span class="single">LSD1285596735</span>' + '<br/>' + '2018-11-09 22:00',
//         'zje': '1000',
//         'di': '300',
//         'wdy': '200',
//         'bcdy': '<span class="second">100</span>',
//     }, {
//         'dj': '<span class="single">LSD1285596735</span>' + '<br/>' + '2018-11-09 22:00',
//         'zje': '1000',
//         'di': '300',
//         'wdy': '200',
//         'bcdy': '<span class="second">100</span>',
//     },
//
//     ]
// };
// $('#params').goods_grid(params);


//总订货
// 订单匹 ps 发货匹 fhps 未发匹 wfps
// 订单数 zsl 发货数 fhsl 未发数 wfsl
