var html_name = page_arr.xs_fhd_xq;
var id;

fun.clearItem('ck_list');

page_init = function () {
    $('#header').header({
        back: true,//返回
        share: true, //分享
        title: page_data['mc'],//标题
        subtitle: page_data['dh'],//副标题
        order_info: {
            show: true,
            person: page_data['zdr'],//制单人
            dateText: page_data['kdsj']//开单时间
        },
    });
    $('.contents-sx').css('marginTop',$('#header').outerHeight());

    id = page_data['id'];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpXsfhdInfo,
        data: {
            id: id,
        },
        success: function (res) {
            var page_data = convertData(res.data.jl);
            showData1(res.data.dj,res.data.jl);
            showData2(page_data);
        }
    })
    fun.scrollToBottom({}, function () {
        fun.createBottomLine('order_list', ".list-wrap");
    });
}

/**
 * 方法
 */
function showData1(data,data2) {
    $('#kh').val(data['wldw_mc'] || '');
    $('#lxr').val(data['lxr'] || '');
    $('#sj').val(data['lxr_dh'] || '');
    $('#dz').val(data['lxr_dz'] || '');
    $('#bz').val(data['bz'] || '');
    $('#hy').val(data['hy_mc'] || '');
    $('#yf').val(data['hy_je'] || '');
    $('#hyd').val(data['hy_dh'] || '');
    getTotalInfo(data2)
    $('#zps').text(data['zps'] || 0);
    $('#zjjsl').text(data['zjjsl'] || 0);

    if (data['is_zf']) {
        fun.seal({type: 'zf'});
    } else if (data['is_sh']) {
        fun.seal({type: 'sh'});
    }
}

// 获取合计信息
function getTotalInfo(data, setText) {
    var _data = !$.nui.isEmpty(data) ? data : [];
    var tmp_total = {
        zps: 0,
        zsl: 0,
        zjjsl: 0,
        // bdje: 0,
        // hszje: 0,
        // hsje: 0,
        // zje: 0
    };

    for (var i = 0; i < _data.length; i++) {
        var val = _data[i];
        if ($.nui.isTrue(val['is_delete'])) continue;

        tmp_total['zps'] = $.nui.decimalAdd(tmp_total['zps'], parseInt(val['ps'] || 0));
        tmp_total['zsl'] = $.nui.decimalAdd(tmp_total['zsl'], parseFloat(val['zsl'] || 0));
        tmp_total['zjjsl'] = $.nui.decimalAdd(tmp_total['zjjsl'], parseFloat(val['jjsl'] || 0));
        // tmp_total['bdje'] = $.nui.decimalAdd(tmp_total['bdje'], parseFloat(val['hszje'] || 0));
        // tmp_total['hszje'] = $.nui.decimalAdd(tmp_total['hszje'], parseFloat(val['hszje'] || 0));
        // tmp_total['hsje'] = $.nui.decimalAdd(tmp_total['hsje'], parseFloat(val['hsje'] || 0));
        // tmp_total['zje'] = $.nui.decimalAdd(tmp_total['zje'], parseFloat(val['zje'] || 0));
    }


    // tmp_total['bdje'] = __bdjeSswr(tmp_total['bdje']);
    // tmp_total['hszje'] = __bdjeSswr(tmp_total['hszje']);
    // tmp_total['zje'] = __bdjeSswr(tmp_total['zje']);

    if (!setText) {
        $('#zps').text(tmp_total['zps'] || 0);
        $('#zjjsl').text(tmp_total['zjjsl'] || 0);
        $('#jjdw').text($.nui.isFieldValEqual('jjdw_mc', _data)['val']);
        // $('#hszje').text(tmp_total['hszje'] || 0);
    }

    return tmp_total;
}


function showData2(data) {

    var Html = [];
    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        Html.push('<a class="store-title">' + (val['ck_mc'] || ' ') + '</a>');
        Html.push('<div id="order_list">');
        Html.push('<ul class="list-wrap">');
        for (var j = 0; j < val['list'].length; j++) {
            var val_list = val['list'][j];
            // var lximg = '';
            // switch (val_list['lx']) {
            //     case '剪样':
            //         lximg = '<img src="../img/shearing.png" class="xiejiao">';
            //         break;
            //     case '样版':
            //         lximg = '<img src="../img/sample_version.png" class="xiejiao">';
            //         break;
            //     case '色卡':
            //         lximg = '<img src="../img/color_card.png" class="xiejiao">';
            //         break;
            // }

            var lximg = fun.getJgLxImg(val_list);

            Html.push('	<li class="store-info" data-list=\'' + fun.formatString(JSON.stringify(val_list)) + '\'>');
            Html.push(lximg);
            (val_list['dd_dj_id']) && Html.push('                 <div class="box"></div>');
            Html.push('		<p class="store-name">' + (fun.is_value(val_list['cp_bh']) + fun.is_value(val_list['cp_mc'])) + ' <i>' + (fun.is_value(val_list['cp_ys_bh']) + fun.is_value(val_list['cp_ys_mc'])) + '</i> </p>');
            Html.push('		<span>匹数<i class="info-date">' + fun.is_value(val_list['ps']) + '</i></span>');
            Html.push('		<span>数量<i class="info-date">' + fun.is_value(val_list['zsl']) + '<i>' + fun.is_value(val_list['dw_mc']) + '</i></i></span>');
            var colorText = (val_list['zsl'] != val_list['jjsl']) ? 'text' : '';
            Html.push('		<span>计价<i class="info-date ' + colorText + '">' + fun.is_value(val_list['jjsl']) + '</i><i>' + fun.is_value(val_list['jjdw_mc']) + '</i></span>');
            Html.push('		<span>幅宽<i class="info-date">' + fun.is_value(val_list['fk']) + '</i></span>');
            Html.push('		<span>克重<i class="info-date">' + fun.is_value(val_list['kz']) + '</i></span>');
            if (val_list['gh'] == '') {
                Html.push('		<span></span>');
            } else {
                Html.push('		<span>缸号<i class="info-date">' + val_list['gh'] + '</i></span>');
            }
            Html.push('	</li>');
        }
        Html.push('</ul>');
        Html.push('</div>');

    }
    $('.storehouse').append(Html.join(''))
}

// 显示、隐藏切换
$('.hide').hide();
$('.open').on('click', function () {
    if ($('.hide').css("display") === "none") {
        $('.hide').show();
        $(this).children().removeClass("icon-xia").addClass("icon-shang");
    } else {
        $('.hide').hide();
        $(this).children().removeClass('icon-shang').addClass("icon-xia");
    }
});


function convertData(apidata) {
    if (JSON.stringify(apidata) == "[]")
        return [];
    if ((!(apidata instanceof Array))) {
        return "参数错误";
    }
    var list = [], tmp = {};
    $(apidata).each(function (i, obj) {
        if (!tmp[obj['ck_id']]) {
            tmp[obj['ck_id']] = {
                'ck_id': obj['ck_id'],
                'ck_mc': obj['ck_mc'],
                'list': []
            }
        }
        tmp[obj['ck_id']]['list'].push(obj)
    })

    for (var i in tmp) {
        list.push(tmp[i]);
    }
    return list;
}

$('body').on('tap', '.store-info', function () {
    var data_list = $(this).data('list');
    var is_detail = fun.getHouseValue(data_list['ck_id'], 'is_detail'),
        hasData = $.nui.isTrue(data_list['mx']);

    if (is_detail && hasData) {
        fun.showPageFull({
            page_url: page_arr.kdxq_mxbp,
            pageParam: {
                return_page: html_name,
                data: data_list
            }
        });
    }
})


function __checkData() {
    if (!fun.dataIsRead(['ck'])) {
        setTimeout(__checkData, 250);
    } else {
        setTimeout(function () {
            if (typeof page_init === "function") page_init();
        }, 100);
    }
}

//分享单据到微信
$('body').on('click','#share_btn',function(_opt){
    fun.shareRequest({
        djlx:'bp_xsfhd',
        id:page_data['id'],
    })
})
