var html_name = page_arr.xs_fhjs_kd; //页面名称

var Bills = Bills || {};
Bills['AJAX_URL'] = {
    'getInfo': AJAX_URL.getBpXsfhjsInfo, //获取销售发货结算信息
    'save': AJAX_URL.saveBpXsfhjsInfo, //保存
    'getDj': AJAX_URL.getBpXsDjAndScdj, //获取单价
    'getBillsPageDefInfo': AJAX_URL.getBillsPageDefInfo, //开单页面默认信息
    'getSimpleRecordList': AJAX_URL.getSimpleRecordList, //档案
};
// 删除行记录，判断需排除的字段
Bills['del_row_exclude_col'] = ['is_yy_tm', 'dd_jl_id', 'ckd_jl_id'];

Bills['wldw'] = {};
Bills['wldw_type'] = 'kh';//往来单位类型
Bills['wldw']['type'] = 'kh';

Bills['getWldwSubInfoConfig']['lxr'] = true;
Bills['WldwSubInfo'] = {};

Bills['djlx'] = 'bp_xsfhjs';//单据类型
Bills['auth'] = 'bp_xsfhjs';//权限

Bills['win_type'] = 'is_ck';//窗口类型

Bills['print_config'] = { 'has_bar': 1 };

Bills['__post_sign'] = $.nui.getRandomNum(); //不执行后端的限制（相同数据限制30秒后才能保存)

var ori_wldw_id;

var isSave = false;

Bills['config'] = {
    fy_zdy: 'bpxszdyfy', // 布匹-销售自定义费用
    ck_zdy: 'bpckzdygl', // 仓库自定义字段
    kd_zdy: 'bpkdzdyzd', // 开单自定义字段
    dckms: 'dckms_bp',   // 多仓库模式
    adjs: 'adjs_bpxs',   // 按单结算
    dwgshsbl: 'dwgshsbl_bp', // 单位公式换算保留位数
    jesswr: 'jesswr_bpxs',   // 金额四舍五入
    bdjesswr: 'bdjesswr_bpxs', // 本单金额四舍五入
    dddjwlcddj: 'dddjwlcddj_bpxs', // 订单单价为0重读单价
    ssjms: 'qyssjms_bp', // 实售价模式
};

Bills['hy'] = {
    hy_id: 0,
    hy_je: 0,
    hy_zh_id: 0,
    hy_zh_je: 0,
    hy_dh: '',
    hy_lsh: '',
    hy_qqje: 0,
    hy_ljqk: 0
};

Bills['djdymx'] = [];
Bills['origin_data'] = {};
Bills['save_data'] = {};

// //右键菜单默认记忆状态
// var rightMenus_config = {
//     xtckzdgx: true, //相同仓库自动更新
//     jjsfssl: false, //计价数反算出数量
//     zdscjh: false, //自动生成卷号
// };

var USER_INFO = {}; //用户信息
var SYS_CONFIG = {};//系统设置
var DH_CONFIG = {};//单号设置
var zh_list = [];//账户
var ck_list = [];//仓库
var SimpleRecord;
var wldw_kh_list = [], wldw_wl_list = [];

var begin_lCalendar = new lCalendar();

// var __PAGE_STATUS = 'edit';
var __PAGE_INFO = {};//页面默认信息，例如仓库、账户、单号等
var __PAGE_DATA = { dj: {}, jl: [], djdymx: [] };//页面数据
var __DJ_DATA = {};//单据数据
var __JL_DATA = [];//记录数据
var jl_list = [];//记录全部数据
var delGridRows = []; //存储删除的记录行
var shop_dj = {};//储存商城部分数据
fun.clearItem('ck_list');

//权限
var AUTH_EDIT = Auth.check(Bills['auth'], 'edit');
var AUTH_SH = Auth.check(Bills['auth'], 'check');
var AUTH_ZF = Auth.check(Bills['auth'], 'invalid');

var auth_xsbchyxxg = true;

$('#header').header({
    back: true, //返回
    share: true, //分享
    // print: true, //打印
    del: false, //删除
    title: '销售开单',//'发货结算', //标题
    subtitle: '&nbsp;', //副标题
    order_info: {
        show: true,
        person: '&nbsp;',
        dateText: '&nbsp;'
    },
    appendBackBtnEvt: isDataChange
});

$('#share_btn').hide();

// 页面初始化
page_init = function () {
    // auth_xsbchyxxg = Auth.check('bp_xsbchyxxg', 'view');

    USER_INFO = fun.getItem('user_info') || {}; //用户信息
    SYS_CONFIG = fun.getItem('sys_config') || {};//系统设置
    DH_CONFIG = fun.getItem('dh_config') || {};//单号设置
    zh_list = fun.getItem('zh_list') || [];//账户
    ck_list = fun.getItem('ck_list') || [];//仓库

    wldw_kh_list = fun.getItem('wldw_kh_list') || [];
    wldw_wl_list = fun.getItem('wldw_wl_list') || [];

    getSysList();

    if (AuthVersionCheck.checkHide('ddj')) {
        $('#ddj_wrap').addClass('set-important');
    } else {
        $('#ddj_wrap').removeClass('set-important');
    }

    if (!AuthVersionCheck.checkHide('hy')) {
        $('.hy-hide').removeClass('hy-hide');
    }

    $('.sum2').css('padding-left', $('.common2').width());
    // var tmp_page = api.getPrefs({
    //     key: html_name,
    //     sync: true,
    // });
    //
    // if(tmp_page){
    //     page_data = $.extend({}, JSON.parse(tmp_page));
    //
    //     api.removePrefs({
    //         key: html_name
    //     });
    // }
    // console.log(html_name, page_data);
    // $('body').css('height', api.frameHeight);
    //隐藏键盘
    // fun.keyboardEject('.base2');

    //监听返回键
    page_data.keyback = isDataChange;

    //加载数据
    var load_list = ['ck', 'jjdw', 'wldw_kh', 'wldw_wl', 'sys_config'];

    fun.load_DATA_LIST(['cp'], function () {

    });

    fun.load_DATA_LIST(load_list, function () {
        wldw_kh_list = fun.getItem('wldw_kh_list') || [];
        wldw_wl_list = fun.getItem('wldw_wl_list') || [];
        ck_list = fun.getItem('ck_list') || [];
    });


    $('#header').header({
        back: true, //返回
        share: true, //分享
        print: true, //打印
        del: (Auth.check(Bills['auth'], 'edit', false)), //删除
        title: '销售开单',//'发货结算', //标题
        subtitle: '&nbsp;', //副标题
        order_info: {
            show: true,
            person: '&nbsp;',
            dateText: '&nbsp;'
        },
        appendBackBtnEvt: isDataChange
    });

    $('#print_btn,#share_btn/*,#del_btn*/').hide();

    begin_lCalendar.init({
        'trigger': '#kdsj',
        'type': 'datetime',
        'callback': function (date) {
            // if ($('#kdsj').text().trim() !== fun.formatDate(date)) // 选择不同时间
            $('#kdsj').text(fun.formatDate(date));
            __getAllDj({
                'get_dj': false, 'get_scdj': true, 'get_cpbj': false, callback: function () {
                    updatePageList();
                    // showJlList(formatData(__JL_DATA));
                    // getTotalInfo(__JL_DATA);
                    // setYsje();
                    // setDomDisabled();
                    dataChangeShowSaveBtn();
                }
            });
        }
    });

    init();

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        console.log('----------------------------  -  ---------------------------');
        console.log(JSON.parse(JSON.stringify(ret)));
        var temp = ret['value'];
        switch (temp['status']) {
            // case 'ck_back':
            //     $('.ck').removeClass('curr');
            //     break;
            case 'select_list':
                var tmp_data = temp['data'];
                setSelValue(tmp_data);
                break;
            case 'update_rows':
                __JL_DATA = temp['data']['__JL_DATA'];
                updatePageList();
                // showJlList(formatData(__JL_DATA));
                // getTotalInfo(__JL_DATA);
                // setYsje();
                // setDomDisabled();

                if ($.nui.isTrue(temp['data']['IS_JL_FORM_DKC'])) {
                    __getAllDj({
                        'update_all': false,
                        callback: function () {
                            updatePageList();
                            // showJlList(formatData(__JL_DATA));
                            // getTotalInfo(__JL_DATA);
                            // setYsje();
                            // setDomDisabled();
                        }
                    });
                }
                break;
            case 'update_row':
            case 'delete_row':
                var tmp_data = temp['data'];
                if (temp['status'] == 'update_row') {
                    __updateJlDataByIndex({
                        index: tmp_data['row_index'],
                        data: tmp_data['row_data']
                    });
                } else {
                    // var tmp_dels = __JL_DATA.splice(tmp_data['row_index'], 1);
                    //
                    // if (tmp_dels) {
                    //     tmp_dels[0]['is_delete'] = 1;
                    //     tmp_dels[0]['__status'] = 'del';
                    //     delGridRows.push(tmp_dels[0]);
                    // }

                    var tmpDelData = tmp_data['row_data'];
                    // tmpDelData['is_delete'] = 0;
                    // tmpDelData['__status'] = 'del';
                    __JL_DATA[tmp_data['row_index']] = tmpDelData;
                    // delGridRows.push(tmpDelData);
                }

                updatePageList();
                // showJlList(formatData(__JL_DATA));
                // getTotalInfo(__JL_DATA);
                // setYsje();
                // setDomDisabled();
                break;
            case 'fhjs_dkc':
                var tmp_data = temp['data'];

                __dkc_callback(tmp_data, tmp_data['row_index'], html_name);

                updatePageList();
                // showJlList(formatData(__JL_DATA));
                // getTotalInfo(__JL_DATA);
                // setYsje();
                // setDomDisabled();
                break;
            case 'dykhdd':
                var tmp_data = temp['data'];
                ori_wldw_id = $('#wldw').data('wldw_id');

                __dykhdd_callback(tmp_data, function () {
                    updatePageList({ showJlList: false });
                    // getTotalInfo(__JL_DATA);
                    // setYsje();
                    // setDomDisabled();
                });
                updatePageList({ showJlList: false });
                // getTotalInfo(__JL_DATA);
                // setYsje();
                // setDomDisabled();
                break;
            case 'dydj':
                var tmp_data = temp['data'];

                console.log(JSON.stringify(tmp_data))

                var delDjdymx = [];

                for (var i = 0; i < Bills['djdymx'].length; i++) {
                    if (Bills['djdymx'][i]['is_delete']) {
                        delDjdymx.push(Bills['djdymx'][i]);
                    }
                }

                Bills['djdymx'] = delDjdymx.concat(tmp_data['djdymx']);

                $('#ddj').val(tmp_data['ddj'] || '');
                controlbyDdj();
                setLjqk();
                break;
            case 'update_mxbp':
                saveData({
                    closePage: false,
                    callback: function () {
                        init();
                    }
                });
                // init();
                // var tmp_data = temp['data'];
                // __updateJlDataByIndex({
                //     index: tmp_data['row_index'],
                //     data: tmp_data['row_data']
                // });
                // showJlList(formatData(__JL_DATA));
                // getTotalInfo(__JL_DATA);
                // setYsje();
                // setDomDisabled();
                break;

            case 'dkc_edit_del':
                var tmp_data = temp['data'];
                var tmpData = tmp_data['row_data'];
                tmpData['is_delete'] = 1;
                tmpData['__status'] = 'del';
                delGridRows.push(tmpData);
                break;

            case 'refresh_dj'://保存、审核、作废 不关闭页面，只更新状态
                init();
                // setButtonWidth();
                break;
            case 'update_phsz'://更新开单偏好设置
                updatePageList();
                break;
            case 'update':
                var backUpDateArr = [
                    { // 门店
                        pageType: 'fy',
                        idName: 'fy_id'
                    }
                ];
                fun.upDateBackSelRow({
                    backSelRow: temp['data'],
                    backUpDateArr: backUpDateArr,
                    storageMode: 'data', // 自定义属性存储方式
                    assignMode: 'text' // 赋值方式
                });
                upDateAfter();
                function upDateAfter() {
                    if ($.nui.isEmpty($('#fy').text().trim())) {
                        $('#fy').text('其他');
                        $('#fy').data('fy_id', 0);
                    }
                }
                break;
        }

        checkStatusShowSaveBtn(temp['status']);
    });

    // setButtonWidth();
    //console.log('JSON.stringify')
    //console.log(JSON.stringify(getSaveData()))
};

var xsFhjsKd = {
    isZeroRowSsj: function () { // 记录行实售数是否存在为0的情况
        if ($.nui.isEmpty(SYS_CONFIG[Bills['config']['ssjms']])) return false;
        if ($.nui.isTrue(__JL_DATA)) {
            return __JL_DATA.some(function (item, idx) {
                if($.nui.isTrue(item['is_delete'])) return false;
                return !item.ssdj || item.ssdj === '0';
            });
        }
        return false;
    }
};

// 2020-05-15 新增订金判断
xsFhjsKd.checKddj = function (data) {
    var dj = data['dj'];
    var dyKhdd = data['jl'].some(function (item, idx) {
        return $.nui.isTrue(item.dd_dj_id);
    })
    // 当前单据有调用 客户订单 且 当前单据的 现结 没开启 且 抵订金 = 0，
    return dyKhdd && $.nui.isEmpty(dj['is_xj']) && $.nui.isEmpty(dj['ddj']);
}

// 获取记录行订单类别id
xsFhjsKd.getRowsDjId = function (jlData) {
    var lbId = [];
    $(jlData).each(function (idx, item) {
        $.nui.isTrue(item.dd_dj_id) && lbId.push(item.dd_dj_id);
    })
    return lbId;
}

// 显示检查未调用订金弹窗
xsFhjsKd.showDdjDialog = function (param) {
    fun.dialog({
        className: 'data-change-skin',
        shadeClose: false,
        content: '当前单据调用的客户订单还有：' + param.ddjTotal + '元未抵用，是否需要调用订金进行抵扣货款？',
        btn: ['抵用订金', '取消'],
        yes: function () {
            xsFhjsKd.removeDialoClass();
            $('#ddj').trigger('tap');
        },
        no: function () {
            param.saveData();
        }
    });
}

// 清除上一个弹窗造成下一弹窗无法弹窗
xsFhjsKd.removeDialoClass = function () {
    $('.data-change-skin').removeClass('data-change-skin');
}

// api请求获取未调用抵订金
xsFhjsKd.apiGetDdj = function (params) {
    var _that = this;
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getDjcxtj,
        data: {
            is_dy: 1,
            is_sh: 1,
            type: 'dj_zb',
            is_dy_djlx: 'bp_xsfhjs',
            dj_id_in: xsFhjsKd.getRowsDjId(params.data.jl)
        },
        success: function (res) {
            if (res.status === 0) {
                // var ddjTotal = _that.getDdjTotal(res.info) || 0;
                var ddjTotal = res.info[0]['dj'] || 0;
                if ($.nui.isTrue(ddjTotal)) {
                    xsFhjsKd.showDdjDialog({
                        ddjTotal: ddjTotal,
                        saveData: params.saveData
                    })
                } else {
                    params.saveData();
                };
            } else {
                params.saveData();
                // console.log(res.msg);
            }
        },
        error: function (err) {
            console.log(err);
        }
    })
}

// 获取未调用抵定金合计
xsFhjsKd.getDdjTotal = function (data) {
    return data.reduce(function (total, currentValue, idx, self) {
        return total + Number(currentValue.wdyje || 0);
    }, 0);
}

// 检查未调用抵订金
xsFhjsKd.checkWdyDdj = function (params) {
    if (xsFhjsKd.checKddj(params.data)) {
        xsFhjsKd.apiGetDdj({
            saveData: params.saveData,
            data: params.data
        });
    } else {
        params.saveData();
    }
}

/************************* 方法 *************************/
//解决底部按钮宽度问题
// function setButtonWidth() {
//     $('.right2 .button2:visible').css('width', 'calc(100% / ' + $('.right2 .button2:visible').length + ')');
// }

// 更新 记录行 辅助信息
function __setGrid1RowFzxx() {
    var __fz_cp = Bills['WldwSubInfo']['fz_cp'] || {};
    var __fz_ys = Bills['WldwSubInfo']['fz_ys'] || {};
    for (var i = 0; i < __JL_DATA.length; i++) {
        var row = __JL_DATA[i];
        if ($.nui.isTrue(row['cp_id'])) {
            var fz_info = { fzbh: '', fzmc: '', fzsh: '', fzys: '' };
            if (__fz_cp[row['cp_id']] !== undefined) {
                fz_info['fzbh'] = __fz_cp[row['cp_id']]['assistant_number'];
                fz_info['fzmc'] = __fz_cp[row['cp_id']]['assistant_name'];
            }
            if (__fz_ys[row['cp_ys_id']] !== undefined) {
                fz_info['fzsh'] = __fz_ys[row['cp_ys_id']]['assistant_number'];
                fz_info['fzys'] = __fz_ys[row['cp_ys_id']]['assistant_name'];
            }

            __updateJlDataByIndex({
                index: i,
                data: fz_info
            })
        }
    }
}

// //调库存
// function __dkc_callback(params, r_index) {
//     var data = params['list'];
//     var row = params['row'] || {};
//
//     if ($.nui.isTrue(data[0]) && $.nui.isTrue(data[0]['kcms'])) {
//         if (!$.nui.isTrue(row['kc'])) {
//             row['kcms'] = data[0]['kcms'];
//             row['kc'] = data[0]['kc'];
//         }
//     }
//
//     for (var i = 0; i < data.length; i++) {
//         var is_up = false;
//         var check_arr = ['ck_id', 'cw_id', 'cp_id', 'cp_ys_id', 'fk', 'kz', 'gg', 'gh', 'jh', 'ph', 'ck_zdy1', 'ck_zdy2', 'ck_zdy3',
//             'ck_zdy4', 'ck_zdy5', 'dw_id', 'dw2_id', 'ywy_id', 'bp_kh_id', 'bp_gys_id', 'bp_jgs_id'];
//         if ($.nui.isTrue(data[i]['kcms'])) {
//             check_arr.push('kcms');
//             check_arr.push('kc');
//         }
//
//         if ($.nui.isTrue(row['is_yy_tm'])
//             && __checkDjData({arr: check_arr, old_data: row, new_data: data[i]})
//         ) {
//             is_up = true;
//         }
//         var cpData = {
//             yy_djlx: data[i]['yy_djlx'],
//             ck_id: data[i]['ck_id'],
//             ck_mc: data[i]['ck_mc'],
//             cw_id: data[i]['cw_id'],
//             cw_mc: data[i]['cw_mc'],
//             cp_id: data[i]['cp_id'],
//             cp_bh: data[i]['cp_bh'],
//             cp_mc: data[i]['cp_mc'],
//             cp_ys_id: data[i]['cp_ys_id'],
//             cp_ys_bh: data[i]['cp_ys_bh'],
//             cp_ys_mc: data[i]['cp_ys_mc'],
//             fk: data[i]['fk'],
//             kz: data[i]['kz'],
//             gg: data[i]['gg'],
//             gh: data[i]['gh'],
//             jh: data[i]['jh'],
//             ph: data[i]['ph'],
//             kcms: data[i]['kcms'] || '+',
//             kc: data[i]['kc'],
//             ps: data[i]['ps'],
//             zsl: data[i]['zsl'],
//             zsl2: data[i]['zsl2'],
//             jcs: data[i]['jcs'],
//             dw_id: data[i]['dw_id'],
//             dw_mc: data[i]['dw_mc'],
//             dw2_id: data[i]['dw2_id'],
//             dw2_mc: data[i]['dw2_mc'],
//             jjdw_id: data[i]['jjdw_id'] || data[i]['dw_id'],
//             jjdw_mc: data[i]['jjdw_mc'] || data[i]['dw_mc'],
//             bz: data[i]['jl_bz'],
//
//             ck_zdy1: data[i]['ck_zdy1'],
//             ck_zdy2: data[i]['ck_zdy2'],
//             ck_zdy3: data[i]['ck_zdy3'],
//             ck_zdy4: data[i]['ck_zdy4'],
//             ck_zdy5: data[i]['ck_zdy5'],
//
//             ywy_id: data[i]['ywy_id'],
//             ywy_mc: data[i]['ywy_mc'],
//             bp_kh_id: data[i]['bp_kh_id'],
//             bp_kh_mc: data[i]['bp_kh_mc'],
//             bp_gys_id: data[i]['bp_gys_id'],
//             bp_gys_mc: data[i]['bp_gys_mc'],
//             bp_jgs_id: data[i]['bp_jgs_id'],
//             bp_jgs_mc: data[i]['bp_jgs_mc'],
//             is_yy_tm: data[i]['is_yy_tm'],
//         };
//
//         var tmpData = $.extend(true, {}, row, cpData);
//
//         if ($.nui.isTrue(data[i]['mx'])) {
//             var mx = data[i]['mx'], tmpMx = [];
//             if (is_up) tmpMx = row['mx'];
//
//             for (var j = 0; j < mx.length; j++) {
//                 tmpMx.push($.extend(true, {
//                     dj_id: 0,
//                     jl_id: 0,
//                     id: 0
//                 }, mx[j], {px: parseInt(__getMxLength(tmpMx) / 10) + 1, ph: (__getMxLength(tmpMx) % 10) + 1}));
//             }
//             tmpData['mx'] = tmpMx;
//
//             var zsl = 0;
//             for (var j = 0; j < tmpMx.length; j++) {
//                 if ($.nui.isTrue(tmpMx[j]['is_delete'])) continue;
//                 zsl += tmpMx[j]['sl'];
//             }
//             zsl = zsl.fixed();
//
//             tmpData['zsl'] = zsl;
//         }
//
//         if (typeof dck_callback === "function") dck_callback(tmpData, data[i]);
//
//         delete tmpData['id'];
//         delete tmpData['__status'];
//         delete tmpData['__row_key'];
//         delete tmpData['__index'];
//         delete tmpData['__select'];
//
//         tmpData = updateDataAfterDwhs(tmpData);
//
//         if (typeof updateJLData === "function") updateJLData(tmpData, r_index);
//
//         // if (typeof r_index !== 'undefined') {
//         //     jl_data.splice(r_index, 1, tmpData);
//         // } else {
//         //     jl_data.push(tmpData);
//         // }
//     }
//
//     if (typeof setDomDisable === 'function') setDomDisable();
//
//     __getAllDj({'update_all': false});
// }

//调用客户订单
function __dykhdd_callback(params, callback) {
    if ($.nui.isTrue(params['data']['wldw_id'])) {

        // ori_wldw_id = $('#wldw').data('wldw_id');

        var wldw_id = params['data']['wldw_id'];
        Bills['wldw']['id'] = wldw_id;
        var wldw_info = fun.getListInfoByKey(fun.getItem('wldw_kh_list') || [], wldw_id);
        Bills['wldw'] = wldw_info || { id: wldw_id };
        // if($.nui.isTrue(page_data['__route'])){
        //
        // }else{
        //
        // }

        // var wldw_id = params['data']['wldw_id'];
        // var wldw_info = fun.getListInfoByKey(wldw_kh_list || [], wldw_id);
        //
        // $('#wldw').val(wldw_info['merchant_name']).data('wldw_id', wldw_id).attr('disabled', true);
        //
        // $('#wldw_qqje').val(wldw_info['balance'] || 0);
        // setLjqk();
        // if ($.nui.isTrue(wldw_info['is_cash']) || wldw_info['pay_method'] == '现结') {
        //     $('#xj').addClass('nui-active').removeClass('nui-unactive');
        //     switchActive();
        // } else {
        //     $('#xj').addClass('nui-unactive').removeClass('nui-active');
        //     switchUnActive();
        // }
        // __getAllDj({'get_dj': true, 'get_scdj': true});
        // setLxrInfo(wldw_info);


        // var wldw_id = params['data']['wldw_id'];
        // Bills['wldw']['id'] = wldw_id;
        // var wldw_info = fun.getListInfoByKey(fun.getItem('wldw_kh_list') || [], wldw_id);
        $('#wldw').val(wldw_info['merchant_name']).data('wldw_id', wldw_id).attr('disabled', true);

        __getWldwSubInfo({
            callback: function () {
                if (typeof WldwOnSelected === 'function') WldwOnSelected(wldw_info, {
                    setDj: false,
                    isSetSelected: true
                });
            }
        });
        $(params['data']['list']).each(function (i, item) {
            if (item['is_shop'] === 1) {
                shop_dj = {
                    thfs_id: item['thfs_id'],
                    thfs_mc: item['thfs_mc'],
                    is_shop: item['is_shop'],
                }
                return;
            } else {
                setLxrInfo(wldw_info)
            }

        })
        if (ori_wldw_id != wldw_id) {
            if ($.nui.isTrue(wldw_info['is_cash']) || wldw_info['pay_method'] == '现结') {
                $('#xj').addClass('nui-active').removeClass('nui-unactive');
                switchActive();
            } else {
                $('#xj').addClass('nui-unactive').removeClass('nui-active');
                switchUnActive();
            }
        }
    }

    if ($.nui.isEmpty($('#lxr').val().trim()) && $.nui.isEmpty($('#lxr_dh').val().trim()) && $.nui.isEmpty($('#lxr_dz').val().trim())) {
        if ($.nui.isTrue(params['data']['lxr'])) $('#lxr').val((params['data']['lxr']));
        if ($.nui.isTrue(params['data']['lxr_dh'])) $('#lxr_dh').val(params['data']['lxr_dh']);
        if ($.nui.isTrue(params['data']['lxr_dz'])) $('#lxr_dz').val(params['data']['lxr_dz']);
    }

    if ($.nui.isEmpty($('#hy').data('hy_id')) && $.nui.isTrue(params['data']['hy_id'])) setHy(params['data']);

    __delEmptyRow();

    var data = params['data']['list'];

    //标识当前新增的记录行，批量更新报价需用到
    var __update_dj_key = $.nui.getRandomNum();
    for (var i = 0; i < data.length; i++) {
        var tmpData = {
            '__update_dj_key': __update_dj_key,
            yy_djlx: data[i]['yy_djlx'],
            is_dy: 1,
            ck_id: data[i]['ck_id'],
            ck_mc: data[i]['ck_mc'],
            cw_id: data[i]['cw_id'],
            cp_id: data[i]['cp_id'],
            cp_bh: data[i]['cp_bh'],
            cp_mc: data[i]['cp_mc'],
            cp_ys_id: data[i]['cp_ys_id'],
            cp_ys_bh: data[i]['cp_ys_bh'],
            cp_ys_mc: data[i]['cp_ys_mc'],
            fk: data[i]['fk'],
            kz: data[i]['kz'],
            gg: data[i]['gg'],
            gh: data[i]['gh'],
            jh: data[i]['jh'],
            ph: data[i]['ph'],
            kcms: data[i]['kcms'],
            kc: data[i]['kc'],
            // lx: data[i]['lx'],
            jg_lx: data[i]['jg_lx'],
            jg_lx_mc: data[i]['jg_lx_mc'],
            bqkc: data[i]['bqkc'],
            ps: data[i]['ps'],
            zsl: data[i]['zsl'],
            zsl2: data[i]['zsl2'],
            jjsl: data[i]['jjsl'],
            dw_id: data[i]['dw_id'],
            dw_mc: data[i]['dw_mc'],
            dw2_id: data[i]['dw2_id'],
            dw2_mc: data[i]['dw2_mc'],
            jjdw_id: data[i]['jjdw_id'],
            jjdw_mc: data[i]['jjdw_mc'],
            bz: data[i]['jl_bz'],
            fzbh: data[i]['fzbh'],
            fzmc: data[i]['fzmc'],
            fzsh: data[i]['fzsh'],
            fzys: data[i]['fzys'],

            ck_zdy1: data[i]['ck_zdy1'],
            ck_zdy2: data[i]['ck_zdy2'],
            ck_zdy3: data[i]['ck_zdy3'],
            ck_zdy4: data[i]['ck_zdy4'],
            ck_zdy5: data[i]['ck_zdy5'],

            kd_zdy1: data[i]['kd_zdy1'],
            kd_zdy2: data[i]['kd_zdy2'],
            kd_zdy3: data[i]['kd_zdy3'],
            kd_zdy4: data[i]['kd_zdy4'],
            kd_zdy5: data[i]['kd_zdy5'],

            zydj: data[i]['zydj'],
            dj: data[i]['dj'],
            je: data[i]['je'],
            zh_je: data[i]['zh_je'],
            ydyje: data[i]['ydyje'],
            shuilv: data[i]['shuilv'],
            hsdj: data[i]['hsdj'],
            hsje: data[i]['hsje'],
            shuie: data[i]['shuie'],
            fy_zdy1: data[i]['fy_zdy1'],
            fy_zdy2: data[i]['fy_zdy2'],
            fy_zdy3: data[i]['fy_zdy3'],
            fy_zdy4: data[i]['fy_zdy4'],
            fy_zdy5: data[i]['fy_zdy5'],
            zje: data[i]['zje'],

            dd_dh: data[i]['dd_dh'],
            dd_kdsj: data[i]['dd_kdsj'],
            dd_lb_mc: data[i]['dd_lb_mc'],
            dd_lb_id: data[i]['dd_lb_id'],

            dd_dj_id: data[i]['dd_dj_id'],
            dd_jl_id: data[i]['dd_jl_id'],

            ckd_dh: data[i]['ckd_dh'],
            ckd_kdsj: data[i]['ckd_kdsj'],
            ckd_dj_id: data[i]['ckd_dj_id'],
            ckd_jl_id: data[i]['ckd_jl_id'],

            ywy_id: data[i]['ywy_id'],
            ywy_mc: data[i]['ywy_mc'],
            bp_kh_id: data[i]['bp_kh_id'],
            bp_kh_mc: data[i]['bp_kh_mc'],
            bp_gys_id: data[i]['bp_gys_id'],
            bp_gys_mc: data[i]['bp_gys_mc'],
            bp_jgs_id: data[i]['bp_jgs_id'],
            bp_jgs_mc: data[i]['bp_jgs_mc'],

            sskc: data[i]['kc'],
            sssl: data[i]['jjsl'],
            // 修复分享
            is_shop: data[i]['is_shop'],
            shop_type: data[i]['shop_type'],
            bdyh_je: data[i]['bdyh_je'] || 0,
            share_info: data[i]['share_info']
        };
        if ($.nui.isTrue(data[i]['mx'])) {
            var mx = JSON.parse(data[i]['mx']), tmpMx = [];
            for (var j = 0; j < mx.length; j++) {
                tmpMx.push({
                    px: mx[j]['px'] || 0,
                    ph: mx[j]['ph'] || 0,
                    sl: mx[j]['sl'] || 0,
                    jjsl: mx[j]['jjsl'] || 0,
                    tm: mx[j]['tm'] || 0,
                    tm_sl: mx[j]['tm_sl'] || 0
                });
            }
            tmpData['mx'] = tmpMx;
        }

        if (typeof updateJLData === 'function') updateJLData(tmpData);

    }

    if (typeof setDomDisabled === 'function') setDomDisabled();

    __getAllDj({
        '__update_dj_key': __update_dj_key,
        callback: function () {
            if (typeof params.callback === 'function') params.callback();
            if (typeof callback === 'function') callback();
        }
    });
}

//更新记录数据
function updateJLData(tmpData, index) {
    // function dwshSssl() {
    //     tmpData['sssl'] = fun.toNumber(fun.dwhs({
    //         zsl: tmpData['bqsl'] || 0,
    //         ps: tmpData['ps'] || 0,
    //         fk: tmpData['fk'] || '',
    //         kz: tmpData['kz'] || '',
    //         dw: tmpData['dw_mc'] || '',
    //         jjdw: tmpData['jjdw_mc'] || '',
    //         kc: parseFloat(tmpData['sskc'] || 0),
    //         kcms: tmpData['kcms'] || '+',
    //         mx: []
    //     }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
    // }
    if (typeof index !== 'undefined' && index !== null) {
        // __JL_DATA.splice(index, 1);
        // __JL_DATA.push(tmpData);
        updateRowDataAmountAndMoney(index, tmpData, {
            upDateSssl: true
        });
        __JL_DATA[index] = $.extend({},__JL_DATA[index],tmpData);
    } else {
        updateRowDataAmountAndMoney(index, tmpData, {
            upDateSssl: true
        });
        __JL_DATA.push(tmpData);
    }
    return __JL_DATA;
}

//设置货运信息
function setHy(data) {
    Bills['hy'] = {
        hy_id: data['hy_id'] || 0,
        hy_je: data['hy_je'] || 0,
        hy_zh_id: data['hy_zh_id'] || 0,
        hy_zh_je: data['hy_zh_je'] || 0,
        hy_dh: data['hy_dh'] || '',
        hy_lsh: data['hy_lsh'] || '',
        hy_qqje: data['hy_qqje'] || 0,
        hy_ljqk: data['hy_ljqk'] || 0
    };

    wldw_wl_list = fun.getItem('wldw_wl_list') || [];

    $('#hy').val(fun.getValByKey(wldw_wl_list || [], Bills['hy']['hy_id'], 'merchant_name')).data('hy_id', Bills['hy']['hy_id']);
    $('#yf').val(Bills['hy']['hy_je']);
    $('#hyd').val(Bills['hy']['hy_dh']);
}

//初始化
function init() {
    $('button').hide();
    if ($.nui.isTrue(page_data['id'])) {
        $('#print_btn').show();
        getSimpleRecord();
        getData();
    } else {
        // begin_lCalendar.init({
        //     'trigger': '#kdsj',
        //     'type': 'datetime',
        //     'callback': function (date) {
        //         $('#kdsj').text(fun.formatDate(date));
        //         __getAllDj({
        //             'get_dj': false, 'get_scdj': true, 'get_cpbj': false, callback: function () {
        //                 showJlList(formatData(__JL_DATA));
        //                 getTotalInfo(__JL_DATA);
        //                 setYsje();
        //                 setDomDisabled();
        //             }
        //         });
        //     }
        // });
        // __setDisable(false);
        $('#kdsj').text(fun.formatDate(new Date()));
        $('#zdr').text(USER_INFO['name']).data('zdr_id', USER_INFO['id']);

        $('#del_btn').hide();
        $('#kd_save').show();
        $('.button3').show();

        Bills['origin_data'] = getSaveData();

        if ($.nui.isTrue(page_data['__route'])) {
            getPageDefInfo(function () {
                Bills['origin_data'] = getSaveData();
            });

            $('#wldw').val(page_data['wldw']['merchant_name']).data('wldw_id', page_data['wldw']['id']);
            ori_wldw_id = $('#wldw').data('wldw_id');
            Bills['wldw']['id'] = page_data['wldw']['id'];
            Bills['wldw'] = page_data['wldw'];

            if ($.nui.isTrue(page_data['xsjs_tmp'])) {
                __JL_DATA = page_data['xsjs_tmp']['__JL_DATA'];
                page_data['return_page'] = page_data['LIST_PAGE'] || page_arr.xs_fthjs_tj;

                updatePageList();
                // showJlList(formatData(__JL_DATA));
                // getTotalInfo(__JL_DATA);
                // setYsje();
                // setDomDisabled();
                __getWldwSubInfo({
                    callback: function () {
                        if (typeof WldwOnSelected === 'function') WldwOnSelected(page_data['wldw'], {
                            setDj: false,
                            isSetSelected: true
                        });
                    }
                });

                if ($.nui.isTrue(page_data['xsjs_tmp']['IS_JL_FORM_DKC'])) {
                    __getAllDj({
                        'update_all': false,
                        callback: function () {
                            updatePageList();
                            // showJlList(formatData(__JL_DATA));
                            // getTotalInfo(__JL_DATA);
                            // setYsje();
                            // setDomDisabled();
                        }
                    });
                }

                setLxrInfo(page_data['wldw']);

                if (page_data['wldw']['pay_method'] == '现结') {
                    $('#xj').addClass('nui-active').removeClass('nui-unactive');
                    switchActive();
                } else {
                    $('#xj').addClass('nui-unactive').removeClass('nui-active');
                    switchUnActive();
                }

            }
            if ($.nui.isTrue(page_data['dykhdd_data'])) {
                ori_wldw_id = 0;
                __JL_DATA = page_data['dykhdd_data']['__JL_DATA'];
                jl_list = page_data['dykhdd_data']['data']['list'];
                __dykhdd_callback(page_data['dykhdd_data'], function () {
                    updatePageList({ showJlList: false });
                    // getTotalInfo(__JL_DATA);
                    // setYsje();
                    // setDomDisabled();
                });
                page_data['return_page'] = page_data['LIST_PAGE'] || page_arr.xs_fthjs_tj;
                updatePageList({ showJlList: false });
                // getTotalInfo(__JL_DATA);
                // setYsje();
                // setDomDisabled();
            }
        } else {
            getPageDefInfo(function () {
                Bills['origin_data'] = getSaveData();
            });
        }
    }
}

//新单状态下，页面默认信息获取
function getPageDefInfo(callback) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        async: false,
        url: Bills['AJAX_URL']['getBillsPageDefInfo'],
        data: {
            djlx: 'bp_xsfhjs',
            table: 'bp_xsfhjs_dj'
        },
        success: function (res) {
            if (res['status'] == 0) {
                __PAGE_INFO = res['data'];
                $('.subtitle').text(__PAGE_INFO['dh'] || ' ');
                if (typeof callback === 'function') callback();
            } else {
                return fun.alert({ msg: '获取单号失败！' });
            }
        }
    });
}
//获取档案信息
function getSimpleRecord() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: Bills['AJAX_URL']['getSimpleRecordList'],
        data: { "type": "xs_djlb", "is_stop": 1 },
        success: function (res) {
            console.log(res);
            if (res['status'] == 0) {
                SimpleRecord = res['data'];
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}

//获取数据
function getData() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: Bills['AJAX_URL']['getInfo'],
        data: {
            id: page_data['id'],
            type: 'view'
        },
        success: function (res) {
            if (res['status'] == 0) {
                __PAGE_DATA = res['data'];

                __DJ_DATA = __PAGE_DATA['dj'];
                __JL_DATA = __PAGE_DATA['jl'];

                page_data['dj_is_sh'] = __DJ_DATA['is_sh'];

                Bills['djdymx'] = __PAGE_DATA['djdymx'] || [];
                showData(res['data']);
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    });
}



//显示数据
function showData(data) {
    begin_lCalendar.disabled = false;

    $('input,#kdsj,.list-type,.icon-saoma').removeAttr('disabled');

    var dj = data['dj'];
    var jl = data['jl'];

    // __setDisable(true);
    $('.subtitle').text(dj['dh'] || ' ');
    $('#zdr').text(dj['zdr_mc'] || USER_INFO['name']);
    $('#kdsj').text(fun.formatDate(dj['kdsj']));

    $('#del_btn').show();
    begin_lCalendar.disabled = (!Auth.check(Bills['auth'], 'edit') || dj['is_sh'] || !auth_xsbchyxxg);

    if ((!Auth.check(Bills['auth'], 'edit') || dj['is_sh']) || !auth_xsbchyxxg) {
        $('#kdsj').attr('disabled', true);
    }

    // begin_lCalendar.init({
    //     'trigger': '#kdsj',
    //     'type': 'datetime',
    //     'disabled': (!Auth.check(Bills['auth'], 'edit') || dj['is_sh']),
    //     'callback': function (date) {
    //         $('#kdsj').text(fun.formatDate(date));
    //         __getAllDj({
    //             'get_dj': false, 'get_scdj': true, 'get_cpbj': false, callback: function () {
    //                 showJlList(formatData(__JL_DATA));
    //                 getTotalInfo(__JL_DATA);
    //                 setYsje();
    //                 setDomDisabled();
    //             }
    //         });
    //     }
    // });

    fun.setShareBtnDisplay(dj);

    if (dj['is_zf']) {
        fun.seal({ type: 'zf' });
    } else if (dj['is_sh']) {
        fun.seal({ type: 'sh' });
    } else {
        if ($('body').find('#state_icon').length) $('body').find('#state_icon').remove();
    }

    $('#zdr').data('zdr_id', dj['zdr_id'] || USER_INFO['id']);
    $('#wldw').val(dj['wldw_mc']).data('wldw_id', dj['wldw_id']);

    Bills['wldw'] = fun.getListInfoByKey(fun.getItem('wldw_kh_list') || [], dj['wldw_id']);

    $('#wldw_qqje').val(dj['wldw_qqje']);
    $('#wldw_ljqk').val(dj['wldw_ljqk']);
    $('#fy').text(dj['fy_mc'] || '其他').data('fy_id', dj['fy_id']);
    $('#fy_je').val(dj['fy_je'] || '');

    $('#zh').val(dj['zh_mc']).data('zh_id', dj['zh_id']);
    if ($.nui.isTrue(dj['zh_id'])) {
        var icon = fun.getValByKey(zh_list || [], dj['zh_id'], 'icon');
        icon && $('#zh_icon').attr('src', '../img/bank/' + icon).show();
    } else {
        $('#zh_icon').attr('src', '').hide();
    }
    $('#remark').val(dj['bz']);
    $('#ddj').val(dj['ddj'] || '');
    $('#lxr').val(dj['lxr']);
    $('#lxr_dh').val(dj['lxr_dh']);
    $('#lxr_dz').val(dj['lxr_dz']);
    $('#hy').val(dj['hy_mc']).data('hy_id', dj['hy_id']);
    $('#yf').val(dj['hy_je'] || '');
    $('#hyd').val(dj['hy_dh']);

    controlbyDdj();

    Bills['hy'] = {
        hy_id: dj['hy_id'] || 0,
        hy_je: dj['hy_je'] || 0,
        hy_zh_id: dj['hy_zh_id'] || 0,
        hy_zh_je: dj['hy_zh_je'] || 0,
        hy_dh: dj['hy_dh'] || '',
        hy_lsh: dj['hy_lsh'] || '',
        hy_qqje: dj['hy_qqje'] || 0,
        hy_ljqk: dj['hy_ljqk'] || 0
    };

    if (dj['is_xj']) {
        $('#xj').addClass('nui-active').removeClass('nui-unactive');
        switchActive();
    } else {
        $('#xj').addClass('nui-unactive').removeClass('nui-active');
        setSwitchColor($('#xj'), false);
    }
    $('#ysje').val(dj['ysje']);
    $('#zhje').val(dj['zh_je'] || '');

    if (__PAGE_DATA['dj']['is_sh'] || !auth_xsbchyxxg) {
        $('#kdsj').attr('disabled', true);
        // $('#ddj').attr('disabled',true);
    }

    showJlList(formatData(jl || []));

    $('#zps').text(dj['zps'] || 0);
    $('#zjjsl').text(dj['zjjsl'] || 0);
    $('#hszje').text(dj['hszje'] || 0);

    // if (dj['ddj'] > 0) {
    //     $('#xj').hide();
    // } else {
    //     $('#xj').css('display','inline-block');
    // }


    // 单据已审核时 隐藏保存按钮和添加按钮
    if (dj['is_sh']) {
        $('#kd_save,#kd_audit,.button3,#del_btn,.add-product').hide();
        if (Auth.check(Bills['auth'], 'invalid', false)) {
            if ($.nui.isTrue(SYS_CONFIG['fsh'])) {
                $('#kd_cancel_audit').show();
            } else {
                $('#kd_invalid').show();
            }
        }
        $('.off-tap').off('tap');
    } else {
        if (Auth.check(Bills['auth'], 'check', false)) {
            $('.button3').hide();
            $('#kd_audit').show();
        } else if (Auth.check(Bills['auth'], 'edit', false)) $('#kd_save').show();
    }

    if (typeof setDomDisabled === 'function') setDomDisabled();

    setPageDomDisable(data);

    // 没有当前页面的 修改权限 或 当前单据已审核，则当前单据全部内容都不允许编辑。//2020-06-22;增加有无权限(销售保存后不允许修改)的情况
    if (!AUTH_EDIT || dj['is_sh'] || !auth_xsbchyxxg) {
        $('input:not("#ddj"),#xj,.list-type,.icon-saoma,#kdsj').attr('disabled', true);
        $('.button3,.icon-saoma,.add-product').hide();
        if(AUTH_EDIT && !dj['is_sh'] && !auth_xsbchyxxg){//有修改权，单据未审核，有开启销售保存后不允许修改；部分可修改
            $('#remark,#ddj,#lxr,#lxr_dh,#lxr_dz,#hy,#yf,#hyd').removeAttr('disabled');
            $('#kd_save').css({
                'width': '100%',
                'border-radius': '2rem'
            })
            inputBindEvent();
        }
    } else {
        $('.button3,.add-product').css('display', 'inline-block');
        $('.icon-saoma').show();
        inputBindEvent();
    }

    /* 
        一次性全拿
            分页
            3 > 3
            
    */

    if (dj['is_zf']) {
        $('button').hide();
    }

    if (!AUTH_SH) {
        $('#kd_audit,#kd_cancel_audit').hide();
    }

    if (!AUTH_ZF) {
        $('#kd_invalid').hide();
    }

    if (!AUTH_EDIT) {
        $('.right2').hide();
    }

    // fun.getItem('sys_config'); //fhjsbchbyxxg

    // if (SYS_CONFIG['fhjsshhdy'] == 1 && (dj['is_sh'] == 1 || dj['is_zf'] == 1)) {
    //     $('#print_btn').show();
    // } else {
    //     $('#print_btn').hide();
    // }

    if ($.nui.isTrue(SYS_CONFIG['fhjsshhdy'])) {
        if (dj['is_sh'] || dj['is_zf']) {
            $('#print_btn').show();
        } else {
            $('#print_btn').hide();
        }
    } else {
        $('#print_btn').show();
    }

    if (!auth_xsbchyxxg) {
        $('#kd_save,#kd_audit,.button3,#del_btn,.add-product,#kd_cancel_audit,#kd_invalid').hide();
        if (dj['is_sh']) {
            if (Auth.check(Bills['auth'], 'invalid', false)) {
                if ($.nui.isTrue(SYS_CONFIG['fsh'])) {
                    $('#kd_cancel_audit').show();
                } else { 
                    $('#kd_invalid').show();
                }
            }
            $('.off-tap').off('tap');
        } else {
            if (Auth.check(Bills['auth'], 'check', false)) {
                $('.button3').hide();
                $('#kd_audit').show();
                $('#kd_audit').css({
                    'border-radius': '2rem',
                    'width': '100%'
                })
                $('#del_btn').show();
            }
        }
    }

    // setButtonWidth();

    
    Bills['origin_data'] = getSaveData();
}

// 删除 没商品编号、匹数=0、数量=0 的记录行
// keys: 当数组里的某个key值为真, 则行不删除
function __delEmptyRow(options) {
    var _opt = $.extend(true, { 'keys': Bills['del_row_exclude_col'] }, options);
    var rows = __JL_DATA.slice();
    for (var i = rows.length - 1; i >= 0; i--) {
        if ($.nui.isEmpty(rows[i]['cp_id']) || ($.nui.isEmpty(rows[i]['ps']) && $.nui.isEmpty(rows[i]['zsl']))) {
            var isDel = true;

            if (fun.getHouseValue(rows[i]['ck_id'], 'is_detail')) {

            } else {
                for (var j = 0; j < _opt['keys'].length; j++) {
                    var key = _opt['keys'][j];
                    if ($.nui.isTrue(rows[i][key])) {
                        isDel = false;
                        break;
                    }
                }
            }

            if (isDel) {
                var __t_data = __JL_DATA.splice(i, 1);

                if (__t_data) {
                    __t_data[0]['is_delete'] = 1;
                    __t_data[0]['__status'] = 'del';
                    delGridRows.push(__t_data[0]);
                }
            }
        }
    }
    updatePageList();
    // showJlList(formatData(__JL_DATA));
    // getTotalInfo(__JL_DATA);
    // setYsje();
    // setDomDisabled();
}

// 格式化数据
function formatData(data) {
    if ($.nui.isEmpty(data)) {
        return [];
    }
    var list = [],
        tmp = {};
    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        val['__del_index'] = i;
        if ($.nui.isEmpty(val['__key'])) {
            val['__key'] = $.nui.getRandomNum();
        }
        if ($.nui.isEmpty(val['__row_uuid'])) {
            val['__row_uuid'] = $.nui.getRandomNum();
        }
        if ($.nui.isTrue(val['is_delete'])) continue;
        if (!tmp[val['ck_id']]) {
            tmp[val['ck_id']] = {
                ck_id: val['ck_id'],
                ck_mc: val['ck_mc'],
                list: []
            }
        }
        tmp[val['ck_id']]['list'].push(val);
    }
    for (var i in tmp) {
        list.push(tmp[i]);
    }

    return list;
}

// 显示单据-记录列表
function showJlList(data) {
    var html = [];

    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        var delClass = (!Auth.check(Bills['auth'], 'edit', false) || __PAGE_DATA['dj']['is_sh']) ? '' : 'swipe-delete';
        if (!auth_xsbchyxxg) {
            delClass = '';
        }

        html.push('<div class="storehouse ' + delClass + '">');
        html.push('     <a class="store-title ck off-tap" data-ck_id="' + (val['ck_id']) + '">' + (val['ck_mc']) + '</a>');
        html.push('     <ul>');
        for (var j = 0; j < val['list'].length; j++) {
            var item = val['list'][j];
            // var rtImg = '';

            var jjslColor = (item['jjsl'] == item['zsl']) ? '#000' : '#17b3ec';

            // switch (item['lx']) {
            //     case '剪样':
            //         rtImg = '<img src="../img/shearing.png" class="xiejiao">';
            //         break;
            //     case '样版':
            //         rtImg = '<img src="../img/sample_version.png" class="xiejiao">';
            //         break;
            //     case '色卡':
            //         rtImg = '<img src="../img/color_card.png" class="xiejiao">';
            //         break;
            // }

            var rtImg = fun.getJgLxImg(item);

            var sshk = item['sshk'] in item ? item['sshk'] : $.nui.decimalSub(item['hszje'] || 0, item['sszje'] || 0);

            html.push('         <li data-list_data=\'' + fun.formatString(JSON.stringify(item)) + '\' class="store-info fixed jl-item">');
            html.push('             <div class="le">');
            html.push(rtImg);
            (item['dd_dj_id'] || item['ckd_dj_id']) && html.push('                 <div class="box"></div>');
            html.push('                 <p class="store-name">' + (item['cp_bh'] || '') + (item['cp_mc'] || '') + ' <i>' + (item['cp_ys_bh'] || '') + (item['cp_ys_mc'] || '') + '</i> </p>');
            html.push('                 <span>匹数<i class="info-date">' + (item['ps'] || 0) + '</i></span>');
            html.push('                 <span>数量<i class="info-date">' + (item['zsl'] || 0) + '<i>' + (item['dw_mc'] || '') + '</i></i></span>');
            html.push('                 <span>计价<i class="info-date text" style="color:' + jjslColor + '">' + (item['jjsl'] || 0) + '<i class="unit">' + (item['jjdw_mc'] || '') + '</i></i></span>');
            html.push('                 <span>单价<i class="info-date unitprice">' + (item['hsdj'] || 0) + '</i></span>');
            html.push('                 <span class="price"><i>￥</i>' + (item['hszje'] || 0) + '</span>');
            html.push('                 <span><i class="info-date"></i></span>');

            if ($.nui.isTrue(SYS_CONFIG['qyssjms_bp'])) {
                html.push('         <div>');
                html.push('                 <span>实售价<i class="info-date kddj-color">' + (item['ssdj'] || 0) + '</i></span>');
                html.push('                 <span>实售数<i class="info-date kdsl-color">' + (item['sssl'] || 0) + '</i></span>');
                html.push('                 <span>实售额<i class="info-date kdje-color">' + (item['sszje'] || 0) + '</i></span>');
                html.push('         </div>');
                html.push('         <div>');
                html.push('                 <span>回扣<i class="info-date kdje-color">' + (sshk || 0) + '</i></span>');
                html.push('         </div>');

                // html.push('<div class="ssjms-wrap font-ls">');
                // html.push('    <div class="ssms-money">');
                // html.push('        <div class="ssms-box">');
                // html.push('            <span class="ssms-title">实售价</span>');
                // html.push('            <i class="info-date kddj-color">' + (item['ssdj'] || 0) + '</i>');
                // html.push('        </div>');
                // html.push('        <div class="ssms-box">');
                // html.push('            <span class="ssms-title">实售数</span>');
                // html.push('            <i class="info-date kdsl-color">' + item['sssl'] || 0 + '</i>');
                // html.push('        </div>');
                // html.push('        <div class="ssms-box">');
                // html.push('            <span class="ssms-title">实售额</span>');
                // html.push('            <i class="info-date kdje-color">' + item['sszje'] || 0 + '</i>');
                // html.push('        </div>');
                // html.push('    </div>');
                // html.push('    <div class="ssms-box">');
                // html.push('        <span class="ssms-title">回扣</span>');
                // html.push('        <i class="info-date kdje-color">' + (sshk || 0) + '</i>');
                // html.push('    </div>');
                // html.push('</div>');

                // html.push('                 </div>');
            }

            if (fun.getKdSetting('fk')) {
                html.push('                 <span>幅宽<i class="info-date">' + (item['fk'] || '') + '</i></span>');
            }
            if (fun.getKdSetting('kz')) {
                html.push('                 <span>克重<i class="info-date">' + (item['kz'] || '') + '</i></span>');
            }
            if (fun.getKdSetting('gg')) {
                html.push('                 <span>规格<i class="info-date">' + (item['gg'] || '') + '</i></span>');
            }
            if (fun.getKdSetting('gh')) {
                html.push('                 <span>缸号<i class="info-date">' + (item['gh'] || ' ') + '</i></span>');
            }
            var zdy_arr = fun.getZdyfyArr('bpxszdyfy', item);
            if (zdy_arr.length != 0) {
                html.push('                 <div class="manyExpenses">')
                html.push('                     <div>')
                html.push('                         <p class="manyExpenses-p">费用</p>')
                for (var k = 0; k < zdy_arr.length; k += 2) {
                    html.push('                     <span class="manyExpenses-span">' + zdy_arr[k] + ' ' + zdy_arr[k + 1] + '元</span>');
                }
                html.push('                     </div>')
                html.push('                 </div>')
            }

            html.push('                 <div class="delete dels1 delete-btn" data-del_index="' + (item['__del_index']) + '"><b class="swipe-span">删除</b></div>');
            html.push('             </div>');
            html.push('         </li>');
        }
        html.push('     </ul>');
        html.push('</div>');
    }
    if ($.nui.isTrue(SYS_CONFIG['qyssjms_bp']) && data.length) {
        html.push('         <div class="show-zhk">总回扣：' + calcZhk() + '元</div>');
    }

    // html.push('         <div class="add-product"><i class="iconfont icon-tianjia"></i>&nbsp;添加产品</div>');
    $('#jl').html(html.join(''));

    setDomDisabled();
}
// 计算总回扣
function calcZhk() {
    var zhk = 0;
    for (var i = 0; i < __JL_DATA.length; i++) {
        var item = __JL_DATA[i];
        if (item['is_delete']) continue;
        if ('sshk' in item) { // 有回扣字段直接拿，没有需要计算
            zhk = $.nui.decimalAdd((item['sshk'] || 0), zhk);
        } else {
            var tmp_zhk = $.nui.decimalSub((item['hszje'] || 0), (item['sszje'] || 0));
            zhk = $.nui.decimalAdd(tmp_zhk, zhk);
        }
    }
    return zhk;
}

//设置搜索页选中值
function setSelValue(data) {
    switch (data['page_type']) {
        case 'kh':
            if ($('#wldw').data('wldw_id') == data['id']) return;
            Bills['wldw']['id'] = data['id'];
            Bills['wldw'] = data['list_data'];
            $('#wldw').val(data['select_val']).data('wldw_id', data['id']);

            __getWldwSubInfo({
                callback: function () {
                    if (typeof WldwOnSelected === 'function') WldwOnSelected(data['list_data']);
                }
            });

            setLxrInfo(data['list_data']);
            if ($.nui.isTrue(data['list_data']['is_cash']) || data['list_data']['pay_method'] == '现结') {
                $('#xj').addClass('nui-active').removeClass('nui-unactive');
                switchActive();
            } else {
                $('#xj').addClass('nui-unactive').removeClass('nui-active');
                switchUnActive();
            }

            // afterSetKhVal(data['list_data']);
            // setLxrInfo(data['list_data']);
            break;
        case 'zh':
            $('#zh').val(data['select_val']).data('zh_id', data['id']);
            data['list_data']['icon'] && $('#zh_icon').attr('src', '../img/bank/' + data['list_data']['icon']).show();
            break;
        case 'ck':
            var ori_ck_id = $('.ck.curr').data('ck_id') || 0;
            var ck_id = data['id'];
            var ck_mc = data['select_val'];

            if (ori_ck_id == ck_id) return;

            if (hasRightData()) {
                var house_list = fun.getItem('ck_list') || [];
                var oldCkInfo = fun.getListInfoByKey(house_list, ori_ck_id);
                var newCkInfo = fun.getListInfoByKey(house_list, ck_id);
                // var ori_type;
                // if (fun.getHouseValue(ori_ck_id, 'is_bar')) ori_type = 'tm';
                // else if (fun.getHouseValue(ori_ck_id, 'is_detail')) ori_type = 'mx';
                // else ori_type = 'zs';
                //
                // var curr_type;
                // if (fun.getHouseValue(ck_id, 'is_bar')) curr_type = 'tm';
                // else if (fun.getHouseValue(ck_id, 'is_detail')) curr_type = 'mx';
                // else curr_type = 'zs';
                //
                // if (ori_type === 'zs' && curr_type === 'mx') {
                //     return fun.toast('不允许更换为明细管理仓库！');
                // } else if (ori_type !== 'tm' && curr_type === 'tm') {
                //     return fun.toast('条码管理仓库不允许手动添加记录！');
                // } else if (ori_type !== 'zs' && curr_type === 'zs') {
                //     return fun.toast('不允许更换为非明细管理仓库！');
                // }

                if (!fun.selectCkCheck(oldCkInfo, newCkInfo)) return;
            }

            for (var i = 0; i < __JL_DATA.length; i++) {
                // if (__JL_DATA[i]['ck_id'] == ori_ck_id && $.nui.isEmpty(__JL_DATA[i]['ckd_dj_id'])) {
                //     __JL_DATA[i]['ck_id'] = ck_id;
                //     __JL_DATA[i]['ck_mc'] = ck_mc;
                //     __JL_DATA[i]['cw_id'] = 0;
                //     __JL_DATA[i]['cw_mc'] = '';
                //     __JL_DATA[i]['ph'] = '';
                //     __JL_DATA[i]['bp_kh_id'] = 0;
                //     __JL_DATA[i]['bp_kh_mc'] = '';
                //     __JL_DATA[i]['bp_gys_id'] = 0;
                //     __JL_DATA[i]['bp_gys_mc'] = '';
                //     __JL_DATA[i]['bp_jgs_id'] = 0;
                //     __JL_DATA[i]['bp_jgs_mc'] = '';
                //     __JL_DATA[i]['bp_ywy_id'] = 0;
                //     __JL_DATA[i]['bp_ywy_mc'] = '';

                //     // 只能调用库存开单
                // }

                if (__JL_DATA[i]['ck_id'] != ori_ck_id) continue;

                var _tmps_data = {
                    ck_id: ck_id, ck_mc: ck_mc,
                    cw_id: 0, cw_mc: '',
                    ph: '',
                    bp_kh_id: 0, bp_kh_mc: '',
                    bp_gys_id: 0, bp_gys_mc: '',
                    bp_jgs_id: 0, bp_jgs_mc: '',
                    bp_ywy_id: 0, bp_ywy_mc: ''
                };

                // // 如果仓库不是色卡类型且记录行产品颜色=色卡 则清空
                // if (fun.getValByKey(ck_list, ck_id,'type') !='skyb' && __JL_DATA[i]['cp_ys_bh'] === '色卡') {
                //     _tmps_data['cp_id'] = __JL_DATA[i]['cp_id'];
                //     _tmps_data['cp_ys_id'] = 0;
                //     _tmps_data['cp_ys_bh'] = '';
                //     _tmps_data['cp_ys_mc'] = '';
                //     _tmps_data['dw_id'] = 0;
                //     _tmps_data['dw_mc'] = '';
                //     _tmps_data['jjdw_id'] = 0;
                //     _tmps_data['jjdw_mc'] = '';
                //     _tmps_data['jg_lx'] = '';
                //     _tmps_data['jg_lx_mc'] = '';

                //     __resetUnit(_tmps_data);
                // }

                if ($.nui.isEmpty(__JL_DATA[i]['ckd_dj_id'])) {
                    __JL_DATA[i] = $.extend({}, __JL_DATA[i], _tmps_data);
                }
            }
            showJlList(formatData(__JL_DATA));
            break;
        case 'wl':
            $('#hy').val(data['select_val']).data('hy_id', data['id']);
            break;
        case 'fy':
            $('#fy').text(data['select_val']).data('fy_id', data['id']);
            break;
        case 'xz_lxr':
            $('#lxr').val(data['select_val'] || '');
            $('#lxr_dh').val(data['list_data']['mobile'] || data['list_data']['phone'] || '');
            var lxr_dz = (data['list_data']['province'] || '') + (data['list_data']['city'] || '') + (data['list_data']['area'] || '') + (data['list_data']['address'] || '');
            $.nui.isTrue(lxr_dz) && $('#lxr_dz').val(lxr_dz);
            break;
    }

    showSaveBtn();
}

// 选择 客商 后触发的事件
function WldwOnSelected(data, options) {
    var _options = $.extend({}, { setDj: true }, options);
    var _params = $.extend(true, { ljqk: true, dj: true, lxr: true, isSetSelected: false });
    if (_params['isSetSelected']) return false;
    // 更新 记录行 辅助信息
    __setGrid1RowFzxx();
    // 获取 单价、上次价
    _options['setDj'] && __getAllDj({
        'get_dj': true,
        'get_scdj': true,
        callback: function () {
            updatePageList();
            // showJlList(formatData(__JL_DATA));
            // getTotalInfo(__JL_DATA);
            // setYsje();
            // setDomDisabled();
        }
    });

    // 设置 前欠金额
    $('#wldw_qqje').val(parseFloat(Bills['WldwSubInfo']['ljqk'] || 0).fixed());
    if (typeof setLjqk === 'function') setLjqk();

    // 手动选择客户, 抵订金 信息 要清空
    if ($.nui.isTrue(page_data['id'])) {
        for (var i = 0; i < Bills['djdymx'].length; i++) {
            Bills['djdymx'][i]['is_delete'] = 1;
        }
    } else {
        Bills['djdymx'] = [];
    }

    $('#ddj').val('');
}

// 选完客户后联系人等信息赋值
function setLxrInfo(data) {
    $('#lxr').val(data['contact_name'] || '');
    $('#lxr_dh').val(data['mobile'] || data['phone'] || '');
    $('#lxr_dz').val((data['province'] || '') + (data['city'] || '') + (data['area'] || '') + (data['address'] || ''));
}

// 现结开关打开
function switchActive() {
    $('#zhje').attr('disabled', true);
    $('#zhje').val($('#ysje').val().trim() || '');

    $('#ddj').attr('disabled', true);

    if ($.nui.isEmpty($('#zh').data('zh_id'))) {
        for (var i = 0; i < (fun.getItem('zh_list') || []).length; i++) {
            var data = fun.getItem('zh_list')[i];
            if ((data['is_cash'] == 1) && (data['store_id'] == USER_INFO['store_id'])) {
                $('#zh').val(data['name']).data('zh_id', data['id']);
                data['icon'] && $('#zh_icon').attr('src', '../img/bank/' + data['icon']).show();
                break;
            }
        }
    }
    setYsje();

    setSwitchColor($('#xj'), true);
}

// 现结开关关掉
function switchUnActive() {
    $('#zhje').removeAttr('disabled');
    $('#ddj').removeAttr('disabled');

    $('#zhje').val('');
    $('#zh').val('').data('zh_id', 0);
    $('#zh_icon').attr('src', '').hide();

    controlbyDdj();

    setYsje();

    setSwitchColor($('#xj'), false);
}


// 获取合计信息
function getTotalInfo(data, setText) {
    var _data = !$.nui.isEmpty(data) ? data : [];
    var tmp_total = {
        zps: 0,
        zsl: 0,
        zjjsl: 0,
        bdje: 0,
        hszje: 0,
        hsje: 0,
        zje: 0
    };

    for (var i = 0; i < _data.length; i++) {
        var val = _data[i];
        if ($.nui.isTrue(val['is_delete'])) continue;

        tmp_total['zps'] = $.nui.decimalAdd(tmp_total['zps'], parseInt(val['ps'] || 0));
        tmp_total['zsl'] = $.nui.decimalAdd(tmp_total['zsl'], parseFloat(val['zsl'] || 0));
        tmp_total['zjjsl'] = $.nui.decimalAdd(tmp_total['zjjsl'], parseFloat(val['jjsl'] || 0));
        tmp_total['bdje'] = $.nui.decimalAdd(tmp_total['bdje'], parseFloat(val['hszje'] || 0));
        tmp_total['hszje'] = $.nui.decimalAdd(tmp_total['hszje'], parseFloat(val['hszje'] || 0));
        tmp_total['hsje'] = $.nui.decimalAdd(tmp_total['hsje'], parseFloat(val['hsje'] || 0));
        tmp_total['zje'] = $.nui.decimalAdd(tmp_total['zje'], parseFloat(val['zje'] || 0));
    }


    tmp_total['bdje'] = __bdjeSswr(tmp_total['bdje']);
    tmp_total['hszje'] = __bdjeSswr(tmp_total['hszje']);
    tmp_total['zje'] = __bdjeSswr(tmp_total['zje']);

    if (!setText) {
        $('#zps').text(tmp_total['zps'] || 0);
        $('#zjjsl').text(tmp_total['zjjsl'] || 0);
        $('#jjdw').text($.nui.isFieldValEqual('jjdw_mc', _data)['val']);
        $('#hszje').text(tmp_total['hszje'] || 0);
    }

    return tmp_total;
}

// 设置应收金额
function setYsje() {
    var hszje = 0;
    for (var i = 0; i < __JL_DATA.length; i++) {
        if($.nui.isTrue(__JL_DATA[i]['is_delete'])) continue;
        hszje = $.nui.decimalAdd(hszje, parseFloat(__JL_DATA[i]['hszje'] || 0));
    }
    var tmpFyje = $('#fy_je').val().trim();
    tmpFyje = isNaN(tmpFyje) ? 0 : tmpFyje;
    var fyje = parseFloat(tmpFyje || 0);
    var bdje = __bdjeSswr(parseFloat(hszje)); //本单金额
    var ysje = (bdje + fyje).fixed();
    $('#xj').hasClass('nui-active') && $('#zhje').val(ysje);
    $('#ysje').val(ysje);
    setLjqk();
}

// 设置累计欠款
function setLjqk() {
    var tmpQqje = $('#wldw_qqje').val().trim();
    tmpQqje = isNaN(tmpQqje) ? 0 : tmpQqje;
    var tmpZhje = $('#zhje').val().trim();
    tmpZhje = isNaN(tmpZhje) ? 0 : tmpZhje;
    var qqje = parseFloat(tmpQqje || 0),
        ysje = parseFloat($('#ysje').val().trim() || 0),
        zhje = parseFloat(tmpZhje || 0),
        ddj = parseFloat($('#ddj').val().trim() || 0);
    var ljqk = (Bills['wldw']['type'] === 'kh') ? (qqje + ysje - zhje - ddj) : ((qqje - ysje + zhje + ddj));
    $('#wldw_ljqk').val(ljqk.fixed());
}


//获取保存的数据
function getSaveData() {
    var dj = {},
        jl = [];

    var tmp_dj = __PAGE_DATA['dj'];
    if (shop_dj['is_shop'] === 1) {
        var djlb_id = fun.getItem('sys_config')['shop_xsfh_djlb_id']
        var thfs_id = shop_dj['thfs_id']
        var thfs = shop_dj['thfs_mc']
    } else {
        var djlb_id = tmp_dj['djlb_id']
        var thfs_id = tmp_dj['thfs_id']
        var thfs = tmp_dj['thfs']
    }
    // 单据信息
    dj = {
        "id": !$.nui.isEmpty(page_data['id']) ? page_data['id'] : 0,
        "save_time": tmp_dj['save_time'] || '',
        "is_xj": ($('#xj').length && $('#xj').hasClass('nui-active')) ? 1 : 0,
        "jsr_id": tmp_dj['jsr_id'] || 0,
        "wldw_id": $('#wldw').data('wldw_id') || 0,
        "zdr_id": $('#zdr').data('zdr_id') || 0,
        md_id: USER_INFO['store_id'], //制单人门店id
        // "md_id": tmp_dj['md_id'] || 0,
        "ywy_id": tmp_dj['ywy_id'] || 0,
        "kdsj": $('#kdsj').text().trim(),
        "dj_lsh": tmp_dj['dj_lsh'] || '',
        "dh": $('.subtitle').text().trim() || '',
        "ck_id": tmp_dj['ck_id'] || 0,
        "fp_id": tmp_dj['fp_id'] || 0,
        "djlb_id": djlb_id || 0,
        "thfs_id": thfs_id || 0,
        "thfs": thfs || '',
        "fy_id": $('#fy').data('fy_id') || 0,
        "fy_je": isNaN($('#fy_je').val().trim()) ? 0 : parseFloat($('#fy_je').val().trim() || 0),
        //         "hszje": $('#hszje').text().trim(), //记录含税金额合计
        //         "bdje": 0, //记录总金额合计
        "ysje": parseFloat($('#ysje').val().trim() || 0),
        "zh_id": $('#zh').data('zh_id') || 0,
        "zh_je": parseFloat($('#zhje').val().trim() || 0),
        "hy_id": $('#hy').data('hy_id') || 0,
        "hy_je": parseFloat($('#yf').val().trim() || 0),
        "hy_zh_id": tmp_dj['hy_zh_id'] || 0,
        "hy_zh_je": tmp_dj['hy_zh_je'] || 0,
        "hy_dh": $('#hyd').val().trim(),
        //         "zps": parseInt($('#zps').text().trim() || 0), //记录匹数合计
        //         "zsl": 0, //记录数量合计
        //         "zjjsl": parseFloat($('#zjjsl').text().trim() || 0), //记录计价数量合计
        "lxr": $('#lxr').val().trim() || '',
        "lxr_dh": $('#lxr_dh').val().trim() || '',
        "lxr_dz": $('#lxr_dz').val().trim() || '',
        "ddj": parseFloat($('#ddj').val().trim() || 0),
        "bz": $('#remark').val().trim()
    };

    var recordData = __JL_DATA.concat(delGridRows);

    if ($.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']]) && $.nui.isEmpty(dj['ck_id'])) {
        dj['ck_id'] = $.nui.isFieldValEqual('ck_id', __JL_DATA)['val'] || 0;
    } else {
        dj['ck_id'] = $.nui.isEmpty(__JL_DATA) ? 0 : __JL_DATA[0]['ck_id'];
    }

    var tmp_total = getTotalInfo(__JL_DATA);

    dj['zps'] = tmp_total['zps'];
    dj['zsl'] = tmp_total['zsl'];
    dj['zjjsl'] = tmp_total['zjjsl'];
    dj['bdje'] = tmp_total['bdje'];
    dj['hszje'] = tmp_total['hszje'];
    dj['zje'] = tmp_total['zje'];

    var px = 0;
    var is_shop = 0, shop_type = '';

    for (var i = 0; i < recordData.length; i++) {
        var val = $.extend(true, { mx: [] }, recordData[i]);
        if ((val['__status'] === 'del' || $.nui.isTrue(val['is_delete'])) && $.nui.isEmpty(val['id'])) continue;

        var tmpData = $.extend({}, val, { is_delete: (val['__status'] === 'del') ? 1 : 0, mx: [] });
        if ($.nui.isEmpty(tmpData['is_delete'])) {
            px += 1;
            tmpData['px'] = px;
        }

        // 未开启【系统设置-多仓库模式】时 ,把单据表的仓库赋值到记录表,反之认记录表的仓库
        // tmpData['ck_id'] = ($.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']])) ? (dj['ck_id'] ? val['ck_id'] : 0) : (val['ck_id'] || 0);

        // 没商品编号、匹数=0、数量=0  的记录行 跳过
        // if ($.nui.isEmpty(tmpData['cp_id']) || ($.nui.isEmpty(tmpData['ps']) && $.nui.isEmpty(tmpData['zsl']))) continue;

        for (var j = 0; (val['mx']) && (j < val['mx'].length); j++) {
            // 如果记录行删除的情况,则明细表也是得以删除的情况处理
            if ($.nui.isTrue(tmpData['is_delete'])) val['mx'][j]['is_delete'] = 1;
            // 当数量为0, 并且无id字段信息，则代表为新添加并且手动删除的信息，跳过不处理
            if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isTrue(val['mx'][j]['is_delete'])) continue;
            if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isEmpty(val['mx'][j]['sl'])) continue;
            tmpData['mx'].push(val['mx'][j]);
        }
        jl.push(tmpData);
    }

    for (var i = 0; i < jl.length; i++) {
        jl[i]['__index'] = i;
    }

    $(jl_list).each(function (i, item) {
        if ($.nui.isTrue(item['is_shop']) || $.nui.isTrue(item['shop_type']) === 'shop') {
            is_shop = 1 || 0;
            shop_type = item['shop_type'] || '';
            return;
        }
    })
    dj['is_shop'] = is_shop;
    dj['shop_type'] = shop_type;

    var data = {
        "dj": dj,
        "jl": jl,
        "djdymx": Bills['djdymx'],
    };

    __DJ_DATA = $.extend({}, __DJ_DATA, data['dj']);
    xsFhjsKd.getJpdAndScp(data.jl);
    return data;
}

//保存数据
function saveData(options) {

    var _options = $.extend({ closePage: true, callback: null }, options);
    var dj = {}, jl = [];
    __delEmptyRow();

    var data = getSaveData();

    dj = data['dj'];
    var recordData = data['jl'];

    if ($.nui.isEmpty(dj['kdsj'])) return fun.toast('日期不能为空。');

    if (!Check.kzrq({ sj: dj['kdsj'] })) return false;
    if (!Check.yjrq({ sj: dj['kdsj'] })) return false;


    if ($.nui.isTrue($('#yf').val()) || $.nui.isTrue($('#hyd').val())) {
        if (!$('#hy').val()) {
            return fun.toast('货运不能为空。')
        }
    }
    if ($.nui.isEmpty(dj['dh'])) return fun.toast('单号不能为空。');//$.nui.isTrue(DH_CONFIG[Bills['djlx']])&&$.nui.isTrue(DH_CONFIG[Bills['djlx']]['is_diy']) &&
    if ($.nui.isEmpty(dj['wldw_id'])) return fun.toast('客户不能为空。');
    if (dj['zh_je'] && !dj['zh_id']) return fun.toast('请选择账户。');
    if (dj['fy_je'] && !dj['fy_id']) return fun.toast('请选择费用。');
    // if ($.nui.isEmpty(dj['hy_id']) && dj['is_shop'] === 1 && dj['thfs'] == '邮寄') return fun.toast('请选择货运。');
    // if ($.nui.isEmpty(dj['hy_dh']) && dj['is_shop'] === 1 && dj['thfs'] == '邮寄') return fun.toast('请输入货运单号。');

    if ($.nui.isEmpty(dj['zh_je'])) dj['zh_id'] = 0;

    if ($.nui.isEmpty(dj['hy_id']) && ($.nui.isTrue(dj['hy_dh']) || $.nui.isTrue(dj['hy_je']))) return fun.toast('请选择货运。');

    if ($.nui.isEmpty(dj['fy_je'])) {
        $('#fy').text('其他').data('fy_id', 0);
        dj['fy_id'] = 0;
    }
    var wldw_date = fun.getValByKey(wldw_kh_list, dj['wldw_id'], 'date');
    if (fun.formatDate(dj['kdsj'], 'YYYY-MM-DD') < fun.formatDate(wldw_date, 'YYYY-MM-DD')) {
        // 当前单据的日期 < 当前往来单位的建立日期，则弹提示框
        return fun.toast(tips_arr['小于建立日期提示']);
    }

    var zh_date = fun.getValByKey(zh_list, dj['zh_id'], 'date');
    if (dj['kdsj'] < fun.formatDate(zh_date)) {
        // 当前单据的日期 < 当前账户的建立日期，则弹提示框
        return fun.toast(tips_arr['小于建立日期提示-账户']);
    }

    if ($.nui.isTrue(dj['hy_id'])) {
        var hy_date = fun.formatDate(fun.getValByKey(wldw_wl_list, dj['hy_id'], 'date'));
        if (dj['kdsj'] < hy_date) {
            // 当前单据的日期 < 当前 货运 的建立日期，则弹提示框
            return fun.toast(tips_arr['小于建立日期提示-货运']);
        }
    }

    // 没开启【系统设置-多仓库模式】时，需约束：仓库不能为空。
    // if (recordData.length && $.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']]) && $.nui.isEmpty(dj['ck_id'])) return fun.toast('仓库不能为空。');

    var hasZeroPrice = false;

    for (var i = 0; i < recordData.length; i++) {
        var tmpData = recordData[i];

        // 如果 记录行 被删除, 则不需要判断 限制
        if ($.nui.isTrue(tmpData['is_delete'])) continue;
        if ($.nui.isEmpty(tmpData['ck_id'])) return fun.toast('请选择：【仓库】。');
        if ($.nui.isEmpty(tmpData['cp_ys_id'])) return fun.toast('请选择：【颜色】。');
        if ($.nui.isEmpty(tmpData['dw_id'])) return fun.toast('请选择：【单位】。');
        if ($.nui.isEmpty(tmpData['jjdw_id'])) return fun.toast('请选择：【计价单位】。');

        // 部分产品单价为0, 需要弹出提示
        $.nui.isEmpty(tmpData['dj']) && (hasZeroPrice = true);

        // 仓库有开启：批次管理，则对应的记录的批号字段不能为空
        if ($.nui.isTrue(fun.getHouseValue(tmpData['ck_id'], 'is_batch')) && $.nui.isEmpty(tmpData['ph'])) {
            return fun.toast('【' + fun.getHouseValue(tmpData['ck_id'], 'name') + '】已启用批次管理，只能调用库存开单。');
            // return fun.toast('【' + fun.getHouseValue(tmpData['ck_id'], 'name') + '】已启用批次管理，产品的批号不能为空。');
        }

        // 仓库有开启：明细管理，则对应记录的明细表都必须有记录
        if ($.nui.isTrue(fun.getHouseValue(tmpData['ck_id'], 'is_detail'))) {
            if ($.nui.isEmpty(tmpData['mx'])) {
                return fun.toast('【' + fun.getHouseValue(tmpData['ck_id'], 'name') + '】已启用明细管理，请输入明细匹。');
            }
        }

        jl.push(tmpData);
    }

    if (jl.length && $.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']]) && !$.nui.isFieldValEqual('ck_id', jl)['res']) return fun.toast('一张单不允许多个仓库。');

    if (jl.length === 0) return fun.toast(tips_arr['空单提示']);

    xsFhjsKd.savePriceConstraint = function () {
        if (this.isZeroRowSsj()) { // 记录行是否存在实售价为0的情况
            fun.dialog({
                content: '部分产品实售金额为0，您确定要保存吗？',
                btn: ['确定', '取消'],
                shadeClose: false,
                className: 'data-change-skin',
                no: function () { // 取消
                },
                yes: function () { // 确定
                    xsFhjsKd.removeDialoClass();
                    xsFhjsKd.checkWdyDdj({
                        data: data,
                        saveData: __saveData
                    });
                }
            });
        } else {
            xsFhjsKd.checkWdyDdj({
                data: data,
                saveData: __saveData
            });
        }
    }

    if (hasZeroPrice) {
        fun.dialog({
            content: '部分产品单价为0,您确定要保存吗？',
            btn: ['确定', '取消'],
            className: 'data-change-skin',
            shadeClose: false,
            yes: function () {
                xsFhjsKd.removeDialoClass();
                xsFhjsKd.savePriceConstraint();
            }
        });
    } else {
        xsFhjsKd.removeDialoClass();
        xsFhjsKd.savePriceConstraint();
    }

    function __saveData() {

        if (Bills['wldw']['type'] == 'kh' && $.nui.isTrue(Bills['wldw']['xygk']) && !isSave) {
            // 超信誉额提示
            setCredit();
        } else __save();
    }

    function __save() {
        var save_data = $.extend(true, {}, data, { status: 'save', isSave: isSave, __post_sign: Bills['__post_sign']});

        fun.ajax({
            showLoad: true,
            hideLoad: true,
            loadTitle: '保存中...',
            url: Bills['AJAX_URL']['save'],
            data: save_data,
            success: function (res) {
                if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
                // State['is_saving'] = 0;
                switch (res['status']) {
                    case 0:
                        fun.toast('保存成功！');

                        page_data['id'] = res['data']['dj_id'];
                        if (page_data['shop_type'] == 'shop' && res['msg'] == '审核成功') {
                            api.sendEvent({
                                name: page_data['return_page'],
                                extra: {
                                    'status': 'refresh'
                                }
                            });
                        }
                        if (_options['closePage']) {
                            closePage();
                        }
                        delGridRows = [];
                        if (typeof _options['callback'] === 'function') _options['callback']();
                        break;
                    case 'DCK_LIST':
                        var list = res['dck_list'][0];
                        fun.toast('条码' + list['tm'] + '已被调用或已出库');
                        break;
                    case 'WDYJE_LESS_BCDY':
                        fun.toast('超出了订金，无法保存单据。');
                        console.log(res.data);

                        for (var i = 0; i < res.data.length; i++) {
                            var _res = res.data[i];
                            for (var j = 0; j < Bills['djdymx'].length; j++) {
                                if (_res['dd_dh'] == Bills['djdymx'][j]['dd_dh']) {
                                    console.log(Bills['djdymx'][j])
                                    // Bills['djdymx'][j]['dyqje'] = _res['wdyje'];
                                    Bills['djdymx'][j]['zh_je'] = _res['zh_je'];
                                    Bills['djdymx'][j]['use_latest'] = 1;
                                }
                            }
                        }
                        return;
                        break;
                    case 'DJ_LESS_ZDJ':
                        fun.toast('产品的销售价不能低于产品档案的最低价');
                        // fun.toast('售价低于最低价提示');
                        break;
                    default:
                        fun.toast(res['msg']);
                        // fun.alert({msg: res['msg']}, function () {
                        //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) closePage();
                        // });
                        break;
                }
            }
        });
    }


    function setCredit() {
        var wldw_mc = Bills['wldw']['merchant_name'],
            ysje = parseFloat(dj['ysje'] || 0),
            zhje = parseFloat(dj['zh_je'] || 0),
            ddj = parseFloat(dj['ddj'] || 0),
            xye = Bills['wldw']['credit'] || 0,
            qqje = 0,
            ljqk = 0,
            chje = 0,
            zje = 0;


        __getWldwSubInfo({
            callback: function () {
                qqje = (Bills && Bills['WldwSubInfo'] && Bills['WldwSubInfo']['info']) ? (Bills['WldwSubInfo']['info']['balance'] || 0) : 0;
                if (!$.nui.isEmpty(dj) && (Bills['wldw']['id'] == dj['wldw_id'])) {
                    var dj_ysje = dj['ysje'] || 0,
                        dj_zhje = dj['zh_je'] || 0,
                        dj_ddj = dj['ddj'] || 0;

                    ljqk = (qqje - (dj_ysje - dj_zhje - dj_ddj)).fixed();
                    zje = (qqje + ysje - zhje - ddj - (dj_ysje - dj_zhje - dj_ddj)).fixed();

                    if (zje > xye) {
                        chje = (ljqk + (ysje - zhje - ddj) - xye).fixed();
                        var param = {
                            'wldw_mc': wldw_mc,
                            'ljqk': ljqk,
                            'ysje': (ysje - zhje - ddj).fixed(),
                            'xye': xye,
                            'chje': chje
                        };
                        _checkAuthPwd(param);
                    } else {
                        __save();
                    }

                } else {
                    zje = (qqje + ysje - zhje - ddj).fixed();

                    if (zje > xye) {
                        chje = (qqje + (ysje - zhje - ddj) - xye).fixed();
                        var param = {
                            'wldw_mc': wldw_mc,
                            'ljqk': Bills['WldwSubInfo']['ljqk'],
                            'ysje': (ysje - zhje - ddj).fixed(),
                            'xye': xye,
                            'chje': chje
                        };
                        _checkAuthPwd(param);
                    } else {
                        __save();
                    }
                }
            }
        });
    }

    function _checkAuthPwd(param) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.getAuthList,
            data: { "type": "bpcxyebyxkd" },
            success: function (res) {
                var btns = $.nui.isTrue(res['data']) ? ['取消保存'] : ['继续保存', '取消'];
                fun.cxyetx({
                    content: param,
                    btn: btns,
                    yes: function (e) {
                        if ($.nui.isTrue(res['data'])) {
                            layer.closeAll();
                        } else {
                            __save();
                        }
                    }
                });
            }
        });
    }
}

//数据是否发生改变
function isDataChange() {
    Bills['save_data'] = getSaveData();

    console.log(JSON.stringify(Bills['origin_data']))
    console.log(JSON.stringify(Bills['save_data']))

    // 页面不可编辑时直接返回
    if ((!Auth.check(Bills['auth'], 'edit', false) || __PAGE_DATA['dj']['is_sh'])) {
        return pageBackEvent();
    }

    if (!$.nui.isObjEquals(Bills['origin_data'], Bills['save_data'])) {
        if ($('body').find('.data-change-skin').length) return;
        layer.closeAll();
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData();
            },
            no: function () {
                // api.closeWin();
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         'status': 'refresh'
                //     }
                // });
                if (page_data['shop_type'] == 'shop' && __DJ_DATA['is_sh']) {
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh'
                        }
                    });
                }
                fun.useBack();
                api.closeToWin({
                    name: page_data['LIST_PAGE'] || page_arr.xs_fthjs_tj
                });
            }
        });
    } else if (page_data['shop_type'] == 'shop' && __DJ_DATA['is_sh']) {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'refresh'
            }
        });
        api.closeToWin({
            name: page_data['LIST_PAGE']
        });
    } else {
        pageBackEvent();
    }
}

// 页面返回事件
function pageBackEvent() {
    fun.useBack();
    api.closeToWin({
        name: page_data['LIST_PAGE'] || page_arr.xs_fthjs_tj
    });
}

//关闭页面并刷新上一页
function closePage(flag) {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh'
        }
    });
    if (!flag) {
        api.sendEvent({
            name: html_name,
            extra: {
                'status': 'refresh_dj'
            }
        });
    }

    if (flag) {
        setTimeout(function () {
            // api.closeWin();
            fun.useBack();
            api.closeToWin({
                name: page_data['LIST_PAGE'] || page_arr.xs_fthjs_tj
            });
        }, 200);
    }
}


function __getDjInfo() {
    return getSaveData()['dj'];
}

function __getJlData() {
    return getSaveData()['jl'];
}


// //批量 获取单价、上次价
// function __getAllDj(options) {
//     var __opt = $.extend(true, {
//         'get_dj': 1,
//         'get_scdj': 1,
//         'get_cpbj': 1,
//         'update_all': 1,
//         '__update_dj_key': ''
//     }, options);
//
//     var list = [];
//
//     var dj_info = getSaveData()['dj'];
//     var jl_rows = getSaveData()['jl'];
//
//     for (var i = 0; i < jl_rows.length; i++) {
//         var __row = jl_rows[i];
//         __row['__index'] = i;
//         if ($.nui.isTrue(__opt['__update_dj_key']) && (__opt['__update_dj_key'] !== __row['__update_dj_key'])) continue;
//         if ($.nui.isEmpty(__row['cp_id']) || $.nui.isEmpty(__row['cp_ys_id']) || $.nui.isEmpty(__row['jjdw_id'])) continue;
//         // 当 update_all=true 则代表只更新 单价 为 0 的记录
//         if ($.nui.isEmpty(__opt['update_all']) && ((__row['dj'] || 0) > 0)) continue;
//         list.push({
//             "djlx": Bills['djlx'],
//             "__key": __row['__index'],
//             "__get_dj": __opt['get_dj'],
//             "__get_scdj": __opt['get_scdj'],
//             "wldw_id": dj_info['wldw_id'] || 0,
//             "cp_id": __row['cp_id'] || 0,
//             "cp_ys_id": __row['cp_ys_id'] || 0,
//             "jjdw_id": __row['jjdw_id'] || 0,
//             "dj_info": __row['dj_info'] || {},
//             "dd_dj_id": __row['dd_dj_id'] || 0,
//             "dd_jl_id": __row['dd_jl_id'] || 0,
//             "gx_id": __row['gx_id'] || 0,
//             "kdsj": dj_info['kdsj'],
//             "dj": __row['dj'] || 0,
//         });
//     }
//
//     fun.ajax({
//         showLoad: false,
//         hideLoad: true,
//         url: Bills['AJAX_URL']['getDj'],
//         data: {list: list},
//         success: function (res) {
//             for (var key in res['data']) {
//                 var __tmpData = {};
//                 $.nui.isTrue(__opt['get_scdj']) && (__tmpData['scdj'] = res['data'][key]['scdj']);
//                 if ($.nui.isTrue(__opt['get_dj'])) {
//                     __tmpData['dj'] = res['data'][key]['dj'];
//                     __tmpData['ssdj'] = res['data'][key]['ssdj'];
//                 }
//                 if ($.nui.isTrue(__opt['get_cpbj'])) {
//                     __tmpData['bzj'] = res['data'][key]['bzj'];
//                     __tmpData['zdj'] = res['data'][key]['zdj'];
//                 }
//                 // 扩展方法, 不同模块 有 特殊的 价格字段需要赋值
//                 // 销售: ssdj:实售价、bzj:标准价、zdj:最低价
//                 // 加工: dj_info: 工序单价
//                 if (typeof __setDj === 'function') __setDj({
//                     __data: __tmpData,
//                     res: res['data'][key]
//                 });
//
//                 if (typeof __updateJlDataByIndex === 'function') __updateJlDataByIndex({
//                     index: key,
//                     data: __tmpData
//                 });
//
//                 // for (var j = 0; j < __JL_DATA.length; j++) {
//                 //     if (j == key) {
//                 //         __JL_DATA[j] = $.extend({}, __JL_DATA[j], __tmpData);
//                 //         break;
//                 //     }
//                 // }
//             }
//
//             showJlList(formatData(__JL_DATA));
//             if (typeof __opt['callback'] === 'function') __opt['callback']();
//         }
//     });
// }

function __updateJlDataByIndex(options) {
    var _options = $.extend({
        index: null,
        data: {}
    }, options);

    var tmpData = _options['data'];

    for (var j = 0; j < __JL_DATA.length; j++) {
        if (j == _options['index']) {
            tmpData = updateRowDataMoney(j, tmpData, {}, __JL_DATA[j]);
            __JL_DATA[j] = $.extend({}, __JL_DATA[j], tmpData);
            break;
        }
    }
}


// 设置不可用
// function setDomDisabled() {
// if (__PAGE_STATUS !== 'edit') return;
// var value = {wldw: false, ck: false};
// for (var i = 0; (grid1 && (i < grid1.rows.length)); i++) {
//     var row = grid1.rows[i];

//     // 记录表 有引用 订单的记录 或 仓库单的记录 则 往来单位不能修改
//     if ($.nui.isTrue(row['dd_dj_id']) || $.nui.isTrue(row['ckd_dj_id'])) value['wldw'] = true;

//     // 如果是 引用仓库单记录，则判断 多仓库模式、调用不同仓库单结算 都没开启 则需把仓库设置为 不可用状态
//     if ($.nui.isTrue(row['ckd_dj_id']) &&
//         $.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']]) &&
//         $.nui.isEmpty(SYS_CONFIG[Bills['config']['dbtckjs']])
//     ) value['ck'] = true;

//     // 如果是 引用 有 引用条码记录 则 仓库不能修改
//     if ($.nui.isTrue(row['is_yy_tm'])) value['ck'] = true;

//     // 如果 有 引用 条码采集窗口 则 仓库、往来单位 都不能修改
//     if (row['yy_djlx'] === 'tmcj') {
//         value['wldw'] = true;
//         value['ck'] = true;
//     }
// }
// wldw && wldw.setDisable(value['wldw']);
// ck && ck.setDisable(value['ck']);
// }

/************************* 事件绑定 *************************/

$('body').on('tap', '.ck', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;
    var ck_id = $(this).data('ck_id');
    var ck_list = fun.getItem('ck_list') || [];
    // if (fun.getHouseValue(ck_id, 'is_bar')) return;

    if ((!Auth.check(Bills['auth'], 'edit', false) || __PAGE_DATA['dj']['is_sh'] || !auth_xsbchyxxg)) return;
    $(this).addClass('curr');
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            return_page: html_name,
            page_type: 'ck',
            ck_type: (fun.getValByKey(ck_list, ck_id, 'type') === 'skyb' && fun.checkJlHasSk(__JL_DATA, ck_id)) ? 'skyb' : ''
        }
    });
});
//点击跳转
$('body').on('tap', ' .list-type', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;
    var list_type = $(this).data('list_type');
    var url = '';
    switch (list_type) {
        case 'kh':
        case 'wl':
            url = page_arr.customer_search;
            break;
        case 'zh':
            url = page_arr.select_bank_list;
            break;
        default:
            url = page_arr.select_list;
            break;
    }
    fun.showPageFull({
        page_url: url,
        pageParam: {
            return_page: html_name,
            page_type: list_type
        }
    });
});


//联系人搜索
$('#lxr').on('tap', function (e) {
    if ($(this).attr('disabled')) return;

    if (!$('#wldw').data('wldw_id')) {
        return fun.toast('请先选择客户！');
    }
    fun.showPageFull({
        page_url: page_arr.contacter_search,
        pageParam: {
            "return_page": html_name,
            "page_type": 'kh',
            'wldw_mc': $('#wldw').val().trim(),
            'wldw_id': $('#wldw').data('wldw_id')
        }
    });
});

//调用订金
$('body').on('tap', '#ddj', function (e) {
    if ($(this).attr('disabled')) return;
    var __PAGE_EDIT = !(!Auth.check(Bills['auth'], 'edit', false) || __PAGE_DATA['dj']['is_sh'] || !auth_xsbchyxxg);
    if (!__PAGE_EDIT && !$(this).val().trim()) return;

    if (!$('#wldw').data('wldw_id')) return fun.toast('请先选择客户！');
    var jl_id_notin = [];

    // for (var i = 0; i < Bills['djdymx'].length; i++) {
    //     if ($.nui.isTrue(Bills['djdymx'][i]['dj_id'])) Bills['djdymx'].push(jl_data[i]['dj_id']);
    // }

    var djdymxObj = {};
    var djdymxDhObj = {};
    for (var i = 0; i < Bills['djdymx'].length; i++) {
        if ($.nui.isTrue(Bills['djdymx'][i]['is_delete'])) continue;
        djdymxObj[Bills['djdymx'][i]['dd_dj_id']] = Bills['djdymx'][i];
        // djdymxDhObj[Bills['djdymx'][i]['dd_dj_id']] = Bills['djdymx'][i];
        // if ($.nui.isTrue(Bills['djdymx'][i]['dj_id'])) Bills['djdymx'].push(jl_data[i]['dj_id']);
    }


    fun.showPageFull({
        page_url: page_arr.xs_dydj,
        pageParam: {
            return_page: html_name,
            page_type: Bills['djlx'],
            djlx: Bills['djlx'],
            wldw_id: $('#wldw').data('wldw_id'),
            wldw_mc: $('#wldw').val().trim(),
            jl_id_notin: jl_id_notin,
            ddj: parseFloat($(this).val().trim() || 0),
            djdymx: Bills['djdymx'] || [],
            djdymxObj: djdymxObj,
            djdymxDhObj: djdymxDhObj,
            page_edit: __PAGE_EDIT
        }
    });
});

// 费用金额改变时，应收金额要变化
$('#fy_je').on('keyup', function (e) {
    // if (isNaN($(this).val().trim())) {
    //     $(this).val('');
    //     return;
    // }

    setYsje();
});

// 账户金额改变时，累欠金额要变化
$('#zhje').on('keyup', function (e) {
    // if (isNaN($(this).val().trim())) {
    //     $(this).val('');
    //     return;
    // }
    setLjqk();
});

$('#fy_je,#zhje').on('blur', function (e) {
    var val = $(this).val();
    if (isNaN(val)) {
        $(this).val('');
    }
});

// 显示、隐藏切换
$('.hide').hide();
$('.open').on('click', function () {
    if ($(this).find('.iconfont').hasClass('icon-xia')) {
        $(this).find('.iconfont').addClass('icon-shang').removeClass('icon-xia');
        // $('.contents').css('height','auto');
    } else {
        $(this).find('.iconfont').addClass('icon-xia').removeClass('icon-shang');
        // $('.contents').css('height','calc(100% - 8.2rem)');
    }
    $('.hide').toggle();
});


// 删除记录行
$('body').on('touchend', '.delete-btn', function (e) {
    e.preventDefault();
    var _this = this;
    fun.dialog({
        content: '你确定要删除当前记录吗？',
        btn: ['删除', '取消'],
        yes: function () {
            var index = $(_this).data('del_index');
            var tmpData = __JL_DATA.splice(index, 1);
            if ($.nui.isTrue(tmpData)) {
                tmpData[0]['is_delete'] = 1;
                tmpData[0]['__status'] = 'del';
                delGridRows.push(tmpData[0]);
            }

            updatePageList();
            dataChangeShowSaveBtn();
            // showJlList(formatData(__JL_DATA));
            // getTotalInfo(__JL_DATA);
            // setYsje();
            //
            // setDomDisabled();
        }
    });
    return false;
});

// 现结
$('body').on('tap', '#xj', function (e) {
    if ($(this).attr('disabled')) return;
    if ($(this).hasClass('nui-active')) {
        switchActive();
    } else {
        switchUnActive();
    }
    showSaveBtn();
});


// 点击跳转记录表详情
$('body').on('tap', '.jl-item', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;

    var pageUrl = '',
        pageParam = {};

    var list_data = $(this).data('list_data');
    var ck_id = list_data['ck_id'] || 0;
    // var ck_mc = list_data['ck_mc'] || '';

    //重新读取本地仓库列表
    ck_list = fun.getItem('ck_list') || [];
    var ck_info = fun.getListInfoByKey(ck_list, ck_id);
    var ck_is_detail = ck_info['is_detail'] || 0;
    var bj_type = '';
    //
    var row_index = parseInt(list_data['__del_index']);

    // var __PAGE_EDIT = (__PAGE_STATUS == 'edit' || $.nui.isEmpty(Bills['dj_id']));

    var __PAGE_EDIT = !(!Auth.check(Bills['auth'], 'edit', false) || __PAGE_DATA['dj']['is_sh'] || !auth_xsbchyxxg);

    // 开单编辑页参数
    var kdbjParam = {
        djlx: Bills['djlx'],
        return_page: html_name,
        list_data: $(this).data('list_data'),
        ck_info: ck_info,
        edit_row: true,
        row_index: row_index,
        __JL_DATA: __JL_DATA,
        __DJ_DATA: getSaveData()['dj'],
        __PAGE_EDIT: __PAGE_EDIT,
        ck_is_disabled: $(this).closest('.storehouse').find('.ck').attr('disabled'),

    };

    // 明细布匹页参数
    var mxbpParam = {
        djlx: Bills['djlx'],
        return_page: html_name,
        list_data: $(this).data('list_data'),
        row_index: row_index,
        ck_info: ck_info,
        edit_row: true,
        __JL_DATA: __JL_DATA,
        __DJ_DATA: __DJ_DATA,
        __PAGE_EDIT: __PAGE_EDIT,
        ck_is_disabled: $(this).closest('.storehouse').find('.ck').attr('disabled')
    };

    if (ck_is_detail) { //开启明细管理
        if ($.nui.isTrue(list_data['mx']) && $.nui.isTrue(existTm(list_data['mx']))) { //有条码
            // 跳明细布匹
            bj_type = 'mx';
            mxbpParam['bj_type'] = bj_type;
            mxbpParam['MXTM'] = true;
            pageUrl = NEW_BILLS ? page_arr.bills_zsmx : page_arr.detailed_barcode;
            pageParam = mxbpParam;
        } else { //没条码
            if (!Auth.check(Bills['auth'], 'edit', false) || __PAGE_DATA['dj']['is_sh'] || !auth_xsbchyxxg) { //非编辑状态
                // 跳明细布匹
                bj_type = 'mx';
                mxbpParam['bj_type'] = bj_type;
                // mxbpParam[''] = ''
                pageUrl = NEW_BILLS ? page_arr.bills_zsmx : page_arr.detailed_barcode;
                pageParam = mxbpParam;
            } else { //编辑状态
                // 跳明细
                bj_type = 'mx';
                kdbjParam['bj_type'] = bj_type;
                pageUrl = NEW_BILLS ? page_arr.bills_zsmx : page_arr.single_editor;
                pageParam = kdbjParam;
            }
        }
    } else { //没开启明细管理
        if (!Auth.check(Bills['auth'], 'edit', false) || __PAGE_DATA['dj']['is_sh'] || !auth_xsbchyxxg) { //非编辑状态
            if (NEW_BILLS) {
                // 跳总数
                bj_type = 'zs';
                kdbjParam['bj_type'] = bj_type;
                pageUrl = NEW_BILLS ? page_arr.bills_zsmx : page_arr.single_editor;
                pageParam = kdbjParam;
            } else {
                return; // 点击无效
            }
        } else { //编辑状态
            // 跳总数
            bj_type = 'zs';
            kdbjParam['bj_type'] = bj_type;
            pageUrl = NEW_BILLS ? page_arr.bills_zsmx : page_arr.single_editor;
            pageParam = kdbjParam;

        }
    }

    fun.showPageFull({
        page_url: pageUrl,
        pageParam: pageParam
    });

    // // fun.showPageFull({
    // //     page_url: page_arr.single_editor,
    // //     pageParam: {
    // //         return_page: html_name,
    // //         bj_type: bj_type,
    // //         list_data: $(this).data('list_data'),
    // //         kdjl_list: jl_data,
    // //         ck_info: {
    // //             ck_id: ck_id,
    // //             ck_mc: ck_mc,
    // //             ck_is_detail: ck_is_detail,
    // //             ck_type: ck_info['type'],
    // //             ck_type_name: ck_info['type_name'],
    // //             ck_info: ck_info
    // //         },
    // //         edit_row: true,
    // //         row_index: row_index
    // //     }
    // // });

});

// 添加
// $('body').on('click', '.button3', function (e) {
//     e.preventDefault();
//     var html = [];
//     html.push('<div class="record-wrap">');
//     html.push('     <div class="record-header"><span class="record-title">添加记录</span><span class="record-close">&times;</span></div>');
//     html.push('     <ul class="record-list">');
//     html.push('         <li id="cpzl"><div style="background-color: #18b4ed;" class="cloth-box"><i class="iconfont record-icon icon-chanpin"></i></div><span class="record-text">产品资料</span></li>');
//     html.push('         <li id="khdd"><div style="background-color: #2ecc71;" class="cloth-box"><i class="iconfont record-icon icon-caigoudingdan"></i></div><span class="record-text">客户订单</span></li>');
//     html.push('     </ul>');
//     html.push('</div>');
//     layer.open({
//         type: 1,
//         content: html.join(''),
//         style: 'width: 75%; height: 160px;border:none;background-color: #fff;border-radius: 10px;',
//         success: function (elem) {
//             $('.record-close').on('click', function (e) {
//                 layer.closeAll();
//             });
//
//             $('#cpzl').on('tap', function (e) {
//                 fun.showPageFull({
//                     page_url: page_arr.choice_product,
//                     pageParam: {
//                         return_page: html_name,
//                         __JL_DATA: __JL_DATA,
//                         __PAGE_INFO: __PAGE_INFO,
//                         __DJ_DATA: getSaveData()['dj'],
//                         __PAGE_EDIT: !(!Auth.check(Bills['auth'], 'edit', false) || __PAGE_DATA['dj']['is_sh'])
//                     }
//                 });
//                 setTimeout(function () {
//                     layer.closeAll();
//                 }, 200);
//             });
//
//             $('#khdd').on('tap', function (e) {
//                 var jl_id_notin = [];
//                 for (var i = 0; i < __JL_DATA.length; i++) {
//                     if ($.nui.isTrue(__JL_DATA[i]['dd_jl_id'])) {
//                         jl_id_notin.push(__JL_DATA[i]['dd_jl_id']);
//                     }
//                 }
//                 fun.showPageFull({
//                     page_url: page_arr.xs_dykhdd,
//                     pageParam: {
//                         return_page: html_name,
//                         djlx: Bills['djlx'],
//                         gxlx_id: 0,
//                         wldw_id: $('#wldw').data('wldw_id') || 0,
//                         jl_id_notin: jl_id_notin,
//                         wldw_setDisable: 0
//                     }
//                 });
//                 setTimeout(function () {
//                     layer.closeAll();
//                 }, 200);
//             });
//         }
//     });
//     return false;
// });

$('body').on('tap', '.button3,.add-product', function (e) {
    e.stopPropagation();

    // if ($.nui.isTrue(page_data['id'])) {
    if ($.nui.isTrue(__JL_DATA)) {
        __PAGE_INFO['ck_id'] = __JL_DATA[__JL_DATA.length - 1]['ck_id'];
    }
    // }

    fun.showPageFull({
        page_url: page_arr.choice_product,
        pageParam: {
            return_page: html_name,
            djlx: Bills['djlx'],
            __JL_DATA: __JL_DATA,
            __PAGE_INFO: __PAGE_INFO,
            __DJ_DATA: getSaveData()['dj'],
            __PAGE_EDIT: !(!Auth.check(Bills['auth'], 'edit', false) || __PAGE_DATA['dj']['is_sh'] ||  !auth_xsbchyxxg)
        }
    });
});


/******************** 单据功能 *********************/
// 保存单据
$('body').delay('tap', '#kd_save', function () {
    if (!Auth.check(Bills['auth'], 'edit')) return false;
    saveData();
});

// 记录表单元格编辑后触发的事件
function setRowData(index, data, opt, _data) {//下标，新数据，配置，旧数据
    if ($.nui.isEmpty(SYS_CONFIG[Bills['config']['ssjms']])) return;
    _data['ssdj'] = parseFloat(_data['ssdj'] || 0);
    if ((typeof data['ssdj'] === 'undefined') && ((typeof data['dj'] !== 'undefined'))) _data['ssdj'] = _data['dj'];

    if (opt.upDateSssl) {
        _data['sssl'] = fun.toNumber(fun.dwhs({
            zsl: _data['bqsl'] || 0,
            ps: _data['ps'] || 0,
            fk: _data['fk'] || '',
            kz: _data['kz'] || '',
            dw: _data['dw_mc'] || '',
            jjdw: _data['jjdw_mc'] || '',
            kc: parseFloat(_data['sskc'] || 0),
            kcms: _data['kcms'] || '+',
            mx: []
        }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
    }

    _data['ssje'] = (_data['ssdj'] * (_data['sssl'] || 0)).fixed();
    _data['sszje'] = (_data['ssdj'] * (_data['sssl'] || 0)).fixed();
    // 自定义费用
    for (var i = 1; i <= 5; i++) _data['sszje'] += parseFloat(_data['fy_zdy' + i] || 0);

    _data['ssje'] = __jeSswr(_data['ssje']);
    _data['sszje'] = __jeSswr(_data['sszje']);
}


$('body').on('tap', ".icon-saoma", function (e) {
    if ($(this).attr('disabled')) return;
    QuestPermission.requestPermission('camera', null, function () {
        openScanner({
            callback: function (value) {
                $('#hyd').val(value);
            }
        });
    });
});


//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
    });
}


function controlbyDdj() {
    if ($.nui.isTrue($('#ddj').val().trim())) {
        $('#xj').attr('disabled', true);//,#zhje
    } else {
        $('#xj,#zhje').removeAttr('disabled');
    }
}

// 修改状态下根据条件判断控件是否为可用状态
function setDomDisabled() {
    var value = { wldw: false };

    var ck_ids = {};

    for (var i = 0; i < __JL_DATA.length; i++) {
        var row = __JL_DATA[i];

        // 记录表 有引用 订单的记录 或 仓库单的记录 则 往来单位不能修改
        if ($.nui.isTrue(row['dd_dj_id']) || $.nui.isTrue(row['ckd_dj_id']) || $.nui.isTrue(row['ybjl_id'])) value['wldw'] = true;

        // // 如果是 引用仓库单记录，则判断 多仓库模式、调用不同仓库单结算 都没开启 则需把仓库设置为 不可用状态
        if ($.nui.isTrue(row['ckd_dj_id']) &&
            $.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']]) &&
            $.nui.isEmpty(SYS_CONFIG[Bills['config']['dbtckjs']])
        ) {
            value['ck'] = true;
            ck_ids[row['ck_id']] = row['ck_id'];
        }

        // 如果是 引用 有 引用条码记录 则 仓库不能修改
        if ($.nui.isTrue(row['is_yy_tm'])) {
            value['ck'] = true;
            ck_ids[row['ck_id']] = row['ck_id'];
        }

        // 如果 有 引用 条码采集窗口 则 仓库、往来单位 都不能修改
        if (row['yy_djlx'] === 'tmcj') {
            value['wldw'] = true;
            value['ck'] = true;
            ck_ids[row['ck_id']] = row['ck_id'];
        }

        if (!fun.getHouseValue(row['ck_id'], 'is_detail') && fun.getHouseValue(row['ck_id'], 'is_batch')) {
            value['ck'] = true;
            ck_ids[row['ck_id']] = row['ck_id'];
        }

    }

    if ($.nui.isTrue(value['wldw']) || $.nui.isTrue(__DJ_DATA['is_sh'])) {
        $('#wldw').attr('disabled', true);
    } else {
        $('#wldw').removeAttr('disabled');
    }

    if ($.nui.isTrue(value['ck'])) {
        for (var key in ck_ids) {
            $('.ck[data-ck_id="' + key + '"]').attr('disabled', true);
        }
    }
}


// 设置控件状态不可用
function setDisable(value) {
    // if (value) $('input,#xj').attr('disabled', true);
    // else $('input,#xj').removeAttr('disabled');
}

//设置 实售价、标准价、最低价
function __setDj(params) {
    if ($.nui.isTrue(SYS_CONFIG[Bills['config']['ssjms']])) {
        params['__data']['ssdj'] = params['res']['ssdj'];
    }
    params['__data']['bzj'] = params['res']['bzj'];
    params['__data']['zdj'] = params['res']['zdj'];
}


function dkc_callback(tmpData, param) {
    // ycztm_arr.push(param['tm']);

    tmpData['is_cjjl'] = param['is_cjjl'];
    tmpData['cj_jjsl'] = param['cj_jjsl'];
    // tmpData['dd_dh'] = param['dd_dh'];
    // tmpData['dd_kdsj'] = param['dd_kdsj'];
    // tmpData['dd_lb_mc'] = param['dd_lb_mc'];
    // tmpData['dd_lb_id'] = param['dd_lb_id'];
    // tmpData['dd_dj_id'] = param['dd_dj_id'];
    // tmpData['dd_jl_id'] = param['dd_jl_id'];
}


function setPageDomDisable(data) {
    if ($.nui.isEmpty(data)) return;
    var dj = data['dj'];
    var jl = data['jl'];

    if ($.nui.isTrue(dj)) {
        if ($.nui.isTrue(dj['is_sh']) || !auth_xsbchyxxg) {
            $('#wldw').attr('disabled', true);
        }
    }
}

function __checkData() {
    if (!fun.dataIsRead(['ck'])) {
        setTimeout(__checkData, 250);
    } else {
        setTimeout(function () {
            if (typeof page_init === "function") page_init();
        }, 100);
    }
}

//分享单据到微信
$('body').on('click', '#share_btn', function (_opt) {
    Bills['save_data'] = getSaveData();

    if (!$.nui.isObjEquals(Bills['origin_data'], Bills['save_data'])) {
        return fun.toast('请先保存单据！');
    }
    fun.shareRequest({
        djlx: Bills['djlx'],
        id: __DJ_DATA['id'],
    })
})

// $('body').off('tap', '#print_btn').on('tap', '#print_btn', function (e) {
//     e.stopPropagation();
//     layer.closeAll();
//     if (['none', 'unknown'].indexOf(api.connectionType) > -1) {
//         return fun.toast('网络错误！');
//     }
//     Print.printLoad();
// });

//更新页面内容
function updatePageList(options) {
    var _options = $.extend({
        showJlList: true
    }, options);
    _options['showJlList'] && showJlList(formatData(__JL_DATA));
    getTotalInfo(__JL_DATA);
    setYsje();
    setDomDisabled();
}


// 有开启线上支付
function kqXszfDisabled() {

}

// 显示保存按钮
function showSaveBtn() {
    console.log(1);
    if ($('#kd_audit:visible').length) {
        $('#kd_audit').hide();
    }
    console.log(2);
    if ($('#kd_save:visible').length) return;
    if (__DJ_DATA['is_sh']) return;
    console.log(3);
    $('#kd_save').show();
}

// 判断数据是否发生改变
function checkDataChange() {
    var tmpOriData = Bills['origin_data'];
    var tmpSaveData = getSaveData();
    return !$.nui.isObjEquals(tmpOriData, tmpSaveData);
}

// 数据发生改变显示保存按钮
function dataChangeShowSaveBtn() {
    if (checkDataChange()) showSaveBtn();
}

// input输入框绑定事件
function inputBindEvent() {
    // 未审核数据改变显示保存按钮
    $('body').off('input propertychange', ':input').on('input propertychange', ':input', fun.throttle(showSaveBtn, 300));
}

// 根据返回状态检测数据判断显示保存按钮
function checkStatusShowSaveBtn(status) {
    var statusArr = [ // 状态数组
        'select_list',
        'update_rows',
        'update_row',
        'delete_row',
        'fhjs_dkc',
        'dykhdd',
        'dydj',
        'update_mxbp',
        'dkc_edit_del'
    ];
    // 返回回来的状态
    if (statusArr.indexOf(status) > - 1) {
        dataChangeShowSaveBtn();
    }
}

/**
 * 2020-04-17
 * 调整
 * 多加一个获取系统设置
 */
function getSysList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSysList,
        data: {},
        success: function (res) {
            if (res['status'] == 0) {
                fun.setItem('sys_config', res['data']);
                SYS_CONFIG = fun.getItem('sys_config') || {};//系统设置
            }
        }
    });
}

/*
    1. 有单价 >= 有实售价 >= 没订金 >= 跳转
    2. 有单价 >= 没实售价 >= 没订金 >= 跳转
    3. 有单价 >= 没实售价 >= 有订金 >= 保存

    4. 没单价 >= 有实售价 >= 没订金 >= 跳转
    5. 没单价 >= 有实售价 >= 有订金 >= 保存
    6. 没单价 >= 没实售价 >= 没订金 >= 跳转
    7. 没单价 >= 没实售价 >= 有订金 >= 保存

    8. 有单价 >= 有实售 >= 有订金 >= 保存
*/

// 获取剪匹数、实出匹
xsFhjsKd.getJpdAndScp = function (data) {
    $(data).each(function (idx, item) { 
        if (item.is_delete) return true;
        var zps = 0;
        var scps = 0;
        var jps = 0;
        if ($.nui.isTrue(item.mx) && __getMxLength(item.mx)) {
            $(item.mx).each(function (index, mxItem) {
                if (mxItem.is_delete) { // 排除被删除明细
                    return true;
                }
                zps++;
                if (parseFloat(mxItem.sl) < parseFloat(mxItem.tm_sl || 0)) { // 修改后比调用记录小，剪匹数+1
                    jps++;
                };
            })
            if (!zps && item.ps) {
                zps = item.ps;
            }
        } else {
            if (item.ps) {
                zps = item.ps;
            }
        }
        scps = zps - jps; // 实出匹
        item.jps = jps;
        item.ps = zps;
        item.scps = scps;
    })
}