var html_name = page_arr.xs_fthjs_tj;

//默认开始显示数据
var to_month = fun.getLatelyTime(1, false);
var page_list = [],
    ztj_data = {};
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd')
};

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd')
};
var _hz = html_name + '_hz_';
var _html_name = html_name + '_';

$('.increase').hide();


$('#header').header({
    back: true,
    filter: true,
    title: '销售开单统计'//'发退货结算'
});

var USER_INFO = {};
var SYS_CONFIG = {};

var hz_group_columns = {
    'dh': 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc',
    'kh': 'wldw_id,wldw_mc',
    'cp': 'cp_bh,cp_mc',
    'ys': 'cp_ys_bh,cp_ys_mc',
    "hsdj": 'hsdj,ssdj',
    "fkkz": 'fk,kz',
    "gg": 'gg'
};
//接收查询后的参数
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    SYS_CONFIG = fun.getItem('sys_config') || {};

    if (Auth.check('bp_xsthjs', 'edit') && Auth.check('bp_xsfhjs', 'edit')) {
        $('.increase').show();
    } else if (Auth.check('bp_xsthjs', 'edit')) {
        $('.increase').show();
        $('.come').hide();
        $('.retreat').addClass('single-btn-style');
    } else if (Auth.check('bp_xsfhjs', 'edit')) {
        $('.increase').show();
        $('.retreat').hide();
        $('.come').addClass('single-btn-style');
    } else {
        $('.increase').hide();
        $('.content').removeClass('fthjs');
    }
    // $('.increase-p:visible:first').css('margin-left', '2%');

    fun.load_DATA_LIST(['ck']);
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = fun.getItem(_html_name + 'group') || "";

    search_storage = $.extend(true, {
        //隐藏已审核
        'ycysh': fun.getItem(html_name + '_ycysh', 0),
        'hldj': fun.getItem(html_name + '_hldj', 0),
        'xsmx': fun.getItem(html_name + '_xsmx', 0),
        "hz": {
            "choose": {
                "kh": fun.getItem(_hz + 'kh', 1),
                "dh": fun.getItem(_hz + 'dh', 1),
                "md": fun.getItem(_hz + 'md', 0),
                "cp": fun.getItem(_hz + 'cp', 1),
                "ys": fun.getItem(_hz + 'ys', 1),
                "fkkz": fun.getItem(_hz + 'fkkz', 0),
                "gg": fun.getItem(_hz + 'gg', 0),
                "hsdj": fun.getItem(_hz + 'hsdj', 1),
            },
            "text": fun.getItem(_hz + 'text', ""),
        },
        'djlx': fun.getItem(html_name + "_djlx")
    }, search_storage);

    //首页今日销售跳转过来，赋值今天日期
    if (!!page_data['today']) {
        search_data['md_id'] = page_data['md_id'];
        search_data['md_mc'] = page_data['md_mc'];
        search_storage['md'] = {
            id: page_data['md_id'],
            text: page_data['md_mc']
        };
        search_data['begin_time'] = page_data['today'];
        search_data['end_time'] = page_data['today'];
        search_storage['begin_date'] = page_data['today'];
        search_storage['end_date'] = page_data['today'];
        date_bar.setDate(search_storage);
    }
    //首页今日销售跳转过来，赋值本月日期(新版首页)
    if (!!page_data['begin_time'] && !!page_data['end_time']) {
        search_data['md_id'] = page_data['md_id'];
        search_data['md_mc'] = page_data['md_mc'];
        search_storage['md'] = {
            id: page_data['md_id'],
            text: page_data['md_mc']
        };
        search_data['begin_time'] = page_data['begin_time'];
        search_data['end_time'] = page_data['end_time'];
        search_storage['begin_date'] = page_data['begin_time'];
        search_storage['end_date'] = page_data['end_time'];
        date_bar.setDate(search_storage);
    }
    if (!!page_data['data']) {
        search_data['md_id'] = page_data['data']['md_id'];
        search_data['md_mc'] = page_data['data']['md_mc'];
        search_storage['md'] = {
            id: page_data['data']['md_id'],
            text: page_data['data']['md_mc']
        };
    }
    //上个页面：客户分析-详情
    if (!!page_data['details']) {
        search_data['wldw_id'] = page_data['details']['wldw_id'];
        search_data['wldw_mc'] = page_data['details']['wldw_mc'];
        search_storage['kh'] = {
            id: page_data['details']['wldw_id'],
            text: page_data['details']['wldw_mc']
        };
        search_data['begin_time'] = page_data['details']['begin_date'];
        search_data['end_time'] = page_data['details']['end_date'];
        search_storage['begin_date'] = page_data['details']['begin_date'];
        search_storage['end_date'] = page_data['details']['end_date'];
        date_bar.setDate(search_storage);
    }
    //上个页面：产品分析-详情
    if (!!page_data['type'] && page_data['type'] === 'cp_fx') {
        search_data['cp_id'] = page_data['cp_id'];
        search_data['cp_mc'] = page_data['cp_mc'];
        search_storage['cp'] = {
            id: page_data['cp_id'],
            text: page_data['cp_mc']
        };
        search_data['begin_time'] = page_data['begin_date'];
        search_data['end_time'] = page_data['end_date'];
        search_storage['begin_date'] = page_data['begin_date'];
        search_storage['end_date'] = page_data['end_date'];
        date_bar.setDate(search_storage);
    }
    search_data = $.extend({}, search_data, search_storage);

    fun.initGroupOfSearchData(search_data, search_storage.hz.choose, hz_group_columns, ',jjdw_id,jjdw_mc');
    getList(search_data);

    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret.value;

        switch (temp['status']) {
            case 'search':
                var param = temp.data;

                search_data['keyword'] = param['LIKE_DATA'] || ''; //关键字
                search_data['begin_time'] = param.begin_date; //开始时间
                search_data['end_time'] = param.end_date; //结束时间
                search_data['wldw_id'] = param.kh['id'] || ''; //供应商
                search_data['cp_id'] = param.cp['id'] || ''; //产品
                search_data['cp_lb_id'] = param.cp_lb['id'] || 0;//产品类别
                search_data['ck_id'] = param.ck['id'] || ''; //仓库
                search_data['md_id'] = param.md['id'] || ''; //门店
                search_data['ycysh'] = param['ycysh'];
                search_data['hldj'] = param['hldj'];
                search_data['xsmx'] = param['xsmx'];

                if (param.djlx['type'].indexOf(',') > -1) {
                    // var split=param.djlx['type'].split(',');
                    search_data['djlx'] = ["bp_xsfhjs", "bp_xsthjs"];
                } else {
                    search_data['djlx'] = param.djlx['type'] != "" ? [param.djlx['type']] : ["bp_xsfhjs", "bp_xsthjs"];
                }
                search_data['djlx_text'] = param.djlx['text'];
                fun.setItem(html_name + '_djlx', search_data['djlx'])
                fun.setItem(html_name + '_djlx_text', search_data['djlx_text'])
                if (param.djlx['keys']['bp_xsfhjs'] == 0 && param.djlx['keys']['bp_xsthjs'] == 0) {
                    fun.setItem(html_name + '_bp_xsfhjs', 1);
                    fun.setItem(html_name + '_bp_xsthjs', 1);
                } else {
                    fun.setItem(html_name + '_bp_xsfhjs', param.djlx['keys']['bp_xsfhjs']);
                    fun.setItem(html_name + '_bp_xsthjs', param.djlx['keys']['bp_xsthjs']);
                }

                //搜索菜单需要缓存的数据
                search_storage['keyword'] = search_data['keyword'];
                search_storage['begin_date'] = search_data['begin_time'];
                search_storage['end_date'] = search_data['end_time'];
                search_storage['kh'] = param.kh;
                search_storage['cp'] = param.cp;
                search_storage['cp_lb'] = param.cp_lb;
                search_storage['ck'] = param.ck;
                search_storage['md'] = param.md;
                search_storage['ycysh'] = search_data['ycysh'];
                search_storage['hldj'] = search_data['hldj'];
                search_storage['xsmx'] = search_data['xsmx'];

                //设置时间控件时间
                date_bar.setDate(search_storage);

                fun.setItem(html_name + '_ycysh', search_storage['ycysh']);
                fun.setItem(html_name + '_hldj', search_storage['hldj']);
                fun.setItem(html_name + '_xsmx', search_storage['xsmx']);

                //汇总功能
                search_data['group'] = param.hz['group'] || '';
                search_storage['hz'] = param.hz;
                fun.setGroupCondition(search_data, 'jjdw_id,jjdw_mc');

                var hc = param['hz']['choose'];
                fun.setItem(_html_name + 'group', search_data['group']);
                fun.setItem(_hz + 'kh', hc['kh']);
                fun.setItem(_hz + 'dh', hc['dh']);
                fun.setItem(_hz + 'md', hc['md']);
                fun.setItem(_hz + 'cp', hc['cp']);
                fun.setItem(_hz + 'ys', hc['ys']);
                fun.setItem(_hz + 'fkkz', hc['fkkz']);
                fun.setItem(_hz + 'gg', hc['gg']);
                fun.setItem(_hz + 'hsdj', hc['hsdj']);
                fun.setItem(_hz + 'text', param.hz['text']);
                fun.setItem(html_name + 'sideslip', true);
                // $('#order_list').empty();
                // page_list = [];
                getList(search_data);
                break;
            case 'refresh':
                // $('#order_list').empty();
                // page_list = [];
                getList(search_data);
                break;
        }

    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });

    // 开启实售价后显示
    if ($.nui.isTrue(SYS_CONFIG.qyssjms_bp)) {
        $('#sszl').css('display', 'block');
    }
}
fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip')
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [{
            key: "kh",
            "text": "客户",
            "value": (search_storage['kh'] && search_storage['kh']['text']) || "",
            "id": (search_storage['kh'] && search_storage['kh']['id']) || 0,
        }, {
            key: "cp",
            "text": "产品",
            "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
            "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
        }, {
            key: "cp_lb",
            "text": "产品类别",
            "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
            "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
        }, {
            key: "ck",
            "text": "仓库",
            "value": (search_storage['ck'] && search_storage['ck']['text']) || "",
            "id": (search_storage['ck'] && search_storage['ck']['id']) || 0,
        }, {
            key: "md",
            "text": "门店",
            "value": (search_storage['md'] && search_storage['md']['text']) || "",
            "id": (search_storage['md'] && search_storage['md']['id']) || 0,
        },
        {
            key: "hz",
            "text": "汇总",
            "group": [
                // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                { key: 'dh', name: '单号', columns: hz_group_columns.dh, choose: getHz('dh') },
                { key: 'kh', name: '客户', columns: hz_group_columns.kh, choose: getHz('kh') },
                { key: 'cp', name: '产品', columns: hz_group_columns.cp, choose: getHz('cp') },
                { key: 'ys', name: '颜色', columns: hz_group_columns.ys, choose: getHz('ys') },
                { key: "hsdj", name: '单价', columns: hz_group_columns.hsdj, choose: getHz('hsdj') },
                { key: "fkkz", name: '幅宽克重', columns: hz_group_columns.fkkz, choose: getHz('fkkz') },
                { key: "gg", name: '规格', columns: hz_group_columns.gg, choose: getHz('gg') }
            ],
            "value": getVal('hz', 'text'),
        }
        ],
        'xs': [
            {
                "key": 'djlx',
                "text": "单据类型",
                "xsType": (fun.getItem(html_name + '_' + 'djlx') || 'bp_xsfhjs,bp_xsthjs'),
                "list": [
                    {
                        'name': '发货',
                        'column': 'bp_xsfhjs',
                        'is_choose': fun.getItem(html_name + '_' + 'bp_xsfhjs') == 0 ? 0 : 1
                    },
                    {
                        'name': '退货',
                        'column': 'bp_xsthjs',
                        'is_choose': fun.getItem(html_name + '_' + 'bp_xsthjs') == 0 ? 0 : 1
                    },
                ],
                "alone": false,
                "value": (fun.getItem(html_name + '_' + 'djlx_text') || "发货、退货"),
            }],
        "switch": [{
            "text": "隐藏已审核单据",
            "max_width": true,
            "key": "ycysh",
            "value": (!!fun.getItem(html_name + '_ycysh') ? fun.getItem(html_name + '_ycysh') : 0)
        }, {
            "text": "显示明细数据",
            "max_width": true,
            "key": "xsmx",
            "value": (!!fun.getItem(html_name + '_xsmx') ? fun.getItem(html_name + '_xsmx') : 0)
        }, {
            "text": "合拢单据",
            "max_width": true,
            "key": "hldj",
            "value": (!!fun.getItem(html_name + '_hldj') ? fun.getItem(html_name + '_hldj') : 0)
        }],
    }
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

// 退货结算-开单
$('body').on('tap', '.increase-retreat', function () {
    //未开账不能开单
    if (!fun.checkKz()) return;

    PageShow.xsthjs();
});

// 发货结算-开单
$('body').on('tap', '.increase-come', function () {
    //未开账不能开单
    if (!fun.checkKz()) return;

    PageShow.xsfhjs();
});

// 月份选择
var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            // $('#order_list').empty();
            // page_list = [];
            getList(search_data);
        }
    });

// 获取汇总选中值
function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

// 获取汇总文本
function getVal(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

/** 获取发退货结算数据
 * @param {*} data
 */
function getList(data) {
    page_list = [];
    //暂时使用这种方式访问api接口，如果没有这个就会访问不到
    data['djlx'] = search_data['djlx'] || ["bp_xsfhjs", "bp_xsthjs"];
    data['group'] = fun.groupRepeat(data['group'] || "");
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpXsfthjstj,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj1').text(0);
                    $('#tj2').text(0);
                    $('#tj3').text(0);
                    $('#tj4').text(0);
                    $('#tj5').text(0);
                    $('#real_num').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: '#order_list', btnShow: false, style: 'top:0rem;height:9rem;' });
                }
                ztj_data = res['info'];
                fun.clearPage($('#order_list'));
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createKeysValueFun: function (obj) {
                        return {
                            "wldw_mc": obj['wldw_mc'],
                            "md_id": obj['md_id'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "is_sh": obj['is_sh'],
                            "dj_je": obj['dj_je'],
                            "dj_ps": obj['dj_ps'],
                            "dj_zsl": obj['dj_zsl'],
                            "zdw_mc_tmp": obj['zjjdw_mc'],  // 计价单位名称
                            "djlx": obj['djlx'],
                        };
                    }
                });

                showList(fun.PagingData(page_list) || [], true);
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}


function showList(data) {
    var sshkzl = $.nui.decimalSub(ztj_data['zje'], ztj_data['sszje']);
    $('#tj1').text(ztj_data['ps'] || 0);
    // $('#tj2').text(ztj_data['zsl'] || 0);
    $('#tj2').text(ztj_data['jjsl'] || 0);
    $('#tj3').text(ztj_data['hszje'] || 0); //含税总金额
    $('#tj4').text(ztj_data['sszje'] || 0);
    $('#tj5').text(sshkzl || 0);
     $('#real_num').text(ztj_data['sssl'] || 0);

    // var kzxx = JSON.parse(fun.getItem('sys_config')['kzxx']); //获取开账信息
    // kzxx = JSON.stringify(kzxx['cbhs'])
    // switch(JSON.parse(kzxx)) {
    //     case 'hs':
    //         $('#tj3').text(ztj_data['je'] || 0); //总金额
    //         break;
    //     case 'bhs':
    //         break;
    // }
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !search_storage['hldj'],
        isNoExpand: search_storage['xsmx'],
        showLog: false,
        render: {
            titlebar: function (res) {
                return fthStatistics.createTitlebar(res, {
                    showPrice: true,
                    search_data: search_data,
                    jsjeText: '应收'
                });
            },
            subtitle: function (res) {
                return fthStatistics.createSubtitle(res, {
                    search_data: search_data
                });
            },
            subdata: function (res) {
                return fthStatistics.createSubdata(res, {
                    search_data: search_data,
                    showPrice: true,
                    ps_tmp: res.ps,
                    sl_tmp: res.jjsl,
                    dw_tmp: res.jjdw_mc,
                    zje: fun.is_value(res.zje, 0),  // 总金额
                    ssdj: res.ssdj,                               // 实售单价
                    sszje: res.sszje,                             // 实售总金额
                    SYS_CONFIG: SYS_CONFIG
                });
            }
        },
    });

}

fun.tjContentTap(function (dj_data) {
    if (!fun.checkKz()) return;

    var page_url;
    if (!Auth.check(dj_data['djlx'], 'view')) return;
    switch (dj_data['djlx']) {
        case 'bp_xsfhjs': //发货结算
            page_url = page_arr.xs_fhjs_kd;
            break;
        case 'bp_xsthjs': //退货结算
            page_url = page_arr.xs_thjs_kd;
            break;
    }

    if ($.nui.isEmpty(dj_data['dj_id'])) return;

    fun.showPageFull({
        page_url: page_url,
        pageParam: {
            return_page: html_name,
            id: dj_data['dj_id'] || 0,
        }
    });
});


$('body').on('click', '.row-list', function () {
    if (fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var list = $(this).children('.summary').children('.summary-content').data('list');
    if ($.nui.isEmpty(list['dj_id'])) return;
    var page_url;
    if (!Auth.check(list['djlx'], 'view')) return;
    switch (list['djlx']) {
        case 'bp_xsfhjs': //发货结算
            page_url = page_arr.xs_fhjs_kd;
            break;
        case 'bp_xsthjs': //退货结算
            page_url = page_arr.xs_thjs_kd;
            break;
    }

    fun.showPageFull({
        page_url: page_url,
        pageParam: {
            return_page: html_name,
            id: list['dj_id']
        }
    });
})