var html_name = page_arr.xs_khfx,
    date_arr = fun.getDateArr(),
    to_month = fun.getMonthArr(1)[0],
    xsph_search = {
        'begin_time': fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        'end_time': fun.Date(to_month['end_date']).Format('yy-mm-dd'),
        'order': {
            'xse': "desc",
        }
    },
    date_bar = $('#date_bar').dateBar({ //日期选择插件
        'data': date_arr,
        'tap': function (ret) {
            xsph_search['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            xsph_search['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getList();
        }
    }),
    lsfx_search = {
        'type': 'kh_ls',
        'lsts': 0
    },
    page_index = 'xsph',
    opt_data = {};
// var fx_lsts = '';
// page_list = [];
var USER_INFO = {};
var SYS_CONFIG = {};
var lastClick = 0;
var search_time = {};
$('#header').header({
    back: true,
    title: '客户分析',
    filter: true,
});
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    SYS_CONFIG = fun.getItem('sys_config') || {};

    init();
    // 判断是否从销售情况页面跳转过来
    if ('search_time' in page_data){
        xsph_search['begin_time'] = page_data.search_time['begin_time'];
        xsph_search['end_time'] = page_data.search_time['end_time'];
        $('.main-color').removeClass('main-color');
        date_bar.setDate({
            "begin_date": page_data.search_time['begin_time'],
            "end_date": page_data.search_time['end_time'],
        });
    };
    // console.log(JSON.stringify(SYS_CONFIG['khlsts']))
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));
    xsph_search['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    xsph_search['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    lsfx_search['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    lsfx_search['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    lsfx_search['lsts'] = (SYS_CONFIG['khlsts'] || 0);
    if (!!page_data['type']) {
        $('.lsfx_layout').addClass('choice').siblings().removeClass('choice');
        page_index = $('.lsfx_layout').attr('index');
        var index = $('.lsfx_layout').index();
        $('.switch').hide();
        $('.switch:eq(' + index + ')').show();
        getList();
    }
    if (page_data['wldw_id'] && page_data['wldw_mc']) {
        xsph_search['wldw_id'] = page_data['wldw_id'];
        xsph_search['wldw_mc'] = page_data['wldw_mc'];
        opt_data['xsph_wldw_id'] = page_data['wldw_id'];
        opt_data['xsph_wldw_mc'] = page_data['wldw_mc'];

        lsfx_search['wldw_id'] = page_data['wldw_id'];
        lsfx_search['wldw_mc'] = page_data['wldw_mc'];
        opt_data['lsfx_wldw_id'] = page_data['wldw_id'];
        opt_data['lsfx_wldw_mc'] = page_data['wldw_mc'];
    }
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret['value'],
            data = temp['data'];
        switch (temp['status']) {
            case "search":
                //搜索条件缓存
                opt_data[page_index + '_wldw_id'] = data['kh']['id'];
                opt_data[page_index + '_md_id'] = data['md']['id'];
                opt_data[page_index + '_wldw_mc'] = data['kh']['text'];
                opt_data[page_index + '_md_mc'] = data['md']['text'];

                if (page_index == "xsph") {  //销售排行搜索条件
                    xsph_search['begin_time'] = data['begin_date'];
                    xsph_search['end_time'] = data['end_date'];
                    xsph_search['order'] = {
                        xss: (data['xss_sort'] || ""),
                        xse: (data['xse_sort'] || "")
                    };
                    xsph_search['wldw_id'] = (data['kh']['id'] || 0);
                    xsph_search['md_id'] = (data['md']['id'] || 0);
                    date_bar.setDate({
                        "begin_date": fun.Date(xsph_search['begin_time']).Format('yy-mm-dd'),
                        "end_date": fun.Date(xsph_search['end_time']).Format('yy-mm-dd'),
                    });
                } else if (page_index == "lsfx") { //流失分析搜索条件
                    lsfx_search['wldw_id'] = (data['kh']['id'] || 0);
                    lsfx_search['md_id'] = (data['md']['id'] || 0);

                    // fun.setItem(html_name + '_lsts', data['input']['value']);
                    lsfx_search['lsts'] = data['input']['value'] || 0;

                    lsfx_search['order'] = {
                        lsts: (data['lsts_sort'] || ""),
                        qk: (data['qk_sort'] || "")
                    }
                }
                fun.setItem(html_name + 'sideslip', true);
                getList();
                break;
        }
    });

    // fun.scrollToBottom({}, function () {
    //     if (page_list.length > 0) {
    //         showList(fun.PagingData(page_list) || []);
    //     }
    //     else {
    //         fun.createBottomLine('order_list', ".list-wrap");
    //     }
    // });
    getList();

    bindEvnet();
}

// 初始化函数
function init() {
    xsphInit();
}

// 销售分析页面初始化距离
function xsphInit() {
    $('.rankings-top').css({
        top: (api.safeArea.top + $('#header').outerHeight() + $('.top-half').outerHeight()) - parseFloat($('html').css('fontSize'))
    })
    $('.rankings-content').css({
        marginTop: parseFloat($('.rankings-top').css('top')) + $('.rankings-top').outerHeight()
    })
}

function lsfxInit() {
    $('.top').css({
        top: parseFloat($('.rankings-top').css('top'))
    })
}

function getList() {
    var params = (page_index == "xsph") ? xsph_search : lsfx_search;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getKhfxList,
        data: $.extend({}, {
            "begin_time": "",
            "end_time": "",
            "group": "wldw_id,wldw_mc",
            "md_id": 0,
            "wldw_id": 0,
            "wldw_lb_id": 0,
            "type": ((page_index == "xsph") ? "kh_pm" : "kh_ls")
        }, params),
        success: function (res) {
            if (res['status'] == 0) {
                if (res['data'].length == 0) {
                    if (page_index == "xsph") {
                        $('#zxse').text(0);
                    } else {
                        $('#zqk').text(0);
                        $('#count').text(0);
                    }
                    var obj = ((page_index == "xsph") ? "#rankings_list" : "#lsfx_list");
                    // return $(obj).html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: obj, btnShow: false,style:"top:10rem;"});
                }
                var data = res['data'] || [],
                    info = res['info'] || {};
                // console.log(JSON.stringify(info))
                $('#zxse').text((info['xse'] || 0));
                $('#zqk').text((info['qk'] || 0));
                $('#count').text((info['count'] || 0));
                showList(data);
            }
        }
    })
}

//显示列表
function showList(data) {
    // console.log(JSON.stringify(data))
    // console.log(JSON.stringify(lsfx_search))
    var html = [];
    switch (page_index) {
        case "xsph":
            var img_name = ["jp.png", "yp.png", "tp.png"];
            html.push('<div class="rankings-title lower-border-line">');
            html.push('     <div class="rankings-text">排名</div>');
            html.push('     <div class="right-text">');
            html.push('         <div class="rankings-text2">客户名称</div>');
            html.push('         <div class="rankings-text3">销售数</div>');
            html.push('         <div class="rankings-text4">销售额</div>');
            html.push('     </div>');
            html.push('</div>');
            $(data).each(function (i, obj) {
                html.push('<div wldw_mc="' + obj['wldw_mc'] + '" wldw_id="' + obj['wldw_id'] + '" class="rankings-list-item lower-border-line">');
                html.push('<div class="rankings-ranking">');
                (i >= 3) && html.push(i + 1 + ".");
                (i < 3) && html.push('<img src="../img/' + img_name[i] + '" />');
                html.push('</div>');
                html.push('<div class="right-text">');
                html.push('    <div class="rankings-name">' + (obj['wldw_mc'] || "") + '</div>');
                html.push('    <div class="sales-number">');
                html.push('        <div class="rankings-number2">' + (obj['xss'] || 0) + '</div>');
                html.push('        <div class="rankings-number3">' + (obj['xsp'] || 0) + '匹</div>');
                html.push('    </div>');
                html.push('    <div class="sales-volume">');
                html.push('        <div class="rankings-sum">' + (obj['xse'] || 0) + '</div>');
                html.push('        <i class="iconfont icon-youfanhui rankings-youfanhui"></i>');
                html.push('    </div>');
                html.push('</div>');
                html.push('</div>');
            })
            $('#rankings_list').html(html.join(''));
            break;
        case "lsfx":
            $(data).each(function (k, obj) {
                html.push('<li class="term lower-border-line" id="details" wldw_mc="' + obj['wldw_mc'] + '" wldw_id="' + obj['wldw_id'] + '">');
                html.push('    <div class="left-content">');
                html.push('        <div class="first-line">');
                html.push('            <span class="sort">' + (k + 1) + '.</span>');
                html.push('            <div class="left-box">');
                html.push('                 <span class="word">' + fun.is_value(obj['wldw_mc']) + '</span>');
                html.push('            </div>');
                html.push('            <div class="right-box">');
                html.push('                 <span class="word2">无往来</span>');
                html.push('                 <span class="word3">' + fun.is_value(obj['lsts']) + '天</span>');
                // html.push('                 <span class="day">天</span>');
                html.push('            </div>');
                html.push('        </div>');
                (obj['md_mc'] || obj['ywy_mc'] || obj['lxr_mc'] || obj['lxr_sj']) ? html.push('        <div class="lines">') : html.push('        <div class="lines" style="margin-bottom: 0.25rem;">');
                html.push('            <div class="left-box pad-left">');
                html.push('                 <span class="credit">信誉额</span>');
                html.push('                 <span class="credit-amount">' + (obj['xye'] || 0) + '</span>');
                html.push('            </div>');
                html.push('            <div class="right-box">');
                html.push('                 <span class="arrears">欠款</span>');
                html.push('                 <span class="current-arrears">' + (obj['qk'] || 0) + '</span>');
                html.push('            </div>');
                html.push('        </div>');
                if (obj['lxr_mc'] || obj['lxr_sj']) {
                    (obj['md_mc'] || obj['ywy_mc']) ? html.push('        <div class="lines">') : html.push('        <div class="lines" style="margin-bottom: 0.25rem;">');
                    html.push('            <span class="contacts pad-left">' + fun.is_value(obj['lxr_mc']) + '</span>');
                    html.push('            <span class="telephone">' + fun.is_value(obj['lxr_sj']) + '</span>');
                    (obj['lxr_sj'] && obj['lxr_sj'] != "") ? html.push('            <i class="iconfont icon-dianhua dianhua" data-dial="' + fun.is_value(obj['lxr_sj']) + '"></i>') : '';
                    html.push('        </div>');
                }
                if (obj['md_mc'] || obj['ywy_mc']) {
                    html.push('        <div class="lines" style="margin-bottom: 0.25rem;">');
                    html.push('            <span class="contacts pad-left">' + fun.is_value(obj['md_mc']) + '</span>');
                    if ($.nui.isTrue(obj['md_mc'])) {
                        html.push('            <span class="telephone">' + fun.is_value(obj['ywy_mc']) + '</span>');
                    } else {
                        html.push('            <span class="telephone pad-left">' + fun.is_value(obj['ywy_mc']) + '</span>');
                    }
                    (obj['ywy_mc'] && obj['ywy_mc'] != "") && html.push('            <span class="fuze">负责</span>');
                    html.push('        </div>');
                }
                html.push('    </div>');
                html.push('    <div class="right-content">');
                html.push('        <i class="iconfont icon-youfanhui youfanhui"></i>');
                html.push('    </div>');
                html.push('</li>');
            })
            $('#lsfx_list').html(html.join(''));
            break;
    }
}

fun.setItem(html_name + 'sideslip', true);

function setoption() {
    // console.log(JSON.stringify(SYS_CONFIG['khlsts']))
    var options = {};
    var sideslip = fun.getItem(html_name + 'sideslip');
    if (page_index == 'xsph') {

        options = {
            "time": {
                "begin_date": xsph_search['begin_time'],
                "end_date": xsph_search['end_time']
            },
            "choose_merchants": [{
                "key": "kh",
                "id": is_opt('wldw_id'),
                "text": "客户",
                "value": is_opt('wldw_mc')
            }, {
                "key": "md",
                "id": is_opt('md_id'),
                "text": "门店",
                "value": is_opt('md_mc')
            }],
            "sort": [{
                "text": "销售数",
                "key": "xss_sort",
                "value": ((xsph_search && xsph_search['order']) ? xsph_search['order']['xss'] : "")
            }, {
                "text": "销售额",
                "key": "xse_sort",
                "value": ((xsph_search && xsph_search['order']) ? xsph_search['order']['xse'] : "")
            }],
        };
    } else {
        // var fx_lsts = fun.getItem(html_name+'_lsts') || (SYS_CONFIG['khlsts'] || 0);
        options = {
            "choose_merchants": [{
                "key": "kh",
                "id": is_opt('wldw_id'),
                "text": "客户",
                "value": is_opt('wldw_mc')
            }, {
                "key": "md",
                "id": is_opt('md_id'),
                "text": "门店",
                "value": is_opt('md_mc')
            }, {
                "key": "input",
                "id": 0,
                "title": "无往来",
                "text": "天",
                "value": lsfx_search['lsts'] || 0
            }],
            "sort": [{
                "text": "无往来",
                "key": "lsts_sort",
                "value": ((lsfx_search && lsfx_search['order']) ? lsfx_search['order']['lsts'] : "")
            }, {
                "text": "欠款",
                "key": "qk_sort",
                "value": ((lsfx_search && lsfx_search['order']) ? lsfx_search['order']['qk'] : "")
            }],
        };
    }

    function is_opt(key) {
        return ((opt_data && opt_data[page_index + '_' + key]) ? opt_data[page_index + '_' + key] : "");
    }

    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
}

// 初始化事件
function bindEvnet() {
    //拨打电话
    $('body').on('tap', '.dianhua', function () {
        event.stopPropagation();
        var number = $(this).data('dial');
        // console.log(number)
        if ($.nui.isTrue(number) && fun.regCheck(number, 'phone')) {
            api.call({
                type: 'tel_prompt',
                number: number
            });
        } else {
            fun.toast('手机号码有误！无法拨打电话.');
        }
        return false;
    });

    //切换
    $('.layout').on('tap', fun.debounce(function () {
        if (lastClick === $(this).index()) return;
        lastClick = $(this).index();
        $(this).addClass('choice').siblings().removeClass('choice');
        page_index = $(this).attr('index');
        var index = $(this).index();
        switch (index) {
            case 0:
                // xsphInit()
                break;
            case 1:
                $('.content').css('marginTop', parseFloat($('.rankings-top').css('top')) + $('.top').outerHeight())
                lsfxInit();
                break;
            // 没有default
        }

        $('.switch').hide();
        $('.switch:eq(' + index + ')').show();
        getList();
    }, 300));

    //销售-客户分析-产品
    $('body').on('tap', '.rankings-list-item', function () {
        fun.showPageFull({
            page_url: page_arr.xs_khfx_cp,
            pageParam: {
                begin_time: xsph_search['begin_time'],
                end_time: xsph_search['end_time'],
                wldw_mc: $(this).attr('wldw_mc'),
                wldw_id: $(this).attr('wldw_id')
            }
        });
    })

    //销售-客户分析-详情
    $('body').on('tap', '#details', function () {
        fun.showPageFull({
            page_url: page_arr.xs_khfx_xq,
            pageParam: {
                page_index: 'xfxg',
                wldw_mc: $(this).attr('wldw_mc'),
                wldw_id: $(this).attr('wldw_id')
            }
        });
    })

    //打开搜索页
    $('body').on('tap', '#filter_btn', function () {
        setoption();
        // $('#lsfx_ts').attr("disabled","false");
    })
}