var html_name = page_arr.xs_xsbj_kd;
var id, dh, getData = {
    dj: {
        bz: '',
        lxr: '',
        lxr_dh: '',
        lxr_dz: '',
        wldw_id: ''
    },
    jl: []
};
var origin_data = {
    dj: { bz: '', lxr: '', lxr_dh: '', lxr_dz: '', wldw_id: '' },
    jl: []
}, save_data = {}, data_text;
var begin_lCalendar = new lCalendar();
var fsh = fun.getItem('sys_config')['fsh'];
var selectIndex; // 选择编辑的数组下标
var xs_xsbj_kd = {
    deleteRows: [], // 需要逻辑删除的行记录
    fz_ys: [], // 辅助颜色信息
    fz_cp: []  // 辅助产品信息
};
//
Bills['AJAX_URL'] = { getDj: AJAX_URL.getBpXsDjAndScdj };
Bills['djlx'] = 'bp_xsbj';

Bills['__post_sign'] = $.nui.getRandomNum();

var AUTH_EDIT = Auth.check('bp_xsbj', 'edit');
var AUTH_SH = Auth.check('bp_xsbj', 'check');
var AUTH_ZF = Auth.check('bp_xsbj', 'invalid');

page_init = function () {
    // fun.keyboardEject('.base2');
    // console.log(html_name, page_data);

    id = page_data['id'];
    page_data.return_page = page_arr.xs_xsbj_cx;            // 指定返回页面

    page_data.keyback = function () {
        isDataChange();
    };

    xs_xsbj_kd.initHeader();
    xs_xsbj_kd.initHeaderAfter();
    dateSelect();

    __init();

    khSelect();   // 客户搜索

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        console.log('addEventListener');
        console.log(temp);
        switch (temp['status']) {
            case 'select_list':
                temp.data.id = Number(temp.data.id);
                if (temp.data.page_type === 'xz_lxr') { // 选择联系人
                    if (temp.data.id !== 0 && getData.dj.wldw_id !== temp.data.id) {
                        // 联系人信息
                        xs_xsbj_kd.setLxr(temp.data.list_data);
                        xs_xsbj_kd.dataChangeShowSaveBtn(); // 数据发生改变显示保存按钮
                    }
                } else if (temp.data.page_type === 'kh') {  // 选择往来单位
                    if (temp.data.id !== 0 && getData.dj.wldw_id !== temp.data.id) {
                        page_data['type'] = temp['data']['page_type'];
                        $('#wldw').val(temp['data']['select_val']);
                        getData.dj.wldw_id = temp['data']['id'];
                        getData.dj.wldw_mc = temp['data']['select_val'];
                        // 获取辅助色号/颜色，产品辅助编号/名称
                        Bills.wldw = { id: temp['data']['id'] };
                        xs_xsbj_kd.apiGetFzInfo();
                        // 读取单价、上次价、标准价、最低价
                        xs_xsbj_kd.getBpXsDjAndScdj({
                            status: true
                        });
                    }
                }
                break;
            case 'update_rows':      // 编辑时添加记录
                getData.jl = temp.data.__JL_DATA;
                // 重新渲染数据
                showData2(getData.jl);
                showData1(getData.dj);
                break;
            case 'update':  // 记录修改
                eventUpdate(temp.row);
                break;
            case 'refresh_dj':
                __init();
                break;
        }

        xs_xsbj_kd.checkStatusShowSaveBtn(temp['status']);
    });
};

function __init() {
    $('button').hide();
    if ($.nui.isTrue(page_data['id'])) {
        getApiData(page_data);
    } else {
        if (page_data.data) {
            getData.jl = page_data.data.list;
        }
        if (page_data.__DJ_DATA) {
            getData.dj = page_data.__DJ_DATA;
            Bills.wldw = { id: getData.dj.wldw_id };
            xs_xsbj_kd.apiGetFzInfo();
        }

        $('#wldw').val(getData.dj.wldw_mc || '');

        showData2(getData.jl);
        showData1(getData.dj);
        $('#del_btn').hide();

        getDh();
    }
}

function dateSelect() {
    begin_lCalendar.init({
        'trigger': '#kdsj',
        'type': 'datetime',
        'callback': function (date) {
            // if ($('#kdsj').text().trim() === fun.formatDate(date)) return;
            getData.dj.kdsj = fun.formatDate(date, 'YYYY-MM-DD HH:mm');
            $('#kdsj').text(fun.formatDate(date));
            // 日期变化加载价格
            xs_xsbj_kd.getBpXsDjAndScdj({
                status: false,
                get_dj: false
            });
        }
    });
}

//获取数据
function getApiData(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpxsbjInfo,
        data: {
            id: page_data['id']
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    data_text = res.data.dj;
                    origin_data = JSON.parse(JSON.stringify(res.data));

                    getData = res.data;

                    // xs_xsbj_kd.initHeader();
                    xs_xsbj_kd.initHeaderAfter();

                    begin_lCalendar.disabled = false;
                    $('input,#kdsj').removeAttr('disabled');
                    $('.storehouse').addClass('swipe-delete');

                    showData2(res.data.jl);
                    showData1(res.data.dj);

                    if (!Auth.check('bp_xsbj', 'edit') || res.data.dj['is_sh']) {
                        // dateSelect();
                        begin_lCalendar.disabled = true;
                        $('#kdsj').attr('disabled', true);
                    }

                    // 获取辅助信息
                    if (!getData.dj.is_sh) {
                        Bills.wldw = { id: getData.dj.wldw_id };
                        xs_xsbj_kd.apiGetFzInfo({
                            lxr: data_text.lxr,
                            lxr_dh: data_text.lxr_dh,
                            lxr_dz: data_text.lxr_dz
                        });
                    }

                    origin_data = JSON.parse(JSON.stringify(getSaveData()));

                    break;
                default:
                    fun.alert({ msg: '网络异常' });
                    break;
            }
        }
    })
}

// 获取联系人信息 / 获取辅助信息
xs_xsbj_kd.apiGetFzInfo = function (lxr) {
    // 已有联系人信息，不加载
    var loadLxr = true;
    if (!$.isEmptyObject(lxr)) {
        loadLxr = false
    }

    __getWldwSubInfo({
        ljqk: true,
        fz_cp: true,
        fz_ys: true,
        lxr: loadLxr,
        callback: function (res) {
            fun.hideLoad();
            // 联系人
            if (loadLxr) {
                if (res.lxr && res.lxr.length) { // 修改时，已有联系人信息
                    xs_xsbj_kd.setLxr(res.lxr[0]);
                } else {
                    xs_xsbj_kd.setLxr({});
                }
            } else {
                xs_xsbj_kd.setLxr(lxr, true);
            }

            // 辅助色号/颜色
            xs_xsbj_kd.fz_ys = res.fz_ys || [];
            fun.setFzys(xs_xsbj_kd.fz_ys, getData.jl);

            // 辅助编号/产品
            xs_xsbj_kd.fz_cp = res.fz_cp || [];
            fun.setFzcps(xs_xsbj_kd.fz_cp, getData.jl);
        }
    });
};

xs_xsbj_kd.setLxr = function (lxr, useDefault) {
    if (useDefault) {
        getData.dj.lxr = lxr.lxr;
        getData.dj.lxr_dh = lxr.lxr_dh;
        getData.dj.lxr_dz = lxr.lxr_dz;
    } else {
        // 联系人信息
        if (!$.isEmptyObject(lxr)) {
            // res.lxr[0].mobile  // res.lxr[0].name // res.lxr[0].province/city/area/address
            getData.dj.lxr = lxr.name;
            getData.dj.lxr_dh = lxr.mobile || lxr.phone;
            getData.dj.lxr_dz = lxr.province + lxr.city + lxr.area + lxr.address;
        } else {
            getData.dj.lxr = '';
            getData.dj.lxr_dh = '';
            getData.dj.lxr_dz = '';
        }
    }

    $('#lxr').val(getData.dj.lxr);
    $('#sj').val(getData.dj.lxr_dh);
    $('#dz').val(getData.dj.lxr_dz);
};

// 获取产品单价、上次价、标准价、最低价、最低价
xs_xsbj_kd.getBpXsDjAndScdj = function (params) {

    var get_dj = typeof params.get_dj === 'undefined' ? true : params.get_dj;

    __getDjInfo = function () {
        return {
            wldw_id: getData.dj.wldw_id,
            kdsj: $('#kdsj').text()
        }
    };

    __getJlData = function () {
        return getData.jl;
    };

    // 更新成本价
    __updateJlDataByIndex = function (item) {
        var upateItem = getData.jl[item.index];

        upateItem.bzj = item.data.bzj;
        upateItem.scdj = item.data.scdj;
        upateItem.zdj = item.data.zdj;

        upateItem.dj = typeof item.data.dj === 'undefined' ? upateItem.dj : item.data.dj;

        if (params['status']) {
            upateItem.hsdj = item.data.dj;
        }

        // 计算汇总金额hsje
        if (upateItem.jjsl && upateItem.hsdj) {
            upateItem.hsje = upateItem.jjsl * upateItem.hsdj;
        } else {
            upateItem.hsje = 0;
        }
        upateItem.je = upateItem.hsje;
        upateItem.zje = upateItem.hsje;
        // upateItem.hszje = upateItem.hsje;
    };

    __getAllDj({
        get_dj: get_dj,
        get_scdj: true,
        callback: function () {
            // 重新渲染数据
            showData2(getData.jl);
            showData1(getData.dj);
            xs_xsbj_kd.dataChangeShowSaveBtn(); // 数据发生改变显示保存按钮
        }
    });
};

xs_xsbj_kd.rowDeleteHandler = function (row, key) {
    xs_xsbj_kd.isDeleteRows = true;
    if ($.nui.isEmpty(key)) {
        key = 'id';
    }
    if (row && $.nui.isTrue(row[key])) {
        row.is_delete = 1;
        if (row.mx && row.mx.length) { // 明细记录也设置删除状态
            for (var i = 0; i < row.mx.length; i++) {
                row.mx[i].is_delete = 1;
            }
        }
        xs_xsbj_kd.deleteRows.push(row);
    }
};

//固定数据
function showData1(data, btnChange) {
    // 联系人信息
    $('.subtitle').text(data['dh']);
    $('#lxr').val(getData.dj.lxr);
    $('#sj').val(getData.dj.lxr_dh);
    $('#dz').val(getData.dj.lxr_dz);
    $('#bz').val(data['bz'] || '');
    $('#hszje').text(data['hsje'] || 0);

    if ('kdsj' in data) { // 有修改时间才显示
        var kdsj = fun.formatDate(data['kdsj']);
        $('#kdsj').text(kdsj);
    }

    page_data['id'] && $('#del_btn').show();

    if (AUTH_EDIT) {                            // 有编辑权限
        $('.saves,.choice').show();
    }

    if (data.is_sh) { // 已审核
        $('#bz').attr('disabled', 'disabled');

        if (!data.is_zf) {
            if (AUTH_ZF && fsh) {    // 未作废、有作废权限并且【系统设置-反审核】有开启
                $('.obsolete').show();
            }
            if (AUTH_ZF && !fsh) {  // 未作废、有作废权限并且【系统设置-反审核】没有开启
                // $('.revocatory').show();
            }
        }
    } else {                                     // 未审核
        if (page_data.id && AUTH_SH) {           // 有审核权限
            $('.audit').show();
            $('.saves').hide();
            xs_xsbj_kd.inputBindEvent();
        }
    }


    if (!AUTH_EDIT || data['is_sh']) {
        $('input').attr('disabled', true);
        $('#del_btn,.saves,.choice').hide();
        $('.swipe-delete').removeClass('swipe-delete');
    }

    if (data['is_zf']) {
        fun.seal({ type: 'zf' });
    } else if (data['is_sh']) {
        fun.seal({ type: 'sh' });
    } else {
        if ($('body').find('#state_icon').length) $('body').find('#state_icon').remove();
    }

    if (data['is_zf']) {
        $('button').hide();
    }

    if (!AUTH_EDIT) { // 没编辑权限
        $('.right2').hide();
        $('.contents').css({
            paddingBottom: 0
        })
    }

    // 处理底部按钮显示问题
    // $('.right2 .button2:visible').css('width', 'calc(100% / ' + $('.right2 .button2:visible').length + ')');
}

//列表数据
function showData2(data) {

    console.log('--------------update_rows');
    console.log(JSON.stringify(data));
    console.log('--------------update_rows');

    var Html = [];
    var hszje = 0;

    for (var i = 0; i < data.length; i++) {
        var data_list = data[i];
        var dzts = '', jjsl = '';

        Html.push(' <li class="store-info fixed-high fixed">');
        Html.push('     <div class="le clearfix">');
        Html.push('      <div class="store-content" data-index=\'' + i + '\'>');

        Html.push('         <p class="store-name">' + xs_xsbj_kd.productName(data_list) + '</p>');

        if (fun.getKdSetting('fk')) {
            Html.push('<span>幅宽<i class="info-date">' + fun.is_value(data_list['fk']) + '</i></span>');
        }
        if (fun.getKdSetting('kz')) {
            Html.push('<span>克重<i class="info-date">' + fun.is_value(data_list['kz']) + '</i></span>');
        }
        if (data_list['lx'] === '定做' && data_list['dzts'] > 0) {
            dzts = fun.is_value(data_list['dzts']) + '天';
        }

        fun.is_value(data_list['lx']) && Html.push('         <span><i class="info-date offer-data">' + fun.is_value(data_list['lx']) + '<i>' + fun.is_value(dzts) + '</i></i></span>');
        // Html.push('         <span>成分<i class="info-date">' + data_list['cf'] + '</i></span>');
        // Html.push('         <span><i></i></span><span><i></i></span>');
        Html.push('         <span>单价<i class="info-date unitprice">' + Number(data_list['hsdj']).fixed() + '</i></span>');

        if (data_list.jjsl) {
            jjsl = fun.is_value(data_list.jjsl, 0);
        }

        Html.push(!!jjsl ? '         <span>计价<i class="info-date">' + jjsl + '<i class="unit">' + fun.is_value(data_list.jjdw_mc) + '</i></i></span>' : '');

        Html.push(!!data_list['hsje'] ? '         <span class="price"><i>￥</i>' + Number(data_list['hsje']).fixed(4) + '</span>' : '');
        Html.push('       </div>');
        if (getData.dj.is_sh) {
            Html.push('         <span style="width: 100%">备注 <i style="width: 80%;"  class="info-date">' + data_list.bz + '</i></span>');
        } else {
            Html.push('         <span style="width: 100%">备注 <input style="width: 80%;"  readonly="readonly" id="jl_bz_' + i + '" type="text" class="info-date" value="' + fun.is_value(data_list.bz) + '"></span>');
        }

        Html.push('       <div class="delete dels1 delete-btn" data-del_index="' + i + '"><b class="swipe-span">删除</b></div>');
        Html.push('     </div>');
        Html.push(' </li>');

        // hszje = $.nui.decimalAdd(hszje, data_list['hszje']);
    }

    // Html.push('         <div class="add-product"><i class="iconfont icon-tianjia"></i>&nbsp;添加产品</div>');

    // getData.dj.hszje = __bdjeSswr(hszje);
    $('#ul_list').html(Html.join(''));

    console.log('-----------');
    console.log($('#ul_list').html());
    console.log('-----------');
}

xs_xsbj_kd.initHeader = function () {
    var date = new Date();

    if ($.nui.isEmpty(page_data.id)) {
        date.setSeconds(0, 0);
        var current_date = fun.formatDate(date, 'YYYY-MM-DD HH:mm');
        origin_data.dj.kdsj = current_date;
        getData.dj.kdsj = current_date;
    }

    $('#header').header({
        back: true,                             // 返回
        // share: $.nui.isTrue( ),              // 分享
        // print: true,                         // 打印
        del: true, 	    // 删除
        title: '销售报价',                      // 标题
        appendBackBtnEvt: isDataChange,
        subtitle: getData.dj.dh || '&nbsp;',    // 副标题
        order_info: {
            show: true,
            person: getData.dj.zdr || fun.getItem('user_info')['name'],
            dateText: page_data['kdsj'] || fun.formatDate(date),
            // obj: getData.dj.wldw_mc || '点击选择客户'
        },
    });

    $('#wldw').val(getData.dj.wldw_mc || '');

    $('#del_btn').hide();
};

xs_xsbj_kd.initHeaderAfter = function () {
    var date = new Date();
    $('.subtitle').html(getData.dj.dh || '&nbsp;');
    $('#zdr').text(getData.dj.zdr || fun.getItem('user_info')['name']);
    $('#kdsj').text(fun.formatDate(page_data['kdsj']) || fun.formatDate(date));
    $('#wldw').val(getData.dj.wldw_mc || '');
}

function getDh() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBillsPageDefInfo,
        data: {
            'djlx': 'bp_xsbj',
            'table': 'bp_xsbj_dj'
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    dh = res.data.dh;
                    $('.subtitle').text(dh)
                    break;
                default:
                    fun.alert({ msg: '网络异常' });
                    break;
            }
        }
    })
}

function getSaveData() {

    var dj = {
        id: Number(page_data['id'] || 0),
        save_time: (!$.nui.isEmpty(data_text) ? data_text['save_time'] : ''),//保存时间
        jsr_id: (!$.nui.isEmpty(data_text) ? data_text['jsr_id'] : 0),//经手人id
        wldw_id: getData.dj.wldw_id || 0,//往来单位id
        zdr_id: origin_data.dj.zdr_id || fun.getItem('user_info')['id'],//制单人id
        md_id: fun.getItem('user_info')['store_id'] || 0,//门店id
        kdsj: fun.formatDate($('#kdsj').text().trim(), 'YYYY-MM-DD HH:mm'),// 开单时间
        dj_lsh: (!$.nui.isEmpty(data_text) ? data_text['dj_lsh'] : 0),//单据流水号
        // zje: __bdjeSswr(Number($('#hszje').text().trim() || 0)),//总金额
        // hszje: __bdjeSswr(Number($('#hszje').text().trim() || 0)),//含税总金额
        dh: $('.subtitle').text().trim() || '',//单号
        bz: $('#bz').val().trim() || '',
        // 联系人信息
        lxr: $('#lxr').val(),
        lxr_dh: $('#sj').val(),
        lxr_dz: $('#dz').val()
    };

    for (var i = 0; i < getData.jl.length; i++) {
        var item = getData.jl[i];
        item['zj'] = ((item['hsdj'] || 0) - (item['scdj'] || 0));
        item['color_type'] = item['color_type'] || item['type'] || '';
    }

    return {
        dj: $.extend({}, origin_data.dj, dj),
        jl: getData.jl
    };
}

//保存
function saveData() {
    var save_data = getSaveData();
    var dj = save_data['dj'];

    // 获取每条记录的备注信息
    for (var i = 0; i < getData.jl.length; i++) {
        getData.jl[i].bz = $('#jl_bz_' + i).val();
        getData.jl[i].zdj = getData.jl[i].zdj || 0;
    }

    if (!Check.kzrq({ sj: dj['kdsj'] })) return false;
    if (!Check.yjrq({ sj: dj['kdsj'] })) return false;
    if (dj['dh'] == '') return fun.toast('单号不能为空');
    if ($.nui.isEmpty(dj.wldw_id)) return fun.toast('客户不能为空');

    if (fun.formatDate(dj['kdsj'], 'YYYY-MM-DD') < fun.formatDate(fun.getValByKey(fun.getItem('wldw_kh_list') || [], dj['wldw_id'], 'date'), 'YYYY-MM-DD')) {
        return fun.toast('结算日期不能小于客户的建立日期');
    }

    // 删除单价为0记录行
    var result = xs_xsbj_kd.deleteEmptyRows();
    if (result.deleteRows) {
        setTimeout(function () {   // 放回调里执行，异步渲染
            showData2(getData.jl);
            showData1(getData.dj);
        }, 100);
    }
    save_data.jl = getData.jl;

    if ($.nui.isEmpty(save_data.jl)) return fun.toast(tips_arr['空单提示']);

    save_data.jl = save_data.jl.concat(xs_xsbj_kd.deleteRows);
    var data = $.extend(true, { status: 'save', __post_sign: Bills['__post_sign']}, save_data);

    console.log(11111);
    console.log(JSON.stringify(data));
    console.log(11111);

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveBpxsbjInfo,
        data: data,
        success: function (res) {
            if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('保存成功。');
                    page_data['id'] = res['data']['dj_id'];
                    xs_xsbj_kd.deleteRows = [];
                    closePage();
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    })
}

// 删除单价为0记录行
xs_xsbj_kd.deleteEmptyRows = function () {
    var ckIds = [];
    var realSaveJl = [];
    var deleteRows = false;
    for (var i = 0; i < getData.jl.length; i++) {
        if ($.nui.isEmpty(getData.jl[i].hsdj)) {
            deleteRows = true;
            xs_xsbj_kd.rowDeleteHandler(getData.jl[i]);
        } else {
            realSaveJl.push(getData.jl[i]);
            if (ckIds.indexOf(getData.jl[i].ck_id) === -1) {
                ckIds.push(getData.jl[i].ck_id);
            }
        }
    }
    // 删除数据后重新渲染
    getData.jl = realSaveJl;
    return { ckIds: ckIds, deleteRows: deleteRows };
};



//删除
function delData(data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('bp_xsbj', 'delete')) return false;
    if (!Auth.qfmd({ 'key': 'delete', 'md_id': getData.dj['md_id'] })) return false;
    if (!Auth.qfczy({ 'key': 'delete', 'zdr_id': getData.dj['zdr_id'] })) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveBpxsbjInfo,
        data: { status: 'delete', scr_id: fun.getItem('user_info')['id'], dj_id: data['id'][0], __post_sign: Bills['__post_sign'] },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('删除成功。');
                    closePage(true);
                    break;
                case 'WDYJE_LESS_BCDY':
                    fun.toast('超出了订金，无法删除单据。');
                    break;
                case 'IS_NOT_FIND':
                    fun.toast(res['msg']);
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
            fun.hideLoad();
        }
    })
}

//审核
function audit(data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!Auth.check('bp_xsbj', 'check')) return false;
    if (!Auth.qfmd({ 'key': 'check', 'md_id': getData.dj['md_id'] })) return false;
    if (!Auth.qfczy({ 'key': 'check', 'zdr_id': getData.dj['zdr_id'] })) return false;
    fun.ajax({
        url: AJAX_URL.saveBpxsbjInfo,
        data: { status: 'audit', shr_id: fun.getItem('user_info')['id'], dj_id: data['id'][0], __post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('审核成功。');
                    closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'][0];
                    fun.toast('条码' + list['tm'] + '和库存信息不一致');
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_NOT_FIND':
                    fun.toast(res['msg']);
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
            fun.hideLoad();
        }
    })
}

//作废
function obsolete(data) {
    if ($.nui.isEmpty(data['id'][0])) return fun.toast('无单据id');
    if (!AUTH_ZF) return false;
    if (!Auth.qfmd({ 'key': 'invalid', 'md_id': getData.dj['md_id'] })) return false;
    if (!Auth.qfczy({ 'key': 'invalid', 'zdr_id': getData.dj['zdr_id'] })) return false;
    fun.ajax({
        url: AJAX_URL.saveBpxsbjInfo,
        data: {
            status: 'cancel',
            zfr_id: fun.getItem('user_info')['id'],
            dj_id: data['id'][0],
            zf_yy: '', // 作废原因
            scxd: (data.index == 0) ? 1 : 0, // 生成新单
            __post_sign: Bills['__post_sign']
        },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            // if(data.index == 0){
            //   if (res['status'] == 0) {
            //     fun.toast('作废成功！');
            //     closePage();
            //   }else{
            //     fun.toast(res['msg']);
            //   }
            // }else{
            switch (res['status']) {
                case 0:
                    fun.toast('作废成功。');
                    if (data.index == 0) { // 重新跟单
                        page_data['id'] = res['data']['dj_id'];
                    } else if (data.index === 1) { // 直接作废
                        $('.contents').css({
                            paddingBottom: 0
                        })
                    }
                    closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'];
                    var listInfo = {};
                    if ($.nui.isTrue(list)) listInfo = list[0];
                    var msg = '条码' + (listInfo['tm'] || '') + '和库存信息不一致';
                    fun.toast(msg);
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_JS':
                    fun.toast('单据已被结算过，无法作废。');
                    break;
                case 'WDYJE_LESS_BCDY':
                    fun.toast('超出了订金，无法作废单据。');
                    break;
                case 'IS_NOT_FIND':
                    fun.toast(res['msg']);
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
            // }
            fun.hideLoad();
        }
    })
}

//关闭当前窗口
function closePage(flag) {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            status: 'refresh',
            wldw: page_data['wldw']
        }
    });
    if (!flag) {
        api.sendEvent({
            name: html_name,
            extra: {
                'status': 'refresh_dj'
            }
        });
    } else {
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_arr.xs_xsbj_cx });
        }, 200);
    }

}

//返回事件
function isDataChange() {
    if (getData.dj.is_sh || !Auth.check('bp_xsbj', 'edit')) {
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         'status': 'refresh'
        //     }
        // });
        fun.useBack();
        api.closeToWin({ name: page_arr.xs_xsbj_cx });
        return false;
    }

    // return;

    if (xs_xsbj_kd.checkDataChange()) {
        if ($('body').find('.data-change-skin').length) return;
        // 判断是否可以直接关闭
        // 新单时，如果数据需要保存的记录行数据为0，并且没有填写单据信息，没有删除过行记录
        if ($.nui.isEmpty(page_data.id) && getData.jl.length === 0 && xs_xsbj_kd.deleteRows.length === 0 && !xs_xsbj_kd.isDjDataChange() && !xs_xsbj_kd.isDeleteRows) {
            // api.sendEvent({
            //     name: page_data['return_page'],
            //     extra: {
            //         'status': 'refresh'
            //     }
            // });
            fun.useBack();
            api.closeToWin({ name: page_arr.xs_xsbj_cx });
            return false;
        }

        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData();
            },
            no: function () {
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         'status': 'refresh'
                //     }
                // });
                fun.useBack();
                api.closeToWin({ name: page_arr.xs_xsbj_cx });
            }
        });
    } else {
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         'status': 'refresh'
        //     }
        // });
        fun.useBack();
        api.closeToWin({ name: page_arr.xs_xsbj_cx });
    }
}

xs_xsbj_kd.checkDataChange = function () {
    save_data = getSaveData();
    var tmpOriData = JSON.parse(JSON.stringify(origin_data));
    var tmpSaveData = JSON.parse(JSON.stringify(save_data));
    for (var i = 0; i < tmpOriData.jl.length; i++) {
        delete tmpOriData.jl[i].zje;
        delete tmpOriData.jl[i].hszje;
    }

    for (var i = 0; i < tmpSaveData.jl.length; i++) {
        delete tmpSaveData.jl[i].__index;
        delete tmpSaveData.jl[i].zje;
        delete tmpSaveData.jl[i].hszje;
        tmpSaveData.jl[i].zdj = tmpSaveData.jl[i].zdj || 0;
    }

    console.log(JSON.stringify(tmpOriData))
    console.log(JSON.stringify(tmpSaveData))

    return !$.nui.isObjEquals(tmpOriData, tmpSaveData);
};

/**
 * 按钮
 */
//删除
$('body').on('touchend', '#del_btn', function (e) {
    e.stopPropagation();
    // 检查数据是否修改
    if (xs_xsbj_kd.checkDataChange()) {
        fun.toast('单据已修改，未保存，不能删除!');
        return false;
    }

    fun.dialog({
        content: '您确定要删除当前单据吗？',
        btn: ['删除', '取消'],
        yes: function () {
            delData({ id: [page_data['id']] });
        }
    });
});
//审核
$('body').on('tap', '.audit', function (e) {
    e.stopPropagation();
    // 检查数据是否修改
    if (xs_xsbj_kd.checkDataChange()) {
        fun.toast('单据已修改，未保存，不能审核!');
        return false;
    }

    fun.dialog({
        content: '您确定要审核当前单据吗？',
        btn: ['确定', '取消'],
        yes: function () {
            audit({ id: [page_data['id']] });
        }
    });
});
//取消审核
$('body').on('tap', '.revocatory', function (e) {
    e.stopPropagation();
    fun.dialog({
        content: '您确定要取消当前单据的审核状态吗？',
        btn: ['确定', '取消'],
        yes: function () {
            /////////
        }
    });
});
//作废
$('body').on('tap', '.obsolete', function (e) {
    e.stopPropagation();
    fun.dialog({
        content: '您确定要作废当前单据吗？',
        btn: ['重新做单', '直接作废', '取消'],
        yes: function (datas) {
            obsolete({ id: [page_data['id']], index: datas['index'] });
        },
        no: function (datas) {
            $('#fixtabbar').hide();
            obsolete({ id: [page_data['id']], index: datas['index'] });
        }
    });
});

//保存
$('body').delay('tap', '.saves', function (e) {
    saveData();
});

// 选择联系人
$('body').on('tap', '.lxr-li', function (e) {
    if (AUTH_EDIT && !getData.dj.is_sh) {
        if ($.nui.isEmpty(getData.dj.wldw_id)) return fun.toast('请先选择客户！');

        fun.showPageFull({
            page_url: page_arr.contacter_search,
            pageParam: {
                "return_page": html_name,
                "page_type": 'kh',
                'wldw_mc': getData.dj.wldw_mc,
                'wldw_id': getData.dj.wldw_id
            }
        });
    }
});

// 客户搜索
function khSelect() {
    $('body').on('tap', '#wldw', function () {
        if (AUTH_EDIT && !getData.dj.is_sh) {
            fun.showPageFull({
                page_url: page_arr.customer_search,
                pageParam: {
                    return_page: html_name,
                    page_type: 'kh',
                }
            });
        }
    });
}

// 删除单行
$('body').on('touchend', '.delete-btn', function (e) {
    var index = $(this).data('del_index');
    e.stopPropagation();
    fun.dialog({
        content: '您确定要删除当前记录吗？',
        btn: ['确定', '取消'],
        yes: function () {
            var delArr = getData.jl.splice(index, 1);
            xs_xsbj_kd.rowDeleteHandler(delArr[0]);
            showData2(getData.jl);
            showData1(getData.dj);
            xs_xsbj_kd.showSaveBtn();
        }
    });
});

// 编辑行记录
$('body').on('tap', '.store-content', function (e) {
    e.preventDefault();
    selectIndex = $(this).data('index');
    var item = getData.jl[selectIndex];
    // var item_data=getSaveData();
    fun.showPageFull({
        page_url: page_arr.xsbj,
        pageParam: {
            djlx: 'bp_xsbj',
            __ROW_DATA: item,
            return_page: html_name,
            __DJ_DATA: getData.dj,
            // __DJ_DATA: item_data.dj,
            __IS_NEW: false,
            __IS_EDIT: AUTH_EDIT && !getData.dj.is_sh,  // 已审核不能修改
            __PAGE_EDIT: AUTH_EDIT && !getData.dj.is_sh,  // 已审核不能修改
            wldw: page_data['wldw']
        }
    })
});

// 添加
$('body').on('tap', '.choice', function () {
    // 跳转选择产品页面
    var type = 'wldw' in page_data ? page_data['wldw']['type'] : page_data['type'];
    const __route = [
        {
            url: page_arr.choice_product,
            page_data: {
                djlx: 'bp_xsbj',
                return_page: html_name,
                from_page: html_name,
                cp_tmp: {
                    __PAGE_INFO: {},
                    __DJ_DATA: {},
                    __PAGE_EDIT: true,
                    return_page: html_name,
                },
                __JL_DATA: getData.jl,
                NOT_OPEN_AGAIN: true,
                wldw: {
                    id: getData.dj.wldw_id,
                    type: type
                }
            }
        },
        {
            url: page_arr.xs_xsbj_kd, page_data: {}
        }
    ];

    fun.showPageFull({
        page_url: __route[0]['url'],
        pageParam: $.extend(true, { __route: __route }, __route[0]['page_data'])
    });
});

// 监听备注输入
$('body').on('change', '#bz', function (e) {
    e.preventDefault();
    getData.dj.bz = $(this).val();
});

$('body').on('change', '#sj', function (e) {
    e.preventDefault();
    getData.dj.lxr_dh = $(this).val();
});

$('body').on('change', '#dz', function (e) {
    e.preventDefault();
    getData.dj.lxr_dz = $(this).val();
});

/********************* 事件绑定 *********************/
// 显示、隐藏切换
// $('#show-arrow').data('mark');
$('.edit-wrap').hide();
$('#show-arrow').on('tap', function (e) {
    if ($(this).find('.iconfont').hasClass('icon-xia')) {
        $(this).find('.iconfont').addClass('icon-shang').removeClass('icon-xia');
    } else {
        $(this).find('.iconfont').addClass('icon-xia').removeClass('icon-shang');
    }
    $('.edit-wrap').slideToggle(200);
    return false;
});

// 记录修改事件处理
function eventUpdate(row) {
    getData.jl[selectIndex] = row;
    fun.setFzys(xs_xsbj_kd.fz_ys, getData.jl);
    fun.setFzcps(xs_xsbj_kd.fz_cp, getData.jl);

    showData2(getData.jl);
    showData1(getData.dj);
}

// 判断往来单位、手机、地址、备注、开单时间是不是已经修改
xs_xsbj_kd.isDjDataChange = function () {
    return origin_data.dj.wldw_id !== getData.dj.wldw_id ||
        origin_data.dj.lxr !== getData.dj.lxr ||
        origin_data.dj.lxr_dh !== getData.dj.lxr_dh ||
        origin_data.dj.lxr_dz !== getData.dj.lxr_dz ||
        origin_data.dj.bz !== getData.dj.bz ||
        origin_data.dj.kdsj !== getData.dj.kdsj;
};

// 数据发生改变显示保存按钮
xs_xsbj_kd.showSaveBtn = function () {
    if ($('.audit:visible').length) {
        $('.audit').hide();
    }
    if ($('.saves:visible').length) return;
    if (getData.dj.is_sh) return;
    $('.saves').show();
}

// 数据发生改变显示保存按钮
xs_xsbj_kd.dataChangeShowSaveBtn = function () {
    if (xs_xsbj_kd.checkDataChange()) xs_xsbj_kd.showSaveBtn(); // 数据发生变化显示保存按钮
}

// input输入框绑定事件
xs_xsbj_kd.inputBindEvent = function () {
    $('body').off('input propertychange', ':input').on('input propertychange', ':input', fun.throttle(xs_xsbj_kd.showSaveBtn, 300)); // 未审核数据改变显示保存按钮
}

// 根据返回状态检测数据判断显示保存按钮
xs_xsbj_kd.checkStatusShowSaveBtn = function (status) {
    // 返回状态数组
    var statusArr = ['update_rows', 'update'];
    if (statusArr.indexOf(status) > -1) xs_xsbj_kd.dataChangeShowSaveBtn();
}

// 销售报价是否开启色系报价
xs_xsbj_kd.isSeries = function () {
    return !!Number(fun.getItem('sys_config').qysexibjms_bp);
}

// 记录行产品编号名称 
xs_xsbj_kd.productName = function (data) {
    var temStr = fun.is_value(data['cp_bh']) + fun.is_value(data['cp_mc']) + ' <i>' + fun.is_value(data['cp_ys_bh']) + fun.is_value(data['cp_ys_mc']) + '</i>';
    if (this.isSeries()) { // 开启色系报价
        // 色号为空 且 色系不为空 
        if ($.nui.isEmpty(data['cp_ys_bh']) && $.nui.isTrue(data['color_type'])) {
            return fun.is_value(data['cp_bh']) + fun.is_value(data['cp_mc']) + ' <i>' + fun.is_value(data['color_type']) + '</i>';
        } else {
            return temStr;
        }
    } else {
        return temStr;
    }
}
