$('#header').header({
    back: true, //返回
    title: '销售分析', //标题
    text_btn: true, //文字按钮
    text_val: 'TOP 10', //文字按钮值
});


// 基于准备好的dom，初始化echarts实例
var myChart = echarts.init(document.getElementById('bar'));

// 指定图表的配置项和数据
var option = {
    title: [{
                  text: '产品编号+产品名称',
                  x: '20',
                  top: '2%',
                  textStyle:{
                      color:'#555',
                      fontWeight: '400',
              　　　　fontSize:15
                  }
              },{
                  text: "产品编号+产品名称",
                  x: '20',
                  top: '15.5%',
                  textStyle:{
                      color:'#555',
                      fontWeight: '400',
              　　　　 fontSize:15
                  }
              },{
                  text: "产品编号+产品名称",
                  x: '20',
                  top: '29%',
                  textStyle:{
                      color:'#555',
                      fontWeight: '400',
              　　　　 fontSize:15
                  }
              },{
                  text: "产品编号+产品名称",
                  x: '20',
                  top: '42%',
                  textStyle:{
                      color:'#555',
                      fontWeight: '400',
              　　　　 fontSize:15
                  }
              },{
                  text: "产品编号+产品名称",
                  x: '20',
                  top: '55%',
                  textStyle:{
                      color:'#555',
                      fontWeight: '400',
              　　　　 fontSize:15
                  }
              },{
                  text: "产品编号+产品名称",
                  x: '20',
                  top: '69%',
                  textStyle:{
                      color:'#555',
                      fontWeight: '400',
              　　　　 fontSize:15
                  }
              },{
                  text: "产品编号+产品名称",
                  x: '20',
                  top: '82%',
                  textStyle:{
                      color:'#555',
                      fontWeight: '400',
              　　　　 fontSize:15
                  }
              }],
    tooltip: {
       show: "true",
       trigger: 'axis',
       axisPointer: { // 坐标轴指示器，坐标轴触发有效
           type: 'none' // 默认为直线，可选为：'line' | 'shadow'
       },
       transitionDuration: 0,
       borderRadius: 8,
       borderWidth: 0,
       padding: [5, 10],
   },
    series: [{
        type: 'bar',
    }],
    grid: {
        left: '-90',
        right: '10',
        top: '20',
        bottom: '-10',
        containLabel: true
    },

    xAxis: {
        type: 'value',
        show: false,
    },
    yAxis: [{
        axisLabel: {
            show: false, //让Y轴数据不显示
        },
        axisLine: {
            show: false
        },
        axisTick: {
            show: false
        },
        itemStyle: {
            color: '#fff',
        },
        splitLine: {
            show: false
        },
        type: 'category',
        data: ['产品编号+产品名称', '产品编号+产品名称', '产品编号+产品名称', '产品编号+产品名称', '产品编号+产品名称', '产品编号+产品名称', '产品编号+产品名称'],
    }],
    series: [{
        name: '金额',
        type: 'bar',
        barWidth: '40%',
        stack: '总量',
        barGap: '-100%',
        itemStyle: {
            normal: {
                color: function(params) {　 //首先定义一个数组
                    var colorList = [
                        '#99b963', '#98c1f3', '#80e5d3', '#85ca8d', '#fbc987', '#f09777', '#da5859'
                    ];
                    return colorList[params.dataIndex]
                },
            }
        },
        label: {

            normal: {
                show: true,
                position: [0, '-70%'],
                textStyle: {
                    fontSize: 16,
                    color:'#555',
                },
                formatter:function(a,b){
                    return a.name;
                }
            }
        },
        label: {
            normal: {
                show: true,
                position: 'insideRight'
            }
        },
        data: [820, 832, 901, 934, 1290, 1330, 1320],
    }],

};

myChart.setOption(option);
