$('#header').header({
    back: true, //返回
    title: '销售分析', //标题
});

function randomData() {
    return Math.round(Math.random() * 600);
}
//初始化echarts实例
var myChart = echarts.init(document.getElementById('china'));

var mydata = [
                {name: '北京',value: '100' },{name: '天津',value: randomData() },
                {name: '上海',value: randomData() },{name: '重庆',value: randomData() },
                {name: '河北',value: randomData() },{name: '河南',value: randomData() },
                {name: '云南',value: randomData() },{name: '辽宁',value: randomData() },
                {name: '黑龙江',value: randomData() },{name: '湖南',value: randomData() },
                {name: '安徽',value: randomData() },{name: '山东',value: randomData() },
                {name: '新疆',value: randomData() },{name: '江苏',value: randomData() },
                {name: '浙江',value: randomData() },{name: '江西',value: randomData() },
                {name: '湖北',value: randomData() },{name: '广西',value: randomData() },
                {name: '甘肃',value: randomData() },{name: '山西',value: randomData() },
                {name: '内蒙古',value: randomData() },{name: '陕西',value: randomData() },
                {name: '吉林',value: randomData() },{name: '福建',value: randomData() },
                {name: '贵州',value: randomData() },{name: '广东',value: randomData() },
                {name: '青海',value: randomData() },{name: '西藏',value: randomData() },
                {name: '四川',value: randomData() },{name: '宁夏',value: randomData() },
                {name: '海南',value: randomData() },{name: '台湾',value: randomData() },
                {name: '香港',value: randomData() },{name: '澳门',value: randomData() },
                {name: '南海诸岛',value: randomData() }
            ];

var optionMap = {
    backgroundColor: '#f9f9f9',
    tooltip: {
        trigger: 'item'
    },

    //左侧小导航图标
    visualMap: {
        show: true,
        x: '10',
        y: 'bottom',
        splitList: [{
            start: 500,
            // end: 600
        }, {
            start: 400,
            end: 500
        }, {
            start: 300,
            end: 400
        }, {
            start: 200,
            end: 300
        }, {
            start: 100,
            end: 200
        }, {
            start: 0,
            end: 100
        }, ],
        color: ['#ea646d', '#f7b159', '#28a7de', '#afb6e0', '#92c8bb', '#e8e8e8']
    },
    toolbox: {
        show: true,
        orient: 'vertical',
        left: 'right',
        top: 'top',
        feature: {
            // dataView: {
            //     readOnly: false
            // },
            restore: {},
            // saveAsImage: {}
        }
    },
    //配置属性
    series: [{
        name: '销售额',
        type: 'map',
        mapType: 'china',
        roam: true,
        label: {
            normal: {
                show: false //省份名称
            },
            emphasis: {
                show: false
            }
        },
        data: mydata //数据
    }]
};

//使用制定的配置项和数据显示图表
myChart.setOption(optionMap);
