var html_name = page_arr.xstq;
var temps, page_list = [], ztj_data = [];
var origin_data = {}, save_data = {};
var type_arr = [
    {'name': '上年总增长', 'id': 'zzz', type: 'zzz', is_choose: 1},
    {'name': '上年同月总增长', 'id': 'tyzzz', type: 'tyzzz'}
];

//标题栏
$('#header').header({
    back: true,
    title: '销售同期',
    filter:true,
    xstq:{
      show:true
    }
    // appendBackBtnEvt: isDataChange
});

// callAddress();

page_init = function () {
  $('.xstq-show-all2').children('.xstq-in_text').attr('type','zzz');
  api.addEventListener({
      name: html_name,
  }, function (ret, err) {
      var temp = ret['value'];

      switch (temp['status']) {
          case 'search':
              search_data['md_id'] = temp['data']['md']['id'] || '';
              search_data['md_mc'] = temp['data']['md']['text'] || '';
              search_data['is_stop'] = temp['data']['is_stop'] || '';
              fun.setItem(html_name + '_isStop', temp['data']['is_stop']);
              fun.setItem(html_name + 'sideslip', true);
              $('#list').empty();
              getList();
              break;
          case 'refresh':
              $('#list').empty();
              getList();
              break;
      }

  });
}

//切换时间
$(".xstq-cuttime").on('tap',function(){
    var id=$(this)[0].id;
		var dateval=$('.date').text();
		var ss=getCutTime(id,dateval);
		$('.date').text(ss);
});

//获得相应月份
function getCutTime(id,cur_times){
  //获得当前年月日
  var cur_year=parseInt(cur_times.slice(0,4));
  var cur_month=parseInt(cur_times.slice(5,7));
  var year,month,str;
  //判断是前一月还是下一月时间
  switch(id){
    case 'pre_time':
      if(cur_month==1){
        cur_year--;//如果当前月份为1月，则年份减1
        cur_month=12;
        year=cur_year;
        month=cur_month;
      }else{
        cur_month--;
        year=cur_year;
      }
    break;
    case 'next_time':
      if(cur_month==12){
        cur_year++;//如果当前月份为1月，则年份减1
        cur_month=1;
        year=cur_year;
        month=cur_month;
      }else{
        cur_month++;
        year=cur_year;
      }
    break;
    default:break;
  }
  if(cur_month.toString().length==1){
    month='0'+cur_month;
  }else{
    month=cur_month;
  }
  str=year+'-'+month;
  return str;
}
//选择类型
$('body').on('touchend', '.xstq-show-all2', function (e) {
    e.preventDefault();
    var val = $(this).children('.xstq-in_text').attr('type');
    $(type_arr).each(function (i, arr) {
        if (arr['id'] == val) {
            type_arr[i]['is_choose'] = 1;
        } else {
            type_arr[i]['is_choose'] = 0;
        }
    });

    fun.showBookList({
        width: '280px',
        shadeClose: true,
        list: type_arr,
        choose: function (res) {
            $('.xstq-in_text').text(res.name);
            $('.xstq-in_text').attr('type', res.id);
        }
    });
    return false;
});


fun.setItem(html_name+'sideslip',true);
//打开搜索框
$('body').on('tap', '#filter_btn', function (e) {
    var sideslip=fun.getItem(html_name+'sideslip');
    var options = {
        "choose_merchants": [
            {
                key: "md",
                "text": "门店",
                "value": (temps && temps['md_mc'] ? temps['md_mc'] : ""),
                "id": (temps && temps['md_id'] ? temps['md_id'] : 0),
                // disabled: disabled
            },{
                key: "ywy",
                "text": "员工",
                "value": (temps && temps['ywy'] ? temps['ywy'] : ""),
                "id": (temps && temps['ywy'] ? temps['ywy'] : 0),
                // disabled: disabled
            },
        ],
        "switch": [
            {
                "text": "目标业绩",
                "max_width": true,
                "key": "mbyj",
                "value": (temps && fun.getItem(html_name + '_isStop') ? fun.getItem(html_name + '_isStop') : '')
            },
            {
                "text": "回款情况",
                "max_width": true,
                "key": "hkqk",
                "value": (temps && fun.getItem(html_name + '_isStop') ? fun.getItem(html_name + '_isStop') : '')
            },
        ],
    };
    if(sideslip){
        fun.setItem(html_name+'sideslip',false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});
