var html_name = page_arr.xz_lts;

//默认开始显示数据
var to_month = fun.getLatelyTime(1,false);
var page_list = [], ztj_data = [];
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

$('#header').header({
    back: true,
    filter: true,
    title: '来退纱'
});
var USER_INFO = {};

var hz_group_columns = {
    'dh': 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc',
    'wldw': 'wldw_id,wldw_mc',
    'cp': 'cp_bh,cp_mc',
    'cp_ys': 'cp_ys_bh,cp_ys_mc',
    "hsdj": 'hsdj',
    "fkkz": 'fk,kz',
    "gg": 'gg'
};
//接收查询后的参数
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(html_name + '_' + 'hz') || "");

    var hnh = html_name + '_';
    search_storage = $.extend(true, {
        'ycysh': fun.getItem(html_name + '_ycysh', 0),
        'hldj': fun.getItem(html_name + '_hldj', 0),
        'xsmx': fun.getItem(html_name + '_xsmx', 0),
        "hz": {
            "choose": {
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "dh": fun.getItem(hnh + 'dh', 1),
                "wldw": fun.getItem(hnh + 'wldw', 1),
                "cp": fun.getItem(hnh + 'cp', 1),
                "cp_ys": fun.getItem(hnh + 'cp_ys', 1),
                "fkkz": fun.getItem(hnh + 'fkkz', 0),
                "gg": fun.getItem(hnh + 'gg', 0)
            },
            "text": fun.getItem(hnh + 'text', ""),
        },
        'djlx':fun.getItem(html_name+"_djlx")
    }, search_storage);

    search_data = $.extend({}, search_data, search_storage);
    fun.initGroupOfSearchData(search_data, search_storage.hz.choose, hz_group_columns, ',dw_id,dw_mc');
    getList(search_data);

    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {

        var param = ret.value.data;

        search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
        search_data['begin_time'] = param.begin_date;                   //开始时间
        search_data['end_time'] = param.end_date;                       //结束时间
        search_data['wldw_id'] = param.jgs['id'] || '';                 //供应商
        search_data['cp_id'] = param.cp['id'] || '';                    //纱线
        search_data['cp_lb_id'] = param.cp_lb['id'] || 0;             //纱线类别
        search_data['ck_id'] = param.ck['id'] || '';                    //仓库
        search_data['md_id'] = param.md['id'] || '';                    //门店
        search_data['ycysh'] = param['ycysh'];
        search_data['hldj'] = param['hldj'];                            //合拢单据
        search_data['xsmx'] = param['xsmx'];                            //显示明细数据
        search_data['kh_id'] = param.kh['id'];                          // 客户
        search_data['dh'] = param['dh'] || '';                          // 订单单号

        if(param.djlx['type'].indexOf(',')>-1){
            var split=param.djlx['type'].split(',');
            search_data['djlx'] = [split[0],split[1]]
        }else{
            search_data['djlx']=param.djlx['type']!=""?[param.djlx['type']]:["bp_jglhd","bp_jgthd"];
        }
        search_data['djlx_text'] = param.djlx['text'];
        fun.setItem(hnh+'djlx',search_data['djlx'])
        fun.setItem(hnh+'djlx_text',search_data['djlx_text'])
        if(param.djlx['keys']['bp_jglhd']==0&&param.djlx['keys']['bp_jgthd']==0){
            fun.setItem(hnh+'bp_jglhd',1);
            fun.setItem(hnh+'bp_jgthd',1);
        }else{
            fun.setItem(hnh+'bp_jglhd',param.djlx['keys']['bp_jglhd']);
            fun.setItem(hnh+'bp_jgthd',param.djlx['keys']['bp_jgthd']);
        }

        search_storage['keyword'] = search_data['keyword'];
        search_storage['begin_date'] = search_data['begin_time'];
        search_storage['end_date'] = search_data['end_time'];
        search_storage['jgs'] = param.jgs;
        search_storage['cp'] = param.cp;
        search_storage['cp_lb'] = param.cp_lb;
        search_storage['ck'] = param.ck;
        search_storage['md'] = param.md;
        search_storage['ycysh'] = search_data['ycysh'];
        search_storage['hldj'] = search_data['hldj'];
        search_storage['xsmx'] = search_data['xsmx'];
        search_storage['kh'] = param.kh;
        search_storage['dh'] = search_data['dh'];
        //设置时间控件时间
        date_bar.setDate(search_storage);

        fun.setItem(html_name + '_ycysh', search_storage['ycysh']);
        fun.setItem(html_name + '_hldj', search_storage['hldj']);
        fun.setItem(html_name + '_xsmx', search_storage['xsmx']);

        //汇总功能
        search_data['group'] = param.hz['group'] || '';
        search_storage['hz'] = param.hz;
        var hc = param['hz']['choose'];
        fun.setItem(hnh + 'md_mc', hc['md_mc']);
        fun.setItem(hnh + 'dh', hc['dh']);
        fun.setItem(hnh + 'wldw', hc['wldw']);
        fun.setItem(hnh + 'cp', hc['cp']);
        fun.setItem(hnh + 'cp_ys', hc['cp_ys']);
        fun.setItem(hnh + 'fkkz', hc['fkkz']);
        fun.setItem(hnh + 'gg', hc['gg']);
        fun.setItem(hnh + 'text', param.hz['text']);
        fun.setGroupCondition(search_data, "dw_id,dw_mc");

        // if (!!search_data['group']) {
        //     var group_data = search_data['group'];
        //     group_data += ',dw_id,dw_mc,jjdw_mc';
        //     search_data['group'] = group_data;
        // }
        fun.setItem(html_name + '_' + 'hz', search_data['group']);
        fun.setItem(html_name + 'sideslip', true);

        $('#order_list').empty();
        getList(search_data);
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });

}
//存储一个值用于判定是否打开搜索页//值为false即为打开
fun.setItem(html_name+'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    //取值做判断搜索页是否打开
    var n = fun.getItem(html_name+'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "dh_wrap": {
            "key": "dh",
            "value": search_storage['dh'] || "",
            "placeholder": "订单单号"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [{
            key: "jgs",
            "text": "加工商",
            "value": (search_storage['jgs'] && search_storage['jgs']['text']) || "",
            "id": (search_storage['jgs'] && search_storage['jgs']['id']) || 0,
        }, {
            key: "cp",
            "text": "纱线",
            "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
            "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
        }, {
            key: "cp_lb",
            "text": "纱线类别",
            "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
            "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
        }, {
            key: "ck",
            "text": "仓库",
            "value": (search_storage['ck'] && search_storage['ck']['text']) || "",
            "id": (search_storage['ck'] && search_storage['ck']['id']) || 0,
        }, {
            key: "md",
            "text": "门店",
            "value": (search_storage['md'] && search_storage['md']['text']) || "",
            "id": (search_storage['md'] && search_storage['md']['id']) || 0,
        },
        {
            key: "kh",
            "text": "客户",
            "value": (search_storage['kh'] && search_storage['kh']['text']) || "",
            "id": (search_storage['kh'] && search_storage['kh']['id']) || 0,
        },
        {
            key: "hz",
            "text": "汇总",
            //加工商、单号、门店、纱线、颜色
            group: [
                 // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                 { key: 'dh', name: '单号', columns: hz_group_columns.dh, choose: getHz('dh') },
                 { key: 'wldw', name: '加工商', columns: hz_group_columns.wldw, choose: getHz('wldw') },
                 { key: 'cp', name: '纱线', columns: hz_group_columns.cp, choose: getHz('cp') },
                 { key: 'cp_ys', name: '颜色', columns: hz_group_columns.cp_ys, choose: getHz('cp_ys') },
                //  { key: "hsdj", name: '单价', columns: hz_group_columns.hsdj, choose: getHz('hsdj')},
                 { key: "fkkz", name: '幅宽克重', columns: hz_group_columns.fkkz, choose: getHz('fkkz')},
                 { key: "gg", name: '规格', columns: hz_group_columns.gg, choose: getHz('gg')}
            ],
            "value": getTwo('hz', 'text'),
        }
        ],
        'xs':[
            {
                "key":'djlx',
                "text":"单据类型",
                "xsType":(fun.getItem(html_name+'_'+'djlx')||'bp_jglhd,bp_jgthd'),
                "list":[
                    { 'name': '来货', 'column': 'bp_jglhd', 'is_choose': fun.getItem(html_name+'_'+'bp_jglhd')==0?0:1 },
                    { 'name': '退货', 'column': 'bp_jgthd', 'is_choose': fun.getItem(html_name+'_'+'bp_jgthd')==0?0:1 },
                ],
                "alone":false,
                "value":(fun.getItem(html_name+'_'+'djlx_text')||"来货、退货"),
        }],
        "switch": [{
            "text": "隐藏已审核单据",
            "max_width": true,
            "key": "ycysh",
            "value": (!!fun.getItem(html_name + '_ycysh') ? fun.getItem(html_name + '_ycysh') : 0)
        },{
            "text": "显示明细数据",
            "max_width": true,
            "key": "xsmx",
            "value": (!!fun.getItem(html_name + '_xsmx') ? fun.getItem(html_name + '_xsmx') : 0)
        },{
            "text": "合拢单据",
            "max_width": true,
            "key": "hldj",
            "value": (!!fun.getItem(html_name + '_hldj') ? fun.getItem(html_name + '_hldj') : 0)
        }
        ],
    };
    if (n) {
        fun.setItem(html_name+'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

// // 退货结算-开单
// $('body').on('tap','#retreat',function(){
// 	fun.showPageFull({
// 		page_url:page_arr.jg_thjs_kd,
// 		pageParam:{}
// 	});
// });
//
// // 来货结算-开单
// $('body').on('tap','#hair',function(){
// 	fun.showPageFull({
// 		page_url:page_arr.jg_lhjs_kd,
// 		pageParam:{}
// 	});
// });

var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            $('#order_list').empty();
            getList(search_data);
        }
    });

function showList(data) {
    $('#tj1').text(ztj_data[0]['ps'] || 0);
    $('#tj2').text(ztj_data[0]['zsl'] || 0);
    // var i;
    var hldj = fun.getItem(html_name + '_hldj', 0);
    var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !hldj,
        isNoExpand: xsmx,
        render: {
            titlebar: function (res) {
                return fthStatistics.createTitlebar(res, {
                    showPrice: false,
                    search_data: search_data
                });
            },
            subtitle: function (res) {
                return fthStatistics.createSubtitle(res, {
                    search_data: search_data
                });
            },
            subdata: function (res) {
                return fthStatistics.createSubdata(res, {
                    search_data: search_data,
                    showPrice: false,
                    ps_tmp: res.ps,
                    sl_tmp: res.zsl,
                    dw_tmp: res.dw_mc
                });
            }
        },
    });
}


/** 获取发退货结算数据
 * @param {*} data
 */
function getList(data) {
    page_list = [];
    var tmpdata = $.extend(true, {}, data);
    //暂时使用这种方式访问api接口，如果没有这个就会访问不到
    tmpdata['djlx'] = search_data['djlx']||["bp_jglhd","bp_jgthd"];
    tmpdata['ycycl'] = 1;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL['getBpJglthdtj'],
        data: tmpdata,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj1').text(0);
                    $('#tj2').text(0);
                    $('#tj3').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                ztj_data = res['info'];
                // page_list = convertData(res.data);
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createKeysValueFun: function(obj) {
                        return {
                            "wldw_mc": obj['wldw_mc'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            is_sh : obj['is_sh'],
                            // "ysje": obj["ysje"],
                            "dj_ps": fun.is_value(obj['dj_ps'],0),
                            "dj_zsl": fun.is_value(obj['dj_zsl'],0),
                            "dj_je": fun.is_value(obj['dj_je'],0),         // 单据金额
                            "zdw_mc_tmp": fun.is_value(obj['zdw_mc']),  // 总单位名称
                        };
                    }
                });
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}


// 详情跳转
fun.tjContentTap(function (data_list) {
    if ($.nui.isTrue(data_list['dj_id'])) {
        var djlx = data_list['djlx'];
        var id = data_list['dj_id'];
        var dh = data_list['dh'];
        var kdsj = data_list['kdsj'];
        var zdr = data_list['zdr_mc'];
        var djlx_lth, p_url;
        if (djlx == 'bp_jgthd') {
            djlx_lth = '退货单';
            p_url = page_arr.jg_thd;
        } else {
            djlx_lth = '来货单';
            p_url = page_arr.jg_lhd;
        }
        fun.showPageFull({
            page_url: p_url,
            pageParam: {
                return_page: html_name,
                id: id,
                mc: djlx_lth,
                dh: dh,
                kdsj: kdsj,
                zdr: zdr
            }
        });
    }
});

$('body').on('click','.row-list',function(){
    if(fun.getItem(html_name + '_xsmx', 0)) return;
    var data_list = $(this).children('.summary').children('.summary-content').data('list');
    if ($.nui.isTrue(data_list['dj_id'])) {
        var djlx = data_list['djlx'];
        var id = data_list['dj_id'];
        var dh = data_list['dh'];
        var kdsj = data_list['kdsj'];
        var zdr = data_list['zdr_mc'];
        var djlx_lth, p_url;
        if (djlx == 'bp_jgthd') {
            djlx_lth = '退货单';
            p_url = page_arr.jg_thd;
        } else {
            djlx_lth = '来货单';
            p_url = page_arr.jg_lhd;
        }
        fun.showPageFull({
            page_url: p_url,
            pageParam: {
                return_page: html_name,
                id: id,
                mc: djlx_lth,
                dh: dh,
                kdsj: kdsj,
                zdr: zdr
            }
        });
    }
})
