var html_name = page_arr.yarn_bottomcard_edit;
var url_arr = [];
var data;
var IS_PAGE_EDIT = false;
var merchant_assistant, unit;
var wldw_pdName;
var UIAlbumBrowser = null;
var press_Time, press_Time, press_endTime;
var current; //开始的往来单位名称
var count = 0; // 用于终止递归判断变量
//选择往来单位类型
var type_data = [
    { id: 1, name: '供应商', db_name: 'gys', "is_choose": 1 },
    { id: 2, name: '客户', db_name: 'kh' },
    { id: 3, name: '加工商', db_name: 'jgs' },
];

// 支持拖拽效果
var Sortable = new Sortable($('#cpzt-img')[0], {
    delay: 400,
    animation: 150,
    draggable: '.show-img',
    onStart: function (evt) {
        console.log(evt)
        //获取索引
        var index = evt.oldIndex;
        $('.show-img').eq(index).css({ 'transform': 'scale(1.05)' });
    },
    onMove: function () {
        $('.null-img').hide();
        if ($('.show-img').length == 5 || $('.show-img').length == 9) {
            $('#cpzt-img').css('padding-bottom', '4rem');
        }
    },
    onEnd: function (evt) {
        var index = evt.oldIndex;
        $('.show-img').eq(index).css({ 'transform': 'scale(1)' });
        $('#cpzt-img').css('padding-bottom', '0');
        $('.null-img').remove();
        if ($('#cpzt-img .show-img').length < 9) {
            var html = [];
            html.push('<div class="null-img">');
            html.push('    <img src="../img/null.png" class="img" alt="">');
            html.push('</div>');
            $('#cpzt-img').append(html.join(''));
        }
    },
    delay: 400,
});

$('#header').header({
    back: true,
    title: '底卡信息',
    appendBackBtnEvt: isDataChange
});

$('.change-edit').hide();

page_init = function () {
    UIAlbumBrowser = api.require('UIAlbumBrowser');
    IS_PAGE_EDIT = Auth.check('sx', 'edit');
    data = page_data['data'];
    // $('.show-wrap').css({
    //     top: api.safeArea.top + $('#header').height() - fun.computedHtmlFontSize()
    // })
    if (page_data['type'] != 'add') {
        showData(data);
        $('.change-edit').show();

    } else {
        showColor(page_data['color'] || '', page_data['dw'] || '');
        $('#gys').css('width', '100%')
        $('#wldw_val').attr('placeholder', '请选择供应商')
    }
    //安卓返回键
    page_data.keyback = function () {
        isDataChange();
    };
    //监听页面返回值
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        console.log(ret);
        var temp = ret['value'] && ret['value']['data'];
        if (temp == undefined) return; // 如果temp不存在则不执行
        var __temp = temp['page_type'] && temp['page_type'] || '';

        switch (ret['value']['status']) {
            case 'select_list': // 选择客/供/加
                switch (__temp) {
                    case 'gys':
                    case 'jgs':
                    case 'kh':
                        $('#wldw_val').val(temp['select_val'] || "").data('wldw_id', temp['id'] || 0);
                        $('#gys').css('width', '75%')
                        if ($.nui.isEmpty($('.unit').data('unit_id'))) {
                            $('.unit').data('unit_id', page_data['jjdw_id'] || 0);
                        }
                        $('.change-edit').show();
                        break;
                        ;
                }
            case 'select_sx_list': // 单位
                switch (__temp) {
                    case 'dw':
                        $('.unit').text(temp['select_val'] || unit || '').data('unit_id', temp['id'] || 0);
                        break;
                }
                break;
            case 'update': // 返回按钮监听
                var backUpDateArr = [
                    { // 单位
                        pageType: 'dw',
                        idName: 'unit_id'
                    }
                ];
                fun.upDateBackSelRow({
                    backSelRow: temp,
                    backUpDateArr: backUpDateArr,
                    storageMode: 'data', // 自定义属性存储方式
                    assignMode: 'text' // 赋值方式
                });
                if ($.nui.isEmpty($('.unit').text().trim())) {
                    $('.unit').text(page_data['dw'] || '').data('unit_id', page_data['jjdw_id'] || 0);
                }
                break;
        }
    });
    if (IS_PAGE_EDIT) {
        Sortable.options.disabled = false;
        $('.delete-img').show()
    } else {
        $('.null-img').hide();
    }
    //判断底卡信息 页面 类型是否为主要，如果有开启，做默认不打开主要按钮
    judgeMainisTure();

    bindEvent(); // 初始化事件
    fun.setKeyBoard({ // 处理ios和安卓键盘弹起
        isIos: {
            showFn: keyBoardShow,
            hideFn: keyBoardHide
        },
        isAnd: {
            hideFn: keyBoardHideHandle
        }
    });
    fun.inputType();
}

//加载数据
function showData(data) {

    var wldw_name;
    switch (data['merchant_type']) {
        case 'jgs':
            wldw_name = "加工商";
            break;
        case 'kh':
            wldw_name = "客户";
            break;
        case 'gys':
            wldw_name = "供应商";
            break;
    }

    // 选择客/供/加做记忆
    $(type_data).each(function (idx, item) {
        item['is_choose'] = 0;
    })

    $(type_data).each(function (idx, item) {
        if (item['db_name'] === data['merchant_type']) {
            item['is_choose'] = 1;
        }
    })

    $('#gys_name').text(wldw_name || '');//往来单位类型/id
    if (data['is_default'] == 1) {
        $('.switch-stop-btn').removeClass('nui-unactive').addClass('nui-active');
    }
    $('#gys_name').attr('data-wldw', data['merchant_type'])
    $('#wldw_val').val(data['merchant_name'] || '').data('wldw_id', data['merchant_id']);//往来单位
    $('#fzbh').val(data['number'] || '');//辅助编号
    $('#fzmc').val(data['name'] || '');//辅助名称
    $('.unit').text((data['jjdw_mc'] || page_data['dw']) || '').data('unit_id', (data['jjdw_id'] || page_data['jjdw_id'] || 0))//计价单位
    showPic(data['imgs']);
    showColor(data['colour_assistant'] || '', data['jjdw_mc'] || page_data['dw']);//加载颜色
}

//加载图片
function showPic(imgs) {
    if ($.nui.isEmpty(imgs)) return;
    var html = [];
    if (Array.isArray(imgs)) {
        $(imgs).each(function (i, tiem) {
            var pic_thum = fun.getImgPath(tiem, false, { url: UPLOAD_IMG_PATH });
            var pic = fun.getImgPath(tiem, true, { url: UPLOAD_IMG_PATH });
            html.push(' <li class="show-img" id="show_img"  data-name="' + tiem + '">');
            html.push('     <img src="' + pic_thum + '" class="img uplod" data-url="' + pic + '">');
            html.push('     <div class="delete-img"><div class="packs"><i class="iconfont icon-fork fork"></i></div></div>');
            html.push(' </li>');
        });
    } else {
        if (imgs.indexOf(',') < -1) {
            var pic_thum = fun.getImgPath(imgs, false, { url: UPLOAD_IMG_PATH });
            var pic = fun.getImgPath(imgs, true, { url: UPLOAD_IMG_PATH });
            html.push(' <li class="show-img" id="show_img"  data-name="' + imgs + '">');
            html.push('     <img src="' + pic_thum + '" class="img uplod" data-url="' + pic + '">');
            html.push('     <div class="delete-img"><div class="packs"><i class="iconfont icon-fork fork"></i></div></div>');
            html.push(' </li>');
        } else {
            var img_arr = imgs.split(',');
            $(img_arr).each(function (i, tiem) {
                var pic_thum = fun.getImgPath(tiem, false, { url: UPLOAD_IMG_PATH });
                var pic = fun.getImgPath(tiem, true, { url: UPLOAD_IMG_PATH });
                html.push(' <li class="show-img" id="show_img"  data-name="' + tiem + '">');
                html.push('     <img src="' + pic_thum + '" class="img uplod" data-url="' + pic + '">');
                html.push('     <div class="delete-img"><div class="packs"><i class="iconfont icon-fork fork"></i></div></div>');
                html.push(' </li>');
            });
        }
    }

    $('.null-img').before(html.join(''));
    var img_length_show = $('.uplod').length;
    $('#pic-number').html(img_length_show);
    if (img_length_show >= 9) {
        $('.null-img').hide();
    }
    //权限
    if (IS_PAGE_EDIT) {
        $('.delete-img').show()
    } else {
        $('.null-img').hide();
    }

}

//加载颜色
function showColor(data, jj_dw) {
    if (data.length == 0) return;
    var html = [];
    for (var i = 0; i < data.length; i++) {
        var data_list = data[i],
            is_stop = data_list['is_stop'] ? 'through' : '',

            color_extra = page_data['type'] == 'add' ? true : data_list['name'] == '' && data_list['number'] == '' ? true : false,
            backups;
        if (page_data['type'] == 'add') {
            backups = {
                colour_name: data_list['name'],
                colour_number: data_list['number'],
                id: 0,
                is_delete: 0,
                name: '',
                number: '',
                order_amount: 0,
                price: 0,
                is_stop: data_list['is_stop']
            }
        } else {
            backups = data_list;
        }

        html.push('<li class="lower-border-line clear opacity8 color-list" style="display:flex"  data-color=\'' + JSON.stringify(backups) + '\'>');
        html.push('     <p class="yarn-color"><span class="over-hidden ' + is_stop + '">' + (backups['colour_number'] + backups['colour_name']) + '</span></p>');
        if (color_extra) {
            html.push('     <p class="order yarn-order"><span class="iconfont icon-xiugai" id="bianji"></span></p>')
        } else {
            html.push('     <p class="order yarn-order"><span class="dfjf_number">' + data_list['number'] + '</span><span class="dfjf_name">' + data_list['name'] + '</span></p>');
        }

        var input_id = Math.round(Math.random() * 10000);

        html.push('     <p class="yarn-price">');
        html.push('         <span class="color-button-red jiage">');
        html.push('             <input  type="text" class="jiage-inp num-input color-button-red" num_type="2" decimal_digits="4" value="' + (data_list['price'] || 0) + '" id="input_' + input_id + '">');
        html.push('         </span><span class="text-hidden">/</span>');
        html.push('         <span class="unit unit_two">' + jj_dw || '' + '</span>');
        html.push('     </p>');
        html.push('</li>');
        $('.unit').text(jj_dw || '')//计价单位
    }
    $('#showColor').append(html.join(''));
}

// 渲染编辑对面色号和名称
function editColour($this, number_val, name_val, index) {
    var html = [];
    html.push('  <div class="warm"> ');
    html.push('   <div class="warm-title"> ');
    html.push('    <span class="title" >对方叫法</span> ');
    html.push('   </div> ');
    html.push('   <div class="warm-con"> ');
    html.push('    <ul> ');
    html.push('     <li class="obj-title"> <span class="param">色号</span> <input id="colour_number" type="text" value="' + number_val + '"> </li> ');
    html.push('     <li class="obj-title"> <span class="param">名称</span> <input id="color_name" type="text" value="' + name_val + '"> </li> ');
    html.push('    </ul> ');
    html.push('   </div> ');
    html.push('   <div class="warm-operation"> ');
    html.push('    <button class="btn" id="cancel">取消</button>');
    html.push('    <button class="btn" id="confirm">确认</button> ');
    html.push('   </div> ');
    html.push('  </div>');
    layer.open({
        type: 1,
        content: html.join(''),
        shadeClose: false,
        style: 'width: 90%; min-height: auto; border-radius: 0.5rem;background-color: #fff; overflow-y: hidden;',
        success: function (ele) {
            document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android

            // 取消
            $('#cancel').on('tap', function () {
                $('.show-wrap').removeClass('modal-ios');
                setTimeout(function () {
                    document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
                    layer.closeAll()
                }, 50)
            });

            // 确定
            $('#confirm').on('tap', function () {
                $('.show-wrap').removeClass('modal-ios');
                var numval = $('#colour_number').val().trim();
                var color_name = $('#color_name').val().trim();
                if ($.nui.isEmpty(numval) && $.nui.isEmpty(color_name)) {
                    setTimeout(function () {
                        document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
                        layer.closeAll()
                    }, 50)
                    $('.order').eq(index).html('<span class="iconfont icon-xiugai" id="bianji"></span>')
                    // $('#colour_number').val() == '' &&  $('#color_name').val() == ''
                    // fun.toast('色号不能为空');
                } else {
                    //修改列表数据
                    $this.html('<span class="dfjf_number">' + numval + '</span><span class="dfjf_name">' + color_name + '</span>')
                    var data = $this.parent('.lower-border-line').data('color');
                    data['number'] = numval;
                    data['name'] = color_name;
                    $this.parent('.lower-border-line').data('color', data);

                    setTimeout(function () {
                        document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
                        layer.closeAll()
                    }, 50)
                }
            })
        }
    });
}

// parseFloat(mival.toFixed(4))
// 只能输入小数点4位
function is_event(state) {
    if (!state) {
        $('#add_btn').css('visibility', 'hidden');
        $('.pack').show();
        $('.pack').addClass('changes');
        $('.list-term').addClass('label_shake');
        Sortable.options.disabled = false;
        is_edit = true;
    } else {
        $('#add_btn').css('visibility', 'visible');
        $('.pack').hide();
        $('.pack').removeClass('changes');
        $('.list-term').removeClass('label_shake');
        Sortable.options.disabled = true;
        is_edit = false;
    }
}

// 转化iso路径
function IOSChange(list, callback) {
    var temporary = list;
    $.each(list, function (i, item) {
        UIAlbumBrowser.transPath({
            path: item['path']
        }, function (res, err) {
            if (res) {
                temporary[i]['path'] = res['path'];
                if (i >= list.length - 1) {
                    if (typeof callback === 'function') callback(temporary);
                }
            }
        });
    })
};

//添加图片
function addImgToImgs(obj, Introduction) {
    fun.showLoad();
    var imgItem = [];
    if (Introduction) {
        addImgs(obj, function (obj1) {
            fun.imagePickerRender({
                pushHtml: [],
                allImageData: obj1,
                end: function (params) {
                    var html = params.html || [];
                    $('.null-img').before(html.join(''));
                    var img_length = $('.uplod').length;
                    $('#pic-number').text(img_length);
                    if (img_length >= 9) {
                        $('.null-img').hide();
                    }
                    //权限
                    if (IS_PAGE_EDIT) {
                        $('.delete-img').show()
                    }

                    $('#add-picture,.box').hide();
                    fun.hideLoad();
                },
                renderHtml: function (params) {
                    var url = fun.is_value(params.imgUrl); // 图片路径
                    var imgName = fun.is_value(params.imgName); // 图片名称
                    var html = params.html || [];
                    var index = params.index;
                    html.push(' <li class="show-img" id="show_img" data-name="' + imgName + '">');
                    IS_PAGE_EDIT && html.push('     <img  src="' + url + '" class="img uplod" data-url="' + url + '">');
                    html.push('     <div class="delete-img"><div class="packs"><i class="iconfont icon-fork fork"></i></div></div>');
                    html.push(' </li>');
                }
            });
        })
    } else {
        var imgUrl = fun.is_value(obj.fileData.data);
        imgItem.push(' <li class="show-img" id="show_img" data-name="' + obj.imgName + '">');
        IS_PAGE_EDIT && imgItem.push('     <img src="' + imgUrl + '" class="img uplod" data-url="' + imgUrl + '">');
        imgItem.push('     <div class="delete-img"><div class="packs"><i class="iconfont icon-fork fork"></i></div></div>');
        imgItem.push(' </li>');
        $('.null-img').before(imgItem.join(''));
        var img_length = $('.uplod').length;
        $('#pic-number').text(img_length);
        if (img_length >= 9) {
            $('.null-img').hide();
        }
        //权限
        if (IS_PAGE_EDIT) {
            $('.delete-img').show()
        }
        $('#add-picture,.box').hide();
        fun.hideLoad();
    }

}

function addImgs(param, callback) {
    if (count >= param.length) {
        count = 0;
        if (typeof callback === 'function') callback(param)
        return param;
    }
    fun.getUrlBase64(param[count]['path'], param[count]['suffix'], function (base64) {
        // console.log('count',count-1,'base64',base64);//base64编码值
        param[count - 1]['base64'] = base64;
        addImgs(param, callback);
    });
    count++;
}

// 返回判断数据改变
function isDataChange() {
    var val = $('#wldw_val').val();
    var data = getData();
    if (page_data['page_type'] == 'product_view_empty') {
        if ($.nui.isEmpty(data['merchant_id'])) {
            closePage();
        } else {
            if ($('body').find('.data-change-skin').length) return;
            fun.dialog({
                content: '您确定要保存吗？',
                btn: ['保存', '不保存', '取消'],
                shadeClose: false,
                className: 'data-change-skin',
                yes: function () {
                    saveData(data);
                },
                no: function () {
                    closePage();
                }
            });
        }

    } else {
        if ($.nui.isTrue($('#wldw_val').val().trim())) {
            var merchant_assistants = []
            if ($.nui.isTrue(data)) {
                merchant_assistants.push(data);
            }
            api.sendEvent({
                // name: page_arr.shop_dk_dkyl,
                name: page_data['return_page'],
                extra: {
                    'status': 'cpzl_data',
                    'page_type': 'dk_bj',
                    'data': data,
                    'type': page_data['type'],
                    'merchant_assistants': merchant_assistants,
                }
            });
        }
        closePage();
    }
}

//返回上一页
function closePage() {
    setTimeout(function () {
        api.closeWin({
            name: html_name,
        });
    }, 200);
}

// 获取保存数据
function getData() {
    var __imgs = [];//图片
    for (var i = 0; i < $('.show-img').length; i++) {
        __imgs.push($('.show-img').eq(i).data('name'));
    }

    var __data = {
        merchant_type: $('#gys_name').data('wldw') || '',//往来单位类型
        merchant_id: Number($('#wldw_val').data('wldw_id')) || 0,//往来单位id
        merchant_name: $('#wldw_val').val().trim() || '',//往来单位名称
        is_default: $('.switch-stop-btn').hasClass('nui-active') ? 1 : 0,//主要
        number: $('#fzbh').val().trim() || '',//辅助名称
        name: $('#fzmc').val().trim() || '',//辅助编号
        imgs: __imgs || [],
        jjdw_id: Number($('#jj_dw').data('unit_id')) || 0,//计量单位
        jjdw_mc: $('#jj_dw').text().trim() || '',//计量单位
    }

    var storage = $.extend(data, __data);
    storage['colour_assistant'] = [];
    $('.color-list').each(function (k, obj) {//颜色记录行
        storage['colour_assistant'].push($('.color-list').eq(k).data('color'));
        storage['colour_assistant'][k]['price'] = Number($('.jiage-inp').eq(k).val());
    })
    return storage;
}

//做记忆，判断底卡信息 主要是否有开启
function judgeMainisTure() {
    if ('main_isTure' in page_data) {
        if ($('#gys_name').text().indexOf('供应商') > -1 && page_data['main_isTure']['gys_isTure'] == 0) {
            $('.switch-stop-btn').removeClass('nui-unactive').addClass('nui-active');
        } else if ($('#gys_name').text().indexOf('供应商') > -1 && page_data['main_isTure']['gys_isTure'] == 1) {
            $('.switch-stop-btn').removeClass('nui-active').addClass('nui-unactive');
        }

        if ($('#gys_name').text().indexOf('加工商') > -1 && page_data['main_isTure']['jgs_isTure'] == 0) {
            $('.switch-stop-btn').removeClass('nui-unactive').addClass('nui-active');
        } else if ($('#gys_name').text().indexOf('加工商') > -1 && page_data['main_isTure']['jgs_isTure'] == 1) {
            $('.switch-stop-btn').removeClass('nui-active').addClass('nui-unactive');
        }

        if ($('#gys_name').text().indexOf('客户') > -1 && page_data['main_isTure']['kh_isTure'] == 0) {
            $('.switch-stop-btn').removeClass('nui-unactive').addClass('nui-active');
        } else if ($('#gys_name').text().indexOf('客户') > -1 && page_data['main_isTure']['kh_isTure'] == 1) {
            $('.switch-stop-btn').removeClass('nui-active').addClass('nui-unactive');
        }
    }
}

// 保存数据
function saveData(dk_data) {
    dk_data['id'] = 0
    var _save_data = []
    _save_data.push(dk_data);

    var data = page_data['count_data']
    var info = data['info'];
    if ($.nui.isEmpty(info['imgs'])) {
        info['imgs'] = []
    } else {
        if (!$.isArray(info['imgs'])) {
            var imgs = info['imgs']
            if (imgs.indexOf(',') > -1) {
                info['imgs'] = []
                info['imgs'] = imgs.split(',');
            } else {
                info['imgs'] = []
                info['imgs'].push(imgs)
            }
        }
    }

    var save_data = {
        save_type: 'save',
        id: info['id'] || 0,
        type: 'sx', // 类型
        date: info['date'] || '', // 时间
        number: info['number'] || '', // 编号
        name: info['name'] || '', // 名称
        unit_id: info['unit_id'], // 单位id
        component: info['component'] || '', // 成分
        diff: info['diff'] || '+', // 空差模式
        imgs: info['imgs'], // 主图
        unit_options: info['unit_options'],
        class_id: info['class_id'],
        remark: info['remark'], // 备注
        label_id: info['label_id'], // 标签id
        is_stop: info['is_stop'], // 是否停用
        sx_jw: info['sx_jw'], // 经纬
        craft: info['craft'], // 工艺
        brand: info['brand'], // 品牌
        area: info['area'], // 地区
        nature: info['nature'], //性质
        sx_ys: info['sx_ys'], // 预损
        sx_jz: info['sx_jz'], // 均重
        goods_colour: data['goods_colour'], // 产品颜色
        delete_colour: [], // 删除的产品颜色
        goods_spec: data['goods_spec'], // 规格
        delete_spec: [], // 删除的规格
        merchant_assistant: _save_data, // 底卡信息
        delete_merchant_assistant: [], // 删除的底卡信息
        delete_colour_assistant: [],
        goods_machining: data['goods_machining'], // 加工
        delete_machining: [], // 删除的加工
        delete_converter: [], //
        delete_process: [],
        goods_craft: data['goods_craft'] || [], // 工艺
        delete_craft: [], // 删除工艺 
        goods_param: data['param'], // 其他参数
        goods_material: [],
        delete_material: [],
    };
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveYarn,
        data: save_data,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.toast('保存成功')
                    fun.showLoad();
                    api.sendEvent({
                        name: page_arr.yarn_view,
                        extra: {
                            status: 'refresh'
                        }
                    })
                    closePage();
                    fun.hideLoad();
                    break;
                case 104:
                    var msg = '';
                    switch (res['data']['type']) {
                        case 'number':
                            msg = '该编号';
                            break;
                        case 'name':
                            msg = '名称';
                            break;
                        case 'colour':
                            msg = res['data']['name'] || '';
                            break;
                        case 'machining':
                            msg = '加工流程-加工商记录表出现相同加工商。';
                            break;
                        case 'assistant':
                            msg = '辅助对象不能出现2个一样的：客\\供\\加。';
                            break;
                    }
                    return fun.toast((res['data']['type'] != 'assistant' && res['data']['type'] != 'machining') ? (msg + '已存在。') : msg);
                    break;
                case 101:
                    fun.toast('保存失败。');
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    });
}

// 键盘弹起处理
function keyBoardShow() {
    fun.headerAbsolute('#header');
    $('.show-wrap').removeClass('scroll');
}

// 键盘处理处理
function keyBoardHide() {
    keyBoardHideHandle();
    fun.headerFixed('#header');
    $('.show-wrap').addClass('scroll');
}

// 安卓ios键盘收起处理
function keyBoardHideHandle() {
    if ($('input').hasClass('single-ipt')) { // 失去焦点颜色单独设置价格处理
        var val = $('.single-ipt').val().trim();
        if ($.nui.isEmpty(val)) {
            $('.single-ipt').val(0);
        }
        $('input').removeClass('single-ipt');
    }

    if ($('input').hasClass('batch-ipt')) { // 失去焦点颜色批量设置价格处理
        var val = $('.batch-ipt').val().trim();
        if ($.nui.isEmpty(val)) {
            $('.batch-ipt').val(0);
            $('.jiage-inp').val(0);
        } else {
            $('.jiage-inp').val(val);
        }
        $('input').removeClass('batch-ipt');
    }
}

// 输入框输入值处理
function singleIptHandle() {
    if ($.nui.isEmpty($(this).val().trim())) {
        $(this).val('');
    }
}

// 输入框添加类名
function IptAddClass(selector) {
    $(this).addClass(selector);
}

// 输入框清除类名
function iptRemoveClass(selector) {
    $(this).removeClass(selector);
}

//加载图片到页面上
// function addPic(img_url, img_nmae) {
//     var html = [];
//     html.push(' <li class="show-img" id="show_img" data-name="' + img_nmae + '">');
//     html.push('     <img src="' + img_url + '" class="img" data-url="' + img_url + '">');
//     html.push('     <div class="iconfont icon-shanchu11 news-circle"></div>');
//     html.push(' </li>');
//     $('.null-img').before(html.join(''));
//     var img_length = $('.show-img').length;
//     if (img_length <= 9) $('#pic-number').text(img_length);
//     if (img_length == 9) $('.null-img').hide();
//     $('.news-circle').show()
// }


// 初始化事件
function bindEvent() {
    //iphoneX适应
    $('#ys_list').css('margin-bottom', api.safeArea.bottom + 'px');
    $('#cancelPhoto').css('margin-bottom', api.safeArea.bottom + 'px')

    // 产品主图
    $('body').on('touchstart', '#cpzt-img .img', function () {
        var cpzt_index = $("#cpzt-img .img").index(this);
        press_startTime = +new Date();
        press_Time = setTimeout(function () {
            if ($("#cpzt-img .img").eq(cpzt_index).attr("src") == '../../img/null.png') {
                $("#add-picture,.box").css("display", "block");
                document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
            }
        }, 500);
    });

    $('body').on('touchend', '#cpzt-img .img', function () {
        press_endTime = +new Date()
        clearTimeout(press_Time)
        if (press_endTime - press_startTime >= 500) {

        }
    });

    // 点击预览图片
    $('body').on('click', '#cpzt-img .img', function () {
        press_endTime = +new Date();
        // var cpzt_index2 = $("#cpzt-img .img").index(this);
        clearTimeout(press_Time);
        if (press_endTime - press_startTime < 500) {
            if ($(this).attr("src") != '../img/null.png') {
                var img_arr = [];
                img_arr.push(String($(this).data('url')));
                var photoBrowser = api.require('photoBrowser');
                photoBrowser.open({
                    images: img_arr,
                    activeIndex: 0,
                    placeholderImg: '../../img/logo.png',
                    bgColor: '#000'
                }, function (ret, err) {
                    if (ret) {
                        if (ret['eventType'] == 'click') {
                            photoBrowser.close();
                        }
                    }
                });

            } else {
                $("#add-picture,.box").css("display", "block");
            }
        }
    });

    // 点击切换客户、供应商、加工商
    $('#gys_name').on('click', function () {
        var _this = $(this);
        fun.showBookList({
            width: '280px',
            shadeClose: true,
            list: type_data,
            choose: function (res) {
                $(type_data).each(function (i, obj) {
                    if (obj['id'] == res['id']) {
                        type_data[i]['is_choose'] = 1;
                    } else {
                        type_data[i]['is_choose'] = 0;
                    }
                })
                if ($('#gys_name').data('wldw') == res['db_name']) return;
                $('.change-edit').hide();
                $('#wldw_val').val('').data('wldw_id', 0);
                $('#gys_name').text(res['name'] || "").data('wldw', (res['db_name'] || ""));
                //记忆功能
                $('#wldw_val').attr('placeholder', '请选择' + res['name'])
                judgeMainisTure();
            }
        });
    });

    //选择往来单位
    $('#wldw_val').on('tap', function () {
        var data = [];
        var sib = $(this).siblings('#gys_name').data('wldw');
        $(page_data['merchant_assistant']).each(function (i, item) {

            if (item['merchant_type'] == sib) {
                var merchant = {};
                merchant['merchant_type'] = item['merchant_type'];
                merchant['merchant_name'] = item['merchant_name'];
                data.push(merchant);
                if ($('#wldw_val').val().trim() == merchant['merchant_name']) {
                    current = merchant['merchant_name']
                }
            }

            // else if(item['merchant_type'] == 'kh'){
            //     data[i]['merchant_type'] = item['merchant_type']
            //     data[i]['merchant_name'] = item['merchant_name']
            // }else if(item['merchant_type'] == 'jgs'){
            //     data[i]['merchant_type'] = item['merchant_type']
            //     data[i]['merchant_name'] = item['merchant_name']
            // }
        })
        console.log(data)
        fun.showPageFull({
            page_url: page_arr.customer_search,
            pageParam: {
                return_page: html_name,
                page_type: sib,
                verify_data: data,
                current: current,
                goods_type: 'sx',
                type: 'dk_bj',
            }
        })
    })

    //选择单位
    $('#batch_unit').on('tap', function () {
        unit = $('#jj_dw').text()
        fun.showPageFull({
            page_url: page_arr.select_sx_list,
            pageParam: {
                "return_page": html_name,
                "page_type": 'dw'
            }
        });
    })

    // // 点击编辑对方色号和名称
    // $('body').on('tap', '.order', function (e) {
    //     var $this = $(this);
    //     var number_val = $this.find('.dfjf_number').text();
    //     var name_val = $this.find('.dfjf_name').text();
    //     var index = $('.order').index(this)
    //     editColour($this, number_val, name_val, index);
    // });

    // 统一价格
    $('body').on('focus', '.money', function () {
        IptAddClass.call(this, 'batch-ipt');
        singleIptHandle.call(this);
    })

    // 设置颜色价格
    $('body').on('focus', '.jiage-inp', function () {
        IptAddClass.call(this, 'single-ipt');
        singleIptHandle.call(this);
    })

    // 多个输入框相同类名的情况下，失去焦点必须清除对应的类名
    $('body').on('blur', '.jiage-inp', function () {
        iptRemoveClass.call(this, 'single-ipt');
    })

    // 多个输入框相同类名的情况下，失去焦点必须清除对应的类名
    $('body').on('blur', '.money', function () {
        iptRemoveClass.call(this, 'batch-ipt');
    })

    // 添加新图片
    $('.null-img').on('click', function () {
        document.body.addEventListener('touchmove', preventDefault, { passive: false });
        $('#add-picture,.box').show();
    })

    // 取消新增图片选项
    $('#cancelPhoto').on('tap', function () {
        document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        $('#add-picture,.box').css("display", "none");
    });

    // 拍照
    $('#paizhao').on('tap', function () {
        document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        $('#add-picture,.box').hide();
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 100,
            targetWidth: 1000,
            targetHeight: 1000,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (!$.nui.isEmpty(ret)) {
                if (ret['base64Data'] != '') {
                    fun.showLoad();
                    var fileData = {
                        data: ret || [],
                        index: 0
                    };
                    fun.fileUpload(fileData, function (imgName) {
                        addImgToImgs({
                            imgName: imgName,
                            fileData: ret || {},
                        }, false);
                    });
                }
            }
        });
    });

    // 从相册中选择
    $('#selectPhoto').on('tap', function () {
        document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        $('#add-picture,.box').hide();
        var img_length = $('.show-img').length;
        var max;
        if (img_length == 0) {
            max = 6;
        } else {
            var max_clong = 9 - img_length;
            max_clong > 6 ? max = 6 : max = max_clong
        }

        // 20200927 点击很多次确定会返回上一个页面，这里要限制只执行一次
        var UIAlbumBrowserTimer = null;
        var UIAlbumBrowserTimerFlag = true;

        UIAlbumBrowser.imagePicker({
            max: max,//最多选择图片的数量，默认为9
            showCamera: false,//禁止访问相机
            styles: {//选择图片的样式 
                bg: '#fff',
                nav: {
                    cancelColor: '#000',//取消按钮颜色
                    nextStepColor: '#000',//确定按钮颜色
                    cancelText: '返回',
                    finishText: '确定'
                },
            }
        }, function (ret) {

            if(UIAlbumBrowserTimerFlag) {
                UIAlbumBrowserTimerFlag = false;
                clearTimeout(UIAlbumBrowserTimer);
                UIAlbumBrowserTimer = null;
                UIAlbumBrowserTimer = setTimeout(function(){
                    UIAlbumBrowserTimerFlag = true;
                }, 1000);

                nextConfirm(ret);
            }

            function nextConfirm(ret) {
                if (ret.eventType == 'nextStep') {
                    var u = navigator.userAgent;
                    var list = ret['list'];
                    if (list == undefined || list == '' || list == null) return UIAlbumBrowser.closePicker();
                    fun.UploadRestriction(list, function () {
                        if (u.indexOf('Android') > -1 || u.indexOf('Linux') > -1) {//安卓路径无误
                            addImgToImgs(list, true);
                            UIAlbumBrowser.closePicker();
                        } else if (!!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) { // ios路径需转化,包括iPad
                            IOSChange(list, function (temporary) {
                                addImgToImgs(temporary, true);
                            })
                            UIAlbumBrowser.closePicker();
                        }
                    });
                }
            }
        })
    });

    $('body').on('tap', '.num-input', function () {
        var id = $(this).attr('id');
        $('#' + id).blur(function () {
            if ($('#' + id).val().trim() == '') {
                $('#' + id).val(0)
            }
        })
    })

    // 点击删除按钮出现提示语
    $('body').on('tap', '#cpzt-img .delete-img', function (e) {
        e.preventDefault();
        e.stopPropagation();
        var pic = $(this).parent();
        fun.dialog({
            content: '你确定要删除主图吗？',
            btn: ['删除', '取消'],
            isClose: false,
            yes: function () {
                pic.remove();//删除对应的图片
                // if ($('.show-img').length < 9) {//如果是小于9张图的话，要显示null图
                //     $('.null-img').show();
                // }

                $('#pic-number').text($('.show-img').length);
                if ($('.null-img').is(':hidden')) {
                    $('.null-img').show();
                }
                if ($('.null-img').length == 0) {
                    var html = [];
                    html.push('<div class="null-img">');
                    html.push('    <img src="../img/null.png" class="img" alt="">');
                    html.push('</div>');
                    $('#cpzt-img').append(html.join(''));
                }
                layer.closeAll();//关闭弹窗
            }
        });
    });

    // 点击编辑对方色号和名称
    $('body').on('tap', '.order', function (e) {
        var $this = $(this);
        var number_val = $this.find('.dfjf_number').text();
        var name_val = $this.find('.dfjf_name').text();
        var index = $('.order').index(this)
        $('.show-wrap').addClass('modal-ios');
        editColour($this, number_val, name_val, index);
    });
}