var html_name = page_arr.yarn_edit; // 页面名称
var params_data = [];
var photoBrowser = null; // 拍照单选图片
var UIAlbumBrowser = null; // 多选图片
var IS_PAGE_EDIT = true; // 页面是否可编辑
var _origin_data = {};
var _save_data = {};
var label_arr = ''; // 标签
var DATA_LIST = {};

var count = 0; // 相册图片递归终止变量
var sx_lb_list = null;
var SYS_CONFIG = {};
var imgInfo = []; // 临时存储相册图片路径
var imgSub = { // 最多还可以选择几张图片
    cpMax: 0,
    skMax: 0,
    bbxqMax: 0
}
var main_isTure = {     //判断该类型是否开启主要功能，给底卡编辑做记忆功能用
    'gys_isTure': 0,
};

search_data = { // 单选多选
    'id': 0
};

// 返回被删除的列表
delete_list = {
    colour_arr: [], // 颜色
    width_weight_arr: [], // 幅宽克重
    spec_arr: [], // 规格
    fzxx_arr: [], // 辅助信息（其他要求）
    craft_arr: [], // 工艺
    fzxx_colouArr: [],//删除的底卡辅助颜色信息
};

// 纱线信息
var CP_INFO = {
    info: {},
    goods_colour: [],
    goods_weight: [],
    goods_spec: [],
    merchant_assistant: [],
    goods_machining: [],
    goods_craft: [],
    options: {},
    param: []
};

// 默认
var default_obj = {
    default_fkkz: {}, // 幅宽克重默认
    default_gg: {} // 规格默认
}

// 图片滑动
var sortable = {
    sortable1: null, // 纱线主图拖拽
    // sortable2: null, // 色卡主图拖拽
    // sortable3: null //  宝贝详情拖拽
};

// 点击类型弹出
var type_data = [
    {
        id: 1,
        name: '经纱',
        db_name: 'js',
        "is_choose": 0
    },
    {
        id: 2,
        name: '纬纱',
        db_name: 'ws',
        "is_choose": 0
    }
];

// 纱线编辑
var yranEdit = {
    searchData: { // 报价搜索数据
        type: "add",
        is_mobile: 1,
        cp_id: 0,
        cp_lb_id: 0,
        jjdw_id: 0,
        sx_pp: '',
        sx_dq: '',
        sx_xz: '',
        gg: '',
    },
    offerData: [] // 纱线报价数据
};

// 初始化之后
yranEdit.initAfter = function () {
    $('#cancelPhoto').css('margin-bottom', api.safeArea.bottom);
    $('#wrap, .bottom-space-evenly').css({
        paddingBottom: api.safeArea.bottom
    });
    if (!!$('.fixed:visible').length) {
        $('#click-show').css({
            marginBottom: $('.fixed').height()
        })
    } else {
        $('#click-show').css({
            marginBottom: $('.fixed:visible').length ? $('.fixed').outerHeight() : $('#wrap').css('padding-bottom', api.safeArea.bottom / 2)
        })
    }
}

// 初始化纱线价格搜索条件
yranEdit.upDateYranSearchCondition = function () {
    var xsdw_id = CP_INFO['info']['unit_options']['xsdw_id'];
    this.searchData['cp_id'] = page_data['id'];
    this.searchData['cp_lb_id'] = $('#sx_lb').attr('lb_id') || 0;
    this.searchData['jjdw_id'] = getUnitId();
    this.searchData['jjdw_mc'] = getJjdw(xsdw_id);
    this.searchData['sx_pp'] = $('#sx_pp').val().trim() || '';
    this.searchData['sx_dq'] = $('#sx_dq').val().trim() || '';
    this.searchData['sx_xz'] = $('#sx_xz').val().trim() || '';
    this.searchData['gg'] = $('#cp_gg').val().trim() || '';
};

yranEdit.filterOfferData = function () {
    var offerArr = [];
    $(CP_INFO['bj_info']['data']).each(function (idx, item) {
        offerArr.push({
            cp_ys_mc: item['cp_ys_mc'],
            cp_ys_bh: item['cp_ys_bh'],
            cp_ys_id: item['cp_ys_id'],
            bz_bzj: item['bz_bzj'] || 0,
            id: item['id']
        })
    });
    return offerArr;
}

yranEdit.initOfferData = function () {
    this.offerData = yranEdit.filterOfferData();
}

page_init = function () {
    SYS_CONFIG = fun.getItem('sys_config') || {};
    IS_PAGE_EDIT = Auth.check('sx', 'edit');
    fun.load_DATA_LIST(['jjdw', 'sx_lb'], function () {
        sx_lb_list = fun.getItem('sx_lb_list');
        if (!page_data['id']) {
            $('#sx_lb').attr('lb_id', page_data['last_lb_id'] || 0).val(fun.getValByKey(sx_lb_list, page_data['last_lb_id'], 'name')) || '';
        }
    }, {
        showLoad: true,
        hideLoad: false,
        close: false
    })

    photoBrowser = api.require('photoBrowser');
    UIAlbumBrowser = api.require('UIAlbumBrowser'); // 多选图片模块

    if (IS_PAGE_EDIT) {
        $('.fixed').show();
    }
    if (page_data && page_data['id']) { // 记录行进来
        search_data['id'] = page_data['id'];
        $('#shade').show();
        getList();
    } else { // 新增进来

        showNewAdd();

        getParam(); // 获取参数
        getNumber(); // 获取纱线编号
    }

    $('.message-wrap').hide();

    $("#header").header({ // 头部初始化
        back: true,
        title: '纱线',
        appendBackBtnEvt: isDataChange
    })

    page_data.keyback = function () { // 监听安卓返回键
        isDataChange();
    };

    // 时间插件
    new lCalendar().init({
        'trigger': '#cp_sj',
        'type': 'datetime',
        callback: function (date) {
            $('#cp_sj').text(date);
        }
    });

    api.addEventListener({
        name: page_arr.yarn_edit,
    }, function (ret, err) {
        var temp = ret['value'] || {},
            data = temp['data'] || {};
        console.log('------------------');
        console.log(data)
        switch (temp['status']) {
            case 'refresh':
                $('#cp_dw').val(data['dw_mc']); // 单位
                $('#cp_dw').attr('dw_id', data['dw_id'] || 0);
                CP_INFO['info']['unit_id'] = data['dw_id'] || 0;
                CP_INFO['info']['unit_options']['xsdw_id'] = Number(data['dw_id']) || 0;
                yranEdit['offerData'] = data['quoteData'];
                showJg();
                break;
            case "select_list":
                if (data['page_type'] == "sx_lb") {
                    $('#sx_lb').attr('lb_id', data['id'] || 0).val(data['select_val'] || "");
                }
                break;
            case "select_sx_list":
                switch (data['page_type']) {
                    // case "sx_lb":
                    //     $('#sx_lb').attr('lb_id', data['id'] || 0).val(data['select_val'] || "");
                    //     break;
                    case "sx_pp":
                        $('#sx_pp').attr('pp_id', data['id'] || 0).val(data['select_val'] || "");
                        break;
                    case "sx_dq":
                        $('#sx_dq').attr('dq_id', data['id'] || 0).val(data['select_val'] || "");
                        break;
                    case "sx_xz":
                        $('#sx_xz').attr('xz_id', data['id'] || 0).val(data['select_val'] || "");
                        break;

                    // case "cp_jd":
                    //     $('#cp_jd').attr('jd_id', data['id'] || 0).val(data['select_val'] || "");
                    //     break;
                    case "dw":
                        $('#cp_dw').attr('dw_id', data['id'] || 0).val(data['select_val'] || "");
                        break;
                    case "sx_gy":
                        $('#sx_gy').attr('gy_id', data['id'] || 0).val(data['select_val'] || "");
                        break;
                    // 没有default
                }
                break;
            case 'cpzl_data':
                switch (temp['page_type']) {
                    case 'gg': // 规格
                        CP_INFO['goods_spec'] = temp['list']; // 修改后的规格数据
                        if ($.nui.isTrue(temp['delete_arr'])) {
                            $(temp['delete_arr']).each(function (idx, item) {
                                delete_list['spec_arr'].push(item);
                            })
                        }
                        default_obj['default_gg'] = temp['default_obj']; // 默认的规格数据
                        $('#cp_gg').val(default_obj['default_gg']['spec']);
                        break;
                    case 'qtyq': // 其他要求
                        CP_INFO['goods_craft'] = temp['list']; // 其他要求
                        if ($.nui.isTrue(temp['delete'])) {
                            $(temp['delete']).each(function (idx, item) {
                                delete_list['craft_arr'].push(item); // 删除的工艺
                            })
                        }
                        break;
                    case 'qtcs': // 其他参数
                        CP_INFO['param'] = temp['list'];
                        break;
                    case 'dk_xx': //  底卡信息 
                        var tempArr = [];
                        CP_INFO['merchant_assistant'] = temp['merchant_assistant'];
                        if ($.nui.isTrue(CP_INFO['merchant_assistant'])) {
                            $(CP_INFO['merchant_assistant']).each(function (idx, item) {
                                if (item['is_delete']) { // 被删除的需要把id传进去
                                    if ('id' in item) {
                                        delete_list['fzxx_arr'].push(item['id']);
                                    }
                                } else { // 没被删除
                                    if (item['merchant_id']) {
                                        tempArr.push(item);
                                    }
                                }
                            })
                        }
                        CP_INFO['merchant_assistant'] = tempArr;
                        $('#fzxx_jl').text(CP_INFO['merchant_assistant'].length + '个');
                        break;
                    case 'dk_bj':
                        if ($.nui.isTrue(temp['data']['merchant_name'])) {
                            $(temp['data']).each(function (index, item) {
                                CP_INFO['merchant_assistant'].push(item);
                            })
                            $('#fzxx_jl').text(CP_INFO['merchant_assistant'].length + '个');
                        } else {
                            $('#fzxx_jl').text('0个');
                        }
                        break;
                }
                break;
            case 'yarn_color': // 颜色编辑界面返回到纱线编辑界面，需要返回停用颜色个数
                $(temp['data']).each(function (index, item) {
                    delete item['__index'];
                })
                CP_INFO['goods_colour'] = temp['data']; // 获取颜色编辑界面修改后的数据
                //循环底卡的数量，更换里面的颜色信息
                if (CP_INFO['merchant_assistant'].length > 0) { // 有底卡
                    $(CP_INFO['merchant_assistant']).each(function (merchant_index, colour_item) {
                        var colour_length = colour_item['colour_assistant'].length; // 有多少个赋值颜色
                        var parme_arr = [];
                        $(CP_INFO['goods_colour']).each(function (colour_index, item) {   // 返回颜色通知底卡颜色改变
                            var index = item['_index']; // 纱线编辑颜色的_index
                            // 判断如果有新增的颜色则做加入，存在则做修改,如果存在，则colour_assistant数组长度是大于0的
                            if (('_index' in item)) {
                                var colour_assistant = colour_item['colour_assistant'][index];
                            }
                            if (('_index' in item) && colour_item['colour_assistant'].length > 0 && colour_assistant != undefined && ('goods_colour_id' in colour_assistant)) {
                                var parme = {
                                    colour_number: item['number'] || '',
                                    colour_name: item['name'] || '',
                                    id: colour_assistant['id'],
                                    goods_id: item['goods_id'],
                                    merchant_assistant_id: colour_assistant['merchant_assistant_id'],
                                    goods_colour_id: item['id'],
                                    number: colour_assistant['number'] || '',
                                    name: colour_assistant['name'] || '',
                                    simple: colour_assistant['simple'],
                                    order_amount: colour_assistant['order_amount'] || 0,
                                    price: colour_assistant['price'] || 0,
                                    is_delete: colour_assistant['is_delete'],
                                    create_time: colour_assistant['create_time'],
                                    update_time: colour_assistant['update_time'],
                                    is_stop: item['is_stop']
                                }
                                // if ('is_stop' in colour_assistant) {
                                //     parme['is_stop'] = item['is_stop'];
                                // }
                                parme_arr.push(parme);
                            } else {
                                var parme = {
                                    colour_name: item['name'],
                                    colour_number: item['number'],
                                    id: 0,
                                    is_delete: 0,
                                    name: '',
                                    number: '',
                                    order_amount: 0,   //如果底卡是新增的，但还没保存的情况下，则那新增时价格对应进去，如果有多余的，则取0
                                    price: ('_index' in item && colour_length >= (item['_index'] + 1)) ? colour_assistant['price'] : 0,
                                    is_stop: item['is_stop']
                                }
                                // if ('is_stop' in colour_assistant) { parme['is_stop'] = item['is_stop'] }
                                parme_arr.push(parme);
                            }
                        })

                        //判断是否有删除，有则把对面辅助颜色id返回
                        if ($.nui.isTrue(temp['delete_colour'])) {
                            $(temp['delete_colour']).each(function (idx, item) {
                                if (item['_index'] != '') {
                                    delete_list['fzxx_colouArr'].push(colour_item['colour_assistant'][item['_index']]['id'])
                                }
                            })
                        }
                        colour_item['colour_assistant'] = parme_arr;
                    })
                }
                $('#ys_stop_count').text(temp['stop_count'] + '个');
                if ($.nui.isTrue(temp['delete_colour'])) {
                    $(temp['delete_colour']).each(function (idx, item) {
                        delete_list['colour_arr'].push(item['id']); // 被删除颜色列表
                    })
                }
                break;
            case 'label': // 选择标签
                label_arr = temp['label_arr'];
                getLabel(label_arr);
                break;
            case 'update': // 更新类别
                // if (data['page_type'] == 'sx_lb') {
                //     for (var i = 0; i < data['del_id'].length; i++) {
                //         if (data['del_id'][i] === Number($('#sx_lb').attr('lb_id'))) {
                //             $('#sx_lb').attr('lb_id', '').val('')
                //         }
                //     }
                // }
                var backUpDateArr = [
                    { // 类别
                        pageType: 'sx_lb',
                        idName: 'lb_id'
                    },
                    { // 单位
                        pageType: 'dw',
                        idName: 'dw_id'
                    },
                    { // 品牌
                        pageType: 'sx_pp',
                        idName: 'pp_id'
                    },
                    { // 地区
                        pageType: 'sx_dq',
                        idName: 'dq_id'
                    },
                    { // 性质
                        pageType: 'sx_xz',
                        idName: 'xz_id'
                    },
                    { // 工艺
                        pageType: 'sx_gy',
                        idName: 'gy_id'
                    }
                ];
                fun.upDateBackSelRow({
                    backSelRow: data,
                    backUpDateArr: backUpDateArr,
                    storageMode: 'attr',
                    assignMode: 'val',
                });
                break;
        }

        if (data['page_type'] == 'dw') { // 单位
            $('.unit').text(data['select_val']);
        }
    });

    bindEvent(); // 绑定事件
    pageEditDisabled();
    fun.setKeyBoard({
        isIos: {
            hideFn: keyBoardHide,
            showFn: keyBoardShow,
        },
        isAnd: {
            hideFn: keyBoardHide,
            showFn: keyBoardShow,
        },
        ele: '.content-wrap',
    });
    _origin_data = JSON.parse(JSON.stringify(getSaveData()));
    yranEdit.initAfter();
}

// 获取计较单位
function getJjdw(xsdw_id) {
    var jjdwMc = '';
    if ($.nui.isTrue(xsdw_id)) { // 销售单位id
        jjdwMc = fun.getValByKey(fun.getItem('jjdw_list'), Number(xsdw_id), 'name');
    } else {
        if ($.nui.isTrue(CP_INFO['info']['unit_id'])) { // 单位id
            jjdwMc = $('#cp_dw').val().trim();
        }
    }
    return jjdwMc;
}

// 获取单位id（有销售单位id拿，没有拿主单位，如果没有给0）
function getUnitId() {
    var unitId = 0;
    if ($.nui.isTrue(CP_INFO['info']['unit_options']['xsdw_id'])) {
        unitId = CP_INFO['info']['unit_options']['xsdw_id'];
    } else if ($.nui.isTrue(CP_INFO['info']['unit_id'])) {
        unitId = CP_INFO['info']['unit_id'];
    }
    return unitId;
}

// 没有取到值返回0
function showVal(value) {
    if ($.nui.isEmpty(value)) {
        value = 0;
    }
    return value;
}

// 显示价格
function showJg() {
    var jgValue = yranEdit['offerData']; // 报价方式价格数据
    var xsdw_id = CP_INFO['info']['unit_options']['xsdw_id']; // 计价单位id
    var unit = $.nui.isTrue(getJjdw(xsdw_id)) ? '/' + getJjdw(xsdw_id) : '';

    if ($.nui.isEmpty(jgValue)) { // 没填价格，显示0元，计价单位（有销售辅助单位拿销售辅助单位，没有不显示）
        $('.price-box').text('0元' + unit);
        return;
    } else { // 有价格
        var cpYsArr = [];
        var dhArr = [];
        var dhZero = false;
        if ($.nui.isTrue(jgValue)) {
            // 报价价格显示与产品与差异：产品需要排除白坯#，纱线不需要排除白纱#
            $(jgValue).each(function (idx, item) {
                // if (item['cp_ys_bh'] !== '坯纱#') {
                cpYsArr.push(item);
                dhArr.push(showVal(item['bz_bzj']));
                // }
            })
        }

        dhZero = dhArr.every(function (item, idx) { // 除了白坯填的都为0
            return !item;
        })

        var maxDhj = Math.max.apply(null, dhArr);
        var minDhj = Math.min.apply(null, dhArr);

        if ($.nui.isEmpty(cpYsArr) || dhZero) {
            var res = '0元' + unit;
            $('.price-box').text(res);
            return;
        }

        if (cpYsArr.length === 1) { // 一个价格，有填价格，并且不为0，显示最高价
            if (!dhZero) {
                var res = maxDhj + '元' + unit;
                $('.price-box').text(res);
                return;
            }
        }

        if (cpYsArr.length > 1) { // 多个价格
            if (!dhZero) { // 有值
                if (maxDhj === minDhj) { // 最高最低相等
                    var res = maxDhj + '元' + unit;
                    $('.price-box').text(res);
                    return;
                } else {
                    var res = minDhj + '~' + maxDhj + '元' + unit;
                    $('.price-box').text(res);
                    return;
                }
            }
        }
    }
}

function colour_edit(type) {
    if (type.indexOf('more') > -1) {

    }
}

// 删除临时创建的下标
function deleteColorIdx() {
    $(CP_INFO['goods_colour']).each(function (colour_index, item) {
        if ('_index' in item) {
            delete item['_index'];
        }
    })
}

// 点击返回
function isDataChange() {
    deleteColorIdx();
    _save_data = JSON.parse(JSON.stringify(getSaveData()));
    if ($.nui.isObjEquals(_origin_data, _save_data)) {
        fun.pageCloseFun({});
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         status: 'refresh',
        //     }
        // })
        // closeWin();
    } else {
        if ($('body').find('.data-change-skin').length) return;
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData();
            },
            no: function () {
                fun.pageCloseFun({});
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         status: 'refresh'
                //     }
                // })
                // closeWin();
            }
        });
    }
}

// 关闭当前窗口
function closeWin() {
    fun.showLoad();
    setTimeout(function () {
        api.closeWin();
        fun.hideLoad();
    }, 200)
}

// 获取纱线信息
function getList() {
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getYarnInfo,
        data: search_data,
        success: function (res) {
            if (res['status'] == 0) {
                $('#shade').hide();
                DATA_LIST = res.data || {};
                CP_INFO = res['data'] || CP_INFO;

                resetColorImg();
                $('#header').header({
                    back: true,
                    title: '纱线',
                    appendBackBtnEvt: isDataChange
                });
                console.log(CP_INFO);
                showData(res['data']);
            }
        }
    })
}

// 图片字符串装数组，过滤空值
function resetColorImg() {
    $(CP_INFO['goods_colour']).each(function (idx, item) {
        var temp = [];
        if ($.nui.isTrue(item['imgs'])) {
            var img = item['imgs'].split(',');
            $(img).each(function (index, imgs) {
                if ($.nui.isTrue(imgs)) {
                    temp.push(imgs);
                }
            })
        } else {
            temp = [];
        }
        item['imgs'] = temp;
    })
}

// 获取纱线标签
function getLabel(arr, callback) {
    label_arr = arr;
    var lar = label_arr.split(',') || [];
    var tmp = new Array();
    for (var i = 0; i < lar.length; i++) {
        tmp[i] = Number(lar[i]);
    }
    lar = tmp;
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: AJAX_URL.getLabelList,
        data: {
            "type": 'sx',
        },
        success: function (res) {
            if (res['status'] != 0) return fun.toast('获取标签失败。');
            var info_list = res.data;
            var html = [];

            for (var j = 0; j < lar.length; j++) {
                for (var i = 0; i < info_list.length; i++) {
                    var val = info_list[i];
                    if (lar[j] == val['id']) {
                        html.push('<span data-list=\'' + (fun.formatString(JSON.stringify(val))) + '\' class="label" style="background:' + val['colour'] + '">' + val['name'] + '</span>');
                    }
                }
            }

            $("#label_wrap").html(html.join(''));

            if ($(".special").children().length >= 1) {
                $(".special").css({
                    paddingBottom: '1rem'
                })
            } else {
                $(".special").css({
                    paddingBottom: 0
                })
            }

            if (typeof callback === 'function') callback();
        }
    });
}

// 显示纱线类型
function showProductType() {
    $(type_data).each(function (idx, item) {
        if (CP_INFO['info']['sx_jw'] === item['name']) {
            item['is_choose'] = 1;
        } else {
            item['is_choose'] = 0;
        }
    })
}

// 显示页面数据
function showData(data) {
    CP_INFO['info'] = data['info'];
    CP_INFO['goods_colour'] = data['goods_colour'] || [];
    CP_INFO['goods_weight'] = data['goods_weight'] || [];
    CP_INFO['goods_spec'] = data['goods_spec'] || [];
    CP_INFO['merchant_assistant'] = data['merchant_assistant'] || [];
    CP_INFO['goods_machining'] = data['goods_machining'] || [];
    CP_INFO['goods_craft'] = data['goods_craft'] || [];
    CP_INFO['param'] = data['param'];
    CP_INFO['options'] = data['options'];

    $('#cp_lx').attr('cp_lx', 'cp');
    var info = data['info'] || {};
    var goods_colour = data['goods_colour'] || []; // 颜色
    var goods_weight = data['goods_weight'] || []; // 克重
    var goods_spec = data['goods_spec'] || []; // 规格
    var merchant_assistant = data['merchant_assistant'] || []; // 辅助信息
    var param = data['param'] || []; // 其他参数
    $('.line-stop').show(); // 编辑状态显示停用按钮

    // 信息
    var cp_img = ($.nui.isTrue(info['imgs'])) ? info['imgs'].split(',') : []; // 纱线主图

    info['is_stop'] === 1 && $('#switch_stop').addClass('nui-active'); // 是否停用
    $('#cp_bh').val(info['number']); // 编号
    $('#cp_mc').val(page_data['cp_mc'] || info['name']); // 名称
    $('#sx_lb').val(info['lb_mc']); // 类别
    $('#cp_dw').val(info['dw_mc']); // 单位
    $('#cp_cf').val(info['component']); // 成分

    $('#cp_sj').text(fun.Date(info['date'], true).Format("yy-mm-dd hh:ii")); // 时间
    $('#cp_bz').val(info['remark']); // 备注

    $('#sx_lb').attr('lb_id', info['class_id'] || 0);
    $('#cp_dw').attr('dw_id', info['unit_id'] || 0);
    $('#sx_pp').val(info['brand'] || '').data('old-val', info['brand'] || ''); // 品牌
    $('#sx_dq').val(info['area'] || '').data('old-val', info['area'] || ''); // 地区
    $('#sx_xz').val(info['nature'] || '').data('old-val', info['nature'] || ''); // 性质
    $('#sx_jw').val(info['sx_jw'] || ''); // 经纬
    $('#sx_ys').val(info['sx_ys'] || ''); // 预损
    $('#sx_jz').val(info['sx_jz'] || ''); // 均重

    $('#sx_gy').val(info['gy'] || '').attr('gy_id', info['craft']); // 工艺

    $(goods_spec).each(function (idx, item) { // 规格
        if (item['is_default']) {
            $('#cp_gg').val(item['spec']).data('old-val', item['spec'] || ''); // 规格
            default_obj['default_gg'] = item;
            return false;
        }
    })

    $('#fzxx_jl').text(merchant_assistant.length + '个'); // 辅助信息（底卡信息）

    var htmlCpImg = []; // 主图
    if (cp_img.length !== 0) {
        var count = 0;
        for (var i = 0; i < cp_img.length; i++) {
            count++;
            htmlCpImg.push('<li class="show-img">');
            htmlCpImg.push('        <img src="' + fun.getImgPath(cp_img[i]) + '" class="img" alt="" large-url="' + fun.getImgPath(cp_img[i], true) + '" data-name="' + cp_img[i] + '">');

            htmlCpImg.push('        <div class="delete-img" style="display: block;">');
            htmlCpImg.push('            <div class="packs">');
            htmlCpImg.push('                <i class="iconfont icon-fork fork"></i>');
            htmlCpImg.push('            </div>');
            htmlCpImg.push('        </div>');
            // htmlCpImg.push('        <div class="news-circle">');
            // htmlCpImg.push('            <i class=" iconfont icon-fork arrow"></i>');
            // htmlCpImg.push('        </div>');
            htmlCpImg.push('</li>');
        }
        if (cp_img.length >= 9) {
            $('.cp-add-img').before(htmlCpImg.join(''));
            $('.cp-add-img').remove();
        }
        $('#cpzt_size').text(count);
        imgSub['cpMax'] = 9 - count;
        $('.cp-add-img').before(htmlCpImg.join(''));
    }

    var count = 0;
    $(data.goods_colour).each(function (idx, item) { // 颜色
        if (!item['is_stop']) {
            count++;
        }
    })

    $('#ys_stop_count').text(count + '个');

    showProductType(); // 根据保存时类型做记忆
    _origin_data = JSON.parse(JSON.stringify(getSaveData()));

    getLabel(info['label_id'], function () { // 标签
        _origin_data = JSON.parse(JSON.stringify(getSaveData()));
    });

    yranEdit.initOfferData();
    showJg();
}

// 新加进入
function showNewAdd() {
    var newAdd = [{
        id: 0,
        sort: 1,
        number: '白纱#',
        name: '',
        type: '',
        wldw_mc: '',
        merchant_id: 0,
        order_amount: '',
        is_stop: 0,
        remark: '',
        imgs: [],
        goods_material: []
    }];
    if (page_data['tc_type']) {
        for (var i = 0; i < 31; i++) {
            newAdd.push({
                id: 0,
                sort: i + 2,
                number: i + '#',
                name: '',
                type: '',
                wldw_mc: '',
                merchant_id: 0,
                order_amount: '',
                is_stop: 0,
                remark: '',
                imgs: [],
                goods_material: []
            })
        }
    };
    CP_INFO['goods_colour'] = newAdd;
    $('#cpzt_size').text(0); // 纱线主图最多图片大小
    units = page_data['last_dw_mc'];
    units_id = page_data['last_dw_id'];
    $('#cp_sj').text(new Date().Format('yy-mm-dd hh:ii'));

    $('#cp_dw').attr('dw_id', page_data['last_dw_id'] || 0).val(page_data['last_dw_mc'] || "");
    if ($.nui.isTrue(page_data['cp_mc'])) {
        $('#cp_mc').val(page_data['cp_mc'] || '');
    }
    CP_INFO['info']['unit_options'] = {
        cgdw_id: Number(SYS_CONFIG['sxfzdw_cg'] || 0),
        jgdw_id: Number(SYS_CONFIG['sxfzdw_jg']) || 0,
        xsdw_id: Number(SYS_CONFIG['sxfzdw_xs']) || 0,
        // dw2_id: Number(SYS_CONFIG['bpfzdw_dw2']) || 0
    };

    var jjdwMc = '';
    if ($.nui.isTrue(Number(CP_INFO['info']['unit_options']['xsdw_id']))) {
        jjdwMc = '/' + fun.getValByKey(fun.getItem('jjdw_list'), Number(CP_INFO['info']['unit_options']['xsdw_id']), 'name');
    } else {
        if ($.nui.isTrue($('#cp_dw').attr('dw_id'))) {
            jjdwMc = '/' + $('#cp_dw').val().trim();
            CP_INFO['info']['unit_id'] = page_data['last_dw_id'];
        }
    }

    $('.price-box').text('0元' + jjdwMc);

    if (!Auth.check('sx_fzxx', 'view')) { // 没有底卡信息的浏览权限，不显示这一行
        $('#bottom-card').hide();
    }

    $('#ys_stop_count').text(CP_INFO['goods_colour'].length + '个');
}

// 获取幅宽选项列表
function getFkKzList(type) {
    var fk_or_kz = [];
    switch (type) {
        case 'fk': // 幅宽列表选项
            fk_or_kz = [{
                name: 'cm',
                id: 'cm',
                type: 'cm',
                is_choose: 1
            },
            {
                name: 'm',
                id: 'm',
                type: 'm'
            },
            {
                name: 'inch',
                id: 'inch',
                type: 'inch'
            }
            ];
            break;

        case 'kz': // 克重列表选项
            fk_or_kz = [{
                name: 'g',
                id: 'g',
                type: 'g',
                is_choose: 1
            },
            {
                name: 'g/m',
                id: 'g/m',
                type: 'g/m'
            },
            {
                name: 'g/㎡',
                id: 'g/㎡',
                type: 'g/㎡'
            }
            ];
            break;
        // 没有default:
    }
    return fk_or_kz;
}

//获取纱线编号
function getNumber() {
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: AJAX_URL.getNumber,
        data: {
            "type": "sx"
        },
        success: function (res) {
            if (res['status'] == 0) {
                $('#cp_bh').val((res['data'] || ""));

                if (!!page_data['cp_bh']) {
                    $('#cp_bh').val(page_data['cp_bh']);
                }
                _origin_data = JSON.parse(JSON.stringify(getSaveData())); // 需要对比数据（暂没做）
            }
        }
    });
}

//获取参数
function getParam() {
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getParamOptions,
        data: {
            "type": "sx"
        },
        success: function (res) {
            if (res['status'] == 0) {
                var data = res['data'];
                console.log('---');
                console.log(data);

                $(data['param']).each(function (idx, item) {
                    CP_INFO['param'][idx] = {
                        id: item['id'] || 0,
                        param_id: item['param_id'] || 0,
                        value: '',
                        name: item['name'] || ''
                    }
                })

                _origin_data = JSON.parse(JSON.stringify(getSaveData()));
            }
        }
    });
}

// 没有权限页面禁止编辑
function pageEditDisabled() {
    if (!IS_PAGE_EDIT) {
        $('input').attr('disabled', 'disabled');
    }
    imgHasDrag(); // 有编辑权限才可以拖拽
}

// 输入框显示保存按钮隐藏
// fun.keyboardEject('.fixed')

// 拖拽排序
function imgHasDrag() {
    if (IS_PAGE_EDIT) {
        sortable.sortable1 = new Sortable($('#cpzt-img')[0], {
            animation: 150,
            onStart: function (e) {
                preventEvent(e);
            },
            onMove: function (e) {
                preventEvent(e);
                $('.cp-add-img').hide()
                if ($('#cpzt-img .img:not(.cp-add-img .img)').length == 5 || $('#cpzt-img .img:not(.cp-add-img .img)').length == 9) {
                    $('#cpzt-img').css('padding-bottom', '4rem')
                }
            },
            onEnd: function (e) {
                preventEvent(e);
                $('#cpzt-img').css('padding-bottom', '0')
                $('.cp-add-img').remove()
                if ($('#cpzt-img .img:not(.cp-add-img .img)').length < 9) {
                    var html = [];
                    html.push('<div class="show-img cp-add-img">');
                    html.push('    <img src="../img/null.png" class="img" alt="">');
                    html.push('</div>');
                    $('#cpzt-img').append(html.join(''));
                }
            },
            delay: 500,
        });
    }
}

// 去除单双引号和空数组的值
function imgFormat(save_data, name) {
    var tempArr = [];
    $(save_data[name]).each(function (idx, item) {
        if ($.nui.isTrue(item)) tempArr.push(item);
    })
    return tempArr;
}

// 拿到保存数据
function getSaveData() {
    var info = CP_INFO['info'];
    var dw_id = $('#cp_dw').attr('dw_id');
    // var cp_lx = $('#cp_lx').attr('cp_lx');

    var sx_lb_id = $('#sx_lb').attr('lb_id');

    if (info['unit_options'] && (typeof info['unit_options'] === 'string')) {
        info['unit_options'] = JSON.parse(info['unit_options']);
    }

    var jgValue = typeof info['jg_value'] === 'object' ? JSON.stringify(info['jg_value']) : info['jg_value'];
    var add_unit_options = {
        cgdw_id: Number(SYS_CONFIG['sxfzdw_cg'] || 0),
        jgdw_id: Number(SYS_CONFIG['sxfzdw_jg']),
        xsdw_id: Number(SYS_CONFIG['sxfzdw_xs']) || 0,
        // dw2_id: Number(SYS_CONFIG['bpfzdw_dw2'])
    };

    var save_data = {
        save_type: 'save',
        id: page_data['id'] || 0,
        type: 'sx', // 类型
        date: $('#cp_sj').text().trim() || '', // 时间
        number: $('#cp_bh').val().trim() || '', // 编号
        name: $('#cp_mc').val().trim() || '', // 名称
        unit_id: $.nui.isTrue(dw_id) ? fun.toNumber(dw_id) : 0, // 单位id
        component: $('#cp_cf').val().trim() || '', // 成分
        diff: info['diff'] || '+', // 空差模式
        imgs: [], // 主图
        unit_options: info['unit_options'] || add_unit_options,
        class_id: $.nui.isTrue(sx_lb_id) ? fun.toNumber(sx_lb_id) : 0,
        remark: $('#cp_bz').val().trim() || '', // 备注
        label_id: '', // 标签id
        is_stop: $('#switch_stop').hasClass('nui-active') ? 1 : 0, // 是否停用
        sx_jw: $('#sx_jw').val().trim() || '', //经纬
        craft: fun.toNumber($('#sx_gy').attr('gy_id')) || 0, // 工艺
        brand: $('#sx_pp').val().trim() || '', // 品牌
        area: $('#sx_dq').val().trim() || '', // 地区
        nature: $('#sx_xz').val().trim() || '', //性质
        sx_ys: $('#sx_ys').val().trim() || '', //预损
        sx_jz: $('#sx_jz').val().trim() || '', //均重
        goods_colour: CP_INFO['goods_colour'], // 纱线颜色
        delete_colour: delete_list['colour_arr'] || [], // 删除的纱线颜色
        goods_spec: CP_INFO['goods_spec'], // 规格
        delete_spec: delete_list['spec_arr'] || [], // 删除的规格
        merchant_assistant: [], // 底卡信息
        delete_merchant_assistant: delete_list['fzxx_arr'] || [], // 删除的底卡信息  delete_list['fzxx_colouArr'] ||
        delete_colour_assistant: delete_list['fzxx_colouArr'] || [], //删除的底卡辅助颜色信息
        goods_machining: CP_INFO['goods_machining'] || [], // 加工
        delete_machining: [], // 删除的加工
        delete_converter: [], //
        delete_process: [],
        goods_craft: CP_INFO['goods_craft'] || [], // 工艺
        delete_craft: delete_list['craft_arr'], // 删除工艺 
        goods_param: CP_INFO['param'], // 其他参数
        goods_material: [],
        delete_material: []
    };
    if ($.isArray(label_arr)) {
        save_data['label_id'] = label_arr.join(',');
    } else {
        save_data['label_id'] = label_arr;
    }

    $(CP_INFO['merchant_assistant']).each(function (idx, item) {
        if (!('id' in item)) {
            item['id'] = 0;
        }
    })

    // 纱线图片
    if ($('#cpzt-img').find('.show-img').not('.cp-add-img').length > 0) {
        $('#cpzt-img').find('.show-img').not('.cp-add-img').each(function (idx, item) {
            if ($(this).find('img').data('name')) {
                save_data['imgs'].push($(this).find('img').data('name'));
            }
        })
    }

    $(CP_INFO['merchant_assistant']).each(function (idx, item) {
        if ($.nui.isEmpty(item['imgs'])) {
            item['imgs'] = [];
        } else {
            if (!($.isArray(item['imgs']))) {
                var imgs = item['imgs'];
                if (imgs.indexOf(',') > -1) {
                    item['imgs'] = imgs.split(',');
                } else {
                    var imgs_arr = []
                    imgs_arr[0] = item['imgs'];
                    item['imgs'] = imgs_arr;
                }
            }
        }
    })

    // 处理图片产生的空格
    save_data['imgs'] = imgFormat(save_data, 'imgs');
    $(CP_INFO['merchant_assistant']).each(function (index, item) {
        var temp = [];
        item['sort'] = index + 1;
        $(item['imgs']).each(function (idx, imgs) {
            if ($.nui.isTrue(imgs)) {
                temp.push(imgs);
            }
        })
        item['imgs'] = temp;
    })
    save_data['merchant_assistant'] = CP_INFO['merchant_assistant'];
    return save_data;
}

//验证类别是否存在
function LbCheck() {
    var is_lb;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        async: false,
        url: AJAX_URL.getSimpleRecordList,
        data: {
            type: 'sx'
        },
        success: function (res) {

            if (res.status != 0) return fun.toast('保存失败。');
            var lb_info = res.data;
            var lb_name = $('#sx_lb').attr('lb_id') + '_' + $('#sx_lb').val().trim();
            for (var i = 0; i < lb_info.length; i++) {
                var lb_tmpName = lb_info[i].id + '_' + lb_info[i].name;
                if (lb_tmpName == lb_name) {

                    is_lb = true;
                    return;
                }
                is_lb = false;
            }
        }
    });
    return is_lb;
}

// 保存数据
function saveData(options) {
    var _options = $.extend({}, {
        callback: null,
        tips: true
    }, options);
    if (!$('#cp_sj').text().trim()) {
        return fun.toast('日期不能为空。');
    } else if (!$('#cp_mc').val().trim()) {
        return fun.toast('纱线名称不能为空。');
    } else if (!$('#cp_bh').val().trim()) {
        return fun.toast('纱线编号不能为空。');
    } else if (!$.nui.isTrue($('#cp_dw').attr('dw_id'))) {
        return fun.toast('单位不能为空。');
    }

    deleteColorIdx(); // 删除因其他页面用到创建的_indx
    var tmp_data = getSaveData(); // 拿到保存数据

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveYarn,
        data: tmp_data,
        success: function (res) {
            console.log(res);
            switch (res['status']) {
                case 0:
                    function closePageRefresh() { // 关闭页面
                        fun.pageCloseFun({
                            refresh: true,
                            extraData: {
                                status: 'refresh',
                                tc_type: page_data['tc_type'] ? true : false,
                                number: tmp_data['number'] || '',
                            }
                        });
                    }
                    if (options && typeof _options.callback == "function") {
                        _options['tips'] && fun.toast('保存成功！');
                        page_data['id'] = res['data']['id'];
                        search_data['id'] = page_data['id'];
                        options.callback(options['params']);
                    } else {
                        page_data['id'] = res['data']['id'];
                        search_data['id'] = page_data['id'];
                        fun.toast('保存成功！');
                    }
                    closePageRefresh();
                    break;
                case 104:
                    var msg = '';
                    switch (res['data']['type']) {
                        case 'number':
                            msg = '该编号';
                            break;
                        case 'name':
                            msg = '名称';
                            break;
                        case 'colour':
                            msg = res['data']['name'] || '';
                            break;
                        case 'machining':
                            msg = '加工流程-加工商记录表出现相同加工商。';
                            break;
                        case 'assistant':
                            msg = '辅助对象不能出现2个一样的：客\\供\\加。';
                            break;
                    }
                    return fun.toast((res['data']['type'] != 'assistant' && res['data']['type'] != 'machining') ? (msg + '已存在。') : msg);
                    break;
                case 101:
                    fun.toast('保存失败。');
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    });
}

// 阻止默认事件
function preventEvent(e) {
    e.stopPropagation();
    e.preventDefault();
}

// 添加图片
function addImgToImgs(data, Introduction) {
    var url = data['data'] || "";
    var base64 = data['base64Data'] || "";
    if (Introduction) { // 多选图片
        // var count = 0;
        addImgs(data, function (param) {
            fun.imagePickerRender({
                pushHtml: [],
                allImageData: param,
                end: function (params) {
                    var html = params.html || [];
                    if ($.nui.isTrue($('#cpzt-img .img').parents('div').hasClass('cpImg'))) { // 纱线主图
                        var cpCount = fun.toNumber($('#cpzt_size').text());
                        $('.cp-add-img').before(html.join(''));
                        cpCount += data.length;
                        imgSub['cpMax'] = 9 - cpCount;

                        $('#cpzt_size').text(cpCount);

                        if (cpCount >= 9) {
                            $('.cp-add-img').remove();
                            $('.cpImg').removeClass('cpImg');
                        }
                    } else if ($.nui.isTrue($('#sktp-img .img').parents('div').hasClass('sktpImg'))) { // 色卡图片
                        var cpCount = fun.toNumber($('#sktp_size').text());
                        $('.sktp-add-img').before(html.join(''));
                        cpCount += data.length;
                        imgSub['skMax'] = 9 - cpCount;

                        $('#sktp_size').text(cpCount);

                        if (cpCount >= 9) {
                            $('.sktp-add-img').remove();
                            $('.sktpImg').removeClass('sktpImg');
                        }
                    } else if ($.nui.isTrue($('#bbxq-img .img').parents('div').hasClass('bbxqImg'))) { // 纱线图片
                        var cpCount = fun.toNumber($('#bbxq_size').text());
                        $('.bbxq-add-img').before(html.join(''));
                        cpCount += data.length;
                        imgSub['bbxqMax'] = 30 - cpCount;

                        $('#bbxq_size').text(cpCount);

                        if (cpCount >= 30) {
                            $('.bbxq-add-img').remove();
                            $('.bbxqImg').removeClass('bbxqImg');
                        }
                        console.log(imgSub['bbxqMax']);
                    }

                    imgInfo = [];
                    removePhotoClass();
                    fun.hideLoad();
                    document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
                },
                renderHtml: function (params) {
                    var url = fun.is_value(params.imgUrl); // 图片路径
                    var imgName = fun.is_value(params.imgName); // 图片名称
                    var html = params.html || [];
                    var index = params.index;
                    html.push('<li class="show-img">');
                    html.push('    <img src="' + url + '" class="img" alt="" large-url="' + url + '"  data-name="' + imgName + '">')
                    html.push('    <div class="delete-img" style="display: block;">');
                    html.push('        <div class="packs">');
                    html.push('            <i class="iconfont icon-fork fork"></i>');
                    html.push('        </div>');
                    html.push('    </div>');
                    html.push('</li>');
                }
            });
        })

    } else {
        showSingleData(data);
    }
}

// 多选图片渲染
function showMoreData(data) {
    var htmlCpImg = [];
    $(data).each(function (idx, item) {
        htmlCpImg.push('<li class="show-img">');
        htmlCpImg.push('    <img src="' + fun.getImgPath(item['img']) + '" class="img" alt="" large-url="' + item['img_name'] + '"  data-name="' + item['img'] + '">')
        htmlCpImg.push('    <div class="delete-img" style="display: block;">');
        htmlCpImg.push('        <div class="packs">');
        htmlCpImg.push('            <i class="iconfont icon-fork fork"></i>');
        htmlCpImg.push('        </div>');
        htmlCpImg.push('    </div>');
        htmlCpImg.push('</li>');
    });

    if ($.nui.isTrue($('#cpzt-img .img').parents('div').hasClass('cpImg'))) { // 纱线主图
        var cpCount = fun.toNumber($('#cpzt_size').text());
        $('.cp-add-img').before(htmlCpImg.join(''));
        cpCount += data.length;
        imgSub['cpMax'] = 9 - cpCount;

        $('#cpzt_size').text(cpCount);

        if (cpCount >= 9) {
            $('.cp-add-img').remove();
            $('.cpImg').removeClass('cpImg');
        }
    } else if ($.nui.isTrue($('#sktp-img .img').parents('div').hasClass('sktpImg'))) { // 色卡图片
        var cpCount = fun.toNumber($('#sktp_size').text());
        $('.sktp-add-img').before(htmlCpImg.join(''));
        cpCount += data.length;
        imgSub['skMax'] = 9 - cpCount;

        $('#sktp_size').text(cpCount);

        if (cpCount >= 9) {
            $('.sktp-add-img').remove();
            $('.sktpImg').removeClass('sktpImg');
        }
    } else if ($.nui.isTrue($('#bbxq-img .img').parents('div').hasClass('bbxqImg'))) { // 纱线图片
        var cpCount = fun.toNumber($('#bbxq_size').text());
        $('.bbxq-add-img').before(htmlCpImg.join(''));
        cpCount += data.length;
        imgSub['bbxqMax'] = 30 - cpCount;

        $('#bbxq_size').text(cpCount);

        if (cpCount >= 30) {
            $('.bbxq-add-img').remove();
            $('.bbxqImg').removeClass('bbxqImg');
        }
        console.log(imgSub['bbxqMax']);
    }

    imgInfo = [];
    removePhotoClass();
    fun.hideLoad();
    document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
}

// 单选图片渲染
function showSingleData(data) {
    var fileData = {
        data: data,
        index: 0
    };
    var imgUrl = fun.is_value(data.data);
    fun.fileUpload(fileData, function (imgName) {
        var htmlCpImg = [];
        htmlCpImg.push('<li class="show-img">');
        htmlCpImg.push('    <img src="' + imgUrl + '" class="img" alt="" large-url="' + imgUrl + '"  data-name="' + imgName + '">')
        htmlCpImg.push('    <div class="delete-img" style="display: block;">');
        htmlCpImg.push('        <div class="packs">');
        htmlCpImg.push('            <i class="iconfont icon-fork fork"></i>');
        htmlCpImg.push('        </div>');
        htmlCpImg.push('    </div>');
        htmlCpImg.push('</li>');

        // 拍照渲染
        if ($('#cpzt-img .img').parents('div').hasClass('cpImg')) { // 纱线主图
            var cpCount = fun.toNumber($('#cpzt_size').text());
            ++cpCount;
            $('.cp-add-img').before(htmlCpImg.join(''));
            if (cpCount >= 9) {
                cpCount = 9;
                $('.cp-add-img').remove();
            }
            $('.cpImg').removeClass('cpImg');
            $('#cpzt_size').text(cpCount);
            imgSub['cpMax'] = 9 - cpCount;

            console.log('cpMax');
            console.log(imgSub['cpMax']);
        }
        if ($('#sktp-img .img').parents('div').hasClass('sktpImg')) { // 色卡主图
            var skCount = fun.toNumber($('#sktp_size').text());
            ++skCount;
            $('.sktp-add-img').before(htmlCpImg.join(''));
            if (skCount >= 9) {
                skCount = 9;
                $('.sktp-add-img').remove();
            }
            $('.sktpImg').removeClass('sktpImg');
            $('#sktp_size').text(skCount);
            imgSub['skMax'] = 9 - skCount;

            console.log('skMax');
            console.log(imgSub['skMax']);
        }
        if ($('#bbxq-img .img').parents('div').hasClass('bbxqImg')) { // 宝贝详情主图
            var bbxqCount = fun.toNumber($('#bbxq_size').text());
            ++bbxqCount;
            $('.bbxq-add-img').before(htmlCpImg.join(''));
            if (bbxqCount >= 30) {
                bbxqCount = 30;
                $('.bbxq-add-img').remove();
            }
            $('.bbxqImg').removeClass('bbxqImg');
            $('#bbxq_size').text(bbxqCount);
            imgSub['bbxqMax'] = 30 - bbxqCount;

            console.log('bbxqMax');
            console.log(imgSub['bbxqMax']);
        }

        $('#openCamera').hide();
        fun.hideLoad();
    });
}

// 递归取base64，执行渲染方法
function addImgs(param, callback) {
    if (count >= param.length) {
        count = 0;
        if (typeof callback === 'function') callback(param)
        return param;
    }
    count++;
    fun.getUrlBase64(param[count - 1]['path'], param[count - 1]['suffix'], function (base64) {
        param[count - 1]['base64'] = base64;
        addImgs(param, callback);
    });
}

// 转化iso路径
function IOSChange(list, callback) {
    var temporary = list;
    $.each(list, function (i, item) {
        UIAlbumBrowser.transPath({
            path: item['path'],
            quality: 100
        }, function (res, err) {
            if (res) {
                temporary[i]['path'] = res['path'];
                if (i >= list.length - 1) {
                    if (typeof callback === 'function') callback(temporary);
                }
            }
        });
    })
};

// 清除选择相册判断类名
function removePhotoClass() {
    $('#cpzt-img .img').parents('div').removeClass('cpImg');
    $('#sktp-img .img').parents('div').removeClass('sktpImg');
    $('#bbxq-img .img').parents('div').removeClass('bbxqImg');
}

// 初始化事件
function bindEvent() {
    // 解决穿透
    $('.box,.add-picture').on('touchmove', function (event) {
        event.preventDefault();
    });

    // 没有编辑权限禁止停用按钮切换
    $('.disabled-switch').on('tap', function (e) {
        if (!IS_PAGE_EDIT) {
            e.stopPropagation();
            e.preventDefault();
            return;
        }
    })

    //选择标签
    $('body').on('click', '#label', function (e) {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        if ($(this).attr('disabled')) return;
        var params = {
            "return_page": page_arr.yarn_edit,
            "page_type": 'sx',
            "opt": (!!page_data['id']) ? 'edit' : 'append',
            "label_arr": label_arr || '',
            "title": '纱线',
            "id": page_data['id'] || 0,
            "type": 'sx'
        };
        fun.showPageFull({
            page_url: page_arr.label,
            pageParam: params
        });
        fun.hideLoad();
    });

    $('body').on('tap', '#hide-info', function () {
        if (!IS_PAGE_EDIT) return;
    });

    // 纱线主图
    $('body').on('click', '#cpzt-img .img', function () {
        if (!IS_PAGE_EDIT) return;
        var press_start = new Date();
        var cpzt_index2 = $("#cpzt-img .img").index(this);
        if (new Date() - press_start < 700) {
            if ($("#cpzt-img .img").eq(cpzt_index2).attr("src") !== '../img/null.png') { // 有图，显示大图预览
                var src = $("#cpzt-img .img").eq(cpzt_index2).data('name');
                photoBrowser.open({
                    images: [fun.getImgPath(src, true)],
                    placeholderImg: '../img/logo.png',
                    bgColor: '#000'
                }, function (ret, err) {
                    if (ret) {
                        if (ret['eventType'] == 'click') {
                            photoBrowser.close();
                        }
                    }
                });
            } else {
                $(this).parents('div').addClass('cp-sel-photo cpImg'); // 选择相册、纱线主图拍照添加图片
                $("#add-picture,.box").css("display", "block");
            }
        }
    });

    // 删除主图
    $('body').on('tap', '#cpzt-img .delete-img', function () {
        var _that = $(this);
        setTimeout(function () {
            fun.dialog({
                content: '你确定要删除主图吗？',
                btn: ['删除', '取消'],
                yes: function () {
                    _that.parent().remove();
                    if ($('#cpzt-img .img:not(.cp-add-img .img)').length === 8) {
                        // $('.cp-add-img').hide()
                        var html = [];
                        html.push('<div class="show-img cp-add-img">');
                        html.push('    <img src="../img/null.png" class="img" alt="">');
                        html.push('</div>');
                        $('#cpzt-img').append(html.join(''));
                    }
                    var len = $('#cpzt-img .img:not(.cp-add-img .img)').length;
                    $('#cpzt_size').text(len);
                    imgSub['cpMax'] = 9 - len;
                }
            });
        }, 100)
    });

    // 拍照
    $('body').on('click', '#paizhao', function (e) {
        e.stopPropagation();
        e.preventDefault();
        if (!IS_PAGE_EDIT) return;
        $('#add-picture,.box').hide();
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 90,
            targetWidth: 900,
            targetHeight: 900,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if (ret.data) {
                    fun.showLoad();
                    addImgToImgs(ret);
                }

            } else { }
        });
    });

    // 从相册中选择
    $('body').on('click', '#selectPhoto', function (e) {
        e.stopPropagation();
        e.preventDefault();
        if (!IS_PAGE_EDIT) return;
        $('#add-picture,.box').hide();
        // api.getPicture({
        //     sourceType: 'album',
        //     encodingType: 'jpg',
        //     mediaValue: 'pic',
        //     destinationType: 'base64',
        //     allowEdit: false,
        //     quality: 100, //图片质量
        //     saveToPhotoAlbum: false
        // }, function (ret, err) {
        //     if (ret) {
        //         if (ret.data) addImgToImgs(ret);
        //     } else { }
        // });
        var max = 6;

        if ($.nui.isTrue($('#cpzt-img .img').parents('div').hasClass('cpImg'))) {
            if (imgSub['cpMax'] === 0) {
                imgSub['cpMax'] = 6;
            }
            max = imgSub['cpMax'] >= max ? max : imgSub['cpMax'];
        } else if ($.nui.isTrue($('#sktp-img .img').parents('div').hasClass('sktpImg'))) { // 色卡图片
            if (imgSub['skMax'] === 0) {
                imgSub['skMax'] = 6;
            }
            max = imgSub['skMax'] >= max ? max : imgSub['skMax'];
        } else if ($.nui.isTrue($('#bbxq-img .img').parents('div').hasClass('bbxqImg'))) { // 纱线图片
            if (imgSub['bbxqMax'] === 0) {
                imgSub['bbxqMax'] = 6;
            }
            max = imgSub['bbxqMax'] >= max ? max : imgSub['bbxqMax'];
        }

        // 20200927 点击很多次确定会返回上一个页面，这里要限制只执行一次
        var UIAlbumBrowserTimer = null;
        var UIAlbumBrowserTimerFlag = true;

        UIAlbumBrowser.imagePicker({
            max: max,//最多选择图片的数量，默认为9
            showCamera: false,//禁止访问相机
            styles: {
                bg: '#fff',
                nav: {
                    cancelColor: '#000',//取消按钮颜色
                    nextStepColor: '#000',//确定按钮颜色
                    cancelText: '取消',
                    finishText: '确定'
                },
            },
            // isOpenPreview: true
        }, function (ret) {

            if(UIAlbumBrowserTimerFlag) {
                UIAlbumBrowserTimerFlag = false;
                clearTimeout(UIAlbumBrowserTimer);
                UIAlbumBrowserTimer = null;
                UIAlbumBrowserTimer = setTimeout(function(){
                    UIAlbumBrowserTimerFlag = true;
                }, 1000);

                nextConfirm(ret);
            }

            function nextConfirm(ret) {
                if (ret.eventType == 'nextStep') { // 确定事件
                    fun.showLoad();
                    var u = navigator.userAgent;
                    var list = ret['list'] || [];
                    if ($.nui.isEmpty(list)) {
                        UIAlbumBrowser.closePicker();
                        fun.hideLoad();
                        return;
                    };

                    fun.UploadRestriction(list, function () {
                        if (u.indexOf('Android') > -1 || u.indexOf('Linux') > -1) {//安卓路径无误
                            UIAlbumBrowser.closePicker();
                            addImgToImgs(list, true);
                        } else if (!!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) { // ios路径需转化,包括iPad
                            UIAlbumBrowser.closePicker();
                            IOSChange(list, function (temporary) {
                                addImgToImgs(temporary, true);
                            })
                        }
                        document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
                    });
                }
            }

            if (ret.eventType === 'cancel') { // 取消事件
                removePhotoClass();
            }
        })
    });

    // 取消新增图片选项
    $('body').on('click', '#cancelPhoto', function (e) {
        e.stopPropagation();
        e.preventDefault();
        removePhotoClass();
        $('#add-picture,.box').css("display", "none");
    });

    // 跳转价格页面
    $('body').on('tap', '#price', function (e) {
        e.stopPropagation();
        if (page_data['opt'] == 'append') return
        var xsdw_id = CP_INFO['info']['unit_options']['xsdw_id'];

        fun.showPageFull({
            page_url: page_arr.yarn_quotation,
            pageParam: {
                return_page: page_arr.yarn_edit,
                dw_id: getUnitId(),
                dw_mc: getJjdw(xsdw_id),
                sx_mc: $('#cp_mc').val().trim() || '', // 纱线名称
                cp_id: page_data['id'] || 0,
                sx_pp: $('#sx_pp').val().trim() || '', // 品牌
                sx_dq: $('#sx_dq').val().trim() || '', // 地区
                sx_xz: $('#sx_xz').val().trim() || '', //性质
                sx_gg: $('#cp_gg').val().trim() || '', // 规格
            }
        })
        fun.showLoad();
        var jgValue = CP_INFO['info']['jg_value'];
        // var skipOjb = { // 暂时

        // }
        // if ('id' in page_data) {
        //     fun.showPageFull({
        //         page_url: page_arr.yarn_quotation,
        //         pageParam: {
        //             unit_id: xsdw_id || 0, // 销售单位id
        //             zdw: getJjdw(xsdw_id),
        //             zdw_id: getUnitId(),
        //             jg_type: CP_INFO['info']['jg_type'],
        //             jg_value: jgValue,
        //             data: page_data['data'],
        //             id: page_data['id'] || '',
        //             return_page: page_arr.yarn_edit,
        //             page_type: 'yarn_quotation',
        //             goods_colour: CP_INFO['goods_colour'], // 价格页面编辑获取的纱线颜色
        //             delete_colour: delete_list['colour_arr'], // 被删除的纱线颜色
        //             cp_mc: $('#cp_mc').val().trim() || '' // 纱线名称
        //         }
        //     });
        // } else {
        //     fun.showPageFull({
        //         page_url: page_arr['shop_product_jg'],
        //         pageParam: {
        //             unit_id: xsdw_id || 0,
        //             zdw: getJjdw(xsdw_id),
        //             zdw_id: getUnitId(),
        //             jg_type: CP_INFO['info']['jg_type'],
        //             jg_value: jgValue,
        //             data: page_data['data'],
        //             return_page: page_arr.yarn_edit,
        //             page_type: 'shop_product_jg',
        //             goods_colour: CP_INFO['goods_colour'], // 价格页面编辑获取的纱线颜色
        //             delete_colour: delete_list['colour_arr'], // 被删除的纱线颜色
        //             cp_mc: $('#cp_mc').val().trim() || ''
        //         }
        //     });
        // }

        fun.hideLoad();
    });

    // 跳转颜色页面
    $('body').on('tap', '#color-card', function () {
        fun.showLoad();
        // 跳转页面参数(根据跳转链接)
        $(CP_INFO['goods_colour']).each(function (_index, item) {
            item['_index'] = _index;
        })
        if (!IS_PAGE_EDIT) return;
        if ('id' in page_data) {
            fun.showPageFull({
                page_url: page_arr.yarn_color,
                pageParam: {
                    data: CP_INFO['goods_colour'],
                    return_page: page_arr.yarn_edit,
                    page_type: 'yarn_color',
                    id: page_data['id'],
                    // count_data: CP_INFO
                }
            });
        } else {
            fun.showPageFull({
                page_url: page_arr.yarn_color,
                pageParam: {
                    data: CP_INFO['goods_colour'],
                    return_page: page_arr.yarn_edit,
                    page_type: 'yarn_color',
                    // count_data: CP_INFO
                }
            });
        }
        fun.hideLoad();
    });

    // 跳转底卡页面
    $('body').on('tap', '#bottom-card', function () {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        if ($.nui.isEmpty(CP_INFO['merchant_assistant'])) { // 底卡信息为空
            fun.showPageFull({
                page_url: page_arr.yarn_bottomcard_edit,
                pageParam: {
                    return_page: page_arr.yarn_edit,
                    main_isTure: main_isTure,
                    page_type: 'yarn_bottomcard_edit',
                    type: 'add',
                    color: CP_INFO['goods_colour'],
                    dw: getJjdw(CP_INFO['info']['unit_options']['xsdw_id']),
                    jjdw_id: getUnitId()
                }
            })
        } else { // 有底卡信息
            fun.showPageFull({
                page_url: page_arr.yarn_bottomcard,
                pageParam: {
                    id: page_data['id'],
                    return_page: page_arr.yarn_edit,
                    page_type: 'yarn_bottomcard',
                    merchant_assistant: CP_INFO['merchant_assistant'],
                    color: CP_INFO['goods_colour'],
                    dw: getJjdw(CP_INFO['info']['unit_options']['xsdw_id']),
                    jjdw_id: getUnitId()
                }
            })
        }
        fun.hideLoad();
    });

    // 纱线规格
    $('body').on('tap', '#cp_gg', function () {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr.yarn_specifications,
            pageParam: {
                id: page_data['id'] || '',
                return_page: page_arr.yarn_edit,
                list: CP_INFO['goods_spec'] || [], //列表数据
                delete_arr: delete_list['spec_arr'] || [], // 删除数据
                default_obj: default_obj['default_gg'], // 
                page_type: 'yarn_specifications'
            }
        });
        fun.hideLoad();
    });

    // 其他要求
    $('#gy_yq').on('tap', function () {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr.yarn_requirement,
            pageParam: {
                return_page: page_arr.yarn_edit,
                list: CP_INFO['goods_craft'] || [],
                delete: delete_list['craft_arr'] || [],
                id: page_data['id'] || ''
            }
        });
        fun.hideLoad();
    })

    // 其他参数
    $('body').on('tap', '#cp_qtcs', function () {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr.yarn_parameter,
            pageParam: {
                return_page: page_arr.yarn_edit,
                list: CP_INFO['param'] || []
            }
        });
        fun.hideLoad();
    });

    //选择往来单位
    $('.skip_select').on('tap', function () {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        var tmp_url = '';
        if ($(this).data('type') == 'sx_lb') {
            tmp_url = page_arr.select_type;
        } else {
            tmp_url = page_arr.select_sx_list;
        }
        fun.showPageFull({
            page_url: tmp_url,
            pageParam: {
                "return_page": page_arr.yarn_edit,
                "page_type": ($(this).data('type') || "")
            }
        });
        fun.hideLoad();
    });

    // 保存事件
    $('body').on('tap', '#save_btn', function () {
        if (!IS_PAGE_EDIT) return;
        saveData();
    });

    // 显示隐藏更多
    $('body').on('tap', '#click-hide', function () {
        if (!IS_PAGE_EDIT) return;
        // $('.attributes').css('marginBottom', $('bottom-btn-style').height() + 'px');
        $("#hide-info").slideUp(600);
        $("#click-show").show(600);
    });

    // 隐藏属性
    $('body').on('tap', '#click-show', function () {
        if (!IS_PAGE_EDIT) return;
        // $('.attributes').css('marginBottom', '3rem');
        $("#click-show").slideUp(500);

        $("#hide-info").slideDown(1000, function () {
            $(this).css({
                marginBottom: $('.fixed:visible').length && $('.fixed:visible').height()
            })
        });
    });

    // 类型切换
    $('#sx_jw').on('click', function () {
        if (!IS_PAGE_EDIT) return;
        var _this = $(this);
        fun.showBookList({
            width: '280px',
            shadeClose: true,
            list: type_data,
            open_init: function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false });
            },
            choose: function (res) {
                $(type_data).each(function (i, obj) {
                    if (obj['id'] == res['id']) {
                        type_data[i]['is_choose'] = 1;
                    } else {
                        type_data[i]['is_choose'] = 0;
                    }
                })
                $(_this).val(res['name'] || "").attr('sx_jw', (res['db_name'] || ""));
            },
            end: function () {
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            }
        });
    })
}

// 键盘弹起处理函数
function keyBoardShow() {
    // $('.fixed').hide();
    // $('.attributes').css({
    //     marginBottom: 0
    // })
}

// 键盘收起处理函数
function keyBoardHide() {
    // $('.fixed').show();
    // $('.attributes').css({
    //     marginBottom: '3.5rem'
    // })
}

function preventDefault(e) {
    e.preventDefault();
}