var html_name = page_arr.yarn_quotation;
var search_data = {
    "type": "add",
    "is_mobile": 1,
    "keyword": "",
    "keyword_key": ['cp_ys_mc', 'cp_ys_bh', 'simple'],
    "cp_id": 0,
    "cp_lb_id": 0,
    "jjdw_id": 0,
    "sx_pp": '',
    "sx_dq": '',
    "sx_xz": '',
    "gg": '',
};
var title = '';
var yarnQuote = {
    quoteData: [],
    closePage: function () {
        setTimeout(function () {
            api.closeWin();
        }, 200);
    }
};
page_init = function () {
    //安卓返回键
    page_data['keyback'] = isDataChange;
    $('#foot_search').focus();
    //根据开账设置显示隐藏
    if (fun.getKzValue('sxjg', 'sx_pp')) { //品牌
        search_data['sx_pp'] = page_data['sx_pp'] || '';
        $('#sx_pp').text(page_data['sx_pp'] || '');
        if ($.nui.isTrue(page_data['sx_pp'])) {
            $('#sx_pp').next().show();
        }
        $('#brand').show();
    }
    if (fun.getKzValue('sxjg', 'sx_dq')) { //地区
        search_data['sx_dq'] = page_data['sx_dq'] || '';
        $('#sx_dq').text(page_data['sx_dq'] || '');
        if ($.nui.isTrue(page_data['sx_dq'])) {
            $('#sx_dq').next().show();
        }
        $('#region').show();
    }
    if (fun.getKzValue('sxjg', 'sx_xz')) { //性质
        search_data['sx_xz'] = page_data['sx_xz'] || '';
        $('#sx_xz').text(page_data['sx_xz'] || '');
        if ($.nui.isTrue(page_data['sx_xz'])) {
            $('#sx_xz').next().show();
        }
        $('#nature').show();
    }
    if (fun.getKzValue('sxjg', 'gg')) { //规格
        search_data['gg'] = page_data['sx_gg'] || '';
        $('#sx_gg').text(page_data['sx_gg'] || '');
        if ($.nui.isTrue(page_data['sx_gg'])) {
            $('#sx_gg').next().show();
        }
        $('#specifications').show();
    }
    
    //接收
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        var data = temp['data'];
        switch (temp['status']) {
            case 'select_sx_list':
                switch (data['page_type']) {
                    case 'sx_pp': //品牌
                        if ($.nui.isTrue(data['select_val'])) {
                            $('#sx_pp').next().show();
                            $('#sx_pp').text(data['select_val']);
                            search_data['sx_pp'] = data['select_val'] || '';
                            getList();
                        }

                        break;
                    case 'sx_dq': //地区
                        if ($.nui.isTrue(data['select_val'])) {
                            $('#sx_dq').next().show();
                            $('#sx_dq').text(data['select_val']);
                            search_data['sx_dq'] = data['select_val'] || '';
                            getList();
                        }
                        break;
                    case 'sx_xz': //性质
                        if ($.nui.isTrue(data['select_val'])) {
                            $('#sx_xz').next().show();
                            $('#sx_xz').text(data['select_val']);
                            search_data['sx_xz'] = data['select_val'] || '';
                            getList();
                        }
                        break;
                    case 'jjdw':  //计价单位
                        if ($.nui.isTrue(data['select_val'])) {
                            $('#dw').text(data['select_val']).attr('dw_id', data['id']);
                            search_data['jjdw_id'] = data['id'] || 0;
                            search_data['jjdw_mc'] = data['select_val'] || '';
                            getList();
                        }
                        break;
                }
                break;
            case 'goodsdata'://规格
                if ($.nui.isTrue(data['select_val'])) {
                    $('#sx_gg').next().show();
                    $('#sx_gg').text(data['select_val']);
                    search_data['gg'] = data['select_val'] || '';
                    getList();
                }
                break;
            case 'refresh':
                getList();
                break;
        }
    });
    title = page_data['sx_mc'];
    $('#header').header({
        back: true,
        title: title,//纱线名称
        // add: Auth.check('sxbj', 'edit'),
        foot_input: {
            show: true,
            plader: '搜索颜色'
        },
        appendBackBtnEvt: isDataChange
    });

    // console.log(JSON.stringify(page_data));
    search_data['cp_id'] = page_data['cp_id'];
    search_data['jjdw_id'] = page_data['dw_id'] || 0;
    search_data['jjdw_mc'] = page_data['dw_mc'] || '';
    
    $('#dw').text(page_data['dw_mc'] || '');
    getList();
};

//返回事件
function isDataChange() {
    if (Auth.check('sxbj', 'edit')) {
        preservation();
    } else {
        yarnQuote.closePage();
    }
};

//获取数据
function getList() {
    //其中一个条件为空不查询（开账设置没开除外）
    // if (($.nui.isEmpty(search_data['sx_pp']) && fun.getKzValue('sxjg', 'sx_pp')) ||
    //     ($.nui.isEmpty(search_data['sx_dq']) && fun.getKzValue('sxjg', 'sx_dq')) ||
    //     ($.nui.isEmpty(search_data['sx_xz']) && fun.getKzValue('sxjg', 'sx_xz')) ||
    //     ($.nui.isEmpty(search_data['gg']) && fun.getKzValue('sxjg', 'gg'))) {
    //     return
    // }
    //计价单位为空时,不查询
    if ($.nui.isEmpty(search_data['jjdw_id']) && $.nui.isEmpty(search_data['jjdw_mc'])) {
        return
    }
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSxbjList,
        data: search_data,
        success: function (res) {
            fun.hideLoad();
            if (res['status'] == 0) {
                // console.log('获取数据');
                // console.log(JSON.stringify(res))
                // if (!res['data'] || res['data'].length == 0) {
                // return $('#swipe_delete').html('<p class="empty_text">暂无数据！</p>');
                // return fun.createDataEmptyTips({ dom: '#swipe_delete', btnShow: false, style: 'top:10rem;height:10rem;' });
                // }
                showData(res['data'] || []);
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}

//渲染数据
function showData(data) {
    // console.log('////////');
    // console.log(JSON.stringify(search_data));
    // console.log(JSON.stringify(data));
    // console.log(JSON.stringify(data.length));
    var listHtml = [];
    for (var i = 0; i < data.length; i++) {
        // console.log(i);
        var list_data = data[i];
        var cp_ys_id = list_data['cp_ys_id'] || 0;
        var cp_ys = ((list_data['cp_ys_bh'] || '') + ' ' + (list_data['cp_ys_mc'] || ''));
        var info_data = {
            "id": search_data['cp_id'] || 0,
            "cp_mc": list_data['cp_mc'] || '',
            "cp_ys_id": cp_ys_id || 0,
            "cp_ys_mc": list_data['cp_ys_mc'] || '',
            "cp_ys_bh": list_data['cp_ys_bh'] || '',
            "simple": list_data['simple'] || '',
            "order_amount": list_data['order_amount'] || '',
            "gg": search_data['gg'] || '',
            "sx_pp": search_data['sx_pp'] || '',
            "sx_dq": search_data['sx_dq'] || '',
            "sx_xz": search_data['sx_xz'] || '',
        };
        // if ($.nui.isTrue(cp_ys_id)) {

        listHtml.push('<li class="info" cp_ys_id="' + cp_ys_id + '"  data-info=\'' + JSON.stringify(info_data) + '\'>');
        listHtml.push('     <div class="ins-detail color lower-border-line">');
        listHtml.push('         <span class="color-name">' + (fun.redFont(fun.is_value(cp_ys), search_data['keyword']) || "") + '</span>');
        listHtml.push('         <div class="container qdl-box">');
        listHtml.push('             <span class="stand-price">起订量</span>');
        listHtml.push('             <span class="qdl_text">' + fun.is_value(list_data['order_amount']) + '</span>');
        listHtml.push('         </div>');
        listHtml.push('     </div>');
        listHtml.push('<ul class="ins-list swipe-delete">');
        listHtml.push('     <li data-time="' + fun.is_value(list_data['bz_sj']) + '" data-bzj="' + fun.is_value(list_data['bz_bzj']) + '" data-zdj="' + fun.is_value(list_data['bz_zdj']) + '" data-id="' + 0 + '" class="ins-detail-li lower-border-line" cp_ys_id="' + cp_ys_id + '">');
        listHtml.push('         <span class="color-type">标准</span>');
        listHtml.push('         <div class="container">');
        listHtml.push('             <span class="stand-price">标准价</span>');
        listHtml.push('             <input type="text" id="' + cp_ys_id + '_bz_bzj' + '" value="' + fun.is_value(list_data['bz_bzj']) + '" class="ms_bzj num-input bzj" num_type="2" decimal_digits="4"/>');
        listHtml.push('         </div>');
        listHtml.push('         <div class="container">');
        listHtml.push('             <span class="stand-price">最低价</span>');
        listHtml.push('             <input type="text" id="' + cp_ys_id + '_bz_zdj' + '" value="' + fun.is_value(list_data['bz_zdj']) + '" class="ms_zdj num-input zdj" num_type="2" decimal_digits="4"/>');
        listHtml.push('         </div>');
        listHtml.push('     </li>');
        var bjms = list_data['bjms'];
        for (var j = 0; j < bjms.length; j++) {
            var bj = bjms[j];
            var ms_sj = (bj['ms_sj_' + bj['id']] || '');
            var bzj = (bj['ms_bzj_' + bj['id']] || '');
            var zdj = (bj['ms_zdj_' + bj['id']] || '');
            var bz_id = cp_ys_id + '_bzj_' + bj['id'];
            var zd_id = cp_ys_id + '_zdj_' + bj['id'];
            listHtml.push('     <li data-time="' + ms_sj + '" data-bzj="' + bzj + '" data-zdj="' + zdj + '" data-id="' + bj['id'] + '" class="ins-detail-li lower-border-line" cp_ys_id="' + cp_ys_id + '">');
            listHtml.push('         <span class="color-type">' + bj['name'] + '</span>');
            listHtml.push('         <div class="container">');
            listHtml.push('             <span class="stand-price">标准价</span>');
            listHtml.push('             <input type="text" id="' + bz_id + '" value="' + bzj + '" class="ms_bzj num-input bzj" num_type="2" decimal_digits="4"/>');
            listHtml.push('         </div>');
            listHtml.push('         <div class="container">');
            listHtml.push('             <span class="stand-price">最低价</span>');
            listHtml.push('             <input type="text" id="' + zd_id + '" value="' + zdj + '" class="ms_zdj num-input zdj" num_type="2" decimal_digits="4"/>');
            listHtml.push('         </div>');
            listHtml.push('     </li>');
        }
        listHtml.push('    </ul>');
        listHtml.push('</li>');
    }
    $("#swipe_delete").html(listHtml.join(''));

    //无纱线报价编辑权限，输入框不可编辑
    if (!Auth.check('sxbj', 'edit')) {
        $('.num-input').attr('readonly', 'readonly');
    }
}

//保存数据
function preservation() {
    $('.num-input').blur();
    var list_data = {};
    var list = [];
    $('.info').each(function (i, iemt) {
        var data_info = $(iemt).data('info') || {};
        $(iemt).find('.ins-detail-li').each(function (k, key) {
            var id = $(key).data('id');
            if (data_info['cp_ys_id'] == $(key).attr('cp_ys_id')) {
                if ($.nui.isEmpty(id)) {
                    if ($.nui.isTrue($(key).data('time'))) {
                        data_info['bz_sj'] = $(key).data('time') || '';
                    }
                    if ($.nui.isTrue($(key).data('bzj'))) {
                        data_info['bz_bzj'] = $(key).data('bzj') || '';
                    }
                    if ($.nui.isTrue($(key).data('zdj'))) {
                        data_info['bz_zdj'] = $(key).data('zdj') || '';
                    }
                } else {
                    var ms_sj = 'ms_sj_' + id;
                    var ms_bzj = 'ms_bzj_' + id;
                    var ms_zdj = 'ms_zdj_' + id;
                    if ($.nui.isTrue($(key).data('time'))) {
                        data_info[ms_sj] = $(key).data('time') || '';
                    }
                    if ($.nui.isTrue($(key).data('bzj'))) {
                        data_info[ms_bzj] = $(key).data('bzj') || '';
                    }
                    if ($.nui.isTrue($(key).data('zdj'))) {
                        data_info[ms_zdj] = $(key).data('zdj') || '';
                    }
                }
            }
        });
        list.push(data_info);
    });

    // console.log('---');
    // console.log(list);
    // console.log('---');

    $(list).each(function (idx, item) {
        yarnQuote['quoteData'].push({
            cp_ys_mc: item['cp_ys_mc'],
            cp_ys_bh: item['cp_ys_bh'],
            cp_ys_id: item['cp_ys_id'],
            bz_bzj: item['bz_bzj'] || 0,
            id: item['id']
        });
    })

    // console.log('保存数据');
    // console.log(JSON.stringify(list));
    list_data = {
        "status": "add",
        "cp_id": search_data['cp_id'] || 0,
        "jjdw_id": search_data['jjdw_id'] || 0,
        "zdr_id": fun.getItem('user_info')['id'] || 0,
        "gg": search_data['gg'] || '',
        "sx_pp": search_data['sx_pp'] || '',
        "sx_dq": search_data['sx_dq'] || '',
        "sx_xz": search_data['sx_xz'] || '',
        "data": list || []
    };
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: AJAX_URL.saveSxbjInfo,
        data: list_data,
        success: function (res) {
            switch(res['status']){
                case 0:
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                            'data': {
                                dw_id: search_data['jjdw_id'] || 0,
                                dw_mc: search_data['jjdw_mc'] || '',
                                quoteData: yarnQuote['quoteData']
                            },
                        }
                    });
                    yarnQuote.closePage();
                    break;
                case 'AUTH_ERR':
                    fun.alert({ msg: res['msg'] });
                    break;
                default :
                    fun.alert({ msg: '网络异常！' });
            }
            // if (res['status'] == 0) {
                
            // } else {
            //     fun.alert({ msg: '网络异常！' });
            // }
        }
    });
}

//搜索
$('body').on('tap', '.edit-info', function () {
    var type = $(this).attr('id');
    var url, page;
    switch (type) {
        case 'brand'://品牌搜索
            page = 'sx_pp';
            break;
        case 'region'://地区搜索
            page = 'sx_dq';
            break;
        case 'nature'://性质搜索
            page = 'sx_xz';
            break;
        case 'specifications'://规格搜索
            var cp_title = title || '',
                cp_id = page_data['cp_id'] || 0,
                gg_name = $('#sx_gg').text() || '';
            fun.showPageFull({
                page_url: page_arr.specifications,
                pageParam: {
                    html_name: html_name,
                    page_type: 'specifications',
                    cp_title: cp_title,
                    cp_id: cp_id,
                    gg_name: gg_name
                }
            });
            return
            break;
        case 'valuation'://单位搜索
            page = 'jjdw';
            break;
    }
    fun.showPageFull({
        page_url: page_arr.select_sx_list,
        pageParam: {
            return_page: html_name,
            page_type: page,
        }
    });
})

// 报价输入框离开焦点自动给时间输入框赋值
$('body').on('blur', '.num-input', function () {
    var jg = $(this).val();
    var $closeLi = $(this).closest('li');
    //默认时间
    var mr_bzj = $closeLi.data('bzj');
    var mr_zdj = $closeLi.data('zdj');
    var myDate = new Date();
    if ($(this).hasClass('bzj')) {
        if (jg != mr_bzj) {
            $closeLi.data('time', myDate.Format('yy-mm-dd hh:ii'));
            $closeLi.data('bzj', jg);
        }
    } else if ($(this).hasClass('zdj')) {
        if (jg != mr_zdj) {
            $closeLi.data('time', myDate.Format('yy-mm-dd hh:ii'));
            $closeLi.data('zdj', jg);
        }
    }

    //当前价格模式都为空，清空时间与自定义属性
    var bzj = $closeLi.find('.bzj').val();
    var zdj = $closeLi.find('.zdj').val();
    if ($.nui.isEmpty(bzj) && $.nui.isEmpty(zdj)) {
        $closeLi.data('time', '');
        $closeLi.data('zdj', '');
        $closeLi.data('bzj', '');
    }
});

// 选择 计价单位
$('body').on('tap', '.count-box', function () {
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            return_page: html_name,
            page_type: 'jjdw',
        }
    });
});
//点击键盘搜索
$('body').bind('search', "#foot_search", function () {
    search_data['keyword'] = $("#foot_search").val().trim();
    $("#swipe_delete").empty();
    getList();
});

//清除选中值
$('body').on('tap', '.list-icon', function (e) {
    e.stopPropagation();
    var list_type = $(this).prev().attr('id');
    switch (list_type) {
        case 'sx_pp':
            $('#sx_pp').text('');
            search_data['sx_pp'] = '';
            break;
        case 'sx_dq':
            $('#sx_dq').text('');
            search_data['sx_dq'] = '';
            break;
        case 'sx_xz':
            $('#sx_xz').text('');
            search_data['sx_xz'] = '';
            break;
        case 'sx_gg':
            $('#sx_gg').text('');
            search_data['gg'] = '';
            break;
    }
    $(this).hide();
    getList();
});