var html_name = page_arr.yarn_specifications;
var goods_spec = [], delete_spec = [];
var new_goodsData = [];
var default_obj = {};
var AUTH_EDIT;
AUTH_EDIT = Auth.check('sx', 'edit');

page_init = function () {
    console.log(JSON.stringify(page_data));
    $("#header").header({
        back: true,
        title: "纱线规格",
        add: AUTH_EDIT,
        appendBackBtnEvt: appendBackBtnEvts
    })
    // pageStyleInit(); // 页面样式初始化
    page_data.keyback = appendBackBtnEvts; // 监听返回键
    goods_spec = [];
    goods_spec = page_data.list || goods_spec;
    delete_spec = page_data.delete_arr || delete_spec;
    $(".message").empty();
    showList(goods_spec);
    fun.setKeyBoard({
        isIos: {
            showFn: iosKeyBoardShow,
            hideFn: iosKeyBoardHide
        }
    })

    //lert(JSON.stringify(delete_spec))
}

// 页面样式初始化
function pageStyleInit() {
    $('.content').css({
        top: $('#header').outerHeight()
    })
}

//添加规格
$('body').on('tap', '#add_btn', function () {
    addSpec({
        type: 'add',
        callback: function (res) {
            goods_spec.push(res)
            $(".message").empty();
            showList(goods_spec)
        }
    });
})

//修改规格
$('body').on('tap', '.guige', function () {
    var xiugai_index = $(this).parents('.lower-border-line2').data("id");
    var gg_name = $(this).find('.xuanzhong').text();
    addSpec({
        type: 'edit',
        value: {
            "sort": goods_spec[xiugai_index].sort,
            "product-gg": goods_spec[xiugai_index].spec,
            "is_default": goods_spec[xiugai_index].is_default,
            "id": goods_spec[xiugai_index].id,
        },
        callback: function (res, index) {
            goods_spec[index] = res;
            $(".message").empty();
            showList(goods_spec)
        }
    }, gg_name, xiugai_index);
})

//删除规格
$('body').on('tap', '.delete-btn', function (e) {
    e.preventDefault();
    var delete_index = $(this).parents('.lower-border-line2').data("id");
    fun.dialog({
        content: '你确定要删除吗?',
        btn: ['删除', '取消'],
        success: function () {
            document.body.addEventListener('touchmove', preventDefault, { passive: false });
        },
        yes: function () {
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            delete_spec.push(goods_spec[delete_index].id)
            goods_spec.splice(delete_index, 1);
            for (var i = 0; i < goods_spec.length; i++) {
                goods_spec[i].sort = i + 1;
            }
            $(".message").empty();
            showList(goods_spec);
        },
        no: function () {
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
        }
    });
});

function appendBackBtnEvts() {
    for (var i = 0; i < goods_spec.length; i++) {
        if (goods_spec[i].is_default == 1) {
            default_obj = goods_spec[i];
        }
    }
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'cpzl_data',
            'page_type': 'gg',
            'list': goods_spec,//列表数据
            'delete_arr': delete_spec,
            'default_obj': default_obj
        }
    });
    api.closeWin();
}

//数据渲染
function showList(data) {
    if(!data || data.length == 0){
        fun.createDataEmptyTips({dom:'.message',btnShow:false});
    }
    for (var i = 0; i < data.length; i++) {
        var html_arr = [];
        html_arr.push('<li class="lower-border-line2" data-id=' + i + ' data-list=\'' + JSON.stringify(data[i]) + '\'>');
        html_arr.push('     <div class="le">');
        html_arr.push('           <div class="guige">');
        html_arr.push('              <span class="color-gray" style="margin-left:0.5rem">' + data[i].sort + '.</span>');
        html_arr.push('              <div class="xuanzhong xunazhong-min">' + data[i].spec + '</div>');
        html_arr.push('              <div class="' + (data[i].is_default == 1 ? 'display' : '') + ' bg-color-blue2 default_guige"></div>');
        html_arr.push('           </div>');
        html_arr.push('          <div class="delete dels1 delete-btn">删除</div>');
        html_arr.push('     </div>');
        html_arr.push('</li>');
        $('.message').append(html_arr.join(''));
    }
    //没有产品编辑权限 
    if (!AUTH_EDIT) {
        //禁用点击事件和左滑
        $('.lower-border-line2').css('pointer-events', 'none').children().removeClass('le')
    }
}

/******新增*****/
function addSpec(opt, gg_name, index) {
    var html = [];
    var val = opt.value || {},
        is_default = (val['is_default'] == 1) ? "nui-active" : "nui-unactive";
    html.push('  <div class="warm"> ');
    html.push('   <div class="warm-title"> ');
    html.push('    <span class="title">' + ((opt.type == "add") ? "新增规格" : "修改规格") + '</span> ');
    html.push('   </div> ');
    html.push('   <div class="warm-con"> ');
    html.push('    <ul> ');
    html.push('     <li class="obj-title"> <span class="param">规格</span> <input id="product-gg" type="text" value="' + (val['product-gg'] || "") + '" /> </li> ');
    html.push('    </ul> ');
    html.push('    <div class="shows"> ');
    html.push('     <i id="gg_is_stop" class="gg-switch stp-btn nui-switch nui-switch-md nui-switch-btn ' + is_default + '"><i class="nui-switch-handle" id="st"></i><label for="gg_is_stop"  class="switch-label">默认</label> </i> ');
    html.push('    </div> ');
    html.push('   </div> ');
    html.push('   <div class="warm-operation"> ');
    html.push('    <button class="btn" id="cancel">取消</button>');
    html.push('    <button class="btn" id="confirm">确认</button> ');
    html.push('   </div> ');
    html.push('  </div>');
    layer.open({
        type: 1,
        content: html.join(''),
        shadeClose: false,
        style: 'width: 90%; min-height: auto; border-radius: 0.5rem;background-color: #fff; overflow-y: hidden;',//position: fixed;top: 25%;left: 5%;
        success: function () {
            document.body.addEventListener('touchmove', preventDefault, { passive: false });
            //确定
            $('#confirm').on('tap', function () {
                if (typeof opt.callback == 'function') {
                    if (!$('#product-gg').val()) {
                        return;
                    }
                    if ($('#gg_is_stop').hasClass('nui-active')) {
                        for (var i = 0; i < goods_spec.length; i++) {
                            goods_spec[i].is_default = 0;
                        }
                    }
                    var is_nowdefault = ($('#gg_is_stop').hasClass('nui-active')) ? 1 : 0;
                    var bianhao = $('.lower-border-line2').length + 1;
                    var param = {
                        "id": (val['id'] || 0),
                        "spec": ($('#product-gg').val().trim() || ""),
                        "sort": (val['sort'] || bianhao),
                        "is_stop": 0,
                        "is_default": ($('#gg_is_stop').hasClass('nui-active')) ? 1 : 0,
                        "remark": ""
                    };
                    if (existGg(param)) return fun.toast('规格已存在。');//规格 存在时，不让弹窗关闭
                    opt.callback(param, index);
                }
                setTimeout(function () {
                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                    layer.closeAll()
                }, 50)
            });

            $('#cancel').on('tap', function () {
                setTimeout(function () {
                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                    layer.closeAll()
                }, 50)
            });
        }
    });
}

//规格是否存在
function existGg(param) {
    for (var i = 0; i < $('.lower-border-line2').length; i++) {
        var $obj = $('.lower-border-line2').eq(i);
        var data = $obj.data('list');
        if (((i + 1) != param['sort']) && (param['spec'] == data['spec'])) return true;
    }
    return false;
}

// ios软键盘弹起处理
function iosKeyBoardShow() {
    fun.headerAbsolute('#header');
    fun.iosScroll('.content');
}

// ios软键盘收起处理
function iosKeyBoardHide() {
    fun.headerFixed('#header');
    fun.iosRemoveScroll('.content');
}