var html_name = page_arr['yarn_view']; // 当前页面名称
var return_page = ''; // 返回页
var photoBrowser = {}; // 大图预览
var IS_PAGE_EDIT = true; // 页面是否可编辑
var PAGE_DATA = {};
var is_sj = 0; // 未上架
var _origin_data = {};
var SYS_CONFIG = {};
var printDataList = []; // 打印的数据
var bbxqImg = []; // 分页加载图片
var swiper = null; // swiper滑动变量 

var Bills = { djlx: 'sx' };
Bills['print_config'] = { 'djlx': 'sx' };
var search_data = {}; // 搜索数据
// 纱线信息
var CP_INFO = {
    info: {},
    goods_colour: [],
    goods_spec: [],
    merchant_assistant: [],
    goods_machining: [],
    goods_craft: [],
    options: {},
    param: []
};

// 返回被删除的列表
delete_list = {
    colour_arr: [], // 颜色
    fzxx_arr: [],
    fzxx_colouArr: [],
};

// 微信展示页判断权限
function wxShowAuth() {
    fun.ajax({
        url: AJAX_URL.getSysList,
        data: {},
        success: function (res) {
            if (res['status'] === 0) {
                var data = res['data'];
                if ('cpxqzs' in data) {
                    $(JSON.parse(data['cpxqzs'])).each(function (idx, item) {
                        if (item['name'] === 'bq' && !item['is_stop']) {
                            $('#line_bq').hide();
                            $('.special').hide();
                            $('.order_list').css({
                                paddingBottom: 0
                            })
                        }
                    })
                }
            }
        }
    });
}

// 监听安卓返回键
function isDataChange() {
    api.sendEvent({
        name: return_page,
        extra: {
            status: 'refresh'
        }
    })
    fun.showLoad();
    setTimeout(function () {
        api.closeWin();
        return fun.hideLoad();
    }, 200);
}

// 设置页面初始化
page_init = function () {
    console.log(page_data);
    fun.load_DATA_LIST(['jjdw']);
    SYS_CONFIG = fun.getItem('sys_config'); // 系统设置
    IS_PAGE_EDIT = Auth.check('sx', 'edit');
    return_page = page_data['return_page'];
    photoBrowser = api.require('photoBrowser'); // 大图预览
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret['value']; // 保存成功后
        switch (temp['status']) {
            case 'yarn_color':
                if ($.nui.isEmpty(temp['data'])) return; // 编辑状态，删除一个颜色，新建一条一模一样的，点击保存提示色号已存在，取值会取到一个undefined
                CP_INFO['goods_colour'] = temp['data'];
                if (CP_INFO['merchant_assistant'].length > 0) {
                    $(CP_INFO['merchant_assistant']).each(function (merchant_index, colour_item) {
                        var colour_length = colour_item['colour_assistant'].length;
                        var parme_arr = [];
                        $(CP_INFO['goods_colour']).each(function (colour_index, item) {   //返回颜色通知底卡颜色改变
                            var index = item['_index'];
                            //判断如果有新增的颜色则做加入，存在则做修改,如果存在，则colour_assistant数组长度是大于0的
                            if (('_index' in item)) {
                                var colour_assistant = colour_item['colour_assistant'][index];
                            }
                            if (('_index' in item) && colour_item['colour_assistant'].length > 0 && colour_assistant != undefined && ('goods_colour_id' in colour_assistant)) {
                                var parme = {
                                    colour_number: item['number'] || '',
                                    colour_name: item['name'] || '',
                                    id: colour_assistant['id'],
                                    goods_id: item['goods_id'],
                                    merchant_assistant_id: colour_assistant['merchant_assistant_id'],
                                    goods_colour_id: item['id'],
                                    number: colour_assistant['number'] || '',
                                    name: colour_assistant['name'] || '',
                                    simple: colour_assistant['simple'],
                                    order_amount: colour_assistant['order_amount'] || 0,
                                    price: colour_assistant['price'] || 0,
                                    is_delete: colour_assistant['is_delete'],
                                    create_time: colour_assistant['create_time'],
                                    update_time: colour_assistant['update_time'],
                                }
                                parme_arr.push(parme)
                            } else {
                                var parme = {
                                    colour_name: item['name'],
                                    colour_number: item['number'],
                                    id: 0,
                                    is_delete: 0,
                                    name: '',
                                    number: '',
                                    order_amount: 0,   //如果底卡是新增的，但还没保存的情况下，则那新增时价格对应进去，如果有多余的，则取0
                                    price: ('_index' in item && colour_length >= (item['_index'] + 1)) ? colour_assistant['price'] : 0,
                                }
                                parme_arr.push(parme);
                            }
                        })
                        if ($.nui.isTrue(temp['delete_colour'])) {
                            $(temp['delete_colour']).each(function (idx, item) {
                                if (item['_index'] != '') {
                                    delete_list['fzxx_colouArr'].push(colour_item['colour_assistant'][item['_index']]['id']);
                                }
                            })
                        }
                        colour_item['colour_assistant'] = parme_arr;
                    })
                }
                $('#has_stop').text(temp['stop_count']);
                delete_list['colour_arr'] = temp['delete_colour'];
                break;
            case 'refresh':
                getList();
                break;
            case 'cpzl_data':
                switch (temp['page_type']) {
                    case 'dk_bj':
                    case 'dk_xx': //  底卡信息
                        var tempArr = [];
                        CP_INFO['merchant_assistant'] = temp['merchant_assistant'] || temp['merchant_assistants'];
                        if ($.nui.isTrue(CP_INFO['merchant_assistant'])) {
                            $(CP_INFO['merchant_assistant']).each(function (idx, item) {
                                if (item['is_delete']) {
                                    if ('id' in item) {
                                        delete_list['fzxx_arr'].push(item['id']);
                                    }
                                } else {
                                    if (item['merchant_id']) {
                                        tempArr.push(item);
                                    }
                                }
                            })
                        }
                        CP_INFO['merchant_assistant'] = tempArr;
                        $('#fzxx_jl').text(CP_INFO['merchant_assistant'].length);
                        break;
                }
                break;
            // 没有default
        }
    });

    page_data.keyback = function () {
        isDataChange();
    };
    init();
}

// 从颜色列表里删除色卡
// function deleteCorCard(data) {
//     for (var i = 0; i < data.length; i++) {
//         var item = data[i];
//         if (item['number'] === '色卡') {
//             data.splice(i, 1);
//         }
//     }
// }

// 获取纱线信息
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getYarnInfo,
        data: {
            id: page_data['goods_id']
        },
        success: function (res) {
            if (res['status'] == 0) {
                var data = res.data || {};
                // console.log(JSON.stringify(data))
                // deleteCorCard(data['goods_colour']);
                CP_INFO = {
                    info: data['info'] || {},
                    goods_colour: data['goods_colour'],
                    goods_spec: data['goods_spec'],
                    merchant_assistant: data['merchant_assistant'],
                    goods_machining: data['goods_machining'],
                    goods_craft: data['goods_craft'],
                    options: data['options'],
                    param: data['param'],
                }
                if ($.nui.isTrue(CP_INFO['info']['bbxq'])) {
                    bbxqImg = CP_INFO['info']['bbxq'].split(',');
                } else {
                    bbxqImg = [];
                }
                initJgVal();
                resetColorImg(); // 图片字符串转数组，过滤空值
                showData(CP_INFO); // 初始化页面
            }
        }
    })
}

// 图片字符串转数组，过滤空值
function resetColorImg() {
    $(CP_INFO['goods_colour']).each(function (idx, item) {
        var temp = [];
        if ($.nui.isTrue(item['imgs'])) {
            var img = item['imgs'].split(',');
            $(img).each(function (index, imgs) {
                if ($.nui.isTrue(imgs)) {
                    temp.push(imgs);
                }
            })
        } else {
            temp = [];
        }
        item['imgs'] = temp;
    })
}

// console.log($('#gridDemo').html());

// 暂时没用到
function sysHasUnit() {
    if ($.nui.isTrue(SYS_CONFIG['bpfzdw_xs'])) {
        return true;
    }
    return false;
}

// 获取计价单位
function getJjdw(info) {
    var xsdw_id = info['unit_options']['xsdw_id'];
    var jjdwMc = '';
    if ($.nui.isTrue(xsdw_id)) { // 有销售单位id
        jjdwMc = fun.getValByKey(fun.getItem('jjdw_list'), Number(xsdw_id), 'name');
    } else { // 没有销售单位id
        if ($.nui.isTrue(info['unit_id'])) { // 有主单位
            jjdwMc = info['dw_mc'];
        }
    }
    return jjdwMc;
}

// 获取单位id（有销售单位id拿，）
function getUnitId() {
    var unitId = 0;
    // if ($.nui.isTrue(CP_INFO['info']['unit_options']['xsdw_id'])) {
    //     unitId = CP_INFO['info']['unit_options']['xsdw_id'];
    // } else if ($.nui.isTrue(CP_INFO['info']['unit_id'])) {
    //     unitId = CP_INFO['info']['unit_id'];
    // }
    return unitId;
}

// 没有取到值返回0
function showVal(value) {
    if ($.nui.isEmpty(value)) {
        value = 0;
    }
    return value;
}

// 处理旧数据保存报价
function initJgVal() {
    if ($.nui.isEmpty(CP_INFO['info']['jg_type']) || $.nui.isEmpty(CP_INFO['info']['jg_value'])) {
        CP_INFO['info']['jg_type'] = 'ys';
        CP_INFO['info']['jg_value'] = [];
    }
}

// 显示价格
function showJg(info) {
    var jg_value = info['jg_value'];
    // var xsdw_id = info['unit_options']['xsdw_id'];
    function getUnit(mark) {
        var unit = '';
        if (mark) {
            unit = $.nui.isTrue(getJjdw(info)) ? '/' + getJjdw(info) : '';
        } else {
            unit = $.nui.isTrue(getJjdw(info)) ? getJjdw(info) : '';
        }
        return unit;
    }
    if ($.nui.isEmpty(info['jg_type'])) {
        var html = [];
        html.push('<p class="type-null text-handle font-ls">￥0' + getUnit(true) + '</p>');
        $('.order-mi')
            .css({
                paddingBottom: '.5rem'
            })
            .html(html.join(''));
        return;
    }
    switch (info['jg_type']) {
        case '':
        case 'ys':
        case 'sl':
            if ($.nui.isEmpty(jg_value)) {
                var html = [];
                html.push('<p class="type-null text-handle font-ls">￥0' + getUnit(true) + '</p>');
                $('.order-mi')
                    .css({
                        paddingBottom: '.5rem'
                    })
                    .html(html.join(''));
                return;
            }
            break;
        // 没有default
    }

    switch (info['jg_type']) {
        case 'sl': // 按数量报价
            var jgValue = info['jg_value'];
            if ($.nui.isTrue(jgValue)) {
                var qdl = jgValue.every(function (item, idx, self) {
                    return !item.qdl;
                })
                var money = jgValue.every(function (item, idx, self) {
                    return !item.money;
                })

                if (qdl && money) { // 起订量和价格都是0
                    var html = [];
                    html.push('<p class="type-null text-handle font-ls">￥0' + getUnit(true) + '</p>');
                    $('.order-mi')
                        .css({
                            paddingBottom: '.5rem'
                        })
                        .html(html.join(''));
                    return;
                    break;
                } else {
                    var html = [];
                    html.push('<ul class="clear-space">');
                    var jgValLen = jgValue.length;

                    switch (jgValLen) {
                        case 1:
                            html.push('<li class="money-wrap li-one">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle ">￥</span>');

                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[0]['money']) + '</span>');
                            html.push('    </p>');

                            html.push('    <p class="font-ms qdl-count text-handle">' + showVal(jgValue[0]['qdl']) + getUnit(false) + '起批</p>');
                            html.push('</li>');
                            break;
                        case 2:
                            html.push('<li class="money-wrap li-one">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle ">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[0]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">' + showVal(jgValue[0]['qdl']) + getUnit(false) + '起批</p>');
                            html.push('</li>');
                            html.push('<li class="money-wrap li-one">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[1]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">≥' + showVal(jgValue[1]['qdl']) + getUnit(false) + '</p>');
                            html.push('</li>');
                            break;
                        case 3:
                            html.push('<li class="money-wrap li-three">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle ">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[0]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">' + showVal(jgValue[0]['qdl']) + getUnit(false) + '起批</p>');
                            html.push('</li>');
                            html.push('<li class="money-wrap li-three">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[1]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">' + showVal(jgValue[1]['qdl']) + '-' + showVal(jgValue[2]['qdl']) + getUnit(false) + '</p>');
                            html.push('</li>');
                            html.push('<li class="money-wrap li-three">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[2]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">≥' + showVal(jgValue[2]['qdl']) + getUnit(false) + '</p>');
                            html.push('</li>');
                            break;
                        // 没有default:
                    }
                    html.push('</ul>');
                    $('.order-mi')
                        .html(html.join(''))
                        .css({
                            paddingBottom: '.7rem'
                        });
                }
            }
            return;
            break;
        case 'ys':
            var jgValue = info['jg_value'];
            var jyArr = [];
            var dhArr = [];
            var cpYsArr = [];
            if ($.nui.isTrue(jgValue)) {
                $(jgValue).each(function (idx, item) {
                    if (item['cp_ys_bh'] !== '白坯#') {// && item['is_stop'] !== 1
                        jyArr.push(showVal(item['jy_bzj']));
                        dhArr.push(showVal(item['bz_bzj']));
                        cpYsArr.push(item);
                    }
                })
            }

            var maxJyj = Math.max.apply(null, jyArr);
            var minJyj = Math.min.apply(null, jyArr);
            var maxDhj = Math.max.apply(null, dhArr);
            var minDhj = Math.min.apply(null, dhArr);

            var jyjZero = jyArr.every(function (item, idx) { // 剪样都填0
                return item === 0;
            })
            var dhjZero = dhArr.every(function (item, idx) { // 大货都填0
                return item === 0;
            })

            if ($.nui.isEmpty(cpYsArr) || (jyjZero && dhjZero)) {
                var html = [];
                html.push('<p class="type-null text-handle font-ls">￥0' + getUnit(true) + '</p>');
                $('.order-mi')
                    .css({
                        paddingBottom: '.5rem'
                    })
                    .html(html.join(''));
                return;
            }

            if (cpYsArr.length > 1) { // 多个价格
                var html = [];
                html.push('<span class="jy yby-center mi-type jy-background middle jy-name">剪样</span>');

                if (minJyj === maxJyj) {
                    html.push('<span class="font-ss jy-money text-handle mi-jy middle">￥<i class="font-style-normal font-ms">' + maxJyj + '</i>' + getUnit(true) + '</span>');
                } else {
                    html.push('<span class="font-ss text-handle middle mi-jy yby-color-red">￥<i class="font-style-normal font-ms">' + minJyj + '</i>~<i class="font-style-normal font-ms">' + maxJyj + '</i>' + getUnit(true) + '</span>');
                }

                html.push('<span class="jy yby-center mi-type dh-background middle dh-name">大货</span>');
                if (minDhj === maxDhj) {
                    html.push('<span class="font-ss jy-money text-handle middle yby-color-red">￥<i class="font-style-normal font-ms">' + maxDhj + '</i>' + getUnit(true) + '</span>');
                } else {
                    html.push('<span class="font-ss text-handle middle yby-color-red">￥<i class="font-style-normal font-ms">' + minDhj + '</i>~<i class="font-style-normal font-ms">' + maxDhj + '</i>' + getUnit(true) + '</span>');
                }
                $('.order-mi')
                    .html(html.join(''))
                    .css({
                        paddingBottom: '.9rem',
                        fontStyle: 'normal'
                    })
                return;

            } else if (cpYsArr.length === 1) { // 单个价格
                var html = [];
                html.push('<span class="jy yby-center mi-type jy-background middle jy-name">剪样</span><span class="mi-jy font-ss jy-money text-handle mi-jy middle">￥<i class="font-style-normal font-ms">' + showVal(cpYsArr[0]['jy_bzj']) + '</i>' + getUnit(true) + '</span><span class="jy yby-center mi-type dh-background middle dh-name">大货</span><span class="font-ss jy-money text-handle mi-jy middle yby-color-red">￥<i class="font-style-normal font-ms">' + showVal(cpYsArr[0]['bz_bzj']) + '</i>' + getUnit(true) + '</span>');

                $('.order-mi').addClass('font-style-normal')
                    .html(html.join(''))
                    .css({
                        paddingBottom: '.9rem'
                    })
                return;
            }
            break;
        // 没有default:
    }
}

// 初始化界面数据
function showData(data) {
    $('#bbxq_box').html('');
    var info = data['info'];
    //纱线信息显示隐藏
    // if ($.nui.isEmpty(info['lb_mc']) && $.nui.isEmpty(info['brand'])
    //     && $.nui.isEmpty(info['area']) && $.nui.isEmpty(info['nature'])
    //     && $.nui.isEmpty(info['component']) && $.nui.isEmpty(info['label_id'])) {
    //     $('#sx_info,#sx_lb_pp').hide();
    // }
    // if ($.nui.isTrue(info['lb_mc']) || $.nui.isTrue(info['brand'])
    //     && $.nui.isTrue(info['area']) || $.nui.isTrue(info['nature'])
    //     && $.nui.isTrue(info['component']) || $.nui.isTrue(info['label_id'])) {
    //     $('#sx_info,#sx_lb_pp').show();
    // }
    if ($.nui.isEmpty(info['lb_mc'])) {//类别
        $('.sx_lb').hide();
    }else{
        $('.sx_lb').show();
    }
    if ($.nui.isEmpty(info['brand'])) {//品牌
        $('.sx_pp').hide();
    }else{
        $('.sx_pp').show();
    }
    if ($.nui.isEmpty(info['area'])) {//地区
        $('.sx_dq').hide();
    }else{
        $('.sx_dq').show();
    }
    if ($.nui.isEmpty(info['nature'])) {//性质
        $('.sx_xz').hide();
    }else{
        $('.sx_xz').show();
    }
    if ($.nui.isEmpty(info['component'])) {//成分
        $('.sx_cf').hide();
    }else{
        $('.sx_cf').show();
    }
    
    // 纱线主图
    if ($.nui.isTrue(info['imgs'])) {
        var html = [];
        var bbxqArr = info['imgs'].split(',');
        $('#swiper_wrapper').css({
            width: bbxqArr.length + '00%'
        })
        for (var i = 0; i < bbxqArr.length; i++) {
            var src = fun.getImgPath(bbxqArr[i], true);
            html.push('<li class="swiper-slide clear-space float-left" style="width: calc(100% / ' + bbxqArr.length + ')" data-index="' + i + '">');
            html.push('    <img src="' + src + '" alt="" class="product-img" large-url="">');
            html.push('</li>');
        }
        $('#swiper_wrapper').html(html.join(''));
        $('.product-img').css({
            width: '100%',
            height: '16rem',
            opacity: '1',
        })
    } else {
        $('#swiper_wrapper, #swiper_wrapper .swiper-slide').css({
            width: '100%'
        });
        var html = [];
        html.push('<li class="swiper-slide clear-space float-left">');
        html.push('    <img src="../img/logo.png" alt="" class="product-img" large-url="">');
        html.push('</li>');
        $('#swiper_wrapper').html(html.join(''));
    }

    $('#cp_bh_mc').text(fun.is_value(info['name']));

    if (!IS_PAGE_EDIT) {
        $('#shanchu').hide();
    }else{
        $('#shanchu').show();
    }

    showJg(info);

    $('#sx_lb').text(info['lb_mc'] || '');
    $('#sx_pp').text(info['brand'] || '');
    $('#sx_dq').text(info['area'] || '');
    $('#sx_xz').text(info['nature'] || '');
    // $('#cp_jd').text(fun.is_value(info['jd']));
    $('#sx_cf').text(info['component'] || '');

    getLabel(info['label_id']);   

    var hasStopCount = 0;
    $(data.goods_colour).each(function (idx, item) { // 颜色
        if (!item['is_stop']) {
            hasStopCount++;
        }
    })

    $('#has_stop').text(hasStopCount);

    $('#fzxx_jl').text(CP_INFO['merchant_assistant'].length); // 辅助信息（底卡信息）



    if (!Auth.check('sx_fzxx', 'view')) {
        $('#dk').hide();
    };

    // wxShowAuth(); // 网页的微信展示页权限判断显示
    authShow();
  
    if (!IS_PAGE_EDIT) {
        $('.bottom-space-evenly').hide();
    }
    $('#dk').css({
        marginBottom: api.safeArea.bottom + $('.operation').outerHeight()
    })
    //iphoneX适应
    $('.bottom-space-evenly').css('padding-bottom', api.safeArea.bottom);
    fun.hideShade();
}

// 判断页面修改权限显示隐藏编辑
function authShow() {
    if (!IS_PAGE_EDIT) { // 没有页面修改权限，不显示这一行
        $('.operation').hide();
        $('.bottom-card').css({
            marginBottom: 0
        })
    } else {
        $('.operation').show();
        $('.bottom-card').css({
            marginBottom: $('.operation').outerHeight() + api.safeArea.bottom
        })
    }
}

//获取纱线标签
function getLabel(arr, callback) {
    label_arr = arr;
    var lar = label_arr.split(',') || [];
    var tmp = new Array();
    for (var i = 0; i < lar.length; i++) {
        tmp[i] = Number(lar[i]);
    }
    lar = tmp;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getLabelList,
        data: {
            "type": 'sx',
        },
        success: function (res) {
            if (res['status'] != 0) return fun.toast('获取标签失败。');
            var info_list = res.data;
            var html = [];
            if ($.nui.isTrue(info_list)) {
                $('.special').css({
                    marginTop: '.6rem'
                });
                $('.order_list').css({
                    paddingBottom: '.5rem'
                })
            }

            for (var j = 0; j < lar.length; j++) {
                for (var i = 0; i < info_list.length; i++) {
                    var val = info_list[i];
                    if (lar[j] == val['id']) {
                        html.push('<span data-list=\'' + (fun.formatString(JSON.stringify(val))) + '\' class="font-ms label" style="background:' + val['colour'] + '">' + val['name'] + '</span>');
                    }
                }
            }


            $(".special").html(html.join(''));
            if ($('.label').length === 0) $('.sx_md,.special').hide();
            if ($('.label').length > 0) $('.sx_md,.special').show();
            if (typeof callback === 'function') callback();
        }
    });
}

// 删除当前纱线
function delGoods(params) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveGoods,
        data: $.extend({}, {
            "save_type": "delete",
            "id": params['id']
        }, params),
        success: function (res) {
            console.log(res);
            switch (res['status']) {
                case 0:
                    fun.toast('删除成功。');
                    fun.pageCloseFun({
                        refresh: true
                    });
                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                    break;
                case 103:
                    var proName = CP_INFO['info']['name'] ? CP_INFO['info']['number'] + ' ' + CP_INFO['info']['name'] : CP_INFO['info']['number'];
                    fun.dialog({
                        content: '【' + proName + '】已被调用，不允许删除。如果该纱线没有在经营，您可以使用：停用功能。',
                        btn: ['转为停用状态', '我知道了'],
                        yes: function () {
                            fun.ajax({
                                showLoad: true,
                                hideLoad: true,
                                url: AJAX_URL.saveGoods,
                                data: {
                                    "save_type": "delete",
                                    "is_has": true,
                                    "id": (params["id"] || [0]),
                                },
                                success: function (res) {
                                    if (res['status'] == 0) {
                                        fun.toast('修改成功。');
                                        fun.pageCloseFun({
                                            refresh: true
                                        });
                                        document.body.removeEventListener('touchmove', preventDefault, { passive: false })
                                    }
                                }
                            })
                        },
                        no: function () {
                            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                        }
                    });
                    break;
                default:
                    fun.toast('删除失败。');
            }
        }
    })
}

// 页面初始化
function init() {
    // 以防安卓系统点击input绝对定位不兼容问题
    fun.keyboardEject('.tool');
    fun.keyboardEject('.triangle');
    fun.showShade();

    getList();
    bindEvent(); // 初始化事件

    // 图片可左右滑动
    swiper = new Swiper('.swiper-container', {
        initialSlide: 0,
        centeredSlides: true,
        observer: true,
        observeParents: true,
    });
}

// 关闭当前窗口
function closeWin() {
    // api.sendEvent({
    //     name: return_page 
    //     extra: {

    //     }
    // });
    setTimeout(function () {
        api.closeWin({
            name: return_page
        })
    }, 200)
}

//  图片预览
function previewImg(showImgList) {

    if ($.nui.isEmpty(showImgList)) {
        return;
    }
    var index = $(this).data('index'); // 大图预览显示张数
    var img_arr = [];

    var large_arr = showImgList.split(',');
    for (var i = 0; i < large_arr.length; i++) {
        var item = large_arr[i];
        img_arr[i] = fun.getImgPath(item, true);
    }

    if ($.nui.isEmpty(img_arr)) return;
    photoBrowser.open({
        images: img_arr,
        activeIndex: index,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                swiper = new Swiper('.swiper-container', {
                    initialSlide: ret.index,
                    centeredSlides: true,
                    observer: true,
                    observeParents: true,
                    preventClicks: true, // 滑动时禁止点击事件
                });
                photoBrowser.close();
            }
        } else { }
    });
}

// 显示上架新纱线图标
function showNewIcon() {
    var nowDate = new Date().getTime(); // 当前时间
    var sj_sj = Date.parse((CP_INFO['info']['sj_sj'].replace(/-/g, '/'))); // 上架时间
    var minus = fun.toNumber(getOffsetDays(nowDate, sj_sj)); // 相隔的差值
    if (minus <= 30) { // 新纱线
        showIcon(true);
    }
}

// 显示new图标
function showIcon(mark) {
    if (mark) {
        $('#new').css({
            opacity: 1,
            visibility: 'visible'
        })
    } else {
        $('#new').css({
            opacity: 0,
            visibility: 'hidden'
        })
    }
}

// 事件初始化
function bindEvent() {
    // 点击图片可预览图片
    $('body').on('click', '.swiper-slide', function (e) {
        previewImg.call(this, CP_INFO['info']['imgs']);
    });

    // // 宝贝详情大图预览
    // $('body').on('tap', '#bbxq_img', function () {
    //     previewImg(CP_INFO['info']['bbxq']);
    // });

    // 设置顶部工具动画效果
    $(window).on('scroll', function () {
        // document.body.removeEventListener('touchmove', preventDefault, { passive: false });
        var topp = $(document).scrollTop();
        $('.triangle-tool').hide();
        if (topp > 250) {
            $('.tool').css({
                'animation': 'scroll250 0.4s ease-in forwards'
            })
        } else if (topp < 250 && topp > 150) {
            $('.tool').css({
                'animation': 'scroll150 0.4s ease-in forwards'
            })
        } else if (topp === 0) {
            $('.tool').css({
                'animation': 'scroll0 0.4s ease-in forwards'
            })
        }
    })

    // $(window).on('scroll', fun.throttle(lazyLoad, 200)); // 图片懒加载

    // 设置点击更多出现删除功能
    $('body').on('tap', '.more-iconfont', function (e) {
        // document.body.addEventListener('touchmove', preventDefault, { passive: false });
        e.stopPropagation();
        e.preventDefault();
        $('.triangle-tool').toggle();
    })

    // 删除当前纱线
    $('body').on('tap', '#shanchu', function (e) {
        e.stopPropagation();
        e.preventDefault();
        $('.triangle-tool').hide();
        var deleteMsg = CP_INFO['info']['name'] ? CP_INFO['info']['number'] + ' ' + CP_INFO['info']['name'] : CP_INFO['info']['number'];
        e.preventDefault();
        fun.dialog({
            content: '你确定要删除【' + deleteMsg + '】吗？',
            btn: ['确定', '取消'],
            success: function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false });
            },
            yes: function () {
                delGoods({
                    id: [page_data['goods_id']]
                });
                $('.triangle-tool').hide();
            },
            no: function () {
                $('.triangle-tool').hide();
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            }
        });
        return false;
    });

    // 颜色功能
    $('body').on('tap', '#color-edit', function () {
        fun.showLoad();
        $(CP_INFO['goods_colour']).each(function (_index, item) {
            item['_index'] = _index;
        })
        fun.showPageFull({
            page_url: page_arr.yarn_color,
            pageParam: {
                data: CP_INFO['goods_colour'],
                return_page: html_name,
                page_type: 'yarn_color',
                id: page_data['goods_id'],
                count_data: CP_INFO,
                type: 'product_view',
            }
        });
        fun.hideLoad();
    })

    // 返回
    $('#header_back').on('tap', function () {
        isDataChange();
    })

    // 底卡功能
    $('body').on('tap', '.bottom-card', function () {
        if (!IS_PAGE_EDIT && !CP_INFO['merchant_assistant'].length) return;
        fun.showLoad();
        var main_isTure = {     //判断该类型是否开启主要功能，给底卡编辑做记忆功能用
            'gys_isTure': 0,
        };
        if ($.nui.isEmpty(CP_INFO['merchant_assistant'])) {
            fun.showPageFull({
                page_url: page_arr.yarn_bottomcard_edit,
                pageParam: {
                    return_page: html_name,
                    page_type: 'yarn_bottomcard_edit',
                    type: 'add',
                    main_isTure: main_isTure,
                    color: CP_INFO['goods_colour'],
                    dw: getJjdw(CP_INFO['info']),
                    count_data: CP_INFO,
                    page_type: 'product_view_empty',
                    jjdw_id: getUnitId()
                }
            })

        } else {
            fun.showPageFull({
                page_url: page_arr.yarn_bottomcard,
                pageParam: {
                    id: page_data['goods_id'],
                    return_page: html_name,
                    page_type: 'yarn_bottomcard',
                    merchant_assistant: CP_INFO['merchant_assistant'],
                    color: CP_INFO['goods_colour'],
                    dw: getJjdw(CP_INFO['info']),
                    data: CP_INFO,
                    type: 'product_view',
                    jjdw_id: getUnitId()
                }
            })
        }
        fun.hideLoad();
    })

    // 编辑
    $('.bianji').on('tap', function () {
        //if ($.nui.isObjEquals(_origin_data, getSaveData())) { // 数据没发生改变
        fun.showLoad();
        setTimeout(function () {
            fun.showPageFull({
                page_url: page_arr.yarn_edit,
                pageParam: {
                    return_page: html_name,
                    opt: "edit",
                    id: page_data['goods_id']
                }
            });
            return fun.hideLoad();
        }, 200);
    })
}

// 防止没图片，数组里还有存在 '' 和 "" 和 null
function imgFormat(save_data, name) {
    var tempArr = [];
    $(save_data[name]).each(function (idx, item) {
        if ($.nui.isTrue(item)) {
            tempArr.push(item);
        }
    })
    return tempArr;
}

// 拿到保存数据
function getSaveData() {
    var info = CP_INFO['info'];
    // $(CP_INFO['goods_colour']).each(function (idx, item) {
    //     item['imgs'] = $.isArray(item['imgs']) ? item['imgs'] : [item['imgs']];
    // })

    if (info['unit_options'] && (typeof info['unit_options'] === 'string')) {
        info['unit_options'] = JSON.parse(info['unit_options']);
    }

    var jgValue = typeof info['jg_value'] === 'object' ? JSON.stringify(info['jg_value']) : info['jg_value'];

    var save_data = {
        save_type: 'save',
        id: info['id'],
        type: 'sx', // 类型
        date: info['date'], // 时间
        number: info['number'], // 编号
        name: info['name'], // 名称
        unit_id: info['unit_id'], // 单位id
        component: info['component'], // 成分
        diff: info['diff'], // 空差模式
        imgs: [], // 主图
        unit_options: info['unit_options'],
        class_id: info['class_id'],
        remark: info['remark'], // 备注
        label_id: info['label_id'], // 标签id
        is_stop: info['is_stop'], // 是否停用
        sx_jw: info['sx_jw'], //经纬
        craft: info['craft'], // 工艺
        brand: info['brand'], // 品牌
        area: info['area'], // 地区
        nature: info['nature'], //性质
        sx_ys: info['sx_ys'], // 预损
        sx_jz: info['sx_jz'], // 均重
        goods_colour: [], // 纱线颜色
        delete_colour: delete_list['colour_arr'], // 删除的纱线颜色
        goods_spec: CP_INFO['goods_spec'], // 规格
        delete_spec: [], // 删除的规格
        merchant_assistant: [], // 底卡信息
        delete_merchant_assistant: delete_list['fzxx_arr'], // 删除的底卡信息
        delete_colour_assistant: delete_list['fzxx_colouArr'] || [], //删除的底卡颜色信息
        goods_machining: CP_INFO['goods_machining'], // 加工
        delete_machining: [],
        delete_converter: [],
        delete_process: [],
        goods_craft: CP_INFO['goods_craft'], // 工艺
        delete_craft: [], // 删除工艺
        goods_param: CP_INFO['param'], // 其他参数
        goods_material: [],
        delete_material: [],
    };

    // 处理图片产生的空格
    save_data['imgs'] = imgFormat(save_data, 'imgs');
    save_data['bbxq'] = imgFormat(save_data, 'bbxq');
    save_data['color_card'] = imgFormat(save_data, 'color_card');

    $(CP_INFO['goods_colour']).each(function (idx, item) {
        // var tempArr = []
        // $(item['imgs']).each(function (sec, o) {
        //     if (o !== '' && o !== "" && o !== null) {
        //         tempArr.push(o);
        //     }
        // })
        // item['imgs'] = tempArr;
    })

    $(CP_INFO['merchant_assistant']).each(function (idx, item) {
        if (!('id' in item)) {
            item['id'] = 0;
        }
    })
    //字符串转数组
    $(CP_INFO['merchant_assistant']).each(function (idx, item) {
        if (!($.nui.isEmpty(item['imgs']))) {
            if (!($.isArray(item['imgs']))) {
                var imgs = item['imgs'];
                if (imgs.indexOf(',') > -1) {
                    item['imgs'] = imgs.split(',');
                } else {
                    if ($.nui.isEmpty(item['imgs'])) {
                        item['imgs'] = [];
                    } else {
                        var imgs_arr = [];
                        imgs_arr[0] = item['imgs'];
                        item['imgs'] = imgs_arr;
                    }
                }
            }
        } else {
            item['imgs'] = [];
        }
    })

    save_data['goods_colour'] = CP_INFO['goods_colour'];
    save_data['merchant_assistant'] = CP_INFO['merchant_assistant'];
    return save_data;
}

// 当前纱线是否是新纱线
function getOffsetDays(time1, time2) {
    var offsetTime = $.nui.decimalSub(time1, time2); // 相差时间
    return Math.floor(offsetTime / fun.getDateTimestamp());
}