var html_name = page_arr.Behavior_analysis;
// 搜索的数据
var search_data = {
    begin_time: fun.Date(fun.getLatelyTime(1, false)['begin_date']).Format('yy-mm-dd'),
    end_time: fun.Date(fun.getLatelyTime(1, false)['end_date']).Format('yy-mm-dd'),
    // rankType: 'sk', // 排行类型
    // groudType: 'date',
    cp: { // 产品搜索页面 
        id: '',
        text: ''
    }
};

//初始化
page_init = function () {

    //头部
    $('#header').header({
        back: true,
        title: '行为分析',
        // appendBackBtnEvt: isDataChange
    });

    // 头部适应
    $('.select').css({
        paddingTop: api.safeArea.top,
        marginTop: $('#header').height()
    })
    show_statistics();
}

//关闭日期插件
$('body').on('click', '.time_btn_click', function () {
    if ($(this).data('time') === 'custom') return;
    $('.time_background_brown').hide();
})

//切换
$('.statistics,.contrast').click(function () {
    if ($(this).hasClass('selected')) return;  //点击相同的时候
    $('.content').remove();
    $('.statistics,.contrast').removeClass('selected');
    $(this).addClass('selected');
    if ($('.statistics').hasClass('selected')) {
        show_statistics();
    } else {
        show_contrast();
    }
})

//切换成统计时的Echats
function show_statistics() {
    var logo_html = [];
    logo_html.push('<div class="content">');
    logo_html.push('  <div id="time_filter" class="time"></div>');
    logo_html.push('    <div class="box-statistics">');
    logo_html.push('      <div class="main-statistics"></div>');
    logo_html.push('      <div class="main-youhui">');
    logo_html.push('        <ul class="statistics_ul">');
    logo_html.push('          <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('          <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('          <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('          <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('          <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('          <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('          <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('          <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('        </ul>');
    logo_html.push('      </div>');
    logo_html.push('  </div>');
    logo_html.push('</div>');
    $('.select').after(logo_html.join(''));
    //图表
    var myChart = echarts.init($('.main-statistics')[0]);
    var data = [78, 60, 60, 70, 69, 52, 10, 99]
    var titlename = ['新客户到访', '老客户到访', '分享小店', '点赞小店', '查看产品', '2D试衣', '3D试衣', '跟进聊天'];
    var valdata = [683, 234, 234, 523, 345, 234, 523, 345]
    option = {
        backgroundColor: '#fff',
        xAxis: {
            show: false
        },
        grid: {
            left: '3%',
            right: '3%',
            bottom: '0%',
            top: '2%',
            containLabel: true
        },
        yAxis: [{
            show: true,
            data: titlename,
            inverse: true,
            axisLine: {
                show: false
            },
            splitLine: {
                show: false
            },
            axisTick: {
                show: false
            },
            axisLabel: {
                textStyle: {
                    color: "#000"
                },
                fontSize: 14,
                formatter: function (value, index) {
                    return [
                        '{title|' + value + '} '
                    ].join('\n')
                },
                rich: {}
            },

        }, {
            show: true,
            inverse: true,
            data: valdata,
            axisLabel: {
                textStyle: {
                    color: "#000"
                },
                fontSize: 14
            },
            axisLine: {
                show: false
            },
            splitLine: {
                show: false
            },
            axisTick: {
                show: false
            },

        }],
        series: [{
            name: '条',
            type: 'bar',
            yAxisIndex: 0,
            data: data,
            barWidth: 10,
            itemStyle: {
                normal: {
                    barBorderRadius: 30,
                    color: '#3D9CFA'
                }
            }
        }]
    };
    myChart.setOption(option);
    //时间组件
    $('#time_filter').time_filter({ // 时间筛选
        begin_time: search_data['begin_time'],//初始开始时间
        end_time: search_data['begin_time'],//初始结束时间
        time_class: 'filter_date',
        time_id: 'filter',
        type_shops: 'true',//全店
        type_shops_data: [
            { name: '全部', img: '../img/user.png' },
            { name: '商城', img: '' },
            { name: '店铺', img: '' },
            { name: '店铺', img: '' },
            { name: '大帆船', img: '' },
            { name: '都是', img: '' },
            { name: '想打', img: '' },
            { name: '大', img: '' },
            { name: '店铺', img: '' },
            { name: '店铺', img: '' },
            { name: '初中生自行车', img: '' },
            { name: '店铺', img: '' },
            { name: '想挨打', img: '' },
            { name: '店铺', img: '' },
            { name: '小册子吃', img: '' },
            { name: '店铺', img: '' },
            { name: 'vc', img: '' },
            { name: '店铺', img: '' },
            { name: '想法', img: '' },
            { name: '大多数', img: '' },
            { name: '店铺', img: '' },
            { name: '打撒', img: '' },
            { name: '', img: '' },
            { name: '店铺', img: '' },
            { name: '的出租车', img: '' },
            { name: '店铺', img: '' },
        ],
        dateText: function (ret) { //返回事件
            search_data['begin_time'] = fun.Date(ret['begin_time']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_time']).Format('yy-mm-dd');
        }
    });
    $('.whole-text').text('全部人');
}

var slow = true;
//切换成对比时的Echats
function show_contrast() {
    var logo_html = [];
    logo_html.push('<div class="content">');
    logo_html.push('  <p class="Behavior">行为对比</p>');
    logo_html.push('  <div id="time_filter" class="time"></div>');
    logo_html.push('  <div id="box" class="box">');
    logo_html.push('      <div class="choice"><ul class="contrast_ul">');
    logo_html.push('          <li class="contrast_li"><span class="view block-color-yellow"></span>');
    logo_html.push('          <span class="view-font">查看小店</span></li>');
    logo_html.push('          <li class="contrast_li"><span class="view block-color-red"></span>');
    logo_html.push('          <span class="view-font">分享小店</span></li>');
    logo_html.push('          <li class="contrast_li"><span class="view block-color-orange"></span>');
    logo_html.push('          <span class="view-font">点赞小店</span></li>');
    logo_html.push('          <li class="contrast_li"><span class="view block-color-pink"></span>');
    logo_html.push('          <span class="view-font">取消点赞</span></li>');
    logo_html.push('          <li class="contrast_li"><span class="view block-color-blue"></span>');
    logo_html.push('          <span class="view-font">保存手机</span></li>');
    logo_html.push('      </ul></div>');
    logo_html.push('      <div id="main" class="main"></div>');
    logo_html.push('  </div>');
    logo_html.push('  <p class="visitors">新增访客数</p>');
    logo_html.push('  <div id="time_filter2" class="time"></div>');
    logo_html.push('  <div id="box2" class="box">');
    logo_html.push('      <div class="choice"><ul class="contrast_ul">');
    logo_html.push('          <li class="con_li"><span class="view block-color-pink"></span>');
    logo_html.push('          <span class="view-font">陈奕迅</span></li>');
    logo_html.push('          <li class="con_li"><span class="view block-color-red"></span>');
    logo_html.push('          <span class="view-font">周润发</span></li>');
    logo_html.push('          <li class="con_li"><span class="view block-color-blue"></span>');
    logo_html.push('          <span class="view-font">彭于晏</span></li>');
    logo_html.push('      </ul></div>');
    logo_html.push('      <div id="main2" class="main"></div>');
    logo_html.push('  </div>');
    logo_html.push('</div>');
    $('.select').after(logo_html.join(''));
    var myChart = echarts.init($('#main')[0]); // echart折线图
    option = {
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                lineStyle: {
                    type: 'dashed',
                    color: '#ccc'
                }
            },
            position: function (pos, params, dom, rect, size) {
                return [pos[0], 0];
            },
            // trigger: 'none',
            // axisPointer: {
            //     type: 'cross',
            //     color: '#ccc'
            // },
            formatter: "{b}"
        },
        grid: {
            left: '6%',
            right: '6%',
            top: '3%',
            bottom: '10%',
            containLabel: true
        },
        xAxis: [{
            type: 'category', //数据类型为不连续数据
            boundaryGap: false, //坐标轴两边是否留白
            axisTick: {
                show: false
            },
            splitLine: {
                show: false
            },
            axisLine: {
                show: false
                // lineStyle: {
                //     color: "#aaa"
                // }
            },
            data: ['0', '5', '10', '15', '20', '25', '30', '35', '40', '45', '50', '55']
        }],
        yAxis: [{
            type: 'value',
            axisTick: {
                show: false
            },
            axisLabel: {
                show: false
            },
            axisLine: {
                show: false
                // lineStyle: {
                //     color: "#aaa"
                // }
            },
            splitLine: {
                show: false,
                // lineStyle: {
                //     type: 'dashed',
                //     color: '#aaa'
                // }
            },
            min: function (value) {
                return value.min;
            },
            max: function (value) {
                return value.max + 20;  //取最大值 + 最小值 * 20%
            }
        }],
        series: [{
            name: '移动',
            type: 'line',
            smooth: true,
            symbol: 'circle',
            symbolSize: 5,
            showSymbol: false,
            lineStyle: {
                normal: {
                    width: 1
                }
            },
            areaStyle: {
                normal: {
                    color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                        offset: 0,
                        color: 'rgba(137, 189, 27, 0.3)'
                    }, {
                        offset: 0.8,
                        color: 'rgba(137, 189, 27, 0)'
                    }], false),
                    shadowColor: 'rgba(0, 0, 0, 0.1)',
                    shadowBlur: 10
                }
            },
            itemStyle: {
                normal: {
                    color: 'rgb(137,189,27)',
                    borderColor: 'rgba(137,189,2,0.27)',
                    borderWidth: 12

                }
            },
            data: [100, 182, 191, 134, 150, 120, 110, 125, 145, 122, 165, 122]
        }, {
            name: '电信',
            type: 'line',
            smooth: true,
            symbol: 'circle',
            symbolSize: 5,
            showSymbol: false,
            lineStyle: {
                normal: {
                    width: 1
                }
            },
            areaStyle: {
                normal: {
                    color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                        offset: 0,
                        color: 'rgba(0, 136, 212, 0.3)'
                    }, {
                        offset: 0.8,
                        color: 'rgba(0, 136, 212, 0)'
                    }], false),
                    shadowColor: 'rgba(0, 0, 0, 0.1)',
                    shadowBlur: 10
                }
            },
            itemStyle: {
                normal: {
                    color: 'rgb(0,136,212)',
                    borderColor: 'rgba(0,136,212,0.2)',
                    borderWidth: 12

                }
            },
            data: [120, 110, 125, 145, 122, 165, 122, 220, 182, 191, 134, 150]
        }, {
            name: '联通',
            type: 'line',
            smooth: true,
            symbol: 'circle',
            symbolSize: 5,
            showSymbol: false,
            lineStyle: {
                normal: {
                    width: 1
                }
            },
            areaStyle: {
                normal: {
                    color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                        offset: 0,
                        color: 'rgba(219, 50, 51, 0.3)'
                    }, {
                        offset: 0.8,
                        color: 'rgba(219, 50, 51, 0)'
                    }], false),
                    shadowColor: 'rgba(0, 0, 0, 0.1)',
                    shadowBlur: 10
                }
            },
            itemStyle: {
                normal: {

                    color: 'rgb(219,50,51)',
                    borderColor: 'rgba(219,50,51,0.2)',
                    borderWidth: 12
                }
            },
            data: [220, 182, 125, 145, 122, 191, 134, 150, 120, 110, 165, 122]
        },]
    };
    if (option && typeof option === "object") {
        myChart.setOption(option, true);
        myChart.getZr().on('click', function (params) {
            var pointInPixel = [params.offsetX, params.offsetY];
            if (myChart.containPixel('grid', pointInPixel)) {
                /*此处添加具体执行代码*/
                var pointInGrid = myChart.convertFromPixel({ seriesIndex: 0 }, pointInPixel);
                //X轴序号
                var xIndex = pointInGrid[0];
                //获取当前图表的option
                var op = myChart.getOption();
                //获得图表的数据
                var value = op.series[0].data[xIndex];
                var value2 = op.series[1].data[xIndex];
                var value3 = op.series[2].data[xIndex];
                $('#zcp').text(value || 0);
                $('#zrs').text(value2 || 0);
                $('#zcs').text(value3 || 0);
            }
        });
        myChart.getZr().on('mousemove', function (params) {
            var pointInPixel = [params.offsetX, params.offsetY];
            if (myChart.containPixel('grid', pointInPixel)) {
                /*此处添加具体执行代码*/
                var pointInGrid = myChart.convertFromPixel({ seriesIndex: 0 }, pointInPixel);
                //X轴序号
                var xIndex = pointInGrid[0];
                //获取当前图表的option
                var op = myChart.getOption();
                //获得图表的数据
                var value = op.series[0].data[xIndex];
                var value2 = op.series[1].data[xIndex];
                var value3 = op.series[2].data[xIndex];
                $('#zcp').text(value);
                $('#zrs').text(value2);
                $('#zcs').text(value3);
            }
        });
        // myChart.dispatchAction({
        //     type: 'highlight',
        //     // 可选，系列 index，可以是一个数组指定多个系列
        //     // seriesIndex: ['0', '5', '10', '15', '20', '25', '30', '35', '40', '45', '50', '55'],
        //     // 可选，系列名称，可以是一个数组指定多个系列
        //     // seriesName: ['移动','电信','联通'],
        //     // 可选，数据的 index
        //     dataIndex: 11,
        //     // 可选，数据的 名称
        //     // name: '55'
        // });
    }

    var myChart = echarts.init($('#main2')[0]); // echart折线图
    option = {
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                lineStyle: {
                    type: 'dashed',
                    color: '#ccc'
                }
            },
            position: function (pos, params, dom, rect, size) {
                return [pos[0], 0];
            },
            // trigger: 'none',
            // axisPointer: {
            //     type: 'cross',
            //     color: '#ccc'
            // },
            formatter: "{b}"
        },
        grid: {
            left: '6%',
            right: '6%',
            top: '3%',
            bottom: '10%',
            containLabel: true
        },
        xAxis: [{
            type: 'category', //数据类型为不连续数据
            boundaryGap: false, //坐标轴两边是否留白
            axisTick: {
                show: false
            },
            splitLine: {
                show: false
            },
            axisLine: {
                show: false
                // lineStyle: {
                //     color: "#aaa"
                // }
            },
            data: ['0', '5', '10', '15', '20', '25', '30', '35', '40', '45', '50', '55']
        }],
        yAxis: [{
            type: 'value',
            axisTick: {
                show: false
            },
            axisLabel: {
                show: false
            },
            axisLine: {
                show: false
                // lineStyle: {
                //     color: "#aaa"
                // }
            },
            splitLine: {
                show: false,
                // lineStyle: {
                //     type: 'dashed',
                //     color: '#aaa'
                // }
            },
            min: function (value) {
                return value.min;
            },
            max: function (value) {
                return value.max + 20;  //取最大值 + 最小值 * 20%
            }
        }],
        series: [{
            name: '移动',
            type: 'line',
            smooth: true,
            symbol: 'circle',
            symbolSize: 5,
            showSymbol: false,
            lineStyle: {
                normal: {
                    width: 1
                }
            },
            areaStyle: {
                normal: {
                    color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                        offset: 0,
                        color: 'rgba(137, 189, 27, 0.3)'
                    }, {
                        offset: 0.8,
                        color: 'rgba(137, 189, 27, 0)'
                    }], false),
                    shadowColor: 'rgba(0, 0, 0, 0.1)',
                    shadowBlur: 10
                }
            },
            itemStyle: {
                normal: {
                    color: 'rgb(137,189,27)',
                    borderColor: 'rgba(137,189,2,0.27)',
                    borderWidth: 12

                }
            },
            data: [100, 182, 191, 134, 150, 120, 110, 125, 145, 122, 165, 122]
        }, {
            name: '电信',
            type: 'line',
            smooth: true,
            symbol: 'circle',
            symbolSize: 5,
            showSymbol: false,
            lineStyle: {
                normal: {
                    width: 1
                }
            },
            areaStyle: {
                normal: {
                    color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                        offset: 0,
                        color: 'rgba(0, 136, 212, 0.3)'
                    }, {
                        offset: 0.8,
                        color: 'rgba(0, 136, 212, 0)'
                    }], false),
                    shadowColor: 'rgba(0, 0, 0, 0.1)',
                    shadowBlur: 10
                }
            },
            itemStyle: {
                normal: {
                    color: 'rgb(0,136,212)',
                    borderColor: 'rgba(0,136,212,0.2)',
                    borderWidth: 12

                }
            },
            data: [120, 110, 125, 145, 122, 165, 122, 220, 182, 191, 134, 150]
        }, {
            name: '联通',
            type: 'line',
            smooth: true,
            symbol: 'circle',
            symbolSize: 5,
            showSymbol: false,
            lineStyle: {
                normal: {
                    width: 1
                }
            },
            areaStyle: {
                normal: {
                    color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                        offset: 0,
                        color: 'rgba(219, 50, 51, 0.3)'
                    }, {
                        offset: 0.8,
                        color: 'rgba(219, 50, 51, 0)'
                    }], false),
                    shadowColor: 'rgba(0, 0, 0, 0.1)',
                    shadowBlur: 10
                }
            },
            itemStyle: {
                normal: {

                    color: 'rgb(219,50,51)',
                    borderColor: 'rgba(219,50,51,0.2)',
                    borderWidth: 12
                }
            },
            data: [220, 182, 125, 145, 122, 191, 134, 150, 120, 110, 165, 122]
        },]
    };
    if (option && typeof option === "object") {
        myChart.setOption(option, true);
        myChart.getZr().on('click', function (params) {
            var pointInPixel = [params.offsetX, params.offsetY];
            if (myChart.containPixel('grid', pointInPixel)) {
                /*此处添加具体执行代码*/
                var pointInGrid = myChart.convertFromPixel({ seriesIndex: 0 }, pointInPixel);
                //X轴序号
                var xIndex = pointInGrid[0];
                //获取当前图表的option
                var op = myChart.getOption();
                //获得图表的数据
                var value = op.series[0].data[xIndex];
                var value2 = op.series[1].data[xIndex];
                var value3 = op.series[2].data[xIndex];
                $('#zcp').text(value || 0);
                $('#zrs').text(value2 || 0);
                $('#zcs').text(value3 || 0);
            }
        });
        myChart.getZr().on('mousemove', function (params) {
            var pointInPixel = [params.offsetX, params.offsetY];
            if (myChart.containPixel('grid', pointInPixel)) {
                /*此处添加具体执行代码*/
                var pointInGrid = myChart.convertFromPixel({ seriesIndex: 0 }, pointInPixel);
                //X轴序号
                var xIndex = pointInGrid[0];
                //获取当前图表的option
                var op = myChart.getOption();
                //获得图表的数据
                var value = op.series[0].data[xIndex];
                var value2 = op.series[1].data[xIndex];
                var value3 = op.series[2].data[xIndex];
                $('#zcp').text(value);
                $('#zrs').text(value2);
                $('#zcs').text(value3);
            }
        });
        // myChart.dispatchAction({
        //     type: 'highlight',
        //     // 可选，系列 index，可以是一个数组指定多个系列
        //     // seriesIndex: ['0', '5', '10', '15', '20', '25', '30', '35', '40', '45', '50', '55'],
        //     // 可选，系列名称，可以是一个数组指定多个系列
        //     // seriesName: ['移动','电信','联通'],
        //     // 可选，数据的 index
        //     dataIndex: 11,
        //     // 可选，数据的 名称
        //     // name: '55'
        // });
    }
    $('#time_filter').time_filter({ // 时间筛选
        bool: true,
        isBehavior: true,
        height: $('.select').outerHeight(true) + $('#time_filter').outerHeight(true),
        time_class: 'filter_date1',
        time_id: 'time_filter11',
        time1: 'time2',
        begin_time: search_data['begin_time'],//初始开始时间
        end_time: search_data['begin_time'],//初始结束时间
        isBehavior_data: [//类型弹窗数据
            { name: '新客户到访',active: true},
            { name: '老客户到访',active: true},
            { name: '分享小店'},
            { name: '点赞小店'},
            { name: '查看小店',active: true},
            { name: '2D试衣'},
            { name: '3D试衣'},
            { name: '跟进聊天',active: true}
        ],
        type_shops: 'true',//全店
        type_shops_data: [
            { name: '全部', img: '../img/user.png' },
            { name: '商城', img: '' },
            { name: '店铺', img: '' },
            { name: '店铺', img: '' },
            { name: '大帆船', img: '' },
            { name: '都是', img: '' },
            { name: '想打', img: '' },
            { name: '大', img: '' },
            { name: '店铺', img: '' },
            { name: '店铺', img: '' },
            { name: '初中生自行车', img: '' },
            { name: '店铺', img: '' },
            { name: '想挨打', img: '' },
            { name: '店铺', img: '' },
            { name: '小册子吃', img: '' },
            { name: '店铺', img: '' },
            { name: 'vc', img: '' },
            { name: '店铺', img: '' },
            { name: '想法', img: '' },
            { name: '大多数', img: '' },
            { name: '店铺', img: '' },
            { name: '打撒', img: '' },
            { name: '', img: '' },
            { name: '店铺', img: '' },
            { name: '的出租车', img: '' },
            { name: '店铺', img: '' },
        ],
        dateText: function (ret) { //返回事件
            search_data['begin_time'] = fun.Date(ret['begin_time']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_time']).Format('yy-mm-dd');
            // $('#order_list').empty();
            // fun.statisticDate(search_data);
            // getList();
        }
    });
    $('#time_filter2').time_filter({ // 时间筛选
        'time_id': 'time_filter12',
        'customTime': 'time1',
        height: $('.select').outerHeight(true) 
                + $('#time_filter').outerHeight(true) 
                + $('.Behavior').outerHeight(true) 
                + $('#box').outerHeight(true) 
                + $('#time_filter2').outerHeight(true),
        begin_time: search_data['begin_time'],//初始开始时间
        end_time: search_data['begin_time'],//初始结束时间
        time_class: 'filter_date2',
        type_shops: 'true',//全店
        type_shops_data: [
            { name: '全部', img: '../img/user.png' },
            { name: '商城', img: '' },
            { name: '店铺', img: '' },
            { name: '店铺', img: '' },
            { name: '大帆船', img: '' },
            { name: '都是', img: '' },
            { name: '想打', img: '' },
            { name: '大', img: '' },
            { name: '店铺', img: '' },
            { name: '店铺', img: '' },
            { name: '店铺', img: '' },
            { name: '店铺', img: '' },
        ],
        dateText: function (ret) { //返回事件
            search_data['begin_time'] = fun.Date(ret['begin_time']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_time']).Format('yy-mm-dd');

        }
    });
}

