var html_name = page_arr.account_admin;
var page_list = [];
// $('#header').header({
//     back: true,
//     add: true,
//     title: '子帐号设置'
//     // foot_input: {
//     //     show: true,
//     //     plader: '搜索账号'
//     // },
// });

page_init = function(){
    $('#header').header({
        back: true,
        add: Auth.check('zhgl','edit'),
        title: '子帐号设置'
        // foot_input: {
        //     show: true,
        //     plader: '搜索账号'
        // },
    });
    getList();
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            return fun.createBottomLine('account_list', ".center-list");
        }
    });

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
            if(temp['status'] == "refresh"){
                $('#account_list').empty();
                getList();
            }
    });

}

function getList(){
    fun.ajax({
		showLoad:true,
		hideLoad:true,
		url:AJAX_URL.getUserList,
		data:{
            "is_stop":0,
            "account_id":(fun.getItem('account_info')['account_id'] || 0),
            no_self: 1,//不允许查看自身权限，避免子账号自己改权限
		},
		success:function(res){
		    $('#account_list').empty();
			if(res['status'] == 0){
                if(res['data'].length == 0){
                    page_list = [];
                    // return $('#account_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#account_list',btnText:'新增子帐号',style:'top:-1rem;',bottomText:'可点击右上角：+ 进行快速建子帐号。'});
                }
                page_list = res['data'];
                showList(fun.PagingData(page_list));
			}
		}
	})
}

function deleteList(id){
    var del_id = (id || 0);
    fun.ajax({
		showLoad:true,
		hideLoad:true,
		url:AJAX_URL.saveUser,
		data:{
            "id":[del_id],
            "save_type":"delete"
		},
		success:function(res){
			if(res['status'] == 0){
                getList();
                fun.toast("删除成功！");
			}
		}
	})
}

function showList(data){
    var html = [];
    $(data).each(function(i,obj){
        var colour = order_color[i % order_color.length];
        html.push('<li account_id="'+(obj['account_id'] || 0)+'" name="'+fun.is_value(obj['name'])+'" class="center-list lower-border-line">');
        html.push('     <div class="le">');
        html.push('      <div class="eidt">');
        html.push('           <div class="name-radius" style="background-color:'+colour+'">');
        if(!!obj['imgs']){
            html.push('<img src="'+fun.getImgPath(obj['imgs'])+'" />');
        }else{
            html.push(fun.getLastName(obj['name'] || ""));
        }
        html.push('</div>');
        html.push('           <div class="account-info">');
        html.push('               <div class="account-name">'+fun.is_value(obj['name'])+'</div>');
        html.push('                   <div class="account-mobile">'+fun.is_value(obj['account'])+'</div>');
        html.push('               </div>');
        html.push('               <i class="iconfont icon-youfanhui arrow"></i>');
        html.push('     </div>');
        html.push('<div class="delete dels1 delete-btn">删除</div>');
        html.push('</div>');
        html.push('</li>');
    })
    $('#account_list').append(html.join(''));


    if(!Auth.check('zhgl','edit')) {
        $('.swipe-delete').removeClass('swipe-delete');
    }
}

//删除
$('body').on('tap','.delete-btn',function(e){
    e.preventDefault();
    var del_id = $(this).parents('.center-list').attr('account_id'),
        row_name = $(this).parents('.center-list').find('.account-name').text() || "此账户";
        fun.dialog({
            content: "你确定要删除【"+row_name+"】吗？",
            btn: ['删除', '取消'],
            yes: function () {
                deleteList(del_id);
            }
        });
    return false;
});

$('body').on('tap','#add_btn,.center-list',function(){
    fun.showPageFull ({
        page_url: page_arr.account_edit,
        pageParam: {
            return_page:html_name,
            name:$(this).attr('name') || "",
            account_id:($(this).attr('account_id') || 0)
        }
    });
})
