var html_name = page_arr.account_edit;

var AUTH_EDIT = Auth.check('zhgl', 'edit');

page_init = function () {
    getList();
    fun.keyboardEject('.button');
    //监听返回
    // page_data['keyback'] = isDataChange;
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'] || {},
            data = temp['data'] || {},
            list_data = data['list_data'] || {};
        if (temp['status'] == "select_list") {
            $('#name').val(data['select_val'] || "");
            $('#name').attr('staff_id', data['id'] || 0);
            $('#store_name').val((list_data['store'] || ""));
            $('#store_name').attr('store_id', (list_data['store_id'] || 0));
        }
    });
    $('#header').header({
        back: true,
        title: '帐号管理',
        del: AUTH_EDIT && ((page_data['account_id'] != 0) ? true : false),
        // appendBackBtnEvt: isDataChange
    });

    if (!AUTH_EDIT) {
        $('input,#salesman').attr('disabled', true);
        $('.sub').hide();
    }

    //iphoneX
    $('.fit-list').css('margin-bottom', api.safeArea.bottom + 'px')
    $('.sub').css('padding-bottom', api.safeArea.bottom + 'px')
}

//点击业务员字眼
$('.salesman').on('tap', function () {
    if ($(this).attr('disabled')) return;
    if ($('#salesman').hasClass('check-choice')) {
        $('#salesman').removeClass('check-choice');
    } else {
        $('#salesman').addClass('check-choice');
    }
})

function isDataChange() {
    // save_data = getSaveData();
    // if (!$.nui.isObjEquals(origin_data, save_data)) {
    //     // if(account_exist=='账户已存在'){return api.closePage();}
    //     if($('body').find('.data-change-skin').length) return;
    //     fun.dialog({
    //         content: '您确定要保存吗？',
    //         btn: ['保存', '不保存', '取消'],
    //         shadeClose: false,
    //         className: 'data-change-skin',
    //         yes: function () {
    //             saveData();
    //         },
    //         no: function () {
    //             setTimeout(function () {
    //                 api.closeWin();
    //             }, 1000);
    //         }
    //     });
    // } else {
    //     setTimeout(function () {
    //         api.closeWin();
    //     }, 1000);
    // }
}

//获取数据
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getUserInfo,
        data: {
            "account_id": (page_data['account_id'] || 0),
            "type": "user"
        },
        success: function (res) {
            // log(res['data']['mobile_authority']);
            if (res['status'] == 0) {
                var temp_data = res['data'];
                addAuthority(temp_data['mobile_authority']);
                if (temp_data.length != 0) {
                    if(page_data['account_id'] != 0){
                        showData(temp_data);
                    }else{
                        var book_list = fun.getItem('account_set_data');
                        for(var i = 0;i < book_list.length;i++){
                            if(book_list[i]['is_default']){
                                $('#book').val(book_list[i]['name'] || '').attr('book_id',book_list[i]['book_id'] || 0);
                            }
                        }
                    }
                }
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}

//保存数据
function saveList(param) {
    var result = $.extend({}, {
        "id": 0,
        "save_type": "save",
        "staff_id": 0,
        "account": "",
        "name": "",
        "pwd": "",
        "is_employe": 0,
        "store_id": 0,
        "remark": "",
        "book_id": "0",
        "is_bills_admin": 0,
        "admin_pwd": "",
        "authority": [],
        "bills_authority": []
    }, param);

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveUser,
        data: result,
        success: function (res) {

            switch (res['status']) {
                case 0:
                    if (result['save_type'] == "save") {
                        fun.toast('保存成功！');
                    } else {
                        fun.toast('删除成功！');
                    }
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh'
                        }
                    });
                    setTimeout(function () {
                        api.closeWin();
                    }, 1000);
                    break;
                case 100:
                    fun.toast('账号不能为空！');
                    break;
                case 104:
                    fun.toast('账号已存在！');
                    break;
                default:
                    fun.toast('保存失败！');
                    break;
            }
        }
    })
}

function showData(params) {
    $('#name').val((params['name'] || ""));
    $('#name').attr('staff_id', params['staff_id'] || "");
    $('#pwd').val((params['pwd'] || ""));
    $('#account').val((params['account'] || ""));
    $('#account').attr("account_id", (params['account_id'] || ""));
    $('#store_name').val((params['store_name'] || ""));
    $('#store_name').attr('store_id', (params['store_id'] || 0));
    $('#book').val((params['book'] || ""));
    $('#book').attr('book_id', (params['book_id'] || ""));
    params['is_employe'] == 1 && $('#salesman').addClass('check-choice');
    getBookList(true);
}

//获取账本列表
function getBookList(show_book) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.Book,
        data: {
            type: 'getBook',
            company_id: (fun.getItem('company_info') ? fun.getItem('company_info')['company_id'] : 0),
            account_id: (fun.getItem('user_info') ? fun.getItem('user_info')['account_id'] : 0),
            is_admin: (fun.getItem('user_info') ? fun.getItem('user_info')['is_admin'] : 0)
        },
        success: function (res) {
            if (res['status'] == 0) {
                var str = $('#book').attr('book_id') || "",
                    book_id = str.split(','),
                    book_data = res['data'] || [],
                    temp_val = [];
                $(book_data).each(function (i, obj) {
                    if (book_id.indexOf(String(obj['id'])) > -1) {
                        obj['is_choose'] = 1;
                        if (show_book) {
                            temp_val.push(obj['name']);
                            return $('#book').val(temp_val.join());
                        }
                    }
                })
                if (!show_book) {
                    fun.showBookList({
                        width: '280px',
                        shadeClose: false,
                        checkbox: true,
                        list: book_data,
                        choose: function (choose_arr) {
                            var id_arr = [],
                                name_arr = [];
                            $(choose_arr).each(function (k, arr) {
                                id_arr.push(arr['id']);
                                name_arr.push(arr['name']);
                            })
                            $('#book').attr('book_id', id_arr.join(',')).val(name_arr.join(','));
                        }
                    })
                }
            }
        }
    })
}

//添加权限
function addAuthority(arr) {
    if (!arr) {
        return;
    }
    var key = {};

    $(arr).each(function (i, array) {
        //暂时隐藏消息相关权限
        if (array['type'] == "xiaoxi") {
            return;
        }


        function setDisplay(array){
            if (array['name'] == 'bp_xsfhjs') array['display'] = '销售 销售开单';
            else if (array['name'] == 'bp_xsthjs') array['display'] = '销售 销售退单';
            else if (array['name'] == 'bp_hdb') array['display'] = '库存 进销存表';
            else if (array['name'] == 'bp_kc') array['display'] = '库存 布匹库存';
            else if (array['name'] == 'sx_kc') array['display'] = '库存 纱线库存';
            else if (array['name'] == 'gsxx') array['display'] = '店铺信息';
            else if (array['name'] == 'khgl') array['display'] = '跟进管理';
            else if (array['name'] == 'cw_mlb') array['display'] = !AuthVersionCheck.checkHide('ycsx') ? '布/毛利表' : '毛利表';
        }

        if (!key[array['type']]) {
            key[array['type']] = [];
            setDisplay(array);
            key[array['type']].push(array);
        } else {
            // if (array['name'] == 'bp_xsfhjs') array['display'] = '销售 销售开单';
            // else if (array['name'] == 'bp_xsthjs') array['display'] = '销售 销售退单';
            // else if (array['name'] == 'bp_hdb') array['display'] = '库存 进销存表';
            // else if (array['name'] == 'bp_kc') array['display'] = '库存 布匹库存';
            // else if (array['name'] == 'sx_kc') array['display'] = '库存 纱线库存';
            // else if (array['name'] == 'cw_mlb') array['display'] = !AuthVersionCheck.checkHide('ycsx') ? '布/毛利表' : '毛利表';
            setDisplay(array);
            key[array['type']].push(array);
        }
    })
    createHtml(key);
    function createHtml(key) {
        var shopArr = [];
        var style = [];
        $.each(key, function (k, obj) {
            var list_tile = "";
            // if(k=='shaxian') return true;
            switch (k) {
                case "xiaoxi":
                    list_tile = "消息";
                    break;
                case "fenxi":
                    list_tile = "分析";
                    break;
                case "bupi":
                    list_tile = "布匹";
                    break;
                case "shaxian":
                    list_tile = "纱线";
                    break;
                case "caiwu":
                    list_tile = "财务";
                    break;
                case "jichu":
                    list_tile = "基础";
                    break;
                case "wode":
                    list_tile = "我的";
                    break;
                case "qita":
                    list_tile = "其它";
                    break;
                case "dingdan":
                    list_tile = "订单";
                    break;
                case "dianpu":
                    list_tile = "店铺";
                    break;
            }
            var status = ((k == "xiaoxi" || k == "fenxi") ? 0 : 1);

            // 循环判断取出基础模块相同权限的，加进店铺模块
            // $(obj).each(function (s, list) {
            //     if (k === 'jichu') {
            //         if (list['name'] === 'cp' || list['name'] === 'kh') {
            //             shopArr.push(list);
            //         }
            //     }
            // })

            // if (k === 'dianpu') { // 店铺前端检查权限
            //     obj.unshift(shopArr[0]);
            //     for (var i = 0; i < obj.length; i++) {
            //         var item = obj[i];
            //         if (item['name'] === 'cplb') { // 产品类别
            //             obj.splice(i + 1, 0, shopArr[1]);
            //             break;
            //         } else {
            //             continue;
            //         }
            //     }
            // }

            var eidt_class = checkAuth(obj, 'edit') ? "nui-active" : '',
                view_class = checkAuth(obj, 'view') ? "nui-active" : '';

            style.push('<li type="' + k + '" data-row=\'' + fun.formatString(JSON.stringify(obj[0])) + '\' class="list-item2">');
            style.push('    <span class="info1"></span>');
            style.push('    <span class="text">' + list_tile + '</span>');
            style.push('        <div class="switch">');
            if (k == "jichu" || k == "caiwu" || k == "shaxian" || k == "bupi" || k == "wode" || k === 'dianpu' || k === 'dingdan') {
                style.push('            <span class="switch-title">修改</span>');
                style.push('                <div authority="edit" parent="' + status + '" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + eidt_class + '" name="' + obj['name'] + '">');
                style.push('                    <div class="nui-switch-handle"></div>');
                style.push('                </div>');
            }
            style.push('            <span class="switch-title">浏览</span>');
            style.push('                <div authority="view" parent="' + status + '" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + view_class + '" name="' + obj['name'] + '">');
            style.push('                    <div class="nui-switch-handle"></div>');
            style.push('                </div>');
            style.push('                <i class="iconfont icon-xia right ' + ((obj[0]['type'] == "xiaoxi" || obj[0]['type'] == "fenxi") ? "hide-icon" : "") + '" id="open"></i>');
            style.push('      </div>');
            style.push('</li>');
            style.push('        <div class="list-item2-wrap">');
            $(obj).each(function (y, row) {
                if (row['type'] === "xiaoxi" || row['type'] === "fenxi") {
                    return;
                }
                var power = {
                    "edit": ((row['edit'] === 1) ? "nui-active" : ""),        //修改
                    "view": ((row['view'] === 1) ? "nui-active" : ""),        //浏览
                    "check": ((row['check'] === 1) ? "nui-active" : ""),      //审核
                    "recheck": ((row['recheck'] === 1) ? "nui-active" : ""),      //复核
                    "invalid": ((row['invalid'] === 1) ? "nui-active" : ""),  //作废
                    "settle": ((row['settle'] === 1) ? "nui-active" : "")     //结单
                };
                // var bill = ["bp_cgdd", "bp_xsdd", "bp_wwjg"];//显示结单
                // var order = ["bp_cgdd", "bp_xsdd", "bp_wwjg", "bp_cgfx", "bp_xscpfx", "bp_xskhfx",
                //     "bp_xsnyfx", "bp_xsfx", "bp_jgfx", "bp_ybfx", "bp_xsmbyj", "bp_xsbfjl", "cw_dxzd",
                //     "cw_xjyhdzb", "cw_dzb_kh", "cw_dzb_gys", "cw_dzb_jgs", "cw_dzb_wl", "cw_rbb",
                //     "cw_ybb", "cw_mlb", "kc_tmcx", "bp_hdb", "bp_kc", "bp_ckc", "bp_xsdjcx"];//不显示审核作废

                //显示作废审核
                var showShZf = [
                    'bp_cglhjs', 'bp_cgthjs', 'bp_cgbj',
                    'bp_xsfhjs', 'bp_xsthjs', 'bp_xsbj',
                    'kc_bppyd', 'kc_bpmxpkd', 'kc_bptbd', 'kc_bpzspd',
                    'cw_skd', 'cw_fkd', 'cw_fyd', 'cw_srd', 'cw_ywtz', 'cw_nbzz'
                ];

                //显示订金审核
                var showDJSH = ['bp_xsdd'];
                //显示复核
                var showFH = ['bp_xsdd', 'bp_cgdd'];

                //显示修改
                var showXg = showShZf.concat(['bp_cgdd', 'bp_xsdd', 'bp_wwjg']);
                var shopChild = ['cp', 'cplb', 'kh', 'fs']; // 店铺有修改权限


                // 显示纱线修改
                var showSxXg = ['sx_cgdd', 'sx_xsdd', 'sx_wwjg', 'sx_xzd'];

                style.push('            <div class="list-item3" data-row=\'' + fun.formatString(JSON.stringify(row)) + '\'>');
                style.push('                <span class="text">' + fun.is_value(row['display']) + '</span>');
                // style.push('                <span class="title">'+fun.is_value(row['display'])+'</span>');
                style.push('                <div class="switch">');
                // 2019-12-27 新增店铺权限
                if (showSxXg.indexOf(row['name']) > -1 || k == "jichu" || k == "wode" || (showXg.indexOf(row['name']) > -1 && (k == "caiwu" || k == "bupi")) || (k === 'dianpu' && shopChild.indexOf(row['name']) > -1 || k === 'dingdan')) {
                    if(row['name'] != 'zh_xsck'){
                        style.push('                    <span class="switch-title">修改</span>');
                        style.push('                        <div authority="edit" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + power['edit'] + '" name="' + row['name'] + '">');
                        style.push('                            <div class="nui-switch-handle"></div>');
                        style.push('                        </div>');
                    }
                }
                style.push('                    <span class="switch-title">浏览</span>');
                style.push('                        <div authority="view" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + power['view'] + '" name="' + row['name'] + '">');
                style.push('                            <div class="nui-switch-handle"></div>');
                style.push('                        </div>');
                style.push('                </div>');
                style.push('                <div class="switch">');

                if (showShZf.indexOf(row['name']) > -1 && obj[0]['type'] != "qita" && obj[0]['type'] != "jichu" && obj[0]['type'] != 'wode') {
                    style.push('                    <span class="switch-title">审核</span>');
                    style.push('                        <div authority="check" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + power['check'] + '" name="' + row['name'] + '">');
                    style.push('                            <div class="nui-switch-handle"></div>');
                    style.push('                        </div>');
                    style.push('                    <span class="switch-title">作废</span>');
                    style.push('                        <div authority="invalid" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + power['invalid'] + '" name="' + row['name'] + '">');
                    style.push('                            <div class="nui-switch-handle"></div>');
                    style.push('                        </div>');
                }

                if (showDJSH.indexOf(row['name']) > -1) {
                    style.push('                    <span class="switch-title">审核</span>');
                    style.push('                        <div authority="check" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + power['check'] + '" name="' + row['name'] + '">');
                    style.push('                            <div class="nui-switch-handle"></div>');
                    style.push('                        </div>');
                }
                if (showFH.indexOf(row['name']) > -1) {
                    style.push('                    <span class="switch-title">复核</span>');
                    style.push('                        <div authority="recheck" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + power['recheck'] + '" name="' + row['name'] + '">');
                    style.push('                            <div class="nui-switch-handle"></div>');
                    style.push('                        </div>');
                }

                var showJd = ['bp_cgdd', 'bp_xsdd'];
                if (showJd.indexOf(row['name']) > -1) {
                    style.push('                    <span class="switch-title">结单</span>');
                    style.push('                        <div authority="settle" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + power['settle'] + '" name="' + row['name'] + '">');
                    style.push('                            <div class="nui-switch-handle"></div>');
                    style.push('                        </div>');
                }
                style.push('                </div>');
                style.push('            </div>');
            })
            style.push('        </div>');
        })
        $('.fit-list').append(style.join(''));
        bindEvent();

        if (!AUTH_EDIT) {
            $('.nui-switch').attr('disabled', true);
        }
    }
}

// 绑定开关事件
function bindEvent() {
    $('body').on('tap', '.nui-switch', function () {
        var key = $(this).attr('authority'); // 当前权限名称
        var type; // 当前模块名称
        if ($(this).attr('parent')) {
            var authType; // 当前点击权限类型
            type = $(this).parents('.list-item2').attr('type');
            var auth = $(this).attr('authority');
            switch (auth) {
                case 'view':
                    authType = 'view';
                    break;
                case 'edit':
                    authType = 'edit';
                    break;
            }

            if ($(this).hasClass('nui-active')) { // 开启
                allSwitch(type, auth)[authType].open(); // 批量开启
            } else { // 关闭
                allSwitch(type, auth)[authType].close(); // 批量关闭
            }

            syncModule.call(this, {
                auth: auth,
                type: type
            })

        } else {
            type = $(this).parents('.list-item2-wrap').prev().attr('type');
            var auth = $(this).attr('authority');
            var name = $(this).attr('name');

            var param = {
                key: key, // 权限名称
                auth: auth, // 权限名称
                type: type, // 模块名称
                name: name // 子模块名称
            }

            singleSwitch.call(this, param);
            singleEdit.call(this, param);

            // 设置权限数据
        }
    })

    //选择账本
    $('#book').on('click', function (e) {
        e.preventDefault();
        e.stopPropagation();
        if ($(this).attr('disabled')) return;
        getBookList();
        return false;
    });

    //选择员工
    $('#staff').on('tap', function () {
        if ($(this).attr('disabled')) return;
        fun.showPageFull({
            page_url: page_arr.employee,
            pageParam: {
                "page_type": "ywy",
                "return_page": html_name
            }
        });
    });

    //展开收缩
    $('body').on('tap', '.list-item2', function () {
        if ($.nui.isEmpty($(this).next().children().length)) return;
        $(this).next().slideToggle(50);
    });

    //点击保存
    $('body').on('tap', '#save_btn', function () {
        if (!$('#name').val().trim()) {
            return fun.toast('姓名不能为空！');
        } else if (!$('#account').val().trim()) {
            return fun.toast('账号不能为空！');
        } else if (!$('#pwd').val().trim()) {
            return fun.toast('密码不能为空！');
        } 
        // else if ($.nui.isEmpty($('#book').attr('book_id'))) {
        //     return fun.toast('请选择账套！');
        // }

        setRowData();

        var temp_arr = [],
            list_arr = ['fenxi'];//
        // list_arr = ["xiaoxi", "fenxi"];
        $(list_arr).each(function (index, obj) {
            temp_arr.push($("[type=" + obj + "]").data('row'));
        })
        $('.list-item3').each(function (index, obj) {
            temp_arr.push($(obj).data('row'));
        })

        temp_arr = unique(temp_arr, 'name');

        if (!power(temp_arr)) {
            return fun.toast('请选择开通的权限');
        }

        saveList({
            "id": $('#account').attr('account_id') || 0,
            "staff_id": $('#name').attr('staff_id') || 0,
            "account": $('#account').val() || "",
            "name": $('#name').val() || "",
            "pwd": $('#pwd').val() || "",
            "is_employe": $('#salesman').hasClass('check-choice') ? 1 : 0,
            "store_id": $('#store_name').attr('store_id') || 0,
            "remark": "",
            "book_id": $('#book').attr('book_id') || 0,
            "is_bills_admin": 0,
            "admin_pwd": "",
            "mobile_authority": JSON.stringify(temp_arr),
            "bills_authority": [],
            "is_mobile": 1
        });
    })

    //删除
    $('body').on('tap', '#del_btn', function () {
        var del_id = page_data['account_id'],
            row_name = page_data['name'] || "此账户";
        fun.dialog({
            content: "你确定要删除【" + row_name + "】吗？",
            btn: ['删除', '取消'],
            yes: function () {
                saveList({
                    "id": [del_id],
                    "save_type": "delete"
                });
            }
        });
    })
}

//至少开启一个浏览权限
function power(arr) {
    for (var i = 0; i < arr.length; i++) {
        var list = arr[i];
        if (list['type'] == 'qita') continue;
        if (list['view'] == 1) return true;
    }
    return false;
}

// 子权限按钮盘判断
var single = {
    view: function (type, auth) { // 子权限打开关闭浏览执行
        if ($(this).hasClass('nui-active')) { // 浏览开启
            contorlAll(type, auth).open();
            // ...code
        } else { // 浏览关闭
            var statusArr = $(this).parents('.list-item3').find('.nui-switch').map(function () {
                return $(this).attr('authority');
            })
            for (var i = 0; i < statusArr.length; i++) { // 开启更改为关闭，将对应的所有权限更新为：关闭状态。
                $(this).parents('.list-item3').find('.nui-switch[authority=' + statusArr[i] + ']').removeClass('nui-active');
            }
            if (btnHasAllClose(type, 'edit')) { // 浏览关闭的时候，修改也全部关闭
                $(this).parents('.list-item2-wrap').prev().find('.nui-switch[authority=edit]').removeClass('nui-active');
            }
            contorlAll(type, auth).close();
        }
    },
    other: function (type, auth) { // 除了修改和浏览
        if ($(this).hasClass('nui-active')) { // 任意选项从关闭更改为开启，将对应的浏览权限更新为：开启状态
            $(this).parents('.list-item3').find('.nui-switch[authority=view]').addClass('nui-active');
        }
        // this.execute(type, auth);
        contorlAll(type, auth).open();
        contorlAll(type, auth).close();
        contorlAll(type, 'view').open(); // 检测通过修改打开的浏览是否全打开
    }
}

/* 
    需要一个检测预览全开和编辑全开的函数
*/
var contorlAll = function (type, auth) {
    var activeCount = count.getActiveCount(type, auth); // 开启的开关个数
    var switchCount = count.getSwitchCount(type, auth); // 总的开关个数
    var allSwitch = {
        open: function () {
            if (activeCount === switchCount) { // 全开
                $('.list-item2[type=' + type + ']').find('.nui-switch[authority=' + auth + ']').addClass('nui-active'); // 对应状态开启
            }
            return this;
        },
        close: function () {
            if (activeCount === 0) { // 全关
                $('.list-item2[type=' + type + ']').find('.nui-switch[authority=' + auth + ']').removeClass('nui-active');
            }
            return this;
        }
    }
    return allSwitch;
}

// 判断子权限按钮是否全关
var btnHasAllClose = function (type, auth) {
    var activeCount = count.getActiveCount(type, auth); // 开启的开关个数
    if (activeCount === 0) {
        return true;
    }
    return false;
}

// 判断子权限按钮是否全开
var btnHasAllOpen = function (type, auth) {
    var activeCount = count.getActiveCount(type, auth); // 开启的开关个数
    var switchCount = count.getSwitchCount(type, auth); // 总的开关个数
    if (activeCount === switchCount) {
        return true;
    }
    return false;
}

// 获取子权限开关个数
var count = {
    getSwitchCount: function (type, auth) { // 获取对应状态开关的个数
        var count = $('.list-item2[type=' + type + ']').next().find('.nui-switch[authority=' + auth + ']').length;
        return count;
    },
    getActiveCount: function (type, auth) { // 获取当前开启开关的子项
        var $parent = $('.list-item2[type=' + type + ']').next();
        var active = 0;
        $parent.find('.nui-switch[authority=' + auth + ']').each(function () {
            if ($(this).hasClass('nui-active')) {
                active++;
            }
        })
        return active;
    }
}

// 批量开始修改或浏览
var allSwitch = function (type, auth) {
    var switchAuth = {
        view: { // 浏览
            open: function () { // 全开本模块 自动当前模块所有子权限 的浏览状态更新为：开启状态。
                this.execute({
                    status: 1
                })
                return this;
            },
            close: function () { // 全关本模块 自动当前模块所有子权限 的所有权限都更新为关闭状态。
                this.execute({
                    status: 0
                })
                return this;
            },
            execute: function (param) { // type 为添加或删除，status add:1，remove: 0
                if (param['status']) { // 开
                    $('.list-item2[type=' + type + ']').find('.nui-switch[authority!=' + auth + ']').addClass('nui-active');
                    $('.list-item2[type=' + type + ']').find('.nui-switch[authority=' + auth + ']').addClass('nui-active');
                } else { // 关
                    $('.list-item2[type=' + type + ']').find('.nui-switch[authority!=' + auth + ']').removeClass('nui-active');
                    $('.list-item2[type=' + type + ']').find('.nui-switch[authority=' + auth + ']').removeClass('nui-active');
                }

                $('.list-item2[type=' + type + ']').next().find('.list-item3').each(function () {
                    // var row = $(this).data('row');
                    // 把所有子权限关了
                    // var statusArr = $(this).find('.nui-switch').map(function () {
                    //     return $(this).attr('authority');
                    // })
                    // for (var i = 0; i < statusArr.length; i++) {
                    //     row[statusArr[i]] = param['status'];
                    // }
                    if (param['status']) {
                        $(this).find('.nui-switch').addClass('nui-active');
                    } else {
                        $(this).find('.nui-switch').removeClass('nui-active');
                    }
                    // $(this).data('row', row);
                })
                return this;
            }
        },
        edit: { // 修改
            open: function () { // 全开本模块
                // 自动当前模块所有 具有修改权限的 子权限 的修改状态更新为：开启状态。且 将对应的浏览权限更新为：开启状态
                $('.list-item2[type=' + type + ']').find('.nui-switch[authority=' + auth + ']').addClass('nui-active');
                $('.list-item2[type=' + type + ']').next().find('.list-item3').find('.nui-switch[authority=' + auth + ']').each(function () {
                    $(this).addClass('nui-active');
                    $(this).siblings('.nui-switch[authority=view]').addClass('nui-active');
                    // var row = $(this).parents('.list-item3').data('row');
                    // row['edit'] = 1;
                    // row['view'] = 1;
                    // $(this).parents('.list-item3').data('row', row);
                })

                if (btnHasAllOpen(type, auth)) {
                    $('.list-item2[type=' + type + ']').find('.nui-switch[authority=view]').addClass('nui-active');
                }
                return this;
            },
            close: function () { // 全关本模块 
                // 自动当前模块所有 具有修改权限的 子权限 的修改状态更新为：关闭。
                $('.list-item2[type=' + type + ']').find('.nui-switch[authority=' + auth + ']').removeClass('nui-active');
                $('.list-item2[type=' + type + ']').next().find('.nui-switch[authority=' + auth + ']').removeClass('nui-active');
                // $('.list-item2[type=' + type + ']').next().find('.list-item3').each(function () {
                //     var row = $(this).data('row');
                //     row['edit'] = 0;
                //     $(this).data('row', row);
                // })
                return this;
            }
        }
    };
    return switchAuth;
}

/**
 * 同步其他模块开关动画
 * @param {string} type 模块名称
 * @param {string} auth 权限名称
 * @param {string} name 对应的类别
 */
function syncMove(type, auth, name) {
    var syncArr = ['kh', 'cp'];
    switch (type) {
        case 'jichu':
            if (syncArr.indexOf(name) > -1) {
                var authType;
                switch (auth) {
                    case 'view':
                        authType = 'view';
                        single[authType].call(this, 'dianpu', auth);
                        break;
                    case 'edit':
                        authType = 'other';
                        single[authType].call(this, 'dianpu', auth);
                        break;
                }
            }
            break;
        case 'dianpu':
            if (syncArr.indexOf(name) > -1) {
                var authType;
                switch (auth) {
                    case 'view':
                        authType = 'view';
                        break;
                    case 'edit':
                        authType = 'other';
                        break;
                }
                single[authType].call(this, 'jichu', auth);
            }
            break;
    }
}

/**
 * 父模块同步其他模块相同权限
 * @param {string} auth 权限名称
 * @param {string} type 模块名称
 */
function syncBatch(auth, type) {
    var syncArr = ['cp', 'kh'];
    var batch = {
        view: { // 批量开启浏览，找到另一模块同一权限的子级
            open: function () {
                batch['view']['execute']({
                    type: 'open'
                })
            },
            close: function () {
                batch['view']['execute']({
                    type: 'close'
                })
            },
            execute: function (params) {
                var moduleType;
                switch (type) {
                    case 'jichu':
                        moduleType = 'dianpu';
                        break;
                    case 'dianpu':
                        moduleType = 'jichu';
                        break;
                }
                for (var i = 0; i < syncArr.length; i++) {
                    var $equal = $('.list-item2[type=' + moduleType + ']').next().find('.nui-switch[name=' + syncArr[i] + ']');
                    switch (params['type']) {
                        case 'open':
                            $equal.addClass('nui-active');
                            break;
                        case 'close':
                            $equal.removeClass('nui-active');
                            break;
                    }
                    single[auth].call($equal, moduleType, auth); // 检测相同权限不同模块子权限对应父权限的全开全关按钮
                    contorlAll(moduleType, 'edit').open(); // 检测相同权限模块编辑是否全开或全关
                }
            }
        },
        edit: { // 批量开启浏览，找到另一模块同一权限的子级
            open: function () {
                batch['edit']['execute']({
                    type: 'open'
                })
            },
            close: function () {
                batch['edit']['execute']({
                    type: 'close'
                })
            },
            execute: function (params) {
                var moduleType;
                switch (type) {
                    case 'jichu':
                        moduleType = 'dianpu';
                        break;
                    case 'dianpu':
                        moduleType = 'jichu';
                        break;
                }
                var $equal = $('.list-item2[type=' + moduleType + ']').next().find('.nui-switch[authority=edit]'); // 另一模块
                if (syncArr.indexOf($equal.attr('name') > -1)) {
                    for (var i = 0; i < syncArr.length; i++) {
                        var $sameEditEle = $('.list-item2[type=' + moduleType + ']').next().find('.nui-switch[authority=edit][name=' + syncArr[i] + ']');
                        switch (params['type']) {
                            case 'open':
                                $sameEditEle.addClass('nui-active');
                                break;
                            case 'close':
                                $sameEditEle.removeClass('nui-active');
                                break;
                        }
                        single.other.call($sameEditEle, moduleType, auth);
                    }
                }
            }
        }
    }
    return batch;
}

/* 数组对象去重 */
function unique(arr, key) {
    var result = [];
    var obj = {};
    for (var i = 0; i < arr.length; i++) {
        if (!obj[arr[i][key]]) {
            result.push(arr[i]);
            obj[arr[i][key]] = true;
        }
    }
    return result;
}

/**
 * 批量设置同步权限
 * @param { Object } 
 * {
 *      auth 权限名称
 *      type 模块名称
 * } 
*/
function syncModule(param) {
    var auth = param['auth'];
    var type = param['type'];
    // 父模块批量设置修改或浏览
    switch (auth) {
        case 'view':
            var tempType;
            if ($(this).hasClass('nui-active')) { // 批量开启浏览
                syncBatch('view', type).view.open();
            } else { // 关闭
                syncBatch('view', type).view.close();
            }

            switch (type) {
                case 'jichu':
                    tempType = 'dianpu';
                    break;
                case 'dianpu':
                    tempType = 'jichu';
                    break;
            }
            break;
        case 'edit':
            var tempType;
            if ($(this).hasClass('nui-active')) { // 批量开启修改
                syncBatch('edit', type).edit.open();
            } else {
                syncBatch('edit', type).edit.close();
            }

            switch (type) {
                case 'jichu':
                    tempType = 'dianpu';
                    break;
                case 'dianpu':
                    tempType = 'jichu';
                    break;
            }
            break;
    }
}

/**
 * 
 * @param { Object }
 * {
        key 权限名称
        auth 权限名称
        type 模块模块
        name 权限模块名称
*  } 
*/
function singleEdit(param) {
    var key = param['key'];
    var auth = param['auth'];
    var type = param['type'];
    var name = param['name'];
    if (key === 'edit') { // 修改
        var moduleType;
        if (type === 'jichu') { // 基础模块去触发店铺模块
            moduleType = 'dianpu';
        } else if (type === 'dianpu') { // 店铺模块去触发基础模块
            moduleType = 'jichu';
        }
        var $ele = $('.list-item2[type=' + moduleType + ']').next().find('.nui-switch[authority=' + auth + '][name=' + name + ']');
        $(this).hasClass('nui-active') ? $ele.addClass('nui-active') : $ele.removeClass('nui-active'); // 另一模块
        syncMove.call($ele, type, auth, name);
    }
}

/**
 * 子权限同步相同模块对应自权限
 * @param { Object }
 * {
        key 权限名称
        auth 权限名称
        type 模块模块
        name 权限模块名称
 * } 
 */
function singleSwitch(param) {
    var key = param['key'];
    var auth = param['auth'];
    var type = param['type'];
    var name = param['name'];
    switch (key) {
        case 'view': // 浏览
            single.view.call(this, type, auth);
            var moduleType;
            if (type === 'jichu') { // 基础模块去触发店铺模块
                moduleType = 'dianpu';
            } else if (type === 'dianpu') { // 店铺模块去触发基础模块
                moduleType = 'jichu';
            }
            var $ele = $('.list-item2[type=' + moduleType + ']').next().find('.nui-switch[authority=' + auth + '][name=' + name + ']');
            $(this).hasClass('nui-active') ? $ele.addClass('nui-active') : $ele.removeClass('nui-active'); // 另一模块
            syncMove.call($ele, type, auth, name);
            break;
        default:
            single.other.call(this, type, auth);
            break;
    }
}

// 设置权限数据
function setRowData() {
    var $moduleEle = $('.list-item2');
    // 设置父模块数据
    $moduleEle.each(function (idx, item) {
        var row = $(this).data('row');
        var $that = $(this);
        $(this).find('.nui-switch').each(function () {
            row[$(this).attr('authority')] = $(this).hasClass('nui-active') ? 1 : 0;
            $that.data('row', row);
        })
    })
    var $authModule = $moduleEle.next();

    $authModule.each(function () {
        if ($(this).children().length) {
            $(this).each(function (idx, item) {
                $(this).find('.list-item3').each(function () {
                    var tempRow = $(this).data('row');
                    $(this).find('.nui-switch').map(function () {
                        return tempRow[$(this).attr('authority')] = $(this).hasClass('nui-active') ? 1 : 0;
                    })
                    $(this).data('row', tempRow);
                })
            })
        } else {
            return true;
        }
    })
}

// 判断子权限是否全开
function checkAuth(arr, auth) {
    var status = arr.every(function (item, idx, self) {
        return item[auth] === 1;
    })
    return status;
}