var html_name = page_arr.account_security;
/******头部显示******/
$("#header").header({
    back: true,
    title: '帐号与安全',
});

var is_wx;
page_init = function () {
    if (!!Auth.check('czrz', 'view')) $('.czrz_opt').show();
    $('#qhzt').text((fun.getItem('book_name') || ""));//显示账套
    //   $('.set-img').css('top', '-'+api.safeArea.top + 'px');

    if (SHOW_WX) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.wxUser,
            data: {
                type: 'is_wx',
            },
            success: function (res) {
                // console.log(JSON.stringify(res));
                is_wx = res.status
                if (is_wx == 0) {
                    security();
                    $('.bdwx_icon').attr('xlink:href','#icon-bangdingweixin');
                    $('.bdwx_text').addClass('blue').removeClass('ash');
                }
                // return fun.toast(res.msg);
            },
        });
    }

}

//安全
function security() {
    $('.set-box,#header').removeClass('main-color').addClass('theme-color');
    $('.set-img').css({
        'background': 'url(../img/safety_shield.png)no-repeat center',
        'background-size': 'contain',
        'top': '-1rem'
    });
    $('.tips').hide();
    $('.set-box').css('height', 'calc(100% - 11rem)');
    $('.list-box').css('height', '11rem');
}
//危险
function danger(){
    $('.set-box,#header').addClass('main-color').removeClass('theme-color');
    $('.set-img').css({
        'background': 'url(../img/dangerous_shield.png)no-repeat center',
        'background-size': 'contain',
        'top': '-0.5rem'
    });
    $('.tips').show();
    $('.set-box').css('height', 'calc(100% - 13rem)');
    $('.list-box').css('height', '13rem');
}
//开启验证弹窗
function verification(text){
    fun.dialog({
        content: '你要开启'+text+'二级验证吗？',
        btn: ['开启', '取消'],
        yes: function () {
            
        }
    });
}

$('body').on('tap', '.list', function (e) {
    e.stopPropagation();
    var name = $(this).data('url');
    var url = '';
    switch (name) {
        case 'xgmm':
            url = page_arr.modify_pwd;
            break;
        case 'ghsj':
            url = page_arr.replace_mobile;
            break;
        case 'bdzw':
            verification('指纹');
            break;
        case 'bdrl':
            url = page_arr.password_verification;
            break;    
    }

    if (!!url) {
        fun.showPageFull({
            page_url: url,//产品类别编辑页面
            pageParam: {
                return_page: html_name,
                // opt_type:'add',
            }
        });
    }
});

$('.wx_info').on('click', function (e) {
    e.preventDefault();
    if (is_wx === 0) {
        fun.dialog({
            content: '你确定要解绑微信吗?',
            btn: ['确定', '取消'],
            yes: function () {
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.wxUser,
                    data: {
                        type: 'jb',
                        // code: ret.code,
                        login_type: 'app'
                    },
                    success: function (res) {
                        // console.log(JSON.stringify(res));
                        is_wx = 1;
                        danger();
                        $('.bdwx_icon').attr('xlink:href','#icon-bangdingweixin1');
                        $('.bdwx_text').addClass('ash').removeClass('blue');
                        return fun.toast(res.msg);
                    },
                    error: function (res) {

                    }
                });
            }
        });
    } else {
        fun.bdWXLoginTips({
            yes: function () {
                var wx = api.require('wxPlus');
                if (!checkWxUseable(wx)) return false;
                wx.auth({
                    apiKey: '' //wx_appid  已从config获取
                }, function (ret, err) {
                    if (ret.status) { //成功登陆
                        fun.ajax({
                            showLoad: true,
                            hideLoad: true,
                            url: AJAX_URL.wxUser,
                            data: {
                                type: 'bd',
                                code: ret.code,
                                login_type: 'app'
                            },
                            success: function (res) {
                                // console.log(JSON.stringify(res));
                                is_wx = 0;
                                security();
                                $('.bdwx_icon').attr('xlink:href','#icon-bangdingweixin');
                                $('.bdwx_text').addClass('blue').removeClass('ash');
                                return fun.toast(res.msg);
                            },
                            error: function (res) {

                            }
                        });
                    } else {
                        if (err.code == 1) {
                            return fun.toast('取消授权');
                        } else if (err.code == 2) {
                            return fun.toast('拒绝授权');
                        } else if (err.code == 3) {
                            return fun.toast('未安装微信');
                        }
                    }
                });
            }
        });
    }
    return false;
});
