var html_name = page_arr.bills_cgddxq; // 页面名称
var billsCgDdXq = {
    showSettle: function () {
        $('#settle,.settle-wrap').show();
    },
    hideSettle: function () {
        $('#settle,.settle-wrap').hide();
    }
};

var Bills = Bills || {},    //开单配置项
    photoBrowser = {},      //大图浏览
    jjsfssl,                //计价数反算出库数
    __PAGE_DATA = {},       //页面数据
    back_ori_data = {},     //点击返回前的原始数据
    back_save_data = {},    //点击返回时的保存数据
    cache_data = {},        //缓存一些数据
    __JL_DATA = [],         //所有记录行数据
    __CP_YS_JL = [],        //所有相同产品记录行数据
    ROW_DATA = {},          //当前页面记录行数据
    target_page = '',       //点击完成要返回哪个页面
    isSave = false,
    showKeyBoard = true,    //显示键盘
    fieldConfig = {},       //字段配置
    JD_FROM_JL = false,     //从记录行结单
    __JD_INFO = {},         //原来的结单数据
    tmpJdDisabled = [],      //临时结单需要禁用的
    PAGE_INIT_DATA = {},    //删除时初始化页面数据
    psslTmpDisabled = [],    //匹数数量临时禁用掉的数组
    IS_FROM_VIEW = false,   //是否是从统计页右上角跟单点击进来
    begin_lCalendar = new lCalendar(),         //货期
    AUTH_EDIT,               //修改权限
    AUTH_JD,                //结单权限
    __cp_list = [],          //当前记录行产品信息数组
    __ck_info = {},           //当前记录行仓库信息
    __ALL_DATA = {},
    __VIEW_TO_EDIT = true,
    is_adjust_save = false,
    execFlag = false,
    CXPSSL_EDIT = false,
    execBack = false
    ;
Bills['wldw_type'] = 'gys';//往来单位类型
Bills['WldwSubInfo'] = {};//往来单位子信息

Bills['AJAX_URL'] = {
    'getDj': AJAX_URL.getBpXsDjAndScdj, //获取单价
};

Bills['data_list'] = ['jjdw', 'ck', 'cp'];//预加载数据列表

Bills['config'] = {
    fy_zdy: 'bpxszdyfy', // 布匹-销售自定义费用
    ck_zdy: 'bpckzdygl', // 仓库自定义字段
    kd_zdy: 'bpkdzdyzd', // 开单自定义字段
    dckms: 'dckms_bp', // 多仓库模式
    adjs: 'adjs_bpxs', // 按单结算
    dwgshsbl: 'dwgshsbl_bp', // 单位公式换算保留位数
    jesswr: 'jesswr_bpxs', // 金额四舍五入
    bdjesswr: 'bdjesswr_bpxs', // 本单金额四舍五入
    dddjwlcddj: 'dddjwlcddj_bpxs', // 订单单价为0重读单价
    qyssjms: 'qyssjms_bp'
};

Bills['__post_sign'] = $.nui.getRandomNum();

fun.clearItem('cp_list');

var SYS_CONFIG = {}, //系统设置
    cp_list = [], //产品列表
    jjdw_list = []; //单位列表

var longClick = 0;

$('#header').header({
    title: '&nbsp;',
    edit1: true,
    text_btn: true,
    text_val: '完成',
    appendBackBtnEvt: backCallback
});

$('#complete_btn,#edit_btn1').hide();

var winHeight = $(window).height(); //获取当前页面高度
$(window).resize(function () {
    var thisHeight = $(this).height();
    if (winHeight - thisHeight > 50) {
        $('.layer-content').css('visibility', 'hidden');
        setPanelHide();
    } else {
        $('.layer-content').css('visibility', 'visible');
    }
});
setPanelHide();

begin_lCalendar.init({
    'trigger': '#hq',
    'type': 'date',
    'callback': function (date) {
        var kdsj = fun.formatDate(__DJ_DATA['kdsj'], 'YYYY-MM-DD');
        if (new Date(Date.parse(date)) < new Date(Date.parse(kdsj))) {
            $('#hqts').val(ROW_DATA['hqts'] || 0);//货期天数
            $('#hq').text(fun.formatDate(ROW_DATA['hq'], 'YY-MM-DD') || '').data('hq', ROW_DATA['hq']);//货期
            setCq(ROW_DATA['hq']);
            begin_lCalendar.format_value = (!!ROW_DATA['hq'] ? fun.formatDate(ROW_DATA['hq'], 'YYYY-MM-DD') : "");
        } else {
            var hqts;
            if (new Date(Date.parse(date)) == new Date(Date.parse(kdsj))) hqts = 0;
            else hqts = Math.abs(new Date(date).getTime() - new Date(kdsj).getTime()) / (1000 * 60 * 60 * 24);
            $('#hqts').val(hqts || 0);
            $('#hq').text(fun.formatDate(date, 'YY-MM-DD') || '').data('hq', date);//货期
            setCq(date);
            begin_lCalendar.format_value = (!!date ? fun.formatDate(date, 'YYYY-MM-DD') : "");
        }

        getRowSaveData();
    },
    'onCheck': function (date) {
        var kdsj = fun.formatDate(__DJ_DATA['kdsj'] || new Date(), 'YYYY-MM-DD');
        if (new Date(Date.parse(date)) < new Date(Date.parse(kdsj))) {
            return false;
        }
        return true;
    },
    'billing': true
});

function refreshPage() {
    CXPSSL_EDIT = false;
    switch (page_data['initType']) {
        case 'view'://订单统计页右上角跟单点击进来时，显示浏览
            IS_FROM_VIEW = true;
            __VIEW_TO_EDIT = false;
            // JD_FROM_JL = false;
            var dj_id = page_data['data']['dj_id'];
            var jl_id = page_data['data']['jl_id'];

            $('#edit_btn1').hide();

            $('#complete_btn').hide();
            setViewDomDisabled();
            setPanelHide();
            $('.active-border').removeClass('active-border');
            __ddGetData(dj_id, jl_id, function () {
                __PAGE_DATA = page_data;
                // isShop();
                (AUTH_EDIT || AUTH_JD) && $('#edit_btn1').show();
                if (!AUTH_EDIT && AUTH_JD) {
                    $('#edit_btn1').hide();
                }

                // 预加载数据
                fun.load_DATA_LIST(['cp'], function () {
                    cp_list = fun.getItem('cp_list') || []; //产品列表
                });
                fun.load_DATA_LIST(['jjdw', 'sys_config'], function () {// 
                    jjdw_list = fun.getItem('jjdw_list') || []; //单位列表
                    SYS_CONFIG = fun.getItem('sys_config') || {}; //系统设置
                });

                showPhszHtml();

                init();
                $('.color-change,#settle,.settle-wrap').hide();
                $('#ps,#sl,#hq,#hqts,#gg,#gg_short,#zt_wrap,#jjcd_wrap,#jjsl_val').attr('disabled', true);
                begin_lCalendar.disabled = true;
                __PAGEDOM_DISABLED();

                if (!AUTH_EDIT && AUTH_JD || ROW_DATA['is_jd']) {
                    $('#edit_btn1').hide();
                    $('#settle,.settle-wrap').show();
                    $('.settle-wrap').appendTo($('.header-content'));
                    $('.settle-wrap').css({ bottom: 0 });
                }
                else {
                    $('.settle-wrap').appendTo($('.header-bar'));
                    $('.settle-wrap').css({ bottom: '0.5rem' });
                }

                btnAuthCheck();
            });
            break;
        case 'edit'://订单记录行点击进来时，显示编辑
            IS_FROM_VIEW = false;
            // fun.load_CP_LIST({ goods_id: 0}, function () {
            // }, {});
            // setEditDomDisabled();
            __PAGE_DATA = page_data;
            // isShop();

            // 预加载数据
            fun.load_DATA_LIST(['cp'], function () {
                cp_list = fun.getItem('cp_list') || []; //产品列表
            });
            fun.load_DATA_LIST(['jjdw', 'sys_config'], function () {// 
                jjdw_list = fun.getItem('jjdw_list') || []; //单位列表
                SYS_CONFIG = fun.getItem('sys_config') || {}; //系统设置
            });

            __PAGE_DATA['ck_info'] = __PAGE_DATA['ck_info'] || {};
            __JL_DATA = __PAGE_DATA['__JL_DATA'] || [];
            __DJ_DATA = __PAGE_DATA['__DJ_DATA'] || {};

            showPhszHtml();

            // 设置初始非浏览状态下所有元素编辑状态
            setEditDomDisabled();
            init();
            __PAGEDOM_DISABLED();
            if (!AUTH_EDIT && AUTH_JD || ROW_DATA['is_jd']) {
                $('#settle,.settle-wrap').show();
                $('.settle-wrap').appendTo($('.header-content'));
                $('.settle-wrap').css({ bottom: 0 });
                $('#complete_btn').hide();
            }
            else {
                $('.settle-wrap').appendTo($('.header-bar'));
                $('.settle-wrap').css({ bottom: '0.5rem' });
            }
            btnAuthCheck();
            break;
    }
}

// apicloud页面初始化
page_init = function () {
    SYS_CONFIG = fun.getItem('sys_config') || {}; //系统设置
    cp_list = fun.getItem('cp_list') || []; //产品列表
    jjdw_list = fun.getItem('jjdw_list') || []; //单位列表

    photoBrowser = api.require('photoBrowser');

    Bills['djlx'] = page_data['djlx'];

    AUTH_EDIT = Auth.check(Bills['djlx'], 'edit');
    AUTH_JD = Auth.check(Bills['djlx'], 'settle');

    switch (page_data['djlx']) {
        case 'bp_xsdd':
            target_page = page_arr.xs_khdd_kd;
            Bills['AJAX_URL']['save'] = AJAX_URL.saveBpXsddInfo;
            Bills['AJAX_URL']['get'] = AJAX_URL.getBpXsddInfo;
            fieldConfig = {
                'fhps_name': 'fhps',
                'fhps_display': '发货',
                'wfps_name': 'wfps',
                'wfps_display': '未发',
                'fhsl_name': 'fhsl',
                'fhsl_display': '发货',
                'wfsl_name': 'wfsl',
                'wfsl_display': '未发'
            };
            Bills['wldw_type'] = 'kh';
            break;
        case 'bp_cgdd':
            target_page = page_arr.cg_cgdd_kd;
            Bills['AJAX_URL']['save'] = AJAX_URL.saveBpCgddInfo;
            Bills['AJAX_URL']['get'] = AJAX_URL.getBpCgddInfo;
            Bills['AJAX_URL']['getDj'] = AJAX_URL.getBpCgDjAndScdj; // 获取单价
            fieldConfig = {
                'fhps_name': 'lhps',
                'fhps_display': '来货',
                'wfps_name': 'wlps',
                'wfps_display': '未来',
                'fhsl_name': 'lhsl',
                'fhsl_display': '来货',
                'wfsl_name': 'wlsl',
                'wfsl_display': '未来'
            };
            Bills['wldw_type'] = 'gys';
            // 设置类型
            Bills.config.fy_zdy = 'bpcgzdyfy';
            Bills.config.jesswr = 'jesswr_bpcg';
            Bills.config.bdjesswr = 'bdjesswr_bpcg';
            Bills.config.dddjwlcddj = 'dddjwlcddj_bpcg';//"订单单价为0重读单价_布匹采购"
            break;
    }

    setTabDisplay();

    $('#complete_btn').show();

    refreshPage();

    page_data.keyback = function () {
        backCallback();
    };

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'select_list':
                setSelectedValue(temp['data']);
                break;
            case 'update':
                var list_data = temp['data']['list_data'] || {};
                if (temp['data']['page_type'] == 'jjcd') {
                    if ($.nui.isTrue(list_data['name'])) {
                        $('#jjcd_mc').text(list_data['name'] || '暂无').data({
                        }).css({
                            'backgroundColor': list_data['colour'],
                        }).removeClass('black-import').addClass('white-import');//紧急程度
                    } else {
                        $('#jjcd_mc').text('暂无');
                        $('#jjcd_mc').data({
                        }).css({
                            'backgroundColor': '#fff',
                            'padding-left': 0
                        }).removeClass('white-import').addClass('black-import');//紧急程度
                    }
                    $('#jjcd_mc').data({
                        jjcd_id: list_data['id'] || 0,
                        jjcd_mc: list_data['name'] || '',
                        colour: list_data['colour'] || ''
                    })
                }
                if (temp['data']['page_type'] == 'zt') {
                    if ($.nui.isTrue(list_data['name'])) {
                        $('#zt_mc').text(list_data['name'] || '暂无').data({
                        }).css({
                            'backgroundColor': list_data['colour'],
                        }).removeClass('black-import').addClass('white-import');
                    } else {
                        $('#zt_mc').text('暂无');
                        $('#zt_mc').data({
                        }).css({
                            'backgroundColor': '#fff',
                            'padding-left': 0
                        }).removeClass('white-import').addClass('black-import');
                    }

                    $('#zt_mc').data({
                        'zt': list_data['name'] || '',
                        'zt_id': list_data['id'] || 0,
                        'colour': list_data['colour'] || ''
                    })
                }
                break;
            case 'goodsdata':
                $('#gg').val(temp['name']).data('ggid', temp['id']);
                break;
            case 'refresh_dj':
                refreshPage();
                break;
        }
    });

    fun.inputType();
};

// 显示订单单据信息
function showDDdjData() {
    //单据信息
    $('#kh').text(__DJ_DATA['wldw_mc'] || '');//客户名称
    $('#dh').text(__DJ_DATA['dh'] || '');//单号
    $('#kdsj').text(fun.formatDate(__DJ_DATA['kdsj']) || '');//开单时间
}

// 显示订单记录行信息
function showDDjlData() {

}

// 第一次由浏览变为编辑事件
function firstViewToEdit() {

}

function setCq(date) {
    if ($.nui.isEmpty(date)) return;
    var _days = count_days(date);
    if (_days >= 0) {
        $('#cq').siblings().text('剩余');
        $('#cq').text(Math.abs(_days) + '天').css('color', '#48C157');
    } else {
        $('#cq').siblings().text('超期');
        $('#cq').text(Math.abs(_days) + '天').css('color', '#ff4e44');
    }
}

function count_days(date) {
    var _date = fun.formatDate(fun.getNowFormatDate(), 'YYYY-MM-DD');
    var date = fun.formatDate(date, 'YYYY-MM-DD')    //date 转化为 "YYYY-MM-DD"
    var _days = (new Date(date).getTime() - new Date(_date).getTime()) / (1000 * 60 * 60 * 24);
    return _days;
}

// 设置标签页显示隐藏
function setTabDisplay() {
    // 采购订单只有一个标签页时不需要显示上面的信息
    if ($('.danju-float-left').length <= 1) {
        $('.float-list').hide();
    } else {
        $('.float-list').show();
    }
}

// 设置键盘隐藏
function setPanelHide() {
    $('.form_edit,.layer-content').hide();
    $('#toggle').find('.icon-toggle').removeClass('icon-xia').addClass('icon-shang');

    $('.layer-content').css({
        height: '2.5rem'
    });

    setClearBtnShow();
}

// 设置键盘显示
function setPanelShow() {
    if (!showKeyBoard) return;
    $('.form_edit,.layer-content').show();
    $('#toggle').find('.icon-toggle').removeClass('icon-shang').addClass('icon-xia');

    $('.layer-content').css({
        height: '12.75rem'
    });

    setClearBtnShow();
}

// 设置清除按钮是否显示
function setClearBtnShow(flag) {
    var tmpFlag;
    if (flag) {
        tmpFlag = parseFloat($('#value').val().trim() || 0);
    } else {
        tmpFlag = $('#value').val().trim();
    }

    if (tmpFlag) {
        $('#remove').show();
    } else {
        $('#remove').hide();
    }
}

//设置计价数量颜色
function setJjslColor() {
    if ($('#sl').val().trim() == $('#jjsl_val').text().trim()) {
        $('#jjsl_val').css('color', '#000');
    } else {
        $('#jjsl_val').css('color', '#18b4ed');
    }
}

// 页面初始化时是否可编辑元素
function initEditDom() {
    if (IS_FROM_VIEW) {

    } else {
        if ($.nui.isTrue(__PAGE_DATA['__PAGE_EDIT'])) {
            $('input,#dw,#jjdw,#sel_jjdw,#toggle,#color_search_wrap,#color,#lx').removeAttr('disabled');
            // $('#scgys,#complete_btn').show();
        } else {
            $('input,#dw,#jjdw,#sel_jjdw,#toggle,#color_search_wrap,#color,#lx').attr('disabled', true);
            // $('#scgys,#complete_btn').hide();
        }
    }
}


// 设置初始浏览状态下所有元素不编辑
function setViewDomDisabled() {
    $('#color_search_wrap,#ps,#cxps,#sl,#cxsl,#dw,#jjsl_val,#dj,#hqts,#hq,#jjcd_wrap,#zt_wrap,#fk,#kz,#gg,#gg_short,#bz').attr('readonly', 'readonly');
    $('#color_search_wrap,#ps,#cxps,#sl,#cxsl,#dw,#jjsl_val,#dj,#hqts,#hq,#jjcd_wrap,#zt_wrap,#fk,#kz,#gg,#gg_short,#bz').attr('disabled', true);
}

// 设置初始非浏览状态下所有元素编辑状态
function setEditDomDisabled() {
    $('input,#color_search_wrap,#dw,#jjsl_val,#gg,#lx,#jjcd_wrap,#zt_wrap').removeAttr('disabled');
    $('#color_search_wrap,#cxps,#cxsl,#dw,#dj,#hqts,#hq,#fk,#kz,#bz').removeAttr('readonly');//#gg,#gg_short,
}


function __checkData() {
    // if(fun.clearCpData) {
    //     fun.remove_DATA_LIST('cp');
    //     fun.clearCpData = false;
    // }
    if (!fun.dataIsRead(['cp'])) {
        setTimeout(__checkData, 250);
    } else {
        setTimeout(function () {
            if (typeof page_init === "function") page_init();
        }, 100);
    }
}

// 商城订单禁用
function isShop() {
    // if (IS_FROM_VIEW) {

    // } else {
    //     if (page_data['is_shop'] == 'shop') {
    //         $('#sl, #ps, #lx, #jjcd_mc, #dw, #jjdw, #jjsl_val').css('pointer-events', 'none').attr('disabled', true);
    //     } else {
    //         $('#sl, #ps, #lx, #jjcd_mc, #dw, #jjdw, #jjsl_val').css('pointer-events', 'auto').removeAttr('disabled');
    //     }
    // }
}

// 页面数据初始化
function init(options) {
    var _options = $.extend({ setColorEmpty: false }, options);

    $('.color-change').show();

    // 初始化页面布局
    // initPageLayout();
    initEditDom();

    jjsfssl = fun.getItem(page_data['djlx'] + '_jjsfssl') || false;//计价数反算出库数

    switch (page_data['djlx']) {
        case 'bp_xsdd':
        case 'bp_cgdd':
            $('.jj-wrap,.djjelx').show();
            $('.je-wrap').css('visibility', 'visible');
            break;
    }

    var cp_list = fun.getItem('cp_list') || [];
    var list_data = __PAGE_DATA['list_data'];

    switch (page_data['djlx']) {
        case 'bp_xsdd':
            // if ($.nui.isTrue(list_data['is_has']) || $.nui.isTrue(list_data['is_dy']) ||
            //     $.nui.isTrue(list_data['is_has_cgdd']) || $.nui.isTrue(list_data[fieldConfig.fhps_name])
            //     || $.nui.isTrue(list_data[fieldConfig.fhsl_name])) {
            //     $('#fk,#kz,#lx').attr('disabled', true);
            // }

            if (!list_data['is_jd'] && $.nui.isEmpty(list_data['is_has']) && $.nui.isEmpty(list_data['is_dy'])
                && $.nui.isEmpty(list_data['is_has_cgdd'])) {
                $('#color_search').removeAttr('disabled');
                $('.color-change').show();
            } else {
                $('#color_search').attr('disabled', true);
                $('.color-change').hide();
            }

            break;
        case 'bp_cgdd':
            // if ($.nui.isTrue(list_data['kh_dd_dj_id']) && $.nui.isTrue(list_data['kh_dd_jl_id'])) {
            //     // 当前记录行 是调用 客户订单 生成的，则：
            //     // 以下字段不允许编辑：商品编号、商品名称、色号、颜色、客户
            // }

            // if ($.nui.isTrue(list_data['is_has']) || $.nui.isTrue(list_data[fieldConfig.fhps_name])
            //     || $.nui.isTrue(list_data[fieldConfig.fhsl_name])) {
            //     // 订单被调用后，不允许修改 仓库、商品、颜色、单位、匹数、数量
            //     $('#fk,#kz').attr('disabled', true);
            // }
            if (!list_data['is_jd'] && $.nui.isEmpty(list_data['is_has'])) {
                $('#color_search').removeAttr('disabled');
                $('.color-change').show();
            } else {
                $('#color_search').attr('disabled', true);
                $('.color-change').hide();
            }
            break;
    }

    // 标题初始化
    afterInitHeader(list_data);

    // if (list_data['is_jd']) {

    // } else {

    // }

    // 初始化图片
    initImgs(list_data);

    if (!__PAGE_DATA['__PAGE_EDIT'] || (list_data['is_jd'])) {
        showKeyBoard = false;
        setPanelHide();
    }

    if ($.nui.isTrue(list_data['cxps']) || $.nui.isTrue(list_data['cxsl'])) {
        showKeyBoard = false;
        setPanelHide();

        $('#color_search_wrap,#fk,#kz,#gg,#lx,#ps,#sl,#dw').attr('disabled', true);
    }

    $('#dw').text(list_data['dw_mc'] || '单位').data('dw_id', list_data['dw_id'] || 0);

    $('#color_search').text((list_data['cp_ys_bh'] || '') + ' ' + (list_data['cp_ys_mc'] || ''))
    $('#color_search_wrap').data({
        'cp_ys_id': list_data['cp_ys_id'],
        'cp_ys_bh': list_data['cp_ys_bh'],
        'cp_ys_mc': list_data['cp_ys_mc']
    });

    if ($.nui.isTrue(list_data['is_jd'])) {
        $('#settle').text('反结单');
        $('input,#lx').attr('disabled', true);
    } else {
        $('#settle').text('结单');
    }

    function initJdBtn() {
        var config = (fun.getValByKey(fun.getItem('xs_ddlb_list') || [], __DJ_DATA['djlb_id'], 'config')) || {};
        var DJLB_FH = config['fh'];//单据类别复核

        if ($.nui.isTrue(__PAGE_DATA['__DJ_DATA']) && $.nui.isTrue(__PAGE_DATA['__DJ_DATA']['id'])) {
            function setSthShowDisable(dj_is_fh) {
                if (dj_is_fh) {
                    billsCgDdXq.showSettle();
                    // $('#settle,.settle-wrap').show();
                    $('#cxps,#cxsl').removeAttr('disabled');
                } else {
                    billsCgDdXq.hideSettle();
                    // $('#settle,.settle-wrap').hide();
                    $('#cxps,#cxsl').attr('disabled', true);
                    if (__DJ_DATA['is_jd']) {
                        billsCgDdXq.showSettle();
                        // $('#settle,.settle-wrap').show();
                    }
                }
            }
            if (!__PAGE_DATA['__DJ_DATA']['is_jd']) {
                $('#cxps,#cxsl').removeAttr('disabled');
            } else {
                $('#cxps,#cxsl').attr('disabled', true);
            }
            switch (page_data['djlx']) {
                case 'bp_xsdd':
                    //销售订单 结单按钮显示
                    if (__PAGE_DATA['__DJ_DATA']['zh_je'] > 0) {
                        if (__PAGE_DATA['__DJ_DATA']['is_sh']) $('#settle,.settle-wrap').show();
                    } else {
                        billsCgDdXq.showSettle();
                        // $('#settle,.settle-wrap').show();
                    }

                    var xsdd_fh = fun.getKzValue('ddfh', 'bp_xsdd');

                    if (xsdd_fh) {
                        if ($.nui.isEmpty(__DJ_DATA['djlb_id'])) {//单据类别为空
                            setSthShowDisable(__PAGE_DATA['__DJ_DATA']['is_fh']);
                        } else {
                            if (DJLB_FH) {
                                setSthShowDisable(__DJ_DATA['is_fh']);
                            } else {
                            }
                        }
                    } else {
                        if ($.nui.isEmpty(__DJ_DATA['djlb_id'])) {//单据类别为空

                        } else {
                            if (DJLB_FH) {
                                setSthShowDisable(__DJ_DATA['is_fh']);
                            } else {

                            }
                        }
                    }

                    //订单类别有值
                    if (!!__DJ_DATA['djlb_id']) {
                        if (xsdd_fh) {
                            if (DJLB_FH) {

                            } else {
                                billsCgDdXq.showSettle();
                                // $('#settle,.settle-wrap').show();
                            }
                        } else {

                        }
                    } else {//订单类别空

                    }

                    break;
                case 'bp_cgdd':
                    var recheck = Auth.check(page_data['djlx'], 'recheck'); // 复核权限
                    var config = fun.getValByKey(fun.getItem('cg_ddlb_list') || [], __DJ_DATA['djlb_id'], 'config') || {};
                    var djLbFh = config['fh']; // 订单类别复核
                    var cgdd_fh = fun.getKzValue('ddfh', 'bp_cgdd');
                    if (cgdd_fh) {
                        setSthShowDisable(__PAGE_DATA['__DJ_DATA']['is_fh']);
                    } else {
                        if (recheck && djLbFh && __DJ_DATA['is_fh']) { // 有复核权限、并且订单类别有开启复核，单据已复核，显示结单
                            billsCgDdXq.showSettle();
                        } else if (recheck && (!djLbFh || $.nui.isEmpty(config))) { // 有复核权限、订单类别没开启复核或为空，显示结单
                            billsCgDdXq.showSettle();
                        }
                    }
                    break;
            }
        } else {

        }
    }

    initJdBtn();

    if ($.nui.isTrue(__PAGE_DATA['edit_row'])) {
        __JD_INFO = __PAGE_DATA['__JD_INFO'] || {};

        showDDdjData();

        // $('#color_search').text((list_data['cp_ys_bh'] || '') + (list_data['cp_ys_mc'] || ''));
        // $('#color_search_wrap').data({
        //     'cp_ys_id': list_data['cp_ys_id'],
        //     'cp_ys_bh': list_data['cp_ys_bh'],
        //     'cp_ys_mc': list_data['cp_ys_mc']
        // });


        $('#dj').val(list_data['hsdj'] || 0);

        $('#je').text(list_data['hszje'] || 0);
        var ssje = 0;
        switch (page_data.djlx) {
            case 'bp_xsdd':
                ssje = list_data['ssje'] || 0;
                $('#ssj').val(list_data['ssdj'] || 0);
                $('#ssje').val(ssje);
                $('#hk').val($.nui.decimalSub((list_data['hszje'] || 0), ssje));
                break;
        }

        // $('#lx').text(list_data['jg_lx_mc'] || '大货').data('jg_lx', list_data['jg_lx'] || 'dh');

        $('#fk').val(list_data['fk'] || '');
        $('#kz').val(list_data['kz'] || '');
        $('#gg').val(list_data['gg'] || '');
        // $('#gh').val(list_data['gh'] || '');

        $('#ps').val(parseInt(list_data['ps'] || 0) || '');
        $('#sl').val(list_data['zsl'] || '');
        $('#jjsl_val').text(list_data['jjsl'] || 0);

        $('#dw').text(list_data['dw_mc'] || '').data('dw_id', list_data['dw_id'] || 0);

        $('#sel_jjdw').text(list_data['jjdw_mc']).data('jjdw_id', list_data['jjdw_id']);
        $('#jjdw').text(list_data['jjdw_mc']).data('jjdw_id', list_data['jjdw_id']);

        $('#je').text(list_data['hszje'] || 0);

        var tmp_wfps = 0, tmp_wfsl = 0;
        if ($.nui.isTrue(list_data[fieldConfig.wfps_name])) {
            tmp_wfps = parseInt(list_data[fieldConfig.wfps_name]);
        } else {
            tmp_wfps = (parseInt(list_data['ps'] || 0) + parseInt(list_data['cxps'] || 0) - (list_data[fieldConfig['fhps_name']] || 0)).fixed();
        }

        if ($.nui.isTrue(list_data[fieldConfig.wfsl_name])) {
            tmp_wfsl = parseFloat(list_data[fieldConfig.wfsl_name]);
        } else {
            tmp_wfsl = (parseFloat(list_data['zsl'] || 0) + parseFloat(list_data['cxsl'] || 0) - (list_data[fieldConfig['fhsl_name']] || 0)).fixed();
        }

        $('#wfps').text(tmp_wfps || '');
        $('#cxps').val(list_data['cxps'] || '').data('old_val', list_data['cxps']);
        $('#wfsl').text(tmp_wfsl || '');
        $('#cxsl').val(list_data['cxsl'] || '').data('old_val', list_data['cxsl']);

        $('#hq').text((!!list_data['hq'] ? fun.formatDate(list_data['hq'], 'YY-MM-DD') : "")).data('hq', list_data['hq']);
        begin_lCalendar.format_value = (!!list_data['hq'] ? fun.formatDate(list_data['hq'], 'YYYY-MM-DD') : "");
        $('#hqts').val($.nui.isTrue($('#hq').text().trim()) ? (list_data['hqts'] || 0) : '');

        setCq(list_data['hq']);

        if ($.nui.isTrue(list_data['jjcd_mc'])) {
            $('#jjcd_mc').text(list_data['jjcd_mc'] || '暂无').data({
            }).css({
                'backgroundColor': list_data['jjcd_colour'],
            }).removeClass('black-import').addClass('white-import');//紧急程度
        } else {
            $('#jjcd_mc').text('暂无');
            $('#jjcd_mc').data({
            }).css({
                'backgroundColor': '#fff',
                'padding-left': 0
            }).removeClass('white-import').addClass('black-import');//紧急程度
        }
        $('#jjcd_mc').data({
            jjcd_id: list_data['jjcd'] || 0,
            jjcd_mc: list_data['jjcd_mc'] || '',
            colour: list_data['jjcd_colour'] || '',
        })

        if ($.nui.isTrue(list_data['zt'])) {
        $('#zt_mc').text(list_data['zt'] || '暂无').data({
            }).css({
                'backgroundColor': list_data['colour'],
            }).removeClass('black-import').addClass('white-import');
        } else {
            $('#zt_mc').text('暂无');
            $('#zt_mc').data({
            }).css({
                'backgroundColor': '#fff',
                'padding-left': 0
            }).removeClass('white-import').addClass('black-import');
        }

        $('#zt_mc').data({
            'zt': list_data['zt'] || '',
            'zt_id': list_data['zt_id'] || 0,
            'colour': list_data['colour'] || ''
        })
        // $('#zt_mc').text(list_data['zt'] || '暂无').data({
        //     'zt': list_data['zt'] || '',
        //     'zt_id': list_data['zt_id'] || 0,
        // });

        $('#bz').val(list_data['bz'] || '');

        if (list_data['cp_ys_bh'] === '色卡') {
            $('#lx,#dw,#jjdw').attr('disabled', true);
        }

        setJjslColor();

        if ($.nui.isTrue(list_data[fieldConfig.fhps_name]) || $.nui.isTrue(list_data[fieldConfig.fhsl_name])) {
            setPanelHide();
        } else {
        }

        switch (page_data['djlx']) {
            case 'bp_xsdd':
                if ($.nui.isTrue(list_data['is_has']) || $.nui.isTrue(list_data['is_dy']) ||
                    $.nui.isTrue(list_data['is_has_cgdd']) || $.nui.isTrue(list_data[fieldConfig.fhps_name])
                    || $.nui.isTrue(list_data[fieldConfig.fhsl_name])) {
                    $('#color_search_wrap,#fk,#kz,#gg,#lx').attr('disabled', true);
                }
                break;
            case 'bp_cgdd':
                if ($.nui.isTrue(list_data['kh_dd_dj_id']) && $.nui.isTrue(list_data['kh_dd_jl_id'])) {
                    // 当前记录行 是调用 客户订单 生成的，则：
                    // 以下字段不允许编辑：商品编号、商品名称、色号、颜色、客户
                    $('#color_search_wrap').attr('disabled', true);
                }

                if ($.nui.isTrue(list_data['is_has']) || $.nui.isTrue(list_data[fieldConfig.fhps_name])
                    || $.nui.isTrue(list_data[fieldConfig.fhsl_name])) {
                    // 订单被调用后，不允许修改 仓库、商品、颜色、单位、匹数、数量
                    $('#color_search_wrap,#fk,#kz,#gg').attr('disabled', true);
                }
                break;
        }

        ROW_DATA = $.extend({}, list_data);


        if (!__PAGE_DATA['__PAGE_EDIT']) {
            $('input,#dj,#jjdw,#sel_jjdw,#lx,#fk,#kz,#gg,#jjsl_val,#bz,#toggle,#color_search_wrap,#color').attr('disabled', true);
            $('#jjcd_wrap').attr('disabled', true);
        }

        var curr_cp_info = fun.getListInfoByKey(cp_list || [], list_data['cp_id']) || {};

        PAGE_INIT_DATA = {
            cp_id: curr_cp_info['id'] || 0,
            cp_bh: curr_cp_info['number'] || '',
            cp_mc: curr_cp_info['name'] || '',
            cp_ys_id: 0,
            cp_ys_bh: '',
            cp_ys_mc: '',
            fzsh: '',
            fzys: '',
            kcms: curr_cp_info['diff'] || '+',
            imgs: (curr_cp_info['imgs'] && curr_cp_info['imgs'].split(',')[0]) || '',
            dw_id: curr_cp_info['unit_id'] || 0,
            dw_mc: curr_cp_info['unit_name'] || '',
            fk: curr_cp_info['width'] || '',
            kz: curr_cp_info['weight'] || '',
            gg: curr_cp_info['spec'] || '',
            cf: curr_cp_info['component'] || '',
            unit_options: curr_cp_info['unit_options'] // 计价数量
        };
    }

    ROW_DATA = $.extend({}, list_data);

    // 如果进入的窗口是 ：客户订单、采购订单、采购来货结算、销售退货结算。
    // 如果进入的窗口是：销售开单、采购退货结算 且 当前仓库没有开启：条码管理。

    switch (page_data['djlx']) {
        case 'bp_xsdd':
        case 'bp_cgdd':
            $('#gg').val(ROW_DATA['gg'] || '');
            break;
    }

    initJdBtn();

    if (!__PAGE_DATA['__PAGE_EDIT']) {
        $('input').attr('disabled', true);
		//页面不可编辑时去掉，把placeholder置空
        $('#ps,#sl').attr('placeholder', '');
    }

    for (var i = 0; i < $('input').length; i++) {
        var ele = $('input').eq(i);
        if (!ele.attr('disabled')) {
            tmpJdDisabled.push(ele.attr('id'));
        }
    }

    if (!$('#dw').attr('disabled')) {
        tmpJdDisabled.push('dw');
    }
    if (!$('#jjdw').attr('disabled')) {
        tmpJdDisabled.push('jjdw');
    }


    if (ROW_DATA['is_jd']) {
    } else {
        for (var i = 0; i < tmpJdDisabled.length; i++) {
            // $('#' + tmpJdDisabled[i]).removeAttr('disabled');
        }
    }

    if (!Auth.check(Bills['djlx'], 'edit')) {
        $('input').attr('disabled', true);
    }
    // isShop();

    // 结单后页面不能编辑
    setDomDisabledByJlJd();

    showSeal(ROW_DATA);
    __PAGEDOM_DISABLED();

    back_ori_data = getRowSaveData();
}


//点击返回，或按键返回触发
function backCallback() {
    // 跟单页进来的，没有修改到直接返回
    if (page_data['initType'] == 'view' && $.nui.isEmpty(__VIEW_TO_EDIT)) {
        return closeAndSendEvent();
    }
    // if (page_data['initType'] === 'view' && !__VIEW_TO_EDIT) return closeAndSendEvent();

    back_save_data = getRowSaveData();

    console.log('JD_FROM_JL', JD_FROM_JL)

    // console.log(JSON.stringify(back_ori_data))
    // console.log(JSON.stringify(back_save_data))

    // if(back_ori_data['jjcd_mc']===null){
    //     back_save_data['jjcd_mc'] = null;
    // }
    // if(back_ori_data['jjcd_colour']===null){
    //     back_save_data['jjcd_colour'] = null;
    // }






    if (!JD_FROM_JL && !checkDataChange(back_ori_data, back_save_data)) {
        // if (JD_FROM_JL) {
        //     api.sendEvent({
        //         name: page_data.return_page,
        //         extra: {
        //             'status': 'close_win',
        //         }
        //     });
        // }
        return closeAndSendEvent();
    }

    // if (__DJ_DATA['is_jd'] && JD_FROM_JL) {
    //     fun.dialog({
    //         content: '您确定要保存吗？',
    //         btn: ['保存', '不保存', '取消'],
    //         shadeClose: false,
    //         className: 'data-change-skin',
    //         yes: function () {
    //             jdFun();
    //         },
    //         no: function () {
    //             api.closeWin();
    //         }
    //     });
    //     return;
    // }


    if (page_data['initType'] == 'view') {
        if (checkDataChange(back_ori_data, back_save_data) && !execFlag) {
            fun.dialog({
                content: '您确定要保存吗？',
                btn: ['保存', '不保存', '取消'],
                shadeClose: false,
                className: 'data-change-skin',
                yes: function () {
                    execBack = true;
                    toBackEvent();
                },
                no: function () {
                    return closeAndSendEvent();
                }
            });
        } else {
            return closeAndSendEvent();
        }
    } else {
        toBackEvent();
    }


    // 20200309 返回封装
    function toBackEvent() {
        __setRowData(null, {});

        if (page_data['djlx'] === 'bp_xsdd') {
            delete ROW_DATA['sszje'];
        }

        if ($.nui.isEmpty(__PAGE_DATA['edit_row']) && $.nui.isEmpty(ROW_DATA['zsl']) && $.nui.isEmpty(ROW_DATA['ps'])) {
            return closeAndSendEvent();
        } else {
            // if ($.nui.isEmpty(ROW_DATA['cp_ys_id'])) return fun.toast('请选择颜色！');

            if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && ($.nui.isTrue(parseFloat(ROW_DATA['zsl'] || 0)) || $.nui.isTrue(parseInt(ROW_DATA['ps'] || 0)))) return fun.toast('请选择颜色！');
            if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && $.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(parseInt(ROW_DATA['ps'] || 0))) {
                return closeAndSendEvent();
            }

            // if ($.nui.isEmpty(ROW_DATA['zsl']) && $.nui.isEmpty(ROW_DATA['ps'])) return fun.toast('请填写数量或匹数！');
            if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) return fun.toast('请选择计价单位！');


            if (!JD_FROM_JL) {
                ROW_DATA['djtz_jl_jd'] = 1;
                ROW_DATA['dj_jd_from_jd'] = 0;
            } else {
                ROW_DATA['djtz_jl_jd'] = 0;
                ROW_DATA['dj_jd_from_jd'] = 1;
            }

            if (__PAGE_DATA['edit_row']) {
                __JL_DATA.splice(__PAGE_DATA['row_index'], 1, ROW_DATA);
            } else {
                __JL_DATA.push(ROW_DATA);
            }

            var tmp_return_page = page_data['return_page'];

            if ($.nui.isTrue(page_data['__route'])) {
                if (page_data['kdbj_tmp']) {
                    page_data['return_page'] = page_data['kdbj_tmp']['return_page'];
                }
            }
            var is_save_djtz = (__DJ_DATA['is_fh'] || __DJ_DATA['is_has'] || __DJ_DATA['is_has_cgdd'] || __DJ_DATA['is_has_wwjg']) ||
                (ROW_DATA['is_has'] || ROW_DATA['is_has_cgdd'] || ROW_DATA['is_has_wwjg']);

            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    'status': 'update_rows',
                    'data': {
                        __JL_DATA: __JL_DATA,
                        save_djtz: is_save_djtz,
                        JD_FROM_JL: JD_FROM_JL,
                        CXPSSL_EDIT: CXPSSL_EDIT
                    }
                }
            });
            if (page_data['initType'] == 'view') {
                __ddSaveData({
                    callback: function () {
                        if (execBack) closeAndSendEvent();
                        if ($.nui.isTrue(page_data['__route'])) {
                            api.closeToWin({ name: tmp_return_page });
                        } else {
                            closeAndSendEvent();
                        }
                        execBack = false;
                    }
                });
            } else {
                if ($.nui.isTrue(page_data['__route'])) {
                    api.closeToWin({ name: tmp_return_page });
                } else {
                    closeAndSendEvent();
                }
            }
        }
    }
}

// 关闭当前页面，发送通知事件
function closeAndSendEvent() {
    api.sendEvent({
        name: page_data.return_page,
        extra: {
            'status': 'close_win',
        }
    });

    if (page_data['initType'] == 'view') {
        api.sendEvent({
            name: page_data.return_page,
            extra: {
                'status': 'refresh',
            }
        });
    }

    setTimeout(function () {
        if ($.nui.isTrue(__PAGE_DATA['edit_row'])) {
            api.closeWin();
        } else {
            api.closeToWin({ name: page_arr.choice_product });
        }
    }, 300);
}

// 20191126
// 更换颜色后事件
function setAfterChangeColor(options) {
    var _options = $.extend({ cp_ys_id: 0, cp_ys_bh: '', cp_ys_mc: '' }, options);

    var cp_ys_bh = _options['cp_ys_bh'];
    if (cp_ys_bh === '色卡') {
        shSkLx();
    } else {
        if ($('#lx').data('jg_lx') == 'sk') {
            $('#lx,#dw,#jjdw').removeAttr('disabled');
        }

        ROW_DATA['dw_id'] = __PAGE_DATA['list_data']['dw_id'] || 0;
        ROW_DATA['dw_mc'] = __PAGE_DATA['list_data']['dw_mc'] || '';

        __setUnit(ROW_DATA);
    }
    updateRowDataAmountAndMoney(null, ROW_DATA);

    $('#jjsl_val').text(ROW_DATA['jjsl'] || 0);
    setJjslColor();
}

// 设置从搜索页返回的值
function setSelectedValue(data) {
    switch (data['page_type']) {
        case 'cp_ys':
            $('#color_search').text((data['list_data']['number'] || '') + ' ' + (data['list_data']['name']));
            $('#color_search_wrap').data({
                'cp_ys_id': data['id'],
                'cp_ys_bh': data['list_data']['number'],
                'cp_ys_mc': data['list_data']['name']
            });

            // 20191126
            setAfterChangeColor({
                'cp_ys_id': data['id'],
                'cp_ys_bh': data['list_data']['number'],
                'cp_ys_mc': data['list_data']['name']
            });

            updateLx();
            updateDj();

            // setColorBtnDisplay();

            break;
        case 'dw':
            $('#dw').text(data['select_val']).data('dw_id', data['id']);
            __setRowData(null, { dw_id: data['id'], dw_mc: data['select_val'] }, {});

            if ($.nui.isEmpty($('#jjdw').data('jjdw_id'))) {
                $('#jjdw').text(data['select_val']).data('jjdw_id', data['id']);
            }

            break;
        case 'jjdw':
            $('#sel_jjdw').text(data['select_val']).data('jjdw_id', data['id']);

            ROW_DATA['jjdw_id'] = data['id'];
            ROW_DATA['jjdw_mc'] = data['select_val'];

            $('#jjdw').data('jjdw_id', data['id']);

            //20191023计价单位
            updateDataAfterChangeDw();
            cache_data['kcms'] = ROW_DATA['kcms'] || '+';
            cache_data['kc'] = ROW_DATA['kc'] || 0;
            cache_data['jjsl'] = ROW_DATA['jjsl'] || 0;
            cache_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
            cache_data['jjdw_mc'] = ROW_DATA['jjdw_mc'] || '';

            cache_data['kcms'] = ROW_DATA['kcms'] || '+';
            cache_data['kc'] = ROW_DATA['kc'] || 0;
            cache_data['jjsl'] = ROW_DATA['jjsl'] || 0;
            cache_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
            cache_data['jjdw_mc'] = ROW_DATA['jjdw_mc'] || '';

            break;
        case 'jjcd':
            var colour = (data['list_data']['config'] && data['list_data']['config']['colour'] || '');
            if ($.nui.isTrue(data['select_val'])) {
                $('#jjcd_mc').text(data['select_val'] || '暂无').css({
                    'backgroundColor': colour,
                    'padding-left': '0.25rem',
                }).removeClass('black-import').addClass('white-import');//紧急程度
                $('#jjcd_mc').data({
                    jjcd_id: data['id'] || 0,
                    jjcd_mc: data['select_val'] || '',
                    colour: colour || ''
                })
            } else {
                $('#jjcd_mc').text('暂无');
                $('#jjcd_mc').css({
                    'backgroundColor': '#fff',
                    'padding-left': 0
                }).removeClass('white-import').addClass('black-import');//紧急程度
                $('#jjcd_mc').data({
                    jjcd_id: 0,
                    jjcd_mc: '',
                    colour: ''
                })
            }
            break;
        case 'zt':
            // $('#zt_mc').text(data['select_val'] || '暂无').data({
            //     zt_id: data['id'] || 0,
            //     zt: data['select_val']
            // });
            var colour = (data['list_data']['colour'] || '');
            if ($.nui.isTrue(data['select_val'])) {
                $('#zt_mc').text(data['select_val'] || '暂无').css({
                    'backgroundColor': colour,
                    'padding-left': '0.25rem',
                }).removeClass('black-import').addClass('white-import');
                $('#zt_mc').data({
                zt_id: data['id'] || 0,
                    zt: data['select_val'] || '',
                    colour: colour
                })
            } else {
                $('#zt_mc').text('暂无');
                $('#zt_mc').css({
                    'backgroundColor': '#fff',
                    'padding-left': 0
                }).removeClass('white-import').addClass('black-import');
                $('#zt_mc').data({
                    zt_id: 0,
                    zt: '',
                    colour: ''
                })
            }
            break;
    }
}

//更新单价
function updateDj(callback) {
    getRowSaveData();

    // __PAGE_DATA['__DJ_DATA'] = __PAGE_DATA['__DJ_DATA'] || {};

    __getDj({
        data: {
            "djlx": Bills['djlx'],
            "wldw_id": __DJ_DATA['wldw_id'] || 0,
            "cp_id": ROW_DATA['cp_id'] || 0,
            "cp_ys_id": ROW_DATA['cp_ys_id'] || 0,
            "jjdw_id": ROW_DATA['jjdw_id'] || 0,
            "kdsj": __DJ_DATA['kdsj'] || fun.formatDate(new Date()),
            "dj_info": ROW_DATA['dj_info'] || {},
            "dd_dj_id": ROW_DATA['dd_dj_id'] || 0,
            "dd_jl_id": ROW_DATA['dd_jl_id'] || 0,
            "gx_id": ROW_DATA['gx_id'] || 0,

            // 获取成本价 需要用到 仓库、单位
            "ck_id": __PAGE_DATA['ck_info']['id'] || 0,
            "dw_id": ROW_DATA['dw_id'] || 0,
            // 标准价 最低价 需要用到类型
            // "jg_lx": fun.getValByKey(fun.getSaleLxData({ showAll: true }) || [], ROW_DATA['jg_lx_mc'], 'simple', 'name') || 'dh'
            "jg_lx": ROW_DATA['jg_lx'] || 'dh'
        },
        callback: function (res) {
            if (res['status'] == 0) {
                // $('#dj').val(res['data']['dj']);
                __setRowData(null, { dj: res['data']['dj'] }, { setSsj: true });
                $('#dj').val(ROW_DATA['hsdj'] || 0);
                // 获取上次价
                if (__PAGE_DATA.loadScdj) {
                    ROW_DATA.scdj = res.data.scdj;
                }
            }
        }
    });
}

// 更新类型
function updateLx() {
    if ($('#color_search_wrap').data('cp_ys_bh') === '色卡') {
        shSkLx();
    } else if (__PAGE_DATA['ck_info']['type'] === 'skyb') {
        $('#lx').text('样版').data('jg_lx', 'yb');
    } else {
        if ($('#lx').data('jg_lx') && $('#lx').data('jg_lx') != 'dh') {

        } else {
            $('#lx').text('大货').data('jg_lx', 'dh');
        }
    }
}

// 20191126
// 色号为色卡时更新单位、计价单位、类型
function shSkLx() {
    var jjdw_list = fun.getItem('jjdw_list') || [];
    var sk_dw_id = fun.getValByKey(jjdw_list || [], '份', 'id', 'name');
    var sk_dw_mc = '份';

    ROW_DATA['dw_id'] = sk_dw_id;
    ROW_DATA['dw_mc'] = sk_dw_mc;
    ROW_DATA['jjdw_id'] = sk_dw_id;
    ROW_DATA['jjdw_mc'] = sk_dw_mc;
    // ROW_DATA['jg_lx'] = 'sk';
    // ROW_DATA['jg_lx_mc'] = '色卡';

    // $('#lx').text('色卡').data('jg_lx', 'sk').attr('disabled', true);
    $('#dw').text(sk_dw_mc).data('dw_id', sk_dw_id).attr('disabled', true);
    $('#jjdw').text(sk_dw_mc).data('jjdw_id', sk_dw_id).attr('disabled', true);
}

// 选产品后设置单位
function __setUnit(list_data) {
    $('#dw').text(list_data['dw_mc'] || '单位').data('dw_id', list_data['dw_id'] || 0);
    var cp_list = fun.getItem('cp_list') || [];
    var jjdw_list = fun.getItem('jjdw_list') || [];
    // 根据 往来单位类型, 赋值 档案 预设的 计价单位
    var unit_options = fun.getValByKey(cp_list || [], list_data['cp_id'], 'unit_options');

    switch (Bills['wldw_type']) {
        case 'kh':
            list_data['jjdw_id'] = unit_options['xsdw_id'];
            break;
        case 'gys':
            list_data['jjdw_id'] = unit_options['cgdw_id'];
            break;
        case 'jgs':
            list_data['jjdw_id'] = unit_options['jgdw_id'];
            break;
    }

    list_data['jjdw_mc'] = fun.getValByKey(jjdw_list || [], list_data['jjdw_id'], 'name');

    if ($.nui.isEmpty(list_data['jjdw_id'])) {
        list_data['jjdw_id'] = list_data['dw_id'] || 0;
        list_data['jjdw_mc'] = list_data['dw_mc'] || '';
    }

    $('#jjdw').text(list_data['jjdw_mc'] || ' ').data('jjdw_id', list_data['jjdw_id'] || 0);

    // 有开启一匹多仓库,则要赋值 单位2
    if ($.nui.isTrue(SYS_CONFIG['ypbddwgl'])) { // 有问题
        list_data['dw2_id'] = unit_options['dw2_id'] || 0;
        list_data['dw2_mc'] = fun.getValByKey(jjdw_list || [], list_data['dw2_id']);
    }
}

// 获取记录行保存数据
function getRowSaveData() {
    $('#hqts').blur();
    var list_data = __PAGE_DATA['list_data'] || {};

    __PAGE_DATA['ck_info'] = __PAGE_DATA['ck_info'] || {};

    var data3 = {
        "ck_id": __PAGE_DATA['ck_info']['id'] || 0,
        "ck_mc": __PAGE_DATA['ck_info']['name'] || '',
        "cp_id": $('#header_title').data('cp_id') || 0,
        "cp_bh": $('#header_title').data('cp_bh') || '',
        "cp_mc": $('#header_title').data('cp_mc') || '',
        "cp_ys_id": $('#color_search_wrap').data('cp_ys_id') || 0,
        "cp_ys_bh": $('#color_search_wrap').data('cp_ys_bh') || '',
        "cp_ys_mc": $('#color_search_wrap').data('cp_ys_mc') || '',
        "fk": $('#fk').val().trim(),
        "kz": $('#kz').val().trim(),
        // "gh": $('#gh').val().trim(),
        "gg": $('#gg').val().trim(),
        "jg_lx_mc": '大货',
        "jg_lx": 'dh',
        "ps": parseInt($('#ps').val().trim() || 0),
        "dw_id": $('#dw').data('dw_id') || 0,
        "dw_mc": $('#dw').text().trim(),
        "zsl": parseFloat($('#sl').val().trim() || 0),
        "jjdw_id": $('#jjdw').data('jjdw_id') || 0,
        "jjdw_mc": fun.getValByKey(fun.getItem('jjdw_list') || [], $('#jjdw').data('jjdw_id') || 0) || '',

        "hsdj": parseFloat($('#dj').val().trim() || 0),

        bz: $('#bz').val().trim() || '',
        //20190920 新增保存数据
        jjcd: $('#jjcd_mc').data('jjcd_id') || 0,
        jjcd_mc: $('#jjcd_mc').data('jjcd_mc') || '',
        jjcd_colour: $('#jjcd_mc').data('colour') || '',

        zt_id: $('#zt_mc').data('zt_id') || 0,
        zt: $('#zt_mc').data('zt') || '',
        colour: $('#zt_mc').data('colour') || '',

        hqts: $('#hqts').val().trim(),
        hq: $('#hq').data('hq') || ''
    };

    data3['cxps'] = parseFloat($('#cxps').val().trim() || 0);
    data3['cxsl'] = parseFloat($('#cxsl').val().trim() || 0);

    data3[fieldConfig['wfps_name']] = parseFloat($('#wfps').text().trim() || 0);
    data3[fieldConfig['wfsl_name']] = parseFloat($('#wfsl').text().trim() || 0);

    ROW_DATA = $.extend({}, list_data, ROW_DATA, data3);

    if (typeof ROW_DATA['jjsl'] === 'undefined') {
        ROW_DATA['jjsl'] = 0;
    }

    if ($.nui.isEmpty(ROW_DATA['jjsl'])) {
        ROW_DATA['jjsl'] = 0;
    }

    switch (page_data['djlx']) {
        case 'bp_xsdd':
        case 'bp_cgdd':
            break;
    }

    delete ROW_DATA['mx'];

    list_data = list_data || {};
    ROW_DATA = ROW_DATA || {};

    if (list_data['jjcd_mc'] === null && ROW_DATA['jjcd_mc'] === '') {
        ROW_DATA['jjcd_mc'] = null
    }

    if (list_data['jjcd_colour'] === null && ROW_DATA['jjcd_colour'] === '') {
        ROW_DATA['jjcd_colour'] = null
    }

    if (list_data['zt'] === null && ROW_DATA['zt'] === '') {
        ROW_DATA['zt'] = null
    }

    if (list_data['colour'] === null && ROW_DATA['colour'] === '') {
        ROW_DATA['colour'] = null
    }
    return ROW_DATA;
}

//更新数据更改单位之后
function updateDataAfterChangeDw() {
    // jjObj = {
    //     kcms: $('.symbol.active').data('type') || '',
    //     kc: $('#kc').val().trim(),
    //     jjdw_id: $('#sel_jjdw').data('jjdw_id'),
    //     jjdw_mc: $('#sel_jjdw').text(),
    //     jjsl: $('#jjsl').val(),
    //     jjsfscks: $('.check-box').hasClass('check-choice')
    // };

    ROW_DATA['kcms'] = $('.symbol.active').data('type') || '';
    ROW_DATA['kc'] = $('#kc').val().trim();
    ROW_DATA['jjdw_id'] = $('#sel_jjdw').data('jjdw_id');
    ROW_DATA['jjdw_mc'] = $('#sel_jjdw').text();
    // ROW_DATA['jjsl'] = $('#jjsl').val();

    if (ROW_DATA['kcms'] == '-') {
        ROW_DATA['kcms'] = '+';
        ROW_DATA['kc'] = -parseFloat(ROW_DATA['kc'] || 0);
    }
    $('#jjsl_val').text(ROW_DATA['jjsl']);
    setJjslColor();
    $('#jjdw').text(ROW_DATA['jjdw_mc']).data(ROW_DATA['jjdw_id']);

    jjsfssl = $('.check-box').hasClass('check-choice');
    if (jjsfssl) {
        var num = fun.dwhs({
            dw: ROW_DATA['dw_mc'] || '',
            jjdw: ROW_DATA['jjdw_mc'] || '',
            jjsl: ROW_DATA['jjsl'] || 0,
            kcms: ROW_DATA['kcms'] || '+',
            kc: ROW_DATA['kc'] || 0,
            ps: ROW_DATA['ps'] || 0,
            is_back: true, //反算
        });

        ROW_DATA['zsl'] = num;
    } else {
        // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
    }

    // __setRowData(null, {
    //     jjsl: ROW_DATA['jjsl'] || 0,
    //     // zsl: ROW_DATA['zsl'] || 0,
    //     // kcms: ROW_DATA['kcms'] || '',
    //     // kc: parseFloat(ROW_DATA['kc'] || 0),
    //     // jjdw_id: ROW_DATA['jjdw_id'] || 0,
    //     // jjdw_mc: ROW_DATA['jjdw_mc'] || ''
    // });

    var dwhs_data = {};

    if (cache_data['kcms'] != ROW_DATA['kcms']) {
        dwhs_data['kcms'] = ROW_DATA['kcms'] || '+';
    }
    if (cache_data['kc'] != ROW_DATA['kc']) {
        dwhs_data['kc'] = ROW_DATA['kc'] || 0;
    }
    // if (cache_data['jjsl'] != ROW_DATA['jjsl']) {
    //     dwhs_data['jjsl'] = ROW_DATA['jjsl'] || 0;
    // }
    if (cache_data['jjdw_id'] != ROW_DATA['jjdw_id']) {
        dwhs_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
    }

    dwhs_data['zsl'] = ROW_DATA['zsl'] || 0;

    if ($.nui.isTrue(dwhs_data)) {
        __setRowData(null, dwhs_data);
    }

    if (jjsfssl) {
        ROW_DATA['jjsl'] = parseFloat($('#jjsl').val() || 0);
    } else {
        // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
    }


    $('#sl').val(ROW_DATA['zsl']);
    $('#jjsl_val').text(ROW_DATA['jjsl']);
    $('#jjsl').val(ROW_DATA['jjsl']);

    //     setRowDataJjsl({
    //         kcms: jjObj['kcms'] || '',
    //         kc: parseFloat(jjObj['kc'] || 0),
    //         jjdw_id: jjObj['jjdw_id'] || 0,
    //         jjdw_mc: jjObj['jjdw_mc'] || '',
    //     });
    //
    //     var __data = $.nui.isEmpty(store_data) ? getData() : store_data;

    //记录行匹数小于2时，则 计价数量允许反算出数量
    if (ROW_DATA['ps'] < 2) {
        //有开启 计价数反算出数量
        if (jjsfssl) {
            var num = fun.dwhs({
                dw: ROW_DATA['dw_mc'] || '',
                jjdw: ROW_DATA['jjdw_mc'] || '',
                jjsl: ROW_DATA['jjsl'] || 0,
                kcms: ROW_DATA['kcms'] || '+',
                kc: ROW_DATA['kc'] || 0,
                fk: ROW_DATA['fk'] || '',
                kz: ROW_DATA['kz'] || '',
                ps: ROW_DATA['ps'] || 0,
                is_back: true
            });

            ROW_DATA['zsl'] = num;
            ROW_DATA['jjsl'] = $('#jjsl').val() || 0;

            $('#jjsl_val').text(ROW_DATA['jjsl']);
            $('#sl').val(ROW_DATA['zsl']);
            setJjslColor();

            var t_mx = ROW_DATA['mx'] || [];
            var t_data = {};

            if ($.nui.isEmpty(t_mx)) {
                t_data = { zsl: num, no_calc_jjsl: 1 };/*, is_fs: 1*/
                if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                    t_data['ps'] = 1;
                    t_data['mx'] = [{ px: 1, ph: 1, sl: num }];
                }
            } else {
                var isPush = true;
                for (var i = 0; i < t_mx.length; i++) {
                    if ($.nui.isTrue(t_mx[i]['is_delete'])) continue;
                    if ((t_mx[i]['tm_sl'] > 0) && (num > 0)) {
                        // 如果当前仓库有开启：不负库存
                        // 当用户修改的数量大于该布匹对应的库存数时，修改无效。
                        if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_minus'))) {
                            if (num > t_mx[i]['tm_sl']) num = t_mx[i]['sl'] || 0;
                        }
                    }
                    t_mx[i]['sl'] = num;
                    isPush = false;
                }

                if (isPush && $.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                    t_mx.push({ px: 1, ph: 1, sl: num })
                }
                t_data = { zsl: num/*, is_fs: 1*/, no_calc_jjsl: 1 };
            }

            __setRowData(null, t_data);

            $('#ps').val(ROW_DATA['ps']);
        }
    }
    setJjslColor();

    if ((cache_data['jjdw_id'] != ROW_DATA['jjdw_id'])) {
        updateDj();
    }

}


// 改变单价后事件
function afterGetRowData() {
    // var _options = $.extend({ setDj: true, setJe: true }, options);
    $('#je').text(ROW_DATA['hszje'] || 0);
    $('#ssj').val(ROW_DATA['ssdj'] || 0);
    var ssje = 0
    if (page_data.djlx != 'bp_xsdd') {
        ssje = ROW_DATA['sszje'] || 0;
    } else {
        ssje = ROW_DATA['ssje'] || 0;
    }
    $('#ssje').val(ssje);
    $('#hk').val($.nui.decimalSub((ROW_DATA['hszje'] || 0), ssje));
}

// 记录表单元格编辑后触发的事件
function setRowData(index, data, opt, _data) {
    switch (page_data.djlx) {
        case 'bp_xsdd':
            //如果没有开启实售价 则拿单价字段
            if ($.nui.isEmpty(SYS_CONFIG[Bills['config']['qyssjms']])) {// || opt['setSsj']
                _data['ssdj'] = _data['dj'];
            } else {
                if (typeof _data['ssdj'] === 'undefined') {
                    _data['ssdj'] = parseFloat(_data['dj'] || 0);
                } else {
                    _data['ssdj'] = parseFloat(_data['ssdj'] || 0);
                }
            }
            _data['ssje'] = (_data['ssdj'] * (_data['jjsl'] || 0)).fixed();


            // 自定义费用
            for (var i = 1; i <= 5; i++) _data['ssje'] += parseFloat(_data['fy_zdy' + i] || 0);
            _data['ssje'] = __jeSswr(_data['ssje']);
            break;
    }
}

// 初始化图片 --new
function initImgs(list_data) {
    cp_list = fun.getItem('cp_list') || [];
    var img_url;
    if (list_data['imgs']) {
        img_url = fun.getImgPath(list_data['imgs']);
    } else if (list_data['cp_imgs']) {
        img_url = fun.getImgPath(list_data['cp_imgs']);
    } else {
        var cp_id = $('#header_title').data('cp_id');
        var cp_info = fun.getListInfoByKey(cp_list, cp_id);

        var cp_imgs = cp_info['imgs'] || '';

        img_url = cp_imgs ? fun.getImgPath(cp_imgs) : "../img/logo.png";
    }

    if (img_url == "../img/logo.png") {
        $('#preview').css({
            'background-color': '#f5f5f5',
            'border-radius': '0.25rem',
        });
    } else {
        $('.img-logo').attr('src', img_url).css({
            'width': '100%',
            'height': '100%',
            'opacity': 1,
            'margin': 0,
        });
        $('.img-mask').show();
    }
}

// 标题初始化后 --new
function afterInitHeader(list_data) {
    $('#header_title').html((list_data['cp_bh'] || '') + ' ' + (list_data['cp_mc'] || ''));
    $('#header_title').data({
        cp_id: list_data['cp_id'],
        cp_bh: list_data['cp_bh'],
        cp_mc: list_data['cp_mc'],
    });
    // if (__PAGE_DATA['__PAGE_EDIT']) {
    //     $('#complete_btn').show();
    // } else {
    //     $('#complete_btn').hide();
    // }
}


function bindEvent() {

}
$('body').on('input', '#cxps,#cxsl', function (e) {
    CXPSSL_EDIT = true;
});

//加减匹
$('body').on('blur', '#cxps', function (e) {
    e.stopPropagation();
    var value = $(this).val().trim();
    if (isNaN(value)) value = 0;
    value = $.nui.isEmpty(value) ? 0 : parseInt(value);
    var oldValue = $(this).data('old_val') || 0;

    // 如果 加/减匹 为负数，当输入的 加/减匹 <  –（数量 – 来货匹） 时，自动跳回原来的值
    if ((value < 0) && (value < (-((ROW_DATA['ps'] || 0) - (ROW_DATA[fieldConfig['fhps_name']] || 0))))) {
        $(this).val(parseFloat(oldValue || 0));
    }
    $(this).data('old_val', $(this).val());

    var wfps = (parseInt(ROW_DATA['ps'] || 0) + parseInt($(this).val() || 0) - (ROW_DATA[fieldConfig['fhps_name']] || 0)).fixed();
    $('#wfps').text(wfps);
    if($.nui.isEmpty(ROW_DATA['ps']) && $.nui.isEmpty(ROW_DATA[fieldConfig['fhps_name']])) {
        $('#wfps').text('');
    }
    if($.nui.isEmpty(ROW_DATA['zsl']) && $.nui.isEmpty(ROW_DATA[fieldConfig['fhsl_name']])) {
        $('#wfsl').text('');
    }
});
//加减数
$('body').on('blur', '#cxsl', function (e) {
    e.stopPropagation();

    var value = $(this).val().trim();
    if (isNaN(value)) value = 0;
    value = $.nui.isEmpty(value) ? 0 : parseFloat(value);
    var oldValue = $(this).data('old_val') || 0;

    // 如果 加/减数 为负数，当输入的 加/减数 <  –（数量 – 来货数） 时，自动跳回原来的值
    if ((value < 0) && (value < (-((ROW_DATA['zsl'] || 0) - (ROW_DATA[fieldConfig['fhsl_name']] || 0))))) {
        $(this).val(parseFloat(oldValue || 0));
    }

    $(this).data('old_val', $(this).val());

    var wfsl = (parseFloat(ROW_DATA['zsl'] || 0) + parseFloat($(this).val() || 0) - (ROW_DATA[fieldConfig['fhsl_name']] || 0)).fixed();
    $('#wfsl').text(wfsl);
});

// 单位
$('body').on('tap', '#dw', function (e) {
    if (!showKeyBoard) return;
    if ($(this).attr('disabled') || $(this).attr('abcdisabled')) return;
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            "return_page": html_name,
            "page_type": 'dw',
            "return_type": 'dw'
        }
    });
});

// 换颜色
$('body').on('tap', '#color_search_wrap', function (e) {
    if ($(this).attr('disabled') || $(this).attr('readonly')) return;
    if ($(this).find('#color_search').attr('disabled')) return;

    var cp_id = $('#header_title').data('cp_id');
    var cp_list = fun.getItem('cp_list') || [];

    var tmp_data = fun.getListInfoByKey(cp_list, cp_id) || {};

    var ck_id = (__PAGE_DATA['ck_info'] && __PAGE_DATA['ck_info']['id']) || 0;
    tmp_data['imgs'] = tmp_data['imgs'] || '';
    var cpbj_info = {
        cp_id: tmp_data['id'] || 0,
        cp_bh: tmp_data['number'] || '',
        cp_mc: tmp_data['name'] || '',
        cp_ys_id: 0,
        cp_ys_bh: '',
        cp_ys_mc: '',
        fzsh: '',
        fzys: '',
        kcms: tmp_data['diff'] || '+',
        imgs: tmp_data['imgs'].split(',')[0] || '',
        dw_id: tmp_data['unit_id'] || 0,
        dw_mc: tmp_data['unit_name'] || '',
        fk: tmp_data['width'] || '',
        kz: tmp_data['weight'] || '',
        gg: tmp_data['spec'] || '',
        cf: tmp_data['component'] || ''
    };
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            return_page: html_name,
            cp_id: cp_id,
            page_type: 'cp_ys',
            clearData: false,
            cpbj_info: cpbj_info,
            NOT_SHOW_SK: fun.getHouseValue(ck_id, 'type') !== 'skyb',
            djlx: page_data['djlx'],
            ck_id: ROW_DATA['ck_id'] || 0,
            __JL_DATA: __JL_DATA
        }
    });
});

// 大图预览
$('body').on('tap', '.img-box', function (e) {
    e.preventDefault();
    e.stopPropagation();
    var cp_id = $('#header_title').data('cp_id');

    var cp_info = fun.getListInfoByKey(cp_list, cp_id);
    var cp_imgs = cp_info['imgs'] || '';

    if ($.nui.isEmpty(cp_imgs)) return;
    var img_arr = [];
    cp_imgs = cp_imgs.split(',');

    if ($.isArray(cp_imgs)) {
        for (var i = 0; i < cp_imgs.length; i++) {
            img_arr.push(fun.getImgPath(cp_imgs[i], true));
        }
    } else {
        img_arr.push(fun.getImgPath(cp_imgs, true));
    }
    if (img_arr.length === 0) return;
    photoBrowser.open({
        images: img_arr,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        } else {
        }
    });
    return false;
});

// 点击幅宽克重缸号
$('body').on('click', '#fk,#kz,#gh', function (e) {
    if ($(this).attr('disabled')) return;
    // $(this).select();
    // this.selectionStart = 0;
    // this.selectionEnd = $(this).val().length;
    // $(this).focus().select();
});

// 监听幅宽、克重、缸号输入
$('body').on('input', '#fk,#kz,#gh', function (e) {
    var key = $(this).attr('id');
    var _data = {};
    _data[key] = $(this).val();
    __setRowData(null, _data, {});
});

// 点击body
$('body').on('tap', function (e) {
    e.stopPropagation();
    var target = $(e.target);
    if (target.is('#back_btn') || target.is('.layui-m-layershade')
        || target.is('.layui-m-layermain') || target.is('.layui-m-layermain *')) return;
    if (cache_data['target'] == 'mx') {

    } else {
        __setRowData(null, {});
        $('#jjsl_val').text(ROW_DATA['jjsl'] || '');
    }

    cache_data['target'] = '';
    $('#value').val('');
    $('input').removeClass('active-border');
    setPanelHide();
    setJjslColor();
});

// 计价数量点击
$('body').on('click', '#jjsl_val', function (e) {
    if ($(this).attr('disabled')) return;
    var html = [];
    var style = 'width:92%;height:10.5rem;border:none;background:#fff; border-radius: 0.5rem; position:absolute; top: 30%; left: 4%;';
    html.push('<span class="title">计价</span>');
    html.push('<ul class="list-group">');
    html.push('<li class="item">');
    html.push('		<div class="text-box"><span>空差</span></div>');
    html.push('		<div class="right"><div class="symbol" data-type="+"><span>+</span></div>');
    html.push('		<div class="symbol" data-type="-"><span>-</span></div>');
    html.push('		<div class="symbol" data-type="×" data-type2="*"><span>×</span></div>');
    html.push('		<div class="symbol" data-type="÷" data-type2="/"><span>÷</span></div>');
    html.push('		<input id="kc" type="text" class="input-box equal num-input" num_type="2" decimal_digits="4"/></div>');
    html.push('</li>');
    html.push('<li class="item">');
    html.push('<div class="text-box"><span>计价数</span></div>');
    html.push('<input id="jjsl" type="text" class="input-box num-input" num_type="2" decimal_digits="4"/>');
    // html.push('<select name="" class="input-box drop-down"><option>公斤</option><option>克</option></select>');
    html.push('<div id="sel_jjdw_wrap" class="input-box drop-down"><span id="sel_jjdw" class="ellipsis-span">公斤</span><i class="iconfont icon-xia down-icon"></i></div>');
    html.push('</li>');

    // if (page_data['list_data'] && !($.nui.isTrue(page_data['list_data']['fhps']) || $.nui.isTrue(page_data['list_data']['fhsl']))) {

    // if ($.nui.isEmpty(page_data['list_data'])) {
    if (page_data['djlx'] == 'bp_xsfhjs' && $.nui.isEmpty($('#sl').attr('disabled')) && ROW_DATA['ps'] < 2) {
        html.push('<li class="last-item">');
        html.push('		<div class="check-box"><i class="iconfont icon-check"></i></div>');
        html.push('		<span class="inverse">计价数反算出库数</span>');
        html.push('</li>');
    }

    // }

    html.push('</ul>');
    html.push('<button id="confirm" class="confirm button">确认</button>');
    html.push('<button class="cancel button">取消</button>');
    layer.open({
        type: 1,
        content: html.join(''),
        style: style,
        skin: 'jj-info',
        shadeClose: false,
        success: function (layero, index) {
            if (ROW_DATA['jjdw_mc'] === '份') $('#sel_jjdw_wrap').attr('disabled', true);
            else { $('#sel_jjdw_wrap').removeAttr('disabled'); }
            cache_data['kcms'] = ROW_DATA['kcms'] || '+';
            cache_data['kc'] = ROW_DATA['kc'] || 0;
            cache_data['jjsl'] = ROW_DATA['jjsl'];
            cache_data['jjdw_id'] = ROW_DATA['jjdw_id'];
            cache_data['jjdw_mc'] = ROW_DATA['jjdw_mc'];

            if ('*/'.indexOf(ROW_DATA['kcms'] || '+') > -1) {
                $('.symbol[data-type2="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
            } else {
                $('.symbol[data-type="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
            }


            $('#kc').val(Math.abs(ROW_DATA['kc'] || 0));
            if (ROW_DATA['kc'] < 0) {
                $('.symbol[data-type="-"]').addClass('active').siblings().removeClass('active');
            }

            $('#jjsl').val(ROW_DATA['jjsl']);
            $('#sel_jjdw').text(ROW_DATA['jjdw_mc']).data('jjdw_id', ROW_DATA['jjdw_id']);

            if (jjsfssl) {
                $('.check-box').addClass('check-choice');
            } else {
                $('.check-box').removeClass('check-choice');
            }

            // 选择空差模式
            $('.symbol').on('tap', function (e) {
                $(this).addClass('active').siblings().removeClass('active');
            });

            // 点击跳转选择计价单位
            $('body').on('tap', '#sel_jjdw_wrap', function (e) {
                if ($(this).attr('disabled')) return;
                fun.showPageFull({
                    page_url: page_arr.select_list,
                    pageParam: {
                        "return_page": html_name,
                        "page_type": 'jjdw',
                        "return_type": 'jjdw'
                    }
                });
            });

            $('.cancel').on('click', function (e) {
                ROW_DATA['jjdw_id'] = cache_data['jjdw_id'];
                ROW_DATA['jjdw_mc'] = cache_data['jjdw_mc'];

                $('#jjdw').text(ROW_DATA['jjdw_mc']).data('jjdw_id', ROW_DATA['jjdw_id']);
                // updateDj();

                //20191023计价单位
                __setRowData(null, {
                    jjdw_id: cache_data['jjdw_id'],
                    jjdw_mc: cache_data['jjdw_mc']
                }, {});
                $('#jjsl_val').text(ROW_DATA['jjsl']);
                setJjslColor();

                layer.closeAll();
            });

            // 点击确定
            $('#confirm').on('click', function (e) {
                // jjObj = {
                //     kcms: $('.symbol.active').data('type') || '',
                //     kc: $('#kc').val().trim(),
                //     jjdw_id: $('#sel_jjdw').data('jjdw_id'),
                //     jjdw_mc: $('#sel_jjdw').text(),
                //     jjsl: $('#jjsl').val(),
                //     jjsfscks: $('.check-box').hasClass('check-choice')
                // };

                ROW_DATA['kcms'] = $('.symbol.active').data('type') || '';
                ROW_DATA['kc'] = $('#kc').val().trim();
                ROW_DATA['jjdw_id'] = $('#sel_jjdw').data('jjdw_id');
                ROW_DATA['jjdw_mc'] = $('#sel_jjdw').text();
                ROW_DATA['jjsl'] = $('#jjsl').val();

                if (ROW_DATA['kcms'] == '-') {
                    ROW_DATA['kcms'] = '+';
                    ROW_DATA['kc'] = -parseFloat(ROW_DATA['kc'] || 0);
                }
                $('#jjsl_val').text(ROW_DATA['jjsl']);
                setJjslColor();
                $('#jjdw').text(ROW_DATA['jjdw_mc']).data(ROW_DATA['jjdw_id']);

                jjsfssl = $('.check-box').hasClass('check-choice');
                if (jjsfssl) {
                    var num = fun.dwhs({
                        dw: ROW_DATA['dw_mc'] || '',
                        jjdw: ROW_DATA['jjdw_mc'] || '',
                        jjsl: ROW_DATA['jjsl'] || 0,
                        kcms: ROW_DATA['kcms'] || '+',
                        kc: ROW_DATA['kc'] || 0,
                        ps: ROW_DATA['ps'] || 0,
                        is_back: true, //反算
                    });

                    ROW_DATA['zsl'] = num;
                } else {
                    // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
                }

                // __setRowData(null, {
                //     jjsl: ROW_DATA['jjsl'] || 0,
                //     // zsl: ROW_DATA['zsl'] || 0,
                //     // kcms: ROW_DATA['kcms'] || '',
                //     // kc: parseFloat(ROW_DATA['kc'] || 0),
                //     // jjdw_id: ROW_DATA['jjdw_id'] || 0,
                //     // jjdw_mc: ROW_DATA['jjdw_mc'] || ''
                // });

                var dwhs_data = {};

                if (cache_data['kcms'] != ROW_DATA['kcms']) {
                    dwhs_data['kcms'] = ROW_DATA['kcms'] || '+';
                }
                if (cache_data['kc'] != ROW_DATA['kc']) {
                    dwhs_data['kc'] = ROW_DATA['kc'] || 0;
                }
                if (cache_data['jjsl'] != ROW_DATA['jjsl']) {
                    dwhs_data['jjsl'] = ROW_DATA['jjsl'] || 0;
                }
                if (cache_data['jjdw_id'] != ROW_DATA['jjdw_id']) {
                    dwhs_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
                }

                if ($.nui.isTrue(dwhs_data)) {
                    __setRowData(null, dwhs_data);
                }

                if (jjsfssl) {
                    ROW_DATA['jjsl'] = parseFloat($('#jjsl').val() || 0);
                } else {
                    // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
                }


                $('#sl').val(ROW_DATA['zsl']);
                $('#jjsl_val').text(ROW_DATA['jjsl']);
                $('#jjsl').val(ROW_DATA['jjsl']);

                //     setRowDataJjsl({
                //         kcms: jjObj['kcms'] || '',
                //         kc: parseFloat(jjObj['kc'] || 0),
                //         jjdw_id: jjObj['jjdw_id'] || 0,
                //         jjdw_mc: jjObj['jjdw_mc'] || '',
                //     });
                //
                //     var __data = $.nui.isEmpty(store_data) ? getData() : store_data;

                //记录行匹数小于2时，则 计价数量允许反算出数量
                if (ROW_DATA['ps'] < 2) {
                    //有开启 计价数反算出数量
                    if (jjsfssl) {
                        var num = fun.dwhs({
                            dw: ROW_DATA['dw_mc'] || '',
                            jjdw: ROW_DATA['jjdw_mc'] || '',
                            jjsl: ROW_DATA['jjsl'] || 0,
                            kcms: ROW_DATA['kcms'] || '+',
                            kc: ROW_DATA['kc'] || 0,
                            fk: ROW_DATA['fk'] || '',
                            kz: ROW_DATA['kz'] || '',
                            ps: ROW_DATA['ps'] || 0,
                            is_back: true
                        });

                        ROW_DATA['zsl'] = num;
                        ROW_DATA['jjsl'] = $('#jjsl').val() || 0;

                        $('#jjsl_val').text(ROW_DATA['jjsl']);
                        $('#sl').val(ROW_DATA['zsl']);
                        setJjslColor();

                        var t_mx = ROW_DATA['mx'] || [];
                        var t_data = {};

                        if ($.nui.isEmpty(t_mx)) {
                            t_data = { zsl: num, no_calc_jjsl: 1 };/*, is_fs: 1*/
                            if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                                t_data['ps'] = 1;
                                t_data['mx'] = [{ px: 1, ph: 1, sl: num }];
                            }
                        } else {
                            var isPush = true;
                            for (var i = 0; i < t_mx.length; i++) {
                                if ($.nui.isTrue(t_mx[i]['is_delete'])) continue;
                                if ((t_mx[i]['tm_sl'] > 0) && (num > 0)) {
                                    // 如果当前仓库有开启：不负库存
                                    // 当用户修改的数量大于该布匹对应的库存数时，修改无效。
                                    if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_minus'))) {
                                        if (num > t_mx[i]['tm_sl']) num = t_mx[i]['sl'] || 0;
                                    }
                                }
                                t_mx[i]['sl'] = num;
                                isPush = false;
                            }

                            if (isPush && $.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                                t_mx.push({ px: 1, ph: 1, sl: num })
                            }
                            t_data = { zsl: num/*, is_fs: 1*/, no_calc_jjsl: 1 };
                        }

                        __setRowData(null, t_data);

                        $('#ps').val(ROW_DATA['ps']);
                    }
                }
                setJjslColor();

                if ((cache_data['jjdw_id'] != ROW_DATA['jjdw_id'])) {
                    updateDj();
                }


                layer.closeAll();
            });
        }
    });
    fun.inputType();
});

// 点击规格
$('body').on('tap', '.gg-wrap', function (e) {
    e.stopPropagation();
    if ($(this).find('#gg').attr('disabled') || $(this).attr('disabled')) return;
    var cp_title = (ROW_DATA['cp_bh'] || '') + (ROW_DATA['cp_mc'] || '');
    var cp_id = $('#header_title').data('cp_id') || 0;
    var gg_name = $('#gg').val().trim();

    fun.showPageFull({
        page_url: page_arr.specifications,
        pageParam: {
            html_name: html_name,
            cp_title: cp_title,
            cp_id: cp_id,
            gg_name: gg_name
        }
    });
});

// 展开收缩
$('body').on('tap', '#toggle', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;
    if ($(this).find('.icon-toggle').hasClass('icon-xia')) {
        setPanelHide();
    } else {
        setPanelShow();
    }
});

// 点击输入框
$('body').on('tap', 'input', function (e) {
    var target = $(e.target);

    if (target.is('#value')) {
        e.stopPropagation();
        return false;
    } else {
        cache_data['target'] = '';
    }
});

// 监听计价数是否发生变化
$('body').on('input', '#jjsl', function (e) {
    $(this).addClass('ipt-change');
});

// 点击数字键盘显示区
$('body').on('tap', '#value', function (e) {
    e.stopPropagation();
    return false;
});

// 点击数字键盘
$('body').on('tap', '.layer-content', function (e) {
    e.stopPropagation();
    return false;
});

//绑定键盘按键
$('body').on('tap', '.num', function (e) {
    e.stopPropagation();
    // if ($.nui.isEmpty(cache_data['target'])) return;
    var val = $('#value');
    var key = $(this).attr('key');

    var vibrate = [];
    vibrate = (api.systemType == 'android') ? [10, 30] : [10];
    if (api.systemType == 'android') {
        api.notification({
            vibrate: vibrate,
        });
    }

    if (key == '.' && cache_data['target'] == 'ps') return;

    if (key == '.' && val.val().trim() === '') {
        val.val('0' + key);
    }

    if (key == '.' && val.val().indexOf('.') > -1) return;
    if (parseFloat((val.val().trim() + $(this).attr('key')) || 0) > 100000000) return fun.toast('输入数字不能超过100000000！');
    var tmpVal = val.val().trim();
    if (tmpVal.split('.')[1] && tmpVal.split('.')[1].length >= 4) return fun.toast('最多只能输入4位小数！');

    if (key != '.' && val.val().trim() === '0') {
        val.val(key);
    } else {
        val.val(val.val() + $(this).attr('key'));
    }

    switch (cache_data['target']) {
        case 'ps':
            $('#ps').val(val.val());
            __setRowData(null, { ps: parseInt($('#ps').val() || 0) }, {});
            break;
        case 'sl':
            $('#sl').val(val.val());

            var value = parseFloat($('#sl').val() || 0);
            var row = ROW_DATA;
            var zps = 0,
                mx = row['mx'] || [];
            if (value <= 0) {
                for (var i = 0; i < mx.length; i++) {
                    if ($.nui.isTrue(mx[i]['is_delete'])) continue;
                    mx[i]['is_delete'] = 1;
                }
            } else {
                for (var i = 0; i < mx.length; i++) {
                    if ($.nui.isTrue(mx[i]['is_delete'])) continue;
                    zps++;
                    if (zps >= 2) break;
                }
                var isPush = true;
                if (zps <= 1) {
                    for (var i = 0; i < mx.length; i++) {
                        if ($.nui.isTrue(mx[i]['is_delete'])) continue;
                        // 如果当前有值的信息是 明细表第一行的第一匹则直接修改值，反之则删除
                        mx[i]['sl'] = value;
                        isPush = false;
                        break;
                    }
                }
                // 判断明细表是否只有1匹，则把 记录表的 数量 赋值给 明细表
                if (isPush && $.nui.isTrue(__PAGE_DATA['ck_info']['is_detail'])) {
                    mx.push({
                        px: 1,
                        ph: 1,
                        sl: row['zsl']
                    });
                }
            }

            var _tmpJlRow = {
                zsl: value
            };
            if (zps === 1) _tmpJlRow['ps'] = 1;

            __setRowData(null, _tmpJlRow, {});

            $('#jjsl_val').text(ROW_DATA['jjsl'] || '');

            // setRowDataJjsl(_tmpJlRow);
            setJjslColor();
            break;
        case 'dj':

            break;
        case 'jjsl':

            break;
    }

    //震动
    // api.notification({
    //     vibrate: [10],
    //     // sound:'default',
    //     // sound: 'widget://res/audio/accept.mp3'
    // });

    setPanelShow();
});

// 点击单价全选
$('body').on('tap', '#dj,#ssj', function (e) {
    // $(this).select();
});

// 监听单价输入
$('body').on('input blur', '#dj', function (e) {
    __setRowData(null, { hsdj: $(this).val() }, {});
});

// 监听实售单价输入
$('body').on('input blur', '#ssj', function (e) {
    var _this = this;
    setTimeout(function () {
        __setRowData(null, { ssdj: $(_this).val() }, {});
    }, 1000);

});

// 匹数
$('body').on('tap', '#ps', function (e) {
    e.stopPropagation();

    if ($(this).attr('disabled')) return;

    // if (!$.nui.isTrue(__PAGE_DATA['edit_row'])) {
    $('input').removeClass('active-border');
    $(this).addClass('active-border');
    // }

    if (__PAGE_DATA['bj_type'] === 'mx') return;
    // $(this).select();
    cache_data['target'] = 'ps';
    $('#value').val($(this).val());
    // if(__PAGE_DATA['bj_type'] != 'mx') $(this).removeAttr('readonly');
    setPanelShow();
});

// 数量
$('body').on('tap', '#sl', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled') || $(this).attr('abcdisabled')) return;
    // if (!$.nui.isTrue(__PAGE_DATA['edit_row'])) {
    $('input').removeClass('active-border');
    $(this).addClass('active-border');
    // }

    if (__PAGE_DATA['bj_type'] == 'mx') return;
    cache_data['target'] = 'sl';
    $('#value').val($(this).val());
    // if(__PAGE_DATA['bj_type'] != 'mx') $(this).removeAttr('readonly');

    setJjslColor();
    setPanelShow();
});

//确定
$('body').on('tap', '#save-btn', function (e) {
    e.stopPropagation();
    switch (cache_data['target']) {
        case 'ps':
            if (__PAGE_DATA['bj_type'] == 'mx') return;
            $('#ps').val($('#value').val());
            $('#value').val('');

            __setRowData(null, { ps: parseInt($('#ps').val() || 0) });
            setPanelHide();
            break;
        case 'sl':
            if (__PAGE_DATA['bj_type'] == 'mx') return;
            $('#sl').val($('#value').val());
            $('#value').val('');

            __setRowData(null, { zsl: parseFloat($('#sl').val() || 0) });

            $('#jjsl_val').text(ROW_DATA['jjsl']);
            // $('#jjsl').val(ROW_DATA['jjsl']);

            setJjslColor();
            setPanelHide();
            break;
        case 'dj':

            break;
        case 'jjsl':

            break;
    }
    $('input').removeClass('active-border');
});

// 清除按钮绑定多个事件
$('body').delegate('#remove', {
    touchstart: function (e) {
        e.stopPropagation();
        longClick = 0; //设置初始为0
        timeOutEvent = setTimeout(function () { //此处为长按事件
            longClick = 1; //假如长按，则设置为1
            $('#value').val('');
            switch (cache_data['target']) {
                case 'ps':
                    $('#ps').val('');
                    __setRowData(null, { ps: 0 }, {});
                    break;
                case 'sl':
                    $('#sl').val('');
                    __setRowData(null, { zsl: 0 }, {});
                    $('#jjsl_val').text(ROW_DATA['jjsl'] || '');
                    setJjslColor();
                    break;
                case 'dj':

                    break;
                case 'jjsl':

                    break;
            }

            setClearBtnShow();
        }, 500);
    },
    touchmove: function (e) {
        e.stopPropagation();
        clearTimeout(timeOutEvent);
        timeOutEvent = 0;
        e.preventDefault();
    },
    touchend: function (e) {
        e.stopPropagation();
        clearTimeout(timeOutEvent);
        if (timeOutEvent != 0 && longClick == 0) { //此处为点击事件
            var val = $('#value');
            var valText = val.val();
            val.val(valText.substring(0, valText.length - 1));

            switch (cache_data['target']) {
                case 'ps':
                    $('#ps').val(val.val());

                    __setRowData(null, { ps: parseInt($('#ps').val() || 0) }, {});
                    break;
                case 'sl':
                    $('#sl').val(val.val());
                    __setRowData(null, { zsl: parseFloat($('#sl').val() || 0) }, {});
                    $('#jjsl_val').text(ROW_DATA['jjsl'] || '');
                    setJjslColor();
                    break;
                case 'dj':

                    break;
                case 'jjsl':

                    break;
            }
        }
        setClearBtnShow();
        var vibrate = [];
        vibrate = (api.systemType == 'android') ? [10, 30] : [10];

        if (api.systemType == 'android') {
            api.notification({
                vibrate: vibrate,
            });
        }
        return false;
    }
});

// 单位
$('body').on('tap', '#dw', function (e) {
    e.stopPropagation();
    if (!showKeyBoard) return;
    if ($(this).attr('disabled')) return;
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            "return_page": html_name,
            "page_type": 'dw',
            "return_type": 'dw'
        }
    });
});

// 类型
$('body').on('click', '#lx,#lx_icon', function (e) {
    e.preventDefault();
    var _id = $(this).attr('id');
    var val = '';
    switch (_id) {
        case 'lx':
            val = $(this).text().trim() || '';
            if ($(this).attr('disabled')) return;
            break;
        case 'lx_icon':
            val = $(this).prev().text().trim() || '';
            if ($(this).prev().attr('disabled')) return;
            break;
    }
    getRowSaveData();
    var list = fun.getSaleLxData({ ck_id: ROW_DATA['ck_id'], cp_ys_bh: ROW_DATA['cp_ys_bh'] });
    var val = $(this).text().trim() || '';
    $(list).each(function (i, arr) {
        if (arr['name'] == val) {
            list[i]['is_choose'] = 1;
        } else {
            list[i]['is_choose'] = 0;
        }
    });
    fun.showBookList({
        list: list,
        choose: function (val) {
            $('#lx').text(val['name']).data('jg_lx', val['id']);

            if (val['id'] === 'sk') {
                $('#dw').text('份').attr('disabled', true);
                $('#jjdw').text('份').attr('disabled', true);

                ROW_DATA['jjdw_mc'] = '份';
                ROW_DATA['dw_mc'] = '份';
            } else {

            }

            getRowSaveData();
            fun.showLoad();

            // __PAGE_DATA['__DJ_DATA'] = __PAGE_DATA['__DJ_DATA'] || {};

            __getDj({
                data: {
                    "djlx": Bills['djlx'],
                    "wldw_id": __DJ_DATA['wldw_id'] || 0,
                    "cp_id": ROW_DATA['cp_id'] || 0,
                    "cp_ys_id": ROW_DATA['cp_ys_id'] || 0,
                    "jjdw_id": ROW_DATA['jjdw_id'] || 0,
                    "kdsj": __DJ_DATA['kdsj'] || fun.formatDate(new Date()),
                    // 标准价 最低价 需要用到类型
                    "jg_lx": fun.getValByKey(fun.getSaleLxData({ showAll: true }) || [], ROW_DATA['jg_lx_mc'], 'simple', 'name') || 'dh'
                },
                callback: function (res) {
                    if (res['status'] == 0) {
                        var __data = {};
                        __data['lx'] = val['name'];
                        // __data['jg_lx_mc'] = val['name'];
                        // __data['jg_lx'] = val['simple'];
                        __data['simple'] = val['simple'];
                        __data['bzj'] = res['data']['bzj'] || 0;
                        __data['zdj'] = res['data']['zdj'] || 0;
                        __data['dj'] = res['data']['dj'] || 0;
                        __data['scdj'] = res['data']['scdj'] || 0;

                        __setRowData(null, __data, {});
                        $('#dj').val(ROW_DATA['hsdj'] || 0);
                    }
                    fun.hideLoad();
                }
            });
        }
    });
});

//2019-09-19 增加紧急标签
$('body').on('tap', '#jjcd_wrap', function (e) {
    if ($(this).attr('disabled')) return;
    layer.closeAll();
    fun.showPageFull({
        page_url: page_arr.urgent_level,
        pageParam: {
            return_page: html_name,
            list_id: $('#jjcd_mc').data('jjcd_id') || 0,
            page_type: 'jjcd'
        }
    })
});

// 选择状态
$('body').on('click', '#zt_wrap', function () {
    if ($(this).attr('disabled')) return;
    fun.showPageFull({
        page_url: page_arr.urgent_level,
        pageParam: {
            return_page: html_name,
            list_id: $('#zt_mc').data('zt_id') || 0,
            page_type: 'zt',
            url_type: 'xsdd',
        }
    });
})

function addDate(date, day) {
    var d = new Date(date.replace(/-/g, "/"));
    d.setDate(d.getDate() + day);
    var m = d.getMonth() + 1;
    return d.getFullYear() + '-' + m + '-' + d.getDate();
}

// 完成
$('body').on('tap', '#complete_btn', function (e) {
    e.stopPropagation();

    back_save_data = getRowSaveData();
    // console.log(JSON.stringify(back_ori_data))
    // console.log(JSON.stringify(back_save_data))
    if (!JD_FROM_JL && $.nui.isObjEquals(back_ori_data, back_save_data)) {
        if (page_data['initType'] === 'view') {
            refreshPage();
        } else {
            closeAndSendEvent();
        }
        return;
    }
    if (!JD_FROM_JL) {
        ROW_DATA['djtz_jl_jd'] = 1;
        ROW_DATA['dj_jd_from_jd'] = 0;
    } else {
        ROW_DATA['djtz_jl_jd'] = 0;
        ROW_DATA['dj_jd_from_jd'] = 1;
    }

    if (page_data['initType'] === 'view') {
        getRowSaveData();
        __JL_DATA[__PAGE_DATA['row_index']] = ROW_DATA;

        __ddSaveData(function () {
            $('#complete_btn').hide();
            setViewDomDisabled();
            __ddGetData(dj_id, jl_id, function () {
                __PAGE_DATA = page_data;
                // isShop();

                // 预加载数据
                fun.load_DATA_LIST(['cp', 'jjdw', 'sys_config'], function () {// 
                    cp_list = fun.getItem('cp_list') || []; //产品列表
                    jjdw_list = fun.getItem('jjdw_list') || []; //单位列表
                    SYS_CONFIG = fun.getItem('sys_config') || {}; //系统设置
                });
                showPhszHtml();
                init();
                $('.color-change,#settle,.settle-wrap').hide();
                $('#hq,#hqts,#gg,#gg_short,#zt_wrap,#jjcd_wrap,#jjsl_val').attr('disabled', true);
                begin_lCalendar.disabled = true;


            });
        });
    } else {
        var __result = addRow();

        switch (__result['status']) {
            case 'ok':
                fun.showLoad('生成单据中...');
                // 跳转 到 开单页            
                jumpToPage();
                break;
            case 'not_zsl_ps':
                // 跳转 到 开单页            
                jumpToPage();
                break;
        }
    }

    // jumpToPage();
    // 跳转 到 开单页
    function jumpToPage() {
        var is_save_djtz = (__DJ_DATA['is_fh'] || __DJ_DATA['is_has'] || __DJ_DATA['is_has_cgdd'] || __DJ_DATA['is_has_wwjg']) ||
            (ROW_DATA['is_has'] || ROW_DATA['is_has_cgdd'] || ROW_DATA['is_has_wwjg']);
        api.sendEvent({
            name: target_page,
            extra: {
                'status': 'update_rows',
                'data': {
                    __JL_DATA: __JL_DATA,
                    save_djtz: is_save_djtz,
                    JD_FROM_JL: JD_FROM_JL,
                    CXPSSL_EDIT: CXPSSL_EDIT
                }
            }
        });
        // api.sendEvent({
        //     name: target_page,
        //     extra: {
        //         'status': 'update_rows',
        //         'data': {
        //             __JL_DATA: __JL_DATA,
        //         }
        //     }
        // });

        setTimeout(function () {
            api.closeToWin({ name: target_page });
        }, 200);
    }
});

$('#hqts').on('keyup paste cut blur', function () {
    if ($(this).val() == '' || isNaN($(this).val())) {
        $('#hq').text('');
        $('#hq').data('hq', '');
        $('#cq').text('');
        $('#cq').siblings().text('超期');
        begin_lCalendar.format_value = fun.formatDate(fun.getNowFormatDate(), 'YYYY-MM-DD');
        return;
    } else if ($(this).val().length > 4) {
        $(this).val($(this).val().slice(0, 4))
    }
    var day = $(this).val();
    // if (isNaN(day)) day = 0;
    var _kdsj = fun.formatDate(__DJ_DATA['kdsj'], 'YYYY-MM-DD'),
        date = String(_kdsj),
        daysInt = parseInt(day);
    var val = addDate(date, daysInt);
    $('#hq').text(fun.formatDate(val, 'YY-MM-DD') || '').data('hq', val);
    begin_lCalendar.format_value = fun.formatDate(val, 'YYYY-MM-DD');
    setCq(val);
})

// 行记录添加方法
function addRow(options) {
    getRowSaveData();
    __setRowData(null, {});

    if ($.nui.isEmpty(ROW_DATA['cp_ys_id'])) {
        // 没有选颜色 但 有填 数量 或者 匹数 则要提示： 请选择颜色 
        if ($.nui.isTrue(parseFloat(ROW_DATA['zsl'] || 0)) || $.nui.isTrue(ROW_DATA['ps'])) {
            fun.toast('请选择颜色！');
            return { status: 'empty_ys', msg: '颜色不能为空' };
        }
    } else {
        // 有选颜色 但 数量、匹数 都没有填 
        if ($.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(ROW_DATA['ps'])) {
            if ($.nui.isEmpty(__PAGE_DATA['edit_row'])) {
                // 如果是新增的情况下，则代表 当次操作不保存
                return { status: 'ok' };
            }
        }
    }

    if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) {// || $.nui.isEmpty(ROW_DATA['jjdw_mc'])
        fun.toast('请选择计价单位！');
        return { status: 'empty_jjdw', msg: '计价单位不能为空' };
    }


    var TMP_ROW_DATA = $.extend({}, ROW_DATA);

    // 判断 匹数 数量 都不能为空 
    if ($.nui.isEmpty(__PAGE_DATA['edit_row']) && ($.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(ROW_DATA['ps']))) {
        return { status: 'ok' };
    } else {
        if (__PAGE_DATA['edit_row']) {
            __JL_DATA[__PAGE_DATA['row_index']] = TMP_ROW_DATA;
        } else {
            __JL_DATA.push(TMP_ROW_DATA);
        }

        return { status: 'ok' };
    }
}

// 浏览状态下获取数据
function __ddGetData(dj_id, jl_id, callback) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: Bills['AJAX_URL']['get'],
        data: { 'id': dj_id },
        success: function (res) {
            if (res['status'] == 0) {
                __ALL_DATA = $.extend({}, res.data);

                Bills.origin_data = res.data;

                __DJ_DATA = __ALL_DATA['dj'];
                __JL_DATA = __ALL_DATA['jl'];
                page_data['list_data'] = {};

                var jl = __JL_DATA || [];

                for (var i = 0; i < jl.length; i++) {
                    var val = jl[i];
                    if (val['id'] == jl_id) {
                        page_data['list_data'] = val;
                        page_data['row_index'] = i;
                        break;
                    }
                }
                var ck_list = fun.getItem('ck_list') || [];
                // page_data['is_shop'] = $.nui.isTrue(__DJ_DATA['is_shop']) ? 'shop' : '';
                page_data['bj_type'] = 'zs';
                page_data['ck_info'] = fun.getListInfoByKey(ck_list, page_data['list_data']['ck_id']);
                page_data['edit_row'] = true;
                page_data['__DJ_DATA'] = __DJ_DATA;
                page_data['__JL_DATA'] = __JL_DATA;

                page_data['__PAGE_EDIT'] = Auth.check(page_data['djlx'], 'edit') ? !__DJ_DATA['is_sh'] : false;

                if (typeof callback === 'function') callback();
            } else {
                return fun.toast('获取单据信息失败！');
            }
        }
    })
}

// 浏览状态下，点击编辑获取保存数据
function __ddGetSaveData() {
    var dj = {}, jl = [];

    dj = __DJ_DATA;
    jl = __JL_DATA;

    var tmp_total = getTotalInfo(__JL_DATA);

    dj['zps'] = tmp_total['zps'];
    dj['zsl'] = tmp_total['zsl'];
    dj['zjjsl'] = tmp_total['zjjsl'];
    dj['bdje'] = __bdjeSswr(tmp_total['bdje']);
    dj['hszje'] = tmp_total['hszje'];
    dj['zje'] = tmp_total['zje'];

    var data = { dj: dj, jl: jl };

    return data;
}

// function __saveOther(callback) {

//     var __other_jl = [];
//     // for (var i = 0; i < jl.length; i++) {
//     //     var __jl = jl[i];
//     var __other_data = {
//         id: ROW_DATA['id'] || 0,
//         dj_id: ROW_DATA['dj_id'] || 0,
//         hqts: Number(ROW_DATA['hqts']) || '',
//         hq: ROW_DATA['hq'] || null,
//         jjcd: ROW_DATA['jjcd'] || 0,
//         jjcd_mc: ROW_DATA['jjcd_mc'] || '',
//         jjcd_colour: ROW_DATA['jjcd_colour'] || '',
//         zt: $('#zt_mc').data('zt') || '',
//         zt_id: ROW_DATA['zt_id'] || 0,
//         colour: ROW_DATA['colour'] || '',
//         bz: ROW_DATA['bz'] || '',
//     };
//     __other_jl.push(__other_data);
//     // }

//     var _set_data = {
//         status: 'setOther',
//         jl: __other_jl,
//     };
//     console.log(JSON.stringify(_set_data))

//     fun.ajax({
//         showLoad: true,
//         hideLoad: true,
//         loadTitle: '保存中...',
//         url: Bills['AJAX_URL']['save'],
//         data: _set_data,
//         success: function (res) {
//             switch (res['status']) {
//                 case 0:
//                     if (typeof callback === 'function') callback();
//                     else {
//                         fun.toast('保存成功！');
//                         JD_FROM_JL = false;
//                         is_adjust_save = false;
//                         __VIEW_TO_EDIT = false;

//                         api.sendEvent({
//                             name: html_name,
//                             extra: {
//                                 'status': 'refresh_dj',
//                                 'data': {}
//                             }
//                         });

//                         api.sendEvent({
//                             name: page_data['return_page'],
//                             extra: {
//                                 'status': 'refresh',
//                                 'closeLayer': true
//                             }
//                         });
//                     }
//                     break;
//                 default:
//                     fun.toast(res['msg']);
//                     break;
//             }
//         }
//     });
// }

// 浏览状态下，点击编辑保存数据
function __ddSaveData(options) {
    var dj = {}, jl = [];

    getRowSaveData();
    var data = __ddGetSaveData();

    dj = data['dj'];
    var recordData = data['jl'];

    var _options = $.extend({ closePage: true, callback: null }, options);

    if ($.nui.isEmpty(dj['kdsj'])) return fun.toast('日期不能为空。');

    if (!Check.kzrq({ sj: dj['kdsj'] })) return false;
    if (!Check.yjrq({ sj: dj['kdsj'] })) return false;

    if ($.nui.isEmpty(dj['wldw_id'])) return fun.toast('客户不能为空。');

    if (dj['zh_je'] && !dj['zh_id']) return fun.toast('请选择账户！');
    if ($.nui.isEmpty(dj['zh_je'])) dj['zh_id'] = 0;

    var toSliceData = recordData.slice(0);

    for (var i = 0; i < recordData.length; i++) {
        var tmpData = recordData[i];

        // 如果 记录行 被删除, 则不需要判断 限制
        if ($.nui.isTrue(tmpData['is_delete'])) continue;
        if ($.nui.isEmpty(tmpData['ck_id'])) return fun.toast('请选择：【仓库】。');
        if ($.nui.isEmpty(tmpData['cp_ys_id'])) return fun.toast('请选择：【颜色】。');
        if ($.nui.isEmpty(tmpData['dw_id'])) return fun.toast('请选择：【单位】。');
        if ($.nui.isEmpty(tmpData['jjdw_id'])) return fun.toast('请选择：【计价单位】。');

        jl.push(tmpData);
    }

    if (jl.length && $.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']]) && !$.nui.isFieldValEqual('ck_id', jl)['res']) return fun.toast('一张单不允许多个仓库。');

    if (jl.length === 0) return fun.toast(tips_arr['空单提示']);

    __save();

    function __save() {
        var djIsSame = $.nui.isObjEquals(dj, Bills.origin_data.dj);
        var jlIsSame = jl.length == Bills.origin_data.jl.length;

        var jlChange = !$.nui.isObjEquals(jl, Bills.origin_data.jl);

        // 复核修改记录但没结单
        var fh_xg_no_jd = (__DJ_DATA['is_fh'] && !JD_FROM_JL);

        if (JD_FROM_JL || CXPSSL_EDIT
            || (__DJ_DATA['is_has'] && djIsSame && jlIsSame)) {
            // __adjust();
            // __saveOther(function () {
            //     
            // });
                __saveJd();
            return;
        }
        else if (fh_xg_no_jd) {
            if (execBack) {
                // __saveOther(function () {
                //     closeAndSendEvent();
                // });
                __saveJd();
            } else {
                // __saveOther();
                __saveJd();
            }
            return;
        } else {
            afterSave();
        }
    }



    function afterSave() {
        console.log('---执行保存');
        var save_data = $.extend(true, {}, data, { status: 'save', __post_sign: Bills['__post_sign']});

        fun.ajax({
            showLoad: true,
            hideLoad: true,
            loadTitle: '保存中...',
            url: Bills['AJAX_URL']['save'],
            data: save_data,
            success: function (res) {
                if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
                // State['is_saving'] = 0;
                switch (res['status']) {
                    case 0:
                        // if (JD_FROM_JL) {
                        //     __adjust();
                        //     return;
                        // } else {
                        fun.toast('保存成功！');
                        JD_FROM_JL = false;
                        is_adjust_save = false;
                        page_data['id'] = res['data']['dj_id'];
                        api.sendEvent({
                            name: html_name,
                            extra: {
                                'status': 'refresh_dj',
                                'data': {}
                            }
                        });

                        api.sendEvent({
                            name: page_data['return_page'],
                            extra: {
                                'status': 'refresh',
                                'closeLayer': true
                            }
                        });

                        if (typeof _options['callback'] === 'function') _options['callback']();

                        break;
                    case 'DCK_LIST':
                        var list = res['dck_list'][0];
                        fun.toast('条码' + list['tm'] + '已被调用或已出库');
                        break;
                    default:
                        fun.toast(res['msg'].replace(/销售订单/, '客户订单'));
                        break;
                }
            }
        });
    }

    // function __adjust(param) {
    //     var __params = $.extend({ tz_jl: [] }, param);
    //     console.log('---执行单据调整保存')

    //     var tmp_djtz_jl = [];
    //     var djtz_jl = jl.slice(0) || [];

    //     var tmpSaveObj = {};

    //     for (var i = 0; i < djtz_jl.length; i++) {
    //         if (djtz_jl[i]['djtz_jl_jd']) {
    //             delete jl[i]['djtz_jl_jd'];
    //             tmp_djtz_jl.push(djtz_jl[i]);
    //             tmpSaveObj[djtz_jl[i]['id']] = djtz_jl[i];
    //         } else if (djtz_jl[i]['dj_jd_from_jd']) {
    //             delete jl[i]['dj_jd_from_jd'];
    //             tmp_djtz_jl.push(djtz_jl[i]);
    //             tmpSaveObj[djtz_jl[i]['id']] = djtz_jl[i];
    //         }
    //     }

    //     var save_data = $.extend(true, {}, {
    //         status: 'adjust',
    //         data: $.nui.isTrue(__params['tz_jl']) ? __params['tz_jl'] : tmp_djtz_jl,
    //         dj_id: dj['id'],
    //         isSave: is_adjust_save
    //     });

    //     save_data['isSave'] = is_adjust_save;

    //     fun.ajax({
    //         showLoad: true,
    //         hideLoad: true,
    //         loadTitle: '保存中...',
    //         url: Bills['AJAX_URL']['save'],
    //         data: save_data,
    //         success: function (res) {
    //             switch (res['status']) {
    //                 case 0:
    //                     if (JD_FROM_JL) {
    //                         if (__DJ_DATA['is_fh'] || save_data['is_save']) {
    //                             fun.toast('保存成功！');
    //                             is_adjust_save = false;
    //                             delGridRows = [];
    //                             api.sendEvent({
    //                                 name: html_name,
    //                                 extra: {
    //                                     'status': 'refresh_dj',
    //                                     'data': {}
    //                                 }
    //                             });

    //                             // IS_JD_FJD_SAVE = true;

    //                             api.sendEvent({
    //                                 name: page_data['return_page'],
    //                                 extra: {
    //                                     'status': 'refresh',
    //                                     'closeLayer': true
    //                                 }
    //                             });

    //                             // if (_options['closePage']) {
    //                             //     closePage();
    //                             // }
    //                             if (typeof _options['callback'] === 'function') _options['callback']();
    //                         } else {
    //                             afterSave();
    //                         }

    //                     } else {
    //                         JD_FROM_JL = false;
    //                         fun.toast('保存成功！');
    //                         is_adjust_save = false;
    //                         delGridRows = [];
    //                         api.sendEvent({
    //                             name: html_name,
    //                             extra: {
    //                                 'status': 'refresh_dj',
    //                                 'data': {}
    //                             }
    //                         });
    //                         api.sendEvent({
    //                             name: page_data['return_page'],
    //                             extra: {
    //                                 'status': 'refresh',
    //                                 'closeLayer': true
    //                             }
    //                         });

    //                         // if (_options['closePage']) {
    //                         //     closePage();
    //                         // }
    //                         if (typeof _options['callback'] === 'function') _options['callback']();
    //                     }
    //                     break;
    //                 case 'IS_ZS_FKC':
    //                     var list = res['data']['list'][0];
    //                     var ps_display = list['bz_ps'] > 0;
    //                     var sl_display = list['bz_sl'] > 0;
    //                     var msg = [
    //                         list['cp_bh'] + list['cp_mc'] + '\r\n',
    //                         list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
    //                         '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
    //                         '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
    //                     ].join('');
    //                     fun.toast(msg);
    //                     break;
    //                 case 'IS_TM_FKC':
    //                     var list = res['data']['list'][0];
    //                     fun.toast('条码' + list['tm'] + '和库存信息不一致');
    //                     break;
    //                 case 'IS_MX_FKC':
    //                     var list = res['data']['list'][0];
    //                     var msg = [
    //                         list['cp_bh'] + list['cp_mc'] + '\r\n',
    //                         list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
    //                         '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
    //                     ].join('');
    //                     fun.toast(msg);
    //                     break;
    //                 case 'DDJ_NOT_EMPTY':
    //                     fun.jdts({
    //                         content: '<div style="text-align:left;margin-top: -0.5rem;">未抵用订金：' + res['data']['wdyje'] + ' <br>您确定要结单吗？</div>',
    //                         btn: ['确定结单', '取消'],
    //                         yes: function () {
    //                             is_adjust_save = true;
    //                             __adjust({ tz_jl: tmp_djtz_jl.slice(0) });
    //                         },
    //                         no: function () {
    //                             for (var key in tmpSaveObj) {
    //                                 for (var j = 0; j < __JL_DATA.length; j++) {
    //                                     if (key == __JL_DATA[j]['id']) {
    //                                         __JL_DATA[j]['is_jd'] = !__JL_DATA[j]['is_jd'] ? 1 : 0;
    //                                         __JL_DATA[j]['jdr_id'] = !__JL_DATA[j]['is_jd'] ? USER_INFO['id'] : 0;
    //                                         __JL_DATA[j]['jdr_mc'] = !__JL_DATA[j]['is_jd'] ? USER_INFO['name'] : '';
    //                                         __JL_DATA[j]['jd_sj'] = !__JL_DATA[j]['is_jd'] ? fun.formatDate(new Date()) : '';
    //                                         // delete __JL_DATA[j]['is_jd'];
    //                                         // delete __JL_DATA[j]['jdr_id'];
    //                                         // delete __JL_DATA[j]['jdr_mc'];
    //                                         // delete __JL_DATA[j]['jd_sj'];
    //                                     }
    //                                 }
    //                             }

    //                             showJlList(formatData(__JL_DATA));

    //                             JD_FROM_JL = false;
    //                         }
    //                     });
    //                     break;
    //                 case 'IS_NOT_FINISH':
    //                     fun.jdts({
    //                         content: '部分产品还没发完货，你确定要结单吗？',
    //                         yes: function () {
    //                             fun.ajax({
    //                                 showLoad: true,
    //                                 hideLoad: true,
    //                                 loadTitle: '结单中...',
    //                                 url: Bills['AJAX_URL']['save'],
    //                                 data: $.extend(true, { 'notCheckFinish': 1 }, save_data),
    //                                 success: function (res) {
    //                                     switch (res['status']) {
    //                                         case 0:
    //                                             fun.toast('结单成功。');
    //                                             // is_adjust_save = false;
    //                                             api.sendEvent({
    //                                                 name: html_name,
    //                                                 extra: {
    //                                                     'status': 'refresh_dj',
    //                                                     'data': {}
    //                                                 }
    //                                             });
    //                                             api.sendEvent({
    //                                                 name: page_data['return_page'],
    //                                                 extra: {
    //                                                     'status': 'refresh',
    //                                                     'closeLayer': true
    //                                                 }
    //                                             });
    //                                             break;
    //                                         default:
    //                                             fun.toast(res['msg']);
    //                                             break;
    //                                     }
    //                                 }
    //                             });
    //                         },
    //                         no: function () {
    //                             for (var key in tmpSaveObj) {
    //                                 for (var j = 0; j < __JL_DATA.length; j++) {
    //                                     if (key == __JL_DATA[j]['id']) {
    //                                         __JL_DATA[j]['is_jd'] = !__JL_DATA[j]['is_jd'] ? 1 : 0;
    //                                         __JL_DATA[j]['jdr_id'] = !__JL_DATA[j]['is_jd'] ? USER_INFO['id'] : 0;
    //                                         __JL_DATA[j]['jdr_mc'] = !__JL_DATA[j]['is_jd'] ? USER_INFO['name'] : '';
    //                                         __JL_DATA[j]['jd_sj'] = !__JL_DATA[j]['is_jd'] ? fun.formatDate(new Date()) : '';
    //                                         // delete __JL_DATA[j]['is_jd'];
    //                                         // delete __JL_DATA[j]['jdr_id'];
    //                                         // delete __JL_DATA[j]['jdr_mc'];
    //                                         // delete __JL_DATA[j]['jd_sj'];
    //                                     }
    //                                 }
    //                             }

    //                             showJlList(formatData(__JL_DATA));

    //                             JD_FROM_JL = false;
    //                         }
    //                     });
    //                     break;
    //                 default:
    //                     fun.toast(res['msg']);
    //                     break;
    //             }
    //         }
    //     });
    // }

    // function setCredit() {
    //     var wldw_mc = Bills['wldw']['merchant_name'],
    //         bdje = dj['bdje'],
    //         zhje = dj['zh_je'],
    //         xye = Bills['wldw']['credit'] || 0,
    //         qqje = 0,
    //         ljqk = 0,
    //         chje = 0,
    //         zje = 0;

    //     __getWldwSubInfo({
    //         callback: function () {
    //             qqje = (Bills && Bills['WldwSubInfo'] && Bills['WldwSubInfo']['info']) ? (Bills['WldwSubInfo']['info']['balance'] || 0) : 0;
    //             zje = (qqje + bdje - zhje).fixed();

    //             if (zje > xye) {
    //                 chje = (qqje + (bdje - zhje) - xye).fixed();
    //                 var param = {
    //                     'wldw_mc': wldw_mc,
    //                     'ljqk': qqje,
    //                     'ysje': (bdje - zhje).fixed(),
    //                     'xye': xye,
    //                     'chje': chje
    //                 };
    //                 checkXye(param);
    //             } else __save();
    //         }
    //     });

    //     function checkXye(param) {
    //         fun.ajax({
    //             hideLoad: true,
    //             url: AJAX_URL.getAuthList,
    //             data: { "type": "bpcxyebyxkd" },
    //             success: function (res) {
    //                 fun.hideLoad();
    //                 var btns = $.nui.isTrue(res['data']) ? ['取消保存'] : ['继续保存', '取消'];
    //                 fun.cxyetx({
    //                     content: param,
    //                     btn: btns,
    //                     yes: function (e) {
    //                         if ($.nui.isTrue(res['data'])) {
    //                             layer.closeAll();
    //                         } else {
    //                             __save();
    //                         }
    //                     }
    //                 });
    //             }
    //         });
    //     }
    // }
}

// 获取合计信息
function getTotalInfo(data) {
    var _data = !$.nui.isEmpty(data) ? data : [];
    var tmp_total = {
        zps: 0,
        zsl: 0,
        zjjsl: 0,
        bdje: 0,
        hszje: 0,
        hsje: 0,
        zje: 0,
        cxps: 0
    };

    for (var i = 0; i < _data.length; i++) {
        var val = _data[i];
        if (val['is_delete']) continue;
        tmp_total['zps'] = $.nui.decimalAdd(tmp_total['zps'], parseInt(val['ps'] || 0));
        tmp_total['cxps'] = $.nui.decimalAdd(tmp_total['cxps'], parseInt(val['cxps'] || 0));
        tmp_total['zsl'] = $.nui.decimalAdd(tmp_total['zsl'], parseFloat(val['zsl'] || 0));
        tmp_total['zjjsl'] = $.nui.decimalAdd(tmp_total['zjjsl'], parseFloat(val['jjsl'] || 0));
        tmp_total['bdje'] = $.nui.decimalAdd(tmp_total['bdje'], parseFloat(val['hszje'] || 0));
        tmp_total['hszje'] = $.nui.decimalAdd(tmp_total['hszje'], parseFloat(val['hszje'] || 0));
        tmp_total['hsje'] = $.nui.decimalAdd(tmp_total['hsje'], parseFloat(val['hsje'] || 0));
        tmp_total['zje'] = $.nui.decimalAdd(tmp_total['zje'], parseFloat(val['zje'] || 0));
    }

    tmp_total['bdje'] = __bdjeSswr(tmp_total['bdje']);
    tmp_total['hszje'] = __bdjeSswr(tmp_total['hszje']);
    tmp_total['zje'] = __bdjeSswr(tmp_total['zje']);

    return tmp_total;
}


// 结单、反结单
$('body').off('tap', '#settle').on('tap', '#settle', function (e) {
    e.stopPropagation();

    // AUTH_JD = Auth.check(__PAGE_DATA['djlx'], 'settle');

    if (!AUTH_JD || $(this).attr('disabled')) return;

    var text = $(this).text().trim();

    var msg = '';
    var btn = ['确定', '取消'];

    var flag = (text == '结单');

    switch (text) {
        case '结单':
            msg = '您确定要结单该产品吗？';
            btn = ['确定', '取消'];
            break;
        case '反结单':
            msg = '您确定要取消该产品的结单状态吗？';
            btn = ['确定', '取消'];
            break;
    }

    // if (text == '结单' && $.nui.isTrue(ROW_DATA['wlps']) || $.nui.isTrue(ROW_DATA['wlsl'])) {
    //     msg = '部分产品还没来完货，你确定要结单吗？';
    //     btn = ['确定结单', '取消'];

    //     fun.dialog({
    //         content: msg,
    //         btn: btn,
    //         yes: function () {
    //             __getJdDataFun(flag);
    //             var save_data = $.extend(true, {}, { status: 'adjust', data: __JL_DATA, dj_id: __DJ_DATA['id'] });

    //             fun.ajax({
    //                 showLoad: true,
    //                 hideLoad: true,
    //                 loadTitle: '结单中...',
    //                 url: Bills['AJAX_URL']['save'],
    //                 data: $.extend(true, { 'notCheckFinish': 1 }, save_data),
    //                 success: function (res) {
    //                     switch (res['status']) {
    //                         case 0:
    //                             fun.toast('结单成功。');
    //                             api.sendEvent({
    //                                 name: page_data['return_page'],
    //                                 extra: {
    //                                     'status': 'refresh_dj',
    //                                 }
    //                             });
    //                             return closeAndSendEvent();
    //                             break;
    //                         default:
    //                             fun.toast(res['msg']);
    //                             break;
    //                     }
    //                 }
    //             });
    //         }
    //     });
    //     return;
    // }

    fun.dialog({
        content: msg,
        btn: ['确定', '取消'],
        yes: function () {
            // ROW_DATA['is_jd'] = flag ? 1 : 0;
            // ROW_DATA['jdr_id'] = flag ? USER_INFO['id'] : 0;
            // ROW_DATA['jdr_mc'] = flag ? USER_INFO['name'] : '';
            // ROW_DATA['jd_sj'] = flag ? fun.formatDate(new Date()) : '';
            // ROW_DATA['is_tmp_jd'] = 1;

            if (flag) {
                $('#cxps,#cxsl,#bz').attr('disabled', true);
                // $('.read-input:not([disabled])').attr('abcdisabled', true);
                for (var i = 0; i < tmpJdDisabled.length; i++) {
                    $('#' + tmpJdDisabled[i]).attr('disabled', true);
                }
            } else {
                $('#cxps,#cxsl,#bz').removeAttr('disabled');
                // $('.read-input:not([disabled])').removeAttr('abcdisabled');
                for (var i = 0; i < tmpJdDisabled.length; i++) {
                    $('#' + tmpJdDisabled[i]).removeAttr('disabled');
                }
            }

            // finishFun(flag);
            __settleFun(flag);
        }
    });
});

function __getJdDataFun(flag, setJd) {
    getRowSaveData();
    __setRowData(null, {});
    if ($.nui.isEmpty(ROW_DATA['cp_ys_id'])) return fun.toast('请选择颜色！');
    if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) return fun.toast('请选择计价单位！');

    // $('#settle').text(flag ? '反结单' : '结单');

    if (!setJd) {
        ROW_DATA['is_jd'] = flag ? 1 : 0;
        ROW_DATA['jdr_id'] = flag ? USER_INFO['id'] : 0;
        ROW_DATA['jdr_mc'] = flag ? USER_INFO['name'] : '';
        ROW_DATA['jd_sj'] = flag ? fun.formatDate(new Date()) : '';
        ROW_DATA['is_tmp_jd'] = 1;
    }

    if (__PAGE_DATA['edit_row']) {
        __JL_DATA.splice(__PAGE_DATA['row_index'], 1, ROW_DATA);
    } else {
        __JL_DATA.push(ROW_DATA);
    }

    JD_FROM_JL = true;
}


function finishFun(flag) {
    getRowSaveData();
    __setRowData(null, {});
    if ($.nui.isEmpty(ROW_DATA['cp_ys_id'])) return fun.toast('请选择颜色！');
    // if (($.nui.isEmpty(ROW_DATA['zsl']) || parseFloat(ROW_DATA['zsl'] || 0) == 0) && $.nui.isEmpty(ROW_DATA['ps'])) return fun.toast('请填写数量或匹数！');
    if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) return fun.toast('请选择计价单位！');

    ROW_DATA['is_jd'] = flag ? 1 : 0;
    ROW_DATA['jdr_id'] = flag ? USER_INFO['id'] : 0;
    ROW_DATA['jdr_mc'] = flag ? USER_INFO['name'] : '';
    ROW_DATA['jd_sj'] = flag ? fun.formatDate(new Date()) : '';
    ROW_DATA['is_tmp_jd'] = 1;

    if (__PAGE_DATA['edit_row']) {
        __JL_DATA.splice(__PAGE_DATA['row_index'], 1, ROW_DATA);
    } else {
        __JL_DATA.push(ROW_DATA);
    }

    JD_FROM_JL = true;
    execFlag = true;
    // if (page_data['initType'] === 'view') {

    // } else {
    backCallback();

    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'judge_jd',
            'data': {
                __JD_INFO: __JD_INFO
            }
        }
    });

    execFlag = false;

    // }
}

// 结单方法调整
function __settleFun(flag, setJd) {
    __getJdDataFun(flag, setJd);
    if (flag) {
        // __saveOther(function () {
        //     __saveJd();
        // });
            __saveJd();
    } else {
        __saveJd();
    }

    execFlag = false;
}

function __saveJd(callback) {

    var __other_data = {
        hqts: Number(ROW_DATA['hqts']) || '',
        hq: ROW_DATA['hq'] || null,
        jjcd: ROW_DATA['jjcd'] || 0,
        jjcd_mc: ROW_DATA['jjcd_mc'] || '',
        jjcd_colour: ROW_DATA['jjcd_colour'] || '',
        zt: $('#zt_mc').data('zt') || '',
        zt_id: ROW_DATA['zt_id'] || 0,
        colour: ROW_DATA['colour'] || '',
        bz: ROW_DATA['bz'] || '',
    };

    var save_data = $.extend(true, {}, { status: 'adjust', data: __JL_DATA, dj_id: __DJ_DATA['id'] ,__post_sign: Bills['__post_sign']});
    $.extend(save_data['data'], __other_data);

    save_data['isSave'] = is_adjust_save;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        loadTitle: '保存中...',
        url: Bills['AJAX_URL']['save'],
        data: save_data,
        success: function (res) {
            if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('保存成功！');
                    if (page_data['initType'] == 'view') {
                        if (execBack) closeAndSendEvent();
                        else refreshPage();
                        is_adjust_save = false;
                    } else {
                        api.sendEvent({
                            name: page_data['return_page'],
                            extra: {
                                'status': 'refresh_dj'
                            }
                        });
                        closeAndSendEvent();
                    }
                    break;
                case 'IS_NOT_FINISH':
                    fun.jdts({
                        content: '部分产品还没来完货，你确定要结单吗？',
                        yes: function () {
                            $('.settle-wrap,#complete_btn').hide();
                            fun.ajax({
                                showLoad: true,
                                hideLoad: true,
                                loadTitle: '结单中...',
                                url: Bills['AJAX_URL']['save'],
                                data: $.extend(true, { 'notCheckFinish': 1 }, save_data),
                                success: function (res) {
                                    Bills['__post_sign'] = $.nui.getRandomNum();
                                    switch (res['status']) {
                                        case 0:
                                            if (page_data['initType'] == 'view') {
                                                refreshPage();
                                                is_adjust_save = false;
                                            } else {
                                                fun.toast('结单成功。');
                                                api.sendEvent({
                                                    name: page_data['return_page'],
                                                    extra: {
                                                        'status': 'refresh_dj'
                                                    }
                                                });
                                                closeAndSendEvent();
                                                is_adjust_save = false;
                                            }
                                            break;
                                        default:
                                            fun.toast(res['msg']);
                                            break;
                                    }
                                }
                            });
                        },
                        no: function () {
                            ROW_DATA['is_jd'] = 0;
                            ROW_DATA['jdr_id'] =  0;
                            ROW_DATA['jdr_mc'] = '';
                            ROW_DATA['jd_sj'] = '';
                            ROW_DATA['is_tmp_jd'] = 0;
                        }
                    });
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'][0];
                    fun.toast('条码' + list['tm'] + '和库存信息不一致');
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DDJ_NOT_EMPTY':
                    fun.jdts({
                        content: '<div style="text-align:left;margin-top: -0.5rem;">未抵用订金：' + res['data']['wdyje'] + ' <br>您确定要结单吗？</div>',
                        btn: ['确定结单', '取消'],
                        yes: function () {
                            is_adjust_save = true;
                            __saveJd();
                        },
                        no: function () {
                            ROW_DATA['is_jd'] = flag ? 1 : 0;
                            ROW_DATA['jdr_id'] = flag ? USER_INFO['id'] : 0;
                            ROW_DATA['jdr_mc'] = flag ? USER_INFO['name'] : '';
                            ROW_DATA['jd_sj'] = flag ? fun.formatDate(new Date()) : '';
                            ROW_DATA['is_tmp_jd'] = 1;
                        }
                    });
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    });
}


$('body').on('tap', '#edit_btn1', function (e) {
    $('#complete_btn').show();
    $(this).hide();
    // 设置初始非浏览状态下所有元素编辑状态
    setEditDomDisabled();
    __VIEW_TO_EDIT = true;
    begin_lCalendar.disabled = false;
    init();
    __PAGEDOM_DISABLED();
    btnAuthCheck();
});

function showPhszHtml() {
    var tmp_sys_config = fun.getItem('sys_config') || {};
    var kdphsz = tmp_sys_config['kdphsz'] || '';

    var fkkz_show = (kdphsz.indexOf('fk,kz') > -1) ? true : false;
    var gg_show = (kdphsz.indexOf('gg') > -1) ? true : false;

    if (!fkkz_show && !gg_show) {
        $('#fkkzgg').hide();
    } else {
        $('#fkkzgg').show();
        if (!fkkz_show) {
            $('.fk-wrap,.kz-wrap').hide();
        }
        if (!gg_show) {
            $('.gg-wrap').hide();
        }
    }
}


// 记录行结单后哪些元素不能编辑
function setDomDisabledByJlJd() {
    if ($.nui.isTrue(ROW_DATA['is_jd'])) {
        $('#ps,#sl,#jjsl_val,#hq,#hqts,#lx,#zt_wrap,#jjcd_wrap,#gg,#gg_short,#color_search_wrap,#color_search,input').attr('disabled', true);
        begin_lCalendar.disabled = true;
        $('.color-change').hide();
    } else {
        $('#hq,#hqts,#zt_wrap,#jjcd_wrap,#bz,#cxps,#cxsl').removeAttr('disabled');
    }
}

// 按钮权限判断
function btnAuthCheck() {

    if (!AUTH_JD) {
        $('#settle,.settle-wrap').hide();
    }
}

// 设置页面元素是否可编辑
function __PAGEDOM_DISABLED() {
    // 结单
    if ($.nui.isTrue(ROW_DATA['is_jd'])) {
        $('#ps,#sl,#jjsl_val,#hq,#hqts,#lx,#zt_wrap,#jjcd_wrap,#gg,#gg_short,#color_search_wrap,#color_search,input').attr('disabled', true);
        begin_lCalendar.disabled = true;
        $('.color-change').hide();
    } else {
        if ($.nui.isTrue(__DJ_DATA['is_fh'])) {
            $('.color-change').hide();
            $('#ps,#sl,#jjsl_val,#hq,#hqts,#lx,#zt_wrap,#jjcd_wrap,#gg,#gg_short,#color_search_wrap,#color_search,input').attr('disabled', true);
            if (__VIEW_TO_EDIT) {
                $('#hq,#hqts,#zt_wrap,#jjcd_wrap,#bz,#cxps,#cxsl').removeAttr('disabled');
            }
        } else {

        }

        // 当前记录行 是调用 客户订单 生成的，则：
        // 以下字段不允许编辑：商品编号、商品名称、色号、颜色、客户、单位
        if ($.nui.isTrue(ROW_DATA['kh_dd_dj_id']) && $.nui.isTrue(ROW_DATA['kh_dd_jl_id'])) {
            $('#color_search_wrap,#color_search,#dw').attr('disabled', true);
        }

        // 订单被调用 或 有填写 加减匹、加减数，不允许修改 仓库、商品、颜色、单位、匹数、数量
        if ($.nui.isTrue(ROW_DATA['is_has']) || $.nui.isTrue(ROW_DATA['cxps']) || $.nui.isTrue(ROW_DATA['cxsl'])) {
            $('#color_search_wrap,#color_search,#dw,#ps,#sl,#fk,#kz,#gg,#jjsl_val,#dj').attr('disabled', true);
        }
    }
}

// 显示结单按钮
function showSeal(row) {
    if ($.nui.isTrue(row['is_jd'])) {
        $('.show-seal').show();
    } else {
        $('.show-seal').hide();
    }
}

function checkDataChange(originData, saveData) {
    var tempOriginData = JSON.parse(JSON.stringify(originData));
    var tempSaveData = JSON.parse(JSON.stringify(saveData));
    if ('dw2_id' in tempOriginData) delete tempOriginData.dw2_id;
    if ('dw2_mc' in tempOriginData) delete tempOriginData.dw2_mc;
    if ('dw2_id' in tempSaveData) delete tempSaveData.dw2_id;
    if ('dw2_mc' in tempSaveData) delete tempSaveData.dw2_mc;
    return !$.nui.isObjEquals(tempOriginData, tempSaveData);
}