var html_name = page_arr.bills_dd; //页面名称

var Bills = Bills || {},    //开单配置项
    photoBrowser = {},      //大图浏览
    jjsfssl,                //计价数反算出库数
    __PAGE_DATA = {},       //页面数据
    back_ori_data = {},     //点击返回前的原始数据
    back_save_data = {},    //点击返回时的保存数据
    cache_data = {},        //缓存一些数据
    __JL_DATA = [],         //所有记录行数据
    __CP_YS_JL = [],        //所有相同产品记录行数据
    ROW_DATA = {},          //当前页面记录行数据
    target_page = '',       //点击完成要返回哪个页面
    isSave = false,
    showKeyBoard = true,    //显示键盘
    fieldConfig = {},       //字段配置
    JD_FROM_JL = false,     //从记录行结单
    __JD_INFO = {},         //原来的结单数据
    tmpJdDisabled = [],      //临时结单需要禁用的
    PAGE_INIT_DATA = {},    //删除时初始化页面数据
    psslTmpDisabled = [],    //匹数数量临时禁用掉的数组
    begin_lCalendar = new lCalendar(),         //货期
    execClickAddColor = false
    ;
Bills['wldw_type'] = 'kh';//往来单位类型
Bills['WldwSubInfo'] = {};//往来单位子信息

Bills['AJAX_URL'] = {
    'getDj': AJAX_URL.getBpXsDjAndScdj, //获取单价
};

Bills['data_list'] = ['jjdw', 'ck', 'cp'];//预加载数据列表

Bills['config'] = {
    fy_zdy: 'bpxszdyfy', // 布匹-销售自定义费用
    ck_zdy: 'bpckzdygl', // 仓库自定义字段
    kd_zdy: 'bpkdzdyzd', // 开单自定义字段
    dckms: 'dckms_bp', // 多仓库模式
    adjs: 'adjs_bpxs', // 按单结算
    dwgshsbl: 'dwgshsbl_bp', // 单位公式换算保留位数
    jesswr: 'jesswr_bpxs', // 金额四舍五入
    bdjesswr: 'bdjesswr_bpxs', // 本单金额四舍五入
    dddjwlcddj: 'dddjwlcddj_bpxs', // 订单单价为0重读单价
    qyssjms: 'qyssjms_bp'
};

fun.clearItem('cp_list');

var SYS_CONFIG = {}, //系统设置
    cp_list = [], //产品列表
    jjdw_list = []; //单位列表

var longClick = 0;
/* 
    实售金额 = 实售数 * 实售单价
    实售总金额 = 实售额 + 5个费用
    回扣 = 含税总金额 - 实售总金额
*/
var xsDdXq = {
    computedSsje: function () { // 计算实售金额
        var ssdj = fun.toNumber($('#ssj').val().trim()) || 0;
        var sssl = fun.toNumber($('#sss').val().trim()) || 0;
        return ($.nui.decimalMul(ssdj, sssl)).fixed();
    },
    computedSszje: function () { // 计算实售总金额
        var ssje = this.computedSsje(); // 实售额
        var zdyFy = this.computedCustomMoney(); // 自定义费用
        return ($.nui.decimalAdd(ssje, zdyFy)).fixed();
    },
    computedCustomMoney: function () {
        return (function () { // 自定义费用
            var total = 0;
            for (var i = 1; i <= 5; i++) {
                var fyZdy = 'fy_zdy' + i;
                total += fun.toNumber(ROW_DATA[fyZdy]) || 0;
            }
            return total.fixed();
        })();
    },
    computedHk: function () { // 计算回扣
        return ($.nui.decimalSub(fun.toNumber(ROW_DATA['hszje']), fun.toNumber(ROW_DATA['sszje']))).fixed();
    },
    upDateSszje: function () {
        $('#ssje').val(this.computedSszje());
    },
    upDateHk: function () {
        $('#hk').val(this.computedHk());
    },
    setJjsl: function () {
        $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);
    },
    lastProductColorName: '',
    upDateLastProductColorName: function (data) {
        this.lastProductColorName =
            $.nui.isEmpty(data.cp_ys_mc) ? data['cp_ys_bh'] : data['cp_ys_bh'] + ' ' + data['cp_ys_mc'];
    },
    nowProductColorName: function (data) {
        return $.nui.isEmpty(data.cp_ys_mc) ? data['cp_ys_bh'] : data['cp_ys_bh'] + ' ' + data['cp_ys_mc'];
    },
    editPrice: {},
};
xsDdXq.isOpenQyssjmsBp = function () {
    return !!Number(SYS_CONFIG[Bills['config']['qyssjms']]);
}

xsDdXq.authShow = function () {
    if (this.isOpenQyssjmsBp()) {
        switch (page_data['djlx']) {
            case 'bp_xsdd':
                $('#ssjms_wrap').css({
                    display: 'flex'
                })
                $('#kickback').show();
                break;
        }
    }
}

$('#header').header({
    title: '&nbsp;',
    text_btn: true,
    text_val: '去结算',
    much: true, //更多
    appendBackBtnEvt: backCallback
});

$('#complete_btn').hide();

var winHeight = $(window).height(); //获取当前页面高度
$(window).resize(function () {
    var thisHeight = $(this).height();
    if (winHeight - thisHeight > 50) {
        $('.layer-content').css('visibility', 'hidden');
        setPanelHide();
    } else {
        $('.layer-content').css('visibility', 'visible');
    }
});
setPanelHide();

begin_lCalendar.init({
    'trigger': '#hq',
    'type': 'date',
    'callback': function (date) {
        var kdsj = fun.formatDate(__DJ_DATA['kdsj'] || new Date(), 'YYYY-MM-DD');
        if (new Date(Date.parse(date)) < new Date(Date.parse(kdsj))) {
            $('#hqts').val(ROW_DATA['hqts'] || 0);//货期天数
            $('#hq').text(fun.formatDate(ROW_DATA['hq'], 'YY-MM-DD') || '').data('hq', ROW_DATA['hq']);//货期
            // $('#delivery').data('value', $('#hq').text());
            // setCq(ROW_DATA['hq']);
            begin_lCalendar.format_value = (!!ROW_DATA['hq'] ? fun.formatDate(ROW_DATA['hq'], 'YYYY-MM-DD') : "");
        } else {
            var hqts;
            if (new Date(Date.parse(date)) == new Date(Date.parse(kdsj))) hqts = 0;
            else hqts = Math.abs(new Date(date).getTime() - new Date(kdsj).getTime()) / (1000 * 60 * 60 * 24);
            $('#hqts').val(hqts || 0);
            $('#hq').text(fun.formatDate(date, 'YY-MM-DD') || '').data('hq', date);//货期
            // setCq(date);
            // $('#delivery').data('value', $('#hq').text());
            begin_lCalendar.format_value = (!!date ? fun.formatDate(date, 'YYYY-MM-DD') : "");
        }

        getRowSaveData();
    },
    'onCheck': function (date) {
        var kdsj = fun.formatDate(__DJ_DATA['kdsj'] || new Date(), 'YYYY-MM-DD');
        if (new Date(Date.parse(date)) < new Date(Date.parse(kdsj))) {
            return false;
        }
        return true;
    },
    'billing': true
});

// apicloud页面初始化
page_init = function () {
    SYS_CONFIG = fun.getItem('sys_config') || {}; //系统设置
    cp_list = fun.getItem('cp_list') || []; //产品列表
    jjdw_list = fun.getItem('jjdw_list') || []; //单位列表

    photoBrowser = api.require('photoBrowser');
    fun.keyboardEject('.record_added');
    fun.setHeaderLocation('.content-wrap');//解决ios头部定位失效

    isShop();

    // 预加载数据
    fun.load_DATA_LIST(['cp'], function () {
        cp_list = fun.getItem('cp_list') || []; //产品列表
    });
    fun.load_DATA_LIST(['jjdw', 'sys_config'], function () {
        jjdw_list = fun.getItem('jjdw_list') || []; //单位列表
        SYS_CONFIG = fun.getItem('sys_config') || {}; //系统设置
        xsDdXq.authShow();
    });

    Bills['djlx'] = page_data['djlx'];

    if ($.nui.isTrue(page_data['__route'])) {
        __PAGE_DATA = page_data['kdbj_tmp'] || {};
    } else {
        __PAGE_DATA = page_data || {};
    }

    __PAGE_DATA['ck_info'] = __PAGE_DATA['ck_info'] || {};
    __JL_DATA = __PAGE_DATA['__JL_DATA'] || [];
    __DJ_DATA = __PAGE_DATA['__DJ_DATA'] || {};

    switch (page_data['djlx']) {
        case 'bp_xsdd':
            target_page = page_arr.xs_khdd_kd;
            Bills['AJAX_URL']['save'] = AJAX_URL.saveBpXsddInfo;
            fieldConfig = {
                'fhps_name': 'fhps',
                'fhps_display': '发货',
                'wfps_name': 'wfps',
                'wfps_display': '未发',
                'fhsl_name': 'fhsl',
                'fhsl_display': '发货',
                'wfsl_name': 'wfsl',
                'wfsl_display': '未发'
            };
            Bills['wldw_type'] = 'kh';
            break;
        case 'bp_cgdd':
            target_page = page_arr.cg_cgdd_kd;
            Bills['AJAX_URL']['save'] = AJAX_URL.saveBpCgddInfo;
            Bills['AJAX_URL']['getDj'] = AJAX_URL.getBpCgDjAndScdj; // 获取单价
            fieldConfig = {
                'fhps_name': 'lhps',
                'fhps_display': '来货',
                'wfps_name': 'wlps',
                'wfps_display': '未来',
                'fhsl_name': 'lhsl',
                'fhsl_display': '来货',
                'wfsl_name': 'wlsl',
                'wfsl_display': '未来'
            };
            Bills['wldw_type'] = 'gys';
            // 设置类型
            Bills.config.fy_zdy = 'bpcgzdyfy';
            Bills.config.jesswr = 'jesswr_bpcg';
            Bills.config.bdjesswr = 'bdjesswr_bpcg';
            Bills.config.dddjwlcddj = 'dddjwlcddj_bpcg';//"订单单价为0重读单价_布匹采购"
            // // 隐藏类型选择
            // $('.lx-block').hide();
            // $('.call-stock').css({
            //     width: 'calc(70% - (35% - 1.6rem - 0.25rem))'
            // });
            break;
    }

    $('#complete_btn').show();

    page_data.keyback = function () {
        backCallback();
    };

    init();

    // 初始化已添加颜色记录
    initColorAdd();

    if ($.nui.isTrue(__PAGE_DATA['__PAGE_EDIT'])) {
        $('.color-wrap').css('display', 'inline-block');
        $('.color-search-label').css('display', 'inline-block');
    } else {
        $('.color-search-label,.color-wrap').hide();
    }

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'select_list':
                if (temp['data']['page_type'] == 'cp_ys') {
                    if (temp['data']['clearData']) {
                        resetData();
                    }
                }
                setSelectedValue({
                    data: temp['data'],
                    notUpDateJjdw: true
                });
                break;
            // case 'update':
            //     console.log(temp['data']);
            //     selectUpdateInfo(temp['data']);
            //     break;
            case 'goodsdata':
                $('#gg').val(temp['name']).data('ggid', temp['id']);
                break;
        }
    });
    fun.inputType();
    // bindEvent();
};

// 初始化已添加颜色记录 --new
function initColorAdd() {
    __CP_YS_JL = [];
    for (var i = 0; i < __JL_DATA.length; i++) {
        if ($.nui.isTrue(__JL_DATA[i]['is_delete'])) continue;
        if (__JL_DATA[i]['cp_id'] == ROW_DATA['cp_id']) {
            __CP_YS_JL.push(__JL_DATA[i]);
        }
    }

    if (__CP_YS_JL.length >= 1) {
        $('.record_added').show();
    } else {
        $('.record_added').hide();
    }
}

// 设置颜色功能按钮显示 --new
function setColorBtnDisplay() {
    if ($.nui.isTrue($('#color_search').data('cp_ys_id'))) {
        $('.color-search-label,.color-wrap').css('display', 'inline-block');
    } else {
        $('.color-search-label,.color-wrap').hide();
    }
}

// 初始化页面布局 --new
function initPageLayout() {
    // placeholder居中
    if (api.systemType == 'ios') {
        $('.ps-input,.sl-input').addClass('ios-placeholder');
    }

    if (api.uiMode == 'pad') {
        $('.ps-input,.sl-input').addClass('pad-placeholder');
    }

    switch (page_data['djlx']) {
        case 'bp_xsdd':
            // // 系统设置有开启：启用实售价模式
            // if ($.nui.isTrue(SYS_CONFIG[Bills['config']['qyssjms']])) {
            //     xsDdXq.authShow();
            // } else {
            //     $('#ssjms_wrap,#kickback').hide();
            // }
            $('.lx-box').css('visibility', 'visible');
            break;
        case 'bp_cgdd':
            $('#lx').attr('disabled', true);
            break;
        default:
            $('#lx').attr('disabled', true);
            break;
    }

    showPhszHtml(function () {
        $('#fk').val(ROW_DATA['fk'] || '');
        $('#kz').val(ROW_DATA['kz'] || '');
        $('#gg').val(ROW_DATA['gg'] || '');
        // $('#gh').val(ROW_DATA['gh'] || '');
    });
}

// 显示幅宽克重规格缸号html代码 --new
function showPhszHtml(callback) {
    var html = [];
    var tmp_sys_config = fun.getItem('sys_config') || {};
    var kdphsz = tmp_sys_config['kdphsz'] || '';
    var arr = kdphsz.split(',') || [];

    var fkkz_show = (kdphsz.indexOf('fk,kz') > -1) ? '' : 'display:none;';
    var gg_show = (kdphsz.indexOf('gg') > -1) ? '' : 'display:none;';

    html.push('<div class="fk-wrap" style="' + fkkz_show + '">');
    html.push('     <label for="fk" class="label-text">幅宽</label>');
    html.push('     <input id="fk" type="text" class="" placeholder="">');
    html.push('</div>');
    html.push('<div class="kz-wrap" style="' + fkkz_show + '">');
    html.push('     <label for="kz" class="label-text">克重</label>');
    html.push('     <input id="kz" type="text" class="" placeholder="">');
    html.push('</div>');
    html.push('<div class="gg-wrap" style="' + gg_show + '">');
    html.push('     <label for="gg" class="label-text">规格</label>');
    html.push('     <input id="gg" type="text" class="" placeholder="" readonly="readonly">');
    html.push('</div>');

    var fkkz_disabled = $('#fk').attr('disabled') || $('#kz').attr('disabled');
    var gg_disabled = $('#gg').attr('disabled');
    // var gh_disabled = $('#gh').attr('disabled');

    $('.fkkzgggh').html(html.join(''));

    if (fkkz_show && gg_show) {
        $('.fkkzgggh').hide();
    } else {
        $('.fkkzgggh').show();
    }

    for (var i = 0; i < $('.fkkzgggh>div:visible').length; i++) {
        var _dom = $('.fkkzgggh>div:visible').eq(i);
        if (i == 0 || i == 3) {
            _dom.css('width', '30%');
        } else {
            _dom.css('width', '35%');
        }
    }
    $('#fk,#kz,#gg').val('');

    if (fkkz_disabled) {
        $('#fk,#kz').attr('disabled', true);
    }
    if (gg_disabled) {
        $('#gg').attr('disabled', true);
    }
    // if (gh_disabled) {
    //     $('#gh').attr('disabled', true);
    // }

    if (typeof callback === 'function') callback();
}

// 页面数据初始化
function init(options) {
    var _options = $.extend({ setColorEmpty: false }, options);

    // 初始化页面布局
    initPageLayout();
    initEditDom();

    jjsfssl = fun.getItem(page_data['djlx'] + '_jjsfssl') || false;//计价数反算出库数

    switch (page_data['djlx']) {
        case 'bp_xsdd':
        case 'bp_cgdd':
            $('.jj-wrap,.djjelx').show();
            $('.je-wrap').css('visibility', 'visible');
            break;
    }

    var cp_list = fun.getItem('cp_list') || [];
    var list_data = __PAGE_DATA['list_data'];

    // 标题初始化
    afterInitHeader(list_data);

    // 初始化图片
    initImgs(list_data);

    if (!__PAGE_DATA['__PAGE_EDIT'] || (list_data['is_jd'])) {
        showKeyBoard = false;
        setPanelHide();
    }

    if ($.nui.isTrue(list_data['cxps']) || $.nui.isTrue(list_data['cxsl'])) {
        showKeyBoard = false;
        setPanelHide();

        $('#color_search,#fk,#kz,#lx,#ps,#sl,#dw').attr('disabled', true);
    }

    if (list_data['is_jd']) {
        $('#hq,#hqts').attr('disabled');
    } else {
        $('#hq,#hqts').removeAttr('disabled');
    }

    $('#dw').text(list_data['dw_mc'] || '单位').data('dw_id', list_data['dw_id'] || 0);

    $('#color_search').val((list_data['cp_ys_bh'] || '') + ' ' + (list_data['cp_ys_mc'] || '')).data({
        'cp_ys_id': list_data['cp_ys_id'],
        'cp_ys_bh': list_data['cp_ys_bh'],
        'cp_ys_mc': list_data['cp_ys_mc']
    });

    if ($.nui.isTrue(__PAGE_DATA['edit_row'])) {
        __JD_INFO = __PAGE_DATA['__JD_INFO'] || {};
        $('#color_search').val((list_data['cp_ys_bh'] || '') + (list_data['cp_ys_mc'] || ''));
        $('#color_search').data({
            'cp_ys_id': list_data['cp_ys_id'],
            'cp_ys_bh': list_data['cp_ys_bh'],
            'cp_ys_mc': list_data['cp_ys_mc']
        });

        $('#dj').val(list_data['hsdj'] || 0);

        $('#je').val(list_data['hszje'] || 0);
        switch (page_data.djlx) {
            case 'bp_xsdd':
                var ssje = list_data['ssje'] || 0;
                $('#ssj').val(list_data['ssdj'] || 0); // 实售价
                $('#sss').val(list_data['sssl'] || 0); // 实售数
                $('#ssje').val(ssje || 0); // 实售额
                $('#hk').val($.nui.decimalSub((list_data['hszje'] || 0), ssje));
                break;
        }

        $('#lx').text(list_data['jg_lx_mc'] || '大货').data('jg_lx', list_data['jg_lx'] || 'dh');

        $('#fk').val(list_data['fk'] || '');
        $('#kz').val(list_data['kz'] || '');
        $('#gg').val(list_data['gg'] || '');
        // $('#gh').val(list_data['gh'] || '');

        $('#ps').val(parseInt(list_data['ps'] || 0) || '');
        $('#sl').val(list_data['zsl'] || '');
        $('#jjsl_val').val(list_data['jjsl'] || 0);

        $('#dw').text(list_data['dw_mc'] || '').data('dw_id', list_data['dw_id'] || 0);

        $('#sel_jjdw').text(list_data['jjdw_mc']).data('jjdw_id', list_data['jjdw_id']);
        $('#jjdw').text(list_data['jjdw_mc']).data('jjdw_id', list_data['jjdw_id']);

        $('#remark').val(list_data['bz'] || '');

        $('#hq').text((!!list_data['hq'] ? fun.formatDate(list_data['hq'], 'YY-MM-DD') : "")).data('hq', list_data['hq']);
        // $('#delivery').data('value', $('#hq').val());
        begin_lCalendar.format_value = (!!list_data['hq'] ? fun.formatDate(list_data['hq'], 'YYYY-MM-DD') : "");
        $('#hqts').val(list_data['hqts'] || '');

        if ($.nui.isTrue(list_data['jjcd_mc'])) {
            $('#jjcd_mc').text(list_data['jjcd_mc'] || '暂无').css({
                'backgroundColor': list_data['jjcd_colour'],
            }).removeClass('black-import').addClass('white-import');//紧急程度

            $('#jjcd_mc').data({
                jjcd_id: list_data['jjcd'] || 0,
                jjcd_mc: list_data['jjcd_mc'] || '',
                colour: list_data['jjcd_colour'] || ''
            })
        } else {
            $('#jjcd_mc').text('暂无');
            $('#jjcd_mc').css({
                'backgroundColor': '#fff',
                'padding-left': 0
            }).removeClass('white-import').addClass('black-import');//紧急程度

            $('#jjcd_mc').data({
                jjcd_id: 0,
                jjcd_mc: '',
                colour: ''
            })
        }

        if (list_data['cp_ys_bh'] === '色卡') {
            $('#lx,#dw,#jjdw').attr('disabled', true);
        }

        setJjslColor();

        if ($.nui.isTrue(list_data[fieldConfig.fhps_name]) || $.nui.isTrue(list_data[fieldConfig.fhsl_name])) {
            setPanelHide();
        } else {
        }

        switch (page_data['djlx']) {
            case 'bp_xsdd':
                if ($.nui.isTrue(list_data['is_has']) || $.nui.isTrue(list_data['is_dy']) ||
                    $.nui.isTrue(list_data['is_has_cgdd']) || $.nui.isTrue(list_data[fieldConfig.fhps_name])
                    || $.nui.isTrue(list_data[fieldConfig.fhsl_name])) {
                    $('#color_search,#fk,#kz,#lx').attr('disabled', true);
                }
                break;
            case 'bp_cgdd':
                if ($.nui.isTrue(list_data['kh_dd_dj_id']) && $.nui.isTrue(list_data['kh_dd_jl_id'])) {
                    // 当前记录行 是调用 客户订单 生成的，则：
                    // 以下字段不允许编辑：商品编号、商品名称、色号、颜色、客户
                    $('#color_search').attr('disabled', true);
                }

                if ($.nui.isTrue(list_data['is_has']) || $.nui.isTrue(list_data[fieldConfig.fhps_name])
                    || $.nui.isTrue(list_data[fieldConfig.fhsl_name])) {
                    // 订单被调用后，不允许修改 仓库、商品、颜色、单位、匹数、数量
                    $('#color_search,#fk,#kz').attr('disabled', true);
                }
                break;
        }

        ROW_DATA = $.extend({}, list_data);


        if (!__PAGE_DATA['__PAGE_EDIT']) {
            $('input,#dj,#jjdw,#sel_jjdw,#lx,#fk,#kz,#jjsl_val,#remark,#toggle,#color_search,#color').attr('disabled', true);
            $('#jjcd_wrap').attr('disabled', true);
        }

        var curr_cp_info = fun.getListInfoByKey(cp_list || [], list_data['cp_id']) || {};
        curr_cp_info['imgs'] = curr_cp_info['imgs'] || '';
        PAGE_INIT_DATA = {
            cp_id: curr_cp_info['id'] || 0,
            cp_bh: curr_cp_info['number'] || '',
            cp_mc: curr_cp_info['name'] || '',
            cp_ys_id: 0,
            cp_ys_bh: '',
            cp_ys_mc: '',
            fzsh: '',
            fzys: '',
            kcms: curr_cp_info['diff'] || '+',
            imgs: curr_cp_info['imgs'].split(',')[0] || '',
            dw_id: curr_cp_info['unit_id'] || 0,
            dw_mc: curr_cp_info['unit_name'] || '',
            fk: curr_cp_info['width'] || '',
            kz: curr_cp_info['weight'] || '',
            gg: curr_cp_info['spec'] || '',
            cf: curr_cp_info['component'] || '',
            unit_options: curr_cp_info['unit_options'] // 计价数量
        };
    } else {
        var list_cp_info = fun.getListInfoByKey(cp_list || [], list_data['cp_id']) || {};
        list_data['fzbh'] = fun.getValByKey(cp_list || [], list_data['cp_id'], 'assistant_number') || '';
        list_data['fzmc'] = fun.getValByKey(cp_list || [], list_data['cp_id'], 'assistant_name') || '';

        list_data['fk'] = list_cp_info['width'] || '';
        list_data['kz'] = list_cp_info['weight'] || '';
        list_data['gg'] = list_cp_info['spec'] || '';

        $('#fk').val(list_data['fk'] || '');
        $('#kz').val(list_data['kz'] || '');

        if (list_data['cp_ys_bh'] === '色卡') {
            shSkLx();
        } else {
            if (fun.getValByKey(fun.getItem('ck_list') || [], ((__PAGE_DATA['ck_info'] && __PAGE_DATA['ck_info']['id']) || 0), 'type') === 'skyb') {
                if (list_data['dw_mc'] === '份' || list_data['jjdw_mc'] === '份') {
                    list_data = $.extend(true, { cp_id: list_data['cp_id'] }, list_data);
                    __setUnit(list_data);
                } else {
                    __setUnit(list_data);
                }
            } else {
                __setUnit(list_data);
            }
        }

        updateLx();

        if ($.nui.isTrue(page_data['__route'])) {
            if ($.nui.isTrue(page_data['ys_tmp'])) {
                var ys_info = page_data['ys_tmp'];
                if (_options['setColorEmpty']) {
                    list_data['cp_ys_id'] = 0;
                    list_data['cp_ys_bh'] = '';
                    list_data['cp_ys_mc'] = '';
                } else {
                    list_data['cp_ys_id'] = ys_info['id'];
                    list_data['cp_ys_bh'] = ys_info['number'];
                    list_data['cp_ys_mc'] = ys_info['name'];
                }

                $('#color_search').val((list_data['cp_ys_bh'] || '') + ' ' + (list_data['cp_ys_mc'] || '')).data({
                    'cp_ys_id': list_data['cp_ys_id'],
                    'cp_ys_bh': list_data['cp_ys_bh'],
                    'cp_ys_mc': list_data['cp_ys_mc']
                });

                if (list_data['cp_ys_bh'] === '色卡') {
                    shSkLx();
                } else {
                    if (fun.getValByKey(fun.getItem('ck_list') || [], ((__PAGE_DATA['ck_info'] && __PAGE_DATA['ck_info']['id']) || 0), 'type') === 'skyb') {
                        if (list_data['dw_mc'] === '份' || list_data['jjdw_mc'] === '份') {
                            list_data = $.extend(true, { cp_id: list_data['cp_id'] }, list_data);
                            __setUnit(list_data);
                        } else {
                            __setUnit(list_data);
                        }
                    } else {
                        __setUnit(list_data);
                    }
                }

                updateLx();
                updateDj();
            }
        }
        PAGE_INIT_DATA = $.extend({}, list_data);
    }

    ROW_DATA = $.extend({}, list_data);
    xsDdXq.upDateLastProductColorName(ROW_DATA);

    // 如果进入的窗口是 ：客户订单、采购订单、采购来货结算、销售退货结算。
    // 如果进入的窗口是：销售开单、采购退货结算 且 当前仓库没有开启：条码管理。

    switch (page_data['djlx']) {
        case 'bp_xsdd':
        case 'bp_cgdd':
            $('#gg').val(ROW_DATA['gg'] || '');
            break;
    }

    if (!__PAGE_DATA['__PAGE_EDIT']) {
        $('input').attr('disabled', true);
    }

    for (var i = 0; i < $('input').length; i++) {
        var ele = $('input').eq(i);
        if (!ele.attr('disabled')) {
            tmpJdDisabled.push(ele.attr('id'));
        }
    }

    if (!$('#dw').attr('disabled')) {
        tmpJdDisabled.push('dw');
    }
    if (!$('#jjdw').attr('disabled')) {
        tmpJdDisabled.push('jjdw');
    }


    if (ROW_DATA['is_jd']) {
    } else {
        for (var i = 0; i < tmpJdDisabled.length; i++) {
            $('#' + tmpJdDisabled[i]).removeAttr('disabled');
        }
    }

    if (!Auth.check(Bills['djlx'], 'edit')) {
        $('input').attr('disabled', true);
    }
    isShop()
    back_ori_data = getRowSaveData();
}

// 标题初始化后 --new
function afterInitHeader(list_data) {
    $('#header_title').html((list_data['cp_bh'] || '') + ' ' + (list_data['cp_mc'] || ''));
    $('#header_title').data({
        cp_id: list_data['cp_id'],
        cp_bh: list_data['cp_bh'],
        cp_mc: list_data['cp_mc'],
    });
    if (__PAGE_DATA['__PAGE_EDIT']) {
        $('#complete_btn').show();
    } else {
        $('#complete_btn').hide();
    }
}

// 初始化图片 --new
function initImgs(list_data) {
    var img_url;
    if (list_data['imgs']) {
        img_url = fun.getImgPath(list_data['imgs']);
    } else if (list_data['cp_imgs']) {
        img_url = fun.getImgPath(list_data['cp_imgs']);
    } else {
        img_url = "../img/logo.png";
    }
    if (img_url == "../img/logo.png") {
        $('.img-box').css({
            'background-color': '#f5f5f5',
            'border-radius': '0.25rem',
        });
    } else {
        $('#preview').attr('src', img_url).css({
            'width': '100%',
            'height': '100%',
            'opacity': 1,
            'margin': 0,
        });
        $('.img-mask').show();
    }
}

// 商城订单禁用
function isShop() {
    if (page_data['is_shop'] == 'shop') {
        // cp ys dw ps sl jjdw dw2 lx kc
        $('#color_search,#color,#sl, #ps, #lx, #jjcd_mc, #dw, #jjdw, #jjsl_val').css('pointer-events', 'none').attr('disabled', true);
    } else {
        $('#color_search,#color,#sl, #ps, #lx, #jjcd_mc, #dw, #jjdw, #jjsl_val').css('pointer-events', 'auto').removeAttr('disabled');
    }
}

//点击返回，或按键返回触发
function backCallback() {
    back_save_data = getRowSaveData();

    console.log('JD_FROM_JL', JD_FROM_JL)

    // console.log(JSON.stringify(back_ori_data))
    // console.log(JSON.stringify(back_save_data))

    // if(back_ori_data['jjcd_mc']===null){
    //     back_save_data['jjcd_mc'] = null;
    // }
    // if(back_ori_data['jjcd_colour']===null){
    //     back_save_data['jjcd_colour'] = null;
    // }

    if (!JD_FROM_JL && $.nui.isObjEquals(back_ori_data, back_save_data)) {
        // if (JD_FROM_JL) {
        //     api.sendEvent({
        //         name: page_data.return_page,
        //         extra: {
        //             'status': 'close_win',
        //         }
        //     });
        // }
        return closeAndSendEvent();
    }

    // if (__DJ_DATA['is_jd'] && JD_FROM_JL) {
    //     fun.dialog({
    //         content: '您确定要保存吗？',
    //         btn: ['保存', '不保存', '取消'],
    //         shadeClose: false,
    //         className: 'data-change-skin',
    //         yes: function () {
    //             jdFun();
    //         },
    //         no: function () {
    //             api.closeWin();
    //         }
    //     });
    //     return;
    // }

    __setRowData(null, { upDateSssl: false });

    if (page_data['djlx'] === 'bp_xsdd') {
        // delete ROW_DATA['sszje'];
    }
    if ($.nui.isEmpty(__PAGE_DATA['edit_row']) && $.nui.isEmpty(ROW_DATA['zsl']) && $.nui.isEmpty(ROW_DATA['ps'])) {
        if (page_arr.choice_product === page_data['return_page']) {
            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    'status': 'update_rows',
                    'data': {
                        __JL_DATA: __JL_DATA,
                        JD_FROM_JL: JD_FROM_JL
                    }
                }
            });
        }

        return closeAndSendEvent();
    } else {
        // if ($.nui.isEmpty(ROW_DATA['cp_ys_id'])) return fun.toast('请选择颜色！');

        if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && ($.nui.isTrue(parseFloat(ROW_DATA['zsl'] || 0)) || $.nui.isTrue(parseInt(ROW_DATA['ps'] || 0)))) return fun.toast('请选择颜色！');
        if ($.nui.isEmpty(ROW_DATA['cp_ys_id']) && $.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(parseInt(ROW_DATA['ps'] || 0))) {
            return closeAndSendEvent();
        }

        // if ($.nui.isEmpty(ROW_DATA['zsl']) && $.nui.isEmpty(ROW_DATA['ps'])) return fun.toast('请填写数量或匹数！');
        if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) return fun.toast('请选择计价单位！');


        if (!JD_FROM_JL) {
            ROW_DATA['djtz_jl_jd'] = 1;
            ROW_DATA['dj_jd_from_jd'] = 0;
        } else {
            ROW_DATA['djtz_jl_jd'] = 0;
            ROW_DATA['dj_jd_from_jd'] = 1;
        }

        if (__PAGE_DATA['edit_row']) {
            __JL_DATA.splice(__PAGE_DATA['row_index'], 1, ROW_DATA);
        } else {
            __JL_DATA.push(ROW_DATA);
        }

        var tmp_return_page = page_data['return_page'];

        if ($.nui.isTrue(page_data['__route'])) {
            if (page_data['kdbj_tmp']) {
                page_data['return_page'] = page_data['kdbj_tmp']['return_page'];
            }
        }
        var is_save_djtz = (__DJ_DATA['is_fh'] || __DJ_DATA['is_has'] || __DJ_DATA['is_has_cgdd'] || __DJ_DATA['is_has_wwjg']) ||
            (ROW_DATA['is_has'] || ROW_DATA['is_has_cgdd'] || ROW_DATA['is_has_wwjg']);

        api.sendEvent({
            name: page_data.return_page,
            extra: {
                'status': 'update_phsz',
            }
        });

        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'update_rows',
                'data': {
                    __JL_DATA: __JL_DATA,
                    save_djtz: is_save_djtz,
                    JD_FROM_JL: JD_FROM_JL
                }
            }
        });

        if ($.nui.isTrue(page_data['__route'])) {
            api.closeToWin({ name: tmp_return_page });
        } else {
            closeAndSendEvent();
        }
    }
}

// 设置开单偏好设置
function setKdph(data) {
    var tmp_list = [];
    var _data = data || [];

    for (var i = 0; i < _data.length; i++) {
        tmp_list.push(_data[i]['id']);
    }

    // if (SYS_CONFIG['kdphsz'] == tmp_list.join(',')) {
    //     return;
    // }

    var save_data = {
        "type": "sys",
        "list": [
            { "key": "kdphsz", "value": tmp_list.join(',') }
        ]
    };

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveSysConfig,
        data: save_data,
        success: function (res) {
            if (res['status'] == 0) {
                fun.load_DATA_LIST(['sys_config'], function () {
                    showPhszHtml(function () {
                        $('#fk').val(ROW_DATA['fk'] || '');
                        $('#kz').val(ROW_DATA['kz'] || '');
                        $('#gg').val(ROW_DATA['gg'] || '');
                    });
                }, { showLoad: false });
            } else {
                fun.toast('保存失败');
            }
        }
    });
}

// 设置清除按钮是否显示
function setClearBtnShow(flag) {
    var tmpFlag;
    if (flag) {
        tmpFlag = parseFloat($('#value').val().trim() || 0);
    } else {
        tmpFlag = $('#value').val().trim();
    }

    if (tmpFlag) {
        $('#remove').show();
    } else {
        $('#remove').hide();
    }
}

// 关闭当前页面，发送通知事件
function closeAndSendEvent() {
    api.sendEvent({
        name: page_data.return_page,
        extra: {
            'status': 'update_phsz',
        }
    });

    api.sendEvent({
        name: page_data.return_page,
        extra: {
            'status': 'close_win',
        }
    });

    setTimeout(function () {
        if ($.nui.isTrue(__PAGE_DATA['edit_row'])) {
            // api.closeWin();
            api.closeToWin({ name: target_page });
        } else {
            api.closeToWin({ name: page_arr.choice_product });
            // api.closeToWin({ name: target_page });
        }
    }, 300);
}

function __checkData() {
    // if(fun.clearCpData) {
    //     fun.remove_DATA_LIST('cp');
    //     fun.clearCpData = false;
    // }
    if (!fun.dataIsRead(['cp'])) {
        setTimeout(__checkData, 250);
    } else {
        setTimeout(function () {
            if (typeof page_init === "function") page_init();
        }, 100);
    }
}

// 重置页面数据
function resetData() {
    $('#color_search').val('').removeData();
    $('#lx').text('').removeData();
    $('#gh,#ps,#sl,#je,#ssj,#ssje').val('');
    $('#jjsl_val').val('');
    $('#dj').val(0);

    setJjslColor();

    ROW_DATA['mx'] = [];
    ROW_DATA['hsdj'] = 0;
    ROW_DATA['dj'] = 0;
    ROW_DATA['gh'] = '';
    ROW_DATA['ps'] = '';
    ROW_DATA['zsl'] = '';
    ROW_DATA['jjsl'] = '';

    ROW_DATA['ssdj'] = 0;

    // 20191126
    setAfterChangeColor({
        'cp_ys_id': 0,
        'cp_ys_bh': '',
        'cp_ys_mc': ''
    });
    updateLx();

    cache_data['target'] = '';

    $('#value').length && $('#value').val('');

    $('input').removeClass('active-border');
    setPanelHide();
}

// 20191126
// 更换颜色后事件
function setAfterChangeColor(options) {
    var _options = $.extend({ cp_ys_id: 0, cp_ys_bh: '', cp_ys_mc: '' }, options);

    var cp_ys_bh = _options['cp_ys_bh'];
    if (cp_ys_bh === '色卡') {
        shSkLx();
    } else {
        if ($('#lx').data('jg_lx') == 'sk') {
            $('#lx,#dw,#jjdw').removeAttr('disabled');
        }

        ROW_DATA['dw_id'] = __PAGE_DATA['list_data']['dw_id'] || 0;
        ROW_DATA['dw_mc'] = __PAGE_DATA['list_data']['dw_mc'] || '';

        __setUnit(ROW_DATA, _options.notUpDateJjdw, _options.notUpDateUnit);
    }

    /*
        色卡切换非色卡，非色卡切换色卡才需要更新，非色卡切换非色卡不需要重新计算（单位和计价单位不需要重新读取）
        _options.notUpDateJjdw 和 _options.notUpDateUnit 为 true 已经判断了是非色卡和非色卡之间的切换关系
    */

    var upDateParams = {};
    if (_options.notUpDateJjdw && _options.notUpDateUnit) {
        upDateParams = { calcJjsl: false };
    } else {
        upDateParams = { calcSssl: true };
    }
    updateRowDataAmountAndMoney(null, ROW_DATA, upDateParams);

    $('#jjsl_val').val(ROW_DATA['jjsl'] || 0);
    setJjslColor();
}

// 设置从搜索页返回的值
function setSelectedValue(params) {
    var data = params.data;
    var listData = data['list_data'];
    switch (data['page_type']) {
        case 'cp_ys':
            if (Number($('#color_search').data('cp_ys_id')) === Number(data.id)) return;
            $('#color_search').val((listData['number'] || '') + ' ' + (listData['name'])).data({
                'cp_ys_id': data['id'],
                'cp_ys_bh': listData['number'],
                'cp_ys_mc': listData['name']
            });

            var transmitParams = {
                'cp_ys_id': data['id'],
                'cp_ys_bh': listData['number'],
                'cp_ys_mc': listData['name'],
            }

            /*
                非色卡切换到色卡，色卡切换到非色卡，才需要重新赋值单位和计价单位
                当前情况为 非色卡切换非色卡（不需要更新）
            */
            if (xsDdXq.lastProductColorName !== '色卡' && xsDdXq.nowProductColorName(transmitParams) !== '色卡') {
                transmitParams.notUpDateUnit = true;
                transmitParams.notUpDateJjdw = true;
            }

            // 20191126
            setAfterChangeColor(transmitParams);

            xsDdXq.upDateLastProductColorName({
                cp_ys_bh: listData['number'],
                cp_ys_mc: listData['name']
            });

            updateLx();
            updateDj();

            setColorBtnDisplay();

            break;
        case 'dw':
            // 选单位，选择相同但是是点击选中，不需要重新计算
            if (fun.toNumber($('#dw').data('dw_id')) === fun.toNumber(data['id'])) {
                return;
            }
            ROW_DATA['dw_mc'] = data['select_val'];
            $('#dw').text(data['select_val']).data('dw_id', data['id']);
            __setRowData(null, { dw_id: data['id'], dw_mc: data['select_val'] }, {});

            if ($.nui.isEmpty($('#jjdw').data('jjdw_id'))) {
                $('#jjdw').text(data['select_val']).data('jjdw_id', data['id']);
            }

            break;
        case 'jjdw':
            $('#sel_jjdw').text(data['select_val']).data('jjdw_id', data['id']);

            ROW_DATA['jjdw_id'] = data['id'];
            ROW_DATA['jjdw_mc'] = data['select_val'];

            $('#jjdw').data('jjdw_id', data['id']);

            //20191023计价单位
            updateDataAfterChangeDw();
            cache_data['kcms'] = ROW_DATA['kcms'] || '+';
            cache_data['kc'] = ROW_DATA['kc'] || 0;
            cache_data['jjsl'] = ROW_DATA['jjsl'] || 0;
            cache_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
            cache_data['jjdw_mc'] = ROW_DATA['jjdw_mc'] || '';

            cache_data['kcms'] = ROW_DATA['kcms'] || '+';
            cache_data['kc'] = ROW_DATA['kc'] || 0;
            cache_data['jjsl'] = ROW_DATA['jjsl'] || 0;
            cache_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
            cache_data['jjdw_mc'] = ROW_DATA['jjdw_mc'] || '';

            break;
        case 'jjcd':
            var colour = (data['list_data']['config'] && data['list_data']['config']['colour'] || '');
            if ($.nui.isTrue(data['select_val'])) {
                $('#jjcd_mc').text(data['select_val'] || '暂无').css({
                    'backgroundColor': colour,
                    'padding-left': '0.25rem',
                }).removeClass('black-import').addClass('white-import');//紧急程度
                $('#jjcd_mc').data({
                    jjcd_id: data['id'] || 0,
                    jjcd_mc: data['select_val'] || '',
                    colour: colour
                })
            } else {
                $('#jjcd_mc').text('暂无');
                $('#jjcd_mc').css({
                    'backgroundColor': '#fff',
                    'padding-left': 0
                }).removeClass('white-import').addClass('black-import');//紧急程度

                $('#jjcd_mc').data({
                    jjcd_id: 0,
                    jjcd_mc: '',
                    colour: ''
                })
            }
            break;
    }
}

//更新单价
function updateDj(callback) {
    getRowSaveData();

    __PAGE_DATA['__DJ_DATA'] = __PAGE_DATA['__DJ_DATA'] || {};
    __PAGE_DATA['ck_info'] = __PAGE_DATA['ck_info'] || {};

    __getDj({
        data: {
            "djlx": Bills['djlx'],
            "wldw_id": __PAGE_DATA['__DJ_DATA']['wldw_id'] || 0,
            "cp_id": ROW_DATA['cp_id'] || 0,
            "cp_ys_id": ROW_DATA['cp_ys_id'] || 0,
            "jjdw_id": ROW_DATA['jjdw_id'] || 0,
            "kdsj": __PAGE_DATA['__DJ_DATA']['kdsj'] || fun.formatDate(new Date()),
            "dj_info": ROW_DATA['dj_info'] || {},
            "dd_dj_id": ROW_DATA['dd_dj_id'] || 0,
            "dd_jl_id": ROW_DATA['dd_jl_id'] || 0,
            "gx_id": ROW_DATA['gx_id'] || 0,

            // 获取成本价 需要用到 仓库、单位
            "ck_id": __PAGE_DATA['ck_info']['id'] || 0,
            "dw_id": ROW_DATA['dw_id'] || 0,
            // 标准价 最低价 需要用到类型
            // "jg_lx": fun.getValByKey(fun.getSaleLxData({ showAll: true }) || [], ROW_DATA['jg_lx_mc'], 'simple', 'name') || 'dh'
            "jg_lx": ROW_DATA['jg_lx'] || 'dh'
        },
        callback: function (res) {
            if (res['status'] == 0) {
                // $('#dj').val(res['data']['dj']);

                var dj_data = {
                    dj: res['data']['dj']
                };

                switch (page_data['djlx']) {
                    case 'bp_xsdd':
                        dj_data['ssdj'] = res['data']['ssdj'];
                        dj_data['bzj'] = res['data']['bzj'] || 0;
                        dj_data['zdj'] = res['data']['zdj'] || 0;
                        break;
                }

                __setRowData(null, dj_data, { setSsj: true, upDateSssl: false, upDateSsdj: true });

                $('#dj').val(ROW_DATA['hsdj'] || 0);
                $('#ssdj').val(ROW_DATA['ssdj'] || 0);
                // 获取上次价
                if (__PAGE_DATA.loadScdj) {
                    ROW_DATA.scdj = res.data.scdj;
                }
            }
        }
    });
}

// 更新类型
function updateLx() {
    if ($('#color_search').data('cp_ys_bh') === '色卡') {
        shSkLx();
    } else if (__PAGE_DATA['ck_info']['type'] === 'skyb') {
        $('#lx').text('样版').data('jg_lx', 'yb');
    } else {
        if ($('#lx').data('jg_lx') && $('#lx').data('jg_lx') != 'dh') {

        } else {
            $('#lx').text('大货').data('jg_lx', 'dh');
        }
    }
}

//设置计价数量颜色
function setJjslColor() {
    if ($('#sl').val().trim() == $('#jjsl_val').val().trim()) {
        $('#jjsl_val').css('color', '#000');
    } else {
        $('#jjsl_val').css('color', '#18b4ed');
    }
}

// 20191126
// 色号为色卡时更新单位、计价单位、类型
function shSkLx() {
    var jjdw_list = fun.getItem('jjdw_list') || [];
    var sk_dw_id = fun.getValByKey(jjdw_list || [], '份', 'id', 'name');
    var sk_dw_mc = '份';

    ROW_DATA['dw_id'] = sk_dw_id;
    ROW_DATA['dw_mc'] = sk_dw_mc;
    ROW_DATA['jjdw_id'] = sk_dw_id;
    ROW_DATA['jjdw_mc'] = sk_dw_mc;
    ROW_DATA['jg_lx'] = 'sk';
    ROW_DATA['jg_lx_mc'] = '色卡';

    $('#lx').text('色卡').data('jg_lx', 'sk').attr('disabled', true);
    $('#dw').text(sk_dw_mc).data('dw_id', sk_dw_id).attr('disabled', true);
    $('#jjdw').text(sk_dw_mc).data('jjdw_id', sk_dw_id).attr('disabled', true);
}

// 选产品后设置单位
function __setUnit(list_data, notUpDateJjdw, notUpDateUnit) {
    console.log('---------------list_data---------------');
    console.log(list_data);
    var tempNotUpDateUnit = $.nui.isEmpty(notUpDateJjdw) && $.nui.isEmpty(notUpDateUnit);

    if (tempNotUpDateUnit) {
        $('#dw').text(list_data['dw_mc'] || '单位').data('dw_id', list_data['dw_id'] || 0);
    }
    var cp_list = fun.getItem('cp_list') || [];
    var jjdw_list = fun.getItem('jjdw_list') || [];
    // 根据 往来单位类型, 赋值 档案 预设的 计价单位
    var unit_options = fun.getValByKey(cp_list || [], list_data['cp_id'], 'unit_options');

    if (tempNotUpDateUnit) { // 换颜色之后，计价数量不用重新换算（2020-4-16 测试登记错误，换颜色重新换算导致算法错误）
        switch (Bills['wldw_type']) {
            case 'kh':
                list_data['jjdw_id'] = unit_options['xsdw_id'];
                break;
            case 'gys':
                list_data['jjdw_id'] = unit_options['cgdw_id'];
                break;
            case 'jgs':
                list_data['jjdw_id'] = unit_options['jgdw_id'];
                break;
        }

        list_data['jjdw_mc'] = fun.getValByKey(jjdw_list || [], list_data['jjdw_id'], 'name');

        if ($.nui.isEmpty(list_data['jjdw_id'])) {
            list_data['jjdw_id'] = list_data['dw_id'] || 0;
            list_data['jjdw_mc'] = list_data['dw_mc'] || '';
        }

        $('#jjdw').text(list_data['jjdw_mc'] || ' ').data('jjdw_id', list_data['jjdw_id'] || 0);
    }

    // 有开启一匹多仓库,则要赋值 单位2
    if (tempNotUpDateUnit && $.nui.isTrue(SYS_CONFIG['ypbddwgl'])) {
        list_data['dw2_id'] = unit_options['dw2_id'] || 0;
        list_data['dw2_mc'] = fun.getValByKey(jjdw_list || [], list_data['dw2_id']);
    }
}

// 更新数据信息
// function selectUpdateInfo(data) {
//     var del_id = data['del_id'];
//     var updateArr = data['update'];

//     //数组值转字符串
//     function convert(arr) {
//         return String(arr).split();
//     }

//     switch (data['page_type']) {
//         case 'jjcd':
//             var row_id = $('#jjcd_mc').data('jjcd_id') || 0;
//             if ($.nui.isTrue(data['del_id'])) {

//                 for (var i = 0; i < data['del_id'].length; i++) {
//                     var item = data['del_id'][i];
//                     if (item == row_id) {
//                         $('#jjcd_mc').data({ 'jjcd_id': 0, colour: '' }).text('').css('backgroundColor', 'transparent');
//                     }
//                 }
//             }
//             if ($.nui.isTrue(data['update'])) {
//                 for (var i = 0; i < data['update'].length; i++) {
//                     var item = data['update'][i];
//                     if (item['id'] == row_id) {
//                         var colour = (item['config'] && item['config']['colour'] || '');
//                         $('#jjcd_mc').data({
//                             jjcd_id: item['id'],
//                             colour: colour
//                         }).text(item['name'] || "").css('backgroundColor', colour);
//                     }
//                 }
//             }

//             break;
//     }
// }






// 页面初始化时是否可编辑元素
function initEditDom() {
    if ($.nui.isTrue(__PAGE_DATA['__PAGE_EDIT'])) {
        $('input,#dw,#jjdw,#sel_jjdw,#toggle,#color_search,#color,#lx').removeAttr('disabled');
        $('#scgys,#complete_btn').show();
    } else {
        $('input,#dw,#jjdw,#sel_jjdw,#toggle,#color_search,#color,#lx').attr('disabled', true);
        $('#scgys,#complete_btn').hide();
    }
}

// 获取记录行保存数据
function getRowSaveData() {
    $('#hqts').blur();
    var list_data = __PAGE_DATA['list_data'] || {};

    __PAGE_DATA['ck_info'] = __PAGE_DATA['ck_info'] || {};

    var data3 = {
        "ck_id": __PAGE_DATA['ck_info']['id'] || 0,
        "ck_mc": __PAGE_DATA['ck_info']['name'] || '',
        "cp_id": $('#header_title').data('cp_id') || 0,
        "cp_bh": $('#header_title').data('cp_bh') || '',
        "cp_mc": $('#header_title').data('cp_mc') || '',
        "cp_ys_id": $('#color_search').data('cp_ys_id') || 0,
        "cp_ys_bh": $('#color_search').data('cp_ys_bh') || '',
        "cp_ys_mc": $('#color_search').data('cp_ys_mc') || '',
        "fk": $('#fk').val().trim(),
        "kz": $('#kz').val().trim(),
        // "gh": $('#gh').val().trim(),
        "gg": $('#gg').val().trim(),
        "jg_lx_mc": $('#lx').length ? ($('#lx').text().trim() || '大货') : '大货',
        "jg_lx": $('#lx').length ? ($('#lx').data('jg_lx') || 'dh') : 'dh',
        "ps": parseInt($('#ps').val().trim() || 0),
        "dw_id": $('#dw').data('dw_id') || 0,
        "dw_mc": $('#dw').text().trim(),
        "zsl": parseFloat($('#sl').val().trim() || 0),
        "jjdw_id": $('#jjdw').data('jjdw_id') || 0,
        "jjdw_mc": fun.getValByKey(fun.getItem('jjdw_list') || [], $('#jjdw').data('jjdw_id') || 0) || '',

        "hsdj": parseFloat($('#dj').val().trim() || 0),

        bz: $('#remark').val().trim() || '',
        hqts: $('#hqts').val().trim() || 0,
        hq: $('#hq').data('hq') || '',
        //20190920 新增保存数据
        jjcd: $('#jjcd_mc').data('jjcd_id') || 0,
        jjcd_mc: $('#jjcd_mc').data('jjcd_mc') || '',
        jjcd_colour: $('#jjcd_mc').data('colour') || ''
    };

    ROW_DATA = $.extend({}, list_data, ROW_DATA, data3);

    if (typeof ROW_DATA['jjsl'] === 'undefined') {
        ROW_DATA['jjsl'] = 0;
    }

    if ($.nui.isEmpty(ROW_DATA['jjsl'])) {
        ROW_DATA['jjsl'] = 0;
    }

    switch (page_data['djlx']) {
        case 'bp_xsdd':
        case 'bp_cgdd':
            break;
    }

    delete ROW_DATA['mx'];

    list_data = list_data || {};
    ROW_DATA = ROW_DATA || {};

    if (list_data['jjcd_mc'] === null && ROW_DATA['jjcd_mc'] === '') {
        ROW_DATA['jjcd_mc'] = null
    }

    if (list_data['jjcd_colour'] === null && ROW_DATA['jjcd_colour'] === '') {
        ROW_DATA['jjcd_colour'] = null
    }

    if ($.nui.isEmpty(ROW_DATA['__row_uuid'])) {
        ROW_DATA['__row_uuid'] = $.nui.getRandomNum();
    }

    return ROW_DATA;
}

// 设置键盘隐藏
function setPanelHide() {
    $('.form_edit,.layer-content').hide();
    $('#toggle').find('.icon-toggle').removeClass('icon-xia').addClass('icon-shang');

    $('.layer-content').css({
        height: '2.5rem'
    });

    setClearBtnShow();
}

// 设置键盘显示
function setPanelShow() {
    if (!showKeyBoard) return;
    $('.form_edit,.layer-content').show();
    $('#toggle').find('.icon-toggle').removeClass('icon-shang').addClass('icon-xia');

    $('.layer-content').css({
        height: '12.75rem'
    });

    setClearBtnShow();
}

//更新数据更改单位之后
function updateDataAfterChangeDw() {
    // jjObj = {
    //     kcms: $('.symbol.active').data('type') || '',
    //     kc: $('#kc').val().trim(),
    //     jjdw_id: $('#sel_jjdw').data('jjdw_id'),
    //     jjdw_mc: $('#sel_jjdw').text(),
    //     jjsl: $('#jjsl').val(),
    //     jjsfscks: $('.check-box').hasClass('check-choice')
    // };

    ROW_DATA['kcms'] = $('.symbol.active').data('type') || '';
    ROW_DATA['kc'] = $('#kc').val().trim();
    ROW_DATA['jjdw_id'] = $('#sel_jjdw').data('jjdw_id');
    ROW_DATA['jjdw_mc'] = $('#sel_jjdw').text();
    // ROW_DATA['jjsl'] = $('#jjsl').val();

    if (ROW_DATA['kcms'] == '-') {
        ROW_DATA['kcms'] = '+';
        ROW_DATA['kc'] = -parseFloat(ROW_DATA['kc'] || 0);
    }
    $('#jjsl_val').val(ROW_DATA['jjsl']);
    setJjslColor();
    $('#jjdw').text(ROW_DATA['jjdw_mc']).data(ROW_DATA['jjdw_id']);

    jjsfssl = $('.check-box').hasClass('check-choice');
    if (jjsfssl) {
        var num = fun.dwhs({
            dw: ROW_DATA['dw_mc'] || '',
            jjdw: ROW_DATA['jjdw_mc'] || '',
            jjsl: ROW_DATA['jjsl'] || 0,
            kcms: ROW_DATA['kcms'] || '+',
            kc: ROW_DATA['kc'] || 0,
            ps: ROW_DATA['ps'] || 0,
            is_back: true, //反算
        });

        ROW_DATA['zsl'] = num;
    } else {
        // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
    }

    // __setRowData(null, {
    //     jjsl: ROW_DATA['jjsl'] || 0,
    //     // zsl: ROW_DATA['zsl'] || 0,
    //     // kcms: ROW_DATA['kcms'] || '',
    //     // kc: parseFloat(ROW_DATA['kc'] || 0),
    //     // jjdw_id: ROW_DATA['jjdw_id'] || 0,
    //     // jjdw_mc: ROW_DATA['jjdw_mc'] || ''
    // });

    var dwhs_data = {};

    if (cache_data['kcms'] != ROW_DATA['kcms']) {
        dwhs_data['kcms'] = ROW_DATA['kcms'] || '+';
    }
    if (cache_data['kc'] != ROW_DATA['kc']) {
        dwhs_data['kc'] = ROW_DATA['kc'] || 0;
    }
    // if (cache_data['jjsl'] != ROW_DATA['jjsl']) {
    //     dwhs_data['jjsl'] = ROW_DATA['jjsl'] || 0;
    // }
    if (cache_data['jjdw_id'] != ROW_DATA['jjdw_id']) {
        dwhs_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
    }

    dwhs_data['zsl'] = ROW_DATA['zsl'] || 0;

    if ($.nui.isTrue(dwhs_data)) {
        __setRowData(null, dwhs_data, {
            upDateSssl: false
        });
    }

    if (jjsfssl) {
        ROW_DATA['jjsl'] = parseFloat($('#jjsl').val() || 0);
    } else {
        // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
    }


    $('#sl').val(ROW_DATA['zsl']);
    $('#jjsl_val').val(ROW_DATA['jjsl']);
    $('#jjsl').val(ROW_DATA['jjsl']);

    //     setRowDataJjsl({
    //         kcms: jjObj['kcms'] || '',
    //         kc: parseFloat(jjObj['kc'] || 0),
    //         jjdw_id: jjObj['jjdw_id'] || 0,
    //         jjdw_mc: jjObj['jjdw_mc'] || '',
    //     });
    //
    //     var __data = $.nui.isEmpty(store_data) ? getData() : store_data;

    //记录行匹数小于2时，则 计价数量允许反算出数量
    if (ROW_DATA['ps'] < 2) {
        //有开启 计价数反算出数量
        if (jjsfssl) {
            var num = fun.dwhs({
                dw: ROW_DATA['dw_mc'] || '',
                jjdw: ROW_DATA['jjdw_mc'] || '',
                jjsl: ROW_DATA['jjsl'] || 0,
                kcms: ROW_DATA['kcms'] || '+',
                kc: ROW_DATA['kc'] || 0,
                fk: ROW_DATA['fk'] || '',
                kz: ROW_DATA['kz'] || '',
                ps: ROW_DATA['ps'] || 0,
                is_back: true
            });

            ROW_DATA['zsl'] = num;
            ROW_DATA['jjsl'] = $('#jjsl').val() || 0;

            $('#jjsl_val').val(ROW_DATA['jjsl']);
            $('#sl').val(ROW_DATA['zsl']);
            setJjslColor();

            var t_mx = ROW_DATA['mx'] || [];
            var t_data = {};

            if ($.nui.isEmpty(t_mx)) {
                t_data = { zsl: num, no_calc_jjsl: 1 };/*, is_fs: 1*/
                if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                    t_data['ps'] = 1;
                    t_data['mx'] = [{ px: 1, ph: 1, sl: num }];
                }
            } else {
                var isPush = true;
                for (var i = 0; i < t_mx.length; i++) {
                    if ($.nui.isTrue(t_mx[i]['is_delete'])) continue;
                    if ((t_mx[i]['tm_sl'] > 0) && (num > 0)) {
                        // 如果当前仓库有开启：不负库存
                        // 当用户修改的数量大于该布匹对应的库存数时，修改无效。
                        if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_minus'))) {
                            if (num > t_mx[i]['tm_sl']) num = t_mx[i]['sl'] || 0;
                        }
                    }
                    t_mx[i]['sl'] = num;
                    isPush = false;
                }

                if (isPush && $.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                    t_mx.push({ px: 1, ph: 1, sl: num })
                }
                t_data = { zsl: num/*, is_fs: 1*/, no_calc_jjsl: 1 };
            }

            __setRowData(null, t_data, {
                upDateSssl: false
            });

            $('#ps').val(ROW_DATA['ps']);
        }
    }
    setJjslColor();

    if ((cache_data['jjdw_id'] != ROW_DATA['jjdw_id'])) {
        updateDj();
    }

}

// 改变单价后事件
function afterGetRowData() {
    console.log('afterGetRowData');
    // var _options = $.extend({ setDj: true, setJe: true }, options);
    $('#je').val(ROW_DATA['hszje'] || 0);

    if (parseFloat($('#ssj').val() || 0) == parseFloat(ROW_DATA['ssdj'] || 0)) {

    } else {
        $('#ssj').val(ROW_DATA['ssdj'] || 0);
    }
    var ssje = ROW_DATA['sszje'] || 0;
    // if (page_data.djlx != 'bp_xsdd') {
    //     ssje = ROW_DATA['sszje'] || 0;
    // } else {
    //     ssje = ROW_DATA['ssje'] || 0;
    // }
    // $('#ssje').val(ssje);
    // $('#hk').val($.nui.decimalSub((ROW_DATA['hszje'] || 0), ssje));

    if (page_data['djlx'] === 'bp_xsdd') {
        $('#ssje').val(ssje);
        $('#sss').val(ROW_DATA['sssl'] || 0);
        $('#hk').val($.nui.decimalSub((ROW_DATA['hszje'] || 0), ssje));
        xsDdXq.setJjsl();
    }
}

// 记录表单元格编辑后触发的事件
function setRowData(index, data, opt, _data) {
    switch (page_data.djlx) {
        case 'bp_xsdd':
            _data['ssdj'] = parseFloat(_data['ssdj'] || 0);
            //如果没有开启实售价 则拿单价字段
            if ($.nui.isTrue(SYS_CONFIG[Bills['config']['qyssjms']])) {// || opt['setSsj']
                if (opt.upDateSsdj) { // 限制 setRowData方法 实售价 = 单价的判断只执行一次
                    if ($.nui.isTrue(_data.dj) && $.nui.isEmpty(_data.ssdj)) { // 有单价没实售单价，实售价 = 单价
                        _data['ssdj'] = _data['dj'];
                    };
                }
                if (opt.upDateSssl) {
                    _data['sssl'] = fun.toNumber(fun.dwhs({
                        zsl: _data['bqsl'] || 0,
                        ps: _data['ps'] || 0,
                        fk: _data['fk'] || '',
                        kz: _data['kz'] || '',
                        dw: _data['dw_mc'] || '',
                        jjdw: _data['jjdw_mc'] || '',
                        kc: _data['sskc'] || 0,
                        kcms: _data['kcms'] || '+',
                        mx: []
                    }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                }
            }
            _data['ssje'] = (_data['ssdj'] * (_data['sssl'] || 0)).fixed();
            _data['ssje'] = __jeSswr(_data['ssje']);
            _data['sszje'] = _data['ssje'];
            // 自定义费用
            for (var i = 1; i <= 5; i++) _data['sszje'] += parseFloat(_data['fy_zdy' + i] || 0);
            _data['sszje'] = __jeSswr(_data['sszje']);
            break;
    }
}

// 行记录添加方法
function addRow(options) {
    getRowSaveData();
    __setRowData(null, {}, { upDateSssl: false });

    if ($.nui.isEmpty(ROW_DATA['cp_ys_id'])) {
        // 没有选颜色 但 有填 数量 或者 匹数 则要提示： 请选择颜色 
        if ($.nui.isTrue(parseFloat(ROW_DATA['zsl'] || 0)) || $.nui.isTrue(ROW_DATA['ps'])) {
            fun.toast('请选择颜色！');
            return { status: 'empty_ys', msg: '颜色不能为空' };
        }
    } else {
        // 有选颜色 但 数量、匹数 都没有填 
        if ($.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(ROW_DATA['ps'])) {
            if ($.nui.isEmpty(__PAGE_DATA['edit_row'])) {
                // 如果是新增的情况下，则代表 当次操作不保存
                return { status: 'ok' };
            }
        }
    }

    if ($.nui.isEmpty(ROW_DATA['jjdw_id'])) {// || $.nui.isEmpty(ROW_DATA['jjdw_mc'])
        fun.toast('请选择计价单位！');
        return { status: 'empty_jjdw', msg: '计价单位不能为空' };
    }


    var TMP_ROW_DATA = $.extend({}, ROW_DATA);

    // 判断 匹数 数量 都不能为空 
    if ($.nui.isEmpty(__PAGE_DATA['edit_row']) && ($.nui.isEmpty(parseFloat(ROW_DATA['zsl'] || 0)) && $.nui.isEmpty(ROW_DATA['ps']))) {
        return { status: 'ok' };
    } else {
        if (__PAGE_DATA['edit_row']) {
            __JL_DATA[__PAGE_DATA['row_index']] = TMP_ROW_DATA;
        } else {
            __JL_DATA.push(TMP_ROW_DATA);
        }

        return { status: 'ok' };
    }
}

function bindEvent() {

}

//更多
$('body').on('tap', '#much_btn', function (e) {
    e.stopPropagation();
    $('.collapse-wrap').css('top', api.safeArea.top - 17 + 'px');
    if ($('.collapse-wrap').hasClass('open')) {
        $('.collapse-wrap').removeClass('open');
    } else {
        $('.collapse-wrap').addClass('open');
    }
});

// 右上角删除该颜色
$('body').on('touchend', '#scgys', function (e) {
    e.preventDefault();
    var _this = this;

    var cpysbhmc = ($('#color_search').data('cp_ys_bh') || '') + ' ' + ($('#color_search').data('cp_ys_mc') || '');
    var title = $.nui.isTrue($.trim(cpysbhmc)) ? '【' + $.trim(cpysbhmc) + '】' : '';

    fun.dialog({
        content: '你确定要删除' + title + '吗？',
        btn: ['删除', '取消'],
        yes: function () {

            // 删除成功
            if (typeof __PAGE_DATA['row_index'] !== 'undefined' && __PAGE_DATA['row_index'] != null) {
                __JL_DATA[__PAGE_DATA['row_index']]['is_delete'] = 1;
                __JL_DATA[__PAGE_DATA['row_index']]['__status'] = 'del';
            }

            // 清空当前页面数据，并处于新增状态
            __PAGE_DATA['edit_row'] = false;
            __PAGE_DATA['row_index'] = undefined;
            __PAGE_DATA['list_data'] = $.extend({}, PAGE_INIT_DATA, {
                cp_ys_id: 0,
                cp_ys_bh: '',
                cp_ys_mc: ''
            });

            ROW_DATA = $.extend({}, PAGE_INIT_DATA);

            __PAGE_DATA['MXTM'] = false;
            psslTmpDisabled = [];
            $('input,#color').removeAttr('disabled');

            init({ setColorEmpty: true });
            initColorAdd();
            resetData();
            setColorBtnDisplay();
            isClear = true;
            getRowSaveData();
        }
    });
    $('.collapse-wrap').removeClass('open');
    return false;
});

//偏好设置
$('body').on('touchend', '#phsz', function (e) {
    e.preventDefault();
    e.stopPropagation();
    getRowSaveData();
    var list_data = [
        { name: '幅宽/克重', id: 'fk,kz' },
        { name: '规格', id: 'gg' },
        // { name: '缸号', id: 'gh' }
    ];

    for (var i = 0; i < list_data.length; i++) {
        if (fun.getKdSetting(list_data[i]['id'])) {
            list_data[i]['is_choose'] = 1;
        }
    }

    fun.showBookList({
        width: '280px',
        shadeClose: false,
        checkbox: true,
        list: list_data,
        choose: function (data) {
            setKdph(data);
        }
    });
    $('.collapse-wrap').removeClass('open');
    return false;
});

//点击其他区域，关闭更多
$('body').on('tap', function (e) {
    $('.collapse-wrap').removeClass('open');
});

// 大图预览
$('body').on('tap', '.img-box', function (e) {
    e.preventDefault();
    e.stopPropagation();
    var cp_id = $('#header_title').data('cp_id');

    var cp_info = fun.getListInfoByKey(cp_list, cp_id);
    var cp_imgs = cp_info['imgs'] || '';

    if ($.nui.isEmpty(cp_imgs)) return;
    var img_arr = [];
    cp_imgs = cp_imgs.split(',');

    if ($.isArray(cp_imgs)) {
        for (var i = 0; i < cp_imgs.length; i++) {
            img_arr.push(fun.getImgPath(cp_imgs[i], true));
        }
    } else {
        img_arr.push(fun.getImgPath(cp_imgs, true));
    }
    if (img_arr.length === 0) return;
    photoBrowser.open({
        images: img_arr,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        } else {
        }
    });
    return false;
});

// 点击幅宽克重缸号
$('body').on('click', '#fk,#kz,#gh', function (e) {
    if ($(this).attr('disabled')) return;
    // $(this).select();
    // this.selectionStart = 0;
    // this.selectionEnd = $(this).val().length;
    // $(this).focus().select();
});

// 监听幅宽、克重、缸号输入
$('body').on('input', '#fk,#kz,#gh', function (e) {
    var key = $(this).attr('id');
    var _data = {};
    _data[key] = $(this).val();
    __setRowData(null, _data, {});
});

// 点击body
$('body').on('tap', function (e) {
    // if(target.is('#back_btn')) return;
    e.stopPropagation();
    var target = $(e.target);
    if (target.is('#back_btn') || target.is('.layui-m-layershade')
        || target.is('.layui-m-layermain') || target.is('.layui-m-layermain *')) return;
    if (cache_data['target'] == 'mx') {

    } else {
        __setRowData(null, {}, {
            upDateSssl: false
        });
        $('#jjsl_val').val(ROW_DATA['jjsl'] || '');
    }

    cache_data['target'] = '';
    $('#value').val('');
    $('input').removeClass('active-border');
    setPanelHide();
    setJjslColor();
});

// 计价数量点击
$('body').on('click', '#jjsl_val', function (e) {
    if ($(this).attr('disabled')) return;
    var html = [];
    var style = 'width:92%;height:10.5rem;border:none;background:#fff; border-radius: 0.5rem; position:absolute; top: 30%; left: 4%;';
    html.push('<span class="title">计价</span>');
    html.push('<ul class="list-group">');
    html.push('<li class="item">');
    html.push('		<div class="text-box"><span>空差</span></div>');
    html.push('		<div class="right"><div class="symbol" data-type="+"><span>+</span></div>');
    html.push('		<div class="symbol" data-type="-"><span>-</span></div>');
    html.push('		<div class="symbol" data-type="×" data-type2="*"><span>×</span></div>');
    html.push('		<div class="symbol" data-type="÷" data-type2="/"><span>÷</span></div>');
    html.push('		<input id="kc" type="text" class="input-box equal num-input" num_type="2" decimal_digits="4"/></div>');
    html.push('</li>');
    html.push('<li class="item">');
    html.push('<div class="text-box"><span>计价数</span></div>');
    html.push('<input id="jjsl" type="text" class="input-box num-input" num_type="2" decimal_digits="4"/>');
    // html.push('<select name="" class="input-box drop-down"><option>公斤</option><option>克</option></select>');
    html.push('<div id="sel_jjdw_wrap" class="input-box drop-down"><span id="sel_jjdw" class="ellipsis-span">公斤</span><i class="iconfont icon-xia down-icon"></i></div>');
    html.push('</li>');

    // if (page_data['list_data'] && !($.nui.isTrue(page_data['list_data']['fhps']) || $.nui.isTrue(page_data['list_data']['fhsl']))) {

    // if ($.nui.isEmpty(page_data['list_data'])) {
    if (page_data['djlx'] == 'bp_xsfhjs' && $.nui.isEmpty($('#sl').attr('disabled')) && ROW_DATA['ps'] < 2) {
        html.push('<li class="last-item">');
        html.push('		<div class="check-box"><i class="iconfont icon-check"></i></div>');
        html.push('		<span class="inverse">计价数反算出库数</span>');
        html.push('</li>');
    }

    // }

    html.push('</ul>');
    html.push('<button id="confirm" class="confirm button">确认</button>');
    html.push('<button class="cancel button">取消</button>');
    layer.open({
        type: 1,
        content: html.join(''),
        style: style,
        skin: 'jj-info',
        shadeClose: false,
        success: function (layero, index) {
            var alertObj = {
                kcAndSskcIsSame: fun.toNumber(ROW_DATA['kc']) === fun.toNumber(ROW_DATA['sskc']),
                assign: function () {
                    $('#sss').val(ROW_DATA['sssl'] || 0);
                    $('#ssje').val(xsDdXq.computedSszje());
                    ROW_DATA['ssje'] = xsDdXq.computedSsje();
                    ROW_DATA['sszje'] = xsDdXq.computedSszje();
                    $('#hk').val(xsDdXq.computedHk());
                },
                setRowKcAfter: function () {
                    if (alertObj.kcAndSskcIsSame) {
                        ROW_DATA['sskc'] = ROW_DATA['kc'] || 0;
                        ROW_DATA['sssl'] = fun.toNumber(fun.dwhs({
                            zsl: ROW_DATA['bqsl'] || 0,
                            ps: ROW_DATA['ps'] || 0,
                            fk: ROW_DATA['fk'] || '',
                            kz: ROW_DATA['kz'] || '',
                            dw: ROW_DATA['dw_mc'] || '',
                            jjdw: ROW_DATA['jjdw_mc'] || '',
                            kc: parseFloat(ROW_DATA['sskc'] || 0),
                            kcms: ROW_DATA['kcms'] || '+',
                            mx: []
                        }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                        alertObj.assign();
                    }
                },
                initTempCacheData: function () { // 缓存打开的数据，为了在计价数量弹窗弹起来的情况下，选择单位跳转选择回来会重新赋值
                    var tempRowData = JSON.parse(JSON.stringify(ROW_DATA));
                    return {
                        kcms: tempRowData.kcms,
                        kc: tempRowData.kc,
                        jjsl: tempRowData.jjsl,
                        jjdw_id: tempRowData.jjdw_id,
                        jjdw_mc: tempRowData.jjdw_mc
                    }
                }
            };
            if (ROW_DATA['jjdw_mc'] === '份') $('#sel_jjdw_wrap').attr('disabled', true);
            else { $('#sel_jjdw_wrap').removeAttr('disabled'); }
            cache_data['kcms'] = ROW_DATA['kcms'] || '+';
            cache_data['kc'] = ROW_DATA['kc'] || 0;
            cache_data['jjsl'] = ROW_DATA['jjsl'];
            cache_data['jjdw_id'] = ROW_DATA['jjdw_id'];
            cache_data['jjdw_mc'] = ROW_DATA['jjdw_mc'];
            var tempCache = alertObj.initTempCacheData();

            if ('*/'.indexOf(ROW_DATA['kcms'] || '+') > -1) {
                $('.symbol[data-type2="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
            } else {
                $('.symbol[data-type="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
            }


            $('#kc').val(Math.abs(ROW_DATA['kc'] || 0));
            if (ROW_DATA['kc'] < 0) {
                $('.symbol[data-type="-"]').addClass('active').siblings().removeClass('active');
            }

            $('#jjsl').val(ROW_DATA['jjsl']);
            $('#sel_jjdw').text(ROW_DATA['jjdw_mc']).data('jjdw_id', ROW_DATA['jjdw_id']);

            if (jjsfssl) {
                $('.check-box').addClass('check-choice');
            } else {
                $('.check-box').removeClass('check-choice');
            }

            // 选择空差模式
            $('.symbol').on('tap', function (e) {
                $(this).addClass('active').siblings().removeClass('active');
            });

            // 点击跳转选择计价单位
            $('body').on('tap', '#sel_jjdw_wrap', function (e) {
                if ($(this).attr('disabled')) return;
                fun.showPageFull({
                    page_url: page_arr.select_list,
                    pageParam: {
                        "return_page": html_name,
                        "page_type": 'jjdw',
                        "return_type": 'jjdw'
                    }
                });
            });

            $('.cancel').on('click', function (e) {
                // ROW_DATA['jjdw_id'] = cache_data['jjdw_id'];
                // ROW_DATA['jjdw_mc'] = cache_data['jjdw_mc'];
                ROW_DATA['jjdw_id'] = tempCache['jjdw_id'];
                ROW_DATA['jjdw_mc'] = tempCache['jjdw_mc'];
                ROW_DATA['kc'] = tempCache['kc'];
                ROW_DATA['kcms'] = tempCache['kcms'];
                ROW_DATA['jjsl'] = tempCache['jjsl'];

                $('#jjdw').text(ROW_DATA['jjdw_mc']).data('jjdw_id', ROW_DATA['jjdw_id']);
                // updateDj();

                //20191023计价单位
                __setRowData(null, {
                    jjdw_id: cache_data['jjdw_id'],
                    jjdw_mc: cache_data['jjdw_mc']
                }, {}, {
                    upDateSssl: false
                });
                $('#jjsl_val').val(ROW_DATA['jjsl']);
                setJjslColor();

                layer.closeAll();
            });

            // 点击确定
            $('#confirm').on('click', function (e) {
                // jjObj = {
                //     kcms: $('.symbol.active').data('type') || '',
                //     kc: $('#kc').val().trim(),
                //     jjdw_id: $('#sel_jjdw').data('jjdw_id'),
                //     jjdw_mc: $('#sel_jjdw').text(),
                //     jjsl: $('#jjsl').val(),
                //     jjsfscks: $('.check-box').hasClass('check-choice')
                // };

                ROW_DATA['kcms'] = $('.symbol.active').data('type') || '';
                ROW_DATA['kc'] = $('#kc').val().trim();
                ROW_DATA['jjdw_id'] = $('#sel_jjdw').data('jjdw_id');
                ROW_DATA['jjdw_mc'] = $('#sel_jjdw').text();
                ROW_DATA['jjsl'] = $('#jjsl').val();

                if (ROW_DATA['kcms'] == '-') {
                    ROW_DATA['kcms'] = '+';
                    ROW_DATA['kc'] = -parseFloat(ROW_DATA['kc'] || 0);
                }
                $('#jjsl_val').val(ROW_DATA['jjsl']);
                setJjslColor();
                $('#jjdw').text(ROW_DATA['jjdw_mc']).data(ROW_DATA['jjdw_id']);

                jjsfssl = $('.check-box').hasClass('check-choice');
                if (jjsfssl) {
                    var num = fun.dwhs({
                        dw: ROW_DATA['dw_mc'] || '',
                        jjdw: ROW_DATA['jjdw_mc'] || '',
                        jjsl: ROW_DATA['jjsl'] || 0,
                        kcms: ROW_DATA['kcms'] || '+',
                        kc: ROW_DATA['kc'] || 0,
                        ps: ROW_DATA['ps'] || 0,
                        is_back: true, //反算
                    });

                    ROW_DATA['zsl'] = num;
                } else {
                    // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
                }

                // __setRowData(null, {
                //     jjsl: ROW_DATA['jjsl'] || 0,
                //     // zsl: ROW_DATA['zsl'] || 0,
                //     // kcms: ROW_DATA['kcms'] || '',
                //     // kc: parseFloat(ROW_DATA['kc'] || 0),
                //     // jjdw_id: ROW_DATA['jjdw_id'] || 0,
                //     // jjdw_mc: ROW_DATA['jjdw_mc'] || ''
                // });

                var dwhs_data = {};

                if (cache_data['kcms'] != ROW_DATA['kcms']) {
                    dwhs_data['kcms'] = ROW_DATA['kcms'] || '+';
                }
                if (cache_data['kc'] != ROW_DATA['kc']) {
                    dwhs_data['kc'] = ROW_DATA['kc'] || 0;
                }
                if (cache_data['jjsl'] != ROW_DATA['jjsl']) {
                    dwhs_data['jjsl'] = ROW_DATA['jjsl'] || 0;
                }
                if (cache_data['jjdw_id'] != ROW_DATA['jjdw_id']) {
                    dwhs_data['jjdw_id'] = ROW_DATA['jjdw_id'] || 0;
                }

                if ($.nui.isTrue(dwhs_data)) {
                    __setRowData(null, dwhs_data);
                }

                if (jjsfssl) {
                    ROW_DATA['jjsl'] = parseFloat($('#jjsl').val() || 0);
                } else {
                    // if (ROW_DATA['jjdw_id'] == ROW_DATA['dw_id']) ROW_DATA['jjsl'] = $('#jjsl').val();
                }


                $('#sl').val(ROW_DATA['zsl']);
                $('#jjsl_val').val(ROW_DATA['jjsl']);
                $('#jjsl').val(ROW_DATA['jjsl']);

                //     setRowDataJjsl({
                //         kcms: jjObj['kcms'] || '',
                //         kc: parseFloat(jjObj['kc'] || 0),
                //         jjdw_id: jjObj['jjdw_id'] || 0,
                //         jjdw_mc: jjObj['jjdw_mc'] || '',
                //     });
                //
                //     var __data = $.nui.isEmpty(store_data) ? getData() : store_data;

                //记录行匹数小于2时，则 计价数量允许反算出数量
                if (ROW_DATA['ps'] < 2) {
                    //有开启 计价数反算出数量
                    if (jjsfssl) {
                        var num = fun.dwhs({
                            dw: ROW_DATA['dw_mc'] || '',
                            jjdw: ROW_DATA['jjdw_mc'] || '',
                            jjsl: ROW_DATA['jjsl'] || 0,
                            kcms: ROW_DATA['kcms'] || '+',
                            kc: ROW_DATA['kc'] || 0,
                            fk: ROW_DATA['fk'] || '',
                            kz: ROW_DATA['kz'] || '',
                            ps: ROW_DATA['ps'] || 0,
                            is_back: true
                        });

                        ROW_DATA['zsl'] = num;
                        ROW_DATA['jjsl'] = $('#jjsl').val() || 0;

                        $('#jjsl_val').val(ROW_DATA['jjsl']);
                        $('#sl').val(ROW_DATA['zsl']);
                        setJjslColor();

                        var t_mx = ROW_DATA['mx'] || [];
                        var t_data = {};

                        if ($.nui.isEmpty(t_mx)) {
                            t_data = { zsl: num, no_calc_jjsl: 1 };/*, is_fs: 1*/
                            if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                                t_data['ps'] = 1;
                                t_data['mx'] = [{ px: 1, ph: 1, sl: num }];
                            }
                        } else {
                            var isPush = true;
                            for (var i = 0; i < t_mx.length; i++) {
                                if ($.nui.isTrue(t_mx[i]['is_delete'])) continue;
                                if ((t_mx[i]['tm_sl'] > 0) && (num > 0)) {
                                    // 如果当前仓库有开启：不负库存
                                    // 当用户修改的数量大于该布匹对应的库存数时，修改无效。
                                    if ($.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_minus'))) {
                                        if (num > t_mx[i]['tm_sl']) num = t_mx[i]['sl'] || 0;
                                    }
                                }
                                t_mx[i]['sl'] = num;
                                isPush = false;
                            }

                            if (isPush && $.nui.isTrue(fun.getHouseValue(ROW_DATA['ck_id'], 'is_detail'))) {
                                t_mx.push({ px: 1, ph: 1, sl: num })
                            }
                            t_data = { zsl: num/*, is_fs: 1*/, no_calc_jjsl: 1 };
                        }

                        __setRowData(null, t_data);

                        $('#ps').val(ROW_DATA['ps']);
                    }
                }
                setJjslColor();

                if ((cache_data['jjdw_id'] != ROW_DATA['jjdw_id'])) {
                    updateDj();
                }

                // 如果当前 记录行 实售空差 的值 = 确认前的空差，同时还需要将空差更新给 实售空差
                alertObj.setRowKcAfter();

                layer.closeAll();
            });
        }
    });
    fun.inputType();
});

// 点击规格
$('body').on('tap', '.gg-wrap', function (e) {
    e.stopPropagation();
    if ($(this).find('#gg').attr('disabled')) return;
    var cp_title = (ROW_DATA['cp_bh'] || '') + (ROW_DATA['cp_mc'] || '');
    var cp_id = $('#header_title').data('cp_id') || 0;
    var gg_name = $('#gg').val().trim();

    fun.showPageFull({
        page_url: page_arr.specifications,
        pageParam: {
            html_name: html_name,
            cp_title: cp_title,
            cp_id: cp_id,
            gg_name: gg_name
        }
    });
});

// 展开收缩
$('body').on('tap', '#toggle', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;
    if ($(this).find('.icon-toggle').hasClass('icon-xia')) {
        setPanelHide();
    } else {
        setPanelShow();
    }
});

// 点击输入框
$('body').on('tap', 'input', function (e) {
    var target = $(e.target);

    if (target.is('#value')) {
        e.stopPropagation();
        return false;
    } else {
        cache_data['target'] = '';
    }
});


//查看已添加的颜色
$('body').on('tap', '.record_added', function (e) {
    e.stopPropagation();
    var Html = [];

    getRowSaveData();

    if (__PAGE_DATA['edit_row'] && typeof __PAGE_DATA['row_index'] !== 'undefined' && __PAGE_DATA['row_index'] !== null) {
        __JL_DATA[__PAGE_DATA['row_index']] = $.extend({}, ROW_DATA);
    }

    __CP_YS_JL = [];
    for (var i = 0; i < __JL_DATA.length; i++) {
        if ($.nui.isEmpty(__JL_DATA[i]['__row_uuid'])) {
            __JL_DATA[i]['__row_uuid'] = $.nui.getRandomNum();
        }
        if ($.nui.isTrue(__JL_DATA[i]['is_delete'])) continue;
        if (__JL_DATA[i]['cp_id'] == ROW_DATA['cp_id']) {
            __CP_YS_JL.push(__JL_DATA[i]);
        }
    }

    for (var i = 0; i < __CP_YS_JL.length; i++) {
        var val = __CP_YS_JL[i];

        var row_index = $.nui.findIndex(__JL_DATA, function (item) {
            return val.__row_uuid === item.__row_uuid;
        });

        Html.push('<li class="selection-list lower-border-line" row_index="' + row_index + '">');
        Html.push('    <div class="selection-box">');
        Html.push('         <span class="selection-color">' + val['cp_ys_bh'] + val['cp_ys_mc'] + '</span>');
        Html.push('    </div>');
        Html.push('    <div class="selection-box">');
        Html.push('         <span class="selection-text">已选：' + val['ps'] + '匹 ' + val['zsl'] + val['dw_mc'] + '</span>');
        Html.push('         <i class="iconfont icon-youfanhui"></i>');
        Html.push('    </div>');
        Html.push('</li>');
    }

    $('.selection').html(Html.join(''));
    $('.selection-mask,.selection').show();
    $('.collapse-wrap').removeClass('open');
    $('#header').css('z-index', '6');
});

// 点击已添加颜色记录行
$('body').on('tap', '.selection-list', function (e) {

    // TODO
    // 先保存当前页面数据到记录里
    // 再切换当前记录行数据，并显示到页面

    var select_data = __JL_DATA[$(this).attr('row_index')];

    var cpysbhmc = (select_data['cp_ys_bh'] || '') + ' ' + (select_data['cp_ys_mc'] || '');
    var title = $.nui.isTrue($.trim(cpysbhmc)) ? '【' + $.trim(cpysbhmc) + '】' : '';

    switch (page_data.djlx) {
        case 'bp_xsdd':
        case 'bp_cgdd':
            if ($.nui.isTrue(select_data['is_has'])) {
                return fun.toast(title + '被调用过，不允许编辑。');
            } else if ($.nui.isTrue(select_data['is_jd'])) {
                return fun.toast(title + '已结单，不允许编辑。');
            }
            break;
    }

    var __result = addRow();
    switch (__result['status']) {
        case 'ok':
            var TMP_ROW_DATA = $.extend({}, ROW_DATA);
            __JL_DATA[__PAGE_DATA['row_index']] = TMP_ROW_DATA;

            __PAGE_DATA['edit_row'] = true;
            __PAGE_DATA['row_index'] = $(this).attr('row_index');
            __PAGE_DATA['list_data'] = __JL_DATA[$(this).attr('row_index')];
            psslTmpDisabled = [];
            $('input').removeAttr('disabled');

            init();
            setColorBtnDisplay();
            initColorAdd();
            $('#header').css('z-index', ' 10000000');
            $('.selection-mask,.selection').hide();

            execClickAddColor = true;

            break;
    }
});

// 点击阴影
$('body').on('tap', '.selection-mask', function (e) {
    $('#header').css('z-index', ' 10000000');
    $('.selection-mask,.selection').hide();
});

// 监听计价数是否发生变化
$('body').on('input', '#jjsl', function (e) {
    $(this).addClass('ipt-change');
});

// 点击数字键盘显示区
$('body').on('tap', '#value', function (e) {
    e.stopPropagation();
    return false;
});

// 点击数字键盘
$('body').on('tap', '.layer-content', function (e) {
    e.stopPropagation();
    return false;
});

//绑定键盘按键
$('body').on('tap', '.num', function (e) {
    e.stopPropagation();
    // if ($.nui.isEmpty(cache_data['target'])) return;
    var val = $('#value');
    var key = $(this).attr('key');

    var vibrate = [];
    vibrate = (api.systemType == 'android') ? [10, 30] : [10];
    if (api.systemType == 'android') {
        api.notification({
            vibrate: vibrate,
        });
    }

    if (key == '.' && cache_data['target'] == 'ps') return;

    if (key == '.' && val.val().trim() === '') {
        val.val('0' + key);
    }

    if (key == '.' && val.val().indexOf('.') > -1) return;
    if (parseFloat((val.val().trim() + $(this).attr('key')) || 0) > 100000000) return fun.toast('输入数字不能超过100000000！');
    var tmpVal = val.val().trim();
    if (tmpVal.split('.')[1] && tmpVal.split('.')[1].length >= 4) return fun.toast('最多只能输入4位小数！');

    if (key != '.' && val.val().trim() === '0') {
        val.val(key);
    } else {
        val.val(val.val() + $(this).attr('key'));
    }

    switch (cache_data['target']) {
        case 'ps':
            $('#ps').val(val.val());
            __setRowData(null, { ps: parseInt($('#ps').val() || 0) }, {});
            break;
        case 'sl':
            $('#sl').val(val.val());

            var value = parseFloat($('#sl').val() || 0);
            var row = ROW_DATA;
            var zps = 0,
                mx = row['mx'] || [];
            if (value <= 0) {
                for (var i = 0; i < mx.length; i++) {
                    if ($.nui.isTrue(mx[i]['is_delete'])) continue;
                    mx[i]['is_delete'] = 1;
                }
            } else {
                for (var i = 0; i < mx.length; i++) {
                    if ($.nui.isTrue(mx[i]['is_delete'])) continue;
                    zps++;
                    if (zps >= 2) break;
                }
                var isPush = true;
                if (zps <= 1) {
                    for (var i = 0; i < mx.length; i++) {
                        if ($.nui.isTrue(mx[i]['is_delete'])) continue;
                        // 如果当前有值的信息是 明细表第一行的第一匹则直接修改值，反之则删除
                        mx[i]['sl'] = value;
                        isPush = false;
                        break;
                    }
                }
                // 判断明细表是否只有1匹，则把 记录表的 数量 赋值给 明细表
                if (isPush && $.nui.isTrue(__PAGE_DATA['ck_info']) && $.nui.isTrue(__PAGE_DATA['ck_info']['is_detail'])) {
                    mx.push({
                        px: 1,
                        ph: 1,
                        sl: row['zsl']
                    });
                }
            }

            var _tmpJlRow = {
                zsl: value
            };
            if (zps === 1) _tmpJlRow['ps'] = 1;

            __setRowData(null, _tmpJlRow, {});

            $('#jjsl_val').val(ROW_DATA['jjsl'] || '');

            // setRowDataJjsl(_tmpJlRow);
            setJjslColor();
            break;
        case 'dj':

            break;
        case 'jjsl':

            break;
    }

    //震动
    // api.notification({
    //     vibrate: [10],
    //     // sound:'default',
    //     // sound: 'widget://res/audio/accept.mp3'
    // });

    setPanelShow();
});

// 点击单价全选
$('body').on('tap', '#dj,#ssj', function (e) {
    // $(this).select();
});

// 监听单价输入
$('body').on('input blur', '#dj', function (e) {
    xsDdXq.editPrice = { hsdj: $(this).val() };
    if (xsDdXq.isOpenQyssjmsBp()) {
        /*
            如果有开启【系统设置 - 开启实售价模式 - 布匹】
            如果 当前实售价 = 修改前单价 的值时，
            将修改后的单价也赋值给实售价。
        */
        if (fun.toNumber(ROW_DATA.ssdj || 0) === fun.toNumber(ROW_DATA.hsdj || 0)) {
            xsDdXq.editPrice = { hsdj: $(this).val(), ssdj: $(this).val() };
        } else {
            xsDdXq.editPrice = { hsdj: $(this).val() };
        }
    } else {
        /*
            如果没开启【系统设置 - 开启实售价模式 - 布匹】
            将修改后的单价也赋值给实售价。
        */
        xsDdXq.editPrice = { hsdj: $(this).val(), ssdj: $(this).val() };
    }
    __setRowData(null, xsDdXq.editPrice, {}, { upDateSssl: false });
});

// 监听实售单价输入
$('body').on('input blur', '#ssj', function (e) {
    __setRowData(null, { ssdj: $(this).val() }, {}, { upDateSssl: false });
});


// 匹数
$('body').on('tap', '#ps', function (e) {
    e.stopPropagation();

    if ($(this).attr('disabled')) return;

    // if (!$.nui.isTrue(__PAGE_DATA['edit_row'])) {
    $('input').removeClass('active-border');
    $(this).addClass('active-border');
    // }

    if (__PAGE_DATA['bj_type'] === 'mx') return;
    // $(this).select();
    cache_data['target'] = 'ps';
    $('#value').val($(this).val());
    // if(__PAGE_DATA['bj_type'] != 'mx') $(this).removeAttr('readonly');
    setPanelShow();
});

// 数量
$('body').on('tap', '#sl', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled') || $(this).attr('abcdisabled')) return;
    // if (!$.nui.isTrue(__PAGE_DATA['edit_row'])) {
    $('input').removeClass('active-border');
    $(this).addClass('active-border');
    // }

    if (__PAGE_DATA['bj_type'] == 'mx') return;
    cache_data['target'] = 'sl';
    $('#value').val($(this).val());
    // if(__PAGE_DATA['bj_type'] != 'mx') $(this).removeAttr('readonly');

    setJjslColor();
    setPanelShow();
});

//确定
$('body').on('tap', '#save-btn', function (e) {
    e.stopPropagation();
    switch (cache_data['target']) {
        case 'ps':
            if (__PAGE_DATA['bj_type'] == 'mx') return;
            $('#ps').val($('#value').val());
            $('#value').val('');

            __setRowData(null, { ps: parseInt($('#ps').val() || 0) });
            setPanelHide();
            break;
        case 'sl':
            if (__PAGE_DATA['bj_type'] == 'mx') return;
            $('#sl').val($('#value').val());
            $('#value').val('');

            __setRowData(null, { zsl: parseFloat($('#sl').val() || 0) });

            $('#jjsl_val').val(ROW_DATA['jjsl']);
            // $('#jjsl').val(ROW_DATA['jjsl']);

            setJjslColor();
            setPanelHide();
            break;
        case 'dj':

            break;
        case 'jjsl':

            break;
    }
    $('input').removeClass('active-border');
});

// 清除按钮绑定多个事件
$('body').delegate('#remove', {
    touchstart: function (e) {
        e.stopPropagation();
        longClick = 0; //设置初始为0
        timeOutEvent = setTimeout(function () { //此处为长按事件
            longClick = 1; //假如长按，则设置为1
            $('#value').val('');
            switch (cache_data['target']) {
                case 'ps':
                    $('#ps').val('');
                    __setRowData(null, { ps: 0 }, {});
                    break;
                case 'sl':
                    $('#sl').val('');
                    __setRowData(null, { zsl: 0 }, {});
                    $('#jjsl_val').val(ROW_DATA['jjsl'] || '');
                    setJjslColor();
                    break;
                case 'dj':

                    break;
                case 'jjsl':

                    break;
            }

            setClearBtnShow();
        }, 500);
    },
    touchmove: function (e) {
        e.stopPropagation();
        clearTimeout(timeOutEvent);
        timeOutEvent = 0;
        e.preventDefault();
    },
    touchend: function (e) {
        e.stopPropagation();
        clearTimeout(timeOutEvent);
        if (timeOutEvent != 0 && longClick == 0) { //此处为点击事件
            var val = $('#value');
            var valText = val.val();
            val.val(valText.substring(0, valText.length - 1));

            switch (cache_data['target']) {
                case 'ps':
                    $('#ps').val(val.val());

                    __setRowData(null, { ps: parseInt($('#ps').val() || 0) }, {});
                    break;
                case 'sl':
                    $('#sl').val(val.val());
                    __setRowData(null, { zsl: parseFloat($('#sl').val() || 0) }, {});
                    $('#jjsl_val').val(ROW_DATA['jjsl'] || '');
                    setJjslColor();
                    break;
                case 'dj':

                    break;
                case 'jjsl':

                    break;
            }
        }
        setClearBtnShow();
        var vibrate = [];
        vibrate = (api.systemType == 'android') ? [10, 30] : [10];

        if (api.systemType == 'android') {
            api.notification({
                vibrate: vibrate,
            });
        }
        return false;
    }
});

// 单位
$('body').on('tap', '#dw', function (e) {
    e.stopPropagation();
    if (!showKeyBoard) return;
    if ($(this).attr('disabled')) return;
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            "return_page": html_name,
            "page_type": 'dw',
            "return_type": 'dw'
        }
    });
});


// 颜色搜索
$('body').on('tap', '#color_search_wrap', function (e) {
    if ($(this).find('#color_search').attr('disabled') || $(this).attr('disabled')) return;

    var cp_id = $('#header_title').data('cp_id');
    var cp_list = fun.getItem('cp_list') || [];

    var tmp_data = fun.getListInfoByKey(cp_list, cp_id) || {};

    var ck_id = (__PAGE_DATA['ck_info'] && __PAGE_DATA['ck_info']['id']) || 0;
    tmp_data['imgs'] = tmp_data['imgs'] || '';
    var cpbj_info = {
        cp_id: tmp_data['id'] || 0,
        cp_bh: tmp_data['number'] || '',
        cp_mc: tmp_data['name'] || '',
        cp_ys_id: 0,
        cp_ys_bh: '',
        cp_ys_mc: '',
        fzsh: '',
        fzys: '',
        kcms: tmp_data['diff'] || '+',
        imgs: tmp_data['imgs'].split(',')[0] || '',
        dw_id: tmp_data['unit_id'] || 0,
        dw_mc: tmp_data['unit_name'] || '',
        fk: tmp_data['width'] || '',
        kz: tmp_data['weight'] || '',
        gg: tmp_data['spec'] || '',
        cf: tmp_data['component'] || ''
    };
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            return_page: html_name,
            cp_id: cp_id,
            page_type: 'cp_ys',
            clearData: false,
            cpbj_info: cpbj_info,
            NOT_SHOW_SK: fun.getHouseValue(ck_id, 'type') !== 'skyb',
            djlx: page_data['djlx'],
            ck_id: ROW_DATA['ck_id'] || 0,
            __JL_DATA: __JL_DATA
        }
    });
});

// 下个色
$('body').on('tap', '#color', function (e) {
    e.stopPropagation();
    if ($(this).attr('disabled')) return;

    var __result = addRow();

    switch (__result['status']) {
        case 'ok':
            // 清除页面的部分状态值
            __PAGE_DATA['edit_row'] = false;
            __PAGE_DATA['row_index'] = undefined;
            __PAGE_DATA['list_data'] = $.extend({}, PAGE_INIT_DATA);

            ROW_DATA = $.extend({}, PAGE_INIT_DATA, {
                cp_ys_id: 0,
                cp_ys_bh: '',
                cp_ys_mc: ''
            });

            // 把当前详情页的记录数据发给选择产品的页面，目的是为了让 选产品的页面 更新：已选匹、已选数量 页面效果
            api.sendEvent({
                name: page_arr.choice_product,
                extra: {
                    'status': 'update_rows',
                    'data': {
                        __JL_DATA: __JL_DATA,
                    }
                }
            });
            getRowSaveData();
            // 跳转 颜色选择页
            jumpToYs();
            break;
        case 'not_zsl_ps':
            getRowSaveData();
            // 跳转 颜色选择页
            jumpToYs();
            break;
    }


    // 跳转 颜色选择页
    function jumpToYs() {
        var cp_list = fun.getItem('cp_list') || [];
        var cp_id = $('#header_title').data('cp_id');

        var tmp_data = fun.getListInfoByKey(cp_list, cp_id) || {};
        var cpbj_info = {
            cp_id: tmp_data['id'] || 0,
            cp_bh: tmp_data['number'] || '',
            cp_mc: tmp_data['name'] || '',
            cp_ys_id: 0,
            cp_ys_bh: '',
            cp_ys_mc: '',
            fzsh: '',
            fzys: '',
            kcms: tmp_data['diff'] || '+',
            imgs: tmp_data['imgs'] ? (tmp_data['imgs'].split(',')[0] || '') : '',
            dw_id: tmp_data['unit_id'] || 0,
            dw_mc: tmp_data['unit_name'] || '',
            fk: tmp_data['width'] || '',
            kz: tmp_data['weight'] || '',
            gg: tmp_data['spec'] || '',
            cf: tmp_data['component'] || ''
        };

        fun.showPageFull({
            page_url: page_arr.select_list,
            pageParam: {
                return_page: html_name,
                cp_id: cp_id,
                page_type: 'cp_ys',
                clearData: true,
                cpbj_info: cpbj_info,
                NOT_SHOW_SK: fun.getHouseValue(ROW_DATA['ck_id'], 'type') !== 'skyb',
                djlx: page_data['djlx'],
                ck_id: ROW_DATA['ck_id'] || 0,
                __JL_DATA: __JL_DATA
            }
        });

        setTimeout(function () {
            resetData();
            // 初始化页面布局
            initPageLayout();
            initEditDom();
            isXGE = true;
            setColorBtnDisplay();
            initColorAdd();
            isClear = true;
        }, 200);
    }
});


// 类型
$('body').on('click', '#lx,#lx_icon', function (e) {
    e.preventDefault();
    var _id = $(this).attr('id');
    var val = '';
    switch (_id) {
        case 'lx':
            val = $(this).text().trim() || '';
            if ($(this).attr('disabled')) return;
            break;
        case 'lx_icon':
            val = $(this).prev().text().trim() || '';
            if ($(this).prev().attr('disabled')) return;
            break;
    }

    getRowSaveData();
    var list = fun.getSaleLxData({ ck_id: ROW_DATA['ck_id'], cp_ys_bh: ROW_DATA['cp_ys_bh'] });

    $(list).each(function (i, arr) {
        if (arr['name'] == val) {
            list[i]['is_choose'] = 1;
        } else {
            list[i]['is_choose'] = 0;
        }
    });
    fun.showBookList({
        list: list,
        choose: function (val) {
            $('#lx').text(val['name']).data('jg_lx', val['id']);

            if (val['id'] === 'sk') {
                $('#dw').text('份').attr('disabled', true);
                $('#jjdw').text('份').attr('disabled', true);

                ROW_DATA['jjdw_mc'] = '份';
                ROW_DATA['dw_mc'] = '份';
            } else {

            }

            getRowSaveData();
            fun.showLoad();

            __PAGE_DATA['__DJ_DATA'] = __PAGE_DATA['__DJ_DATA'] || {};

            __getDj({
                data: {
                    "djlx": Bills['djlx'],
                    "wldw_id": __PAGE_DATA['__DJ_DATA']['wldw_id'] || 0,
                    "cp_id": ROW_DATA['cp_id'] || 0,
                    "cp_ys_id": ROW_DATA['cp_ys_id'] || 0,
                    "jjdw_id": ROW_DATA['jjdw_id'] || 0,
                    "kdsj": __PAGE_DATA['__DJ_DATA']['kdsj'] || fun.formatDate(new Date()),
                    // 标准价 最低价 需要用到类型
                    "jg_lx": fun.getValByKey(fun.getSaleLxData({ showAll: true }) || [], ROW_DATA['jg_lx_mc'], 'simple', 'name') || 'dh'
                },
                callback: function (res) {
                    if (res['status'] == 0) {
                        var __data = {};
                        __data['lx'] = val['name'];
                        __data['jg_lx_mc'] = val['name'];
                        __data['jg_lx'] = val['simple'];
                        __data['simple'] = val['simple'];
                        __data['bzj'] = res['data']['bzj'] || 0;
                        __data['zdj'] = res['data']['zdj'] || 0;
                        __data['dj'] = res['data']['dj'] || 0;
                        __data['scdj'] = res['data']['scdj'] || 0;
                        __data['ssdj'] = res['data']['ssdj'] || 0;

                        __setRowData(null, __data, {}, {
                            upDateSssl: false,
                            upDateSsdj: true
                        });
                        $('#dj').val(ROW_DATA['hsdj'] || 0);
                    }
                    fun.hideLoad();
                }
            });
        }
    });
});

// 完成
$('body').on('tap', '#complete_btn', function (e) {
    e.stopPropagation();
    back_save_data = getRowSaveData();

    if (!JD_FROM_JL && $.nui.isObjEquals(back_ori_data, back_save_data) && page_data['NOT_OPEN_AGAIN']) {
        // 点击已添加颜色的记录后，点击已完成需要更新开单页记录行
        if (execClickAddColor) {
            api.sendEvent({
                name: target_page,
                extra: {
                    'status': 'update_rows',
                    'data': {
                        __JL_DATA: __JL_DATA,
                    }
                }
            });
        }
        return closeAndSendEvent();
    }

    var __result = addRow();

    api.sendEvent({
        name: target_page,
        extra: {
            'status': 'update_phsz',
        }
    });

    switch (__result['status']) {
        case 'ok':
            fun.showLoad('生成单据中...');
            // 跳转 到 开单页            
            jumpToPage();
            break;
        case 'not_zsl_ps':
            // 跳转 到 开单页            
            jumpToPage();
            break;
    }

    // jumpToPage();
    // 跳转 到 开单页
    function jumpToPage() {
        if ($.nui.isTrue(page_data['__route']) && !page_data['NOT_OPEN_AGAIN']) {
            var __opt = { html_name: html_name, page_data: page_data };
            __opt.page_data['ck'] = fun.getListInfoByKey(fun.getItem('ck_list'), ROW_DATA['ck_id']) || {};
            __opt.page_data['wldw'] = page_data['wldw'];
            __opt.page_data['xsjs_tmp'] = {
                __JL_DATA: __JL_DATA
            };

            // 采购订单开单，参数处理
            if (page_data.djlx === 'bp_cgdd') {
                __opt.page_data.data = {
                    list: __JL_DATA
                }
            }
            PageShow.gotoNextPage(__opt);
            return;
        }

        api.sendEvent({
            name: target_page,
            extra: {
                'status': 'update_rows',
                'data': {
                    __JL_DATA: __JL_DATA,
                }
            }
        });

        setTimeout(function () {
            api.closeToWin({ name: target_page });
        }, 200);
    }
});


$('#hqts').on('keyup paste cut blur', function () {
    if ($(this).val() == '' || isNaN($(this).val())) {
        $('#hq').text('');
        $('#cq').text('');
        $('#hq').data('hq', '');
        begin_lCalendar.format_value = fun.formatDate(new Date(), 'YYYY-MM-DD');
        return;
    } else if ($(this).val().length > 4) {
        $(this).val($(this).val().slice(0, 4))
    }
    var _kdsj = fun.formatDate(__DJ_DATA['kdsj'] || new Date(), 'YYYY-MM-DD'),
        date = String(_kdsj),
        day = $(this).val(),
        daysInt = parseInt(day);
    var val = addDate(date, daysInt);
    $('#hq').text(fun.formatDate(val, 'YY-MM-DD') || '').data('hq', val);
    // $('#delivery').data('value', $('#hq').text());
    begin_lCalendar.format_value = (!!val ? fun.formatDate(val, 'YYYY-MM-DD') : "");
})

function addDate(date, day) {
    var d = new Date(date.replace(/-/g, "/"));
    d.setDate(d.getDate() + day);
    var m = d.getMonth() + 1;
    return d.getFullYear() + '-' + m + '-' + d.getDate();
}

//2019-09-19 增加紧急标签
$('body').on('tap', '#jjcd_wrap', function (e) {
    if ($(this).attr('disabled')) return;
    layer.closeAll();
    fun.showPageFull({
        page_url: page_arr.urgent_level,
        pageParam: {
            return_page: html_name,
            page_type: 'jjcd'
        }
    })
});

// 点击获取弹出时间选择器时，调整赋值格式 为 yy-mm-dd 20-05-05
// $('body').on('click', '#delivery', function () {
//     // var value = $(this).data('value');
//     // if ($.nui.isTrue(value)) $('#hq').text(value);
// })

// 实售数
$('body').on('click', '#sss', function (e) {
    e.stopPropagation();
    if (!__PAGE_DATA['__PAGE_EDIT']) return;
    var html = [];
    style = 'width:92%;height:10.5rem;border:none;background:#fff; border-radius: 0.5rem; position:absolute; top: 30%; left: 4%;';
    html.push('<span class="title">实售</span>');
    html.push('<ul class="list-group">');
    html.push('     <li class="item">');
    html.push('     		<div class="text-box"><span>实空差</span></div>');
    html.push('     		<div class="right"><div class="symbol" data-type="+"><span>+</span></div>');
    html.push('     		<div class="symbol" data-type="-"><span>-</span></div>');
    html.push('     		<div class="symbol" data-type="×" data-type2="*"><span>×</span></div>');
    html.push('     		<div class="symbol" data-type="÷" data-type2="/"><span>÷</span></div>');
    // ss 实售      
    html.push('     		<input id="sskc" type="text" class="input-box equal num-input" num_type="2" decimal_digits="4"/></div>');
    html.push('     </li>');
    html.push('     <li class="item">');
    html.push('          <div class="text-box"><span>实售数</span></div>');
    html.push('          <input id="reality_num" type="text" class="input-box num-input reality-num" num_type="2" decimal_digits="4"/>');
    html.push('     </li>');
    html.push('</ul>');
    html.push('<button id="confirm" class="confirm button">确认</button>');
    html.push('<button class="cancel button">取消</button>');
    layer.open({
        type: 1,
        content: html.join(''),
        style: style,
        skin: 'jj-info',
        shadeClose: false,
        success: function (layero, index) {
            var mode = ROW_DATA['kcms'] || '+';
            var alertObj = {
                modeIsMulOrDiv: function (mode) {
                    return mode === '*' || mode === '÷' || mode === '×' || mode === '/';
                },
                modeIsAdd: function (mode) {
                    return mode === '+' || mode === '-';
                },
                init: function () {
                    // if (alertObj.modeIsMulOrDiv(mode)) {
                    //     // 如果 当前记录行模式 = × 或 ÷，则该页面的模式变为不可用状态
                    //     $('.symbol').removeClass('active');
                    // } else if (alertObj.modeIsAdd(mode)) {
                    //     // 如果 当前记录行模式 = +，则该页面的模式 * 和 模式 ➗ 变为不可用状态
                    //     $('.symbol[data-type="' + mode + '"]').addClass('active').siblings().removeClass('active')
                    // }
                    if ('+-*×/÷'.indexOf(ROW_DATA['kcms'] || '+') > -1) {
                        $('.symbol[data-type2="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
                        $('.symbol[data-type="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
                    } else {
                        $('.symbol[data-type2="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
                        $('.symbol[data-type="' + (ROW_DATA['kcms'] || '+') + '"]').addClass('active').siblings().removeClass('active');
                    }

                    if (ROW_DATA['sskc'] < 0) {
                        $('.symbol[data-type="-"]').addClass('active').siblings().removeClass('active');
                    }

                    $('#sskc').val(Math.abs(ROW_DATA['sskc'] || 0));
                    $('#reality_num').val(ROW_DATA['sssl'] || 0);
                },
                assign: function () {
                    $('#sss').val(ROW_DATA['sssl'] || 0);
                    $('#ssje').val(xsDdXq.computedSszje());
                    ROW_DATA['ssje'] = xsDdXq.computedSsje();
                    ROW_DATA['sszje'] = xsDdXq.computedSszje();
                    $('#hk').val(xsDdXq.computedHk());
                }
            };
            alertObj.init();

            // 选择空差模式
            $('.symbol').on('tap', function (e) {
                var modeType = $(this).data('type');
                if (alertObj.modeIsMulOrDiv(mode)) { // × 或 ÷
                    return;
                } else if (alertObj.modeIsAdd(mode) && alertObj.modeIsMulOrDiv(modeType)) { // 当前模式为 + 或 -，并且点击的是 * 或 x 或 / 或 ÷
                    return;
                }
                $(this).addClass('active').siblings().removeClass('active');
            });

            // 点击取消
            $('.cancel').on('click', function (e) {
                layer.closeAll();
            });

            // 点击确定
            $('#confirm').on('click', function (e) {
                var sssl = fun.toNumber($('#reality_num').val().trim()) || 0; // 实售数量
                var sskc = fun.toNumber($('#sskc').val().trim()) || 0; // 实售空差
                ROW_DATA['kcms'] = $('.symbol.active').data('type') || '+';

                // if (ROW_DATA['kcms'] === '-') {
                //     ROW_DATA['kcms'] = '+';
                //     ROW_DATA['sskc'] = -parseFloat(sskc || 0);
                //     sskc = -sskc; // 初始为 +，默认更改为 -，空差则算发生变化
                // } else {
                //     ROW_DATA['sskc'] = parseFloat(sskc || 0);
                // }

                if (ROW_DATA['kcms'] === '-') {
                    ROW_DATA['kcms'] = '+';
                    sskc = -sskc; // 初始为 +，默认更改为 -，空差则算发生变化
                }

                // 如果同时修改到了，实售空差和实售数量，则优先认实售空差换算的值
                if (sskc !== fun.toNumber(ROW_DATA['sskc'])) { // 修改到了实售空差
                    ROW_DATA['sssl'] = fun.toNumber(fun.dwhs({
                        zsl: ROW_DATA['bqsl'] || 0,
                        ps: ROW_DATA['ps'] || 0,
                        fk: ROW_DATA['fk'] || '',
                        kz: ROW_DATA['kz'] || '',
                        dw: ROW_DATA['dw_mc'] || '',
                        jjdw: ROW_DATA['jjdw_mc'] || '',
                        kc: parseFloat(sskc || 0),
                        kcms: ROW_DATA['kcms'] || '+',
                        mx: []
                    }) || 0).fixed(SYS_CONFIG[Bills['config']['dwgshsbl']]);
                } else if (sssl !== fun.toNumber(ROW_DATA['sssl'])) {
                    ROW_DATA['sssl'] = sssl;
                }
                if ('-'.indexOf(sskc) > -1) {
                    ROW_DATA['sskc'] = -parseFloat(sskc || 0);
                } else {
                    ROW_DATA['sskc'] = parseFloat(sskc || 0);
                }
                alertObj.assign();
                layer.closeAll();
            });
        },
        end: function () {
        }
    });
    fun.inputType();
})