var html_name = page_arr.business_cards;
var company_info = fun.getItem('company_info') || {};
var zylm;
var reproduction;  // 底图
var ck_place;
var data_url = '';
$('#header').header({
    back: true,
    title: '分享名片'
    // edit1: true
});
var SYS_CONFIG = {};
var mycanvas, canvas_pictures;
var width, height, prewin, prehei;
var wx , trans;
//判断设备类型
var equipment = navigator.userAgent;
page_init = function () {
    SYS_CONFIG = fun.getItem('sys_config') || {};
    init();
    wx = api.require('wxPlus');
    trans = api.require('trans');
    fun.load_DATA_LIST(['sys_config'], function () {
        SYS_CONFIG = fun.getItem('sys_config') || {};
    });
    console.log(page_data)
    getList();

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'],
            data = temp['data'];
        switch (temp['status']) {
            case 'refresh':
                getList();
                break;
        }
    });
}

//获取公司信息
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getCompanyList,
        data: {},
        success: function (res) {
            if (res['status'] === 0) {
                showData(res.data || []);
            }
        }
    });
}

function init() {
    $('.content').css({
        paddingTop: api.safeArea.top + $('#header').outerHeight() - fun.computedHtmlFontSize(),
        // paddingBottom:  api.safeArea.bottom + 'px'
    })
    $('.adapt').css('height', $('.adapt').outerHeight() - api.safeArea.bottom)
    $('.lower').css('margin-bottom', api.safeArea.bottom + 'px')

}

//显示数据
function showData(data) {
    mycanvas = document.getElementById('mycanvas');
    reproduction = mycanvas.getContext('2d');
    //屏幕可用
    if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1) { // 安卓
        width_screen = screen.availWidth;
        height_screen = screen.availHeight;
        prewin = width / 1080;
        prehei = height / 1920;
        var ratio = getPixelRatio(reproduction);
        mycanvas.width = width_screen * 0.85;
        mycanvas.height = height_screen * 0.75;

    } else if (equipment.indexOf('iPhone') > -1) {  // 苹果
        $('.tutorial').css('margin-top', '5%');
        width_screen = screen.availWidth;
        height_screen = screen.availHeight * 1.2;
        prewin = width / 1080;
        prehei = height / 1920;
        var ratio = getPixelRatio(reproduction);
        mycanvas.width = width_screen * 0.85;
        mycanvas.height = height_screen * 0.75;
    } else {   // 平板不兼容
        width_screen = screen.availWidth;
        height_screen = screen.availHeight * 1.2;
        prewin = width / 1080;
        prehei = height / 1920;
        var ratio = getPixelRatio(reproduction);
        mycanvas.width = width_screen * 0.85;
        mycanvas.height = height_screen * 0.88;
    }
    mycanvas.style.width = mycanvas.width + 'px';
    mycanvas.style.height = mycanvas.height + 'px';
    mycanvas.width = mycanvas.width * ratio;
    mycanvas.height = mycanvas.height * ratio;

    // 底图
    reproduction.scale(ratio, ratio);
    reproduction.fillStyle = "#EDEDED";
    reproduction.fillRect(0, 0, mycanvas.width, mycanvas.height);

    //获取个人名片的数据
    // fun.ajax({
    //     showLoad: true,
    //     hideLoad: true,
    //     url: AJAX_URL.grmpGetInfo,
    //     data:{},
    $.ajax({
        type: 'GET',
        url: AJAX_URL.businessCards + '/' + fun.getItem('account_info')['account_id'] + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        success: function (res) {
            // 仓库地址
            ck_place = (data['ck_province'] || '') + (data['ck_city'] || '') + (data['ck_town'] || '') + (data['ck_address'] || '');

            var bgInformation = new Image();
            bgInformation.src = '../img/cards.png';
            bgInformation.onload = function () {
            reproduction.drawImage(bgInformation, 0,height_screen * 0.005, width_screen * 0.82,height_screen * 0.35);
                //联系人照片
                var product2 = new Image();
                product2.src = res['avatar_url'] || '../img/user.png';
                product2.onload = function () {
                    reproduction.save();
                    reproduction.beginPath();
                    reproduction.arc(width_screen * 0.68, (width_screen * 0.06 + height_screen * 0.07), width_screen * 0.06, 0, 2 * Math.PI);
                    reproduction.clip();
                    reproduction.drawImage(product2, width_screen * 0.62, height_screen * 0.07, width_screen * 0.12, width_screen * 0.12);
                    reproduction.restore();
                }
                //联系人名称
                reproduction.fillStyle = "rgb(0,0,0)";
                reproduction.font = "bold 0.9em sans-serif";
                reproduction.fillText(getStrByWith(res['name'] || '', width_screen * 0.49), width_screen * 0.09, height_screen * 0.09);
                var contact_name = reproduction.measureText(getStrByWith(res['name'] || '', width_screen * 0.49)).width;

                // 职位
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getStaffInfo,
                    data: {
                        id: fun.getItem('user_info')['staff_id']
                    },
                    success: function (res) {
                        if($.nui.isTrue(res['data']['info'])){
                            if(width_screen * 0.5 - contact_name > 0){
                                reproduction.fillStyle = "rgb(0,0,0)";
                                reproduction.font = "0.5em sans-serif";
                                reproduction.fillText(getStrByWith(res['data']['info']['position'] || '', (width_screen * 0.52 - contact_name) * 1.6), contact_name + width_screen * 0.09 + width_screen * 0.01, height_screen * 0.09);
                            }
                        }
                    }
                });

                //公司名称
                reproduction.fillStyle = "rgb(0,0,0)";
                reproduction.font = "0.6em sans-serif";
                if($.nui.isTrue(res['name'])){
                    reproduction.fillText(getStrByWith(data['company'] || '', width_screen * 0.78), width_screen * 0.09, height_screen * 0.12);
                }else{
                    reproduction.fillText(getStrByWith(data['company'] || '', width_screen * 0.78), width_screen * 0.09, height_screen * 0.1);
                }

                //动态调整地址的位置
                if($.nui.isTrue(data['xx_address']) && $.nui.isTrue(ck_place)){
                    if(reproduction.measureText(data['xx_address']).width > width_screen * 0.634 && reproduction.measureText(ck_place).width > width_screen * 0.634 ){
                        //都是两行的
                        var phone_location = 0.2;
                        var location = 0.23;
                    }else{
                        var phone_location = 0.22;
                        var location = 0.25;
                    }
                }else if($.nui.isTrue(data['xx_address']) || $.nui.isTrue(ck_place)){
                    var phone_location = 0.26;
                    var location = 0.28;
                }else{
                    var phone_location = 0.3;
                }

                // 联系方式（手机）
                reproduction.fillStyle = "#9a9a9a";
                if ($.nui.isTrue(res['mobile_phone'])) {
                    reproduction.font = "0.5em IconFont";
                    var icon1 = eval('("' + '&#xe661;'.replace('&#x', '\\u').replace(';', '') + '")')
                    if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1 || equipment.indexOf('iPhone') > -1){
                        reproduction.fillText(icon1, width_screen * 0.09, height_screen * phone_location);
                        reproduction.fillText(res['mobile_phone'] || '', width_screen * 0.13, height_screen * phone_location);
                    }else{
                        reproduction.fillText(icon1, width_screen * 0.09, height_screen * phone_location);
                        reproduction.fillText(res['mobile_phone'] || '', width_screen * 0.11, height_screen * phone_location);
                    }

                }

                // 档口
                reproduction.font = "0.5em IconFont";
                var icon2 = eval('("' + '&#xe6fe;'.replace('&#x', '\\u').replace(';', '') + '")')
                if ($.nui.isTrue(data['xx_address'])) {
                    reproduction.fillText(icon2, width_screen * 0.09, height_screen * location);
                    if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1 || equipment.indexOf('iPhone') > -1){
                        reproduction.fillText('档口: ', width_screen * 0.13, height_screen * location);
                        reproduction.wrapText(getStrByWith(data['xx_address'], width_screen * 2), width_screen * 0.2, height_screen * location, width_screen * 0.54, height_screen * 0.02);
                    }else{
                        reproduction.fillText('档口: ', width_screen * 0.11, height_screen * location);
                        reproduction.wrapText(getStrByWith(data['xx_address'], width_screen * 2), width_screen * 0.16, height_screen * location, width_screen * 0.54, height_screen * 0.02);
                    }
                }

                // 仓库
                reproduction.font = "0.5em IconFont";
                var icon3 = eval('("' + '&#xe725;'.replace('&#x', '\\u').replace(';', '') + '")');
                if ($.nui.isTrue(ck_place)) {
                    reproduction.fillText(icon3, width_screen * 0.09, measure(getStrByWith(data['xx_address'], width_screen * 2),height_screen * location));
                    if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1 || equipment.indexOf('iPhone') > -1){
                        reproduction.fillText('仓库: ', width_screen * 0.13, measure(getStrByWith(data['xx_address'], width_screen * 2), height_screen * location));
                        reproduction.wrapText(getStrByWith(ck_place, width_screen * 2), width_screen * 0.2, measure(getStrByWith(data['xx_address'], width_screen * 2), height_screen * location), width_screen * 0.54, height_screen * 0.02);
                    }else{
                        reproduction.fillText('仓库: ', width_screen * 0.11, measure(getStrByWith(data['xx_address'], width_screen * 2), height_screen * location));
                        reproduction.wrapText(getStrByWith(ck_place, width_screen * 2), width_screen * 0.16, measure(getStrByWith(data['xx_address'], width_screen * 2), height_screen * location), width_screen * 0.54, height_screen * 0.02);
                    }
                }
            }

            var bgCode = new Image();
            bgCode.src = '../img/cards.png';
            bgCode.onload = function () {
                if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1) { // 安卓
                    reproduction.drawImage(bgCode, 0 ,height_screen * 0.37, width_screen * 0.82,height_screen * 0.35);
                }else{
                    reproduction.drawImage(bgCode, 0 ,height_screen * 0.3, width_screen * 0.82,height_screen * 0.35);
                }
                $.ajax({
                    type: 'GET',
                    url: AJAX_URL.businessCards + '/' + fun.getItem('account_info')['account_id'] + '/share' +'?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
                    headers: {
                        "X-Requested-With": "XMLHttpRequest",
                        "Accept": "application/json"
                    },
                    success: function (res) {
                        if(page_data['details'] === 'mall_shop'){ //店铺样式
                            //获取微信小程序码
                                var erwei = new Image();
                                if(page_data['type'] === 'mall'){  //线上店铺
                                    erwei.src = res['business_card']['wechat_mall_code'];
                                }else{ //AI商城
                                    erwei.src = res['business_card']['wechat_aishop_code'];
                                }
                                erwei.onload = function () {
                                    fun.ajax({
                                        showLoad: true,
                                        hideLoad: true,
                                        url: AJAX_URL.getCompanyList,
                                        data: {},
                                        success: function (res) {
                                            if (res['status'] === 0) {
                                                var data = res['data'] || {};
                                                var logo = new Image();
                                                logo.src = fun.getImgPath(data['logo'], false, { url: UPLOAD_IMG_PATH }) || '';
                                                reproduction.fillStyle = "rgb(0,0,0)";
                                                reproduction.font = "0.6em sans-serif";
                                                //提示语
                                                if(page_data['type'] === 'mall'){
                                                    var cluesTips = '长按进入店铺';
                                                }else{
                                                    var cluesTips = '长按进入商城';
                                                }
                                                if (equipment.indexOf('iPhone') > -1) { // 苹果
                                                    logo.onload = function () {
                                                        reproduction.save();
                                                        reproduction.beginPath();
                                                        reproduction.arc(width_screen * 0.451, (width_screen * 0.121 + height_screen * 0.4), width_screen * 0.05, 0, 2 * Math.PI);
                                                        reproduction.clip();
                                                        reproduction.drawImage(logo, width_screen * 0.401, (height_screen * 0.4 + width_screen * 0.071), width_screen * 0.1, width_screen * 0.1);
                                                        reproduction.restore();
                                                    }
                                                    reproduction.drawImage(erwei, width_screen * 0.33, height_screen * 0.4, width_screen * 0.24, width_screen * 0.24);
                                                    reproduction.fillText(cluesTips, width_screen * 0.36, (height_screen * 0.42) + (width_screen * 0.25));
                                                } else if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1) { // 安卓
                                                    // 小程序码与文字间隔为 width_screen * 0.07
                                                    logo.onload = function () {
                                                        reproduction.save();
                                                        reproduction.beginPath();
                                                        reproduction.arc(width_screen * 0.445, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.1)/2), width_screen * 0.05, 0, 2 * Math.PI);
                                                        reproduction.clip();
                                                        reproduction.drawImage(logo, width_screen * 0.395, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.2)/2), width_screen * 0.1, width_screen * 0.1);
                                                        reproduction.restore();
                                                    }
                                                    reproduction.drawImage(erwei, width_screen * 0.32, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.35)/2), width_screen * 0.25, width_screen * 0.25);
                                                    reproduction.fillText(cluesTips, width_screen * 0.345, height_screen * 0.545 + width_screen * 0.14);
                                                } else {  // 平板
                                                    logo.onload = function () {
                                                        reproduction.save();
                                                        reproduction.beginPath();
                                                        reproduction.arc(width_screen * 0.435, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.32)/2), width_screen * 0.03, 0, 2 * Math.PI);
                                                        reproduction.clip();
                                                        reproduction.drawImage(logo, width_screen * 0.405, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.38)/2), width_screen * 0.06, width_screen * 0.06);
                                                        reproduction.restore();
                                                    }
                                                    reproduction.drawImage(erwei, width_screen * 0.36, height_screen * 0.4, width_screen * 0.15, width_screen * 0.15);
                                                    reproduction.fillText(cluesTips, width_screen * 0.38, (height_screen * 0.43) + (width_screen * 0.13));
                                                }
                                            }
                                        }
                                    });
                                }
                        }else if(page_data['details'] === 'friend'){ //店铺+好友样式
                            var friendCode = new Image();
                            if(page_data['type'] === 'mall'){  //线上店铺
                                var codeSrc = res['business_card']['mall_share_link'];
                            }else{
                                var codeSrc = res['business_card']['aishop_share_link'];
                            }
                            if($.nui.isEmpty(codeSrc)){
                                return fun.toast('请上传二维码')
                            }
                            // fun.getUrlBase64(fun.getImgPath(codeSrc, true, { url: UPLOAD_IMG_PATH }),'.png',function(base64){
                            //     base64ToqR(base64,function(url){
                                    var data_url = '';
                                    //创建二维码
                                    var qrcode = new QRCode("qrcode",{
                                        colorDark : "#000000",      //前景色
                                        colorLight : "transparent", //背景色
                                        correctLevel : QRCode.CorrectLevel.H
                                    });
                                    //生成新的二维码
                                    qrcode.makeCode(codeSrc);
                                    $('#qrcode').find('img')[0].onload = function(){
                                        data_url = $('#qrcode').find('img').attr('src');
                                        // friendCode.src = 'http://192.168.2.253/bh_img/1/7544da9939cf490e995d2d6ffd44ec071579072289255367.png';
                                        friendCode.src = data_url;
                                        friendCode.onload = function () {
                                            reproduction.fillStyle = "rgb(0,0,0)";
                                            reproduction.font = "0.5em sans-serif";
                                            fun.ajax({
                                                showLoad: true,
                                                hideLoad: true,
                                                url: AJAX_URL.getCompanyList,
                                                data: {},
                                                success: function (res) {
                                                    if (res['status'] === 0) {
                                                        var data = res['data'] || {};
                                                        var logo = new Image();
                                                        //是否有店铺设置logo
                                                        if($.nui.isTrue(data['logo'])){
                                                            logo.src = fun.getImgPath(data['logo'], false, { url: UPLOAD_IMG_PATH }) || '';
                                                        }else{
                                                            logo.src = '../img/new_logo.png';
                                                        }
                                                        reproduction.fillStyle = "rgb(0,0,0)";
                                                        reproduction.font = "0.4em sans-serif";

                                                        if (equipment.indexOf('iPhone') > -1) { // 苹果
                                                            logo.onload = function () {
                                                                // reproduction.drawImage(logo, width_screen * 0.425, (height_screen * 0.4 + width_screen * 0.096), width_screen * 0.05, width_screen * 0.05);
                                                                drawRoundRect(reproduction,width_screen * 0.025,width_screen * 0.41,(height_screen * 0.4 + width_screen * 0.096),width_screen * 0.05,width_screen * 0.05,logo)
                                                            }
                                                            // reproduction.drawImage(friendCode, width_screen * 0.33, height_screen * 0.4, width_screen * 0.24, width_screen * 0.24);
                                                            // reproduction.fillText('长按识别二维码', width_screen * 0.34, (height_screen * 0.42) + (width_screen * 0.25));
                                                            reproduction.drawImage(friendCode, width_screen * 0.335, height_screen * 0.41, width_screen * 0.2, width_screen * 0.2);
                                                            reproduction.fillText('长按识别二维码', width_screen * 0.36, (height_screen * 0.42) + (width_screen * 0.22));
                                                        } else if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1) { // 安卓
                                                            // 二维码与文字间隔为 width_screen * 0.07
                                                            logo.onload = function () {
                                                                // reproduction.drawImage(logo, width_screen * 0.425, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.2)/2), width_screen * 0.05, width_screen * 0.05);
                                                                drawRoundRect(reproduction,width_screen * 0.025, width_screen * 0.41, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.12)/2),width_screen * 0.05,width_screen * 0.05,logo)
                                                            }
                                                            // reproduction.drawImage(friendCode, width_screen * 0.325, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.4)/2), width_screen * 0.25, width_screen * 0.25);
                                                            // reproduction.fillText('长按识别二维码', width_screen * 0.335, height_screen * 0.545 + width_screen * 0.12);
                                                            reproduction.drawImage(friendCode, width_screen * 0.335, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.27)/2), width_screen * 0.2, width_screen * 0.2);
                                                            reproduction.fillText('长按识别二维码', width_screen * 0.355, height_screen * 0.545 + width_screen * 0.12);
                                                        } else {  // 平板
                                                            logo.onload = function () {
                                                                // drawRoundRect(reproduction, width_screen * 0.015, width_screen * 0.42, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.351)/2), width_screen * 0.03, width_screen * 0.03,logo);
                                                                reproduction.drawImage(logo, width_screen * 0.42, height_screen * 0.35 + ((height_screen * 0.4 - width_screen * 0.351)/2), width_screen * 0.03, width_screen * 0.03);
                                                            }
                                                            reproduction.drawImage(friendCode, width_screen * 0.36, height_screen * 0.4, width_screen * 0.15, width_screen * 0.15);
                                                            reproduction.fillText('长按识别二维码', width_screen * 0.38, (height_screen * 0.43) + (width_screen * 0.13));
                                                        }
                                                    }
                                                }
                                            });
                                        }
                                    }
                                // })
                            // })
                        }
                    },
                    error:function(){
                        fun.toast('请求分享信息失败')
                    }
                });
            }
            //安卓实际宽度：width_screen * 0.85
            //安卓实际高度：height_screen * 0.74
        }
    });
}
//编辑
$('body').on('tap','#edit_btn1',function(){
    fun.showPageFull({
        page_url: page_arr.personal_card, 
        pageParam: {
            return_page: html_name
        }
    });
});

//微信好友
$('#friend').on('tap', function () {
    canvas_pictures = mycanvas.toDataURL('image/png');
    var imgs;
    var wx = api.require('wxPlus');
    if (!checkWxUseable(wx)) return false;
    wx.isInstalled(function (ret, err) {
        if (ret.installed) {
            var wx = api.require('wxPlus');
            var trans = api.require('trans');
            //x上限，y下限
            var x = 100000000;
            var y = 0;
            var rand = parseInt(Math.random() * (x - y + 1) + y);
            var url_pictures = canvas_pictures.split(',')[1];
            // console.log(JSON.stringify(url_pictures))
            trans.saveImage({
                base64Str: url_pictures,
                album: false,
                imgPath: "widget://res",
                imgName: "cp" + rand + ".png"
            }, function (ret, err) {
                if (ret.status) {
                    imgs = "widget://res/cp" + rand + ".png";
                    if (!checkWxUseable(wx)) return false;
                    wx.shareImage({
                        apiKey: '',
                        scene: 'session',
                        contentUrl: imgs,
                    }, function (ret, err) {
                        console.log(JSON.stringify(ret))
                        if (ret.status) {
                        } else {
                            switch (err.code) {
                                case -1:
                                    fun.toast('未知错误！');
                                    break;
                                case 2:
                                    fun.toast('取消分享');
                                    break;
                                case 3:
                                    fun.toast('发送失败！');
                                    break;
                                case 4:
                                    fun.toast('授权失败！');
                                    break;
                            }
                        }
                    });
                } else {
                    fun.toast('保存失败');
                    console.log(err);
                }
            });
        } else {
            return fun.toast('请您安装微信后重试');
        }
    });
})

//朋友圈
$('#circle').on('tap', function () {
    canvas_pictures = mycanvas.toDataURL('image/png');
    var wx = api.require('wxPlus');
    if (!checkWxUseable(wx)) return false;
    wx.isInstalled(function (ret, err) {
        if (ret.installed) {
            var wx = api.require('wxPlus');
            var trans = api.require('trans');
            //x上限，y下限
            var x = 100000000;
            var y = 0;
            var rand = parseInt(Math.random() * (x - y + 1) + y);
            var url_pictures = canvas_pictures.split(',')[1];
            // console.log(JSON.stringify(url_pictures))
            trans.saveImage({
                base64Str: url_pictures,
                album: true,
                imgPath: "widget://res",
                imgName: "cp_pyq" + rand + ".png"
            }, function (ret, err) {
                if (ret.status) {
                    imgs = "widget://res/cp_pyq" + rand + ".png";
                    if (!checkWxUseable(wx)) return false;
                    wx.shareImage({
                        apiKey: '',
                        scene: 'timeline',
                        contentUrl: imgs,
                    }, function (ret, err) {
                        console.log(JSON.stringify(ret))
                        if (ret.status) {
                        } else {
                            switch (err.code) {
                                case -1:
                                    fun.toast('未知错误！');
                                    break;
                                case 2:
                                    fun.toast('取消分享');
                                    break;
                                case 3:
                                    fun.toast('发送失败！');
                                    break;
                                case 4:
                                    fun.toast('授权失败！');
                                    break;
                            }
                        }
                    });
                } else {
                    fun.toast('保存失败');
                    console.log(err);
                }
            });
        } else {
            return fun.toast('请您安装微信后重试');
        }
    });
});

//保存图片
$('#keep').on('tap', function () {
    canvas_pictures = mycanvas.toDataURL('image/png');
    var trans = api.require('trans');
    //x上限，y下限
    var x = 100000000;
    var y = 0;
    var rand = parseInt(Math.random() * (x - y + 1) + y);
    var url_pictures = canvas_pictures.split(',')[1];
    trans.saveImage({
        base64Str: url_pictures,
        album: true,
        imgPath: "widget://res",
        imgName: "cp" + rand + ".png"
    }, function (ret, err) {
        if (ret.status) {
            fun.toast('保存成功');
        } else {
            fun.toast('保存失败');
            console.log(err);
        }
    });
})

//自动换行的方法
CanvasRenderingContext2D.prototype.wrapText = function (text, x, y, maxWidth, lineHeight) {
    if (typeof text != 'string' || typeof x != 'number' || typeof y != 'number') {
        return;
    }

    var context = this;
    var canvas = context.canvas;

    if (typeof maxWidth == 'undefined') {
        maxWidth = (canvas && canvas.width) || 300;
    }
    if (typeof lineHeight == 'undefined') {
        lineHeight = (canvas && parseInt(window.getComputedStyle(canvas).lineHeight)) || parseInt(window.getComputedStyle(document.body).lineHeight);
    }

    // 字符分隔为数组
    var arrText = text.split('');
    var line = '';

    for (var n = 0; n < arrText.length; n++) {
        var testLine = line + arrText[n];
        var metrics = context.measureText(testLine);
        var testWidth = metrics.width;
        if (testWidth > maxWidth && n > 0) {
            context.fillText(line, x, y);
            line = arrText[n];
            y += lineHeight;
        } else {
            line = testLine;
        }
    }
    context.fillText(line, x, y);
};

//圆角矩形函数
function drawRoundRect (ctx,r,x,y,w,h,img) {
	ctx.save()
	// if (w < 2 * r) r = w / 2
    // if (h < 2 * r) r = h / 2
    r = w / 4   //  圆角
    ctx.beginPath()
    ctx.moveTo(x+r, y)
    ctx.arcTo(x+w, y, x+w, y+h, r)
    ctx.arcTo(x+w, y+h, x, y+h, r)
    ctx.arcTo(x, y+h, x, y, r)
    ctx.arcTo(x, y, x+w, y, r)
    ctx.closePath();
    ctx.clip()
    ctx.drawImage(img, x, y, w, h)
	ctx.restore() // 返回上一状态
}

// 获取像素比
var getPixelRatio = function (context) {
    var backingStore = context.backingStorePixelRatio ||
        context.webkitBackingStorePixelRatio ||
        context.mozBackingStorePixelRatio ||
        context.msBackingStorePixelRatio ||
        context.oBackingStorePixelRatio ||
        context.backingStorePixelRatio || 1;
    return (window.devicePixelRatio || 1) / backingStore;
};

// 适应宽度
function measure(txt, init_height) {
    var max_width = width_screen * 0.54;  // 每行最大宽度
    var interception_width = reproduction.measureText(txt).width;
    var floor_line = interception_width / max_width;
    var line_num = Math.ceil(floor_line);                   // 得出占用了几行
    return (height_screen * 0.01) + (line_num * (height_screen * 0.015)) + (init_height || 0);
}

function measure_line(txt) {
    var max_width = width_screen * 0.54;  // 每行最大宽度
    var interception_width = reproduction.measureText(txt).width;
    var floor_line = interception_width / max_width;
    var line_num = Math.ceil(floor_line);                   // 得出占用了几行
    return line_num;
}

// 根据宽度截取对应的字符串
function getStrByWith(desc, width) {
    var span = document.createElement('span');
    span.id = 'cut';
    span.style.visibility = 'hidden';
    span.style.whiteSpace = 'nowrap';
    document.body.appendChild(span);
    var boo = false;
    var temp = '' // 存放截断字符串
    if ($.nui.isTrue(desc)) {
        for (var j = 0; j < desc.length; j++) {
            // desc是目标字符串，
            temp += desc[j];
            span.innerText = temp;
            if (span.offsetWidth > width) {
                boo = true;
                break;
            }
        }
    }
    document.body.removeChild(span);
    if (boo) temp += '...';
    return temp;
}

//解析请求回来的二维码
function base64ToqR(data,callback) {
    var c = document.getElementById("qrcanvas");
    var ctx = c.getContext("2d");
    var img = new Image();
    img.src = data;
    img.onload = function() {
        $("#qrcanvas").attr("width",img.width)
        $("#qrcanvas").attr("height",img.height)
        ctx.drawImage(img, 0, 0, img.width, img.height);
        var imageData = ctx.getImageData(0, 0, img.width, img.height);
        var code = jsQR(imageData.data, imageData.width, imageData.height, {
            inversionAttempts: "dontInvert",
        });
        if(code){
            callback(code.data)
        }else{
            fun.toast("微信个人二维码识别失败")
        }
    };
}