var html_name = page_arr.cg_cgbj_cx;
$('#header').header({
    back: true,
    filter: true,
    add: Auth.check('bp_cgbj', 'edit')/* && SHOW_IS_DOING*/,
    title: '采购报价'
});

//默认开始显示数据
var to_month = fun.getLatelyTime(1,false);
var page_list = [];
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

//时间控件
var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getList(search_data);
        }
    });
var USER_INFO = {};

//接收查询后的参数
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};

    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');


    search_storage = $.extend(true, {
        'ycysh': fun.getItem(html_name + '_ycysh', 0),
        'hldj': fun.getItem(html_name + '_hldj', 0),
        'xsmx': fun.getItem(html_name + '_xsmx', 0),
        'xsgg': fun.getItem(html_name + '_xsgg', 0),
    }, search_storage);

    search_data = $.extend({}, search_data, search_storage);

    getList(search_data);

    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret['value'];
        console.log('-----');
        console.log(temp);
        switch (temp['status']) {
            case 'search':
                var param = ret.value.data;

                search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
                search_data['begin_time'] = param.begin_date;                   //开始时间
                search_data['end_time'] = param.end_date;                       //结束时间
                search_data['wldw_id'] = param.gys['id'] || '';                 //供应商
                search_data['cp_id'] = param.cp['id'] || '';                    //产品
                search_data['cp_lb_id'] = param.cp_lb['id'] || 0;             //产品类别
                // search_data['ck_id'] = param.ck['id'] || '';                    //仓库
                search_data['md_id'] = param.md['id'] || '';                    //门店
                search_data['ycysh'] = param['ycysh'];                          //隐藏已审核
                search_data['hldj'] = param['hldj'];                          //合拢单据
                search_data['xsmx'] = param['xsmx'];                          //显示明细数据
                search_data['xsgg'] = param['xsgg'];                          //显示规格

                //搜索菜单需要缓存的数据
                search_storage['keyword'] = search_data['keyword'];
                search_storage['begin_date'] = search_data['begin_time'];
                search_storage['end_date'] = search_data['end_time'];
                search_storage['ycysh'] = search_data['ycysh'];
                search_storage['hldj'] = search_data['hldj'];
                search_storage['xsmx'] = search_data['xsmx'];
                search_storage['xsgg'] = search_data['xsgg'];
                search_storage['gys'] = param.gys;
                search_storage['cp'] = param.cp;
                search_storage['cp_lb'] = param.cp_lb;
                // search_storage['ck'] = param.ck;
                search_storage['md'] = param.md;

                fun.setItem(html_name + '_ycysh', search_storage['ycysh']);
                fun.setItem(html_name + '_hldj', search_storage['hldj']);
                fun.setItem(html_name + '_xsmx', search_storage['xsmx']);
                fun.setItem(html_name + '_xsgg', search_storage['xsgg']);

                //设置时间控件时间
                date_bar.setDate(search_storage);

                fun.setItem(html_name + 'sideslip', true);

                page_list = [];
                getList(search_data);
                break;
            case 'refresh':
                page_list = [];
                getList(search_data);
                page_data['wldw'] = temp['wldw'];
                break;
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });

}

/** 获取数据
 * @param {*} data
 */
function getList(data) {
    //暂时使用这种方式访问api接口，如果没有这个就会访问不到
    page_list = [];
    var tmpdata = $.extend(true, {}, data);
    tmpdata['type'] = "search_mx";
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpCgbjtj,
        data: tmpdata,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnText:'新增采购报价',auth:'bp_cgbj'});
                }
                fun.clearPage($('#order_list'));
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createOtherKeysFun: function (obj) {
                        return obj['dh'];
                    },
                    createKeysValueFun: function (obj) {
                        return {
                            "wldw_mc": obj['wldw_mc'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "is_sh": obj['is_sh']
                        }
                    }
                });
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        },
    })
}

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip')
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [{
            key: "gys",
            "text": "供应商",
            "value": (search_storage['gys'] && search_storage['gys']['text']) || "",
            "id": (search_storage['gys'] && search_storage['gys']['id']) || 0,
        }, {
            key: "cp",
            "text": "产品",
            "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
            "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
        }, {
            key: "cp_lb",
            "text": "产品类别",
            "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
            "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
        }, {
            key: "md",
            "text": "门店",
            "value": (search_storage['md'] && search_storage['md']['text']) || "",
            "id": (search_storage['md'] && search_storage['md']['id']) || 0,
        }],
        "switch": [
            { "text": "隐藏已审核单据", "max_width": true, "key": "ycysh", "value": search_storage['ycysh'] },
            { "text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_storage['xsmx'] },
            { "text": "合拢单据", "max_width": true, "key": "hldj", "value": search_storage['hldj'] },
            { "text": "显示规格", "max_width": true, "key": "xsgg", "value": search_storage['xsgg'] }
        ],
    }
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});


var order_data = [{
    wldw_mc: '供应商',
    md_mc: '门店',
    zdr_mc: '制单人',
    kdsj: '2018-05-28 15:30',
    dh: 'CDD1812270006',
    list: [{
        cp_bh: '编号',
        cp_mc: '名称',
        cp_sh: '色号',
        cp_ys: '颜色',
        fk: 170,
        kz: 190,
        cf: 1,
        dz: '8天',
        jj: 2,
        dj: 4,
    }, {
        cp_bh: '编号',
        cp_mc: '名称',
        cp_sh: '色号',
        cp_ys: '颜色',
        fk: 170,
        kz: 190,
        cf: 1,
        dz: '8天',
        jj: 2,
        dj: 4,
    }],
},
];


function showList(data) {
    var hldj = fun.getItem(html_name + '_hldj', 0);
    var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !hldj,
        isNoExpand: xsmx,
        render: {
            titlebar: function (res) {
                return [
                    '<div class="title-bar-row bar-cgbj1" style="margin-bottom:0;padding-bottom: 0.2rem;">',
                    '    <div style="vertical-align:middle;"><span class="font-ls color-black weight">' + fun.is_value(res['wldw_mc']) + '</span></div>',
                    '    <div style="vertical-align:middle;" class="align-right color-gray font-ss" ><span>' + fun.formatTime(res['kdsj']) + '</span>&nbsp;&nbsp;<a>' + fun.is_value(res['zdr_mc']) + '</a>&nbsp;<span class="shen1">' + fun.createIsShLabelHtml(res['is_sh']) + '</span></div>',
                    '</div>',
                ].join('');
            },

            subtitle: function (res) {
                var hasFKKZ = (!!(fun.is_value(res['fk']) && fun.is_value(res['kz'])));
                var xsgg = fun.getItem(html_name + '_xsgg', 0);
                return [
                    '<div class="row" data-list=\'' + fun.formatString(JSON.stringify(res)) + '\'>',
                    '     <div><span>' + fun.is_value(res['cp_bh']) + '</span>&nbsp;&nbsp;<span>' + fun.is_value(res['cp_mc']) + '</span>&nbsp;&nbsp;<span>' + fun.is_value(res['cp_ys_bh']) + '</span>&nbsp;&nbsp;<span>' + fun.is_value(res['cp_ys_mc']) + '</span></div>',
                    '</div>',
                    (xsgg && hasFKKZ) ? fun.createFkKzGgHtml(search_data, res) : '',
                ].join('')
            },
            subdata: function (res) {
                var dz = res['dzts'] > 0 ? ((res['dzts']) + "天") : "";
                var lx = res['lx'] != null || res['lx'] != "" ? res['lx'] : "现货";
                return [
                    '<div class="row bg-gray">',
                    '    <div><span class="color-gray">单价</span><span>' + fun.toNumber(res['hsdj']) + '/' + res['jjdw_mc'] + '</span></div>',
                    '    <div><span class="color-gray">' + lx + '</span><span>' + dz + '</span></div>',
                    '</div>',
                ].join('');
            }
        },
    });
}

// 采购报价-开单
$('#add_btn').on('tap', function () {
    if (!fun.checkKz()) return;
    const __route = [
        {
            url: page_arr.customer_search,
            page_data: {
                djlx: 'bp_cgbj',
                return_page: html_name,
                // save_return_page: html_name,
                page_type: 'gys',
                type: 'bp_cgbj',
                from_page: html_name,
                wldw_tmp: {
                    return_page: html_name,
                    page_type: 'gys',
                    djlx: 'bp_cgbj',
                    getBillsPageDefInfo: AJAX_URL.getBillsPageDefInfo
                },
                NOT_OPEN_AGAIN: false
            }
        },
        {
            url: page_arr.choice_product, page_data: {
                djlx: 'bp_cgbj',
                return_page: html_name,
                cp_tmp: {
                    return_page: html_name,
                }
            }
        },
        {
            url: page_arr.cg_cgbj_kd, page_data: {
                // save_return_page: html_name,
            }
        }
    ];

    fun.showPageFull({
        page_url: __route[0]['url'],
        pageParam: $.extend(true, { __route: __route }, __route[0]['page_data'])
    });
});

//采购报价-编辑
fun.tjContentTap(function (data_list) {
    if (!fun.checkKz()) return;

    var id = data_list['dj_id'],
        dh = data_list['dh'],
        wldw_id = data_list['wldw_id'],
        wldw_mc = data_list['wldw_mc'],
        kdsj = data_list['kdsj'],
        zdr = data_list['zdr_mc'],
        wldw = page_data['wldw'];

    fun.showPageFull({
        page_url: page_arr.cg_cgbj_kd,
        pageParam: {
            return_page: html_name,
            id: id,
            dh: dh,
            wldw_id: wldw_id,
            wldw_mc: wldw_mc,
            kdsj: kdsj,
            zdr: zdr,
            wldw: wldw
        }
    })
});

$('body').on('click','.row-list',function(){
    if(fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var data_list = $(this).children('.summary').children('.summary-content').data('list');
    var id = data_list['dj_id'],
        dh = data_list['dh'],
        wldw_id = data_list['wldw_id'],
        wldw_mc = data_list['wldw_mc'],
        kdsj = data_list['kdsj'],
        zdr = data_list['zdr_mc'],
        wldw = page_data['wldw'];

    fun.showPageFull({
        page_url: page_arr.cg_cgbj_kd,
        pageParam: {
            return_page: html_name,
            id: id,
            dh: dh,
            wldw_id: wldw_id,
            wldw_mc: wldw_mc,
            kdsj: kdsj,
            zdr: zdr,
            wldw: wldw
        }
    })
})