// 库存几个开单窗口公用动作。common_fun文件之后


// 子类必须配置null字段的内容
var stockManager = {
    getDataUrl: null,       // 获取页面详情url
    postUrl: null,          // 删除/保存/审核/反审核/作废url
    authCheckName: null,    // Auth.check()方法的name

    djlx: null,             // 生成单号需要字段
    table: null,            // 生成单号需要字段

    headerTitle: null,      // 导航头标题
    data: {                 // 需要保存的数据
        dj: {
            id: '',
            save_time: '',
            jsr_id: 0,
            zdr_id: 0,
            md_id: '',
            kdsj: '',
            dj_lsh: '',
            dh: '',
            ck_id: '',
            is_zf: 0,
            bz: '',
            zps: 0,
            zsl: 0
        },
        jl: []
    },
    fsh: fun.getItem('sys_config')['fsh'],
    origin_data: { dj: { bz: '' }, jl: [] },        // 页面打开时最原始数据，新增时为空，编辑时为后台加载的数据
    zps: 0,
    zsl: 0,
    zje: 0,                  // 总金额,保存四位小数
    showedDw: '',            // 显示在底部导航栏的单位
    //
    hzData: [],               // 根据仓库汇总后的数据

    isLoadCbj: true,
    extraDJData: {},          // 扩展数据

    deleteRows: [],           // 需要逻辑删除的行记录
    isDckms: false,           // 是否多仓库模式 true 开启 | false 关闭
    isDeleteRows: false,      // 是否删除行记录 true 已删除 | false 未删除
    JD_FROM_JL: false,
    is_adjust_save: false,
    del_row_exclude_col: [],
    __PAGE_INIT_DATA: { dj: {}, jl: [] },
    dateCalendar: null,
    begin_lCalendar: new lCalendar(),
    fh_state: false,
    CXPSSL_EDIT: false
};

// 获取产品类别
stockManager.getCategory = function () {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSimpleRecordList,
        data: {
            "type": "cg_ddlb"
        },
        success: function (res) {
            if (res['status'] == 0) {
                var category = res['data'];
                var _category = {};
                $(category).each(function (i, item) {
                    if (Number(item['config']['ddmr']) === 1) { // 开启默认
                        _category = item;
                    } else {
                        return true;
                    }
                })
                console.log('getSimpleRecordList');
                console.log(_category);
                console.log('getSimpleRecordList');
                $('#cg_ddlb').val(_category['name'] || '').data('djlb_id', _category['id'] || 0);
                stockManager.data.dj.lb_mc = _category['name'];
                stockManager.data.dj.djlb_id = _category['id'];
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    });
}

// 更新本地订单类别
stockManager.loadDataList = function () {
    fun.load_DATA_LIST(['cg_ddlb'])
}

// 初始化动作逻辑
// 打开页面必传参数 return_page
// 新增时必传数据 data.list， list为数组
// 编辑时必传参数 dh, id, zdr, kdsj
// 其他init初始化的动作，使用stockManager.initExtend();
page_init = function () {
    console.log('common page_data', page_data);


    if (!AuthVersionCheck.checkHide('hy')) {
        $('.hy-hide').removeClass('hy-hide');
    }
    $('.sum2').css('padding-left', $('.common2').width());
    stockManager.isDckms = $.nui.isTrue(fun.getItem('sys_config')['dckms_bp']);

    $('.collapse-wrap').css('top', api.safeArea.top - 17 + 'px');
    // 根据情况初始化获取成本价url
    if (stockManager.isLoadCbj && typeof Bills !== 'undefined') {
        Bills['AJAX_URL'] = { 'getDj': AJAX_URL.getKccpCbj }; // 获取产品成本url
    }

    stockManager.initStart();

    page_data.keyback = stockManager.isDataChange;

    stockManager.initHeader();
    stockManager.initHeaderAfter();
    stockManager.initDateTimePicker();

    __init();

    stockManager.initDomEvent();
    stockManager.initExtend();
    stockManager.initAddDataListener();
};

function __init() {
    $('button').hide();
    $('#much_btn,#print_btn,#del_btn,#share_btn').hide();
    stockManager.loadDataList();
    if (page_data.id) {
        stockManager.apiGetData();
    } else {
        fun.showLoad();
        // 初始化头部导航栏
        // stockManager.initHeader();

        stockManager.initHeaderAfter();
        stockManager.getCategory(); // 获取有开启默认的产品类别
        // stockManager.initDateTimePicker();

        if (page_data.data && page_data.data.list) {
            stockManager.initLoadCpcbj(page_data.data.list);
        } else {
            if ($.nui.isTrue(page_data['xsjs_tmp']) && $.nui.isTrue(page_data['xsjs_tmp']['__JL_DATA'])) {
                stockManager.data.jl = page_data['xsjs_tmp']['__JL_DATA'];
            }

            stockManager.initShowData();
        }
        stockManager.apiGetDh();
        if (Auth.check(stockManager.authCheckName, 'edit')) stockManager.inputBindEvent();
        fun.hideLoad();
    }
}

// api 方法 ----------------------------------------------------------------------------------
/**
 * 获取数据api
 */
stockManager.apiGetData = function () {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.getDataUrl,
        data: {
            id: page_data.id,
        },
        success: function (res) {

            console.log('apiGetData');
            console.log(res);
            console.log('apiGetData');

            switch (res.status) {
                case 0:
                    stockManager.begin_lCalendar.disabled = false;
                    $('#kdsj').removeAttr('disabled');
                    stockManager.origin_data = JSON.parse(JSON.stringify(res.data));
                    stockManager.data = res.data;
                    console.log('stockManager.data');
                    console.log(stockManager.data);
                    console.log('stockManager.data');
                    page_data['dh'] = stockManager.data.dj.dh;

                    page_data['dj_is_sh'] = stockManager.data.dj['is_sh'];

                    stockManager.fh_state = stockManager.data.dj.is_fh;

                    stockManager.__PAGE_INIT_DATA = res.data;
                    $('#much_btn').hide();

                    // 初始化头部导航栏
                    // stockManager.initHeader();
                    stockManager.initHeaderAfter();
                    // if (false) {
                    //     stockManager.begin_lCalendar.disabled = false;
                    //     $('input,#kdsj,#wldw_mc').removeAttr('disabled');
                    // }

                    stockManager.apiDataLoaded();
                    console.log('stockManager.isInEdit()', stockManager.isInEdit())

                    if (!stockManager.isInEdit()) {
                        stockManager.begin_lCalendar.disabled = true;
                        $('#kdsj, #cg_ddlb').attr('disabled', true);
                        // stockManager.initDateTimePicker();
                    }

                    if (Auth.check(stockManager.authCheckName, 'edit')) stockManager.inputBindEvent();

                    $('#print_btn').show();
                    if ($.nui.isTrue(page_data.id)) {
                        $('#del_btn').show();
                    }
                    stockManager.initShowData();
                    break;
                default:
                    fun.alert({ msg: '获取单号失败！' });
                    break;
            }
        }
    })
};

// api数据加载完成调用方法
stockManager.apiDataLoaded = function () {
};

/**
 * 删除单据api
 */
stockManager.apiDelData = function () {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'delete')) return false;
    if (!Auth.qfmd({ 'key': 'delete', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'delete', 'zdr_id': stockManager.data.dj.zdr_id })) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: { status: 'delete', scr_id: fun.getItem('user_info')['id'], dj_id: page_data.id, __post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('删除成功。');
                    stockManager.closePage(true);
                    break;
                case 'IS_NOT_FIND':
                    fun.toast('单据已被其他操作人员删除，无法删除');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh'
                        }
                    });
                    // fun.alert({msg:res['msg']}, function () {
                    //     stockManager.closePage();
                    // });
                    break;
                default:
                    fun.toast(res['msg']);
                    // fun.alert({msg: res['msg']}, function () {
                    //     if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1) stockManager.closePage();
                    // });
                    break;
            }
            fun.hideLoad();
        }
    })
};

stockManager.apiAuditError = function (res) {
    fun.toast(res['msg']);
};

/**
 * 审核单据api
 */
stockManager.apiAudit = function () {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'check')) return false;
    if (!Auth.qfmd({ 'key': 'check', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'check', 'zdr_id': stockManager.data.dj.zdr_id })) return false;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: { status: 'audit', shr_id: fun.getItem('user_info')['id'], dj_id: page_data.id, __post_sign: Bills['__post_sign'] },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            switch (res['status']) {
                case 0:
                    fun.toast('审核成功。');
                    stockManager.closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'][0];
                    fun.toast('条码' + list['tm'] + '和库存信息不一致');
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_NOT_FIND':
                    // fun.toast(res['msg']);
                    fun.toast('单据已被其他操作人员删除，无法审核');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });
                    // fun.alert({msg: res['msg']}, function () {
                    //     stockManager.closePage();
                    // });
                    break;
                default:
                    // if (['IS_CANCEL', 'IS_EDITED', 'IS_DELETE', 'IS_AUDIT'].indexOf(res['status']) > -1){
                    //     fun.alert({msg: res['msg']}, function () {
                    //         stockManager.closePage();
                    //     });
                    // }else{
                    stockManager.apiAuditError(res);
                    // }
                    break;
            }
        }
    })
};
/**
 * 反审核单据api
 */
stockManager.apiRevocatory = function () {
    // if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    // if (!Auth.check(stockManager.authCheckName, 'check')) return false;
    // if (!Auth.qfmd({ 'key': 'check', 'md_id': stockManager.data.dj.md_id })) return false;
    // if (!Auth.qfczy({ 'key': 'check', 'zdr_id': stockManager.data.dj.zdr_id })) return false;
    // fun.ajax({
    //     showLoad: true,
    //     hideLoad: true,
    //     url: stockManager.postUrl,
    //     data: {
    //         status: 'dbaudit',
    //         fhr_id: fun.getItem('user_info')['id'],
    //         dj_id: [page_data.id],
    //         is_fh: 0, // 生成新单
    //     },
    //     success: function (res) {
    //         switch (res['status']) {
    //             case 0:
    //                 fun.toast('取消审核成功。');
    //                 stockManager.closePage();
    //                 break;
    //             default:
    //                 fun.toast(res['msg']);
    //                 break;
    //         }
    //     }
    // });
};


/**
 * 作废单据api
 */
stockManager.apiObsolete = function (is_scxd) {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'invalid')) return false;
    if (!Auth.qfmd({ 'key': 'invalid', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'invalid', 'zdr_id': stockManager.data.dj.zdr_id })) return false;

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: {
            status: 'cancel',
            zfr_id: fun.getItem('user_info')['id'],
            dj_id: page_data.id,
            zf_yy: '', // 作废原因
            scxd: (is_scxd == 0) ? 1 : 0, // 生成新单
            __post_sign: Bills['__post_sign']
        },
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            // if(is_scxd == 0){
            //   if (res['status'] == 0) {
            //     fun.toast('作废成功！');
            //     stockManager.closePage();
            //   }else{
            //     fun.toast(res['msg']);
            //   }
            // }else{
            switch (res['status']) {
                case 0:
                    fun.toast('作废成功。');
                    if (is_scxd == 0) {
                        page_data.id = res['data']['dj_id'];
                    }
                    stockManager.closePage();
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'];
                    var listInfo = {};
                    if ($.nui.isTrue(list)) listInfo = list[0];
                    var msg = '条码' + (listInfo['tm'] || '') + '和库存信息不一致';
                    fun.toast(msg);
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DCK_LIST':
                    var list = res['dck_list'][0];
                    fun.toast('条码' + list['tm'] + '已被调用或已出库');
                    break;
                case 'IS_JS':
                    fun.toast('单据已被结算过，无法作废。');
                    break;
                case 'WDYJE_LESS_BCDY':
                    fun.toast('超出了订金，无法作废单据。');
                    break;
                case 'IS_NOT_FIND':
                    // fun.toast(res['msg']);
                    fun.toast('单据已被其他操作人员删除，无法作废');
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });
                    // fun.alert({msg:res['msg']}, function () {
                    //     stockManager.closePage();
                    // });
                    break;
                default:
                    stockManager.apiObsoleteError(res);
                    break;
            }
            // }
        }
    })
};

stockManager.apiObsoleteError = function (res) {
    fun.toast(res['msg']);
};

stockManager.checkBeforeApiSaveAjax = function (callback) {
    callback(true);
};

stockManager.apiSaveError = function (res) {
    fun.toast(res['msg'].replace(/销售订单/, '客户订单'));
};

/**
 * 根据id，检查删除的行记录是否需要上传后台
 * @param row 行记录
 * @param key 查询的主键，默认是id
 */
stockManager.rowDeleteHandler = function (row, key) {
    stockManager.isDeleteRows = true;

    if ($.nui.isEmpty(key)) {
        key = 'id';
    }
    if (row) {// && $.nui.isTrue(row[key])
        row.is_delete = 1;
        if (row.mx && row.mx.length) { // 明细记录也设置删除状态
            for (var i = 0; i < row.mx.length; i++) {
                row.mx[i].is_delete = 1;
            }
        }
        stockManager.deleteRows.push(row);
    }
};


/**
 *  删除匹数、数量为0的数据
 *  返回仓库id集合
 */
stockManager.deleteEmptyRows = function () {
    var ckIds = [];
    var realSaveJl = [];
    var tmpArr = stockManager.data.jl;
    var deleteRows = false;
    for (var i = 0; i < tmpArr.length; i++) {
        if ($.nui.isEmpty(tmpArr[i].ps) && $.nui.isEmpty(tmpArr[i].zsl)) {
            var isDel = true;
            // 如果有些字段值不为空，即使匹数数量0也不删除
            for (var j = 0; j < stockManager.del_row_exclude_col.length; j++) {
                var key = stockManager.del_row_exclude_col[j];
                if ($.nui.isTrue(tmpArr[i][key])) {
                    isDel = false;
                    break;
                }
            }


            if (isDel) {
                deleteRows = true;
                stockManager.rowDeleteHandler(tmpArr[i]);
            } else {
                realSaveJl.push(tmpArr[i]);
                if (ckIds.indexOf(tmpArr[i].ck_id) === -1) {
                    ckIds.push(tmpArr[i].ck_id);
                }
            }
        } else {
            realSaveJl.push(tmpArr[i]);
            if (ckIds.indexOf(tmpArr[i].ck_id) === -1) {
                ckIds.push(tmpArr[i].ck_id);
            }
        }
    }
    // 删除数据后重新渲染
    stockManager.data.jl = realSaveJl;
    return { ckIds: ckIds, deleteRows: deleteRows };
};

/**
 * 保存单据api
 */
stockManager.apiSave = function () {
    var dj = {}, jl = [];
    stockManager.data.dj = stockManager.getSaveDj();

    var result = stockManager.deleteEmptyRows();

    stockManager.data = stockManager.getSaveData();

    var jl_list = [];
    if ($.nui.isTrue(page_data['data'])) {
        jl_list = page_data['data']['jl_list'] || [];
    }

    var is_shop = 0, shop_type = '';
    if ($.nui.isTrue(jl_list)) {
        $(jl_list).each(function (i, item) {
            if ($.nui.isTrue(item['is_shop']) || $.nui.isTrue(item['shop_type']) === 'shop') {
                is_shop = 1 || 0;
                shop_type = item['shop_type'] || '';
            }
        })
    }
    stockManager.data.dj['is_shop'] = is_shop
    stockManager.data.dj['shop_type'] = shop_type
    if (!Check.kzrq({ sj: stockManager.data.dj.kdsj })) return false;
    if (!Check.yjrq({ sj: stockManager.data.dj.kdsj })) return false;

    if (stockManager.data.dj.dh === '') return fun.toast('单号不能为空');

    var recordData = stockManager.data.jl.concat(stockManager.deleteRows), px = 0;

    // var tmpJl = [];
    // for (var i = 0; i < recordData.length; i++) {
    //     var val = $.extend(true, {mx: []}, recordData[i]);

    //     if ($.nui.isTrue(val['is_delete']) && $.nui.isEmpty(val['id'])) continue;

    //     var __tmp_data = {};

    //     // if (stockManager.djlx == 'kc_bptbd') {
    //         __tmp_data['mx'] = [];
    //     // }
    //     var tmpData = $.extend({}, val, __tmp_data);

    //     if ($.nui.isEmpty(tmpData['is_delete'])) {
    //         px += 1;
    //         tmpData['px'] = px;
    //     }

    //     // if (stockManager.djlx == 'kc_bptbd') {
    //         for (var j = 0; j < val['mx'].length; j++) {
    //             // 如果记录行删除的情况,则明细表也是得以删除的情况处理
    //             if ($.nui.isTrue(tmpData['is_delete'])) val['mx'][j]['is_delete'] = 1;
    //             // 当数量为0, 并且无id字段信息，则代表为新添加并且手动删除的信息，跳过不处理
    //             if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isTrue(val['mx'][j]['is_delete'])) continue;
    //             if ($.nui.isEmpty(val['mx'][j]['id']) && $.nui.isEmpty(val['mx'][j]['sl'])) continue;
    //             tmpData['mx'].push(val['mx'][j]);
    //         }
    //     // }

    //     tmpJl.push(tmpData);
    // }

    var jl_list = [];
    var jl_data = stockManager.data.jl || [];
    for (var i = 0; i < jl_data.length; i++) {
        if ($.nui.isEmpty(jl_data[i]['is_delete'])) {
            jl_list.push(jl_data[i]);
        }
    }
    // stockManager.data.jl = tmpJl.slice(0);

    // 没开启【系统设置-多仓库模式】时，需约束：仓库不能为空。
    if ($.nui.isTrue(jl_list) && !stockManager.isDckms && $.nui.isEmpty(stockManager.data.dj['ck_id']))
        return fun.toast('仓库不能为空');

    // var result = stockManager.deleteEmptyRows();
    if (result.deleteRows) {
        setTimeout(function () {   // 放回调里执行，异步渲染
            stockManager.initShowData();
        }, 100);
    }

    if (stockManager.djlx == 'bp_cglhjs' || stockManager.djlx == 'bp_cgthjs'
        || stockManager.djlx == 'bp_cgdd' || stockManager.djlx == 'kc_bppyd'
        || stockManager.djlx == 'kc_bpmxpkd') {
        var realJl = [];
        for (var i = 0; i < stockManager.data.jl.length; i++) {
            var tmpData = stockManager.data.jl[i];

            // 如果 记录行 被删除, 则不需要判断 限制
            if ($.nui.isTrue(tmpData['is_delete'])) continue;
            if ($.nui.isEmpty(tmpData['ck_id'])) return fun.toast('请选择：【仓库】。');
            if ($.nui.isEmpty(tmpData['cp_ys_id'])) return fun.toast('请选择：【颜色】。');
            if ($.nui.isEmpty(tmpData['dw_id'])) return fun.toast('请选择：【单位】。');

            if (stockManager.djlx !== 'kc_bppyd' && stockManager.djlx !== 'kc_bpmxpkd') {
                if ($.nui.isEmpty(tmpData['jjdw_id'])) return fun.toast('请选择：【计价单位】。');
                if ($.nui.isEmpty(tmpData['ps']) && $.nui.isEmpty(tmpData['zsl'])) return fun.toast('请输入：【匹数】、【数量】。');
            }

            realJl.push(tmpData);
        }
        if (stockManager.djlx == 'bp_cgdd') {
            // stockManager.data.jl = realJl.slice(0);
        }
    }

    if ($.nui.isEmpty(jl_list)) return fun.toast(tips_arr['空单提示']);

    // 没开启【系统设置-多仓库模式】时，需约束：仓库不能为空。
    if ($.nui.isTrue(stockManager.data.jl) && !stockManager.isDckms && $.nui.isEmpty(stockManager.data.dj['ck_id']))
        return fun.toast('仓库不能为空');

    if (!stockManager.isDckms && !$.nui.isFieldValEqual('ck_id', stockManager.data.jl)['res']) {
        fun.toast('不允许调用多个仓库的布匹。');
        return false;
    }

    stockManager.checkBeforeApiSaveAjax(function (result) {
        console.log('---执行保存')
        if (result) {
            // console.log(JSON.stringify(realSaveJl.concat(stockManager.deleteRows)));
            // console.log(JSON.stringify({
            //     dj: stockManager.data.dj,
            //     jl: realSaveJl.concat(stockManager.deleteRows)
            // }));

            var djIsSame = $.nui.isObjEquals(stockManager.data.dj, stockManager.origin_data.dj);
            var jlIsSame = stockManager.data.jl.length == stockManager.origin_data.jl.length;

            var jlChange = !$.nui.isObjEquals(stockManager.data.jl, stockManager.origin_data.jl);

            // 复核修改记录但没结单
            var fh_xg_no_jd = (stockManager.fh_state && jlChange && !stockManager.JD_FROM_JL);

            if (stockManager.JD_FROM_JL || stockManager.CXPSSL_EDIT
                || (stockManager.data.dj['is_has'] && djIsSame && jlIsSame)) {
                __saveOther(function () {
                    __adjust();
                });
                return;
            } else if (fh_xg_no_jd) {
                __saveOther();
                return;
            } else {
                __save();
            }

            function __saveOther(callback) {
                var __other_jl = [];
                for (var i = 0; i < stockManager.data.jl.length; i++) {
                    var __jl = stockManager.data.jl[i];
                    var __other_data = {
                        id: __jl['id'] || 0,
                        dj_id: __jl['dj_id'] || 0,
                        hqts: Number(__jl['hqts']) || '',
                        hq: __jl['hq'] || null,
                        jjcd: __jl['jjcd'] || 0,
                        jjcd_mc: __jl['jjcd_mc'] || '',
                        jjcd_colour: __jl['jjcd_colour'] || '',
                        zt: __jl['zt'] || '',
                        zt_id: __jl['zt_id'] || 0,
                        bz: __jl['bz'] || '',
                    };
                    __other_jl.push(__other_data);
                }

                var _set_data = {
                    status: 'setOther',
                    jl: __other_jl,
                    __post_sign: Bills['__post_sign']
                };

                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    loadTitle: '保存中...',
                    url: stockManager.postUrl,
                    data: _set_data,
                    success: function (res) {
                        if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
                        switch (res['status']) {
                            case 0:
                                if (typeof callback === 'function') callback();
                                else {
                                    fun.toast('保存成功。');
                                    stockManager.JD_FROM_JL = false;

                                    if (stockManager.djlx == 'bp_cgdd') {
                                        stockManager.deleteRows = [];
                                        api.sendEvent({
                                            name: html_name,
                                            extra: {
                                                'status': 'refresh_dj'
                                            }
                                        });
                                        api.sendEvent({
                                            name: page_data['return_page'],
                                            extra: {
                                                'status': 'refresh',
                                                'closeLayer': true
                                            }
                                        });
                                    }
                                }
                                break;
                            default:
                                fun.toast(res['msg']);
                                break;
                        }
                    }
                });
            }

            function __save() {
                var __saveData = {
                    status: 'save',
                    dj: stockManager.data.dj,
                    jl: stockManager.data.jl, // .concat(cgddDelRows)
                    __post_sign: Bills['__post_sign']
                };

                if (Bills['djlx'] == 'kc_bpmxpkd') {
                    console.log(22222)
                    __saveData['dj']['kdsj'] = fun.formatDate(__saveData['dj']['kdsj']);
                    delete __saveData['dj']['is_sh'];
                    var tmpSaveJl = __saveData['jl'].slice(0);

                    for (var i = 0; i < tmpSaveJl.length; i++) {
                        tmpSaveJl[i]['mx'] = [];
                        console.log(i, tmpSaveJl[i]['rk_sj'].split('').reverse()[0])

                        delete tmpSaveJl[i]['bqsl'];
                        delete tmpSaveJl[i]['dd_dh'];
                        delete tmpSaveJl[i]['dd_dj_id'];
                        delete tmpSaveJl[i]['dd_jl_id'];
                        delete tmpSaveJl[i]['dd_kdsj'];
                        delete tmpSaveJl[i]['dj'];
                        delete tmpSaveJl[i]['zje'];
                        delete tmpSaveJl[i]['je'];
                        delete tmpSaveJl[i]['shuie'];
                        delete tmpSaveJl[i]['zydj'];
                        delete tmpSaveJl[i]['jjdw_id'];
                        delete tmpSaveJl[i]['jjdw_mc'];
                        delete tmpSaveJl[i]['jjsl'];
                        delete tmpSaveJl[i]['sssl'];
                        delete tmpSaveJl[i]['hsdj'];
                        delete tmpSaveJl[i]['hsje'];
                        delete tmpSaveJl[i]['hszje'];
                        delete tmpSaveJl[i]['sl'];
                        delete tmpSaveJl[i]['__uuid'];
                    }
                }

                console.log($.extend({}, __saveData));

                console.log('-----');
                console.log(__saveData);
                console.log('-----');

                // if(stockManager.djlx=='bp_cglhjs') return;
                // return;

                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: stockManager.postUrl,
                    data: __saveData,
                    success: function (res) {
                        if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
                        switch (res['status']) {
                            case 0:
                                // if (stockManager.JD_FROM_JL) {
                                //     stockManager.__adjust();
                                //     return;
                                // } else {
                                fun.toast('保存成功。');
                                stockManager.JD_FROM_JL = false;

                                page_data.id = res['data']['dj_id'];

                                if (stockManager.djlx == 'bp_cgdd') {
                                    stockManager.deleteRows = [];
                                    api.sendEvent({
                                        name: html_name,
                                        extra: {
                                            'status': 'refresh_dj'
                                        }
                                    });
                                    api.sendEvent({
                                        name: page_data['return_page'],
                                        extra: {
                                            'status': 'refresh',
                                            'closeLayer': true
                                        }
                                    });
                                } else {
                                    // api.sendEvent({
                                    //     name: page_data['return_page'],
                                    //     extra: {
                                    //         'status': 'refresh',
                                    //         'closeLayer': true
                                    //     }
                                    // });
                                    stockManager.closePage();
                                }
                                // }
                                break;
                            case 'DCK_LIST':
                                var list = res['dck_list'][0];
                                fun.toast('条码' + list['tm'] + '已被调用或已出库');
                                break;
                            default:
                                stockManager.apiSaveError(res);
                                break;
                        }
                    }
                });
            }


            function __adjust() {
                console.log('---执行单据调整保存')

                var tmp_djtz_jl = [];
                var djtz_jl = stockManager.data.jl.slice(0) || [];

                var tmpSaveObj = {};

                for (var i = 0; i < djtz_jl.length; i++) {
                    if (djtz_jl[i]['djtz_jl_jd']) {
                        delete stockManager.data.jl[i]['djtz_jl_jd'];
                        tmp_djtz_jl.push(djtz_jl[i]);
                        tmpSaveObj[djtz_jl[i]['id']] = djtz_jl[i];
                    } else if (djtz_jl[i]['dj_jd_from_jd']) {
                        delete stockManager.data.jl[i]['dj_jd_from_jd'];
                        tmp_djtz_jl.push(djtz_jl[i]);
                        tmpSaveObj[djtz_jl[i]['id']] = djtz_jl[i];
                    }
                }


                var save_data = $.extend(true, {}, {
                    status: 'adjust',
                    data: tmp_djtz_jl,
                    dj_id: stockManager.data.dj['id'],
                    __post_sign: Bills['__post_sign']
                });

                save_data['isSave'] = stockManager.is_adjust_save;

                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    loadTitle: '保存中...',
                    url: stockManager.postUrl,
                    data: save_data,
                    success: function (res) {
                        if(res['status'] !== 0) Bills['__post_sign'] = $.nui.getRandomNum();
                        switch (res['status']) {
                            case 0:
                                if (stockManager.JD_FROM_JL) {
                                    if (stockManager.fh_state) {
                                        fun.toast('保存成功！');

                                        if (stockManager.djlx == 'bp_cgdd') {
                                            stockManager.deleteRows = [];
                                            api.sendEvent({
                                                name: html_name,
                                                extra: {
                                                    'status': 'refresh_dj',
                                                }
                                            });
                                            api.sendEvent({
                                                name: page_data['return_page'],
                                                extra: {
                                                    'status': 'refresh',
                                                    'closeLayer': true
                                                }
                                            });
                                        } else {
                                            // api.sendEvent({
                                            //     name: page_data['return_page'],
                                            //     extra: {
                                            //         'status': 'refresh',
                                            //         'closeLayer': true
                                            //     }
                                            // });
                                            stockManager.closePage();
                                        }

                                    } else {
                                        __save();
                                    }

                                } else {
                                    stockManager.JD_FROM_JL = false;
                                    fun.toast('保存成功！');
                                    if (stockManager.djlx == 'bp_cgdd') {
                                        stockManager.deleteRows = [];
                                        api.sendEvent({
                                            name: html_name,
                                            extra: {
                                                'status': 'refresh_dj',
                                            }
                                        });
                                        api.sendEvent({
                                            name: page_data['return_page'],
                                            extra: {
                                                'status': 'refresh',
                                                'closeLayer': true
                                            }
                                        });
                                    } else {
                                        // api.sendEvent({
                                        //     name: page_data['return_page'],
                                        //     extra: {
                                        //         'status': 'refresh',
                                        //         'closeLayer': true
                                        //     }
                                        // });
                                        stockManager.closePage();
                                    }
                                }
                                break;
                            case 'IS_NOT_FINISH':
                                fun.jdts({
                                    content: '部分产品还没来完货，你确定要结单吗？',
                                    yes: function () {
                                        fun.ajax({
                                            showLoad: true,
                                            hideLoad: true,
                                            loadTitle: '结单中...',
                                            url: stockManager.postUrl,
                                            data: $.extend(true, { 'notCheckFinish': 1 }, save_data),
                                            success: function (res) {
                                                Bills['__post_sign'] = $.nui.getRandomNum();
                                                switch (res['status']) {
                                                    case 0:
                                                        fun.toast('结单成功。');
                                                        // is_adjust_save = false;
                                                        api.sendEvent({
                                                            name: html_name,
                                                            extra: {
                                                                'status': 'refresh_dj',
                                                                'data': {}
                                                            }
                                                        });
                                                        api.sendEvent({
                                                            name: page_data['return_page'],
                                                            extra: {
                                                                'status': 'refresh',
                                                                'closeLayer': true
                                                            }
                                                        });
                                                        break;
                                                    default:
                                                        fun.toast(res['msg']);
                                                        break;
                                                }
                                            }
                                        });
                                    },
                                    no: function () {
                                        for (var key in tmpSaveObj) {
                                            for (var j = 0; j < stockManager.data.jl.length; j++) {
                                                if (key == stockManager.data.jl[j]['id']) {
                                                    stockManager.data.jl[j]['is_jd'] = !stockManager.data.jl[j]['is_jd'] ? 1 : 0;
                                                    stockManager.data.jl[j]['jdr_id'] = !stockManager.data.jl[j]['is_jd'] ? USER_INFO['id'] : 0;
                                                    stockManager.data.jl[j]['jdr_mc'] = !stockManager.data.jl[j]['is_jd'] ? USER_INFO['name'] : '';
                                                    stockManager.data.jl[j]['jd_sj'] = !stockManager.data.jl[j]['is_jd'] ? fun.formatDate(new Date()) : '';
                                                }
                                            }
                                        }

                                        stockManager.initShowData();
                                    }
                                });
                                break;
                            case 'IS_ZS_FKC':
                                var list = res['data']['list'][0];
                                var ps_display = list['bz_ps'] > 0;
                                var sl_display = list['bz_sl'] > 0;
                                var msg = [
                                    list['cp_bh'] + list['cp_mc'] + '\r\n',
                                    list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                                    '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                                    '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                                ].join('');
                                fun.toast(msg);
                                break;
                            case 'IS_TM_FKC':
                                var list = res['data']['list'][0];
                                fun.toast('条码' + list['tm'] + '和库存信息不一致');
                                break;
                            case 'IS_MX_FKC':
                                var list = res['data']['list'][0];
                                var msg = [
                                    list['cp_bh'] + list['cp_mc'] + '\r\n',
                                    list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                                    '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                                ].join('');
                                fun.toast(msg);
                                break;
                            case 'DDJ_NOT_EMPTY':
                                fun.jdts({
                                    content: '<div style="text-align:left;margin-top: -0.5rem;">未抵用订金：' + res['data']['wdyje'] + ' <br>您确定要结单吗？</div>',
                                    btn: ['确定结单', '取消'],
                                    yes: function () {
                                        stockManager.is_adjust_save = true;
                                        __adjust();
                                    }
                                });
                                break;
                            default:
                                fun.toast(res['msg']);
                                break;
                        }
                    }
                });
            }
        }
    });
};


/**
 * 获取单号后回调
 */
stockManager.afterApiGetDh = function (data) {
    // return data;
};

/**
 * 获取单号
 */
stockManager.apiGetDh = function () {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBillsPageDefInfo,
        data: {
            'djlx': stockManager.djlx,
            'table': stockManager.table
        },
        success: function (res) {
            console.log('-----');
            console.log(res);
            console.log('-----');

            switch (res.status) {
                case 0:
                    $('.subtitle').text(res.data.dh);

                    stockManager.data.dj.dh = res.data.dh;

                    stockManager.initHeaderAfter();

                    stockManager.afterApiGetDh(res.data);

                    break;
                default:
                    fun.alert({ msg: '网络异常！' });
                    break;
            }
        }
    })
};

// 普通方法 -------------------------------------------------------------------------------
// 初始化开始时执行方法
stockManager.initStart = function () {
};
stockManager.initLoadCpcbj = function (initList) {
    stockManager.loadCpcbj(initList, function (list) {
        stockManager.data.jl = list;
        stockManager.initShowData();
    });
};

/**
 * 初始化dom事件
 */
stockManager.initDomEvent = function () {
    // 先解除bill.js的同名绑定事件
    $('body').off('tap', '#del_btn');
    //删除
    $('body').on('tap', '#del_btn', function (e) {
        e.stopPropagation();
        $('.collapse-more.collapse-wrap').removeClass('open');
        // 数据更改时，提示
        stockManager.data.dj = stockManager.getSaveDj();
        if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            return fun.toast('单据已修改，未保存，不能删除！');
        }

        fun.dialog({
            content: '您确定要删除当前单据吗？',
            btn: ['删除', '取消'],
            yes: function () {
                stockManager.apiDelData();
            }
        });
    });
    //审核
    $('body').on('tap', '.audit', function (e) {
        e.stopPropagation();
        $('.collapse-more.collapse-wrap').removeClass('open');
        // 数据更改时，提示
        stockManager.data.dj = stockManager.getSaveDj();
        if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            return fun.toast('单据已修改，未保存，不能审核！');
        }

        fun.dialog({
            content: '您确定要审核当前单据吗？',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiAudit();
            }
        });
    });
    //取消审核
    $('body').on('tap', '.revocatory', function (e) {
        e.stopPropagation();
        $('.collapse-more.collapse-wrap').removeClass('open');
        fun.dialog({
            content: '您确定要取消当前单据的审核状态吗？',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiRevocatory();
            }
        });
    });
    //作废
    $('body').on('tap', '.obsolete', function (e) {
        e.stopPropagation();
        $('.collapse-more.collapse-wrap').removeClass('open');
        fun.dialog({
            content: '您确定要作废当前单据吗？',
            btn: ['重新做单', '直接作废', '取消'],
            yes: function (datas) {
                stockManager.apiObsolete(datas.index)
            },
            no: function (datas) {
                stockManager.apiObsolete(datas.index)
            }
        });
    });

    //保存
    $('body').delay('tap', '.saves', function () {
        $('.collapse-more.collapse-wrap').removeClass('open');
        stockManager.apiSave();
    });

    // 添加事件
    $('body').on('tap', '.choice,.add-product', function () {
        $('.collapse-more.collapse-wrap').removeClass('open');
        stockManager.openAddPage();
    });

    // 删除记录行
    $('body').on('tap', '.delete-btn', function (e) {
        e.preventDefault();
        $('.collapse-more.collapse-wrap').removeClass('open');
        if (stockManager.isInEdit()) {
            var _this = this;
            fun.dialog({
                content: '你确定要删除当前记录吗？',
                btn: ['删除', '取消'],
                yes: function () {
                    stockManager.deleteRow(_this);
                    stockManager.fsm();
                }
            });
        }
    });

    // 详情编辑
    $('body').on('tap', '.store-content', function (e) {
        e.preventDefault();
        stockManager.editRow(this);
    });

    // 添加备注输入事件
    $('body').on('change', '#bz', function (e) {
        e.preventDefault();
        stockManager.data.dj.bz = $(this).val();
    });
};

/**
 * 删除行记录逻辑
 * @param _this 点击行记录的this对象
 */
stockManager.deleteRow = function (_this) {
};

/**
 * 编辑行记录
 * @param _this 点击行记录的this对象
 */
stockManager.editRow = function (_this) {
};

/**
 * 扩展的初始化方法
 */
stockManager.initExtend = function () {
};

// 更新修改产品类别
stockManager.upDateCategory = function (arr) {
    if ($.nui.isEmpty(arr)) return;
    $(arr).each(function (idx, item) {
        if (fun.toNumber(item.id) === fun.toNumber($('#cg_ddlb').data('djlb_id'))) {
            $('#cg_ddlb').val(item.name).data('djlb_id', item.id);
            stockManager.data.dj.lb_mc = item.name;
            stockManager.data.dj.djlb_id = item.id;
            return false;
        } else {
            return true;
        }
    })
}

/**
 * 扩展的事件监听方法
 */
stockManager.eventListenerExtend = function (ret, err) {
};

/**
 * 通过id查找对应记录的下标
 * @param callback {function}
 */
stockManager.findIndex = function (callback) {
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        if (callback(stockManager.data.jl[i])) {
            return i;
        }
    }
    return -1;
};

/**
 * 获取提交后台的单据数据
 */
stockManager.getSaveDj = function () {
    var kdsj = $('#kdsj').text().trim();
    var oriDj = JSON.parse(JSON.stringify(stockManager.origin_data.dj));
    // delete oriDj['is_jd'];
    // delete oriDj['is_fh'];
    return $.extend(oriDj, {
        id: Number(page_data['id'] || 0),
        save_time: stockManager.data.dj.save_time || '', // 保存时间
        jsr_id: stockManager.data.dj.jsr_id || 0,       // 经手人id
        zdr_id: fun.getItem('user_info')['id'],      // 制单人id stockManager.data.dj.zdr_id ||
        md_id: fun.getItem('user_info')['store_id'],  // 门店id stockManager.data.dj.md_id ||
        kdsj: fun.formatDate(kdsj, 'YYYY-MM-DD HH:mm:ss'),             // 开单时间
        dj_lsh: stockManager.data.dj.dj_lsh || '',        // 单据流水号
        dh: $('.subtitle').text().trim() || '',     // 单号
        ck_id: Number(stockManager.data.dj.ck_id || 0),
        bz: $('#bz').val().trim() || '',
        zps: parseInt($('#zps').text() || 0),
        zsl: parseFloat($('#zsl').text() || 0),
        is_sh: stockManager.data.dj.is_sh || 0,
        djlb_id: $('#cg_ddlb').data('djlb_id') || 0, // 单据类别id
        lb_mc: $('#cg_ddlb').val().trim() || ''
    }, stockManager.extraDJData);
};

// 获取保存数据
stockManager.getSaveData = function () {
    var dj = {}, jl = [];

    var kdsj = $('#kdsj').text().trim();
    var oriDj = JSON.parse(JSON.stringify(stockManager.origin_data.dj));

    dj = {
        id: Number(page_data['id'] || 0),
        save_time: stockManager.data.dj.save_time || '', // 保存时间
        jsr_id: stockManager.data.dj.jsr_id || 0,       // 经手人id
        zdr_id: fun.getItem('user_info')['id'],      // 制单人id stockManager.data.dj.zdr_id ||
        md_id: fun.getItem('user_info')['store_id'],  // 门店id stockManager.data.dj.md_id ||
        kdsj: fun.formatDate(kdsj, 'YYYY-MM-DD HH:mm:ss'),             // 开单时间
        dj_lsh: stockManager.data.dj.dj_lsh || '',        // 单据流水号
        dh: $('.subtitle').text().trim() || '',     // 单号
        ck_id: Number(stockManager.data.dj.ck_id || 0),
        bz: $('#bz').val().trim() || '',
        zps: parseInt($('#zps').text() || 0),
        zsl: parseFloat($('#zsl').text() || 0),
        djlb_id: $('#cg_ddlb').data('djlb_id')
    };

    dj = $.extend({}, dj, stockManager.extraDJData);
    var recordData = stockManager.data.jl.concat(stockManager.deleteRows), px = 0;
    for (var i = 0; i < recordData.length; i++) {
        var val = $.extend({ qtyq: [] }, recordData[i]);
        if ($.nui.isTrue(val['is_delete']) && $.nui.isEmpty(val['id'])) continue;

        var __tmp_data = {};

        __tmp_data['mx'] = [];
        var tmpData = $.extend({}, val, __tmp_data);

        if ($.nui.isEmpty(tmpData['is_delete'])) {
            px += 1;
            tmpData['px'] = px;
        }

        jl.push(tmpData);
    }
    var data = { dj: dj, jl: jl };
    return data;
};

// 添加数据的事件触发后，调用该方法
stockManager.addData = function () {
};

/**
 * 添加数据时监听方法
 */
stockManager.initAddDataListener = function () {
    api.addEventListener({ name: html_name }, function (ret, err) {
        if (ret.value.data && !$.nui.isEmpty(ret.value.data.list)) {
            stockManager.eventListenerAdd(ret, err);
        } else {
            stockManager.eventListenerExtend(ret, err);
        }
    });
};

// 默认的添加事件处理
stockManager.eventListenerAdd = function (ret, err) {
    console.log('eventListenerAdd', ret);
    // 只更新新添加数据的成本
    stockManager.loadCpcbj(ret.value.data.list, function (list) {
        stockManager.data.jl = stockManager.data.jl.concat(list);
        // 重新初始化显示数据
        stockManager.initShowData();
        stockManager.fsm();
    });
};

// 关闭页面，发送刷新事件
stockManager.closePage = function (flag) {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh'
        }
    });
    if (!flag) {
        api.sendEvent({
            name: html_name,
            extra: {
                'status': 'refresh_dj'
            }
        });
    } else {
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
    }

};

/**
 * 数据显示时转换处理，根据相同仓库合并
 * @returns {Array}
 */
stockManager.convertData = function () {
    var list = [], hzData = {};

    for (var i = 0; i < stockManager.data.jl.length; i++) {
        var item = stockManager.data.jl[i];
        if ($.nui.isTrue(item['is_delete'])) continue;
        if (!hzData[item.ck_id]) {
            hzData[item.ck_id] = {
                ck_id: item.ck_id,
                ck_mc: item.ck_mc,
                list: []
            }
        }
        hzData[item.ck_id].list.push(item);
    }

    var ckIds = [];
    for (var ck_id in hzData) {
        if (hzData.hasOwnProperty(ck_id)) {
            list.push(hzData[ck_id]);
            ckIds.push(ck_id);
        }
    }

    // 没有开启多仓库
    if (!stockManager.isDckms) {
        stockManager.data.dj.ck_id = ckIds[0];
    } else {
        stockManager.data.dj.ck_id = 0;
    }

    console.log(list)

    stockManager.hzData = list;
    return list;
};

/**
 * 检查数据是否已经变化
 * @param origin_data  原始数据
 * @param data 最新数据
 * @returns {boolean} true 已经修改 | false 没有修改
 */
stockManager.checkDataChange = function (origin_data, data) {
    return !$.nui.isObjEquals(origin_data, data);
};

/**
 * 判断是否单据信息修改，只检查备注字段，其他需要自己重写
 * @returns {boolean}  true 已修改 | false 未修改
 */
stockManager.isDjDataChange = function () {
    return stockManager.origin_data.dj.bz !== stockManager.data.dj.bz || stockManager.origin_data.dj.kdsj !== stockManager.data.dj.kdsj;
};


stockManager.isDataNotChange = function () {
    if (!stockManager.isInEdit()) { // 非编辑状态，无法修改，直接返回
        // api.closeWin();
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
        return true;
    }
    return false;
};

/**
 * 判断页面数据是否修改
 */
stockManager.isDataChange = function () {
    stockManager.data.dj = stockManager.getSaveDj();

    if ($.nui.isTrue(stockManager.refreshUpperPage)) {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'refresh',
                'closeLayer': true
            }
        });
        stockManager.refreshUpperPage = false;
    }

    if (stockManager.JD_FROM_JL && !stockManager.__PAGE_INIT_DATA.dj['is_jd']) {
        if ($('body').find('.data-change-skin').length) return;

        // // 新单时，如果数据需要保存的记录行数据为0，并且没有填写单据信息，没有删除过行记录
        // if ($.nui.isEmpty(page_data.id) && stockManager.data.jl.length === 0 && stockManager.deleteRows.length === 0 && !stockManager.isDjDataChange() && !stockManager.isDeleteRows) {
        //     api.closeToWin({name: page_data.return_page});
        //     return false;
        // }

        if (!stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            // api.sendEvent({
            //     name: page_data['return_page'],
            //     extra: {
            //         'status': 'refresh',
            //     }
            // });
            fun.useBack();
            api.closeToWin({ name: page_data.return_page });
            return;
        }

        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: stockManager.apiSave,
            no: function () {
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        'status': 'refresh',
                        'closeLayer': true
                    }
                });
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         'status': 'refresh',
                //     }
                // });
                api.closeToWin({ name: page_data.return_page });
            }
        });
        return false;
    }

    if (!stockManager.JD_FROM_JL && stockManager.isDataNotChange()) {
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         'status': 'refresh',
        //     }
        // });
        // api.closeToWin({name: page_data.return_page});
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
        return false;
    }

    console.log(JSON.stringify(stockManager.origin_data))
    console.log(JSON.stringify(stockManager.data))

    if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
        if ($('body').find('.data-change-skin').length) return;

        // 新单时，如果数据需要保存的记录行数据为0，并且没有填写单据信息，没有删除过行记录
        if ($.nui.isEmpty(page_data.id) && stockManager.data.jl.length === 0 && stockManager.deleteRows.length === 0 && !stockManager.isDjDataChange() && !stockManager.isDeleteRows) {
            // api.sendEvent({
            //     name: page_data['return_page'],
            //     extra: {
            //         'status': 'refresh',
            //     }
            // });
            // api.closeToWin({name: page_data.return_page});
            setTimeout(function () {
                fun.useBack();
                api.closeToWin({ name: page_data.return_page })
            }, 200);
            return false;
        }


        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: stockManager.apiSave,
            no: function () {
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        'status': 'refresh',
                        'closeLayer': true
                    }
                });
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         'status': 'refresh',
                //     }
                // });
                // api.closeToWin({name: page_data.return_page});
                setTimeout(function () {
                    fun.useBack();
                    api.closeToWin({ name: page_data.return_page })
                }, 200);
            }
        });
    } else {
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         'status': 'refresh',
        //     }
        // });
        // api.closeToWin({name: page_data.return_page});
        setTimeout(function () {
            fun.useBack();
            api.closeToWin({ name: page_data.return_page })
        }, 200);
    }
};

/**
 * 封装获取成本逻辑
 * @param list 需要获取成本的数组
 * @param callback 获取成功后回调函数
 */
stockManager.loadCpcbj = function (list, callback) {
    if (Auth.check('yxckbpcbj', 'view')) {
        __getJlData = function () {
            // 处理定价单位id
            for (var i = 0; i < list.length; i++) {
                list[i]['jjdw_id'] = list[i]['dw_id'];
            }
            return list;
        };

        // 更新成本价
        __updateJlDataByIndex = function (item) {
            list[item.index]['cbj'] = item.data.dj;
        };

        __getAllDj({
            get_dj: true,
            callback: function () {
                callback(list);
            }
        });
    }
};

/**
 * 加载产品成本价，初始化数据
 */
stockManager.initShowData = function () {
    $('.collapse-more.collapse-wrap').removeClass('open');
    stockManager.beforeShowData();
    stockManager.renderData(stockManager.convertData());
};

/**
 * 点击添加按钮，具体内容自己实现
 */
stockManager.openAddPage = function () {
    throw Error("添加按钮动作未实现");
};

/**
 *  判断是否可以编辑
 */
stockManager.isInEdit = function () {
    var AUTH_EDIT = Auth.check(stockManager.authCheckName, 'edit');
    return AUTH_EDIT ? !stockManager.data.dj['is_sh'] : false;
};
// 页面显示处理 --------------------------------------------------------------------------------
/**
 * 显示页面数据通用方法
 */
stockManager.renderData = function (data) {
    data = stockManager.beforeRenderData(data);

    console.log('renderData');
    console.log(data);
    console.log('renderData');

    // 总匹数，总数量，计价单位处理
    var html = [], dws = {};
    stockManager.zps = 0;
    stockManager.zsl = 0;
    stockManager.zje = 0;

    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        var ck_mc = val['ck_mc'];
        if (val['ck_id'] && !ck_mc) {
            ck_mc = fun.getHouseValue(val.ck_id, 'name');
        }
        html.push('<a class="store-title" data-ck_id="' + val.ck_id + '" data-index=\'' + i + '\'>' + (ck_mc || ' ') + '</a>');
        html.push('<ul class="swipe-delete">');
        for (var j = 0; j < val['list'].length; j++) {
            var data_list = val['list'][j];
            // 统计显示单位名称
            if (!dws[data_list.dw_id]) {
                dws[data_list.dw_id] = data_list.dw_mc;
            }
            html.push(stockManager.initContentList(data_list));
        }
        html.push('</ul>');
    }
    // html.push('         <div class="add-product"><i class="iconfont icon-tianjia"></i>&nbsp;添加产品</div>');

    $('.storehouse').html(html.join(''));

    if (!stockManager.isInEdit()) {
        $('.swipe-delete').removeClass('swipe-delete');
    }

    // 只有一个单位时显示，多个时不显示
    var showedDw = [];
    for (var dwId in dws) {
        showedDw.push(dws[dwId]);
    }
    if (showedDw.length === 1) {
        stockManager.showedDw = showedDw[0];
    } else {
        stockManager.showedDw = '';
    }

    stockManager.afterRenderData();

    stockManager.renderFooter();
};
/**
 * 初始化化每个li内容,主要返回字符串内容
 */
stockManager.initContentList = function () {
    throw Error('stockManager.initContentList() 方法未实现');
};
/**
 * 渲染列表内容之后动作
 */
stockManager.afterRenderData = function () {
};
/**
 * 渲染列表内容之前动作
 */
stockManager.beforeRenderData = function (data) {
    return data;
};

/**
 * 初始化数据之前调用
 */
stockManager.beforeShowData = function () {
};


//解决底部按钮宽度问题
// stockManager.setButtonWidth = function () {
//     $('.right2 .button2:visible').css('width', 'calc(100% / ' + $('.right2 .button2:visible').length + ')');
// };

/**
 * 显示底部导航栏内容
 */
// stockManager.renderFooter = function () {
//     if (stockManager.isInEdit()) {// 有权限或者单据未审核
//         $('.saves').show();
//         $('.choice').show();
//         $('.choice,.add-product').css('display', 'inline-block');
//         if (Auth.check(stockManager.authCheckName, 'check') && page_data.id) { // 有审核权限
//             $('.audit').show();
//         }
//     } else {//有权限并且单据已审核
//         $('#bz').attr('disabled', 'disabled');
//         $('#del_btn').hide();
//         $('.choice,.add-product').hide();

//         if ((!stockManager.data.dj.is_zf) && Auth.check(stockManager.authCheckName, 'invalid') && stockManager.fsh) { // 未作废、有作废权限并且【系统设置-反审核】有开启
//             $('.obsolete').show();
//         }
//         if ((!stockManager.data.dj.is_zf) && Auth.check(stockManager.authCheckName, 'invalid') && !stockManager.fsh) { // 未作废、有作废权限并且【系统设置-反审核】没有开启
//             $('.revocatory').show();
//         }
//     }
//     $('#bz').val(stockManager.data.dj['bz'] || '');
//     // 总匹数/总数量
//     $('#zps').text((stockManager.zps.fixed(2) || 0) + '匹');
//     $('#zsl').text((stockManager.zsl.fixed(2) || 0) + stockManager.showedDw);
//     $('#zje').text(stockManager.zje.fixed(2) + '元');    // 保存2位小数

//     stockManager.afterRenderFooter();

//     if (stockManager.data.dj['is_zf']) {
//         fun.seal({ type: 'zf' });
//     } else if (stockManager.data.dj['is_sh']) {
//         fun.seal({ type: 'sh' });
//     } else {
//         if ($('body').find('#state_icon').length) $('body').find('#state_icon').remove();
//     }

//     var AUTH_EDIT = Auth.check(stockManager.authCheckName, 'edit');
//     var AUTH_SH = Auth.check(stockManager.authCheckName, 'check');
//     // var AUTH_FH = Auth.check(stockManager.authCheckName, 'recheck');
//     // var AUTH_JD = Auth.check(stockManager.authCheckName, 'settle');
//     var AUTH_ZF = Auth.check(stockManager.authCheckName, 'invalid');

//     if (stockManager.data.dj.is_sh) {
//         $('.obsolete').show();
//     } else {
//         $('.obsolete').hide();
//         page_data.id && $('.audit').show();
//     }

//     if (stockManager.data.dj['is_zf']) {
//         $('button').hide();
//     }

//     if (!AUTH_EDIT) {
//         $('#del_btn,.choice,.add-product.saves').hide();
//         $('input').attr('disabled', 'disabled');
//     }

//     if (!AUTH_SH) {
//         $('.audit,.revocatory').hide();
//     } else {
//         $('.saves,.choice').hide();
//     }

//     if (!AUTH_ZF) {
//         $('.obsolete').hide();
//     } else {
//         $('.saves,.choice').hide();
//     }


//     stockManager.setButtonWidth();

//     // 初始化准备提交的汇总数据
//     stockManager.data.dj = stockManager.getSaveDj();
// };

/**
 * 显示底部导航栏之后动作
 */
stockManager.afterRenderFooter = function () {
    // $('#zps').text(data['zps']+'匹'||'0匹');
    // $('#zsl').text(data['zsl'] + kcZspdEdit.showedDw || '0' + kcZspdEdit.showedDw);
};
/**
 * 初始化导航栏
 */
stockManager.initHeader = function () {
    var date = new Date();
    // 新单时，设置默认开单时间
    if (!page_data.id) {
        date.setSeconds(0, 0);
        var current_date = fun.formatDate(date, 'YYYY-MM-DD HH:mm:ss');
        stockManager.origin_data.dj.kdsj = current_date;
        stockManager.data.dj.kdsj = current_date;
    }

    $('#header').header({
        back: true,
        title: stockManager.headerTitle,
        subtitle: page_data['dh'] || '&nbsp;',
        appendBackBtnEvt: stockManager.isDataChange,
        del: true,//stockManager.isInEdit(), // 编辑状态，并且单据可以修改
        order_info: {
            show: true,
            person: page_data['zdr'] || fun.getItem('user_info')['name'],
            dateText: page_data['kdsj'] || fun.formatDate(date),
        },
        much: (stockManager.djlx == 'bp_cgdd') ? true : false,
        print: true,//$.nui.isTrue(page_data.id)
        share: true,//$.nui.isTrue(page_data.id)
    });

    $('#much_btn,#print_btn,#del_btn,#share_btn').hide();
};

stockManager.initHeaderAfter = function () {
    var date = new Date();
    if (!stockManager.isInEdit()) {
        $('#del_btn').hide();
    }

    $('.subtitle').text(stockManager.data.dj.dh || ' ');
    $('#zdr').html(stockManager.data.dj['zdr_mc'] || fun.getItem('user_info')['name']);
    $('#kdsj').html(fun.formatDate(stockManager.data.dj['kdsj']) || fun.formatDate(date));

    if ($.nui.isTrue(page_data.id)) $('#print_btn').show();
    if ($.nui.isTrue(page_data.id)) {
        if (['bp_cgdd', 'bp_cglhjs', 'bp_cgthjs', 'bp_cglhd', 'bp_cgthd'].indexOf(stockManager.djlx) > -1) $('#share_btn').show();
    }
};

/**
 * 选择时间回调
 * @param date
 */
stockManager.kdsjChange = function (date) {
    // 设置记录行货期天数
    var rows = stockManager.data.jl || [];
    var kdsj = fun.formatDate(date, 'YYYY/MM/DD');

    for (var i = 0; i < rows.length; i++) {
        var __row = rows[i];
        if ($.nui.isTrue(__row['hq'])) {
            var hqts = fun.getDaysBetween(__row['hq'], kdsj);
            __row['hqts'] = hqts;
        } else if ($.nui.isTrue(__row['hqts'])) {
            __setHqts(__row, __row['hqts'], i);
        }
    }
};


/**
 * 设置或者清空批号，根据仓库是否开启批次管理判断
 */
stockManager.generaPh = function (config) {
    // 仓库开启批次的，需要设置批号
    if (config.ckInfo.is_batch) {
        if (!config.item[config.key] || config.forceUpdate) {
            config.item[config.key] = fun.formatDate(config.date, 'YYYYMMDD');
        }
    } else {
        config.item[config.key] = '';
    }
};

/**
 * 初始化时间选择控件
 */
stockManager.initDateTimePicker = function () {
    // <link rel="stylesheet" type="text/css" href="../css/lCalendar.css">
    var link = document.createElement('link');
    link.type = "text/css";
    link.rel = "stylesheet";
    link.href = "../css/lCalendar.css";
    document.getElementsByTagName("head")[0].appendChild(link);

    stockManager.begin_lCalendar.init({
        'trigger': '#kdsj',
        'type': 'datetime',
        'callback': function (date) {
            stockManager.data.dj.kdsj = fun.formatDate(date, 'YYYY-MM-DD HH:mm');
            $('#kdsj').text(fun.formatDate(date));
            stockManager.kdsjChange(date);
            stockManager.initShowData();
            stockManager.fsm();
        }
    });
};






// 属性配置
html_name = page_arr.cg_cgdd_kd;

Bills.djlx = 'bp_cgdd';
// 获取布匹上次价需要
Bills.AJAX_URL = { getDj: AJAX_URL.getBpCgDjAndScdj };
Bills.config.bdjesswr = 'bdjesswr_bpcg';   // 本单金额四舍五入
Bills.config.jesswr = 'jesswr_bpcg';       // 金额四舍五入

stockManager.getDataUrl = AJAX_URL.getBpCgddInfo;
stockManager.postUrl = AJAX_URL.saveBpCgddInfo;
stockManager.authCheckName = Bills.djlx;
stockManager.isLoadCbj = false;

stockManager.djlx = Bills.djlx;
stockManager.table = 'bp_cgdd_dj';

stockManager.headerTitle = '采购订单';
stockManager.fz_ys = [];     // 辅助颜色
stockManager.fz_cp = [];     // 辅助产品
stockManager.updateRow = false;  // 是否在编辑

stockManager.wldw = null;         // 往来单位

stockManager.wlcp = [];           // 未来产品集合
stockManager.selectCkIndex = -1;  // 切换的仓库对应hzData下标

// fun.keyboardEject('.base2');
stockManager.dws = {};            // 单位集合

var AUTH_EDIT = Auth.check(stockManager.authCheckName, 'edit');
var AUTH_SH = Auth.check(stockManager.authCheckName, 'check');
var AUTH_FH = Auth.check(stockManager.authCheckName, 'recheck');
var AUTH_JD = Auth.check(stockManager.authCheckName, 'settle');

// var equipment = navigator.userAgent;
// if(equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1){
//     $('.contents').css('marginTop','6.5rem');
//   }
// 复核功能需要开启
// methods ----------------------------------------------------------------
stockManager.initStart = function () {
    // 新增时,设置供应商信息
    if ($.nui.isEmpty(page_data.id)) {
        if (page_data.wldw) {
            stockManager.wldw = page_data.wldw;
            stockManager.data.dj.wldw_id = page_data.wldw.id;
            stockManager.data.dj.wldw_mc = page_data.wldw.merchant_name;

            $('#wldw_mc').val(stockManager.data.dj.wldw_mc);
            // 加载辅助信息
            Bills.wldw = { id: page_data.wldw.id };
            stockManager.loadFzInfo();
        }

        // 设置默认值
        stockManager.origin_data.dj.wldw_id = '';
        stockManager.origin_data.dj.bp_lx = 'pb';
        stockManager.data.dj.bp_lx = 'pb';
    }
};

stockManager.initExtend = function () {
    // 设置返回页面
    page_data.return_page = page_arr.cg_cgdd_tj;

    // 点击选择供应商
    // 如果当前单据 任意一条记录行 已来过货 或 结单，则不允许编辑供应商。
    $('.wldw-block').on('click', function () {
        $('.collapse-more.collapse-wrap').removeClass('open');
        if ($(this).find('#wldw_mc').attr('disabled')) return;
        if (stockManager.isInEdit() && $.nui.isEmpty(stockManager.data.dj.is_has)) {
            fun.showPageFull({
                page_url: page_arr.customer_search,
                pageParam: {
                    page_type: 'gys',
                    return_page: html_name
                }
            });
        }
    });

    // radio 选择切换
    $('body').off('tap', '.radio-box').on('tap', '.radio-box', function () {
        $('.collapse-more.collapse-wrap').removeClass('open');
        if ($(this).attr('disabled')) return;
        if (stockManager.isInEdit()) {
            $('.radio-box').removeClass('radio-choice');
            $(this).addClass('radio-choice');

            var bp_lx = $(this).data('value');
            stockManager.data.dj.bp_lx = bp_lx;
            stockManager.extraDJData.bp_lx = bp_lx;
        }
    });

    // 复核处理
    $('body').off('tap', '.audit').on('tap', '.audit', function (e) {
        e.stopPropagation();
        $('.collapse-more.collapse-wrap').removeClass('open');
        if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            return fun.toast('单据已修改，未保存，不能复核！');
        }

        if ($.nui.isEmpty(stockManager.data.jl)) return fun.toast(tips_arr['空单提示']);

        fun.dialog({
            content: '您确定要复核当前单据吗',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiAudit(1);
            }
        });
    });

    // 反复核
    $('body').off('tap', '.revocatory').on('tap', '#kd_cancel_fh,#cgdd-ffh', function (e) {
        e.stopPropagation();
        $('.collapse-more.collapse-wrap').removeClass('open');
        if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            return fun.toast('单据已修改，未保存，不能取消复核！');
        }

        fun.dialog({
            content: '您确定要反复核吗',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiAudit(0);
            }
        });
    });
    // 结单
    $('body').on('tap', '#kd_jd', function (e) {
        $('.collapse-more.collapse-wrap').removeClass('open');
        e.stopPropagation();
        // if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
        //     return fun.toast('单据已修改，未保存，不能结单！');
        // }

        fun.dialog({
            content: '您确定要整张单据结单吗',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiFinish(1);
            }
        });
    });

    // 反结单
    $('body').off('tap', '.btn-finish').on('tap', '.btn-finish', function (e) {
        e.stopPropagation();
        $('.collapse-more.collapse-wrap').removeClass('open');
        if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
            return fun.toast('单据已修改，未保存，不能取消结单！');
        }

        fun.dialog({
            content: '您确定要取消结单吗',
            btn: ['确定', '取消'],
            yes: function () {
                stockManager.apiFinish(0);
            }
        });
    })

    // 选择仓库
    $('body').on('tap', '.store-title', function () {
        $('.collapse-more.collapse-wrap').removeClass('open');
        if ($(this).attr('disabled')) return;
        if (stockManager.isInEdit()) {
            stockManager.selectCkIndex = $(this).data('index');
            var hzData = stockManager.hzData[stockManager.selectCkIndex];
            // 如果有一行被调用，则不允许切换仓库
            var isHas = false;
            for (var i = 0; i < hzData.list.length; i++) {
                if (hzData.list[i].has) {
                    isHas = true;
                    break;
                }
            }
            // 当前记录行被调用过，不允许编辑
            if (!isHas) {
                var ck_id = $(this).data('ck_id');
                var ck_list = fun.getItem('ck_list') || [];
                fun.showPageFull({
                    page_url: page_arr.select_list,
                    pageParam: {
                        djlx: stockManager.djlx,
                        page_type: 'ck',
                        return_page: html_name,
                        ck_type: (fun.getValByKey(ck_list, ck_id, 'type') === 'skyb' && fun.checkJlHasSk(stockManager.data.jl, ck_id)) ? 'skyb' : ''
                    }
                })
            }
        }
    });
};

// 获取调号后回调
stockManager.afterApiGetDh = function (data) {
    if (data.bp_lx) {
        if (data.bp_lx === 'bp') {  // 默认成品
            data.bp_lx = 'cp';
        }
        stockManager.data.dj.bp_lx = data.bp_lx;
        stockManager.origin_data.dj.bp_lx = data.bp_lx;
        stockManager.extraDJData.bp_lx = data.bp_lx;
    }
    stockManager.setRadioCheck();
};

// 复核/反复核api请求
stockManager.apiAudit = function (status) {
    if ($.nui.isEmpty(page_data.id)) return fun.toast('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'recheck')) return false;
    if (!Auth.qfmd({ 'key': 'recheck', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'recheck', 'zdr_id': stockManager.data.dj.zdr_id })) return false;

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: stockManager.postUrl,
        data: { status: 'dbaudit', fhr_id: fun.getItem('user_info')['id'], is_fh: status, dj_id: page_data.id, __post_sign: Bills['__post_sign']},
        success: function (res) {
            Bills['__post_sign'] = $.nui.getRandomNum();
            fun.toast(res.msg);
            if (res.status === 0) {
                setTimeout(function () {
                    stockManager.closePage();
                }, 300);
            }
        }
    });
};

// 结单/反结单api请求
stockManager.apiFinish = function (status) {
    if ($.nui.isEmpty(page_data.id)) return console.log('无单据id');
    if (!Auth.check(stockManager.authCheckName, 'settle')) return false;
    if (!Auth.qfmd({ 'key': 'settle', 'md_id': stockManager.data.dj.md_id })) return false;
    if (!Auth.qfczy({ 'key': 'settle', 'zdr_id': stockManager.data.dj.zdr_id })) return false;

    // 结单api请求
    settle({
        status: 'finish',
        jdr_id: fun.getItem('user_info')['id'],
        is_jd: status,
        dj_id: page_data.id,
        isSave: false,
        __post_sign: Bills['__post_sign']
    });

    function settle(saveData) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: stockManager.postUrl,
            data: saveData,
            success: function (res) {
                Bills['__post_sign'] = $.nui.getRandomNum();
                switch (res['status']) {
                    case 0:
                        fun.toast(res.msg);
                        api.sendEvent({
                            name: html_name,
                            extra: {
                                'status': 'refresh_dj',
                            }
                        });
                        api.sendEvent({
                            name: page_data['return_page'],
                            extra: {
                                'status': 'refresh',
                                'closeLayer': true
                            }
                        });
                        break;
                    case 'IS_NOT_FINISH':
                        fun.jdts({
                            content: '部分产品还没来完货，你确定要结单吗？',
                            yes: function () {
                                settle($.extend({ notCheckFinish: 1 }, saveData));
                            }
                        });
                        break;
                    case 'IS_ZS_FKC':
                        var list = res['data']['list'][0];
                        var ps_display = list['bz_ps'] > 0;
                        var sl_display = list['bz_sl'] > 0;
                        var msg = [
                            list['cp_bh'] + list['cp_mc'] + '\r\n',
                            list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                            '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                            '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                        ].join('');
                        fun.toast(msg);
                        break;
                    case 'IS_TM_FKC':
                        var list = res['data']['list'][0];
                        fun.toast('条码' + list['tm'] + '和库存信息不一致');
                        break;
                    case 'IS_MX_FKC':
                        var list = res['data']['list'][0];
                        var msg = [
                            list['cp_bh'] + list['cp_mc'] + '\r\n',
                            list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                            '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                        ].join('');
                        fun.toast(msg);
                        break;
                    default:
                        if (['IS_NOT_FIND'].indexOf(res['status']) > -1) {
                            fun.toast('单据已被其他操作人员删除，无法' + (status ? '结单' : '反结单'));
                            api.sendEvent({
                                name: page_data['return_page'],
                                extra: {
                                    'status': 'refresh',
                                }
                            });
                        } else if (['IS_DBAUDIT'].indexOf(res['status']) > -1) {
                            fun.toast(res['msg']);
                            api.sendEvent({
                                name: html_name,
                                extra: {
                                    'status': 'refresh_dj',
                                }
                            });
                        } else {
                            fun.toast(res['msg']);
                        }
                        break;
                }
            }
        });
    }
};

// 重写显示底部导航栏方法
stockManager.renderFooter = function () {
    $('#wldw_mc,.store-title,.radio-box,input').removeAttr('disabled');

    // 只有一个单位时显示，多个时不显示
    var showedDws = [];
    for (var dwId in stockManager.dws) {
        showedDws.push(stockManager.dws[dwId]);
    }
    var showedDw = '';
    if (showedDws.length === 1) {
        showedDw = showedDws[0];
    }

    $('#kdsj').text(fun.formatDate(stockManager.data.dj['kdsj']));

    $('#bz').val(stockManager.data.dj['bz'] || '');
    // 总匹数/总数量
    $('#zps').text($.nui.decimalAdd(stockManager.zps, stockManager.cxps) + '匹');
    $('#zsl').text((stockManager.zjjsl || 0) + showedDw);
    $('#zje').text(stockManager.zje.fixed(2) + '元');

    $('.choice,.add-product').css('display', 'inline-block');

    // 是否开启复核权限
    var isAuthFh = fun.getKzValue('ddfh', Bills.djlx);

    var AUTH_SETTLE = Auth.check(Bills['auth'], 'settle'); // 结算
    var config = (fun.getValByKey(fun.getItem('cg_ddlb_list') || [], stockManager.data.dj['djlb_id'], 'config')) || {};
    var djLbFh = config['fh']; // 订单类别复核

    if (stockManager.isInEdit()) {                                   //  单据未复核
        $('#kd_save').show();
        if (isAuthFh && $.nui.isTrue(page_data['id'])) {             // 用户拥有复核权限
            $('#kd_fh').show();
            $('#kd_save').hide();
        }
    } else if (isAuthFh) {                                           // 单据已复核
        // 备注不可输入
        $('#bz, #cg_ddlb').attr('disabled', 'disabled');
        // 隐藏底部加号按钮
        $('.choice,.add-product').hide();

        if (stockManager.data.dj.is_jd && Auth.check(Bills.djlx, 'settle')) {       // 已结单
            $('.radio-box, #cg_ddlb').attr('disabled', true);
            $('#kd_cancel_jd').show();
        } else {                                                     // 未结单
            // 当前用户有当前页面的结单权限时，才显示该按钮
            if (Auth.check(Bills.djlx, 'settle')) {
                $('#kd_jd').show();
            }
            $('#kd_cancel_fh').show();
            $('.choice,.add-product').css('display', 'inline-block');
        }
    }

    if (!isAuthFh) {
        if (stockManager.data.dj.is_jd) {
            $('#kd_cancel_jd').show();
            $('.choice,.add-product').hide();
            $('.radio-box, #cg_ddlb').attr('disabled', true);
        } else {
            // $.nui.isTrue(page_data['id']) && $('#kd_jd').show() && $('#kd_save').hide();//.choice,
            if ($.nui.isTrue(page_data['id'])) {
                $('#kd_jd').show();
                $('#kd_save').hide();
            }
            if (djLbFh) {
                $('#kd_jd').hide();
                $('#kd_fh').show();
            }
            if (stockManager.data.dj.is_fh) {
                $('#kd_save,#del_btn,.choice,.add-product').hide();
                $('input').attr('disabled', true);
                if (Auth.check(Bills.djlx, 'settle')) {
                    $('#kd_fh').hide();
                    $('#kd_jd').show();
                }
            } else {

            }
        }
    }

    // if (djLbFh) { // 有开启复核
    //     $('#kd_jd').hide();
    //     $('#kd_fh').show();
    // } else { // 无开启复核
    //     $('#kd_fh').hide();
    //     $('#kd_jd').show();
    // }

    if (!stockManager.isInEdit()) {
        $('input').attr('disabled', true);
    }

    if (stockManager.checkJlIsJd(stockManager.data.jl)) {
        $('#del_btn').hide();
    }

    if (AUTH_FH && stockManager.data.dj.is_fh) {
        console.log('-0-0-0-0--0-0--')
        !stockManager.data.dj['is_jd'] && $('#much_btn').show();
        $('#del_btn').hide();
    }

    if (stockManager.data.dj.is_jd) {
        $('#kd_fh,#kd_save').hide();
    }

    if (!AUTH_EDIT) {
        $('#del_btn,.choice,.add-product').hide();
        // $('#kd_fh,#kd_cancel_fh').hide();
        $('input').attr('disabled', true);
        $('.right2').hide();
    }
    if (!AUTH_FH) {
        $('#kd_fh,#kd_cancel_fh').hide();
    }

    if (!AUTH_JD) {
        $('#kd_jd,#kd_cancel_jd').hide();
    }

    // 如果已结单
    if (stockManager.data.dj['is_jd']) {
        fun.seal({ type: 'jd' });
    } else {
        $('body').find('#state_icon').remove();
    }

    stockManager.setDisabledByDy();

    if (stockManager.data.dj.is_fh) {
        $('.choice,.add-product').hide();
    }

    stockManager.setButtonWidth();

    if (!AUTH_EDIT || stockManager.data.dj.is_fh) {
        $('#wldw_mc,.radio-box,#cg_ddlb,input').attr('disabled', true);
    }

    // 初始化准备提交的汇总数据
    stockManager.data.dj = stockManager.getSaveDj();
};

stockManager.checkJlIsJd = function (jl) {
    var jd = false;

    for (var i = 0; i < jl.length; i++) {
        if (jl[i]['is_jd'] && !jl[i]['is_tmp_jd']) {
            jd = true;
        }
    }
    return jd;
};

// ·编辑时数据加载回调
stockManager.apiDataLoaded = function () {
    // 编辑时设置供应商信息
    stockManager.wldw = fun.getListInfoByKey(fun.getItem('wldw_gys_list'), stockManager.data.dj.wldw_id);
    stockManager.setRadioCheck();
};

// 显示数据之前动作
stockManager.beforeShowData = function () {
    // 获取供应商具体信息
    // 显示radio
    // 显示供应商
    // 显示是否结单图片
    if (!$.nui.isEmpty(page_data.id)) {
        $('#wldw_mc').val(stockManager.data.dj.wldw_mc);
    }

    console.log(JSON.stringify(stockManager.data.dj))

    $('#cg_ddlb').val(stockManager.data.dj['lb_mc'] || '').data('djlb_id', stockManager.data.dj['djlb_id'] || 0); // 辅助产品类别字段

    // 设置唯一下标，因为要按仓库聚合一次，删除时需要
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        stockManager.data.jl[i].__uuid = $.nui.getRandomNum();
    }
    // 数据清0
    stockManager.zjjsl = 0;
    stockManager.hszje = 0;
    stockManager.dws = {};

    $('#wldw_mc,.radio-box,#cg_ddlb,input').removeAttr('disabled');

};

// radio 选择框处理
stockManager.setRadioCheck = function () {
    var $radioBox = $('.radio-box');
    $radioBox.removeClass('radio-choice');
    $radioBox.each(function (index, e) {
        var $e = $(e);
        if ($e.data('value') === stockManager.data.dj.bp_lx) {
            $e.addClass('radio-choice');
        }
    });
};

// 拼接显示列表
stockManager.initContentList = function (data_list) {
    var kh_style = !!data_list['kh_dd_dh'] ? 'height:12.5rem' : '';
    var delete_style = !!data_list['kh_dd_dh'] ? 'height:12.5rem;line-height:12.5rem' : '';

    var html = ['<li class="store-info fixed-high" >'];

    html.push('<div class="le">');
    if (data_list.is_dy) { // 标志记录是调单记录
        html.push('<div class="box"></div>');
    }
    html.push('<div class="store-content" data-row=\'' + fun.formatString(JSON.stringify(data_list)) + '\'>');
    html.push('<p class="store-name">' + data_list['cp_bh'] + data_list['cp_mc'] + ' <i>' + data_list['cp_ys_bh'] + data_list['cp_ys_mc'] + '</i></p>');

    // html.push('<span>幅宽<i class="info-date">' + fun.is_value(data_list['fk']) + '</i></span>');
    // html.push('<span>克重<i class="info-date">' + fun.is_value(data_list['kz']) + '</i></span>');
    // // html.push('<span><i class="info-date"></i></span>');
    // html.push('                 <span><div class="label-jjcd urgent" style="background-color: ' + data_list['jjcd_colour'] + '">' + fun.is_value(data_list['jjcd_mc'], ' ') + '</div></span>');

    var valObj = {
        ps: $.nui.decimalAdd(parseInt((data_list['ps'] || 0)), parseInt((data_list['cxps'] || 0))),
        zsl: $.nui.decimalAdd(parseFloat((data_list['zsl'] || 0)), parseFloat((data_list['cxsl'] || 0))),
    };

    html.push('<span>匹数<i class="info-date">' + valObj['ps'] + '</i></span>');
    html.push('<span>数量<i class="info-date">' + valObj['zsl'] + fun.is_value(data_list['dw_mc']) + '</i></span>');
    // 当 计价数量 <> 数量 时，计价数量 字体颜色用蓝色，反之，则为黑色
    if (data_list['jjsl'] !== data_list['zsl']) {
        html.push('<span>计价<i class="info-date price-cp">' + (data_list['jjsl'] || 0) + '<i class="unit">' + fun.is_value(data_list['jjdw_mc']) + '</i></i></span>');
    } else {
        html.push('<span>计价<i class="info-date">' + (data_list['jjsl'] || 0) + fun.is_value(data_list['jjdw_mc']) + '</i></span>');
    }

    html.push('<span>单价<i class="info-date unitprice">' + fun.is_value(data_list['hsdj'], 0) + '</i></span>');
    html.push('<span><i class="price">￥' + fun.sswr((data_list.hszje || 0)) + '</i></span>');
    html.push('<span><i class="info-date"></i></span>');
    if (fun.getKdSetting('fk')) {
        html.push('                 <span>幅宽<i class="info-date">' + fun.is_value(data_list['fk']) + '</i></span>');
    }
    if (fun.getKdSetting('kz')) {
        html.push('                 <span>克重<i class="info-date">' + fun.is_value(data_list['kz']) + '</i></span>');
    }
    if ($.nui.isTrue(data_list['jjcd_mc'])) {
        html.push('                 <span><div class="label-jjcd urgent" style="background-color: ' + data_list['jjcd_colour'] + '">' + fun.is_value(data_list['jjcd_mc'], ' ') + '</div></span>');
    }
    if (fun.getKdSetting('gg')) {
        html.push('                 <span>规格<i class="info-date">' + fun.is_value(data_list['gg']) + '</i></span>');
    }
    // if(fun.getKdSetting('gh') && data_list['gh']){
    //     html.push('                 <span>' + (data_list['gh'] ? '缸号' : ' ') + '<i class="info-date">' + fun.is_value(data_list['gh']) + '</i></span>');
    // }
    html.push('<span style="width: 90%;">备注<i class="info-date">' + fun.is_value(data_list.bz) + '</i></span>');
    //调单信息
    if (!!data_list['kh_dd_dh']) {
        html.push('<p class="odd-numbers">');
        html.push('<em>' + data_list.kh_mc + '</em>');
        html.push('<em>订单：' + data_list.kh_dd_dh + '</em>');
        html.push('</p>');
    }
    html.push('</div>'); // .store-content

    if ($.nui.isEmpty(stockManager.data.dj.is_fh)) {
        html.push('<div class="delete dels1 delete-btn delete2"  data-row=\'' + fun.formatString(JSON.stringify(data_list)) + '\' ><b class="swipe-span">删除</b></div>');
    }

    html.push('</div>'); // .le
    html.push('</li>');

    // 检查是否产品未来货
    if (page_data.id && (data_list.wlps > 0 || data_list.wlsl > 0)) {
        stockManager.wlcp.push(data_list);
    }

    stockManager.cxps = 0;

    // 总匹数，总数量合计
    stockManager.zps = $.nui.decimalAdd(stockManager.zps, data_list.ps);
    stockManager.cxps = $.nui.decimalAdd(stockManager.cxps || 0, data_list.cxps || 0);
    stockManager.zsl = $.nui.decimalAdd(stockManager.zsl, data_list.zsl);
    stockManager.zje = $.nui.decimalAdd(stockManager.zje, data_list.zje);
    stockManager.zjjsl = $.nui.decimalAdd(stockManager.zjjsl, data_list.jjsl);
    stockManager.hszje = $.nui.decimalAdd(stockManager.hszje, data_list.hszje);

    if (!stockManager.dws[data_list.jjdw_id]) {
        stockManager.dws[data_list.jjdw_id] = data_list.jjdw_mc;
    }
    return html.join('');
};

//
stockManager.afterRenderData = function () {
    // 扩展extraDJData
    stockManager.hszje = __bdjeSswr(stockManager.hszje);
    stockManager.zje = __bdjeSswr(stockManager.zje);
    stockManager.bdje = __bdjeSswr(stockManager.hszje);

    stockManager.extraDJData = {
        wldw_id: stockManager.data.dj.wldw_id,
        wldw_mc: stockManager.data.dj.wldw_mc,
        fp_id: stockManager.data.dj.fp_id,
        bp_lx: stockManager.data.dj.bp_lx,
        bdje: stockManager.hszje || 0,
        zje: stockManager.zje,
        zsl: stockManager.zsl,
        hszje: stockManager.hszje,
        zps: stockManager.zps,
        // djlb_id: stockManager.data.dj.djlb_id,
        // lb_mc: stockManager.data.dj.lb_mc
    };

    // 原始数据修改，设置总计价数量
    stockManager.origin_data.dj.zjjsl = stockManager.zjjsl;
    stockManager.origin_data.dj.bdje = stockManager.hszje;

    stockManager.setDisabledByDy();
};

// 重写改方法
stockManager.isDataNotChange = function () {
    // 1. 编辑状态，返回false走检查数据是否修改检查
    // 2. 已复核状态
    if (stockManager.isInEdit()) {
        return false;
    } else {
        if (stockManager.data.dj.is_fh) {
            // 取消复核状态时，返回false走检查数据是否修改检查
            return false;
        }
    }

    // 其他情况，可以关闭返回
    api.closeWin();
    return true;
};

// 重写isInEdit
stockManager.isInEdit = function () {
    var flag = true;
    if (AUTH_EDIT) {
        var is_fh = !stockManager.data.dj['is_fh'];
        // 是否开启复核权限
        var isAuthFh = fun.getKzValue('ddfh', Bills.djlx);
        if (isAuthFh) {
            flag = is_fh;
            if (stockManager.data.dj['is_jd']) flag = false;
        } else {
            // flag = !stockManager.data.dj['is_jd'];
            if (stockManager.data.dj['is_fh']) flag = false;
            if (stockManager.data.dj['is_jd']) flag = false;
        }
    } else {
        flag = false;
    }

    return flag;
};

// 判断数据是否修改
stockManager.checkDataChange = function (origin_data, data) {
    var tmp_data = JSON.parse(JSON.stringify(data));

    for (var i = 0; i < tmp_data.jl.length; i++) {
        delete tmp_data.jl[i].__uuid;
        delete tmp_data.jl[i].dj_jd_from_jd;
        delete tmp_data.jl[i].djtz_jl_jd;
        delete tmp_data.jl[i].jg_lx_mc;
        delete tmp_data.jl[i].jg_lx;
    }
    delete tmp_data.dj.is_sh;

    tmp_data.dj.id = Number(tmp_data.dj.id || 0);

    // 去掉仓库id
    delete tmp_data.dj.ck_id;
    delete origin_data.dj.ck_id;
    // delete origin_data.dj.is_jd;
    // delete origin_data.dj.is_fh;

    if (origin_data.dj) {
        origin_data.dj.zdr_id = fun.getItem('user_info')['id'];
        origin_data.dj.md_id = fun.getItem('user_info')['store_id'];
    }

    if(origin_data.dj.lb_mc===null && tmp_data.dj.lb_mc === ''){
        tmp_data.dj.lb_mc = null;
    }

    // console.log(JSON.stringify(origin_data));
    // console.log(JSON.stringify(tmp_data));
    return !$.nui.isObjEquals(origin_data, tmp_data);
};

// 删除记录行
stockManager.deleteRow = function (_this) {
    var list_data = $(_this).data('row');
    var foundIndex = stockManager.findIndex(function (item) {
        return item.__uuid === list_data.__uuid;
    });
    var delArr = stockManager.data.jl.splice(foundIndex, 1);
    stockManager.rowDeleteHandler(delArr[0]);
    stockManager.initShowData();
};

// 编辑记录行
stockManager.editRow = function (_this) {
    var list_data = $(_this).data('row') || {};

    // 查找编辑行记录
    var foundIndex = stockManager.findIndex(function (item) {
        return item.__uuid === list_data.__uuid;
    });

    // 复核后才需要显示结算
    var __DJ_DATA = stockManager.data.dj;
    if (!stockManager.isInEdit()) {
        __DJ_DATA.id = page_data.id
    }

    stockManager.updateRow = true;

    // console.log(JSON.stringify({
    //     djlx: Bills.djlx,
    //     list_data: list_data,
    //     ck_info: {
    //         id: list_data.ck_id,
    //         name: list_data.ck_mc
    //     },
    //     edit_row: true,
    //     __PAGE_EDIT: stockManager.isInEdit(),
    //     row_index: foundIndex,
    //     __JL_DATA: stockManager.data.jl,
    //     return_page: html_name,
    //     __DJ_DATA: __DJ_DATA,
    //     bj_type: 'zs'
    // }))

    fun.showPageFull({
        page_url: NEW_BILLS ? page_arr.bills_cgddxq : page_arr.kdbj_dd,
        pageParam: {
            djlx: Bills.djlx,
            list_data: list_data,
            ck_info: {
                id: list_data.ck_id,
                name: list_data.ck_mc
            },
            edit_row: true,
            __PAGE_EDIT: stockManager.isInEdit(),
            row_index: foundIndex,
            __JL_DATA: stockManager.data.jl,
            return_page: html_name,
            __DJ_DATA: __DJ_DATA,
            bj_type: 'zs',
            initType: 'edit'
        }
    });
};

// 打开页面
stockManager.openAddPage = function () {
    var __PAGE_INFO = { ck_id: '' };

    if (stockManager.hzData.length) {
        __PAGE_INFO.ck_id = stockManager.hzData[0].ck_id;
    }

    fun.showPageFull({
        page_url: page_arr.choice_product,
        pageParam: {
            djlx: stockManager.djlx,
            return_page: html_name,
            __PAGE_INFO: __PAGE_INFO,
            __JL_DATA: stockManager.data.jl || [],
            __DJ_DATA: stockManager.data.dj,
            wldw: {
                id: stockManager.data.dj.wldw_id
            },
            NOT_OPEN_AGAIN: true,
            edit_row: true,
            is_dy_cgdd_type: stockManager.data.dj.bp_lx,
            loadScdj: true
        }
    })
};

// 辅助颜色/色号
// 产品辅助名称/编号
stockManager.loadFzInfo = function () {
    __getWldwSubInfo({
        ljqk: false,
        fz_cp: true,
        fz_ys: true,
        lxr: false,
        callback: function (res) {
            fun.hideLoad();
            // 辅助色号/颜色
            stockManager.fz_ys = res.fz_ys || [];
            fun.setFzys(stockManager.fz_ys, stockManager.data.jl);

            // 辅助编号/产品
            stockManager.fz_cp = res.fz_cp || [];
            fun.setFzcps(stockManager.fz_cp, stockManager.data.jl);
        }
    });
};

// 获取布匹上次价
stockManager.loadCpcbj = function (list, callback1, options) {
    options = $.extend({ update_all: false, get_dj: false }, options);
    var update_list = list;

    if (!options.update_all) {
        update_list = [];
        for (var i = 0; i < list.length; i++) {
            if (typeof list[i].scdj === 'undefined') {
                update_list.push(list[i]);
            }
            // 设置税率
            if (typeof list[i].shuilv === 'undefined') {
                list[i].shuilv = 0;
            }
            // 采购订单其他要求，默认空数组
            if (typeof list[i].qtyq === 'undefined') {
                list[i].qtyq = [];
            }
        }
    }

    __getJlData = function () {
        return update_list;
    };

    __getDjInfo = function () {
        return stockManager.data.dj;
    };

    // 更新上次价
    __updateJlDataByIndex = function (item) {
        var list_item = update_list[item.index];
        list_item.scdj = item.data.scdj;
        // 修改单价、含税总金额
        if (options.get_dj) {
            console.log(123333)
            list_item.dj = item.data.dj;

            var _data = list_item;

            _data['dj'] = parseFloat(_data['dj'] || 0);
            _data['hsdj'] = parseFloat(_data['hsdj'] || 0);

            _data['hsdj'] = (_data['dj'] * (1 + (parseFloat(_data['shuilv'] || 0)) / 100.00)).fixed();

            _data['je'] = (_data['dj'] * (_data['jjsl'] || 0)).fixed();
            _data['zydj'] = ($.nui.isEmpty(_data['zsl'])) ? 0 : (_data['je'] / parseFloat(_data['zsl'])).fixed();

            _data['hsje'] = ((_data['hsdj'] || 0) * (_data['jjsl'] || 0)).fixed();
            _data['shuie'] = ((_data['hsje'] || 0) - (_data['je'] || 0)).fixed();

            _data['zje'] = _data['je'];
            _data['hszje'] = _data['hsje'];
            for (var i = 1; i <= 5; i++) {
                // 自定义费用
                _data['zje'] += parseFloat(_data['fy_zdy' + i] || 0);
                _data['hszje'] += parseFloat(_data['fy_zdy' + i] || 0);
            }
            _data['zje'] = __jeSswr(_data['zje']);
            _data['hszje'] = __jeSswr(_data['hszje']);

            // list_item.hsdj = list_item.dj = item.data.dj;
            // list_item.hszje = fun.sswr(list_item.hsdj * list_item.jjsl);
        }
    };

    if (update_list.length) {
        __getAllDj({
            get_scdj: true,
            update_all: options.update_all,
            get_dj: options.get_dj,
            callback: function () {
                callback1(list);
            }
        });
    } else {
        callback1(list);
    }
};

// 选择供应商回调
stockManager.gysSelectHandler = function (wldw) {
    stockManager.wldw = wldw;
    stockManager.data.dj.wldw_id = wldw.id;
    stockManager.data.dj.wldw_mc = wldw.merchant_name;
    // 设置供应商信息
    stockManager.extraDJData.wldw_id = wldw.id;
    stockManager.extraDJData.wldw_mc = wldw.merchant_name;

    // 供应商辅助信息
    Bills.wldw = { id: wldw.id };
    $('#wldw_mc').val(wldw.merchant_name);
    stockManager.loadFzInfo();

    // 重新读取单价
    stockManager.loadCpcbj(stockManager.data.jl, function (list) {
        stockManager.data.jl = list;
        stockManager.initShowData();
        stockManager.fsm();
    }, { update_all: true, get_dj: true });
};

// 获取属性名
stockManager.getAttrId = function (type) {
    var attrId = '';
    switch (type) {
        case 'cg_ddlb': // 采购订单类别
            attrId = 'djlb_id';
            break;
    }
    return attrId;
}

// 返回更新数据
stockManager.upDateSelRow = function (data) {
    var $obj = $('[data-list_type="' + data['page_type'] + '"]');
    var attrId = stockManager.getAttrId(data['page_type']);
    var rowId = $obj.data(attrId);
    if (data['del_id'].length !== 0) {
        if (data['del_id'].indexOf(rowId) > -1) {
            $obj.data(attrId, 0).val("");
        }
    }
}

// 事件监听扩展
stockManager.eventListenerExtend = function (ret, err) {
    console.log('eventListenerExtend', ret);
    var value = ret.value;
    if (value.status === 'select_list') {
        if (value.data.page_type === 'gys') {    // 选择供应商回调，需要更新辅助信息、账户信息
            if (stockManager.data.dj.wldw_id != value.data.list_data.id) { // 选择同一个供应商不做处理
                stockManager.gysSelectHandler(value.data.list_data);
            }
        } else if (value.data.page_type === 'ck') {    // 选择仓库回调
            var hzData = stockManager.hzData[stockManager.selectCkIndex];
            stockManager.selectCkIndex = -1;
            if (hzData.ck_id !== value.data.list_data.id) {     // 选择同个仓库不做处理
                for (var i = 0; i < stockManager.data.jl.length; i++) {
                    // 记录行原本仓库跟点击仓库不一致时，跳过仓库赋值
                    if(hzData.ck_id != stockManager.data.jl[i].ck_id) continue;
                    stockManager.data.jl[i].ck_id = value.data.list_data.id;
                    stockManager.data.jl[i].ck_mc = value.data.list_data.name;
                }
                // 不允许多库存时，更新dj数据
                if (!stockManager.isDckms) {
                    stockManager.data.dj.ck_id = value.data.list_data.id;
                    stockManager.data.dj.ck_mc = value.data.list_data.name;
                }
                stockManager.initShowData();
            }
            stockManager.fsm();
        } else if (value.data.page_type === 'cg_ddlb') { // 采购订单类别
            if ($('#cg_ddlb').val().trim() === value.data['select_val']) return;
            $('#cg_ddlb').val(value.data['select_val']).data('djlb_id', value.data['id']);
            stockManager.data.dj.lb_mc = value.data['select_val'];
            stockManager.data.dj.djlb_id = value.data['id'];
            stockManager.fsm();
        }
    } else if (value.status === 'update_rows') {
        stockManager.JD_FROM_JL = ret.value.data.JD_FROM_JL;
        stockManager.CXPSSL_EDIT = ret.value.data.CXPSSL_EDIT;
        if (stockManager.updateRow) {                       // 编辑返回
            stockManager.updateRow = false;
            stockManager.data.jl = ret.value.data.__JL_DATA;
            stockManager.initShowData();
            stockManager.fsm();
        } else {                                            // 新增返回
            // 判断是否需要加载成本价
            stockManager.loadCpcbj(ret.value.data.__JL_DATA, function (list) {
                // 新增时, 辅助单位处理
                fun.setFzys(stockManager.fz_ys, list);
                fun.setFzcps(stockManager.fz_cp, list);
                stockManager.data.jl = list;
                // 重新初始化显示数据
                stockManager.initShowData();
                stockManager.fsm();
            });
        }
        if (ret.value.data['save_djtz']) {
            $('#kd_save').trigger('tap');
            stockManager.fsm();
        }
    } else if (value.status === 'refresh_dj') {              // 刷新数据
        // 按钮设置重置
        $('#kd_fh,#kd_cancel_fh,#kd_jd,#kd_save,#kd_cancel_jd').hide();
        stockManager.apiGetData();
        stockManager.refreshUpperPage = true;
    } else if (value.status === 'close_win') {
        stockManager.updateRow = false;
    } else if (value.status === 'update') {                  // 选择仓库直接返回
        switch (value.data.page_type) {
            case 'cg_ddlb': // 采购订单类别
                var tempData = value.data;
                stockManager.upDateSelRow(tempData);
                stockManager.upDateCategory(tempData['up']); // 更新产品类别
                break;
            case 'ck': // 仓库
                stockManager.selectCkIndex = -1;
                break;
            // 没有default
        }
    } else if (value.status === 'cg_dykhdd') {
        stockManager.data.jl = value.data.__JL_DATA;
        // 重新初始化显示数据
        stockManager.initShowData();

        // 添加新数据, 辅助单位设置
        fun.setFzcps(stockManager.fz_cp, value.data.__JL_DATA);
        fun.setFzys(stockManager.fz_ys, value.data.__JL_DATA);

    } else if (value.status === 'judge_jd') {
        stockManager.JD_FROM_JL = true;
        $('#kd_save').trigger('tap');
    }

    setTimeout(function () {
        stockManager.checkStatusShowSaveBtn(value['status']);
    }, 200);
};

// 保存前检查
stockManager.checkBeforeApiSaveAjax = function (callback) {
    var canAjax = true;
    // 检查供应商
    if ($.nui.isEmpty(stockManager.data.dj.wldw_id)) {
        fun.toast('供应商不能为空');
        canAjax = false;
    } else {
        // 当前单据的日期 < 当前往来单位的建立日期，则弹提示框
        var kdsjFormateDate = fun.formatDate(stockManager.data.dj.kdsj, 'YYYY-MM-DD');
        var wldwFormateDate = fun.formatDate(stockManager.wldw.date, 'YYYY-MM-DD');
        if (kdsjFormateDate < wldwFormateDate) {
            fun.toast('当据日期不能小于供应商建立日期');
            canAjax = false;
        }
    }

    // 设置总计价数量
    stockManager.data.dj.zjjsl = stockManager.zjjsl;

    callback(canAjax);
};

// 判断是否可以直接返回  检查备注、供应商、布匹类型、开单时间
stockManager.isDjDataChange = function () {
    return stockManager.data.dj.wldw_id != stockManager.origin_data.dj.wldw_id ||
        stockManager.data.dj.bz !== stockManager.origin_data.dj.bz ||
        stockManager.data.dj.bp_lx !== stockManager.origin_data.dj.bp_lx ||
        stockManager.data.dj.djlb_id != stockManager.origin_data.dj.djlb_id ||
        stockManager.origin_data.dj.kdsj !== stockManager.data.dj.kdsj;
};

// 被调用后设置不可用
stockManager.setDisabledByDy = function () {
    var jdFlag = false;

    for (var i = 0; i < stockManager.data.jl.length; i++) {
        var val = stockManager.data.jl[i];
        if (val['is_delete']) continue;
        if ($.nui.isTrue(val['is_jd']) && !val['is_tmp_jd']) {
            jdFlag = true;
        }
    }

    if (jdFlag) {
        $('#wldw_mc,.store-title,.radio-box,#cg_ddlb').attr('disabled', true);
    } else {
        $('#wldw_mc,.store-title,.radio-box,#cg_ddlb').removeAttr('disabled');
    }

    var flag = false;
    for (var i = 0; i < stockManager.data.jl.length; i++) {
        var val = stockManager.data.jl[i];

        if ($.nui.isTrue(val['kh_dd_dj_id'])) {
            flag = true;
        }
    }
    if (flag) {
        $('.radio-box,#cg_ddlb').attr('disabled', true);
    } else {
        !jdFlag && $('.radio-box,#cg_ddlb').removeAttr('disabled');
    }

    if ($.nui.isTrue(stockManager.data.dj['is_has'])) {
        $('#wldw_mc,.store-title,.radio-box,#cg_ddlb').attr('disabled', true);
    } else {

    }
};

// 根据状态去隐藏对应按钮并显示保存按钮
stockManager.fsm = function () {
    if ($('#kd_jd:visible').length) {
        stockManager.statusChangeShowSaveBtn('#kd_jd');
    } else if ($('#kd_fh:visible').length) {
        stockManager.statusChangeShowSaveBtn('#kd_fh');
    }
}

// 显示保存，隐藏对应状态按钮
stockManager.statusChangeShowSaveBtn = function (ele) {
    if (stockManager.dataHasChange()) { // 数据有发生改变
        stockManager.showAuthBtn(ele);
        stockManager.showSaveBtn();
    }
    stockManager.setButtonWidth();
}

// 隐藏对应状态按钮
stockManager.showAuthBtn = function (ele) {
    if ($(ele + ':visible').length) $(ele).hide();
}

// 显示保存按钮
stockManager.showSaveBtn = function () {
    if ($('#kd_save:visible').length) return;
    if (stockManager.data.dj['is_sh']) return;
    if ($.nui.isTrue(page_data['id'])) {
        $('#kd_save').addClass('bottom-btn-style width-whole');
    }
    $('#kd_save').show();
}

// 判断数据是否改变
stockManager.dataHasChange = function () {
    stockManager.data.dj = stockManager.getSaveDj();
    console.log('-------------------------')
    console.log(JSON.stringify(stockManager.origin_data))
    console.log(JSON.stringify(stockManager.data))
    return stockManager.checkDataChange(stockManager.origin_data, stockManager.data);
}

// input输入框绑定事件
stockManager.inputBindEvent = function () {
    // 未审核数据改变显示保存按钮
    $('body').off('input propertychange', ':input').on('input propertychange', ':input', fun.throttle(stockManager.fsm, 200));
}

// 根据返回状态检测数据判断显示保存按钮
stockManager.checkStatusShowSaveBtn = function (status) {
    var statusArrr = [
        'close_win',
        'update',
        'cg_dykhdd',
        'judge_jd'
    ];
    if (statusArrr.indexOf(status) > -1) stockManager.fsm();
}

//更多
$('body').on('tap', '#much_btn', function (e) {
    e.stopPropagation();
    // $('.collapse-wrap').removeClass('open');
    $('.collapse-more .collapse-ul').html('');

    var html = '';

    var ffhHtml = '<li id="cgdd-ffh" class="collapse-li">反复核</li>';

    var dj = stockManager.data['dj'],
        is_fh = dj['is_fh'],
        is_jd = dj['is_jd'];

    console.log(dj);

    if (!is_jd && is_fh) {
        html = ffhHtml;
    }


    // 当前页面处于 修改状态下 且 订金 > 0  且 当前单据的订单类别-没开启复核  且 当前用户有当前页面的审核权限时，才显示该按钮。反之，则隐藏。
    var AUTH_RECHECK = Auth.check(Bills['djlx'], 'recheck');//复核
    var AUTH_SETTLE = Auth.check(Bills['djlx'], 'settle');//结单
    var DD_FH = fun.getKzValue('ddfh', Bills['djlx']);//订单复核

    if (DD_FH) {
        if (dj['is_fh']) {
            html = ffhHtml;
        } else {
            html = '';
        }
    } else {
        html = '';
        if (dj['is_fh']) {
            html = ffhHtml;
        } else {
            html = '';
        }
    }

    if (dj['is_jd']) {
        html = '';
    }


    //复核
    if (!AUTH_RECHECK) {
        html = '';
    }

    $('.dy-collapse-wrap.collapse-wrap').removeClass('open');

    if ($('.collapse-more.collapse-wrap').hasClass('open')) {
        $('.collapse-wrap').removeClass('open');
    } else {
        $('.collapse-more.collapse-wrap').addClass('open');
    }

    $('.collapse-more .collapse-ul').html(html);

    if (!html) $('.collapse-more.collapse-wrap').removeClass('open');
});

$('body').on('tap', function (e) {
    $('.collapse-wrap').removeClass('open');
});

$('body').on('tap', '.collapse-li', function (e) {
    $('.collapse-more.collapse-wrap').removeClass('open');
});

//分享单据到微信
$('body').on('click', '#share_btn', function (_opt) {
    $('.collapse-more.collapse-wrap').removeClass('open');
    stockManager.data.dj = stockManager.getSaveDj();
    if (stockManager.checkDataChange(stockManager.origin_data, stockManager.data)) {
        return fun.toast('请先保存单据！');
    }
    fun.shareRequest({
        djlx: Bills['djlx'],
        id: page_data['id'],
    })
})

$('body').on('click', '.single-box,.radio-text', function (e) {
    e.stopPropagation();
    $('.collapse-more.collapse-wrap').removeClass('open');
    if (!AUTH_EDIT || stockManager.data.dj.is_fh) return;
    var bp_lx, oldType = stockManager.data.dj.bp_lx;
    if ($(this).is('.single-box')) { // 按钮
        if ($(this).find('.radio-box').attr('disabled')) return;
        // var idx = $(this).index('.single-box');
        $(this).siblings().find('.radio-box').removeClass('radio-choice');
        $(this).find('.radio-box').addClass('radio-choice');
        bp_lx = $(this).find('.radio-box').data('value');
    } else if ($(this).is('.radio-text')) { // 文字
        // var idx = $(this).index('.radio-text');
        if ($(this).prev().find('.radio-box').attr('disabled')) return;
        $('.radio-box').removeClass('radio-choice');
        $(this).prev().find('.radio-box').addClass('radio-choice');
        bp_lx = $(this).prev().find('.radio-box').data('value');
    }
    stockManager.data.dj.bp_lx = bp_lx;
    stockManager.extraDJData.bp_lx = bp_lx;
    stockManager.fsm();
});

// 跳转类型
$('body').on('click', '.list-type', function (e) {
    e.stopPropagation();
    if (!AUTH_EDIT || $(this).attr('disabled') || stockManager.data.dj.is_fh) return;
    var listType = $(this).data('list_type');
    var url = '';
    switch (listType) {
        case 'cg_ddlb': // 订单类别
            url = page_arr['select_list'];
            break;
    }
    fun.showPageFull({
        page_url: url,
        pageParam: {
            return_page: html_name,
            page_type: listType
        }
    });
})

stockManager.setButtonWidth = function () {
    var btnCount = $('.right2 button:visible').length;
    $('.right2 button:visible').removeClass('check-style');
    $('.choice').removeClass('choice-full-radius');
    $('.right2 button:visible').css('width', 'calc(100% / ' + btnCount + ')');

    var AUTH_EDIT = Auth.check(stockManager.authCheckName, 'edit');
    var AUTH_SETTLE = Auth.check(stockManager.authCheckName, 'settle');
    var AUTH_RECHECK = Auth.check(stockManager.authCheckName, 'recheck');

    if (!AUTH_SETTLE && !AUTH_RECHECK && AUTH_EDIT) {
        $('.saves').show();
        $('.choice').removeClass('choice-full-radius');
        btnCount = $('.right2 button:visible').length;
    }

    if (btnCount == 1) {

    } else if (btnCount == 2) {
        $('.right2 button:visible').eq(1).addClass('check-style');
    } else {
        $('.right2 button:visible').filter(function (index, dom) {
            return (!$(dom).hasClass('choice') && !$(dom).hasClass('saves'));
        }).hide();
    }
    btnCount = $('.right2 button:visible').length;
    if (btnCount === 1 && $('.right2 button:visible').hasClass('choice')) {
        $('.choice').addClass('choice-full-radius');
    }
    btnCount = ((btnCount >= 2) ? 2 : btnCount);
    $('.right2 button:visible').css('width', 'calc(100% / ' + btnCount + ')');
}