var html_name = page_arr.cg_cgdd_tj;


//默认开始显示数据
var to_month = fun.getLatelyTime(1,false);
var page_list = [], ztj_data = {};
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),

    jjcd_id: 0
};
//查询菜单缓存变量
var search_storage = {
    //之所以不用begin_time字段，是因为时间控件用的是begin_date字段
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

var USER_INFO = {};
// 系统设置
var SYS_CONFIG = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    // 系统设置
    SYS_CONFIG = fun.getItem('sys_config') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(html_name + '_' + 'hz') || '');
    var hn = html_name + '_';
    var hnt = hn + 'type' + '_';
    var hnh = hn + 'hz' + '_';

    // 页面加载，要先读取有记忆的搜索条件
    search_storage = $.extend(true, {
        'ycjd': fun.getItem(hn + 'ycjd', 1),
        'ycywc': fun.getItem(hn + 'ycywc', 0),
        'xscq': fun.getItem(hn + 'xscq', 0),
        'xsgg': fun.getItem(hn + 'xsgg', 0),
        'hldj': fun.getItem(hn + 'hldj', 0),
        'xsmx': fun.getItem(hn + 'xsmx', 1),
        'type': {
            'number': fun.getItem(hnt + 'number', 1),
            'horse': fun.getItem(hnt + 'horse', 0),
        },
        "hz": {
            "choose": {
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "dh": fun.getItem(hnh + 'dh', 0),
                "wldw": fun.getItem(hnh + 'wldw', 0),
                "cp": fun.getItem(hnh + 'cp', 0),
                "cp_ys": fun.getItem(hnh + 'cp_ys', 0),
            },
            "text": fun.getItem(hnh + 'text', ""),
        }
    }, search_storage);

    search_data = $.extend({}, search_data, search_storage);

    //初始页面默认请求的数据
    getList(search_data);
    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        console.log(ret)
        if (ret.value.status === 'refresh') {
            // $('#order_list').empty();
            // page_list = [];
            getList(search_data);
        } else if (ret.value.status === 'search') {
            var param = ret.value.data;

            //api请求参数
            search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
            search_data['begin_time'] = param.begin_date;                   //开始时间
            search_data['end_time'] = param.end_date;                       //结束时间
            search_data['wldw_id'] = param.gys['id'] || 0;                 //供应商
            search_data['cp_id'] = param.cp['id'] || 0;                    //产品
            search_data['cp_lb_id'] = param.cp_lb['id'] || 0;             //产品类别
            search_data['ck_id'] = param.ck['id'] || 0;                    //仓库
            search_data['md_id'] = param.md['id'] || 0;                    //门店
            search_data['ycjd'] = param['ycjd'];                //隐藏已结单记录
            search_data['ycywc'] = param['ycywc'];              //隐藏已发完记录
            search_data['xscq'] = param['xscq'];                //只显示超期产品
            search_data['kh_id'] = param.kh.id || 0;                        //客户id
            search_data['xsgg'] = param['xsgg'];                            //显示规格
            search_data['hldj'] = param['hldj'];                            //合拢单据
            search_data['xsmx'] = param['xsmx'];                            //显示明细数据
            search_data['dh'] = param['dh'] || '';                          // 订单单号

            search_data['jjcd_id'] = param.jjcd['id'];                   //紧急程度
            search_data['zt_id'] = param.zt['id'];                          //状态

            //缓存搜索菜单数据
            search_storage['keyword'] = param['LIKE_DATA'] || '';              //关键字
            search_storage['begin_date'] = param.begin_date;                   //开始时间
            search_storage['end_date'] = param.end_date;                       //结束时间
            search_storage['type'] = param['type'];                //数量
            search_storage['ycjd'] = param['ycjd'];                //隐藏已结单记录
            search_storage['ycywc'] = param['ycywc'];              //隐藏已发完记录
            search_storage['xscq'] = param['xscq'];                //只显示超期产品
            search_storage['gys'] = param.gys;
            search_storage['cp'] = param.cp;
            search_storage['cp_lb'] = param.cp_lb;
            search_storage['ck'] = param.ck;
            search_storage['md'] = param.md;
            search_storage['kh'] = param.kh;                     // 客户信息
            search_storage['xsgg'] = param['xsgg'];
            search_storage['hldj'] = param['hldj'];
            search_storage['xsmx'] = param['xsmx'];
            search_storage['dh'] = search_data['dh'];

            search_storage['jjcd'] = param.jjcd;                            //紧急程度
            search_storage['zt'] = param.zt;                                //状态

            //设置时间控件
            date_bar.setDate(search_storage);

            fun.setItem(hnt + 'number', search_storage['type']['number']);
            fun.setItem(hnt + 'horse', search_storage['type']['horse']);
            fun.setItem(hn + 'ycjd', search_storage['ycjd']);
            fun.setItem(hn + 'ycywc', search_storage['ycywc']);
            fun.setItem(hn + 'xscq', search_storage['xscq']);
            fun.setItem(hn + 'xsgg', param['xsgg']);
            fun.setItem(hn + 'hldj', param['hldj']);
            fun.setItem(hn + 'xsmx', param['xsmx']);

            // 汇总功能
            search_data['group'] = param.hz['group'] || '';
            search_storage['hz'] = param.hz;
            var hc = param['hz']['choose'];
            fun.setItem(hnh + 'md_mc', hc['md_mc']);
            fun.setItem(hnh + 'dh', hc['dh']);
            fun.setItem(hnh + 'wldw', hc['wldw']);
            fun.setItem(hnh + 'cp', hc['cp']);
            fun.setItem(hnh + 'cp_ys', hc['cp_ys']);
            fun.setItem(hnh + 'text', param.hz['text']);
            fun.setGroupCondition(search_data, 'jjdw_id,jjdw_mc,dw_id,dw_mc');

            // if (!!search_data['group']) {
            //     var group_data = search_data['group'];
            //     group_data += ',dw_id,dw_mc';
            //     search_data['group'] = group_data;
            // }

            fun.setItem(html_name + '_' + 'hz', search_data['group']);

            fun.setItem(html_name + 'sideslip', true);

            // $('#order_list').empty();
            // page_list = [];
            getList(search_data);
        } else {
            getList(search_data);
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            return fun.createBottomLine('order_list', ".list-wrap");
        }
    });
};

//页面头部
$('#header').header({
    back: true,
    add: Auth.check('bp_cgdd', 'edit'),
    filter: true,
    title: '采购订单',
});

// 采购订单-开单
$('body').on('tap', '#add_btn', function () {
    if (!fun.checkKz()) return;
    var djlx = 'bp_cgdd';
    const __route = [
        {
            url: page_arr.customer_search,
            page_data: {
                djlx: djlx,
                return_page: html_name,
                page_type: 'gys',
                wldw_tmp: {
                    return_page: html_name,
                    page_type: 'gys',
                    djlx: djlx,
                    getBillsPageDefInfo: AJAX_URL.getBillsPageDefInfo
                },
                NOT_OPEN_AGAIN: false,
                edit_row: false,
                loadScdj: true
            }
        },
        {
            url: page_arr.choice_product,
            page_data: {
                djlx: djlx,
                return_page: html_name,
                cp_tmp: {
                    return_page: html_name,
                }
            }
        },
        {
            url: page_arr.cg_cgdd_kd,
            page_data: {
                return_page: html_name,
            }
        }
    ];

    fun.showPageFull({
        page_url: __route[0].url,
        pageParam: $.extend({ __route: __route }, __route[0]['page_data'])
    })
});

function getHz(key, def) {
    def = def || 0;
    // key =  obj["cp_bh"] + '_' + obj["cp_mc"] + '_' + obj["cp_ys_bh"] + '_' + obj["cp_ys_mc"];
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'],
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "dh_wrap": {
            "key": "dh",
            "value": search_storage['dh'] || "",
            "placeholder": "订单单号"
        },
        "choose_merchants": [
            {
                key: "gys",
                "text": "供应商",
                "value": getTwo('gys', 'text'),
                "id": getTwo('gys', 'id'),
                "disabled": !Auth.check('gdckxskgjje', 'view')
            }, {
                key: "cp",
                "text": "产品",
                "value": getTwo('cp', 'text'),
                "id": getTwo('cp', 'id'),
            }, {
                key: "cp_lb",
                "text": "产品类别",
                "value": getTwo('cp_lb', 'text'),
                "id": getTwo('cp_lb', 'id'),
            }, {
                key: "ck",
                "text": "仓库",
                "value": getTwo('ck', 'text'),
                "id": getTwo('ck', 'id'),
            }, {
                key: "md",
                "text": "门店",
                "value": getTwo('md', 'text'),
                "id": getTwo('md', 'id'),
            },
            {
                key: "kh",
                "text": "客户",
                "value": getTwo('kh', 'text'),
                "id": getTwo('kh', 'id')
            },
            {
                key: "zt",
                text: "状态",
                value: getTwo('zt', 'text'),
                id: getTwo('zt', 'id'),
                loadData: true,
                loadDataType: 'xsdd',
                list: []
            },
            {
                key: "jjcd",
                text: "紧急",
                value: getTwo('jjcd', 'text'),
                id: getTwo('jjcd', 'id'),
                loadData: true,
                list: []
            },
            {
                key: "hz",
                "text": "汇总",
                //供应商、单号、门店、产品、颜色
                "group": [
                    // {key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc')},
                    {
                        key: 'dh',
                        name: '单号',
                        columns: 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc',
                        choose: getHz('dh')
                    },
                    { key: 'wldw', name: '供应商', columns: 'wldw_id,wldw_mc', choose: getHz('wldw') },
                    { key: 'cp', name: '产品', columns: 'cp_bh,cp_mc', choose: getHz('cp') },
                    { key: 'cp_ys', name: '颜色', columns: 'cp_ys_bh,cp_ys_mc', choose: getHz('cp_ys') },
                ],
                "value": getTwo('hz', 'text'),
            }
        ],
        'type': [
            {
                key: "number",
                "text": "数量",
                "value": getTwo('type', 'number'),
            }, {
                key: "horse",
                "text": "匹数",
                "value": getTwo('type', 'horse'),
            }
        ],

        "switch": [
            {
                "text": "隐藏已结单记录",
                "max_width": true,
                "key": "ycjd",
                "value": search_storage['ycjd']
            }, {
                "text": "隐藏已来完记录",
                "max_width": true,
                "key": "ycywc",
                "value": search_storage['ycywc']
            }, {
                "text": "只显示超期产品",
                "max_width": true,
                "key": "xscq",
                "value": search_storage['xscq']
            },
            { "text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_storage['xsmx'] },
            { "text": "合拢单据", "max_width": true, "key": "hldj", "value": search_storage['hldj'] },
            { "text": "显示规格", "max_width": true, "key": "xsgg", "value": search_storage['xsgg'] }
        ],
    };
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false)
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
})

//时间控件
var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            // $('#order_list').empty();
            getList(search_data);
        }
    });


/** 生成 剩/超 天 字符串
 * @param {*} hqts 货期天数
 */
function hqtsStr(hqts) {
    if (hqts < 0)
        return "超" + Math.abs(hqts) + "天";
    else if ((hqts > 0)) {
        return "剩" + hqts + "天";
    }
    return "";
}

/** 数量和匹数转换
 * @param {*} isNumber 是否选择数量
 * @param {*} res 数据源
 */
function numberHorse(isNumber, res) {
    if (isNumber) {
        return {
            title: {
                "0": "订单",
                "1": "来货",
                "2": "未来",
            },
            value: {
                "0": $.nui.decimalAdd(Number(res['zsl']), Number(res['cxsl'])) || "",
                "1": res['lhsl'] || "",
                "2": res['wlsl'] || "",
            }
        }
    }

    var ps = $.nui.decimalAdd(Number(res['ps']), Number(res['cxps']));
    if (ps) {
        ps = ps + '匹';
    }

    return {
        title: {
            "0": "订货",
            "1": "来货",
            "2": "未来",
        },
        value: {
            "0": ps,
            "1": res['lhps'] || "",
            "2": res['wlps'] || "",
        }
    }
}

// showList(order_data);

function showList(data) {
    //合计显示
    var hj_type = search_storage['type'];
    $.each(hj_type, function (key, val) {
        if (!!val) {
            if (key == 'number') {//类型 = 数量
                $('#hj1').text(($.nui.decimalAdd(Number(ztj_data['zsl']), Number(ztj_data['cxsl']))) || 0);
                $('#hj2').text(ztj_data['lhsl'] || 0);
                $('#hj3').text(ztj_data['wlsl'] || 0);
            } else {//类型 = 匹数
                $('#hj1').text(($.nui.decimalAdd(Number(ztj_data['ps']), Number(ztj_data['cxps']))) || 0);
                $('#hj2').text(ztj_data['lhps'] || 0);
                $('#hj3').text(ztj_data['wlps'] || 0);
            }
        }
    });
    // var i;
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !search_storage.hldj,
        isNoExpand: search_storage.xsmx,
        render: {
            titlebar: function (res) {
                // var kzxx = JSON.parse(SYS_CONFIG.kzxx) || {};
                // var ddfh = kzxx.ddfh || {};

                var is_ddfh = fun.getKzValue('ddfh', 'bp_cgdd'); // 订单复核

                return statistics.order.createTitlebar(res, {
                    group: search_data.group,
                    other_condition: (is_ddfh || 0) && !res.is_fh,
                    // type: res.bp_lx_mc || ''
                    dd_lb_fh: $.nui.isTrue(res.dd_lb_fh),
                    type: res.dd_lb_mc
                });
            },
            subtitle: function (res) {
                return statistics.order.createSubtitle(res, {
                    group: search_data.group,
                    search_data: search_data,
                    showIcon: true,
                });
            },
            subdata: function (res) {
                var isSelectNum = search_storage['type']['number'] ? search_storage['type']['number'] : 0;
                var numberHorseVal = numberHorse(isSelectNum, res);

                return statistics.order.createSubdata(res, {
                    group: search_data.group,
                    search_storage: search_storage,
                    title: numberHorseVal.title,
                    value: numberHorseVal.value,
                    isSelectNum: isSelectNum,
                    renderJdHtml: true,
                    // onlyShowJjcd: true
                });
            }
        }
    }
    );
}

/** 获取发退货结算数据
 * @param {*} data
 */
function getList(data) {
    page_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL['getBpCgddtj'],
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#hj1').text(0);
                    $('#hj2').text(0);
                    $('#hj3').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: '#order_list', btnText: '新增采购订单', auth: 'bp_cgdd' });
                }
                ztj_data = res['info'] || {};
                fun.clearPage($('#order_list'));
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createKeysValueFun: function (obj) {
                        return {
                            "dh": obj['dh'],
                            "kdsj": obj['kdsj'],
                            "zdr_mc": obj['zdr_mc'],
                            "wldw_mc": obj['wldw_mc'],
                            "md_mc": obj['md_mc'],
                            "md_id": obj['md_id'],
                            "dj_jd": obj["dj_jd"],
                            "dd_lb_fh": obj["dd_lb_fh"],
                            // 状态
                            "is_fh": obj["is_fh"],
                            "is_jd": obj["is_jd"],
                            "bp_lx_mc": obj["bp_lx_mc"],
                            "dj_ps": fun.is_value(obj['dj_ps'], 0),
                            "dj_zsl": fun.is_value(obj['dj_zsl'], 0),
                            "dj_je": fun.is_value(obj['dj_je'], 0),
                            "zdw_mc_tmp": fun.is_value(obj['zjjdw_mc']),  // 总计价单位名称
                            "djlx": obj["djlx"],

                            "dd_lb_mc": obj['dd_lb_mc'],
                            "dd_lb_fh": obj["dd_lb_fh"]
                        };
                    }
                });

                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        },
    })
}

// 详情点击
fun.tjContentTap(function (data_list) {
    if (!fun.checkKz()) {
        return;
    }

    var id = data_list.dj_id;
    if ($.nui.isEmpty(id)) {
        return;
    }

    var dh = data_list.dh,
        wldw_id = data_list.wldw_id,
        wldw_mc = data_list.wldw_mc,
        kdsj = data_list.kdsj,
        zdr = data_list.zdr_mc;

    fun.showPageFull({
        page_url: page_arr.cg_cgdd_kd,
        pageParam: {
            return_page: html_name,
            id: id,
            dh: dh,
            wldw_id: wldw_id,
            wldw_mc: wldw_mc,
            kdsj: kdsj,
            zdr: zdr
        }
    });
});


$('body').on('click', '.row-list', function () {
    if (fun.getItem(html_name + '_xsmx', 1)) return;
    if (!fun.checkKz()) {
        return;
    }
    var data_list = $(this).children('.summary').children('.summary-content').data('list') || {};
    if ($.nui.isEmpty(data_list.dj_id)) {
        return;
    }
    var dh = data_list.dh,
        wldw_id = data_list.wldw_id,
        wldw_mc = data_list.wldw_mc,
        kdsj = data_list.kdsj,
        zdr = data_list.zdr_mc;

    fun.showPageFull({
        page_url: page_arr.cg_cgdd_kd,
        pageParam: {
            return_page: html_name,
            id: data_list.dj_id,
            dh: dh,
            wldw_id: wldw_id,
            wldw_mc: wldw_mc,
            kdsj: kdsj,
            zdr: zdr
        }
    });
})
//
$('body').on('tap', '.particulars', function (e) {
    e.stopPropagation();

    var $row = $(this).closest('.summary-title').next('.summary-content') || {};
    var index = Number($row.data('index'));
    var indent_data = fun.apiData[index];
    fun.showPageFull({
        page_url: NEW_BILLS ? page_arr.bills_cgddxq : page_arr.cg_cgdd_xqy,//
        pageParam: {
            return_page: html_name,
            data: indent_data,
            search_type: search_data.type,
            // edit: true,
            initType: 'view',
            djlx: 'bp_cgdd'
        }
    })
    // popup(e, $row);
});