var html_name = page_arr.cg_dykhdd;
var date_arr = fun.getMonthArr(6),
    to_month = fun.getMonthArr(1)[0];

var page_list = [];
var total_data = {};

var Bills = Bills || {};
var hjText = {};

var USER_INFO = {};
var SYS_CONFIG = {};
var wldw_kh_list = [], wldw_gys_list = [];

var __PAGE_PARAM = {}, __JL_DATA, __DJ_DATA;
var begin_date = fun.Date(to_month['begin_date']).Format('yy.mm.dd');
var end_date = fun.Date(to_month['end_date']).Format('yy.mm.dd');

var fieldConfig = {};

$('#date_range').text(begin_date + ' ~ ' + end_date);

var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    "ycjd": 0,
    "ycywc": 0,
    "xscq": 0,
    "is_dy_cgdd_type": "cp",
    "is_mobile": 1
};

var search_storage = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd')
};

var headerTitle = '未采购的';
var selData = [];

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    SYS_CONFIG = fun.getItem('sys_config') || {};
    __PAGE_PARAM = page_data;
    __JL_DATA = page_data.__JL_DATA || [];
    __DJ_DATA = page_data.__DJ_DATA || {};

    Bills.djlx = page_data.djlx;
    if (page_data.loadScdj) {
        Bills.AJAX_URL = {getDj: page_data.getDjUrl};
    }

    fun.load_DATA_LIST(['cp']);

    fun.load_DATA_LIST(['wldw_kh', 'wldw_gys', 'jjdw'], function () {
        wldw_kh_list = fun.getItem('wldw_kh_list') || [];
        wldw_gys_list = fun.getItem('wldw_gys_list') || [];
    });

    console.log('__PAGE_PARAM', __PAGE_PARAM);

    __PAGE_PARAM['is_dy_cgdd_type'] = __PAGE_PARAM['is_dy_cgdd_type'] || 'cp';

    if (__PAGE_PARAM['is_dy_cgdd_type'] === 'cp') {
        headerTitle += '成品';
        fieldConfig = {
            // 'fhps_name': 'fhps',
            // 'fhps_display': '发货',
            // 'wfps_name': 'wfps',
            // 'wfps_display': '未发',
            // 'fhsl_name': 'fhsl',
            // 'fhsl_display': '发货',
            // 'wfsl_name': 'wfsl',
            // 'wfsl_display': '未发'
            wcgps: 'cpcg_wcgps',
            wcgsl: 'cpcg_wcgsl',
        };
    } else {
        headerTitle += '坯布';
        fieldConfig = {
            // 'fhps_name': 'fhps',
            // 'fhps_display': '发货',
            // 'wfps_name': 'wfps',
            // 'wfps_display': '未发',
            // 'fhsl_name': 'fhsl',
            // 'fhsl_display': '发货',
            // 'wfsl_name': 'wfsl',
            // 'wfsl_display': '未发'
            wcgps: 'pbcg_wcgps',
            wcgsl: 'pbcg_wcgsl',
        };

        search_data['is_pp'] = true;

    }

    $('#header').header({
        back: true,
        filter: true,
        title: headerTitle
    });
    var hn = html_name + '_';
    // 页面加载，要先读取有记忆的搜索条件
    search_storage = $.extend(true, {
        // 'ycjd': fun.getItem(hn + 'ycjd', 1)
        'is_pp': fun.getItem(hn + 'is_pp', 1),
        'xsjd': fun.getItem(hn + 'xsjd', 1)
    }, search_storage);

    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');

    search_data['wldw_id'] = __PAGE_PARAM['wldw_id'] || 0;
    search_data['is_dy'] = 1;
    search_data['gxlx_id'] = (__PAGE_PARAM['gxlx_id'] || 0);
    search_data['is_dy_djlx'] = __PAGE_PARAM['djlx'] || 'bp_cgdd';
    search_data['jl_id_notin'] = __PAGE_PARAM['jl_id_notin'] || [];
    search_data['is_dy_cgdd_type'] = __PAGE_PARAM['is_dy_cgdd_type'] || 'cp';
    // search_data['ycjd'] = search_storage['ycjd'] || 0;
    search_data['xsjd'] = search_storage['xsjd'] || 0;

    search_data = $.extend({}, search_data, search_storage);

    getList(search_data);

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var param = ret.value.data;
        search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
        search_data['begin_time'] = param.begin_date;                   //开始时间
        search_data['end_time'] = param.end_date;                       //结束时间
        search_data['wldw_id'] = param.kh['id'] || 0;                 //客户
        search_data['cp_id'] = param.cp['id'] || 0;                    //产品
        search_data['cp_lb_id'] = param.cp_lb['id'] || 0;             //产品类别
        search_data['md_id'] = param.md['id'] || 0;                    //门店
        // search_data['ycjd'] = param['ycjd'];                //隐藏已结单记录
        search_data['xsjd'] = param['xsjd'];                //隐藏已结单记录

        search_storage['keyword'] = param['LIKE_DATA'] || '';
        search_storage['begin_time'] = param.begin_date;                   //开始时间
        search_storage['end_time'] = param.end_date;                       //结束时间
        // search_storage['ycjd'] = param['ycjd'];                //隐藏已结单记录
        search_storage['xsjd'] = param['xsjd'];                //隐藏已结单记录

        search_storage['kh'] = param.kh;
        search_storage['cp'] = param.cp;
        search_storage['cp_lb'] = param.cp_lb;
        search_storage['md'] = param.md;

        if (__PAGE_PARAM['is_dy_cgdd_type'] == 'pb') {
            search_data['is_pp'] = param.is_pp;
            search_storage['is_pp'] = search_data['is_pp'];
        }

        $('#date_range').text(fun.Date(param.begin_date).Format('yy.mm.dd') + ' ~ ' + fun.Date(param.end_date).Format('yy.mm.dd'));

        //缓存按钮开关
        // fun.setItem(hn + 'ycjd', param['ycjd']);
        fun.setItem(hn + 'xsjd', param['xsjd']);
        fun.setItem(hn + 'is_pp', param['is_pp']);

        fun.setItem(html_name + 'sideslip', true);

        $('#order_list').empty();
        getList(search_data);
    });

};

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

function convertData(apidata) {
    if ($.nui.isEmpty(apidata)) return [];
    if ((!(apidata instanceof Array))) {
        return "参数错误";
    }
    var list = [], tmp = {};
    $(apidata).each(function (i, obj) {
        if (!tmp[obj["dh"]]) {
            tmp[obj["dh"]] = {
                "dh": obj['dh'],
                "kdsj": obj['kdsj'],
                "zdr_mc": obj['zdr_mc'],
                "wldw_mc": obj['wldw_mc'],
                "md_mc": obj['md_mc'],
                "zdw_mc":obj['zdw_mc'],
                "dj_cpcg_wcgps": obj['dj_cpcg_wcgps'],
                "dj_cpcg_wcgsl": obj['dj_cpcg_wcgsl'],
                "dj_pbcg_wcgps": obj['dj_pbcg_wcgps'],
                "dj_pbcg_wcgsl": obj['dj_pbcg_wcgsl'],
                "fzxx_wldw_mc": obj['fzxx_wldw_mc']
            };
            tmp[obj["dh"]]['list'] = [];
        }
        tmp[obj["dh"]]['list'].push(obj);
    });
    for (var i in tmp) {
        list.push(tmp[i]);
    }

    return list;
}

function getList(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpXsddtj,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#zps').text(0);
                    $('#zsl').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                total_data = res['info'];
                page_list = convertData(res.data);
                showList(page_list);
            } else {
                fun.alert({msg: '网络异常！'});
            }
        }
    })
}

function showList(data) {
    var t_ps = 0, t_sl = 0;

    t_ps = total_data[0][fieldConfig['wcgps']] || 0;
    t_sl = total_data[0][fieldConfig['wcgsl']] || 0;

    $('#zps').text(t_ps);
    $('#zsl').text(t_sl);

    $('#order_list').OrderList({
        data: data,
        bindevent: false,
        render: {
            titlebar: function (res) {
                var style = [];
                style.push('<div class="title-bar-row">');
                style.push('    <span class="check-box"><i class="iconfont icon-check"></i></span>');
                style.push('    <div><span  class="font-bold font-ls">&nbsp;' + fun.is_value(res['wldw_mc']) + '</span></div>');
                style.push('    <div class="align-right time-option" ><a>' + fun.is_value(res['md_mc']) + '</a>');
                style.push('<span class="font-ss"><a>'+fun.formatTime(res['kdsj'])+'</a></span>');
                style.push('&nbsp;<span class="font-ss"><a>' + fun.is_value(res['zdr_mc']) + '</a></span></div>');
                style.push('</div>');

                style.push('<div class="title-bar-row">');
                style.push('<div style="width: 55%;"><span class="color-gray">未采购&nbsp;</span>');
                style.push('<span>'+fun.is_value(res['dj_'+fieldConfig['wcgps']],0)+'匹&nbsp;</span>');
                style.push('<span>'+fun.is_value(res['dj_'+fieldConfig['wcgsl']],0)+fun.is_value(res['zdw_mc'])+'</span></div>');
                style.push('<div style="width: 40%;" class="align-right number font-ss fixed-right" ><a>' + fun.is_value(res['dh']) + '</a></div>');
                style.push('</div>');
                style.push('<div class="title-bar-row">');
                style.push((__PAGE_PARAM['is_dy_cgdd_type'] == 'cp' && $.nui.isTrue(res['fzxx_wldw_mc'])) ? '     <div><span class="color-gray">供应商 </span><span>' + fun.is_value(res['fzxx_wldw_mc']) + '</span></div>' : '');
                style.push('</div>');
                return style.join('');
            },
            subtitle: function (res) {
                var title_html = [],
                fkkz = fun.is_value(res['fk']) + (res['fk'] && res['kz'] ? "×" : "") + fun.is_value(res['kz']);
                title_html.push('<div class="row" data-list_data=\'' + fun.formatString(JSON.stringify(res)) + '\'>');
                title_html.push('<div>');
                title_html.push('<span class="check-box checkbox-option"><i class="iconfont icon-check"></i></span>');
                title_html.push('<span class="row-select">' + fun.is_value(res['cp_bh']) + ' ' + fun.is_value(res['cp_mc']) +'&nbsp;'+ fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc'])+'</span></div>');
                title_html.push('</div>');
                // title_html.push('<div class="row">');
                // title_html.push('     <div>' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</div>');
                // title_html.push((__PAGE_PARAM['is_dy_cgdd_type'] == 'cp' && $.nui.isTrue(res['fzxx_wldw_mc'])) ? '     <div>供应商 ' + fun.is_value(res['fzxx_wldw_mc']) + '</div>' : '<div></div>');
                // if (!!res['fk'] || !!res['kz']) {
                //     title_html.push('     <div class="align-right"><a>幅\\克</a>' + fkkz + '</div>');
                // }
                // title_html.push('</div>');
                return title_html.join('');
            },
            subdata: function (res) {
                var s_ps = 0, s_sl = 0;
                switch (__PAGE_PARAM['is_dy_cgdd_type']) {
                    case 'cp':
                        s_ps = res['cpcg_wcgps'] || 0;
                        s_sl = res['cpcg_wcgsl'] || 0;
                        break;
                    case 'pb':
                        s_ps = res['pbcg_wcgps'] || 0;
                        s_sl = res['pbcg_wcgsl'] || 0;
                        break;
                }

                var valObj = {
                    ps: ($.nui.decimalAdd(Number(res['ps']), Number(res['cxps']))) || 0,
                    zsl: ($.nui.decimalAdd(Number(res['zsl']), Number(res['cxsl']))) || 0
                };

                return [
                    '<div class="row row-option bg-gray top-margin">',
                    '    <div><span class="color-gray padd-left">订单匹</span><span>' + (res['ps'] || 0) + '</span></div>',
                    '    <div><span class="color-gray">未采购匹</span><span>' + (s_ps || 0) + '</span></div>',
                    '</div>',
                    '<div class="row row-option bg-gray border-radius">',
                    '    <div><span class="color-gray padd-left">订单数</span><span>' + (res['zsl'] || 0) + '</span></div>',
                    '    <div><span class="color-gray">未采购数</span><span>' + (s_sl || 0) + '</span></div>',
                    '</div>',
                ].join('');
            }
        },
    });

    $('.title-bar').off('tap');

    $('.check-box').removeClass('check-choice');
    setSelCount();
}

fun.setItem(html_name+'sideslip', true);
//打开搜索页
$('body').off('tap').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name+'sideslip');
    var disabled = $.nui.isTrue(__PAGE_PARAM['wldw_id']);

    var switchArr = [];

    if (__PAGE_PARAM['is_dy_cgdd_type'] == 'pb') {
        switchArr.push({"text": "自动匹配坯布", "max_width": true, "key": "is_pp", "value": search_storage['is_pp']});
    }

    switchArr.push({
        "text": "显示结单记录",
        "max_width": true,
        "key": "xsjd",
        "value": search_storage['xsjd']
    });

    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'],
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage['begin_time'],
            "end_date": search_storage['end_time']
        },
        "choose_merchants": [
            {
                key: "kh",
                "text": "客户",
                "value": fun.getValByKey(wldw_kh_list || [], __PAGE_PARAM['wldw_id'], 'merchant_name') || getTwo('kh', 'text'),
                "id": __PAGE_PARAM['wldw_id'] || getTwo('kh', 'id'),
                // "disabled": disabled
            },
            {
                key: "gys",
                "text": "供应商",
                "value": fun.getValByKey(wldw_gys_list || [], __PAGE_PARAM['wldw_gys_id'], 'merchant_name') || getTwo('gys', 'text'),
                "id": __PAGE_PARAM['wldw_gys_id'] || getTwo('gys', 'id'),
            },
            {
                key: "cp",
                "text": "产品",
                "value": getTwo('cp', 'text'),
                "id": getTwo('cp', 'id'),
            },
            {
                key: "cp_lb",
                "text": "产品类别",
                "value": getTwo('cp_lb', 'text'),
                "id": getTwo('cp_lb', 'id'),
            },
            {
                key: "md",
                "text": "门店",
                "value": getTwo('md', 'text'),
                "id": getTwo('md', 'id'),
            },
        ],
        "switch": switchArr
    };
    if (sideslip) {
        fun.setItem(html_name+'sideslip', false)
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});


$('body').on('tap', '.check-box', function (e) {
    e.stopPropagation();
    if ($(this).hasClass('check-choice')) {
        $(this).removeClass('check-choice');
    } else {
        $(this).addClass('check-choice');
    }
});


$('body').on('tap', '#selAll', function (e) {
    if ($(this).hasClass('check-choice')) {
        $('.check-box').addClass('check-choice');
    } else {
        $('.check-box').removeClass('check-choice');
    }
    setSelCount();
});

$('body').on('tap', '.title-bar .check-box', function (e) {
    e.stopPropagation();
    if ($(this).hasClass('check-choice')) {
        $(this).closest('li').find('.summary-title .check-box').addClass('check-choice');
    } else {
        $(this).closest('li').find('.summary-title .check-box').removeClass('check-choice');
    }
    setSelCount();

    setSelAllState();
});


$('body').on('tap', '.summary-title .check-box', function (e) {
    e.stopPropagation();
    var $closeLi = $(this).closest('li');
    var totalCount = $closeLi.find('.summary-title .check-box').length;
    var selCount = $closeLi.find('.summary-title .check-box.check-choice').length;

    if (totalCount == selCount) {
        $closeLi.find('.title-bar .check-box').addClass('check-choice');
    } else {
        $closeLi.find('.title-bar .check-box').removeClass('check-choice');
    }
    setSelCount();

    setSelAllState();
});

$('body').on('tap', '.title-bar', function (e) {
    e.stopPropagation();
    var cb = $(this).find('.check-box');
    if (cb.hasClass('check-choice')) {
        cb.removeClass('check-choice');
        $(this).closest('li').find('.summary-title .check-box').removeClass('check-choice');
    } else {
        cb.addClass('check-choice');
        $(this).closest('li').find('.summary-title .check-box').addClass('check-choice');
    }
    setSelCount();
    setSelAllState();
});

$('body').on('tap', '.summary-title', function (e) {
    e.stopPropagation();

    var cb = $(this).find('.check-box');
    if (cb.hasClass('check-choice')) {
        cb.removeClass('check-choice');
    } else {
        cb.addClass('check-choice');
    }

    var $closeLi = $(this).closest('li');
    var totalCount = $closeLi.find('.summary-title .check-box').length;
    var selCount = $closeLi.find('.summary-title .check-box.check-choice').length;

    if (totalCount == selCount) {
        $closeLi.find('.title-bar .check-box').addClass('check-choice');
    } else {
        $closeLi.find('.title-bar .check-box').removeClass('check-choice');
    }

    setSelCount();
    setSelAllState();
});


function setSelAllState() {
    var titleBox = $('.title-bar .check-box').length;
    var titleSelBox = $('.title-bar .check-box.check-choice').length;

    if (titleBox == titleSelBox) {
        $('#selAll').addClass('check-choice');
    } else {
        $('#selAll').removeClass('check-choice');
    }
}


function setSelCount() {
    selData = getSelectedData();

    var count = 0;
    for (var i = 0; i < selData.length; i++) {
        var val = selData[i];

        count += Number(val[fieldConfig['wcgps']]) || 0;

        // switch (__PAGE_PARAM['is_dy_cgdd_type']) {
        //     case 'cp':
        //         count += Number(val['cpcg_wcgps']) || 0;
        //         break;
        //     case 'pb':
        //         count += Number(val['pbcg_wcgps']) || 0;
        //         break;
        // }
    }
    $('#sel_ps').text(count);
}


function getSelectedData() {
    var data = [];
    for (var i = 0; i < $('.summary-title .check-box').length; i++) {
        var $ele = $('.summary-title .check-box').eq(i);
        var $row = $ele.closest('.row');

        if ($ele.hasClass('check-choice')) {
            data.push($row.data('list_data'));
        }
    }
    return data;
}

function closePage() {
    api.sendEvent({
        name: __PAGE_PARAM['return_page'],
        extra: {
            'status': 'dykhdd',//调用客户订单
            'data': {}
        }
    });

    setTimeout(function () {
        api.closeWin();
    }, 200);
}

// 调用逻辑处理
$('body').on('tap', '#save', function (e) {
    e.stopPropagation();
    var sendData = [];

    var selData = callByBpcg();

    if ($.nui.isEmpty(selData)) return;

    if (__PAGE_PARAM['is_dy_cgdd_type'] === 'pb') {

        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.getCpInfoByPb,
            data: {data: selData, is_pp: search_data['is_pp']},
            success: function (res) {
                switch (res['status']) {
                    case 0:
                        selData = callByBpcg({type: 'pb', data: res['data']});
                        if ($.nui.isEmpty(selData)) return;
                        call();
                        break;
                    default:
                        fun.toast(res['msg']);
                        break;
                }
            }
        })

        //     Fun.ajax({
        //         url: AJAX_URL.getCpInfoByPb,
        //         data: {data: selData, is_pp: $("#zdpppb").is(':checked')},
        //         success: function (res) {
        //             switch (res['status']) {
        //                 case 0:
        //                     GridOnDBClickRowByCgdd(res['data'], msg, __data);
        //                     if ($.nui.isTrue(msg['status'])) {
        //                         Fun.dialog({
        //                             content:'<div style="margin-top: 15px;text-align:left;">' +
        //                                 '<div style="text-align:center;">请调用相同仓库的记录：</div>' +
        //                                 '<div style="margin-left:25px;">开单仓库：【'+msg['kd_ck_mc']+'】<br>调用库存：【'+msg["dy_ck_mc"]+'】</div></div>',
        //                             btn:['确定'],
        //                             callback: function () {
        //                                 call();
        //                             }
        //                         });
        //                     } else if ($.nui.isTrue(msg['msg'])) {
        //                         Fun.alert({msg: msg['msg'], width: '300px', callback: call});
        //                     } else call();
        //                     break;
        //                 default :
        //                     Fun.alert(res['msg']);
        //                     break;
        //
        //             }
        //         }
        //     });


    } else {
        call();
    }


    function call() {

        // 数据格式化
        for (var i = 0; i < selData.length; i++) {
            var item = selData[i];

            var pushData = {
                yy_djlx: item['yy_djlx'],
                "is_dy": 1,
                "qtyq": item.other_info.qtyq,
                "fzmc": item.fzmc,
                "fzbh": item.fzbh,
                "ck_id": item.ck_id,
                "ck_zdy1": item.ck_zdy1,
                "ck_zdy2": item.ck_zdy2,
                "ck_zdy3": item.ck_zdy3,
                "ck_zdy4": item.ck_zdy4,
                "ck_zdy5": item.ck_zdy5,

                "dj": 0,
                "hsdj": 0,
                "je": 0,
                "zydj": 0,
                "hsje": 0,
                "hszje": 0,
                "shuie": 0,
                "zje": 0,
                "cp_bh": item.cp_bh,
                "cp_id": item.cp_id,
                "cp_mc": item.cp_mc,
                "dw_id": item.dw_id,
                "dw_mc": item.dw_mc,
                "fk": item.fk,
                "kz": item.kz,
                "gg": item.gg,
                "gh": item.gh,
                "jh": item.jh,
                "ph": item.ph,


                "kd_zdy1": item.kd_zdy1,
                "kd_zdy2": item.kd_zdy2,
                "kd_zdy3": item.kd_zdy3,
                "kd_zdy4": item.kd_zdy4,
                "kd_zdy5": item.kd_zdy5,

                "kh_id": item.kh_id,
                "kh_mc": item.kh_mc,
                "kh_dd_dh": item.kh_dd_dh,
                "kh_dd_kdsj": item.kh_dd_kdsj,
                "kh_dd_dj_id": item.kh_dd_dj_id,
                "kh_dd_jl_id": item.kh_dd_jl_id,

                
                "cp_ys_id": item.cp_ys_id,
                "cp_ys_bh": item.cp_ys_bh,
                "cp_ys_mc": item.cp_ys_mc,
                "fzsh": item.fzsh,
                "fzys": item.fzys,
                
                "fy_zdy1": item.fy_zdy1,
                "fy_zdy2": item.fy_zdy2,
                "fy_zdy3": item.fy_zdy3,
                "fy_zdy4": item.fy_zdy4,
                "fy_zdy5": item.fy_zdy5,

                "cf": item.cf,
                "kcms": '+',
                "jjdw_id": 0,//item.jjdw_id,
                "jjdw_mc": '',//item.jjdw_mc,
                "jjsl": item.jjsl,
                "zsl2": item.zsl2,
                "scdj": item.scdj,
                "ps": item.ps,
                "is_delete": 0,
                "mx": [],
                "zsl": item.zsl,
                "bz": item.jl_bz
            };

            var cp_list = fun.getItem('cp_list') || [];
            var wldw_list = fun.getItem('wldw_gys_list') || [];
            var jjdw_list = fun.getItem('jjdw_list') || [];
            var wldw_type = 'gys';

            // 根据 往来单位类型, 赋值 档案 预设的 计价单位
            var unit_options = fun.getValByKey(cp_list, pushData['cp_id'], 'unit_options');

            wldw_type = fun.getValByKey(wldw_list, __PAGE_PARAM['wldw_gys_id'] || 0, 'type') || 'gys';

            switch (wldw_type) {
                case 'kh':
                    pushData['jjdw_id'] = unit_options['xsdw_id'];
                    break;
                case 'gys':
                    pushData['jjdw_id'] = unit_options['cgdw_id'];
                    break;
                case 'jgs':
                    pushData['jjdw_id'] = unit_options['jgdw_id'];
                    break;
            }

            pushData['jjdw_mc'] = fun.getValByKey(jjdw_list || [], pushData['jjdw_id'], 'name');

            if ($.nui.isEmpty(pushData['jjdw_id'])) {
                pushData['jjdw_id'] = pushData['dw_id'] || 0;
                pushData['jjdw_mc'] = pushData['dw_mc'] || '';
            }

            updateRowDataAmountAndMoney(null, pushData);

            sendData.push(pushData);
        }

        // 具体供应商信息
        if (page_data.loadScdj) {
            __getDjInfo = function () {
                return {
                    wldw_id: __DJ_DATA.wldw_id || '',
                    kdsj: __DJ_DATA.kdsj || fun.formatDate(new Date())
                };
            };

            __getJlData = function () {
                return sendData;
            };

            __updateJlDataByIndex = function (item) {
                var list_item = sendData[item.index];
                list_item.scdj = item.data.scdj;
                list_item.hsdj = list_item.dj = item.data.dj;
                list_item.hszje = fun.sswr(list_item.hsdj * list_item.jjsl);
            };

            __getAllDj({
                get_dj: true,
                get_scdj: true,
                update_all: true,
                callback: function () {
                    dykhddFinish(sendData, {});
                }
            })
        } else {
            dykhddFinish(sendData, {});
        }
    }

});

function dykhddFinish(sendData, wldw) {
    __JL_DATA = __JL_DATA.concat(sendData);
    if ($.nui.isTrue(page_data['__route'])) {   // 新增时调用，打开新页面
        var opt = {html_name: html_name, page_data: page_data};
        page_data.data = {
            list: __JL_DATA,
            wldw: wldw,
            jl_list: getSelectedData()
        };
        opt['page_data']['LIST_PAGE'] = page_data['LIST_PAGE'];
        PageShow.gotoNextPage(opt);
    } else {                                    // 编辑时调用，发送事件
        var eventStatus = 'update_rows';
        if (page_data.djlx === 'bp_cgdd') {
            eventStatus = 'cg_dykhdd';
        }
        api.sendEvent({
            name: __PAGE_PARAM['goto_page'],
            extra: {
                'status': eventStatus,// 调用客户订单
                'data': {
                    __JL_DATA: __JL_DATA,
                    wldw: wldw
                }
            }
        });

        setTimeout(function () {
            api.closeToWin({name: __PAGE_PARAM.goto_page});
        }, 200);
    }
}

//采购调用客户订单
function callByBpcg(options) {
    var _options = $.extend({type: null, data: []}, options);
    var selData = [];

    if (!!_options['type']) {
        selData = _options['data'];
    } else {
        selData = getSelectedData();
    }

    if ($.nui.isEmpty(selData)) return []; //无选择记录则不执行任何操作

    var __data = {list: [], wldw_id: 0, ck_id: 0, fp_id: 0, hy_id: 0};

    var msg = '';
    var dj_id = 0;
    for (var i = 0; i < selData.length; i++) {
        // if (i !== 0) {
        //     if ($.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']])) {
        //         if (__data['ck_id'] !== selData[i]['ck_id']) {
        //             msg['msg'] = '你所选记录有多个不同的仓库，<br/><br/>调用过去【仓库】不会自动赋值。';
        //             __data['ck_id'] = undefined;
        //         }
        //     }
        // }
        //
        // if ($.nui.isEmpty(SYS_CONFIG['dckms_bp']) &&
        //     $.nui.isTrue(__params['ck_id']) && __params['ck_id'] !== selData[i]['ck_id']) {
        //     msg['status'] = 1;
        //     msg['kd_ck_mc'] = __params['ck_mc'];
        //     msg['dy_ck_mc'] = selData[i]['ck_mc'];
        //     __data['ck_id'] = undefined;
        // }

        (__data['ck_id'] === 0) && (__data['ck_id'] = selData[i]['ck_id']);
        (__data['fp_id'] === 0) && (__data['fp_id'] = selData[i]['fp_id']);

        var ps = 0, zsl = 0;

        if (__PAGE_PARAM['is_dy_cgdd_type'] == 'pb') {
            ps = selData[i]['pbcg_wcgps'];
            zsl = selData[i]['pbcg_wcgsl'];

        } else {
            ps = selData[i]['cpcg_wcgps'];
            zsl = selData[i]['cpcg_wcgsl'];
        }

        var rmpRow = {
            'yy_djlx': selData[i]['djlx'],
            'ps': ps,
            'zsl': zsl,
            'gyyq': selData[i]['gyyq'],
            'kh_id': selData[i]['wldw_id'],
            'kh_mc': selData[i]['wldw_mc'],
            'kh_dd_dh': selData[i]['dh'],
            'kh_dd_kdsj': selData[i]['kdsj'],
            'kh_dd_dj_id': selData[i]['dj_id'],
            'kh_dd_jl_id': selData[i]['jl_id'],
            'shuilv': 0,
            'fy_zdy1': 0,
            'fy_zdy2': 0,
            'fy_zdy3': 0,
            'fy_zdy4': 0,
            'fy_zdy5': 0,
        };

        rmpRow['ps'] = (rmpRow['ps'] < 0) ? 0 : rmpRow['ps'];
        rmpRow['zsl'] = (rmpRow['zsl'] < 0) ? 0 : rmpRow['zsl'];

        __data['list'].push($.extend(true, {}, selData[i], rmpRow));
    }

    return __data['list'];
}
