var html_name = page_arr.cg_lthtj;


//默认开始显示数据
var to_month = fun.getLatelyTime(1,false);
var page_list = [], ztj_data = [];
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

$('#header').header({
    back: true,
    filter: true,
    title: '来退货单'
});

var USER_INFO = {};

var hz_group_columns = {
    'dh': 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc',
    'wldw': 'wldw_id,wldw_mc',
    'cp': 'cp_bh,cp_mc',
    'cp_ys': 'cp_ys_bh,cp_ys_mc',
    "fkkz": 'fk,kz',
    "gg": 'gg'
};


//接收查询后的参数
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var hnh = html_name + '_';
    search_storage = $.extend(true, {
        hldj: fun.getItem(hnh + 'hldj', 0),
        xsmx: fun.getItem(hnh + 'xsmx', 0),
        "hz": {
            "choose": {
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "dh": fun.getItem(hnh + 'dh', 1),
                "wldw": fun.getItem(hnh + 'wldw', 1),
                "cp": fun.getItem(hnh + 'cp', 1),
                "cp_ys": fun.getItem(hnh + 'cp_ys', 1),
                "fkkz": fun.getItem(hnh + 'fkkz', 0),
                "gg": fun.getItem(hnh + 'gg', 0)
            },
            "text": fun.getItem(hnh + 'text', ""),
        },
        'djlx': fun.getItem(html_name + "_djlx")
    }, search_storage);
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(html_name + '_' + 'hz') || '');

    search_data = $.extend({}, search_data, search_storage);
    fun.initGroupOfSearchData(search_data, search_storage.hz.choose, hz_group_columns, ',dw_id,dw_mc');
    getList(search_data);

    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var param = ret.value.data;

        search_data['keyword'] = param['LIKE_DATA'] || '';              // 关键字
        search_data['begin_time'] = param.begin_date;                   // 开始时间
        search_data['end_time'] = param.end_date;                       // 结束时间
        search_data['wldw_id'] = param.gys['id'] || '';                 // 供应商
        search_data['cp_id'] = param.cp['id'] || '';                    // 产品
        search_data['cp_lb_id'] = param.cp_lb['id'] || 0;               // 产品类别
        search_data['ck_id'] = param.ck['id'] || '';                    // 仓库
        search_data['md_id'] = param.md['id'] || '';                    // 门店
        search_data['kh_id'] = param.kh['id'] || '';                    // 客户
        search_data['dh'] = param['dh'] || '';                          // 订单单号
        search_data['hldj'] = param['hldj'];                       // 合拢单据
        search_data['xsmx'] = param['xsmx'];                       // 显示明细数据

        if (param.djlx['type'].indexOf(',') > -1) {
            var split = param.djlx['type'].split(',');
            search_data['djlx'] = [split[0], split[1]]
        } else {
            search_data['djlx'] = param.djlx['type'] != "" ? [param.djlx['type']] : ["bp_cglhd", "bp_cgthd"];
        }
        search_data['djlx_text'] = param.djlx['text'];
        fun.setItem(hnh + 'djlx', search_data['djlx'])
        fun.setItem(hnh + 'djlx_text', search_data['djlx_text'])
        if (param.djlx['keys']['bp_cglhd'] == 0 && param.djlx['keys']['bp_cgthd'] == 0) {
            fun.setItem(hnh + 'bp_cglhd', 1);
            fun.setItem(hnh + 'bp_cgthd', 1);
        } else {
            fun.setItem(hnh + 'bp_cglhd', param.djlx['keys']['bp_cglhd']);
            fun.setItem(hnh + 'bp_cgthd', param.djlx['keys']['bp_cgthd']);
        }

        //搜索菜单需要缓存的数据
        search_storage['keyword'] = search_data['keyword'];
        search_storage['begin_date'] = search_data['begin_time'];
        search_storage['end_date'] = search_data['end_time'];
        search_storage['gys'] = param.gys;
        search_storage['cp'] = param.cp;
        search_storage['cp_lb'] = param.cp_lb;
        search_storage['ck'] = param.ck;
        search_storage['md'] = param.md;
        search_storage['kh'] = param.kh;
        search_storage['dh'] = search_data['dh'];
        search_storage['hldj'] = search_data['hldj'];
        search_storage['xsmx'] = search_data['xsmx'];

        //设置时间控件时间
        date_bar.setDate(search_storage);
        fun.setItem(html_name + '_hldj', search_storage['hldj']);
        fun.setItem(html_name + '_xsmx', search_storage['xsmx']);

        // 汇总功能
        search_data['group'] = param.hz['group'] || '';
        search_storage['hz'] = param.hz;
        var hc = param['hz']['choose'];
        fun.setItem(hnh + 'md_mc', hc['md_mc']);
        fun.setItem(hnh + 'dh', hc['dh']);
        fun.setItem(hnh + 'wldw', hc['wldw']);
        fun.setItem(hnh + 'cp', hc['cp']);
        fun.setItem(hnh + 'cp_ys', hc['cp_ys']);
        fun.setItem(hnh + 'text', param.hz['text']);
        fun.setItem(hnh + 'fkkz', hc['fkkz']);
        fun.setItem(hnh + 'gg', hc['gg']);
        fun.setGroupCondition(search_data, 'dw_id,dw_mc');

        // if (!!search_data['group']) {
        //     var group_data = search_data['group'];
        //     group_data += ',dw_id,dw_mc,jjdw_mc';
        //     search_data['group'] = group_data;
        // }
        fun.setItem(hnh + 'hz', search_data['group']);

        fun.setItem(html_name + 'sideslip', true);

        page_list = [];
        getList(search_data);
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });

}
//存储一个值用于判定是否打开搜索页//值为false即为打开
fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {

    var sideslip = fun.getItem(html_name + 'sideslip');

    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "dh_wrap": {
            "key": "dh",
            "value": search_storage['dh'] || "",
            "placeholder": "订单单号"
        },
        "choose_merchants": [{
            key: "gys",
            "text": "供应商",
            "value": (search_storage['gys'] && search_storage['gys']['text']) || "",
            "id": (search_storage['gys'] && search_storage['gys']['id']) || 0,
        }, {
            key: "cp",
            "text": "产品",
            "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
            "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
        }, {
            key: "cp_lb",
            "text": "产品类别",
            "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
            "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
        }, {
            key: "ck",
            "text": "仓库",
            "value": (search_storage['ck'] && search_storage['ck']['text']) || "",
            "id": (search_storage['ck'] && search_storage['ck']['id']) || 0,
        }, {
            key: "md",
            "text": "门店",
            "value": (search_storage['md'] && search_storage['md']['text']) || "",
            "id": (search_storage['md'] && search_storage['md']['id']) || 0,
        },
        {
            key: "kh",
            "text": "客户",
            "value": (search_storage['kh'] && search_storage['kh']['text']) || "",
            "id": (search_storage['kh'] && search_storage['kh']['id']) || 0,
        },
        {
            key: "hz",
            "text": "汇总",
            "group": [
                // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                { key: 'dh', name: '单号', columns: hz_group_columns.dh, choose: getHz('dh') },
                { key: 'wldw', name: '供应商', columns: hz_group_columns.wldw, choose: getHz('wldw') },
                { key: 'cp', name: '产品', columns: hz_group_columns.cp, choose: getHz('cp') },
                { key: 'cp_ys', name: '颜色', columns: hz_group_columns.cp_ys, choose: getHz('cp_ys') },
                //    { key: "hsdj", name: '单价', columns: hz_group_columns.hsdj, choose: getHz('hsdj')},
                { key: "fkkz", name: '幅宽克重', columns: hz_group_columns.fkkz, choose: getHz('fkkz')},
                { key: "gg", name: '规格', columns: hz_group_columns.gg, choose: getHz('gg')}
            ],
            "value": getTwo('hz', 'text'),
        }
        ],
        'xs': [
            {
                "key": 'djlx',
                "text": "单据类型",
                "xsType": (fun.getItem(html_name + '_' + 'djlx') || 'bp_cglhd,bp_cgthd'),
                "list": [
                    { 'name': '来货', 'column': 'bp_cglhd', 'is_choose': fun.getItem(html_name + '_' + 'bp_cglhd') == 0 ? 0 : 1 },
                    { 'name': '退货', 'column': 'bp_cgthd', 'is_choose': fun.getItem(html_name + '_' + 'bp_cgthd') == 0 ? 0 : 1 },
                ],
                "alone": false,
                "value": (fun.getItem(html_name + '_' + 'djlx_text') || "来货、退货"),
            }],
        "switch": [{
            "text": "显示明细数据",
            "max_width": true,
            "key": "xsmx",
            "value": (!!fun.getItem(html_name + '_xsmx') ? fun.getItem(html_name + '_xsmx') : 0)
        },{
            "text": "合拢单据",
            "max_width": true,
            "key": "hldj",
            "value": (!!fun.getItem(html_name + '_hldj') ? fun.getItem(html_name + '_hldj') : 0)
        }]
    };
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getList(search_data);
        }
    });

function showList(data) {
    $('#tj1').text(ztj_data['ps'] || 0);
    $('#tj2').text(ztj_data['zsl'] || 0);
    var i;
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !search_storage['hldj'],
        isNoExpand: search_storage['xsmx'],
        render: {
            titlebar: function (res) {
                return fthStatistics.createTitlebar(res, {
                    showPrice: false,
                    search_data: search_data
                });
                // i=1;
                // var hDW=!!fun.is_value(res['wldw_mc']),
                //     hMD=!!fun.is_value(res['md_mc'])||fun.is_value(res['zdr_mc']);
                //     if(!!res['md_id']||res['md_id']==0) hMD=true;
                // var dwmc=hDW||hMD,
                //     hKD=!!fun.is_value(res['kdsj']),
                //     hDH=!!fun.is_value(res['dh']),
                //     kddh=hKD||hDH;

                // var Html=[]
                //     Html.push(dwmc?'<div class="title-bar-row">':'');
                //     Html.push(hDW?'    <div><span style="color:' + res['color_val'] + '">' + fun.is_value(res['wldw_mc']) + '</span></div>':dwmc?'<div></div>':'');
                //     Html.push(hMD?'    <div class="align-right" ><a>' + fun.is_value(res['md_mc']) + '</a>&nbsp;<a>' + fun.is_value(res['zdr_mc']) + '</a></div>':'');
                //     Html.push(dwmc?'</div>':'');
                //     Html.push(kddh?'<div class="title-bar-row">':'');
                //     Html.push(hKD?'    <div><span>' + fun.is_value(res['kdsj']) + '</span></div>':kddh?'<div></div>':'');
                //     Html.push(hDH?'    <div class="align-right" ><a>' + fun.is_value(res['dh']) + '</a></div>':'');
                //     Html.push(kddh?'</div>':'');
                //     return Html.join('');
            },
            subtitle: function (res) {
                return fthStatistics.createSubtitle(res, {
                    search_data: search_data
                });
                // var hMD=!!fun.is_value(res['md_mc'])||fun.is_value(res['zdr_mc']),
                //     hDW=!!fun.is_value(res['wldw_mc']),
                //     hKD=!!fun.is_value(res['kdsj']);
                //     if(!!res['md_id']||res['md_id']==0) hMD=true;
                //     if(i==1){
                //         hMD=false;
                //         hDW=false;
                //         hKD=false;
                //         i++;
                //     }
                // var hCP=!!fun.is_value(res["cp_bh"])||fun.is_value(res["cp_mc"]),
                //     hYS=!!fun.is_value(res["cp_ys_bh"])||fun.is_value(res["cp_ys_mc"]),
                //     hKZ=!!fun.is_value(res["fk"])||fun.is_value(res["kz"]);
                //     yskz=hYS||hKZ;
                // var htmlArr = [];
                // htmlArr.push(hCP?' <div class=\"row\" data-list=\''+JSON.stringify(res)+'\'>':(hKD||hDW||hMD)?'<div class=\"row\">':'');
                // htmlArr.push(hCP?'                         <div>' + fun.is_value(res["cp_bh"]) + '' + fun.is_value(res["cp_mc"]) + '</div>':(hKD||hDW||hMD)?'<div></div>':'');
                // htmlArr.push(hCP?'                    </div>':(hKD||hDW||hMD)?'</div>':'');
                // htmlArr.push(yskz?'                    <div class=\"row\" data-list=\''+JSON.stringify(res)+'\'>':"");
                // htmlArr.push(hYS?"                         <div>" + fun.is_value(res["cp_ys_bh"]) + " " + fun.is_value(res["cp_ys_mc"]) + "</div>":"");
                // htmlArr.push(hKZ?"                         <div class=\"align-right\"><a>幅\\克</a>" + fun.is_value(res["fk"]) + ((res["fk"] && res["kz"]) ? 'x' : "") + fun.is_value(res["kz"]) + "</div>":"");
                // htmlArr.push(yskz?"                    </div>":"");
                // return htmlArr.join('');
                // return [
                //     '<div class="row">',
                //     '     <div>' + fun.is_value(res['cp_bh']) + ' ' + fun.is_value(res['cp_mc']) + '</div>',
                //     '</div>',
                //     '<div class="row">',
                //     '     <div>' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</div>',
                //     '     <div class="align-right"><a>幅/克</a>' + fun.is_value(res['fk']) + '×' + fun.is_value(res['kz']) + '</div>',
                //     '</div>',
                // ].join('')
            },
            subdata: function (res) {
                // console.log('res.dw_mc', res.dw_mc);
                return fthStatistics.createSubdata(res, {
                    search_data: search_data,
                    showPrice: false,
                    ps_tmp: res.ps,
                    sl_tmp: res.zsl,
                    dw_tmp: res.dw_mc
                });
                // var htmlstr = "", htmlArr = [];
                // htmlArr.push(' <div class=\"row\" data-list=\''+JSON.stringify(res)+'\'>');
                // htmlArr.push("                        <div><span>" + (fun.is_value(res['ps']) + "匹") + "</span><span>" + (fun.is_value(res['zsl']) + fun.is_value(res['dw_mc'])) + "</span></div>");
                // htmlArr.push("                        <div><span>计价</span><span>" + (fun.is_value(res['jjsl']) + "" + fun.is_value(res['jjdw_mc'])) + "</span></div>");
                // if (fun.is_value(res['gh']))
                //     htmlArr.push("                        <div><span>缸号</span><span>" + fun.is_value(res["gh"]) + "</span></div>");
                // htmlArr.push("                    </div>");
                // htmlstr = htmlArr.join('');
                // return htmlstr;
                // return [
                //     '<div class="row">',
                //     '    <div><span>' + fun.is_value(res['ps']) + '</span><span>' + fun.is_value(res['gj']) + '</span></div>',
                //     '    <div><span>计价</span><span>' + fun.is_value(res['jj']) + '</span></div>',
                //     '    <div><span>缸号</span><span>' + fun.is_value(res['gh']) + '</span></div>',
                //     '</div>',
                // ].join('');
            }

        },


    });
}

/** 获取发退货结算数据
 * @param {*} data
 */
function getList(data) {

    page_list = [];
    //暂时使用这种方式访问api接口，如果没有这个就会访问不到
    data['djlx'] = search_data['djlx'] || ["bp_cglhd", "bp_cgthd"];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL['getBpCglthdtj'],
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj1').text(0);
                    $('#tj2').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                ztj_data = res['info'];
                fun.clearPage($('#order_list'));
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createKeysValueFun: function(obj) {
                        return {
                            "wldw_mc": obj['wldw_mc'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "is_sh": obj['is_sh'],
                            "md_id": obj['md_id'],
                            "list": [],
                            "dj_ps": fun.is_value(obj['dj_ps'], 0),
                            "dj_zsl": fun.is_value(obj['dj_zsl'], 0),
                            "zdw_mc_tmp": fun.is_value(obj['zdw_mc']),  // 总单位名称
                        }
                    }
                });
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}


//跳转事件
fun.tjContentTap(function (data_list) {
    if ($.nui.isTrue(data_list['dj_id'])) {
        var djlx = data_list['djlx'];
        var id = data_list['dj_id'];
        var dh = data_list['dh'];
        var kdsj = data_list['kdsj'];
        var zdr = data_list['zdr_mc'];
        var djlx_lth, p_url;
        if (djlx == 'bp_cgthd') {
            djlx_lth = '退货单';
            p_url = page_arr.cg_thd_xq;
        } else {
            djlx_lth = '来货单';
            p_url = page_arr.cg_lhd_xq;
        }
        fun.showPageFull({
            page_url: p_url,
            pageParam: {
                return_page: html_name,
                id: id,
                mc: djlx_lth,
                dh: dh,
                kdsj: kdsj,
                zdr: zdr
            }
        });
    }
});

$('body').on('click','.row-list',function(){
    if(fun.getItem(html_name + '_xsmx', 0)) return;
    var data_list = $(this).children('.summary').children('.summary-content').data('list');
    if ($.nui.isTrue(data_list['dj_id'])) {
        var djlx = data_list['djlx'];
        var id = data_list['dj_id'];
        var dh = data_list['dh'];
        var kdsj = data_list['kdsj'];
        var zdr = data_list['zdr_mc'];
        var djlx_lth, p_url;
        if (djlx == 'bp_cgthd') {
            djlx_lth = '退货单';
            p_url = page_arr.cg_thd_xq;
        } else {
            djlx_lth = '来货单';
            p_url = page_arr.cg_lhd_xq;
        }
        fun.showPageFull({
            page_url: p_url,
            pageParam: {
                return_page: html_name,
                id: id,
                mc: djlx_lth,
                dh: dh,
                kdsj: kdsj,
                zdr: zdr
            }
        });
    }
})