var html_name = page_arr.cw_fyd_tj, temps,
    date_arr = fun.getDateArr(),
    to_month = fun.getLatelyTime(1,false), //获取本月第一天和最后一天
    search_data = {
        'begin_time': fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        'end_time': fun.Date(to_month['end_date']).Format('yy-mm-dd'),
        "type": "tj_fyd",
    },
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            // $('#order_list').empty();
            fun.clearPage($('#order_list'))
            getData();
        }
    }),
    page_list = [], ztj_data = [];

$('#header').header({
    back: true,
    add: Auth.check('cw_fyd', 'edit'),
    filter: true,
    title: '费用单',
});

var USER_INFO = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var hnh = html_name + '_';
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(hnh + 'hz') || '')
    search_data = $.extend(true, {
        'hldj': fun.getItem(html_name + '_hldj', 0),
        'xsmx': fun.getItem(html_name + '_xsmx', 0),
        "hz": {
            "choose": {
                "fylx_mc": fun.getItem(hnh + 'fylx_mc', 0),
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "zh": fun.getItem(hnh + 'zh', 0),
            },
            "text": fun.getItem(hnh + 'text', ""),
        }
    }, search_data);

    console.log(search_data);

    getData();
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'search':
                search_data['begin_time'] = temp['data']['begin_date'];
                search_data['end_time'] = temp['data']['end_date'];
                date_bar.setDate({
                    begin_date: search_data['begin_time'],
                    end_date: search_data['end_time']
                });
                search_data['keyword'] = temp['data']['LIKE_DATA'] || '';
                search_data['zh_id'] = temp['data']['zh']['id'] || '';//账户id
                search_data['zh_mc'] = temp['data']['zh']['text'] || '';//账户
                search_data['md_id'] = temp['data']['md']['id'] || '';
                search_data['md_mc'] = temp['data']['md']['text'] || '';

                //类型
                search_data['fylx_id'] = temp['data']['cost']['id'] || '';
                search_data['fylx_mc'] = temp['data']['cost']['text'] || '';
                search_data['order'] = {};
                search_data['order']['je'] = temp['data']['je'] || '';

                search_data['hldj'] = temp['data']['hldj'];
                search_data['xsmx'] = temp['data']['xsmx'];
                fun.setItem(html_name + '_hldj', search_data['hldj']);
                fun.setItem(html_name + '_xsmx', search_data['xsmx']);


                //汇总功能
                search_data['group'] = temp['data']['hz']['group'] || '';
                search_data['hz'] = temp['data']['hz'];
                var hc = temp['data']['hz']['choose'];

                console.log(123, hc)
                console.log(123, hc['fylx_mc'])

                fun.setItem(hnh + 'fylx_mc', hc['fylx_mc']);
                fun.setItem(hnh + 'md_mc', hc['md_mc']);
                fun.setItem(hnh + 'zh', hc['zh']);
                fun.setItem(hnh + 'text', temp['data']['hz']['text']);
                fun.setItem(hnh + 'hz', search_data['group']);
                fun.setItem(html_name + 'sideslip', true);
                // $('#order_list').empty();
                getData();
                break;
            case "refresh":
                // $('#order_list').empty();
                getData();
                break;
        }
    });
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
}

//获取数据
function getData() {
    page_list = [];
    temps = $.extend({
        "keyword": "",
        "begin_time": "",
        "end_time": "",
        "md_id": 0,
        "md_mc": "",
        "zh_id": 0,
        "zh_mc": "",
        "fylx_id": "",
        "order": {
            "je": "",
        }
    }, search_data);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getFydtj,
        data: temps,
        success: function (res) {
            if (!res['data'] || res['data'].length == 0) {
                $('#tj1').text(0);
                // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                return fun.createDataEmptyTips({ dom: '#order_list', btnText: '新增费用单', auth: 'cw_fyd' });
            }
            fun.clearPage($('#order_list'))
            ztj_data = res.info;
            // for (var i = 0; i < info_list.length; i++) {
            //     order_data.push({
            //         zh_tb: (info_list[i]['zh_tb'] || ''),
            //         zh_mc: (info_list[i]['zh_mc'] || ''),//往来单位
            //         md_mc: (info_list[i]['md_mc'] || ''),
            //         zdr_mc: (info_list[i]['zdr_mc'] || ''),
            //         kdsj: (info_list[i]['kdsj'] || ''),
            //         dh: (info_list[i]['dh'] || ''),
            //         zh_qcje: (info_list[i]['zh_qcje'] || ''),//前存
            //         je: (info_list[i]['je'] || ''),//金额
            //         zh_ljck: (info_list[i]['zh_ljck'] || ''),//累存
            //         bz: (info_list[i]['bz'] || ''),//备注
            //         lx: (info_list[i]['fylx_mc'] || ''),//类型
            //     });
            // }
            // if (!!order_data[0]) {
            //
            page_list = fun.createApiDataIndex(res.data);
            showList(fun.PagingData(page_list));
            // }
            $(".lxs").each(function () {
                if (!$(this).text()) {
                    $(this).parent().hide();
                }
            });
            $(".bzs").each(function () {
                if (!$(this).text()) {
                    $(this).parent().parent().hide();
                }
            });
        }
    });
}

function showList(data) {
    $('#tj1').text(ztj_data[0]['je'] || 0);
    var hldj = fun.getItem(html_name + '_hldj', 0);
    var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        is_row: true,
        isExpand: !hldj,
        isNoExpand: xsmx,
        render: {
            titlebar: function (res) {
                var html = [];
                var hZH = !!fun.is_value(res['zh_tb']) || fun.is_value(res['zh_mc']);

                if (hZH) {
                    html.push('<div class="title-bar-row">');
                    html.push('     <div><img src="../img/bank/' + fun.is_value(res['zh_tb']) + '" class="account-icon">&nbsp;<span class="font-ls" style="">' + fun.is_value(res['zh_mc']) + '</span></div>');
                    html.push('     <div class="align-right" ><a class="font-ss">' + fun.formatTime(res['kdsj']) + '</a>&nbsp;<a class="font-ss">' + fun.is_value(res['zdr_mc']) + '</a>&nbsp;<a>' + fun.createIsShLabelHtml(res['is_sh'])
                        + '</a></div>');
                    html.push('</div>');
                }

                return html.join('');
            },
            subtitle: function (res) {
                var hLB = !!fun.is_value(res['je']);
                var html = [];
                if (hLB) {
                    html.push('<div class="row">');
                    html.push('     <div><span>' + fun.is_value(res['fylx_mc'], '金额') + '</span></div><div></div>');
                    html.push('     <div class="align-right"><span class="color-gray font-ss">' + (fun.is_value(res['jsr_mc']) ? fun.is_value(res['jsr_mc']) + '&nbsp;:&nbsp;' : '') + '</span><span class="color-money-red">￥' + fun.is_value(res['je']) + '</span></div>');
                    html.push('</div>');
                }
                return html.join('');
            },
            subdata: function (res) {
                //【账户-显示存款】没有开启
                if(!Auth.check('zh_xsck','view')) {return}
                var through = !!fun.getItem(html_name + '_' + 'hz');

                if ($.nui.isEmpty(res['zh_qcje']) && $.nui.isEmpty(res['zh_ljck'])) return '';
                var html = [];
                if (!through) {
                    html.push('<div class="row bg-gray">');
                    html.push('     <div><span class="color-gray">前存</span><span>' + fun.is_value(res['zh_qcje']) + '</span></div>');
                    html.push('     <div><span class="color-gray">累存</span><span>' + fun.is_value(res['zh_ljck']) + '</span></div>');
                    html.push('</div>');
                }
                return html.join('');
            }
        },
    });
}
fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": (temps && temps['keyword'] ? temps['keyword'] : ''),
            "placeholder": "单号"
        },
        "time": {
            "begin_date": search_data['begin_time'],
            "end_date": search_data['end_time']
        },
        "choose_merchants": [{
            key: "zh",
            "text": "账户",
            "value": (temps && temps['zh_mc'] ? temps['zh_mc'] : ''),
            "id": (temps && temps['zh_id'] ? temps['zh_id'] : ''),
        }, {
            key: "md",
            "text": "门店",
            "value": (temps && temps['md_mc'] ? temps['md_mc'] : ''),
            "id": (temps && temps['md_id'] ? temps['md_id'] : '')
        }, {
            key: "cost",
            "text": "类型",
            "value": (temps && temps['fylx_mc'] ? temps['fylx_mc'] : ''),
            "id": (temps && temps['fylx_id'] ? temps['fylx_id'] : ''),
        },
        {
            key: "hz",
            "text": "汇总",
            group: [
                { key: 'zh', name: '账户', columns: 'zh_id,zh_mc,zh_tb', choose: getHz('zh') },
                // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                { key: 'fylx_mc', name: '类型', columns: 'fylx_mc', choose: getHz('fylx_mc') },
            ],
            "value": getTwo('hz', 'text'),
        },
        ],
        "switch": [
            { "text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_data['xsmx'] },
            { "text": "合拢单据", "max_width": true, "key": "hldj", "value": search_data['hldj'] },
        ],
        "sort": [
            {
                "text": "金额",
                "key": "je",
                "value": (temps && temps['order']['je'] ? temps['order']['je'] : '')
            },
        ],
    }
    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
        console.log(header)
    }
});

function getHz(key, def) {
    def = def || 0;
    return (search_data['hz'] && search_data['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_data[key] && search_data[key][son]) || def;
}

//开单
$('body').on('tap', '#add_btn', function () {
    if (!fun.checkKz()) return;
    fun.showPageFull({
        page_url: page_arr.cw_fyd_kd,
        pageParam: {
            "type": "add",
            "return_page": html_name
        }
    });
})

// 修改单据
fun.tjContentTap(function (row) {
    if (!fun.checkKz()) return;
    if ($.nui.isEmpty(row['dj_id'])) return;

    fun.showPageFull({
        page_url: page_arr.cw_fyd_kd,
        pageParam: {
            "type": "edit",
            "dj_id": row['dj_id'],
            "return_page": html_name
        }
    });
})

$('body').on('tap', '.summary-content,.summary-title', function () {
    if (!fun.checkKz()) return;
    var row = $(this).data('list');
    if ($.nui.isEmpty(row['dj_id'])) return;
    fun.showPageFull({
        page_url: page_arr.cw_fyd_kd,
        pageParam: {
            "type": "edit",
            "dj_id": row['dj_id'],
            "return_page": html_name
        }
    });
})

$('body').on('click', '.row-list', function () {
    if (fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var row = $(this).children('.summary').children('.summary-content').data('list');
    if ($.nui.isEmpty(row['dj_id'])) return;

    fun.showPageFull({
        page_url: page_arr.cw_fyd_kd,
        pageParam: {
            "type": "edit",
            "dj_id": row['dj_id'],
            "return_page": html_name
        }
    });
})