var html_name = page_arr.cw_dz,
    options = {},
    date_arr = fun.getDateArr(),
    to_month = fun.getLatelyTime(1, false),
    search_data = {
        "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd')
    },
    search_storage = {
        "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd')
    },
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            $('#wrap').empty();
            setOption(search_storage);
            getList();
        }
    }),
    global_search = {},
    page_type = "kh",
    page_list = [],
    ztj_data = [];

var USER_INFO = {};
var SYS_CONFIG = {};

function getStorageName($pt) {
    return html_name + '_' + $pt + '_';
}

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    SYS_CONFIG = fun.getItem('sys_config') || {};

    $('.contents').css('paddingTop', api.safeArea.top + 'px');
    fun.load_DATA_LIST(['sys_config']);
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');

    $('#header').header({
        back: true,
        title: '客户对账表',
        filter: true,
        foot_input: {
            show: true,
            fork_icon: true,
            plader: '搜索'
        },
    });
    $("#foot_search").attr("readonly", "readonly");//输入框不可编辑

    var pt = page_data['page_type'];
    page_type = pt;

    //获取默认按钮配置
    // if (page_data['goods_type']) {
    //     fun.setItem(html_name + pt + '_lx', page_data['goods_type'] || '');
    //     fun.setItem(html_name + pt + '_lx_text', page_data['goods_text'] || '');
    //     if (page_data['goods_type'] === 'sx') {
    //         fun.setItem(html_name + pt + '_bp', 0);
    //         fun.setItem(html_name + pt + '_sx', 1);
    //     } else {
    //         fun.setItem(html_name + pt + '_bp', 1);
    //         fun.setItem(html_name + pt + '_sx', 0);
    //     }
    // }

    // var lx_type = fun.getItem(html_name + pt + '_lx') || '';
    // if (lx_type.indexOf(',') > -1) {
    //     search_data['goods_type'] = '';
    // } else {
    //     search_data['goods_type'] = lx_type != '' ? lx_type : '';
    // }
    var hnpt = getStorageName(pt);

    //首页跳转后赋值往来单位
    if (!!page_data['data']) {
        search_data['wldw_id'] = page_data['data']['wldw_id'];
        search_data['wldw_mc'] = page_data['data']['wldw_mc'];

        $('#foot_search').val(page_data['data']['wldw_mc'] || '');
    }
    if ($.nui.isTrue(page_data['home_md'])) {
        var md_list = fun.getItem('md_list') || [];
        search_data['md_id'] = page_data['home_md']['md_id'];
        search_data['md_mc'] = fun.getValByKey(md_list, search_data['md_id'], 'name');

        search_storage['md'] = {
            id: search_data['md_id'],
            text: search_data['md_mc'],
        }
    }

    //客户分析-详情回款率跳转过来，赋值时间
    if (!!page_data['begin_time'] || !!page_data['end_time']) {
        search_data['begin_time'] = page_data['begin_time'];
        search_data['end_time'] = page_data['end_time'];
        search_storage['begin_date'] = page_data['begin_time'];
        search_storage['end_date'] = page_data['end_time'];
        date_bar.setDate(search_storage);
    }
    var sk_text = '付款额';

    $('body').on('tap', "#foot_search", function () {
        fun.showPageFull({
            page_url: page_arr.customer_search,
            pageParam: {
                return_page: html_name,
                page_type: pt,
                notShowMulti: true,
                showAllWldw: true
            }
        });
    });

    search_storage['xsqb'] = fun.getItem(hnpt + 'xsqb', 0);
    search_storage['xsty'] = fun.getItem(hnpt + 'xsty', 0);

    switch (pt) {
        case 'kh':
            sk_text = '收款额';

            search_storage['xshuik'] = fun.getItem(hnpt + 'xshuik', 0);
            search_storage['xshex'] = fun.getItem(hnpt + 'xshex', 0);
            search_storage['xskp'] = fun.getItem(hnpt + 'xskp', 0);

            break;

        case 'gys':
            // $('body').on('tap', "#foot_search", function () {
            //     fun.showPageFull({
            //         page_url: page_arr.customer_search,
            //         pageParam: {
            //             return_page: html_name,
            //             page_type: 'gys',
            //         }
            //     });
            // });
            // search_storage['xsqb'] = fun.getItem(hnpt + 'xsqb', 0);
            // search_storage['xsty'] = fun.getItem(hnpt + 'xsty', 0);
            break;
        case 'jgs':
            // $('body').on('tap', "#foot_search", function () {
            //     fun.showPageFull({
            //         page_url: page_arr.customer_search,
            //         pageParam: {
            //             return_page: html_name,
            //             page_type: 'jgs',
            //         }
            //     });
            // });
            // search_storage['xsqb'] = fun.getItem(hnpt + 'xsqb', 0);
            // search_storage['xsty'] = fun.getItem(hnpt + 'xsty', 0);
            break;
        case 'wl':
            // $('body').on('tap', "#foot_search", function () {
            //     fun.showPageFull({
            //         page_url: page_arr.customer_search,
            //         pageParam: {
            //             return_page: html_name,
            //             page_type: 'wl',
            //         }
            //     });
            // });
            // search_storage['xsqb'] = fun.getItem(hnpt + 'xsqb', 0);
            // search_storage['xsty'] = fun.getItem(hnpt + 'xsty', 0);
            break;
    }
    $('#sk_text').text(sk_text);
    setOption(search_storage);
    $('#wrap').empty();
    getList();

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        // console.log(JSON.stringify(temp))
        switch (temp['status']) {
            case 'search':
                var data = temp['data'];
                search_data['begin_time'] = data['begin_date'];
                search_data['end_time'] = data['end_date'];
                search_data['order'] = {
                    ljqk: data['px_sort'] || ""
                }
                search_data['xsty'] = data['xsty'];         //显示停用
                search_data['xsqb'] = data['xsqb'];         //显示全部

                search_storage = data;
                var pt = page_data['page_type'];
                var hnpt = getStorageName(pt);

                fun.setItem(hnpt + 'xsqb', data['xsqb']);
                fun.setItem(hnpt + 'xsty', data['xsty']);

                search_data['md_id'] = data['md']['id'];    //门店

                switch (pt) {
                    case 'kh':
                        // search_data['wldw_id'] = data['kh']['id'];
                        search_data['wldw_lb_id'] = data['kh_lb']['id'];  //类别
                        // search_data['ywy_id'] = data['ywy']['id'];  //业务员

                        fun.setItem(hnpt + 'xshuik', data['xshuik']);
                        fun.setItem(hnpt + 'xshex', data['xshex']);
                        fun.setItem(hnpt + 'xskp', data['xskp']);

                        break;
                    case 'gys':
                        // search_data['wldw_id'] = data['gys']['id'];
                        search_data['wldw_lb_id'] = data['gys_lb']['id'];
                        // search_data['md_id'] = data['md']['id'];

                        // fun.setItem(hnpt + 'xsqb', data['xsqb']);
                        // fun.setItem(hnpt + 'xsty', data['xsty']);
                        break;
                    case 'jgs':
                        // search_data['wldw_id'] = data['jgs']['id'];
                        search_data['wldw_lb_id'] = data['jgs_lb']['id'];
                        // search_data['md_id'] = data['md']['id'];

                        // fun.setItem(hnpt + 'xsqb', data['xsqb']);
                        // fun.setItem(hnpt + 'xsty', data['xsty']);
                        break;
                    case 'wl':
                        // search_data['wldw_id'] = data['wl']['id'];
                        search_data['wldw_lb_id'] = data['wl_lb']['id'];
                        // search_data['md_id'] = data['md']['id'];

                        // fun.setItem(hnpt + 'xsqb', data['xsqb']);
                        // fun.setItem(hnpt + 'xsty', data['xsty']);
                        break;
                }
                fun.setItem(html_name + 'sideslip', true);
                //类型
                // if(pt != 'wl'){
                //     var lx = data['lx'];
                //     if (lx['type'].indexOf(',') > -1) {
                //         search_data['goods_type'] = '';
                //     } else {
                //         search_data['goods_type'] = lx['type'] != '' ? lx['type'] : '';
                //     }
                //     fun.setItem(html_name + pt + '_lx', search_data['goods_type'])
                //     fun.setItem(html_name + pt + '_lx_text', lx['text'])
                //     if (lx['keys']['bp'] == 0 && lx['keys']['sx'] == 0) {
                //         fun.setItem(html_name + pt + '_bp', 1);
                //         fun.setItem(html_name + pt + '_sx', 1);
                //     } else {
                //         fun.setItem(html_name + pt + '_bp', lx['keys']['bp']);
                //         fun.setItem(html_name + pt + '_sx', lx['keys']['sx']);
                //     }
                // }
                //设置时间控件
                date_bar.setDate(search_storage);
                setOption(search_storage);
                $('#wrap').empty();
                getList();
                break;
            case 'select_list':
                search_data['wldw_id'] = temp['data']['id'];
                $('#foot_search').val(temp['data']['select_val']);
                $('#wrap').empty();
                getList();
                break;
            case 'refresh':
                $('#wrap').empty();
                getList();
                break;
        }
    });
    // 监听列表滚到底
    fun.scrollToBottom({}, function () {
        if (page_list.length === 0) {
            fun.createBottomLine('wrap', '.supplier');
        } else {
            showSwitchList(fun.PagingData(page_list) || []);
        }
    });

    fun.orderListHeight({ dom: '#wrap' });

}
//输入框清除按钮
$('body').on('tap', ".icon-fork", function () {
    search_data['wldw_id'] = 0;
    $('#foot_search').val('');
    $('#wrap').empty();
    getList();
});

//设置搜索页配置
function setOption(value) {
    // 页面加载，要先读取有记忆的搜索条件
    var pt = page_data['page_type'];
    var hnpt = getStorageName(pt);
    var _data = value || search_storage;

    function get_id($key, $default) {
        return ((_data && _data[$key] && _data[$key]['id']) ? _data[$key]['id'] : $default);
    }

    function get_text($key, $default) {
        return ((_data && _data[$key] && _data[$key]['text']) ? _data[$key]['text'] : $default);
    }

    function get_value($key, $default) {
        return ((_data && (_data[$key] || _data[$key] == 0)) ? _data[$key] : $default);
    }

    function get_stor($key, $default) {
        return fun.getItem(hnpt + $key, $default);
    }

    switch (pt) {
        case 'kh':
            $('.cg,.jg').hide();
            if (!get_stor('xshuik', 0)) {
                $('.hk').hide();
            } else {
                $('.hk').show();
            }
            if (!get_stor('xshex', 0)) {
                $('.hx').hide();
            } else {
                $('.hx').show();
            }
            if (!get_stor('xskp', 0)) {
                $('.kp').hide();
            } else {
                $('.kp').show();
            }


            $('#header_title').text('客户对账表');

            var switchArr = [];

            if (AuthVersionCheck.checkHide('hx') && AuthVersionCheck.checkHide('kp')) {
                $('.hk').hide();
                $('.hx').hide();
                $('.kp').hide();
            } else {
                switchArr.push({
                    "text": "显示回款",
                    "max_width": false,
                    "key": "xshuik",
                    "value": get_stor('xshuik', 0)
                });
                switchArr.push({
                    "text": "显示核销",
                    "max_width": false,
                    "key": "xshex",
                    "value": get_stor('xshex', 0)
                });
                switchArr.push({
                    "text": "显示开票",
                    "max_width": false,
                    "key": "xskp",
                    "value": get_stor('xskp', 0)
                });
            }
            switchArr.push({
                "text": "全部客户",
                "max_width": false,
                "key": "xsqb",
                "value": get_value('xsqb', 1)
            });
            switchArr.push({
                "text": "显示停用",
                "max_width": false,
                "key": "xsty",
                "value": get_value('xsty', 1)
            });

            options = {
                "time": {
                    "begin_date": _data['begin_date'],
                    "end_date": _data['end_date']
                },
                "choose_merchants": [
                    // {.
                    //     key: "kh",
                    //     "text": "客户",
                    //     "id": get_id('kh', 0),
                    //     "value": get_text('kh', '')
                    // },
                    {
                        key: "kh_lb",
                        "text": "类别",
                        "id": get_id('kh_lb', 0),
                        "value": get_text('kh_lb', '')
                    }, {
                        key: "md",
                        "text": "门店",
                        "id": get_id('md', 0),
                        "value": get_text('md', '')
                    },
                    // {
                    //     key: "ywy",
                    //     "text": "业务员",
                    //     "id": get_id('ywy', 0),
                    //     "value": get_text('ywy', '')
                    // },
                ],
                "sort": [{
                    "text": "累欠",
                    "key": "px_sort",
                    "value": get_value('px_sort', '')
                },],
                // 'xs': [
                //     {
                //         "key": 'lx',
                //         "text": "类型",
                //         "xsType": (fun.getItem(html_name + pt + '_' + 'lx') || 'bp,sx'),
                //         "list": [
                //             {
                //                 'name': '布匹',
                //                 'column': 'bp',
                //                 'is_choose': fun.getItem(html_name + pt + '_' + 'bp') == 0 ? 0 : 1
                //             },
                //             {
                //                 'name': '纱线',
                //                 'column': 'sx',
                //                 'is_choose': fun.getItem(html_name + pt + '_' + 'sx') == 0 ? 0 : 1
                //             },
                //         ],
                //         "alone": false,
                //         "value": (fun.getItem(html_name + pt + '_' + 'lx_text') || "布匹、纱线"),
                //     }],
                "switch": switchArr,
            };
            break;
        case 'gys':
            $('.xs,.jg,.hx,.hk,.kp').hide();
            $('#header_title').text('供应商对账表');
            options = {
                "time": {
                    "begin_date": _data['begin_date'],
                    "end_date": _data['end_date']
                },
                "choose_merchants": [
                    // {
                    //     key: "gys",
                    //     "text": "供应商",
                    //     "id": get_id('gys', 0),
                    //     "value": get_text('gys', '')
                    // },
                    {
                        key: "gys_lb",
                        "text": "类别",
                        "id": get_id('gys_lb', 0),
                        "value": get_text('gys_lb', '')
                    }, {
                        key: "md",
                        "text": "门店",
                        "id": get_id('md', 0),
                        "value": get_text('md', '')
                    },
                ],
                "sort": [{
                    "text": "累欠",
                    "key": "px_sort",
                    "value": get_value('px_sort', '')
                },],
                // 'xs': [
                //     {
                //         "key": 'lx',
                //         "text": "类型",
                //         "xsType": (fun.getItem(html_name + pt + '_' + 'lx') || 'bp,sx'),
                //         "list": [
                //             {
                //                 'name': '布匹',
                //                 'column': 'bp',
                //                 'is_choose': fun.getItem(html_name + pt + '_' + 'bp') == 0 ? 0 : 1
                //             },
                //             {
                //                 'name': '纱线',
                //                 'column': 'sx',
                //                 'is_choose': fun.getItem(html_name + pt + '_' + 'sx') == 0 ? 0 : 1
                //             },
                //         ],
                //         "alone": false,
                //         "value": (fun.getItem(html_name + pt + '_' + 'lx_text') || "布匹、纱线"),
                //     }],
                "switch": [
                    {
                        "text": "全部供应商",
                        "max_width": true,
                        "key": "xsqb",
                        "value": get_stor('xsqb', 1)
                    }, {
                        "text": "显示停用",
                        "max_width": true,
                        "key": "xsty",
                        "value": get_stor('xsty', 1)
                    }
                ]
            };
            break;
        case 'jgs':
            $('.xs,.cg,.hx,.hk,.kp').hide();
            $('#header_title').text('加工商对账表');
            options = {
                "time": {
                    "begin_date": _data['begin_date'],
                    "end_date": _data['end_date']
                },
                "choose_merchants": [
                    //     {
                    //     key: "jgs",
                    //     "text": "加工商",
                    //     "id": get_id('jgs', 0),
                    //     "value": get_text('jgs', '')
                    // },
                    {
                        key: "jgs_lb",
                        "text": "类别",
                        "id": get_id('jgs_lb', 0),
                        "value": get_text('jgs_lb', '')
                    }, {
                        key: "md",
                        "text": "门店",
                        "id": get_id('md', 0),
                        "value": get_text('md', '')
                    },
                ],
                "sort": [{
                    "text": "累欠",
                    "key": "px_sort",
                    "value": get_value('px_sort', '')
                },],
                // 'xs': [
                //     {
                //         "key": 'lx',
                //         "text": "类型",
                //         "xsType": (fun.getItem(html_name + pt + '_' + 'lx') || 'bp,sx'),
                //         "list": [
                //             {
                //                 'name': '布匹',
                //                 'column': 'bp',
                //                 'is_choose': fun.getItem(html_name + pt + '_' + 'bp') == 0 ? 0 : 1
                //             },
                //             {
                //                 'name': '纱线',
                //                 'column': 'sx',
                //                 'is_choose': fun.getItem(html_name + pt + '_' + 'sx') == 0 ? 0 : 1
                //             },
                //         ],
                //         "alone": false,
                //         "value": (fun.getItem(html_name + pt + '_' + 'lx_text') || "布匹、纱线"),
                //     }],
                "switch": [{
                    "text": "全部加工商",
                    "max_width": true,
                    "key": "xsqb",
                    "value": get_stor('xsqb', 1)
                }, {
                    "text": "显示停用",
                    "max_width": true,
                    "key": "xsty",
                    "value": get_stor('xsty', 1)
                }]
            };
            break;
        case 'wl':
            $('.log').hide();
            $('#header_title').text('物流对账表');
            $(".log2").text("运费");
            $(".log4").text("其他");
            $(".log1").text("付款");
            options = {
                "time": {
                    "begin_date": _data['begin_date'],
                    "end_date": _data['end_date']
                },
                "choose_merchants": [
                    //     {
                    //     key: "wl",
                    //     "text": "物流",
                    //     "id": get_id('wl', 0),
                    //     "value": get_text('wl', '')
                    // },
                    {
                        key: "wl_lb",
                        "text": "类别",
                        "id": get_id('wl_lb', 0),
                        "value": get_text('wl_lb', '')
                    }, {
                        key: "md",
                        "text": "门店",
                        "id": get_id('md', 0),
                        "value": get_text('md', '')
                    },
                ],
                "sort": [{
                    "text": "累欠",
                    "key": "px_sort",
                    "value": get_value('px_sort', '')
                },],
                "switch": [{
                    "text": "全部物流",
                    "max_width": true,
                    "key": "xsqb",
                    "value": get_stor('xsqb', 1)
                }, {
                    "text": "显示停用",
                    "max_width": true,
                    "key": "xsty",
                    "value": get_stor('xsty', 1)
                }],
            };
            break;
    }
}

function getList() {
    page_list = [];
    search_data['wldw_type'] = page_data['page_type'];
    var params = $.extend({
        "wldw_type": "kh",
        "begin_time": search_data['begin_time'],
        "end_time": search_data['end_time'],
        "wldw_id": 0,
        "xszf": search_storage['xszf'] || 0,
        "xsty": search_storage['xsty'] || 0,
        "xsqb": search_storage['xsqb'] || 0,
        "ycxj": search_storage['ycxj'] || 0,
        "md_id": "",
        "ywy_id": "",
        "wldw_lb_id": 0,
        "order": "",
        "type": "dzb_zb"
    }, search_data);

    global_search = $.extend({}, params);

    var ajax_url = page_data['page_type'] == 'wl' ? AJAX_URL.getWlDzb : AJAX_URL.getKsDzb;

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: ajax_url,
        data: params,
        success: function (res) {
            // console.log(JSON.stringify(res))
            if (res['status'] == 0) {
                if (res['data']) {
                    if (!res['data'] || res['data'].length == 0) {
                        $('#tj_qc').text(0);
                        $('#tj_xse').text(0);
                        $('#tj_the').text(0);
                        $('#tj_ske').text(0);
                        $('#tj_qte').text(0);
                        $('#tj_lc').text(0);
                        $('#tj_yhk').text(0);
                        $('#tj_yihk').text(0);
                        $('#tj_whk').text(0);
                        $('#tj_cge,#tj_cgthe,#tj_jge,#tj_jgthe').text(0);
                        $('#tj_yhx,#tj_whx,#tj_ykp,#tj_wkp').text(0);
                        // return
                        // $('.custom-detail').css({'height': '40%', 'position': 'fixed'});
                        // $('#wrap').html('<p class="empty_text">暂无数据！</p>');
                        fun.createDataEmptyTips({ dom: '#wrap', btnShow: false, style: 'top:1rem;height:9rem;' });
                    } else {
                        // $('.custom-detail').css({'height': '100%', 'position': 'unset'});
                        ztj_data = res['info'];
                        page_list = res['data'];
                        $('#wrap').empty();
                        showSwitchList(fun.PagingData(page_list));
                    }

                }
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}

function getFloat(value) {
    value = parseFloat(value);
    var noVirtualValue = (value == 0 || isNaN(value))
    if (noVirtualValue) return 0;
    return value;
}

//客户对账数据列表
function createKhHtml(data) {
    var style = [];
    $(data).each(function (i, obj) {
        var colour = order_color[i % order_color.length];

        style.push('<div data-list=\'' + fun.formatString(JSON.stringify(obj)) + '\' wldw_id="' + fun.is_value(obj['wldw_id']) + '" wldw_mc="' + fun.is_value(obj['wldw_mc']) + '" class="supplier">');
        style.push('    <div class="custom-info">');
        style.push('  <span class="info red cus black">' + fun.is_value(obj['wldw_mc']) + '</span>');
        style.push('  <span class="info block sup pro log log-name">' + fun.is_value(obj['ywy_mc']) + '</span>');
        style.push('  <span class="info">前欠 <em class="info-money block">' + getFloat(obj['wldw_qqje']) + '</em></span>');
        style.push('  <span class="info">累欠 <em class="info-money block">' + getFloat(obj['wldw_ljqk']) + '</em></span>');
        if (obj['xygk'] == 1) {
            style.push('  <span class="info sup pro log log-name">信誉额 <em class="info-money block">' + getFloat(obj['xye']) + '</em></span>');

            if (parseFloat(obj['ced']) > 0) {
                style.push('  <span class="info sup pro log">超额度 <em class="info-money red">' + getFloat(obj['ced']) + '</em></span>');
            }
        }
        style.push(' </div>');
        style.push('<div class="service-info" style="background-color: #f6f6f6;">');

        //销售额、销售退货额
        // if (getFloat(obj['xsje']) > 0 || getFloat(obj['xsthje']) > 0) {
        style.push('  <span class="service-name log-name"><span class="sup2 pro2 log2">销售额</span><em class="service-money">' + getFloat(obj['xsje']) + '</em></span>');
        style.push(' <span class="service-name log-name"><span class="log1">退货额</span><em class="service-money">' + getFloat(obj['xsthje']) + '</em></span>');
        // }

        //采购额、采购退货额
        if (parseFloat(obj['cgje'] || 0) > 0 || parseFloat(obj['cgthje'] || 0) > 0) {
            style.push('  <span class="service-name log-name"><span class="sup2 pro2 log2">采购额</span><em class="service-money">' + getFloat(obj['cgje']) + '</em></span>');
            style.push('  <span class="service-name log-name"><span class="sup4 pro4 log4">退货额</span><em class="service-money">' + getFloat(obj['cgthje']) + '</em></span>');
        }

        //加工额、加工退货额
        if ((parseFloat(obj['jgje'] || 0) > 0 || parseFloat(obj['jgthje'] || 0) > 0)) {
            style.push(' <span class="service-name log-name"><span class="log1">加工额</span><em class="service-money">' + getFloat(obj['jgje']) + '</em></span>');
            style.push('  <span class="service-name log log-name"><span>退货额</span><em class="service-money">' + parseFloat(obj['jgthje'] || 0) + '</em></span>');
        }

        //收款额、其他额
        style.push('  <span class="service-name log-name"><span class="sup4 pro4 log4">收款额</span><em class="service-money">' + parseFloat(getFloat(obj['skje']) - getFloat(obj['fkje'])).fixed(4) + '</em></span>');
        var qtje = (parseFloat(obj['fyje'] || 0) + parseFloat(obj['tzje'] || 0) + parseFloat(obj['srje'] || 0) - parseFloat(obj['zcje'] || 0)).fixed(4);
        style.push('  <span class="service-name log log-name "><span>其他额</span><em class="service-money">' + qtje + '</em></span>');


        style.push('  <span class="service-name log log-name"><span class="sup1 pro1">销售匹</span><em class="service-money">' + getFloat(obj['xsps']) + '</em></span>');
        style.push('  <span class="service-name log log-name"><span class="sup3 pro3">销售数</span><em class="service-money">' + getFloat(obj['xssl']) + '</em></span>');

        if ($.nui.isTrue(SYS_CONFIG['qyssjms_bp']) || $.nui.isTrue(SYS_CONFIG['qyssjms_sx'])) {
            style.push('  <span class="service-name log log-name"><span class="sup1 pro1">实售数</span><em class="service-money">' + getFloat(obj['sssl']) + '</em></span>');
            style.push('  <span class="service-name log log-name"><span class="sup3 pro3">实售额</span><em class="service-money">' + getFloat(obj['sszje']) + '</em></span>');
            style.push('  <span class="service-name log log-name"><span class="sup3 pro3">回扣额</span><em class="service-money">' + getFloat(obj['sshke']) + '</em></span>');
        }

        !AuthVersionCheck.checkHide('ddj') && style.push('  <span class="service-name sup pro log log-name"><span>抵订金</span><em class="service-money">' + getFloat(obj['ddj']) + '</em></span>');

        if (search_storage['xshuik']) {
            style.push('  <span class="service-name sup pro log log-name"><span>应回款</span><em class="service-money">' + getFloat(obj['hkje']) + '</em></span>');
            style.push('  <span class="service-name sup pro log log-name"><span>已回款</span><em class="service-money">' + getFloat(obj['yhkje']) + '</em></span>');
            style.push('  <span class="service-name sup pro log log-name"><span>未回款</span><em class="service-money">' + getFloat(obj['whkje']) + '</em></span>');
            style.push('  <span class="service-name sup pro log log-name"><span>回款率</span><em class="service-money">' + parseFloat(getFloat(obj['hkl'])).fixed(2) + '%</em></span>');
        }
        if (search_storage['xshex'] && !AuthVersionCheck.checkHide('hx')) {
            style.push('  <span class="service-name sup pro log log-name"><span>已核销</span><em class="service-money">' + getFloat(obj['hxje']) + '</em></span>');
            style.push('  <span class="service-name sup pro log log-name"><span>未核销</span><em class="service-money">' + getFloat(obj['whxje']) + '</em></span>');
        }
        if (search_storage['xskp'] && !AuthVersionCheck.checkHide('kp')) {
            style.push('  <span class="service-name sup pro log log-name"><span>已开票</span><em class="service-money">' + getFloat(obj['kpje']) + '</em></span>');
            style.push('  <span class="service-name sup pro log log-name"><span>未开票</span><em class="service-money">' + getFloat(obj['wkpje']) + '</em></span>');
        }

        style.push('</div>');
        style.push(' </div>');
    })

    // console.log(style.join(''));

    $('#wrap').append(style.join(''));
}

//供应商数据列表
function createGysHtml(data) {
    var style = [];

    $(data).each(function (i, obj) {
        var colour = order_color[i % order_color.length];
        style.push('<div wldw_id="' + fun.is_value(obj['wldw_id']) + '" wldw_mc="' + fun.is_value(obj['wldw_mc']) + '" class="supplier">');
        style.push('    <div class="custom-info">');
        style.push('  <span class="info red cus black">' + fun.is_value(obj['wldw_mc']) + '</span>');
        style.push('  <span class="info block sup pro log log-name">' + fun.is_value(obj['ywy_mc']) + '</span>');
        style.push('  <span class="info">前欠 <em class="info-money block">' + getFloat(obj['wldw_qqje']) + '</em></span>');
        style.push('  <span class="info">累欠 <em class="info-money block">' + getFloat(obj['wldw_ljqk']) + '</em></span>');

        style.push(' </div>');
        style.push('<div class="service-info" style="background-color: #f6f6f6;">');


        //销售额、销售退货额
        if (getFloat(obj['xsje']) > 0 || getFloat(obj['xsthje']) > 0) {
            style.push('  <span class="service-name log-name"><span class="sup2 pro2 log2">销售额</span><em class="service-money">' + getFloat(obj['xsje']) + '</em></span>');
            style.push(' <span class="service-name log-name"><span class="log1">退货额</span><em class="service-money">' + getFloat(obj['xsthje']) + '</em></span>');
        }

        //采购额、采购退货额
        // if (parseFloat(obj['cgje']||0) > 0 || parseFloat(obj['cgthje']||0) > 0) {
        style.push('  <span class="service-name log-name"><span class="sup2 pro2 log2">采购额</span><em class="service-money">' + getFloat(obj['cgje']) + '</em></span>');
        style.push('  <span class="service-name log-name"><span class="sup4 pro4 log4">退货额</span><em class="service-money">' + getFloat(obj['cgthje']) + '</em></span>');
        // }

        //加工额、加工退货额
        if ((parseFloat(obj['jgje'] || 0) > 0 || parseFloat(obj['jgthje'] || 0) > 0)) {
            style.push(' <span class="service-name log-name"><span class="log1">加工额</span><em class="service-money">' + getFloat(obj['jgje']) + '</em></span>');
            style.push('  <span class="service-name log log-name"><span>退货额</span><em class="service-money">' + parseFloat(obj['jgthje'] || 0) + '</em></span>');
        }

        //付款额、其他额
        style.push('  <span class="service-name log-name"><span class="sup4 pro4 log4">付款额</span><em class="service-money">' + parseFloat(getFloat(obj['fkje']) - getFloat(obj['skje']) - getFloat(obj['ddj'])).fixed(4) + '</em></span>');
        var qtje = (parseFloat(obj['fyje'] || 0) + parseFloat(obj['tzje'] || 0) - parseFloat(obj['srje'] || 0) + parseFloat(obj['zcje'] || 0)).fixed(4);
        style.push('  <span class="service-name log log-name"><span>其他额</span><em class="service-money">' + qtje + '</em></span>');

        style.push('  <span class="service-name log log-name"><span class="sup1 pro1">采购匹</span><em class="service-money">' + getFloat(obj['cgps']) + '</em></span>');
        style.push('  <span class="service-name log log-name"><span class="sup3 pro3">采购数</span><em class="service-money">' + getFloat(obj['cgsl']) + '</em></span>');


        style.push('</div>');
        style.push(' </div>');
    })
    $('#wrap').append(style.join(''));
}

//加工商数据列表
function createJgsHtml(data) {
    var style = [];
    $(data).each(function (i, obj) {
        var colour = order_color[i % order_color.length];

        style.push('<div wldw_id="' + fun.is_value(obj['wldw_id']) + '" wldw_mc="' + fun.is_value(obj['wldw_mc']) + '" class="supplier">');
        style.push('    <div class="custom-info">');
        style.push('  <span class="info red cus black">' + fun.is_value(obj['wldw_mc']) + '</span>');
        style.push('  <span class="info block sup pro log log-name">' + fun.is_value(obj['ywy_mc']) + '</span>');
        style.push('  <span class="info">前欠 <em class="info-money block">' + getFloat(obj['wldw_qqje']) + '</em></span>');
        style.push('  <span class="info">累欠 <em class="info-money block">' + getFloat(obj['wldw_ljqk']) + '</em></span>');


        style.push(' </div>');
        style.push('<div class="service-info" style="background-color: #f6f6f6;">');

        //销售额、销售退货额
        if (getFloat(obj['xsje']) > 0 || getFloat(obj['xsthje']) > 0) {
            style.push('  <span class="service-name log-name"><span class="sup2 pro2 log2">销售额</span><em class="service-money">' + getFloat(obj['xsje']) + '</em></span>');
            style.push(' <span class="service-name log-name"><span class="log1">退货额</span><em class="service-money">' + getFloat(obj['xsthje']) + '</em></span>');
        }

        //采购额、采购退货额
        if (parseFloat(obj['cgje'] || 0) > 0 || parseFloat(obj['cgthje'] || 0) > 0) {
            style.push('  <span class="service-name log-name"><span class="sup2 pro2 log2">采购额</span><em class="service-money">' + getFloat(obj['cgje']) + '</em></span>');
            style.push('  <span class="service-name log-name"><span class="sup4 pro4 log4">退货额</span><em class="service-money">' + getFloat(obj['cgthje']) + '</em></span>');
        }

        //加工额、加工退货额
        // if ((parseFloat(obj['jgje']|| 0) > 0 || parseFloat(obj['jgthje']|| 0) > 0)) {
        style.push(' <span class="service-name log-name"><span class="log1">加工额</span><em class="service-money">' + getFloat(obj['jgje']) + '</em></span>');
        style.push('  <span class="service-name log log-name"><span>退货额</span><em class="service-money">' + (obj['jgthje'] === null ? 0 : parseFloat(obj['jgthje'] || 0)) + '</em></span>');
        // }

        //付款额、其他额
        style.push('  <span class="service-name log-name"><span class="sup4 pro4 log4">付款额</span><em class="service-money">' + parseFloat(parseFloat(obj['fkje'] || 0) - parseFloat(obj['skje'] || 0) - parseFloat(obj['ddj'] || 0)).fixed(4) + '</em></span>');
        var qtje = (parseFloat(obj['fyje'] || 0) + parseFloat(obj['tzje'] || 0) - parseFloat(obj['srje'] || 0) + parseFloat(obj['zcje'] || 0)).fixed(4);
        style.push('  <span class="service-name log log-name"><span>其他额</span><em class="service-money">' + qtje + '</em></span>');


        style.push('  <span class="service-name log log-name"><span class="sup1 pro1">加工匹</span><em class="service-money">' + parseFloat(obj['jgps'] || 0) + '</em></span>');
        style.push('  <span class="service-name log log-name"><span class="sup3 pro3">加工数</span><em class="service-money">' + parseFloat(obj['jgsl'] || 0) + '</em></span>');


        style.push('</div>');
        style.push(' </div>');
    })
    $('#wrap').append(style.join(''));

}

//物流数据列表
function createWlHtml(data) {
    var style = [];
    $(data).each(function (i, obj) {

        var colour = order_color[i % order_color.length];
        style.push('<div wldw_id="' + fun.is_value(obj['wldw_id']) + '" wldw_mc="' + fun.is_value(obj['wldw_mc']) + '" class="supplier">');
        style.push('    <div class="custom-info">');
        style.push('  <span class="info red cus black">' + fun.is_value(obj['wldw_mc']) + '</span>');
        style.push('  <span class="info block sup pro log log-name">' + fun.is_value(obj['ywy_mc']) + '</span>');
        style.push('  <span class="info">前欠 <em class="info-money block">' + parseFloat(obj['wldw_qqje'] || 0) + '</em></span>');
        style.push('  <span class="info">累欠 <em class="info-money block">' + parseFloat(obj['wldw_ljqk'] || 0) + '</em></span>');

        style.push(' </div>');
        style.push('<div class="service-info" style="background-color: #f6f6f6;">'); // #f6f6f6

        style.push('  <span class="service-name3 log-name"><span class="sup2 pro2 log2">运费</span><em class="service-money">' + (parseFloat(obj['xsyf'] || 0) + parseFloat(obj['cgyf'] || 0) + parseFloat(obj['jgyf'] || 0)) + '</em></span>');
        if ((parseFloat(obj['fyje'] || 0) - parseFloat(obj['tzje'] || 0)) != 0) {
            // var qt = (parseFloat(obj['fyje'] || 0) - parseFloat(obj['tzje'] || 0));
            var qt = parseFloat(parseFloat(obj['fyje'] || 0) + parseFloat(obj['tzje'] || 0)).fixed(4);
            style.push(' <span class="service-name3 log-name"><span class="log1">其他</span><em class="service-money">' + qt + '</em></span>');
        } else {
            style.push(' <span class="service-name3 log-name"><span class="log1"></span><em class="service-money"></em></span>');
        }
        style.push('  <span class="service-name3 log-name"><span class="sup2 pro2 log2">付款</span><em class="service-money">' + (parseFloat(obj['fkje'] || 0) - parseFloat(obj['skje'] || 0)) + '</em></span>');

        style.push('</div>');
        style.push(' </div>');
    })
    $('#wrap').append(style.join(''));

}

//数据列表转换器
var curPageData = [];

function showSwitchList(data) {
    $('.ssj').hide();
    $('#tj_qc').text(ztj_data['wldw_qqje'] || 0);//前欠 1
    switch (page_data['page_type']) {
        case 'kh':
            $('#tj_xse').text(ztj_data['xsje'] || 0);//销售额 1
            $('#tj_the').text(ztj_data['xsthje'] || 0);//退货额 1
            // $('#tj_ske').text(ztj_data['skje'] || 0);//收款额 1
            $('#tj_ske').text((parseFloat(ztj_data['skje'] || 0) - parseFloat(ztj_data['fkje'] || 0) + parseFloat(ztj_data['ddj'] || 0)).fixed(4) || 0);//收款额

            $('#tj_cge').text(ztj_data['cgje'] || 0);//采购额 1
            $('#tj_cgthe').text(ztj_data['cgthje'] || 0);//采购退货额 1

            if (ztj_data['cgje'] > 0 || ztj_data['cgthje'] > 0) {
                $('.cg').show();
                // $('#tj_cge').text(ztj_data['cgje'] || 0);//采购额 1
                // $('#tj_cgthe').text(ztj_data['cgthje'] || 0);//采购退货额 1
            } else {
                $('.cg').hide();
            }

            if ($.nui.isTrue(SYS_CONFIG['qyssjms_bp']) || $.nui.isTrue(SYS_CONFIG['qyssjms_sx'])) {
                $('.ssj').show();
                // $('#tj_cge').text(ztj_data['cgje'] || 0);//采购额 1
                // $('#tj_cgthe').text(ztj_data['cgthje'] || 0);//采购退货额 1
            } else {
                $('.ssj').hide();
            }
            $('#tj_sss').text(ztj_data['sssl'] || 0);//实售数 1
            $('#tj_sse').text(ztj_data['sszje'] || 0);//实售额 1
            $('#tj_hke').text(ztj_data['sshke'] || 0);//回扣额 1
            $('#tj_jge').text(ztj_data['jgje'] || 0);//加工额 1
            $('#tj_jgthe').text(ztj_data['jgthje'] || 0);//加工退货额 1

            if (ztj_data['jgje'] > 0 || ztj_data['jgthje'] > 0) {
                $('.jg').show();
                // $('#tj_jge').text(ztj_data['jgje'] || 0);//加工额 1
                // $('#tj_jgthe').text(ztj_data['jgthje'] || 0);//加工退货额 1
            } else {
                $('.jg').hide();
            }

            $('#tj_qte').text(parseFloat(ztj_data['fyje'] + ztj_data['tzje'] + ztj_data['srje'] - ztj_data['zcje']).fixed(4) || 0);//其他额 1
            $('#tj_lc').text(ztj_data['wldw_ljqk'] || 0);//累欠 1
            $('#tj_yhk').text(ztj_data['hkje'] || 0);//应回款 1
            $('#tj_yihk').text(ztj_data['yhkje'] || 0);//已回款 1
            $('#tj_whk').text(ztj_data['whkje'] || 0);//未回款 1

            $('#tj_yhx').text(ztj_data['hxje'] || 0);//已核销 1
            $('#tj_whx').text(ztj_data['whxje'] || 0);//未核销 1
            $('#tj_ykp').text(ztj_data['kpje'] || 0);//已开票 1
            $('#tj_wkp').text(ztj_data['wkpje'] || 0);//未开票 1
            break;
        case 'gys':
            $('.sup').hide();
            // $('.wws').removeClass('line');

            $('#tj_xse').text(ztj_data['xsje'] || 0);//销售额
            $('#tj_the').text(ztj_data['xsthje'] || 0);//退货额
            if (ztj_data['xsje'] > 0 || ztj_data['xsthje'] > 0) {
                $('.xs').show();

            } else {
                $('.xs').hide();
            }

            $('#tj_cge').text(ztj_data['cgje'] || 0);//采购额
            $('#tj_cgthe').text(ztj_data['cgthje'] || 0);//采购退货额

            $('#tj_jge').text(ztj_data['jgje'] || 0);//加工额 1
            $('#tj_jgthe').text(ztj_data['jgthje'] || 0);//加工退货额 1

            if (ztj_data['jgje'] > 0 || ztj_data['jgthje'] > 0) {
                $('.jg').show();

            } else {
                $('.jg').hide();
            }

            // $('#tj_ske').text(ztj_data['fkje'] || 0);//收款额
            $('#tj_ske').text((parseFloat(ztj_data['fkje'] || 0) - parseFloat(ztj_data['skje'] || 0) - parseFloat(ztj_data['ddj'] || 0)).fixed(4) || 0);//收款额
            $('#tj_qte').text(parseFloat((ztj_data['fyje'] + ztj_data['tzje'] + ztj_data['zcje'] - ztj_data['srje'])).fixed(4) || 0);//其他额
            $('#tj_lc').text(ztj_data['wldw_ljqk'] || 0);//累欠
            break;
        case 'jgs':
            $('.pro').hide();

            $('#tj_xse').text(ztj_data['xsje'] || 0);//销售额
            $('#tj_the').text(ztj_data['xsthje'] || 0);//退货额
            if (ztj_data['xsje'] > 0 || ztj_data['xsthje'] > 0) {
                $('.xs').show();
            } else {
                $('.xs').hide();
            }


            $('#tj_cge').text(ztj_data['cgje'] || 0);//采购额
            $('#tj_cgthe').text(ztj_data['cgthje'] || 0);//采购退货额
            if (ztj_data['cgje'] > 0 || ztj_data['cgthje'] > 0) {
                $('.cg').show();
            } else {
                $('.cg').hide();
            }

            $('#tj_jge').text(ztj_data['jgje'] || 0);//加工额 1
            $('#tj_jgthe').text(ztj_data['jgthje'] || 0);//加工退货额 1
            // $('#tj_ske').text(ztj_data['fkje'] || 0);//付款额
            $('#tj_ske').text((parseFloat(ztj_data['fkje'] || 0) - parseFloat(ztj_data['skje'] || 0) - parseFloat(ztj_data['ddj'] || 0)).fixed(4) || 0);//收款额
            $('#tj_qte').text(parseFloat(ztj_data['fyje'] + ztj_data['tzje'] + ztj_data['zcje'] - ztj_data['srje']).fixed(4) || 0);//其他额
            $('#tj_lc').text(ztj_data['wldw_ljqk'] || 0);//累欠
            break;
        case 'wl':
            $('#tj_xse').text((ztj_data['cgyf'] + ztj_data['xsyf'] + ztj_data['jgyf']) || 0);//运费
            $('#tj_the').text((ztj_data['fyje'] + ztj_data['tzje']) || 0);//其它
            // $('#tj_ske').text(ztj_data['fkje'] || 0);//付款
            $('#tj_ske').text((parseFloat(ztj_data['fkje'] || 0) - parseFloat(ztj_data['skje'] || 0)).fixed(4) || 0);//收款额
            $('#tj_lc').text(ztj_data['wldw_ljqk'] || 0);//累欠
            break;
    }
    var line_arr = $('.all:visible');
    $.each(line_arr, function (i) {
        if ((i + 1) % 3 != 0 && (i + 1) != line_arr.length) {
            $(this).addClass('line');
        }
    });
    switch (page_type) {
        case 'kh':
            createKhHtml(data);
            break;
        case 'gys':
            createGysHtml(data);
            break;
        case 'jgs':
            createJgsHtml(data);
            break;
        case 'wl':
            //添加物流功能：先获取当前物流的数据
            curPageData = data;
            createWlHtml(data);
            break;
    }
}

/** 寻找用户选中的是哪个物流信息
 * @param {*} selectid 选中物流id
 */
function findSelectData(selectid, $curPageData) {

    for (var k in $curPageData) {
        var obj = $curPageData[k];
        if (obj['wldw_id'] == selectid) {
            return obj;
        }
    }
    return [];
}

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    // console.log(JSON.stringify(search_storage))
    var sideslip = fun.getItem(html_name + 'sideslip');
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

/** 计算物流单据 头部信息
 * @param {*} selectWlObj 当前用户选中的物流信息
 */
function countWLDJTopInfo(selectWlObj) {
    var yf = (parseFloat(selectWlObj['xsyf'] || 0) + parseFloat(selectWlObj['cgyf'] || 0) + parseFloat(selectWlObj['jgyf'] || 0));
    // var qt = (parseFloat(selectWlObj['fkje'] || 0) - parseFloat(selectWlObj['skje'] || 0));
    var qt = (parseFloat(selectWlObj['fyje'] || 0) + parseFloat(selectWlObj['tzje'] || 0));
    var ysje = yf + qt;
    var fkje = (parseFloat(selectWlObj['fkje'] || 0) - parseFloat(selectWlObj['skje'] || 0));

    return {
        qqje: selectWlObj['wldw_qqje'],
        ysje: ysje,
        fkje: fkje,
        lqje: selectWlObj['wldw_ljqk'],
    }
}

// function getDldjTopInfo(list) {
//     var qqje = list['wldw_qqje'] || 0;
//     var ysje = 0;
//     var fkje = (page_type === 'wl') ? parseFloat(parseFloat(list['fkje'] || 0) - parseFloat(list['skje'] || 0)).fixed(4) : parseFloat(parseFloat(list['skje'] || 0) - parseFloat(list['fkje'] || 0)).fixed(4);
//     var lqje = list['wldw_ljqk'] || 0;
// }


//打开单据页面
$('body').on('tap', '.supplier', function (e) {
    if (AuthVersionCheck.checkHide('dzbmx')) return;

    //添加物流功能：
    var select_wlObj = findSelectData($(this).attr('wldw_id'), curPageData);
    var wldj_top = countWLDJTopInfo(select_wlObj);
    // var list = $(this).data('list') || {};
    // var wldj_top = getDldjTopInfo(list);
    fun.showPageFull({
        page_url: page_arr.cw_khdz_dj,
        pageParam: {
            return_page: html_name,
            wldw_type: page_data['page_type'],
            wldw_id: $(this).attr('wldw_id'),
            wldw_mc: $(this).attr('wldw_mc'),
            begin_time: search_data['begin_time'],
            end_time: search_data['end_time'],
            global_search: global_search,

            //添加物流功能: 把 前欠、应收、付款、累欠 传递给 单据页面
            top_data: wldj_top

        }
    });
})
