var headerH;
var page_list = [];
var temps, ztj_data = [];
var html_name = page_arr.cw_nbzz;
$('#header').header({
    back: true,
    title: '内部转账',
    add: Auth.check('cw_nbzz', 'edit'),
    filter: true,
});

var date_arr = fun.getDateArr(),
    to_month = fun.getLatelyTime(1,false), //获取本月第一天和最后一天
    search_data = {
        'begin_time': fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        'end_time': fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    },
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getData();
        }
    });

var USER_INFO = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var hnh = html_name + '_';
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(hnh + 'hz') || '')
    search_data = $.extend(true, {
        'hldj': fun.getItem(html_name + '_hldj', 0),
        'xsmx': fun.getItem(html_name + '_xsmx', 0),
        "hz": {
            "choose": {
                "zczh": fun.getItem(hnh + 'zczh', 0),
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "zrzh": fun.getItem(hnh + 'zrzh', 0),
            },
            "text": fun.getItem(hnh + 'text', ""),
        }
    }, search_data);
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'search':
                search_data['begin_time'] = temp['data']['begin_date'];
                search_data['end_time'] = temp['data']['end_date'];
                date_bar.setDate({
                    begin_date: search_data['begin_time'],
                    end_date: search_data['end_time']
                });
                search_data['keyword'] = temp['data']['LIKE_DATA'] || '';
                search_data['zc_zh_id'] = temp['data']['zh']['id'] || '';//收款账户id
                search_data['zc_zh_mc'] = temp['data']['zh']['text'] || '';//收款账户id
                search_data['md_id'] = temp['data']['md']['id'] || '';//门店
                search_data['md_mc'] = temp['data']['md']['text'] || '';//门店
                search_data['order'] = {};
                search_data['order']['je'] = temp['data']['je'] || '';

                search_data['hldj'] = temp['data']['hldj'];
                search_data['xsmx'] = temp['data']['xsmx'];
                fun.setItem(html_name + '_hldj', search_data['hldj']);
                fun.setItem(html_name + '_xsmx', search_data['xsmx']);

                //汇总功能
                search_data['group'] = temp['data']['hz']['group'] || '';
                search_data['hz'] = temp['data']['hz'];
                var hc = temp['data']['hz']['choose'];
                fun.setItem(hnh + 'zczh', hc['zczh']);
                fun.setItem(hnh + 'zrzh', hc['zrzh']);
                fun.setItem(hnh + 'md_mc', hc['md_mc']);
                fun.setItem(hnh + 'skzh', hc['skzh']);
                fun.setItem(hnh + 'text', temp['data']['hz']['text']);
                fun.setItem(hnh + 'hz', search_data['group']);

                fun.setItem(html_name + 'sideslip', true);

                getData();
                break;
            case 'refresh':
                getData();
                break;
        }
    });
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showData(fun.PagingData(page_list, 5) || []);
        }
        else {
            fun.createBottomLine('order_list', ".list-right");
        }
    });
    getData();
}

function getData() {
    page_list = [];
    temps = $.extend({
        "keyword": "",
        "begin_time": "",
        "end_time": "",
        "md_id": 0,
        "md_mc": "",
        "zc_zh_id": 0,
        "zc_zh_mc": "",
        "order": {
            "je": "",
        }
    }, search_data);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getNbzztj,
        data: temps,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    if (!res['data'] || res['data'].length == 0) {
                        $('#tj1').text(0);
                        $('#tj2').text(0);
                        // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                        return fun.createDataEmptyTips({ dom: '#order_list', btnText: '新增内部转账单', auth: 'cw_nbzz' });
                    }
                    page_list = res.data;
                    ztj_data = res.info;
                    $('#order_list').empty();
                    showData(fun.PagingData(page_list, 5));
                    break;
                default:
                    // fun.alert({msg: res['msg']});
                    fun.toast(res['msg']);
                    break;
            }
        }
    });
}

// 内部转账-开单
// $('body').on('tap','#add_btn',function(){
// 	fun.showPageFull({
// 		page_url:page_arr.cw_nbzz_kd,
// 		pageParam:{}
// 	});
// });

// $('body').on('click','.list',function(){
//   fun.showPageFull({
//     page_url:page_arr.cw_nbzz_kd,
//     pageParam:{
//       dh:$(this).data('dh'),
//       id:$(this).data('id'),
//       zdr:$(this).data('zdr'),
//       kdsj:$(this).data('kdsj'),
//     }
//   });
// });
fun.setItem(html_name + 'sideslip', true);
//打开搜索框
$('body').on('tap', '#filter_btn', function () {
    var n = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": (temps && temps['keyword'] ? temps['keyword'] : ''),
            "placeholder": "单号"
        },
        "time": {
            "begin_date": search_data['begin_time'],
            "end_date": search_data['end_time']
        },
        "choose_merchants": [{
            key: "zh",
            "text": "转出账户",
            "value": (temps && temps['zc_zh_mc'] ? temps['zc_zh_mc'] : ''),
            "id": (temps && temps['zc_zh_id'] ? temps['zc_zh_id'] : ''),
        }, {
            key: "md",
            "text": "门店",
            "value": (temps && temps['md_mc'] ? temps['md_mc'] : ''),
            "id": (temps && temps['md_id'] ? temps['md_id'] : '')
        },
        {
            key: "hz",
            "text": "汇总",
            group: [
                { key: 'zrzh', name: '转入账户', columns: 'zr_zh_id,zr_zh_mc,zr_zh_tb,zr_zh_num', choose: getHz('zrzh') },
                { key: 'zczh', name: '转出账户', columns: 'zc_zh_id,zc_zh_mc,zc_zh_tb,zc_zh_num', choose: getHz('zczh') },
                // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                // { key: 'wldw', name: '类型', columns: 'wldw_lb', choose: getHz('wldw') },
            ],
            "value": getTwo('hz', 'text'),
        }],
        "switch": [
            { "text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_data['xsmx'] },
            { "text": "合拢单据", "max_width": true, "key": "hldj", "value": search_data['hldj'] },
        ],
        "sort": [{
            "text": "金额",
            "key": "je",
            "value": (temps && temps['order']['je'] ? temps['order']['je'] : '')
        }],
    };
    if (n) {
        fun.setItem(html_name + 'sideslip', false)
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

function getHz(key, def) {
    def = def || 0;
    return (search_data['hz'] && search_data['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_data[key] && search_data[key][son]) || def;
}
function showData(data) {
    $('#tj1').text(ztj_data[0]['je'] || 0);
    $('#tj2').text(ztj_data[0]['sxf'] || 0);
    var list_html = [];
    //红，黄，蓝，绿，水蓝
    var bg_color = [['#FF9277', '#FE5567'], ['#FFD077', '#FF9055'], ['#64CEFF', '#248CFF'], ['#29D986', '#19A965'], ['#00D6BC', '#0190BA']];
    var bank_icon = [
        ['beijing', 'gonghang', 'guangfa', 'guangzhou', 'huaxia', 'huifeng', 'zhaoshang', 'zhonghang', 'zhoangxin'],
        ['guangda', 'ningbo', 'pingan', 'qita', 'xianjin', 'zheshang'],
        ['jianhang', 'jiangsu', 'jiaohang', 'minsheng', 'pufa', 'shanghai', 'shenfa', 'xingye', 'zhifubao'],
        ['weixin', 'youchu'],
        ['nonghang', 'wangshang']
    ];
    var hldj = $.nui.isEmpty(fun.getItem(html_name + '_hldj', 0));
    var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;
    var isExpand = hldj ? '' : 'display:none;';
    var isNoExpand = xsmx ? '' : 'display:none;';

    var isNoBar = xsmx ? '' : 'title-border';
    var isBar = hldj ? '' : 'title-border';
    for (var i = 0; i < data.length; i++) {
        var group_data = fun.getItem(html_name + '_' + 'hz');
        var zc_zh = -1;
        var zr_zh = -1;

        if (group_data != null) {
            // var md=group_data.indexOf('md_id');
            zc_zh = group_data.indexOf('zc_zh_id');
            zr_zh = group_data.indexOf('zr_zh_id');
        }
        // if (!data[i]['is_zf']) {
        //     list_html.push('<div class="list" data-zdr="' + fun.is_value(data[i]['zdr_mc']) + '" data-dh="' + fun.is_value(data[i]['dh']) + '" data-kdsj="' + fun.is_value(data[i]['kdsj']) + '" data-id="' + fun.is_value(data[i]['dj_id']) + '">');
        //     list_html.push('    <div class="list-left">');
        //     list_html.push('        <span class="lines-dot"></span>');
        //     list_html.push('        <hr class="lines">');
        //     list_html.push('    </div>');
        //     list_html.push('    <div class="list-right">');
        //     list_html.push('        <div class="right-head">');
        //     list_html.push((group_data==''||group_data==null)?'            <p class="head-top">':'');
        //     list_html.push((group_data==''||group_data==null)?'                <span class="zz-info color1">' + fun.is_value(data[i]['kdsj']) + '</span>':'');
        //     list_html.push((group_data==''||group_data==null)?'           <span class="zz-info"><em class="zz-md">' + fun.is_value(data[i]['md_mc']) + '</em><em class="zz-person">' + fun.is_value(data[i]['zdr_mc']) + '</em></span>':'');
        //     list_html.push((group_data==''||group_data==null)?'            </p>':'');
        //     list_html.push('            <p class="head-bot">');
        //     list_html.push('                <span class="zz-info zz-je">金额<em class="je">&nbsp;&nbsp;' + fun.is_value(data[i]['je']) + '</em></span>');
        //     list_html.push((group_data==''||group_data==null)?'                <span class="zz-info zz-order">' + fun.is_value(data[i]['dh']) + '</span>':md!=-1?'           <span class="zz-info"><em class="zz-md">' + fun.is_value(data[i]['md_mc']) + '</em><em class="zz-person">' + fun.is_value(data[i]['zdr_mc']) + '</em></span>':'');
        //     list_html.push('            </p>');
        //     list_html.push('        </div>');

        //     list_html.push('        <div class="right-bank" data-list=\'' + JSON.stringify(data[i]) + '\'>');
        //     list_html.push('            <ul>');
        //     if(zc_zh>-1||(group_data==''||group_data==null)){
        //         if (!!fun.is_value(data[i]['zc_zh_tb'])) {
        //             var zc = getIndexs(bank_icon, fun.is_value(data[i]['zc_zh_tb']));
        //             list_html.push('            <li class="bank-info" style="background:linear-gradient(to right,' + bg_color[zc][0] + ', ' + bg_color[zc][1] + ');">');
        //         }
        //         list_html.push('                    <div class="bankImg">');
        //         list_html.push('                        <img src="../img/bank/' + fun.is_value(data[i]['zc_zh_tb']) + '" alt="">');
        //         list_html.push('                    </div>');
        //         list_html.push('                    <div class="bankCon">');
        //         list_html.push('                        <span class="bank-name">' + fun.is_value(data[i]['zc_zh_mc']) + '</span>');
        //         list_html.push('                        <span class="bank-out">转出</span>');
        //         list_html.push('                        <div class="service-type">');
        //         list_html.push((zc_zh==-1&&(group_data!=''||group_data!=null))?'                            <span class="service">前存 <em class="service-money">' + fun.is_value(data[i]['zc_qcje']) + '</em></span>':'');
        //         list_html.push((zc_zh==-1&&(group_data!=''||group_data!=null))?'                            <span class="service rights">手续费 <em class="service-money">' + fun.is_value(data[i]['sxf']) + '</em></span>':'<span class="service rights" style="margin:0">手续费 <em class="service-money">' + fun.is_value(data[i]['sxf']) + '</em></span>');
        //         list_html.push((zc_zh==-1&&(group_data!=''||group_data!=null))?'                            <span class="service">累存 <em class="service-money">' + fun.is_value(data[i]['zc_ljqk']) + '</em></span>':'');
        //         list_html.push('                        </div>');
        //         list_html.push('                        <p><span class="bank-card">' + fun.dealCard(data[i]['zc_zh_num']) + '</span></p>');
        //         // list_html.push('<p><span class="bank-card">****</span><span class="bank-card">****</span><span class="bank-card">****</span><span class="bank-card">****</span></p>');
        //         list_html.push('                        <img src="../img/bank2/' + fun.is_value(data[i]['zc_zh_tb']) + '" alt="">');
        //         list_html.push('                    </div>');
        //         list_html.push('                </li>');
        //     }

        if (!data[i]['is_zf']) {
            list_html.push('    <div class="list-right margin-3top ' + (isBar || isNoBar) + '">');
            list_html.push('        <div class="right-head">');
            list_html.push((group_data == '' || group_data == null) ? '            <p class="head-top">' : '');
            list_html.push('                                                   <span class="zz-je">&nbsp;&nbsp;金额<em class="je color1">&nbsp;￥' + fun.is_value(data[i]['je']) + '</em></span>');
            list_html.push((group_data == '' || group_data == null) ? '                <span class="zz-info font-ss"><em class="align-right width1">' + fun.formatTime(data[i]['kdsj']) + '</em><em class="zz-person">' + fun.is_value(data[i]['zdr_mc']) + '</em><em class="shen align-right">' + fun.createIsShLabelHtml(data[i]['is_sh']) + '</em></span>' : '');
            list_html.push((group_data == '' || group_data == null) ? '            </p>' : '');
            list_html.push('        </div>');

            list_html.push('        <div  style="' + (isExpand || isNoExpand) + '" class="right-bank" data-list=\'' + fun.formatString(JSON.stringify(data[i])) + '\'>');
            list_html.push('            <ul>');
            if (zc_zh > -1 || (group_data == '' || group_data == null)) {
                if (!!fun.is_value(data[i]['zc_zh_tb'])) {
                    var zc = getIndexs(bank_icon, fun.is_value(data[i]['zc_zh_tb']));
                    list_html.push('            <li class="bank-info" style="background:linear-gradient(to right,' + bg_color[zc][0] + ', ' + bg_color[zc][1] + ');">');
                }
                list_html.push('                    <div class="bankImg">');
                list_html.push('                        <img src="../img/bank/' + fun.is_value(data[i]['zc_zh_tb']) + '" alt="">');
                list_html.push('                    </div>');
                list_html.push('                    <div class="bankCon">');
                list_html.push('                        <span class="bank-name">' + fun.is_value(data[i]['zc_zh_mc']) + '</span>');
                list_html.push('                        <span class="bank-out">转出</span>');
                list_html.push('                        <div class="service-type">');
                //【账户-显示存款】有开启
                if(Auth.check('zh_xsck','view')) {
                    list_html.push((zc_zh == -1 && (group_data != '' || group_data != null)) ? '                            <span class="service">前存 <em class="service-money">' + fun.is_value(data[i]['zc_qcje']) + '</em></span>' : '');
                    list_html.push((zc_zh == -1 && (group_data != '' || group_data != null)) ? '                            <span class="service rights">手续费 <em class="service-money">' + fun.is_value(data[i]['sxf']) + '</em></span>' : '<span class="service rights" style="margin:0">手续费 <em class="service-money">' + fun.is_value(data[i]['sxf']) + '</em></span>');
                    list_html.push((zc_zh == -1 && (group_data != '' || group_data != null)) ? '                            <span class="service">累存 <em class="service-money">' + fun.is_value(data[i]['zc_ljqk']) + '</em></span>' : '');
                }else{
                    list_html.push((zc_zh == -1 && (group_data != '' || group_data != null)) ? '                            <span class="service">手续费 <em class="service-money">' + fun.is_value(data[i]['sxf']) + '</em></span>' : '<span class="service rights" style="margin:0">手续费 <em class="service-money">' + fun.is_value(data[i]['sxf']) + '</em></span>');
                }
                list_html.push('                        </div>');
                list_html.push('                        <p><span class="bank-card">' + fun.dealCard(data[i]['zc_zh_num']) + '</span></p>');
                list_html.push('                        <img src="../img/bank2/' + fun.is_value(data[i]['zc_zh_tb']) + '" alt="">');
                list_html.push('                    </div>');
                list_html.push('                </li>');
            }

            //
            if (zr_zh > -1 || (group_data == '' || group_data == null)) {
                if (!!fun.is_value(data[i]['zr_zh_tb'])) {
                    var zr = getIndexs(bank_icon, fun.is_value(data[i]['zr_zh_tb']));
                    list_html.push('            <li class="bank-info" style="background:linear-gradient(to right,' + bg_color[zr][0] + ', ' + bg_color[zr][1] + ');">');
                }
                list_html.push('                    <div class="bankImg">');
                list_html.push('                        <img src="../img/bank/' + fun.is_value(data[i]['zr_zh_tb']) + '" alt="">');
                list_html.push('                    </div>');
                list_html.push('                    <div class="bankCon">');
                list_html.push('                        <span class="bank-name enter-bank-name">' + fun.is_value(data[i]['zr_zh_mc']) + '</span>');
                list_html.push('                        <span class="bank-out enter">转入</span>');
                //【账户-显示存款】有开启
                if(Auth.check('zh_xsck','view')) {
                    list_html.push('                        <div class="service-type">');
                    list_html.push((zr_zh == -1 && (group_data != '' || group_data != null)) ? '                            <span class="service">前存 <em class="service-money">' + fun.is_value(data[i]['zr_qcje']) + '</em></span>' : '<span class="service"></span>');
                    list_html.push((zr_zh == -1 && (group_data != '' || group_data != null)) ? '                            <span class="service en">累存 <em class="service-money">' + fun.is_value(data[i]['zr_ljqk']) + '</em></span>' : '<span class="service"</span>');
                    list_html.push('                        </div>');
                }
                list_html.push('                        <p><span class="bank-card">' + fun.dealCard(data[i]['zr_zh_num']) + '</span></p>');
                list_html.push('                        <img src="../img/bank2/' + fun.is_value(data[i]['zr_zh_tb']) + '" alt="">');
                list_html.push('                    </div>');
                list_html.push('                </li>');
            }
            list_html.push('            </ul>');
            list_html.push('        </div>');
            list_html.push('    </div>');
            list_html.push('</div>');
        }
    }
    $('#order_list').append(list_html.join(''));
    $('.list:last-child').css('padding-bottom', '1rem');
    $('.list-right:first').removeClass('margin-3top');
    //【账户-显示存款】没有开启
    if(!Auth.check('zh_xsck','view')){
        $('.enter-bank-name').css('top','20%');
    }
    $('.right-head').each(function () {
        if (!xsmx) return;
        $(this).on('tap', function () {
            $(this).siblings('.right-bank').stop().slideToggle();
            if($(this).parent('.list-right').hasClass('title-border')){
                $(this).parent('.list-right').removeClass('title-border');
            }else{
                // if(!_options['isExpand']) return;
                $(this).parent('.list-right').addClass('title-border');
            }
        });
    });
}

//判断数据是否存在于数组中，并返回对应的颜色
function getIndexs(arr1, value) {
    if (!!value.indexOf('.')) value = value.substr(0, value.indexOf('.'));
    for (var i = 0; i < arr1.length; i++) {
        if (arr1[i].indexOf(value) !== -1) {
            return i;
        }
    }
}

//跳转到开单页面
$('body').on('tap', '.right-bank', function () {
    if (!fun.checkKz()) return;
    var data_list = $(this).data('list') || {};
    if (!!data_list['dj_id']) {
        fun.showPageFull({
            page_url: page_arr.cw_nbzz_kd,
            pageParam: {
                return_page: html_name,
                id: data_list['dj_id'],
                dh: data_list['dh'],
                kdsj: data_list['kdsj'],
                zdr_mc: data_list['zdr_mc'],
            }
        })
    }
})
$('body').on('tap', '#add_btn', function () {
    if (!fun.checkKz()) return;
    fun.showPageFull({
        page_url: page_arr.cw_nbzz_kd,
        pageParam: {
            return_page: html_name
        }
    })
})
$('body').on('click','.list-right',function(){
    if (fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var data_list = $(this).children('.right-bank').data('list') || {};
    if (!!data_list['dj_id']) {
        fun.showPageFull({
            page_url: page_arr.cw_nbzz_kd,
            pageParam: {
                return_page: html_name,
                id: data_list['dj_id'],
                dh: data_list['dh'],
                kdsj: data_list['kdsj'],
                zdr_mc: data_list['zdr_mc'],
            }
        });
    }
})