var html_name = page_arr.cw_rbb, temps,
    date_arr = fun.getMonthArr(6),
    to_month = fun.getMonthArr(1)[0], //获取本月第一天和最后一天
    search_data = {
        'begin_time': fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        'end_time': fun.Date(to_month['end_date']).Format('yy-mm-dd'),
        // "type": "tj_rbb",
    },
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            // $('#daily_list').empty();
            fun.clearPage($('#daily_list'));
            getData();
        }
    }),
    page_list = [];
$('#header').header({
    back: true,
    title: '日报表',
    filter: true,
});

// var html_name = 'bills_list',
//     date_arr = fun.getMonthArr(6),
//     date_bar = $('#date_bar').dateBar({
//         'data': date_arr,
//         'tap': function (ret) {
//             var begintime = fun.Date(ret['begin_date']).Format('yy-mm-dd');
//             var endtime = fun.Date(ret['end_date']).Format('yy-mm-dd');
//         }
//     });

// var headerH,inputH,html_name=page_arr.cw_rbb;

var USER_INFO = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');

    getData();
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'search':
                search_data['begin_time'] = temp['data']['begin_date'];
                search_data['end_time'] = temp['data']['end_date'];
                date_bar.setDate({
                    begin_date: search_data['begin_time'],
                    end_date: search_data['end_time']
                });
                search_data['md_id'] = temp['data']['md']['id'] || '';
                search_data['md_mc'] = temp['data']['md']['text'] || '';

                fun.setItem(html_name + 'sideslip', true);

                // $('#daily_list').empty();
                fun.clearPage($('#daily_list'));
                getData();
                break;
            case "refresh":
                // $('#daily_list').empty();
                fun.clearPage($('#daily_list'));
                getData();
                break;
        }
    });
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('daily_list', ".daily-list");
        }
    });


//   var header = $api.byId('header');
//   headerH = $api.offset(header).h;
//   //接收搜索页值
//   api.addEventListener({
//       name:html_name
//   },function(ret,err){
//   });
}

//将数字转换成金额显示
function toMoney(num) {
    num = Number(num).fixed(2);
    num = parseFloat(num)
    num = num.toLocaleString();
    return num; //返回的是字符串23,245.12保留2位小数
}

//获取数据
function getData() {
    page_list = [];
    fun.load_DATA_LIST(['zh'], '', {async: false});
    //查询条件
    temps = $.extend({
        "begin_time": "",
        "end_time": "",
        "md_id": 0
    }, search_data);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getRbb,
        data: temps,
        success: function (res) {
            if (!res['data'] || res['data'].length == 0) {
                $('#zxse').text(0);
                $('#zsk').text(0);
                $('#zqk').text(0);
                $('.daily').css({'height': '70%', 'position': 'fixed'});
                // return $('#daily_list').html('<p class="empty_text">暂无数据！</p>');
                return fun.createDataEmptyTips({dom:'#daily_list',btnShow:false,style:'height:9rem;top:-1.5rem;'});
            } else {
                fun.clearPage($('#daily_list'));
                var info = res['info'] || {};
                $('#zxse').text(res['info']['xs_zje'] || 0);
                $('#zsk').text(res['info']['zh_zje'] || 0);
                $('#zqk').text(res['info']['qk'] || 0);
                $('.daily').css({'height': 'auto', 'position': 'unset'});
                page_list = res.data;
                showList(fun.PagingData(page_list));
            }
        }
    });
};

//显示数据
function showList(data) {
    var listHtml = [];
    for (var i = 0; i < data.length; i++) {
        var record = data[i];
        //分割时间
        var date = record['kdsj'] || undefined;
        date && (date = date.replace(/[-\/]/ig, '-'))
        var dates = date.split('-');
        var dd = dates[2],
            yy = dates[0],
            mm = dates[1];
        var xse = record['xs_zje'] || 0,
            sk = record['zh_zje'] || 0,
            qk = record['qk'] || 0,
            xs_ps = record['xs_zps'] || 0,
            xs_sl = record['xs_zsl'] || 0,
            fy_je = toMoney(record['fy']) || 0;
        // var zh = JSON.stringify(record).indexOf("zh_");
        // var dates = date.split(''),
        //  var dd = $.nui.dayjs(date).date(),
        //     yy = $.nui.dayjs(date).year(),
        //     mm = $.nui.dayjs(date).month();
        listHtml.push('<div class="daily-list">');
        listHtml.push('   <div class="list-info">');
        if (record['md_mc'] != null) {
            listHtml.push('   <span class="shop-name">' + record['md_mc'] + '</span>');
        }
        listHtml.push('       <div class="head-box">')
        listHtml.push('         <span class="list-head">');
        listHtml.push('             <span class="da-head m"><i>' + dd + '</i>号</span>');
        listHtml.push('             <em class="date-info">' + yy + '年' + mm + '月</em>');
        listHtml.push('         </span>');
        listHtml.push('         <span class="list-head">');
        listHtml.push('             <span class="da-head seal">销售额</span>');
        listHtml.push('             <em class="em">' + xse + '</em>');
        listHtml.push('         </span>');
        listHtml.push('         <span class="list-head">');
        listHtml.push('             <span class="da-head gather">收款</span>');
        listHtml.push('             <em class="em">' + sk + '</em>');
        listHtml.push('         </span>');
        listHtml.push('         <span class="list-head">');
        listHtml.push('             <span class="da-head debt">欠款</span>');
        listHtml.push('             <em class="em">' + qk + '</em>');
        listHtml.push('         </span>');
        listHtml.push('       </div>');
        listHtml.push('    </div>');
        listHtml.push('   <div class="detail-list">');
        listHtml.push('       <ul>');
        listHtml.push('           <li class="detail sale">');
        listHtml.push('               <div class="detail-icon">');
        listHtml.push('                    <span class="detail-img">销</span>');
        listHtml.push('               </div>');
        listHtml.push('                   <div class="detail-data">');
        listHtml.push('                       <span class="pi">' + xs_ps + '匹</span>');
        // listHtml.push('                       <span class="quantity"><em calss="number">数量</em><em class="quan sales-figures">'+ xs_sl +'</em></span>');
        listHtml.push('                       <span class="quantity">数量 <em class="sales-figures" style="color: #000;">' + xs_sl + '</em></span>');
        listHtml.push('                   </div>');
        listHtml.push('           </li>');
        listHtml.push('           <li class="detail cost">');
        listHtml.push('               <div class="detail-icon">');
        listHtml.push('                  <span class="detail-img img1">费</span>');
        listHtml.push('               </div>');
        listHtml.push('                   <div class="detail-data">');
        listHtml.push('                       <span class="pi">费用</span>');
        listHtml.push('                       <em class="quan">￥' + fy_je + '</em>');
        listHtml.push('                   </div>');
        listHtml.push('           </li>');
        for (var key in record) {
            if (key.indexOf('__zh_') > -1) {
                var zh_id = key.split('__zh_')[1];
                if(isNaN(Number(zh_id))) continue;
                var zh_list = fun.getItem('zh_list') || [];
                var zh_info = fun.getListInfoByKey(zh_list || [], zh_id);
                var icon = zh_info['icon'] || '',
                    name = zh_info['name'] || '',
                    zh_je = toMoney(record['__zh_' + zh_id]) || 0;
                // zh_je = record['__zh_'+zh_id] || 0;
                if (!$.nui.isEmpty(zh_je)) {
                    listHtml.push('           <li class="detail">');
                    listHtml.push('               <div class="detail-icon">');
                    listHtml.push('                   <img src="../img/bank/' + icon + '" class="account-icon" />');
                    listHtml.push('               </div>');
                    listHtml.push('               <div class="detail-data">');
                    listHtml.push('                   <span class="pi">' + name + '</span>');
                    listHtml.push('                   <em class="quan">￥' + zh_je + '</em>');
                    listHtml.push('               </div>');
                    listHtml.push('           </li>');
                }
            }
        }
        listHtml.push('       </ul>');
        listHtml.push('    </div>');
        listHtml.push('</div>');

    }
    $('#daily_list').append(listHtml.join(''));

    //展开列表
    var detailList = $('.detail-list');
    detailList.hide();
}


fun.setItem(html_name + 'sideslip', true);
//打开搜索框
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "time": {
            "begin_date": search_data['begin_time'],
            "end_date": search_data['end_time']
        },
        "choose_merchants": [{
            key: "md",
            "text": "门店",
            "value": (temps && temps['md_mc'] ? temps['md_mc'] : ''),
            "id": (temps && temps['md_id'] ? temps['md_id'] : '')
        }],
    };
    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

//展开列表
$('body').on('tap', '.list-info', function (e) {
    e.stopPropagation();
    $(this).siblings().addClass('list-active');
    $('.detail-list:not(".list-active")').hide();
    $(this).siblings().toggle();
    $(this).siblings().removeClass('list-active');
});


function __checkData() {
    if (!fun.dataIsRead(['zh'])) {
        setTimeout(__checkData, 250);
    } else {
        setTimeout(function () {
            if (typeof page_init === "function") page_init();
        }, 100);
    }
}
