var html_name = page_arr.cw_sfkd_tj;
var through;
var date_arr = fun.getDateArr(),
    to_month = fun.getLatelyTime(1,false), //获取本月第一天和最后一天
    search_data = {
        'begin_time': fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        'end_time': fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    },
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            $('#order_list').empty();
            initPage(page_data.obj);
        }
    }),
    merchants_opt = [],
    page_list = [],
    sum_info = {};

var USER_INFO = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    // setTimeout(function () {
    //     fun.showLoad();
    // },200);
    // fun.load_DATA_LIST(['zh'],function () {
    //     fun.hideLoad();
    // });

    var title, obj;
    title = page_data.title;
    obj = page_data.obj;
    through = obj;
    //防止页面没传page_data;
    if (through != 'skd') through = 'fkd';
    search_data['group'] = (fun.getItem(obj + '_' + 'hz') || '');
    search_data = $.extend(true, {
        'hldj': fun.getItem(obj + '_hldj', 0),
        'xsmx': fun.getItem(obj + '_xsmx', 0),
        "hz": {
            "choose": {
                "wldw": fun.getItem(obj + 'wldw', 0),
                "md_mc": fun.getItem(obj + 'md_mc', 0),
                "skzh": fun.getItem(obj + 'skzh', 0),
            },
            "text": fun.getItem(obj + 'text', ""),
        }
    }, search_data);
    $('#header').header({
        back: true,
        title: title,
        add: Auth.check((obj == 'skd') ? "cw_skd" : "cw_fkd", 'edit'),
        filter: true
    });

    if (obj == 'skd') {
        merchants_opt = [
            {"name": "客户", "column": "kh", "is_choose": 1},
            {"name": "供应商", "column": "gys", "is_choose": 0},
            {"name": "加工商", "column": "jgs", "is_choose": 0},
            {"name": "物流", "column": "wl", "is_choose": 0}
        ]
    } else {
        merchants_opt = [
            {"name": "客户", "column": "kh", "is_choose": 0},
            {"name": "供应商", "column": "gys", "is_choose": 1},
            {"name": "加工商", "column": "jgs", "is_choose": 0},
            {"name": "物流", "column": "wl", "is_choose": 0}
        ]
    }


    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');


    initPage(obj);
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'],
            data = temp['data'];
        switch (temp['status']) {
            case 'search':
                search_data['begin_time'] = data['begin_date'];
                search_data['end_time'] = data['end_date'];
                date_bar.setDate({
                    begin_date: search_data['begin_time'],
                    end_date: search_data['end_time']
                });
                search_data['keyword'] = data['keyword'] || '';

                search_data['wldw_id'] = data['merchants']['wldw_id'] || 0;
                search_data['wldw_mc'] = data['merchants']['wldw_mc'] || "";
                merchants_opt = data['merchants']['list'];//客商列表选择值
                // if(obj=='skd'){
                //     search_data['wldw_id']=temp['data']['kh']['id'] || '';
                //     search_data['wldw_mc']=temp['data']['kh']['text'] || '';
                // }else{
                //     search_data['wldw_id']=temp['data']['gys']['id'] || '';
                //     search_data['wldw_mc']=temp['data']['gys']['text'] || '';
                // }
                search_data['zh_id'] = data['zh']['id'] || '';//收款账户id
                search_data['zh_mc'] = data['zh']['text'] || '';//收款账户名称
                search_data['md_id'] = data['md']['id'] || '';
                search_data['md_mc'] = data['md']['text'] || '';
                search_data['order'] = {};
                search_data['order']['je'] = data['je'] || '';

                search_data['hldj'] = data['hldj'];
                search_data['xsmx'] = data['xsmx'];

                fun.setItem(obj + '_hldj', search_data['hldj']);
                fun.setItem(obj + '_xsmx', search_data['xsmx']);

                //汇总功能
                search_data['group'] = data.hz['group'] || '';
                search_data['hz'] = data.hz;
                var hc = data['hz']['choose'];
                fun.setItem(obj + 'wldw', hc['wldw']);
                fun.setItem(obj + 'md_mc', hc['md_mc']);
                fun.setItem(obj + 'skzh', hc['skzh']);
                fun.setItem(obj + 'text', data.hz['text']);
                //  if(obj!='skd'&&data.hz['group']!=''){
                //     var group_data=search_data['group'];
                //     group_data +=',fy_id,fy_mc';
                //     search_data['group']=group_data;
                //  }
                fun.setItem(obj + '_' + 'hz', search_data['group']);

                fun.setItem(html_name + 'sideslip', true);

                $('#order_list').empty();
                initPage(obj, data);
                break;
            case "refresh":
                $('#order_list').empty();
                initPage(obj, data);
                break;
        }
    });
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList((fun.PagingData(page_list) || []),obj);
        } else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
}

//初始化界面
function initPage(obj) {
    var url;
    var temp = $.extend({
        "keyword": "",
        "begin_time": "",
        "end_time": "",
        "wldw_id": 0,
        "wldw_mc": "",
        "md_id": 0,
        "md_mc": "",
        "zh_id": 0,
        "zh_mc": "",
        "order": {
            "je": "",
        }
    }, search_data);
    fun.setItem(html_name + 'sideslip', true);
    switch (obj) {
        case 'skd':
            openOrderPage('收款单', obj);
            $('.number-title').text('总收款');
            url = AJAX_URL.getSkdtj;
            //打开搜索页
            $('body').off('tap', '#filter_btn').on('tap', '#filter_btn', function () {
                var sideslip = fun.getItem(html_name + 'sideslip');
                var options = {
                    "keywords": {
                        "key": "keyword",
                        "value": (temp && temp['keyword'] ? temp['keyword'] : ''),
                        "placeholder": "单号"
                    },
                    "time": {
                        "begin_date": search_data['begin_time'],
                        "end_date": search_data['end_time']
                    },
                    "choose_merchants": [{
                        "key": "merchants",
                        "text": "客户",
                        "value": (search_data && search_data['wldw_mc'] ? search_data['wldw_mc'] : ''),
                        "id": (search_data && search_data['wldw_id'] ? search_data['wldw_id'] : ''),
                        "merchants_list": merchants_opt
                    },
                        {
                            key: "md",
                            "text": "门店",
                            "value": (temp && temp['md_mc'] ? temp['md_mc'] : ''),
                            "id": (temp && temp['md_id'] ? temp['md_id'] : '')
                        },
                        {
                            key: "zh",
                            "text": "收款账户",
                            "value": (temp && temp['zh_mc'] ? temp['zh_mc'] : ''),
                            "id": (temp && temp['zh_id'] ? temp['zh_id'] : ''),
                        }, {
                            key: "hz",
                            "text": "汇总",
                            group: [
                                {key: 'wldw', name: '往来单位', columns: 'wldw_id,wldw_mc', choose: getHz('wldw')},
                                // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                                {key: 'skzh', name: '收款账户', columns: 'zh_id,zh_mc,zh_tb', choose: getHz('skzh')},
                            ],
                            "value": getTwo('hz', 'text'),
                        }],
                    "switch":[
                        {"text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_data['xsmx']},
                        {"text": "合拢单据", "max_width": true, "key": "hldj", "value": search_data['hldj']},
                    ],
                    'sort': [{
                        key: "je",
                        "text": "金额",
                        "value": (temp && temp['order']['je'] ? temp['order']['je'] : '')
                    },],
                }
                if (sideslip) {

                    fun.setItem(html_name + 'sideslip', false);
                    fun.openFrame({
                        frame_url: page_arr.search,
                        pageParam: {
                            "return_page": html_name,
                            "search_data": options
                        },
                        // y: fun.fontUnit(header)
                    });
                }
            });
            break;
        case 'fkd':
            openOrderPage('付款单', obj);
            url = AJAX_URL.getFkdtj;
            //打开搜索页
            $('body').off('tap', '#filter_btn').on('tap', '#filter_btn', function () {
                var sideslip = fun.getItem(html_name + 'sideslip');
                var options = {
                    "keywords": {
                        "key": "keyword",
                        "value": (temp && temp['keyword'] ? temp['keyword'] : ''),
                        "placeholder": "单号"
                    },
                    "time": {
                        "begin_date": search_data['begin_time'],
                        "end_date": search_data['end_time']
                    },
                    "choose_merchants": [{
                        "key": "merchants",
                        "text": "供应商",
                        "value": (search_data && search_data['wldw_mc'] ? search_data['wldw_mc'] : ''),
                        "id": (search_data && search_data['wldw_id'] ? search_data['wldw_id'] : ''),
                        "merchants_list": merchants_opt
                    },
                        {
                            key: "md",
                            "text": "门店",
                            "value": (temp && temp['md_mc'] ? temp['md_mc'] : ''),
                            "id": (temp && temp['md_id'] ? temp['md_id'] : '')
                        },
                        {
                            key: "zh",
                            "text": "付款账户",
                            "value": (temp && temp['zh_mc'] ? temp['zh_mc'] : ''),
                            "id": (temp && temp['zh_id'] ? temp['zh_id'] : ''),
                        }, {
                            key: "hz",
                            "text": "汇总",
                            group: [
                                {key: 'wldw', name: '往来单位', columns: 'wldw_id,wldw_mc', choose: getHz('wldw')},
                                // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                                {key: 'skzh', name: '付款账户', columns: 'zh_id,zh_mc,zh_tb', choose: getHz('skzh')},
                            ],
                            "value": getTwo('hz', 'text'),
                        }],
                    "switch":[
                        {"text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_data['xsmx']},
                        {"text": "合拢单据", "max_width": true, "key": "hldj", "value": search_data['hldj']},
                    ],
                    'sort': [{
                        key: "je",
                        "text": "金额",
                        "value": (temp && temp['order']['je'] ? temp['order']['je'] : '')
                    },],
                }
                if (sideslip) {

                    fun.setItem(html_name + 'sideslip', false);
                    fun.openFrame({
                        frame_url: page_arr.search,
                        pageParam: {
                            "return_page": html_name,
                            "search_data": options
                        },
                        // y: fun.fontUnit(header)
                    });
                }
            });
            break;
        default:
            break;
    }
    page_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: url,
        data: temp,
        success: function (res) {
            if (!res['data'] || res['data'].length == 0) {
                $('#tj1').text(0);
                // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                return fun.createDataEmptyTips({dom:'#order_list',btnText:'新增'+((obj == 'skd')?'收款单':'付款单'),auth:((obj == 'skd') ? "cw_skd" : "cw_fkd")});
            }
            // var info_list = res.data; // order_data = [];
            sum_info = res['info'][0];
            // for(var i=0;i<info_list.length;i++){
            //     order_data.push({
            //       wldw_mc: (info_list[i]['wldw_mc'] || ''),
            //       md_mc: (info_list[i]['md_mc'] || ''),
            //       zdr_mc: (info_list[i]['zdr_mc'] || ''),
            //       kdsj: (info_list[i]['kdsj'] || ''),
            //       dh: (info_list[i]['dh'] || ''),
            //       zh_tb: (info_list[i]['zh_tb'] || ''),
            //       zh_mc:  (info_list[i]['zh_mc'] || ''),//收款账户
            //     //   wldw_zh: (info_list[i]['wldw_zh'] || ''),//对方账户
            //       wldw_qqje: (info_list[i]['wldw_qqje'] || ''),//前欠
            //       je: (info_list[i]['je'] || ''),//收款金额
            //       wldw_ljqk: (info_list[i]['wldw_ljqk'] || ''),//累欠
            //       fy_mc: (info_list[i]['fy_mc'] || ''),//费用类型
            //       fy_je: (info_list[i]['fy_je'] || ''),//费用金额
            //       bz: (info_list[i]['bz'] || ''),//备注
            //   });
            // }
            // if(!!order_data[0]){
            fun.clearPage($('#order_list'));
            page_list = fun.createApiDataIndex(res.data);
            showList(fun.PagingData(page_list));

            // }

            $(".othersty").each(function (i) {
                if (!$(this).data('fy')) {
                    $(this).hide();
                }
            });
            $(".dfzh").each(function (i) {
                if (!$(this).text()) {
                    $(this).parent().parent().hide();
                }
            });
        }
    });
}

function getHz(key, def) {
    def = def || 0;
    return (search_data['hz'] && search_data['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_data[key] && search_data[key][son]) || def;
}

//打开单据页面
function openOrderPage(titles, objs) {
    $('.custom-detail').each(function (i) {
        $(this).on('tap', function () {
            fun.showPageFull({
                page_url: page_arr.cw_sfkd_tj,
                pageParam: {
                    title: titles,
                    obj: objs,
                }
            });
        });
    });
}

function getBankIcon(res, khh_list) {
    for (var i = 0; i < khh_list.length; i++) {
        if (res['wldw_zh'].split(' ')[0].indexOf(khh_list[i]['name']) > -1) {
            return khh_list[i]['icon'];
            break;
        }
    }
    return '';
}

// function fanhui(res) {
//     if (res == '分享测试（加工商）') {
//         return '<span class="label-s font-ss">加</span>';
//     } if (res == '分享测试（客户）') {
//         return '<span class="label-s font-ss">客</span>';
//     } if (res == '分享测试（供应商）') {
//         return '<span class="label-s font-ss">供</span>';
//     } if (res == '分享测试（物流）') {
//         return '<span class="label-s font-ss">物</span>';
//     }
// }

function showList(data, obj) {
    var hldj = fun.getItem(page_data['obj'] + '_hldj', 0);
    var xsmx = fun.getItem(page_data['obj'] + '_xsmx') == 1 ? true : false;
    console.log(JSON.parse(JSON.stringify(data)));
    // var list_html = [];
    var sfk_type;
    if (page_data['obj'] == 'fkd') {
        sfk_type = '付款';
        $('#tj1').text(parseFloat(sum_info['je'] || 0) + parseFloat(sum_info['sxf'] || 0) + parseFloat(sum_info['ddj'] || 0));
    } else {
        sfk_type = '收款';
        $('#tj1').text(parseFloat(sum_info['je'] || 0));
    }

    $('#order_list').OrderList({
        data: data,
        schedule: false,
        is_row: true,
        isExpand: !hldj,
        isNoExpand: xsmx,
        render: {
            titlebar: function (res) {
                var search_group_data = fun.getItem(through + '_' + 'hz') || '';
                var html = [];
                var hWL = !!fun.is_value(res['wldw_mc']);
                var hJE = parseFloat(((page_data['obj'] == 'fkd')?fun.is_value(res['ddj'],0):0) +  fun.is_value(res['sxf'],0) + fun.is_value(res['je'],0)).fixed(4);
                var hKD = fun.is_value(res['kdsj']);
                var hZDR = fun.is_value(res['zdr_mc']);

                if ($.nui.isTrue(search_group_data) && search_group_data == 'wldw_id,wldw_mc') {
                    if (hWL) {
                        html.push('<div class="title-bar-row">');
                        html.push('       <div><span style="" class="font-bold">' + fun.is_value(res['wldw_mc']) + '</span>&nbsp;' + fun.createWldwTypeLabelHtml(res['wldw_type']) + '</div>');
                        hJE && html.push('<div class="align-right"><span class="color-money-red font-lls sk_money">￥' + fun.is_value(res['je']) + '</span></div>');
                        html.push('</div>');
                    }
                } else {
                    if (hWL) {
                        html.push('<div class="title-bar-row">');
                        html.push('       <div><span style="" class="font-bold">' + fun.is_value(res['wldw_mc']) + '</span>&nbsp;' + fun.createWldwTypeLabelHtml(res['wldw_type']) + '</div>');
                        (hZDR || hKD)&&html.push('<div class="align-right color-gray font-ss" ><span>' + fun.formatTime(res['kdsj']) + '</span> &nbsp;' + '<span>' + fun.is_value(res['zdr_mc']) + '</span>&nbsp;' + '' + fun.createIsShLabelHtml(res['is_sh']) + '</div>');
                        html.push('</div>');
                    }
                }
                return html.join('');
            },
            subtitle: function (res) {
                // if (page_data['obj'] == 'fkd') {
                //
                // }
                var sk_money = parseFloat(((page_data['obj'] == 'fkd')?fun.is_value(res['ddj'],0):0) +  fun.is_value(res['sxf'],0) + fun.is_value(res['je'],0)).fixed(4);
                var hTZ = !!fun.is_value(res['zh_tb']) || fun.is_value(res['zh_mc']);
                var hJE = !!sk_money;
                var search_group_data = fun.getItem(through + '_' + 'hz') || '';

                var html = [];
                if ((hTZ || hJE) && search_group_data != 'wldw_id,wldw_mc') {
                    html.push('<div class="row">');
                    hTZ && html.push('<div><span class="df">' + sfk_type + '&nbsp;</span><img src="../img/bank/' + fun.is_value(res['zh_tb']) + '" class="account-icon"/>&nbsp;' + fun.is_value(res['zh_mc']) + '</div>');
                    html.push('       <div class="align-right"><span class="color-money-red font-lls sk_money">￥' + sk_money + '</span></div>');
                    html.push('</div>');
                }
                return html.join('');
            },

            subdata: function (res) {
                var group_data = !!fun.getItem(through + '_' + 'hz');

                if ($.nui.isEmpty(res['wldw_qqje']) && $.nui.isEmpty(res['fy_je']) && $.nui.isEmpty(res['wldw_ljqk'])) return '';

                var html = [];
                html.push('<div class="row bg-gray">');
                html.push(!group_data ? '    <div><span class="df margin-left">前欠</span><span>' + fun.is_value(res['wldw_qqje']) + '</span></div>' : '');
                html.push($.nui.isTrue(res['fy_je']) ? '<div><span class="df">' + (res['fy_mc'] || '费用金额') + '</span><span>' + fun.is_value(res['fy_je']) + '</span></div>' : '<div><span class="df"></span><span></div>');
                html.push(!group_data ? '    <div><span class="df">累欠</span><span>' + fun.is_value(res['wldw_ljqk']) + '</span></div>' : '');
                html.push('</div>');
                return html.join('');
            }
        },
    });
}

//开单
$('body').on('tap', '#add_btn', function () {
    if (!fun.checkKz()) return;
    var url = (page_data.obj == "skd") ? page_arr.cw_skd_kd : page_arr.cw_fkd_kd;
    fun.showPageFull({
        page_url: url,
        pageParam: {
            "type": "add",
            "return_page": html_name
        }
    });
});

//修改单据
fun.tjContentTap(function (row) {
    if (!fun.checkKz()) return;
    var url = (page_data.obj == "skd") ? page_arr.cw_skd_kd : page_arr.cw_fkd_kd;

    if ($.nui.isTrue(row['dj_id'])) {
        fun.showPageFull({
            page_url: url,
            pageParam: {
                "type": "edit",
                "dj_id": row['dj_id'],
                "return_page": html_name
            }
        });
    }
});

$('body').on('click','.row-list',function(){
    if(fun.getItem(through + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var row = $(this).children('.summary').children('.summary-content').data('list');
    var url = (page_data.obj == "skd") ? page_arr.cw_skd_kd : page_arr.cw_fkd_kd;
    if ($.nui.isTrue(row['dj_id'])) {
        fun.showPageFull({
            page_url: url,
            pageParam: {
                "type": "edit",
                "dj_id": row['dj_id'],
                "return_page": html_name
            }
        });
    }
})