var html_name = page_arr.cw_zhdz_mx,
    date_arr = fun.getMonthArr(6),
    // to_month = fun.getMonthArr(1)[0],
    search_data = {
        // "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        // "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd')
    },
    // date_bar = $('#date_bar').dateBar({
    //     'data': date_arr,
    //     'tap': function (ret) {
    //         search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
    //         search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
    //         $('#bill_wrap').empty();
    //         getList();
    //     }
    // }),
    total_info = {},
    page_list = [];

page_init = function () {
    var is_PrevPage = false;
    page_data.keyback = refreshPrevPage;//  监听返回键

    search_data['zh_id'] = page_data['zh_id'];
    search_data['begin_time'] = page_data['begin_time'];
    search_data['end_time'] = page_data['end_time'];
    $('#header').header({
        back: true,
        title: page_data['zh_mc'],
        // subtitle: (page_data['begin_time'] || "") + "~" + (page_data['end_time'] || ""),
        appendBackBtnEvt: refreshPrevPage
    });
    $('#date_bar').text((page_data['begin_time'] || "") + "~" + (page_data['end_time'] || ""));
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('bill_wrap', ".bill-list");
        }
    });
    //【账户-显示存款】没有开启
    if(!Auth.check('zh_xsck','view')) {
        $('.deposit').hide();
    }
    function refreshPrevPage() {
        if (is_PrevPage) {
            api.sendEvent({
                name: page_data['return_page'],
                extra: {
                    'status': 'refresh'
                }
            });
        }
        api.closeWin();
    }

    getList();

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'refresh':
                $('#bill_wrap').empty();
                getList();
                break;
        }
    });

    fun.orderListHeight({dom:'#bill_wrap'});
}

function __getTmpOtherHeight(){
    return -$('#header').height() || 0;
}

function getHjInfo() {
    var tmp_search = $.extend({}, page_data['global_search'], {zh_id: page_data['zh_id']});
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getXjyhDzb,
        data: tmp_search,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj_qc').text(0);
                    $('#tj_sr').text(0);
                    $('#tj_zc').text(0);
                    $('#tj_lc').text(0);
                } else {
                    var hj_info = res['info'] || {};
                    $('#tj_qc').text(hj_info['zh_qcje'] || 0);
                    $('#tj_sr').text(hj_info['srje'] || 0);
                    $('#tj_zc').text(hj_info['zcje'] || 0);
                    $('#tj_lc').text(hj_info['zh_ljck'] || 0);
                }
            }
        }
    })
}

function getList() {
    getHjInfo();
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getXjyhDzb,
        data: $.extend({}, {
            "begin_time": "",
            "end_time": "",
            "keyword": "",
            "xsty": false,
            "xszf": false,
            "type": "dzb_mx"
        }, search_data),
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    // return $('#bill_wrap').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#bill_wrap',btnShow:false,style:'top:1rem;height:9rem;',sameAsTj:false});

                }
                total_info = res['info'] || {};

                $('#tj_sr').text(fun.is_value(total_info['srje']));
                $('#tj_zc').text(fun.is_value(total_info['zcje']));
                $('#tj_qc').text(fun.is_value(total_info['zh_qcje']));
                $('#tj_lc').text(fun.is_value(total_info['zh_ljck']));

                page_list = res['data'];
                showList(fun.PagingData(page_list));
            }
        }
    })
}

function showList(data) {
    var html = [];
    $(data).each(function (i, obj) {
        var colour = order_color[i % order_color.length];
        // var val = {};

        // switch (obj['djlx_mc']) {
        //     case "cw_skd":
        //     case "cw_qtsr":
        //         val['text'] = "+";
        //         val['value'] = obj['srje'];
        //         val['color'] = "#4FC45E";
        //         break;
        //     case "cw_nbzz":
        //         if (obj['srje'] > 0) {
        //             val['text'] = "+";
        //             val['value'] = obj['srje'];
        //             val['color'] = "#4FC45E";
        //         } else if (obj['zcje'] > 0) {
        //             val['text'] = "-";
        //             val['value'] = obj['zcje'];
        //             val['color'] = "#ff4e44";
        //         }
        //         break;
        //     default:
        //         val['text'] = "-";
        //         val['value'] = obj['zcje'];
        //         val['color'] = "#ff4e44";
        //         break;
        // }

        html.push('<li class="bill-list lower-border-line border-radius-s" data-row=\'' + fun.formatString(JSON.stringify(obj)) + '\' >');
        html.push('    <div class="radius-box">');
        html.push('         <div style="background-color:' + colour + ';" class="radius">' + getLx(obj) + '</div>');
        html.push('    </div>');
        html.push('    <div class="content">');
        html.push('        <div class="row"><span>' + getDxmc(obj) + '</span></div>');
        html.push('        <div class="row">');
        html.push('             <span class="account color-gray font-ss">' + fun.is_value(obj['kdsj']) + '</span>');
        html.push('             <span class="account color-money-red" style="text-align: right; font-size: 1rem; margin-top: -1.5rem;">');
        // if (fun.is_value(obj['zcje']) > 0) {
        //     html.push('             <span class="color-money-green">-' + fun.is_value(obj['zcje']) + '</span>');
        // } else if (fun.is_value(obj['srje']) > 0) {
        //     html.push('             <span class="color-money-red">+' + fun.is_value(obj['srje']) + '</span>');
        // }

        var zc_money = 0;
        var show_money = '';

        function getZcMoney(val) {
            if (obj['lx'] === '运费') {
                return (-1 * val);
            }
            switch (obj['djlx']) {
                case 'bp_cglhjs':
                case 'bp_xsthjs':
                case 'bp_jglhjs':
                case 'cw_fkd':
                case 'cw_fyd':
                case 'cw_nbzz':
                case 'sx_xsthjs':
                case 'sx_cglhjs':
                case 'sx_jglhjs':
                case 'sx_xzlhjs':
                    return (-1 * val);
                    break;
                case 'bp_cgthjs':
                case 'bp_xsfhjs':
                case 'bp_jgthjs':
                case 'bp_xsdd':
                case 'cw_skd':
                case 'cw_srd':
                case 'sx_xsfhjs':
                case 'sx_cgthjs':
                case 'sx_jgthjs':
                    return val;
                    break;
                default:
                    return val;
                    break;
            }
        }

        var color_class = '';
        if ($.nui.isTrue(obj['zcje'])) {
            zc_money = getZcMoney(obj['zcje']);
            show_money = zc_money;
            if (zc_money > 0) {
                color_class = 'color-money-red';
                show_money = '+' + zc_money;
            } else {
                color_class = 'color-money-green';
            }
        } else if ($.nui.isTrue(obj['srje'])) {
            zc_money = obj['srje'];
            show_money = zc_money;
            if (obj['srje'] > 0) {
                color_class = 'color-money-red';
                show_money = '+' + zc_money;
            } else {
                color_class = 'color-money-green';
            }
        }
        html.push('             <span class="' + color_class + '">' + show_money + '</span>');

        html.push('             </span>');
        html.push('        </div>');
        html.push('        <div class="row">');
        html.push('             <span class="account color-gray font-ss">' + fun.is_value(obj['dh']) + '</span>');
        //【账户-显示存款】有开启
        if(Auth.check('zh_xsck','view')) {
            html.push('             <span class="account color-gray font-ss" style="text-align: right;">累存：' + fun.is_value(obj['zh_ljck']) + '</span>');
        }
        html.push('        </div>');
        html.push('    </div>');
        html.push('</li>');

        // html.push('<li class="bill-list lower-border-line" data-row=\''+JSON.stringify(obj) + '\' >');
        // html.push('    <div class="radius-box">')
        // html.push('         <div style="background-color:' + colour + ';" class="radius">' + fun.is_value(obj['djlx_mc'].slice(0, 1)) + '</div>');
        // html.push('    </div>')
        // html.push('    <div class="content">');
        // html.push('        <div class="row gray-color"><span>' + fun.is_value(obj['djlx_mc']) + '&nbsp;</span><span>' + fun.is_value(obj['dh']) + '</span></div>');
        // html.push('        <div class="row"><span>' + fun.is_value(obj['wldw_mc']) + '</span></div>');
        // html.push('        <div class="row">');
        // html.push('             <span class="account">前存<em>' + fun.is_value(obj['zh_qcje']) + '</em></span>');
        // if (fun.is_value(obj['zcje']) != 0) {
        //     html.push('             <span class="account">支出<em class="color">' + fun.is_value(obj['zcje']) + '</em></span>');
        // } else if (fun.is_value(obj['srje']) != 0) {
        //     html.push('             <span class="account">收入<em class="color2">' + fun.is_value(obj['srje']) + '</em></span>');
        // }
        // html.push('             <span class="account accumulation">累存<em>' + fun.is_value(obj['zh_ljck']) + '</em></span>');
        // html.push('        </div>');
        // // html.push('        <div class="row"><span>' + fun.is_value(obj['wldw_mc']) + '</span><div>');
        // html.push('    </div>');
        // html.push('</li>');
    })

    $('#bill_wrap').append(html.join(''))
     //【账户-显示存款】没有开启，调整位置
    if(!Auth.check('zh_xsck','view')){
        $('.color-money-red').css('margin-top','-0.25rem');
    }
}

// 获取对象名称
function getDxmc(data) {
    switch (fun.is_value(data['djlx'])) {
        case "cw_fyd":
        case "cw_srd":
            return data.lx;
        case "cw_nbzz":
            var arr = data.zy.split('调到');

            if (data['zcje']) {
                return '汇到：' + arr[1] + '';
            } else if (data['srje']) {
                return '收到：' + arr[0] + '';
            }
            return '';
        default:
            return data.wldw_mc;
    }
}

// 获取类型
function getLx(data) {
    switch (fun.is_value(data['djlx'])) {
        case "cw_fyd":
            return '费用';
        case "cw_srd":
            return '收入';
        case "cw_skd":
            return '收款';
        case "cw_fkd":
            return '付款';
        case "cw_nbzz":
            return "转账";
        default:
            if (data['lx'] === data['djlx_mc']) { // TODO 判断可能需要修改
                // return fun.is_value(data['djlx_mc'].slice(0, 2));
                switch (data['djlx']) {
                    case "bp_xsdd":
                        return "订金";
                    case "bp_xsfhjs":
                    case 'sx_xsfhjs':    
                        // return "发货";
                        return "销售";
                    case "bp_xsthjs":
                    case 'sx_xsthjs':
                        return "退货";
                    case "bp_cglhjs":
                    case 'sx_cglhjs':
                        return "采购";
                    case "bp_cgthjs":
                    case 'sx_cgthjs':
                        return "采/退";
                    case "bp_jglhjs":
                    case 'sx_jglhjs':
                        return "加工";
                    case "bp_jgthjs":
                    case 'sx_jgthjs':
                        return "加/退";
                    case 'sx_xzlhjs':
                        return "下织";
                     break;
                    default:
                        return fun.is_value(data['djlx_mc'].slice(0, 2));
                }
            } else {
                return data.lx;
            }
    }
}

//总收入，总支出，前存，累存


$('body').on('tap', '.bill-list', function (e) {
    var row = $(this).data('row') || {};

    console.log(row)

    fun.jumpToBillsPage(row);

    //TODO 先注释掉
    // fun.BillPageJump(row);
})
