var html_name = page_arr.employee_add,
    custom_params = [],//缓存其他参数
    marry_data = [
        { "id": 0, "name": "未婚", is_choose: 1 },
        { "id": 1, "name": "已婚" }
    ],
    sex_data = [
        { "id": 1, "name": "男", is_choose: 1 },
        { "id": 2, "name": "女", }
    ],
    begin_lCalendar = new lCalendar(),
    rz_rq = new lCalendar(),
    lz_rq = new lCalendar();

var _origin_data = {}, save_data = {}, yg_info = {};
var param_data = [];
var YG_DATA = {};

rz_rq.init({
    'trigger': '#rz_rq',
    'type': 'date',
    disabled: !Auth.check('yg', 'edit')
});
lz_rq.init({
    'trigger': '#lz_rq',
    'type': 'date',
    disabled: !Auth.check('yg', 'edit')
});
begin_lCalendar.init({
    'trigger': '#birthday',
    'type': 'date',
    disabled: !Auth.check('yg', 'edit'),
    callback: function (date) {
        var temp_date = date.split('-');
        $('#birthday').attr('birthday', date);
        $('#year').text(temp_date[0]);
        $('#month').text(temp_date[1]);
        $('#day').text(temp_date[2]);
    }
}),
    cache_data = {
        "name": "",
        "sex": "1",
        "mobile": "",
        "section_id": 0,
        "position_id": 0,
        "phone": "",
        "in_date": "",
        "birthday": "",
        "age": "0",
        "store_id": 0,
        "out_date": "",
        "is_married": 0,
        "card": "",
        "address": "",
        "remark": "",
        "imgs": (!!$("#addImgBtn").attr('imgs')) ? [$("#addImgBtn").attr('imgs')] : [],
    };


$('#header').header({
    back: true,
    title: '员工',
    del: Auth.check('yg', 'edit'),
    appendBackBtnEvt: isDataChange
});

var USER_INFO = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    page_data.keyback = isDataChange;
    if ($.nui.isTrue(page_data['id'])) {
        getData(page_data);
    } else {
        $('#del_btn').hide();
        getNumber();
        getParam();

        $('#rz_rq').val(fun.formatDate(new Date(), 'YYYY-MM-DD'));
    }
    //编辑状态下显示识别按钮
    if (Auth.check('yg', 'edit')) {
        $('#distinguish').show();
        $('#save_info').addClass('right-buttom');
    }
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'] || {},
            value = temp['data'];

        switch (temp['status']) {
            case 'select_list':
                switch (value['page_type']) {
                    case "md":
                        var tmp_id = $('#md').attr('md_id');
                        $('#md').val(value['select_val'] || "");
                        $('#md').attr('md_id', (value['id'] || 0));

                        if (tmp_id != value['id']) {
                            $('#bm').val('').attr('bm_id', 0);
                            $('#zw').val('').attr('zw_id', 0);
                        }

                        break;
                    case "xz_bm":
                        var tmp_id = $('#md').attr('md_id');
                        $('#bm').val(value['select_val'] || "");
                        $('#bm').attr('bm_id', (value['id'] || 0));

                        if (tmp_id != value['id']) {
                            $('#zw').val('').attr('zw_id', 0);
                        }

                        break;
                    case "xz_zw":
                        $('#zw').val(value['select_val'] || "");
                        $('#zw').attr('zw_id', (value['id'] || 0));
                        break;
                    case "params_opt":
                        var params_data = value['list_data'] || {};
                        // var node = $("[staue='1']");
                        // $(node).find('.params-input').val(params_data['name'] || "");
                        // $(node).attr('id', params_data['id'] || 0);

                        for (var i = 0; i < $('.params').length; i++) {
                            var item = $('.params').eq(i);
                            var param_id = item.data('param_id');

                            if (params_data['param_id'] == param_id) {
                                item.find('.params-input').val(params_data['name'] || "");
                            }
                        }
                        break;
                }
                break;
            case 'update_params':
                if ($.nui.isTrue(page_data['id'])) {
                    getData(page_data);
                }
                getParam(); // hcx 2020-03-09调整，员工添加返回无更新数据
                break;
            case 'update':
                var backUpDateArr = [
                    { // 门店
                        pageType: 'md',
                        idName: 'md_id'
                    },
                    { // 部门
                        pageType: 'xz_bm',
                        idName: 'bm_id'
                    },
                    { // 职位
                        pageType: 'xz_zw',
                        idName: 'zw_id'
                    }
                ];
                fun.upDateBackSelRow({
                    backSelRow: value,
                    backUpDateArr: backUpDateArr,
                    storageMode: 'attr', // 自定义属性存储方式
                    assignMode: 'val' // 赋值方式
                });
                break;
            case 'sfz_b':
                $('#termof_validity').val(temp['Valid_date'] || "");
                $('.status_b').find('img').attr('src', fun.getImgPath(temp['photo_name'], true, { url: UPLOAD_IMG_PATH }));
                $('.status_b').find('img').data('img_name', temp['photo_name']);
                $('.status_b').find('img')[0].onload = function () {
                    if ($('.status_b').find('img').attr('src') != '../img/status_b.jpg') { //身份证反面不为空时，显示删除
                        $('.delete_b').css({
                            marginLeft: $('.status_b').find('img:last-child').width() - ($('.delete_b').width() / 2)
                        })
                        $('.delete_b').show();
                    }
                }
                break;
            case 'sfz_z':
                $('#employee_name').val(temp['name']);
                $('#sex').val(temp['sex']);
                if (temp['sex'] === '男') {
                    $('#sex').attr('sex_id', 1)
                } else {
                    $('#sex').attr('sex_id', 2)
                }
                //识别到生日
                if ($.nui.isTrue(temp['born'])) {
                    var born = temp['born'].slice(0, 4) + '-' + temp['born'].slice(4, 6) + '-' + temp['born'].slice(6, 8);
                    $('#birthday').attr('birthday', born);
                    $('#year').text(temp['born'].slice(0, 4));
                    $('#month').text(temp['born'].slice(4, 6));
                    $('#day').text(temp['born'].slice(6, 8));
                }
                $('#credit').val(temp['number']);
                $('.status_f').find('img').attr('src', fun.getImgPath(temp['photo_name'], true, { url: UPLOAD_IMG_PATH }));
                $('.status_f').find('img').data('img_name', temp['photo_name']);
                if ($.nui.isEmpty($('#dz').val())) {
                    $('#dz').val(temp['place'])
                }
                $('.status_f').find('img')[0].onload = function () {
                    if ($('.status_f').find('img').attr('src') != '../img/status_f.jpg') { //身份证正面不为空时，显示删除
                        $('.delete_z').css({
                            marginLeft: $('.status_f').find('img:last-child').width() - ($('.delete_z').width() / 2)
                        })
                        $('.delete_z').show();
                    }
                }
                break;
        }
    })
    //修改权限
    // if (Auth.check('yg', 'edit')) {
    //     $('#save_info').show();
    //     $('input').attr('disabled', false);
    // }

    if (!Auth.check('yg', 'edit')) {
        $('input,#sex,#hf,#add_params,.params-input,.params-list-icon,#uploadImgs,#addImgBtn').attr('disabled', 'disabled ');
        $('#save_info,#add_params').hide();
        $('.info,.cut-con').css('padding-bottom', '0');
        // $('.cut-con').css('height', 'calc(100% - 5rem)')
    } else {
        $('#save_info').show();
        $('input').attr('disabled', false);
    }

    //当前用户门店不为空 且 当前用户没【允许查看其他门店员工】的修改权限
    if (USER_INFO['store_id'] && !Auth.check('yxckqtmdyg', 'edit')) {
        $('#md').val(USER_INFO['store_name'] || 0);
        $('#md').attr('md_id', USER_INFO['store_id'] || 0);
        $('#md').attr('disabled', true);
    }
    // fun.keyboardEject('.sub');
    // fun.keyboardEject('#bigSaveBtn');
    fun.setKeyBoard({
        ele: '.cut-con',
        isIos: {
            showFn: function () { },
            hideFn: function () { },
        }
    });
}

$('body').on('click', '.delete_zy', function (e) {
    e.stopPropagation();
    var _this = $(this);
    fun.dialog({
        content: '你确定要删除【' + ($('#employee_name').val() || '') + '】的身份证吗？',
        btn: ['删除', '取消'],
        yes: function () {
            $('.business-photo').find('img').attr('src', '../img/business.jpg');
            if (_this.parent().hasClass('status_f')) {
                _this.parent().find('img').attr('src', '../img/status_f.jpg');
            } else {
                _this.parent().find('img').attr('src', '../img/status_b.jpg');
            }
            _this.hide();
        }
    })
})

//获取参数
function getParam() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getParamOptions,
        data: {
            "type": "yg"
        },
        success: function (res) {
            if (res['status'] == 0) {
                var data = res['data'];
                addParamsList(data['param'] || []);

                _origin_data = getSaveData();
            }
        }
    });
}

//获取员工信息
function getData(params) {
    // $('#del_btn').css("cssText", "display:block !important;");
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getStaffInfo,
        data: {
            id: params['id']
        },
        success: function (res) {
            if (res.status != 0) return fun.alert({ msg: JSON.stringify(res) });
            var info_list = res.data, order_data = [];

            YG_DATA = res.data;

            yg_info = res.data;
            showData(info_list);
        }
    });
}

//获取员工工号
function getNumber() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getNumber,
        data: {
            "type": "yg"
        },
        success: function (res) {
            if (res['status'] == 0) {
                $('#employee_index').val((res['data'] || ""));
                _origin_data = getSaveData();
            }
        }
    });
}

//保存员工信息
function saveData(options) {
    var _options = $.extend({ callback: null }, options);
    if (!$('#employee_name').val()) {
        return fun.toast("姓名不能为空。");
    } else if (!$('#employee_index').val()) {
        return fun.toast("工号不能为空。");
    } else if (!$('#rz_rq').val()) {
        return fun.toast("入职日期不能为空。");
    }
    //身份证效验
    if ($('#credit').val().trim()) {
        var reg = /(^\d{15}$)|(^\d{18}$)|(^\d{17}(\d|X|x)$)/;
        if (reg.test($('#credit').val().trim()) === false) {
            return fun.toast("身份证不合法!");
        }
    }
    //其它参数
    var param_data = [];
    $('#params_list > li').each(function (k, node) {
        param_data.push({
            "id": ($(node).data('id') || 0),
            "param_id": ($(node).data('param_id') || 0),
            "value": ($(node).find('input').val().trim() || "")
        });
    })
    var save_data = {
        "date": fun.formatDate(new Date()) || "",
        "name": ($('#employee_name').val().trim() || ""),
        "number": ($('#employee_index').val().trim() || 0),
        "sex": ($('#sex').attr('sex_id') || 1),
        "mobile": ($('#sj').val().trim() || ""),
        "section_id": ($('#bm').attr('bm_id') || 0),
        "position_id": ($('#zw').attr('zw_id') || 0),
        "phone": ($('#dh').val().trim() || ""),
        "in_date": ($('#rz_rq').val().trim() || ""),
        "birthday": ($('#birthday').attr('birthday') || ""),
        "age": ($('#age').val().trim() || 0),
        "store_id": ($('#md').attr('md_id') || 0),
        "out_date": ($('#lz_rq').val().trim() || ""),
        // "is_stop": ((!!is_married()) ? 1 : 0),
        "is_stop": (($('#lz_rq').val()) ? 1 : 0),
        "is_married": ($('#hf').attr('married_id') || 0),
        "card": ($('#credit').val().trim() || ""),
        "address": ($('#dz').val().trim() || ""),
        "remark": ($('#bz').val().trim() || ""),
        "imgs": (!!$("#addImgBtn").attr('imgs')) ? [$("#addImgBtn").attr('imgs')] : [],
        "param": param_data
    }

    if ($('#img-item').length > 0) {
        save_data['imgs'] = [$('#img-item').data('name')];
    }

    var saveData = getSaveData();

    request(saveData);
    function request(params) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.saveStaff,
            data: $.extend({}, {
                "save_type": "save",
                "id": (page_data && page_data['id']) ? page_data['id'] : 0,
                "date": "",
                "name": "",
                "number": "",
                "sex": "",
                "mobile": "",
                "section_id": 0,
                "position_id": 0,
                "phone": "",
                "in_date": "",
                "birthday": "",
                "age": 0,
                "store_id": 0,
                "out_date": "",
                "is_stop": 0,
                "is_married": "0",
                "card": "",
                "address": "",
                "remark": "",
                "imgs": [],
                "param": [],
                "card_img_before": "",
                "card_img_back": "",
                "card_valid_time": ""
            }, params),
            success: function (res) {
                switch (res['status']) {
                    case 0:
                        if (_options && typeof _options.callback == "function") {
                            page_data['id'] = res['data']['id'];
                            _options.callback(_options['params']);
                        } else {
                            fun.toast("保存成功。");
                            // closePage();
                            fun.pageCloseFun({ refresh: true });
                        }
                        break;
                    case 104:
                        var msg = res['data']['type'] == 'number' ? '工号' : '姓名';
                        return fun.dialog({
                            content: msg + "已存在。",
                            btn: ['确定']
                        });
                        break;
                    default:
                        fun.toast("保存失败。");
                }
            }
        });
    }
}

//数据是否发生改变
function isDataChange() {
    save_data = getSaveData();
    if (!$.nui.isObjEquals(_origin_data, save_data)) {
        if ($('body').find('.data-change-skin').length) return;
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData();
            },
            no: function () {
                // closePage();
                fun.pageCloseFun({});
                // api.closeWin();
            }
        });
    } else {
        // closePage();
        fun.pageCloseFun({});
        // api.closeWin();
    }
}
// 删除员工
function delStaff(params) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveStaff,
        data: $.extend({}, {
            "save_type": "delete",
            "id": [0]
        }, params),
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.toast("删除成功。");
                    // closePage();
                    fun.pageCloseFun({ refresh: true });
                    break;
                case 103:
                    fun.dialog({
                        content: '【' + ($('#employee_index').val().trim() || "") + ' ' + ($('#employee_name').val().trim() || "") + '】已被调用，不允许删除。您可以将此员工转为：离职状态。',
                        btn: ['转为离职状态', '我知道了'],
                        show_time: true,
                        yes: function (res) {
                            delStaff({
                                "id": params['id'],
                                "is_has": true,
                                "out_date": res['time']
                            });
                        }
                    });
                    break;
                default:
                    fun.toast("删除失败。");
            }
        }
    });
}

//显示员工信息
function showData(data) {
    var info = data['info'] || {};
    var param = data['param'] || {};
    //id
    $('#sex').attr('sex_id', info['sex'] || 1);
    $('#bm').attr('bm_id', info['section_id'] || 0);
    $('#zw').attr('zw_id', info['position_id'] || 0);
    $('#birthday').attr('birthday', info['birthday'] || "");
    $('#md').attr('md_id', info['store_id'] || 0);
    $('#hf').attr('married_id', info['is_married'] || 0);
    $("#addImgBtn").attr('imgs', info['imgs'] || "");

    //默认值
    $("#employee_name").val(fun.is_value(info['name']));
    $("#addImgBtn").attr('src', fun.getImgPath(info['imgs']) || '../img/link-person.png').data('name', info['imgs'] || '');
    $("#employee_index").val(fun.is_value(info['number']));
    $("#md").val(fun.is_value(info['store']));//门店
    $("#bm").val(fun.is_value(info['section']));//部门
    $("#zw").val(fun.is_value(info['position']));//职位
    $("#sex").val((fun.is_value(info['sex']) > 1 ? '女' : '男'));
    $("#sj").val(fun.is_value(info['mobile']));
    $("#dh").val(fun.is_value(info['phone']));
    $("#rz_rq").val(fun.is_value(info['in_date']));
    $("#lz_rq").val(fun.is_value(info['out_date']));
    $("#hf").val((fun.is_value(info['is_married']) > 0 ? '已婚' : '未婚'));
    $("#age").val(fun.is_value(info['age']));
    $("#dz").val(fun.is_value(info['address']));
    $("#year").text(fun.is_value(info['birthday'].substr(0, 4)));
    $("#month").text(fun.is_value(info['birthday'].substr(5, 2)));
    $("#day").text(fun.is_value(info['birthday'].substr(8, 2)));
    $("#credit").val(fun.is_value(info['card']));
    $("#bz").val(fun.is_value(info['remark']));
    $('#termof_validity').val(info['card_valid_time'] || "");
    $('.status_b').find('img').data('img_name', info['card_img_back']);
    $('.status_f').find('img').data('img_name', info['card_img_before']);
    $('.status_b').find('img').attr('src', fun.getImgPath(info['card_img_back'], true, { url: UPLOAD_IMG_PATH }));
    $('.status_f').find('img').attr('src', fun.getImgPath(info['card_img_before'], true, { url: UPLOAD_IMG_PATH }));

    $('.status_f').find('img')[0].onload = function () {
        if ($('.status_f').find('img').attr('src') != '../img/status_f.jpg') { //身份证正面不为空时，显示删除
            $('.delete_z').css({
                marginLeft: $('.status_f').find('img:last-child').width() - ($('.delete_z').width() / 2)
            })
            $('.delete_z').show();
        }
    }
    $('.status_b').find('img')[0].onload = function () {
        if ($('.status_b').find('img').attr('src') != '../img/status_b.jpg') { //身份证反面不为空时，显示删除
            $('.delete_b').css({
                marginLeft: $('.status_b').find('img:last-child').width() - ($('.delete_b').width() / 2)
            })
            $('.delete_b').show();
        }
    }
    if (!!param) {
        addParamsList(param);
    }

    if (info['is_has'] > 0) {
        $('#del_btn').hide();
    }

    cache_data = {
        "number": $("#employee_index").val(),
        "name": $("#employee_name").val(),
        "sex": $('#sex').attr('sex_id'),
        "mobile": $("#sj").val(),
        "section_id": $('#bm').attr('bm_id'),
        "position_id": $('#zw').attr('zw_id'),
        "phone": $("#dh").val(),
        "in_date": $("#rz_rq").val(),
        "birthday": $('#birthday').attr('birthday'),
        "age": $("#age").val(),
        "store_id": $("#md").attr('md_id'),
        "out_date": $("#lz_rq").val(),
        "is_married": parseInt($('#hf').attr('married_id') || 0),
        "card": $("#credit").val(),
        "address": $("#dz").val(),
        "remark": $("#bz").val(),
        "imgs": ($('#img-item').length > 0) ? $('#img-item').children('.img').attr('src').split() : ($("#addImgBtn").attr('imgs') || []),
        "param": param_data
    }
    _origin_data = getSaveData();
}

// 顶部tap切换
$('.nav').on('tap', function () {
    $(this).addClass('active').siblings().removeClass('active');
    var index = $(this).index();
    number = index;
    $('.cut-con').hide();
    $('.cut-con:eq(' + index + ')').show();
});

//保存员工信息
$('body').delay('tap', '#save_info', function () {
    saveData();
});

//选择往来单位
$('.wldw_xz').on('tap', function () {
    if ($(this).attr('disabled')) return;
    var params = {
        "return_page": html_name
    };
    switch ($(this).attr('name')) {
        case "xz_md":
            params['page_type'] = "md";
            break;
        case "xz_bm":
            if ($('#md').attr('md_id') == 0) return fun.toast('请先选择门店！');
            params['page_type'] = "xz_bm";
            params['md_id'] = $('#md').attr('md_id');
            break;
        case "xz_zw":
            if ($('#bm').attr('bm_id') == 0) return fun.toast('请先选择部门！');
            params['page_type'] = "xz_zw";
            params['md_id'] = $('#md').attr('md_id');
            params['bm_id'] = $('#bm').attr('bm_id');
            break;
    }
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: params
    });
})
//身份证正面为空
$('body').on('click', '.status_f', function (e) {
    e.stopPropagation();
    if (!Auth.check('yg', 'edit')) return;
    if ($(this).children('img').attr('src') !== '../img/status_f.jpg') {
        var photoBrowser = api.require('photoBrowser');
        photoBrowser.open({
            images: [$(this).children('img').attr('src')],
            placeholderImg: '../img/logo.png',
            bgColor: '#000'
        }, function (ret, err) {
            if (ret) {
                if (ret['eventType'] == 'click') {
                    photoBrowser.close();
                }
            }
        });
    } else {
        fun.showPageFull({
            page_url: page_arr.bankcard_identification,
            pageParam: {
                type: 'sfz_f',
                title: '身份证正面',
                img: '../img/status_f.jpg',
                img_name: $('.status_f').find('img').data('img_name') || '',
                return_page: html_name
            }
        });
    }

})
//身份证背面为空
$('body').on('click', '.status_b', function (e) {
    e.stopPropagation();
    if (!Auth.check('yg', 'edit')) return;
    if ($(this).children('img').attr('src') !== '../img/status_b.jpg') {
        var photoBrowser = api.require('photoBrowser');
        photoBrowser.open({
            images: [$(this).children('img').attr('src')],
            placeholderImg: '../img/logo.png',
            bgColor: '#000'
        }, function (ret, err) {
            if (ret) {
                if (ret['eventType'] == 'click') {
                    photoBrowser.close();
                }
            }
        });
    } else {
        fun.showPageFull({
            page_url: page_arr.bankcard_identification,
            pageParam: {
                type: 'sfz_b',
                title: '身份证背面',
                img: '../img/status_b.jpg',
                img_name: $('.status_b').find('img').data('img_name') || '',
                return_page: html_name
            }
        });
    }
})
//选择性别、是否已婚
$('#sex,#hf').on('touchend', function (e) {
    if ($(this).attr('disabled')) return;
    $('input').blur();
    var _this = $(this);
    var _opt = (($(_this).attr('id') == 'sex') ? sex_data : marry_data);
    var data_id;
    if (($(_this).attr('id') == 'sex')) {
        data_id = $(_this).attr('sex_id')
    } else {
        data_id = $(_this).attr('married_id')
    }
    $(_opt).each(function (i, obj) {
        if (obj['id'] == data_id) {
            _opt[i]['is_choose'] = 1;
        } else {
            _opt[i]['is_choose'] = 0;
        }
    })
    fun.showBookList({
        width: '280px',
        shadeClose: true,
        list: _opt,
        choose: function (res) {
            $(_this).val(res['name'] || "");
            if ($(_this).attr('id') == 'sex') {
                sex_data = _opt;
                $(_this).attr('sex_id', res['id'] || 0);
            } else {
                marry_data = _opt;
                $(_this).attr('married_id', res['id'] || 0);
            }
        }
    })
    e.preventDefault();
})
//身份证识别
$('body').on('click', '#distinguish', function () {
    fun.showPageFull({
        page_url: page_arr.bankcard_identification,
        pageParam: {
            type: 'sfz_z',
            title: '身份证正面',
            img: '../img/status_f.jpg',
            img_name: $('.status_f').find('img').data('img_name') || '',
            return_page: html_name
        }
    });
});
//计算工龄
$('#rz_rq,#lz_rq').bind('input propertychange', function () {
    compare($('#rz_rq').val().trim(), $('#lz_rq').val().trim())
})
//显示隐藏属性
$('body').on('tap', '#click_show', function () {
    $("#click_show").slideUp(500);
    $("#hide_info").slideDown(1000);
});
$('body').on('tap', '#click_hide', function () {
    $("#hide_info").slideUp(600);
    $("#click_show").show(600);
});
//删除当前员工
$('body').on('touchend', '#del_btn', function (e) {
    e.preventDefault();
    if (!!page_data['id']) {
        fun.dialog({
            content: '你确定要删除【' + ($('#employee_name').val().trim() || "") + '】',
            btn: ['确定', '取消'],
            yes: function () {
                delStaff({ id: [page_data['id']] });
            }
        });
    }
    return false;
})

$('.portrait').on('tap', function () {
    if ($(this).attr('disabled')) return;
    $('#openCamera').show();
    $('.box').show();
});
$('#cancelPhoto').on('tap', function () {
    $('#openCamera').hide();
    $('.box').hide();
});

//添加自定义参数、添加自定义参数配置
$('body').on('tap', '#add_params,.params-list-icon', function (e) {
    // if ($(this).attr('disabled')) return;
    // if ($(this).attr('page-type') == "params_opt") {
    //     $('.params-list-icon').parent().attr('staue', "");
    //     $(this).parent().attr('staue', 1);
    // }
    // var param = {
    //     "page_type": $(this).attr('page-type'),
    //     "params_name": $(this).prevAll('.params-name').text() || "",
    //     "params_id": $(this).parent().attr('param-id')
    // }
    // saveData({
    //     params: param,
    //     callback: function (param) {
    //         getData(page_data);
    //         fun.showPageFull({
    //             page_url: page_arr.select_list,
    //             pageParam: {
    //                 "return_page": html_name,
    //                 "params_type": "yg",
    //                 "page_type": param["page_type"],
    //                 "params_name": param["params_name"],
    //                 "params_id": param["params_id"]
    //             }
    //         });
    //     }
    // });

    e.stopPropagation();
    if ($(this).attr('disabled')) return;
    var list_type = $(this).data('search');

    if ($(this).attr('page-type') == "params_opt") {
        $('.params-list-icon').closest('li').attr('staue', "");
        $(this).closest('li').attr('staue', 1);
    }

    var params = {
        return_page: html_name,
        page_type: list_type,
        params_type: "yg"
    };
    var url = page_arr.select_list;

    switch (list_type) {
        case 'params':
            break;
        case 'params_opt':
            params['params_name'] = $(this).closest('li').data('param_name');
            params['params_id'] = $(this).closest('li').data('param_id');
            break;
    }

    fun.showPageFull({
        page_url: url,
        pageParam: params
    });

    // saveData({
    //     params: params,
    //     callback: function () {
    //         api.sendEvent({
    //             name: page_data['return_page'],
    //             extra: {
    //                 'status': 'refresh',
    //             }
    //         });
    //         getData(page_data);
    //         fun.showPageFull({
    //             page_url: url,
    //             pageParam: params
    //         });
    //     }
    // });
})

//添加其她参数列表
function addParamsList(param) {
    if (!param) return;
    var p_list = [];
    $(param).each(function (i, obj) {
        p_list.push('<li id="' + obj['id'] + '" param_id="' + (obj['param_id'] || 0) + '" class="del-info lower-border-line params"  data-id="' + (obj['id'] || 0) + '" data-param_name="' + obj['name'] + '"  data-param_id="' + obj['param_id'] + '">');
        p_list.push('<span class="cut-info params-name">' + fun.is_value(obj['name']) + '</span>');
        p_list.push('<input type="text" class="params-input" value="' + fun.is_value(obj['value']) + '">');
        p_list.push('<i page-type="params_opt" data-search="params_opt" class="iconfont icon-xia params-list-icon"></i>');
        p_list.push('  </li>');
    });
    $("#params_list").html(p_list.join(''));

    !Auth.check('yg', 'edit') && $('.params-input,.params,.params-list-icon').attr('disabled', true);
}

//是否离职
function is_married() {
    return (new Date($('#lz_rq').val().trim()).Format('yy-mm-dd') < new Date().Format('yy-mm-dd'));
}


//退出，刷新上一页
function closePage() {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh'
        }
    });
    setTimeout(function () {
        api.closeWin();
    }, 200)
}

//拍照

$('#paizhao').off('tap').on('tap', function () {
    $('#openCamera,.box').hide();
    QuestPermission.requestPermission('camera', null, function () {
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 100,   //jpg图片质量
            targetWidth: 150,
            targetHeight: 150,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if (!!ret.data) {
                    addImgToImgs(ret);
                }
            } else {
            }
        });
    });

});

//从相册中选择
$('#selectPhoto').off('tap').on('tap', function () {
    $('#openCamera,.box').hide();
    QuestPermission.requestPermission('camera', null, function () {
        api.getPicture({
            sourceType: 'album',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 100,   //jpg图片质量
            targetWidth: 150,
            targetHeight: 150,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if (!!ret.data) {
                    addImgToImgs(ret);
                }
            } else {
            }
        });
    });
});

//取消拍照
$('#cancelPhoto').off('tap').on('tap', function () {
    $('#openCamera').hide();
    $('.box').hide();
});

//添加图片
function addImgToImgs(obj, Introduction) {
    // fun.showLoad();
    // var url = obj['data'] || "",
    //     base64 = obj['base64Data'] || "";
    // var imgItemNode = $('<div id="img-item" base64="' + base64 + '" class="img-item">' +
    //     '<img class="img" src="' + url + '" alt="1">' +
    //     '<div class="close-btn">X</div>' +
    //     '</div>');
    // $('#addImgBtn').before(imgItemNode);
    // $('#openCamera,.picture,.box').hide();
    // fun.hideLoad();

    showSingleData(obj);
}

// 单选图片渲染
function showSingleData(params) {
    var ret_params = {
        data: params
    }
    if (api.systemType == "ios") {
        showImgs(ret_params, params);
    } else {
        // fun.getUrlBase64(ret_params['data']['data'], 'webp', function (base64) {
        fun.getUrlBase64(ret_params['data']['data'], 'jpeg', function (base64) {
            ret_params['data']['base64Data'] = base64
            showImgs(ret_params, params);
        });
    }
}

function showImgs(ret_params, params) {
    fun.fileUpload(ret_params, function (img) {
        var imgItemNode = $('<div id="img-item" data-name="' + img + '" class="img-item">' +
            '<img class="img" src="' + params.data + '" alt="1">' +
            '<div class="close-btn">X</div>' +
            '</div>');
        $('#addImgBtn').before(imgItemNode);
        $('#openCamera,.picture,.box').hide();
        fun.hideLoad();
    });
}

//获取所有的图片
function getAllImg() {
    var imgs = $('#uploadImgs .img-item .img');
    var imgArr = [];
    imgs.each(function (i, obj) {
        imgArr.push(obj.src);
    });
    return imgArr;
}

//判断工龄
function compare(d1, d2, manage) {
    if (!d2) {
        $('#age').val(fun.compareDate(d1, d2) || 0);
        return;
    }
    if (!d1 || !d2) return;
    // if (new Date(d1).getTime() > new Date(d2).getTime()) {
    //     $('#out_date').val('');
    //     out_date.options.value = '';
    //     out_date.setValue('');
    //     $('#age').val(0);
    // } else {
    //     $('#age').val(Fun.compareDate(d1, d2) || 0);
    // }
    if (new Date(d1).getTime() > new Date(d2 || new Date()).getTime()) {
        fun.toast("入职日期不能大于离职日期。");
        $('#lz_rq').val('');
        $('#age').val(0);
    } else {
        $('#age').val(fun.compareDate(d1, d2) || 0);
    }
}

//数据是否有变动
// function is_change() {
//     var temp_data = {
//         "number": $("#employee_index").val(),
//         "name": $("#employee_name").val(),
//         "sex": $('#sex').attr('sex_id'),
//         "mobile": $("#sj").val(),
//         "section_id": ($('#bm').attr('bm_id') || 0),
//         "position_id": ($('#zw').attr('zw_id') || 0),
//         "phone": $("#dh").val(),
//         "in_date": $("#rz_rq").val(),
//         "birthday": ($('#birthday').attr('birthday') || ""),
//         "age": $("#age").val(),
//         "store_id": ($("#md").attr('md_id') || 0),
//         "out_date": $("#lz_rq").val(),
//         "is_married": parseInt($('#hf').attr('married_id') || 0),
//         "card": $("#credit").val(),
//         "address": $("#dz").val(),
//         "remark": $("#bz").val(),
//         "imgs": ($('#img-item').length > 0) ? $('#img-item').children('.img').attr('src').split() : ($("#addImgBtn").attr('imgs') || []),
//         "param": param_data
//     }
//     if (JSON.stringify(cache_data) === JSON.stringify(temp_data)) {
//         return api.closeWin();
//     }
//     fun.dialog({
//         content: '您确定要保存吗？',
//         btn: ['保存', '不保存', '取消'],
//         yes: function () {
//             saveData();
//         },
//         no: function () {
//             api.closeWin();
//         }
//     });
// }




function getSaveData() {

    var md_id = $('#md').attr('md_id');
    var bm_id = $('#bm').attr('bm_id');
    var zw_id = $('#zw').attr('zw_id');

    var param_data = [];
    //其它参数
    $('#params_list > li').each(function (k, node) {
        param_data.push({
            "id": ($(node).data('id') || 0),
            "param_id": ($(node).data('param_id') || 0),
            "value": ($(node).find('input').val().trim() || "")
        });
    });

    var data = {
        save_type: 'save',
        id: page_data['id'] || 0,
        date: yg_info['date'] || fun.formatDate(new Date()),
        name: $('#employee_name').val().trim(),
        number: $('#employee_index').val().trim(),
        sex: $('#sex').attr('sex_id') || 1,
        mobile: $('#sj').val().trim(),
        section_id: $.nui.isTrue(bm_id) ? bm_id : 0,
        position_id: $.nui.isTrue(zw_id) ? zw_id : 0,
        phone: $('#dh').val().trim(),
        in_date: $('#rz_rq').val().trim(),
        birthday: $('#birthday').attr('birthday') || '',
        age: $('#age').val().trim(),
        store_id: $.nui.isTrue(md_id) ? md_id : 0,
        out_date: $('#lz_rq').val().trim(),
        is_stop: $('#lz_rq').val().trim() ? 1 : 0,
        is_married: parseInt($('#hf').attr('married_id') || 0),
        card: $('#credit').val().trim(),
        address: $('#dz').val().trim(),
        remark: $('#bz').val().trim(),
        imgs: (!!$("#addImgBtn").attr('imgs')) ? [$("#addImgBtn").attr('imgs')] : [],
        param: param_data,
        card_img_before: $('.status_f').find('img').data('img_name'),
        card_img_back: $('.status_b').find('img').data('img_name'),
        card_valid_time: $('#termof_validity').val()
    };
    if ($('#img-item').length > 0) {
        data['imgs'] = [$('#img-item').data('name')];
    }
    return data;
}

//检查是否保存
// $('#back_btn').off('tap').on('touchend', function (e) {
//     // is_change();
//     isDataChange();
//     e.preventDefault();
//     return false;
// });
//点击图片预览
// function photoBrowserEvt(imgarr){
//     $('.img-item').off('tap').on('tap','.img', function () {
//         var photoBrowser = api.require('photoBrowser');
//         photoBrowser.open({
//             images:imgarr,
//              placeholderImg: '../img/logo.png',
//             bgColor: '#000'
//         }, function(ret, err) {
//             if (ret) {
//             } else {
//             }
//         });
//     });
// }

//公历与农历的转化
// var y, m, d;
// var date;

// function sloarToChina(year, month, day) {
//     var lunarObj = sloarToLunar(year, month, day);
//     var lunarYear = lunarObj.lunarYear; //农历年份
//     var lunarMonth = lunarObj.lunarMonth; //农历月份
//     var lunarDay = lunarObj.lunarDay; //农历日期
//     $('#year').text(lunarYear);
//     $('#month').text(lunarMonth);
//     $('#day').text(lunarDay);
// }

// //公历日期
// function sloarDate(y, m, d) {
//     $('#year').text(y);
//     $('#month').text(m);
//     $('#day').text(d);
// }

// //公农历选择
// $('.selectDate').on('tap', function() {
//     if (y == null || m == null || d == null) {
//     } else {
//         open_window();
//     }
// });

// function open_window() {
//     //获得日期
//     var year = $('#year').text();
//     var month = $('#month').text();
//     var day = $('#day').text();
//     $('.item').on('tap', function() {
//         type = $(this).children().val();
//         if (type == 0) {
//             $('.selectDate').text('农历');
//             sloarToChina(year, month, day);
//         } else {
//             $('.selectDate').text('公历');
//             sloarDate(y, m, d);
//         }
//     });
// }
