var html_name = page_arr.empower;
var book_info = fun.getBookInfo(),
    user_info = fun.getUserInfo(),
    company_info = fun.getItem('company_info') || {},
    screenClip;
$('#header').header({
    back: true,
    title: '协助授权',
});

$('.empower-ck').hide();
$('.empower-xx').hide();

page_init = function () {
    screenClip = api.require('screenClip');//加载模块
    // getCompanyName();
    $('#gs').text(company_info['company_name'] || '');// 公司名称

    if(fun.getItem('empower-xy') == 1){
        $('.agree').addClass('agrees');
    }
    var dbb_version = $.nui.isTrue(fun.getItem('COMPANY_APP_VERSION'))?'（'+fun.getItem('COMPANY_APP_VERSION')+'）':'';
    if (!$.nui.isEmpty(page_data)) {
        $('#zh').text(page_data['user_info']);//帐号
        $('#zt').text(page_data['book_info']);//账套
        $('#bb').text('APP '+page_data['edition']+dbb_version);//版本
        $('#sb').text(page_data['equipment']);//设备
        $('#xt').text(page_data['system']);//系统
        if (!$.nui.isEmpty(page_data['position'])) {
            $('.empower-ck').show();
            $('#ck').text(page_data['position']);//窗口
        }
        if (!$.nui.isEmpty(page_data['information'])) {
            $('.empower-xx').show();
            $('#xx').text(page_data['information']);//信息
        }
    } else {
        var cut_db_name = (book_info['db_name'] || '').replace(/bh_web_|yby_/ig,'');
        $('#zh').text(user_info['account'] + ' （' + user_info['name'] + '）');
        $('#zt').text(book_info['name'] + ' （' + cut_db_name + '）');
        $('#bb').text('APP '+APP_VERSION + ' （' + api.appVersion + '）'+dbb_version);
        $('#sb').text(api.deviceModel);
        $('#xt').text(api.systemType + ' ' + api.systemVersion + ' ' + api.connectionType);
    }
    getTemporaryPassword();
}
//获取授权
function getTemporaryPassword() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveAccount,
        data: {
            "type": "getTempPwd",
            "company_id": company_info['company_id'],
            "account_id": user_info['account_id'],
        },
        success: function (res) {
            if (res['status'] === 0) {
                if (res['data']['pwd'] != undefined) {
                    $('.temporary').show();
                    var data = res['data'];
                    $('.temporary-date').text(data['end_time']);
                    var pwd = String(data['pwd']);
                    for (var i = 0; i < pwd.length; i++) {
                        $('.temporary-mm' + (i+1)).text(pwd[i]);
                    }
                } else {
                    $('.empower-login').show();
                }
            }
        }
    });
};

//获取公司名称
function getCompanyName() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getCompanyList,
        data: {},
        success: function (res) {
            if (res['status'] === 0) {
                $('#gs').text(res.data.company);// 公司名称
            }
        }
    });
};
//更新（暂无
function update() {
    $('#gxbb').on('click', function () {
        // fun.dialog({
        //     content:'最后一次云版本的更新提示',
        //     btn:['点我更新','取消'],
        //     yes:function(){

        //     }
        // })
        // fun.dialog({
        //     content:'我们有更新的版本了，请先更新到最新版本，看看是否已解决您的问题？',
        //     btn:['点我更新','取消'],
        //     yes:function(){

        //     }
        // })
    });
}


$('.agree,.agreement-text').on('click', function () {
    if($('.agree').hasClass('agrees')){
        fun.setItem('empower-xy',0);
        $('.agree').removeClass('agrees');
    }else{
        fun.setItem('empower-xy',1);
        $('.agree').addClass('agrees');
    }
})
//保存临时授权，获得密码
$('.empower-login-btn').on('click', function () {
    if (!$('.agree').hasClass('agrees')) return fun.toast('请先同意云布业授权协议。');
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveAccount,
        data: {
            "type": "setTempPwd",
            "company_id": company_info['company_id'],
            "account_id": user_info['account_id'],
            "book_id": book_info['id'],    //账本
            "system": $('#xt').text() || '',  //系统
            "device": $('#sb').text() || '', //设备（网页时填写 浏览器信息）
            "other": {       //错误信息
                "window": $('#ck').text() || '',
                "text": $('#xx').text() || '',
                "version": $('#bb').text() || '',
            }
        },
        success: function (res) {
            switch (res['status']) {
                case 0:
                    $('.empower-login').hide();
                    $('.temporary').show();
                    var data = res['data'];
                    $('.temporary-date').text(data['end_time']);
                    var pwd = String(data['pwd']);
                    for (var i = 0; i < pwd.length; i++) {
                        $('.temporary-mm' + (i+1)).text(pwd[i]);
                    }
                    break;
                default:
                    // fun.toast(res['msg'])
                    break;
            };
        }
    });
});
//关闭临时授权
$('.temporary-close').on('click', function () {
    fun.dialog({
        content: '您确定要关闭授权吗？</br>如果您有和我司工程师约定：处理问题、升级软件，请勿关闭，避免维护失败。',
        className: 'empower-layer',
        btn: ['确认关闭', '取消'],
        yes: function () {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.saveAccount,
                data: {
                    "type": "delTempPwd",
                    "company_id": company_info['company_id'],
                    "account_id": user_info['account_id'],
                },
                success: function (res) {
                    if (res['status'] === 0) {
                        fun.toast('关闭成功');
                        setTimeout(function(){
                            api.closeWin();
                        },200);
                        // $('.temporary').hide();
                        // $('.empower-login').show();
                        // for(var i=1;i<9;i++){
                        //     $('.temporary-mm'+i).text('');
                        // }
                    }
                },
            });
        }
    });
});
//反馈
$('.feedback').on('click',function(){
    var imgName =  Date.parse(new Date()) +''+ Math.round(Math.random()*100000);
    screenClip.screenShot({
        album: true,
        imgPath: 'fs://',
        imgName: imgName,
    }, function (ret, err) {
        if (ret.status) {
            fun.toast('图片已保存，请转“人工客服”后进行发送图片。');
        } else {
            fun.toast('保存图片失败，请稍后重试！');
        }
    })
})
//授权协议
$('.ace').on('click',function(){
    var html = [];
    html.push('<p class="ace-may">授权协议</p>');
    html.push('<ul>');
    html.push('     <li class="ace-tips">');
    html.push('         <span>尊敬的用户，您好：</span>');
    html.push('         <span>&nbsp;&nbsp;&nbsp;&nbsp;为了能更快、更准确的为您排查问题及提供技术支持，为了确保你的帐号安全，需要您授权一个临时密码给我司工作人员。我司工作人员承诺：登录帐号只帮助客户处理问题，绝不会对数据进行泄漏和传播。</span>');
    html.push('         <span>&nbsp;&nbsp;&nbsp;&nbsp;当开启登录授权后，当前帐号将自动生成一个临时授权密码，在授权期间范围内，我司工作人员可通过该临时密码登录当前帐号，用户权限等同于当前帐号的权限。</span>');
    html.push('         <span>&nbsp;&nbsp;&nbsp;&nbsp;授权密码有效时间最长持续7天，7天后将自动关闭授权密码，您也可以在授权期间内随时手动关闭。</span>');
    html.push('         <span>&nbsp;&nbsp;&nbsp;&nbsp;温馨提示：请保管好您的密码，请勿通过其他途径授权密码。如有其他疑问，请咨询我司在线客服。</span>');
    html.push('     </li>');
    html.push('</ul>');

    var overscroll = function (el) {
        el.addEventListener('touchstart', function () {
            var top = el.scrollTop;
            var totalScroll = el.scrollHeight;
            var currentScroll = top + el.offsetHeight;
            if (top === 0) {
                el.scrollTop = 1;
            } else if (currentScroll === totalScroll) {
                el.scrollTop = top - 1;
            }
        });
        el.addEventListener('touchmove', function (evt) {
            if (el.offsetHeight < el.scrollHeight) {
                evt._isScroller = true;
            }
        });
    }

    function preventDefault(e) {
        if (!e._isScroller) {
            e.preventDefault();
        }
    }
    layer.open({
        type:1,
        anim: 'up',
        style:'position:fixed; bottom:0; left:0; width: 94%;height:45%; border:none;overflow-y: scroll; padding: 0 3%;',
        className:'ace-layer',
        content:html.join(''),
        success: function () {
            for (var i = 0; i < document.querySelectorAll('.ace-layer').length; i++) {
                overscroll(document.querySelectorAll('.ace-layer')[i]);
            }
            document.body.addEventListener('touchmove', preventDefault, {passive: false});
        },
        end: function () {
            document.body.removeEventListener('touchstart', preventDefault, {passive: false});
            document.body.removeEventListener('touchmove', preventDefault, {passive: false});
        }
    })
})
