var html_name = page_arr.entity_authentication;
var IS_PAGE_EDIT = true, is_edit = false;
var item_img;
$("#header").header({
    back: true,
    title: '实体认证',
    appendBackBtnEvt: backEvent,
});

page_init = function () {
    if (page_data && 'obj' in page_data) { // 实体认证通过
        $('.sh').css({
            height: $('.sh_title').outerHeight() + $('.sh_con').outerHeight(true)
        })
        $('.content').css({
            position: 'relative',
            paddingTop: api.safeArea.top,
            // height: $(window).height() - api.safeArea.top - $('#header').outerHeight()
            height: $(window).height() - api.safeArea.top - $('#header').outerHeight() - fun.computedHtmlFontSize()
        })
    }

    $('#header').css({
        paddingTop: api.safeArea.top
    })
    $('.content').css({
        position: 'relative',
        paddingTop: api.safeArea.top
    })

    //返回键监听
    page_data.keyback = function () {
        backEvent();
    };
    getData();
    if (!!fun.getItem('login_info')['md_img']) {
        addImgToImgs()
    }
}

function getData() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getCompanyList,
        data: {},
        success: function (res) {
            if (res['status'] === 0) {
                showData(res.data || {});
            }
        }
    });
}

function showData(data) {

    if (!!data['logo'] && !!data['company']) {
        $('.logo img').attr({ 'src': fun.getImgPath(data['logo']) })
        $('#gsjc').text(data['company']);
    } else if (!!data['company']) {
        $('.logo').hide();
        $('#gsjc').css('line-height', '7rem').text(data['company']);
    } else {
        $('.logo img').attr({ 'src': '../img/shop/shoplogo.png' });
    }

}

//上传图片
$('body').on('click', '.upload_img', function () {
    if ($(this).attr('disabled')) return;
    $('#openCamera,.box').show();
});

//拍照
$('#paizhao').off('tap').on('tap', function () {
    $('#openCamera,.picture,.box').hide();
    //解决tap穿透
    $('.content').css('pointer-events', 'none');
    setTimeout(function () {
        $('.content').css('pointer-events', 'auto');
    }, 200);
    QuestPermission.requestPermission('camera', null, function () {
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 100,
            targetWidth: 1000,
            targetHeight: 1000,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if (ret.data) addImgToImgs(ret);
            } else {
            }
        });
    });

});

//从相册中选择
$('#selectPhoto').off('tap').on('tap', function () {
    $('#openCamera,.picture,.box').hide();
    //解决tap穿透
    $('.content').css('pointer-events', 'none');
    setTimeout(function () {
        $('.content').css('pointer-events', 'auto');
    }, 200);
    QuestPermission.requestPermission('camera', null, function () {
        api.getPicture({
            sourceType: 'album',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: true,
            quality: 100,
            targetWidth: 1000,
            targetHeight: 1000,
            saveToPhotoAlbum: false
        }, function (ret, err) {
            if (ret) {
                if (ret.data) addImgToImgs(ret);
            } else {
                // console.log(JSON.stringify(err));
            }
        });
    });

});

function is_event(state) {
    if (!state) {
        IS_PAGE_EDIT && $('.packs').show();
        is_edit = true;
    } else {
        $('.packs').hide();
        is_edit = false;
    }
}

//取消
$('#cancelPhoto').on('click', function () {
    $('#openCamera').css('display', 'none');
    $('.box').css('display', 'none');
});

// 添加图片执行
function addPictureExe() {
    IS_PAGE_EDIT && $('.upload_img .packs').show();
    $('.upload_img').attr('disabled', true);
    $('#openCamera').hide();
    $('.box').hide();
    fun.hideLoad();
}

//添加图片
function addImgToImgs(obj) {
    fun.showLoad();

    imgItem = [];
    if (!!obj) {
        base64 = obj['base64Data'] || "";
        var fileData = {
            data: obj,
            index: 0
        };

        var url = fun.is_value(obj.data)
        fun.fileUpload(fileData, function (imgName) {
            IS_PAGE_EDIT && imgItem.push('<span class="packs" name="pack" id="imgs"><i class="iconfont icon-fork fork"></i></span>');
            imgItem.push('<img alt="" class="dp_img" src="' + url + '" data-img="' + imgName + '">');
            $('.upload_img').html(imgItem.join(''));
            addPictureExe();
        });

    } else {
        item_img = fun.getItem('login_info')['md_img'];
        if (!(/http/.test(item_img))) {
            item_img = fun.getImgPath('strz/' + fun.getItem('login_info')['md_img'], true, { url: UPLOAD_IMG_PATH })
        }
        IS_PAGE_EDIT && imgItem.push('<span class="packs" name="pack" id="imgs"><i class="iconfont icon-fork fork"></i></span>');
        imgItem.push('<img alt="" class="dp_img" src="' + item_img + '" data-img="' + fun.getItem('login_info')['md_img'] + '">');
        $('.upload_img').html(imgItem.join(''));

        addPictureExe();
    }
}

//删除图片
$('body').on('touchstart', '.packs', function (e) {
    e.stopPropagation();
    var this_ = $(this);
    var objs = $(this).parent().parent().hasClass('Img1');
    fun.dialog({
        content: '你确定要删除门店图片吗?',
        btn: ['删除', '取消'],
        isClose: false,
        yes: function () {
            $('.dp_img').attr({ 'src': '../img/null.png', 'large-url': '', 'img-name': '' });
            $('.upload_img').attr('disabled', false);
            this_.hide();
            layer.closeAll();
        },
    });
    return false;
});

//提交认证
$('#submitRz').on('click', function () {
    var img = $('.dp_img').attr('src');
    var imgSrc = $('.dp_img').data('img');

    if (img === '../img/null.png') {
        return fun.toast('请选择图片！');
    } else if (/http/.test(imgSrc)) {
        imgSrc = imgSrc.slice(imgSrc.lastIndexOf('/') + 1);
    }

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveStrz,
        data: {
            dir: 'strz',
            md_img: imgSrc
        },
        success: function (res) {
            if (res.status === 0) {
                // var data = fun.getItem('login_info');
                // data['is_strz'] = 1;
                // data['md_img'] = file_name;
                // fun.setItem('login_info',data)
                fun.toast('提交成功。');
                var loginInfo = fun.getItem('login_info');
                loginInfo['md_img'] = imgSrc;
                fun.setItem('login_info', loginInfo);
                fun.showPageFull({
                    page_url: page_arr.entity_authentication_next,
                    pageParam: {
                        'obj': 'entity_authentication_next',
                    }
                });
            } else if (res.status === 104) {
                fun.toast('请选择图片！');
            } else if (res.status === 101) {
                fun.toast('请勿重复提交');
            }
        }
    })
});

//返回店铺设置页面
function backEvent() {
    if (page_data['obj'] == 'entity_authentication_next') {
        api.sendEvent({
            name: page_arr.shop_settings,
            extra: {
                status: 'update_strz',
                // 'is_strz': fun.getItem('login_info')['is_strz'],
            }
        });
        fun.closeToWin(page_arr.shop_settings);
    } else {
        api.closeWin();
    }
}

