var html_name = page_arr.forget_password;
var cont=true;
$('#header').header({
    back: true,
    title: '忘记密码'
});
page_init = function(){
    if(page_data['mobile']!=''){
        $('#sj').val(page_data['mobile']);
        $('#btn-yzm').addClass('enabling');
    }
}
/*手机号码限制输入11位 */
$('#sj').on('keyup', function (event) {
    $(this).val($(this).val().slice(0, 11));
    if ($(this).val().length == 11) {
        if(!cont) return;
        $('#btn-yzm').addClass('enabling');
    } else {
        $('#btn-yzm').removeClass('enabling');
    }
});
/*验证码限制输入4位 */
$('#yzm').on('keyup paste input', function (event) {
    $(this).val($(this).val().slice(0, 6));
    if($(this).val().length==6){
        $('#yzsf').addClass('bg-yzsf').off('click').on('click',function(){
            verification();
        })
    }else{
        $('#yzsf').removeClass('bg-yzsf').off('click');
    }
});
// 验证码 按钮
$('#btn-yzm').on('click', function (event) {
    if ($(this).hasClass('enabling')) {
        if ($('#sj').val().trim()=='') return fun.toast('手机号码不能为空！');
        if (!fun.regCheck($('#sj').val().trim(), 'phone')) return fun.toast('手机号码有误，请重填。');
        sendCode({
            'callback': function (res) {
                if (res['status'] === 0) {
                    cont=false;
                    $('#btn-yzm').removeClass('enabling');
                    timeWait(59);//启动倒计时函数
                }
            }
        });
    }
});

function sendCode(options) {
    //发送验证码的代码
    fun.ajax({
        showLoad:true,
        hideLoad:true,
        url:AJAX_URL.code,
        data:{
            type:'forgetPwd',
            mobile:$('#sj').val().trim(),
        },
        success:function(res){
            switch (res['status']) {
                case 0:
                    if (typeof options['callback'] === 'function') options['callback'](res);
                    break;
                case 104:
                    fun.toast('该手机号码未注册云布业\n' +
                        '如果该号码为子账号\n请联系贵公司管理员为您变更密码！');
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    })
}
function timeWait(time) {
    setTimeout(function () {
        if (time >= 0) {
            $('#btn-yzm').html(time + 's');
            time--;
            timeWait(time);
        } else {
            $('#btn-yzm').html('发送验证码');
            cont=true;
            ($('#sj').val().length == 11) ? $('#btn-yzm').addClass('enabling') : $('#btn-yzm').removeClass('enabling');
        }
    }, 1000);
}

function verification(){
    if ($('#sj').val().trim()=='') return fun.toast('手机号码不能为空！');
    if (!fun.regCheck($('#sj').val().trim(), 'phone')) return fun.toast('手机号码有误，请重填。');
    fun.ajax({
        showLoad:true,
        hideLoad:true,
        url:AJAX_URL.code,
        data:{
            "type":"checkCode",
            "check_type":"forgetPwd",
            "mobile":$('#sj').val().trim(),
            "sms_code":$('#yzm').val().trim(),
        },
        success:function(res){
            switch (res['status']) {
                case 0:
                    fun.showPageFull({
                        page_url: page_arr.forget_password_modify,
                        pageParam:{
                            code:$('#yzm').val().trim(),
                            mobile:$('#sj').val().trim()
                        }
                    });
                    break;
                case 105:
                    fun.toast('验证码错误！');
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    })
}

fun.keyboardEject('.forget_password-unavailable');

$('body').on('click','#wfsy',function () {
    fun.showPageFull({
        page_url: page_arr.new_win
    });
    api.closeWin();
})

