var html_name = page_arr.jg_jgbj;
$('#header').header({
    back: true,
    filter: true,
    title: '加工报价'
});


//默认开始显示数据
var to_month = fun.getLatelyTime(1,false);
var page_list = [];
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

//时间控件
var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getList(search_data);
        }
    });

var USER_INFO = {};
//接收查询后的参数
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_storage = $.extend(true, {
        'ycysh': fun.getItem(html_name + '_' + 'ycysh', 0),
        'xsgg': fun.getItem(html_name + '_' + 'xsgg', 0),
        'hldj': fun.getItem(html_name + '_' + 'hldj', 0),
        'xsmx': fun.getItem(html_name + '_xsmx', 0),
    }, search_storage);
    search_data = $.extend({}, search_data, search_storage);
    getList(search_data);

    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var param = ret.value.data;

        search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
        search_data['begin_time'] = param.begin_date;                   //开始时间
        search_data['end_time'] = param.end_date;                       //结束时间
        search_data['wldw_id'] = param.jgs['id'] || '';                 //供应商
        search_data['cp_id'] = param.cp['id'] || '';                    //产品
        search_data['cp_lb_id'] = param.cp_lb['id'] || 0;             //产品类别
        // search_data['ck_id'] = param.ck['id'] || '';                    //仓库
        search_data['md_id'] = param.md['id'] || '';                    //门店
        search_data['ycysh'] = param['ycysh'];
        search_data['xsgg'] = param['xsgg'];                            //显示规格
        search_data['hldj'] = param['hldj'];                            //合拢单据
        search_data['xsmx'] = param['xsmx'];                            //显示明细数据


        //搜索菜单需要缓存的数据
        search_storage['keyword'] = search_data['keyword'];
        search_storage['begin_date'] = search_data['begin_time'];
        search_storage['end_date'] = search_data['end_time'];
        search_storage['ycysh'] = param['ycysh'];
        search_storage['xsgg'] = param['xsgg'];
        search_storage['hldj'] = param['hldj'];
        search_storage['xsmx'] = param['xsmx'];
        search_storage['jgs'] = param.jgs;
        search_storage['cp'] = param.cp;
        search_storage['cp_lb'] = param.cp_lb;
        // search_storage['ck'] = param.ck;
        search_storage['md'] = param.md;

        fun.setItem(html_name + '_' + 'ycysh', param['ycysh']);
        fun.setItem(html_name + '_' + 'xsgg', param['xsgg']);
        fun.setItem(html_name + '_' + 'hldj', param['hldj']);
        fun.setItem(html_name + '_xsmx', param['xsmx']);

        fun.setItem(html_name + 'sideslip', true);

        //设置时间控件时间
        date_bar.setDate(search_storage);
        getList(search_data);
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
};


/** 获取数据
 * @param {*} data
 */
function getList(data) {
    page_list = [];
    //暂时使用这种方式访问api接口，如果没有这个就会访问不到
    var tmpdata = $.extend(true, {}, data);
    tmpdata['type'] = "search_mx";
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpJgbjtj,
        data: tmpdata,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                fun.clearPage($('#order_list'));
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createOtherKeysFun: function(obj) {
                        return obj['dh'];
                    },
                    createKeysValueFun: function(obj) {
                        return {
                            "wldw_mc": obj['wldw_mc'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "is_sh": obj['is_sh']
                        }
                    }
                });

                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        },
    })
}

fun.setItem(html_name+'sideslip',true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip=fun.getItem(html_name+'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [{
            key: "jgs",
            "text": "加工商",
            "value": (search_storage['jgs'] && search_storage['jgs']['text']) || "",
            "id": (search_storage['jgs'] && search_storage['jgs']['id']) || 0,
        }, {
            key: "cp",
            "text": "产品",
            "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
            "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
        }, {
            key: "cp_lb",
            "text": "产品类别",
            "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
            "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
        },{
            key: "md",
            "text": "门店",
            "value": (search_storage['md'] && search_storage['md']['text']) || "",
            "id": (search_storage['md'] && search_storage['md']['id']) || 0,
        }],
        "switch": [
            { "text": "隐藏已审核单据", "max_width": true, "key": "ycysh", "value": search_storage['ycysh'] },
            { "text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_storage['xsmx'] },
            { "text": "合拢单据", "max_width": true, "key": "hldj", "value": search_storage['hldj'] },
            { "text": "显示规格", "max_width": true, "key": "xsgg", "value": search_storage['xsgg'] }
        ],
    }
    if(sideslip){

        fun.setItem(html_name+'sideslip',false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
        });
    }
});

// 退货结算-开单
// $('body').on('tap', '#retreat', function () {
//     fun.showPageFull({
//         page_url: page_arr.jg_thjs_kd,
//         pageParam: {}
//     });
// });

// 来货结算-开单
// $('body').on('tap', '#hair', function () {
//     fun.showPageFull({
//         page_url: page_arr.jg_lhjs_kd,
//         pageParam: {}
//     });
// });


var order_data = [{
    wldw_mc: '加工商',
    md_mc: '门店',
    zdr_mc: '制单人',
    kdsj: '2018-05-28 15:30',
    dh: 'CDD1812270006',
    list: [{
        cp_bh: '编号',
        cp_mc: '名称',
        cp_sh: '色号',
        cp_ys: '颜色',
        fk: 170,
        kz: 190,
        cf: 1,
        dj: 4,
        gs: 1,
    }, {
        cp_bh: '编号',
        cp_mc: '名称',
        cp_sh: '色号',
        cp_ys: '颜色',
        fk: 170,
        kz: 190,
        cf: 1,
        dj: 4,
        gs: 1,
    }],
},
];
// showList(order_data);

function showList(data) {
    var hldj = fun.getItem(html_name + '_hldj', 0);
    var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !hldj,
        isNoExpand: xsmx,
        render: {
            titlebar: function (res) {
                return [
                    '<div class="title-bar-row border-bottom padding-bottom-s">',
                    '    <div><span class="font-ls" style="font-weight: bold;">' + fun.is_value(res['wldw_mc']) + '</span></div>',
                    '    <div class="align-right" ><span class="color-gray font-ss">' + fun.formatTime(res['kdsj']) + '</span><a></a>&nbsp;<a class="color-gray font-ss">' + fun.is_value(res['zdr_mc']) + '</a>&nbsp;<span>' + fun.createIsShLabelHtml(res['is_sh']) + '</span></div>',
                    '</div>',
                ].join('');
            },
            subtitle: function (res) {
                return [
                    '<div class="row">',
                    '     <div><span>' + fun.is_value(res['cp_bh']) + ' ' + fun.is_value(res['cp_mc']) + '</span><span class="margin-left-s">' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</span></div>',
                    '</div>',
                ].join('')
            },
            subdata: function (res) {
                return [
                    fun.createFkKzGgHtml(search_data, res),
                    '<div class="row bg-gray">',
                    fun.is_value(res['gx_mc']) ? '    <div><span>' + fun.is_value(res['gx_mc']) + '</span></div>' : "",
                    '    <div><span class="color-gray">单价</span><span>' + fun.toNumber(res['hsdj']) + '</span></div>',
                    '</div>',
                ].join('');
            }
        },
    });
}
