var html_name = page_arr.jg_lhjs;
var id;

fun.clearItem('ck_list');

page_init = function () {
	//头部样式
	$('#header').header({
		back: true,
		title: page_data['mc'],
		subtitle: page_data['dh'],
		order_info: {
			show: true,
			person: page_data['zdr'],//制单人
			dateText: page_data['kdsj']//开单时间
		},
	});
    $('.contents-sx').css('marginTop',$('#header').outerHeight());
	//页面传递过来的id
	id = page_data['id'];
	//ajax请求页面数据
	fun.ajax({
		showLoad: true,
		hideLoad: true,
		data: {
			id: id,
		},
		url: AJAX_URL.getBpJglhjsInfo,
		success: function (res) {
			var page_data = convertData(res.data.jl)
			showData1(res.data.dj);
			showData2(page_data);
		}
	})
	fun.scrollToBottom({}, function () {
        fun.createBottomLine('order_list', ".list-wrap");
    });
}

/**
 * 方法
 */
//加载固定数据
function showData1(data) {
	$('#zdr').text(data['zdr_mc'] || fun.getItem('user_info')['name']);
	$('#jgs').val(data['wldw_mc'] || '');
	$('#qq').val(data['wldw_qqje'] || 0);
	$('#lq').val(data['wldw_ljqk'] || 0);
	$('#qt').siblings().text(data['fy_mc'] || '其他');
	$('#qt').val(data['fy_je'] || 0);
	$('#yf').val(data['ysje'] || 0);
	$('#fk').val(data['zh_je'] || 0);
	$('#zh').val(data['zh_mc'] || '');
	$('#bz').val(data['bz'] || '');
	$('#hy').val(data['hy_mc'] || '');
	if (data.hy_dh == '') $('#hy_yf').val(data['hy_je'] || '');
	else $('#hy_yf').val(data['hy_je'] || 0);
	$('#hyd').val(data['hy_dh'] || '');

    if (data['is_zf']) {
        fun.seal({type: 'zf'});
    } else if (data['is_sh']) {
        fun.seal({type: 'sh'});
    }
}

//动态加载仓库数据
function showData2(data) {
	var Html = [];
	for (var i = 0; i < data.length; i++) {
		var val = data[i];
		Html.push('<a class="store-title">' + (val['ck_mc'] || ' ') + '</a>');
		Html.push('<div id="order_list">');
        Html.push('<ul class="list-wrap">');
		for (var j = 0; j < val['list'].length; j++) {
			var val_list = val['list'][j]
			Html.push('	<li class="store-info" data-list=\''+fun.formatString(JSON.stringify(val_list))+'\'>');
			(val_list['dd_dj_id'] || val_list['ckd_dj_id']) && Html.push('                 <div class="box"></div>');
			Html.push('		<p class="store-name">' + (fun.is_value(val_list['cp_bh']) + fun.is_value(val_list['cp_mc'])) + ' <i>' + (fun.is_value(val_list['cp_ys_bh']) + fun.is_value(val_list['cp_ys_mc'])) + '</i> </p>');
			Html.push('		<span>幅宽<i class="info-date">' + fun.is_value(val_list['fk']) + '</i></span>');
			Html.push('		<span>克重<i class="info-date">' + fun.is_value(val_list['kz']) + '</i></span>');
			if (val_list['gh'] == '') {
				Html.push('		<span></span>');
			} else {
				Html.push('		<span>缸号<i class="info-date">' + val_list['gh'] + '</i></span>');
			}
			Html.push('		<span>匹数<i class="info-date">' + fun.is_value(val_list['ps']) + '</i></span>');
			Html.push('		<span>数量<i class="info-date">' + fun.is_value(val_list['zsl']) + '<i>' + fun.is_value(val_list['dw_mc']) + '</i></i></span>');
			var colorText = (val_list['zsl'] != val_list['jjsl']) ? 'text' : '';
			Html.push('		<span>计价<i class="info-date ' + colorText + '">' + fun.is_value(val_list['jjsl']) + '</i><i>' + fun.is_value(val_list['jjdw_mc']) + '</i></span>');
			Html.push('		<span>单价<i class="info-date unitprice">' + fun.is_value(val_list['hsdj']) + '</i></span>');
			Html.push('		<span class="price"><i>￥</i>' + fun.is_value(val_list['hszje']) + '</span>');
			//调单信息
            if(!!val_list['kh_dd_dh']&&!!val_list['kh_dd_dj_id']&&!!val_list['kh_id']){
                Html.push('     <p class="odd-numbers">');
                Html.push('         <em>'+val_list['kh_mc']+'</em>');
                Html.push('         <em>订单：'+val_list['kh_dd_dh']+'</em>');
                Html.push('     </p>');
			}

			var zdy_arr = fun.getZdyfyArr('wwjgzdyfy', val_list);
			if(zdy_arr.length!=0){
				Html.push('                 <div class="manyExpenses">');
				Html.push('                     <div>');
				Html.push('                         <p class="manyExpenses-p">费用</p>');
				for(var k = 0;k<zdy_arr.length;k+=2){
					Html.push('                     <span class="manyExpenses-span">' + zdy_arr[k] + ' '+zdy_arr[k+1]+'元</span>');
				}
				Html.push('                     </div>');
				Html.push('                 </div>');
			}
			
			Html.push('	</li>');
		}
		Html.push('</ul>');
		Html.push('</div>');
	}
	$('.storehouse').append(Html.join(''))
}


//详细信息
$('.hide').hide();
$('.open').on('tap', function () {
	if ($('.hide').css("display") === "none") {
		$('.hide').show();
		$(this).children().removeClass("icon-xia").addClass("icon-shang");
	} else {
		$('.hide').hide();
		$(this).children().removeClass('icon-shang').addClass("icon-xia");
	}
});


//数据归类，同仓库放在一起
function convertData(apidata) {
	if (JSON.stringify(apidata) == "[]")
		return [];
	if ((!(apidata instanceof Array))) {
		return "参数错误";
	}
	var list = [], tmp = {};
	$(apidata).each(function (i, obj) {
		if (!tmp[obj['ck_id']]) {
			tmp[obj['ck_id']] = {
				'ck_id': obj['ck_id'],
				'ck_mc': obj['ck_mc'],
				'list': []
			}
		}
		tmp[obj['ck_id']]['list'].push(obj)
	})

	for (var i in tmp) {
		list.push(tmp[i]);
	}
	return list;
}
$('body').on('tap','.store-info',function(){
	var data_list=$(this).data('list');
	var is_detail=fun.getHouseValue(data_list['ck_id'],'is_detail'),
		hasData = $.nui.isTrue(data_list['mx']);
	if(is_detail&&hasData){
		fun.showPageFull({
			page_url: page_arr.kdxq_mxbp,
			pageParam: {
				return_page: html_name,
				data:data_list
			}
		});
	}
})


function __checkData() {
	if (!fun.dataIsRead(['ck'])) {
		setTimeout(__checkData, 250);
	} else {
		setTimeout(function () {
			if (typeof page_init === "function") page_init();
		}, 100);
	}
}
