var obj, title;
var html_name = page_arr.kc_hdb_mx;

var search_storage = [];

page_init = function () {
    // console.log(JSON.stringify(page_data))
    obj = page_data.obj || "cloth";
    title = page_data.title;
    search_storage = page_data.search_storage;
    search_storage['ck_id'] = page_data.ck.id || 0;

    search_storage['cp_id'] = page_data.hdb_params.cp_id || 0;
    search_storage['cp_bh'] = page_data.hdb_params.cp_bh || 0;
    search_storage['cp_mc'] = page_data.hdb_params.cp_mc || 0;
    search_storage['cp_ys_id'] = page_data.hdb_params.cp_ys_id || 0;
    search_storage['fk'] = page_data.hdb_params.fk || '';
    search_storage['kz'] = page_data.hdb_params.kz || '';
    search_storage['dw_id'] = page_data.hdb_params.dw_id || 0;
    search_storage['dw_mc'] = page_data.hdb_params.dw_mc || '';

    search_storage['begin_time'] = search_storage.begin_date;
    search_storage['end_time'] = search_storage.end_date;
    search_storage['hide_zf'] = 1;
    search_storage['group'] = "cp_id,cp_ys_id,fk,kz,dw_id";


    $('#ck_name').text(page_data.ck.select_val);
    $('#query_date').text(search_storage.begin_date + '~' + search_storage.end_date);

    $('#header').header({
        back: true,
        title: title
    });
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showClothList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
    initPage(obj);
}

function initPage(obj) {
    switch (obj) {
        case 'yarn':
            var order_data = [{
                wldw_mc: '客户名称',
                md_mc: '单据类型',
                zdr_mc: '制单人',
                kdsj: '2018-05-28 15:30',
                dh: 'CDD1812270006',
                list: [{
                    cp_pp: '品牌',
                    cp_mc: '名称',
                    cp_sh: '色号',
                    cp_ys: '颜色',
                    dq: '地区',
                    xz: '性质',
                    gg: '规格',
                    ph: 'XXX',
                    qc: 30,
                    rk: 30,
                    qm: 30,
                }, {
                    cp_pp: '品牌',
                    cp_mc: '名称',
                    cp_sh: '色号',
                    cp_ys: '颜色',
                    dq: '地区',
                    xz: '性质',
                    gg: '规格',
                    ph: 'XXX',
                    qc: 30,
                    rk: 30,
                    qm: 30,
                }],
            },];
            showList(order_data);

        function showList(data) {
            $('#order_list').OrderList({
                data: data,
                schedule: false,
                render: {
                    titlebar: function (res) {
                        return [
                            '<div class="title-bar-row">',
                            '    <div><span style="color:' + res['color_val'] + '">' + fun.is_value(res['wldw_mc']) + '</span></div>',
                            '    <div class="align-right" ><a>' + fun.is_value(res['md_mc']) + '</a>&nbsp;<a>' + fun.is_value(res['zdr_mc']) + '</a></div>',
                            '</div>',
                            '<div class="title-bar-row">',
                            '    <div><span>' + fun.is_value(res['kdsj']) + '</span></div>',
                            '    <div class="align-right" ><a>' + fun.is_value(res['dh']) + '</a></div>',
                            '</div>',
                        ].join('');
                    },
                    subtitle: function (res) {
                        return [
                            '<div class="row">',
                            '     <div>' + fun.is_value(res['cp_mc']) + '</div>',
                            '     <div class="align-right">' + fun.is_value(res['cp_pp']) + '</div>',
                            '</div>',
                            '<div class="row">',
                            '     <div>' + fun.is_value(res['cp_sh']) + '+' + fun.is_value(res['cp_ys']) + '</div>',
                            '     <div class="align-right"><a>' + fun.is_value(res['dq']) + '</a><a>' + fun.is_value(res['xz']) + '</a></div>',
                            '</div>',
                            '<div class="row">',
                            '     <div><a>' + fun.is_value(res['gg']) + '</a></div>',
                            '     <div class="align-right"><a>批号</a>' + fun.is_value(res['ph']) + '</div>',
                            '</div>',
                        ].join('')
                    },
                    subdata: function (res) {
                        //判断单据表类型，渲染 入库、出库 字段
                        // var orderType = res['djlx'];
                        // var hasRK = [];
                        // var hasCK = [];
                        // var hasCRK = [];

                        // var classify = {
                        //     //销售
                        //     xsRK: ["bp_xsdd", "bp_xsthd", "bp_xsthjs"],
                        //     xsCK: ["bp_xsfhd", "bp_xsfhjs"],

                        //     //采购
                        //     cgRK: ["bp_cgdd", "bp_cglhd", "bp_cglhjs"],
                        //     cgCK: ["bp_xsfhd", "bp_xsfhjs"],

                        //     //财务
                        //     cwRK: ["cw_skd", "cw_ywtz", "cw_nbzz", "cw_srd", "cw_fkd", "cw_fyd"],

                        //     //库存
                        //     cgRK: ["kc_bpfp", "11111", "11111"],
                        //     cgCK: ["kc_bpfp", "11111"],

                        //     //库存
                        //     cgRK: ["11111", "11111", "11111"],
                        //     cgCK: ["11111", "11111"],

                        //     //库存
                        //     cgRK: ["11111", "11111", "11111"],
                        //     cgCK: ["11111", "11111"],

                        //     //库存
                        //     cgRK: ["11111", "11111", "11111"],
                        //     cgCK: ["11111", "11111"],
                        // }


                        // var order_type_list = {
                        //     bp_xsdd: "客户订单",
                        //     bp_xsfhd: "发货单",
                        //     bp_xsthd: "退货单",
                        //     bp_xsfhjs: "销售发货结算",
                        //     bp_xsthjs: "销售退货结算",

                        //     bp_cgdd: "采购订单",
                        //     bp_cglhd: "来货单",
                        //     bp_cgthd: "退货单",
                        //     bp_cglhjs: "采购来货结算",
                        //     bp_cgthjs: "采购退货结算",
                        //     bp_cgfp: "采购发票",  //暂无采购发票 的 出库、入库信息

                        //     cw_skd: "收款单",
                        //     cw_ywtz: "业务调账",
                        //     cw_nbzz: "内部转账",
                        //     cw_srd: "其他收入",
                        //     cw_fkd: "付款单",
                        //     cw_fyd: "费用单",

                        //     kc_bpfp: "布匹分匹",
                        //     kc_bpczd: "拆装单",
                        //     kc_bptbd: "调拨单",
                        //     kc_bppyd: "盘盈单",
                        //     kc_bppkd: "盘亏单",
                        //     kc_bpmxpkd: "明细盘亏",
                        //     kc_zspd: "总数盘点",
                        //     kc_bpqtck: "其他出库",
                        //     kc_bpqtrk: "其他入库",

                        //     bp_xsfp: "销售发票",
                        //     bp_xsfp: "销售发票",
                        //     bp_xsbj: "销售报价",
                        //     bp_cgbj: "采购报价",
                        //     kc_bptmpd: "条码盘点",
                        //     bp_wwjg: "委外加工",
                        //     bp_jglhd: "加工来货单",
                        //     bp_jgthd: "加工退货单",
                        //     bp_jglhjs: "加工来货结算",
                        //     bp_jgthjs: "加工退货结算",
                        //     kc_bpghbq: "更换标签",
                        //     tmcj: "条码采集",
                        //     bp_jgbj: "加工报价",
                        // }

                        return [
                            '<div class="row">',
                            '    <div><span>期初</span><span>' + fun.is_value(res['qc']) + '</span></div>',
                            '    <div><span>入库</span><span>' + fun.is_value(res['rk']) + '</span></div>',
                            '</div>',
                            '<div class="row">',
                            '    <div><span>期末</span><span>' + fun.is_value(res['qm']) + '</span></div>',
                            '</div>',
                        ].join('');
                    }
                },
            });
        }

            break;
        case 'cloth':
            var order_data = [{
                wldw_mc: '客户名称',
                md_mc: '单据类型',
                zdr_mc: '制单人',
                kdsj: '2018-05-28 15:30',
                dh: 'CDD1812270006',
                list: [{
                    cp_bh: '编号',
                    cp_mc: '名称',
                    cp_sh: '色号',
                    cp_ys: '颜色',
                    fk: 170,
                    kz: 190,
                    qc: 30,
                    rk: 30,
                    qm: 30,
                }, {
                    cp_bh: '编号',
                    cp_mc: '名称',
                    cp_sh: '色号',
                    cp_ys: '颜色',
                    fk: 170,
                    kz: 190,
                    qc: 30,
                    rk: 30,
                    qm: 30,
                }],
            },];
            // showList(order_data);
            getList(search_storage);

            // var data = convertData();

            break;
        default:

    }
}


function showClothList(data) {
    var isnumber = search_storage['type']['number'];

    function queCon(res, key) {
        return function (key) {
            var map = isnumber ? {
                qc: "qc_sl",
                lc: "lc_sl",
                rk: "rk_sl",
                ck: "ck_sl",
            } : {
                qc: "qc_ps",
                lc: "lc_ps",
                rk: "rk_ps",
                ck: "ck_ps",
            }
            if (isnumber) {
                return (parseFloat(res[map[key]])) || 0;
            } else {
                return parseFloat(res[map[key]]) || 0;
            }
        }
    }

    function getFKKZ(fk, kz) {
        if ((!fk || !kz)) {
            return "";
        } else {
            return (fk + (fk && kz ? 'x' : "") + (kz));
        }
    }

    $('#order_list').empty();
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        render: {
            titlebar: function (res) {

                var djlx_mc = res['djlx_mc'] || '';
                djlx_mc = djlx_mc.replace(/销售发货结算/g,'销售开单');
                djlx_mc = djlx_mc.replace(/销售退货结算/g,'销售退单');

                return [
                    // '<div class="title-bar-row">',
                    // '    <div><span style="color:' + res['color_val'] + '">' + fun.is_value(res['wldw_mc'], "") + '</span></div>',
                    // '    <div class="align-right" ><a>' + fun.is_value(res['djlx_mc'], "") + '</a>&nbsp;<a>' + fun.is_value(res['zdr_mc']) + '</a></div>',
                    // '</div>',
                    // '<div class="title-bar-row">',
                    // '    <div><span>' + fun.is_value(fun.dateFormat(res['kdsj'])) + '</span></div>',
                    // '    <div class="align-right" ><a>' + fun.is_value(res['dh']) + '</a></div>',
                    // '</div>',
                    '<div class="title-bar-row bar-kc-hdbmx">',
                    '    <div><span class="font-bold">' + fun.is_value(res['wldw_mc'], "") + '</span></div>',
                    '    <div class="align-right font-ss" ><a>' + fun.formatTime(fun.dateFormat(res['kdsj'])) + '</a>&nbsp;<a>' + fun.is_value(res['zdr_mc']) + '</a></div>',
                    '</div>',
                    '<div class="title-bar-row bar-cgbj" style="width: 100%;">',
                    '    <div style="width: 100%;" class="font-ss paddingbm color-gray"><span>' + fun.is_value(djlx_mc, "") + '&nbsp;:&nbsp;</span><span>' + fun.is_value(res['dh']) + '</span></div>',
                    '</div>',
                ].join('');
            },
            subtitle: function (res) {
                return [
                    // '<div class="row">',
                    // '     <div>' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</div>',
                    // getFKKZ(res['fk'], res['kz']) ? '     <div class="align-right"><a>幅\\克</a>' + getFKKZ(res['fk'], res['kz']) + '</div>' : "",
                    // '</div>',
                    '<div class="row row-2">',
                    '     <div>' + fun.is_value(res['cp_bh']) + ' ' + fun.is_value(res['cp_mc']) + ' ' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</div>',
                    '</div>',
                ].join('')
            },
            subdata: function (res) {
                var qc = queCon(res);
                return [
                    '<div class="row row-2 bg-gray">',
                    '    <div><span class="color-gray">&nbsp;&nbsp;期初</span><span>' + qc('qc') + '</span></div>',
                    qc('rk') > 0 ?
                        '    <div><span class="color-gray">入库</span><span>' + qc('rk') + "" + (isnumber ? res['dw_mc'] : "") + '</span></div>' :
                        '    <div><span class="color-gray">出库</span><span>' + qc('ck') + "" + (isnumber ? res['dw_mc'] : "") + '</span></div>',
                    '    <div><span class="color-gray">期末</span><span>' + qc('lc') + '</span></div>',
                    '</div>',
                ].join('');

            }
        },
    });
}


function getList(data) {
    function convertData(apidata) {
        if (JSON.stringify(apidata) == "[]")
            return [];
        if ((!(apidata instanceof Array))) {
            return "参数错误";
        }

        var list = [], tmp = {};
        $(apidata).each(function (i, obj) {
            if (!tmp[obj["dh"]]) {
                tmp[obj["dh"]] = {
                    "wldw_mc": obj['wldw_mc'],
                    "md_mc": obj['md_mc'],
                    "zdr_mc": obj['zdr_mc'],
                    "kdsj": obj['kdsj'],
                    "dh": obj['dh'],
                    "djlx_mc": obj['djlx_mc'],
                }
                tmp[obj["dh"]]['list'] = [];
            }
            tmp[obj["dh"]]['list'].push(obj);
        })
        for (var i in tmp) {
            list.push(tmp[i]);
        }
        return list;
    }

    var tmpdata = $.extend(true, {}, data);
    tmpdata['type'] = 'hdb_lsz';
// console.log(JSON.stringify(tmpdata))
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpHdbList,
        data: tmpdata,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                page_list = convertData(res.data);
                showClothList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}

// var date_arr = fun.getMonthArr(6),
//     date_bar = $('#date_bar').dateBar({
//         'data': date_arr,
//         'tap': function (ret) {
//             var begintime = fun.Date(ret['begin_date']).Format('yy-mm-dd');
//             var endtime = fun.Date(ret['end_date']).Format('yy-mm-dd');
//         }
//     });
