var html_name = page_arr.kc_kcyj;
var search_data = {};
var page_list = [];
//头部
$('#header').header({
    back: true,
    title: "库存预警",
    filter: true,
    foot_input: {
        show: true,
        scan_icon: true,
        plader: "产品编号、产品名称"
    },
});

var USER_INFO = {};
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');


    search_data['xs'] = (fun.getItem(html_name + '_xs') || 'kys');
    search_data['xs_text'] = (fun.getItem(html_name + '_xs_text') || '可用数');
    search_data['yjfs'] = (fun.getItem(html_name + '_yjfs') || 'qb');
    search_data['yjfs_text'] = (fun.getItem(html_name + '_yjfs_text') || '全部');


    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'],
            data = temp['data'];

        // console.log(ret);

        switch (temp['status']) {
            case 'search':
                console.log(data);

                search_data['ck_id'] = data['ck']['id'];
                search_data['ck_mc'] = data['ck']['text'];
                search_data['cp_lb_id'] = data['cp_lb']['id'];
                search_data['cp_lb_text'] = data['cp_lb']['text'];
                search_data['md_id'] = data['md']['id'];
                search_data['md_mc'] = data['md']['text'];
                search_data['xs'] = data['xs']['type'];
                search_data['xs_text'] = data['xs']['text'];
                search_data['yjfs'] = data['yjfs']['type'];
                search_data['yjfs_text'] = data['yjfs']['text'];

                fun.setItem(html_name + '_xs', search_data['xs'])
                fun.setItem(html_name + '_xs_text', search_data['xs_text'])
                fun.setItem(html_name + '_yjfs', search_data['yjfs'])
                fun.setItem(html_name + '_yjfs_text', search_data['yjfs_text'])

                fun.setItem(html_name + 'sideslip', true);
                $('#product_list').empty();
                getList();
                break;
            case 'refresh':
                fun.setItem(html_name + 'sideslip', true);
                break;
        }
    })


    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('product_list', ".earlyWarning-box");
        }
    });

    getList();
}

function getList() {
    // console.log(JSON.stringify(search_data))
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileCkc,
        data: $.extend({}, {
            "cp_lb_id": 0,
            "md_id": 0,
            "ck_id": "",
            "ck_mc": "",
            "keyword": "",
            "keyword_key": ['cp_bh', 'cp_mc'],
            "yjlx": search_data['xs'],
            "xsyj": 1,
            "qbkc": 1,
        }, search_data),
        success: function (res) {
            if (res['status'] == 0) {
                $('#product_list').empty();
                var list = res['list'] || [],
                    hj = res['hj'] || {};

                if (list.length == 0) {
                    // showSum(hj);
                    $('#hj_zms').text(0);
                    $('#hj_zmas').text(0);
                    $('#hj_zgj').text(0);
                    $('#hj_zps').text(0);
                    $('#product_list').css({ 'height': '60%', 'position': 'fixed', 'width': '100%' });
                    // return $('#product_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#product_list',btnShow:false,style:'top:0rem;height:10rem;'});
                    
                } else {
                    $('#product_list').css({ 'height': 'auto', 'position': 'unset' });
                }
                showSum(hj);
                page_list = list;
                showList(fun.PagingData(page_list));
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}
function showList(data) {
    var Html = [];

    var kc,style_bcp,style_bcs,
        sxx_bcp = 0, sxx_ps = 'xx', sxx_p = '下限', sxx_pszy = '不足',
        sxx_bcs = 0, sxx_sl = 'xx', sxx_s = '下限', sxx_slzy = '不足';

    if (search_data['xs'] == 'kcs') kc = "库存";
    else if (search_data['xs'] == 'kys') kc = "可用";
    else if (search_data['xs'] == 'kfh') kc = "可发";


    $(data).each(function (i, item) {

        if (search_data['yjfs'].indexOf('qb') > -1) {//预警方式为全部
            if (item['ps'] < item['ps_xx']) {
                sxx_p = "下限";
                sxx_ps = "ps_xx";
                sxx_pszy = '不足';
                sxx_bcp = $.nui.decimalSub(item['ps_xx'],item['ps']);
                style_bcp='bzp';
            } else if (item['ps'] > item['ps_sx']) {
                sxx_p = "上限";
                sxx_ps = "ps_sx";
                sxx_pszy = '超出';
                sxx_bcp = $.nui.decimalSub(item['ps'],item['ps_sx']);
                style_bcp='ccp';
            } else if ((item['ps_xx'] < item['ps'] && item['ps'] < item['ps_sx'])||item['ps'] == item['ps_sx']||item['ps_xx'] == item['ps']) {
                sxx_bcp = 0;
            }


            if (item['sl'] < item['sl_xx']) {
                sxx_s = "下限";
                sxx_sl = "sl_xx";
                sxx_slzy = '不足';
                sxx_bcs = $.nui.decimalSub(item['sl_xx'],item['sl']);
                style_bcs='bzp';
            } else if (item['sl'] > item['sl_sx']) {
                sxx_s = "上限";
                sxx_sl = "sl_sx";
                sxx_slzy = '超出';
                sxx_bcs = $.nui.decimalSub(item['sl'],item['sl_sx']);
                style_bcs='ccp';
            } else if ((item['sl_xx'] < item['sl'] && item['sl'] < item['sl_sx'])||item['sl'] == item['sl_sx']||item['sl_xx'] == item['sl']) {
                sxx_bcs = 0;
            }

        } else if (search_data['yjfs'].indexOf('sxp') > -1) {//预警方式为上限匹
            sxx_p = "上限";
            sxx_ps = "ps_sx";
            sxx_pszy = '超出';
            sxx_bcp = $.nui.decimalSub(item['ps'],item['ps_sx']);
            style_bcp='ccp';
        } else if (search_data['yjfs'].indexOf('xxp') > -1) {//预警放式为下限匹
            sxx_p = "下限";
            sxx_ps = "ps_xx";
            sxx_pszy = '不足';
            sxx_bcp = $.nui.decimalSub(item['ps_xx'],item['ps']);
            style_bcp='bzp';
        } else if (search_data['yjfs'].indexOf('xxs') > -1) {//预警方式下限数
            sxx_s = "下限";
            sxx_sl = "sl_xx";
            sxx_slzy = '不足';
            sxx_bcs = $.nui.decimalSub(item['sl_xx'],item['sl']);
            style_bcs='bzp';
        } else if (search_data['yjfs'].indexOf('sxs') > -1) {//预警方式上限数
            sxx_s = "上限";
            sxx_sl = "sl_sx";
            sxx_slzy = '超出';
            sxx_bcs = $.nui.decimalSub(item['sl'],item['sl_sx']);
            style_bcs='ccp';
        }

        if (sxx_bcp != 0 || sxx_bcs != 0) {
            Html.push(' <div class="earlyWarning-box" data-list=\'' + fun.formatString(JSON.stringify(item)) + '\'>');
            Html.push('     <div class="earlyWarning-titli">');
            Html.push('         <h5>' + item['kc_mc'] + '</h5>');
            Html.push('     </div>');
            Html.push('     <div class="earlyWarning-product">');
            Html.push('         <span class="yj-ellipsis">' + (fun.redFont((fun.is_value(item['cp_bh']) +fun.is_value(item['cp_mc'])),search_data['keyword'])||'') + ' ' + (fun.is_value(item['cp_ys_bh']) + fun.is_value(item['cp_ys_mc'])) + '</span>');
            Html.push('     </div>');
            Html.push('     <ul class="earlyWarning-frame">');

            Html.push(!!sxx_bcp ? '         <div>' : '');
            Html.push(!!sxx_bcp ? '             <li class="kc_changeable">' : '');
            Html.push(!!sxx_bcp ? '                 <span>' + kc + '</span>' : '');
            Html.push(!!sxx_bcp ? '                 <span>' + item['ps'] + '匹</span>' : '');
            Html.push(!!sxx_bcp ? '             </li>' : '');
            Html.push(!!sxx_bcp ? '             <li class="kc_fixed">' : '');
            Html.push(!!sxx_bcp ? '                 <span>' + sxx_p + '</span>' : '');
            Html.push(!!sxx_bcp ? '                 <span>' + item[sxx_ps] + '</span>' : '');
            Html.push(!!sxx_bcp ? '             </li>' : '');
            Html.push(!!sxx_bcp ? '             <li class="kc_fixed">' : '');
            Html.push(!!sxx_bcp ? '                 <span>' + sxx_pszy + '</span>' : '');
            Html.push(!!sxx_bcp ? '                 <span class="'+style_bcp+'">' + sxx_bcp + '</span>' : '');
            Html.push(!!sxx_bcp ? '             </li>' : '');
            Html.push(!!sxx_bcp ? '         </div>' : '');

            Html.push(!!sxx_bcs ? '         <div>' : '');
            Html.push(!!sxx_bcs ? '             <li class="kc_changeable">' : '');
            Html.push(!!sxx_bcs ? '                 <span>' + kc + '</span>' : '');
            Html.push(!!sxx_bcs ? '                 <span>' + item['sl'] + item['dw_mc'] + '</span>' : '');
            Html.push(!!sxx_bcs ? '             </li>' : '');
            Html.push(!!sxx_bcs ? '             <li class="kc_fixed">' : '');
            Html.push(!!sxx_bcs ? '                 <span>' + sxx_s + '</span>' : '');
            Html.push(!!sxx_bcs ? '                 <span>' + item[sxx_sl] + '</span>' : '');
            Html.push(!!sxx_bcs ? '             </li>' : '');
            Html.push(!!sxx_bcs ? '             <li class="kc_fixed">' : '');
            Html.push(!!sxx_bcs ? '                 <span>' + sxx_slzy + '</span>' : '');
            Html.push(!!sxx_bcs ? '                 <span class="'+style_bcs+'">' + sxx_bcs + '</span>' : '');
            Html.push(!!sxx_bcs ? '             </li>' : '');
            Html.push(!!sxx_bcs ? '         </div>' : '');
            Html.push('     </ul>');
            Html.push(' </div>');
        }
    })
    $('#product_list').append(Html.join(''));
}

//显示合计
function showSum(hj) {
    var zms,zmas,zgj,zps;
    if(search_data['yjfs'].indexOf('xx')>-1){//下限
        zms=hj['sl_m_bz'];//总米数
        zmas=hj['sl_y_bz'];//总码数
        zgj=hj['sl_kg_bz'];//总公斤
        zps=hj['ps_bz'];//总匹数
    }else if(search_data['yjfs'].indexOf('sx')>-1){//上限
        zms=hj['sl_m_cc'];//总米数
        zmas=hj['sl_y_cc'];//总码数
        zgj=hj['sl_kg_cc'];//总公斤
        zps=hj['ps_cc'];//总匹数
    }else if(search_data['yjfs'].indexOf('qb')>-1){//全部
        zms=$.nui.decimalSub(hj['sl_m_bz'],hj['sl_m_cc']);//总米数
        zmas=$.nui.decimalSub(hj['sl_y_bz'],hj['sl_y_cc']);//总码数
        zgj=$.nui.decimalSub(hj['sl_kg_bz'],hj['sl_kg_cc']);//总公斤
        zps=$.nui.decimalSub(hj['ps_bz'],hj['ps_cc']);//总匹数
    }
    // console.log(zms)
    // console.log(zmas)
    // console.log(zgj)
    $('#hj_zms').text(Math.round((zms || 0) * 10) / 10);
    $('#hj_zmas').text(Math.round((zmas  || 0) * 10) / 10);
    $('#hj_zgj').text(Math.round((zgj || 0) * 10) / 10);
    $('#hj_zps').text(zps || 0);
}


fun.setItem(html_name + 'sideslip', true);
// 打开搜索页
$('body').on('click', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "choose_merchants": [
            {
                "key": "ck",
                "id": ((search_data && search_data['ck_id']) ? search_data['ck_id'] : 0),
                "text": "仓库",
                "value": ((search_data && search_data['ck_mc']) ? search_data['ck_mc'] : "")
            },
            {
                "key": "cp_lb",
                "id": ((search_data && search_data['cp_lb_id']) ? search_data['cp_lb_id'] : 0),
                "text": "类别",
                "value": ((search_data && search_data['cp_lb_text']) ? search_data['cp_lb_text'] : "")
            },
            {
                "key": "md",
                "id": ((search_data && search_data['md_id']) ? search_data['md_id'] : 0),
                "text": "门店",
                "value": ((search_data && search_data['md_mc']) ? search_data['md_mc'] : "")
            },
        ],
        'xs': [
            {
                "key": 'xs',
                "text": "显示",
                "xsType": (search_data && search_data['xs'] || 'kys'),
                "list": [
                    { 'name': '可用数', 'column': 'kys', 'is_choose': 1 },
                    { 'name': '可发货', 'column': 'kfh', 'is_choose': 0 },
                    { 'name': '库存数', 'column': 'kcs', 'is_choose': 0 },
                ],
                "alone": true,
                "value": (search_data && search_data['xs_text'] || "可用数"),
            },
            {
                "key": 'yjfs',
                "text": "预警",
                "xsType": (search_data && search_data['yjfs'] || 'qb'),
                "list": [
                    { 'name': '全部', 'column': 'qb', 'is_choose': 1 },
                    { 'name': '上限数', 'column': 'sxs', 'is_choose': 0 },
                    { 'name': '下限数', 'column': 'xxs', 'is_choose': 0 },
                    { 'name': '上限匹', 'column': 'sxp', 'is_choose': 0 },
                    { 'name': '下限匹', 'column': 'xxp', 'is_choose': 0 },
                ],
                "alone": true,
                "value": (search_data && search_data['yjfs_text'] || "全部"),
            }
        ]
    };
    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});



$('body').on('click', '.earlyWarning-box', function (e) {
    if(!Auth.check('bp_ckc', 'view')) return;

    var data_list = $(this).data('list');
    // console.log($(this).data('list'));
    // return;
    var type = '', sxx = '', sxx_text = '';
    if (search_data['yjfs'].indexOf('qb') > -1) type = '', sxx = 'qb', sxx_text = '全部';
    else if (search_data['yjfs'].indexOf('sxs') > -1) type = 'sl', sxx = 'sx', sxx_text = '上限';
    else if (search_data['yjfs'].indexOf('xxs') > -1) type = 'sl', sxx = 'xx', sxx_text = '下限';
    else if (search_data['yjfs'].indexOf('sxp') > -1) type = 'ps', sxx = 'sx', sxx_text = '上限';
    else if (search_data['yjfs'].indexOf('xxp') > -1) type = 'ps', sxx = 'xx', sxx_text = '下限';
    fun.showPageFull({
        page_url: page_arr.kc_kcxq,
        pageParam: {
            return_page: html_name,
            name: 'kcyj',
            info: (data_list['cp_bh'] || '') + ' ' + (data_list['cp_mc'] || ''),//title
            cp_id: data_list['cp_id'],//产品id
            ck_id: data_list['ck_id'],//仓库id
            ck_mc: data_list['kc_mc'],//仓库名称
            cp_ys_id: data_list['cp_ys_id'],
            cp_ys_mc: (data_list['cp_ys_bh'] || '') + ' ' + (data_list['cp_ys_mc'] || ''),
            md_id: ((search_data && search_data['md_id']) ? search_data['md_id'] : 0),//门店id
            md_mc: ((search_data && search_data['md_mc']) ? search_data['md_mc'] : ''),//门店名称
            dw_id:data_list['dw_id']||0,
            type: type,//类型
            xs: search_data['xs'],//显示
            xs_text: search_data['xs_text'],//显示文本
            yjfs: sxx,//预警方式
            yjfs_text: sxx_text,//预警方式文本
            xsyj: 1,//显示预警
            qbkc: 1,//显示0库存
        }
    });
    return false;
})

//搜索框
$('body').bind('search', "#foot_search", function () {
    search_data['keyword'] = $('#foot_search').val().trim();
    $('#product_list').empty();
    getList();
});
//打开扫描
$('body').on('click', ".icon-saoma", function () {
    QuestPermission.requestPermission('camera', null,function () {
        openScanner({
            callback: function (value) {
                $("#foot_search").val(value);
                if (!!$("#foot_search").val().trim()) {
                    search_data['keyword'] = $('#foot_search').val().trim();
                    $('#product_list').empty();
                    getList();
                    return true;
                } else {
                    fun.toast('扫码失败！');
                    return true;
                }
            }
        });
    });
   
});
//扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });
}
