var html_name = page_arr.detailed_barcode;

var kc_mxpk_barcode = {
    ROW_DATA: {},
    __DJ_DATA: {},
    edit_row: []        // 修改的明细记录，包括删除、修改
};

/**
 * 页面必传参数
 * return_page 事件通知页面
 * list_data 点击的汇总行信息
 * __DJ_DATA 单据信息
 */
page_init = function () {
    console.log('kc_mxpk_barcode', page_data);

    kc_mxpk_barcode.ROW_DATA = page_data['list_data'];
    kc_mxpk_barcode.__DJ_DATA = page_data['__DJ_DATA'] || {};

    kc_mxpk_barcode.initHeader();

    // $('.content').css({
    //     height: 'calc(100% - 5rem)',
    //     top: '5rem'
    // });

    // $('.editor-wrap').css({
    //     height:'5rem'
    // })

    $('#shys').text((kc_mxpk_barcode.ROW_DATA['cp_ys_bh'] || '') + (kc_mxpk_barcode.ROW_DATA['cp_ys_mc'] || ''));

    if ($.nui.isTrue(page_data.__PAGE_EDIT)) {
        $('#list').addClass('swipe-delete');
        $('.dbd-show').show();
    } else {
        $('.dbd-show').hide();
        $('#list').removeClass('swipe-delete');
    }


    kc_mxpk_barcode.initPageData(kc_mxpk_barcode.ROW_DATA);

    kc_mxpk_barcode.showList(kc_mxpk_barcode.ROW_DATA['mx']);
};


kc_mxpk_barcode.initHeader = function () {
    $('#header').header({
        back: true,
        title: (kc_mxpk_barcode.ROW_DATA['cp_bh'] || '') + (kc_mxpk_barcode.ROW_DATA['cp_mc'] || ''),
        // text_btn: page_data.__PAGE_EDIT,
        // text_val: '完成',
        appendBackBtnEvt: function () {
            kc_mxpk_barcode.sendData(true);
        }
    });
};

// 发送数据
kc_mxpk_barcode.sendData = function (closeWin) {
    if (page_data.__PAGE_EDIT && !$.nui.isEmpty(kc_mxpk_barcode.edit_row)) {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'update_row',
                'data': {
                    row_data: kc_mxpk_barcode.edit_row,
                }
            }
        });
    }

    if (closeWin) {
        setTimeout(function () {
            api.closeWin();
        }, 200);
    }
};

// 渲染明细列表
kc_mxpk_barcode.showList = function (mx) {
    var html = [];
    for (var i = 0; i < mx.length; i++) {
        var val = mx[i];
        if ($.nui.isTrue(val['is_delete'])) continue;

        var color = ((val['zsl'] > 0 && val['sl'] > 0) && (val['sl'] !== val['zsl'])) ? 'color: green;' : '';
        html.push('<li class="list-term lower-border-line" data-list_data=\'' + fun.formatString(JSON.stringify(val)) + '\' data-index="' + i + '">');
        html.push('     <div class="le">');
        html.push('         <span class="summary" style="' + color + '">' + val['sl'] + '</span>');
        html.push('         <span class="unit">' + kc_mxpk_barcode.ROW_DATA['dw_mc'] + '</span>');
        html.push('         <span class="text">' + (val['tm'] || '') + '</span>');
        html.push('         <div class="delete dels1 delete-btn" data-index="' + i + '">删除</div>');
        html.push('     </div>');
        html.push('</li>');
    }
    var ul_height = $('.editor-wrap').height();
    $('#list').html(html.join('')).css('top', 'calc(5rem + ' + ul_height + 'px)');
};

// 初始化数据
kc_mxpk_barcode.initPageData = function (row) {
    $('#header_title').data('cp_id', row['cp_id']);

    var cp_info = fun.getListInfoByKey(fun.getItem('cp_list') || [], row['cp_id']);
    var cp_imgs = cp_info['imgs'] || '';
    cp_imgs = cp_imgs.split(',')[0];

    var img_url = (cp_imgs) ? fun.getImgPath(cp_imgs) : "../img/logo.png";

    $('.img-box').css({
        background: 'url(' + img_url + ') no-repeat',
        backgroundSize: '100%',
        backgroundPosition: 'center center'
    });

    // $('#fk').val(row['fk'] || '');
    // $('#kz').val(row['kz'] || '');
    // $('#gh').val(row['gh'] || '');
    var _sys_config = fun.getItem('sys_config');
    var kdphsz_arr = _sys_config['kdphsz'] && _sys_config['kdphsz'].split(',') || [];
    var html = [];
    if (kdphsz_arr.length > 3) {
        html.push('<li class="edit-list">');
        html.push('    <div class="in-block">');
        html.push('        <span class="label-info">幅宽</span>');
        html.push('        <input id="fk" class="" type="text" value="' + (data['fk'] || '') + '" readonly="readonly"/>');
        html.push('    </div>');
        html.push('    <div class="in-block">');
        html.push('        <span class="label-info">克重</span>');
        html.push('        <input id="kz" class="" type="text" value="' + (data['kz'] || '') + '" readonly="readonly"/>');
        html.push('    </div>');
        html.push('    <div class="in-block">');
        html.push('        <span class="label-info">规格</span>');
        html.push('        <input id="gg" class="" type="text" value="' + (data['gg'] || '') + '" readonly="readonly"/>');
        html.push('    </div>');
        html.push('</li>');
        html.push('<li class="edit-list">');
        html.push('    <div class="in-block">');
        html.push('        <span class="label-info">缸号</span>');
        html.push('        <input id="gh" class="" type="text" value="' + (data['gh'] || '') + '" readonly="readonly"/>');
        html.push('    </div>');
        html.push('</li>');
    } else if (kdphsz_arr.length <= 3 && kdphsz_arr.length != 0) {
        html.push('<li class="edit-list">');
        $(kdphsz_arr).each(function (i, item) {
            switch (kdphsz_arr[i]) {
                case 'fk':
                    html.push('    <div class="in-block">');
                    html.push('        <span class="label-info">幅宽</span>');
                    html.push('        <input id="fk" class="" type="text" value="' + (data['fk'] || '') + '" readonly="readonly"/>');
                    html.push('    </div>');
                    break;
                case 'kz':
                    html.push('    <div class="in-block">');
                    html.push('        <span class="label-info">克重</span>');
                    html.push('        <input id="kz" class="" type="text" value="' + (data['kz'] || '') + '" readonly="readonly"/>');
                    html.push('    </div>');
                    break;
                case 'gg':
                    html.push('    <div class="in-block">');
                    html.push('        <span class="label-info">规格</span>');
                    html.push('        <input id="gg" class="" type="text" value="' + (data['gg'] || '') + '" readonly="readonly"/>');
                    html.push('    </div>');
                    break;
                case 'gh':
                    html.push('    <div class="in-block">');
                    html.push('        <span class="label-info">缸号</span>');
                    html.push('        <input id="gh" class="" type="text" value="' + (data['gh'] || '') + '" readonly="readonly"/>');
                    html.push('    </div>');
                    break;

            }
        })
        html.push('</li>');
    }
    $('.likeSet').html(html.join(''));



    $('#ps').val(row['ps'] || 0);
    $('#sl').val(row['zsl'] || 0);
    $('#dw').text(row['dw_mc'] || '单位').data('dw_id', row['dw_id'] || 0);
};

// 计算总匹数 和 总数量
kc_mxpk_barcode.calcZpsZsl = function (arr) {
    var zps = 0, zsl = 0;

    for (var i = 0; i < arr.length; i++) {
        if ($.nui.isTrue(arr[i]['is_delete'])) continue;
        zps = $.nui.decimalAdd(zps, arr[i].ps < 0 ? 0 : arr[i].ps);
        zsl = $.nui.decimalAdd(zsl, parseFloat(arr[i]['sl'] || 0));
    }

    $('#ps').val(zps || 0);
    $('#sl').val(zsl || 0);
};

// 事件绑定 ------------------------------------------------------------------------------------------

// 删除
$('body').on('touchend', '.delete-btn', function (e) {
    e.preventDefault();
    if ($(this).attr('disabled')) return;
    if (!$.nui.isTrue(page_data.__PAGE_EDIT)) return;

    var row = $(this).closest('li').data('list_data') || {};
    var val = row['sl'];
    var index = $(this).closest('li').data('index');
    fun.dialog({
        content: '你确定要删除：【' + val + (row['dw_mc'] || '') + '】的布匹吗？',
        btn: ['删除', '取消'],
        yes: function () {
            var item = kc_mxpk_barcode.ROW_DATA.mx[index];

            // 处理删除的条码
            page_data.tm_arr = page_data.tm_arr || [];
            for (var i = 0; i < page_data.tm_arr.length; i++) {
                if (page_data.tm_arr[i] === item.tm) {
                    page_data.tm_arr.splice(i, 1);
                    break;
                }
            }

            if (item.__uuid) {    // 删除原有的记录
                item.is_delete = 1;
                kc_mxpk_barcode.edit_row.push(item);
            } else {               // 不是删除原有的记录，直接删除
                kc_mxpk_barcode.ROW_DATA.mx.splice(index, 1);
            }

            kc_mxpk_barcode.showList(kc_mxpk_barcode.ROW_DATA.mx);
            kc_mxpk_barcode.calcZpsZsl(kc_mxpk_barcode.ROW_DATA.mx);
        }
    });
    return false;
});

// 行记录点击
$('body').on('tap', '.list-term', function (e) {
    if (!$.nui.isTrue(page_data.__PAGE_EDIT)) return;
    var row = $(this).data('list_data');
    var index = $(this).data('index');

    var content = [];
    content.push('<div class="edit-wrap">');
    content.push('  <div class="edit-title"><span>修改数量</span></div>');
    content.push('  <div class="edit-row"><label class="edit-label">出库数</label><input id="cks" type="text" class="cks-input num-input" num_type="2" decimal_digits="4"/><span id="dw_mc" class="dw-text">' + kc_mxpk_barcode.ROW_DATA['dw_mc'] + '</span></div>');
    content.push('  <div class="edit-row"><label class="edit-label">库存数</label><span id="kcs" class="show-text">' + (row['kc_sl'] || ' ') + '</span></div>');
    content.push('</div>');

    var oldSl = row['sl'];
    var kc_sl = row.kc_sl;

    fun.dialog({
        content: content.join(''),
        btn: ['确定', '取消'],
        success: function () {
            $('#cks').val(row['sl']).select();
            $('#kcs').text(row['kc_sl']);

            setTimeout(function () {
                $('#cks').focus();
            }, 200);
        },
        yes: function () {
            var newSl = parseFloat($('#cks').val().trim() || 0);
            if (isNaN(newSl)) return false;
            if (oldSl === newSl) return false;

            // 如果当前仓库有开启：不负库存
            // 当用户修改的数量大于该布匹对应的库存数时，修改无效。自动跳回没修改前的值
            if ($.nui.isTrue(fun.getHouseValue(row.ck_id, 'is_minus'))) {
                if (newSl < 0) {
                    return false;
                }
            }
            // 布匹数量不能为0
            if (newSl === 0) {
                return fun.toast('请输入布匹数量');
            }

            var item = kc_mxpk_barcode.ROW_DATA.mx[index];
            if (newSl > kc_sl) {            // 新增数量，不能大于库存数量
                return false;
            } else if (newSl < kc_sl) {     // 新增数量，小于库存数量时，匹数减1
                // 添加修改的行记录, ps、sl
                if (item.ps > 0) {
                    item.ps = item.ps - 1;
                }
            } else {                        // 新增数量，等于库存数量时，匹数等于1
                item.ps = 1;
            }

            item.sl = newSl;
            kc_mxpk_barcode.edit_row.push(item);
            // 渲染数据，计算总匹数、总数量
            kc_mxpk_barcode.showList(kc_mxpk_barcode.ROW_DATA.mx);
            kc_mxpk_barcode.calcZpsZsl(kc_mxpk_barcode.ROW_DATA.mx);
        }
    });
});

// 调库存处理
$('body').on('tap', '.stock-btn', function (e) {
    e.preventDefault();

    kc_mxpk_barcode.sendData(false);

    var cp_ys_info = {
        cp_ys_id: kc_mxpk_barcode.ROW_DATA.cp_ys_id,
        cp_ys_bh: kc_mxpk_barcode.ROW_DATA.cp_ys_bh,
        cp_ys_mc: kc_mxpk_barcode.ROW_DATA.cp_ys_mc,
    };

    var cp_info = {
        id: kc_mxpk_barcode.ROW_DATA.cp_id,
        name: kc_mxpk_barcode.ROW_DATA.cp_mc,
        number: kc_mxpk_barcode.ROW_DATA.cp_bh
    };

    fun.showPageFull({
        page_url: page_arr.detailed_stock2,
        pageParam: {
            djlx: page_data.djlx,
            return_page: html_name,
            goto_page: page_data['return_page'],
            ck_id: kc_mxpk_barcode.ROW_DATA.ck_id,
            cp_info: cp_info,
            cp_ys_info: cp_ys_info,
            disabledCpCkYs: true,
            tm_arr: page_data.tm_arr,
            __row_data: kc_mxpk_barcode.ROW_DATA,
            __JL_DATA: [],
            ck_is_disabled: page_data['ck_is_disabled']
        }
    });
});

// 完成
$('body').on('tap', '#complete_btn', function (e) {
    e.stopPropagation();
    kc_mxpk_barcode.sendData(true);
});

//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });

}
//扫码
$(".saoma").on('click', function () {
    openScanner({
        callback: function (value) {
            if (!!value) {
                var mx = ROW_DATA['mx']
                if (mx.length != 0) {
                    for (var i = 0; i < mx.length; i++) {
                        if (mx[i]['tm'] == value) {
                            var item = kc_mxpk_barcode.ROW_DATA.mx[i];

                            // 处理删除的条码
                            page_data.tm_arr = page_data.tm_arr || [];
                            for (var i = 0; i < page_data.tm_arr.length; i++) {
                                if (page_data.tm_arr[i] === item.tm) {
                                    page_data.tm_arr.splice(i, 1);
                                    break;
                                }
                            }
                
                            if (item.__uuid) {    // 删除原有的记录
                                item.is_delete = 1;
                                kc_mxpk_barcode.edit_row.push(item);
                            } else {               // 不是删除原有的记录，直接删除
                                kc_mxpk_barcode.ROW_DATA.mx.splice(i, 1);
                            }
                
                            kc_mxpk_barcode.showList(kc_mxpk_barcode.ROW_DATA.mx);
                            kc_mxpk_barcode.calcZpsZsl(kc_mxpk_barcode.ROW_DATA.mx);
                            return true;
                        }
                    }
                    return fun.toast('当前页面找不到该条码。');
                } else {
                    fun.toast('无明细布匹。');
                }
                return true;
            } else {
                fun.toast('扫码失败！');
                return true;
            }
        }
    });
});