$('#header').header({
    back:true,
    title:'验布分析',
    bar:true,
    filter:true,
    analysis_info:{
      show:true,
      hasinput:true,
      analysis_type:'验布效率',
      type_sel:'验布人',
      count:'25413268.32',
      count_title:'总匹数',
    },
});


//当前日期
var cur_time=fun.getNowFormatDate();
$('.date').text(cur_time.slice(0,7));

//切换时间
$(".cuttime").on('tap',function(){
    var id=$(this)[0].id;
		var dateval=$('.date').text();
		var ss=getCutTime(id,dateval);
		$('.date').text(ss);
});

//获得相应月份
	function getCutTime(id,cur_times){
		//获得当前年月日
		var cur_year=parseInt(cur_times.slice(0,4));
		var cur_month=parseInt(cur_times.slice(5,7));
		var year,month,str;
		//判断是前一月还是下一月时间
		switch(id){
			case 'pre_time':
				if(cur_month==1){
					cur_year--;//如果当前月份为1月，则年份减1
					cur_month=12;
					year=cur_year;
					month=cur_month;
				}else{
					cur_month--;
					year=cur_year;
				}
			break;
			case 'next_time':
				if(cur_month==12){
					cur_year++;//如果当前月份为1月，则年份减1
					cur_month=1;
					year=cur_year;
					month=cur_month;
				}else{
					cur_month++;
					year=cur_year;
				}
			break;
			default:break;
		}
		if(cur_month.toString().length==1){
			month='0'+cur_month;
		}else{
			month=cur_month;
		}
		str=year+'-'+month;
		return str;
	}
//得到日期
var ds;
var begin_lCalendar = new lCalendar();
  	begin_lCalendar.init({
      'trigger': '#begin_date',
      'type': 'date',
      callback:function(date){
        ds=date.slice(0,7);
        $('.date').text(ds);
      }
  });
var headerH,inputH,html_name=page_arr.kc_ybfx;
page_init = function(){
  var header = $api.byId('header');
  headerH = $api.offset(header).h;
  headerH=headerH-$('.analysis-input').height()-$('.analysis-show').height()-15;
  //接收搜索页值
  api.addEventListener({
      name:html_name
  },function(ret,err){
  });
}
var params = {
  auto_width: '100%',
  show_sum: false,
  roll_height: '100%',
  title: [{
      name: '验布人',
      key: 'yb',
      width: 70
    }, {
      name: '匹数',
      key: 'ps',
      width: 70
    }, {
      name: '增长',
      key: 'add',
      width: 50
    }
  ],
  data: [
      {'yb':'张三','ps':'100','add':'<span class="change">10</span><span>11.68%</span>'},
      {'yb':'李四','ps':'100','add':'<span class="change">-2</span><span>-2.3%</span>'},
      {'yb':'王五','ps':'100','add':'<span class="change">10</span><span>6.8%</span>'},
  ],
};

$('#params').goods_grid(params);
$('.change').each(function(){
  var n=parseInt($(this).text());
  if(n>0){
    $(this).css('color','#4DC46F');
  }else{
    $(this).css('color','#FF2B29');
  }
});

$('body').on('tap','#bar_btn',function(){
    fun.showPageFull({
        page_url: page_arr.ybfx_yfx,
        pageParam: {}
    });
});
fun.setItem(html_name+'sideslip',true);
//打开搜索框
$('body').on('tap','#filter_btn',function(){
  var sideslip=fun.getItem(html_name+'sideslip');
  var options = {
    "keywords": {
          "key": "LIKE_DATA",
          "value": "",
          "placeholder": "搜索XX"
      },
      "choose_merchants":[
      	{key:"md","text":"门店","value":""},
      	{key:"xs","text":"显示","value":"金额"},
        {key:"zz","text":"增长","value":"比上月"},
      ],
      "sort": [
            {"text": "金额", "key": "JE_SORT", "value": "desc"},
      ],
  };
  if(sideslip){
         

        fun.setItem(html_name+'sideslip',false);
    fun.openFrame({
        frame_url: page_arr.search,
        pageParam:{
          "return_page":html_name,
              "search_data": options
        },
        y: headerH
    });
  }
});
