var html_name = page_arr.kdxq_mxbp;
var row_data = {};
var __PAGE_EDIT;
var __ROW_DATA = {};

page_init = function () {
    // $('#foot_search').trigger('click').focus();

    __ROW_DATA = page_data['data'];
    $('#header').header({
        back: true,
        title: (__ROW_DATA['cp_bh'] || '') + (__ROW_DATA['cp_mc'] || ''),
        foot_input: {
            show: false,
            plader: '搜索条码',
            scan_icon: true
        },
        appendBackBtnEvt: function () {
            sendData();
        }
    });

    // if (!existTm(__ROW_DATA['mx'])) {
    $('.content').css({
        height: 'calc(100% - 3.2rem)',
        // top: '3.2rem'
    });
    // }

    $('#shys').text((__ROW_DATA['cp_ys_bh'] || '') + (__ROW_DATA['cp_ys_mc'] || ''));
    $('#zps').text(__ROW_DATA['ps'] || 0);
    $('#zsl').text(__ROW_DATA['zsl'] || 0);

    $('#list').removeClass('swipe-delete');

    showList(__ROW_DATA['mx']);
};


/************************* 方法 *************************/
function sendData() {
    if (__PAGE_EDIT) {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'update_row',
                'data': {
                    row_index: page_data['row_index'],
                    row_data: __ROW_DATA
                }
            }
        });
    }

    setTimeout(function () {
        api.closeWin();
    }, 200);
}


// 是否存在条码
function existTm(data) {
    for (var i = 0; i < data.length; i++) {
        if ($.nui.isTrue(data[i]['tm'])) {
            return true;
        }
    }
    return false;
}

// 渲染列表
function showList(data) {
    var html = [];
    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        var color = ((val['tm_sl'] > 0 && val['sl'] > 0) && (val['sl'] != val['tm_sl'])) ? 'color: green;' : '';
        html.push('<li class="list-term lower-border-line" data-list_data=\'' + fun.formatString(JSON.stringify(val)) + '\' data-index="' + i + '">');
        html.push('     <div class="le">');
        html.push('         <span class="summary" style="' + color + '">' + val['sl'] + '</span>');
        html.push('         <span class="unit">' + __ROW_DATA['dw_mc'] + '</span>');
        html.push('         <span class="text">' + (val['tm'] || '') + '</span>');
        html.push('         <div class="delete dels1 delete-btn" data-index="' + i + '">删除</div>');
        html.push('     </div>');
        html.push('</li>');
    }
    $('#list').html(html.join(''));
}

// 获取 当前选择的 仓库ID
function __getCkID(ck_id) {
    var _ck_id = ck_id;
    if ($.nui.isEmpty(ck_id)) {
        _ck_id = __ROW_DATA['ck_id'] || 0;
    }
    return _ck_id || 0;
}

// 计算总匹数 和 总数量
function calcZpsZsl(data) {
    var zps = 0,
        zsl = 0;
    zps = data.length;
    for (var i = 0; i < data.length; i++) {
        zsl += data[i]['sl'];
    }
    $('#zps').text(zps || 0);
    $('#zsl').text(zsl || 0);
}

/************************* 事件绑定 *************************/

$('body').on('tap', '.icon-saoma', function (e) {
    e.stopPropagation();
    QuestPermission.requestPermission('camera', null,function () {
        fun.openScanner({
            callback: function (value) {
                $('#foot_search').val(value);
            }
        });
    });
});
