var html_name = page_arr.label,
    label_arr = [],
    is_edit = false,
    color_index = 0,
    search_data = {};

var docHeight = $(document).height();
var type_data = false;

$('#header').header({
    back: true,
    add: true,
    edit: true,
    // filter: true,
    title: '标签',
    foot_input: {
        show: true,
        plader: '搜索'
    },
    appendBackBtnEvt: sendData,
});
var u = navigator.userAgent;
var isAndroid = u.indexOf("Android") > -1 || u.indexOf("Adr") > -1; // android终端

// TODO代码可优化
page_init = function () {
    // fun.iosRemoveScroll('.label-content');
    page_data.keyback = sendData;//  监听返回键
    var index = fun.getItem('color_index'+page_data.page_type) || 0;
    if(index === 10){
        index = 0;
    }else if(index === 0){
        index = 0;
    }else{
        index = index + 1;
    }
    color_index = index || 0;
    $('#foot_search').select();
    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret['value'],
            data = temp['data'];
        switch (temp.status) {
            case 'search':
                search_data['is_stop'] = data['is_stop'] || '';//是否显示停用
                fun.setItem(html_name + '_isStop', data['is_stop']);
                fun.setItem(html_name + 'sideslip', true);
                break;
            case 'refresh':
                getData();
                break;
        }
    });
    getData();

    fun.orderListHeight({ dom: '#list' });
    fun.setKeyBoard({
        isIos: {
            showFn: keyBoardShow,
            hideFn: keyBoardHide
        },
    });
}

function getData() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getLabelList,
        data: $.extend({
            "type": page_data.page_type,
            "keyword": "",
            "keyword_key": ['name', 'simple'],
            "is_stop": fun.getItem(html_name + '_isStop') || "",
        }, search_data),
        success: function (res) {
            if (res.status != 0) return fun.toast('获取信息失败！');
            var info_list = res.data;

            if (info_list.length === 0) {
                if(type_data){
                    is_event(is_edit);
                }
                return fun.createDataEmptyTips({ dom: '#list', btnText: '新增标签', auth: '', isDa: true });
            }

            showData(info_list);
            if(type_data){
                is_event(is_edit);
            }
        }
    });
}

//显示数据
function showData(data) {
    var html = [];
    if (!$.nui.isEmpty(page_data['label_arr'])) {
        label_arr = page_data['label_arr'].split(',');
    }
    var len = data.length - 1;
    for (var i = 0; i < data.length; i++) {
        var val = data[i],
            bg_color = "background-color:" + val['colour'] + ";";
        if (!!label_arr && label_arr.indexOf(String(val['id'])) !== -1) {
            html.push('<li class="list-term" colour="' + val['colour'] + '" is="true" id="' + val['id'] + '" name="' + val['name'] + '" remark="' + val['remark'] + '">');
            html.push('<div class="box" style="' + bg_color + '" id="' + val['id'] + '">');
        } else {
            html.push('<li class="list-term" colour="' + val['colour'] + '" is="false" id="' + val['id'] + '" name="' + val['name'] + '" remark="' + val['remark'] + '">');
            html.push('<div class="box">');
        }
        html.push('<span class="text" type="' + val['type'] + '" sort="' + val['sort'] + '">' + val['name'] + '</span>');
        html.push('</div>');
        html.push('<div class="packParent"><div class="pack"><i class="iconfont icon-fork fork"></i></div></div>');
        html.push('</li>');
    }
    $('#list').html(html.join(''));
}

//返回数据并关闭
function sendData() {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            "status": 'label',
            "return_page": html_name,
            "opt": page_data.opt,
            "label_arr": label_arr.toString() || '',
            "title": page_data.title,
            "id": page_data.id,
            "type": page_data.type
        }
    });
    api.closeWin();
}

function is_event(state) {
    if (!state) {
        $('#add_btn').css('visibility', 'hidden');
        $('.packParent,.pack').show();
        $('.pack').addClass('changes');
        $('.list-term').addClass('label_shake');
        // Sortable.options.disabled = false;
        is_edit = true;
    } else {
        $('#add_btn').css('visibility', 'visible');
        $('.packParent,.pack').hide();
        $('.pack').removeClass('changes');
        $('.list-term').removeClass('label_shake');
        // Sortable.options.disabled = true;
        is_edit = false;
    }
}

//保存数据
function saveData(opt, options) {
    var __options = $.extend({ callback: null }, options);
    var label_count = (($('.list-term').length < 1) ? 1 : $('.list-term').length);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getLabelList,
        data: {
            "type": page_data.page_type,
            "keyword": "",
            "keyword_key": ['name', 'simple'],
            "is_stop": fun.getItem(html_name + '_isStop') || "",
        },
        success: function (res) {
            if (res.status != 0) return;
            var info_list = res.data;
            var len = info_list.length - 1;
            for (var k = 0; k < info_list.length; k++) {
                if(k == len){
                    label_count = info_list[len]['sort'] + 1 || 1;
                }
            }
    var params = $.extend({}, {
        "save_type": (opt && !!opt.save_type) ? opt.save_type : "save",
        "type": page_data.page_type,
        "label": []
    }, opt);
    $('.list-term').each(function (i, list) {
        params['label'].push({
            "id": $(list).attr('id') || 0,
            "name": $(list).attr('name') || "",
            "type": $(list).find('.text').attr('type') || page_data.page_type,
            "colour": $(list).attr('colour') || '',
            "sort": $(list).find('.text').attr('sort') || label_count,
            "remark": $(list).attr('remark') || '',
        });
    })
    //删除
    if (opt && opt.save_type == "delete") {
        params['id'] = opt.id || 0,
            delete params['label'];
    }
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveLabelInfo,
        data: params,
        success: function (res) {
            switch (res.status) {
                case 0:
                    (params.save_type == 'delete') ? fun.toast('删除成功!') : fun.toast('保存成功!');
                    $('#add_btn').css('visibility', 'visible');
                    is_edit = true;
                    is_event(is_edit);
                    // getData();
                    api.sendEvent({
                        name: html_name,
                        extra: {
                            'status': 'refresh'
                        }
                    });
                    if (typeof __options['callback'] === 'function') __options['callback']();
        
                    break;
                case 103:
                    fun.dialog({
                        content: (opt['name'] || '') + '已被引用过，不能删除！',
                        btn: ['我知道了'],
                        width: '30%',
                        style: 'width: 85%; padding-top:0.3rem; border:none; background: #fff; border-radius: 0.5rem; '//position: absolute; top: 30%; left: 7.5%;
                    });
                    $('.btn-wrap button').css('width', '100%');
                            is_edit = true;
                            is_event(is_edit);
                            api.sendEvent({
                                name: html_name,
                                extra: {
                                    'status': 'refresh'
                                }
                            });
                    break;
                case 104:
                    fun.toast("该标签已存在！");
                            is_edit = true;
                            is_event(is_edit);
                            api.sendEvent({
                                name: html_name,
                                extra: {
                                    'status': 'refresh'
                                }
                            });
                    break;
                default:
                    fun.toast("保存失败！");
                    break;
            }
        }
    });
        }
    });
    
}

//弹窗
function addLabel(node, status) {
    var html = [],
        style = 'width: 85%;  border:none; background: #fff; border-radius: 0.5rem; ',//position: absolute; top: 30%; left: 7.5%;
        value = (status == 'edit') ? (node.attr('name') || "") : "";
    html.push('<span class="label">' + ((status == 'add') ? "添加" : "修改") + '标签</span>');
    html.push('<input id="label_value" type="text" class="input-box" value="' + value + '" placeholder="标签名称"/>');
    html.push('<ul class="status-list"><li class="label-wrap">');
    html.push('<div class="circle1" color="#FF2E2E" data-index="0"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#FF5391" data-index="1"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#FFD334" data-index="2"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#99D75A" data-index="3"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#38BB5C" data-index="4"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#22D7BB" data-index="5"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#2CBDFF" data-index="6"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#7076FB" data-index="7"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#C572EF" data-index="8"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#8d8d8d" data-index="9"><i class="iconfont icon-check status"></i></div>');
    html.push('</li></ul>')
    //暂时隐藏停用按钮
    // html.push('<div class="switch"><div class="nui-switch nui-switch-md nui-unactive nui-switch-btn stops">');
    // html.push('<div class="nui-switch-handle"></div></div>');
    // html.push('<span class="switch-title">停用</span></div>');

    var oriColor = '';
    fun.dialog({
        content: html.join(''),
        btn: ['保存', '取消'],
        style: style,
        isClose: false,
        success: function () {
            document.body.addEventListener('touchmove', preventDefault, { passive: false });
            if (node) {
                oriColor = node.attr('colour');
            }
            $('body .no-padding .layui-m-layercont').css('border-radius', '0.5rem');
            $('.lay-warm .lay-warm-content').css({ 'display': 'block', 'min-height': '9rem', 'max-height': '9rem' });
        },
        yes: function () {
            var edit_name = $('#label_value').val().trim();
            if ($.nui.isEmpty(edit_name)) return fun.toast('标签名不能为空！');
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            switch (status) {
                case 'add':
                    if (!!$("[name='" + edit_name + "']").attr('name')) return fun.toast("该标签已存在！");
                    var index = fun.getItem('color_index' + page_data.page_type) || 0;
                    color_index = index || color_index;
                    $('.label-wrap div').eq(color_index).addClass('choice');
                    if (!$('#label_value').val()) {
                        return fun.toast('请输入标签名称！');
                    } else if ($('.choice').length < 1) {
                        return fun.toast('请选择标签颜色！');
                    }
                    $('#list').append([
                        '<li class="list-term" colour="' + $('.choice').attr('color') + '" is="false" id="" name="' + $('#label_value').val() + '" remark="">',
                        ' <div class="box">',// style="background-color:' + $('.choice').attr('color') + ';"
                        '    <span class="text">' + $('#label_value').val() + '</span>',
                        '</div>',
                        '<div class="packParent"><div class="pack"><i class="iconfont icon-fork fork"></i></div></div>',
                        '</li>'
                    ].join(''));
                    saveData({}, {
                        callback: function () {
                            color_index = $('.choice').data('index')+1 || 0;
                            if (color_index > 9) color_index = 0;
                            fun.setItem('color_index'+page_data.page_type,color_index);
                            layer.closeAll();
                            // getData();
                        }
                    });
                    break;
                case 'edit':
                    var label_name = node.attr('name');
                    if (edit_name && edit_name != label_name) {
                        node.find('.text').text(edit_name);
                        node.attr('name', edit_name);
                        node.addClass('edit_label');
                        $('#label_value').select();
                    }
                    if (node.hasClass('edit_label')) {
                        saveData();
                        layer.closeAll();
                    }
                    break;
            }
        },
        no: function () {
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            if (status == 'edit') {
                console.log(node.data('oriColor'))

                node.attr('colour', node.data('oriColor'));
                node.removeClass('edit_label');
            }
        }
    });

    if (status == 'edit') {
        $('.circle1').each(function () {
            if ($(this).attr('color') == node.attr('colour')) {
                $(this).addClass('choice');
            }
        });
    } else {
        var index = fun.getItem('color_index' + page_data.page_type) || 0;
        color_index = index || color_index;
        $('.label-wrap div').eq(color_index).addClass('choice');
    }

    $('body').off('tap', '.circle1').on('tap', '.circle1', function () {
        $(this).addClass('choice').siblings().removeClass('choice');
        color_index = $('.choice').data('index') || 0;
        if (status == 'edit') {
            // node.attr('colour', $(this).attr('color'));
            // node.addClass('edit_label');
            node.attr('colour', $(this).attr('color')).data('oriColor', oriColor);
            node.addClass('edit_label');
        }else{
            fun.setItem('color_index'+page_data.page_type,color_index);
        }
    })

    //是否停用
    // $(".stops").on('click', function () {
    //     if (!$(this).hasClass('nui-unactive')) {
    //         $(this).attr('stopVal',1);
    //         node.addClass('edit_label');
    //     } else {
    //         $(this).attr('stopVal',0);
    //         node.addClass('edit_label');
    //     }
    // });
}

// 键盘弹起处理函数
function keyBoardShow() {
    fun.headerAbsolute('#header');
    $('.content').removeClass('scroll');
}

// 键盘收起处理函数
function keyBoardHide() {
    fun.headerFixed('#header');
    $('.content').addClass('scroll');
}

//点击键盘搜索
$("#foot_search").bind('search', function () {
    search_data["keyword"] = $(this).val().trim();
    $(this).select();
    $('#list').empty();
    getData();
    if(type_data){
        is_event(is_edit);
        $('#add_btn').css('visibility', 'hidden');
    } 
});

//选择标签
$('body').on('tap', '.list-term', function (event) {
    event.stopPropagation();
    event.preventDefault();
    if (!$('.pack').hasClass('changes')) {
        var id = $(this).attr('id'),
            colour = $(this).attr('colour');
        if ($(this).attr('is') == 'false') {
            if (label_arr.indexOf(id) == -1) {
                label_arr.push(id);
            }
            $(this).children('.box').css('background-color', colour);
            $(this).attr('is', 'true');
        } else {
            if (label_arr.indexOf(id) > -1) {
                label_arr.splice(label_arr.indexOf(id), 1);
            }
            $(this).children('.box').css('background-color', '#c6c6c6');
            $(this).attr('is', 'false');
        }
    } else {//处于编辑状态
        addLabel($(this), 'edit');
    }
    page_data['label_arr'] = label_arr.toString();
});

//点击编辑
$('#edit_btn').on('tap', function () {
    type_data = true;
    is_event(is_edit);
});

//点击空白处
$('body').on('tap', '.content', function () {
    type_data = false;
    is_edit = true;
    is_event(is_edit);
});

//删除标签
$('body').on('tap', '.packParent', function (event) {
    event.stopPropagation();
    event.preventDefault();
    var label_name = $(this).siblings('.box').children('span').text();
    var id = $(this).parent().attr('id');
    fun.dialog({
        content: '你确定要删除【' + label_name + '】吗?',
        btn: ['删除', '取消'],
        yes: function () {
            is_edit = true;
            is_event(is_edit);
            saveData({
                "save_type": "delete",
                "id": [id],
                "name": label_name
            });
        }
    });
})

//添加标签
$('body').on('tap', '#add_btn', function () {
    type_data = false;
    addLabel('', 'add');
});

// 拖拽排序
// var Sortable = new Sortable($('#list')[0], {
//     animation: 150,
//     disabled: true,
//     onStart: function (evt) {
//         evt.stopPropagation();
//         $('.list-term').removeClass('label_shake');
//     },
//     onEnd: function (evt) {
//         $('.list-term').addClass('label_shake');
//     }
// });

//打开搜索页
// $('body').on('tap', '#filter_btn', function () {
//     var options = {
//         "switch": [
//             {
//                 "text": "显示停用",
//                 "max_width": true,
//                 "key": "is_stop",
//                 "value": (temps && fun.getItem(html_name + '_isStop') ? fun.getItem(html_name + '_isStop') : '')
//             }
//         ]
//     };
//     fun.openFrame({
//         frame_url: page_arr.search,
//         pageParam: {
//             "return_page": html_name,
//             "search_data": options
//         },
//         // y: fun.fontUnit(header)
//     });
// })

// $('body').on('tap', '.box', function (event) {
//    var parents = $(this).parents('.list-term')
//     if (!$('.pack').hasClass('changes')) {
//         var id = parents.attr('id'),
//             colour = parents.attr('colour');
//         if (parents.attr('is') == 'false') {
//             if (label_arr.indexOf(id) == -1) {
//                 label_arr.push(id);
//             }
//             $(this).css('background-color', colour);
//             parents.attr('is', 'true');
//         } else {
//             if (label_arr.indexOf(id) > -1) {
//                 label_arr.splice(label_arr.indexOf(id), 1);
//             }
//             $(this).css('background-color', '#e2e2e2');
//             parents.attr('is', 'false');
//         }
//     } else {//处于编辑状态
//         addLabel(parents, 'edit');
//     }
//     page_data['label_arr'] = label_arr.toString();
// });