var html_name = page_arr.make_bill;
var begin_lCalendar = new lCalendar();

$('#header').header({
    back: true,
    title: '开账',
});
$('.qdkz').hide();//隐藏确定按钮
page_init = function () {
    getList();
}

//获取账户信息
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMakeBillsInfo,
        data: {},
        success: function (res) {
            console.log(JSON.stringify(res))
            switch (res['status']) {
                case 0:
                    if (!$.nui.isEmpty(res['data']['kzxx'])) {
                        var data_xx = res['data']['kzxx'];
                        var ddfh_arr = data_xx['ddfh'];
                        var sxjg_arr = data_xx['sxjg'];
                        $('#kzrq').val(data_xx['kzrq']);
                        setDdfh(ddfh_arr);//订单复核
                        setSxjg(sxjg_arr);//纱线价格
                        $('#kzrq,#ddfh,#sxjg').addClass('ash');
                        $('.qdkz').hide();

                        $('#ddfh,#sxjg,#kzrq').attr('disabled',true);//
                        if(api.systemType=='android'){
                            $('input:disabled,input[disabled]').addClass('and')
                        }else{
                            $('input:disabled,input[disabled]').addClass('ios')
                        }


                    } else {
                        $('.qdkz').show();
                        effect();
                    }
                    break;
                default:
                    $('.qdkz').show();
                    effect();
                    break;
            }
        }
    })
}

function setDdfh(arr) {
    var ddfh = [];
    var ddfh_data = [];
    if (arr['bp_xsdd'] == 1) {
        ddfh.push('布匹销售');
        ddfh_data.push('bp_xsdd');
    }
    if (arr['bp_cgdd'] == 1) {
        ddfh.push('布匹采购');
        ddfh_data.push('bp_cgdd');
    }
    if (arr['bp_wwjg'] == 1) {
        ddfh.push('委外加工');
        ddfh_data.push('bp_wwjg');
    }
    if (arr['bp_xzdd'] == 1) {
        ddfh.push('下织单');
        ddfh_data.push('bp_xzdd');
    }
    if (arr['sx_xsdd'] == 1) {
        ddfh.push('纱线销售');
        ddfh_data.push('sx_xsdd');
    }
    if (arr['sx_cgdd'] == 1) {
        ddfh.push('纱线采购');
        ddfh_data.push('sx_cgdd');
    }
    if (arr['sx_jgdd'] == 1) {
        ddfh.push('纱线加工');
        ddfh_data.push('sx_jgdd');
    }
    $('#ddfh').data('column', ddfh_data.join()).val(ddfh.join('、'));
}

function setSxjg(arr) {
    var sxjg = [];
    var sxjg_data = [];
    if (arr['gg'] == 1) {
        sxjg.push('规格');
        sxjg_data.push('gg');
    }
    if (arr['pp'] == 1) {
        sxjg.push('品牌');
        sxjg_data.push('pp');
    }
    if (arr['cd'] == 1) {
        sxjg.push('产地');
        sxjg_data.push('cd');
    }
    if (arr['lx'] == 1) {
        sxjg.push('类型');
        sxjg_data.push('lx');
    }
    $('#sxjg').data('column', sxjg_data.join()).val(sxjg.join('、'));
}

function effect() {
    //订单复核
    $('#ddfh').on('click', function () {
        var this_name = $(this);
        var merchants_list = [
            {"name": "布匹销售", "column": "bp_xsdd", "is_choose": 0},
            {"name": "布匹采购", "column": "bp_cgdd", "is_choose": 0},
            {"name": "委外加工", "column": "bp_wwjg", "is_choose": 0},
            {"name": "下织单", "column": "bp_xzdd", "is_choose": 0},
            {"name": "纱线销售", "column": "sx_xsdd", "is_choose": 0},
            {"name": "纱线采购", "column": "sx_cgdd", "is_choose": 0},
            {"name": "纱线加工", "column": "sx_jgdd", "is_choose": 0},
        ];

        // selectList(merchants_list,val);
        // var str = this_name.val() || "",
        //     column = str.split('、');
        // selectList(merchants_list, column, this_name);

        selectG(this_name, merchants_list)
    })
    //纱线价格
    $('#sxjg').on('click', function () {
        var this_name = $(this);
        var merchants_list = [
            {"name": "规格", "column": "gg", "is_choose": 0},
            {"name": "品牌", "column": "pp", "is_choose": 0},
            {"name": "产地", "column": "cd", "is_choose": 0},
            {"name": "类型", "column": "lx", "is_choose": 0},
        ];
        // selectList(merchants_list,val);
        // var str = this_name.val() || "",
        //     column = str.split('、');
        // selectList(merchants_list, column, this_name);

        selectG(this_name, merchants_list)
    })
    //开账时间
    begin_lCalendar.init({
        'trigger': '#kzrq',
        'type': 'date',
        'callback': function (date) {
            $('#kzrq').text(fun.formatDate(date));
        }
    });
}

/**选择---传递数据 */
function selectG($this, list) {
    var column = $this.data('column');
    var column_arr = [];
    console.log(column)
    if (column != undefined) {
        var column_data = column.split(',');
        for (var i = 0; i < column_data.length; i++) {
            column_arr[i] = column_data[i];
        }
    }
    // var merchants_list = [
    //     { "name": "布匹销售", "column": "bp_xsdd", "is_choose": 0 },
    //     { "name": "布匹采购", "column": "bp_cgdd", "is_choose": 0 },
    //     { "name": "委外加工", "column": "bp_wwjg", "is_choose": 0 },
    //     { "name": "下织单", "column": "bp_xzdd", "is_choose": 0 },
    //     { "name": "纱线销售", "column": "sx_xsdd", "is_choose": 0 },
    //     { "name": "纱线采购", "column": "sx_cgdd", "is_choose": 0 },
    //     { "name": "纱线加工", "column": "sx_jgdd", "is_choose": 0 },
    // ];
    $.each(list, function (i, val) {
        $.each(column_arr, function (j, val2) {
            if (val['column'] == val2) {
                val['is_choose'] = 1;
            }
        })
    })
    // selectList(merchants_list,val);
    var str = $this.val() || "",
        column = str.split(',');
    selectList(list, column, $this);
}

//公共选择
function selectList(merchants_list, column, this_name) {
    // $(merchants_list).each(function (i, arr) {
    //     $(column).each(function (j, obj) {
    //         if (arr['name'] == column[j]) {
    //             merchants_list[i]['is_choose'] = 1;
    //         }
    //     })
    // })
    fun.showBookList({
        list: merchants_list,
        checkbox: true,
        shadeClose: false,
        choose: function (res) {
            var name = [];
            var column = [];
            $(res).each(function (i, arr) {
                name.push(arr['name']);
                column.push(arr['column']);
            })
            this_name.data('column', column.join()).val(name.join('、'));
        }
    })
}

//开账按钮
$('#qdkz').on('tap', function (e) {
    e.stopPropagation();
    fun.dialog({
        content: '您确定要开账吗？',
        btn: ['确定', '取消'],
        yes: function () {
            var data = {
                'type': 'make',
                'kzr_id': fun.getItem('user_info')['id'] || 0,
                'kzrq': $('#kzrq').val(),
                'kzxx': getData(),
            }
            if (data.kzrq == '') return fun.toast('请选择开账日期');

            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.saveInfo,
                data: data,
                success: function (res) {
                    switch (res['status']) {
                        case 0:
                            //     fun.dialog({
                            //     content: res['msg'],
                            //     btn: ['确定'],
                            //     yes: function () {
                            //         closePage();
                            //     }
                            // });
                            fun.toast('开账成功！');
                            fun.load_DATA_LIST(['sys_config'], function () {
                                // closePage();
                                getList();
                            });
                            break;
                        case 'IS_KZ':
                            fun.toast(res['msg']);
                            fun.load_DATA_LIST(['sys_config'], function () {
                                // closePage();
                                getList();
                            });
                            break;
                        default:
                            fun.toast(res['msg']);
                            break;
                    }
                }
            })
        }
    });
})

//获取保存数据
function getData() {
    var ddfh = $('#ddfh').data('column') || '';
    var ddfh_arr = [
        {"__index": 0, "name": "布匹销售", "djlx": "bp_xsdd",},
        {"__index": 1, "name": "布匹采购", "djlx": "bp_cgdd",},
        {"__index": 2, "name": "委外加工", "djlx": "bp_wwjg"},
        {"__index": 3, "name": "下织单", "djlx": "bp_xzdd"},
        {"__index": 4, "name": "纱线销售", "djlx": "sx_xsdd"},
        {"__index": 5, "name": "纱线采购", "djlx": "sx_cgdd"},
        {"__index": 6, "name": "纱线加工", "djlx": "sx_jgdd"}
    ];
    if (ddfh != '' && ddfh.indexOf(',') == -1) {//保存只有一项
        $(ddfh_arr).each(function (i, arr) {
            if (arr['djlx'] == ddfh) arr["__status"] = "select";
        })
    } else if (ddfh != '' && ddfh.indexOf(',') > -1) {//保存有多项
        var ddfh_arr1 = ddfh.split(',');
        $(ddfh_arr1).each(function (i, arr1) {
            $(ddfh_arr).each(function (j, arr) {
                if (arr['djlx'] == arr1) arr["__status"] = "select";
            })
        })
    }
    var sxjg = $('#sxjg').data('column') || '';
    var sxjg_arr = [
        {"__index": 0, "name": "规格", "jglx": "gg"},
        {"__index": 1, "name": "品牌", "jglx": "pp"},
        {"__index": 2, "name": "产地", "jglx": "cd"},
        {"__index": 3, "name": "类型", "jglx": "lx"}
    ]
    if (sxjg != '' && sxjg.indexOf(',') == -1) {//保存只有一项
        $(sxjg_arr).each(function (i, arr) {
            if (arr['jglx'] == sxjg) arr["__status"] = "select";
        })
    } else if (sxjg != '' && sxjg.indexOf(',') > -1) {//保存有多项
        var sxjg_arr1 = sxjg.split(',');
        $(sxjg_arr1).each(function (i, arr1) {
            $(sxjg_arr).each(function (j, arr) {
                if (arr['jglx'] == arr1) arr["__status"] = "select";
            })
        })
    }
    var data = {
        kzr_id: fun.getItem('user_info')['id'] || 0,
        kzrq: $('#kzrq').val().trim(),
        ddfh: ddfh_arr,
        sxjg: sxjg_arr,
        cbhs: '',
    }
    return data;
}

//关闭页面
function closePage() {
    setTimeout(function () {
        api.closeWin();
    }, 200);
}
