var html_name = page_arr.my;
var $show_item = $('.list-show > div'); // 跳转项
var $company = $('.company-name'); // 公司名称

// 页面初始化
page_init = function () {
    // var LOGIN_INFO = fun.getItem('login_info') || {};

    // if (IS_TO_LOCAL) {
    //     if ($.nui.isTrue(LOGIN_INFO['is_rz']) && $.nui.isTrue(LOGIN_INFO['md_img'])) {
    //         $('.comp-strz').show();
    //     } else {
    //         fun.getStrzInfo(function (res) {
    //             var data = res['data'] || {};

    //             if ($.nui.isTrue(data['is_rz']) && $.nui.isTrue(data['md_img'])) {
    //                 $('.comp-strz').show();
    //             }
    //         });
    //     }
    // }
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret.value.data;
        var tets = ret.value;
        switch (tets['status']) {
            case 'my':
                $('.name').text(temp['xm']); // 用户姓名
                $('.tel').text(temp['sj']); // 手机号码

                if ($.nui.isTrue(temp['sj'])) {
                    $('.name').css('line-height', '2rem');
                } else {
                    $('.name').css('line-height', '3.5rem');
                }

                if (!!tets['imgs']) {
                    $('.img img').attr('src', fun.getImgPath(tets['imgs'], true, { url: UPLOAD_IMG_PATH }))
                }
                break;
            case 'refresh':
                fun.ajax({
                    showLoad: false,
                    hideLoad: true,
                    url: AJAX_URL.getCompanyList,
                    data: {},
                    success: function (res) {
                        if (res['status'] === 0) {
                            $('.company-name').text(res.data.company);// 公司名称
                        }
                    }
                });
                break;
            case 'strz':
                fun.getStrzInfo(function (res) {
                    if (res['status'] === 0) {
                        if($.nui.isTrue(res['data']['is_rz'])){
                            $('.comp-strz').show();
                        }else{
                            $('.comp-strz').hide();
                        }
                    }
                });
                break;
        }
    });
    init();
    AuthShowHide();
};

// 页面初始化
function init() {
    $('.name').text(fun.getItem('user_info')['name']); // 用户姓名
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.grmpGetInfo,
        data: {},
        success: function (res) {
            $('.name').text(res['name']); // 用户姓名
            $('.tel').text(res['phone']); // 手机号码

            if ($.nui.isTrue(res['phone'])) {
                $('.name').css('line-height', '2rem');
            } else {
                $('.name').css('line-height', '3.5rem');
            }

            $('.img img').attr('src', fun.getImgPath(res['touxiang'], true, { url: UPLOAD_IMG_PATH }));
        }
    })

    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: AJAX_URL.getCompanyList,
        data: {},
        success: function (res) {
            if (res['status'] === 0) {
                $('.company-name').text(res.data.company/* || fun.getItem('company_info')['company_name']*/);// 公司名称
                if ($.nui.isTrue(res['data']['qyrz'])) {
                    $('.comp-strz').show();
                }
            }
        }
    })
}

var param = {
    dpsz: { // 店铺设置
        // page_url: page_arr['company_information'],
        page_url: page_arr['shop_settings']
    },
    zzhgl: { // 账号管理
        page_url: page_arr['account_admin']
    },
    printer_list: { // 打印设置
        page_url: page_arr['printer_list']
    },
    bzzx: { // 帮助中心
        page_url: page_arr['help_center']
    },
    more_set: { //更多设置
        page_url: page_arr['more_set']
    },
    push_set: {
        page_url: page_arr['push_set']
    }
};

// 点击跳转
$show_item.on('tap', function () {
    var type = $(this).data('type'); // 拿到显示链接地址
    var pageUrl = param[type];

    // if (type === 'more_set') { // 没有更多设置先不跳转
    //     return;
    // }

    if (type === 'contact_fk') {
        // fun.openBrowser('https://cschat-ccs.aliyun.com/index.htm?tntInstId=_1QLFyp6&scene=SCE00004988');
        fun.showPageFull({
            page_url: page_arr.new_win
        });
        return;
    }

    fun.showPageFull({
        page_url: pageUrl['page_url'] || '',
        pageParam: {
            return_page: html_name,
        }
    });
});

//跳转到推送消息
// $('.icon-tixingxiaoxi').on('tap', function () {
//     fun.showPageFull({
//         page_url: page_arr.push_message,
//         pageParam: {}
//     });
// });

//跳转到设置页
// $('.img').on('tap', function (e) {
//     e.stopPropagation();
//     fun.showPageFull({
//         page_url: page_arr.set,
//         pageParam: {}
//     });
// });


//跳转到个人名片

$('#geren').on('tap', function () {
    if(!AuthVersionCheck.checkHide('xsdp')){
        fun.showPageFull({
            page_url: page_arr.personal_card,
            pageParam: {
                return_page: html_name
            }
        });
    }
});

//跳转到递名片
$('.card').on('tap', function () {
    fun.showPageFull({
        page_url: page_arr.business_cards,
        pageParam: {}
    });
});

//权限判断显示隐藏
function AuthShowHide() {
    $('#zzhgl').hide();
    if (Auth.check('zhgl', 'view')) {
        $('#zzhgl').show();
    }
    // if (!Auth.check('gsxx', 'view')) {
    //     $('#dpsz').hide();
    // }

    // //店铺设置权限
    // if (Auth.check('dpsz', 'view')) {
    //     $('#dpsz').show();
    // } else {
    //     $('#dpsz').hide();
    // }

    //判断是否有线上店铺
    if(!AuthVersionCheck.checkHide('xsdp')){
        $('.card, .icon-qianbi').show(); // .icon-tixingxiaoxi
    } else {
        $('.card, .icon-qianbi, .icon-tixingxiaoxi').hide();
        $('.m-con1 > div').css('height','7rem');
        $('.m-con1').css('padding-bottom','5.3rem');
    }
}



