var html_name = page_arr.login_new;
var network = 1;
var clipBoard;
var login = {
    jgId: '',
    ajPush: null
};
var isToLauncher = false; // 是否返回到桌面
var user_phone = ''; // 手机号码
// 初始化获取极光推送id
login.initAjPushId = function () {
    var that = this;
    this.ajPush = api.require('ajpush');
    this.ajPush.init(function (ret) {
        that.ajPush.getRegistrationId(function (ret, err) {
            that.jgId = ret.id;
        });
    })
}

// 获取绑定极光推送数据
login.getSetBindAjaxData = function () {
    var data = fun.getSetBindAjaxData();
    data.jiguang_id = login.jgId;
    return data;
};

// 登录成功返回首页
login.loginSuccessGotoIndex = function () {
    fun.showPageFull({
        page_url: page_arr.index,
        closeWin: true
    });
}

// 登录成功绑定极光id
login.loginSetBind = function () {
    $.ajax({
        type: "POST",
        url: AJAX_URL.setBind,
        data: {
            data: login.getSetBindAjaxData()
        },
        success: function (res) {
            if (res.status === 0) {
                login.loginSuccessGotoIndex();
            } else {
                fun.toast(res.msg);
            }
        },
        error: function (err) {
            console.log(err);
        }
    });
}

// 检测是否显示微信登录
function checkShowWx(){
    var wx = api.require('wxPlus');

    if (api.systemType === 'android') {
        $('#showWechat').show();
    } else {
        if(!checkWxUseable(wx)) return false;
        wx.isInstalled(function (ret, err) {//判断当前设备是否安装了微信客户端
            if (ret.installed) {//installed会返回true或false
                $('#showWechat').show();
            } else {
                $('#showWechat').hide();
            }
        });
    }
}

page_init = function () {
    fun.clearItem('DYNAMIC_APIS');
    checkShowWx();
   
    var login_mode = fun.getItem('login_mode') || 'mm'
    fun.setItem('login_mode', login_mode)
    
    clipBoard = api.require('clipBoard'); //加载模块
    keyboardEject('.register-login');
    keyboardEject('.tool-box');
    // var user_info = fun.getItem('user_info');
    // $('#user_name').text(user_info['name']);
    var company_lastname = fun.getItem('company_info') || {};
    var account_lastname = fun.getItem('account_info') || {};
    $('.company').val(company_lastname.company_name);
    $('.account').val(account_lastname.account);
    // if ($.nui.isTrue(fun.getItem('yby_before_login'))) {//华为应用上架，隐私政策调整，不能默认选中
    //     $('.agree').addClass('agrees');
    // }
    if (!SHOW_WX) {
        $('.order-login').hide();
    }
    // if (api.systemType === 'android') {
    //     getUserPhone();
    // }
    var isShowAgreementPopup = fun.getItem('isShowAgreementPopup') || '';//记忆是否弹出过隐私协议弹窗，弹出过一次就不再弹出。
    if($.nui.isEmpty(isShowAgreementPopup)){
        fun.setItem('isShowAgreementPopup',1);
        showAgreementPopup();
    }
    

    page_data.keyback = function () {
        if (!isToLauncher) {
            fun.toast("再按一次退出，第二次滑动就返回到桌面。");
        } else {
            api.toLauncher();//回到系统桌面app进入后台不会关闭
        }
        isToLauncher = !isToLauncher;
    };

    $('.version-info').text(APP_VERSION + '（' + api.appVersion + '）');

    api.addEventListener({
        name: 'online' //连接网络
    }, function (ret, err) {
        console.log(api.connectionType)
        network = 1;
    })

    api.addEventListener({
        name: 'offline' //未连接网络
    }, function (ret, err) {
        console.log(api.connectionType)
        network = 0;
    })

    
    api.addEventListener({
        name:'pause'
    }, function(ret, err){        
        toBack = true;
        api.hideProgress();
        clearTimeout(mini_timer);
    });

    api.addEventListener({
        name:'resume'
    }, function(ret, err){        
        toBack = false;
        api.hideProgress();
        clearTimeout(mini_timer);
        api.closeFrame({
            name: page_arr.wxxf_tips
        });
    });


    var u = navigator.userAgent;
    var isAndroid = u.indexOf("Android") > -1 || u.indexOf("Adr") > -1; // android终端
    if (isAndroid) {
        pasteCopy();
    }
    fun.clearItem('versionInfo');
    fun.checkBaseVersion({
        getStorage: false,
        showTipsAlert: true
    });

};

function keyboardEject(obj) {
    var winHeight = $(window).height();//获取当前页面高度
    var isAndroid = navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1;
    if (isAndroid) {
        window.addEventListener('resize', function () {
            var thisHeight = $(this).height();
            if (winHeight - thisHeight > 50) {
                $(obj).hide();
                // $(obj).css('bottom', '-3rem');
            } else {
                $(obj).show();
                // $(obj).css('bottom', 0);
            }
        });
    }
}
//设置底部免费注册不会因为input而改变静止流
// fun.keyboardEject('.register-login')

$("input").focus(function () {
    $(this).css('box-shadow', "0px 0px 5px #40a9fe");
}).blur(function () {
    $(this).css('box-shadow', "0px 0px 5px #fff");
});

function showAgreementPopup(callBack){
    var content = `<div style="font-size:1rem;margin-bottom:0.5rem;">用户协议和隐私政策</div>
                       <div style="color:#969696;padding:0 0.6rem">进入下一步前，请先阅读并同意<span class="use-agreement" style="color:#4F8CFF;">《用户协议》</span>及<span class="privacy-agreement" style="color:#4F8CFF;">《隐私政策》</span></div>
                     `;
    fun.dialog({
        content: content,
        wrapClass:'fx-col',
        anim: false,
        btn: ['同意','拒绝'],
        success:function (layero) {
            $(layero).find('.use-agreement').on('click', function (e) {
                e.preventDefault();
                $('.use').click();
            });
            $(layero).find('.privacy-agreement').on('click', function (e) {
                e.preventDefault();
                $('.privacy').click();
            });
        },
        yes: function (res) {
            // $('.agree').addClass('agrees');
            if(typeof callBack=='function') callBack();
        },
        no:function(){
            
        },
    });
}

function submitFun() {
    var comp = $(".company").val().trim();
    var account = $(".account").val().trim();
    var pwd = $(".password").val().trim();
    if ($.nui.isEmpty(comp)) {
        return fun.toast('请输入公司名称')
    } else if ($.nui.isEmpty(account)) {
        return fun.toast("请输入账号");
    } else if ($.nui.isEmpty(pwd)) {
        return fun.toast("请输入密码");
    }
    else if (!$('.agree').hasClass('agrees')) {
        showAgreementPopup(function(){
            //submitFun();
        })
    } 
    else {
        fun.setItem('yby_before_login', 1);
        $('input').blur();
        if (api.systemType === 'android') {
            getUserPhone(function(){
                Login(comp, account, pwd);
            });
        } else {
            Login(comp, account, pwd);
        }
    }
}

//登录
$('body').delay('tap', '#submit', function (e) {
    e.stopPropagation();

    fun.setItem('login_mode', 'mm');
    submitFun();
});


// $("#submit").on('tap', function (e) {
//     e.stopPropagation();
//     submitFun();
// })

function stopSubmit() {
    return false;
}

$('body').off('keyup', '.password').on('keyup', '.password', function (e) {
    e.stopPropagation();
    if (e.keyCode === 13) {
        submitFun();
        // $("#submit").trigger("tap")
        // if (!$('#pass').val()) {
        //     return fun.toast('请输入密码。');
        // }
        $(this).blur();
        return false;
    }
});


function Login(company, account, pwd) {
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        async: false,
        url: 'http://139.159.243.171/getServerConfig.php',
        data: {
            company_name: company,
            type: 'mobile'
        },
        success: function (res) {
            if (res['status'] === 0 && $.nui.isTrue(res['data'])) {
                console.log(res)
                fun.setItem('DYNAMIC_APIS', res.data);
                getDynamicApis();
            }
        }
    });

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.login,
        data: {
            type: 'mobile',
            company: company,
            account: account,
            pwd: pwd,
            phone_code: user_phone
        },
        success: function (res) {
            switch (res['status']) {
                case 0:
                    var account_info = {
                        account: account,
                        account_id: res['data']['account_id']
                    };
                    var company_info = {
                        company_id: res['data']['company_id'] || 0,
                        company_name: company,
                    };

                    var login_info = res['data'] || {};
                    if ($.nui.isEmpty(login_info['sale_code'])) {
                        return emptySaleCodeAlert();
                    }
                    // fun.requestPermission(function(){});
                    if (H5PAY) login.initAjPushId();
                    fun.setItem('is_yfw', login_info['is_yfw'] || 0);
                    fun.setItem('account_info', account_info);
                    fun.setItem('company_info', company_info);
                    fun.setItem('token', res['data']['token'] || {});
                    fun.setItem('login_info', res['data'] || {});

                    fun.setItem('book_id', res['data']['book_id'] || 0);

                    var login_enterprise = fun.getItem('login_enterprise') || {};
                    var enterpriseKey = (company + '_' + account).toLowerCase();
                    var enterpriseItem = {
                        enterpriseKey: enterpriseKey,
                        company: company,
                        account: account,
                        pwd: pwd,
                        company_id: res['data']['company_id'] || 0,
                        account_id: res['data']['account_id']
                    };

                    login_enterprise[enterpriseKey] = enterpriseItem;

                    fun.setItem('login_enterprise', login_enterprise);

                    DBB_FIXED && VersionManager.getAppUpdatePackInfo(function (data) {
                        // 设置当前公司app使用版本
                        fun.setItem('COMPANY_APP_VERSION', data['version'] || '');
                        VersionManager.apiset_storage('COMPANY_APP_VERSION',data['version'] || '');
                    });
                    getUserInfo();
                    break;
                case 100:
                    switch (res['data']['type']) {
                        case 'company':
                            fun.dialog({
                                content: '公司名称不能为空！',
                                btn: ['确定']
                            });
                            break;
                        case 'account':
                            fun.dialog({
                                content: '账号或手机号码不能为空！',
                                btn: ['确定']
                            });
                            break;
                        case 'pwd':
                            fun.dialog({
                                content: '密码不能为空！',
                                btn: ['确定']
                            });
                            break;
                        default:
                            fun.dialog({
                                content: res.msg,
                                btn: ['确定']
                            });
                            break;
                    }
                    break;
                case 104:
                    switch (res['data']['type']) {
                        case 'company':
                            fun.dialog({
                                content: '公司名称不存在！',
                                btn: ['确定']
                            });
                            break;
                        case 'account':
                            fun.dialog({
                                content: '帐号或手机号码不存在！',
                                btn: ['确定']
                            });
                            break;
                        case 'pwd':
                            fun.dialog({
                                content: '密码错误！',
                                btn: ['确定']
                            });
                            break;
                        case 'staff_out_date':
                            fun.dialog({
                                content: res.msg,
                                btn: ['确定']
                            });
                            break;
                        default:
                            fun.dialog({
                                content: res.msg,
                                btn: ['确定']
                            });
                            break;
                    }
                    break;
                case 107:
                    // 获取云布业是否有开启短信权限
                    var resultList = api.hasPermission({
                        list:['sms']
                    });
                    var granted = resultList[0].granted;
                    if (!granted) {
                        fun.dialog({
                            content: '已启用登录管控，需要应用权限：短信，请设置后再登录',
                            btn: ['我知道了']
                        });
                    } else {
                        return fun.alert({
                            msg: res['msg']
                        });
                    }
                    break;
                case 601:
                    fun.dialog({
                        content: '账号已过服务期！',
                        btn: ['确定']
                    });
                    break;
                case 602:
                    fun.dialog({
                        content: '账号已被停用！',
                        btn: ['确定']
                    });
                    break;
                case 603:
                    fun.dialog({
                        content: '当前用户的站点数是' + res.count + ',已超出站点数！',
                        btn: ['确定']
                    });
                    break;
                case 604:
                    return emptySaleCodeAlert();
                    // fun.dialog({
                    //     content: '未通过使用！',
                    //     btn: ['确定']
                    // });
                    break;
                case 605:
                    fun.dialog({
                        content: '请联系管理员开通手机权限！',
                        btn: ['确定']
                    });
                    break;
                default:
                    return fun.alert({
                        msg: res['msg']
                    });
                    break;
            }
        },
        error: function (res) {
            return fun.alert({ msg: '网络异常！' });
        }
    });
    
    return;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        method: 'post',
        dataType: 'json',
        certificate: {
            path: 'widget://res/client.p12',
            password: 'pn2200932'
        },
        data: {
            values: ''
        }
    }, function (ret, err) {
        if (err) return fun.alert({ msg: "网络异常！" });;

        fun.ajax2({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.login,
            data: {
                type: 'mobile',
                company: company,
                account: account,
                pwd: $.nui.md5(MD5_SALT + pwd)
            },
            success: function (res) {
                switch (res['status']) {
                    case 0:
                        var account_info = {
                            account: account,
                            account_id: res['data']['account_id']
                        };
                        var company_info = {
                            company_id: res['data']['company_id'] || 0,
                            company_name: company,
                        };

                        var login_info = res['data'] || {};
                        if ($.nui.isEmpty(login_info['sale_code'])) {
                            return emptySaleCodeAlert();
                        }
                        // fun.requestPermission(function(){});
                        if (H5PAY) login.initAjPushId();
                        fun.setItem('is_yfw', login_info['is_yfw'] || 0);
                        fun.setItem('account_info', account_info);
                        fun.setItem('company_info', company_info);
                        fun.setItem('token', res['data']['token'] || {});
                        fun.setItem('login_info', res['data'] || {});

                        fun.setItem('book_id', res['data']['book_id'] || 0);

                        DBB_FIXED && VersionManager.getAppUpdatePackInfo(function (data) {
                            // 设置当前公司app使用版本
                            fun.setItem('COMPANY_APP_VERSION', data['version'] || '');
                            VersionManager.apiset_storage('COMPANY_APP_VERSION',data['version'] || '');
                        });
                        getUserInfo();
                        break;
                    case 100:
                        switch (res['data']['type']) {
                            case 'company':
                                fun.dialog({
                                    content: '公司名称不能为空！',
                                    btn: ['确定']
                                });
                                break;
                            case 'account':
                                fun.dialog({
                                    content: '账号或手机号码不能为空！',
                                    btn: ['确定']
                                });
                                break;
                            case 'pwd':
                                fun.dialog({
                                    content: '密码不能为空！',
                                    btn: ['确定']
                                });
                                break;
                            default:
                                fun.dialog({
                                    content: res.msg,
                                    btn: ['确定']
                                });
                                break;
                        }
                        break;
                    case 104:
                        switch (res['data']['type']) {
                            case 'company':
                                fun.dialog({
                                    content: '公司名称不存在！',
                                    btn: ['确定']
                                });
                                break;
                            case 'account':
                                fun.dialog({
                                    content: '帐号或手机号码不存在！',
                                    btn: ['确定']
                                });
                                break;
                            case 'pwd':
                                fun.dialog({
                                    content: '密码错误！',
                                    btn: ['确定']
                                });
                                break;
                            case 'staff_out_date':
                                fun.dialog({
                                    content: res.msg,
                                    btn: ['确定']
                                });
                                break;
                            default:
                                fun.dialog({
                                    content: res.msg,
                                    btn: ['确定']
                                });
                                break;
                        }
                        break;
                    case 601:
                        fun.dialog({
                            content: '账号已过服务期！',
                            btn: ['确定']
                        });
                        break;
                    case 602:
                        fun.dialog({
                            content: '账号已被停用！',
                            btn: ['确定']
                        });
                        break;
                    case 603:
                        fun.dialog({
                            content: '当前用户的站点数是' + res.count + ',已超出站点数！',
                            btn: ['确定']
                        });
                        break;
                    case 604:
                        return emptySaleCodeAlert();
                        // fun.dialog({
                        //     content: '未通过使用！',
                        //     btn: ['确定']
                        // });
                        break;
                    case 605:
                        fun.dialog({
                            content: '请联系管理员开通手机权限！',
                            btn: ['确定']
                        });
                        break;
                    default:
                        return fun.alert({
                            msg: res['msg']
                        });
                        break;
                }
            },
            error: function (res) {
                return fun.alert({ msg: '网络异常！' });
            }
        });
    });
}

function getUserInfo() {
    var login_info = fun.getItem('login_info') || {};
    if ($.nui.isEmpty(login_info)) {
        return;
    }

    function getSetBook() {
        fun.getBookList(function () {
            fun.ajax({
                showLoad: false,
                hideLoad: true,
                url: AJAX_URL.getUserInfo,
                data: {
                    type: 'login',
                    account_id: login_info['account_id']
                },
                success: function (res) {
                    if (res['status'] == 0) {
                        if (!res['data']['mobile_auth']) {
                            fun.dialog({
                                content: "此账套没有手机端权限,请联系管理员开通权限！",
                                btn: ["确定"],
                                yes: function () {

                                }
                            });
                            return;
                        }
                        fun.setItem('user_info', res['data']);
                        //获取系统设置
                        fun.ajax({
                            showLoad: false,
                            hideLoad: true,
                            url: AJAX_URL.getSysList,
                            data: {},
                            success: function (res) {
                                if (res['status'] == 0) {
                                    fun.setItem('sys_config', res['data']);
                                }
                            }
                        });

                        fun.ajax({
                            showLoad: false,
                            hideLoad: true,
                            url: AJAX_URL.getBillsNumList,
                            data: {},
                            success: function (res) {
                                if (res['status'] == 0) {
                                    fun.setItem('dh_config', res['data']);
                                }
                            }
                        });
                        var company = $('.company').val();

                        // fun.getShopMallinfo();
                        if(res.data.company_config && $.nui.isTrue(res.data.company_config.is_mask)){//开启归档了(【数据归档-简化版】：RW00220240930011
                            https://oa321.cn/task-center/task-center?196674831767306240)
                            return fun.dialog({
                                className: 'package-rebot-skin',
                                shadeClose: false,
                                content: '小云已搭乘808航班去追寻诗和远方了',
                                btn: ['我知道了'],
                                yes: function () {

                                }
                            })
                        }
                        //云服务关闭状态下
                        if($.nui.isEmpty(fun.getItem('is_yfw'))){
                            if(fun.getItem('user_info').is_admin == 1){
                                return fun.showPageFull({
                                            page_url: page_arr.cloud_services,
                                            closeWin: true
                                        });
                            }else{
                                return fun.dialog({
                                            className: 'package-rebot-skin',
                                            shadeClose: false,
                                            content: '小云已搭乘808航班去追寻诗和远方了',
                                            btn: ['我知道了'],
                                            yes: function () {

                                            }
                                        })
                            }
                        }
                        //预加载数据
                        fun.load_DATA_LIST(['zh', 'ck', 'khh'], function () {
                            if (H5PAY) {
                                login.loginSetBind();
                            } else {
                                fun.showPageFull({
                                    page_url: page_arr.index,
                                    closeWin: true,
                                });
                            }
                        }, { showLoad: true });
                    }
                }
            })
        }, { not_alert: true, execLogout: false });
    }

    if (FORMER_CONFIG) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.getUserInfo,
            data: {
                type: 'login',
                account_id: login_info['account_id'] || 0
            },
            success: function (res) {
                if (res['status'] == 0) {
                    fun.setItem('user_info', res['data']);
                    fun.setItem('book_id', res['data']['last_book_id'] || 0);
                    getSetBook();
                }
            }
        })
    } else {
        getSetBook();
    }
}

//注册
$('#zc').on('click', function () {
    fun.showPageFull({
        page_url: page_arr.registration
    })
});


function register() {
    var html = [];
    var style = 'width: 13rem; height: 13rem; border:none;  padding: 0.5rem;';
    html.push('<div>');
    html.push(' <div class="register-zc">注册</div>');
    html.push(' <i class="iconfont icon-fork fork"></i>');
    html.push(' <div id="ewm" class="register-img">');   /*二维码*/
    html.push('     <img src="../img/code.png" id="code">');
    html.push(' </div>');
    html.push(' <div class="register-font">请前往微信：云布业 服务号进行注册。</div>');
    html.push('</div>');
    layer.open({
        type: 1,
        content: html.join(''),
        style: style,
        success: function (layero, index) {
            $('.fork').on('click', function () {
                layer.closeAll()
            })

            //长按保存图片
            var startDate, endDate;
            fun.longPress({
                "obj": "#code",
                "callback": function (ret) {
                    var wx_gzh = '云布业';//微信公众号 YunBuYe
                    var clipBoard = api.require('clipBoard');
                    clipBoard.set({
                        value: wx_gzh
                    }, function (ret, err) {
                        if (ret) {
                            fun.toast('“云布业”公众号复制成功！\r\n请前往注册，正在跳转微信...');

                            setTimeout(function () {
                                api.openApp({
                                    iosUrl: 'weixin://',
                                    androidPkg: 'com.tencent.mm',
                                    mimeType: 'text/html',
                                    uri: 'weixin://',
                                    //https://mp.weixin.qq.com/mp/profile_ext?action=home&__biz=MzU5NDk1MjUzMw==&scene=123#wechat_redirect
                                });
                            }, 1000);
                        } else {
                            fun.toast("复制失败，请重试！");
                        }
                    });
                    // console.log(JSON.stringify(ret));
                },

            })

            //点击图片跳转到微信(无法跳转到公众号)
            // $('#ewm').on('click',function(){
            //     api.openApp({
            //         iosUrl:'weixin://',
            //         androidPkg:'com.tencent.mm',
            //         mimeType: 'text/html',
            //         uri: 'weixin://',
            //     })
            // })

            // $('#ewm').on('touchstart',function(e){
            //     e.stopPropagation();
            //     startDate=Date.parse(new Date());
            // }).on('touchend',function(){
            //     endDate=Date.parse(new Date());
            //     var date=endDate-startDate;
            //     if(date>=1500){//长按达到1.5s
            //         //保存图片...
            //         var timeStamp=new Date().getTime();
            //         api.download({
            //             url:'https://imgs.yunbuye.com/code.png',//图片在线url
            //             savePath:'fs://'+timeStamp+'.jpeg',
            //             report:true,
            //             cache:true,
            //             allowResume:true,
            //         },function(ret,err){
            //             if(ret['state']==1){
            //                 api.toast({msg:'图片已保存到本地'});
            //                 api.saveMediaToAlbum({
            //                     path:'fs://'+timeStamp+'.jpeg',
            //                 }, function(ret, err) {
            //
            //                 })
            //             }
            //         })
            //     }
            // })
        }
    })
}


// 获取企业微信配置信息
function getWxWorkConf(comp) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getWxWorkConf,
        data: {
            name: comp
        },
        success: function (res) {
            if (res.status !== 0 || $.nui.isEmpty(res.data.wxwork_corp_id) || $.nui.isEmpty(res.data.wxwork_agent_id) || $.nui.isEmpty(res.data.wxwork_agent_schema)) {
                return fun.toast('企业微信配置错误！');
            }
            var wxWork = api.require('wxwork-sdk');
            wxWork.registerApp({
                appid: res.data.wxwork_corp_id,
                agentid: res.data.wxwork_agent_id,
                schema: api.systemType === 'android' ? res.data.wxwork_agent_schema : 'wwauthyunbuye'
            });
            wxWork.auth({
                state: "state_" + new Date().getTime() + (Math.random() * 10000)
            }, function(res){
                var errCode = res.errCode; // 错误码
                if (errCode === 0) {
                    //成功
                    fun.ajax({
                        showLoad: true,
                        hideLoad: true,
                        url: AJAX_URL.wxUser,
                        data: {
                            company: comp,
                            type: 'wxwork_dl',
                            code: res.code,
                            login_type: 'app'
                        },
                        success: function (res) {
                            if (res.status !== 0) {
                                return fun.toast(res.msg);
                            }
                            if (api.systemType === 'android') {
                                getUserPhone(function(){
                                    Login(res.data.comp, res.data.account, res.data.pwd)
                                });
                            } else {
                                Login(res.data.comp, res.data.account, res.data.pwd)
                            }
                        }
                    });
                } else if (errCode == 1) {
                    //取消
                    return fun.toast('取消授权');
                } else {
                    //错误
                    return fun.toast(res.errMsg);
                }
            });
        },
        false: function () {
            fun.alert({ msg: '获取企业微信配置异常！' });
        }
    });
}


//企业微信登录
$('body').on('tap', '.bind-wxwork', function () {
    fun.setItem('login_mode', 'qw');
    
    var comp = $(".company").val().trim();
    if ($.nui.isEmpty(comp)) {
        return fun.toast('请输入公司名称')
    }

    if (!$('.agree').hasClass('agrees')) {
        return fun.toast('请先同意用户协议与隐私政策');
    }

    if (!network) {
        return fun.alert({ msg: '网络异常！' });
    }

    if (api.connectionType === 'none') {
        return fun.alert({ msg: '请对APP授权数据网络允许访问。' });
    }

    getWxWorkConf(comp);
})


//微信登录
$('body').on('tap', '.bind-wx', function () {
    fun.setItem('login_mode', 'wx');

    if (!$('.agree').hasClass('agrees')) {
        return fun.toast('请先同意用户协议与隐私政策');
    }

    if (!network) {
        return fun.alert({ msg: '网络异常！' });
    }

    if (api.connectionType === 'none') {
        return fun.alert({ msg: '请对APP授权数据网络允许访问。' });
    }

    var wx = api.require('wxPlus');
    if(!checkWxUseable(wx)) return false;
    wx.auth({
        apiKey: ''  //wx_appid  已从config获取
    }, function (ret, err) {
        if (ret.status) {   //成功登陆
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.wxUser,
                data: {
                    type: 'dl',
                    code: ret.code,
                    login_type: 'app'
                },
                success: function (res) {
                    console.log(JSON.stringify(res));
                    if (res.status !== 0) {
                        return fun.toast(res.msg);
                    }
                    if (api.systemType === 'android') {
                        getUserPhone(function(){
                            Login(res.data.comp, res.data.account, res.data.pwd)
                        });
                    } else {
                        Login(res.data.comp, res.data.account, res.data.pwd)
                    }
                }
            });
        } else {
            if (err.code == 1) {
                return fun.toast('取消授权');
            } else if (err.code == 2) {
                return fun.toast('拒绝授权');
            } else if (err.code == 3) {
                return fun.toast('未安装微信');
            }
        }
    });
})

$('#wjmm').on('click', function () {
    var mobile = '';
    if ($('.account').val().length == 11 && fun.regCheck($('.account').val(), 'phone')) {
        mobile = $('.account').val();
    }
    fun.showPageFull({
        page_url: page_arr.forget_password,
        pageParam: {
            mobile: mobile
        }
    })
})
$('#ydwt').on('click', function () {
    var html = [];
    html.push('<div>');
    html.push('     <div>');
    html.push('         <p>请将当前界面截图发给我司客服进行协助处理</p>');
    html.push('         <p>对您造成不便，请谅解</p>');
    html.push('     </div>');
    html.push('     <ul>');
    html.push('         <li>');
    html.push('             <span>公司</span>');
    html.push('             <span>' + ($('.company').val() || '') + '</span>');
    html.push('         </li>');
    html.push('         <li>');
    html.push('             <span>账号</span>');
    html.push('             <span>' + ($('.account').val() || '') + '</span>');
    html.push('         </li>');
    html.push('         <li>');
    html.push('             <span>版本</span>');
    html.push('             <span>V' + APP_VERSION + '（' + api.appVersion + '）' + '</span>');
    html.push('         </li>');
    html.push('         <li>');
    html.push('             <span>系统</span>');
    html.push('             <span>' + api.systemType + ' ' + api.systemVersion + '</span>');//+ ' ' + api.connectionType 
    html.push('         </li>');
    html.push('     </ul>');
    html.push('     <div class="problems-btn">');
    html.push('         <button class="problems-lxkf">联系客服<button>');
    html.push('     </div>');
    html.push('</div>');

    layer.open({
        content: html.join(''),
        style: 'width:90%;',
        className: 'problems-layer',
        shade: true,
        success: function () {
            $('.problems-lxkf').on('click', function () {
                fun.jumpZxkf()
                // fun.showPageFull({
                //     page_url: page_arr.new_win
                // });
            })
        }
    })
})


function emptySaleCodeAlert() {
    var html = [];
    html.push('<div>');
    html.push('     <div>');
    html.push('         <p class="img-wrap"><img src="../img/pic_001.png"></p>');
    // html.push('         <p>&nbsp;</p>');
    html.push('         <p style="text-align:center;font-size:0.75rem;">请联系我司授权开通版本</p>');
    // html.push('         <p>&nbsp;</p>');
    html.push('     </div>');
    html.push('     <div class="problems-btn">');
    html.push('         <button class="problems-lxkf">联系客服<button>');
    html.push('     </div>');
    html.push('</div>');

    layer.open({
        content: html.join(''),
        style: 'width:90%;',
        className: 'problems-layer',
        shade: true,
        success: function () {
            $('.problems-lxkf').on('click', function () {
                fun.jumpZxkf()
                // fun.showPageFull({
                //     page_url: page_arr.new_win
                // });
            })
        }
    })
}

$('body').on('click', '.agree-login', function (e) {
    e.stopPropagation();

    if ($('.agree').hasClass('agrees')) {
        fun.setItem('yby_before_login', 0);
        $('.agree').removeClass('agrees');
    } else {
        fun.setItem('yby_before_login', 1);
        $('.agree').addClass('agrees');
        if (api.systemType === 'android') {
            getUserPhone();
        }
    }
});


$('.use').on('click', function (e) {
    e.stopPropagation();
    var overscroll = function (el) {
        el.addEventListener('touchstart', function () {
            var top = el.scrollTop;
            var totalScroll = el.scrollHeight;
            var currentScroll = top + el.offsetHeight;
            if (top === 0) {
                el.scrollTop = 1;
            } else if (currentScroll === totalScroll) {
                el.scrollTop = top - 1;
            }
        });
        el.addEventListener('touchmove', function (evt) {
            if (el.offsetHeight < el.scrollHeight) {
                evt._isScroller = true;
            }
        });
    }

    function preventDefault(e) {
        // e.preventDefault(); //阻止默认的处理方式(阻止下拉滑动的效果)
        if (!e._isScroller) {
            e.preventDefault();
        }
    }


    var Html = [];
    Html.push(' <div class="agreement-box">');
    Html.push('     <p class="agreement-title">广州鸿翼智能科技有限公司</p>');
    Html.push('     <p class="agreement-title2">用户使用协议</p>');
    Html.push('     <ul class="agreement-text">');
    Html.push('         <li class="li-none">1.重要须知</li>');
    Html.push('         <li>1.1. 广州鸿翼智能科技有限公司及关联企业（以下合称“我们”）同意按照本协议的规定及其不时发布的操作规则提供基于互联网以及移动网的云布业、云布业相关产品等在线服务（以下称“服务”），为获得服务，服务使用人（以下简称“用户”或“您”）应当基于了解本协议全部内容，在独立思考的基础上认可、同意本协议的全部条款并按照页面上的提示完成全部的注册程序。您在进行注册程序过程中点击“同意” 按钮即表示您完全接受《云布业用户使用协议》（以下简称“本协议”）及我们公司公示的各项规则、规范。您确认，您是具备完全民事权利能力和完全民事行为能力的自然人、法人或其他组织（以下简称“法律主体”），如您代表一家公司或其他法律主体进行注册或以其他允许的方式实际使用本服务，视为您已经获得该公司或该法律主体受本协议条款的约束。如果您不具备前述法律主体资格，请立即终止在云布业平台上的任何操作，且我们公司有权注销您的账号。我们公司因此受到损失的，将向您和/或您的监护人索赔。</li>');
    Html.push('         <li>1.2. 为提高您的服务体验和满意度，您同意我们公司将基于您的操作行为对您的行为数据进行调查研究和分析，从而进一步优化产品和服务。</li>');
    Html.push('         <li>1.3. 您在使用结束后，如需暂时或永久离开本服务，数据将会自动归档处理，待归档期限结束后会自动删除。</li>');

    Html.push('         <li class="li-none">2.服务内容 在线企业软件服务，通过PC或者移动设备联网访问使用</li>');
    Html.push('         <li>2.1. 本协议所述的云布业服务具体内容由我们公司根据实际情况提供，包括但不限于授权您通过其帐号，使用云布业、云布业相关产品等，我们公司有权对其提供的服务或产品形态进行升级或其他调整，并将及时告知您。</li>');
    Html.push('         <li>2.2. 您理解，我们公司仅提供与服务相关的技术服务等，除此之外与相关网络服务有关的设备（如个人电脑、手机、及其他与接入互联网或移动网有关的装置）及所需的费用（如为接入互联网而支付的电话费及上网费、为使用移动网而支付的手机费）均应由您自行负担。</li>');

    Html.push('         <li class="li-none">3.服务变更、中断或终止</li>');
    Html.push('         <li>3.1. 鉴于网络服务的特殊性（包括但不限于服务器的稳定性问题、恶意的网络攻击等行为的存在及其他我们公司无法控制的情形），您同意我们公司有权随时中断或终止部分或全部的服务，若发生该等中断或中止服务的情形，我们公司将尽可能及时通过网页公告、系统通知、私信、短信、微信或其他合理方式通知受到影响的您。</li>');
    Html.push('         <li>3.2. 您理解，我们公司需要定期或不定期地对提供服务的平台（如互联网网站基础设施设备等）或相关的设备进行检修或者维护，如因此类情况而造成服务在合理时间内的中断，我们公司无需为此承担任何责任，但我们公司应尽可能事先进行通告。</li>');
    Html.push('         <li>3.3. 如发生下列任何一种情形，我们公司有权随时中断或终止向您提供本协议项下的服务而无需对您或任何第三方承担任何责任：</li>');
    Html.push('         <li>3.3.1. 您提供的个人资料不真实；</li>');
    Html.push('         <li>3.3.2. 您违反法律法规国家政策或本协议中规定的使用规则；</li>');
    Html.push('         <li>3.3.3. 您在使用收费服务时未按规定付费。</li>');
    Html.push('         <li>3.4. 如您在申请开通服务后，授权过期未续费，则我们公司有权选择采取以下方式进行处理，由此产生的一切法律责任将由您自行承担：</li>');
    Html.push('         <li>3.4.1. 回收昵称；</li>');
    Html.push('         <li>3.4.2. 停止提供服务。</li>');
    Html.push('         <li>3.5. 您选择将帐号与微信等第三方帐号进行绑定的，除您自行解除绑定关系外，如发生下列任何一种情形，您已绑定的第三方帐号也有可能被解除绑定而我们公司无需对您或任何第三方承担任何责任：</li>');
    Html.push('         <li>3.5.1. 违反法律法规国家政策、本协议的；</li>');
    Html.push('         <li>3.5.2. 违反第三方帐户协议或其相关规定的；</li>');
    Html.push('         <li>3.5.3. 其他需要解除绑定的。</li>');
    Html.push('         <li>3.6. 您理解并同意，我们公司有权随时要求您完成云布业账户的实名认证，上传企业证照和相关信息（包含企业名称、人员规模、所处行业、办公电话、电子邮箱、联系人、联系地址、工商注册证照、统一社会信用代码等）。 同时，我们公司可能会就某些产品或服务的开通，要求您提供更多的身份资料和信息，做进一步的身份认证或资格验证，您的账户只有在通过这些认证和验证之后，方可获得使用相关产品或服务的资格。</li>');

    Html.push('         <li class="li-none">4. 使用规则</li>');
    Html.push('         <li>您应遵守与您使用“服务”，以及与您竞买、购买和销售任何物品以及提供商贸信息有关的所有相关的法律、法规、条例和规章。您须自行负责对您的账号和密码保密，且须对您在帐号和密码下发生的所有活动承担责任。您同意：(a) 如发现任何人未经授权使用您的会员注册名或密码，或发生违反保密规定的任何其他情况，您会立即通知云布业；及 (b) 确保您在每个上网时段结束时，以正确步骤离开网站。云布业不能也不会对因您未能遵守本款规定而发生的任何损失或损毁负责</li>');
    Html.push('         <li>4.1. 您注册云布业账号，制作、发布、传播信息内容的，应当使用真实身份信息，不得以虚假、冒用的居民身份信息、企业注册信息、组织机构代码信息进行注册。</li>');
    Html.push('         <li>4.2. 如您违反前述4.1条之约定，依据相关法律、法规及国家政策要求，我们公司有权随时中止或终止您对服务的使用且不承担责任。</li>');
    Html.push('         <li>4.3. 您在使用服务时，我们公司有权基于安全运营、社会公共安全的需要或国家政策的要求，要求您提供准确的个人资料，如您提供的个人资料有任何变动，导致您的实际情况与您提交给我们公司的信息不一致的，您应及时更新。</li>');
    Html.push('         <li>4.4. 您不应将其帐号、密码转让或出借予他人使用。如您发现其帐号或服务遭他人非法使用，应立即通知我们公司协调处理。因无法对非法或未经您授权使用您账号及密码的行为作出甄别，因此我们公司不承担任何责任。</li>');
    Html.push('         <li>4.5. 您同意我们公司在提供服务过程中以各种方式投放各种商业性广告或其他任何类型的商业信息，并且，您同意接受我们公司通过电子邮件或其他方式向您发送商品促销或其他相关商业信息。</li>');
    Html.push('         <li>4.6. 对于您通过服务公开发布的任何内容，您同意我们公司在全世界范围内具有免费的、永久性的、不可撤销的、非独家的和完全再许可的权利和许可，以使用、复制、修改、改编、出版、翻译、据以创作衍生作品、传播、表演和展示此等内容（整体或部分），和/或将此等内容编入当前已知的或以后开发的其他任何形式的作品、媒体或技术中。</li>');
    Html.push('         <li>4.7. 您在使用服务过程中，不得在网站上制作、复制、上传、发布、传播含有下列内容之一的信息：</li>');
    Html.push('         <li>4.7.1. 违反宪法确定的基本原则的；</li>');
    Html.push('         <li>4.7.2. 危害国家安全，泄露国家秘密，颠覆国家政权，破坏国家统一的；</li>');
    Html.push('         <li>4.7.3. 损害国家荣誉和利益的；</li>');
    Html.push('         <li>4.7.4. 煽动民族仇恨、民族歧视，破坏民族团结的；</li>');
    Html.push('         <li>4.7.5. 破坏国家宗教政策，宣扬邪教和封建迷信的；</li>');
    Html.push('         <li>4.7.6. 散布谣言，扰乱社会秩序，破坏社会稳定的；</li>');
    Html.push('         <li>4.7.7. 散布淫秽、色情、赌博、暴力、恐怖或者教唆犯罪的；</li>');
    Html.push('         <li>4.7.8. 侮辱或者诽谤他人，侵害他人合法权益的；</li>');
    Html.push('         <li>4.7.9. 煽动非法集会、结社、游行、示威、聚众扰乱社会秩序；</li>');
    Html.push('         <li>4.7.10. 以非法民间组织名义活动的；</li>');
    Html.push('         <li>4.7.11. 不符合《即时通信工具公众信息服务发展管理暂行规定》及遵守法律法规、社会主义制度、国家利益、公民合法利益、公共秩序、社会道德风尚和信息真实性等“七条底线”要求的；</li>');
    Html.push('         <li>4.7.12. 发布、传送、传播、储存侵害他人名誉权、肖像权、知识产权、商业秘密等合法权利的内容；</li>');
    Html.push('         <li>4.7.13. 涉及他人隐私、个人信息或资料的；</li>');
    Html.push('         <li>4.7.14. 发表、传送、传播骚扰、广告信息、过度营销信息及垃圾信息或含有任何性或性暗示的；</li>');
    Html.push('         <li>4.7.15. 干扰我们公司正常运营和侵犯其他您或第三方合法权益内容的信息。</li>');
    Html.push('         <li>4.7.16. 含有中国法律、法规以及任何具有法律效力之规范所限制或禁止的其它内容的。</li>');
    Html.push('         <li>4.8. 我们公司针对某些特定的服务的使用通过各种方式（包括但不限于网页公告、系统通知、私信、短信提醒等）作出的任何声明、通知、警示等内容视为本协议的一部分，您如使用该等服务，视为您同意该等声明、通知、警示的内容。</li>');
    Html.push('         <li>4.9. 您承诺自己在使用本网站服务的所有行为均遵守国家法律、法规和本网站的相关规定以及各种社会公共利益或公共道德。对于任何法律后果的发生，您将以自己的名义独立承担所有相应的法律责任，我们公司不承担任何责任。</li>');
    Html.push('         <li>4.10. 您在使用服务时如发现服务系统或其他相关系统的信息安全漏洞需及时通知我们公司，禁止对我们公司服务系统进行漏洞扫描、渗透测试等可能造成我们公司损失的行为。</li>');
    Html.push('         <li>4.11. 除非法律允许或云布业书面许可，你使用本产品或服务过程中不得从事下列行为：</li>');
    Html.push('         <li>4.11.1. 删除本产品及其副本上关于著作权的信息；</li>');
    Html.push('         <li>4.11.2. 对本产品进行反向工程、反向汇编、反向编译，或者以其他方式尝试发现本产品的源代码；</li>');
    Html.push('         <li>4.11.3. 对云布业拥有知识产权的内容进行使用、出租、出借、复制、修改、链接、转载、汇编、发表、出版、建立镜像站点等；</li>');
    Html.push('         <li>4.11.4. 对本产品或者本产品运行过程中释放到任何终端内存中的数据、产品运行过程中客户端与服务器端的交互数据，以及本产品运行所必需的系统数据，进行复制、修改、增加、删除、挂接运行或创作任何衍生作品，形式包括但不限于使用插件、外挂或非云布业经授权的第三方工具/服务接入本产品和相关系统；</li>');
    Html.push('         <li>4.11.5. 通过修改或伪造产品运行中的指令、数据，增加、删减、变动产品的功能或运行效果，或者将用于上述用途的产品、方法进行运营或向公众传播，无论这些行为是否为商业目的；</li>');
    Html.push('         <li>4.11.6. 自行或者授权他人、第三方产品对本产品及其组件、模块、数据进行干扰；</li>');
    Html.push('         <li>4.11.7. 其他未经云布业明示授权的行为。</li>');
    Html.push('         <li>4.12. 除非法律允许或云布业书面许可，使用本产品或服务过程中不得从事下列行为：</li>');
    Html.push('         <li>4.12.1. 提交、发布虚假信息，或冒充、利用他人名义的；</li>');
    Html.push('         <li>4.12.2. 诱导其他您点击链接页面或分享信息的；</li>');
    Html.push('         <li>4.12.3. 虚构事实、隐瞒真相以误导、欺骗他人的；</li>');
    Html.push('         <li>4.12.4. 侵害他人名誉权、肖像权、知识产权、商业秘密等合法权利的；</li>');
    Html.push('         <li>4.12.5. 其他违反法律法规规定、侵犯其他您合法权益、干扰产品正常运营或云布业未明示授权的行为。</li>');

    Html.push('         <li class="li-none">5. 知识产权</li>');
    Html.push('         <li>5.1. 我们公司提供的网络服务中包含的任何文本、图片、图形、音频和/或视频资料均受著作权、商标和/或其它财产所有权法律的保护，未经相关权利人同意，上述资料均不得在任何媒体直接或间接发布、播放、出于播放或发布目的而改写或再发行，或者被用于其他任何商业目的。所有这些资料或资料的任何部分仅可作为私人和非商业用途而保存在某台计算机内。我们公司不就由上述资料产生或在传送或递交全部或部分上述资料过程中产生的延误、不准确、错误和遗漏或从中产生或由此产生的任何损害赔偿，以任何形式，向您或任何第三方负责。</li>');
    Html.push('         <li>5.2. 服务中涉及的“云布业”、“YUNBUYE”、“CLOUD CLOTH”等文字或图形及其组成，均是我们公司的商标。未经我们公司事先书面同意，您不得有擅自使用或展示这些商标，一经发现，我们公司将追究法律责任。</li>');
    Html.push('         <li>5.3. 我们公司为提供服务而使用的，或者第三方针对服务开发的在平台上运行、供您使用的任何软件（包括但不限于软件中所含的任何图象、照片、动 画、录像、录音、音乐、文字和附加程序、随附的帮助材料）的一切权利均属于该软件的著作权人，未经该软件的著作权人许可，您不得对该软件进行反向工程 （reverse engineer）、反向编译（decompile）或反汇编（disassemble）。</li>');

    Html.push('         <li class="li-none">6. 免责声明</li>');
    Html.push('         <li>6.1. 您在使用服务的过程中应遵守国家法律法规及政策规定，因其使用服务而产生的行为后果由您自行承担。</li>');
    Html.push('         <li>6.2. 通过服务发布的任何信息，及通过服务传递的任何观点不代表我们公司之立场，我们公司亦不对其完整性、真实性、准确性或可靠性负责。您对于可能会接触到的非法的、非道德的、错误的或存在其他失宜之处的信息，及被错误归类或是带有欺骗性的发布内容，应自行做出判断。在任何情况下，对于任何信息，包括但不仅限于其发生的任何错误或遗漏；或是由于使用通过服务发布、私信、传达、其他方式所释出的或在别处传播的信息，而造成的任何损失或伤害，应由相关行为主体承担全部责任。</li>');
    Html.push('         <li>6.3. 鉴于外部链接指向的网页内容非我们公司实际控制的，因此我们公司无法保证为向您提供便利而设置的外部链接的准确性和完整性。</li>');
    Html.push('         <li>6.4. 您完全理解并同意，本服务涉及到互联网等相关服务，可能会受到不可抗力（包括但不限于战争、台风、水灾、火灾、地震、罢工、暴动等）、计算机病毒或黑客攻击、互联网络等造成的服务中断或不能满足您要求的风险，使用本服务的您须承担以上风险，我们公司不承担任何责任。</li>');
    Html.push('         <li>6.5. 对网站系统发生故障影响到本服务的正常运行，我们公司承诺将及时处理、修复。但您因此而产生的经济和精神损失，我们公司不承担任何责任。此外，我们公司保留不经事先通知进行维护、升级或其他目的暂停本服务的权利，由此产生的损失我们公司不承担任何责任。</li>');
    Html.push('         <li>6.6. 您在使用过程中遭受的来自任何他人的威胁、诽谤或其他非法行为，您对此必须自己承担责任，我们公司对本服务不做任何类型的保证；对因此导致任何您产生直接或间接地损失，我们公司不承担任何责任。</li>');
    Html.push('         <li>6.7. 您在注册账号后，如果出现违反法律或本协议的情形，有权回收该账号，由此给您带来的任何问题均由您自行承担。</li>');
    Html.push('         <li>6.8. 如发生下列任何一种情形，云布业有权随时中断或终止向您提供服务而无需通知该您：</li>');
    Html.push('         <li>6.8.1. 提供的个人资料不真实或存在侵犯第三方知识产权或其他权利的情形；</li>');
    Html.push('         <li>6.8.2. 违反本服务条款的规定；</li>');
    Html.push('         <li>6.8.3. 按照政府部门和/或司法机关的要求；</li>');
    Html.push('         <li>6.8.4. 注册后长期（持续90日或以上）闲置不用的账号；</li>');
    Html.push('         <li>6.8.5. 恶意抢注企业名称，我们公司收到第三方投诉且该第三方出具相应证据的；</li>');
    Html.push('         <li>6.8.6. 其他我们公司认为是符合整体服务需求的特殊情形。</li>');
    Html.push('         <li>6.9. 您知悉并同意，我们公司可能会与第三方合作向您提供产品，并由第三方向您提供该产品的升级、维护、客服等后续工作，由该等第三方对该产品的质量问题或其本身的原因导致的一切纠纷或您损失承担责任，您在此同意将向该第三方主张与此有关的一切权利和损失。</li>');
    Html.push('         <li>6.10. 云布业平台上提供的产品或服务，如未标明使用期限、或者其标明的使用期限为“永久”、“无限期”或“无限制”的，则其使用期限为自您获得该产品或服务之日起至该产品或服务在云布业下线之日为止。</li>');

    Html.push('         <li class="li-none">7. 赔偿</li>');
    Html.push('         <li>7.1. 如因我们公司违反有关法律、法规或本协议项下的任何条款而给您造成损失，我们公司同意承担由此造成的损害赔偿责任，赔偿金额限于您为购买相应服务已支付的费用。在相关法律所允许的最大范围内，我们公司不就您因使用或不能使用服务所发生的间接损害（包括但不限于营业中断、利润损失、商业信息的丢失、费用增加等）承担赔偿责任；我们公司不对由于移动通信服务商、互联网接入服务商等第三方原因导致服务无法使用或出现故障所发生的损失承担责任。</li>');
    Html.push('         <li>7.2. 您同意保障和维护我们公司及其他您的利益，如因您违反有关法律、法规或本协议项下的任何条款而给我们公司或任何其他第三人造成损失，您同意承担由此造成的损害赔偿责任并保证我们公司免遭损失。</li>');

    Html.push('         <li class="li-none">8. 协议修改</li>');
    Html.push('         <li>8.1. 我们公司保留不时修改本协议任何条款的权利，一旦本协议的内容发生变动，我们公司将会在网站上公布修改之后的协议内容，若您不同意上述修改，则可以选择停止使用服务。我们公司也可选择通过其他适当方式（比如系统通知）向您通知修改内容。</li>');
    Html.push('         <li>8.2. 如果不同意我们公司对本协议相关条款所做的修改，您有权停止使用服务。如果您继续使用服务，则视为您接受我们公司对本协议相关条款所做的修改。</li>');

    Html.push('         <li class="li-none">9. 通知送达</li>');
    Html.push('         <li>9.1. 本协议项下我们公司对于您所有的通知均可通过网页公告、电子邮件、系统通知主动联系、私信、手机短信或常规的信件传送等方式进行；该等通知于发送之日视为已送达收件人。</li>');
    Html.push('         <li>9.2. 您对于我们公司的通知应当通过我们公司对外正式公布的通信地址、传真号码、电子邮件地址等联系信息进行送达。</li>');

    Html.push('         <li class="li-none">10. 法律适用</li>');
    Html.push('         <li>10.1. 本协议及其修订本的有效性、履行和解释均适用于中华人民共和国之法律，任何争议也仅适用中华人民共和国法律。如协议服务条款之任何一部分与中华人民共和国法律相抵触，则该部分条款应按法律规定重新解释，部分条款之无效或重新解释不影响其它条款之法律效力 。</li>');
    Html.push('         <li>10.2. 因本协议所引起的您与我们公司的任何纠纷或争议，首先应本着友好协商原则进行解决，如果协商不成的，您在此完全同意将纠纷或争议提交至可向广州市海珠区人民法院提起诉讼。</li>');
    Html.push('         <li class="li-none">11. 其他规定</li>');
    Html.push('         <li>11.1. 本协议构成双方对本协议之约定事项及其他有关事宜的完整协议，除本协议规定的之外，未赋予本协议各方其他权利。</li>');
    Html.push('         <li>11.2. 如本协议中的任何条款无论因何种原因完全或部分无效或不具有执行力，本协议的其余条款仍应有效并且有约束力。</li>');
    Html.push('         <li>11.3. 本协议中的标题仅为方便而设，在解释本协议时应被忽略。</li>');
    Html.push('     </ul>');
    Html.push('</div>');
    layer.open({
        type: 1,
        anim: 'up',
        style: 'position:fixed; bottom:0; left:0; width: 94%;height:70%; border:none;overflow-y: scroll; padding-left:3%;padding-right:3%;',
        className: 'agreement-layer',
        content: Html.join(''),
        success: function () {

            for (var i = 0; i < document.querySelectorAll('.agreement-layer').length; i++) {
                overscroll(document.querySelectorAll('.agreement-layer')[i]);
            }
            document.body.addEventListener('touchmove', preventDefault, { passive: false });

        },
        end: function () {
            document.body.removeEventListener('touchstart', preventDefault, { passive: false });
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
        }
    })
});

$('.privacy').on('click', function (e) {
    e.stopPropagation();
    var overscroll = function (el) {
        el.addEventListener('touchstart', function () {
            var top = el.scrollTop;
            var totalScroll = el.scrollHeight;
            var currentScroll = top + el.offsetHeight;
            if (top === 0) {
                el.scrollTop = 1;
            } else if (currentScroll === totalScroll) {
                el.scrollTop = top - 1;
            }
        });
        el.addEventListener('touchmove', function (evt) {
            if (el.offsetHeight < el.scrollHeight) {
                evt._isScroller = true;
            }
        });
    }

    function preventDefault(e) {
        // e.preventDefault(); //阻止默认的处理方式(阻止下拉滑动的效果)
        if (!e._isScroller) {
            e.preventDefault();
        }
    }


    var Html = [];
    Html.push(' <div class="agreement-box">');
    Html.push('     <p class="agreement-title">隐私政策</p>');
    Html.push('     <ul class="agreement-text">');
    Html.push('         <li class="li-none">一、引言</li>');
    Html.push('         <li>您的信任对【广州鸿翼智能科技有限公司】（以下简称“我们”）非常重要，我们深知用户隐私信息对您的重要性，为此我们将按法律法规要求，采取相应安全保护措施，尽力保护您的信息安全可控。在此前提下，<u>您在使用我们的产品或服务时，我们可能会收集、使用、储存和分享您的相关信息。</u></li>');
    Html.push('         <li>本《隐私政策》与您所使用的由我们提供的产品或服务息息相关，我们希望通过本《隐私政策》向您说明，在使用我们的产品或服务时，我们如何收集、使用、储存和分享这些信息，以及我们为您提供的访问、更新、控制和保护这些信息的方式。<u>您需仔细阅读本《隐私政策》，尤其需关注您同意我们收集、使用、储存、分享您的相关信息及免除或限制责任的条款，在需要时，请您按照本《隐私政策》的指引，作出您认为适当的选择。前述条款将通过加粗及下划线标识的方式提示您特别注意。</u></li>');
    Html.push('         <li><u>您一旦开始使用我们的产品或服务，即意味着同意我们按照本《隐私政策》收集、使用、储存和分享您的相关信息。本《隐私政策》是我们就向您提供产品或服务时发布的《云布业用户协议》等相关协议的组成部分，与其构成一个统一的整体，您接受其中任一协议则代表您接受本《隐私政策》。</u></li>');
    Html.push('         <li>如果您<b>未满18周岁<u>的个人用户</u></b>，请在法定监护人的陪同下阅读并接受本《隐私政策》，并特别注意未成年人使用条款。</li>');
    Html.push('         <li>如对本《隐私政策》或相关事宜有任何疑问、意见或建议，您可通过我们提供的各种联系方式与我们联系。</li>');

    Html.push('         <li class="li-none">二、我们可能收集的信息</li>');
    Html.push('         <li>您在使用我们的产品，或者我们向您提供服务时，我们可能会收集下列与您有关的信息。如果您不提供相关信息，可能无法为您提供某些服务，或者无法达到相关服务拟达到的效果。我们可能收集如下信息：</li>');
    Html.push('         <li>1、您向我们提供的信息</li>');
    Html.push('         <li>您在需要协助授权时，需向我们提供以下信息：公司名称、登录的账号名称、账套名称、APP版本号、<b>设备名称、手机系统版本号和网络类型</b>，方便我司人员能更快的帮您服务。</li>');
    Html.push('         <li>2、我们获取您的信息</li>');
    Html.push('         <li>您在使用我们产品或服务时我们可能收集如下信息：</li>');
    Html.push('         <li> （1）设备或软件信息 我们可能会收集您设备或软件专用的信息<b>（APP版本号、设备MAC地址、软件安装列表、设备名称、手机系统版本号和网络类型）</b>，我们收集这些信息是为了向您提供我们基本服务和基础功能。</li>');
    Html.push('         <li> （2）日志信息 当您使用我们的服务或查看由我们提供的内容时，我们可能会自动收集某些信息并存储到服务器日志中。此类信息包括：错误日志、崩溃日志。</li>');
    Html.push('         <li> （3）位置信息 当您确认需要使用定位功能时，我们可能会收集并处理有关您实际所在位置的信息。</li>');
    Html.push('         <li> （4）本地存储 我们可能会使用浏览器网络存储等机制（包括HTML5）和应用数据缓存，收集您设备上的信息（包括登录信息）并进行本地存储。</li>');
    Html.push('         <li> （5）手机号码 当您确认需要使用 云布业账号绑定手机号码时，我们会收集当前设备的手机号码。</li>');
    Html.push('         <li> （6）相机权限 当您主动拍摄时，我们会请求您授权手机、相册 权限。如果您拒绝授权，将无法拍摄，但不影响您使用云布业的其他功能。</li>');
    Html.push('         <li> （7）粘贴板权限 当您打开 APP 或输入内容时，我们会请求您授权粘贴板权限。如果您拒绝授权，将无法获取粘贴板的数据，但不影响您使用云布业的其他功能。</li>');

    Html.push('         <li class="li-none">三、我们可能如何使用信息</li>');
    Html.push('         <li>我们可能将向您提供服务的过程中所收集的信息用作下列用途：</li>');
    Html.push('         <li> 1、向您提供服务；</li>');
    Html.push('         <li> 2、在我们提供服务时，用于身份验证、客户服务、安全防范、诈骗监测、存档和备份等用途，确保我们向您提供的产品和服务的安全性；</li>');
    Html.push('         <li> 3、帮助我们完善现有服务，开发新的功能以为您提供更好的服务；</li>');
    Html.push('         <li> 4、我们可能会将来自某项服务的您的信息与来自其他我们或关联公司提供服务的信息结合起来，以为您提供更为全面的服务；</li>');

    Html.push('         <li class="li-none">四、我们可能分享的信息</li>');
    Html.push('         <li><u>除法律另有规定外，您知晓并同意，在以下情形下，我们以及我们的关联公司可能会与第三方分享您的信息：</u></li>');
    Html.push('         <li>1、我们以及我们的关联公司，可能将您的信息与我们的关联公司、合作伙伴及第三方服务供应商、承包商及代理商分享，用作下列用途：</li>');
    Html.push('         <li> （1）向您提供我们的服务；</li>');
    Html.push('         <li> （2）实现“我们可能如何使用信息”部分所述目的；</li>');
    Html.push('         <li> （3）履行我们在引言部分所述的义务或本《隐私政策》中的义务和行使我们的权利；</li>');
    Html.push('         <li> （4）理解、维护和改善我们的服务。</li>');
    Html.push('         <li>2、随着我们业务的持续发展，我们以及我们的关联公司有可能进行合并、收购、资产转让或类似的交易，您的信息有可能作为此类交易的一部分而被转移。我们将在转移前通知您。</li>');
    Html.push('         <li>3、我们或我们的关联公司还可能为以下需要而保留、保存或披露您的信息：</li>');
    Html.push('         <li> （1）遵守适用的法律法规；</li>');
    Html.push('         <li> （2）遵守法院判决、裁定或其他法律程序的规定；</li>');
    Html.push('         <li> （3）遵守相关政府机关的要求；</li>');
    Html.push('         <li> （4）为遵守适用的法律法规、维护社会公共利益，或保护我们的客户、我们或我们的集团公司、其他用户或雇员的人身和财产安全或合法权益所合理必需的用途。</li>');
    Html.push('         <li>4、<u>在不透露单个用户隐私资料的前提下，我们及我们委托的关联公司及（或）合作伙伴有权对整个用户数据库进行推演、计算、分析、梳理、挖掘应用，并在此基础上对用户数据库进行商业上的利用。我们保证不对外公开或向第三方提供单个用户的注册资料及用户在使用网络服务时存储在我们处的非公开内容和数据。</u></li>');
    Html.push('         <li>如我们或我们的关联公司与任何上述第三方分享您的信息，我们将努力确保该等第三方在使用您的信息时遵守本《隐私政策》及我们要求其遵守的其他适当的保密和安全措施。</li>');

    Html.push('         <li class="li-none">五、云同步服务</li>');
    Html.push('         <li>您在使用我们具有云同步服务功能的产品、服务和网站时，也将适用本《隐私政策》中的条款。</li>');
    Html.push('         <li>通过我们云同步功能您可以使用某些互联网服务，包括将您的云同步内容存放在您的兼容装置和电脑上并供访问。一旦您启用云同步功能，您的云同步内容将被自动发送给我们并由我们存储，之后您就可访问该等信息或以无线方式将信息推送至您的其他启用云同步功能的装置或电脑上。</li>');
    Html.push('         <li><u>在保证您的信息安全的前提下，你理解并同意我们通过云服务对您的信息按照本《隐私政策》约定的条件进行收集、使用、储存和分享。</u></li>');

    Html.push('         <li class="li-none">六、信息安全</li>');
    Html.push('         <li>我们使用各种安全技术和程序，以防信息的丢失、不当使用、未经授权阅览或披露。例如，在某些服务中，我们将利用加密技术（例如SSL）来保护您提供的信息。</li>');
    Html.push('         <li><u>但请您理解，由于技术的限制以及可能存在的各种恶意手段，在互联网行业，即便竭尽所能加强安全措施，也不可能始终保证信息百分之百的安全。您需要了解，您接入我们的服务所用的系统和通讯网络，有可能因我们可控范围外的因素而出现问题。</u></li>');

    Html.push('         <li class="li-none">七、敏感信息</li>');
    Html.push('         <li>某些<u>您的</u>信息因其特殊性可能被认为是敏感个人信息，例如您的种族、宗教、个人健康和医疗信息等。相比其他信息，敏感个人信息受到更加严格的保护。<u>在征得您的同意后，我们会与关联公司之外的第三方公司、组织和个人分享您的信息。在您选择同意后我们才会共享您的敏感个人信息。</u></li>');

    Html.push('         <li class="li-none">八、适用范围</li>');
    Html.push('         <li>本隐私政策适用于由我们及其关联公司提供的所有产品及服务，但是不包括具有独立隐私权政策（未并入本《隐私政策》）的服务。</li>');
    Html.push('         <li>本《隐私政策》不适用于由非我们及我们的关联公司的其他公司或个人提供的服务，例如在搜索结果中向您显示的产品或网站、可能包含我们服务的网站或者在我们的服务中链接到的其他网站。对于为我们的服务进行广告宣传，以及可能使用Cookie、像素标签和其他技术来投放和提供相关广告的其他公司和组织，我们的隐私政策并未涵盖其信息处理惯例。</li>');

    Html.push('         <li class="li-none">九、注销账号</li>');
    Html.push('         <li> 1、您有权向云布业要求注销您的账户，经审核同意的，云布业将注销您的账户，届时，您与云布业基于本协议的合同关系即终止。</li>');
    Html.push('         <li> 2、您可以通过以下方式联系我司注销：  1）云布业网站（yunbuye.cn）联系我司客服；2） 关注微信公众号（932 云布业纺织软件）联系在线客服；3）云布业应用页内 我的 在线客服。</li>');
    Html.push('         <li> 3、您的账户被注销后，云布业没有义务为您保留或向您披露您账户中的任何电子信息，也没有义务向您或第三方转发任何您未曾阅读或发送过的信息。法律法规另有规定的除外。 </li>');

    Html.push('         <li class="li-none">十、政策变更</li>');
    Html.push('         <li>我们可能适时修订本《隐私政策》的有关条款，该等修订构成本《隐私政策》的一部分。如该等修订造成您在本《隐私政策》下权利的实质减少，我们将在修订生效前通过在主页上显著位置提示或向您发送电子邮件或以其他方式通知您。<u>在该种情况下，若您继续使用我们的服务，即表示同意接受经修订的本《隐私政策》的约束。</u></li>');

    Html.push('         <li class="li-none">十一、其他</li>');
    Html.push('         <li>本《隐私政策》的成立、生效、履行、解释及纠纷解决，适用中华人民共和国大陆地区法律（不包括香港、澳门特别行政区及台湾地区法律）。</li>');
    Html.push('         <li>如就本《隐私政策》的解释或执行发生争议，双方应首先力争通过友好协商解决该争议。如果在一方向其他方送达要求开始协商的书面通知后六十天内未能通过协商解决争议，那么任何一方均可向<u>广州市海珠区人民法院</u>提起诉讼。当任何争议发生时以及在对任何争议进行诉讼时，除争议事项外，各方应继续行使各自在本《隐私政策》项下的其他权利，履行各自在本《隐私政策》项下的其他义务。</li>');
    Html.push('         <li>如本《隐私政策》中的任何条款因任何原因被判定为完全或部分无效或不具有执行力，本《隐私政策》的其余条款仍应有效并且有执行力。</li>');
    Html.push('         <li>如本《隐私政策》中的任何条款与已发布的用户协议存在约定不一致或相互冲突的，以本《隐私政策》条款为准。</li>');
    
    Html.push('         <li class="li-none">十二、自启动和关联启动说明</li>');
    Html.push('         <li>为确保本应用处于关闭或后台运行状态下可正常接收到客户端推送的广播信息，本应用须使用(自启动)能力，将存在一定频率通过系统发送广播唤醒本应用自启动或关联启动行为，是因实现功能及服务所必要的。</li>');

    Html.push('     </ul>');
    Html.push('</div>');
    layer.open({
        type: 1,
        anim: 'up',
        style: 'position:fixed; bottom:0; left:0; width: 94%;height:70%; border:none;overflow-y: scroll; padding-left:3%;padding-right:3%;',
        className: 'agreement-layer',
        content: Html.join(''),
        success: function () {

            for (var i = 0; i < document.querySelectorAll('.agreement-layer').length; i++) {
                overscroll(document.querySelectorAll('.agreement-layer')[i]);
            }
            document.body.addEventListener('touchmove', preventDefault, { passive: false });
        },
        end: function () {
            document.body.removeEventListener('touchstart', preventDefault, { passive: false });
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
        }
    })
});

function pasteCopy() {
    var input = $('.input-css'), event;
    addLongDown(input, function (e) {
        $('.copy').show();
        var saet = $(this).offset();
        event = $(this);
        if (event.attr('id') == 'pass') $('.copy').hide();
        $('.toolBar').show().css({ 'top': (saet.top - 28) + 'px', 'left': (saet.left) + 'px' });
    });


    function addLongDown(elem, callback) {
        var time = 0; // 用于计算按下时间
        var flag = false; // 判断按下时间否是大于500毫秒

        elem.on('touchstart', function (e) { // 按下计时
            time = new Date().getTime();
        });

        elem.on('touchend', function (e) { // 抬起计算
            flag = (new Date().getTime() - time) > 500;
            // console.log($(this).offset());
            if (flag) {
                callback.call(this, e); // 按下大于500毫秒执行回调函数
            }

        });

        elem.on('click', function (e) { // 在同一个target上执行按下和抬起会触发点击事件,屏蔽掉已经绑定的点击事件
            if (flag) {
                flag = false; // 重新计算
                e.stopImmediatePropagation(); // 屏蔽this的所有点击事件
            }
        });
    }
    $('body').on('click', function () {
        $('.toolBar').hide();
        event = '';
    })

    $('.paste').on('click', function (e) {
        e.preventDefault();
        e.stopPropagation();
        clipBoard.get(function (ret, err) {
            if (ret) {
                console.log(ret);
                event.val(event.val() + ret.value)
            } else {
                console.log(err);
            }
        });
        $('.toolBar').hide();
    });
    $('.copy').on('click', function (e) {
        e.preventDefault();
        e.stopPropagation();
        var val = event.val();
        if (val == '') return;
        clipBoard.set({
            value: val,
        }, function (ret, err) {
            if (ret) {
                console.log(ret);
            } else {
                console.log(err);
            }
        })
        $('.toolBar').hide();
    })
}


// function getCompanyAppVersion() {
//     fun.ajax({
//         url: AJAX_URL.getAppUpdatePackInfo,
//         data: {

//         }
//     })
// }


//跳转到智能工具箱
var toBack = false;
var mini_timer = null;
$('#gjx').on('click',function(){
    var wx = api.require('wxPlus');
    fun.showLoad('跳转中...');
    if(!checkWxUseable(wx)) return api.hideProgress();
    wx.isInstalled(function (ret, err) {
        if (ret.installed) {
            wx.launchMiniProgram({
                // apiKey: 'wx336f555f66045248',
                miniProgramType: 'release',
                userName: 'gh_2cf3954b4d79', 
                path: 'pages/index/index', 
            }, function(ret, err) {
                api.hideProgress();
                // if (ret.status) {
                    // console.log('成功',ret);
                // } else {
                    // console.log('失败',err.code);
                // }
                if ($.nui.isTrue(err.code)) {
                    fun.toast('操作异常, 请稍后重试!');
                }
            });
        }else{
            api.hideProgress();
            fun.toast('未安装微信');
        }
    });

    clearTimeout(mini_timer);
    mini_timer = setTimeout(function(){
        if(!toBack) {
            api.hideProgress();
            fun.openFrame({
                setZero: true,
                bgColor: 'rgba(0,0,0,0.7)',
                frame_url: page_arr.wxxf_tips,
                hide_anima: true,
                pageParam: {}
            })
            // fun.openWin({
            //     page_url: page_arr.wxxf_tips,
            //     pageParam: {},
            //     hideAnimate: true,
            //     bgColor: 'rgbd(0,0,0,0.4)'
            // });
            return;
            // return fun.alert({msg:'此功能需要开启微信的悬浮窗权限！'});
        }
    }, 3500);
})
//智能计数点击事件
$('#znjs').on('click',function(){
    if($('.agree').hasClass('agrees')){
        $("#add-picture,.box").css("display", "block");
    }else{
        showAgreementPopup(function(){
            //$("#add-picture,.box").css("display", "block");
        })
    }
})
// 取消选项
$('body').on('click', '#cancel_photo', function (e) {
    $('#add-picture,.box').hide();
});
// 点击相册事件
$('body').on('click', '#selectPhoto', function (e) {
    QuestPermission.requestPermission(['photos'], null, function () {
        api.getPicture(
            {
                sourceType: 'library', // 图片源类型，从相册、图片库或相机获取图片
                encodingType: 'jpg', // 返回图片类型，jpg或png
                mediaValue: 'pic', // 媒体类型，图片或视频
                destinationType: 'base64', // 返回数据类型，指定返回图片地址或图片经过base64编码后的字符串
                quality: 80, // 图片质量，只针对jpg格式图片（0-100整数）
                targetWidth: 1080, // 压缩后的图片宽度，图片会按比例适配此宽度
                // targetHeight: 400, // 压缩后的图片高度，图片会按比例适配此高度
                saveToPhotoAlbum: false, // 拍照或录制视频后是否保存到系统相册目录。注意此处仅是文件系统层面的操作，使用诸如“图库”App仍然有可能查看到。
            },
            function (ret, err) {
                if (ret && ret.base64Data) {
                    // 跳转到智能计数
                    fun.showPageFull({
                        page_url: page_arr.smart_count,
                        pageParam: {
                            return_page: html_name,
                            base64: ret.base64Data,
                            type: 'reselect',
                        },
                    });
                } else {
                    console.log(err);
                }
            }
        );
    });
});
// 点击拍照事件
$('body').on('click', '#paizhao', function (e) {
    QuestPermission.requestPermission('camera', null, function () {
        api.getPicture(
            {
                sourceType: 'camera', // 图片源类型，从相册、图片库或相机获取图片
                encodingType: 'jpg', // 返回图片类型，jpg或png
                mediaValue: 'pic', // 媒体类型，图片或视频
                destinationType: 'base64', // 返回数据类型，指定返回图片地址或图片经过base64编码后的字符串
                quality: 70, // 图片质量，只针对jpg格式图片（0-100整数）
                targetWidth: 1080, // 压缩后的图片宽度，图片会按比例适配此宽度
                // targetHeight: 500, // 压缩后的图片高度，图片会按比例适配此高度
                saveToPhotoAlbum: false, // 拍照或录制视频后是否保存到系统相册目录。注意此处仅是文件系统层面的操作，使用诸如“图库”App仍然有可能查看到。
            },
            function (ret, err) {
                if (ret && ret.base64Data) {
                    // 跳转到智能计数
                    fun.showPageFull({
                        page_url: page_arr.smart_count,
                        pageParam: {
                            return_page: html_name,
                            base64: ret.base64Data,
                            type: 'downbeat',
                        },
                    });
                } else {
                    console.log(err);
                }
            }
        );
    });
});

// 获取用户手机号码
function getUserPhone(callback) {
    var simInfoImp = api.require('simInfoImp');
    simInfoImp.getPhoneNumber(function(ret) {
        var userPhoneNumber = fun.getMobileNumber(ret.phoneNumber);;
        console.log('用户手机号码为：' + userPhoneNumber);
        user_phone = userPhoneNumber;
    });
    if (typeof callback === 'function') callback();
}