page_init = function () {
    $('#header').header({
        back: true, //返回
        title: '在线客服',
        appendBackBtnEvt: isDataChange
    });
    page_data['keyback'] = isDataChange;
    fun.setItem('clipOpentrue', 'false');
    fun.openFrame({
        frame_url: getYzfOpenUrl(),
        hide_anima: true,
        bgColor: '#fff',
        pageParam: {},
    });
};

function isDataChange() {
    fun.setItem('clipOpentrue', 'true');
    setTimeout(function () {
        api.closeWin();
    }, 200);
}

// 匹配括号内容去除多余空格
function matchTrimSpace(str) {
    var reg = /（.+）/ig;
    var res = str.match(reg);
    if (res) { // 括号里面有内容
        return str.replace(/（(.+)）/ig, function (allMatch, match, idx, self) {
            match = (match || '').trim();
            if (!match.length) { // 内容为空字符串
                return '';
            }
            return '（' + match.trim() + '）';
        })
    } else { // 括号里面没有内容
        if (typeof str === 'string') {
            // 无括号，有内容，存在每个值之间相隔有多个空格的情况，需要格式化为一个空格
            str = str.trim().replace(/\s+/ig, ' ');
        }
        return str.replace(/（）/ig, '');
    }
};

// 获取云智服跳转链接
function getYzfOpenUrl() {
    /*
        api.systemType 操作系统
        api.connectionType 网络情况
        api.deviceModel 设备
        api.systemVersion 系统版本
    */
    var url = 'https://yzf.qq.com/xv/web/static/chat/index.html?sign=37ef9b97862303c72343cbe71be0b3317117a56fa5a9d501fbfb9da18ed6e425c91bb37b1a3808dcf158bbe846694eeb99bd2a';
    var userInfo = fun.getItem('user_info') || {}; // 用户信息
    var bookInfo = fun.getItem('book_info') || {}; // 账本信息
    var loginInfo = fun.getItem('login_info') || {}; // 登录信息

    var saleCode = loginInfo.sale_code; // 销售版本码
    var formatSaleCode = (typeof saleCode === 'object' && $.isArray(saleCode)) ? saleCode.join(',') : saleCode; // 检测后的销售版本码
    // 注 销售码版本主要给非开发人员看
    var saleTitle = loginInfo.sale_title; // 销售版本码
    var companyName = fun.is_value((fun.getItem('company_info') || {}).company_name); // 公司名称
    var contactWay = fun.is_value(userInfo.account) + '（' + fun.is_value(userInfo.name) + ' ' + fun.is_value(userInfo.telephone) + '）'; // 联系方式
    var appVersion = fun.is_value(saleTitle) + '（' + fun.is_value(loginInfo.app_count) + '）'; // 软件版本
    var book = fun.is_value(bookInfo.name) + '（' + fun.is_value(bookInfo.db_name) + '）'; // 账套
    var deviceDefailt = fun.is_value(api.systemType) + ' ' + fun.is_value(api.connectionType) + ' ' + fun.is_value(api.deviceModel) + ' ' + fun.is_value(api.systemVersion) + '版本';

    var parmams = {
        c1: companyName, // 公司名称
        c2: contactWay, // 联系方式
        c3: appVersion, // 软件版本
        c4: book, // 账套
        c5: deviceDefailt, // 使用端
    };

    for (var key in parmams) {
        parmams[key] = (matchTrimSpace(parmams[key]) || '').trim();
        url += '&' + key + '=' + parmams[key];
    }
    return url;
}