var html_name = page_arr.operation_log;
var to_month = fun.getMonthArr(1)[0], page_list = [];
var SYS_CONFIG = fun.getItem('sys_config') || {};
var search_data = {
    "begin_time": $.nui.dayjs().subtract((SYS_CONFIG['cxrqfw'] || 0), 'day').format('YYYY-MM-DD'),//fun.Date(to_month['begin_date']).Format('yy-mm-dd')
    "end_time": $.nui.dayjs().format('YYYY-MM-DD')//fun.Date(to_month['end_date']).Format('yy-mm-dd')
};

//查询菜单缓存变量
var search_storage = {
    "begin_date": $.nui.dayjs().subtract((SYS_CONFIG['cxrqfw'] || 0), 'day').format('YYYY-MM-DD'),//fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": $.nui.dayjs().format('YYYY-MM-DD')//fun.Date(to_month['end_date']).Format('yy-mm-dd')
};

$('#header').header({
    back: true,
    title: '操作日志',
    filter: true
});

page_init = function () {
    api.addEventListener({
        name: html_name,
    }, function (res) {
        console.log(res)
        var temp = res['value']['data'];
        if (!!res) {
            switch (res.value.status) {
                case "search":
                    search_data['ywy_id'] = temp['ywy']['id'] || 0;
                    search_data['md_id'] = temp['md']['id'] || 0;
                    search_data['czy_mc'] = temp['ywy']['text'] || 0;

                    search_data['begin_time'] = temp['begin_date'];
                    search_data['end_time'] = temp['end_date'];

                    search_storage['ywy'] = temp['ywy'];
                    search_storage['md'] = temp['md'];
                    search_storage['begin_date'] = search_data['begin_time'];
                    search_storage['end_date'] = search_data['end_time'];
                    fun.setItem(html_name + 'sideslip', true);
                    //设置时间控件时间
                    // date_bar.setDate(search_storage);
                    $('#line').empty();
                    getList();
                    break;
                default:

            }
        }
    });
    getList();

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list, 10) || []);
        } else {
            fun.createBottomLine('line', ".work");
        }
    });
}


//获取数据
function getList() {
    setTimeout(function () {
        fun.showLoad();
    },200);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getCzrz,
        data: $.extend({}, search_data),
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    page_list = [];
                    // return $('#line').html('<p class="empty_text cpfx_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#line',btnShow:false,style:'top:0;height:10rem;'});
                }
                page_list = res.data;
                showList(fun.PagingData(page_list, 20) || []);

                setTimeout(function () {
                    fun.hideLoad();
                },500);
                // showData(page_list || []);
            }
        }
    })
}

function showList(data) {
    var html = [];
    var colour = '';
    $.each(data, function (i, obj) {
        html.push('<li class="work"><div class="left">');
        html.push('<span class="lines lines' + i + '"></span></div>');
        html.push('<div class="rigth"><div class="right-title">');
        html.push('<span class="title">' + (obj['czy_mc'] || '') + '</span>');
        html.push('<span class="title">' + (obj['dz'] || '') + '</span>');
        html.push('<span class="title">' + (obj['djlx_mc'] || '') + '</span></div>');

        // console.log(obj['czsj'], $.nui.isEmpty(obj['dh']))
        if(!!obj['zy']){
          html.push('<span class="zy">'+(obj['zy'] || '')+'</span>');
        }

        if (!!obj['wldw_mc'] || !$.nui.isEmpty(obj['dh'])) {
            var dh_str = (!$.nui.isEmpty(obj['dh'])) ? obj['dh'] : '';
            html.push('<div class="summary"><span class="summary1" style="margin-right:' + ((!!obj['wldw_mc']) ? '6px' : '0') + '">' + (obj['wldw_mc'] || '') + '</span><span class="summary2">' + (dh_str || '') + '</span></div>');
        }
        html.push('<span class="time">' + (fun.formatTime(obj['czsj'],2) || '') + '</span></div></li>');
    });
    $("#line").append(html.join(''));

    $('.lines').each(function (i) {
        colour = order_color[i % order_color.length];
        var appendStr = "<style>.lines" + i + ":before{background:" + colour + "}</style>";
        $(this).append(appendStr);
    });
}

fun.setItem(html_name + 'sideslip', true);
//打开搜索框
$('body').on('tap', '#filter_btn', function (e) {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [
            {
                key: "ywy",
                "text": "操作人",
                "value": (search_storage['ywy'] && search_storage['ywy']['text']) || "",
                "id": (search_storage['ywy'] && search_storage['ywy']['id']) || 0,
            }, {
                key: "md",
                "text": "门店",
                "value": (search_storage['md'] && search_storage['md']['text']) || "",
                "id": (search_storage['md'] && search_storage['md']['id']) || 0,
            },
        ],
    };



    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);

        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            y: $('#header')[0].offsetHeight
            // y: 59

        });
    }
});

//判断日期是今天还是昨天
function judgeDate(date_str) {
    var ys = date_str.split(' ')[0];
    var year = date_str.substring(0, 4);
    var month = date_str.substring(5, 7);
    var day = date_str.substring(8, 10);
    var min = date_str.split(' ')[1].split(':')[0] + ':' + date_str.split(' ')[1].split(':')[1] + ':' + date_str.split(' ')[1].split(':')[2];
    //今天
    var now = new Date();
    var now_y = now.getFullYear();
    var now_m = now.getMonth() + 1;
    var now_d = now.getDate();

    //昨天
    var dd = new Date();
    dd.setDate(dd.getDate() + (-1));//获取AddDayCount天后的日期 
    var y = dd.getFullYear();
    var m = dd.getMonth() + 1;//获取当前月份的日期 
    var d = dd.getDate();

    if (parseInt(now_m) < 10) now_m = '0' + now_m;
    if (parseInt(now_d) < 10) now_d = '0' + now_d;
    if (parseInt(m) < 10) m = '0' + m;
    if (parseInt(d) < 10) d = '0' + d;

    if (year == now_y && now_m == month && day == now_d) {//如果是今天
        return min;
    } else if (year == y && month == m && day == d) {//如果是昨天
        return '昨天 ' + min;
    } else {
        return ys;
    }
}
