var html_name = page_arr['powder_addition']; //增粉分析
var interval = 0; // echarts X轴显示间隔
var axisX = []; // echarts X轴显示范围
var echartShowData = []; // echart显示数据
var pageList = []; // 分页渲染列表数据
var reset = {}; // 重置按钮传参数据
var last = { // 限制切换同一个tab造成的再次请求
    tab: 0,
    date: $('.btn_click').length - 1
}
// 搜索的数据
var search_data = {
    begin_time: fun.Date(fun.getLatelyTime(1, false)['begin_date']).Format('yy-mm-dd'),
    end_time: fun.Date(fun.getLatelyTime(1, false)['end_date']).Format('yy-mm-dd'),
    rankType: 'sk', // 排行类型
    groudType: 'date',
    cp: { // 产品搜索页面 
        id: '',
        text: ''
    }
};
// 访客合计
var total = {
    cp_zsl: 0, // 产品个数
    zsl: 0 // 产品数量
}

page_init = function () {
    // console.log(html_name);
    // console.log(page_data);

    $('#header').header({ // 头部初始化
        back: true,
        title: '增粉分析'
    });
    // 时间筛选
    $('#time_filter').time_filter({ 
        begin_time: search_data['begin_time'],//初始开始时间
        end_time: search_data['begin_time'],//初始结束时间
        type_popup: 'true',//类型弹窗
        type_popup_data: [//类型弹窗数据
            {name: '全部',type: 'qb'},
            {name: '商城',type: 'sc'},
            {name: '店铺',type: 'dp'},
        ],
        type_shops: 'true',//全店
        type_shops_data: [
            {name: '全部',img:'../img/user.png'},
            {name: '商城',img: ''},
            {name: '店铺',img: ''},
            {name: '店铺',img: ''},
            {name: '大帆船',img: ''},
            {name: '都是',img: ''},
            {name: '想打',img: ''},
            {name: '大',img: ''},
            {name: '店铺',img: ''},
            {name: '店铺',img: ''},
            {name: '初中生自行车',img: ''},
            {name: '店铺',img: ''},
            {name: '想挨打',img: ''},
            {name: '店铺',img: ''},
            {name: '小册子吃',img: ''},
            {name: '店铺',img: ''},
            {name: 'vc',img: ''},
            {name: '店铺',img: ''},
            {name: '想法',img: ''},
            {name: '大多数',img: ''},
            {name: '店铺',img: ''},
            {name: '打撒',img: ''},
            {name: '',img: ''},
            {name: '店铺',img: ''},
            {name: '的出租车',img: ''},
            {name: '店铺',img: ''},
        ],  
        dateText: function (ret) { //返回事件
            //日期条件
            if($.nui.isTrue(ret['begin_time']) && $.nui.isTrue(ret['end_time'])){
                search_data['begin_time'] = fun.Date(ret['begin_time']).Format('yy-mm-dd');
                search_data['end_time'] = fun.Date(ret['end_time']).Format('yy-mm-dd');
            }
            //类型弹窗
            if($.nui.isTrue(ret['collapse'])){
                // search_data['begin_time'] = ret['collapse'];
            }
            $('#order_list').empty();
            fun.statisticDate(search_data);
            getList();
        }
    });

        
    // 该页面筛选按钮是否可以打开
    fun.setItem(html_name + 'sideslip', true);

    // 事件监听
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
        }
    });
    optionChar();//渲染图表
    init(); // 页面初始化
    bindEvent(); // 事件初始化
    fun.scrollToBottom({}, function () { // 滚动底部分页渲染
        if ($('#origin_list').children('.empty-tips-wrap').length) return;
        if ($.nui.isTrue(pageList)) {
            fun.showLoad();
            showOriData(fun.PagingData(pageList, 10) || []);
            setTimeout(function () {
                fun.hideLoad();
            }, 200);
        } else {
            if ($.nui.isTrue($('.empty_bottom').length)) return;
            var rangeList = parseFloat($('.content').css('marginTop')) + ($('.content').outerHeight() - $('#origin_list').outerHeight());
            var listHeight = $(window).height() - rangeList;
            if ($('#origin_list').outerHeight() >= listHeight) {
                fun.createBottomLine('origin_list', '.origin-list');
                $('.empty_bottom').show();
                return;
            }
        }
    });
    
}

// 获取数据列表
function getList() {
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getVisitorFxList, // 获取访客分析
        data: {
            start_date: search_data['begin_time'],
            end_date: search_data['end_time'],
            groud: {
                create_time: search_data['groudType'], // 按什么方式给数据
            },
            member_id: search_data['cp']['id'] || '',
        },
        success: function (res) {
            console.log('拿样记录数据');
            console.log(res);
            if (res['status'] === 0) { // 请求成功
                var list = res['list'];
                pageList = [];
                pageList = res['info_list'];
                switch (search_data['rankType']) {
                    case 'sk': // 色卡
                        $(list).each(function (idx, item) {
                            echartShowData[idx] = item['sl'];
                        })
                        break;
                    case 'jy': // 剪样
                        $(list).each(function (idx, item) {
                            echartShowData[idx] = item['sl'];
                        })
                        break;
                    // 没有default:
                }
                showHeaderTotal(res); // 头部合计显示
                // resetData(pageList); // 默认降序显示数据
                showData(fun.PagingData(pageList || [])); // 渲染数据
            }
        }
    })
}

// 页面初始化
function init() {
    // search_data['begin_time'] = fun.getLatelyTime(30, true)['begin_date'];
    // search_data['end_time'] = fun.getLatelyTime(30, true)['end_date'];
    // $('#begin_date').text(fun.getLatelyTime(30, false)['begin_date']); // 起始时间
    // $('#end_date').text(fun.getLatelyTime(30, false)['end_date']); // 结束时间
    // search_data['begin_time'] = fun.getLatelyTime(30, true)['begin_date'];
    // search_data['end_time'] = fun.getLatelyTime(30, true)['end_date'];
    // reset = { // 重置日期
    //     begin_date: fun.getLatelyTime(30, true)['begin_date'],
    //     end_date: fun.getLatelyTime(30, true)['end_date']
    // }
    getList(); // 初始化渲染数据
}

// 获取产品搜索数据
function getTwo(key, son, def) {
    def = def || "";
    return (search_data[key] && search_data[key][son]) || def;
}

// 头部合计
function showHeaderTotal(data) {
    if ($.nui.isTrue(data['hj'])) {
        // 合计显示
        total['cp_zsl'] = data['hj']['cp_zsl'];
        total['zsl'] = data['hj']['zsl'];
    } else {
        total['cp_zsl'] = 0;
        total['zsl'] = 0;
    }

    // 渲染数据
    $('#product_count').text(total['cp_zsl']); // 产品总数量
    $('#count').text(total['zsl']); // 总数量
}

// 显示页面数据
function showData(data) {
    $('#origin_list').html('');
    echartsDataInit(echartShowData); // 初始化echart图数据
    fun.statisticTime(search_data);
    // fun.showGraphic(); // 渲染echarts图
    showOriData(data); // 渲染数据来源
    $('.now-time-list:first').show();
}

// 初始化echart图数据
function echartsDataInit(data) {
    var mark = data.every(function (item, idx) {
        return item === 0;
    })

    if (mark) {
        for (var i = 0; i < data.length; i++) {
            data[i] = '';
        }
    }
}

// 重置数据
// function resetData(data) {
//     data.sort(function (a, b) {
//         return fun.fun.getTimeArrStamp(b['sj']) - fun.fun.getTimeArrStamp(a['sj']);
//     })
//     for (var i = 0; i < data.length; i++) {
//         var item = data[i];
//         if ($.nui.isTrue(item['mx'])) {
//             item['mx'].sort(function (x, y) {
//                 return y['zsl'] - x['zsl'];
//             })
//         } else {
//             continue;
//         }
//     }
// }

// 渲染数据来源
function showOriData(data) {
    if ($.nui.isTrue(data)) {
        var html = [];
        $(data).each(function (idx, item) {
            if (!item['cp_count'] && !item['sl_count']) return true; // 产品和数量都为0，不显示该记录行
            var arrowDirectionClass = 'icon-xia';
            var mark = true;
            if (idx === 0) { // 首条列表项展开，箭头为上，其它初始默认合拢状态，箭头为下
                arrowDirectionClass = 'arrow-down icon-xia';
            } else {
                mark = false;
            }
            html.push('<div class="origin-item over-hide">');
            html.push('     <p class="data_hang font-ss color-gray rank-title analyze-line-height" data-mark="' + mark + '">');
            switch (search_data['groudType']) {
                case 'date': // 按天汇总
                    html.push('         <span>' + fun.dateFormat('yyyy-MM-dd', item['sj']) + '</span>');
                    break;
                case 'month': // 按月汇总
                    html.push('         <span>' + fun.dateFormat('yyyy-MM', item['sj']) + '</span>');
                    break;
                // 没有default
            }
            switch (search_data['rankType']) {
                case 'sk': // 色卡
                    html.push('        <span class="newgong">共 ：' + (item['cp_count'] || 0) + '人，' + (item['sl_count'] || 0) + '次</span>');
                    break;
                case 'jy': // 剪样
                    html.push('        <span class="newgong">共 ：' + (item['cp_count'] || 0) + '人' + (item['sl_count'] || 0) + '次</span>');
                    break;
                // 没有default
            }
            html.push('         <i class="iconfont arrow-mark float-right ' + arrowDirectionClass + '"></i>');
            html.push('     </p>');
            html.push('     <div class="now-time-list">');
            if ($.nui.isTrue(item['visitor_list'])) {
                $(item['visitor_list']).each(function (index, items) {
                    var rowsTime;
                    var name = items['nickname']; // 显示微信昵称

                    switch (search_data['groudType']) {
                        case 'date': // 按天汇总
                            rowsTime = fun.formatDate(fun.Date(items['create_time'], true), 'HH:mm');
                            break;
                        case 'month': // 按月汇总
                            rowsTime = fun.getRowTime(fun.formatDate(fun.Date(items['create_time'], true), 'MM月DD号'));
                            break;
                    }

                    if ($.nui.isTrue(items['kh_lxr'])) {
                        if ($.nui.isTrue(items['kh_mc'])) {
                            name = items['kh_mc'] + ' @ ' + items['kh_lxr'];
                        } else if ($.nui.isEmpty(items['kh_lxr'])) {
                            name = items['kh_mc'];
                        }
                    }
                    html.push('        <div class="main clear-space">');
                    if ($.nui.isTrue(items['avatar_url'])) {
                        var imgUrl = '';
                        if (/http/.test(items['avatar_url'])) { // 完整路径
                            imgUrl = items['avatar_url'];
                        } else {
                            imgUrl = IMG_PATH + 'shop/' + items['avatar_url'];
                        }
                        html.push('            <img class="circle over-hide vertical-middle" src="' + imgUrl + '">');
                    } else {
                        html.push('            <img class="circle over-hide vertical-middle transparent" src="">');
                    }
                    html.push('             <div class="right-container clear-space">')
                    html.push('                 <span class="wechat font-ls text-overflow vertical-middle analyze-line-height">' + fun.is_value(name) + '</span>');
                    html.push('                 <span class="text-overflow font-ms vertical-middle analyze-line-height total-count yby-right">' + (items['count'] || 0) + '次</span>');
                    html.push('                 <span class="font-ms color-gray text-overflow vertical-middle analyze-line-height data-time yby-right">' + rowsTime + '</span>');
                    html.push('             </div>');
                    html.push('        </div>');
                })
            }
            html.push('    </div>');
            html.push('</div>');
        })
        $('#origin_list').append(html.join(''));
    }
    if (!$('#origin_list').children().length) { // 列表数据为空
        $('#origin_list').addClass('empty-wrap');
        fun.createDataEmptyTips({ dom: '#origin_list', btnShow: false });
    }
}

//渲染图表
function optionChar() {
    var myChart = echarts.init($('#container')[0]); // echart折线图
    option = {
        tooltip: {
            trigger: 'axis',
            axisPointer: {
                lineStyle: {
                    type: 'dashed',
                    color: '#ccc'
                }
            },
            position: function (pos, params, dom, rect, size) {
                return [pos[0], 0];
            },
            // trigger: 'none',
            // axisPointer: {
            //     type: 'cross',
            //     color: '#ccc'
            // },
            formatter: "{b}"
        },
        grid: {
            left: '6%',
            right: '6%',
            top: '3%',
            bottom: '10%',
            containLabel: true
        },
        xAxis: [{
            type: 'category', //数据类型为不连续数据
            boundaryGap: false, //坐标轴两边是否留白
            axisTick: {
                show: false
            },
            splitLine: {
                show: false
            },
            axisLine: {
                show: false
                // lineStyle: {
                //     color: "#aaa"
                // }
            },
            data: ['0', '5', '10', '15', '20', '25', '30', '35', '40', '45', '50', '55']
        }],
        yAxis: [{
            type: 'value',
            axisTick: {
                show: false
            },
            axisLabel: {
                show: false
            },
            axisLine: {
                show: false
                // lineStyle: {
                //     color: "#aaa"
                // }
            },
            splitLine: {
                show: false,
                // lineStyle: {
                //     type: 'dashed',
                //     color: '#aaa'
                // }
            }
        }],
        series: [{
            name: '昨天',
            type: 'line',
            smooth: true,
            symbol: 'circle',
            symbolSize: 5,
            showSymbol: false,
            lineStyle: {
                normal: {
                    width: 1
                }
            },
            areaStyle: {
                normal: {
                    color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                        offset: 0,
                        color: 'rgba(137, 189, 27, 0.3)'
                    }, {
                        offset: 0.8,
                        color: 'rgba(137, 189, 27, 0)'
                    }], false),
                    shadowColor: 'rgba(0, 0, 0, 0.1)',
                    shadowBlur: 10
                }
            },
            itemStyle: {
                normal: {
                    color: 'rgb(137,189,27)',
                    borderColor: 'rgba(137,189,2,0.27)',
                    borderWidth: 12

                }
            },
            data: [220, 182, 191, 134, 150, 120, 110, 125, 145, 122, 165, 122]
        }, {
            name: '今天',
            type: 'line',
            smooth: true,
            symbol: 'circle',
            symbolSize: 5,
            showSymbol: false,
            lineStyle: {
                normal: {
                    width: 1
                }
            },
            areaStyle: {
                normal: {
                    color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [{
                        offset: 0,
                        color: 'rgba(0, 136, 212, 0.3)'
                    }, {
                        offset: 0.8,
                        color: 'rgba(0, 136, 212, 0)'
                    }], false),
                    shadowColor: 'rgba(0, 0, 0, 0.1)',
                    shadowBlur: 10
                }
            },
            itemStyle: {
                normal: {
                    color: 'rgb(0,136,212)',
                    borderColor: 'rgba(0,136,212,0.2)',
                    borderWidth: 12

                }
            },
            data: [120, 110, 125, 145, 122, 165, 122, 220, 182, 191, 134, 150]
        },]
    };
    if (option && typeof option === "object") {
        myChart.setOption(option, true);
        myChart.getZr().on('click', function (params) {
            var pointInPixel = [params.offsetX, params.offsetY];
            if (myChart.containPixel('grid', pointInPixel)) {
                /*此处添加具体执行代码*/
                var pointInGrid = myChart.convertFromPixel({ seriesIndex: 0 }, pointInPixel);
                //X轴序号
                var xIndex = pointInGrid[0];
                //获取当前图表的option
                var op = myChart.getOption();
                //获得图表的数据
                var value = op.series[0].data[xIndex];
                var value2 = op.series[1].data[xIndex];
                $('#zcp').text(value || 0);
                $('#zrs').text(value2 || 0);
            }
        });
        myChart.getZr().on('mousemove', function (params) {
            var pointInPixel = [params.offsetX, params.offsetY];
            if (myChart.containPixel('grid', pointInPixel)) {
                /*此处添加具体执行代码*/
                var pointInGrid = myChart.convertFromPixel({ seriesIndex: 0 }, pointInPixel);
                //X轴序号
                var xIndex = pointInGrid[0];
                //获取当前图表的option
                var op = myChart.getOption();
                //获得图表的数据
                var value = op.series[0].data[xIndex];
                var value2 = op.series[1].data[xIndex];
                $('#zcp').text(value);
                $('#zrs').text(value2);
            }
        });
        // myChart.dispatchAction({
        //     type: 'highlight',
        //     // 可选，系列 index，可以是一个数组指定多个系列
        //     // seriesIndex: ['0', '5', '10', '15', '20', '25', '30', '35', '40', '45', '50', '55'],
        //     // 可选，系列名称，可以是一个数组指定多个系列
        //     // seriesName: ['移动','电信','联通'],
        //     // 可选，数据的 index
        //     dataIndex: 11,
        //     // 可选，数据的 名称
        //     // name: '55'
        // });
    }
}
// 初始化事件
function bindEvent() {
    // 跳转到增粉分析排行页面 
    $('body').on('tap', '.data_origin', function () {
        // if ($.nui.isTrue(search_data['cp']['text'])) return;
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr.powder_grading,
            pageParam: {
                // begin_time: search_data['begin_time'],
                // end_time: search_data['end_time'],
                // total: total,
                // type: 'nyjlph', // 拿样分析排行
                // rankType: search_data['rankType']
            }
        });
        fun.hideLoad();
    })
}

// 收缩功能
$('body').on('tap', '.rank-title', function () {
    if ($.nui.isEmpty($(this).siblings().children().length)) return;
    $(this).siblings().stop().slideToggle(500);
    var $arrow = $(this).find('.icon-xia');
    var mark = $(this).data('mark');
    if (mark) { // 当前展开效果
        console.log(mark);
        $arrow.removeClass('rotate-arrow-up');
        $arrow.addClass('rotate-arrow-down');
    } else { // 当前收起效果
        $arrow.addClass('rotate-arrow-up');
    }
    $(this).data('mark', !mark);
})
// console.log($('#origin_list').html());
