var html_name = page_arr.product,
    list_data = {},
    page_list = [],
    photoBrowser = {},
    search_data = {
        "keyword": "",
        "keyword_key": ['number', 'name', 'simple'],
        'craft': 0,
        'quarter': 0,
        // "is_stop": 0,
        "class_id": 0,
        "order": {},
        "is_stop": 0
        // "label_id":[]
    };

var last_lb_id = 0;
var last_dw_id = 0, last_dw_mc = '';
var cp_lb_list = [];
var search_storage = {};
var prices_arr = [];
var stop = false;
var printDataList = [];//产品打印数据

var Bills = { djlx: 'cp' };
Bills['print_config'] = { 'djlx': 'cp' };

var print_columns = [
    { name: 'class_name', display: '类别', width: 100, mergeCell: true },
    { name: 'type', display: '类型', width: 78, mergeCell: true },
    { name: 'imgs', display: '图', width: 60 },
    { name: 'tm', display: '条码', width: 100, visible: false },
    { name: 'number', display: '编号', width: 100 },
    { name: 'name', display: '名称', width: 160 },
    { name: 'unit_name', display: '单位', width: 90 },
    { name: 'width', display: '幅宽', type: 'float', width: 80 },
    { name: 'weight', display: '克重', type: 'float', width: 80 },
    { name: 'component', display: '成分', width: 150 },
    { name: 'craft', display: '工艺', width: 80 },
    { name: 'quarter', display: '季度', width: 80 },
    { name: 'gauze', display: '纱支', width: 80 },
    { name: 'density', display: '密度', width: 80 },
    { name: 'label_id', display: '标签', width: 150, mergeCell: ['merchant_name'], },
    { name: 'is_sj', display: '上架', width: 80, type: 'checkbox' },
    { name: 'sj_sj', display: '上架时间', width: 150, },
    { name: 'gys', display: '供应商', width: 80 },
    { name: 'diff', display: '模式', width: 80, visible: false, },
    { name: 'remark', display: '备注', width: 160, align: 'left' },
    { name: 'date', display: '日期', width: 150, },
    { name: 'is_stop', type: 'switch', display: '停用', width: 60, editor: { disabled: true } },
];


$('#header').header({
    back: true,
    add: Auth.check('cp', 'edit'),
    filter: true,
    title: '产品资料',
    foot_input: {
        show: true,
        scan_icon: true,
        plader: '产品编号、产品名称'
    },
});

page_init = function () {

    //ios头部穿透
    // fun.pierceThrough('.center-list');
    // fun.setHeaderLocation('.content');
    $('.ios_fixed').css('height', ($(window).height() - (api.safeArea.top + api.safeArea.bottom) + 'px'));
    fun.load_DATA_LIST(['cp_lb']);
    search_storage = $.extend(true, {
        'is_stop': fun.getItem(html_name + '_' + 'is_stop', 0),
    }, search_storage);

    search_data = $.extend({}, search_data, search_storage);
    getList(search_data);

    photoBrowser = api.require('photoBrowser');

    api.addEventListener({
        name: html_name,
    }, function (res) {
        // console.log(res);
        $("foot_input").select();
        //is_edit是否有修改权限
        var temp = res['value']['data'];
        if (!!res) {
            switch (res.value.status) {
                case "search":
                    if (!!res.value.data.view) {
                        fun.setItem('cp_view', 1);
                    } else {
                        fun.setItem('cp_view', 0);
                    }
                    search_data['class_id'] = temp['cp_lb']['id'];
                    search_data['quarter'] = temp['cp_jd']['id'];
                    search_data['craft'] = temp['cp_gy']['id'];
                    search_data['class_name'] = temp['cp_lb']['text'];
                    search_data['jd_name'] = temp['cp_jd']['text'];
                    search_data['gy_name'] = temp['cp_gy']['text'];
                    search_data['order']['rq'] = temp['RQ_SORT'];
                    search_data['is_stop'] = temp['is_stop'];

                    var label_arr, lar;
                    label_arr = temp['bq']['value'];
                    if (label_arr != '0') {
                        var lar = label_arr.split(',') || [];
                        var tmp = new Array();
                        for (var i = 0; i < lar.length; i++) {
                            tmp[i] = Number(lar[i]);
                        }
                        lar = tmp;
                    } else {
                        lar = label_arr;
                    }
                    search_data['label_id'] = lar;
                    search_data['label_string'] = label_arr;



                    //搜索菜单需要缓存的数据
                    search_storage['is_stop'] = temp['is_stop'];
                    fun.setItem(html_name + '_' + 'is_stop', search_storage['is_stop']);
                    fun.setItem(html_name + 'sideslip', true);
                    getList();
                    break;
                case "refresh":
                    getList();
                    break;
                case "empty":
                    prices_arr = [];
                    break;
                default:
            }
        }
    });

    // 解决由于ios造成的滚动事件失效，模拟滚动到底部
    fun.iosScrollToBottom()({
        up: {
            ele: '#goods_list', // 需要传递的选择器，用于获取滚动高度
            viewListHeight: function () { // 视口列表高度
                return $(window).height() - fun.getCssVal('.content', 'top')
            },
            getListHeight: getListHeight, // 容器真实高度，分页叠加的过程，高度逐渐增加
            callback: function () {
                if (page_list.length > 0) {
                    showData(fun.PagingData(page_list, 5) || []);
                } else {
                    if ($.nui.isTrue($('.empty_bottom').length)) return;
                    var minus = $(window).height() - fun.getCssVal('.content', 'top')
                    if (getListHeight() >= minus) {
                        fun.createBottomLine('goods_list', ".content");
                        $('.empty_bottom').show();
                    }
                }
            }
        },
    })

    if (Auth.check('cp', 'edit') || Auth.check('cpbj', 'view')) {
        $('#goods_list').addClass('swipe-delete');
    } else {
        $('#goods_list').removeClass('swipe-delete');
    }

    fun.orderListHeight({ dom: '#goods_list' });

    // if(!Auth.check('cpbj','view')){
    //     $('#goods_list').removeClass('swipe-delete');
    // }
}

// 计算滑动容器列表高度。由于父级都是定位
function getListHeight() {
    var height = 0;
    if ($.nui.isTrue($('#goods_list li').length)) {
        $('#goods_list li').each(function (idx, item) {
            height += $(this).outerHeight();
        })
    }
    return height;
}

//搜索条码
$('body').on('keypress', '#foot_input', function (e) {
    var value = $('#foot_input').val().trim();
    if (e.keyCode === 13 && !!code) {
        $(this).select();
        page_data['page_num'] = 1;
        getList();
    }
});

// $('#delete').on('click', function() {
//     $(this).butn({
//         tips: 'ttttt',
//         noSave: true,
//     });
//     $('#cancel').on('tap', function() {
//         layer.closeAll();
//     });
// });


function getList() {
    list_data = {};
    page_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getGoodsList,
        data: $.extend({}, {
            "keyword": "",
            "is_stop": 0
        }, search_data),
        success: function (res) {
            if (res['status'] == 0) {
                //获取数据时清空列表
                // $("#goods_list").html('');
                $("#goods_list").empty();
                $('.empty_bottom').show();
                if (!res['data'] || res['data'].length == 0) {
                    page_list = [];
                    // return $('#goods_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: '#goods_list', btnText: '新增产品', auth: 'cp', style: 'top:1.5rem;', isDa: true });
                }
                page_list = res.data;
                printDataList = res.data.slice(0);

                var tmp_rows = (res.data || []).slice(0).sort(function (a, b) {
                    return new Date(fun.compateIEDate(a['date'])).getTime() - new Date(fun.compateIEDate(b['date'])).getTime();
                });

                last_dw_id = tmp_rows[tmp_rows.length - 1]['unit_id'];
                last_dw_mc = tmp_rows[tmp_rows.length - 1]['unit_name'];
                last_lb_id = tmp_rows[tmp_rows.length - 1]['class_id'] || 0;

                showData(fun.PagingData(page_list) || []);
            } else {
                fun.alert({ msg: '网络异常！' })
            }
        }
    })
    fun.load_DATA_LIST(['cp'], function () {
        //  fun.readFile({
        //     path:'fs://DATA_LIST/cp_list.txt',
        //     callback: function(list){
        //         console.log('------>');
        //         console.log(list);
        //     }
        // });
    });
}

//显示数据
function showData(data) {
    var listHtml = [];

    if (!fun.getItem('cp_view')) {
        for (var i = 0; i < data.length; i++) {

            var goods_text = ((data[i]['number'] || "") + " " + (data[i]['name'] || "")),
                goods_id = data[i]['id'],
                img_url = (data[i]['imgs']) ? fun.getImgPath(data[i]['imgs']) : "../img/logo.png",
                large_url = (data[i]['imgs']) ? fun.getImgPath(data[i]['imgs'], true) : "../img/logo.png";
            // var goods_dw = data[i]['unit_id'] || 0;
            // var goods_dwmc = data[i]['unit_name'];
            // if(data[i]['unit_options']['xsdw_id']) {
            //     goods_dw = data[i]['unit_options']['xsdw_id'];
            //     goods_dwmc = data[i]['xsdw_name'];
            // }

            list_data[goods_id] = data[i];
            listHtml.push('<li class="center-list lower-border-line pro-add" goods_id="' + goods_id + '" data-list=\'' + fun.formatString(JSON.stringify(data[i])) + '\'>');
            listHtml.push('    <div class="le">');
            if (img_url === "../img/logo.png") {
                listHtml.push('   <div class="picture mr-bj">');
                listHtml.push('       <img src="' + img_url + '" class="product cp-img imgs">');
            } else {
                listHtml.push('   <div class="picture">');//onerror=null;this.src=' + "'../img/logo.png'" + '
                listHtml.push('       <img src="' + img_url + '" onerror="imgError1(this);" large-url="' + large_url + '" class="product large imgs">');
                listHtml.push('       <img src="../img/mask.png" class="mask">');
            }
            // if (data['imgs']) {
            // listHtml.push('       <img src="../img/mask.png" class="mask">');
            // }
            // listHtml.push('<img src="../img/' + (data[i]['imgs'] || 'cp.png') + '" class="product">');
            // listHtml.push('<img src="../img/mask.png" class="mask">');
            listHtml.push('       </div>');
            listHtml.push('       <div class="center-text">');
            listHtml.push('           <div class="text">' + (fun.redFont(goods_text, search_data['keyword']) || "") + '</div>');
            listHtml.push('           <div class="">');
            listHtml.push('               <span class="left">' + (data[i]['class_name'] || '') + '</span>');
            listHtml.push('               <span class="right">' + (data[i]['quarter'] || '') + '</span>');
            listHtml.push('           </div>');
            listHtml.push('           <div>');
            listHtml.push('               <span class="left dates">' + (data[i]['date'].substr(0, find(data[i]['date'], ' ', 0)) || '') + '</span>');
            listHtml.push('               <span class="right">' + (data[i]['craft'] || '') + '</span>');
            listHtml.push('           </div>');
            listHtml.push('       </div>');
            if (SHOW_IS_DOING) {
                listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 shares share-btn">分享</div>');
                listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 stamp stamp-btn">打印</div>');
                listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 prices prices-btn">批量</div>');
                listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 more more-btn">更多</div>');
            } else {
                listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" style="right: -20%;" class="slids dels1 prices price-btn offer">报价</div>');
                !AuthVersionCheck.checkHide('cpdy') && listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" style="right: -40%;" class="slids dels1 stamp price-btn stamp-btn">打印</div>');
            }

            listHtml.push('    </div>');
            listHtml.push('</li>');
        }
    } else {
        for (var i = 0; i < data.length; i++) {
            var goods_text = ((data[i]['number'] || '') + ' ' + (data[i]['name'] || ''));
            var goods_id = data[i]['id'];
            var img_url = (data[i]['imgs']) ? fun.getImgPath(data[i]['imgs']) : "../img/logo.png",
                large_url = (data[i]['imgs']) ? fun.getImgPath(data[i]['imgs'], true) : "../img/logo.png";
            listHtml.push('<li class="content-list pro-add" goods_id="' + goods_id + '"  data-list=\'' + fun.formatString(JSON.stringify(data[i])) + '\'>');

            // listHtml.push('        <img src="'+img_url+'" class="product2 cp-img">');
            if (img_url === "../img/logo.png") {
                listHtml.push('  <div class="picture2 mr-bj">');
                listHtml.push('    <img src="' + img_url + '" class="product2 cp-img">');
            } else {
                listHtml.push('  <div class="picture2">');
                listHtml.push('        <img src="' + img_url + '"large-url="' + large_url + '"  class="product2">');
                listHtml.push('    <img src="../img/mask.png" class="mask2">');
            }
            // listHtml.push('<img src="../img/' + (data[i]['imgs'] || 'cp.png') + '" class="product2">');
            // listHtml.push('<img src="../img/mask.png" class="mask2">');
            listHtml.push('    </div>');
            listHtml.push('    <div class="center-text2">');
            listHtml.push('         <div class="text2">' + goods_text + '</div>');
            listHtml.push('         <div class="bot">');
            listHtml.push('             <span class="left2">' + (data[i]['class_name'] || '') + '</span>');
            listHtml.push('             <span class="right2">' + (data[i]['quarter'] || '') + '</span>');
            listHtml.push('         </div>');
            listHtml.push('         <div class="bot">');
            listHtml.push('             <span class="left2 dates">' + (data[i]['date'].substr(0, find(data[i]['date'], ' ', 0)) || '') + '</span>');
            listHtml.push('             <span class="right2">' + (data[i]['craft'] || '') + '</span>');
            listHtml.push('         </div>');
            listHtml.push('    </div>');
            listHtml.push('</li>');
        }
    }
    $("#goods_list").append(listHtml.join(''));
}

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "choose_merchants": [{
            key: "cp_lb",
            "text": "类别",
            "id": (search_data['class_id'] || 0),
            "value": (search_data['class_name'] || "")
        }, {
            key: "cp_jd",
            "text": "季度",
            "id": (search_data['quarter'] || 0),
            "value": (search_data['jd_name'] || "")
        }, {
            key: "cp_gy",
            "text": "工艺",
            "id": (search_data['craft'] || 0),
            "value": (search_data['gy_name'] || "")
        }, {
            key: 'bq',
            type: 'cp',
            value_arr: search_data['label_string'] || '0',
        }],
        "sort": [{
            "text": "日期",
            "key": "RQ_SORT",
            "value": (search_data['order']['rq'] || '')
        },],
        "switch": [{
            "text": "视图模式",
            "max_width": true,
            "key": "view",
            "value": fun.getItem('cp_view')
        }, {
            "text": "显示停用",
            "max_width": true,
            "key": "is_stop",
            // "value": (search_data['is_stop'] || 0)
            "value": search_storage['is_stop']
        }],
    }
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
})

//添加产品
$('body').delay('tap','#add_btn', function (e) {

    // if (grid.rows.length) {
    //     var _tmp_rows = grid.rows.slice(0).sort(function (a, b) {
    //         return new Date(Fun.compateIEDate(a['date'])).getTime() - new Date(Fun.compateIEDate(b['date'])).getTime();
    //     });
    //     last_unit = _tmp_rows[_tmp_rows.length - 1]['unit_id'];
    // }
    var search_val = $('#foot_search').val().trim();
    if (search_val == '') {
        openPage(search_val)
    } else {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.getInfoByKeyword,
            data: {
                "type": 'cp',
                "keyword": search_val
            },
            success: function (res) {
                switch (res['status']) {
                    case 0:
                        openPage(search_val);
                        break;
                    case 104:
                        layer.closeAll();
                        fun.dialog({
                            content: '【' + search_val + '】已存在，是否继续添加？',
                            btn: ['确定', '取消'],
                            shadeClose: false,
                            className: 'data-change-skin',
                            yes: function () {
                                openPage('');
                            },
                            no: function () {
                                search_data['keyword'] = search_val;
                                $("#goods_list").empty();
                                getList();
                            }
                        });
                        break;
                    default:
                        fun.toast(res['msg']);
                        break;
                }
            }
        })
    }
});

function openPage(jvals) {
    fun.showPageFull({
        "page_url": page_arr.product_add,
        "pageParam": {
            "return_page": html_name,
            "last_lb_id": last_lb_id,
            'last_dw_id': last_dw_id,
            'last_dw_mc': last_dw_mc,
            'cp_bh': jvals,
        }
    });
}

// 跳转 产品报价
$('body').on('tap', '.offer', function (e) {
    e.stopPropagation();
    var list = $(this).closest('li').data('list');
    fun.showPageFull({
        "page_url": page_arr.product_quoted,
        "pageParam": {
            "goods_info": list,
            "goods_text": $(this).attr('goods_text'),
            "goods_id": list['id']
        }
    });
    return false;
});

// 跳转 产品详情页
$('body').on('tap', '.pro-add', function (e) {
    e.stopPropagation();
    var list = $(this).closest('li').data('list');
    fun.showPageFull({
        "page_url": page_arr.product_add,
        "pageParam": {
            "goods_info": list,
            "goods_id": list['id'],
            "return_page": html_name
        }
    });
});


//列表模式 点击预览图片
$('body').on('tap', '.large,.mask', function (e) {
    e.preventDefault();
    var img_arr = [];
    $('.large').each(function (i, obj) {
        img_arr.push($(this).attr('large-url'));
        $(obj).attr('index', i);
    })

    if (img_arr.length == 0) return;
    var index = $(this).prev().attr('index');
    photoBrowser.open({
        images: img_arr,
        activeIndex: index || 0,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        } else {
            console.log(JSON.stringify(err));
        }
    });
    return false;
})

// function searchData(status, stype) {
//     api.addEventListener({
//         name: html_name
//     }, function(res) {
//
//     });
// }

//点击键盘搜索
$("#foot_search").bind('search', function () {
    search_data['keyword'] = $(this).val().trim();
    $("#goods_list").empty();
    getList();
});
//切换视图


//获得指定字符出现几次的位置
function find(str, cha, num) {
    var x = str.indexOf(cha);
    for (var i = 0; i < num; i++) {
        x = str.indexOf(cha, x + 1);
    }
    return x;
}

$('body').on('tap', ".icon-saoma", function () {
    QuestPermission.requestPermission('camera', null,function () {
        openScanner({
            callback: function (value) {
                $("#foot_search").val(value);
                if (!!$("#foot_search").val()) {
                    search_data['keyword'] = $('#foot_search').val().trim();
                    $('#product_list').empty();
                    getList();
                    return true;
                } else {
                    fun.toast('扫码失败！');
                    return true;
                }
            }
        });
    });
});


//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });

}


function imgError1(_this) {
    _this.src = '../img/logo.png';
    _this.parentNode.classList.add('mr-bj');
    _this.classList.remove('large');
    _this.classList.add('cp-img');
    var nextEle = _this.nextElementSibling;
    _this.parentNode.removeChild(nextEle);
    _this.onerror = null;
}

//分享
$('body').on('tap', '.share-btn', function (e) {
    e.stopPropagation();
    var list = $(this).closest('li').data('list');
    if ($.nui.isTrue(list['imgs'])) {
        fun.showPageFull({
            "page_url": page_arr.share_newpictures,
            "pageParam": {
                data: list
            }
        });
    } else {
        fun.toast('该产品没有上传图片，无法分享！');
    }
})

//打印
$('body').on('tap', '.stamp-btn', function (e) {
    e.stopPropagation();
    search_data['cp_id'] = $(this).attr('goods_id');
    layer.closeAll();
    Print.printLoad({ printType: 'cp' });

    // fun.cpBqPrintCloudDialog();
});

//打印
// $('body').on('tap', '.stamp-btn', function (e) {
//     e.stopPropagation();
//     console.log('打印');
//     search_data['cp_id'] = $(this).attr('goods_id');
//     // fun.cpBqPrintDialog();
//
//     fun.cpBqPrintCloudDialog();
//
//     // var $this = $(this);
//     // fun.printPop();
//     // var stampHtml = [];
//     // stampHtml.push('<div class="product-subject">');
//     // stampHtml.push('    <p>打印</p>');
//     // stampHtml.push('    <div>');
//     // stampHtml.push('        <div class="product-btn">');
//     // stampHtml.push('            <button id="layout1">格式1</button>');
//     // stampHtml.push('            <button id="layout2">格式2</button>');
//     // stampHtml.push('        </div>');
//     // stampHtml.push('        <div class="product-fs">');
//     // stampHtml.push('            <span>份数：</span>');
//     // stampHtml.push('            <input value="1" id="fs">');
//     // stampHtml.push('        </div>');
//     // stampHtml.push('        <div class="product-gn">');
//     // stampHtml.push('            <span class="qx" id="qx">取消</span>');
//     // stampHtml.push('            <span class="dy" id="dy">打印</span>');
//     // stampHtml.push('        </div>');
//     // stampHtml.push('    <div>');
//     // stampHtml.push('</div>');
//     // var option = {
//     //     content: stampHtml.join(''),
//     //     className: 'product-list',
//     //     btn: false,
//     // }
//     // option.success = function () {
//     //     //格式1
//     //     $('body').on('click', '#layout1', function (e) {
//     //         e.preventDefault();
//     //         if ($(this).hasClass('model') == false) {
//     //             $(this).addClass('model');
//     //             $('#layout2').removeClass('model');
//     //         }
//     //     })
//     //     //格式2
//     //     $('body').on('click', '#layout2', function (e) {
//     //         e.preventDefault();
//     //         if ($(this).hasClass('model') == false) {
//     //             $(this).addClass('model');
//     //             $('#layout1').removeClass('model');
//     //         }
//     //     })
//     //     $('body').on('click', '#qx', function () {
//     //         layer.closeAll();
//     //     })
//     // }
//     // fun.dialog(option);
// })
//批量
$('body').on('tap', '.prices-btn', function (e) {
    e.stopPropagation();
    // console.log('批量');
    $('.p-batch').show();
    var $this = $(this);
    var list = $this.closest('li').data('list');
    // console.log(list);

    for (var i = 0; i < prices_arr.length; i++) {
        if (prices_arr[i]['id'] == list['id']) {
            stop = true;
            return
        } else {
            stop = false;
        }
    }
    prices_arr.push(list);
    parabole($this);
    // console.log(prices_arr);
})

//更多
$('body').on('touchend', '.more-btn', function (e) {
    e.stopPropagation();
    console.log('更多');
    var $this = $(this);
    var list = $this.closest('li').data('list');
    var merchants_list = [
        { "name": "报价", "column": "bj", },
        { "name": "库存", "column": "kc", },
        { "name": "分析", "column": "fx", },
        // { "name": "试衣", "column": "sy", },
        { "name": "删除", "column": "sc", }
    ];
    fun.showBookList({
        list: merchants_list,
        choose: function (res) {
            console.log(res);
            switch (res['column']) {
                case 'bj'://报价
                    fun.showPageFull({
                        "page_url": page_arr.product_quoted,
                        "pageParam": {
                            "goods_info": list,
                            "goods_text": $this.attr('goods_text'),
                            "goods_id": list['id']
                        }
                    });
                    break;
                case 'kc'://库存
                    //////////////////
                    fun.showPageFull({
                        "page_url": page_arr.kc_kcxq,
                        "pageParam": {
                            "data": list,
                            "cp_id": list['id'],
                            "info": list['number'] + "" + list['name']
                        }
                    })
                    break;
                case 'fx'://分析
                    //////////////////
                    var to_month = fun.getMonthArr(1)[0];
                    var data = {
                        "cp_mc": list['name'],
                        "cp_id": list['id'],
                        "cp_bh": list['number'],

                    }
                    fun.showPageFull({
                        "page_url": page_arr.xs_cpfx_xq,
                        "pageParam": {
                            "data": data,

                            "cp_id": list['id'],
                            "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
                            "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
                        }
                    })
                    break;
                case 'sy'://试衣
                    //////////////////
                    break;
                case 'sc'://删除
                    fun.dialog({
                        content: '您确定要删除【' + list['number'] + list['name'] + '】吗？',
                        btn: ['删除', '取消'],
                        yes: function () {
                            fun.ajax({
                                showLoad: true,
                                hideLoad: true,
                                url: AJAX_URL.saveGoods,
                                data: {
                                    "save_type": "delete",
                                    "id": list['id']
                                },
                                success: function (res) {
                                    switch (res['status']) {
                                        case 0:
                                            fun.toast('删除成功。');
                                            getList();
                                            break;
                                        case 103:
                                            fun.dialog({
                                                content: '【' + list['number'] + '' + list['name'] + '】已被调用，不允许删除。如果该产品没有在经营，您可以使用：停用功能。',
                                                btn: ['转为停用状态', '我知道了'],
                                                yes: function () {
                                                    fun.ajax({
                                                        showLoad: true,
                                                        hideLoad: true,
                                                        url: AJAX_URL.saveGoods,
                                                        data: {
                                                            "save_type": "delete",
                                                            "is_has": true,
                                                            "id": (list['id'] || [0]),
                                                        },
                                                        success: function (res) {
                                                            if (res['status'] == 0) {
                                                                fun.toast('修改成功。');
                                                                getList();
                                                            }
                                                        }
                                                    })
                                                }
                                            });
                                            break;
                                        default:
                                            fun.toast('删除失败。');
                                    }
                                }
                            })
                        }
                    })
                    break;
            }
        }
    })
    return false;
})

//批量
$('.p-batch').on('tap', function (e) {
    e.stopPropagation();
    fun.showPageFull({
        "page_url": page_arr.product_batch,
        "pageParam": {
            return_page: html_name,
            data: prices_arr,
        }
    });
})


//小球动画效果
function parabole($this) {

    if (stop == true) {
        return;
    }
    var img_src = $this.siblings('.picture').children('.imgs').attr("src");
    // console.log(img);
    var heigth = document.body.scrollTop;
    //获取图片位置
    var YStart = $this.offset().top + 20;
    var yStart = YStart - heigth;
    // var YStart = 200;
    var XStart = $this.offset().left + 20;
    // var XStart = 0;
    // console.log(YStart,XStart);
    //获取批量图标位置
    var targetTop = $('.p-batch').offset().top + 5;
    var targettop = targetTop - heigth;
    // var targetTop = 500;
    var targetLeft = $('.p-batch').offset().left + 5;
    // var targetLeft = 300;
    // console.log(YEnd,XEnd);

    // 根据关键参数Xpeed计算动画时间与垂直加速度//1s
    var Time = 1 / 0.016;//|| (0.8 / 0.016);
    // 确定关键参数
    var Xspeed = Number((targetLeft - XStart)) / Time;
    //上抛高度
    var Yspeed = -3;

    var A = (2 * (targettop - yStart - Yspeed * Time)) / (Time * Time);
    // console.log(Time,A);
    var IMG = document.createElement('img');
    IMG.src = img_src;
    IMG.className = 'parabole';
    IMG.style.top = yStart + 'px';
    IMG.style.left = XStart + 'px';
    document.body.appendChild(IMG);
    // console.log(targetTop,targetLeft)
    // return
    // 单位时间 记录元素实时位置
    var loop = 0;
    var nowX = XStart;
    var nowY = yStart;


    function move() {
        if (nowY >= targettop) {
            // 销毁的判断
            IMG.remove();
            return;
        }

        // 当前位置等于原始位置 + 单位时间内的位移
        nowX += Xspeed;
        //
        nowY += (A * loop + Yspeed);
        requestAnimationFrame(function () {
            IMG.style.top = Math.min(nowY, targetTop) + 'px';
            IMG.style.left = Math.min(nowX, targetLeft) + 'px';
            loop++;
            move();
        });
    };
    move();
}
