var html_name=page_arr.product_batch;
var photoBrowser;
$('#header').header({
    back: true,
    title: '批量操作',
    empty:true
});

page_init=function(){
    console.log(page_data);
    if(page_data['data'].length!=0){
        setData(page_data['data']);
    }
    photoBrowser = api.require('photoBrowser');
    $('.ck-one').addClass('check-choice');
    $('.ck-one').siblings().children('.product_batch-cpmx').children('.product_batch-numberList').children('input').addClass('hop');
    $('.ck-all').addClass('check-choice');

    fun.keyboardEject($('.batch-btn'));
}
//加载数据到页面
function setData(data){
    var html=[];
    for(var i=0;i<data.length;i++){
        var data_list=data[i],
            img_url = (data_list['imgs']) ? fun.getImgPath(data_list['imgs']) : "../img/logo.png",
            large_url = (data_list['imgs']) ? fun.getImgPath(data_list['imgs'], true) : "../img/logo.png";
        html.push(' <li class="product_batch-cpLsit" data-list=\''+fun.formatString(JSON.stringify(data_list[i]))+'\'>');
        html.push('     <div class="le open">');
        html.push('         <div class="check-box boxs ck-one"><i class="iconfont icon-check"></i></div>');
        html.push('         <div class="product_batch-cp">');
        html.push('             <div class="product_b-img">');
        html.push(img_url=="../img/logo.png"?'<img class="imgs img-null" src="'+img_url+'">':'<img class="imgs" src="'+img_url+'" large-url="' + large_url + '">');
        html.push('             </div>');
        html.push('             <div class="product_batch-cpmx">');
        html.push('                 <div class="product_batch-cpbh">');
        html.push('                     <span>'+data_list['number']+'</span>');
        html.push('                     <span>'+data_list['name']+'</span>');
        html.push('                 </div>');
        html.push('                 <div class="product_batch-numberList">');
        html.push('                     <p>打印份数</p>');
        html.push('                     <span class="cut">-</span>');
        html.push('                     <input type="number" value="1" class="inputBatch" onkeyup="value=value.replace(/[^0-9]/g,\'\')" ">');
        html.push('                     <span class="add">+</span>');
        html.push('                 </div>');
        html.push('             </div>');
        html.push('         </div>');
        html.push('         <div class="delete dels1 delete-btn" id="delete" data-id="'+data_list['id']+'">删除</div>');
        html.push('     </div>');
        html.push(' </li>');
    }
    $('.product_batch').append(html.join(''));

}

//批量减
$('body').on('tap','.cutAll',function(){
    var $this=$(this),cutAll=$('.cut');
    var input=$this.siblings('input'),cut_input=cutAll.siblings('input.hop');
    var val=input.val();
    if(Number(val)==0) return;
    val=Number(val)-1;
    input.val(val);
    cut_input.val(val);
})
//批量加
$('body').on('tap','.addAll',function(){
    var $this=$(this),addAll=$('.add');
    var input=$this.siblings('input'),add_input=addAll.siblings('input.hop');
    var val=input.val();
    val=Number(val)+1;
    input.val(val);
    add_input.val(val);
})
//减
$('body').on('tap','.cut',function(){
    var $this=$(this);
    var input=$this.siblings('input');
    var val=input.val();
    if(Number(val)==0) return;
    val=Number(val)-1;
    input.val(val);
})
//加
$('body').on('tap','.add',function(){
    var $this=$(this);
    var input=$this.siblings('input');
    var val=input.val();
    val=Number(val)+1;
    input.val(val);
})
//
$('.inputAll').on('keyup',function(){
    var val=$(this).val();
    $('input.hop').val(val);
})

$('body').on('tap', '.ck-one', function (e) {
    e.stopPropagation();
    var input=$(this).siblings().children('.product_batch-cpmx').children('.product_batch-numberList').children('input');

    // if($('.ck-one').length==1){
    //     $('.ck-all').addClass('check-choice');
    // }
    if(input.hasClass('hop')){
        input.removeClass('hop');
    }else{
        input.addClass('hop');
    }
    if($('.ck-one').length==$('.ck-one.check-choice').length){
        $('.ck-all').addClass('check-choice');
    }else{
        $('.ck-all').removeClass('check-choice');
    }

});

//多选
$('body').on('tap', '.ck-all', function (e) {
    e.stopPropagation();
    var input=$('.ck-one').siblings().children('.product_batch-cpmx').children('.product_batch-numberList').children('input');
    if ($(this).hasClass('check-choice')) {
        $('.ck-one').addClass('check-choice');
        input.addClass('hop');
    } else {
        $('.ck-one').removeClass('check-choice');
        input.removeClass('hop');
    }
});

$('body').on('tap', '#check_all', function (e) {
    e.stopPropagation();
    if ($(this).siblings('.ck-all').hasClass('check-choice')) {
        $(this).siblings('.ck-all').removeClass('check-choice');
        $('.ck-one').removeClass('check-choice');
    } else {
        $(this).siblings('.ck-all').addClass('check-choice');
        $('.ck-one').addClass('check-choice');
    }
});


//清空
$('body').on('tap','#empty_btn',function(){
    $('.product_batch').empty();
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'empty'
        }
    });
    api.closeWin();
})
//删除
$('body').on('tap','#delete',function(){
    var id=$(this).data('id');
    var data=page_data['data'];
    for(var i=0;i<data.length;i++){
        if(data[i]['id']==id){
            data.splice(i,1);
        }
    }
    $('.product_batch').empty();
    setData(data);
})


//浏览大图
$('body').on('tap','.imgs',function(e){
    e.preventDefault();
    var imgs_src=$(this).attr('src');
    // console.log(imgs_src);
    var img_arr = [];
    $('.imgs').each(function (i, obj) {
        img_arr.push($(this).attr('large-url'));
        $(obj).attr('index', i);
    })
    if(imgs_src=='../img/logo.png') return;
    var index = $(this).prev().attr('index');
    photoBrowser.open({
        images: img_arr,
        activeIndex: index || 0,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        } else {
            console.log(JSON.stringify(err));
        }
    });
    return false;
})

//打印
$('#shares').on('tap', function (e) {
    e.stopPropagation();
    console.log('打印');
    var $this = $(this);
    var stampHtml = [];
    stampHtml.push('<div class="product-subject">');
    stampHtml.push('    <p>打印</p>');
    stampHtml.push('    <div>');
    stampHtml.push('        <div class="product-btn">');
    stampHtml.push('            <button id="layout1">格式1</button>');
    stampHtml.push('            <button id="layout2">格式2</button>');
    stampHtml.push('        </div>');
    stampHtml.push('        <div class="product-fs">');
    // stampHtml.push('            <span>份数：</span>');
    // stampHtml.push('            <input value="1" id="fs">');
    stampHtml.push('        </div>');
    stampHtml.push('        <div class="product-gn">');
    stampHtml.push('            <span class="qx" id="qx">取消</span>');
    stampHtml.push('            <span class="dy" id="dy">打印</span>');
    stampHtml.push('        </div>');
    stampHtml.push('    <div>');
    stampHtml.push('</div>');
    var option = {
        content: stampHtml.join(''),
        className: 'product-list',
        btn: false
    }
    option.success = function () {
        //格式1
        $('body').on('click', '#layout1', function (e) {
            e.preventDefault();
            if ($(this).hasClass('model') == false) {
                $(this).addClass('model');
                $('#layout2').removeClass('model');
            }
        })
        //格式2
        $('body').on('click', '#layout2', function (e) {
            e.preventDefault();
            if ($(this).hasClass('model') == false) {
                $(this).addClass('model');
                $('#layout1').removeClass('model');
            }
        })
        $('body').on('click', '#qx', function () {
            layer.closeAll();
        })
    }
    fun.dialog(option);
})
