var html_name = page_arr.product_quoted;
var search_data = {
    "type": "add",
    "keyword": "",
    "keyword_key": ['cp_ys_mc','simple'],
    "cp_id": 0,
    "jjdw_id": 0,
    "jjdw_mc": ''
};
var title = '';
var cp_ys = '',
    cp_ys_id = '',
    cp_ys_bh = '',
    cp_ys_mc = '';
var cpbj_data = [];
var bj_info = '';

page_init = function () {
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'select_list':
                if (temp['data']['page_type'] == "jjdw") {
                    $('#dwmc').text(temp['data']['select_val']).data('dw_id', temp['data']['id']);
                    search_data['jjdw_id'] = temp['data']['id'];
                    search_data['jjdw_mc'] = temp['data']['select_val'] || '';
                    getList();
                }
                break;
            case 'refresh':
                getList();
                break;
        }
    });
    title = page_data['goods_text'];
    $('#header').header({
        back: true,
        title: title,//XX产品编号+产品名称
        add: Auth.check('cpbj', 'edit'),
        foot_input: {
            show: true,
            plader: '搜索颜色'
        },
    });

    // $('#foot_search').focus();

    var goods_info = page_data['goods_info'];
    var dw_id = goods_info['unit_id'] || 0;
    var dw_mc = goods_info['unit_name'];

    if (goods_info['unit_options']['xsdw_id']) {
        dw_id = goods_info['unit_options']['xsdw_id'];
        dw_mc = goods_info['xsdw_name'];
    }

    $('.foot-input-box').append('<div class="count-box"><i id="dwmc" data-dw_id="' + (dw_id) + '">' + (fun.is_value(dw_mc, '单位')) + '</i>');

    if (!dw_mc) {
        fun.toast('请选择单位！');
    }

    if (!Auth.check('cpbj', 'edit')) {
        $('.ins-list').removeClass('swipe-delete');
    }

    search_data['cp_id'] = page_data['goods_id'];
    search_data['jjdw_id'] = dw_id || 0;
    search_data['jjdw_mc'] = dw_mc || '';

    getList();
};

function getList() {
    if ($.nui.isEmpty(search_data['jjdw_id'])) return fun.toast('请选择单位！');

    fun.showLoad();
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileAppCpbj,
        // data: search_data,
        data: $.extend({}, {
            "keyword": "",
            "is_stop": 0
        }, search_data),
        success: function (res) {
            fun.hideLoad();
            if (res['status'] == 0) {
                if (!res['data'] || res['data']['bj_info'].length == 0) {
                    // return $('#swipe_delete').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#swipe_delete',btnShow:false,style:'top:2rem;height:10rem;'});
                }

                cpbj_data = res.data;
                showData(res['data'] || []);
            } else {
                fun.alert({msg: '网络异常！'});
            }
        }
    })
}

function showData(data) {
    var listHtml = [];
    bj_info = data['bj_info'];
    var bjms = data['bjms'];
    for (var i = 0; i < bj_info.length; i++) {
        var bj = bj_info[i]['cpbj_info'];
        cp_ys_id = bj_info[i]['cp_ys_id'];
        cp_ys = ((bj_info[i]['cp_ys_bh'] || '') + ' ' + (bj_info[i]['cp_ys_mc'] || ''));
        cp_ys_bh = bj_info[i]['cp_ys_bh'] || '';
        cp_ys_mc = bj_info[i]['cp_ys_mc'] || '';
        listHtml.push('<li class="info" cp_ys_id="' + cp_ys_id + '" data-cpbj_info=\'' + fun.formatString(JSON.stringify(bj_info[i])) + '\'>');
        listHtml.push('     <div class="ins-detail color lower-border-line">');
        listHtml.push('         <span class="color-name">' + cp_ys + '</span>');
        if (bj_info[i]['order_amount'] > 0) {
            listHtml.push('         <span class="min-order-quantity">起订量 ' + '<span style="color:#000;">' + (bj_info[i]['order_amount'] || 0) + '</span>' + '</span>');
        }
        listHtml.push('     </div>');
        listHtml.push('<ul class="ins-list swipe-delete">');
        if (bj['bz_sj'] || bj['bz_bzj'] || bj['bz_zdj']) {
            listHtml.push('     <li data-bjms_type="bz_sj" data-bzj="bz_bzj" data-zdj="bz_zdj" class="ins-detail lower-border-line" cp_ys="' + cp_ys + '">');
            listHtml.push('       <div class="le">');
            listHtml.push('         <span class="color-type">标准</span>');
            // if (bj['bz_bzj'] > 0) {
            listHtml.push('         <span class="stand-price">标准价<i>' + (bj['bz_bzj'] || '') + '</i></span>');
            // }
            // if (bj['bz_zdj'] > 0) {
            listHtml.push('         <span class="lower-price">最低价<i>' + (bj['bz_zdj'] || '') + '</i></span>');
            // }
            listHtml.push('          <div class="delete dels1 delete-btn">删除</div>');
            listHtml.push('       </div>');
            listHtml.push('     </li>');
        }
        if (bj['jy_sj'] || bj['jy_bzj'] || bj['jy_zdj']) {
            listHtml.push('     <li data-bjms_type="jy_sj" data-bzj="jy_bzj" data-zdj="jy_zdj" class="ins-detail lower-border-line" cp_ys="' + cp_ys + '">');
            listHtml.push('       <div class="le">')
            listHtml.push('         <span class="color-type">剪样</span>');
            // if (bj['jb_bzj'] > 0) {
            listHtml.push('         <span class="stand-price">标准价<i>' + (bj['jy_bzj'] || '') + '</i></span>');
            // }
            // if (bj['jb_zdj'] > 0) {
            listHtml.push('         <span class="lower-price">最低价<i>' + (bj['jy_zdj'] || '') + '</i></span>');
            // }
            listHtml.push('          <div class="delete dels1 delete-btn">删除</div>');
            listHtml.push('        </div>');
            listHtml.push('     </li>');
        }
        if (bj['yb_sj'] || bj['yb_bzj'] || bj['yb_zdj']) {
            listHtml.push('     <li data-bjms_type="yb_sj" data-bzj="yb_bzj" data-zdj="yb_zdj" class="ins-detail lower-border-line" cp_ys="' + cp_ys + '">');
            listHtml.push('          <div class="le">');
            listHtml.push('         <span class="color-type">样版</span>');
            // if (bj['yb_bzj'] > 0) {
            listHtml.push('         <span class="stand-price">标准价<i>' + (bj['yb_bzj'] || '') + '</i></span>');
            // }
            // if (bj['yb_zdj'] > 0) {
            listHtml.push('         <span class="lower-price">最低价<i>' + (bj['yb_zdj'] || '') + '</i></span>');
            // }
            listHtml.push('          <div class="delete dels1 delete-btn">删除</div>');
            listHtml.push('        </div>');
            listHtml.push('     </li>');
        }
        // if (bj['sk_sj'] || bj['sk_bzj'] || bj['sk_zdj']) {
        //     listHtml.push('     <li data-bjms_type="sk_sj" data-bzj="sk_bzj" data-zdj="sk_zdj" class="ins-detail lower-border-line" cp_ys="' + cp_ys + '">');
        //     listHtml.push('          <div class="le">');
        //     listHtml.push('         <span class="color-type">色卡</span>');
        //     // if (bj['sk_bzj'] > 0) {
        //     listHtml.push('         <span class="stand-price">标准价<i>' + (bj['sk_bzj'] || '') + '</i></span>');
        //     // }
        //     // if (bj['sk_zdj'] > 0) {
        //     listHtml.push('         <span class="lower-price">最低价<i>' + (bj['sk_zdj'] || '') + '</i></span>');
        //     // }
        //     listHtml.push('          <div class="delete dels1 delete-btn">删除</div>');
        //     listHtml.push('        </div>');
        //     listHtml.push('     </li>');
        // }
        for (var j = 0; j < bjms.length; j++) {
            // if (typeof bj['ms_bzj_' + bjms[j]['id']] === undefined) continue;
            var ms_sj = (bj['ms_sj_' + bjms[j]['id']] || '');
            var bzj = (bj['ms_bzj_' + bjms[j]['id']] || 0);
            var zdj = (bj['ms_zdj_' + bjms[j]['id']] || 0);
            if (!bzj && !zdj && !ms_sj) continue;
            listHtml.push('     <li data-bjms_type="ms_sj_' + bjms[j]['id'] + '" data-bzj="ms_bzj_' + bjms[j]['id'] + '" data-zdj="ms_zdj_' + bjms[j]['id'] + '" class="ins-detail lower-border-line" cp_ys="' + cp_ys + '">');
            listHtml.push('       <div class="le">');
            listHtml.push('         <span class="color-type">' + bjms[j]['name'] + '</span>');
            // if (bj['ms_bzj_' + bjms[j]['id']] > 0) {
            listHtml.push('         <span class="stand-price">标准价<i>' + bzj + '</i></span>');
            // }
            // if (bj['ms_zdj_' + bjms[j]['id']] > 0) {
            listHtml.push('         <span class="lower-price">最低价<i>' + zdj + '</i></span>');
            // }
            listHtml.push('          <div class="delete dels1 delete-btn">删除</div>');
            listHtml.push('        </div>');
            listHtml.push('     </li>');
        }
        listHtml.push('    </ul>');
        listHtml.push('</li>');
    }
    $("#swipe_delete").html(listHtml.join(''));


    if (!Auth.check('cpbj', 'edit')) {
        $('.ins-list').removeClass('swipe-delete');
    }
}

// 选择 计价单位
$('body').on('tap', '.count-box', function () {
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            return_page: html_name,
            page_type: 'jjdw',
        }
    });
});
//点击键盘搜索
$('body').bind('search', "#foot_search", function () {
    search_data['keyword'] = $("#foot_search").val().trim();
    $("#swipe_delete").empty();
    getList();
});
// function searchData(status, stype) {
//     api.addEventListener({
//         name: html_name
//     }, function(res) {
//         if (!!res) {
//             if (!!res.value.data.view) stype = 'card';
//             if (!!res.value.status) status = res.value.status;
//         }
//         getList()
//     });
// }
// 产品报价-编辑
$('body').on('tap', '#add_btn', function (e) {
    if (!$('#dwmc').data('dw_id')) {
        return fun.toast('请选择单位！');
    }

    var goods_info = page_data['goods_info'];

    var cpbj_info = {
        cp_id: goods_info['id'],
        cp_bh: goods_info['number'] || '',
        cp_mc: goods_info['name'] || '',
        cp_ys_id: 0,
        cp_ys_bh: '',
        cp_ys_mc: '',
        jjdw_id: $('#dwmc').data('dw_id') || 0,
        jjdw_mc: $('#dwmc').text().trim() || '',
        id: 0,
        // type: '',
        // lx_mc: '',
        // cp_lb_mc: '',
    };

    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            return_page: html_name,
            page_type: 'cpbj_ys',
            cp_id: search_data['cp_id'],
            cp_title: title,
            cp_jjdw: search_data['jjdw_mc'],
            jjdw_id: search_data['jjdw_id'],
            cpbj_info: cpbj_info
        }
    });
});

// 点击记录行
$('body').on('tap', '.info', function (e) {
    e.preventDefault();
    if (!Auth.check('cpbj', 'edit')) return;
    var cpbj_info = $(this).data('cpbj_info');
    fun.showPageFull({
        page_url: page_arr.product_quoted_edit,
        pageParam: {
            cp_id: search_data['cp_id'],
            cp_title: title,
            cp_dw: search_data['jjdw_mc'],
            jjdw_id: search_data['jjdw_id'],
            cp_ys: cp_ys,
            cp_ys_id: $(this).attr('cp_ys_id'),
            cp_ys_bh: cp_ys_bh,
            cp_ys_mc: cp_ys_mc,
            cpbj_info: cpbj_info
        }
    });
    return false;
});

//删除价格模式
function delBank(params) {
    // fun.ajax({
    //     showLoad: true,
    //     hideLoad: true,
    //     url: AJAX_URL.saveBpcpbjInfo,
    //     //   data:$.extend({},{
    //     //     "save_type":"delete"
    //     //   },params),
    //     data: params,
    //     success: function (res) {
    //         if (res['status'] == 0) {
    //             fun.toast('删除成功。');
    //             api.closeWin();
    //         } else {
    //             fun.toast('删除失败。');
    //         }
    //     }
    // });
}

//删除当前
$('body').on('touchend', 'li .delete-btn', function (e) {
    // cp_ys = $(this).parent().parent().attr('cp_ys');
    // var jgms = $(this).parent().find('.color-type').text();
    // var jgms_data = $(this).parent().parent().attr('bj_info');
    // fun.dialog({
    //     content: '你确定要删除：【' + cp_ys + ' ' + jgms + '】价格吗？',
    //     btn: ['确定', '取消'],
    //     yes: function () {
    //         //   if(!!page_data['id']){
    //         // var params = bj_info[0]['cpbj_info'];
    //         // delBank(params);
    //         //   }
    //     }
    // });

    var cpbj_info = $(this).closest('.info').data('cpbj_info');
    var cpysmc = cpbj_info['cp_ys_bh'] + ' ' + cpbj_info['cp_ys_mc'];
    var jgms = $(this).closest('.ins-detail').find('.color-type').text().trim();
    var closeLi = $(this).closest('.ins-detail');

    var sj = closeLi.data('bjms_type');
    var bzj = closeLi.data('bzj');
    var zdj = closeLi.data('zdj');

    var listObj = cpbj_info['cpbj_info'];

    delete listObj[sj];
    delete listObj[bzj];
    delete listObj[zdj];

    var list_data = $.extend({
        "id": cpbj_info['cp_id'],
        "cp_mc": cpbj_info['cp_mc'],
        "cp_ys_id": cpbj_info['cp_ys_id'],
        "cp_ys_mc": cpbj_info['cp_ys_mc'],
        "cp_ys_bh": cpbj_info['cp_ys_bh']
    }, listObj);

    fun.dialog({
        content: '你确定要删除：【' + cpysmc + ' ' + jgms + '】的价格吗？',
        btn: ['确定', '取消'],
        yes: function () {
            //   if(!!page_data['id']){
            // var params = bj_info[0]['cpbj_info'];
            // delBank(params);
            //   }

            // delJgms();
            var data = {
                "status": "add",
                "cp_id": cpbj_info['cp_id'],
                "jjdw_id": cpbj_info['jjdw_id'] || 0,
                "zdr_id": fun.getItem('user_info')['id'],
                "data": [list_data]
            };

            delJgms(data);
        }
    });

    e.preventDefault();
    return false;
});


function getSaveData() {
    // var goods_info = page_data['goods_info'];
    // var data = {
    //     "status": "add",
    //     "cp_id": goods_info['id'],
    //     "jjdw_id": $('#dwmc').data('dw_id') || 0,
    //     "zdr_id": fun.getItem('user_info')['id'],
    //     "data": [{
    //         "id": 122,
    //         "cp_mc": "ss",
    //         "cp_ys_id": 185,
    //         "cp_ys_mc": "",
    //         "cp_ys_bh": "白坯#",
    //     }]
    // };

    // {
    //     "status": "add",
    //     "cp_id": 122,
    //     "jjdw_id": 3,
    //     "zdr_id": 1,
    //     "data": [{
    //     "id": 122,
    //     "cp_mc": "ss",
    //     "cp_ys_id": 185,
    //     "cp_ys_mc": "",
    //     "cp_ys_bh": "白坯#",
    //     "bz_bzj": 1,
    //     "bz_sj": "2019-03-22 10:21",
    //     "bz_zdj": 1,
    //     "jb_bzj": 2,
    //     "jb_sj": "2019-03-22 10:21",
    //     "jb_zdj": 2,
    //     "yb_bzj": 3,
    //     "yb_sj": "2019-03-22 10:21",
    //     "yb_zdj": 3,
    //     "sk_bzj": 4,
    //     "sk_sj": "2019-03-22 10:21",
    //     "sk_zdj": 4,
    //     "ms_bzj_4": 5,
    //     "ms_sj_257": "2019-03-22 10:21",
    //     "ms_zdj_4": 5,
    //     "ms_sj_4": "2019-03-22 10:21",
    //     "ms_bzj_225": 6,
    //     "ms_zdj_225": 6,
    //     "ms_sj_225": "2019-03-22 10:21",
    //     "ms_bzj_257": 7,
    //     "ms_zdj_257": 7,
    //     "ms_bzj_256": 8,
    //     "ms_zdj_256": 8,
    //     "ms_sj_256": "2019-03-22 10:22",
    //     "ms_bzj_255": 2,
    //     "ms_zdj_255": 2,
    //     "ms_sj_255": "2019-03-22 10:22",
    //     "ms_bzj_226": 5,
    //     "ms_zdj_226": 5,
    //     "ms_sj_226": "2019-03-22 10:22"
    // }, {
    //     "id": 122,
    //     "cp_mc": "ss",
    //     "cp_ys_id": 186,
    //     "cp_ys_mc": "黄",
    //     "cp_ys_bh": "1#"
    // }]
    // }

    return data;
}

function delJgms(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveBpcpbjInfo,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                fun.toast('删除成功。');
                getList();
            } else {
                fun.toast('删除失败！');
            }
        }
    });
}
