var html_name = page_arr.push_set;
var account_id = fun.getItem('login_info').account_id;
var original_data = save_data = {}; //初始化数据和保存数据
/******头部显示******/
$("#header").header({
    back: true,
    title: '推送设置',
    appendBackBtnEvt: isDataChange
});

page_init = function () {
    page_data['keyback'] = isDataChange;//监听安卓返回键
    // $('.close').removeClass('nui-unactive').addClass('nui-active');
    $('.content').css({
        marginTop: api.safeArea.top + $('#header').height()
    })
    getList();
}

//点击推送设置
$('body').on('tap', '.new-close', function () {
    if($(this).hasClass('nui-active')){
        $(this).data('order',1);
    }else{
        $(this).data('order',0);
    }
})

//点击雷达设置
$('body').on('tap', '.close', function () {
    if($(this).hasClass('nui-active')){
        $(this).data('order',1);
    }else{
        $(this).data('order',0);
    }
})

//获取推送设置和雷达设置
function getList() {
    $.ajax({
        type: "GET",
        header: {
            "X-Requested-With": XMLHttpRequest
        },
        url: AJAX_URL.pushRadarSettings + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        success: function (res) {
            var pushData = res['push_setting'];
            var radarData = res['radar_setting'];
            $('.new-info').data('pushId',pushData.id);
            $('.push_single').data('radarId',radarData.id);
            //推送
            pushData['requested_order'] ? $("#orders").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#orders").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            pushData['accepted_order'] ? $("#tg-applying").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#tg-applying").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            pushData['refused_order'] ? $("#jj-applying").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#jj-applying").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            pushData['shipped_order'] ? $("#shipments").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#shipments").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            // 雷达
            radarData['do_not_disturb_at_night'] ? $("#notDisturb").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#notDisturb").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            radarData['old_customers_don_not_notice'] ? $("#oldCustomer").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#oldCustomer").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            radarData['viewed_shop'] ? $("#seeShop").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#seeShop").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            radarData['shared_shop'] ? $("#shareShop").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#shareShop").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            radarData['liked_shop'] ? $("#goodShop").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#goodShop").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            radarData['viewed_goods'] ? $("#product").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#product").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            radarData['fitted_2d'] ? $("#2D").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#2D").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            radarData['fitted_3d'] ? $("#3D").removeClass('nui-unactive').addClass('nui-active').data('order',1) : $("#3D").removeClass('nui-active').addClass('nui-unactive').data('order',0)
            switch (radarData['interval']) {
                case 0:
                    $('.minute').find('span').text("一直提醒").data('order',0);
                    break;
                case 1:
                    $('.minute').find('span').text("1分钟").data('order',1);
                    break;
                case 2:
                    $('.minute').find('span').text("2分钟").data('order',2);
                    break;
                case 3:
                    $('.minute').find('span').text("3分钟").data('order',3);
                    break;
                case 5:
                    $('.minute').find('span').text("5分钟").data('order',5);
                    break;
            }
            original_data = JSON.parse(JSON.stringify(saveData()));
        }
    })

}

function saveData(){
    var data = {};
    data = {
        "requested_order": $("#orders").data('order'),
        "accepted_order": $("#tg-applying").data('order'),
        "refused_order": $("#jj-applying").data('order'),
        "shipped_order": $("#shipments").data('order'),
        "do_not_disturb_at_night": $("#notDisturb").data('order'),
        "old_customers_don_not_notice": $("#oldCustomer").data('order'),
        "viewed_shop": $("#seeShop").data('order'),
        "shared_shop": $("#shareShop").data('order'),
        "liked_shop": $("#goodShop").data('order'),
        "viewed_goods": $("#product").data('order'),
        "fitted_2d": $("#2D").data('order'),
        "fitted_3d": $("#3D").data('order'),
        "interval": $('.minute').find('span').data('order')
    }
    return data;
}

//点击弹出选择类型
$('.minute-content').on('click', function (e) {
    document.body.addEventListener('touchmove', preventDefault, { passive: false });
    var val = $('.minute').find('span').text();
    var merchants_list = [
        { "name": "一直提醒", "column": "alway", "is_choose": 0 ,"id": 0},
        { "name": "1分钟", "column": "one", "is_choose": 1 ,"id": 1},
        { "name": "2分钟", "column": "two", "is_choose": 0 ,"id": 2},
        { "name": "3分钟", "column": "three", "is_choose": 0 ,"id": 3},
        { "name": "5分钟", "column": "wl", "is_choose": 0 ,"id": 5}
    ];
    $(merchants_list).each(function (i, arr) {
        if (arr['name'] == val) {
            merchants_list[i]['is_choose'] = 1;
        } else {
            merchants_list[i]['is_choose'] = 0;
        }
    });
    fun.showBookList({
        list: merchants_list,
        choose: function (res) {
            if (res['name'] === $('.minute').find('span').text()){
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                return;  // 选择相同类型，不执行
            }
            $('.minute').find('span').text(res['name']).data('order',res['id']);
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            
        }
    })
    return false;
});

$('body').on('click', function (e) {
    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
})

function isDataChange(){
    save_data = JSON.parse(JSON.stringify(saveData()));
    if($.nui.isObjEquals(original_data,save_data)){   // 对比数据是否有发生变化
        api.closeWin();
    }else{
        var puId = $('.new-info').data('pushId');
        $.ajax({
            type: "PUT",
            url: AJAX_URL.pushSettings + '/' + puId + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
            header: {
                "X-Requested-With": XMLHttpRequest
            },
            data: {
                "requested_order": $("#orders").data('order'),
                "accepted_order": $("#tg-applying").data('order'),
                "refused_order": $("#jj-applying").data('order'),
                "shipped_order": $("#shipments").data('order')
            },
            success: function (res) {
                var radarId = $('.push_single').data('radarId');
                $.ajax({
                    type: "PUT",
                    url: AJAX_URL.RadarSettings + '/' + radarId + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
                    header: {
                        "X-Requested-With": XMLHttpRequest
                    },
                    data: {
                        "do_not_disturb_at_night": $("#notDisturb").data('order'),
                        "old_customers_don_not_notice": $("#oldCustomer").data('order'),
                        "viewed_shop": $("#seeShop").data('order'),
                        "shared_shop": $("#shareShop").data('order'),
                        "liked_shop": $("#goodShop").data('order'),
                        "viewed_goods": $("#product").data('order'),
                        "fitted_2d": $("#2D").data('order'),
                        "fitted_3d": $("#3D").data('order'),
                        "interval": $('.minute').find('span').data('order')
                    },
                    success: function (res) {
                        setTimeout(function(){
                            api.closeWin();
                        },200)
                    },
                    error: function () {
                        fun.toast('保存失败')
                        setTimeout(function(){
                            api.closeWin();
                        },200)
                    },
                    
                })
            },
            error:function(){
                fun.toast('保存失败')
                setTimeout(function(){
                    api.closeWin();
                },200)
            }
        })
    }
}

// //阻止默认事件
function preventDefault(e) {
    e.preventDefault();
}