var html_name = page_arr.radar;
var begin_lCalendarRange = new lCalendarRange;
var search_data = {};
search_data['action_begin_time'] = fun.dateFormat('yyyy-MM-dd');
search_data['action_end_time'] = fun.dateFormat('yyyy-MM-dd');
search_data['visitor_begin_time'] = fun.dateFormat('yyyy-MM-dd');
search_data['visitor_end_time'] = fun.dateFormat('yyyy-MM-dd');

$("#header").header({
    back: true,
    title: '雷达',
});

page_init = function () {

}

$('#time_action').time_filter({ // 时间筛选
    'time_id': 'time_action1',
    begin_time: search_data['action_begin_time'],//初始开始时间
    end_time: search_data['action_end_time'],//初始结束时间
    dateText: function (ret) { //返回事件
        search_data['begin_time'] = fun.Date(ret['begin_time']).Format('yy-mm-dd');
        search_data['end_time'] = fun.Date(ret['end_time']).Format('yy-mm-dd');
        // $('#order_list').empty();
        // fun.statisticDate(search_data);
        // getList();
    }
});

$('#time_visitor').time_filter({ // 时间筛选
    'time_id': 'time_visitor1',
    begin_time: search_data['visitor_begin_time'],//初始开始时间
    end_time: search_data['visitor_end_time'],//初始结束时间
    dateText: function (ret) { //返回事件
        search_data['begin_time'] = fun.Date(ret['begin_time']).Format('yy-mm-dd');
        search_data['end_time'] = fun.Date(ret['end_time']).Format('yy-mm-dd');
        // $('#order_list').empty();
        // fun.statisticDate(search_data);
        // getList();
    }
});

$('.modular').click(function (e) {
    e.preventDefault();
    var data_url = $(this).data('name');
    console.log(data_url);
    $('.modular').removeClass('selection');
    $(this).addClass('selection');
    $('.modular-ul').hide();
    $('#' + data_url + '').show();
    if (data_url == 'action') {
        show_statistics();
    }
})



function show_statistics() {
    var myChart = echarts.init(document.getElementById('census'));
    var data = [78, 60, 60, 70, 69, 52, 10, 99]
    var titlename = ['新客户到访', '老客户到访', '分享小店', '点赞小店', '查看产品', '2D试衣', '3D试衣', '跟进聊天'];
    var valdata = [683, 234, 234, 523, 345, 234, 523, 345]
    var myColor = ['#1089E7', '#F57474', '#56D0E3', '#F8B448', '#8B78F6'];
    option = {
        backgroundColor: '#fff',
        xAxis: {
            show: false
        },
        grid: {
            left: '3%',
            right: '3%',
            bottom: '0%',
            top: '5%',
            containLabel: true
        },
        yAxis: [{
            show: true,
            data: titlename,
            inverse: true,
            axisLine: {
                show: false
            },
            splitLine: {
                show: false
            },
            axisTick: {
                show: false
            },
            axisLabel: {
                textStyle: {
                    color: "#000"
                },
                formatter: function (value, index) {
                    return [
                        '{title|' + value + '} '
                    ].join('\n')
                },
                rich: {}
            },

        }, {
            show: true,
            inverse: true,
            data: valdata,
            axisLabel: {
                textStyle: {
                    color: "#000"
                }
            },
            axisLine: {
                show: false
            },
            splitLine: {
                show: false
            },
            axisTick: {
                show: false
            },

        }],
        series: [{
            name: '条',
            type: 'bar',
            yAxisIndex: 0,
            data: data,
            barWidth: 10,
            itemStyle: {
                normal: {
                    barBorderRadius: 30,
                    color: '#3D9CFA'
                }
            }
        }]
    };
    myChart.setOption(option);
    var logo_html = [];
    logo_html.push('<div class="main-youhui">');
    logo_html.push('    <ul class="statistics_ul">');
    logo_html.push('        <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('        <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('        <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('        <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('        <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('        <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('        <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('        <li class="statistics_li"><i class="iconfont icon-youfanhui"></i></li>');
    logo_html.push('    </ul>');
    logo_html.push('</div>');
    $('.main-statistics').append(logo_html.join(''));
}

$('.rader-details').click(function (e) {
    e.preventDefault();
    var $this = $(this);
    var box = $this.siblings('.chart-box');
    var id = box.attr('id');
    var children = $this.children('.block-right').children('.iconfont')
    console.log(children);
    box.stop().slideToggle("fast", function () {
        if (box.css("display") == "none") {
            children.removeClass('icon-shang').addClass('icon-xia');
        } else {
            show_list_more(id);
            children.removeClass('icon-xia').addClass('icon-shang');
        }
    });


})

function show_list_more(elem) {
    var myChart = echarts.init(document.getElementById(elem));
    var data = [78, 60, 60, 70]
    var titlename = ['查看小店', '分享小店', '点赞小店', '保存通讯录',];
    var valdata = [683, 234, 234, 523]
    var myColor = ['#1089E7', '#F57474', '#56D0E3', '#F8B448', '#8B78F6'];
    option = {
        backgroundColor: '#fff',
        xAxis: {
            show: false
        },
        grid: {
            left: '3%',
            right: '3%',
            bottom: '0%',
            top: '5%',
            containLabel: true
        },
        yAxis: [{
            show: true,
            data: titlename,
            inverse: true,
            axisLine: {
                show: false
            },
            splitLine: {
                show: false
            },
            axisTick: {
                show: false
            },
            axisLabel: {
                textStyle: {
                    color: "#000"
                },
                formatter: function (value, index) {
                    return [
                        '{title|' + value + '} '
                    ].join('\n')
                },
                rich: {}
            },

        }, {
            show: true,
            inverse: true,
            data: valdata,
            axisLabel: {
                textStyle: {
                    color: "#000"
                }
            },
            axisLine: {
                show: false
            },
            splitLine: {
                show: false
            },
            axisTick: {
                show: false
            },

        }],
        series: [{
            name: '条',
            type: 'bar',
            yAxisIndex: 0,
            data: data,
            barWidth: 10,
            itemStyle: {
                normal: {
                    barBorderRadius: 30,
                    color: '#3D9CFA'
                }
            }
        }]
    };
    myChart.setOption(option);
}
