$('#header').header({
    back: true,
    title: '立即注册'
});
var photoBrowser;
page_init = function(){
    photoBrowser = api.require('photoBrowser');

    if (api.systemType == "ios") {
        $('#img1').attr('src', '../img/registration_ios_1.jpg');
        $('#img2').attr('src', '../img/registration_ios_2.jpg');
    } else {
        $('#img1').attr('src', '../img/registration_1.jpg');
        $('#img2').attr('src', '../img/registration_2.jpg');
    }
}


$('#zc').on('click', function () {
    // register();
    var wx_gzh = '云布业';//微信公众号 YunBuYe
    var clipBoard = api.require('clipBoard');
    clipBoard.set({
        value: wx_gzh
    }, function (ret, err) {
        if (ret) {
            fun.toast('“云布业”公众号复制成功！\r\n请前往注册，正在跳转微信...');

            setTimeout(function () {
                var wx = api.require('wxPlus');//要使用前先加载api的微信模块
                if (!checkWxUseable(wx)) return false;
                wx.isInstalled(function (ret1, err1) {//判断当前设备是否安装了微信客户端
                    if (ret1.installed) {//installed会返回true或false
                        api.openApp({
                            iosUrl: 'weixin://',
                            androidPkg: 'com.tencent.mm',
                            mimeType: 'text/html',
                            uri: 'weixin://',
                        });
                    } else {
                        return fun.toast('请您安装微信后重试');
                    }
                });
            }, 3000);
        } else {
            fun.toast("复制失败，请重试！");
        }
    });
});


$('.imgs').on('click', function () {
    var indexs = $(this).data('index');
    var img_arr = [ONLINE_IMGS+'registration_1.jpg', ONLINE_IMGS+'registration_2.jpg'];

    if (api.systemType == "ios") {
        img_arr = [ONLINE_IMGS+'registration_ios_1.jpg', ONLINE_IMGS+'registration_ios_2.jpg'];
    }

    photoBrowser.open({
        images: img_arr,
        activeIndex: indexs|| 0,
        placeholderImg: 'widget://img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        } else {
        }
    });
})
