var html_name = page_arr.replace_mobile;
var mobile = fun.getItem('user_info')['account'];
var company_id = fun.getItem('company_info')['company_id'];
var cout = false,times;
//标题栏
$('#header').header({
    back: true,
    title: '更换手机',
    // appendBackBtnEvt: isDataChange
});
page_init = function () {
    if (mobile != '') {
        var new_mobile = replacepos(mobile, 3);
        $('#sj').val(new_mobile);
    }
}

//指定位置 n ~ n+4 的字符替换为'****'
function replacepos(string, start) {
    mystr = string.substring(0, start) + '****' + string.substring(start + 4);
    return mystr;
}

/*验证码限制输入6位 */
$('#yzm').on('keyup', function (event) {
    $(this).val($(this).val().slice(0, 6));
});
// 验证码 按钮
$('#btn-yzm').on('click', function (event) {
    if(cout) return;
    cout = true;
    $('#btn-yzm').removeClass('enabling');
    timeWait(59);//启动倒计时函数
    sendCode();
});

function sendCode() {
    //发送验证码的代码
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.code,
        data: {
            "mobile_type":"old",
            "type":"replaceAccount",
            'mobile': mobile,
            'company_id':company_id
        },
        success: function (res) {
            switch (res['status']) {
                case 0:

                    break;
                case 104:
                    fun.toast('该手机号码未注册云布业\n' +
                        '如果该号码为子账号\n请联系贵公司管理员为您变更密码！');
                    cout = false;
                    clearTimeout(times);
                    $('#btn-yzm').html('发送验证码');
                    $('#btn-yzm').addClass('enabling');
                    break;
                default:
                    fun.toast(res['msg']);
                    cout = false;
                    clearTimeout(times);
                    $('#btn-yzm').html('发送验证码');
                    $('#btn-yzm').addClass('enabling');
                    break;
            }
        }
    })
}
function timeWait(time) {
    times = setTimeout(function () {
        if (time >= 0) {
            $('#btn-yzm').html(time + 's');
            time--;
            timeWait(time);
        } else {
            cout = false;
            $('#btn-yzm').html('发送验证码');
            $('#btn-yzm').addClass('enabling');
        }
    }, 1000);
}

$('#xyb').on('click', function () {
    if ($('#yzm').val().trim() == '') return fun.toast('验证码不能为空！');
    if ($('#yzm').val().length != 6) return fun.toast('验证码不满6位数！');
    console.log($('#yzm').val());
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.code,
        data: {
            "type":"checkCode",
            "check_type":"replaceAccount",
            "mobile":mobile,
            "sms_code":$('#yzm').val().trim(),
        },
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.showPageFull({
                        page_url:page_arr.replace_mobile_change,
                        pageParam:{
                            mobile:mobile,
                            company_id:company_id,
                            code:$('#yzm').val().trim()
                        }
                    })
                    setTimeout(function(){
                        api.closeWin();
                    },1000)
                    break;
                case 100:
                    if(res['type'] == 'mobile'){
                        fun.toast('手机号码不能为空！');
                    }else if(res['type'] == 'old_mobile'){
                        fun.toast('旧手机号码不能为空！');
                    }else if(res['type'] == 'code'){
                        fun.toast('验证码不能为空！');
                    }else if(res['type'] == 'code'){
                        fun.toast(res['msg']);
                    }
                    break;
                case 105:
                    fun.toast('验证码错误！');
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    })
})