var html_name = page_arr.replace_mobile_change;
var cont = false, times;
$('#header').header({
    back: true,
    title: '更换手机',
});

/*手机号码限制输入11位 */
$('#sj').on('keyup paste input', function (event) {
    $(this).val($(this).val().slice(0, 11));
    if ($(this).val().length == 11) {
        if (cont) return;
        $('#btn-yzm').addClass('enabling');
    } else {
        $('#btn-yzm').removeClass('enabling');
    }
});
/*验证码限制输入6位 */
$('#yzm').on('keyup', function (event) {
    $(this).val($(this).val().slice(0, 6));
});

// 验证码 按钮
$('#btn-yzm').on('click', function (event) {
    if ($(this).hasClass('enabling')) {
        if ($('#sj').val().trim() == '') return fun.toast('请输入手机号码。');
        
        if (!fun.regCheck($('#sj').val().trim(), 'phone')) return fun.toast('手机号码有误，请重填。');
        if (cont) return
        cont = true;
        $('#btn-yzm').removeClass('enabling');
        timeWait(59);//启动倒计时函数
        sendCode();
    }
});

function restart() {
    cont = false;
    clearTimeout(times);
    $('#btn-yzm').html('发送验证码');
    ($('#sj').val().length == 11) ? $('#btn-yzm').addClass('enabling') : $('#btn-yzm').removeClass('enabling');
}

function sendCode(options) {
    if ($('#sj').val().trim() == '') return fun.toast('请输入手机号码。');
    //发送验证码的代码
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.code,
        data: {
            "mobile_type": "new",
            "type": "replaceAccount",
            "mobile": $('#sj').val().trim(),
            "company_id": page_data['company_id']
        },
        success: function (res) {
            switch (res['status']) {
                case 0:

                    break;
                case 104:
                    // fun.toast('该号码未绑定账号\n' +
                    //     '如果您的号码不是主账号\n请联系贵公司管理员为您改密码！');

                    fun.toast('该手机已被注册过。');

                    restart()
                    break;
                default:
                    fun.toast(res['msg']);
                    restart()
                    break;
            }
        }
    })
}
function timeWait(time) {
    times = setTimeout(function () {
        if (time >= 0) {
            $('#btn-yzm').html(time + 's');
            time--;
            timeWait(time);
        } else {
            $('#btn-yzm').html('发送验证码');
            cont = false;
            ($('#sj').val().length == 11) ? $('#btn-yzm').addClass('enabling') : $('#btn-yzm').removeClass('enabling');
        }
    }, 1000);
}
$('#qrgh').off('click').on('click', function () {
    verification();
})
function verification() {
    if ($('#sj').val().trim() == '') return fun.toast('手机号码不能为空！');
    if (!fun.regCheck($('#sj').val().trim(), 'phone')) return fun.toast('手机号码有误，请重填。');
    // if (page_data['mobile'] == $('#sj').val().trim()) return fun.toast('新手机不能和原手机一样！');
    if ($('#yzm').val().trim() == '') return fun.toast('验证码不能为空！');
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveAccount,
        data: {
            "type": "replaceAccount",
            "old_mobile": page_data['mobile'],
            "mobile": $('#sj').val().trim(),
            "old_sms_code":page_data['code'],
            "sms_code": $('#yzm').val().trim(),
            "company_id": page_data['company_id']
        },
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.toast('更换成功！');
                    fun.logoutToLogin();
                    break;
                case 100:
                    if(res['type'] == 'mobile'){
                        fun.toast('手机号码不能为空！');
                    }else if(res['type'] == 'old_mobile'){
                        fun.toast('旧手机号码不能为空！');
                    }else if(res['type'] == 'code'){
                        fun.toast('验证码不能为空！');
                    }else if(res['type'] == 'code'){
                        fun.toast(res['msg']);
                    }
                    break;
                case 104:
                    fun.toast('该手机已被注册过。');
                    break;
                case 105:
                    fun.toast('验证码错误！');
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    })
}
