var html_name=page_arr.select_bank;
var page_url;

var search_data = {keyword:''};

$('#header').header({
    back: true,
    add: Auth.check('zh','edit'),
    title: '账户',
    foot_input: {
        show: true,
        plader: '搜索'
    },
});

page_init = function(){
    //ios头部穿透
    // fun.pierceThrough('.account-list');
    switch(page_data['page_type']){
        // case "zh":
        //     page_url = AJAX_URL.getBankList;//含简称
        //     break;
        case "xz_zh":
            page_url = AJAX_URL.getBankName;//不含简称
            $('#add_btn').hide();
            break;
    }
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch(temp['status']){
            case 'refresh':
              getList();
            break;
        }
    });
    getList();

    fun.orderListHeight({dom:'#list'});
}

function getList(params){
    fun.ajax({
		showLoad:true,
		hideLoad:true,
		url:page_url,
		data:$.extend({},{
            "keyword":"",
            "keyword_key": ['name','simple'],
            "is_stop":0
        }, params),
		success:function(res){
			if(res['status'] == 0){
                if(res['data'].length == 0){
                    // $('.content').css({'height': 'calc(100% - 6.7rem)', 'position': 'fixed'});
                    // return $('#list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#list',btnShow:false,style:'top:-0.5rem;height:10rem;'});
                }
                showList(res.data);
            } else {
                fun.alert({msg: '网络异常！'});
            }
		}
	})
}

function showList(data){
    var html = [];
    $(data).each(function(i,obj){

        // console.log(obj['name'])

        html.push('<li data-list_data=\''+fun.formatString(JSON.stringify(obj))+'\' id="'+(obj['id'] || 0)+'" name="'+fun.is_value(obj['name'])+'" class="account-list lower-border-line">');
        html.push('    <img src="../img/bank/'+obj['icon']+'" class="bank">');
        html.push('    <span class="summary">'+(fun.redFont(fun.is_value(obj['name']),search_data['keyword']||''))+'</span>');
        // html.push('    <div class="vessel">');
        // html.push('        <span class="text">公户</span>');
        // html.push('  </div>');
        html.push('</li>');
    })
    $('#list').html(html.join(''));
}

// 搜索
// $('#foot_search').on('input',function(){
//     getList({
//         "keyword":$(this).val().trim()
//     });
// })

//点击键盘搜索
$("body").bind('search','#foot_search', function(){
    search_data['keyword'] = $('#foot_search').val().trim();
    $('#list').empty();
    getList({
        "keyword":$('#foot_search').val().trim()
    });
});

//员工编辑
$('#add_btn').on('tap',function(){
	fun.showPageFull({
		page_url:page_arr.account_add,
		pageParam:{
      "return_page":html_name,
      "status": 'add',
      "page_type":page_data.page_type
    }
	});
});

// 返回选中值
$('body').on('tap','.account-list',function(){
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'select_list',
            'data': {
                "id":$(this).attr('id'),
                "select_val":$(this).attr('name'),
                "page_type":page_data['page_type'],
                "list_data": $(this).data('list_data')
            }
        }
    });
    api.closeWin();
})
