var html_name = page_arr.set_gjsz;
var gjsz = {};
/******头部显示******/
$("#header").header({
    back: true,
    title: '高级设置'
});

// 初始化极光推送id
gjsz.initGetJgId = function () {
    gjsz.ajPush = api.require('ajpush'); // 导入推送模块
    gjsz.ajPush.init(function (ret) {
        gjsz.ajPush.getRegistrationId(function (ret, err) {
            gjsz.jgId = ret.id;
        });
    })
}

// 高级设置列表
gjsz.switchArr = [
    {
        type: 'ycwktgn',
        selector: '#ycwkt'
    }
    // {
    //     type: 'skyybb',
    //     selector: '#yybb'
    // }
];

// 拿到要显示隐藏的元素
// gjsz.getSelectorGather = function () {
//     var str = '';
//     for (var i = 0; i < gjsz.switchArr.length; i++) {
//         var item = gjsz.switchArr[i];
//         str += '[data-type="' + item['type'] + '"]';
//     }
//     return str;
// }

// 根据权限显示隐藏
gjsz.checkHide = function () {
    // var tempSelector = gjsz.getSelectorGather();
    // 
    if (AuthVersionCheck.checkHide('gjsz')) {
        $('.content').hide();
    } else {
        $('.content').show();
    }
}

// 按钮打开
gjsz.switchActive = function (type) {
    $(type).addClass('nui-active').removeClass('nui-unactive');
}

// 按钮关闭
gjsz.switchUnActive = function (type) {
    $(type).addClass('nui-unactive').removeClass('nui-active');
}

// 初始化页面开关设置按钮样式
gjsz.initSwitchStyle = function (res) {
    for (var i = 0; i < this.switchArr.length; i++) {
        var item = this.switchArr[i];
        if ($.nui.isTrue(res[item.type])) {
            this.switchActive(item.selector);
        } else {
            this.switchUnActive(item.selector);
        }
    }

    H5PAY && gjsz.initSkyybbSwitch();
}

// 设置收款语音播报开关状态
gjsz.skyybbSwtich = function (isPush) {
    if (isPush) {
        gjsz.switchActive('#yybb');
    } else {
        gjsz.switchUnActive('#yybb');
    }
}

// 初始化语音播报开关状态
gjsz.initSkyybbSwitch = function () {
    fun.getSkyybbStatus({
        callBack: gjsz.skyybbSwtich
    })
}

// 获取语音播报是否开启
gjsz.getIsEnabledYybb = function () {
    return $('#yybb').hasClass('nui-active') ? 1 : 0;
}

// 获取保存语音播报数据
gjsz.saveYybbAjaxData = function () {
    var ajaxParams = fun.getSetBindAjaxData();
    ajaxParams.jiguang_id = gjsz.jgId;
    ajaxParams.is_push = gjsz.getIsEnabledYybb();
    return ajaxParams;
}

// 保存语音播报
gjsz.saveYybb = function () {
    $.ajax({
        type: "POST",
        url: AJAX_URL.setBind,
        data: {
            data: gjsz.saveYybbAjaxData()
        },
        success: function (res) {
            if (res.status === 0) {
                gjsz.sendEvent();
            } else {

            }
        },
        error: function () {

        }
    });
}

// 保存成功发送事件监听
gjsz.sendEvent = function () {
    setTimeout(function () {
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'refresh'
            }
        });
        api.sendEvent({
            name: page_arr.index,
            extra: { 'status': 'reload' }
        });
    }, 100);
}

page_init = function () {
    if (H5PAY) {
        $('[data-type="skyybb"]').show();
    } else {
        $('[data-type="skyybb"]').hide();
    }
    init();
    bindEvent();
};

function init() {
    H5PAY && gjsz.initGetJgId();
    gjsz.checkHide();
    fun.load_DATA_LIST(['sys_config'], function (res) {
        gjsz.initSwitchStyle(res);
    });
}

function bindEvent() {
    $('body').on('tap', '#ycwkt', function (e) {
        e.stopPropagation();
        saveData();
    });

    // 语音播报推送开关
    $('body').on('tap', '#yybb', function () {
        gjsz.saveYybb();
    })
}

function getSaveData() {
    var save_data = {
        "type": "sys",
        "list": [
            { "key": "ycwktgn", "value": $('#ycwkt').hasClass('nui-active') ? 1 : 0 }
            // { "key": "skyybb", "value": $('#yybb').hasClass('nui-active') ? 1 : 0 }
        ]
    };
    return save_data;
}

function saveData() {
    var save_data = getSaveData();
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveSysConfig,
        data: save_data,
        success: function (res) {
            if (res['status'] == 0) {
                fun.load_DATA_LIST(['sys_config']);
                gjsz.sendEvent();
            } else {
                fun.toast('保存失败');
            }
        }
    });
}