var html_name = page_arr.share_pictures;
$('#header').header({
    back: true,
    title: '递名片'
});

var fxtp_config = {
    'gs': true,
    'cf': false,
    'fk': true,
    'dj': true
};

var SYS_CONFIG = {};

var assess_token_info = {};
var assess_token_xcx = {};
var mycanvas, canvas_pictures;
var width, height, prewin, prehei;
//判断设备类型
var equipment = navigator.userAgent;
page_init = function () {
    SYS_CONFIG = fun.getItem('sys_config') || {};
    assess_token_info = fun.getItem('assess_token_info') || {};
    assess_token_xcx = fun.getItem('assess_token_xcx') || {};

    fun.load_DATA_LIST(['sys_config'], function () {
        SYS_CONFIG = fun.getItem('sys_config') || {};
    });

    fxtp_config = $.extend({}, fxtp_config, fun.getItem('fxtp_config') || {});

    // console.log(JSON.stringify(fxtp_config))
    getList();

}

//获取公司信息
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getCompanyList,
        data: {},
        success: function (res) {
            if (res['status'] === 0) {
                showData(res.data || []);
            }
        }
    });
}

//显示数据
function showData(data) {
    // console.log(JSON.stringify(page_data['data']))
    // console.log(JSON.stringify(data))
    // console.log(JSON.stringify(fxtp_config))
    // console.log(JSON.stringify(SYS_CONFIG))

    var product_data = page_data['data'];
    mycanvas = document.getElementById('mycanvas');
    width = screen.availWidth;
    height = screen.availHeight;
    prewin = width / 1080;
    prehei = height / 1920;
    // console.log(prewin)
    // console.log(prehei)
    //屏幕可用
    mycanvas.width = width;
    mycanvas.height = height * 0.90;

    //画服务号二维码
    if (fxtp_config['fwh']) {
        var fwhmy = SYS_CONFIG['fwhmy'];
        var fwhappid = SYS_CONFIG['fwhappid'];
        var url = 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=' + fwhappid + '&secret=' + fwhmy;
        // console.log(new Date().getTime())
        // console.log(assess_token_info['former_time'])
        // console.log(new Date().getTime() - assess_token_info['former_time'])
        if ($.nui.isTrue(assess_token_info) && assess_token_info['assess_token'] && (new Date().getTime() - assess_token_info['former_time']) < 7200000) {
            var ewm_url = 'https://api.weixin.qq.com/cgi-bin/qrcode/create?access_token=' + assess_token_info['assess_token'] + '&type=jsapi';
            setCode(ewm_url);
        } else {
            // console.log(JSON.stringify(url))
            $.ajax({
                url: url,
                type: "get",
                async: true,
                success: function (result) {
                    console.log(JSON.stringify(result))

                    if (result['errcode']) {
                        switch (result['errcode']) {
                            case 40013:
                                fun.toast('无效的服务号APPID!');
                                break;
                            case 40125:
                                fun.toast('无效的服务号密钥!');
                                break;
                            case -1:
                                fun.toast('系统繁忙,请稍后重试。');
                                break;
                            case 40001:
                                fun.toast('服务号密钥错误或者服务号密钥不属于这个公众号。');
                                break;
                            case 40002:
                                fun.toast('未知错误！');
                                break;
                            case 40164:
                                fun.toast('无效的ip！');
                                break;
                        }
                    } else {
                        //本地存储
                        fun.setItem('assess_token_info', {
                            assess_token: result['access_token'],
                            former_time: new Date().getTime()
                        });
                        var access_token = result['access_token'];
                        var ewm_url = 'https://api.weixin.qq.com/cgi-bin/qrcode/create?access_token=' + access_token + '&type=jsapi';
                        setCode(ewm_url);
                    }

                },

            });
        }

    }

    //画小程序图片
    if (fxtp_config['xcx']) {
        //获取系统设置
        var xscmy = SYS_CONFIG['xscmy'];
        var xcxappid = SYS_CONFIG['xcxappid'];
        // console.log(JSON.stringify(assess_token_xcx))
        console.log(new Date().getTime() - assess_token_xcx['former_time'])
        // console.log(JSON.stringify(assess_token_xcx))

        var url = 'https://api.weixin.qq.com/cgi-bin/token?grant_type=client_credential&appid=' + xcxappid + '&secret=' + xscmy;
        if ($.nui.isTrue(assess_token_xcx) && assess_token_xcx['assess_token'] && (new Date().getTime() - assess_token_xcx['former_time']) < 7200000) {
            ewm_url = assess_token_xcx['assess_token'];
            // var ewm_url = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token=' + assess_token_xcx['assess_token'] + '&type=jsapi';
            console.log('============')
            setSmall(ewm_url);
        } else {
            $.ajax({
                url: url,
                type: "get",
                async: true,
                success: function (result) {
                    console.log(JSON.stringify(111111111111111))
                    console.log(JSON.stringify(result))
                    if (result['errcode']) {
                        switch (result['errcode']) {
                            case 40013:
                                fun.toast('无效的服务号APPID!');
                                break;
                            case 40125:
                                fun.toast('无效的服务号密钥!');
                                break;
                            case -1:
                                fun.toast('系统繁忙,请稍后重试。');
                                break;
                            case 40001:
                                fun.toast('服务号密钥错误或者服务号密钥不属于这个公众号。');
                                break;
                            case 40002:
                                fun.toast('未知错误！');
                                break;
                            case 40164:
                                fun.toast('无效的ip！');
                                break;
                        }
                    } else {
                        //本地存储
                        console.log('本地存储')
                        fun.setItem('assess_token_xcx', {
                            assess_token: result['access_token'],
                            former_time: new Date().getTime()
                        });
                        var access_token = result['access_token'];
                        setSmall(access_token);
                    }

                },

            });
        }

    }

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpcpbjList,
        data: {
            "type": "list",
            "cp_id": product_data['id']
        },
        success: function (res) {
            if (res['status'] == 0) {

                    
                
                    var text = mycanvas.getContext('2d');
                    text.fillStyle = "rgb(0,0,0)";
                    if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1) {
                        //安卓手机
                        text.font = "24px sans-serif";
                    } else if (equipment.indexOf('iPhone') > -1) {
                        //苹果手机
                        text.font = "22px sans-serif";
                    } else {
                        text.font = "28px sans-serif";
                    }

                    //圆角矩形函数
                    function drawRoundRect(cxt, x, y, width, height, radius){
                        cxt.beginPath();
                        cxt.arc(x + radius, y + radius, radius, Math.PI, Math.PI * 3 / 2);
                        cxt.lineTo(width - radius + x, y);
                        cxt.arc(width - radius + x, radius + y, radius, Math.PI * 3 / 2, Math.PI * 2);
                        cxt.lineTo(width + x, height + y - radius);
                        cxt.arc(width - radius + x, height - radius + y, radius, 0, Math.PI * 1 / 2);
                        cxt.lineTo(radius + x, height +y);
                        cxt.arc(radius + x, height - radius + y, radius, Math.PI * 1 / 2, Math.PI);
                        cxt.closePath();
                    }
                    
                    //背景
                    var canvas = mycanvas.getContext('2d');    
                    canvas.beginPath();
                    drawRoundRect(canvas, 0, 0,width, height*0.8, 10);
                    canvas.fillStyle = "rgb(255,255,255)";
                    canvas.fill();
                    
                    //边框
                    canvas.lineWidth=5;
                    drawRoundRect(canvas, 65 * prewin, 90 * prehei, 950 * prewin, 740 * prehei, 10);
                    canvas.strokeStyle = "#eee";
                    canvas.stroke();
                    canvas.closePath();
                    
                    //logo
                    var logo_img = mycanvas.getContext('2d');
                    var logo = new Image();
                    logo.src = fun.getImgPath(data['logo']);
                    logo.onload = function () {
                    logo_img.drawImage(logo, 100 * prewin, 110 * prehei, 100 * prewin, 100 * prehei);
                    //console.log('logo')


                    //公司简称
                    var text = mycanvas.getContext('2d');
                    text.fillStyle = "rgb(0,0,0)"; 
                    text.font = "17px sans-serif";
                    text.fillText(data['company'], 210 * prewin, 175 * prehei);
                    

                    //联系人照片
                    var product2 = new Image();
                    product2.src = fun.getImgPath(product_data['imgs']);
                    product2.onload = function () {
                        var gase_img = mycanvas.getContext('2d');
                        gase_img.beginPath();
                        gase_img.stroke();
                        gase_img.save();
                        gase_img.arc(470 * prewin, 345 * prehei, 27, 0, 2 * Math.PI);
                        gase_img.clip();
                        gase_img.drawImage(product2, 365 * prewin, 255 * prehei, 200 * prewin, 170 * prehei);
                        gase_img.restore();
                        gase_img.closePath();
                    }


                    //联系人名称
                    var text2 = mycanvas.getContext('2d');
                    text2.fillStyle = "rgb(0,0,0)"; 
                    text.font = "0.8rem sans-serif";
                    text2.fillText(data['lxr'], 560 * prewin, 325 * prehei);


                    //联系人电话
                    var text3 = mycanvas.getContext('2d');
                    text3.fillStyle = "rgb(3,3,3)"; 
                    text3.font = "0.7rem Arial";
                    text3.fillText(data['mobile'], 560 * prewin, 390 * prehei);   
                    //alert(JSON.stringify(data))
                    }
                    
            
                    var product_name = mycanvas.getContext('2d');
                    //手机适配
                    var component = mycanvas.getContext('2d');
                    var spec = mycanvas.getContext('2d');
                    var unit_price = mycanvas.getContext('2d');

                    
                    if (equipment.indexOf('Android') > -1 || equipment.indexOf('Linux') > -1) {
                        console.log('安卓手机')
                        //安卓手机
                        product_name.font = "30px sans-serif";
                        component.font = "22px sans-serif";
                        spec.font = "22px sans-serif";
                        unit_price.font = "22px sans-serif";
                    } else if (equipment.indexOf('iPhone') > -1) {
                        console.log('苹果手机')
                        //苹果手机
                        product_name.font = "26px sans-serif";
                        component.font = "20px sans-serif";
                        spec.font = "20px sans-serif";
                        unit_price.font = "20px sans-serif";
                    } else {
                        console.log('其他')
                        product_name.font = "30px sans-serif";
                        component.font = "26px sans-serif";
                        spec.font = "26px sans-serif";
                        unit_price.font = "26px sans-serif";
                    }

                    //图标
                    var context1 = mycanvas.getContext('2d');
                    context1.beginPath();
                    context1.font="0.5rem IconFont";  // 将这里的Arial 设置为自己图标库的名称
                    //主营图标
                    var icon1 = eval('("'+'&#xe63b;'.replace('&#x','\\u').replace(';','')+'")')
                    context1.fillStyle= "#8d8d8d";
                    context1.fillText(icon1,100 * prewin, 530 * prehei);
                     //座机图标
                     var icon2 = eval('("'+'&#xe61c;'.replace('&#x','\\u').replace(';','')+'")')
                     context1.fillText(icon2,100 * prewin, 610 * prehei);
                    //档口地址
                    var icon3 = eval('("'+'&#xe678;'.replace('&#x','\\u').replace(';','')+'")')
                     context1.fillText(icon3,100 * prewin, 690 * prehei);
                    //仓库地址
                    var icon4 = eval('("'+'&#xe695;'.replace('&#x','\\u').replace(';','')+'")')
                     context1.fillText(icon4,100 * prewin, 770 * prehei);
                    //邮箱地址
                    var icon5 = eval('("'+'&#xe684;'.replace('&#x','\\u').replace(';','')+'")')
                     context1.fillText(icon5,460 * prewin, 610 * prehei);

                    
                    text4 = mycanvas.getContext('2d');
                    text4.fillStyle = "#8d8d8d";
                    text4.font = "0.6rem sans-serif";

                    //主营
                    if($.nui.isTrue(data['zyjy'])){  
                        text4.fillText('主营 : '+data['zyjy'], 140 * prewin, 530 * prehei);   
                    } 
                    //座机
                    if($.nui.isTrue(data['zyjy']) && $.nui.isTrue(data['zyjy'])){
                        text4.fillText('座机 : '+data['phone'], 140 * prewin, 610 * prehei);
                    }else{
                        text4.fillText('座机 : '+data['phone'],  140 * prewin, 530 * prehei);
                    }
                    
                   
                    text4.fillText('档口 : '+data['xx_address'], 140 * prewin, 690 * prehei);
                    text4.fillText('仓库 : '+data['phone'], 140 * prewin, 770 * prehei);
                    text4.fillText('邮箱 : '+'56544548844@qq.com', 500 * prewin, 610 * prehei);

              
                
                 
            }
        }
    });

}

function setImges(data) {

}

//获取服务号二维码
function setCode(data) {
    ewm_url = data;
    $.ajax({
        url: ewm_url,
        type: "POST",
        dataType: "json",
        data: JSON.stringify({
            "action_name": "QR_LIMIT_STR_SCENE",
            "action_info": {
                "scene": {
                    "scene_str": "test"
                }
            }
        }),
        async: true,
        success: function (data) {
            // console.log(JSON.stringify(data))
            if (data['ticket']) {
                //接口B：适用于需要的码数量极多的业务场景
                // var code_url = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token='+(data['ticket']);
                //接口A: 适用于需要的码数量较少的业务场景
                var code_url = 'https://mp.weixin.qq.com/cgi-bin/showqrcode?ticket=' + (data['ticket']);
                //接口C: 适用于需要的码数量较少的业务场景
                // var code_url = 'https://api.weixin.qq.com/cgi-bin/wxaapp/createwxaqrcode?access_token=' + (data['ticket']);
                var ewm_img = mycanvas.getContext('2d');
                var qr_code = new Image();
                qr_code.src = code_url;
                // console.log(JSON.stringify(code_url))
                qr_code.onload = function () {
                    ewm_img.drawImage(qr_code, 800 * prewin, 1480 * prehei, 210 * prehei, 210 * prehei);
                    // console.log('服务号ewm')
                    // ewm_img.globalCompositeOperation = "destination-over";
                }
            } else {
                fun.toast('获取二维码失败.');
                fun.setItem('assess_token_info', {});
                // getList();
            }
        },
    });
}

//获取小程序二维码
function setSmall(data) {
    var ewm_url = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token=' + data;
    console.log('-------------------')
    console.log(data)
    console.log(JSON.stringify(ewm_url))
    // console.log(JSON.stringify({access_token: data, scene: 123,is_hyaline: true,width:430,page:''  }))

    // ewm_url = data;
    $.ajax({
        url: ewm_url,
        type: "post",
        // dataType: "json",
        // data: JSON.stringify({}),
        data: JSON.stringify({
            "scene": "000",
            "page": "pages/index/index"
        }),
        async: true,
        contentType: 'image/jpeg',

        success: function (data) {
            if (data['errcode'] && data['errcode'] == 40001) {
                fun.toast('当前二维码不是最新的，请重新获取.');
                fun.setItem('assess_token_xcx', {});
                getList();
            }
            console.log(JSON.stringify(data))

            console.log('*****************************************')

            // function transformArrayBufferToBase64 (buffer) {
            //     var binary = '';
            //     var bytes = new Uint8Array(buffer);
            //     for (var len = bytes.byteLength, i = 0; i < len; i++) {
            //         binary += String.fromCharCode(bytes[i]);
            //     }
            //     return window.btoa(binary);
            // }
            // var img = 'https://api.weixin.qq.com/wxa/getwxacodeunlimit?access_token='+JSON.stringify(data);
            // console.log(JSON.stringify(data))
            var xcx_img = mycanvas.getContext('2d');
            var xcz_code = new Image();
            xcz_code.src = data;
            $('#imgs').attr('src', data)
            xcz_code.onload = function () {
                xcx_img.drawImage(xcz_code, 520, 695, 125, 125);
                console.log('xcx1')
                // ewm_img.globalCompositeOperation = "destination-over";
            }
        },
        error: function (err) {
            console.log(JSON.stringify(666))
            console.log(JSON.stringify(err))
            var ewm_img = mycanvas.getContext('2d');
            var qr_code = new Image();
            qr_code.src = err;
            qr_code.onload = function () {
                ewm_img.drawImage(qr_code, 520, 695, 125, 125);
                console.log('xcx2')
                // ewm_img.globalCompositeOperation = "destination-over";
            }
            // $('#imgs').attr('src',err['responseText'])
        }
    });
}

$('#keep').on('tap', function () {
    // console.log(JSON.stringify(666))
    // getList();
    setImges();
})


//微信好友
$('#friend').on('tap', function () {
    canvas_pictures = mycanvas.toDataURL('image/png');
    // console.log(JSON.stringify(66666666666))
    // console.log(JSON.stringify(canvas_pictures))
    var imgs;
    var wx = api.require('wxPlus');
    if (!checkWxUseable(wx)) return false;
    wx.isInstalled(function (ret, err) {
        if (ret.installed) {
            var wx = api.require('wxPlus');
            var trans = api.require('trans');
            //x上限，y下限
            var x = 100000000;
            var y = 0;
            var rand = parseInt(Math.random() * (x - y + 1) + y);
            var url_pictures = canvas_pictures.split(',')[1];
            // console.log(JSON.stringify(url_pictures))
            trans.saveImage({
                base64Str: url_pictures,
                album: false,
                imgPath: "widget://res",
                imgName: "cp" + rand + ".png"
            }, function (ret, err) {
                if (ret.status) {
                    imgs = "widget://res/cp" + rand + ".png";
                    if (!checkWxUseable(wx)) return false;
                    wx.shareImage({
                        apiKey: '',
                        scene: 'session',
                        contentUrl: imgs,
                    }, function (ret, err) {
                        console.log(JSON.stringify(ret))
                        if (ret.status) {
                        } else {
                            switch (err.code) {
                                case -1:
                                    fun.toast('未知错误！');
                                    break;
                                case 2:
                                    fun.toast('取消分析.');
                                    break;
                                case 3:
                                    fun.toast('发送失败！');
                                    break;
                                case 4:
                                    fun.toast('授权失败！');
                                    break;
                            }
                        }
                    });
                } else {
                    fun.toast(JSON.stringify(err));
                }
            });
        } else {
            return fun.toast('请您安装微信后重试');
        }
    });
})

//朋友圈
$('#circle').on('tap', function () {
    canvas_pictures = mycanvas.toDataURL('image/png');
    // console.log(JSON.stringify(canvas_pictures))
    var wx = api.require('wxPlus');
    if (!checkWxUseable(wx)) return false;
    wx.isInstalled(function (ret, err) {
        if (ret.installed) {
            var wx = api.require('wxPlus');
            var trans = api.require('trans');
            //x上限，y下限
            var x = 100000000;
            var y = 0;
            var rand = parseInt(Math.random() * (x - y + 1) + y);
            var url_pictures = canvas_pictures.split(',')[1];
            // console.log(JSON.stringify(url_pictures))
            trans.saveImage({
                base64Str: url_pictures,
                album: true,
                imgPath: "widget://res",
                imgName: "cp_pyq" + rand + ".png"
            }, function (ret, err) {
                if (ret.status) {
                    imgs = "widget://res/cp_pyq" + rand + ".png";
                    if (!checkWxUseable(wx)) return false;
                    wx.shareImage({
                        apiKey: '',
                        scene: 'timeline',
                        contentUrl: imgs,
                    }, function (ret, err) {
                        console.log(JSON.stringify(ret))
                        if (ret.status) {
                        } else {
                            switch (err.code) {
                                case -1:
                                    fun.toast('未知错误！');
                                    break;
                                case 2:
                                    fun.toast('取消分析.');
                                    break;
                                case 3:
                                    fun.toast('发送失败！');
                                    break;
                                case 4:
                                    fun.toast('授权失败！');
                                    break;
                            }
                        }
                    });
                } else {
                    fun.toast(JSON.stringify(err));
                }
            });
        } else {
            return fun.toast('请您安装微信后重试');
        }
    });
});

//保存图片
$('#keep').on('tap', function () {
    canvas_pictures = mycanvas.toDataURL('image/png');
    var trans = api.require('trans');
    //x上限，y下限
    var x = 100000000;
    var y = 0;
    var rand = parseInt(Math.random() * (x - y + 1) + y);
    var url_pictures = canvas_pictures.split(',')[1];
    trans.saveImage({
        base64Str: url_pictures,
        album: true,
        imgPath: "widget://res",
        imgName: "cp" + rand + ".png"
    }, function (ret, err) {
        if (ret.status) {
            fun.toast('保存成功');
        } else {
            fun.toast(JSON.stringify(err));
        }
    });
})



