var html_name = page_arr.dk_bj;
$('#header').header({
    back: true,
    title: '底卡信息',
});

page_init = function () {

    //监听页面返回值
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value']['data'];
        switch (temp['page_type']) {
            case 'gys':
            case 'jgs':
            case 'wl':
                $('#wldw_val').val(temp['select_val'] || "").data('wldw_id', temp['id'] || 0);
                break;
            case 'dw':
                $('.unit').text(temp['select_val'] || '').data('unit_id', temp['id'] || 0);
                break;
        }
    });
    fun.inputType();
}



/*****产品主图*****/
$('body').on('touchstart', '#cpzt-img .img', function () {
    var cpzt_index = $("#cpzt-img .img").index(this);
    press_startTime = +new Date();
    press_Time = setTimeout(function () {
        if ($("#cpzt-img .img").eq(cpzt_index).attr("src") != '../../img/null.png') {
            var newcircle = $(".news-circle");
            if (newcircle.eq(cpzt_index).css("display") == "none") {
                newcircle.eq(cpzt_index).css("display", "block");
            } else if (newcircle.eq(cpzt_index).css("display") == "block") {
                newcircle.eq(cpzt_index).css("display", "none");
            }
        } else {
            $("#add-picture,.box").css("display", "block");
        }
    }, 500);

});

$('body').on('touchend', '#cpzt-img .img', function () {
    press_endTime = +new Date()
    clearTimeout(press_Time)
    if (press_endTime - press_startTime >= 500) {

    }
});

// ********点击预览图片******
$('body').on('click', '#cpzt-img .img', function () {
    press_endTime = +new Date();
    var cpzt_index2 = $("#cpzt-img .img").index(this);
    clearTimeout(press_Time);
    if (press_endTime - press_startTime < 500) {
        if ($("#cpzt-img .img").eq(cpzt_index2).attr("src") != '../../img/null.png') {
            var img_arr = [];
            img_arr.push($(this).data('url'))
            var photoBrowser = api.require('photoBrowser');
            photoBrowser.open({
                images: img_arr,
                activeIndex: cpzt_index2,
                placeholderImg: '../../img/logo.png',
                bgColor: '#000'
            }, function (ret, err) {
                if (ret) {
                    if (ret['eventType'] == 'click') {
                        photoBrowser.close();
                    }
                }
            });

        } else {
            $("#add-picture,.box").css("display", "block");
        }
    }
});


//选择往来单位类型
var type_data = [
    { id: 1, name: '供应商', db_name: 'gys_name', "is_choose": 1 },
    { id: 2, name: '客户', db_name: 'kh' },
    { id: 3, name: '加工商', db_name: 'jgs_name' },
];
// ********点击切换客户、供应商、加工商******
$('#gys_name').on('click', function () {
    var _this = $(this);
    fun.showBookList({
        width: '280px',
        shadeClose: true,
        list: type_data,
        choose: function (res) {
            $(type_data).each(function (i, obj) {
                if (obj['id'] == res['id']) {
                    type_data[i]['is_choose'] = 1;
                } else {
                    type_data[i]['is_choose'] = 0;
                }
            })
            $('#gys_name').text(res['name'] || "").data('wldw', (res['db_name'] || ""));
        }
    });
});
//选择往来单位
$('#wldw_val').on('tap', function () {
    var sib = $(this).siblings('#gys_name').data('wldw');
    fun.showPageFull({
        page_url: '../' + page_arr.customer_search,
        pageParam: {
            return_page: html_name,
            page_type: sib
        }
    })
})
//选择单位
$('#batch_unit').on('tap', function () {
    fun.showPageFull({
        page_url: '../' + page_arr.select_list,
        pageParam: {
            "return_page": html_name,
            "page_type": 'dw'
        }
    });
})

// *****渲染编辑对面色号和名称****
function editColour($this) {
    var html = [];
    html.push('  <div class="warm"> ');
    html.push('   <div class="warm-title"> ');
    html.push('    <span class="title" >对方叫法</span> ');
    html.push('   </div> ');
    html.push('   <div class="warm-con"> ');
    html.push('    <ul> ');
    html.push('     <li class="obj-title"> <span class="param">色号</span> <input id="colour_number" type="text" value=""> </li> ');
    html.push('     <li class="obj-title"> <span class="param">名称</span> <input id="color_name" type="text" value=""> </li> ');
    html.push('    </ul> ');
    html.push('   </div> ');
    html.push('   <div class="warm-operation"> ');
    html.push('    <button class="btn" id="cancel">取消</button>');
    html.push('    <button class="btn" id="confirm">确认</button> ');
    html.push('   </div> ');
    html.push('  </div>');
    layer.open({
        type: 1,
        content: html.join(''),
        shadeClose: false,
        style: 'width: 90%; min-height: auto; border-radius: 0.5rem;background-color: #fff; overflow-y: hidden;',
        success: function (ele) {

            // ***取消***
            $('#cancel').on('click', function () {
                setTimeout(function () {
                    layer.closeAll()
                }, 50)
            });

            // ****确定***
            $('#confirm').on('tap', function () {
                var numval = $('#colour_number').val();
                var color_name = $('#color_name').val();
                if ($('#colour_number').val() == '') {
                    fun.toast('色号不能为空');
                } else if ($('#color_name').val() == '') {
                    fun.toast('名称不能为空');
                } else {
                    $this.text(numval + color_name)
                    setTimeout(function () {
                        layer.closeAll()
                    }, 50)
                }
            })
        }
    });
}


// *******点击编辑对方色号和名称****
$('.order').on('tap', function (e) {
    var $this = $(this);
    editColour($this);
});


/******统一价格 */
$('.money').on('keyup', function () {
    var inpval = $('.money').val();
    inpval = Number(inpval);
    if ($('.money').val() == '') $('.jiage-inp').val('');
    if ($('.money').val() !== '' && inpval >= 0) {
        $('.jiage-inp').val(inpval);
    }
})

// *****价格******
$('.jiage-inp').blur(function () {
    var mival = $(this).val();
    if (mival == '') {
        $(this).val(0)
    } else if (mival > 0 && mival !== '') {
        $(this).val(mival)
    }
})

// parseFloat(mival.toFixed(4))
// ******只能输入小数点4位*****

function is_event(state) {
    if (!state) {
        $('#add_btn').css('visibility', 'hidden');
        $('.pack').show();
        $('.pack').addClass('changes');
        $('.list-term').addClass('label_shake');
        Sortable.options.disabled = false;
        is_edit = true;
    } else {
        $('#add_btn').css('visibility', 'visible');
        $('.pack').hide();
        $('.pack').removeClass('changes');
        $('.list-term').removeClass('label_shake');
        Sortable.options.disabled = true;
        is_edit = false;
    }
}

// 支持拖拽效果
var Sortable = new Sortable($('#cpzt-img')[0], {
    animation: 150,
    // disabled: true,
});

/***取消新增图片选项***/
$('#cancelPhoto').on('tap', function () {
    $('#add-picture,.box').css("display", "none");
});


/******拍照*****/
$('#paizhao').on('tap', function () {
    $('#add-picture,.box').hide();
    QuestPermission.requestPermission('camera', null,function () {
        api.getPicture({
            sourceType: 'camera',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: false,
            quality: 100,   //图片质量
            saveToPhotoAlbum: false
        }, function (ret, err) {
            // alerts(ret);
            // ret['data']//路径  // ret['base64Data']//base64码 
            if (ret['data'] != '' || ret['base64Data'] != '') {
                addPic(ret);
            }
        });
    });
    
});



/***从相册中选择***/
$('#selectPhoto').on('tap', function () {
    $('#add-picture,.box').hide();
    QuestPermission.requestPermission('camera', null,function () {
        api.getPicture({
            sourceType: 'album',
            encodingType: 'jpg',
            mediaValue: 'pic',
            destinationType: 'base64',
            allowEdit: false,
            quality: 100,   //图片质量
            saveToPhotoAlbum: false
        }, function (ret, err) {
            // alerts(ret);
            // ret['data']//路径  // ret['base64Data']//base64码 
            if (ret['data'] != '' || ret['base64Data'] != '') {
                addPic(ret);
            }
        });
    });
    
});

//加载图片到页面上
function addPic(url) {
    var html = [];
    html.push(' <li class="show-img" id="show_img">');
    html.push('     <img src="' + url['base64Data'] + '" class="img" data-url="' + url['data'] + '">');
    html.push('     <div class="iconfont icon-shanchu11 news-circle"></div>');
    html.push(' </li>');
    $('#add-pic').before(html.join(''));
    var img_length = $('.show-img').length;
    if (img_length <= 9) $('#pic-number').text(img_length);
    if (img_length == 9) $('.null-img').hide();

}

// *****点击删除按钮出现提示语*******
$('body').on('touchstart', '#cpzt-img .news-circle', function () {
    var pic = $(this).parent();
    fun.dialog({
        content: '你确定要删除主图吗？',
        btn: ['删除', '取消'],
        isClose: false,
        yes: function () {
            pic.remove();//删除对应的图片
            if ($('.show-img').length > 9) {//如果是小于9张图的话，要显示null图
                $('.null-img').show();
            }
            $('#pic-number').text($('.show-img').length);
            layer.closeAll();//关闭弹窗

        }
    });
});


function showColor(data) {
    var html = [];
    for (var i = 0; i < data.length; i++) {
        var data_list = data[i];
        var is_stop = data_list['is_stop'] ? 'yby-deletexian' : '';
        html.push('<li class="lower-border-line clear opacity8">');
        html.push('     <p class="color float-left ' + is_stop + '">' + (data_list['cp_ys_bh'] + data_list['cp_ys_mc']) + '</p>');
        html.push('     <p class="order float-left">' + data_list['cp_ys_fz_bh'] + data_list['cp_ys_fz_mc'] + '</p>');
        html.push('     <p class="price float-left">');
        html.push('         <span class="color-button-red jiage float-left">');
        html.push('             <input id="jiage1" type="tel" class="jiage-inp num-input color-button-red" num_type="2"decimal_digits="4" value="' + (data_list['hsdj'] || 0) + '">');
        html.push('         </span>/');
        // html.push('         <span class="unit">'+(data_list['jjdw'])+'</span>');
        html.push('         <span class="unit">米</span>');
        html.push('     </p>');
        html.push('</li>');
    }
    $('#ys_bp').append(html.join(''));
}
