var html_name = page_arr.product_class_search,
    page_type;
/******头部显示******/
$("#header").header({
    back: true,
    title: '产品类别',
    add:true
});

page_init = function () {
    var title = "";
    page_type = "cp";
    getData(page_type);
}

//获取数据
function getData(page_type) {
    setTimeout(function () {
        fun.showLoad();
    },200);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSimpleRecordList,
        data: { type: page_type },
        success: function (res) {
            if (res.status != 0) return fun.toast('该数据不存在！');
            all = [];
            $('.contents').empty();
            var info_list = res.data;
            showData(getAllSon(ceilFormat(sortByKey(info_list))));
            setTimeout(function () {
                fun.hideLoad();
            },400);
        }
    });
    // fun.load_DATA_LIST([page_type]);
}

function showData(data){
  $('.contents').empty();
  var list = [];
  for (var x = 0; x < data.length; x++) {
      var steps;//判断层级
      var ptype = data[x]['parent_id'];
      if (!ptype) {//如果父级为空，则为第一级
          steps = 1;
          create(steps, data[x]);
      } else {
          var step = $("[stype='" + ptype + "']").parent().attr('step');
          var objs = $("[stype='" + ptype + "']");
          if (ptype == objs.attr('stype')) {
              step++;
              create(step, data[x]);
          }
      }
  }

  function create(st, datas) {
      var son = datas['son'];
      var list = [];
      var tip_dis = (parseInt(st) + 1.1);
      list.push('<ul class="swipe-delete swipe-delete' + st + '" step=' + st + '>');
      list.push('<li class="account-list lower-border-line" data-row=\'' + JSON.stringify(datas) + '\' son="' + son + '" type="' + datas.type + '" id="' + datas.id + '" name="' + datas.name + '" stype="' + datas.id + '" ptype="' + datas.parent_id + '">');
      list.push('<div class="le" sort="' + datas.sort + '" simple="' + datas.simple + '" create_time="' + datas.create_time + '" update_time="' + datas.update_time + '">');
      list.push('<p class="le_top"><span class="color-number" style="margin-left:' + st + 'rem" number="' + datas.number + '">' + datas.name + '</span>');
      // if (Auth.check(page_type, 'edit')) {
          list.push('<i class="iconfont icon-tianjia"></i>');
      // }
      list.push('</p>');
      list.push('<p class="le_btn">');
      if(st == 1){
        list.push('<i class="iconfont icon-xxmm" style="left:' + st + 'rem"></i>');
      }else{
        list.push('<i class="iconfont icon-lock" style="left:' + st + 'rem"></i>');
      }
      if(st == 1){
        list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">所有人可见</span>');
      }else{
        list.push('<span class="tip_text" style="left:' + tip_dis + 'rem">指定客户可见</span>');
      }
      list.push('</p>');
      list.push('<div class="slids view dels1 view-btn" data-opt="views">查看产品</div>');
      list.push('<div class="slids edit dels1 edit-btn" data-opt="edit">编辑</div>');
      list.push('<div class="delete dels1 delete-btn" data-opt="delete">删除</div>');
      list.push('</div>');
      list.push('</li>');
      list.push('</ul>');
      switch (st) {
          case 1:
              $('.contents').append(list.join(''));
              list = [];
              break;
          default:
              $("[stype='" + ptype + "']").parent().append(list.join(''));
              list = [];
              break;
      }
  }

}

//如果是选择产品类型时，点击返回数据
$('body').on('tap', '.account-list', function (e) {
    e.stopPropagation();
    var data = {
        'id': $(this).attr('id'),
        "page_type": page_data['page_type'],
        "select_val": $(this).attr('name'),
        "list_data": {
            "id": $(this).attr('id'),
            "type": $(this).attr('type'),
            "name": $(this).attr('name'),
            "number": "",
            "simple": $(this).children('.le').attr('simple'),
            "parent_id": $(this).attr('ptype'),
            "sort": $(this).children('.le').attr('sort'),
            "remark": "",
            "config": [],
            "is_default": 0,
            "is_stop": 0,
            "is_sys": 0,
            "is_delete": 0,
            "is_has": 9,
            "create_time": $(this).children('.le').attr('create_time'),
            "update_time": $(this).children('.le').attr('update_time')
        }
    }
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'select_list',
            'data': data
        }
    });
    api.closeWin();
});

//对得到得数据进行排序
function sortByKey(array, key) {
    return array.sort(function (a, b) {
        var x = a[key];
        var y = b[key];
        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    });
}


function getAllSon(ars) {
    for (var j = 0; j < ars.length; j++) {
        all.push(ars[j]);
        if (!!ars[j]['son'][0]) {
            getAllSon(sortByKey(ars[j]['son'], 'sort'));
        }
    }
    return all;
}

//排序格式化
function ceilFormat(arr) {
    var p_arrs = [], c_arrs = [];
    for (var i = 0; i < arr.length; i++) {
        if (arr[i]['parent_id'] == 0) {
            p_arrs.push(arr[i]);
        } else {
            c_arrs.push(arr[i]);
        }
    }

    for (var i = 0; i < c_arrs.length; i++) {
        c_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (c_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                c_arrs[i]['son'].push(c_arrs[j]);
                // all.push(c_arrs[j]);
            }
        }
    }

    for (var i = 0; i < p_arrs.length; i++) {
        p_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (p_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                p_arrs[i]['son'].push(c_arrs[j]);
            }
        }
    }

    return sortByKey(p_arrs, 'sort');
    //sort按照升序
}

function filter(str) {
    var pattern = /[`~!@#$^&*()=|{}':;',\\\[\]\.<>\/?~！@#￥……&*（）——|{}【】'；：""'。，、？]/g;
    return str.replace(pattern, "");
}

$('body').on('tap','.dels1',function(e){
  var option_obj = $(this).data('opt');
  var url = (option_obj == 'views') ? page_arr.shop_product_view:'';
  var obj = $(this).parent().parent();//获得对象
  var parent_list = $($(this).parents('.swipe-delete')[0]);
  switch (option_obj) {
    case 'views':
    case 'edit':
      fun.showPageFull({
          page_url:url,//产品类别编辑页面
          pageParam: {
              return_page: html_name,
              class_id:obj.attr('id'),
              class_name:obj.attr('name')
          }
      });
      break;
    case 'delete':
      deleteClass(parent_list,obj);
      break;
  }
});

function deleteClass(parent_list,obj){
  fun.dialog({
      content: '你确定要删除【'+obj.attr('name')+'类别】吗？',
      btn: ['删除','取消'],
      yes: function () {
          var param = {
              'id': obj.attr('id'),
              "is_delete":0,
              'subLevel': false,
              'save_type': 'delClass'
          };
          //存在子类别
          if (parent_list.children().filter('.swipe-delete').length > 0) {
              param['subLevel'] = true;
          }
          if(param['subLevel'] === true) {
              fun.toast('有下一类别，无法删除。');
          }else {
              param['is_delete'] = 1;
              fun.ajax({
                  showLoad: true,
                  hideLoad: true,
                  url: AJAX_URL.saveSimpleRecord,
                  data: param,
                  success: function (res) {
                    // console.log(JSON.stringify(res));
                      switch (res['status']) {
                          case 0:
                              $("[stype='" + param['id'] + "']").parent().remove();
                              fun.toast('删除成功。');
                              getData(page_type);
                              break;
                          case 103:
                              fun.toast('【'+res['name']+'类别】已被调用过，无法删除。');
                              break;
                          case 104:
                              fun.toast('删除失败。');
                              break;
                      }
                  }
              });
          }
      }
  });
}

$('body').on('tap', '#add_btn', function (e) {
    e.stopPropagation();
    // fun.showPageFull({
    //     page_url:'',//产品类别编辑页面
    //     pageParam: {
    //         return_page: html_name,
    //         opt_type:'add',
    //     }
    // });
});

$('body').on('tap', ".icon-tianjia", function (e) {
    e.stopPropagation();
    // fun.showPageFull({
    //     page_url:'',//产品类别编辑页面
    //     pageParam: {
    //         return_page: html_name,
    //         opt_type:'edit',
    //     }
    // });
});
