var html_name = page_arr.shop_product_fkkz_bj;
var goods_weight = [], delete_arr = [], default_obj = {};
var fkkz_list = {
    "fk_dw": 'cm',
    "kz_dw": 'g',
};

//头部
$("#header").header({
    back: true,
    title: "幅宽克重",
    add: true,
    appendBackBtnEvt: isDataChange
})

//页面加载完毕之后
page_init = function () {
    goods_weight = page_data['list'];//上个页面传过来的数据，暂时莫得，由本地模拟
    delete_arr = page_data['delete_arr'];//上个页面传过来的被删除的数组
    default_obj = page_data['default_obj'];
    if (!$.nui.isEmpty(goods_weight)) { // 添加状态进入，没传数据，默认添加1行记录 且 开启默认
        $(goods_weight).each(function (i, tiem) {
            goods_weight[i]['sort'] = (i + 1);//将数组进行排序
        })
    }
    showList(goods_weight);

    //监听返回键
    page_data.keyback = function () {
        isDataChange();
    };

    fun.setKeyBoard({ // 处理ios和安卓键盘弹起
        isIos: {
            showFn: iosKeyBoardShow,
            hideFn: ioskeyBoardHide
        },
        // isAnd: {
        //     showFn: keyBoard
        // }
    });
}

//加载数据到页面
function showList(data) {
    $('.content').empty();
    if (data.length === 0) {
        $('.content').css({
            'background-color': '#f7f7f7',
            // 'position': 'absolute',
            'height': $(window).height() - api.safeArea.top - $('#header').outerHeight()
        })
        fun.createDataEmptyTips({ dom: '.content', btnShow: false });
        return;
    }

    var html = [];
    html.push('<ul class="message swipe-delete">');
    $(data).each(function (i, item) {

        var fk_dw = item['fk_dw'] || 'cm';
        var kz_dw = item['kz_dw'] || 'g';

        var show_fk = fun.is_value(item['width'])?fun.is_value(item['width'])+fk_dw:'';
        var show_kz = fun.is_value(item['weight'])?fun.is_value(item['weight'])+kz_dw:'';

        html.push(' <li class="lower-border-line input-width le" data-list=\'' + JSON.stringify(item) + '\'>');
        html.push('    <div class="le box">');
        html.push('         <div class="box-div">');
        html.push('             <span class="color-gray">' + (i + 1) + '.</span>');
        html.push('             <span class="margin-left-m">幅宽</span>');
        html.push('             <div class="xuanzhong">' + show_fk + '</div>');
        html.push('         </div>');
        html.push('         <div class="width-min box-div">');
        html.push('             <span class="color-gray">克重</span>');
        html.push('             <div class="xuanzhong">' + show_kz + '</div>');
        html.push('         </div>');
        html.push(item['is_default'] == 1 ? '     <div class="bg-color-blue2 default_guige box-div"></div>' : '');
        html.push('         <div class="slids dels1 delete">删除</div>');
        html.push('     </div>')
        html.push(' </li>');
    })
    html.push('</ul>');
    $('.content').html(html.join(''));
    $('.content').css({
        'background-color': '#f7f7f7',
        // 'position': 'absolute',
        'height': 'auto'
    })
}

//新增、修改幅宽克重
function addWidth(opt) {
    var html = [];
    var list = opt.list || fkkz_list,
        is_default = list && (list['is_default'] == 1) ? "nui-active" : "nui-unactive";
    console.log(list);
    html.push('  <div class="warm"> ');
    html.push('   <div class="warm-title"> ');
    html.push('    <span class="title">' + ((opt.type == "add") ? "新增幅宽克重" : "修改幅宽克重") + '</span> ');
    html.push('   </div> ');
    html.push('   <div class="warm-con"> ');
    html.push('    <ul> ');
    html.push('             <li class="obj-title"><span class="param">幅宽</span>');
    html.push('                 <span class="fzwldw-wrap"><input id="fk" value="' + (list['width'] || '') + '" /></span>');
    html.push('                 <span class="fzlx-wrap"><input id="fkdw"  readonly="readonly" type="text" value="' + (list['fk_dw'] || 'cm') + '" /><i class="iconfont icon-xia fzlx-type-down"></i></span>');
    html.push('             </li>');
    html.push('             <li class="obj-title"><span class="param">克重</span>');
    html.push('                 <span class="fzwldw-wrap"><input  id="kz" value="' + (list['weight'] || '') + '" /></span>');
    html.push('                 <span class="fzlx-wrap"><input id="kzdw"  readonly="readonly" type="text" value="' + (list['kz_dw'] || 'g') + '" /><i class="iconfont icon-xia fzlx-type-down"></i></span>');
    html.push('             </li>');
    html.push('    </ul> ');
    html.push('    <div class="shows"> ');
    html.push('     <i id="is_default" class="gg-switch stp-btn nui-switch nui-switch-md nui-switch-btn ' + is_default + '"><i class="nui-switch-handle" id="st"></i><label for="is_stop"  class="switch-label">默认</label> </i> ');
    html.push('    </div> ');
    html.push('   </div> ');
    html.push('   <div class="warm-operation"> ');
    html.push('    <button class="btn" id="cancel">取消</button>');
    html.push('    <button class="btn" id="confirm">确认</button> ');
    html.push('   </div> ');
    html.push('  </div>');
    layer.open({
        type: 1,
        content: html.join(''),
        shadeClose: false,
        style: 'width: 90%; min-height: auto; border-radius: 0.5rem;background-color: #fff; overflow-y: hidden;',//position: fixed;top: 25%;left: 5%;
        success: function (ele) {
            document.body.addEventListener('touchmove', preventDefault, { passive: false });
            //确定
            $('#confirm').on('tap', function () {
                if (typeof opt.callback == 'function') {
                    if (!$('#fk').val().trim() && !$('#kz').val().trim()) {
                        return;
                    };
                    fkkz_list = {
                        "fk_dw": $('#fkdw').val().trim(),
                        "kz_dw": $('#kzdw').val().trim(),
                    };
                    var param = {
                        // "create_time": (list['create_time'] || ''),
                        // "update_time": (list['update_time'] || ''),
                        "id": (list['id'] || 0),
                        "width": ($('#fk').val().trim() || ""),
                        "fk_dw": $('#fkdw').val().trim(),
                        "weight": ($('#kz').val().trim() || ""),
                        "kz_dw": $('#kzdw').val().trim(),
                        "is_default": ($('#is_default').hasClass('nui-active')) ? 1 : 0,
                        "is_delete": (list['is_delete'] || ''),
                        "is_stop": list['is_stop'] || 0,
                        "sort": (list['sort'] || $('.lower-border-line').length + 1 || 1),
                        "remark": (list['remark'] || '')
                    };
                    if (existFkkz(param)) return fun.toast('幅宽克重已存在。');
                    opt.callback(param);
                };
                setTimeout(function () {
                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                    layer.closeAll();
                }, 50)
            });

            //取消
            $('#cancel').on('tap', function () {
                setTimeout(function () {
                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                    layer.closeAll();
                }, 50)
            });

            // 点击单位弹出
            var fkdw_data = [
                { id: 1, name: 'cm', db_name: 'cm', "is_choose": 1 },
                { id: 2, name: 'm', db_name: 'm' },
                { id: 3, name: 'inch', db_name: 'inch' },
            ];

            var kzdw_data = [
                { id: 1, name: 'g', db_name: 'g', "is_choose": 1 },
                { id: 2, name: 'g/m', db_name: 'g/m' },
                { id: 3, name: 'g/㎡', db_name: 'g/㎡' },
            ];

            $('#fkdw').on('click', function () {
                var _this = $(this);
                $(fkdw_data).each(function (i, arr) {
                    if (arr['name'] === _this.val().trim()) {
                        fkdw_data[i]['is_choose'] = 1;
                    } else {
                        fkdw_data[i]['is_choose'] = 0;
                    }
                })
                fun.showBookList({
                    width: '280px',
                    shadeClose: true,
                    list: fkdw_data,
                    choose: function (res) {
                        $(fkdw_data).each(function (i, obj) {
                            if (obj['id'] == res['id']) {
                                fkdw_data[i]['is_choose'] = 1;
                            } else {
                                fkdw_data[i]['is_choose'] = 0;
                            }
                        })
                        $(_this).val(res['name'] || "").attr('fk_kz', (res['db_name'] || ""));
                    }
                });
            });
            $('#kzdw').on('click', function () {
                var _this = $(this);
                $(kzdw_data).each(function (i, arr) {
                    if (arr['name'] === _this.val().trim()) {
                        kzdw_data[i]['is_choose'] = 1;
                    } else {
                        kzdw_data[i]['is_choose'] = 0;
                    }
                })
                fun.showBookList({
                    width: '280px',
                    shadeClose: true,
                    list: kzdw_data,
                    choose: function (res) {
                        $(kzdw_data).each(function (i, obj) {
                            if (obj['id'] == res['id']) {
                                kzdw_data[i]['is_choose'] = 1;
                            } else {
                                kzdw_data[i]['is_choose'] = 0;
                            }
                        })
                        $(_this).val(res['name'] || "").attr('kz_dw', (res['db_name'] || ""));
                    }
                });
            });

        }
    });
}

// 新增幅宽克重
$('body').delegate('#add_btn', 'tap', function () {
    addWidth({
        type: 'add',
        callback: function (param) {
            if (param['is_default'] == 1) {
                default_obj = param;
                $(goods_weight).each(function (i, item) {
                    goods_weight[i]['is_default'] = 0;
                })
            }
            goods_weight.push(param);
            $('.message').empty();
            showList(goods_weight);
        }
    });
});

// 修改幅宽克重
$('body').delegate('.lower-border-line', 'tap', function (e) {
    e.stopPropagation();
    e.preventDefault();
    var list = $(this).data('list');
    addWidth({
        type: 'edit',
        list: list,
        callback: function (param) {
            if (param['is_default'] === 1) { // 开启默认
                $(goods_weight).each(function (i, item) {
                    item['is_default'] = 0;
                })
                $(goods_weight).each(function (i, item) {
                    if (param['sort'] === item['sort']) {
                        goods_weight[i] = param;
                        default_obj = goods_weight[i];
                        return false;
                    }
                })
            } else { // 关闭默认
                $(goods_weight).each(function (i, item) {
                    if (param['sort'] === item['sort']) {
                        goods_weight[i] = param;
                        item['is_default'] = 0;
                    }
                    if (default_obj['sort'] === param['sort']) {
                        default_obj = {};
                    }
                })
            }

            var flag = goods_weight.every(function (item, idx) {
                return !item['is_default'];
            })

            if (flag) { // 如果都取消默认的话，那么就不需要传一条默认的回去，
                default_obj = {};
            }

            $('.message').empty();
            showList(goods_weight);
        }
    });
});

// 删除
$('body').on('tap', '.delete', function (e) {
    e.stopPropagation();
    e.preventDefault();
    var list = $(this).closest('.lower-border-line').data('list');
    fun.dialog({
        content: '您确定要删除：【' + list['width'] + '幅宽+' + list['weight'] + '克重】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            if (page_data && 'id' in page_data && $.nui.isTrue(list['id'])) {
                console.log(list['id']);
                delete_arr.push(list['id']);
            }

            $(goods_weight).each(function (i, item) {
                if (list['width'] == item['width'] && list['weight'] == item['weight'] && (list['fk_dw'] == item['fk_dw']) && (list['kz_dw'] == item['kz_dw'])) {
                    goods_weight.splice(i, 1);
                }
            })
            $(goods_weight).each(function (i, tiem) {
                goods_weight[i]['sort'] = (i + 1);//将数组进行排序
            })

            var flag = goods_weight.every(function (item, idx) {
                return !item['is_default'];
            })

            if (flag) { // 删除了，数据里面没有默认的
                default_obj = {};
            }

            $('.message').empty();
            showList(goods_weight);
        }
    });
})

function isDataChange() {
    if ($.nui.isTrue(goods_weight)) {
        $(goods_weight).each(function (i, item) {
            console.log('----');

            if (item['is_default'] === 1) {
                default_obj = item;
            }
            goods_weight[i]['sort'] = (i + 1); // 将数组进行排序
        })
    }
    api.sendEvent({
        name: page_data.return_page,
        extra: {
            'status': 'cpzl_data',
            'page_type': 'fkkz',//fkkz gg
            'list': goods_weight,//列表数据
            'delete_arr': delete_arr,
            'default_obj': default_obj
        }
    });
    closePage();
}

//返回上一页
function closePage() {
    setTimeout(function () {
        api.closeWin();
    }, 200);
}

function existFkkz(param) {
    for (var i = 0; i < goods_weight.length; i++) {
        var item = goods_weight[i];
        //  sort：排序    width：幅宽   weight：克重   fk_dw：幅宽单位  kz_dw：克重单位
        if (((i + 1) != param['sort']) && (param['width'] == item['width']) && (param['weight'] == item['weight']) && (param['fk_dw'] == item['fk_dw']) && (param['kz_dw'] == item['kz_dw'])) return true;
    }
    return false;
}

// 键盘弹起
// function keyBoard() {
//     $('.content').css({
//         position: 'static'
//     })
// }

// ios键盘弹起处理
function iosKeyBoardShow() {
    fun.headerAbsolute('#header');
    // keyBoard();
}

// ios键盘收起处理
function ioskeyBoardHide() {
    fun.headerFixed('#header');
}
