var html_name = page_arr.shop_cp_cpzl, // 页面名称
    list_data = {},
    page_list = [],  // 分页加载列表
    photoBrowser = {},
    search_data = {
        "keyword": "",
        "keyword_key": ['number', 'name', 'simple'],
        'craft': 0,
        'quarter': 0,
        // "is_stop": 0,
        "class_id": 0,
        "order": {},
        // "is_mall": 1,
        // "is_sj": 1,
        "is_stop": 0,
        "tag": 'zh',   //综合
        "is_all": 1     //全部
        // "label_id":[]
    };

// 分页配置
var PagerConfig = {
    page_count: 1,
    page_size: 200
};

var last_lb_id = 0;
var ai_arg = false;
var last_dw_id = 0, last_dw_mc = '';
var cp_lb_list = [];
var search_storage = {};
var prices_arr = [];
var printDataList = []; // 产品打印数据
var last = { // 限制多次点击同一个tab，造成的重复请求
    tab: 0
}
var Bills = { djlx: 'cp' };
Bills['print_config'] = { 'djlx': 'cp' };

var shopListData = []; // 存储全部产品的数据
var tabSwitchType = 'zh';

// 点击类型弹出
var tabTypePopup = [
    {
        id: 1,
        name: '全部',
        db_name: 'qb',
        is_choose: 1
    },
    {
        id: 2,
        name: '已上架',
        db_name: 'sj',
        is_choose: 0
    },
    {
        id: 3,
        name: '已下架',
        db_name: 'xj',
        is_choose: 0
    }
];

var print_columns = [
    { name: 'class_name', display: '类别', width: 100, mergeCell: true },
    { name: 'type', display: '类型', width: 78, mergeCell: true },
    { name: 'imgs', display: '图', width: 60 },
    { name: 'tm', display: '条码', width: 100 },
    { name: 'number', display: '编号', width: 100 },
    { name: 'name', display: '名称', width: 160 },
    { name: 'unit_name', display: '单位', width: 90 },
    { name: 'width', display: '幅宽', type: 'float', width: 80 },
    { name: 'weight', display: '克重', type: 'float', width: 80 },
    { name: 'component', display: '成分', width: 150 },
    { name: 'craft', display: '工艺', width: 80 },
    { name: 'quarter', display: '季度', width: 80 },
    { name: 'gauze', display: '纱支', width: 80 },
    { name: 'density', display: '密度', width: 80 },
    { name: 'sale_point', display:'卖点',width: 150 },
    // { name: 'label_id', display: '标签', width: 150, mergeCell: ['merchant_name'], },
    { name: 'is_sj', display: '上架', width: 80, type: 'checkbox' },
    { name: 'sj_sj', display: '上架时间', width: 150, },
    { name: 'gys', display: '供应商', width: 80 },
    { name: 'diff', display: '模式', width: 80, visible: false, },
    { name: 'remark', display: '备注', width: 160, align: 'left' },
    { name: 'date', display: '日期', width: 150, },
    { name: 'is_stop', type: 'switch', display: '停用', width: 60, editor: { disabled: true } },
    { name: 'pb_fk', display: '坯布幅宽', width: 60},
    { name: 'pb_kz', display: '坯布克重', width: 60},
    { name: 'needle', display: '针寸数', width: 60},
    { name: 'machine_road', display: '机台路数', width: 60},
    { name: 'needle_count', display: '总针数', width: 60},
    { name: 'model_count', display: '总模数', width: 60},
    { name: 'weave_mode', display: '织造方式', width: 60},
    { name: 'weave_type', display: '织造类型', width: 60},
    { name: 'machine_type', display: '机台类别', width: 60},
    { name: 'machine_num', display: '机台号', width: 60},
    { name: 'shelf_width', display: '布架宽度', width: 60},
    { name: 'speed', display: '机速/分', width: 60},
    { name: 'sjjs', display: '上机经纱', width: 60},
    { name: 'mkjs', display: '每筘经纱', width: 60},
    { name: 'reed_num', display: '筘号', width: 60},
    { name: 'bobbin_num', display: '梭数', width: 60},
    { name: 'sjwm', display: '上机纬密', width: 60},
    { name: 'xjwm', display: '下机纬密', width: 60},
    { name: 'reed_width', display: '筘幅', width: 60},
    { name: 'slitter_edge', display: '废边', width: 60},
    { name: 'weave_loss', display: '织造损耗%', width: 60},
    { name: 'weave_shrinkage', display: '织缩率%', width: 60},
    { name: 'dye_loss', display: '染整损耗%', width: 60},
    { name: 'whole_shrinkage', display: '整缩率%', width: 60}
];

var comBScroll = null;

var shopCpzl = {
    timer: null,
    bScroll: null,
    options: {
        click: true,
        tap: true,
        pullUpLoad: {
            threshold: -10, // 在上拉到超过底部 10px 时，触发 pullingUp 事件
        },
        isCreateBScroll: false
    }
};

// 清空页面操作
shopCpzl.resetPage = function () {
    list_data = {};
    page_list = [];
    this.clearContainerHtml();
}

// 如果当前产品的标签为：推荐、热卖，则显示对应的图标，反之才判断是不是新品，显示：新品的图标
shopCpzl.showLabelIcon = function (data) {
    var labelIconStr = '';
    if (data['label'] === 'tj') { // 标签状态为推荐
        labelIconStr = '<i class="iconfont product-status-icon icon-tuijian recommend-icon"></i>';
    } else if (data['label'] === 'rx') { // 标签状态为热卖
        labelIconStr = '<i class="iconfont product-status-icon icon-rexiao hot-sale-icon"></i>';
    } else if (data['is_new'] === 1) { // 标签状态为新品
        labelIconStr = '<i class="iconfont product-status-icon  icon-xinpinNEW new-product-icon"></i>';
    }
    return labelIconStr;
}

shopCpzl.getNumIdlist = function (idList) {
    return $.map(idList, function (n) {
        return Number(n);
    });
}

// 获取可视列表高度
shopCpzl.getVisualListHeight = function () {
    return window.screen.height - fun.getCssVal('.goods-wrap', 'top') || 0;
}

// 加载暂无数据样式
shopCpzl.createBottomLine = function () {
    if ($.nui.isTrue($('.empty_bottom').length)) return;
    if ($.nui.isEmpty(page_list)) {
        if (shopCpzl.listAtVisualOut()) { // 列表数据大于列表可视区域高度
            fun.createBottomLine('goods_list', ".content");
            $('.empty_bottom').show();
        }
    }
}

// 清空列表数据
shopCpzl.clearContainerHtml = function () {
    $('#goods_list').html('');
}

// 设置列表高度 auto
shopCpzl.setListHeightAuto = function () {
    $('#goods_list').css({
        height: 'auto'
    })
}

// 空数据样式重置
shopCpzl.emptyDataContainerStyleReset = function () {
    $('#goods_list').css({
        height: shopCpzl.getVisualListHeight()
    })
}

// 分页加载方法
shopCpzl.pullingUp = function () {
    clearTimeout(shopCpzl.timer);
    shopCpzl.timer = setTimeout(function () {
        if ($.nui.isTrue(page_list)) {
            fun.removeLoadingAnimation();
            showData(fun.PagingData(page_list, 5) || []);
        } else {
            if ($.nui.isTrue($('.empty_bottom').length)) return;
        }
    }, 1000);
}

// 列表初始化分页加载
shopCpzl.enabledListScroll = function () {
    var that = this;
    if (!that.isCreateBScroll) {
        comBScroll = that.bScroll = new BScroll($('#goods_wrap')[0], that.options);
        that.isCreateBScroll = true;
    }
    showData(fun.PagingData(page_list, 10) || []);
    that.bScroll.off('pullingUp', that.pullingUp);
    that.bScroll.on('pullingUp', that.pullingUp);
}

// dom创建正在加载动画
shopCpzl.createLoading = function () {
    if ($.nui.isEmpty(page_list)) {
        fun.removeLoadingAnimation();
        return;
    };
    $("#goods_list").append(fun.createLoadingAnimation().join(''));
}

// 请求数据前执行
shopCpzl.beforeAjaxUpDate = function () {
    this.resetPage();
}

// 查询数据，回到顶部
shopCpzl.scrollToTop = function () { // 页面回到顶部
    this.bScroll.scrollToElement($('#goods_list')[0]);
}

// 显示改标签弹出层
shopCpzl.showPopup = function () {
    $('#shop_popup,.user-shade').show();
}

// 隐藏改标签弹出层
shopCpzl.hidePopup = function () {
    $('#shop_popup,.user-shade').hide();
}

// 改标签修改
shopCpzl.changeLaberStatus = function (params) {
    var idList = params.idList;
    var recommend = params['recommend'];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveGoods,
        data: {
            goods_id: idList,
            save_type: 'addLabel',
            label: recommend
        },
        success: function (res) {
            if (res['status'] == 0) {
                shopCpzl.hidePopup();
            } else {
                fun.toast('保存标签失败')
            }
            shopCpzl.hidePopup();
            api.sendEvent({
                name: html_name,
                extra: {
                    status: 'refresh'
                }
            })
        },
        error: function (err) {
            shopCpzl.hidePopup();
        }
    });
}

// 列表在可视区域之内
shopCpzl.listAtVisualOut = function () {
    return $('#goods_list').outerHeight() >= shopCpzl.getVisualListHeight();
}

$('#header').header({
    back: true,
    add: Auth.check('cp', 'edit'),
    filter: true,
    title: '产品资料',
    foot_input: {
        show: true,
        scan_icon: true,
        plader: '搜索'
    },
});

//监听页面滚动事件
page_init = function () {
    //请求web商城设置有设置：AI商城的XX参数
    $.ajax({
        type: "GET",
        async: false,
        url: AJAX_URL.companies + '/' + fun.getItem('company_info')['company_id'] +'?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        success:function(res){
            if($.nui.isTrue(res['company']['wechat_setting']['miniprogram_app_id']) && $.nui.isTrue(res['company']['wechat_setting']['miniprogram_app_secret'])){
                ai_arg = true;
            }
        }
    })

    if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) { // 有开通线上店铺
        search_data['is_mall'] = 1;
        // search_data['is_sj'] = 1;
    }else{      // 没有开通线上店铺且没有开通线上店铺
        permissions();
    }
    init();
    getList(true);

    api.addEventListener({
        name: html_name,
    }, function (res) {
        // console.log(res);
        $("foot_input").select();
        //is_edit是否有修改权限
        var temp = res['value']['data'];
        if (!!res) {
            switch (res.value.status) {
                case "search":
                    $('#goods_list').addClass('switch-tab');
                    if (!!res.value.data.view) {
                        fun.setItem('cp_view', 1);
                    } else {
                        fun.setItem('cp_view', 0);
                    }
                    search_data['class_id'] = temp['cp_lb']['id'];
                    search_data['quarter'] = temp['cp_jd']['id'];
                    search_data['craft'] = temp['cp_gy']['id'];
                    search_data['class_name'] = temp['cp_lb']['text'];
                    search_data['jd_name'] = temp['cp_jd']['text'];
                    search_data['gy_name'] = temp['cp_gy']['text'];
                    search_data['order']['rq'] = temp['RQ_SORT'];
                    search_data['order']['xl'] = temp['XL_SORT'];
                    search_data['order']['ll'] = temp['LL_SORT'];
                    search_data['order']['sc'] = temp['SC_SORT'];
                    search_data['is_stop'] = temp['is_stop'];
                    //搜索菜单需要缓存的数据
                    search_storage['is_stop'] = temp['is_stop'];

                    fun.setItem(html_name + '_' + 'is_stop', search_storage['is_stop']);
                    fun.setItem(html_name + 'sideslip', true);
                    getList();
                    break;
                case "refresh":
                    $('#goods_list').addClass('switch-tab');
                    getList(false);
                    break;
                case "empty":
                    prices_arr = [];
                    break;
                case "yfl"://移分类
                    $('#goods_list').addClass('switch-tab');
                    getList();
                    fun.toast('移分类更新成功！');
                    break;
                case 'createBetterScroll':
                    bScroll = new BScroll(document.getElementById('goods_wrap'), options);
                    showData(fun.PagingData(page_list, 10) || []);
                    function pullingUp() {
                        console.log($('#goods_list').children().length);
                        console.log('我触发了');
                        clearTimeout(timer);
                        timer = setTimeout(function () {
                            if (page_list.length > 0) {
                                showData(fun.PagingData(page_list, 5) || []);
                            } else {
                                if ($.nui.isTrue($('.empty_bottom').length)) return;
                                // var minus = $(window).height() - fun.getCssVal('.goods-wrap', 'top');
                                // if (getListHeight() >= minus) {
                                //     fun.createBottomLine('goods_list', ".content");
                                //     $('.empty_bottom').show();
                                // }
                            }
                        }, 1000);
                    }
                    bScroll.off('pullingUp', pullingUp);
                    bScroll.on('pullingUp', pullingUp);
                    break;
                default:
                    break;
            }
        }
    });

    bindEvent(); // 初始化事件

    if (AuthVersionCheck.checkHide('scdp')) {
        $('.p-batch').hide();
    }
};

// 页面动态计算元素初始化位置
function stylePageInit() {
    $('#tab_wrap').css({
        marginTop: api.safeArea.top + $('#header').outerHeight() - fun.computedHtmlFontSize()
    });

    // $('.bqy').css({
    //     paddingBottom: $('.foot-input-box').outerHeight() - $('.input_box').outerHeight()
    // })

    $('#p-batch-old,#p-batch-new').css('margin-bottom', api.safeArea.bottom);

    // computedCilcleLocation();

    $('#goods_wrap').css({
        bottom: api.safeArea.bottom
    })
    $('.bottom-list').css({
        paddingBottom: api.safeArea.bottom
    });
}

function checkAuthStyleInit() {
    if (!AuthVersionCheck.checkHide('scdp')) { // 有开通线上店铺
        // $('#tab_switch').show(); // 暂时注释
        // $('.goods-wrap').css({
        //     top: fun.getCssVal('#tab_wrap', 'marginTop') + $('#tab_wrap').outerHeight()
        // })
    } else {
        // 暂时注释
        // $('.header .foot-input-box').css({
        //     height: '3rem'
        // })
        // $('.goods-wrap').css({
        //     top: api.safeArea.top + $('#header').outerHeight() - fun.computedHtmlFontSize()
        // })
    }

    $('.goods-wrap').css({
        top: fun.getCssVal('#tab_wrap', 'marginTop') + $('#tab_wrap').outerHeight()
    })
}

// 初始化
function init() {
    stylePageInit();
    checkAuthStyleInit(); // 根据权限判断显示

    // fun.setHeaderLocation('.content'); // 解决ios头部定位失效
    search_storage = $.extend(true, {
        'is_stop': fun.getItem(html_name + '_' + 'is_stop', 0),
    }, search_storage);

    search_data = $.extend({}, search_data, search_storage);

    //产品类别传值过来
    if ($.nui.isTrue(page_data['type']) && page_data['type'] == 'cp_class') {
        search_data['class_id'] = page_data['class_id'];
        search_data['class_name'] = page_data['class_name'];
    }
    photoBrowser = api.require('photoBrowser');
}

// 获取计较单位
function getJjdw(info) {
    var jjdwMc = '';
    if ($.nui.isTrue(info['unit_options']['xsdw_id'])) { // 有销售单位id
        jjdwMc = info['xsdw_name'];
    } else if ($.nui.isTrue(info['unit_id'])) { // 主单位
        jjdwMc = info['unit_name'];
    }
    return jjdwMc;
}

// 没有取到值返回0
function showVal(value) {
    if ($.nui.isEmpty(value)) {
        value = 0;
    }
    return value;
}

// 显示价格
function showJg(info) {
    var jg_value = info['jg_value'];
    var unit = $.nui.isTrue(getJjdw(info)) ? '/' + getJjdw(info) : '';

    function getUnit(mark) {
        var unit = '';
        if (mark) {
            unit = $.nui.isTrue(getJjdw(info)) ? '/' + getJjdw(info) : '';
        } else {
            unit = $.nui.isTrue(getJjdw(info)) ? getJjdw(info) : '';
        }
        return unit;
    }

    if ($.nui.isEmpty(info['jg_type'])) {
        var html = [];
        // html.push('<p class="type-null text-handle font-lls">￥0<i class="font-ss">' + getUnit(true) + '</i></p>');
        html.push('<p class="type-null text-handle clear-space">');
        html.push('    <i class="font-lls single-money">￥0</i>');
        html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
        html.push('</p>');
        return html.join('');
    }
    switch (info['jg_type']) {
        case '':
        case 'ys':
        case 'sl':
            if ($.nui.isEmpty(jg_value)) {
                var html = [];
                // html.push('<p class="type-null text-handle font-lls">￥0<i class="font-ss">' + getUnit(true) + '</i></p>');
                html.push('<p class="type-null text-handle clear-space">');
                html.push('    <i class="font-lls single-money">￥0</i>');
                html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
                html.push('</p>');
                return html.join('');
            }
            break;
        // 没有default
    }

    switch (info['jg_type']) {
        case 'sl': // 按数量报价
            var jgValue = info['jg_value'];
            if ($.nui.isTrue(jgValue)) {
                var html = [];
                var res = '￥' + 0;
                var moneyArr = [];
                $(jgValue).each(function (idx, item) {
                    moneyArr.push(showVal(item['money']));
                });

                var maxVal = Math.max.apply(null, moneyArr); // 最高价
                var minVal = Math.min.apply(null, moneyArr); // 最低价

                if (maxVal === minVal) { // 两个值相等
                    res = '￥' + minVal;
                }

                if (maxVal !== minVal) { // 最高不等于最低（直接赋值最高价和最低价）
                    res = '￥' + minVal + ' ~ ' + maxVal;
                }

                html.push('<div class="yby-color-red text-overflow clear-space">');
                html.push('    <i class="font-lls single-money">' + res + '</i>');
                html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
                html.push('</div>');
                return html.join('');
            }
            return;
            break;
        case 'ys':
            var jgValue = info['jg_value'];
            var jyArr = [];
            var dhArr = [];
            var cpYsArr = [];
            if ($.nui.isTrue(jgValue)) {
                $(jgValue).each(function (idx, item) {
                    if (item['cp_ys_bh'] !== '白坯#') { // && item['is_stop'] !== 1
                        jyArr.push(showVal(item['jy_bzj']));
                        dhArr.push(showVal(item['bz_bzj']));
                        cpYsArr.push(item);
                    }
                })
            }

            var maxJyj = Math.max.apply(null, jyArr);
            var minJyj = Math.min.apply(null, jyArr);
            var maxDhj = Math.max.apply(null, dhArr);
            var minDhj = Math.min.apply(null, dhArr);

            var jyjZero = jyArr.every(function (item, idx) { // 剪样都填0
                return item === 0;
            })
            var dhjZero = dhArr.every(function (item, idx) { // 大货都填0
                return item === 0;
            })

            if ($.nui.isEmpty(cpYsArr) || (jyjZero && dhjZero)) {
                var html = [];
                // html.push('<p class="type-null text-handle font-lls">￥0<i class="font-ss">' + getUnit(true) + '</i></p>');

                html.push('<p class="type-null text-handle clear-space">');
                html.push('    <i class="font-lls single-money">￥0</i>');
                html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
                html.push('</p>');
                return html.join('');
            }

            if (cpYsArr.length > 1) { // 多个价格
                var html = [];
                html.push('<span class="jy yby-center mi-type jy-background jy-name vertical-middle">剪样</span>');
                if (minJyj === maxJyj) {
                    html.push('<span class=" jy-color vertical-middle clear-space">');
                    html.push('    <i class="font-lls ys-money">￥' + maxJyj + '</i>');
                    html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
                    html.push('</span>');
                } else {
                    html.push('<span class=" jy-color vertical-middle clear-space">');
                    html.push('    <i class="font-lls ys-money">￥' + minJyj + ' ~ ' + maxJyj + '</i>');
                    html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
                    html.push('</span>');
                }

                html.push('<span class="jy yby-center mi-type dh-background vertical-middle dh-name">大货</span>');
                if (minDhj === maxDhj) {
                    html.push('<span class="text-handle vertical-middle yby-color-red clear-space">');
                    html.push('    <i class="font-lls ys-money">￥' + maxDhj + '</i>');
                    html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
                    html.push('</span>');
                } else {
                    html.push('<span class="text-handle vertical-middle yby-color-red clear-space">');
                    html.push('    <i class="font-lls ys-money">￥' + minDhj + ' ~ ' + maxDhj + '</i>');
                    html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
                    html.push('</span>');
                }
                return html.join('');
            } else if (cpYsArr.length === 1) { // 单个价格
                var html = [];
                html.push('<span class="jy yby-center mi-type jy-background jy-name vertical-middle">剪样</span>');
                html.push('<span class=" jy-color vertical-middle clear-space">');
                html.push('    <i class="font-lls ys-money">￥' + showVal(cpYsArr[0]['jy_bzj']) + '</i>');
                html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
                html.push('</span>');
                html.push('<span class="jy yby-center mi-type dh-background vertical-middle dh-name">大货</span>');
                html.push('<span class="text-handle vertical-middle yby-color-red clear-space">');
                html.push('    <i class="font-lls ys-money">￥' + showVal(cpYsArr[0]['bz_bzj']) + '</i>');
                html.push('    <i class="font-ss">' + getUnit(true) + '</i>');
                html.push('</span>');
                return html.join('');
            }
            break;
        // 没有default:
    }
}

// 处理旧数据保存报价
function initJgVal(data) {
    $(data).each(function (idx, item) {
        if ($.nui.isEmpty(item['jg_type']) || $.nui.isEmpty(item['jg_value'])) {
            item['jg_type'] = 'ys';
            item['jg_value'] = [];
        }
    })
}

// 获取请求的数据
function getList(initFirst) {
    shopCpzl.beforeAjaxUpDate();
    fun.ajax({
        showLoad: true,
        hideLoad: false,
        url: AJAX_URL.getGoodsList,
        data: $.extend({}, {
            "keyword": "",
            "is_stop": 0,
            // page_count: PagerConfig['page_count'],
            // page_size: PagerConfig['page_size']
        }, search_data),
        success: function (res) {
            if (initFirst) {
                fun.load_DATA_LIST(['jjdw'], null, { showLoad: false, hideLoad: true, close: true });
                fun.load_DATA_LIST(['cp_lb'], null, { showLoad: false, hideLoad: true, close: true });
            }
            if (res['status'] == 0) {
                if ($.nui.isEmpty(res['data'])) {
                    $('.empty_bottom').hide();
                    $('.font-lls').css('pointer-events', 'auto');
                    shopCpzl.emptyDataContainerStyleReset();
                    fun.createDataEmptyTips({ dom: '#goods_list', btnShow: false });
                    fun.load_DATA_LIST(['cp'], null, { showLoad: false, hideLoad: true, close: true });
                    return fun.hideLoad();
                }

                shopListData = JSON.parse(JSON.stringify(res.data));
                page_list = res.data;
                initJgVal(res.data); // 处理旧数据保存报价
                printDataList = res.data.slice(0);

                var tmp_rows = (res.data || []).slice(0).sort(function (a, b) {
                    $('.font-lls').css('pointer-events', 'auto');
                    return new Date(fun.compateIEDate(a['date'])).getTime() - new Date(fun.compateIEDate(b['date'])).getTime();
                });

                last_dw_id = tmp_rows[tmp_rows.length - 1]['unit_id'];
                last_dw_mc = tmp_rows[tmp_rows.length - 1]['unit_name'];
                last_lb_id = tmp_rows[tmp_rows.length - 1]['class_id'] || 0;
                shopCpzl.setListHeightAuto();
                shopCpzl.enabledListScroll();
            } else {
                fun.alert({ msg: '网络异常！' });
                fun.hideLoad();
            }
            $('.font-lls').css('pointer-events', 'auto');
            fun.load_DATA_LIST(['cp'], null, { showLoad: false, hideLoad: false, close: false });
        }
    })
}

//显示数据
function showData(data) {
    var listHtml = [];
    for (var i = 0; i < data.length; i++) {
        var item = data[i];
        var goods_text = ((item['number'] || "") + " " + (item['name'] || "")),
            goods_id = item['id'],
            img_url = (item['imgs']) ? fun.getImgPath(item['imgs']) : "../img/logo.png",
            large_url = (item['imgs']) ? fun.getImgPath(item['imgs'], true) : "../img/logo.png";
        var wangc = $('#p-batch-old').find('.cloth-box').text();
        var quanx = $('#p-batch-new').find('.cloth-box').text();

        list_data[goods_id] = item;
        listHtml.push('<li class="center-list lower-border-line pro-add clearfix wrap-style" goods_id="' + goods_id + '" data-list=\'' + fun.formatString(JSON.stringify(item)) + '\'>');
        listHtml.push('    <div class="le wrap-style">');
        listHtml.push(wangc == '完成' ? '<div class="check" style="display: block;">' : '<div class="check">');
        listHtml.push((quanx == '反选' ? '<span class="check-box check-choice">' : '<span class="check-box">') + '<i class="iconfont icon-check"></i></span>');
        listHtml.push('       </div>');
        // if (img_url === "../img/logo.png") {
        //     listHtml.push(wangc == '完成' ? '<div class="picture mr-bj margin-left-0">' : '<div class="picture mr-bj">');
        //     listHtml.push('       <img src="' + img_url + '" class="product cp-img imgs">');
        // } else {
        listHtml.push(wangc == '完成' ? '<div class="picture margin-left-0">' : '<div class="picture mr-bj">');//onerror=null;this.src=' + "'../../img/logo.png'" + '
        if (img_url === "../img/logo.png") {
            listHtml.push('       <img src="' + img_url + '" class="product cp-img imgs">');
        } else {
            listHtml.push('       <img src="' + img_url + '" onerror="imgError1(this);" large-url="' + large_url + '" class="product large imgs">');
        }
        listHtml.push('       <img src="../img/mask.png" class="mask">');
        // }
        listHtml.push('       </div>');
        if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) { // 有开通线上店铺
            listHtml.push(wangc == '完成' ? '<div class="center-text" style="width: calc(100% - 6rem);">' : '<div class="center-text">');
        } else { // 没开通线上店铺
            listHtml.push(wangc == '完成' ? '<div class="center-text right-content-middle fixed-height right-content-middle-reset" style="width: calc(100% - 6rem);">' : '<div class="center-text right-content-middle fixed-height right-content-middle-reset">');
        }
        listHtml.push('           <div class="text">');
        listHtml.push('             <span class="product-name">' + (fun.redFont(goods_text, search_data['keyword']) || "") + '</span>');
        if(!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')){
            listHtml.push('              ' + shopCpzl.showLabelIcon(item) + '');
        }
        listHtml.push('           </div>');

        if (item['jg_type'] === 'ys') {
            listHtml.push('       <div class="middle clear-space text-handle">');
        } else {
            listHtml.push('           <div class="middle">');
        }
        listHtml.push(showJg(item));
        listHtml.push('           </div>');

        if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) { // 有开通线上店铺
            listHtml.push('           <div class="xls clear-space">');
            listHtml.push('               <span class="xiao font-ss">销量 ' + ((item['cp_xl'] > 9999 ? '9999+' : item['cp_xl']) || 0) + '</span>');
            listHtml.push('               <span class="liu align-center font-ss">浏览 ' + ((item['cp_ll'] > 9999 ? '9999+' : item['cp_ll']) || 0) + '</span>');
            listHtml.push('               <span class="shou font-ss">收藏 ' + (item['cp_sc'] || 0) + '</span > ');
            listHtml.push('           </div>');
        }
        listHtml.push('             <div class="more-btn-box">');
        listHtml.push('                 <i class="iconfont icon-gengduo1 icon-more-btn" id="icon_more"></i>');
        listHtml.push('             </div>');
        listHtml.push('       </div>');
        var xsdp = (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc'));
        if (xsdp) { // 有开通线上店铺
            listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 more more-btn btn-style">更多</div>');
            // listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 more delete-cp btn-style">删除</div>');
            Auth.check('cp', 'edit') ? listHtml.push('<div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 prices prices-btn btn-style">编辑</div>') : '';
            listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 stamp stamp-btn btn-style">打印</div>');
            listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 shares share-btn btn-style">分享</div>');
        } else if (!AuthVersionCheck.checkHide('aisc') && ai_arg) { // 没有开通线上店铺但开通AI商城
            Auth.check('cp', 'edit') ? listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 more delete-cp btn-style">删除</div>') : '';
            Auth.check('cp', 'edit') ? listHtml.push('<div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 prices prices-btn btn-style">编辑</div>') : '';
            if (!AuthVersionCheck.checkHide('cpdy')) { // 非免费版本要显示打印按钮
                listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 stamp stamp-btn btn-style">打印</div>');
            }
            listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 shares share-btn btn-style">分享</div>');
        } else {
            listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 more deltet-cp btn-style">删除</div>');
            Auth.check('cp', 'edit') ? listHtml.push('<div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 prices prices-btn btn-style">编辑</div>') : '';

            if (!AuthVersionCheck.checkHide('cpdy')) { // 非免费版本要显示打印按钮
                listHtml.push('       <div goods_id=' + goods_id + ' goods_text="' + goods_text + '" class="slids dels1 stamp stamp-btn btn-style">打印</div>');
            }
        }
        listHtml.push('    </div>');
        listHtml.push('</li>');
    }

    $("#goods_list").append(listHtml.join(''));
    resetSwiperSlide(); // 左滑根据权限滑动对应距离

    shopCpzl.createLoading();
    shopCpzl.createBottomLine();
    shopCpzl.bScroll.refresh();
    shopCpzl.bScroll.finishPullUp();

    setTimeout(function () {
        fun.hideLoad();
    }, 200);
}

// 左滑根据权限滑动对应距离
function resetSwiperSlide() {
    for (var i = 0; i < $('.le').length; i++) { // 每一个记录行的
        var slidesLen = $('.le').eq(i).find('.slids').length;
        for (var j = 0; j < slidesLen; j++) { // 每一记录行的左滑出现子项
            $('.le').eq(i).find('.slids').eq(j).css({
                right: -(slidesLen - j) * 20 + '%'
            })
        }
    }
}

// // 重置中间区域居中
// function resetCenterContent() {
//     $('.center-text').each(function () {
//         var thatH = $(this).outerHeight();
//         $(this).css({
//             height: '4rem',
//             paddingTop: ($(this).parents('.center-list').outerHeight() - fun.computedHtmlFontSize() * 4) / 2
//         })
//     })
// }

// 删除产品
function deleteCp(list) {
    fun.dialog({
        content: '您确定要删除【' + list['number'] + list['name'] + '】吗？',
        btn: ['删除', '取消'],
        success: function () {
            setTimeout(function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
            }, 200);
        },
        yes: function () {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.saveGoods,
                data: {
                    "save_type": "delete",
                    "id": typeof list['id'] === 'object' ? list['id'] : [list['id']]
                },
                success: function (res) {
                    switch (res['status']) {
                        case 0:
                            fun.toast('删除成功。');
                            getList();
                            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                            break;
                        case 103:
                            fun.dialog({
                                content: '【' + list['number'] + '' + list['name'] + '】已被调用，不允许删除。如果该产品没有在经营，您可以使用：停用功能。',
                                btn: ['转为停用状态', '我知道了'],
                                yes: function () {
                                    fun.ajax({
                                        showLoad: true,
                                        hideLoad: true,
                                        url: AJAX_URL.saveGoods,
                                        data: {
                                            "save_type": "delete",
                                            "is_has": true,
                                            "id": typeof list['id'] === 'object' ? list['id'] : [list['id']],
                                        },
                                        success: function (res) {
                                            if (res['status'] == 0) {
                                                fun.toast('修改成功。');
                                                getList();
                                            }
                                        }
                                    })
                                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                                },
                                no: function () {
                                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                                }
                            });
                            break;
                        default:
                            fun.toast('删除失败。');
                            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                    }
                }
            })
        },
        no: function () {
            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
        },
    })
}

//底部固定按钮
function foundBottm() {
    var btmHtml = [];
    if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) { // 有开通线上店铺
        btmHtml.push('        <li id="share" class="bottom-li clear-space">');
        btmHtml.push('            <i class="iconfont icon-fenxiang1"></i>');
        btmHtml.push('            <span class="bottom-text">分享</span>');
        btmHtml.push('        </li>');
        btmHtml.push('        <li id="printing" class="bottom-li clear-space">');
        btmHtml.push('            <i class="iconfont icon-dayinji1"></i>');
        btmHtml.push('            <span class="bottom-text">打印</span>');
        btmHtml.push('        </li>');
    } else {
        if (!AuthVersionCheck.checkHide('cpdy')) { // 非免费版本显示打印按钮
            btmHtml.push('        <li id="printing" class="bottom-li clear-space">');
            btmHtml.push('            <i class="iconfont icon-dayinji1"></i>');
            btmHtml.push('            <span class="bottom-text">打印</span>');
            btmHtml.push('        </li>');
        }
    }
    if (Auth.check('cp', 'edit')) {
        if (!AuthVersionCheck.checkHide('scdp')) { // 有开通线上店铺
            btmHtml.push('        <li id="upper_shelf" class="bottom-li clear-space">');
            btmHtml.push('            <i class="iconfont icon-shangjia"></i>');
            btmHtml.push('            <span class="bottom-text">上架</span>');
            btmHtml.push('        </li>');
            btmHtml.push('        <li id="lower_shelf" class="bottom-li clear-space">');
            btmHtml.push('            <i class="iconfont icon-xiajia"></i>');
            btmHtml.push('            <span class="bottom-text">下架</span>');
            btmHtml.push('        </li>');
        }
        btmHtml.push('        <li id="shift_class" class="bottom-li clear-space">');
        btmHtml.push('            <i class="iconfont icon-leibie1"></i>');
        btmHtml.push('            <span class="bottom-text">移分类</span>');
        btmHtml.push('        </li>');

        // 2020-03-16 hcx 新增 改标签
        btmHtml.push('<li id="change_label" class="bottom-li clear-space">');
        btmHtml.push('    <i class="iconfont icon-leibie1"></i>');
        btmHtml.push('    <span class="bottom-text">改标签</span>');
        btmHtml.push('</li>');
    }
    $(".bottom-list").html(btmHtml.join(''));
    //js控制底部列表宽
    var len = $('.bottom-li').length;
    $(".bottom-li").css('width', 100 / len + '%');
}

fun.setItem(html_name + 'sideslip', true);

//获得指定字符出现几次的位置
function find(str, cha, num) {
    var x = str.indexOf(cha);
    for (var i = 0; i < num; i++) {
        x = str.indexOf(cha, x + 1);
    }
    return x;
}

//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });

}

function imgError1(_this) {
    _this.src = '../img/logo.png';
    _this.parentNode.classList.add('mr-bj');
    _this.classList.remove('large');
    _this.classList.add('cp-img');
    var nextEle = _this.nextElementSibling;
    if ($.nui.isTrue(nextEle)) {
        _this.parentNode.removeChild(nextEle);
    }
    _this.onerror = null;
}

//获取选中id 
function getIdlist(id_list) {
    var id_list = [];
    var id;
    for (var i = 0; i < $('.check-choice').length; i++) {
        id = $('.check-choice:eq(' + i + ')').closest('li').attr('goods_id');
        id_list.push(id);
    }
    return id_list;
};

// 获取选中的产品的列表
function getCpLxList(cp_lx) {
    var cp_lx = [];
    var list;
    for (var i = 0; i < $('.check-choice').length; i++) {
        list = $('.check-choice:eq(' + i + ')').closest('li').data('list');
        cp_lx.push(list.cp_lx);
    }
    return cp_lx
};

// 初始化事件
function bindEvent() {
    // 非免费版才显示
    if (AuthVersionCheck.checkHide('scdp')) {
        $('.p-batch').hide();
    }

    // 点击下方小圆圈
    $('#p-batch-old').on('click', function (e) {
        e.stopPropagation();
        if ($('#p-batch-old').find('.cloth-box').text() === '完成') { // 收起底部列表
            $('#p-batch-new').hide();
            $('#p-batch-old').find('.cloth-box').html('<i class="iconfont icon-batch"></i>').find('i').show();
            $('.check').hide();
            $('.picture').removeClass('margin-left-0');
            $('.center-text ').css('width', 'calc(100% - 4.5rem)');
            $('.right').css('width', '55%');

            $('.check-box').removeClass('check-choice'); // 清除记忆选项
            //隐藏底部固定按钮
            $('.bottom-list').removeClass('padding').hide();
            $('.content').css('padding-bottom', '0');

            $('#p-batch-old').css({
                marginBottom: api.safeArea.bottom
            })

            // computedCilcleLocation();
        } else { // 展开底部列表
            $('#p-batch-new').show().find('.cloth-box').text('全选');
            $('#p-batch-old').find('.cloth-box').html('完成').find('i').hide();
            $('.check').show();
            $('.picture').addClass('margin-left-0');
            $('.center-text ').css('width', 'calc(100% - 6rem)');
            $('.right').css('width', '52%');

            //显示底部固定按钮
            $('.content').css('padding-bottom', '3rem');
            foundBottm();
            $('.bottom-list').addClass('padding').show();
            // computedCilcleLocation();
            $('#p-batch-old').css({
                marginBottom: $('.bottom-list').outerHeight()
            })
            $('#p-batch-new').css({
                marginBottom: $('.bottom-list').outerHeight()
            })
        }
    });

    // 点击全选/反选按钮
    $('#p-batch-new').on('click', function (e) {
        e.stopPropagation();
        if ($('#p-batch-new').find('.cloth-box').text() === '全选') {
            $('.check-box').addClass('check-choice');
            $('#p-batch-new').find('.cloth-box').text('反选');
        } else {
            $('.check-box').removeClass('check-choice');
            $('#p-batch-new').find('.cloth-box').text('全选');
        }
    });

    // 删除产品
    $('body').on('click', '.delete-cp', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var list = $(this).parents('.center-list').data('list');
        deleteCp(list);
    })

    // 打印
    $('body').on('click', '.stamp-btn', function (e) {
        document.body.addEventListener('touchmove', preventDefault, { passive: false });
        e.stopPropagation();
        e.preventDefault();
        layer.closeAll();
        search_data['cp_id'] = $(this).attr('goods_id');
        Print.printLoad({ printType: 'cp' });
    });

    // 搜索条码
    $('body').on('keypress', '#foot_input', function (e) {
        var value = $('#foot_input').val().trim();
        if (e.keyCode === 13 && !!code) {
            $(this).select();
            page_data['page_num'] = 1;
            getList();
        }
    });

    // 上架状态切换
    // $('.tab-sel').on('tap', fun.debounce(function () {
    //     if (last['tab'] === $(this).index()) return;
    //     last['tab'] = $(this).index();
    //     var sj_zt = $(this).data('type');
    //     $('.tab-sel .title-text').removeClass('selected');
    //     $(this).find('.title-text').addClass('selected');
    //     $('#goods_list').addClass('switch-tab');
    //     if (sj_zt === 'ysj') {
    //         search_data['is_sj'] = 1;
    //     } else {
    //         search_data['is_sj'] = 0;
    //     }
    //     $('.tab-sel').css('pointer-events', 'none');
    //     getList();
    // }, 300));

    // 扫描
    $('body').on('tap', ".icon-saoma", function () {
        QuestPermission.requestPermission('camera', null, function () {
            openScanner({
                callback: function (value) {
                    $("#foot_search").val(value);
                    if (!!$("#foot_search").val()) {
                        search_data['keyword'] = $('#foot_search').val().trim();
                        $('#product_list').empty();
                        getList();
                        return true;
                    } else {
                        fun.toast('扫码失败！');
                        return true;
                    }
                }
            });
        });

    });

    // 打开搜索页
    $('body').on('click', '#filter_btn', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var filterObj = [{ // 权限判断显示
            "text": "销量",
            "key": "XL_SORT",
            "value": (search_data['order']['xl'] || '')
        }, {
            "text": "浏览",
            "key": "LL_SORT",
            "value": (search_data['order']['ll'] || '')
        }, {
            "text": "收藏",
            "key": "SC_SORT",
            "value": (search_data['order']['sc'] || '')
        }];
        var sideslip = fun.getItem(html_name + 'sideslip');
        var options = {
            "choose_merchants": [{
                key: "cp_lb",
                "text": "类别",
                "id": (search_data['class_id'] || 0),
                "value": (search_data['class_name'] || "")
            }, {
                key: "cp_jd",
                "text": "季度",
                "id": (search_data['quarter'] || 0),
                "value": (search_data['jd_name'] || "")
            }, {
                key: "cp_gy",
                "text": "工艺",
                "id": (search_data['craft'] || 0),
                "value": (search_data['gy_name'] || "")
            },],
            "sort": [{
                "text": "日期",
                "key": "RQ_SORT",
                "value": (search_data['order']['rq'] || '')
            },
                // {
                //     "text": "销量",
                //     "key": "XL_SORT",
                //     "value": (search_data['order']['xl'] || '')
                // }, {
                //     "text": "浏览",
                //     "key": "LL_SORT",
                //     "value": (search_data['order']['ll'] || '')
                // }, {
                //     "text": "收藏",
                //     "key": "SC_SORT",
                //     "value": (search_data['order']['sc'] || '')
                // },
            ],
            "switch": [{
                "text": "显示停用",
                "max_width": true,
                "key": "is_stop",
                // "value": (search_data['is_stop'] || 0)
                "value": search_storage['is_stop']
            }],
        }
        if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) { // 有开通线上店铺
            options['sort'] = options['sort'].concat(filterObj);
        }
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    "return_page": html_name,
                    "search_data": options
                },
                // y: fun.fontUnit(header)
            });
        }
    });

    // 编辑产品
    $('body').on('click', '.prices', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var index = $('.prices').index(this)
        var goods_id = $('.prices').eq(index).attr('goods_id')
        var search_val = $('#foot_search').val().trim();
        var jvals = fun.judgeLastStr(search_val);
        fun.showPageFull({
            "page_url": page_arr.shop_product_compile,
            "pageParam": {
                "return_page": html_name,
                'id': goods_id
            }
        });
    });

    // 添加产品
    $('body').delay('tap', '#add_btn', function () {
        var search_val = $('#foot_search').val().trim();

        if (search_val == '') {
            openPage(search_val);
        } else {
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.getInfoByKeyword,
                data: {
                    "type": 'cp',
                    "keyword": search_val
                },
                success: function (res) {
                    switch (res['status']) {
                        case 0:
                            openPage(search_val);
                            break;
                        case 104:
                            layer.closeAll();
                            fun.dialog({
                                content: '【' + search_val + '】已存在，是否继续添加？',
                                btn: ['确定', '取消'],
                                shadeClose: false,
                                className: 'data-change-skin',
                                yes: function () {
                                    openPage('');
                                },
                                no: function () {
                                    search_data['keyword'] = search_val;
                                    getList();
                                }
                            });
                            break;
                        default:
                            fun.toast(res['msg']);
                            break;
                    }
                }
            })
        }

        function openPage(jvals) {
            fun.showPageFull({
                "page_url": page_arr.shop_product_compile,
                "pageParam": {
                    "return_page": html_name,
                    "last_lb_id": last_lb_id,
                    'last_dw_id': last_dw_id,
                    'last_dw_mc': last_dw_mc,
                    'cp_bh': jvals
                }
            });
        }
    });

    // 跳转 产品详情页
    $('body').on('click', '.pro-add', function (e) {
        e.stopPropagation();
        e.preventDefault();
        if ($(this).find('.check-box:visible').length) {
            if ($(this).find('.check-box').hasClass('check-choice')) {
                $(this).find('.check-box').removeClass('check-choice');
            } else {
                $(this).find('.check-box').addClass('check-choice');
            }
        } else {
            var list = $(this).closest('li').data('list');
            fun.showPageFull({
                "page_url": page_arr.shop_product_view,
                "pageParam": {
                    "goods_info": list,
                    "goods_id": list['id'],
                    "return_page": html_name
                }
            });
        }
    });

    // 点击键盘搜索
    $("#foot_search").bind('search', fun.throttle(function () {
        shopCpzl.clearContainerHtml(); // 搜索清除页面html结构
        page_list = [];
        search_data['keyword'] = $(this).val().trim();
        getList();
    }, 300));

    // 分享
    $('body').on('click', '.share-btn', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var list = $(this).closest('li').data('list');
        if ($.nui.isTrue(list['imgs'])) {
            $.ajax({  //转化成测试服务器那边的产品id
                type: "GET",
                headers: {
                    "X-Requested-With": "XMLHttpRequest",
                    "Accept": "application/json"
                },
                url: AJAX_URL.adminGoods + list['id'] + '?app_token='+ fun.getItem('token') +'&company_id='+ fun.getItem('company_info')['company_id'],
                success: function (res) {
                    fun.showPageFull({
                        "page_url": page_arr.share_newpictures,
                        "pageParam": {
                            data: list,
                            good_id: res['id']
                        }
                    });
                },
                error:function(){
                    fun.toast('该产品已停用或产品未上架！');
                }
            });
        } else {
            fun.toast('该产品没有上传图片，无法分享！');
        }
    });

    // 更多
    $('body').on('click', '.more-btn', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var $this = $(this);
        var list = $this.closest('li').data('list');
        var merchants_list = [
            { "name": "库存", "column": "kc", },
            { "name": "分析", "column": "fx", },
        ];
        if (Auth.check('cp', 'edit')) {
            merchants_list.push({ "name": "删除", "column": "sc", })
        }
        fun.showBookList({
            list: merchants_list,
            open_init: function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false });
            },
            choose: function (res) {
                // document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
                // console.log(res);
                switch (res['column']) {
                    case 'kc'://库存
                        fun.showPageFull({
                            "page_url": page_arr.kc_kcxq,
                            "pageParam": {
                                "data": list,
                                "cp_id": list['id'],
                                "info": list['number'] + "" + list['name'],
                                "return_page": html_name
                            }
                        })
                        break;
                    case 'fx'://分析
                        var to_month = fun.getMonthArr(1)[0];
                        // var data = {
                        //     "cp_mc": list['name'],
                        //     "cp_id": list['id'],
                        //     "cp_bh": list['number'],
                        // }
                        fun.showPageFull({
                            "page_url": page_arr.xs_cpfx_xq,
                            "pageParam": {
                                "type": 'rxfx',
                                "cp_mc": list['name'],
                                "cp_id": list['id'],
                                "cp_bh": list['number'],
                                "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
                                "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
                            }
                        })
                        break;
                    case 'sc'://删除
                        deleteCp(list);
                        break;
                }
            },
            end: function () {
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            }
        })
        return false;
    });

    // 批量分享
    $('body').on('tap', '#share', function () {
        var id_list = [];
        var img_list = [];
        var id;
        var list;
        for (var i = 0; i < $('.check-choice').length; i++) {
            list = $('.check-choice:eq(' + i + ')').closest('li').data('list');
            id = $('.check-choice:eq(' + i + ')').closest('li').attr('goods_id');
            id_list.push(id);
            img_list.push(list)
        }
        var result = img_list.some(function (item) {
            return !item.imgs;
        })
        if ($.nui.isEmpty(id_list)) return fun.toast('请先选择产品。');
        if ($.nui.isEmpty(id_list)) {
            fun.toast('请选择分享内容')
        } else if (id_list.length > 9) {
            fun.toast('每次最多只能分享9个产品')
        } else if (result) {
            fun.toast('部分产品没有上传图片，无法分享！');
        } else {
            $.ajax({  //转化成测试服务器那边的产品id
                type: "GET",
                headers: {
                    "X-Requested-With": "XMLHttpRequest",
                    "Accept": "application/json"
                },
                url: AJAX_URL.adminGoods + 'lists?app_token='+ fun.getItem('token') +'&company_id='+ fun.getItem('company_info')['company_id'],
                data:{
                    yby_ids: id_list
                },
                success: function (res) {
                    if(res.length === id_list.length){
                        var id_item = [];
                        for(var i = 0; i < res.length; i++){
                            id_item.push(res[i]['id']);
                        }
                        fun.showPageFull({
                            "page_url": page_arr.share_newpictures,
                            "pageParam": {
                                data: img_list,
                                good_id: id_item.reverse()
                            }
                        })
                    }else{
                        return fun.toast('部分产品未上架或已停用，无法分享！');
                    }
                },
                error:function(){
                    fun.toast('该产品已停用或产品未上架！');
                }
            });
            
        }
    });

    // 批量打印
    $('body').on('tap', '#printing', function (e) {
        e.stopPropagation();
        var id_list = getIdlist();
        if ($.nui.isEmpty(id_list)) return fun.toast('请先选择产品。');
        search_data['cp_id'] = id_list;
        layer.closeAll();
        Print.printLoad({ printType: 'cp' });
    });

    // 批量上架
    $('body').on('tap', '#upper_shelf', function () {
        var id_list = getIdlist();
        if ($.nui.isEmpty(id_list)) return fun.toast('请先选择产品。');
        var cp_lx = getCpLxList();
        var cur_time = fun.getNowFormatDate();
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.saveGoods,
            data: {
                "id": id_list,
                "save_type": "state",
                "sj_sj": fun.formatDate(cur_time),
                "type": "sj",
                "is_sj": 1,
                "cp_lx": cp_lx
            },
            success: function (res) {
                switch (res['status']) {
                    case 0:
                        getList();
                        fun.toast('上架更新成功！');
                        break;
                    default:
                        fun.toast(res['msg']);
                        break;
                }
            }
        });
    });

    // 批量下架
    $('body').on('tap', '#lower_shelf', function () {
        var id_list = getIdlist();
        var cp_lx = getCpLxList();
        if ($.nui.isEmpty(id_list)) return fun.toast('请先选择产品。');
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.saveGoods,
            data: {
                "id": id_list,
                "save_type": "state",
                "type": "sj",
                "is_sj": 0,
                "cp_lx": cp_lx
            },
            success: function (res) {
                if (res['status'] == 0) {
                    getList();
                    fun.toast('下架更新成功！');
                }
            }
        });
    });

    // 批量移分类
    $('body').on('tap', '#shift_class', function () {
        var id_list = getIdlist();
        if ($.nui.isEmpty(id_list)) return fun.toast('请先选择产品。');
        if ($.nui.isEmpty(id_list)) return fun.toast('请选择需要移分类的产品！');
        fun.showPageFull({
            "page_url": page_arr.shop_product_class,
            "pageParam": {
                type: 'yfl',
                id: id_list
            }
        })
    });

    // 点击更多，弹出
    $('body').on('click', '.more-btn-box', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var $parents = $(this).parents('.le');
        var len = $parents.find('.slids').length;
        $('.le').not($parents).css({
            left: 0
        })
        $parents.css({
            left: -(len * 20) + '%'
        })
    });

    // 更改标签
    $('body').on('click', '#change_label', function (e) {
        e.stopPropagation();
        if ($.nui.isEmpty(getIdlist())) return fun.toast('请先选择产品。');
        shopCpzl.showPopup();
    })

    // 取消更改标签
    $('body').on('click', '#cancel', function (e) {
        e.stopPropagation();
        shopCpzl.hidePopup();
    })

    // 清空标签
    $('body').on('click', '#clear_label', function () {
        shopCpzl.changeLaberStatus({
            idList: shopCpzl.getNumIdlist(getIdlist()),
            recommend: '',
            hotSale: 0
        });
    })

    // 标签-推荐
    $('body').on('click', '#recommend', function () {
        shopCpzl.changeLaberStatus({
            idList: shopCpzl.getNumIdlist(getIdlist()),
            recommend: 'tj',
            hotSale: 0
        });
    })

    // 标签-热销
    $('body').on('click', '#hot', function () {
        shopCpzl.changeLaberStatus({
            idList: shopCpzl.getNumIdlist(getIdlist()),
            recommend: 'rx',
            hotSale: 1
        });
    })

    $('body').on('click', '.tab-item', function () {
        if (shopCpzl.bScroll) {
            shopCpzl.scrollToTop();
        }
        var type = $(this).data('type');
        $(this).addClass('active-color').siblings().removeClass('active-color');
        tabSwitchType = type;
        delete search_data.jg_sort;
        switch (type) {
            case 'zh': // 综合
                search_data.tag = 'zh'
                break;
            case 'xl': // 销量
                search_data.tag = 'xl'
                break;
            case 'xp': // 新品
                search_data.tag = 'xp'
                break;
            case 'jg': // 价格
                search_data.tag = 'jg';
                // 0当前为降序，1当前为升序
                var order = $('.tab-price').data('order');
                if (order) { // 升序变降序
                    $('.price-down').removeClass('tab-wrap-color');
                    $('.price-up').addClass('tab-wrap-color');
                    search_data.jg_sort = 'desc';
                } else { // 降序变升序
                    $('.price-up').removeClass('tab-wrap-color');
                    $('.price-down').addClass('tab-wrap-color');
                    search_data.jg_sort = 'asc';
                }
                $('.tab-price').data('order', Number(!order));
                break;
            // 没有default
        }
        getList();
    })

    $('body').on('click', '.tab-all', function () {
        if (!Auth.check('cp', 'edit') && AuthVersionCheck.checkHide('xsdp') && AuthVersionCheck.checkHide('aisc')) { // 没有产品编辑跟没有开通线上店铺
            return;
        } else if (!(fun.checkVersion2()['isBzShop'] || fun.checkVersion2()['isFreeVipShop']) && AuthVersionCheck.checkHide('aisc')) {// 没有开通了线上店铺的免费版或vip版 || 没有开通了线上店铺的标准版及以后版本
            return;
        }
        tabSwitchType = 'qb';
        var self = this;
        // $('.tab-item').removeClass('active-color');
        $('.tab-all').removeClass('active-color');
        $('.tab-all .pull-down-btn').removeClass('active-color');
        $(this).addClass('active-color');
        $(this).find('.pull-down-btn').addClass('active-color');
        fun.showBookList({
            width: '280px',
            shadeClose: true,
            list: tabTypePopup,
            open_init: function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false });
            },
            choose: function (res) {
                if (shopCpzl.bScroll) {
                    shopCpzl.scrollToTop();
                }
                $(tabTypePopup).each(function (i, obj) {
                    if (Number(res['id']) === obj['id']) {
                        tabTypePopup[i]['is_choose'] = 1;
                    } else {
                        tabTypePopup[i]['is_choose'] = 0;
                    }
                })
                $(self)
                    .find('.tab-all-desc')
                    .text(res['name'] || "");
                switch (res['db_name']) {
                    case 'qb': // 全部
                        delete search_data['is_sj'];
                        search_data['is_all'] = 1;
                        break;
                    case 'sj': // 上架
                        delete search_data['is_all'];
                        search_data['is_sj'] = 1;
                        break;
                    case 'xj': // 下架
                        delete search_data['is_all'];
                        search_data['is_sj'] = 0;
                        break;
                };
                getList();
            },
            end: function () {
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            }
        });
    });
}

function preventDefault(e) {
    e.preventDefault();
}

// 计算底部圆圈定位
function computedCilcleLocation() {
    $('#p-batch-old').css({
        bottom: api.safeArea.bottom + (fun.computedHtmlFontSize() * 5)
    })
}

//没有线上店铺或AI商城的标签页
function permissions(){
    $('.tab-all').hide();
    $('.tab-item').eq(2).hide();
    $('.tab-list,.tab-item:last-of-type').css({
        flex: 1
    })
}