var html_name = page_arr.shop_kh_gl

$('#header').header({
    back: true,
    title: '跟进管理',
});

page_init = function () {
    getList();
    bindEvent();
    init();

    api.addEventListener({
        name: html_name
    },function(ret,err){
        console.log(ret)
        switch(ret.value.status){
            case 'refresh':
                getList();
                break;
        }
    })
}

// 页面初始化
function init() {
    $('#main').css({
        marginTop: api.safeArea.top + $('#header').outerHeight() - parseFloat($('html').css('fontSize'))
    })
}

function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.countStatusInfo,
        data: {
            "type": ['primary', 'potential', 'visitor', 'stop']
        },
        success: function (res) {
            //if(res.status == 0){
            $('#emphasis').text(res.count_primary + '人')
            $('#potential').text(res.count_potential + '人')
            $('#visitor').text(res.count_visitor + '人')
            $('#blacklist').text(res.count_stop + '人')
            //}
        }
    })
}

function bindEvent() {
    //跳转到重点跟进客户页面
    $('.zhongdian').on('tap', function () {
        fun.showPageFull({
            page_url: page_arr.shop_kh_zdgjkh,
            pageParam: {
                return_page: html_name,
                type: 'zdgjkh',
            }
            //closeWin: true,
        });
    })
    //潜在客户
    $('.qianzai').on('tap', function () {
        fun.showPageFull({
            page_url: page_arr.shop_kh_zdgjkh,
            pageParam: {
                return_page: html_name,
                type: 'qzkh',
            }
        });
    })
    //访客
    $('.fangke').on('tap', function () {
        fun.showPageFull({
            page_url: page_arr.shop_kh_zdgjkh,
            pageParam: {
                return_page: html_name,
                type: 'fk',
            }
        });
    })
    //黑名单
    $('.heimingdan').on('tap', function () {
        fun.showPageFull({
            page_url: page_arr.shop_kh_zdgjkh,
            pageParam: {
                return_page: html_name,
                type: 'hmd',
            }
        });
    })
}