var html_name = page_arr.shop_product_class_edit,
    page_type, page_data = {};
var auth_type, auth_val = [],
    _origin_data = {};
/******头部显示******/
$("#header").header({
    back: true,
    title: '产品类别',
    del: Auth.check('cplb', 'edit') ? true : false,
    appendBackBtnEvt: isDataChange
});

page_init = function () {
    if (!AuthVersionCheck.checkHide('xsdp')) {
        $('.jurisdiction').show()
    }

    if (!Auth.check('cplb', 'edit')) {
        $('#cls_type').attr('disabled', 'true')
        $('.qxxz , .radio-text, #cls_ptype,.lb_box').css('pointer-events', 'none')
        // $('.icon-minus,.cut_info_list,.sub,#del_btn').hide()
        $('.icon-minus,.cut_info_list,#del_btn').hide();
    }
    switch (page_data['opt_type']) {
        case 'add':
            _origin_data = {
                "id": 0,
                "name": '',
                "parent_id": page_data['class_id'] || 0,
                "auth_type": page_data['auth_type'] || 'all',
                "auth_val": [],
            }

            $('#del_btn').hide();
            $('#cls_ptype').text(page_data['class_name']);
            $('#cls_ptype').attr('cls_id', page_data['class_id']);
            break;

        case 'edit':
            _origin_data = {
                "id": page_data['id'],
                "name": page_data['class_name'],
                "parent_id": page_data['class_id'],
                "auth_type": page_data['auth_type'],
                "auth_val": $.nui.isTrue(page_data['auth_val']) ? JSON.parse(page_data['auth_val']) : [],
            }

            $('#cls_type').val(page_data['class_name']);
            if (page_data['parent_name'] != 'undefined' && page_data['parent_name'] != '') {
                $('#cls_ptype').text(page_data['parent_name']);
            }
            $('#cls_type').attr('cls_id', page_data['class_id']);
            break;
    }

    if (page_data['auth_type'] == 'all' || $.nui.isEmpty(page_data['auth_type'])) {
        $('.cls_types').css('display', 'none');
        auth_type = page_data['auth_type'] || 'all'
    } else {
        $('.qxxz').eq(0).removeClass('showsimg');
        $('.qxxz').eq(1).addClass('showsimg');
        $('.cls_types').css('display', 'block');
        if (page_data['auth_type'] == 'zdkh') {
            $('.lb_box').eq(1).addClass('active').parent().siblings().children().removeClass('active');
            $('.zdkhs').show().siblings('.cut_info').hide();
        }
        auth_type = page_data['auth_type']
    }

    if ($.nui.isTrue(page_data['auth_val'])) {
        showList(JSON.parse(page_data['auth_val']), page_data['auth_type'])
    }

    // 新增取消绑定类别
    if ($.nui.isTrue($('#cls_ptype').text()) && Auth.check('cplb', 'edit')) {
        $('#icon_close_btn').show();
    }

    // fun.keyboardEject('.sub');
    //监听返回键
    page_data.keyback = function () {
        isDataChange();
    };

    api.addEventListener({
        name: html_name,
    }, function (res) {

        //is_edit是否有修改权限
        var temp = res['value']['data'];

        if (!!res) {
            switch (res.value.status) {
                case "class":
                    //父级类别、父级id
                    $('#cls_ptype').text(temp['class_name']);
                    page_data['class_id'] = temp['class_id']
                    break;
                case "select_list":
                    if (temp['type'] == 'zdkhs') { //指定客户渲染
                        $('#zdkhs').empty();
                        // temp['kh_class'] = fun.createApiDataIndex(temp['kh_class']);
                        showList(temp['kh_class'], 'zdkh')
                    } else if (temp['type'] == 'zdlb') { //指定类别渲染
                        $('#khlbs').empty();
                        // temp['zd_class'] = fun.createApiDataIndex_two(temp['zd_class']);
                        showList(temp['zd_class'], 'zdlb')
                    }

                    break;
            }
        }
    });

    bindEvent();
};

function isDataChange() {
    var auth_data = []
    if (auth_type == 'zdlb') {
        if ($('#khlbs').children().hasClass('cut_info_list')) {
            var auth_id = $('#khlbs > .cut_info_list')
            for (var i = 0; i < auth_id.length; i++) {
                var index = auth_id.eq(i).data('list')
                auth_data.push(fun.apiDatas[index])
            }
        }
    } else if (auth_type == 'zdkh') {
        var auth_id = $('#zdkhs > .cut_info_list')
        if ($('#zdkhs').children().hasClass('cut_info_list')) {
            for (var i = 0; i < auth_id.length; i++) {
                var index = auth_id.eq(i).data('list')
                auth_data.push(fun.apiData[index])
            }
        }
    }
    var _save_data = {
        "id": page_data['id'] || 0,
        "name": $('#cls_type').val().trim() || '',
        "parent_id": $.nui.isEmpty(page_data['class_id']) ? 0 : page_data['class_id'],
        "auth_type": auth_type || '',
        "auth_val": auth_data || []
    }

    if (page_data['parent_name'] !== 'undefined' && $.nui.isTrue(page_data['parent_name']) && $.nui.isEmpty($('#cls_ptype').text().trim())) { // hcx 2020-03-13 新增取消绑定上级类别
        _save_data['cancelBinding'] = true;
    }

    //对比判断是否修改
    if (!$.nui.isObjEquals(_origin_data, _save_data)) {
        if ($('body').find('.data-change-skin').length) return;
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                verify();
            },
            no: function () {
                setTimeout(function () {
                    api.closeToWin({
                        name: page_data['return_page']
                    })
                }, 200)
            }
        });
    } else {
        setTimeout(function () {
            api.closeToWin({
                name: page_data['return_page']
            })
        }, 200)
    }
}


function bindEvent() {
    //iphoneX
    $('.sub').css('padding-bottom', api.safeArea.bottom + 'px')

    //单选框
    $('.qxxz').on('tap', function () {
        var type = $(this).data('type');
        $('.qxxz').removeClass('showsimg');
        $(this).addClass('showsimg');
        if (type === 'zdyhkj') {
            $('.cls_types').css('display', 'block');
            auth_type = 'zdlb'
        } else {
            $('.cls_types').css('display', 'none');
            auth_type = 'all'
        }
    });

    $('.radio-text').on('tap', function () {
        var type = $(this).prev('.qxxz').data('type');
        $('.qxxz').removeClass('showsimg');
        $(this).prev('.qxxz').addClass('showsimg');
        if (type === 'zdyhkj') {
            $('.cls_types').css('display', 'block');
            auth_type = 'zdlb'
        } else {
            $('.cls_types').css('display', 'none');
            auth_type = 'all'
        }
    });

    //选择上级类别
    $('body').on('tap', '#cls_ptype', function () {
        fun.showPageFull({
            page_url: page_arr.shop_product_class_two,
            pageParam: {
                return_page: html_name,
                type: "class_edit",
                class_id: page_data['id']
            }
        });
    });

    //删除客户
    $('body').on('tap', '.class_delete', function () {
        var id = $(this).parents('.cut_info_list').attr('id')
        var name = $(this).parents('.cut_info_list').text()
        fun.dialog({
            content: '你确定要删除【' + name + '】吗？',
            btn: ['删除', '取消'],
            yes: function () {
                $('#' + id).remove();
            }
        });
    });

    //添加类别
    $('body').on('tap', '.class_add', function () {
        var type = $(this).data('type');

        if (type == 'zdkhs') {
            auth_val = [];
            var auth_id = $('#zdkhs > .cut_info_list')

            if ($.nui.isTrue(auth_id.length)) {
                for (var i = 0; i < auth_id.length; i++) {
                    var index = JSON.parse(auth_id.eq(i).data('list'))
                    auth_val.push(fun.apiData[index].id)
                }
            }
            fun.showPageFull({
                page_url: page_arr.customer_search,
                pageParam: {
                    return_page: html_name,
                    page_type: 'kh',
                    page_status: 'class_edit',
                    auth_val: auth_val
                }
            });
        } else {
            auth_val = [];
            var auth_id = $('#khlbs > .cut_info_list')
            if ($.nui.isTrue(auth_id.length)) {
                for (var i = 0; i < auth_id.length; i++) {
                    var index = JSON.parse(auth_id.eq(i).data('list'))
                    auth_val.push(fun.apiDatas[index].id)
                }
            }
            fun.showPageFull({
                page_url: page_arr.select_type,
                pageParam: {
                    return_page: html_name,
                    page_type: 'kh',
                    page_status: 'class_edit',
                    auth_val: auth_val
                }
            });
        }
    });

    //删除类别
    $('body').on('tap', '#del_btn', function () {
        fun.dialog({
            content: '你确定要删除【' + page_data['class_name'] + '】吗？',
            btn: ['删除', '取消'],
            yes: function () {
                var param = {
                    'id': page_data['id'],
                    "is_delete": 1,
                    'subLevel': false,
                    'save_type': 'delClass',
                    'type': 'cp'
                };
                //存在子类别
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.getSimpleRecordList,
                    data: {
                        type: 'cp'
                    },
                    success: function (res) {

                        if (res['status'] === 0) {
                            for (var i = 0; i < res['data'].length; i++) {
                                var data = res['data'][i]
                                if (data['parent_id'] == page_data['id']) {
                                    return fun.toast('【' + page_data['class_name'] + '】已被调用过，无法删除。');
                                }
                            }

                            fun.ajax({
                                showLoad: true,
                                hideLoad: true,
                                url: AJAX_URL.saveSimpleRecord,
                                data: param,
                                success: function (res) {
                                    switch (res['status']) {
                                        case 0:
                                            api.sendEvent({
                                                name: page_arr.shop_product_class,
                                                extra: {
                                                    status: 'refresh'
                                                }
                                            })
                                            setTimeout(function () {
                                                api.closeToWin({
                                                    name: page_arr.shop_product_class
                                                })
                                            }, 500)

                                            break;
                                        case 103:
                                            fun.toast('【' + res['data']['name'] + '】已被调用过，无法删除。');
                                            break;
                                        case 104:
                                            fun.toast('删除失败。');
                                            break;
                                        default:
                                            fun.toast(res.msg);
                                    }
                                }
                            });
                        }
                    }
                });

            }
        });
    });

    //权限选择
    $('body').on('tap', '.qx_items', function () {
        if (!$(this).is(':checked')) {
            $(this).siblings('.qxxz').removeClass('hideimg').addClass('showsimg');
            $(this).parent().siblings().children('.qxxz').removeClass('showsimg').addClass('hideimg');
        }
    });

    //切换类别选项
    $('body').on('tap', '.lb_box', function () {
        var type = $(this).data('type');
        var cut_obj = $('.' + type);
        if (!$(this).hasClass('active')) {
            $(this).addClass('active').parent().siblings().children().removeClass('active');
            cut_obj.show().siblings('.cut_info').hide();
        }
        if (type == 'khlbs') {
            //指定类别
            auth_type = 'zdlb'
        } else {
            //指定客户
            auth_type = 'zdkh'
        }
    });

    $('body').on('tap', '#saveData', function (e) {
        e.stopPropagation()
        e.preventDefault()
        verify()
    });

    $('body').on('click', '#icon_close_btn', function () {
        // if (!Auth.check('cplb', 'edit')) return;
        $('#cls_ptype').text('');
        $(this).hide();
    })
}

//保存前校验
var cls_type;

function verify() {
    cls_type = $('#cls_type').val().trim()
    if ($('#cls_type').val().trim() == '') {
        fun.toast('类别不能为空')
        // setTimeout(function(){
        //   $('#cls_type').focus()
        // },300)
        return;
    }
    //所有人可见
    if (auth_type == 'all' || auth_type == '') {
        auth_val = []
    }
    fun.showLoad()
    fun.ajax({
        url: AJAX_URL.getSimpleRecordList,
        data: {
            type: 'cp'
        },
        success: function (res) {
            if (res['status'] === 0) {
                for (var i = 0; i < res['data'].length; i++) {
                    var data = res['data'][i];
                    if (!!page_data['id']) {
                        if (data['id'] == page_data['id']) {
                            continue;
                        }
                    }

                    var cls_type = $('#cls_type').val().trim()
                    if (data['parent_id'] === 0 && $.nui.isEmpty(page_data['class_id'])) {
                        if (cls_type == data['name']) {
                            setTimeout(function () {
                                $('#cls_type').select()
                                fun.hideLoad()
                            }, 200)
                            return fun.toast('【' + cls_type + '】已存在');
                        }
                    } else if (data['parent_id'] == page_data['class_id']) {
                        if (cls_type == data['name']) {

                            setTimeout(function () {
                                $('#cls_type').select()
                                fun.hideLoad()
                            }, 200)
                            return fun.toast('【' + cls_type + '】已存在')
                        }
                    }
                }
                saveData()
            } else {
                setTimeout(function () {
                    fun.hideLoad()
                }, 200)
            }

        },
        error: function () {
            setTimeout(function () {
                fun.hideLoad()
            }, 200)
        }
    })
}

//保存数据
function saveData() {
    var auth_data = [];
    var flag = false; // 2020-3-13 hcx新增取消绑定上级类别
    if (auth_type == 'zdlb') { //指定类别
        if ($('#khlbs').children().hasClass('cut_info_list')) {
            var auth_id = $('#khlbs > .cut_info_list')
            for (var i = 0; i < auth_id.length; i++) {
                var index = auth_id.eq(i).data('list')
                auth_data.push(fun.apiDatas[index])
            }
        }
    } else if (auth_type == 'zdkh') { //指定客户
        var auth_id = $('#zdkhs > .cut_info_list')
        if ($('#zdkhs').children().hasClass('cut_info_list')) {
            for (var i = 0; i < auth_id.length; i++) {
                var index = auth_id.eq(i).data('list')
                auth_data.push(fun.apiData[index])
            }
        }
    }
    if (AuthVersionCheck.checkHide('xsdp')) {
        auth_type = 'all';
        auth_data = [];
    }
    if (page_data['parent_name'] !== 'undefined' && $.nui.isTrue(page_data['parent_name']) && $.nui.isEmpty($('#cls_ptype').text().trim())) flag = true; // 2020-3-13 hcx新增取消绑定上级类别
    fun.ajax({
        // showLoad: true,
        // hideLoad: true,
        url: AJAX_URL.saveSimpleRecord,
        data: {
            "save_type": "saveClass",
            "type": 'cp',
            "id": page_data['id'] || '',
            "name": cls_type,
            "parent_id": flag ? 0 : ($.nui.isEmpty(page_data['class_id']) ? 0 : page_data['class_id']),
            "auth_type": auth_type,
            "auth_val": auth_data || [],
        },
        success: function (res) {
            switch (res.status) {
                case 0:
                    fun.toast('保存成功');
                    api.sendEvent({
                        name: page_arr.shop_product_class,
                        extra: {
                            status: 'refresh'
                        }
                    })
                    api.closeToWin({
                        name: page_data['return_page']
                    })
                    break;
                case 104:
                    $('#cls_type').select()
                    fun.toast('【' + $('#cls_type').val().trim() + '】已存在')
                    break;
                default:
                    fun.toast('保存失败');
                    break;
            }
            setTimeout(function () {
                fun.hideLoad()
            }, 200)
        },
        error: function () {
            setTimeout(function () {
                fun.hideLoad()
            }, 200)
        }
    })
}

function showList(list, type) {
    var html = [];
    var data = [];
    if (type == 'zdlb') {
        data = fun.createApiDataIndex_two(list);
    } else if (type = 'zdkh') {
        data = fun.createApiDataIndex(list);
    }

    for (var i = 0; i < data.length; i++) {
        html.push(' <p class="cut_info_list" id="' + data[i].id + '"  data-list="' + data[i].__index + '">')
        html.push('<span class="class_delete"><i class="iconfont icon-minus"></i></span>')
        html.push('<span class="lb_name">' + data[i].select_val + '</span>')
        html.push('</p>')
    }

    if (type == 'zdkh') {
        $('#zdkhs').append(html.join(''))
    } else {
        $('#khlbs').append(html.join(''))
    }
}
//对得到得数据进行排序
function sortByKey(array, key) {
    return array.sort(function (a, b) {
        var x = a[key];
        var y = b[key];
        return ((x < y) ? -1 : ((x > y) ? 1 : 0));
    });
}

var all = []

function getAllSon(ars) {
    for (var j = 0; j < ars.length; j++) {
        all.push(ars[j]);
        if (!!ars[j]['son'][0]) {
            getAllSon(sortByKey(ars[j]['son'], 'sort'));
        }
    }
    return all;
}

//排序格式化
function ceilFormat(arr) {
    var p_arrs = [],
        c_arrs = [];
    for (var i = 0; i < arr.length; i++) {
        if (arr[i]['parent_id'] === 0) {
            p_arrs.push(arr[i]);
        } else {
            c_arrs.push(arr[i]);
        }
    }
    for (var i = 0; i < c_arrs.length; i++) {
        c_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (c_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                c_arrs[i]['son'].push(c_arrs[j]);
                // all.push(c_arrs[j]);
            }
        }
    }
    for (var i = 0; i < p_arrs.length; i++) {
        p_arrs[i]['son'] = [];
        for (var j = 0; j < c_arrs.length; j++) {
            if (p_arrs[i]['id'] == c_arrs[j]['parent_id']) {
                p_arrs[i]['son'].push(c_arrs[j]);
            }
        }
    }
    return sortByKey(p_arrs, 'sort'); //sort按照升序
}

/**
 * 创建列表数据的下标
 * @param datas {Array}
 */
fun.createApiDataIndex_two = function (datas) {
    fun.apiDatas = JSON.parse(JSON.stringify(datas));
    $(datas).each(function (index, item) {
        item.__index = index;
    });

    return datas;
};