var html_name = page_arr.shop_product_compile; // 页面名称
var params_data = [];
var photoBrowser = null; // 拍照单选图片
var UIAlbumBrowser = null; // 多选图片
var IS_PAGE_EDIT = true; // 页面是否可编辑
var _origin_data = {};
var _save_data = {};
var label_arr = ''; // 标签
var DATA_LIST = {};

var countent = 0;
var item = {};
var custom = 1;

var count = 0; // 相册图片递归终止变量
var cp_lb_list = null;
var SYS_CONFIG = {};
var imgInfo = []; // 临时存储相册图片路径
var imgSub = { // 最多还可以选择几张图片
    cpMax: 0,
    skMax: 0,
    bbxqMax: 0
}
var main_isTure = {     //判断该类型是否开启主要功能，给底卡编辑做记忆功能用
    'gys_isTure': 0,
};

search_data = { // 单选多选
    'id': 0
};

// 返回被删除的列表
delete_list = {
    colour_arr: [], // 颜色
    width_weight_arr: [], // 幅宽克重
    spec_arr: [], // 规格
    fzxx_arr: [], // 辅助信息（其他要求）
    craft_arr: [], // 工艺
    fzxx_colouArr: [],//删除的底卡辅助颜色信息
};

// 产品信息
var CP_INFO = {
    info: {},
    goods_colour: [],
    goods_weight: [],
    goods_spec: [],
    merchant_assistant: [],
    goods_machining: [],
    goods_craft: [],
    options: {},
    param: [],

    goods_xzgy: [],
    delete_yarn_material: [],
    delete_xzgy: []
};

// 默认
var default_obj = {
    default_fkkz: {}, // 幅宽克重默认
    default_gg: {} // 规格默认
}

// 图片滑动
var sortable = {
    sortable1: null, // 产品主图拖拽
    sortable2: null, // 色卡主图拖拽
    sortable3: null //  宝贝详情拖拽
};

// 点击类型弹出
var type_data = [
    {
        id: 1,
        name: '成品',
        db_name: 'cp',
        is_choose: 1
    },
    {
        id: 2,
        name: '坯布',
        db_name: 'pb',
        is_choose: 0
    },
];

var shopCompile = {};

// 页面适配
shopCompile.pageAdaptive = function () {
    $('#cancel_photo, #cancel_popup').css({
        marginBottom: api.safeArea.bottom
    });

    $('.bottom-space-evenly, #wrap').css({
        paddingBottom: api.safeArea.bottom
    });

    if (!!$('.fixed:visible').length) {
        $('#click-show').css({
            marginBottom: $('.fixed').height()
        })
    } else {
        $('#click-show').css({
            marginBottom: $('.fixed:visible').length ? $('.fixed').outerHeight() : $('#wrap').css('padding-bottom', api.safeArea.bottom / 2)
        })
    }
};

shopCompile.showLabelPopUp = function () {
    $('#shop_popup, .box').show();
}

shopCompile.hideLabelPopUp = function () {
    $('#shop_popup, .box').hide();
}

shopCompile.setLabelStatus = function (params) {
    var hotSale = params.hotSale;
    var recommend = params.recommend;

    $('#new_label').data('hotSale', hotSale);
    $('#new_label').data('recommend', recommend);
};

shopCompile.changeLaberStatus = function (params) {
    var removeClass = params.removeClass;
    var addClass = params.addClass;
    var changeText = params.changeText;

    $('#selling_status_icon').removeClass(removeClass);
    $('#selling_status_icon').addClass(addClass);
    $('#selling_status_desc').text(changeText);

}

// 该方法为了处理，按颜色报价，价格填好返回，再重新新增颜色不进入报价页面，价格区间缺少新增颜色
shopCompile.productPriceCheck = function () {
    var jgValue = CP_INFO['info']['jg_value'] || [];
    var targetArr = [];
    var productColor = CP_INFO['goods_colour'];
    var tempColorArr = JSON.parse(JSON.stringify(jgValue));
    var tempArr = [];
    for (var i = 0; i < productColor.length; i++) {
        var colorItem = productColor[i];
        var mark = false;
        // var nowTime = fun.dateFormat('yyyy-MM-dd hh:mm', new Date());
        mark = tempColorArr.some(function (item, idx) {
            return colorItem['number'] === item['cp_ys_bh'];
        })
        if (!mark) {
            tempArr.push({
                idx: i,
                data: colorItem
            });
        }
    }
    for (var i = 0; i < tempArr.length; i++) {
        var item = tempArr[i];
        tempColorArr.splice(item.idx, 0, {
            bz_bzj: 0,
            bz_sj: '',
            cp_mc: $('#cp_mc').val().trim(),
            cp_ys_bh: item['data']['number'],
            cp_ys_mc: item['data']['name'] || '',
            cp_ys_id: item['data']['id'] || 0,
            id: page_data['id'] || 0,
            jy_bzj: 0,
            jy_sj: ''
        })
    }

    // 去除重复数据
    for (var i = 0; i < tempColorArr.length; i++) {
        var colorItem = tempColorArr[i];
        var mark = productColor.some(function (item, idx) {
            return colorItem.cp_ys_id === item.id && colorItem.cp_ys_bh === item.number;
        })

        if (mark) {
            targetArr.push(colorItem);
        }
    }

    // 重新排序
    var res = [];
    productColor.forEach(function (item, idx) {
        for (var i = 0; i < targetArr.length; i++) {
            var jgValueItem = targetArr[i];
            if (item.number === jgValueItem.cp_ys_bh) {
                res.push(jgValueItem);
                break;
            }
        }
    });
    return res;
}

// 更新产品价格
shopCompile.productPriceUpDate = function () {
    if (CP_INFO['info']['jg_type'] !== 'ys') return;
    var newProductPrice = this.productPriceCheck();
    if ($.nui.isTrue(newProductPrice)) {
        CP_INFO['info']['jg_value'] = newProductPrice;
        showJg();
    }
}

page_init = function () {
    SYS_CONFIG = fun.getItem('sys_config') || {};
    IS_PAGE_EDIT = Auth.check('cp', 'edit');
    fun.load_DATA_LIST(['jjdw', 'cp_lb'], function () {
        cp_lb_list = fun.getItem('cp_lb_list');
        if (!page_data['id']) {
            $('#cp_lb').attr('lb_id', page_data['last_lb_id'] || 0).val(fun.getValByKey(cp_lb_list, page_data['last_lb_id'], 'name')) || '';
        }
    }, {
        showLoad: true,
        hideLoad: false,
        close: false
    });

    photoBrowser = api.require('photoBrowser');
    UIAlbumBrowser = api.require('UIAlbumBrowser'); // 多选图片模块

    if (IS_PAGE_EDIT) {
        $('.fixed').show();
    }
    if (page_data && page_data['id']) { // 记录行进来
        search_data['id'] = page_data['id'];
        $('#shade').show();
        if (!Auth.check('cp_fzxx', 'view')) { // 没有底卡信息的浏览权限，不显示这一行
            $('#bottom-card').hide();
        }
        getList();
    } else { // 新增进来
        var newAdd = [{
            id: 0,
            sort: 1,
            number: '白坯#',
            name: '',
            type: '',
            wldw_mc: '',
            merchant_id: 0,
            order_amount: '',
            is_stop: 0,
            remark: '',
            imgs: [],
            goods_material: [],
            yarn_material: [] // 2024-04-08 添加字段，不添加会报错
        }]

        CP_INFO['goods_colour'] = newAdd;
        showNewAdd();

        getParam(); // 获取参数
        getNumber(); // 获取产品编号
    }

    $('.message-wrap').hide();

    $("#header").header({ // 头部初始化
        back: true,
        title: '产品',
        appendBackBtnEvt: isDataChange
    })

    page_data.keyback = function () { // 监听安卓返回键
        isDataChange();
    };

    // 时间插件
    new lCalendar().init({
        'trigger': '#cp_sj',
        'type': 'datetime',
        callback: function (date) {
            $('#cp_sj').text(date);
        }
    });

    api.addEventListener({
        name: page_arr.shop_product_compile,
    }, function (ret, err) {
        console.log(ret);
        var temp = ret['value'] || {},
            data = temp['data'] || {};
        switch (temp['status']) {
            case "select_list":
                var id = fun.is_value(data['id'], 0);
                switch (data['page_type']) {
                    case "cp_lb":
                        $('#cp_lb').attr('lb_id', id).val(data['select_val'] || "");
                        break;
                    case "cp_jd":
                        $('#cp_jd').attr('jd_id', id).val(data['select_val'] || "");
                        break;
                    case "dw":
                        $('#cp_dw').attr('dw_id', id).val(data['select_val'] || "");
                        CP_INFO.info.unit_id = id;
                        showJg();
                        break;
                    case "cp_gy":
                        $('#cp_gy').attr('gy_id', id).val(data['select_val'] || "");
                        break;
                    // 没有default
                }
                break;
            case 'cpzl_data':
                switch (temp['page_type']) {
                    case 'gg': // 规格
                        CP_INFO['goods_spec'] = temp['list']; // 修改后的规格数据
                        if ($.nui.isTrue(temp['delete_arr'])) {
                            $(temp['delete_arr']).each(function (idx, item) {
                                delete_list['spec_arr'].push(item);
                            })
                        }
                        default_obj['default_gg'] = temp['default_obj']; // 默认的规格数据
                        $('#cp_gg').val(default_obj['default_gg']['spec']);
                        break;
                    case 'fkkz': // 幅宽克重
                        default_obj['default_fkkz'] = temp['default_obj'];

                        CP_INFO['goods_weight'] = temp['list']; // 幅宽克重页面修改后的数据
                        if ($.nui.isTrue(temp['delete_arr'])) {
                            $(temp['delete_arr']).each(function (idx, item) { // 幅宽克重页面被删除的数据
                                delete_list['width_weight_arr'].push(item);
                            })
                        }
                        if ($.nui.isTrue(default_obj['default_fkkz'])) {
                            $('#fk_ipt').val(fun.is_value(default_obj['default_fkkz']['width']));
                            $('.fk-unit').text(fun.is_value(default_obj['default_fkkz']['fk_dw']));
                            $('#kz_ipt').val(fun.is_value(default_obj['default_fkkz']['weight']));
                            $('.kz-unit').text(fun.is_value(default_obj['default_fkkz']['kz_dw']));
                        } else {
                            $('#fk_ipt').val('');
                            $('#kz_ipt').val('');
                            $('.fk-unit').text('cm'); // 幅宽克重单位暂时用cm和g，后面需求调整（读取上一个产品的幅宽克重单位）
                            $('.kz-unit').text('g');
                        }
                        break;
                    case 'qtyq': // 其他要求
                        CP_INFO['goods_craft'] = temp['list']; // 其他要求
                        if ($.nui.isTrue(temp['delete'])) {
                            $(temp['delete']).each(function (idx, item) {
                                delete_list['craft_arr'].push(item); // 删除的工艺
                            })
                        }
                        break;
                    case 'qtcs': // 其他参数
                        CP_INFO['param'] = temp['list'];
                        break;
                    case 'dk_xx': //  底卡信息 
                        var tempArr = [];
                        CP_INFO['merchant_assistant'] = temp['merchant_assistant'];
                        if ($.nui.isTrue(CP_INFO['merchant_assistant'])) {
                            $(CP_INFO['merchant_assistant']).each(function (idx, item) {
                                if (item['is_delete']) { // 被删除的需要把id传进去
                                    if ('id' in item) {
                                        delete_list['fzxx_arr'].push(item['id']);
                                    }
                                } else { // 没被删除
                                    if (item['merchant_id']) {
                                        tempArr.push(item);
                                    }
                                }
                            })
                        }
                        CP_INFO['merchant_assistant'] = tempArr;
                        $('#fzxx_jl').text(CP_INFO['merchant_assistant'].length + '个');
                        break;
                    case 'dk_bj':
                        if ($.nui.isTrue(temp['data']['merchant_name'])) {
                            $(temp['data']).each(function (index, item) {
                                CP_INFO['merchant_assistant'].push(item);
                            })
                            $('#fzxx_jl').text(CP_INFO['merchant_assistant'].length + '个');
                        } else {
                            $('#fzxx_jl').text('0个');
                        }
                        break;
                }
                break;
            case 'shop_cp_ys_bj': // 颜色编辑界面返回到产品编辑界面，需要返回停用颜色个数
                $(temp['data']).each(function (index, item) {
                    delete item['__index'];
                })
                CP_INFO['goods_colour'] = temp['data']; // 获取颜色编辑界面修改后的数据
                //循环底卡的数量，更换里面的颜色信息
                if (CP_INFO['merchant_assistant'].length > 0) { // 有底卡
                    $(CP_INFO['merchant_assistant']).each(function (merchant_index, colour_item) {
                        var colour_length = colour_item['colour_assistant'].length; // 有多少个赋值颜色
                        var parme_arr = [];
                        $(CP_INFO['goods_colour']).each(function (colour_index, item) {   // 返回颜色通知底卡颜色改变
                            var index = item['_index']; // 产品编辑颜色的_index
                            // 判断如果有新增的颜色则做加入，存在则做修改,如果存在，则colour_assistant数组长度是大于0的
                            if (('_index' in item)) {
                                var colour_assistant = colour_item['colour_assistant'][index];
                            }
                            if (('_index' in item) && colour_item['colour_assistant'].length > 0 && colour_assistant != undefined && ('goods_colour_id' in colour_assistant)) {
                                var parme = {
                                    colour_number: item['number'] || '',
                                    colour_name: item['name'] || '',
                                    id: colour_assistant['id'],
                                    goods_id: item['goods_id'],
                                    merchant_assistant_id: colour_assistant['merchant_assistant_id'],
                                    goods_colour_id: item['id'],
                                    number: colour_assistant['number'] || '',
                                    name: colour_assistant['name'] || '',
                                    simple: colour_assistant['simple'],
                                    order_amount: colour_assistant['order_amount'] || 0,
                                    price: colour_assistant['price'] || 0,
                                    is_delete: colour_assistant['is_delete'],
                                    create_time: colour_assistant['create_time'],
                                    update_time: colour_assistant['update_time'],
                                    is_stop: item['is_stop']
                                }
                                // if ('is_stop' in colour_assistant) {
                                //     parme['is_stop'] = item['is_stop'];
                                // }
                                parme_arr.push(parme);
                            } else {
                                var parme = {
                                    colour_name: item['name'],
                                    colour_number: item['number'],
                                    id: 0,
                                    is_delete: 0,
                                    name: '',
                                    number: '',
                                    order_amount: 0,   //如果底卡是新增的，但还没保存的情况下，则那新增时价格对应进去，如果有多余的，则取0
                                    price: ('_index' in item && colour_length >= (item['_index'] + 1)) ? colour_assistant['price'] : 0,
                                    is_stop: item['is_stop']
                                }
                                // if ('is_stop' in colour_assistant) { parme['is_stop'] = item['is_stop'] }
                                parme_arr.push(parme);
                            }
                        })

                        //判断是否有删除，有则把对面辅助颜色id返回
                        if ($.nui.isTrue(temp['delete_colour'])) {
                            $(temp['delete_colour']).each(function (idx, item) {
                                if (item['_index'] != '') {
                                    delete_list['fzxx_colouArr'].push(colour_item['colour_assistant'][item['_index']]['id'])
                                }
                            })
                        }
                        colour_item['colour_assistant'] = parme_arr;
                    })
                }
                $('#ys_stop_count').text(temp['stop_count'] + '个');
                if ($.nui.isTrue(temp['delete_colour'])) {
                    $(temp['delete_colour']).each(function (idx, item) {
                        delete_list['colour_arr'].push(item['id']); // 被删除颜色列表
                    })
                }

                shopCompile.productPriceUpDate();

                break;
            case 'label': // 选择标签
                label_arr = temp['label_arr'];
                getLabel(label_arr);
                break;
            case 'jg': // 价格
                // 如果价格界面有辅助单位和id，传过去的就拿价格界面辅助单位和id，如果没有，就拿产品编辑界面的单位和id
                // cpbjInfo = temp['cpbjInfo'];
                CP_INFO['info']['unit_options']['xsdw_id'] = Number(temp['jjdw_id']) || 0;
                CP_INFO['info']['jg_value'] = temp['jg_value'];
                CP_INFO['info']['jg_type'] = temp['jg_type']; // 报价方式
                CP_INFO['info']['color_card_price'] = temp['color_card_price']; // 色卡价格
                console.log(CP_INFO);
                showJg();
                break;
            case 'update': //更新类别
                // if (data['page_type'] == 'cp_lb') {
                //     for (var i = 0; i < data['del_id'].length; i++) {
                //         if (data['del_id'][i] === Number($('#cp_lb').attr('lb_id'))) {
                //             $('#cp_lb').attr('lb_id', '').
                //         }
                //     }
                // }
                var backUpDateArr = [
                    { // 类别
                        pageType: 'cp_lb',
                        idName: 'lb_id'
                    },
                    { // 季度
                        pageType: 'cp_jd',
                        idName: 'jd_id'
                    },
                    { // 单位
                        pageType: 'dw',
                        idName: 'dw_id'
                    },
                    { // 工艺
                        pageType: 'cp_gy',
                        idName: 'gy_id'
                    }
                ];
                fun.upDateBackSelRow({
                    backSelRow: data,
                    backUpDateArr: backUpDateArr,
                    storageMode: 'attr',
                    assignMode: 'val',
                });
                break;
        }

        if (data['page_type'] == 'dw') { // 单位
            $('.unit').text(data['select_val']);
        }
    });

    bindEvent(); // 绑定事件
    pageEditDisabled();
    fun.setKeyBoard({
        isIos: {
            hideFn: keyBoardHide,
            showFn: keyBoardShow,
        },
        isAnd: {
            hideFn: keyBoardHide,
            showFn: keyBoardShow,
        },
        ele: '.content-wrap',
    });
    _origin_data = JSON.parse(JSON.stringify(getSaveData()));

    shopCompile.pageAdaptive();
}

// 获取计较单位
function getJjdw(xsdw_id) {
    var jjdwMc = '';
    if ($.nui.isTrue(xsdw_id)) { // 销售单位id
        jjdwMc = fun.getValByKey(fun.getItem('jjdw_list'), Number(xsdw_id), 'name');
    } else {
        if ($.nui.isTrue(CP_INFO['info']['unit_id'])) { // 单位id
            jjdwMc = $('#cp_dw').val().trim();
        }
    }
    return jjdwMc;
}

// 获取单位id（有销售单位id拿，没有拿主单位，如果没有给0）
function getUnitId() {
    var unitId = 0;
    if ($.nui.isTrue(CP_INFO['info']['unit_options']['xsdw_id'])) {
        unitId = CP_INFO['info']['unit_options']['xsdw_id'];
    } else if ($.nui.isTrue(CP_INFO['info']['unit_id'])) {
        unitId = CP_INFO['info']['unit_id'];
    }
    return unitId;
}

// 没有取到值返回0
function showVal(value) {
    if ($.nui.isEmpty(value)) {
        value = 0;
    }
    return value;
}

// 显示价格
function showJg() {
    var info = CP_INFO['info'];
    var jgValue = info['jg_value']; // 报价方式价格数据
    var type = info['jg_type']; // 报价方式
    var xsdw_id = info['unit_options']['xsdw_id']; // 计价单位id
    var unit = $.nui.isTrue(getJjdw(xsdw_id)) ? '/' + getJjdw(xsdw_id) : '';

    if ($.nui.isEmpty(jgValue)) { // 没填价格，显示0元，计价单位（有销售辅助单位拿销售辅助单位，没有不显示）
        $('.price-box').text('0元' + unit);
        return;
    } else { // 有价格
        switch (type) {
            case '': // 空报价
                $('.price-box').text('0元' + unit);
                return;
                break;
            case 'sl': // 按数量报价
                var moneyArr = [];
                $(jgValue).each(function (idx, item) {
                    moneyArr.push(showVal(item['money']));
                });

                var maxVal = Math.max.apply(null, moneyArr); // 最高价
                var minVal = Math.min.apply(null, moneyArr); // 最低价

                if (maxVal === minVal) { // 两个值相等
                    var res = minVal + '元' + unit;
                    $('.price-box').text(res);
                    return;
                }

                if (maxVal !== minVal) { // 最高不等于最低（直接赋值最高价和最低价）
                    var res = minVal + '~' + maxVal + '元' + unit;
                    $('.price-box').text(res);
                    return;
                }
                break;
            case 'ys': // 按颜色报价
                var cpYsArr = [];
                var dhArr = [];
                var dhZero = false;
                if ($.nui.isTrue(jgValue)) {
                    $(jgValue).each(function (idx, item) {
                        if (item['cp_ys_bh'] !== '白坯#') {
                            cpYsArr.push(item);
                            dhArr.push(showVal(item['bz_bzj']));
                        }
                    })
                }

                dhZero = dhArr.every(function (item, idx) { // 除了白坯填的都为0
                    return !item;
                })

                var maxDhj = Math.max.apply(null, dhArr);
                var minDhj = Math.min.apply(null, dhArr);

                if ($.nui.isEmpty(cpYsArr) || dhZero) {
                    var res = '0元' + unit;
                    $('.price-box').text(res);
                    return;
                }

                if (cpYsArr.length === 1) { // 一个价格，有填价格，并且不为0，
                    if (!dhZero) {
                        var res = maxDhj + '元' + unit;
                        $('.price-box').text(res);
                        return;
                    }
                }

                if (cpYsArr.length > 1) { // 多个价格
                    if (!dhZero) { // 有值
                        if (maxDhj === minDhj) { // 最高最低相等
                            var res = maxDhj + '元' + unit;
                            $('.price-box').text(res);
                            return;
                        } else {
                            var res = minDhj + '~' + maxDhj + '元' + unit;
                            $('.price-box').text(res);
                            return;
                        }
                    }
                }
                break;
        }
    }
}

function colour_edit(type) {
    if (type.indexOf('more') > -1) {

    }
}

// 删除临时创建的下标
function deleteColorIdx() {
    $(CP_INFO['goods_colour']).each(function (colour_index, item) {
        if ('_index' in item) {
            delete item['_index'];
        }
    })
}

// 点击返回
function isDataChange() {
    deleteColorIdx();
    restrictFkKz(); // 解决安卓没失去焦点直接保存，导致的幅宽克重值没保存进去
    _save_data = JSON.parse(JSON.stringify(getSaveData()));
    if ($.nui.isObjEquals(_origin_data, _save_data)) {
        fun.pageCloseFun({});
        // api.sendEvent({
        //     name: page_data['return_page'],
        //     extra: {
        //         status: 'refresh',
        //     }
        // })
        // closeWin();
    } else {
        if ($('body').find('.data-change-skin').length) return;
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData();
            },
            no: function () {
                fun.pageCloseFun({});
                // api.sendEvent({
                //     name: page_data['return_page'],
                //     extra: {
                //         status: 'refresh'
                //     }
                // })
                // closeWin();
            }
        });
    }
}

// 关闭当前窗口
function closeWin() {
    fun.showLoad();
    setTimeout(function () {
        api.closeWin();
        fun.hideLoad();
    }, 200)
}

// 获取产品信息
function getList() {
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getGoodsInfo,
        data: search_data,
        success: function (res) {
            if (res['status'] == 0) {
                $('#shade').hide();
                DATA_LIST = res.data || {};
                // deleteCorCard(res['data']['goods_colour']); // 去除请求过来的色卡数据
                CP_INFO = res['data'] || CP_INFO;

                // initJgVal();
                resetColorImg();
                $('#header').header({
                    back: true,
                    title: '产品',
                    appendBackBtnEvt: isDataChange
                });
                showData(res['data']);
            }
        }
    })
}

// 图片字符串装数组，过滤空值
function resetColorImg() {
    $(CP_INFO['goods_colour']).each(function (idx, item) {
        var temp = [];
        if ($.nui.isTrue(item['imgs'])) {
            var img = item['imgs'].split(',');
            $(img).each(function (index, imgs) {
                if ($.nui.isTrue(imgs)) {
                    temp.push(imgs);
                }
            })
        } else {
            temp = [];
        }
        item['imgs'] = temp;
    })
}

//获取产品标签
function getLabel(arr, callback) {
    label_arr = arr;
    var lar = label_arr.split(',') || [];
    var tmp = new Array();
    for (var i = 0; i < lar.length; i++) {
        tmp[i] = Number(lar[i]);
    }
    lar = tmp;
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: AJAX_URL.getLabelList,
        data: {
            "type": 'cp',
        },
        success: function (res) {
            if (res['status'] != 0) return fun.toast('获取标签失败。');
            var info_list = res.data;
            var html = [];

            for (var j = 0; j < lar.length; j++) {
                for (var i = 0; i < info_list.length; i++) {
                    var val = info_list[i];
                    if (lar[j] == val['id']) {
                        html.push('<span data-list=\'' + (fun.formatString(JSON.stringify(val))) + '\' class="label" style="background:' + val['colour'] + '">' + val['name'] + '</span>');
                    }
                }
            }

            $("#label_wrap").html(html.join(''));

            if ($(".special").children().length >= 1) {
                $(".special").css({
                    paddingBottom: '1rem'
                })
            } else {
                $(".special").css({
                    paddingBottom: 0
                })
            }

            if (typeof callback === 'function') callback();
        }
    });
}

// 显示产品类型
function showProductType() {
    $(type_data).each(function (idx, item) {
        if (CP_INFO['info']['cp_lx'] === item['db_name']) {
            item['is_choose'] = 1;
        } else {
            item['is_choose'] = 0;
        }
    })
}

// 显示页面数据
function showData(data) {
    CP_INFO['info'] = data['info'];
    CP_INFO['goods_colour'] = data['goods_colour'] || [];
    CP_INFO['goods_weight'] = data['goods_weight'] || [];
    CP_INFO['goods_spec'] = data['goods_spec'] || [];
    CP_INFO['merchant_assistant'] = data['merchant_assistant'] || [];
    CP_INFO['goods_machining'] = data['goods_machining'] || [];
    CP_INFO['goods_craft'] = data['goods_craft'] || [];
    CP_INFO['param'] = data['param'];
    CP_INFO['options'] = data['options'];

    $('#cp_lx').attr('cp_lx', 'cp');
    $('#bbxq').hide(); // 宝贝详情默认隐藏，有开启线上店铺才显示
    var info = data['info'] || {};
    var goods_colour = data['goods_colour'] || []; // 颜色
    var goods_weight = data['goods_weight'] || []; // 克重
    var goods_spec = data['goods_spec'] || []; // 规格
    var merchant_assistant = data['merchant_assistant'] || []; // 辅助信息
    var param = data['param'] || []; // 其他参数
    $('.line-stop').show(); // 编辑状态显示停用按钮

    // 信息
    var cp_img = ($.nui.isTrue(info['imgs'])) ? info['imgs'].split(',') : []; // 产品主图
    var ys_img = ($.nui.isTrue(info['color_card'])) ? info['color_card'].split(',') : []; // 色卡
    var baby_imgs = ($.nui.isTrue(info['bbxq'])) ? info['bbxq'].split(',') : []; // 宝贝详情、

    info['is_stop'] === 1 && $('#switch_stop').addClass('nui-active'); // 是否停用
    $('#cp_bh').val(info['number']); // 编号
    $('#cp_mc').val(page_data['cp_mc'] || info['name']); // 名称
    $('#cp_lb').val(info['lb_mc']); // 类别
    $('#cp_dw').val(info['dw_mc']); // 单位
    $('#cp_cf').val(info['component']); // 成分
    $('#cp_sz').val(info['gauze']); // 纱支
    $('#cp_md').val(info['density']); // 密度

    $('#cp_sj').text(fun.Date(info['date'], true).Format("yy-mm-dd hh:ii")); // 时间
    $('#cp_bz').val(info['remark']); // 备注

    $('#cp_lb').attr('lb_id', info['class_id'] || 0);
    $('#cp_dw').attr('dw_id', info['unit_id'] || 0);

    $('#cp_lx').attr('cp_lx', (info['type'] === "成品") ? "cp" : "pb");

    $('#cp_jd').val(info['jd'] || '').attr('jd_id', info['quarter']); // 季度
    $('#cp_gy').val(info['gy'] || '').attr('gy_id', info['craft']); // 工艺

    if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) {   // 有线上店铺的权限
        $('#bbxq').show()
    }

    if (!Auth.check('cp_fzxx', 'view')) { // 没有底卡信息的浏览权限，不显示这一行
        $('#bottom-card').hide();
    }

    $(goods_weight).each(function (idx, item) {
        if (item['is_default']) {
            $('#kz_ipt').val(item['weight']); // 克重
            $('#fk_ipt').val(item['width']); // 幅宽

            if ($.nui.isTrue(item['fk_dw'])) {
                $('.fk-unit').text(item['fk_dw']); // 幅宽单位
            }
            if ($.nui.isTrue(item['kz_dw'])) {
                $('.kz-unit').text(item['kz_dw']); // 克重单位
            }
            default_obj['default_fkkz'] = item;
            return false;
        } else { // 需求以后调整（应该读取上一个产品的幅宽克重单位）(需求确认过，暂时用这个两个单位)
            $('.fk-unit').text('cm'); // 克重
            $('.kz-unit').text('g'); // 幅宽
        }
    })

    $(goods_spec).each(function (idx, item) { // 规格
        if (item['is_default']) {
            $('#cp_gg').val(item['spec']); // 规格
            default_obj['default_gg'] = item;
            return false;
        }
    })

    $('#fzxx_jl').text(merchant_assistant.length + '个'); // 辅助信息（底卡信息）

    var htmlCpImg = []; // 主图

    if (cp_img.length !== 0) {
        var count = 0;
        for (var i = 0; i < cp_img.length; i++) {
            count++;
            htmlCpImg.push('<li class="show-img">');
            htmlCpImg.push('        <img src="' + fun.getImgPath(cp_img[i]) + '" class="img" alt="" large-url="' + fun.getImgPath(cp_img[i], true) + '" data-name="' + cp_img[i] + '">');

            htmlCpImg.push('        <div class="delete-img" style="display: block;">');
            htmlCpImg.push('            <div class="packs">');
            htmlCpImg.push('                <i class="iconfont icon-fork fork"></i>');
            htmlCpImg.push('            </div>');
            htmlCpImg.push('        </div>');
            // htmlCpImg.push('        <div class="news-circle">');
            // htmlCpImg.push('            <i class=" iconfont icon-fork arrow"></i>');
            // htmlCpImg.push('        </div>');
            htmlCpImg.push('</li>');
        }
        if (cp_img.length >= 9) {
            $('.cp-add-img').before(htmlCpImg.join(''));
            $('.cp-add-img').remove();
        }
        $('#cpzt_size').text(count);
        imgSub['cpMax'] = 9 - count;
        $('.cp-add-img').before(htmlCpImg.join(''));
    }

    var htmlSktpImg = []; // 色卡
    if (ys_img.length !== 0) {
        var count = 0;
        for (var i = 0; i < ys_img.length; i++) {
            count++;
            htmlSktpImg.push('<li class="show-img">');
            htmlSktpImg.push('      <img src="' + fun.getImgPath(ys_img[i]) + '" class="img" alt="" large-url="' + fun.getImgPath(ys_img[i], true) + '" data-name="' + ys_img[i] + '">');
            htmlSktpImg.push('      <div class="delete-img" style="display: block;">');
            htmlSktpImg.push('          <div class="packs">');
            htmlSktpImg.push('              <i class="iconfont icon-fork fork"></i>');
            htmlSktpImg.push('          </div>');
            htmlSktpImg.push('      </div>');
            // htmlSktpImg.push('      <div class="news-circle">');
            // htmlSktpImg.push('          <i class=" iconfont icon-fork arrow"></i>');
            // htmlSktpImg.push('      </div>');
            htmlSktpImg.push('</li>');
        }

        if (ys_img.length >= 9) {
            $('.sktp-add-img').before(htmlSktpImg.join(''));
            $('.sktp-add-img').remove();
        }
        $('#sktp_size').text(count);
        imgSub['skMax'] = 9 - count;
        $('.sktp-add-img').before(htmlSktpImg.join(''));
    }

    var htmlBabyImg = []; // 宝贝详情
    if (baby_imgs.length !== 0) {
        var count = 0;
        for (var i = 0; i < baby_imgs.length; i++) {
            count++;
            htmlBabyImg.push('<li class="show-img">');
            htmlBabyImg.push('      <img src="' + fun.getImgPath(baby_imgs[i]) + '" class="img" alt="" large-url="' + fun.getImgPath(baby_imgs[i], true) + '" data-name="' + baby_imgs[i] + '">');
            htmlBabyImg.push('      <div class="delete-img" style="display: block;">');
            htmlBabyImg.push('          <div class="packs">');
            htmlBabyImg.push('              <i class="iconfont icon-fork fork"></i>');
            htmlBabyImg.push('          </div>');
            htmlBabyImg.push('      </div>');
            // htmlBabyImg.push('      <div class="news-circle">');
            // htmlBabyImg.push('          <i class=" iconfont icon-fork arrow"></i>');
            // htmlBabyImg.push('      </div>');
            htmlBabyImg.push('</li>');
        }
        if (baby_imgs.length >= 30) {
            $('.bbxq-add-img').before(htmlBabyImg.join(''));
            $('.bbxq-add-img').remove();
        }
        $('#bbxq_size').text(count);
        imgSub['bbxqMax'] = 30 - count;
        $('.bbxq-add-img').before(htmlBabyImg.join(''));
    }

    var count = 0;
    $(data.goods_colour).each(function (idx, item) { // 颜色
        if (!item['is_stop']) {
            count++;
        }
    })

    $('#ys_stop_count').text(count + '个');

    $('#cp_lx').text(info['type']);

    shopCompile.productPriceUpDate(); // 显示价格样式

    // showJg(); // 显示价格样式

    showProductType(); // 根据保存时类型做记忆
    _origin_data = JSON.parse(JSON.stringify(getSaveData()));

    getLabel(info['label_id'], function () { // 标签
        _origin_data = JSON.parse(JSON.stringify(getSaveData()));
    });

    $('#new_label').data('hotSale', info['hot_sale']).data('recommend', info['recommend']);

    // 没有开通线上店铺和AI商城的版本 标签不需要显示
    if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) {
        $('#new_label').show();
    } else {
        $('#new_label').hide();
    }

    if (info['label'] === 'rx') { // 标签状态为热销
        shopCompile.changeLaberStatus({
            removeClass: 'icon-tuijian',
            addClass: 'icon-rexiao',
            changeText: '热销'
        })
    } else if (info['label'] === 'tj') { // 标签状态为推荐
        shopCompile.changeLaberStatus({
            removeClass: 'icon-rexiao',
            addClass: 'icon-tuijian',
            changeText: '推荐'
        })
    } else { // 标签状态非热销和非推荐
        $('#selling_status_icon').removeClass('icon-tuijian icon-rexiao');
        $('#selling_status_desc').text('');
    }
}

// 新加进入
function showNewAdd() {
    // var nowTime = fun.dateFormat('yyyy-MM-dd hh:mm', new Date());
    $('#cpzt_size').text(0); // 产品主图最多图片大小
    $('#sktp_size').text(0); // 色卡主图最多图片大小
    $('#bbxq_size').text(0); // 宝贝详情最多图片大小
    units = page_data['last_dw_mc'];
    units_id = page_data['last_dw_id'];
    $('#cp_sj').text(new Date().Format('yy-mm-dd hh:ii'));

    $('#cp_dw').attr('dw_id', page_data['last_dw_id'] || 0).val(page_data['last_dw_mc'] || "");
    if ($.nui.isTrue(page_data['cp_mc'])) {
        $('#cp_mc').val(page_data['cp_mc'] || '');
    }
    CP_INFO['info']['unit_options'] = {
        cgdw_id: Number(SYS_CONFIG['bpfzdw_cg'] || 0),
        jgdw_id: Number(SYS_CONFIG['bpfzdw_jg']) || 0,
        xsdw_id: Number(SYS_CONFIG['bpfzdw_xs']) || 0,
        dw2_id: Number(SYS_CONFIG['bpfzdw_dw2']) || 0
    };

    CP_INFO['info']['jg_type'] = 'ys';
    CP_INFO['info']['jg_value'] = [
        {
            bz_bzj: 0,
            bz_sj: '',
            cp_mc: $('#cp_mc').val().trim(),
            cp_ys_bh: '白坯#',
            cp_ys_mc: '',
            cp_ys_id: 0,
            id: page_data['id'] || 0,
            jy_bzj: 0,
            jy_sj: ''
        }
    ];

    var jjdwMc = '';
    if ($.nui.isTrue(Number(CP_INFO['info']['unit_options']['xsdw_id']))) {
        jjdwMc = '/' + fun.getValByKey(fun.getItem('jjdw_list'), Number(CP_INFO['info']['unit_options']['xsdw_id']), 'name');
    } else {
        if ($.nui.isTrue($('#cp_dw').attr('dw_id'))) {
            jjdwMc = '/' + $('#cp_dw').val().trim();
            CP_INFO['info']['unit_id'] = page_data['last_dw_id'];
        }
    }

    $('.price-box').text('0元' + jjdwMc);

    if (!Auth.check('cp_fzxx', 'view')) { // 没有底卡信息的浏览权限，不显示这一行
        $('#bottom-card').hide();
    }

    $('#ys_stop_count').text(CP_INFO['goods_colour'].length + '个');


    $('.fk-unit').text('cm'); // 克重 (暂时用这两个单位，需求以后调整（应该读取上一个产品的幅宽克重单位）)
    $('.kz-unit').text('g'); // 幅宽 (暂时用这两个单位，需求以后调整（应该读取上一个产品的幅宽克重单位）)

    $('#new_label').data('hotSale', 0).data('recommend', 0); // 2020-03-18 新增需求(新增标签)
}

// 获取幅宽选项列表
function getFkKzList(type) {
    var fk_or_kz = [];
    switch (type) {
        case 'fk': // 幅宽列表选项
            fk_or_kz = [{
                name: 'cm',
                id: 'cm',
                type: 'cm',
                is_choose: 1
            },
            {
                name: 'm',
                id: 'm',
                type: 'm'
            },
            {
                name: 'inch',
                id: 'inch',
                type: 'inch'
            }
            ];
            break;

        case 'kz': // 克重列表选项
            fk_or_kz = [{
                name: 'g',
                id: 'g',
                type: 'g',
                is_choose: 1
            },
            {
                name: 'g/m',
                id: 'g/m',
                type: 'g/m'
            },
            {
                name: 'g/㎡',
                id: 'g/㎡',
                type: 'g/㎡'
            }
            ];
            break;
        // 没有default:
    }
    return fk_or_kz;
}

//获取产品编号
function getNumber() {
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: AJAX_URL.getNumber,
        data: {
            "type": "cp"
        },
        success: function (res) {
            if (res['status'] == 0) {
                $('#cp_bh').val((res['data'] || ""));

                if (!!page_data['cp_bh']) {
                    $('#cp_bh').val(page_data['cp_bh']);
                }
                _origin_data = JSON.parse(JSON.stringify(getSaveData())); // 需要对比数据（暂没做）
            }
        }
    });
}

//获取参数
function getParam() {
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getParamOptions,
        data: {
            "type": "cp"
        },
        success: function (res) {
            if (res['status'] == 0) {
                var data = res['data'];

                $(data['param']).each(function (idx, item) {
                    CP_INFO['param'][idx] = {
                        id: item['id'] || 0,
                        param_id: item['param_id'] || 0,
                        value: '',
                        name: item['name'] || ''
                    }
                })

                _origin_data = JSON.parse(JSON.stringify(getSaveData()));
            }
        }
    });
}

// 没有权限页面禁止编辑
function pageEditDisabled() {
    if (!IS_PAGE_EDIT) {
        $('input').attr('disabled', 'disabled');
    }
    imgHasDrag(); // 有编辑权限才可以拖拽
}

// 拖拽排序
function imgHasDrag() {
    if (IS_PAGE_EDIT) {
        sortable.sortable1 = new Sortable($('#cpzt-img')[0], {
            animation: 150,
            onStart: function (e) {
                preventEvent(e);
            },
            onMove: function (e) {
                preventEvent(e);
                $('.cp-add-img').hide()
                if ($('#cpzt-img .img:not(.cp-add-img .img)').length == 5 || $('#cpzt-img .img:not(.cp-add-img .img)').length == 9) {
                    $('#cpzt-img').css('padding-bottom', '4rem')
                }
            },
            onEnd: function (e) {
                preventEvent(e);
                $('#cpzt-img').css('padding-bottom', '0')
                $('.cp-add-img').remove()
                if ($('#cpzt-img .img:not(.cp-add-img .img)').length < 9) {
                    var html = [];
                    html.push('<div class="show-img cp-add-img">');
                    html.push('    <img src="../img/null.png" class="img" alt="">');
                    html.push('</div>');
                    $('#cpzt-img').append(html.join(''));
                }
            },
            delay: 500,
        });
        sortable.sortable2 = new Sortable($('#sktp-img')[0], {
            animation: 150,
            onStart: function (e) {
                preventEvent(e);
            },
            onMove: function (e) {
                preventEvent(e);
                $('.sktp-add-img').hide()
                if ($('#sktp-img .img:not(.sktp-add-img .img)').length == 5 || $('#sktp-img .img:not(.sktp-add-img .img)').length == 9) {
                    $('#sktp-img').css('padding-bottom', '4rem')
                }
            },
            onEnd: function (e) {
                preventEvent(e);
                $('#sktp-img').css('padding-bottom', '0')
                $('.sktp-add-img').remove()
                if ($('#sktp-img .img:not(.sktp-add-img .img)').length < 9) {
                    var html = [];
                    html.push('<div class="show-img sktp-add-img">');
                    html.push('     <img src="../img/null.png" class="img" alt="">');
                    html.push('</div>');
                    $('#sktp-img').append(html.join(''));
                }
            },
            delay: 500,
        });
        sortable.sortable3 = new Sortable($('#bbxq-img')[0], {
            animation: 150,
            onStart: function (e) {
                preventEvent(e);
            },
            onMove: function (e) {
                preventEvent(e);
                $('.bbxq-add-img').hide()
                if ($('#bbxq-img .img:not(.bbxq-add-img .img)').length == 5 || $('#bbxq-img .img:not(.bbxq-add-img .img)').length == 9) {
                    $('#bbxq-img').css('padding-bottom', '4rem')
                }
            },
            onEnd: function (e) {
                preventEvent(e);
                $('#bbxq-img').css('padding-bottom', '0')
                $('.bbxq-add-img').remove()
                if ($('#bbxq-img .img:not(.bbxq-add-img .img)').length < 30) {
                    var html = [];
                    html.push('<div class="show-img bbxq-add-img">');
                    html.push('    <img src="../img/null.png" class="img" alt="">');
                    html.push('</div>');
                    $('#bbxq-img').append(html.join(''));
                }
            },
            delay: 500,
        });
    }
}

// 去除单双引号和空数组的值
function imgFormat(save_data, name) {
    var tempArr = [];
    $(save_data[name]).each(function (idx, item) {
        if ($.nui.isTrue(item)) {
            tempArr.push(item);
        }
    })
    return tempArr;
}

// 拿到保存数据
function getSaveData() {
    var info = CP_INFO['info'];
    var dw_id = $('#cp_dw').attr('dw_id');
    var cp_lx = $('#cp_lx').attr('cp_lx');

    var cp_lb_id = $('#cp_lb').attr('lb_id');

    if (info['unit_options'] && (typeof info['unit_options'] === 'string')) {
        info['unit_options'] = JSON.parse(info['unit_options']);
    }

    var jgValue = typeof info['jg_value'] === 'object' ? JSON.stringify(info['jg_value']) : info['jg_value'];
    var colorCardPrice = info['color_card_price'] || 0; //色卡价格

    var add_unit_options = {
        cgdw_id: Number(SYS_CONFIG['bpfzdw_cg'] || 0),
        jgdw_id: Number(SYS_CONFIG['bpfzdw_jg']),
        xsdw_id: Number(SYS_CONFIG['bpfzdw_xs']) || 0,
        dw2_id: Number(SYS_CONFIG['bpfzdw_dw2'])
    };

    var save_data = {
        save_type: 'save',
        id: page_data['id'] || 0,
        date: $('#cp_sj').text().trim() || '', // 时间
        number: $('#cp_bh').val().trim() || '', // 编号
        name: $('#cp_mc').val().trim() || '', // 名称
        unit_id: $.nui.isTrue(dw_id) ? fun.toNumber(dw_id) : 0, // 单位id
        component: $('#cp_cf').val().trim() || '', // 成分
        type: $.nui.isTrue(cp_lx) ? cp_lx : 'cp', // 类型
        diff: info['diff'] || '+', // 空差模式
        imgs: [], // 主图
        color_card: [], // 色卡
        bbxq: [], // 宝贝详情图
        unit_options: info['unit_options'] || add_unit_options,
        class_id: $.nui.isTrue(cp_lb_id) ? fun.toNumber(cp_lb_id) : 0,
        remark: $('#cp_bz').val().trim() || '', // 备注
        label_id: '', // 标签id
        label: "",
        is_stop: $('#switch_stop').hasClass('nui-active') ? 1 : 0, // 是否停用
        is_sj: $('#switch_stop').hasClass('nui-active') ? 1 : 0, // 是否上架
        craft: fun.toNumber($('#cp_gy').attr('gy_id')) || 0, // 工艺
        gauze: $('#cp_sz').val().trim() || '', // 纱布
        density: $('#cp_md').val().trim() || '', // 门店
        quarter: fun.toNumber($('#cp_jd').attr('jd_id')) || 0, // 季度

        jg_type: info['jg_type'], // 价格类型
        jg_value: jgValue, // 价格数据
        color_card_price: colorCardPrice, //色卡价格

        // hot_sale: $('#new_label').data('hotSale'), // 热销
        // recommend: $('#new_label').data('recommend'), // 推荐

        goods_colour: CP_INFO['goods_colour'], // 产品颜色
        delete_colour: delete_list['colour_arr'] || [], // 删除的产品颜色
        delete_material: [],
        goods_width_weight: CP_INFO['goods_weight'], // 幅宽克重
        delete_width_weight: delete_list['width_weight_arr'] || [], // 删除的幅宽克重
        goods_spec: CP_INFO['goods_spec'], // 规格
        delete_spec: delete_list['spec_arr'] || [], // 删除的规格

        merchant_assistant: [], // 底卡信息
        delete_merchant_assistant: delete_list['fzxx_arr'] || [], // 删除的底卡信息  delete_list['fzxx_colouArr'] ||
        delete_colour_assistant: delete_list['fzxx_colouArr'] || [], //删除的底卡辅助颜色信息

        goods_machining: CP_INFO['goods_machining'] || [], // 加工
        delete_machining: [], // 删除的加工
        delete_converter: [], //
        delete_process: [],

        goods_craft: CP_INFO['goods_craft'] || [], // 工艺
        delete_craft: delete_list['craft_arr'], // 删除工艺 

        goods_param: CP_INFO['param'], // 其他参数

        // 纱线相关
        goods_xzgy: CP_INFO['goods_xzgy'] || [],
        delete_yarn_material: CP_INFO['delete_yarn_material'] || [],
        delete_xzgy: CP_INFO['delete_xzgy'] || []
    };

    // 产品类型兼容
    save_data['type'] = fun.compatGoodsType(save_data['type']);

    if ($.isArray(label_arr)) {
        save_data['label_id'] = label_arr.join(',');
    } else {
        save_data['label_id'] = label_arr;
    }

    //标签
    if ($('#selling_status_desc').text() === '热销') {
        save_data['label'] = 'rx';
    } else if ($('#selling_status_desc').text() === '推荐') {
        save_data['label'] = 'tj';
    } else {
        save_data['label'] = '';
    }

    $(CP_INFO['merchant_assistant']).each(function (idx, item) {
        if (!('id' in item)) {
            item['id'] = 0;
        }
    })

    // 产品图片
    if ($('#cpzt-img').find('.show-img').not('.cp-add-img').length > 0) {
        $('#cpzt-img').find('.show-img').not('.cp-add-img').each(function (idx, item) {
            if ($(this).find('img').data('name')) {
                save_data['imgs'].push($(this).find('img').data('name'));
            }
        })
    }

    // 色卡图片
    if ($('#sktp-img').find('.show-img').not('.sktp-add-img').length > 0) {
        $('#sktp-img').find('.show-img').not('.sktp-add-img').each(function (idx, item) {
            if ($(this).find('img').data('name')) {
                save_data['color_card'].push($(this).find('img').data('name'));
            }
        })
    }

    // 宝贝图片
    if ($('#bbxq-img').find('.show-img').not('.bbxq-add-img').length > 0) {
        $('#bbxq-img').find('.show-img').not('.bbxq-add-img').each(function (idx, item) {
            if ($(this).find('img').data('name')) {
                save_data['bbxq'].push($(this).find('img').data('name'));
            }
        })
    }

    $(CP_INFO['merchant_assistant']).each(function (idx, item) {
        if ($.nui.isEmpty(item['imgs'])) {
            item['imgs'] = [];
        } else {
            if (!($.isArray(item['imgs']))) {
                var imgs = item['imgs'];
                if (imgs.indexOf(',') > -1) {
                    item['imgs'] = imgs.split(',');
                } else {
                    var imgs_arr = []
                    imgs_arr[0] = item['imgs'];
                    item['imgs'] = imgs_arr;
                }
            }
        }
    })

    save_data['goods_width_weight'] = CP_INFO['goods_weight'];

    // 处理图片产生的空格
    save_data['imgs'] = imgFormat(save_data, 'imgs');
    save_data['bbxq'] = imgFormat(save_data, 'bbxq');
    save_data['color_card'] = imgFormat(save_data, 'color_card');

    $(CP_INFO['merchant_assistant']).each(function (index, item) {
        var temp = [];
        item['sort'] = index + 1;
        $(item['imgs']).each(function (idx, imgs) {
            if ($.nui.isTrue(imgs)) {
                temp.push(imgs);
            }
        })
        item['imgs'] = temp;
    })
    save_data['merchant_assistant'] = CP_INFO['merchant_assistant'];
    return save_data;
}

//验证类别是否存在
function LbCheck() {
    var is_lb;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        async: false,
        url: AJAX_URL.getSimpleRecordList,
        data: {
            type: 'cp'
        },
        success: function (res) {

            if (res.status != 0) return fun.toast('保存失败。');
            var lb_info = res.data;
            var lb_name = $('#cp_lb').attr('lb_id') + '_' + $('#cp_lb').val().trim();
            for (var i = 0; i < lb_info.length; i++) {
                var lb_tmpName = lb_info[i].id + '_' + lb_info[i].name;
                if (lb_tmpName == lb_name) {

                    is_lb = true;
                    return;
                }
                is_lb = false;
            }
        }
    });
    return is_lb;
}

// 保存数据
function saveData(options) {
    var _options = $.extend({}, {
        callback: null,
        tips: true
    }, options);
    if (!$('#cp_sj').text().trim()) {
        return fun.toast('日期不能为空。');
    } else if (!$('#cp_bh').val().trim()) {
        return fun.toast('产品编号不能为空。');
    } else if (!$.nui.isTrue($('#cp_dw').attr('dw_id'))) {
        return fun.toast('单位不能为空。');
    }

    deleteColorIdx(); // 删除因其他页面用到创建的_indx
    if ($.nui.isTrue($('#cp_lb').val().trim()) && LbCheck() === false) {
        return fun.toast('类别不存在，无法保存。');
    }
    var tmp_data = getSaveData(); // 拿到保存数据
    //保存数据
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveGoods,
        data: tmp_data,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    function closePageRefresh() { // 关闭页面
                        fun.pageCloseFun({
                            refresh: true,
                            extraData: {
                                status: 'refresh',
                                tc_type: page_data['tc_type'] ? true : false,
                                number: tmp_data['number'] || '',
                                id: res['data']['id'],
                            }
                        });
                    }
                    if (options && typeof _options.callback == "function") {
                        _options['tips'] && fun.toast('保存成功！');
                        soldOut(); // 下架方法
                        page_data['id'] = res['data']['id'];
                        search_data['id'] = page_data['id'];
                        options.callback(options['params']);
                    } else {
                        page_data['id'] = res['data']['id'];
                        search_data['id'] = page_data['id'];
                        fun.toast('保存成功！');
                        soldOut(); // 下架方法
                        // if ($.nui.isObjEquals(oriCpBjInfo, cpbjInfo)) {
                        // } else {
                        //     showOffer(closePageRefresh); // 产品报价保存数据
                        // }
                    }
                    setTimeout(function () {
                        closePageRefresh();
                    }, 200)
                    break;
                case 104:
                    var msg = '';
                    switch (res['data']['type']) {
                        case 'number':
                            msg = '该编号';
                            break;
                        case 'name':
                            msg = '名称';
                            break;
                        case 'colour':
                            msg = res['data']['name'] || '';
                            break;
                        case 'machining':
                            msg = '加工流程-加工商记录表出现相同加工商。';
                            break;
                        case 'assistant':
                            msg = '辅助对象不能出现2个一样的：客\\供\\加。';
                            break;
                    }
                    return fun.toast((res['data']['type'] != 'assistant' && res['data']['type'] != 'machining') ? (msg + '已存在。') : msg);
                    break;
                case 101:
                    fun.toast('保存失败。');
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        },
        error: function (err) {
        }
    });
}

// 下架方法
function soldOut() {
    if (page_data && 'id' in page_data && $('#switch_stop').hasClass('nui-active')) { // 编辑页面进来并且有开启停用
        // var cp_lx = $('#cp_lx').attr('cp_lx') ? [$('#cp_lx').attr('cp_lx')] : [];

        // 产品类型兼容
        var tmp_cp_lx = $('#cp_lx').attr('cp_lx');
        tmp_cp_lx = tmp_cp_lx ? [fun.compatGoodsType(tmp_cp_lx)] : [];

        var cp_lx = tmp_cp_lx;

        fun.ajax({
            showLoad: false,
            hideLoad: false,
            url: AJAX_URL.saveGoods,
            data: {
                id: [page_data['id']],
                save_type: 'state',
                type: 'sj',
                is_sj: 0,
                cp_lx: cp_lx,
            },
            success: function (res) {
                if (res['status'] === 0) {
                    CP_INFO['info']['is_sj'] = 0;
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            status: 'refresh'
                        }
                    })
                }
            }
        });
    }
}

// 阻止默认事件
function preventEvent(e) {
    e.stopPropagation();
    e.preventDefault();
}

// 添加图片
function addImgToImgs(data, Introduction) {
    if (Introduction) { // 多选图片
        if (api.systemType == "ios") {
            showMoreData(data); // 多选图片数据渲染
        } else {
            addImgs(data, function (param) {
                showMoreData(param); // 多选图片数据渲染
            })
        }
    } else {
        showSingleData(data);
    }
}

// 多选图片渲染
function showMoreData(data) {
    var htmlCpImg = [];
    countent = data.length;
    item = JSON.parse(JSON.stringify(data[0]));
    fristObj = {
        data: data,
        index: 0
    }
    fun.fileUpload(fristObj, function (imgName) {
        console.log('1111111111111');
        console.log(item.path);
        console.log('2222222222222');
        htmlCpImg.push('<li class="show-img">');
        htmlCpImg.push('    <img src="' + item.path + '" class="img" alt="" large-url="' + item.path + '"  data-name="' + imgName + '">')
        htmlCpImg.push('    <div class="delete-img" style="display: block;">');
        htmlCpImg.push('        <div class="packs">');
        htmlCpImg.push('            <i class="iconfont icon-fork fork"></i>');
        htmlCpImg.push('        </div>');
        htmlCpImg.push('    </div>');
        htmlCpImg.push('</li>');
    }, countCallback);

    function countCallback() {
        if (custom < countent) {
            custom++;
            var __custom = custom - 1;
            var tmpObj = {
                data: JSON.parse(JSON.stringify(data)),
                index: __custom
            }
            item = JSON.parse(JSON.stringify(tmpObj['data'][__custom]));
            fun.fileUpload(tmpObj, function (imgName) {
                htmlCpImg.push('<li class="show-img">');
                htmlCpImg.push('    <img src="' + item.path + '" class="img" alt="" large-url="' + item.path + '"  data-name="' + imgName + '">')
                htmlCpImg.push('    <div class="delete-img" style="display: block;">');
                htmlCpImg.push('        <div class="packs">');
                htmlCpImg.push('            <i class="iconfont icon-fork fork"></i>');
                htmlCpImg.push('        </div>');
                htmlCpImg.push('    </div>');
                htmlCpImg.push('</li>');
            }, countCallback);
        } else {
            if ($.nui.isTrue($('#cpzt-img .img').parents('div').hasClass('cpImg'))) { // 产品主图
                var cpCount = fun.toNumber($('#cpzt_size').text());
                $('.cp-add-img').before(htmlCpImg.join(''));
                cpCount += data.length;
                imgSub['cpMax'] = 9 - cpCount;

                $('#cpzt_size').text(cpCount);

                if (cpCount >= 9) {
                    $('.cp-add-img').remove();
                    $('.cpImg').removeClass('cpImg');
                }
            } else if ($.nui.isTrue($('#sktp-img .img').parents('div').hasClass('sktpImg'))) { // 色卡图片
                var cpCount = fun.toNumber($('#sktp_size').text());
                $('.sktp-add-img').before(htmlCpImg.join(''));
                cpCount += data.length;
                imgSub['skMax'] = 9 - cpCount;

                $('#sktp_size').text(cpCount);

                if (cpCount >= 9) {
                    $('.sktp-add-img').remove();
                    $('.sktpImg').removeClass('sktpImg');
                }
            } else if ($.nui.isTrue($('#bbxq-img .img').parents('div').hasClass('bbxqImg'))) { // 产品图片
                var cpCount = fun.toNumber($('#bbxq_size').text());
                $('.bbxq-add-img').before(htmlCpImg.join(''));
                cpCount += data.length;
                imgSub['bbxqMax'] = 30 - cpCount;

                $('#bbxq_size').text(cpCount);

                if (cpCount >= 30) {
                    $('.bbxq-add-img').remove();
                    $('.bbxqImg').removeClass('bbxqImg');
                }
            }

            imgInfo = [];
            removePhotoClass();
            fun.hideLoad();
            countent = 0;
            custom = 1;
            item = {};
            document.body.removeEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
        }
    }
}

// 单选图片渲染
function showSingleData(params) {
    // fun.upload(base64, function (img_name, img) {
    var ret_params = {
        data: params
    }
    if (api.systemType == "ios") {
        showImgs(ret_params, params);
    } else {
        // fun.getUrlBase64(ret_params['data']['data'], 'webp', function (base64) {
        fun.getUrlBase64(ret_params['data']['data'], 'jpeg', function (base64) {
            ret_params['data']['base64Data'] = base64
            showImgs(ret_params, params);
        });
    }
}

function showImgs(ret_params, params) {
    fun.fileUpload(ret_params, function (img) {
        var htmlCpImg = [];
        htmlCpImg.push('<li class="show-img">');
        htmlCpImg.push('    <img src="' + params.data + '" class="img" alt="" large-url="' + params.data + '"  data-name="' + img + '">')
        htmlCpImg.push('    <div class="delete-img" style="display: block;">');
        htmlCpImg.push('        <div class="packs">');
        htmlCpImg.push('            <i class="iconfont icon-fork fork"></i>');
        htmlCpImg.push('        </div>');
        htmlCpImg.push('    </div>');
        htmlCpImg.push('</li>');

        // 拍照渲染
        if ($('#cpzt-img .img').parents('div').hasClass('cpImg')) { // 产品主图
            var cpCount = fun.toNumber($('#cpzt_size').text());
            ++cpCount;
            $('.cp-add-img').before(htmlCpImg.join(''));
            if (cpCount >= 9) {
                cpCount = 9;
                $('.cp-add-img').remove();
            }
            $('.cpImg').removeClass('cpImg');
            $('#cpzt_size').text(cpCount);
            imgSub['cpMax'] = 9 - cpCount;
        }
        if ($('#sktp-img .img').parents('div').hasClass('sktpImg')) { // 色卡主图
            var skCount = fun.toNumber($('#sktp_size').text());
            ++skCount;
            $('.sktp-add-img').before(htmlCpImg.join(''));
            if (skCount >= 9) {
                skCount = 9;
                $('.sktp-add-img').remove();
            }
            $('.sktpImg').removeClass('sktpImg');
            $('#sktp_size').text(skCount);
            imgSub['skMax'] = 9 - skCount;
        }
        if ($('#bbxq-img .img').parents('div').hasClass('bbxqImg')) { // 宝贝详情主图
            var bbxqCount = fun.toNumber($('#bbxq_size').text());
            ++bbxqCount;
            $('.bbxq-add-img').before(htmlCpImg.join(''));
            if (bbxqCount >= 30) {
                bbxqCount = 30;
                $('.bbxq-add-img').remove();
            }
            $('.bbxqImg').removeClass('bbxqImg');
            $('#bbxq_size').text(bbxqCount);
            imgSub['bbxqMax'] = 30 - bbxqCount;
        }

        $('#openCamera').hide();
        fun.hideLoad();
    })
}

// 递归取base64，执行渲染方法
function addImgs(param, callback) {
    if (count >= param.length) {
        count = 0;
        if (typeof callback === 'function') callback(param)
        return param;
    }
    count++;
    fun.getUrlBase64(param[count - 1]['path'], param[count - 1]['suffix'], function (base64) {
        // fun.getUrlBase64(param[count - 1]['path'], 'webp', function (base64) {
        param[count - 1]['base64'] = base64;
        addImgs(param, callback);
    });
}

// 转化iso路径
function IOSChange(list, callback) {
    var temporary = list;
    $.each(list, function (i, item) {
        UIAlbumBrowser.transPath({
            path: item['path'],
            quality: 100
        }, function (res, err) {
            if (res) {
                temporary[i]['path'] = res['path'];
                if (i >= list.length - 1) {
                    if (typeof callback === 'function') callback(temporary);
                }
            }
        });
    })
};

// 清除选择相册判断类名
function removePhotoClass() {
    $('#cpzt-img .img').parents('div').removeClass('cpImg');
    $('#sktp-img .img').parents('div').removeClass('sktpImg');
    $('#bbxq-img .img').parents('div').removeClass('bbxqImg');
}

// 幅宽克重、单位处理
function restrictFkKz() {
    var width = $('#fk_ipt').val().trim(); // 幅宽
    var weight = $('#kz_ipt').val().trim(); // 克重
    var fkUnit = $('.fk-unit').text().trim(); // 幅宽单位
    var kzUnit = $('.kz-unit').text().trim(); // 克重单位
    if ($.nui.isTrue(width) || $.nui.isTrue(weight)) {
        switch (CP_INFO['goods_weight'].length) {
            case 0:
                CP_INFO['goods_weight'][0] = {
                    create_time: '',
                    update_time: '',
                    fk_dw: fkUnit,
                    is_delete: '',
                    is_default: 1,
                    is_stop: 0,
                    kz_dw: kzUnit,
                    remark: '',
                    sort: 1,
                    weight: weight,
                    width: width,
                    id: 0
                };
                default_obj['default_fkkz'] = CP_INFO['goods_weight'][0];
                break;
            case 1:
                if (CP_INFO['goods_weight'][0]['is_default']) { // 已经有一条，更改的话，更改默认的，产品编辑外面显示的数据就是幅宽克重默认的
                    CP_INFO['goods_weight'][0]['width'] = width;
                    CP_INFO['goods_weight'][0]['weight'] = weight;
                    CP_INFO['goods_weight'][0]['fk_dw'] = fkUnit;
                    CP_INFO['goods_weight'][0]['kz_dw'] = kzUnit;
                    default_obj['default_fkkz'] = CP_INFO['goods_weight'][0];
                }
                break;
        }

        if (CP_INFO['goods_weight'].length > 1) { // 多条
            var flag = CP_INFO['goods_weight'].every(function (item, idx) { // 判断都是没开启默认
                return !item['is_default'];
            })

            // 如果输入的值（幅宽，幅宽单位，克重，克重单位都在里面找到值相同的，那么就把这条找到的，设置开启默认）
            if (flag) { // 全部数据都没开启默认
                /* 
                    1. 输入的四个值在没有默认的数据有匹配到
                    2. 输入的四个值在没有默认的数据没有匹配到
                */
                default_obj['default_fkkz'] = {};
                var mark = false; // 默认没匹配到
                $(CP_INFO['goods_weight']).each(function (idx, item) {
                    if ((width === item['width']) && (weight === item['weight']) && (fkUnit === item['fk_dw']) && (kzUnit === item['kz_dw'])) {
                        mark = true;
                        item['is_default'] = 1;
                        default_obj['default_fkkz'] = item;
                        return false;
                    }
                })
                if (!mark) {
                    var tempObj = {
                        create_time: '',
                        update_time: '',
                        fk_dw: fkUnit,
                        is_delete: '',
                        is_default: 1,
                        is_stop: 0,
                        kz_dw: kzUnit,
                        remark: '',
                        sort: 1,
                        weight: weight,
                        width: width,
                        id: 0
                    };
                    default_obj['default_fkkz'] = tempObj;
                    CP_INFO['goods_weight'].push(tempObj);
                }
            } else { // 有一条开启默认，更新这条默认输入的值
                $(CP_INFO['goods_weight']).each(function (idx, item) {
                    if ($.nui.isTrue(item['is_default'])) {
                        item['width'] = width;
                        item['weight'] = weight;
                        item['fk_dw'] = fkUnit;
                        item['kz_dw'] = kzUnit;
                        default_obj['default_fkkz'] = item;
                        return true;
                    }
                })
            }
        }
    } else if ($.nui.isEmpty(width) && $.nui.isEmpty(weight)) { // 幅宽克重都没值
        if (CP_INFO['goods_weight'].length === 1) {
            // 删除这一条
            if (page_data && 'id' in page_data && $.nui.isTrue(CP_INFO['goods_weight'][0]['id'])) {
                delete_list['width_weight_arr'].push(CP_INFO['goods_weight'][0]['id']);
            }

            CP_INFO['goods_weight'].splice(0, 1);
            default_obj['default_fkkz'] = {};
        }

        if (CP_INFO['goods_weight'].length > 1) { // 多条
            $(CP_INFO['goods_weight']).each(function (idx, item) {
                if (item['is_default']) {
                    if (page_data && 'id' in page_data && $.nui.isTrue(item['id'])) {
                        delete_list['width_weight_arr'].push(item['id']);
                    }
                    CP_INFO['goods_weight'].splice(idx, 1);
                    default_obj['default_fkkz'] = {};
                    return true;
                }
            })
        }
    }
}

// 处理旧数据保存报价
// function initJgVal() {
//     if ($.nui.isEmpty(CP_INFO['info']['jg_type']) || $.nui.isEmpty(CP_INFO['info']['jg_value'])) {
//         CP_INFO['info']['jg_type'] = 'ys';
//         CP_INFO['info']['jg_value'] = [];
//     }
// }

// 初始化事件
function bindEvent() {
    //解决穿透
    $('.box,.add-picture').on('touchmove', function (event) {
        event.preventDefault();
    });

    // 幅宽弹窗列表、 克重弹窗列表
    $('#fk_select,#kz_select').on('click', function (e) {
        var list = null;
        var $ele = null;
        e.stopPropagation();
        e.preventDefault();
        var val = $(this).siblings('.unit-select').text().trim();

        if ($(this).is('#fk_select')) {
            list = getFkKzList('fk');
            $ele = $('.fk-unit');
        } else if ($(this).is('#kz_select')) {
            list = getFkKzList('kz');
            $ele = $('.kz-unit');
        }

        $(list).each(function (idx, item) { // 初始化默认选中值
            if (item['name'] == val) {
                item['is_choose'] = 1;
            } else {
                item['is_choose'] = 0;
            }
        });

        fun.showBookList({
            shadeClose: true,
            list: list,
            open_init: function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false });
            },
            choose: function (res) {
                var unitName = res['name'];
                $ele.text(unitName);
                // restrictFkKz();
            },
            end: function () {
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            }
        });
    });

    // 跳转幅宽克重界面
    $('#fkkz, #skip_fk_kz').on('tap', function (e) {
        fun.showLoad();
        e.stopPropagation();
        e.preventDefault();
        var width = $('#fk_ipt').val().trim(); // 幅宽
        var weight = $('#kz_ipt').val().trim(); // 克重
        var fk_dw = $('.fk-unit').text().trim(); // 幅宽单位
        var kz_dw = $('.kz-unit').text().trim(); // 克重单位

        restrictFkKz();
        setTimeout(function () {
            fun.showPageFull({
                page_url: page_arr['shop_product_fkkz_bj'],
                pageParam: {
                    id: page_data['id'] || '',
                    return_page: page_arr.shop_product_compile,
                    list: CP_INFO['goods_weight'],
                    page_type: 'shop_product_fkkz_bj',
                    delete_arr: delete_list['width_weight_arr'],
                    default_obj: default_obj['default_fkkz']
                }
            })
        }, 200);
        fun.hideLoad();
    });

    // 克重、幅宽触摸不触发跳转
    $('.disabled-skip, .fk-unit, .kz-unit').on('tap', function (e) {
        preventEvent(e);
    });

    // 幅宽输入、克重输入
    $('#fk_ipt, #kz_ipt').on('blur', function () {
        // restrictFkKz();
    });

    // 没有编辑权限禁止停用按钮切换
    $('.disabled-switch').on('tap', function (e) {
        if (!IS_PAGE_EDIT) {
            e.stopPropagation();
            e.preventDefault();
            return;
        }
    })

    // 选择标签
    $('body').on('click', '#label', function (e) {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        if ($(this).attr('disabled')) return;
        var params = {
            "return_page": page_arr.shop_product_compile,
            "page_type": 'cp',
            "opt": (!!page_data['id']) ? 'edit' : 'append',
            "label_arr": label_arr || '',
            "title": '产品',
            "id": page_data['id'] || 0,
            "type": 'cp'
        };
        fun.showPageFull({
            page_url: page_arr.label,
            pageParam: params
        });
        fun.hideLoad();
    });

    $('body').on('tap', '#hide-info', function () {
        if (!IS_PAGE_EDIT) return;
    });

    // 产品主图
    $('body').on('click', '#cpzt-img .img', function () {
        if (!IS_PAGE_EDIT) return;
        var press_start = new Date();
        var cpzt_index2 = $("#cpzt-img .img").index(this);
        if (new Date() - press_start < 700) {
            if ($("#cpzt-img .img").eq(cpzt_index2).attr("src") !== '../img/null.png') { // 有图，显示大图预览
                var src = $("#cpzt-img .img").eq(cpzt_index2).data('name');
                photoBrowser.open({
                    images: [fun.getImgPath(src, true)],
                    placeholderImg: '../img/logo.png',
                    bgColor: '#000'
                }, function (ret, err) {
                    if (ret) {
                        if (ret['eventType'] == 'click') {
                            photoBrowser.close();
                        }
                    }
                });
            } else {
                $(this).parents('div').addClass('cp-sel-photo cpImg'); // 选择相册、产品主图拍照添加图片
                $("#add-picture,.box").css("display", "block");
            }
        }
    });

    // 色卡
    $('body').on('click', '#sktp-img .img', function () {
        if (!IS_PAGE_EDIT) return;
        var press_start = new Date();
        var sktp_index2 = $("#sktp-img .img").index(this);
        if (new Date() - press_start < 700) {
            if ($("#sktp-img .img").eq(sktp_index2).attr("src") !== '../img/null.png') { // 有图显示大图预览
                var src = $('#sktp-img .img').eq(sktp_index2).data('name');
                photoBrowser.open({
                    images: [fun.getImgPath(src, true)],
                    placeholderImg: '../img/logo.png',
                    bgColor: '#000'
                }, function (ret, err) {
                    if (ret) {
                        if (ret['eventType'] == 'click') {
                            photoBrowser.close();
                        }
                    }
                });

            } else {
                $(this).parents('div').addClass('sk-sel-photo sktpImg'); // 色卡拍照添加图片
                $("#add-picture,.box").css("display", "block");
            }
        }
    });

    // 宝贝详情主图
    $('body').on('click', '#bbxq-img .img', function () {
        if (!IS_PAGE_EDIT) return;
        var press_start = new Date();
        var bbxq_index2 = $("#bbxq-img .img").index(this);
        if (new Date() - press_start < 700) {
            if ($("#bbxq-img .img").eq(bbxq_index2).attr("src") !== '../img/null.png') {
                var src = $('#bbxq-img .img').eq(bbxq_index2).data('name');
                photoBrowser.open({
                    images: [fun.getImgPath(src, true)],
                    placeholderImg: '../img/logo.png',
                    bgColor: '#000'
                }, function (ret, err) {
                    if (ret) {
                        if (ret['eventType'] == 'click') {
                            photoBrowser.close();
                        }
                    }
                });

            } else {
                $(this).parents('div').addClass('bbxq-sel-photo bbxqImg'); // 宝贝拍照添加图片
                $("#add-picture,.box").css("display", "block");
            }
        }
    });

    // 删除主图
    $('body').on('tap', '#cpzt-img .delete-img', function () {
        var _that = $(this);
        setTimeout(function () {
            fun.dialog({
                content: '你确定要删除主图吗？',
                btn: ['删除', '取消'],
                yes: function () {
                    _that.parent().remove();
                    if ($('#cpzt-img .img:not(.cp-add-img .img)').length === 8) {
                        // $('.cp-add-img').hide()
                        var html = [];
                        html.push('<div class="show-img cp-add-img">');
                        html.push('    <img src="../img/null.png" class="img" alt="">');
                        html.push('</div>');
                        $('#cpzt-img').append(html.join(''));
                    }
                    var len = $('#cpzt-img .img:not(.cp-add-img .img)').length;
                    $('#cpzt_size').text(len);
                    imgSub['cpMax'] = 9 - len;
                }
            });
        }, 100)
    });

    // 删除色卡
    $('body').on('tap', '#sktp-img .delete-img', function () {
        var _that = $(this);
        setTimeout(function () {
            fun.dialog({
                content: '你确定要删除色卡图片吗？',
                btn: ['删除', '取消'],
                yes: function () {
                    _that.parent().remove();
                    if ($('#sktp-img .img:not(.sktp-add-img .img)').length === 8) {
                        var html = [];
                        html.push('<div class="show-img sktp-add-img">');
                        html.push('     <img src="../img/null.png" class="img" alt="">');
                        html.push('</div>');
                        $('#sktp-img').append(html.join(''));
                    }
                    var len = $('#sktp-img .img:not(.sktp-add-img .img)').length;
                    $('#sktp_size').text(len);
                    imgSub['skMax'] = 9 - len;
                }
            });
        }, 100)
    });

    // 删除宝贝详情
    $('body').on('tap', '#bbxq-img .delete-img', function () {
        var _that = $(this);
        setTimeout(function () {
            fun.dialog({
                content: '你确定要删除宝贝详情图片吗？',
                btn: ['删除', '取消'],
                yes: function () {
                    _that.parent().remove();
                    if ($('#bbxq-img .img:not(.bbxq-add-img .img)').length === 29) {
                        var html = [];
                        html.push('<div class="show-img bbxq-add-img">');
                        html.push('    <img src="../img/null.png" class="img" alt="">');
                        html.push('</div>');
                        $('#bbxq-img').append(html.join(''));
                    }
                    var len = $('#bbxq-img .img:not(.bbxq-add-img .img)').length;
                    $('#bbxq_size').text(len);
                    imgSub['bbxqMax'] = 30 - len;
                }
            });
        }, 100)
    });

    // 拍照
    $('body').on('click', '#paizhao', function (e) {
        e.stopPropagation();
        e.preventDefault();
        if (!IS_PAGE_EDIT) return;
        $('#add-picture,.box').hide();
        QuestPermission.requestPermission('camera', null, function () {
            api.getPicture({
                sourceType: 'camera',
                encodingType: 'jpg',
                mediaValue: 'pic',
                destinationType: 'base64',
                allowEdit: true,
                quality: 90,
                targetWidth: 900,
                targetHeight: 900,
                saveToPhotoAlbum: false
            }, function (ret, err) {
                if (ret) {
                    if (ret.data) {
                        fun.showLoad();
                        addImgToImgs(ret);
                    }

                } else { }
            });
        });

    });

    // 从相册中选择
    $('body').on('click', '#selectPhoto', function (e) {
        e.stopPropagation();
        e.preventDefault();
        if (!IS_PAGE_EDIT) return;
        $('#add-picture,.box').hide();
        var max = 6;
        if ($.nui.isTrue($('#cpzt-img .img').parents('div').hasClass('cpImg'))) {
            if (imgSub['cpMax'] === 0) {
                imgSub['cpMax'] = 6;
            }
            max = imgSub['cpMax'] >= max ? max : imgSub['cpMax'];
        } else if ($.nui.isTrue($('#sktp-img .img').parents('div').hasClass('sktpImg'))) { // 色卡图片
            if (imgSub['skMax'] === 0) {
                imgSub['skMax'] = 6;
            }
            max = imgSub['skMax'] >= max ? max : imgSub['skMax'];
        } else if ($.nui.isTrue($('#bbxq-img .img').parents('div').hasClass('bbxqImg'))) { // 产品图片
            if (imgSub['bbxqMax'] === 0) {
                imgSub['bbxqMax'] = 6;
            }
            max = imgSub['bbxqMax'] >= max ? max : imgSub['bbxqMax'];
        }
        // 20200927 点击很多次确定会返回上一个页面，这里要限制只执行一次
        var UIAlbumBrowserTimer = null;
        var UIAlbumBrowserTimerFlag = true;
        QuestPermission.requestPermission(['photos'], null, function () {
            UIAlbumBrowser.imagePicker({
                max: max,//最多选择图片的数量，默认为9
                showCamera: false,//禁止访问相机
                styles: {
                    bg: '#fff',
                    nav: {
                        cancelColor: '#000',//取消按钮颜色
                        nextStepColor: '#000',//确定按钮颜色
                        cancelText: '取消',
                        finishText: '确定'
                    },
                },
                // isOpenPreview: true
            }, function (ret) {

                if(UIAlbumBrowserTimerFlag) {
                    UIAlbumBrowserTimerFlag = false;
                    clearTimeout(UIAlbumBrowserTimer);
                    UIAlbumBrowserTimer = null;
                    UIAlbumBrowserTimer = setTimeout(function(){
                        UIAlbumBrowserTimerFlag = true;
                    }, 1000);
        
                    nextConfirm(ret);
                }

                function nextConfirm(ret) {
                    if (ret.eventType == 'nextStep') { // 确定事件
                        var list = ret['list'] || [];
                        if ($.nui.isEmpty(list)) {
                            UIAlbumBrowser.closePicker();
                            fun.hideLoad();
                            return;
                        };
                        fun.UploadRestriction(list, function () {
                            fun.showLoad();
                            var u = navigator.userAgent;
                            if (u.indexOf('Android') > -1 || u.indexOf('Linux') > -1) {//安卓路径无误
                                UIAlbumBrowser.closePicker();
                                addImgToImgs(list, true);
                            } else if (!!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/)) { // ios路径需转化,包括iPad
                                UIAlbumBrowser.closePicker();
                                IOSChange(list, function (temporary) {
                                    addImgToImgs(temporary, true);
                                })
                            }
                            document.body.addEventListener('touchmove', preventDefault, { passive: false }); //passive 参数不能省略，用来兼容ios和android
                        });
                    }
                }
                
                if (ret.eventType === 'cancel') { // 取消事件
                    removePhotoClass();
                }
            })
        });

    });

    // // 取消新增图片选项
    // $('body').on('click', '#cancel_photo', function (e) {
    //     e.stopPropagation();
    //     e.preventDefault();
    //     removePhotoClass();
    //     $('#add-picture,.box').css("display", "none");
    // });

    // 跳转价格页面
    $('body').on('tap', '#price', function (e) {
        e.stopPropagation();

        var jgValue = CP_INFO['info']['jg_value'];
        var xsdw_id = CP_INFO['info']['unit_options']['xsdw_id'];
        if ($.nui.isEmpty(xsdw_id) && $.nui.isEmpty(CP_INFO.info.unit_id)) {
            fun.toast('请选择单位！');
            return;
        }

        fun.showLoad();

        if ('id' in page_data) {
            fun.showPageFull({
                page_url: page_arr['shop_product_jg'],
                pageParam: {
                    unit_id: xsdw_id || 0, // 销售单位id
                    zdw: getJjdw(xsdw_id),
                    zdw_id: getUnitId(),
                    jg_type: CP_INFO['info']['jg_type'],
                    jg_value: jgValue,
                    data: page_data['data'],
                    id: page_data['id'] || '',
                    return_page: page_arr.shop_product_compile,
                    page_type: 'shop_product_jg',
                    goods_colour: CP_INFO['goods_colour'], // 价格页面编辑获取的产品颜色
                    delete_colour: delete_list['colour_arr'], // 被删除的产品颜色
                    cp_mc: $('#cp_mc').val().trim() || '', // 产品名称
                    color_card_price: CP_INFO.info.color_card_price || 0   //色卡价格
                }
            });
        } else {
            fun.showPageFull({
                page_url: page_arr['shop_product_jg'],
                pageParam: {
                    unit_id: xsdw_id || 0,
                    zdw: getJjdw(xsdw_id),
                    zdw_id: getUnitId(),
                    jg_type: CP_INFO['info']['jg_type'],
                    jg_value: jgValue,
                    data: page_data['data'],
                    return_page: page_arr.shop_product_compile,
                    page_type: 'shop_product_jg',
                    goods_colour: CP_INFO['goods_colour'], // 价格页面编辑获取的产品颜色
                    delete_colour: delete_list['colour_arr'], // 被删除的产品颜色
                    cp_mc: $('#cp_mc').val().trim() || '',
                    color_card_price: CP_INFO.info.color_card_price || 0   //色卡价格
                }
            });
        }

        fun.hideLoad();
    });

    // 跳转颜色页面
    $('body').on('tap', '#color-card', function () {
        fun.showLoad();
        // 跳转页面参数(根据跳转链接)
        $(CP_INFO['goods_colour']).each(function (_index, item) {
            item['_index'] = _index;
        })
        if (!IS_PAGE_EDIT) return;
        if ('id' in page_data) {
            fun.showPageFull({
                page_url: page_arr.shop_cp_ys_bj,
                pageParam: {
                    data: CP_INFO['goods_colour'],
                    return_page: page_arr.shop_product_compile,
                    page_type: 'shop_cp_ys_bj',
                    id: page_data['id'],
                    // count_data: CP_INFO
                }
            });
        } else {
            fun.showPageFull({
                page_url: page_arr.shop_cp_ys_bj,
                pageParam: {
                    data: CP_INFO['goods_colour'],
                    return_page: page_arr.shop_product_compile,
                    page_type: 'shop_cp_ys_bj',
                    // count_data: CP_INFO
                }
            });
        }
        fun.hideLoad();
    });

    // 跳转底卡页面
    $('body').on('tap', '#bottom-card', function () {
        if (!IS_PAGE_EDIT) return;
        var xsdwId = CP_INFO['info']['unit_options']['xsdw_id'];
        if ($.nui.isEmpty(xsdwId) && $.nui.isEmpty(CP_INFO.info.unit_id)) {
            fun.toast('请选择单位！');
            return;
        }
        fun.showLoad();
        if ($.nui.isEmpty(CP_INFO['merchant_assistant'])) { // 底卡信息为空
            fun.showPageFull({
                page_url: page_arr.shop_dk_bj,
                pageParam: {
                    return_page: page_arr.shop_product_compile,
                    main_isTure: main_isTure,
                    page_type: 'shop_dk_bj',
                    type: 'add',
                    color: CP_INFO['goods_colour'],
                    dw: getJjdw(xsdwId),
                    jjdw_id: getUnitId()
                }
            })
        } else { // 有低卡信息
            fun.showPageFull({
                page_url: page_arr.shop_dk_xx,
                pageParam: {
                    id: page_data['id'],
                    return_page: page_arr.shop_product_compile,
                    page_type: 'shop_dk_xx',
                    merchant_assistant: CP_INFO['merchant_assistant'],
                    color: CP_INFO['goods_colour'],
                    dw: getJjdw(xsdwId),
                    jjdw_id: getUnitId()
                }
            })
        }
        fun.hideLoad();
    });

    // 产品规格
    $('body').on('tap', '#cp_gg', function () {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr.shop_product_ggbj,
            pageParam: {
                id: page_data['id'] || '',
                return_page: page_arr.shop_product_compile,
                list: CP_INFO['goods_spec'] || [], //列表数据
                delete_arr: delete_list['spec_arr'] || [], // 删除数据
                default_obj: default_obj['default_gg'], // 
                page_type: 'shop_product_ggbj'
            }
        });
        fun.hideLoad();
    });

    // 其他要求
    $('#gy_yq').on('tap', function () {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr.shop_other_require,
            pageParam: {
                return_page: page_arr.shop_product_compile,
                list: CP_INFO['goods_craft'] || [],
                delete: delete_list['craft_arr'] || [],
                id: page_data['id'] || ''
            }
        });
        fun.hideLoad();
    })

    // 其他参数
    $('body').on('tap', '#cp_qtcs', function () {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr.shop_product_qtcs,
            pageParam: {
                return_page: page_arr.shop_product_compile,
                list: CP_INFO['param'] || []
            }
        });
        fun.hideLoad();
    });

    //选择往来单位
    $('.skip_select').on('tap', function () {
        if (!IS_PAGE_EDIT) return;
        fun.showLoad();
        var tmp_url = '';
        if ($(this).data('type') == 'cp_lb') {
            tmp_url = page_arr.select_type;
        } else {
            tmp_url = page_arr.select_list;
        }
        fun.showPageFull({
            page_url: tmp_url,
            pageParam: {
                "return_page": page_arr.shop_product_compile,
                "page_type": ($(this).data('type') || "")
            }
        });
        fun.hideLoad();
    });

    // 保存事件
    $('body').on('tap', '#save_btn', function () {
        if (!IS_PAGE_EDIT) return;
        restrictFkKz(); // 解决安卓没失去焦点直接保存，导致的幅宽克重值没保存进去
        saveData();
    });

    // 显示隐藏更多
    $('body').on('tap', '#click-hide', function () {
        if (!IS_PAGE_EDIT) return;
        // $('.attributes').css('marginBottom', $('bottom-btn-style').height() + 'px');
        $("#hide-info").slideUp(600);
        $("#click-show").show(600);
    });

    // 隐藏属性
    $('body').on('tap', '#click-show', function () {
        if (!IS_PAGE_EDIT) return;
        // $('.attributes').css('marginBottom', '3rem');
        $("#click-show").slideUp(500);

        $("#hide-info").slideDown(1000, function () {
            $(this).css({
                marginBottom: $('.fixed:visible').length && $('.fixed:visible').height()
            })
        });
    });

    // 类型切换
    $('body').on('click', '#cp_lx', function () {
        if (!IS_PAGE_EDIT) return;
        var _this = $(this);
        fun.showBookList({
            width: '280px',
            shadeClose: true,
            list: type_data,
            open_init: function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false });
            },
            choose: function (res) {
                $(type_data).each(function (i, obj) {
                    if (obj['id'] == res['id']) {
                        type_data[i]['is_choose'] = 1;
                    } else {
                        type_data[i]['is_choose'] = 0;
                    }
                })
                $(_this).text(res['name'] || "").attr('cp_lx', (res['db_name'] || ""));
            },
            end: function () {
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            }
        });
    });
}

// 键盘弹起处理函数
function keyBoardShow() {
    // $('.fixed').hide();
    // $('.attributes').css({
    //     marginBottom: 0
    // })
}

// 键盘收起处理函数
function keyBoardHide() {
    // $('.fixed').show();
    // $('.attributes').css({
    //     marginBottom: '3.5rem'
    // })
}

function preventDefault(e) {
    e.preventDefault();
}

$('body').on('click', '#new_label', function (e) {
    e.stopPropagation();
    shopCompile.showLabelPopUp();
})

// 取消更改标签
$('body').on('click', '#cancel_popup', function (e) {
    e.stopPropagation();
    shopCompile.hideLabelPopUp();
})

// 清空标签
$('body').on('click', '#clear_label', function (e) {
    e.stopPropagation();
    $('#selling_status_icon').removeClass('icon-rexiao icon-tuijian');
    $('#selling_status_desc').text('');

    shopCompile.setLabelStatus({
        hotSale: 0,
        recommend: ''
    })

    shopCompile.hideLabelPopUp();
})

// 标签-推荐
$('body').on('click', '#recommend', function (e) {
    e.stopPropagation();

    shopCompile.changeLaberStatus({
        removeClass: 'icon-rexiao',
        addClass: 'icon-tuijian',
        changeText: '推荐'
    })

    shopCompile.setLabelStatus({
        hotSale: 0,
        recommend: 'tj'
    })

    shopCompile.hideLabelPopUp();
})

// 标签-热销
$('body').on('click', '#hot', function (e) {
    e.stopPropagation();

    shopCompile.changeLaberStatus({
        removeClass: 'icon-tuijian',
        addClass: 'icon-rexiao',
        changeText: '热销'
    })

    shopCompile.setLabelStatus({
        hotSale: 1,
        recommend: 'rx'
    })

    shopCompile.hideLabelPopUp();
});

// 取消新增图片选项
$('body').on('click', '#cancel_photo', function (e) {
    e.stopPropagation();
    e.preventDefault();
    removePhotoClass();
    $('#add-picture,.box').hide();
});
function preventDefault(e) {
    e.preventDefault();
}
// function preventDefault(e) {
//     e.preventDefault();
// }