var html_name = page_arr.shop_product_jg;

var cpbjInfo = [];
var originData = []; // 返回需要需要对比的数据
var jgType = ''; // 需要切换的报价方式
var jgValue = []; // 报价数据
// var unitId = 0;
var jjdw_mc = '';
var temp_data = [];
var slValue = []; // 按数量报价数据
var isLoad = false; // 判断页面是否已加载完

// 获取数量报价数据
function getSlVal() {
    var tempVal = [];
    $($('.number1')).each(function (idx, item) {
        var qdl = fun.toNumber($(this).val().trim() || 0);
        var money = fun.toNumber($('.number2').eq(idx).val().trim() || 0);
        if ($.nui.isTrue(qdl)) {
            tempVal.push({
                qdl: qdl,
                money: money
            })
        }
    })
    return tempVal;
}

$('#header').header({ // 防止进入页面整个页面空白
    back: true,
    title: '产品价格',
    appendBackBtnEvt: isDataChange,
});

// 获取计量单位的值
page_init = function () {
    fun.showLoad();
    if (!AuthVersionCheck.checkHide('xsdp')) {
        $('.add-offer,.offer-mode').show();
    }
    init();
    page_data['keyback'] = isDataChange;
    //监听
    api.addEventListener({
        name: page_arr.shop_product_jg,
    }, function (ret, err) {
        var temp = ret['value'] || {};
        var data = temp['data'] || {};
        if ($.nui.isEmpty(data['list_data']) && $.nui.isEmpty(data['select_val'])) { // 没有更换计价单位
            return;
        }
        isLoad = false;
        jjdw_mc = data['select_val'];
        if (data['page_type'] == 'dw') {
            var fhdw = data['id']
            $('.comp-info').text(data['select_val']).data('jjdw_id', fhdw)
        }
        if (($('.comp-info').text()) != '') {
            $('input:not(input:radio)').attr('disabled', false);
        }

        if ($.nui.isEmpty(page_data.id)) {
            jgValue = notProductIdInit();
        }

        getMobileAppCpbj({
            type: 'change'
        });

        $('.danwei').text($('.comp-info').text()); //将查询的值赋值到单位中
        // fun.hideLoad();
    });

    fun.setKeyBoard({ // 解决安卓和ios软键盘问题
        isIos: {
            showFn: keyBoardShow,
            hideFn: keyBoardHide,
        }
    })
    fun.inputType();
}

// 页面初始化
function init() {
    page_data['jg_type'] = $.nui.isEmpty(page_data['jg_type']) ? 'ys' : page_data['jg_type'];
    page_data['jg_value'] = $.nui.isEmpty(page_data['jg_value']) ? [] : page_data['jg_value'];
    jjdw_mc = page_data['zdw'];
    jgType = page_data['jg_type'];
    jgValue = page_data['jg_value'];
    if (page_data['jg_type'] === 'sl') {
        slValue = page_data['jg_value'];
    }
    // unitId = page_data['unit_id'];
    if (!(Auth.check('cp', 'edit'))) {
        $('input:not(input:radio)').attr('disabled', true);
    }

    if ($.nui.isTrue(page_data['unit_id'])) {
        $('.comp-info').text(page_data['zdw']).data('jjdw_id', page_data['unit_id']);
    } else {
        $('.comp-info').text(page_data['zdw']).data('jjdw_id', page_data['zdw_id']);
    }


    if ($('.radio-label').eq(0).hasClass('offer-sl')) {
        type = 'sl';
    } else {
        type = 'ys';
    }

    //当计价单位没有值时，禁用输入
    if ($.nui.isEmpty(page_data.zdw)) {
        $('input:not(input:radio)').attr('disabled', true);
    }

    $('.danwei').text($('.comp-info').text());
    getMobileAppCpbj({
        type: 'edit'
    });
    renderSlOffer();
    bindEvent();
    setTimeout(function () {
        fun.inputType();
    }, 400)
}
// 获取产品报价
function getMobileAppCpbj(params) {
    fun.ajax({
        showLoad: true,
        hideLoad: false,
        url: AJAX_URL.getBpcpbjList,
        data: {
            "type": "add",
            "cp_id": page_data['id'],
            "jjdw_id": $('.comp-info').data('jjdw_id')
        },
        success: function (res) {
            temp_data = res['data'];
            if (res['status'] === 0) {

                if (params.type === 'change' && $.nui.isTrue(page_data.id)) {
                    productPriceUpDate(temp_data);
                };

                loop({
                    type: params.type
                });
                randioSwitch();

                //色卡价格
                var colorCardPrice = page_data.color_card_price || 0;
                $('#skjj').val(colorCardPrice);

                isLoad = true;
                setTimeout(function () {
                    fun.hideLoad();
                }, 1000)

            } else {
                fun.toast('获取产品报价失败');
            }
        }
    })
}

// 根据条件显示区间
function showSecHtml(jgValue) {
    var showStyle = 'style=display: block;';
    if ($.nui.isEmpty(jgValue) || page_data.jg_type === 'ys') {
        var html = [];
        html.push('<li class="line3 ul-li clearfix">');
        html.push('    <p class="qujian color-gray">价格趋区间</p>');
        html.push('    <div class="float-left qiding">');
        html.push('        <div class="enlarge-wrap">');
        html.push('            <span class="span1 font-ls">起订量</span>');
        html.push('        </div>');
        html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="num-input input1 number1 tel" num_type="2" decimal_digits="4">');
        html.push('        <span class="span1 font-ls">及以上:</span>');
        html.push('        <input type="text" id="dzts_' + $.nui.getRandomNum() + '" class="sl-money num-input input1 number2 tel" num_type="2" decimal_digits="4">');
        html.push('        <span class="span1 font-ls">元/</span>');
        html.push('        <span class="danwei xiugai_sl">' + jjdw_mc + '</span>');
        html.push('    </div>');
        html.push('</li>');
        return html.join('');
    }

    switch (jgValue.length) {
        case 1:
            var html = [];
            var stairOne = '';
            if ($.nui.isTrue(jgValue[0]['qdl'])) { // 起订量有
                if ($.nui.isTrue(jgValue[0]['money'])) { // 价格有
                    stairOne = jgValue[0]['money'];
                } else {
                    stairOne = 0;
                }
            }
            html.push('<li class="line3 ul-li clearfix">');
            html.push('    <p class="qujian color-gray">价格趋区间</p>');
            html.push('    <div class="float-left qiding">');
            html.push('        <div class="enlarge-wrap">');
            html.push('            <span class="span1 font-ls">起订量</span>');
            html.push('        </div>');
            html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="num-input input1 number1 tel" num_type="2" decimal_digits="4" value="' + fun.is_value(jgValue[0]['qdl']) + '">');
            html.push('        <span class="span1 font-ls">及以上:</span>');
            html.push('        <input type="text" id="dzts_' + $.nui.getRandomNum() + '" class="sl-money num-input input1 number2 tel" num_type="2" decimal_digits="4" value="' + stairOne + '">');
            html.push('        <span class="span1 font-ls">元/</span>');
            html.push('        <span class="danwei xiugai_sl">' + jjdw_mc + '</span>');
            html.push('    </div>');
            html.push('</li>');
            return html.join('');
            break;
        case 2:
            var stairOne = '';
            var stairTwo = '';
            if ($.nui.isTrue(jgValue[0]['qdl'])) { // 起订量有
                if ($.nui.isTrue(jgValue[0]['money'])) { // 价格有
                    stairOne = jgValue[0]['money'];
                } else {
                    stairOne = 0;
                }
            }

            if ($.nui.isTrue(jgValue[1]['qdl'])) { // 起订量有
                if ($.nui.isTrue(jgValue[1]['money'])) { // 价格有
                    stairTwo = jgValue[1]['money'];
                } else {
                    stairTwo = 0;
                }
            }
            var html = [];
            html.push('<li class="line3 ul-li clearfix">');
            html.push('    <p class="qujian color-gray">价格趋区间</p>');
            html.push('    <div class="float-left qiding">');
            html.push('        <div class="enlarge-wrap">');
            html.push('            <span class="span1 font-ls">起订量</span>');
            html.push('        </div>');
            html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="num-input input1 number1 tel" num_type="2" decimal_digits="4" value="' + fun.is_value(jgValue[0]['qdl']) + '">');
            html.push('        <span class="span1 font-ls">及以上:</span>');
            html.push('        <input type="text" id="dzts_' + $.nui.getRandomNum() + '" class="sl-money num-input input1 number2 tel" num_type="2" decimal_digits="4" value="' + stairOne + '">');
            html.push('        <span class="span1 font-ls">元/</span>');
            html.push('        <span class="danwei xiugai_sl">' + jjdw_mc + '</span>');
            html.push('    </div>');
            html.push('</li>');
            html.push('<li class="line4 ul-li clearfix" ' + showStyle + '>');
            html.push('    <div class="float-left tuozhan">');
            html.push('        <div class="enlarge-wrap clear-space">');
            html.push('            <span class="iconfont icon-minus minus1 minus2 click-enlarge"></span>');
            html.push('            <span class="span1 font-ls by-name">购买</span>');
            html.push('        </div>');
            html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="num-input input2 number1 tel" num_type="2" decimal_digits="4" value="' + fun.is_value(jgValue[1]['qdl']) + '">');
            html.push('        <span class="span1 font-ls">及以上:</span>');
            html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="sl-money num-input input2 number2 tel" num_type="2" decimal_digits="4" value="' + stairTwo + '">');
            html.push('        <span class="span1 font-ls">元/</span>');
            html.push('        <span class="danwei xiugai_sl">' + jjdw_mc + '</span>');
            html.push('    </div>');
            html.push('</li>');
            return html.join('');
            break;
        case 3:
            var html = [];
            html.push('<li class="line3 ul-li clearfix">');
            html.push('    <p class="qujian color-gray">价格趋区间</p>');
            html.push('    <div class="float-left qiding">');
            html.push('        <div class="enlarge-wrap">');
            html.push('            <span class="span1 font-ls">起订量</span>');
            html.push('        </div>');
            html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="num-input input1 number1 tel" num_type="2" decimal_digits="4" value="' + fun.is_value(jgValue[0]['qdl']) + '">');
            html.push('        <span class="span1 font-ls">及以上:</span>');
            html.push('        <input type="text" id="dzts_' + $.nui.getRandomNum() + '" class="sl-money num-input input1 number2 tel" num_type="2" decimal_digits="4" value="' + fun.is_value(jgValue[0]['money']) + '">');
            html.push('        <span class="span1 font-ls">元/</span>');
            html.push('        <span class="danwei xiugai_sl">' + jjdw_mc + '</span>');
            html.push('    </div>');
            html.push('</li>');

            for (var i = 1; i < jgValue.length; i++) {
                var item = jgValue[i];
                var money = '';
                if ($.nui.isTrue(item['qdl'])) { // 起订量有
                    if ($.nui.isTrue(item['money'])) { // 价格有
                        money = item['money'];
                    } else {
                        money = 0;
                    }
                }
                html.push('<li class="line4 ul-li clearfix" ' + showStyle + '>');
                html.push('    <div class="float-left tuozhan">');
                html.push('        <div class="enlarge-wrap clear-space">');
                html.push('            <span class="iconfont icon-minus minus1 minus2 click-enlarge"></span>');
                html.push('            <span class="span1 font-ls by-name">购买</span>');
                html.push('        </div>');
                html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="num-input input2 number1 tel" num_type="2" decimal_digits="4" value="' + item['qdl'] + '">');
                html.push('        <span class="span1 font-ls">及以上:</span>');
                html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="sl-money num-input input2 number2 tel" num_type="2" decimal_digits="4" value="' + money + '">');
                html.push('        <span class="span1 font-ls">元/</span>');
                html.push('        <span class="danwei xiugai_sl">' + jjdw_mc + '</span>');
                html.push('    </div>');
                html.push('</li>');
            }
            return html.join('');
            break;
    }
}

// 渲染产品颜色报价
function loop(params) {
    var html = [];
    html.push('<ul class="product_color index-on">');
    html.push('    <li class="lines3 ul-li">');
    html.push('        <span class="pizhe color-gray">批量设置剪样价</span>');
    html.push('        <input type="text" id="dzts_' + $.nui.getRandomNum() + '" class="pizhi pizhi1 tel num-input" num_type="2" decimal_digits="4" maxlength="13" placeholder="请输入统一价格" data-type="jy">');
    html.push('        <p class="pidan color-gray" style="display:inline-block;margin-top:0.3rem"><span class="danwei_ys xiugai"></span></p>');
    html.push('    </li>');
    html.push('    <li class="lines3 ul-li">');
    html.push('        <span class="pizhe color-gray">批量设置大货价</span>');
    html.push('        <input type="text" id="dzts_' + $.nui.getRandomNum() + '" class=" pizhi pizhi2 tel num-input" num_type="2" decimal_digits="4" maxlength="13" placeholder="请输入统一价格" data-type="dh">');
    html.push('        <p class="pidan color-gray" style="display:inline-block;"><span class="danwei_ys xiugai"></span></p>');
    html.push('    </li>');
    html.push('    <li class="lines4 clearfix">');
    html.push('        <p class="yanse color-gray">');
    // html.push('           <span class="yby-margin-left10 line-height2">颜色</span>');
    html.push('           <span class="line-height2" style="padding-left:14%; width: 50%;">颜色</span>');
    html.push('           <span class="line-height2" style="width: 3rem; text-align: center;">剪样价</span>');
    html.push('           <span class="line-height2" style="width: 3rem; text-align: center; margin-left: 1rem;">大货价</span>');
    html.push('        </p>');
    html.push('    </li>');

    showList(html, params);
    html.push(' </ul>');
    $('.product_color').remove();
    $('.cut-con').after(html.join(''));
    //iphoneX适应
    $('.product_color').css('margin-bottom', api.safeArea.bottom + 'px');
    //按颜色报价的单位
    if ($.nui.isTrue($('.comp-info').text())) {
        $('.danwei_ys').text('/' + $('.comp-info').text());
    }
    _origin_data = getSaveData(); // 拿到初始化颜色报价需要保存数据
}

// 获取数据进行加载
function showList(html, params) {
    var tempValue = JSON.parse(JSON.stringify(jgValue));
    if ($.nui.isEmpty(page_data.id) && params.type !== 'change' && jgType === 'sl') {
        tempValue = notProductIdInit();
    }
    for (var i = 0; i < tempValue.length; i++) {
        var item = tempValue[i];
        var isStop = $.nui.isTrue(item['is_stop']) && item['is_stop'] >= 1 ? 'is-stop' : '';
        var cp_bh_mc = item['cp_ys_mc'] ? item['cp_ys_bh'] + ' ' + item['cp_ys_mc'] : item['cp_ys_bh'];
        html.push('    <li class="ul-li1 clearfix render-ys-list">');
        html.push('        <p class="yan">');
        html.push('             <span class="white-cloth ' + isStop + '">' + cp_bh_mc + '</span>');
        html.push('           <input type="text" id="' + (Date.now() + $.nui.getRandomNum()) + '" class="jy  jyj_jianju color_orange num-input" num_type="2" decimal_digits="4" maxlength="13" style="width: 3rem; color: #f68324" value="' + fun.is_value(item.jy_bzj, 0) + '">');
        html.push('           <input type="text" id="' + (Date.now() + $.nui.getRandomNum()) + '" class="dh  dhj_jianju num-input" num_type="2" decimal_digits="4" maxlength="13" value="' + fun.is_value(item.bz_bzj, 0) + '">');
        html.push('        </p>');
        html.push('    </li>');
    }
    cpbjInfo = JSON.parse(JSON.stringify(tempValue));
    originData = JSON.parse(JSON.stringify(tempValue));
};

// 获取产品报价保存数据
function getSaveData() {
    var save_data = {
        jjdw_id: $('.comp-info').data('jjdw_id'),
        zdr_id: fun.getItem('user_info')['id'],
        data: cpbjInfo
    }
    return save_data;
}

// 返回
function isDataChange() {
    if (!isLoad) return;
    var type = '';
    //报价方式
    if ($('.radio-label').eq(0).hasClass('offer-sl')) {
        type = 'sl';
    }

    if ($('.radio-label').eq(1).hasClass('offer-ys')) {
        type = 'ys';
    }

    var jg_value = [];
    var maxcnt = '';
    var mincnt = '';
    if (type === 'sl') {
        jg_value = getSlVal(); // 获取按数量报价数据
        var sl_list = [];
        for (var i in jg_value) {
            sl_list.push(jg_value[i].money);
        }
        maxcnt = Math.max.apply(null, sl_list);
        mincnt = Math.min.apply(null, sl_list);
    } else {
        for (var i = 0; i < cpbjInfo.length; i++) {
            var nowTime = fun.dateFormat('yyyy-MM-dd hh:mm', new Date());
            var item = cpbjInfo[i];
            var dhBzj = fun.toNumber($('.dh').eq(i).val().trim());
            var jyBzj = fun.toNumber($('.jy').eq(i).val().trim());
            if (dhBzj !== fun.toNumber(item.bz_bzj)) {
                item.bz_sj = nowTime;
                item.bz_bzj = dhBzj;
            }
            if (jyBzj !== fun.toNumber(item.jy_bzj)) {
                item.jy_sj = nowTime;
                item.jy_bzj = jyBzj;
            }
        }
        jg_value = cpbjInfo;
    }
    setTimeout(function () {
        var color_card_price = Number($('#skjj').val()) || 0;
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                status: 'jg',
                jjdw_id: $('.comp-info').data('jjdw_id'), //计价单位id
                jjdw: $('.comp-info').text(), //计价单位
                jg_type: type, //报价方式
                jg_value: jg_value, //数据
                color_card_price: color_card_price,  //色卡价格
                maxcnt: fun.toNumber(maxcnt), //最高价
                mincnt: fun.toNumber(mincnt), //最低价
                cpbjInfo: cpbjInfo //产品数据
            }
        });
        api.closeWin();
    }, 200)
}

// 根据条件显示区间
function showSection(jgValue) {
    switch (jgValue.length) {
        case 0:
        case 1:
        case 2:
            $('.line5').show();
            break;
        case 3:
            $('.line5').hide();
            break;
        // 没有default:
    }
}

// 安卓ios键盘收起处理
function keyBoardHideHandle() {
    if ($('input').hasClass('jy-ipt')) { // 失去焦点剪样单独设置价格处理
        var val = $('.jy-ipt').val().trim();
        if ($.nui.isEmpty(val)) {
            $('.jy-ipt').val(0);
        }
        $('input').removeClass('jy-ipt');
    }
    if ($('input').hasClass('dh-ipt')) { // 失去焦点大货单独设置价格处理
        var val = $('.dh-ipt').val().trim();
        if ($.nui.isEmpty(val)) {
            $('.dh-ipt').val(0);
        }
        $('input').removeClass('dh-ipt');
    }

    if ($('input').hasClass('batch-jy')) { // 失去焦点剪样批量设置价格处理
        var val = $('.batch-jy').val().trim();
        if ($.nui.isEmpty(val)) {
            $('.batch-jy').val(0);
            $('.jy').val(0);
        } else {
            $('.jy').val(val);
        }
        $('input').removeClass('batch-jy');
    }

    if ($('input').hasClass('batch-dh')) { // 失去焦点大货批量设置价格处理
        var val = $('.batch-dh').val().trim();
        if ($.nui.isEmpty(val)) {
            $('.batch-dh').val(0);
            $('.dh').val(0);
        } else {
            $('.dh').val(val);
        }
        $('input').removeClass('batch-dh');
    }

    if ($('input').hasClass('sl-money-ipt')) { // 失去焦点数量报价价格单独设置价格处理
        var val = $('.sl-money-ipt').val().trim();
        if ($.nui.isEmpty(val)) {
            $('.sl-money-ipt').val(0);
        }
        $('input').removeClass('sl-money-ipt');
    }
}

// 初始化事件
function bindEvent() {
    // 批量设置报价
    $('body').on('keyup', '.pizhi1, .pizhi2', function () {
        var type = $(this).data('type');
        var batchVal = $(this).val().trim();
        if ($.nui.isEmpty(batchVal)) {
            $(this).val(0);
            $('.' + type).val(0);
        } else {
            $('.' + type).val(batchVal);
        }
    })

    // 剪样、大货、数量报价设置价格
    $('body').on('keyup', '.jy, .dh, .sl-money', function () {
        if ($.nui.isEmpty($(this).val().trim())) {
            $(this).val(0);
        }
    })

    // 单选框
    $('.index-off').click(function () {
        isLoad = false;
        fun.showLoad();
        // fun.showShade();

        var index = $('.index-off').index($(this));
        switch (index) {
            case 0:
                jgType = 'sl';
                $('.radio-label').eq(1).removeClass('offer-ys');
                $('.radio-label').eq(0).addClass('offer-sl');
                // $('.radio-label').eq(0).data('type','sl');
                break;
            case 1:
                jgType = 'ys';
                $('.radio-label').eq(0).removeClass('offer-sl');
                $('.radio-label').eq(1).addClass('offer-ys');
                // $('.radio-label').eq(0).data('type','ys');
                break;
            // 没有default:
        }
        $('.index-on').hide();
        $('.index-on').eq(index).show();
        isLoad = true;
        fun.hideLoad();
        // fun.hideShade();
    })

    // 添加区间
    $('body').on('click', '.line5', function () {
        var html = [];
        html.push('<li class="line4 ul-li clearfix">');
        html.push('    <div class="float-left tuozhan">');
        html.push('        <div class="enlarge-wrap clear-space">');
        html.push('            <span class="iconfont icon-minus minus1 minus2 click-enlarge"></span>');
        html.push('            <span class="span1 font-ls by-name">购买</span>');
        html.push('        </div>');
        html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="num-input input2 number1 tel" num_type="2" decimal_digits="4">');
        html.push('        <span class="span1 font-ls">及以上:</span>');
        html.push('        <input id="dzts_' + $.nui.getRandomNum() + '" type="text" class="sl-money num-input input2 number2 tel" num_type="2" decimal_digits="4">');
        html.push('        <span class="span1 font-ls">元/</span>');
        html.push('        <span class="danwei xiugai_sl">' + jjdw_mc + '</span>');
        html.push('    </div>');
        html.push('</li>');

        switch ($('.line4:visible').length) {
            case 0:
                $('#wrap_box').append(html.join(''));
                break;
            case 1:
                $('#wrap_box').append(html.join(''));
                $('.line5').hide();
                break;
        }
    })

    // 收起区间
    $('body').on('click', '.icon-minus', function () {
        var index = $('.icon-minus').index($(this));
        // $('.line4').eq(index).hide();
        $('.line4').eq(index).find('.number1,.number2').val('');
        $('.line4').eq(index).remove();
        $('.line5').show();
    })

    //起订量之间的约束
    $('body').on('change', '.number1', function () {
        var nums = $('.number1').index(this);
        var num_length = $('.number1').length;
        switch (num_length) {
            case 1:
                break;
            case 2:
                var one_nums = $('.number1').eq(0).val().trim() * 10000;
                var two_nums = $('.number1').eq(1).val().trim() * 10000;
                if (nums === 0) {
                    if ($('.number1').eq(1).val() != '' && one_nums >= two_nums) {
                        fun.toast('不能大于等于' + $('.number1').eq(1).val());
                        $('.number1').eq(0).val('');
                    }
                } else if (nums === 1) {
                    if ($('.number1').eq(0).val() != '' && one_nums >= two_nums) {
                        fun.toast('不能小于等于' + $('.number1').eq(0).val());
                        $('.number1').eq(1).val('');
                    }
                }
                break;
            case 3:
                var one_nums = $('.number1').eq(0).val().trim() * 10000;
                var two_nums = $('.number1').eq(1).val().trim() * 10000;
                var three_nums = $('.number1').eq(2).val().trim() * 10000;
                if (nums === 0) {
                    if ($('.number1').eq(1).val() != '' && one_nums >= two_nums) {
                        fun.toast('不能大于等于' + $('.number1').eq(1).val());
                        $('.number1').eq(0).val('');
                    } else if ($('.number1').eq(2).val() != '' && one_nums >= three_nums) {
                        fun.toast('不能大于等于' + $('.number1').eq(2).val());
                        $('.number1').eq(0).val('');
                    }
                } else if (nums === 1) {
                    if ($('.number1').eq(0).val() != '' && one_nums >= two_nums) {
                        fun.toast('不能小于等于' + $('.number1').eq(0).val());
                        $('.number1').eq(1).val('');
                    } else if ($('.number1').eq(2).val() != '' && three_nums <= two_nums) {
                        fun.toast('不能大于等于' + $('.number1').eq(2).val());
                        $('.number1').eq(1).val('');
                    }
                } else if (nums === 2) {
                    if ($('.number1').eq(0).val() == '') {
                        if ($('.number1').eq(1).val() != '' && three_nums <= two_nums) {
                            fun.toast('不能小于等于' + $('.number1').eq(1).val());
                            $('.number1').eq(2).val('');
                        }
                    } else if ($('.number1').eq(0).val() != '' && $('.number1').eq(1).val() == '') {
                        if (three_nums <= one_nums) {
                            fun.toast('不能小于等于' + $('.number1').eq(0).val());
                            $('.number1').eq(2).val('');
                        }
                    }
                    else if ($('.number1').eq(1).val() != '') {
                        if (three_nums <= two_nums) {
                            fun.toast('不能小于等于' + $('.number1').eq(1).val());
                            $('.number1').eq(2).val('');
                        }
                    }
                }
                break;

        }
    })

    //跳转到单位搜索页面
    $('.line1').on('tap', function () {
        if (!(Auth.check('cp', 'edit'))) return;
        fun.showPageFull({
            page_url: '../html/select_list.html',
            closeWin: true,
            pageParam: {
                "return_page": page_arr.shop_product_jg,
                "page_type": 'dw'
            }
        });
    })
}

// 软键盘弹起
function keyBoardShow() {
    $('#header').css({
        position: 'absolute'
    })
}

// 软键盘收起
function keyBoardHide() {
    $('#header').css({
        position: 'fixed'
    })
}

// 拼接报价数据
function productPriceUpDate(data) {
    var productColor = page_data['goods_colour'];
    var tempColorArr = JSON.parse(JSON.stringify(data));
    var tempArr = [];
    for (var i = 0; i < productColor.length; i++) {
        var colorItem = productColor[i];
        var mark = false;
        mark = tempColorArr.some(function (item, idx) {
            return colorItem['number'] === item['cp_ys_bh'];
        })
        if (!mark) {
            tempArr.push({
                idx: i,
                data: colorItem
            });
        }
    }
    for (var i = 0; i < tempArr.length; i++) {
        var item = tempArr[i];
        tempColorArr.splice(item.idx, 0, {
            bz_bzj: 0,
            bz_sj: '',
            cp_mc: page_data.cp_mc,
            cp_ys_bh: item['data']['number'],
            cp_ys_mc: item['data']['name'] || '',
            cp_ys_id: item['data']['id'] || 0,
            id: page_data['id'] || 0,
            jy_bzj: 0,
            jy_sj: ''
        })
    }
    // 重新排序
    var res = [];
    productColor.forEach(function (item, idx) {
        for (var i = 0; i < tempColorArr.length; i++) {
            var jgValueItem = tempColorArr[i];
            if (item.number === jgValueItem.cp_ys_bh) {
                res.push(jgValueItem);
                break;
            }
        }
    });
    jgValue = res;
}

function randioSwitch() {
    if (jgType === 'ys') {
        $('.radio-label').eq(0).removeClass('offer-sl');
        $('.radio-label').eq(1).addClass('offer-ys');
        $('.index-on').eq(0).hide();
        $('.index-on').eq(1).show();
    } else {
        $('.radio-label').eq(1).removeClass('offer-ys');
        $('.radio-label').eq(0).addClass('offer-sl');
        $('.index-on').eq(1).hide();
        $('.index-on').eq(0).show();
    }
}

// 渲染数量报价数据
function renderSlOffer() {
    var tempValue = jgType === 'ys' && getSlVal() || jgValue;
    $('#wrap_box').html(showSecHtml(tempValue)); // 根据条件显示区间
    showSection(tempValue); // 选择期间显示
};

// 没有产品id，拼接按颜色报价数据
function notProductIdInit() {
    return page_data.goods_colour.reduce(function (initVal, item, idx, self) {
        return (
            initVal.length !== self.length &&
            initVal.push({
                bz_bzj: 0,
                bz_sj: '',
                cp_mc: fun.is_value(page_data.cp_mc),
                cp_ys_bh: fun.is_value(item['number']),
                cp_ys_mc: fun.is_value(item['name']),
                cp_ys_id: fun.is_value(item['id'], 0),
                id: 0,
                jy_bzj: 0,
                jy_sj: ''
            }),
            initVal
        )
    }, []);
}