var html_name = page_arr['shop_product_view']; // 当前页面名称
var return_page = ''; // 返回页
var photoBrowser = {}; // 大图预览
var IS_PAGE_EDIT = true; // 页面是否可编辑
var PAGE_DATA = {};
var is_sj = 0; // 未上架
var _origin_data = {};
var SYS_CONFIG = {};
var printDataList = []; // 打印的数据
var bbxqImg = []; // 分页加载图片
var swiper = null; // swiper滑动变量 

var Bills = { djlx: 'cp' };
Bills['print_config'] = { 'djlx': 'cp' };
var search_data = {}; // 搜索数据
var shopView = {
    hasChangeClick: false
};

var print_columns = [ // 打印需要的参数
    { name: 'class_name', display: '类别', width: 100, mergeCell: true },
    { name: 'type', display: '类型', width: 78, mergeCell: true },
    { name: 'imgs', display: '图', width: 60 },
    { name: 'tm', display: '条码', width: 100 },
    { name: 'number', display: '编号', width: 100 },
    { name: 'name', display: '名称', width: 160 },
    { name: 'unit_name', display: '单位', width: 90 },
    { name: 'width', display: '幅宽', type: 'float', width: 80 },
    { name: 'weight', display: '克重', type: 'float', width: 80 },
    { name: 'component', display: '成分', width: 150 },
    { name: 'craft', display: '工艺', width: 80 },
    { name: 'quarter', display: '季度', width: 80 },
    { name: 'gauze', display: '纱支', width: 80 },
    { name: 'density', display: '密度', width: 80 },
    { name: 'sale_point', display:'卖点',width: 150 },
    // { name: 'label_id', display: '标签', width: 150, mergeCell: ['merchant_name'], },
    { name: 'is_sj', display: '上架', width: 80, type: 'checkbox' },
    { name: 'sj_sj', display: '上架时间', width: 150, },
    { name: 'gys', display: '供应商', width: 80 },
    { name: 'diff', display: '模式', width: 80, visible: false, },
    { name: 'remark', display: '备注', width: 160, align: 'left' },
    { name: 'date', display: '日期', width: 150, },
    { name: 'is_stop', type: 'switch', display: '停用', width: 60, editor: { disabled: true } },
    { name: 'pb_fk', display: '坯布幅宽', width: 60},
    { name: 'pb_kz', display: '坯布克重', width: 60},
    { name: 'needle', display: '针寸数', width: 60},
    { name: 'machine_road', display: '机台路数', width: 60},
    { name: 'needle_count', display: '总针数', width: 60},
    { name: 'model_count', display: '总模数', width: 60},
    { name: 'weave_mode', display: '织造方式', width: 60},
    { name: 'weave_type', display: '织造类型', width: 60},
    { name: 'machine_type', display: '机台类别', width: 60},
    { name: 'machine_num', display: '机台号', width: 60},
    { name: 'shelf_width', display: '布架宽度', width: 60},
    { name: 'speed', display: '机速/分', width: 60},
    { name: 'sjjs', display: '上机经纱', width: 60},
    { name: 'mkjs', display: '每筘经纱', width: 60},
    { name: 'reed_num', display: '筘号', width: 60},
    { name: 'bobbin_num', display: '梭数', width: 60},
    { name: 'sjwm', display: '上机纬密', width: 60},
    { name: 'xjwm', display: '下机纬密', width: 60},
    { name: 'reed_width', display: '筘幅', width: 60},
    { name: 'slitter_edge', display: '废边', width: 60},
    { name: 'weave_loss', display: '织造损耗%', width: 60},
    { name: 'weave_shrinkage', display: '织缩率%', width: 60},
    { name: 'dye_loss', display: '染整损耗%', width: 60},
    { name: 'whole_shrinkage', display: '整缩率%', width: 60}
];

// 产品信息
var CP_INFO = {
    info: {},
    goods_colour: [],
    goods_weight: [],
    goods_spec: [],
    merchant_assistant: [],
    goods_machining: [],
    goods_craft: [],
    options: {},
    param: []
};

// 返回被删除的列表
delete_list = {
    colour_arr: [], // 颜色
    fzxx_arr: [],
    fzxx_colouArr: [],
};


// 获取上架时间距离当前时间的天数
shopView.intervalTime = function (sjSj) {
    var nowDate = new Date().getTime();
    var tempSjSj = new Date(fun.dateFormat('yyyy/MM/dd hh:mm', sjSj)).getTime(); // 上架时间戳
    return fun.toNumber(fun.getOffsetDays(nowDate, tempSjSj));
};

// 如果当前产品的标签为：推荐、热卖，则显示对应的图标，反之才判断是不是新品，显示：新品的图标
shopView.showLabelIcon = function () {
    var labelIconStr = '';
    var info = CP_INFO['info'];
    if (info['label'] === 'tj') { // 标签状态为推荐
        labelIconStr = '<i class="iconfont product-status-icon icon-tuijian recommend-icon"></i>';
    } else if (info['label'] === 'rx') { // 标签状态为热卖
        labelIconStr = '<i class="iconfont product-status-icon icon-rexiao hot-sale-icon"></i>';
    } else if (info['is_new'] === 1) { // 标签状态为新品
        labelIconStr = '<i class="iconfont product-status-icon  icon-xinpinNEW new-product-icon"></i>';
    }
    return labelIconStr;
}


// 微信展示页判断权限
function wxShowAuth() {
    fun.ajax({
        url: AJAX_URL.getSysList,
        data: {},
        success: function (res) {
            if (res['status'] === 0) {
                var data = res['data'];
                if ('cpxqzs' in data) {
                    $(JSON.parse(data['cpxqzs'])).each(function (idx, item) {
                        if (item['name'] === 'bq' && !item['is_stop']) {
                            $('#line_bq').hide();
                            $('.special').hide();
                            $('.order_list').css({
                                paddingBottom: 0
                            })
                        }
                    })
                }
            }
        }
    });
}

// 监听安卓返回键
function isDataChange() {
    if (!shopView['hasChangeClick']) {
        fun.showLoad();
        return setTimeout(function () {
            api.closeWin();
            fun.hideLoad();
        }, 200);
    }
    api.sendEvent({
        name: return_page,
        extra: {
            status: 'refresh'
        }
    })
    fun.showLoad();
    setTimeout(function () {
        api.closeWin();
        return fun.hideLoad();
    }, 200);
}

// 设置页面初始化
page_init = function () {
    console.log(page_data);
    fun.load_DATA_LIST(['jjdw']);
    SYS_CONFIG = fun.getItem('sys_config'); // 系统设置
    IS_PAGE_EDIT = Auth.check('cp', 'edit');
    return_page = page_data['return_page'];
    photoBrowser = api.require('photoBrowser'); // 大图预览
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret['value']; // 保存成功后
        switch (temp['status']) {
            case 'shop_cp_ys_bj':
                if ($.nui.isEmpty(temp['data'])) return; // 编辑状态，删除一个颜色，新建一条一模一样的，点击保存提示色号已存在，取值会取到一个undefined
                CP_INFO['goods_colour'] = temp['data'];
                if (CP_INFO['merchant_assistant'].length > 0) {
                    $(CP_INFO['merchant_assistant']).each(function (merchant_index, colour_item) {
                        var colour_length = colour_item['colour_assistant'].length;
                        var parme_arr = [];
                        $(CP_INFO['goods_colour']).each(function (colour_index, item) {   //返回颜色通知底卡颜色改变
                            var index = item['_index'];
                            //判断如果有新增的颜色则做加入，存在则做修改,如果存在，则colour_assistant数组长度是大于0的
                            if (('_index' in item)) {
                                var colour_assistant = colour_item['colour_assistant'][index];
                            }
                            if (('_index' in item) && colour_item['colour_assistant'].length > 0 && colour_assistant != undefined && ('goods_colour_id' in colour_assistant)) {
                                var parme = {
                                    colour_number: item['number'] || '',
                                    colour_name: item['name'] || '',
                                    id: colour_assistant['id'],
                                    goods_id: item['goods_id'],
                                    merchant_assistant_id: colour_assistant['merchant_assistant_id'],
                                    goods_colour_id: item['id'],
                                    number: colour_assistant['number'] || '',
                                    name: colour_assistant['name'] || '',
                                    simple: colour_assistant['simple'],
                                    order_amount: colour_assistant['order_amount'] || 0,
                                    price: colour_assistant['price'] || 0,
                                    is_delete: colour_assistant['is_delete'],
                                    create_time: colour_assistant['create_time'],
                                    update_time: colour_assistant['update_time'],
                                }
                                parme_arr.push(parme)
                            } else {
                                var parme = {
                                    colour_name: item['name'],
                                    colour_number: item['number'],
                                    id: 0,
                                    is_delete: 0,
                                    name: '',
                                    number: '',
                                    order_amount: 0,   //如果底卡是新增的，但还没保存的情况下，则那新增时价格对应进去，如果有多余的，则取0
                                    price: ('_index' in item && colour_length >= (item['_index'] + 1)) ? colour_assistant['price'] : 0,
                                }
                                parme_arr.push(parme);
                            }
                        })
                        if ($.nui.isTrue(temp['delete_colour'])) {
                            $(temp['delete_colour']).each(function (idx, item) {
                                if (item['_index'] != '') {
                                    delete_list['fzxx_colouArr'].push(colour_item['colour_assistant'][item['_index']]['id']);
                                }
                            })
                        }
                        colour_item['colour_assistant'] = parme_arr;
                    })
                }
                $('#has_stop').text(temp['stop_count']);
                delete_list['colour_arr'] = temp['delete_colour'];
                break;
            case 'refresh':
                shopView.hasChangeClick = true;
                getList();
                break;
            case 'cpzl_data':
                switch (temp['page_type']) {
                    case 'dk_bj':
                    case 'dk_xx': //  底卡信息
                        var tempArr = [];
                        CP_INFO['merchant_assistant'] = temp['merchant_assistant'] || temp['merchant_assistants'];
                        if ($.nui.isTrue(CP_INFO['merchant_assistant'])) {
                            $(CP_INFO['merchant_assistant']).each(function (idx, item) {
                                if (item['is_delete']) {
                                    if ('id' in item) {
                                        delete_list['fzxx_arr'].push(item['id']);
                                    }
                                } else {
                                    if (item['merchant_id']) {
                                        tempArr.push(item);
                                    }
                                }
                            })
                        }
                        CP_INFO['merchant_assistant'] = tempArr;
                        $('#fzxx_jl').text(CP_INFO['merchant_assistant'].length);
                        break;
                }
                break;
            // 没有default
        }
    });

    page_data.keyback = function () {
        isDataChange();
    };

    fun.scrollToBottom({}, function () { // 滚动加载宝贝详情图片
        if ($.nui.isEmpty(bbxqImg)) return;
        if (bbxqImg.length > 0) {
            showBbxqImg(fun.PagingData(bbxqImg, 5) || []);
        }
    });

    init();

    getPrintData();
}

// 获取打印的数据
function getPrintData() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getGoodsList,
        data: $.extend({}, {
            "keyword": "",
            "is_stop": 0
        }),
        success: function (res) {
            if (res['status'] == 0) {
                printDataList = res.data.slice(0);
            } else {
                fun.alert({ msg: '网络异常！' })
            }
        }
    })
    fun.load_DATA_LIST(['cp']);
}

// 从颜色列表里删除色卡
// function deleteCorCard(data) {
//     for (var i = 0; i < data.length; i++) {
//         var item = data[i];
//         if (item['number'] === '色卡') {
//             data.splice(i, 1);
//         }
//     }
// }

// 获取产品信息
function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getGoodsInfo,
        data: {
            id: page_data['goods_id']
        },
        success: function (res) {
            if (res['status'] == 0) {
                var data = res.data || {};
                CP_INFO = {
                    info: data['info'] || {},
                    goods_colour: data['goods_colour'],
                    goods_weight: data['goods_weight'],
                    goods_spec: data['goods_spec'],
                    merchant_assistant: data['merchant_assistant'],
                    goods_machining: data['goods_machining'],
                    goods_craft: data['goods_craft'],
                    options: data['options'],
                    param: data['param'],
                }
                if ($.nui.isTrue(CP_INFO['info']['bbxq'])) {
                    bbxqImg = CP_INFO['info']['bbxq'].split(',');
                } else {
                    bbxqImg = [];
                }
                initJgVal();
                resetColorImg(); // 图片字符串转数组，过滤空值
                showData(CP_INFO); // 初始化页面
            }
        }
    })
}

// 图片字符串转数组，过滤空值
function resetColorImg() {
    $(CP_INFO['goods_colour']).each(function (idx, item) {
        var temp = [];
        if ($.nui.isTrue(item['imgs'])) {
            var img = item['imgs'].split(',');
            $(img).each(function (index, imgs) {
                if ($.nui.isTrue(imgs)) {
                    temp.push(imgs);
                }
            })
        } else {
            temp = [];
        }
        item['imgs'] = temp;
    })
}

// console.log($('#gridDemo').html());

// 暂时没用到
function sysHasUnit() {
    if ($.nui.isTrue(SYS_CONFIG['bpfzdw_xs'])) {
        return true;
    }
    return false;
}

// 获取计较单位
function getJjdw(info) {
    var xsdw_id = info['unit_options']['xsdw_id'];
    var jjdwMc = '';
    if ($.nui.isTrue(xsdw_id)) { // 有销售单位id
        jjdwMc = fun.getValByKey(fun.getItem('jjdw_list'), Number(xsdw_id), 'name');
    } else { // 没有销售单位id
        if ($.nui.isTrue(info['unit_id'])) { // 有主单位
            jjdwMc = info['dw_mc'];
        }
    }
    return jjdwMc;
}

// 获取单位id（有销售单位id拿，）
function getUnitId() {
    var unitId = 0;
    if ($.nui.isTrue(CP_INFO['info']['unit_options']['xsdw_id'])) {
        unitId = CP_INFO['info']['unit_options']['xsdw_id'];
    } else if ($.nui.isTrue(CP_INFO['info']['unit_id'])) {
        unitId = CP_INFO['info']['unit_id'];
    }
    return unitId;
}

// 没有取到值返回0
function showVal(value) {
    if ($.nui.isEmpty(value)) {
        value = 0;
    }
    return value;
}

// 处理旧数据保存报价
function initJgVal() {
    if ($.nui.isEmpty(CP_INFO['info']['jg_type']) || $.nui.isEmpty(CP_INFO['info']['jg_value'])) {
        CP_INFO['info']['jg_type'] = 'ys';
        CP_INFO['info']['jg_value'] = [];
    }
}

// 宝贝详情图片懒加载
// function lazyLoad() {
//     var $img = $('#bbxq_box .bbxq-img');
//     var $imgLen = CP_INFO['info']['bbxq'].split(',').length;
//     // 显示图片
//     function showImg() {
//         // 每个元素距离文档顶部的top值，从最后面一个元素开始检测
//         for (var i = $imgLen - 1; i >= 0; i--) {
//             // 元素距文档top值
//             var eleTop = $img.eq(i).offset().top;

//             // 文档滚动距离
//             var docScrollTop = $(document).scrollTop();

//             // 文档可视区高度
//             var winClientHeigth = $(window).height();

//             // 判断是不是在可视区内，是显示，不是不显示
//             if (eleTop < docScrollTop + winClientHeigth) {
//                 var resImg = $img.eq(i).find('img').data('lazy');
//                 $img.eq(i).find('img').attr('src', resImg)
//             }
//         }
//     }
//     showImg();
// }

// 显示价格
function showJg(info) {
    var jg_value = info['jg_value'];
    var xsdw_id = info['unit_options']['xsdw_id'];
    function getUnit(mark) {
        var unit = '';
        if (mark) {
            unit = $.nui.isTrue(getJjdw(info)) ? '/' + getJjdw(info) : '';
        } else {
            unit = $.nui.isTrue(getJjdw(info)) ? getJjdw(info) : '';
        }
        return unit;
    }
    if ($.nui.isEmpty(info['jg_type'])) {
        var html = [];
        html.push('<p class="type-null text-handle font-ls"><span class="font-lls">￥0</span><i class="font-ss">' + getUnit(true) + '</i></p>');
        $('.order-mi')
            .css({
                paddingBottom: '.5rem'
            })
            .html(html.join(''));
        return;
    }
    switch (info['jg_type']) {
        case '':
        case 'ys':
        case 'sl':
            if ($.nui.isEmpty(jg_value)) {
                var html = [];
                html.push('<p class="type-null text-handle font-ls"><span class="font-lls">￥0</span><i class="font-ss">' + getUnit(true) + '</i></p>');
                $('.order-mi')
                    .css({
                        paddingBottom: '.5rem'
                    })
                    .html(html.join(''));
                return;
            }
            break;
        // 没有default
    }

    switch (info['jg_type']) {
        case 'sl': // 按数量报价
            var jgValue = info['jg_value'];
            if ($.nui.isTrue(jgValue)) {
                var qdl = jgValue.every(function (item, idx, self) {
                    return !item.qdl;
                })
                var money = jgValue.every(function (item, idx, self) {
                    return !item.money;
                })

                if (qdl && money) { // 起订量和价格都是0
                    var html = [];
                    html.push('<p class="type-null text-handle font-ls"><span class="font-lls">￥0</span><i class="font-ss">' + getUnit(true) + '</i></p>');
                    $('.order-mi')
                        .css({
                            paddingBottom: '.5rem'
                        })
                        .html(html.join(''));
                    return;
                    break;
                } else {
                    var html = [];
                    html.push('<ul class="clear-space">');
                    var jgValLen = jgValue.length;

                    switch (jgValLen) {
                        case 1:
                            html.push('<li class="money-wrap li-one">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle ">￥</span>');

                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[0]['money']) + '</span>');
                            html.push('    </p>');

                            html.push('    <p class="font-ms qdl-count text-handle">' + showVal(jgValue[0]['qdl']) + getUnit(false) + '起批</p>');
                            html.push('</li>');
                            break;
                        case 2:
                            html.push('<li class="money-wrap li-one">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle ">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[0]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">' + showVal(jgValue[0]['qdl']) + getUnit(false) + '起批</p>');
                            html.push('</li>');
                            html.push('<li class="money-wrap li-one">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[1]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">≥' + showVal(jgValue[1]['qdl']) + getUnit(false) + '</p>');
                            html.push('</li>');
                            break;
                        case 3:
                            html.push('<li class="money-wrap li-three">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle ">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[0]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">' + showVal(jgValue[0]['qdl']) + getUnit(false) + '起批</p>');
                            html.push('</li>');
                            html.push('<li class="money-wrap li-three">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[1]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">' + showVal(jgValue[1]['qdl']) + '-' + showVal(jgValue[2]['qdl']) + getUnit(false) + '</p>');
                            html.push('</li>');
                            html.push('<li class="money-wrap li-three">');
                            html.push('    <p class="yby-color-red money-containe">');
                            html.push('        <span class="money-small overflow middle">￥</span>');
                            html.push('        <span class="money-big text-handle middle money-one-big">' + showVal(jgValue[2]['money']) + '</span>');
                            html.push('    </p>');
                            html.push('    <p class="font-ms qdl-count text-handle">≥' + showVal(jgValue[2]['qdl']) + getUnit(false) + '</p>');
                            html.push('</li>');
                            break;
                        // 没有default:
                    }
                    html.push('</ul>');
                    $('.order-mi')
                        .html(html.join(''))
                        .css({
                            paddingBottom: '.7rem'
                        });
                }
            }
            return;
            break;
        case 'ys':
            var jgValue = info['jg_value'];
            var jyArr = [];
            var dhArr = [];
            var cpYsArr = [];
            if ($.nui.isTrue(jgValue)) {
                $(jgValue).each(function (idx, item) {
                    if (item['cp_ys_bh'] !== '白坯#') {// && item['is_stop'] !== 1
                        jyArr.push(showVal(item['jy_bzj']));
                        dhArr.push(showVal(item['bz_bzj']));
                        cpYsArr.push(item);
                    }
                })
            }

            var maxJyj = Math.max.apply(null, jyArr);
            var minJyj = Math.min.apply(null, jyArr);
            var maxDhj = Math.max.apply(null, dhArr);
            var minDhj = Math.min.apply(null, dhArr);

            var jyjZero = jyArr.every(function (item, idx) { // 剪样都填0
                return item === 0;
            })
            var dhjZero = dhArr.every(function (item, idx) { // 大货都填0
                return item === 0;
            })

            if ($.nui.isEmpty(cpYsArr) || (jyjZero && dhjZero)) {
                var html = [];
                html.push('<p class="type-null text-handle font-ls">￥0' + getUnit(true) + '</p>');
                $('.order-mi')
                    .css({
                        paddingBottom: '.5rem'
                    })
                    .html(html.join(''));
                return;
            }

            if (cpYsArr.length > 1) { // 多个价格
                var html = [];
                html.push('<span class="jy yby-center mi-type jy-background middle jy-name">剪样</span>');

                if (minJyj === maxJyj) {
                    html.push('<span class="font-ss jy-money text-handle mi-jy middle">￥<i class="font-style-normal font-ms">' + maxJyj + '</i>' + getUnit(true) + '</span>');
                } else {
                    html.push('<span class="font-ss text-handle middle mi-jy yby-color-red">￥<i class="font-style-normal font-ms">' + minJyj + '</i>~<i class="font-style-normal font-ms">' + maxJyj + '</i>' + getUnit(true) + '</span>');
                }

                html.push('<span class="jy yby-center mi-type dh-background middle dh-name">大货</span>');
                if (minDhj === maxDhj) {
                    html.push('<span class="font-ss jy-money text-handle middle yby-color-red">￥<i class="font-style-normal font-ms">' + maxDhj + '</i>' + getUnit(true) + '</span>');
                } else {
                    html.push('<span class="font-ss text-handle middle yby-color-red">￥<i class="font-style-normal font-ms">' + minDhj + '</i>~<i class="font-style-normal font-ms">' + maxDhj + '</i>' + getUnit(true) + '</span>');
                }
                $('.order-mi')
                    .html(html.join(''))
                    .css({
                        paddingBottom: '.9rem',
                        fontStyle: 'normal'
                    })
                return;

            } else if (cpYsArr.length === 1) { // 单个价格
                var html = [];
                html.push('<span class="jy yby-center mi-type jy-background middle jy-name">剪样</span><span class="mi-jy font-ss jy-money text-handle mi-jy middle">￥<i class="font-style-normal font-ms">' + showVal(cpYsArr[0]['jy_bzj']) + '</i>' + getUnit(true) + '</span><span class="jy yby-center mi-type dh-background middle dh-name">大货</span><span class="font-ss jy-money text-handle mi-jy middle yby-color-red">￥<i class="font-style-normal font-ms">' + showVal(cpYsArr[0]['bz_bzj']) + '</i>' + getUnit(true) + '</span>');

                $('.order-mi').addClass('font-style-normal')
                    .html(html.join(''))
                    .css({
                        paddingBottom: '.9rem'
                    })
                return;
            }
            break;
        // 没有default:
    }
}

// 渲染宝贝详情图片
function showBbxqImg(data) {
    var html = [];
    for (var i = 0; i < data.length; i++) {
        var imgUrl = fun.getImgPath(data[i], true);
        html.push('<li class="clear-space bbxq-img">');
        html.push('    <img src="' + imgUrl + '" alt="" class="cp-img" data-lazy="' + imgUrl + '">'); // 暂时不给占位图
        html.push('</li>');
    }
    $('#bbxq_box').append(html.join(''));
}

// 初始化界面数据
function showData(data) {
    $('#bbxq_box').html('');
    var info = data['info'];

    // 产品主图
    if ($.nui.isTrue(info['imgs'])) {
        var html = [];
        var bbxqArr = info['imgs'].split(',');
        $('#swiper_wrapper').css({
            width: bbxqArr.length + '00%'
        })
        for (var i = 0; i < bbxqArr.length; i++) {
            var src = fun.getImgPath(bbxqArr[i], true);
            html.push('<li class="swiper-slide clear-space float-left" style="width: calc(100% / ' + bbxqArr.length + ')" data-index="' + i + '">');
            html.push('    <img src="' + src + '" alt="" class="product-img" large-url="">');
            html.push('</li>');
        }
        $('#swiper_wrapper').html(html.join(''));
        $('.product-img').css({
            width: '100%',
            height: '16rem',
            opacity: '1',
        })
    } else {
        $('#swiper_wrapper, #swiper_wrapper .swiper-slide').css({
            width: '100%'
        });
        var html = [];
        html.push('<li class="swiper-slide clear-space float-left">');
        html.push('    <img src="../img/logo.png" alt="" class="product-img" large-url="">');
        html.push('</li>');
        $('#swiper_wrapper').html(html.join(''));
    }

    // 宝贝详情
    if ($.nui.isTrue(info['bbxq'])) {
        showBbxqImg(fun.PagingData(bbxqImg, 5) || []);
    } else {
        $('#bbxq_box').html('');
    }

    $('#cp_bh_mc').text(info['number'] + ' ' + fun.is_value(info['name']));

    if (!IS_PAGE_EDIT) {
        $('#shanchu').hide();
    };

    showJg(info);

    $('#cp_lb').text(info['lb_mc'] || '');
    $('#cp_jd').text(fun.is_value(info['jd']));
    $('#cp_cf').text(info['component'] || '');
    if ($.nui.isEmpty(info['component'])) {
        $('#line_cf').hide();
    } else {
        $('#line_cf').show();
    }
    // getVisitCount(); // 获取今日游览人数

    if ($.nui.isTrue(data['goods_weight'])) {
        $('.width-KZ').show();
        $(data['goods_weight']).each(function (idx, item) {
            if (!!item['is_default']) {
                $('#kz_value').text(item['weight']);
                $('#fk_value').text(item['width']);
                return false;
            }
        });
    } else {
        $('#kz_value').text('');
        $('#fk_value').text('');
        $('.width-KZ').hide();
    }

    getLabel(info['label_id']);

    var hasStopCount = 0;
    $(data.goods_colour).each(function (idx, item) { // 颜色
        if (!item['is_stop']) {
            hasStopCount++;
        }
    })

    $('#has_stop').text(hasStopCount);
    $('#fzxx_jl').text(CP_INFO['merchant_assistant'].length); // 辅助信息（底卡信息）

    if (!Auth.check('cp_fzxx', 'view')) {
        $('#dk').hide();
    } else {
        $('#dk').show();
    }

    wxShowAuth(); // 网页的微信展示页权限判断显示

    if (CP_INFO['info']['is_sj']) {
        $('.hint').hide();
        $('.shangjia').val('下架');
    } else {
        if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) { // 有开通线上店铺
            $('.hint').show();
        }
        $('.product-details').addClass('old-out');
        $('.shangjia').val('上架');
    }


    if ($('#product_name_wrap').children('.product-status-icon').length) {
        $('#product_name_wrap').children('.product-status-icon').remove();
    }
    if(!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')){
        $('#product_name_wrap').append(shopView.showLabelIcon());
    }

    showSjXjStyle(); // 根据上下架条件显示宝贝详情样式
    authShow();

    if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) { // 有开通线上店铺
        if (!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')) { // 开通了线上店铺的免费版或vip版 || 开通了线上店铺的标准版及以后版本
            $('#share').show(); // 分享功能
            $('#dayin').show(); // 打印功能
            $('.cp-details,.product-details').show();
            // TODO等商城上线再开放
            // $('#visit').show()
            if (IS_PAGE_EDIT) {
                $('.shangjia,.bianji').show();
                $('.bianji,.shangjia').css('width', 'calc(50% - 0.75rem)');
                $('.bottom-space-evenly').removeClass('bottom-btn-wrap');
            } else {
                $('.bianji').show();
                $('.bianji').css('width', '92%');
                $('.bottom-space-evenly').addClass('bottom-btn-wrap');
            }

            if ($('.hint:visible').length === 1) {
                $('.product-details').css({
                    marginBottom: api.safeArea.bottom + $('.operation').outerHeight() + $('.hint').outerHeight()
                })
            } else if ($('.hint:visible').length === 0) {
                $('.product-details').css({
                    marginBottom: api.safeArea.bottom + $('.operation').outerHeight()
                })
            }
        } else if (!AuthVersionCheck.checkHide('aisc')) {
            //请求web商城设置有设置：AI商城的XX参数
            $.ajax({
                type: "GET",
                async: false,
                url: AJAX_URL.companies + '/' + fun.getItem('company_info')['company_id'] +'?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'],
                headers: {
                    "X-Requested-With": "XMLHttpRequest",
                    "Accept": "application/json"
                },
                success:function(res){
                    if($.nui.isTrue(res['company']['wechat_setting']['miniprogram_app_id']) && $.nui.isTrue(res['company']['wechat_setting']['miniprogram_app_secret'])){
                        $('#share').show(); // 分享功能
                    } else {
                        if (!AuthVersionCheck.checkHide('cpdy')) { // 非免费版本显示打印按钮
                            $('#dayin').show(); // 打印功能
                        }
                        $('#dk').css('margin-bottom', '3.1rem')
                    }
                },
                error:function(){
                    if (!AuthVersionCheck.checkHide('cpdy')) { // 非免费版本显示打印按钮
                        $('#dayin').show(); // 打印功能
                    }
                    $('#dk').css('margin-bottom', '3.1rem')
                }
            })
        } else {
            $('.bianji').show();
            $('.bianji').css('width', '92%');
            $('.bottom-space-evenly').addClass('bottom-btn-wrap');
            $('#dk').css({
                marginBottom: api.safeArea.bottom + $('.operation').outerHeight()
            })
        }
    } else {
        if (!AuthVersionCheck.checkHide('cpdy')) { // 非免费版本显示打印按钮
            $('#dayin').show(); // 打印功能
        }
        $('.bianji').show();
        $('.bianji').css('width', '92%');
        $('.bottom-space-evenly').addClass('bottom-btn-wrap');
        $('#dk').css({
            marginBottom: api.safeArea.bottom + $('.operation').outerHeight()
        })
    }

    //iphoneX适应
    $('.bottom-space-evenly').css('padding-bottom', api.safeArea.bottom);
    if(!$('.operation:hidden').length){
        $('.hint').css({
            bottom: $('.operation').outerHeight()
        })
    }

    fun.hideShade();
}

// 显示上架新产品图标
function showNewIcon() {
    var nowDate = new Date().getTime(); // 当前时间
    var sj_sj = Date.parse((CP_INFO['info']['sj_sj'].replace(/-/g, '/'))); // 上架时间
    var minus = fun.toNumber(getOffsetDays(nowDate, sj_sj)); // 相隔的差值
    if (minus <= 30) { // 新产品
        if(!AuthVersionCheck.checkHide('xsdp') || !AuthVersionCheck.checkHide('aisc')){
            showIcon(true);
        }else{
            showIcon(false);
        }
    }
}

// 显示new图标
function showIcon(mark) {
    if (mark) {
        $('#new').css({
            opacity: 1,
            visibility: 'visible'
        })
    } else {
        $('#new').css({
            opacity: 0,
            visibility: 'hidden'
        })
    }
}

// 获取今日游览人数
function getVisitCount() {
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        url: AJAX_URL['countEveryDayViewInfo'],
        data: {
            cp_id: page_data['goods_id']
        },
        success: function (res) {
            if (res['status'] === 0) {
                console.log('游览人数');
                console.log(res);
                $('#people').text(res['data']['today_count_data']['people_count'] || 0);
                // $('#people').text();
            }
        }
    })
}

// 判断页面修改权限显示隐藏编辑和上下架按钮
function authShow() {
    if (!IS_PAGE_EDIT) { // 没有页面修改权限，不显示这一行
        $('.operation').hide();
        $('.hint').css({
            bottom: 0
        })
        if (CP_INFO['info']['is_sj']) {
            $('.product-details').css({
                marginBottom: 0
            })
        } else {
            $('.product-details').css({
                marginBottom: $('.hint').outerHeight() + api.safeArea.bottom
            })
        }
    }
}

//获取产品标签
function getLabel(arr, callback) {
    label_arr = arr;
    var lar = label_arr.split(',') || [];
    var tmp = new Array();
    for (var i = 0; i < lar.length; i++) {
        tmp[i] = Number(lar[i]);
    }
    lar = tmp;
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getLabelList,
        data: {
            "type": 'cp',
        },
        success: function (res) {
            if (res['status'] != 0) return fun.toast('获取标签失败。');
            var info_list = res.data;
            var html = [];
            if ($.nui.isTrue(info_list)) {
                $('.special').css({
                    marginTop: '.6rem'
                });
                $('.order_list').css({
                    paddingBottom: '.5rem'
                })
            }

            for (var j = 0; j < lar.length; j++) {
                for (var i = 0; i < info_list.length; i++) {
                    var val = info_list[i];
                    if (lar[j] == val['id']) {
                        html.push('<span data-list=\'' + (fun.formatString(JSON.stringify(val))) + '\' class="font-ms label" style="background:' + val['colour'] + '">' + val['name'] + '</span>');
                    }
                }
            }


            $(".special").html(html.join(''));
            if (typeof callback === 'function') callback();
        }
    });
}

// 删除当前产品
function delGoods(params) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveGoods,
        data: $.extend({}, {
            "save_type": "delete",
            "id": params['id']
        }, params),
        success: function (res) {
            console.log(res);
            switch (res['status']) {
                case 0:
                    fun.toast('删除成功。');
                    fun.pageCloseFun({
                        refresh: true
                    });
                    document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                    break;
                case 103:
                    var proName = CP_INFO['info']['name'] ? CP_INFO['info']['number'] + ' ' + CP_INFO['info']['name'] : CP_INFO['info']['number'];
                    fun.dialog({
                        content: '【' + proName + '】已被调用，不允许删除。如果该产品没有在经营，您可以使用：停用功能。',
                        btn: ['转为停用状态', '我知道了'],
                        yes: function () {
                            fun.ajax({
                                showLoad: true,
                                hideLoad: true,
                                url: AJAX_URL.saveGoods,
                                data: {
                                    "save_type": "delete",
                                    "is_has": true,
                                    "id": (params["id"] || [0]),
                                },
                                success: function (res) {
                                    if (res['status'] == 0) {
                                        fun.toast('修改成功。');
                                        fun.pageCloseFun({
                                            refresh: true
                                        });
                                        document.body.removeEventListener('touchmove', preventDefault, { passive: false })
                                    }
                                }
                            })
                        },
                        no: function () {
                            document.body.removeEventListener('touchmove', preventDefault, { passive: false });
                        }
                    });
                    break;
                default:
                    fun.toast('删除失败。');
            }
        }
    })
}

// 页面初始化
function init() {
    // 以防安卓系统点击input绝对定位不兼容问题
    fun.keyboardEject('.tool');
    fun.keyboardEject('.triangle');
    fun.showShade();

    getList();
    bindEvent(); // 初始化事件

    // 图片可左右滑动
    swiper = new Swiper('.swiper-container', {
        initialSlide: 0,
        centeredSlides: true,
        observer: true,
        observeParents: true,
    });
}

// 关闭当前窗口
function closeWin() {
    // api.sendEvent({
    //     name: return_page 
    //     extra: {

    //     }
    // });
    setTimeout(function () {
        api.closeWin({
            name: return_page
        })
    }, 200)
}

//  图片预览
function previewImg(showImgList) {

    if ($.nui.isEmpty(showImgList)) {
        return;
    }
    var index = $(this).data('index'); // 大图预览显示张数
    var img_arr = [];

    var large_arr = showImgList.split(',');
    for (var i = 0; i < large_arr.length; i++) {
        var item = large_arr[i];
        img_arr[i] = fun.getImgPath(item, true);
    }

    if ($.nui.isEmpty(img_arr)) return;
    photoBrowser.open({
        images: img_arr,
        activeIndex: index,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        if (ret) {
            if (ret['eventType'] == 'click') {
                swiper = new Swiper('.swiper-container', {
                    initialSlide: ret.index,
                    centeredSlides: true,
                    observer: true,
                    observeParents: true,
                    preventClicks: true, // 滑动时禁止点击事件
                });
                photoBrowser.close();
            }
        } else { }
    });
}

// 事件初始化
function bindEvent() {
    // 点击图片可预览图片
    $('body').on('tap', '.swiper-slide', function (e) {
        e.stopPropagation();
        e.preventDefault();
        previewImg.call(this, CP_INFO['info']['imgs']);
    });

    // // 宝贝详情大图预览
    // $('body').on('tap', '#bbxq_img', function () {
    //     previewImg(CP_INFO['info']['bbxq']);
    // });

    // 设置顶部工具动画效果
    $(window).on('scroll', function () {
        // document.body.removeEventListener('touchmove', preventDefault, { passive: false });
        var topp = $(document).scrollTop();
        $('.triangle-tool').hide();
        if (topp > 250) {
            $('.tool').css({
                'animation': 'scroll250 0.4s ease-in forwards'
            })
        } else if (topp < 250 && topp > 150) {
            $('.tool').css({
                'animation': 'scroll150 0.4s ease-in forwards'
            })
        } else if (topp === 0) {
            $('.tool').css({
                'animation': 'scroll0 0.4s ease-in forwards'
            })
        }
    })

    // $(window).on('scroll', fun.throttle(lazyLoad, 200)); // 图片懒加载

    // 设置点击更多出现打印和删除功能
    $('body').on('tap', '.more-iconfont', function (e) {
        // document.body.addEventListener('touchmove', preventDefault, { passive: false });
        e.stopPropagation();
        e.preventDefault();
        $('.triangle-tool').toggle();
    })

    // 删除当前产品
    $('body').on('tap', '#shanchu', function (e) {
        e.stopPropagation();
        e.preventDefault();
        $('.triangle-tool').hide();
        var deleteMsg = CP_INFO['info']['name'] ? CP_INFO['info']['number'] + ' ' + CP_INFO['info']['name'] : CP_INFO['info']['number'];
        e.preventDefault();
        fun.dialog({
            content: '你确定要删除【' + deleteMsg + '】吗？',
            btn: ['确定', '取消'],
            success: function () {
                document.body.addEventListener('touchmove', preventDefault, { passive: false });
            },
            yes: function () {
                delGoods({
                    id: [page_data['goods_id']]
                });
                $('.triangle-tool').hide();
            },
            no: function () {
                $('.triangle-tool').hide();
                document.body.removeEventListener('touchmove', preventDefault, { passive: false });
            }
        });
        return false;
    });

    // 上架下架功能
    $('body').on('tap', '.shangjia', fun.throttle(function () {
        var cp_lx = [];
        var type = CP_INFO['info']['cp_lx'];
        // 产品类型兼容
        type = fun.compatGoodsType(type);

        cp_lx.push(type);
        if (!!CP_INFO['info']['is_sj']) { // 上架了，显示下架字眼，点击后，淡出提示，下架成功
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.saveGoods,
                data: {
                    id: [page_data['goods_id']],
                    save_type: 'state',
                    type: 'sj',
                    is_sj: 0,
                    cp_lx: cp_lx || [],
                },
                success: function (res) {
                    if (res['status'] === 0) {
                        fun.toast('下架成功！');
                        $('.hint').show();
                        CP_INFO['info']['is_sj'] = 0;
                        $('.shangjia').val('上架');
                        showSjXjStyle();

                        api.sendEvent({
                            name: return_page,
                            extra: {
                                status: 'refresh'
                            }
                        });
                        hasChangeClick = true;
                    }
                }
            });
        } else { // 下架了，显示上架字眼，点击后，淡出提示，上架成功
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.saveGoods,
                data: {
                    id: [page_data['goods_id']],
                    save_type: 'state',
                    sj_sj: fun.dateFormat('yyyy-MM-dd'),
                    type: 'sj',
                    is_sj: 1,
                    cp_lx: cp_lx || [],
                },
                success: function (res) {
                    if (res['status'] !== 0) return fun.toast(res['msg']);
                    if (res['status'] === 0) {
                        fun.toast('上架成功！');
                        CP_INFO['info']['sj_sj'] = fun.dateFormat('yyyy-MM-dd hh:mm', new Date());
                        $('.hint').hide();
                        $('.shangjia').val('下架');
                        showSjXjStyle();
                        api.sendEvent({
                            name: return_page,
                            extra: {
                                status: 'refresh'
                            }
                        });
                        hasChangeClick = true;
                    }
                }
            });
        }
    }, 300))

    // 颜色功能
    $('body').on('tap', '#color-edit', function () {
        fun.showLoad();
        $(CP_INFO['goods_colour']).each(function (_index, item) {
            item['_index'] = _index;
        })
        fun.showPageFull({
            page_url: page_arr.shop_cp_ys_bj,
            pageParam: {
                data: CP_INFO['goods_colour'],
                return_page: html_name,
                page_type: 'shop_cp_ys_bj',
                id: page_data['goods_id'],
                count_data: CP_INFO,
                type: 'product_view',
            }
        });
        fun.hideLoad();
    })

    // 返回
    $('#header_back').on('tap', function () {
        isDataChange();
    })

    // 打印界面
    $('#dayin').on('tap', function (e) {
        document.body.addEventListener('touchmove', preventDefault, { passive: false });
        $('.triangle-tool').hide();
        e.stopPropagation();
        e.preventDefault();
        search_data['cp_id'] = page_data['goods_id'];
        layer.closeAll();
        Print.printLoad({ printType: 'cp' });
        // $('.triangle-tool').hide();
    })

    // 底卡功能
    $('body').on('tap', '.bottom-card', function () {
        if (!IS_PAGE_EDIT && !CP_INFO['merchant_assistant'].length) return;
        fun.showLoad();
        var main_isTure = {     //判断该类型是否开启主要功能，给底卡编辑做记忆功能用
            'gys_isTure': 0,
        };
        if ($.nui.isEmpty(CP_INFO['merchant_assistant'])) {
            fun.showPageFull({
                page_url: page_arr.shop_dk_bj,
                pageParam: {
                    return_page: html_name,
                    page_type: 'shop_dk_bj',
                    type: 'add',
                    main_isTure: main_isTure,
                    color: CP_INFO['goods_colour'],
                    dw: getJjdw(CP_INFO['info']),
                    count_data: CP_INFO,
                    page_type: 'product_view_empty',
                    jjdw_id: getUnitId()
                }
            })

        } else {
            fun.showPageFull({
                page_url: page_arr.shop_dk_xx,
                pageParam: {
                    id: page_data['goods_id'],
                    return_page: html_name,
                    page_type: 'shop_dk_xx',
                    merchant_assistant: CP_INFO['merchant_assistant'],
                    color: CP_INFO['goods_colour'],
                    dw: getJjdw(CP_INFO['info']),
                    data: CP_INFO,
                    type: 'product_view',
                    jjdw_id: getUnitId()
                }
            })
        }
        fun.hideLoad();
    })

    // 游览人数功能（访客分析）
    $('body').on('tap', '#visit', function () {
        fun.showLoad();
        fun.showPageFull({
            page_url: page_arr['shop_dp_fkfx'],
            pageParam: {
                return_page: html_name,
            }
        })
        fun.hideLoad();
    })

    // 图片分享
    $('#share').on('tap', function () {
        if ($.nui.isEmpty(CP_INFO['info']['imgs'])) return fun.toast('该产品没有上传图片，无法分享！');
        fun.showLoad();
        var temp = JSON.parse(JSON.stringify(CP_INFO['info']));
        var xsdw_id = temp['unit_options']['xsdw_id'];
        temp['xsdw_name'] = fun.getValByKey(fun.getItem('jjdw_list'), Number(xsdw_id), 'name'); // 计价单位

        if ($.nui.isTrue(CP_INFO['goods_weight'])) {
            $(CP_INFO['goods_weight']).each(function (idx, item) {
                if (item['is_default']) {
                    temp['width'] = item['width']; // 幅宽
                    temp['weight'] = item['weight']; // 克重
                    temp['fk_dw'] = item['fk_dw']; // 幅宽单位
                    temp['kz_dw'] = item['kz_dw']; // 克重单位
                }
            })
        } else {
            temp['width'] = ''; // 幅宽
            temp['weight'] = ''; // 克重
            temp['fk_dw'] = ''; // 幅宽单位
            temp['kz_dw'] = ''; // 克重单位
        }

        $.ajax({  //转化成测试服务器那边的产品id
            type: "GET",
            headers: {
                "X-Requested-With": "XMLHttpRequest",
                "Accept": "application/json"
            },
            url: AJAX_URL.adminGoods + temp['id'] + '?app_token='+ fun.getItem('token') +'&company_id='+ fun.getItem('company_info')['company_id'],
            success: function (res) {
                fun.showPageFull({
                    page_url: page_arr['share_newpictures'],
                    pageParam: {
                        data: temp,
                        good_id: res['id']
                    }
                })
            },
            error:function(){
                fun.toast('该产品已停用或产品未上架！');
            }
        })
        fun.hideLoad();
    })

    // 编辑
    $('.bianji').on('tap', function () {
        //if ($.nui.isObjEquals(_origin_data, getSaveData())) { // 数据没发生改变
        fun.showLoad();
        setTimeout(function () {
            fun.showPageFull({
                page_url: page_arr.shop_product_compile,
                pageParam: {
                    return_page: html_name,
                    id: page_data['goods_id']
                }
            });
            return fun.hideLoad();
        }, 200);
        // } else {
        //     function edit() {
        //         fun.showPageFull({
        //             page_url: page_arr.shop_product_compile,
        //             pageParam: {
        //                 return_page: html_name,
        //                 id: page_data['goods_id']
        //             }
        //         });
        //     }
        //     saveData(edit);
        // }
    })
}

// 防止没图片，数组里还有存在 '' 和 "" 和 null
function imgFormat(save_data, name) {
    var tempArr = [];
    $(save_data[name]).each(function (idx, item) {
        if ($.nui.isTrue(item)) {
            tempArr.push(item);
        }
    })
    return tempArr;
}

// 拿到保存数据
function getSaveData() {
    var info = CP_INFO['info'];
    // $(CP_INFO['goods_colour']).each(function (idx, item) {
    //     item['imgs'] = $.isArray(item['imgs']) ? item['imgs'] : [item['imgs']];
    // })

    if (info['unit_options'] && (typeof info['unit_options'] === 'string')) {
        info['unit_options'] = JSON.parse(info['unit_options']);
    }

    var jgValue = typeof info['jg_value'] === 'object' ? JSON.stringify(info['jg_value']) : info['jg_value'];

    var save_data = {
        save_type: 'save',
        id: info['id'],
        date: info['date'], // 时间
        number: info['number'], // 编号
        name: info['name'], // 名称
        unit_id: info['unit_id'], // 单位id
        component: info['component'], // 成分
        type: info['type'] === '坯布' ? 'pb' : 'cp', // 类型
        diff: info['diff'], // 空差模式
        imgs: [], // 主图
        color_card: [], // 色卡
        bbxq: [], // 宝贝详情图
        unit_options: info['unit_options'],
        class_id: info['class_id'],
        remark: info['remark'], // 备注
        label_id: info['label_id'], // 标签id
        is_stop: info['is_stop'], // 是否停用
        is_sj: CP_INFO['info']['is_sj'], // 是否上架
        craft: info['craft'], // 工艺
        gauze: info['gauze'], // 纱布
        density: info['density'], // 门店
        quarter: info['quarter'], // 季度

        jg_type: info['jg_type'], // 价格类型
        jg_value: jgValue, // 价格数据

        goods_colour: [], // 产品颜色
        goods_width_weight: CP_INFO['goods_weight'], // 幅宽克重
        delete_width_weight: [], // 删除的付款克重
        goods_spec: CP_INFO['goods_spec'], // 规格
        merchant_assistant: [], // 底卡信息
        goods_machining: CP_INFO['goods_machining'], // 加工
        goods_craft: CP_INFO['goods_craft'], // 工艺
        goods_param: CP_INFO['param'], // 其他参数
        delete_spec: [], // 删除的规格
        delete_colour: delete_list['colour_arr'], // 删除的产品颜色
        delete_material: [],
        delete_merchant_assistant: delete_list['fzxx_arr'], // 删除的底卡信息
        delete_colour_assistant: delete_list['fzxx_colouArr'] || [], //删除的底卡颜色信息
        delete_machining: [],
        delete_converter: [],
        delete_process: [],
        delete_craft: [], // 删除工艺
    };

    // 处理图片产生的空格
    save_data['imgs'] = imgFormat(save_data, 'imgs');
    save_data['bbxq'] = imgFormat(save_data, 'bbxq');
    save_data['color_card'] = imgFormat(save_data, 'color_card');

    $(CP_INFO['goods_colour']).each(function (idx, item) {
        // var tempArr = []
        // $(item['imgs']).each(function (sec, o) {
        //     if (o !== '' && o !== "" && o !== null) {
        //         tempArr.push(o);
        //     }
        // })
        // item['imgs'] = tempArr;
    })

    $(CP_INFO['merchant_assistant']).each(function (idx, item) {
        if (!('id' in item)) {
            item['id'] = 0;
        }
    })
    //字符串转数组
    $(CP_INFO['merchant_assistant']).each(function (idx, item) {
        if (!($.nui.isEmpty(item['imgs']))) {
            if (!($.isArray(item['imgs']))) {
                var imgs = item['imgs'];
                if (imgs.indexOf(',') > -1) {
                    item['imgs'] = imgs.split(',');
                } else {
                    if ($.nui.isEmpty(item['imgs'])) {
                        item['imgs'] = [];
                    } else {
                        var imgs_arr = [];
                        imgs_arr[0] = item['imgs'];
                        item['imgs'] = imgs_arr;
                    }
                }
            }
        } else {
            item['imgs'] = [];
        }
    })

    save_data['goods_colour'] = CP_INFO['goods_colour'];
    save_data['merchant_assistant'] = CP_INFO['merchant_assistant'];
    return save_data;
}

// 显示
function showSjXjStyle() {
    if ($.nui.isTrue(CP_INFO['info']['is_sj'])) { // 上架
        if ($.nui.isTrue(CP_INFO['info']['bbxq'])) { // 宝贝详情有图
            $('.product-details').css({
                marginBottom: $('.operation').outerHeight()
            })
        } else { // 没图
            $('.product-details').css({
                marginBottom: $.nui.decimalDiv($('.operation').outerHeight(), parseFloat($('html').css('fontSize'))) + 0.2 + 'rem'
            })
        }
    } else { // 下架显示样式
        $('.product-details').css({
            marginBottom: $.nui.decimalAdd($('.operation').outerHeight(), $('.hint').outerHeight()) // 这一步有问题
        })
    }
}

// 当前产品是否是新产品
function getOffsetDays(time1, time2) {
    var offsetTime = $.nui.decimalSub(time1, time2); // 相差时间
    return Math.floor(offsetTime / fun.getDateTimestamp());
}