var html_name = page_arr.shop_store_dd;
var flag = true;
var page = 1;
var search_data = {
    order_type: [],
    delivery_type: [],
    from: [],          //终端
    status: [],        //分组
    begin_time: '',    //开始时间
    end_time: '',      //结束时间
    // search: '',     //搜索内容
    // user_id: '',    //粉丝
    // trade_no: '',   //单号
};
var page_list = [],
    to_month = fun.getMonthArr(1)[0],
    search_storage = {
        "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd')
    },
    //重置恢复的时间
    reset = {
        "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd')
    };
var _ddlx = html_name + '_ddlx_';
var _thfs = html_name + '_thfs_';
var _zd = html_name + '_zd_';
/*****头部******/
$('#header').header({
    back: false,
    filter: true,
    title: '商城订单',
    foot_input: {
        show: true,
        plader: '搜索产品'
    },
})
page_init = function () {
    fun.setHeaderLocation('.content');//解决ios头部定位失效
    if (!AuthVersionCheck.checkHide('xsdp') && !AuthVersionCheck.checkHide('aisc')) {
        search_storage = $.extend(true, {
            "ddlx": {
                sk: fun.getItem(_ddlx + 'sk', 1),
                jy: fun.getItem(_ddlx + 'jy', 1),
                dh: fun.getItem(_ddlx + 'dh', 1),
            },
            "thfs": {
                zt: fun.getItem(_thfs + 'zt', 1),
                yj: fun.getItem(_thfs + 'yj', 1),
            },
            "zd": {
                aishop: fun.getItem(_zd + 'aishop', 1),
                mall: fun.getItem(_zd + 'mall', 1),
            },
            'ddlx_text': fun.getItem(_ddlx + 'text', ''),
            'thfs_text': fun.getItem(_thfs + 'text', ''),
            'zd_text': fun.getItem(_zd + 'text', ''),
        }, search_storage);
        search_data['from'] = fun.getItem(_zd + 'from', ['aishop', 'mall']);
    } else {
        search_storage = $.extend(true, {
            "ddlx": {
                sk: fun.getItem(_ddlx + 'sk', 1),
                jy: fun.getItem(_ddlx + 'jy', 1),
                dh: fun.getItem(_ddlx + 'dh', 1),
            },
            "thfs": {
                zt: fun.getItem(_thfs + 'zt', 1),
                yj: fun.getItem(_thfs + 'yj', 1),
            },
            'ddlx_text': fun.getItem(_ddlx + 'text', ''),
            'thfs_text': fun.getItem(_thfs + 'text', '')
        }, search_storage);
    }
    search_data['begin_time'] = fun.Date(to_month['begin_date']).Format('yy-mm-dd');
    search_data['end_time'] = fun.Date(to_month['end_date']).Format('yy-mm-dd');
    search_data['order_type'] = fun.getItem(_ddlx + 'type', ['sk', 'jy', 'dh']);
    search_data['delivery_type'] = fun.getItem(_ddlx + 'delivery_type', ['yj', 'zt']);

    //search_data = $.extend({}, search_data, search_storage);

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var data = ret['value']['data'];
        page = 1;
        switch (ret['value']['status']) {
            case 'search': // 搜索
                search(data);
                break;
            case 'reset': // 重置
                resetHandle();
                break;
            case 'refresh': // 刷新
                refresh();
        }
    })
    $('.card').empty();
    getList();
    bindEvent();

    api.setRefreshHeaderInfo({
        bgColor: '#3c3c3c',
        textColor: '#fff',
        textDown: '下拉刷新.',
        textUp: '松开刷新',
        loadingImg: 'widget://img/update.png'
    }, function (ret, err) {
        api.refreshHeaderLoadDone();
        page_list = [];
        $('.card').empty();
        page = 1;
        getList(page);
    });

    // fun.scrollToBottom({}, function () {
    //     if (page_list.length > 0) {
    //         showList(fun.PagingData(page_list) || [])
    //     } else {
    //         fun.createBottomLine('card', '')
    //     }
    // })

    fun.scrollToBottom({}, function () {
        if ($.nui.isTrue(page_list)) {
            showList(fun.PagingData(page_list, 5));
        } else if (flag) {
            getList(page++)
        }
    })
}

// 刷新处理
function refresh() {
    page_list = [];
    $('.card').empty();
    page = 1;
    getList(page);
}

// 重置处理
function resetHandle() {
    search_data['begin_time'] = fun.Date(to_month['begin_date']).Format('yy-mm-dd');
    search_data['end_time'] = fun.Date(to_month['end_date']).Format('yy-mm-dd');
    search_data['trade_no'] = '';
    search_data['user_id'] = '';
    search_storage['begin_date'] = fun.Date(to_month['begin_date']).Format('yy-mm-dd');
    search_storage['end_date'] = fun.Date(to_month['end_date']).Format('yy-mm-dd');
    search_storage['fans_mc'] = '';
    search_storage['trade_no'] = '';
    search_storage['user_id'] = '';
    refresh();
}

// 搜索处理
function search(data) {
    fun.setItem(html_name + 'sideslip', true)
    //筛选记忆功能
    if ($.nui.isEmpty(data['hz']['text'])) {
        data['hz'] = {
            'choose': {
                'dh': 1,
                'jy': 1,
                'sk': 1,
            },
            'group': 'sk,jy,dh',
            'text': '色卡、剪样、大货'
        }
    }
    if ($.nui.isEmpty(data['thfs']['text'])) {
        data['thfs'] = {
            'choose': {
                'yj': 1,
                'zt': 1,
            },
            'group': 'yj,zt',
            'text': '邮寄、自提'
        }
    }
    if (!AuthVersionCheck.checkHide('xsdp') && !AuthVersionCheck.checkHide('aisc')) {
        if ($.nui.isEmpty(data['zd']['text'])) {
            data['zd'] = {
                'choose': {
                    'aishop': 1,
                    'mall': 1,
                },
                'group': 'aishop,mall',
                'text': 'AI商城、线上店铺'
            }
        }
    }
    search_storage['begin_date'] = data['begin_date'];
    search_storage['end_date'] = data['end_date'];
    search_storage['trade_no'] = data['dd_dh']['value'];
    search_storage['fans_mc'] = data['fans']['text'];
    search_storage['user_id'] = data['fans']['id'];
    search_storage['ddlx'] = {};
    search_storage['thfs'] = {};
    search_storage['ddlx'] = data['hz']['choose'];
    search_storage['thfs'] = data['thfs']['choose'];
    if (!AuthVersionCheck.checkHide('xsdp') && !AuthVersionCheck.checkHide('aisc')) {
        search_storage['zd'] = {};
        search_storage['zd'] = data['zd']['choose'];
        search_storage['zd_text'] = data['zd']['text'];
    }
    search_storage['ddlx_text'] = data['hz']['text'];
    search_storage['thfs_text'] = data['thfs']['text'];

    //请求数据
    search_data['begin_time'] = data['begin_date'];
    search_data['end_time'] = data['end_date'];
    search_data['trade_no'] = data['dd_dh']['value'];
    search_data['user_id'] = data['fans']['id'];

    if (!!data['hz']['group']) {
        search_data['order_type'] = data['hz']['group'].split(',');
    } else {
        search_data['order_type'] = [];
    }

    if (!!data['thfs']['group']) {
        search_data['delivery_type'] = data['thfs']['group'].split(',');
    } else {
        search_data['delivery_type'] = [];
    }

    if (!AuthVersionCheck.checkHide('xsdp') && !AuthVersionCheck.checkHide('aisc')) {
        if (!!data['zd']['group']) {
            search_data['from'] = data['zd']['group'].split(',');
        } else {
            search_data['from'] = [];
        }
    }

    //缓存数据记忆功能
    var ddlx = data['hz']['choose'];
    var thfx = data['thfs']['choose'];

    fun.setItem(_ddlx + 'sk', ddlx['sk']);
    fun.setItem(_ddlx + 'jy', ddlx['jy']);
    fun.setItem(_ddlx + 'dh', ddlx['dh']);
    fun.setItem(_ddlx + 'type', search_data['order_type']);
    fun.setItem(_ddlx + 'text', data['hz']['text']);
    fun.setItem(_thfs + 'zt', thfx['zt']);
    fun.setItem(_thfs + 'yj', thfx['yj']);
    fun.setItem(_thfs + 'text', data['thfs']['text']);
    fun.setItem(_ddlx + 'delivery_type', search_data['delivery_type']);
    if (!AuthVersionCheck.checkHide('xsdp') && !AuthVersionCheck.checkHide('aisc')) {
        var zd = data['zd']['choose'];
        fun.setItem(_zd + 'aishop', zd['aishop']);
        fun.setItem(_zd + 'mall', zd['mall']);
        fun.setItem(_zd + 'text', data['zd']['text']);
    }
    fun.setItem(_ddlx + 'from', search_data['from']);
    page_list = [];
    $('.card').empty();
    page = 1;
    getList(page);
}

//订单信息
function getList(page) {
    fun.showLoad();
    //时间调整
    search_data = JSON.stringify(search_data)
    search_data = search_data.replace(/begin_time/g, "start_date");
    search_data = search_data.replace(/end_time/g, "end_date");
    search_data = search_data.replace(/delivery_type/g, "delivery_method");  //提货方式字段名更改
    search_data = search_data.replace(/status/g, "group");  //分组字段名更改
    search_data = JSON.parse(search_data)
    //提货方式调整
    if (search_data['delivery_method'].length === 2) {
        search_data['delivery_method'][0] = 1;
        search_data['delivery_method'][1] = 2;
    } else if (search_data['delivery_method'].length === 1) {
        if (search_data['delivery_method'][0] === 'yj' || search_data['delivery_method'][0] == 1) {
            search_data['delivery_method'][0] = 1;
        } else {
            search_data['delivery_method'][0] = 2;
        }
    } else {
        delete search_data.delivery_method;
    }

    //订单类型
    if (!search_data['order_type']) {
        delete search_data.order_type;
    } else if (search_data['order_type'].length === 3) {
        search_data['order_type'][0] = 'card';
        search_data['order_type'][1] = 'cutting';
        search_data['order_type'][2] = 'normal';
    } else if (search_data['order_type'].length === 2) {
        $(search_data['order_type']).each(function (idx, item) {
            if (search_data['order_type'][idx] === 'sk' || search_data['order_type'][idx] === 'card') {
                search_data['order_type'][idx] = 'card';
            } else if (search_data['order_type'][idx] === 'jy' || search_data['order_type'][idx] === 'cutting') {
                search_data['order_type'][idx] = 'cutting';
            } else {
                search_data['order_type'][idx] = 'normal';
            }
        })
    } else {
        if (search_data['order_type'][0] === 'sk' || search_data['order_type'][0] === 'card') {
            search_data['order_type'][0] = 'card';
        } else if (search_data['order_type'][0] === 'jy' || search_data['order_type'][0] === 'cutting') {
            search_data['order_type'][0] = 'cutting';
        } else {
            search_data['order_type'][0] = 'normal';
        }
    }
    //分组
    if (search_data['group'].length === 0) {
        search_data['group'][0] = 'all';
    }
    search_data['group'] = search_data['group'].toString();
    //来自
    // 根据版本显示终端的内容
    if (!AuthVersionCheck.checkHide('xsdp') && !AuthVersionCheck.checkHide('aisc')) {
        if (!search_data['from']) {
            if (search_data['from'].length === 0) {
                delete search_data['from'];
            }
        }
    } else if (!AuthVersionCheck.checkHide('xsdp')) {
        search_data['from'] = ['mall'];
    } else if (!AuthVersionCheck.checkHide('aisc')) {
        search_data['from'] = ['aishop'];
    }
    //搜索内容
    if (!search_data['search']) {
        delete search_data['search'];
    }
    //单号
    if (!search_data['trade_no']) {
        delete search_data['trade_no'];
    }
    //粉丝
    if (!search_data['user_id']) {
        delete search_data['user_id'];
    }
    if ($.nui.isTrue(page)) {
        //传递页数
        search_data.page = page;
    }

    $.ajax({
        type: "GET",
        headers: {
            "X-Requested-With": "XMLHttpRequest",
            "Accept": "application/json"
        },
        // url: AJAX_URL.getShopOrderList,
        url: AJAX_URL.Orders + '?app_token=' + fun.getItem('token') + '&company_id=' + fun.getItem('company_info')['company_id'] + '&account_id=' + fun.getItem('account_info')['account_id'] + '',
        data: search_data,
        success: function (res) {
            // if (res['status'] === 0) {
            if (res['data'].length < 1) {
                $('.card').hide()
                $('.no-info').show()
                $('html,body').css('backgroundColor', '#f7f7f7')
                return;
            }
            $('.card').show()
            $('.no-info').hide()
            $('html,body').css({ 'backgroundColor': '#f7f7f7' })

            var data_length = res['data'];
            for (var i = 0; i < data_length.length; i++) {
                // if (data_length[i]['order_info']['type'] != 'sk') {
                if (data_length[i]['order_type'] != 'card') {
                    var jl = [];
                    var tmp = {};
                    var reservecp_key = '';

                    // for (var n = 0; n < res['data'][i]['order_info']['jl'].length; n++) {
                    //     var jl_length = res['data'][i]['order_info']['jl'];
                    for (var n = 0; n < data_length[i]['order_items'].length; n++) {
                        var jl_length = data_length[i]['order_items'];
                        var cp_info = jl_length[n]
                        // var cp_key = cp_info['goods_id'] + '_' + cp_info['cp_bh'];
                        var cp_key = cp_info['goods_id'] + '_' + cp_info['goods_number'];

                        if (!tmp[cp_key]) {
                            tmp[cp_key] = {
                                count: 0,
                                zsl: 0,
                                zje: 0,
                                cp_bh: cp_info['goods_number'],
                                cp_jjdw: cp_info['unit_name'],
                                cp_mc: cp_info['goods_name'],
                                cp_zt: cp_info['goods_image_url'],
                                cp_lx: cp_info['order_type'],
                                color_info: []
                            }
                            tmp[cp_key]['color_info'].push(cp_info)
                        }

                        if (cp_key == reservecp_key) {
                            tmp[cp_key]['color_info'].push(cp_info)
                        }
                        reservecp_key = cp_key

                    }

                    $.each(tmp, function (index, value) {
                        jl.push(value)
                    })

                    data_length[i]['order_items'] = jl;
                }

            }
            page_list = [];
            page_list = res['data']
            if ((page_list.length / 20) >= 1) {
                flag = true;
            } else {
                flag = false;
            }
            showList(fun.PagingData(page_list, 10) || [])
        },
        complete:function(){
            setTimeout(function(){
                fun.hideLoad();
            },300)
        }
    })
}

/*
    1. 一开始全部數據 19 ，
    2. 马上判断是否还有下一页 19 / 20 不是 1 ，就没有下一页数据，大于等于1就是还有下一页数据
    3. 有数据19，分页渲染10条之后还剩下9，继续滑动到底部加载，滑动到底部，判断当前 2得出的结果，是否还要继续请求分页数据
        是的话，再次请求，append，不是就给暂无数据提示
*/

//渲染数据
function showList(data) {
    var html = [];
    for (var i = 0; i < data.length; i++) {
        var order_info = data[i]['order_items'];
        var wechat_img = '';
        if ($.nui.isTrue(data[i]['user']['avatar_url'])) {
            wechat_img = data[i]['user']['avatar_url'];
        } else {
            wechat_img = '../img/link-person.png';
        }
        html.push('<li class="order-info" data-list=\'' + JSON.stringify(data[i]) + '\'>')
        html.push('<div class="order-info-top ">')
        html.push('<img src="' + wechat_img + '" class="user-img hidden" alt="">')
        if ($.nui.isTrue(data[i]['customer'])) {
            html.push('<div class="font-ms over-flow hidden-width-name" style="margin-left:0.2rem">' + (data[i]['customer']['name'] || '') + '</div>')
            if ($.nui.isTrue(data[i]['contacts'])) {
                html.push('<div class="color-blue lianxir over-flow hidden-width-name2" style="margin-left:0.1rem">@' + (data[i]['contacts']['name'] || '') + '</div>')
            }
        } else {
            html.push('<div class="font-ms over-flow hidden-width-name">' + data[i]['user']['nickname'] + '</div>')
        }

        if (data[i]['order_type'] === 'card') {
            html.push('<a class="hint font-ss bg-color-pink hidden">色卡</a>')
        } else if (data[i]['order_type'] === 'cutting') {
            html.push('<a class="hint font-ss bg-color-zi hidden">剪样</a>')
        } else if (data[i]['order_type'] === 'normal') {
            html.push('<a class="hint font-ss bg-color-blue hidden">大货</a>')
        }

        if (!!data[i]['completed_at']) {
            html.push('<a class="hint font-ss bg-color-green hidden">已完成</a>')
        } else if (!!data[i]['refused_at']) {
            html.push('<a class="hint font-ss bg-color-black hidden">已拒绝</a>')
        } else if (!!data[i]['accepted_at']) {
            html.push('<a class="hint font-ss bg-color-org hidden">待发货</a>')
        } else if (!!data[i]['cancelled_at']) {
            html.push('<a class="hint font-ss bg-color-black hidden">已取消</a>')
        } else {
            if ($.nui.isTrue(data[i]['total']) && data[i]['total'] > 0 && data[i]['order_type'] != 'normal' && $.nui.isTrue(data[i]['paid_success_at'])) {
                html.push('<a class="hint font-ss bg-color-blue hidden">已付款</a>')
            } else {
                html.push('<a class="hint font-ss bg-color-pink hidden">待处理</a>')
            }

        }
        html.push('</div>')

        var show_info = data[i]['order_items'].slice(0, 2);
        html = html.concat(productInfo(show_info, order_info));
        if (data[i]['order_items'].length > 2) {
            var hide_info = data[i]['order_items'].slice(2, data[i]['order_items'].length);
            html.push('<div class="data-no" key="' + data[i]['id'] + '" style="display:none">')
            html = html.concat(productInfo(hide_info, order_info));
            html.push('</div>')
            html.push('<div class="align-center color-blue  line-height-ls zhanxian" data-id="' + data[i]['id'] + '" data-length="' + hide_info.length + '">展开剩余' + hide_info.length + '项</div>');
        }

        // if (order_info['type'] != 'sk') {
        if (data['order_type'] != 'card') {
            html.push('<div class="align-center color-black line-height-ls bg-gray sum" style="overflow:hidden;font-size:0">');
            html.push('     <span class="font-ms hidden">共 :</span>');
            html.push('     <span id="color-sum" class="margin-left-s font-ms over-flow hidden-width4">' + getPointNum(data[i]['goods_num']) + '</span>');
            html.push('     <span class="font-ms hidden">个产品，数量</span>');
            html.push('     <span id="length-sum" class="margin-left-s font-ms over-flow hidden-width5">' + getPointNum((data[i]['total_num']) / 10000, 4) + '</span>');
            html.push('     <span id="danwei-sum" class="font-ms over-flow hidden-width-dw2">' + ((data[i]['unit_name']) || '') + '</span>');
            html.push('     <span class="font-ms margin-left-s color-money-red hidden"> ￥</span><span id="money-sum" class="font-ms color-money-red over-flow hidden-width5">' + (data[i]['total']) / 10000 + '</span>');
            html.push('</div>')
        } else {
            html.push('<div class="align-center color-black line-height-ls bg-gray">');
            html.push('    <span class="hidden">色卡：</span>');
            // html.push('    <span class="over-flow">' + order_info['total_goods_count'] + '</span>');
            html.push('    <span class="over-flow">' + (order_info['total_num']) / 10000 + '</span>');
            html.push('    <span class="hidden">份</span>');
            html.push('    <span class="over-flow">' + (order_info['total']) / 10000 + '</span>');
            html.push('    <span class="hidden">元</span>');
            html.push('</div>');
        }
        html.push('</li>')
    }
    $('.card').append(html.join(''));
    setTimeout(function () {
        fun.hideLoad();
    }, 100)
}

//绑定事件
function bindEvent() {
    //筛选
    fun.setItem(html_name + 'sideslip', true)
    $('body').on('tap', '#filter_btn', function () {
        var sideslip = fun.getItem(html_name + 'sideslip')
        // 根据版本显示终端的内容
        if (!AuthVersionCheck.checkHide('xsdp') && !AuthVersionCheck.checkHide('aisc')) {
            //筛选页内容
            var option = {
                "time": {
                    "begin_date": search_storage['begin_date'],
                    "end_date": search_storage['end_date']
                },
                "choose_merchants": [
                    { "key": "dd_dh", "title": "单号", "value": (search_storage['trade_no'] || ''), "placeholder": "" },
                    { "key": "fans", "text": "粉丝", "value": (search_storage['fans_mc'] || ''), "id": (search_storage['user_id'] || '') },
                    {
                        "key": 'hz',
                        "text": "订单类型",
                        "group": [
                            { key: 'sk', name: '色卡', columns: 'sk', choose: search_storage['ddlx']['sk'] },//getSJ('ddlx', 'sk', 1)
                            { key: 'jy', name: '剪样', columns: 'jy', choose: search_storage['ddlx']['jy'] },//getSJ('ddlx', 'jy', 1)
                            { key: 'dh', name: '大货', columns: 'dh', choose: search_storage['ddlx']['dh'] },//getSJ('ddlx', 'dh', 1)
                        ],
                        "value": (search_storage['ddlx_text']),
                    },
                    {
                        "key": 'thfs',
                        "text": "提货方式",
                        "group": [
                            { key: 'yj', name: '邮寄', columns: 'yj', choose: search_storage['thfs']['yj'] },//getSJ('thfs', 'yj', 1) 
                            { key: 'zt', name: '自提', columns: 'zt', choose: search_storage['thfs']['zt'] },//getSJ('thfs', 'zt', 1)
                        ],
                        "value": (search_storage['thfs_text']),
                    },
                    {
                        "key": 'zd',
                        "text": "终端",
                        "group": [
                            { key: 'aishop', name: 'AI商城', columns: 'aishop', choose: search_storage['zd']['aishop'] },
                            { key: 'mall', name: '线上店铺', columns: 'mall', choose: search_storage['zd']['mall'] },
                        ],
                        "value": (search_storage['zd_text']),
                    }
                ]
            }
        } else {
            //筛选页内容
            var option = {
                "time": {
                    "begin_date": search_storage['begin_date'],
                    "end_date": search_storage['end_date']
                },
                "choose_merchants": [
                    { "key": "dd_dh", "title": "单号", "value": (search_storage['trade_no'] || ''), "placeholder": "" },
                    { "key": "fans", "text": "粉丝", "value": (search_storage['fans_mc'] || ''), "id": (search_storage['user_id'] || '') },
                    {
                        "key": 'hz',
                        "text": "订单类型",
                        "group": [
                            { key: 'sk', name: '色卡', columns: 'sk', choose: search_storage['ddlx']['sk'] },//getSJ('ddlx', 'sk', 1)
                            { key: 'jy', name: '剪样', columns: 'jy', choose: search_storage['ddlx']['jy'] },//getSJ('ddlx', 'jy', 1)
                            { key: 'dh', name: '大货', columns: 'dh', choose: search_storage['ddlx']['dh'] },//getSJ('ddlx', 'dh', 1)
                        ],
                        "value": (search_storage['ddlx_text']),
                    },
                    {
                        "key": 'thfs',
                        "text": "提货方式",
                        "group": [
                            { key: 'yj', name: '邮寄', columns: 'yj', choose: search_storage['thfs']['yj'] },//getSJ('thfs', 'yj', 1) 
                            { key: 'zt', name: '自提', columns: 'zt', choose: search_storage['thfs']['zt'] },//getSJ('thfs', 'zt', 1)
                        ],
                        "value": (search_storage['thfs_text']),
                    }
                ]
            }
        }
        if (!!search_storage['user_id']) {
            reset['user_id'] = search_storage['user_id']
        }
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false)
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    "return_page": html_name,
                    "search_data": option,
                    "reset": reset,
                    "is_restbutton": true,
                    "type": 'shop_store_dd'
                }
            })
        }
    })

    //搜索框
    $("#foot_search").bind('search', function () {
        $(".card").empty();
        search_data['search'] = $(this).val().trim()
        page = 1;
        getList(page);
        setTimeout(function () {
            fun.hideLoad();
        }, 100)
    })

    //显示隐藏产品
    var leng = [];
    $('body').on('tap', '.zhanxian', function () {
        var id = $(this).data('id')
        leng[id] = $(this).data('length')
        var data_no = $("[key='" + id + "']");
        if (data_no.css('display') == 'none') {
            data_no.slideDown(250);
            $("[data-id='" + id + "']").text('收起');
        } else if (data_no.css('display') == 'block') {
            data_no.slideUp(250);
            $("[data-id='" + id + "']").text('展开剩余' + leng[id] + '项');
        }
    })

    //聊天页面
    $('body').on('tap', '.order-info-top', function () {
        // fun.showPageFull({
        //     page_url: '',
        //     pageParam: {

        //     }
        // })
    })

    //跳转到剪样订单页面
    $('body').on('tap', '.order-info-center', function () {
        var order_list = $(this).parents('.order-info').data('list');
        fun.showPageFull({
            page_url: page_arr.shop_skddxq,
            pageParam: {
                return_page: html_name,
                order_id: order_list['id'],
                // type: order_list['type'],
                type: order_list['order_type'],
                order_list: order_list,
            }
        })
    })

    // 选项卡
    $('.nav li').on('tap', fun.debounce(function () {
        var $this = $(this);
        if ($this.hasClass('pitch-on')) {
            return;
        } else {
            $this.addClass('pitch-on');
            $this.siblings().removeClass('pitch-on');
        }

        page = 1;
        var index = $this.index();
        if (index === 0) {
            search_data['status'] = ['all'];
        } else if (index === 1) {
            search_data['status'] = ['pending']
        } else if (index === 2) {
            search_data['status'] = ['shipping']
        } else if (index === 3) {
            search_data['status'] = ['completed']
        } else if (index === 4) {
            search_data['status'] = ['refused']
        }
        $('.card').empty();
        getList(page);
        setTimeout(function () {
            fun.hideLoad();
        }, 300)
    }, 300))
}

//渲染产品
function productInfo(data, order_info) {
    var product_html = [];
    for (var b = 0; b < data.length; b++) {
        var jl = data[b];
        var cp_zt, notImg = { bg: '', img: '', display: '' };
        // if ($.nui.isEmpty(jl['cp_zt']) || jl['cp_zt'].indexOf('yby_logo.png') === 0) {
        if ($.nui.isTrue(jl['color_info'])) {//不是色卡
            if ($.nui.isEmpty(jl['color_info'][0]['goods_image_url'])) {
                cp_zt = '../img/logo.png';
                notImg = { bg: 'not-bgGray', img: 'not-img', display: 'display:none' }
            } else {
                // cp_zt = fun.getImgPath(jl['cp_zt']);
                cp_zt = jl['color_info'][0]['goods_image_url'];
            }
            //总金额、总数量
            var unitPrice = unitNum = 0;
            $(jl['color_info']).each(function (idx, item) {
                unitPrice += ((item.total) / 10000);
                unitNum += ((item.num) / 10000);
            })
        } else { //色卡
            if ($.nui.isEmpty(jl['goods_image_url'])) {
                cp_zt = '../img/logo.png';
                notImg = { bg: 'not-bgGray', img: 'not-img', display: 'display:none' }
            } else {
                cp_zt = jl['goods_image_url'];
            }
            //总金额、总数量
            var unitPrice = unitNum = 0;
            $(jl).each(function (idx, item) {
                unitPrice += ((item.total) / 10000);
                unitNum += ((item.num) / 10000);
            })
        }


        product_html.push('<div class="order-info-center lower-border-line clear">');
        product_html.push('     <div class="left com-img ' + notImg.bg + '">');
        product_html.push('         <img src="' + (cp_zt || '../img/logo.png') + '" class="commodity-img ' + notImg.img + '" alt="">');
        product_html.push('         <img src="../img/mask.png" class="commodity-img cp-bg-img" style="' + notImg.display + '">');
        product_html.push('     </div>');
        product_html.push('     <div class="left margin-left-ms" style="width: calc(100% - 3.5rem);">')
        if ($.nui.isTrue(jl['color_info'])) {
            product_html.push('         <p class="color-black font-ls line-height2"><span class="over-flow hidden-width100">' + (jl['cp_bh'] || '') + ' ' + (jl['cp_mc'] || '') + '</span></p>')
        } else {
            product_html.push('         <p class="color-black font-ls line-height2"><span class="over-flow hidden-width100">' + (jl['goods_number'] || '') + ' ' + (jl['goods_name'] || '') + '</span></p>')
        }
        // if (order_info['type'] != 'sk') {
        if ($.nui.isTrue(jl['color_info'])) {
            product_html.push('     <p class=" font-ss line-height" >');
            product_html.push('         <span class="hidden">共 : </span>');
            product_html.push('         <span class="over-flow hidden-width">' + fun.is_value(jl['color_info'].length) + '</span>');
            product_html.push('         <span class="hidden">个色,</span>');
            product_html.push('         <span class="margin-left-s over-flow hidden-width3" >' + getPointNum(fun.is_value(unitNum), 4) + '</span>');
            product_html.push('         <span class="over-flow hidden-width-dw">' + (fun.is_value(jl['cp_jjdw']) || '') + '</span>');
            product_html.push('     </p><p class="font-ss line-height">');
            product_html.push('         <span class="hidden">￥</span><span class="over-flow" style="max-width: calc(100% - 1rem)">' + getPointNum(fun.is_value(unitPrice)) + '</span>');
            product_html.push('     </p>');
        } else {
            product_html.push('     <p class="margin-top-ls font-ss line-height">');
            product_html.push('         <span class="hidden">色卡 </span>');
            // product_html.push('         <span class="over-flow hidden-width3">' + fun.is_value(jl['zsl']) + '</span>');
            product_html.push('         <span class="over-flow hidden-width3">' + unitNum + '</span>');
            product_html.push('         <span class="hidden">份</span>');
            product_html.push('         <span class="over-flow hidden-width3">￥' + unitPrice + '</span>');
            product_html.push('         <span class="hidden">元</span>');
            product_html.push('     </p> ');
        }
        product_html.push('     </div>');
        product_html.push('</div>');
    }
    return product_html;
}

//小数点限制
function getPointNum(num, fixed, zero_display) {
    var _fidex = parseInt(fixed || 2);
    if (zero_display || false) {
        // 显示小数点后的0
        return num.toFixed(_fidex);
    } else {
        // 不显示小数点后的0
        return parseFloat(num.toFixed(_fidex));
    }
}

// function getSJ(father, key, def) {
//     def = def || 0;
//     if (!!search_storage[father]) {
//         return search_storage[father][key] == 1 ? 1 : 0
//     }
//     return def
// }
