var html_name = page_arr.specifications;
var UPDATE = { del_id: [], up: [] };
var title;


page_init = function () {
    if ($.nui.isTrue(page_data.cp_title) && page_data.cp_id != 0) {
        title = page_data['cp_title'] || '';
        getList();
    }
    $('#header').header({
        back: true,
        add: true,
        filter: true,
        title: title,
        foot_input: {
            show: true,
            plader: '搜索或添加规格'
        },
        appendBackBtnEvt: updatePrevPage
    });
    if (page_data['gg_name']) {
        $('#foot_search').val(page_data['gg_name']);
    }

    page_data.keyback = updatePrevPage;//  监听返回键
}

//获取规格数据
function getList(data) {
    fun.ajax({
        showLoad: false,
        hideLoad: false,
        url: AJAX_URL.getGoodsSpecList,
        data: {
            keyword: data || '',
            goods_id: page_data['cp_id']
        },
        success: function (res) {
            if (res['status'] == 0) {

                if ($.nui.isEmpty(res['data']) || res['data'].length == 0) {
                    if ($.nui.isTrue(data)) {
                        fun.dialog({
                            content: '搜索不到，是否需要新增？',
                            btn: ['新增', '取消'],
                            yes: function () {
                                //规格为空
                                // var input_val = $("#input_val").val().trim();
                                if (!data) return fun.toast("请输入规格");
                                //已存在
                                // if (input_val !== opt.default_val) {
                                var name_arr = [];
                                $('.account-list').eq(1).find('.color-number').text()
                                $('.account-list').each(function (i, obj) {
                                    name_arr.push($(obj).find('.color-number').text().trim());
                                });
                                if (name_arr.indexOf(data) > -1) {
                                    return fun.toast("该规格已存在。");
                                }
                                // }
                                fun.ajax({
                                    showLoad: false,
                                    hideLoad: false,
                                    url: AJAX_URL.saveGoods,
                                    data: {
                                        "save_type": "addSpec", // 修改
                                        "goods_id": page_data['cp_id'] || 0,
                                        "id": 0, // 为0是添加，不为0是修改
                                        "spec": data || '',
                                        "is_default": 0 //默认
                                    },
                                    success: function (res) {
                                        // console.log(JSON.stringify(res))
                                        switch (res['status']) {
                                            case 0:
                                                getList();
                                                fun.toast("保存成功！");
                                                Returndata({
                                                    name: data,
                                                    id: res['data']['id']
                                                });
                                                break;
                                            case 104:
                                                fun.dialog({
                                                    content: "【" + data + "】已存在。",
                                                    btn: ['确定']
                                                });
                                                break;
                                            case 'error':
                                                return fun.toast(res['msg']);
                                                break;
                                        }
                                    }
                                })
                            },
                            no: function () {
                                fun.hideLoad();
                                return fun.createDataEmptyTips({ dom: '#list_wrap', isDa: true, btnText: '新增规格', style: 'top:-1rem;' });
                            }
                        });
                    } else {
                        fun.hideLoad();
                        return fun.createDataEmptyTips({ dom: '#list_wrap', isDa: true, btnText: '新增规格', style: 'top:-1rem;' });
                    }
                }
                var parmas = res['data'];
                // console.log(JSON.stringify(res))
                showList(parmas);
                fun.hideLoad();
            } else {
                fun.hideLoad();
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}
//返回事件
function updatePrevPage() {
    var keyword = $('#foot_search').val().trim(); // 拿到搜索关键字
    // $('#list_wrap').empty(); // 清空当前
    // if($.nui.isTrue(keyword)){
    //     getList(keyword); // 根据关键字显示搜索结果
    // }else{
    //     getList();
    // }
    Returndata({
        name: keyword
    });
    api.closeWin();
}

//渲染数据
function showList(data) {
    $('#list_wrap').html('');
    var Html = [];
    $(data).each(function (i, obj) {
        Html.push('<li data-list=\'' + fun.formatString(JSON.stringify(obj)) + '\' data-id="' + fun.is_value(obj['id']) + '" data-default="' + fun.is_value(obj['is_default']) + '" class="account-list lower-border-line" >');
        Html.push('<div class="le">');
        Html.push('     <span class="color-number cost1">' + fun.is_value(obj['spec']) + '</span>');
        Html.push('     <div class="slids edit dels1 edit-btn">修改</div>');
        Html.push('     <div class="delete dels1 delete-btn">删除</div>');
        Html.push('</div>');
        Html.push('</li>');
    });
    $('#list_wrap').html(Html.join(''));
}

//返回上一级数据
function Returndata(data) {
    api.sendEvent({
        name: page_data.html_name,
        extra: {
            'status': page_data['status'] || 'goodsdata',
            'name': data['name'] || '',
            'id': data['id'] || 0,
            'data': {
                'select_val': data['name'] || '',
                'id': data['id'] || 0,
                'page_type': page_data['key'] || '',
            }
        }
    });
    api.closeWin();
}

//新增、修改弹窗
function prompt(opt) {
    var opt = $.extend({}, {
        "default_val": "",//输入框内容
        "switch": true,
        "is_default": 0,//默认
        "id": 0,
        "callback": null
    }, opt);
    var text = (opt.type == "edit") ? "修改" : "新增";
    var html = [];
    style = 'width: 85%;  border:none; background: #fff; border-radius: 0.5rem; ';//position: absolute; top: 30%; left: 7.5%;
    html.push('<span class="label">' + (text + '规格') + '</span>');
    html.push('<input id="input_val" type="text" class="input-box" value="' + (opt.default_val || "") + '" />');
    if (opt.switch) {
        var is_default = (opt.is_default == 1) ? "nui-active" : "";
        html.push('<div class="switch"><div id="is_default" class="nui-switch nui-switch-md nui-unactive nui-switch-btn ' + is_default + '">');
        html.push('<div class="nui-switch-handle"></div></div>');
        html.push('<span class="switch-title">默认</span></div>');
    }
    html.push('<button id="save_btn" class="confirm button">确定</button>');
    html.push('<button id="cancel_btn" class="cancel button">取消</button>');
    layer.open({
        type: 1,
        content: html.join(''),
        style: style,
        shadeClose: false,
        success: function (layero) {
            $('#save_btn').on('tap', function () {
                //规格为空
                var input_val = $("#input_val").val().trim();
                if (!input_val) return fun.toast("请输入规格。");
                // //已存在
                // if (input_val !== opt.default_val) {
                //     var name_arr = [];
                //     $('.account-list').eq(1).find('.color-number').text()
                //     $('.account-list').each(function (i, obj) {
                //         name_arr.push($(obj).find('.color-number').text().trim());
                //     });
                //     if (name_arr.indexOf(input_val) > -1) {
                //         return fun.toast("该规格已存在。");
                //     }
                // }
                var default_data = $('#is_default').hasClass('nui-active') ? 1 : 0;
                fun.ajax({
                    showLoad: true,
                    hideLoad: true,
                    url: AJAX_URL.saveGoods,
                    data: {
                        "save_type": "addSpec", // 修改
                        "goods_id": page_data['cp_id'] || 0,
                        "id": opt.id || 0, // 为0是添加，不为0是修改
                        "spec": input_val || opt.default_val || '',
                        "is_default": default_data || 0 //默认
                    },
                    success: function (res) {
                        // console.log(JSON.stringify(res))
                        // console.log(JSON.stringify(opt.is_default))
                        // console.log(JSON.stringify(default_data))
                        switch (res['status']) {
                            case 0:
                                getList();
                                fun.toast("保存成功！");
                                Returndata({
                                    name: input_val,
                                    id: res['data']['id']
                                });
                                break;
                            case 104:
                                console.log('104')
                                console.log(default_data)
                                console.log(opt.is_default)
                                if (default_data != opt.is_default) {
                                    getList();
                                    fun.toast("保存成功！");
                                    Returndata({
                                        name: input_val,
                                        id: opt.id
                                    });
                                } else {
                                    fun.toast('该规格已存在。');
                                    // fun.dialog({
                                    //     content: "【" + opt.default_val + "】已存在。",
                                    //     btn: ['确定']
                                    // });
                                }
                                break;
                            case 'error':
                                return fun.toast(res['msg']);
                                break;
                        }
                    }
                })
            })
            $('#cancel_btn').on('tap', function () {
                layer.close($(layero).attr('index'));
            })
        }
    })
}

//点击键盘搜索
$('body').bind('search', '#foot_search', function () {
    var keyword = $('#foot_search').val().trim(); // 拿到搜索关键字
    $('#list_wrap').empty(); // 清空当前
    if ($.nui.isTrue(keyword)) {
        getList(keyword); // 根据关键字显示搜索结果
    } else {
        getList();
    }
});

//选中列表
$('body').delegate('.account-list', 'tap', function () {
    var gg_data = $(this).data('list');
    var goods_data = {
        name: gg_data['spec'],
        id: gg_data['id']
    };
    Returndata(goods_data);
});

//添加
$('body').on('tap', '#add_btn', function (e) {
    e.stopPropagation();
    var name = $('#foot_search').val();
    console.log(name)
    prompt({
        "type": "save",
        "switch": true,
        "default_val": name || ''
    });
    return false;
})

//修改
$('body').delegate('.edit-btn', 'tap', function (e) {
    e.stopPropagation();
    var id = $(this).parents('.account-list').attr('data-id');
    var name = $(this).parents('.account-list').find('.color-number').text().trim();
    var is_default = $(this).parents('.account-list').attr('data-default');
    prompt({
        "type": "edit",
        "switch": true,
        "is_default": is_default || false,
        "default_val": name || "",
        "id": id || 0
    });
    return false;
})

//刪除
$('body').delegate('.delete-btn', 'tap', function (e) {
    e.stopPropagation();
    var id = $(this).parents('.account-list').attr('data-id');
    var name = $(this).parents('.account-list').find('.color-number').text().trim();
    fun.dialog({
        content: '你确定要删除【' + name + '】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            fun.ajax({
                // showLoad: true,
                // hideLoad: true,
                url: AJAX_URL.saveGoods,
                data: {
                    "save_type": "delSpec", // 删除
                    "goods_id": page_data['cp_id'] || 0,
                    "id": id || 0,
                    "spec": name || '',
                    "is_default": 1
                },
                success: function (res) {
                    switch (res['status']) {
                        case 0:
                            getList();
                            fun.toast("删除成功！");
                            break;
                        case 'error':
                            return fun.toast(res['msg']);
                            break;
                    }
                }
            })
        }
    });
    return false;
});