var html_name = page_arr.storehouse;//页面名称
var search_data = {}, temps, page_list = [],
    return_data = {};
var UPDATE = { del_id: [], up: [] };
var storeHouse = {};

$('#header').header({
    back: true,
    title: '仓库',
    add: Auth.check('ck', 'edit'),
    filter: true,
    foot_input: {
        show: true,
        plader: '搜索仓库',
        yuyin_icon: false,
    },
    appendBackBtnEvt: updatePrevPage
});

var USER_INFO = {};

storeHouse.filterSearchType = function (filterArr, arrArr) {
    if (filterArr.length === arrArr.length || $.nui.isEmpty(filterArr)) { // 全选或全不选
        search_data['type'] = '';
    } else { // 只选择了其中一个
        search_data['type'] = filterArr[0];
    }
}

storeHouse.initSearchType = function () {
    var typeArr = ['bp','skyb','sx'];
    var searchType = [];
    for (var i = 0; i < typeArr.length; i++) {
        if (fun.getItem(html_name + '_switch_type_' + typeArr[i]) === null) {
            fun.setItem(html_name + '_switch_type_' + typeArr[i], 1);
        } else if ($.nui.isTrue(fun.getItem(html_name + '_switch_type_' + typeArr[i]))) {
            searchType.push(typeArr[i]);
        }
    };
    storeHouse.filterSearchType(searchType, typeArr);
    // if (searchType.length === typeArr.length || $.nui.isEmpty(searchType)) { // 全选或全不选
    //     search_data['type'] = '';
    // } else { // 只选择了其中一个
    //     search_data['type'] = searchType[0];
    // }
}

storeHouse.setSearchData = function (temp) {
    var typeArr = ['bp','skyb','sx'];
    var type = temp['data']['lx'];
    if ($.nui.isTrue(type['type'])) {
        var tempTypeArr = [];
        for (var key in type['keys']) {
            fun.setItem(html_name + '_switch_type_' + key, type['keys'][key]);
            if (type['keys'][key]) {
                tempTypeArr.push(key);
            }
        }
        storeHouse.filterSearchType(tempTypeArr, typeArr);
        // if (tempTypeArr.length === typeArr.length || $.nui.isEmpty(typeArr)) {
        //     search_data['type'] = '';
        // } else {
        //     search_data['type'] = searchType[0];
        // }
    } else {
        for (var i = 0; i < typeArr.length; i++) {
            fun.setItem(html_name + '_switch_type_' + typeArr[i], 1);
            search_data['type'] = '';
        }
    }
}

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');

    page_data.keyback = updatePrevPage;//  监听返回键

    if (!Auth.check('ck', 'edit')) {
        $('#add_btn').hide();
        $('#house_list').removeClass('swipe-delete');
    }

    fun.orderListHeight({ dom: '#house_list' });

    storeHouse.initSearchType();

    getList();

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var temp = ret['value'];
        switch (temp['status']) {
            case 'search':
                search_data['md_id'] = temp['data']['md']['id'] || '';//门店
                search_data['md_mc'] = temp['data']['md']['text'] || '';
                search_data['is_stop'] = temp['data']['is_stop'] || '';//隐藏0欠款
                fun.setItem(html_name + '_isStop', temp['data']['is_stop']);
                fun.setItem(html_name + 'sideslip', true);
                $('#house_list').empty();

                storeHouse.setSearchData(temp);

                fun.setItem(html_name + '_type_text', temp['data']['lx']['text']); // 存储选择文本
                getList();
                break;
            case 'refresh':
                $('#house_list').empty();
                getList();
                break;
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('house_list', '.store-info');
        }
    });
};

function getList() {
    page_list = [];
    temps = $.extend({
        "keyword": "",
        "keyword_key": ['name', 'simple'],
        "md_id": 0,
        "md_mc": "",
        "not_jgs": 1,
        "is_stop": fun.getItem(html_name + '_isStop') || ''
    }, search_data);

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getHouseList,
        data: temps,
        success: function (res) {
            if (res['status'] == 0) {
                $('#house_list').css({ 'height': 'auto', 'position': 'unset' });
                if ($.nui.isEmpty(res['data']) || !res['data'].length) {
                    page_list = [];
                    // $('#house_list').css({'height': '100%', 'position': 'fixed'});
                    // return $('#house_list').html('<p class="empty_text topss">暂无数据！</p>');
                    fun.hideLoad();
                    return fun.createDataEmptyTips({dom:'#house_list',btnText:'新增仓库',auth:'ck',style:'top:1.5rem',isDa:true});
                } else {
                    $('#house_list').html('');
                }
                page_list = res['data'];
                showList(fun.PagingData(page_list));
            } else {
                fun.hideLoad();
                return fun.alert({msg:'网络异常！'});
            }
        }
    });

    fun.load_DATA_LIST(['ck']);
}

function showList(data) {
    var Html = [];
    for (var i = 0; i < data.length; i++) {
        var val = data[i];

        Html.push('<li id="' + (val['id'] || 0) + '" class="store-info lower-border-line"  data-list=\'' + fun.formatString(JSON.stringify(val)) + '\'>');
        Html.push('<div class="le">');
        if ($.nui.isTrue(val['address'])) {
            Html.push('  <div class="top">');
        } else {
            Html.push('  <div class="top" style="padding-top:0.75rem">');
        }
        Html.push('         <span class="md-mc">' + (fun.redFont(val['name'], search_data['keyword']) || "") + ' </span>');
        Html.push('         <div class="logoss">');

        if ($.nui.isTrue(val['is_detail'])) {
            Html.push('         <em>明细</em>');
        }
        if (!AuthVersionCheck.checkHide('tm') && $.nui.isTrue(val['is_bar'])) {
            Html.push('         <em>条码</em>');
        }
        if ($.nui.isTrue(val['is_minus'])) {
            Html.push('        <em>不负库存</em>');
        }
        if ($.nui.isTrue(val['is_batch'])) {
            Html.push('        <em>批次</em></div>');
        }
        Html.push('       </div>');
        if ($.nui.isTrue(val['address'])) {
            Html.push('     <div class="bottom"><span class="store-address">' + (val['address'] || '') + '</span></div>');
        }
        Html.push('     <div class="delete dels1 delete-btn">删除</div>');
        Html.push('</div>');
        Html.push('</li>');
    }

    $('#house_list').append(Html.join(''));
}


//点击键盘搜索
$('body').bind('search', '#foot_search', function (e) {
    search_data['keyword'] = $('#foot_search').val().trim();
    $('#house_list').empty();
    getList();
});


$('body').delay('tap', '#add_btn', function (e) {
    var search_val = $('#foot_search').val().trim();
    if (search_val == '') {
        openPage(search_val)
    } else {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.getInfoByKeyword,
            data: {
                "type": 'ck',
                "keyword": search_val
            },
            success: function (res) {
                switch (res['status']) {
                    case 0:
                        openPage(search_val);
                        break;
                    case 104:
                        layer.closeAll();
                        fun.dialog({
                            content: '【' + search_val + '】已存在，是否继续添加？',
                            btn: ['确定', '取消'],
                            shadeClose: false,
                            className: 'data-change-skin',
                            yes: function () {
                                openPage('');
                            },
                            no: function () {
                                search_data['keyword'] = search_val;
                                $('#house_list').empty();
                                getList();
                            }
                        });
                        break;
                    default:
                        fun.toast(res['msg']);
                        break;
                }
            }
        })
    }

});
function openPage(search_val) {
    fun.showPageFull({
        page_url: page_arr.storehouse_add,
        pageParam: {
            return_page: html_name,
            'state': 'add',
            'ck_name': search_val
        }
    });
}

fun.setItem(html_name + 'sideslip', true);

//打开搜索框
$('body').on('tap', '#filter_btn', function (e) {
    var sideslip = fun.getItem(html_name + 'sideslip');
    // if(!Auth.check('yxckqtmd','view',false)) return false;//【允许查看其他门店】权限
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'edit'));
    var options = {
        "choose_merchants": [
            {
                "key": "md",
                "text": "门店",
                "value": (temps && temps['md_mc'] ? temps['md_mc'] : (disabled ? (USER_INFO['store_name'] || '') : '')),
                "id": (temps && temps['md_id'] ? temps['md_id'] : (disabled ? (USER_INFO['store_id'] || 0) : 0)),
                // disabled: disabled
            }
        ],
        "switch": [
            {
                "text": "显示停用",
                "max_width": true,
                "key": "is_stop",
                "value": (temps && fun.getItem(html_name + '_isStop') ? fun.getItem(html_name + '_isStop') : '')
            },
        ],
        xs: [
            {
                key: 'lx',
                text: '类型',
                xsType: 'bp,skyb,sx',
                list: [
                    {
                        'name': '布匹',
                        'column': 'bp',
                        'is_choose': fun.getItem(html_name + '_switch_type_' + 'bp')
                    },
                    {
                        'name': '色卡\\样版',
                        'column': 'skyb',
                        'is_choose': fun.getItem(html_name + '_switch_type_' + 'skyb')
                    },
                    {
                        'name': '纱线',
                        'column': 'sx',
                        'is_choose': fun.getItem(html_name + '_switch_type_' + 'sx')
                    },
                ],
                alone: false,
                value: fun.getItem(html_name + '_type_text') || '布匹、色卡\\样版、纱线'
            }
        ]
    };
    if (sideslip) {

        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});


$('body').on('tap', '.store-info', function (e) {
    var list = $(this).data('list');
    if (!!page_data.return_page) {
        return_data = {
            id: $(this).attr('id'),
            page_type: page_data['page_type'],
            select_val: list['name'] || '',
            list_data: list,
            // set_where: page_data['set_where']||''
        }
        sendEvent(return_data);
    } else {
        fun.showPageFull({
            page_url: page_arr.storehouse_add,
            pageParam: {
                return_page: html_name,
                'id': list['id'] || 0,
                'state': 'modify',
                'house_name': list['name'] || ''
            }
        });
    }
});

//返回上一页并返回值
function sendEvent(data) {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'select_list',
            'data': data
        }
    });
    api.closeWin();
}

//更新上页选中值
function updatePrevPage() {
    UPDATE['page_type'] = page_data['page_type'];
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'update',
            'data': UPDATE
        }
    });
    api.closeWin();
}

//删除数据
$('body').on('tap', '.delete-btn', function (e) {
    e.stopPropagation();
    var list = $(this).closest('li').data('list');
    var id = list['id'];
    var name = list['name'];
    fun.dialog({
        content: '你确定要删除【' + name + '】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            delHouse({ id: [id] });
        }
    });
});


function delHouse(data, stop) {
    data = $.extend({}, data, { save_type: 'delete' });
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveHouseInfo,
        data: data,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    var msg = stop ? '停用' : '删除';
                    UPDATE['del_id'].push(data['id'][0]);
                    fun.toast(msg + '成功。');
                    $('#house_list').empty();
                    getList();
                    break;
                case 103:
                    fun.dialog({
                        content: '【' + res['name'] + '】已发生过业务，不允许删除。 您可以使用：停用功能。',
                        btn: ['转为停用状态', '我知道了'],
                        yes: function () {
                            data = $.extend({ is_has: true }, data);
                            delHouse(data, true);
                        }
                    });
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    });
}
