/********************* 变量定义 ************************/
var html_name = page_arr.storehouse_add;//页面名称
var origin_data = {}, save_data = {};
var delete_place = [];
var is_has;
var IS_PAGE_EDIT = true;
var type_arr = [
    { 'name': '布匹', 'id': 'bp', type: 'bp', is_choose: 1 }
];
var has_fkc = false;
var header_options = {
    back: true,
    title: '仓库',
    del: false,
    appendBackBtnEvt: isDataChange
};

var ck_info = {};
var USER_INFO = {};

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    type_arr.push({ 'name': '色卡\\样版', 'id': 'skyb', type: 'skyb' });
    type_arr.push({ 'name': '纱线', 'id': 'sx', type: 'sx' });
    // $('.cut-con').css('bottom', ($('.sub:visible').height() + api.safeArea.bottom + 'px'));

    // 条码模块才显示条码
    if (!AuthVersionCheck.checkHide('tm')) {
        $('.tm-hide').removeClass('tm-hide');
    }

    // 显示商城按钮
    if (!AuthVersionCheck.checkHide('scdp')) {
        $('#shop_btn').show();
    }

    //监听返回键
    page_data.keyback = function () {
        isDataChange();
    };
    //隐藏键盘
    // fun.keyboardEject('.sub');

    //监听页面返回值
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        console.log('----');
        console.log(ret);
        console.log('----');

        var temp = ret['value'];
        switch (temp['status']) {
            case 'select_list':
                setSelectVal(temp['data']);
                break;
            case 'refresh_page':
                init();
                break;
            case 'update':
                var backUpDateArr = [
                    { // 门店
                        pageType: 'md',
                        idName: 'md_id'
                    }
                ];
                fun.upDateBackSelRow({
                    backSelRow: temp.data,
                    backUpDateArr: backUpDateArr,
                    storageMode: 'data',
                    assignMode: 'val'
                })
                break;
        }
    });

    init();
};

/********************* 方法 ************************/
//初始化
function init() {
    var md_id = USER_INFO['store_id'] || 0;
    $('#header').header(header_options);
    if (!Auth.check('ck', 'edit')) {
        $('#add_btn').hide();
    }
    if ($.nui.isTrue(page_data['id'])) {
        getData();
    } else {
        $('#stop_btn,#del_btn').hide();
        $('#employee_name').val(page_data['ck_name'] || '');
        $('#lx').val('布匹').data('type', 'bp');
        if ($.nui.isTrue(md_id)) {
            $('#md').data('md_id', md_id).val(fun.getValByKey('md_list', md_id));
            if (!Auth.check('yxckqtmdck', 'edit')) {
                $('#md').attr('disabled', true);
            }
        }

        
        // 仓库默认管理模式
        var sys_config = fun.getItem('sys_config') || {};
        if($.nui.isTrue(sys_config['jgsck_bfkc'])){
            $('#kc').addClass('active');
        }else{
            $('#kc').removeClass('active')
        }
        if($.nui.isTrue(sys_config['jgsck_pcgl'])){
            $('#pc').addClass('active');
        }else{
            $('#pc').removeClass('active');
        }

        fun.load_DATA_LIST(['sys_config'],function () {
            sys_config = fun.getItem('sys_config') || {};
            if($.nui.isTrue(sys_config['jgsck_bfkc'])){
                $('#kc').addClass('active');
            }else{
                $('#kc').removeClass('active')
            }
            if($.nui.isTrue(sys_config['jgsck_pcgl'])){
                $('#pc').addClass('active');
            }else{
                $('#pc').removeClass('active');
            }
            origin_data = getSaveData();
        });
    }
    if (USER_INFO['store_id'] !== 0 && !Auth.check('yxckqtmd', 'view')) {
        $('#md').val(USER_INFO['store_name'] || '').data('md_id', USER_INFO['store_id'] || 0);
    }
    if (!Auth.check('ck', 'edit') || !IS_PAGE_EDIT) {
        $('.sub,#del_btn,#add_place').hide();
        $('input,.choose-ele,.m-switch,#stop_btn,#add_place').attr('disabled', 'disabled');
        $('#place_list').removeClass('swipe-delete');
        // $('.list-wrap').css('height', '100%');
        $('.cut-con').css('margin-bottom', '0');
    }
    // $('.cut').css('height','calc(100% - 5.5rem)');


    origin_data = getSaveData();
}

function getData() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getHouseInfo,
        data: {
            id: page_data['id']
        },
        success: function (res) {
            if (res['status'] == 0) {
                ck_info = res.data;
                has_fkc = res.data.has_fkc;
                showData(res.data);
            }
        }
    });
}

function showData(data) {
    var info = data['info'];
    is_has = info['is_has'];
    header_options['del'] = Auth.check('ck', 'edit');
    if (info['is_has'] > 0) {
        header_options['del'] = false;
        $('#del_btn').hide();
        $('.m-switch,#lx').attr('disabled', true);
        // $('#place_list').removeClass('swipe-delete');
        // $('#kc').removeAttr('disabled');
    }
    $('#header').header(header_options);

    $('#employee_name').val(info['name'] || '');
    $('#md').val(info['md_mc'] || '').data('md_id', info['store_id'] || 0);
    $('#dz').val(info['address'] || '');
    $('#bz').val(info['remark'] || '');

    $('#lx').val(fun.getValByKey(type_arr, info['type'], 'name') || '布匹').data('type', info['type'] || 'bp');

    if (info['type'] === 'sx') { // 纱线
        // 管理模式：明细、条码 自动取消选中状态 且 变为不可用状态，商城选项自动关闭 且 变为不可用状态。
        $('#mx,#tm').removeClass('active').attr('disabled', true);//#kc,#pc,
        $('#shop_btn').removeClass('nui-active').attr('disabled', true);
    }

    // $(type_arr).each(function (i, arr) {
    //     if (arr['id'] == info['type']) {
    //         type_arr[i]['is_choose'] = 1;
    //     } else {
    //         type_arr[i]['is_choose'] = 0;
    //     }
    // });

    var house_place = data['house_place'];

    if ($.nui.isTrue(info['is_stop'])) {
        $('.stop-btn').removeClass('nui-unactive').addClass('nui-active');
    }

    if ($.nui.isTrue(info['is_shop'])) {
        $('#shop_btn').removeClass('nui-unactive').addClass('nui-active');
    }


    if ($.nui.isTrue(info['is_minus'])) {
        $('#kc').addClass('active');
    }

    if ($.nui.isTrue(info['is_batch'])) {
        $('#pc').addClass('active');
    }

    if ($.nui.isTrue(info['is_detail'])) {
        // $('#mx,#pc').addClass('active');
        // $('#pc').attr('disabled', true);
        $('#mx').addClass('active');
    }

    if ($.nui.isTrue(info['is_bar'])) {
        $('#tm,#mx,#pc,#kc').addClass('active');
        $('#mx,#pc,#kc').attr('disabled', true);
    }else {
        //修改状态下,仓库没开启条码管理，不负库存可编辑。
        $('#kc').removeAttr('disabled');
    }

    showPlaceList(house_place);

    origin_data = getSaveData();
}

function setSelectVal(data) {
    $('#md').val(data['select_val']).data('md_id', data['id']);
}

function showPlaceList(data) {
    var html = [];
    for (var i = 0; i < data.length; i++) {
        var val = data[i];
        html.push('<li class="del-info lower-border-line hourse" data-list=\'' + fun.formatString(JSON.stringify(val)) + '\'>');
        html.push('<div class="le">');
        html.push('<span class="sort">' + (i+1) + '.</span>');
        html.push('<span class="text">' + (val['name'] || '') + '</span>');
        html.push('<div class="delete dels1 delete-btn">删除</div>');
        html.push('</div>');
        html.push('</li>');
    }
    $('#place_list').html(html.join(''));

    !Auth.check('ck', 'edit') && $('.hourse').attr('disabled', true);
}

function getSaveData() {
    var info = ck_info['info'] || {};
    var place_data = [];

    for (var i = 0; i < $('.hourse').length; i++) {
        var val = $('.hourse').eq(i).data('list');
        place_data.push({
            id: page_data['id'] ? (val['id'] || 0) : 0,
            name: val['name'] || '',
            sort: (i + 1) || val['sort'] || '',
            tm: val['tm'] || '',
            remark: val['remark'] || ''
        });
    }

    var data = {
        save_type: 'save',
        id: page_data['id'] || 0,
        date: info['date'] || fun.formatDate(new Date()),
        name: $('#employee_name').val().trim() || '',
        store_id: $('#md').data('md_id') || 0,
        address: $('#dz').val().trim() || '',
        remark: $('#bz').val().trim() || '',

        type: $('#lx').data('type') || 'bp',

        is_stop: $('#stop_btn').hasClass('nui-active') ? 1 : 0,
        is_shop: $('#shop_btn').hasClass('nui-active') ? 1 : 0,
        is_bar: $('#tm').hasClass('active') ? 1 : 0,
        is_detail: $('#mx').hasClass('active') ? 1 : 0,
        is_minus: $('#kc').hasClass('active') ? 1 : 0,
        is_batch: $('#pc').hasClass('active') ? 1 : 0,

        is_inferior: info['is_inferior'] || 0,
        house_place: place_data || [],
        delete_place: delete_place || []
    };

    return data;
}

function saveData() {
    if (!$('#employee_name').val().trim()) {
        return fun.toast('仓库不能为空！');
    } else if (!$('#lx').data('type')) {
        return fun.toast('类型不能为空！');
    }

    var data = getSaveData();

    data['is_place'] = 1;

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveHouseInfo,
        data: data,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.toast('保存成功。');
                    // closePage();
                    fun.pageCloseFun({ refresh: true });
                    break;
                case 100:
                    return fun.toast('仓位名不能为空。');
                    break;
                case 101:
                    return fun.toast('保存失败。');
                    break;
                case 103:
                    var msg = '';
                    if (!res['id']) {
                        msg = '仓位' + res['name'] + '被调用，不允许删除。';
                        fun.alert({ msg: msg });
                        showPlaceList(origin_data['house_place']);
                    }
                    else if (res['id'] || res['type'] == 'name') {
                        msg = '【' + res['name'] + '】已开过单，不能变更设置。';
                        return fun.alert({ msg: msg }, function () {
                            // api.sendEvent({
                            //     name:html_name,
                            //     extra:{
                            //         status:'refresh_page'
                            //     }
                            // })
                            disabledAfterSaved();
                        });
                    }

                    break;
                case 104:
                    var msg = '仓库已存在。';
                    if (res['name']) msg = '仓位已存在。';
                    else if (res['id']) msg = '仓库已存在。';
                    return fun.toast(msg);
                    break;
                case 'IS_NOT_AMEND':
                    return fun.toast(res['msg']);
                    break;
            }
        }
    });
}

function closePage() {
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            'status': 'refresh',
        }
    });
    setTimeout(function () {
        api.closeWin();
    }, 200);
}

//数据修改返回提示
function isDataChange() {
    save_data = getSaveData();
    if (!$.nui.isObjEquals(origin_data, save_data)) {
        if ($('body').find('.data-change-skin').length) return;
        fun.dialog({
            content: '您确定要保存吗？',
            btn: ['保存', '不保存', '取消'],
            shadeClose: false,
            className: 'data-change-skin',
            yes: function () {
                saveData();
            },
            no: function () {
                // closePage();
                fun.pageCloseFun({});
                // api.closeWin();
            }
        });
    } else {
        // closePage();
        fun.pageCloseFun({});
        // api.closeWin();
    }
}

function delHouse(data, stop) {
    data = $.extend({}, data, { save_type: 'delete' });
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.saveHouseInfo,
        data: data,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    var msg = stop ? '停用' : '删除';
                    fun.toast(msg + '成功。');

                    // closePage();
                    fun.pageCloseFun({ refresh: true });
                    break;
                case 103:
                    fun.dialog({
                        content: '【' + res['name'] + '】已发生过业务，不允许删除。 您可以使用：停用功能。',
                        btn: ['转为停用状态', '我知道了'],
                        yes: function () {
                            data = $.extend({ is_has: true }, data);
                            delHouse(data, true);
                        }
                    });
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    });
}

function addPlaceDialog(obj, data) {
    var title = '';
    var edit_name = '';
    data = data || {};
    if ($.nui.isTrue(data)) {//修改
        title = '修改仓位';
        edit_name = data['name'];
    } else {//添加
        title = '新增仓位';
    }

    var html = [];
    html.push('<span class="title">' + title + '</span>');
    html.push('<input type="text" class="input-box" name="type" id="type" value="' + (edit_name || '') + '"/>');

    fun.dialog({
        content: html.join(''),
        btn: ['保存', '取消'],
        style: 'width: 85%; padding-top:0.3rem; border:none; background: #fff; border-radius: 0.5rem; ',//position: absolute; top: 30%; left: 7.5%;
        yes: function () {
            var val = $('#type').val().trim();
            if (!val) return fun.toast('请输入仓位！');

            var list = {
                id: data['id'] || 0,
                name: val || '',
                sort: data['sort'] || $('.hourse').length + 1,
                tm: data['tm'] || '',
                remark: data['remark'] || ''
            };

            if (checkExist(list)) return fun.toast(val + '已存在。');

            var html = [];
            html.push('<li class="del-info lower-border-line hourse" data-list=\'' + fun.formatString(JSON.stringify(list)) + '\'>');
            html.push('<div class="le">');
            html.push('<span class="sort">' + list['sort'] + '.</span>');
            html.push('<span class="text">' + (list['name'] || '') + '</span>');
            html.push('<div class="delete dels1 delete-btn">删除</div>');
            html.push('</div>');
            html.push('</li>');

            if ($.nui.isEmpty(data)) {
                $('#place_list').append(html.join(''));
            } else {
                $(obj).data('list', list);
                $(obj).find('.text').text(list['name']);
            }
        }
    });

    $('.lay-warm .lay-warm-content').css('display', 'block');
}

function checkExist(params) {
    for (var i = 0; i < $('.hourse').length; i++) {
        var list = $('.hourse').eq(i).data('list');
        if (((i + 1) != params['sort']) && list['name'] == params['name']) {
            return true;
        }
    }
    return false;
}


/********************* 事件绑定 ************************/
//标签页切换
$('.nav').on('tap', function (e) {
    $(this).addClass('active').siblings().removeClass('active');
    $('.cut-con').eq($(this).index()).show().siblings('.cut-con').hide();
});

//管理模式点击
$('.manage-model a').on('tap', function (e) {
    var this_id = $(this).attr('id');
    if ($(this).attr('disabled') || $(this).hasClass('disabled')) return;

    if ($(this).hasClass('active')) {
        $(this).removeClass('active');
    } else {
        $(this).addClass('active');
    }

    switch (this_id) {
        case 'mx':
            // if ($('#mx').hasClass('active')) {
            //     $('#pc').addClass('active').attr('disabled', true);
            // } else {
            //     $('#pc').removeClass('active').removeAttr('disabled');
            // }
            break;
        case 'tm':
            if ($('#tm').hasClass('active')) {
                $('#mx,#kc,#pc').addClass('active').attr('disabled', true);
            } else {
                $('#mx,#kc,#pc').removeClass('active').removeAttr('disabled');
            }
            break;
        case 'kc':
            if ($('#kc').hasClass('active')) {
                if(has_fkc){
                    $('#kc').removeClass('active')
                    fun.toast('当前仓库存在负数库存，无法开启：不负库存。');
                }
            }
            break;
        default:
            break;
    }
});

//门店搜索
$('body').on('tap', '#md', function () {
    if ($(this).attr('disabled')) return;
    fun.showPageFull({
        page_url: page_arr.select_list,
        pageParam: {
            return_page: html_name,
            page_type: 'md'
        }
    });
});

//选择类型
$('body').on('click', '#lx', function (e) {
    e.preventDefault();
    if ($(this).attr('disabled')) return;
    $('input').blur();
    var val = $(this).data('type');
    $(type_arr).each(function (i, arr) {
        if (arr['id'] == val) {
            type_arr[i]['is_choose'] = 1;
        } else {
            type_arr[i]['is_choose'] = 0;
        }
    });

    fun.showBookList({
        width: '280px',
        shadeClose: true,
        list: type_arr,
        choose: function (res) {
            $('#lx').val(res.name).data('type', res.id);
            if (res['id'] === 'sx') { // 纱线
                // 管理模式：明细、条码 自动取消选中状态 且 变为不可用状态，商城选项自动关闭 且 变为不可用状态。
                $('#mx,#kc,#pc,#tm,#shop_btn').removeAttr('disabled');
                $('#mx,#tm').removeClass('active').attr('disabled', true);//#kc,#pc,
                $('#shop_btn').removeClass('nui-active').attr('disabled', true);
            } else { // 取消
                // $('#mx,#kc,#pc,#tm,#shop_btn').removeAttr('disabled');
                if (!$('#tm').hasClass('active')) {
                    $('#tm,#mx,#kc,#pc').removeAttr('disabled');
                }
                $('#shop_btn').removeAttr('disabled');
            }
        }
    });
    return false;
});

//删除功能
$('body').on('touchend', '#del_btn', function (e) {
    e.preventDefault();
    fun.dialog({
        content: '您确定要删除【' + $('#employee_name').val().trim() + '】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            delHouse({ id: [page_data['id']] });
        }
    });
    return false;
});

$('body').on('tap', '#add_place', function (e) {
    e.preventDefault();
    layer.closeAll();
    if ($(this).attr('disabled')) return;
    addPlaceDialog(this);
    return false;
});

$('body').on('tap', '.hourse', function (e) {
    e.preventDefault();
    layer.closeAll();
    if ($(this).attr('disabled')) return;
    var list = $(this).data('list');
    addPlaceDialog(this, list);
    return false;
});

//删除仓位
$('body').on('tap', '.delete-btn', function (e) {
    e.stopPropagation();
    var _this = this;
    var list = $(this).closest('li').data('list');
    fun.dialog({
        content: '你确定要删除【' + list['name'] + '】吗？',
        btn: ['删除', '取消'],
        yes: function () {
            if (list['is_has'] > 0) {
                fun.toast('【' + list['name'] + '】在仓库里有库存，不允许删除.');
            } else {
                $(_this).closest('li').remove();
                $.nui.isTrue(list['id']) && delete_place.push(list['id']);
                setTimeout(function () {
                    updateSort(list['sort']);
                }, 0);
            }
        }
    });
});

function updateSort(sort) {
    for (var i = 0; i < $('.hourse').length; i++) {
        var list = $('.hourse').eq(i).data('list');
        if (list['sort'] > sort) {
            var newSort = list['sort'] - 1;
            $('.hourse').eq(i).find('.sort').text(newSort + '.');
            $('.hourse').eq(i).data('list', $.extend(list, { sort: newSort }));
        }
    }
}

// 保存
$('body').delay('tap', '#button', function () {
    saveData();
});

function disabledAfterSaved() {
    var info = origin_data['info'] || {};

    $('.m-switch').removeClass('active');

    if ($.nui.isTrue(info['is_stop'])) {
        $('.stop-btn').removeClass('nui-unactive').addClass('nui-active');
    }

    if ($.nui.isTrue(info['is_minus'])) {
        $('#kc').addClass('active');
    }

    if ($.nui.isTrue(info['is_batch'])) {
        $('#pc').addClass('active');
    }

    if ($.nui.isTrue(info['is_detail'])) {
        // $('#mx,#pc').addClass('active');
        // $('#pc').attr('disabled', true);
        $('#mx').addClass('active');
    }

    if ($.nui.isTrue(info['is_bar'])) {
        $('#tm,#mx,#pc,#kc').addClass('active');
        $('#mx,#pc,#kc').attr('disabled', true);
    }

    $('#lx').val(fun.getValByKey(type_arr, info['type'], 'name') || '布匹').data('type', info['type'] || 'bp');

    $('#del_btn').hide();
    $('.m-switch,#lx').attr('disabled', true);
    if(!$.nui.isTrue(info['is_bar'])){
        //修改状态下,仓库没开启条码管理，不负库存可编辑。
        $('#kc').removeAttr('disabled');
    }
}
//
// var del_bit=0,
//     html_name=page_arr.storehouse_add,
//     sort_count=0,
//     house_date,//仓库创建时间
//     cw_count=0,//原本仓位的个数
//     del_cw=[],is_has,ye_change=[];//删除仓位id，有无发生过业务
//
// $('#header').header({
//     back:true,
//     title:'仓库',
//     del: true,
//     appendBackBtnEvt:close_page,
// });
//
// page_init=function(){
//     //监听返回键
//     if(!Auth.check('ck','edit',false)){
//         $('#del_btn').hide();
//         $('.sub').hide();
//         $('input').attr('disabled','disabled');
//     }
//     page_data.keyback=function(){
//         close_page();
//     }
//     //监听页面返回值
//     api.addEventListener({
//         name: html_name,
//     }, function (ret, err) {
//         var temp = ret['value'];
//         switch(temp['status']){
//             case 'select_list':
//                 evaluate(temp['data']);
//                 break;
//         }
//     });
//     if (page_data['state'] == 'modify') {
//         getData(page_data);
//         $('.n-yuyin').hide();
//     }else {//处于添加状态
//         $('#md').val(fun.getItem('user_info')['store_name']).addClass('changes');
//         $('#md').attr('ids',fun.getItem('user_info')['store_id']);
//         house_date=fun.getNowFormatDate().substr(0,fun.getNowFormatDate().length-3);
//         $('#del_btn').css('display','none');
//         $('.stops').hide();
//         $('.stop-btn').hide();
//         $('.cut').addClass('changes');
//     }
// }
//
// //关闭窗口
// function close_page(){
//     if($('.changes').length != 0){
//         fun.dialog({
//             content: '您确定要保存吗？',
//             btn: ['保存', '不保存', '取消'],
//             yes: function () {
//                 if(!$('#employee_name').val()){
//                     fun.toast('用户名称不能为空');
//                     return false;
//                 }
//                 saveData();
//             },
//             no:function(){
//                 api.closeWin();
//             }
//         });
//     }else{
//         api.closeWin();
//     }
// }
//
// //获取具体信息
// function getData(params){
//     fun.ajax({
//         showLoad:true,
//         hideLoad:true,
//         url:AJAX_URL.getHouseInfo,
//         data:{
//             id:params['id']
//         },
//         success:function(res){
//             if (res.status != 0) return fun.alert({ msg: JSON.stringify(res)});
//             var info_list=res.data;
//             showData(info_list);
//         }
//     });
// }
//
// //显示数据信息
// function showData(data){
//     var info=data['info'] || {};
//     var param=data['house_place'] || {};
//     is_house=fun.is_value(info['is_place']);
//     is_has=fun.is_value(info['is_has']);
//     if(!!is_has){$('#del_btn').hide();}//如果当前仓库已经发生过业务
//     $('.cut').attr('info_id',fun.is_value(info['id']));
//     $("#employee_name").val(fun.is_value(info['name']) || '');
//     $("#md").val(fun.is_value(info['md_mc']) || '');//门店
//     $('#md').attr('ids',fun.is_value(info['store_id']));
//
//     ye_change['ps']=fun.is_value(info['ps']) || 0;
//     ye_change['sl']=fun.is_value(info['sl']) || 0;
//     ye_change['lx']=fun.is_value(info['type']);
//     $("#lx").val(fun.is_value(info['type']) || '');
//     $("#dz").val(fun.is_value(info['address']) || '');
//     $("#bz").val(fun.is_value(info['remark']) || '');
//
//     //是否停用
//     if(!!fun.is_value(info['is_stop'])){
//         $('.stop-btn').removeClass('nui-unactive');
//         $('.stop-btn').addClass('nui-active');
//     }
//
//     ye_change['is_detail']=fun.is_value(info['is_detail']);
//     if(!!fun.is_value(info['is_detail'])){
//         $('#mx').css({"background": "#18B4ED","color":"#fff"});
//         $('#mx').attr('isCheck',1);
//     }
//     ye_change['is_bar']=fun.is_value(info['is_bar']);
//     if(!!fun.is_value(info['is_bar'])){
//         $('#tm').css({"background": "#18B4ED","color":"#fff"});
//         $('#tm').attr('isCheck',1);
//     }
//     ye_change['is_minus']=fun.is_value(info['is_minus']);
//     if(!!fun.is_value(info['is_minus'])){
//         $('#kc').css({"background": "#18B4ED","color":"#fff"});
//         $('#kc').attr('isCheck',1);
//     }
//     ye_change['is_batch']=fun.is_value(info['is_batch']);
//     if(!!fun.is_value(info['is_batch'])){
//         $('#pc').css({"background": "#18B4ED","color":"#fff"});
//         $('#pc').attr('isCheck',1);
//     }
//
//     addHouse(param,page_data['state']);
// }
//
// function addHouse(param,state){
//     var p_list=[];
//     cw_count=param.length;
//     if(!!param){
//         for(var i=0;i<param.length;i++){
//             if(state=='modify'){
//                 p_list.push('<li class="del-info lower-border-line hourse" id="'+fun.is_value(param[i]['id'])+'" remark="'+fun.is_value(param[i]['remark'])+'" sort="'+(fun.is_value(param[i]['sort']) || sort_count)+'">');
//             }else{
//                 p_list.push('<li class="del-info lower-border-line hourse" sort="'+(fun.is_value(param[i]['sort']) || sort_count)+'">');
//             }
//             p_list.push('<div class="le">');
//             p_list.push('<span class="sort">'+fun.is_value(param[i]['sort'])+'.</span>');
//             p_list.push('<span class="text" name="'+fun.is_value(param[i]['name'])+'">'+fun.is_value(param[i]['name'])+'</span>');
//             if(Auth.check('ck','edit',false)){
//                 p_list.push('<div class="delete dels1 delete-btn">删除</div>');
//             }
//             p_list.push('</div></li>');
//         }
//
//         if(!$('.hourse').length){
//             $(".other").html(p_list.join(''));
//         }else{
//             if(state=='add'){
//                 $(".hourse:last-child").after(p_list.join(''));
//             }else{
//                 if((sort_count-1) == 0){
//                     $(".hourse:first-child").before(p_list.join(''));
//                 }else{
//                     $("[sort="+ (sort_count-1) +"]").after(p_list.join(''));
//                 }
//             }
//         }
//         // $("input").attr("disabled","disabled");// 不可编辑，可以传值
//     }
// }
//
// $('.nav').on('tap',function () {
//     $(this).addClass('active').siblings().removeClass('active');
//     var index = $(this).index();
//     number = index;
//     $('.cut-con').hide();
//     $('.cut-con:eq('+index+')').show();
// });
//
// //是否停用
// $('body').on('tap','.stop-btn',function(){
//     if($(this).hasClass('nui-active')){//停用
//         $(this).attr('isCheck',1).addClass('changes');
//     }else{
//         $(this).attr('isCheck',0).addClass('changes');
//     }
// });
//
// //隐藏键盘
// $('body').on('click','#employee_name,#dz,#bz',function(e){
//     $(this).focus().select();
//     var submit = $('.sub');
//     fun.keyboardEject(submit);
// });
//
// //赋值
// function evaluate(params){
//     $('#md').val(params['select_val']).addClass('changes');
//     $('#md').attr('ids',params['id'])
// }
//
// //监听值的变化
// $('input').bind('input propertychange', function() {
//     $(this).addClass('changes');
// });
//
// //门店搜索
// $('body').on('tap', '.md', function () {
//     var key=$(this).children('input').attr('id'),url;
//     if(key=='ywy'){
//         url=page_arr.employee;
//     }else{
//         url=page_arr.select_list;
//     }
//     var Param = {
//         "return_page":html_name,
//         "page_type":key
//     };
//     if(Auth.check('ck','edit',false) && Auth.check('yxckqtmd','view',false)){
//         fun.showPageFull({
//             page_url: url,
//             pageParam: Param
//         });
//     }
// });
//
// //选择类型
// $('body').on('click', '.lx', function () {
//     // e.preventDefault();
//     // e.stopPropagation();
//     var type_arr=[
//         {
//             'name':'布匹',
//             'id':1
//         },
//         {
//             'name':'色卡\/样版',
//             'id':2
//         },
//         {
//             'name':'纱线',
//             'id':3
//         }
//     ];
//     if(Auth.check('ck','edit',false)){
//         fun.showBookList({
//             width: '280px',
//             shadeClose: true,
//             list:type_arr,
//             choose: function (res) {
//                 $('#lx').val(res.name).addClass('changes');
//                 $('#lx').attr('type_id',res.id);
//             }
//         });
//         return true;
//     }
// });
//
// //添加仓位
// $('body').on('tap', '.adds,.hourse', function () {
//     if(Auth.check('ck','edit',false)) open_window($(this));
//     $(this).addClass('changes');
//     $('.other').addClass('changes');
// });
//
// //选择管理模式
// $('body').on('tap','.manage a',function(){
//     var id=$(this).attr('id');
//     var is_check=$(this).attr('isCheck');
//     if(!is_has){
//         switch (id) {
//             case 'mx':
//                 changeManages($(this));
//                 changeManages($("[id='pc']"));
//                 break;
//             case 'tm':
//                 changeManages($(".manage a"));
//                 break;
//             default:
//                 changeManages($(this));
//                 break;
//         }
//     }
//     function changeManages(objs){
//         if(is_check==0){
//             objs.css({"background": "#18B4ED","color":"#fff"});
//             objs.attr('isCheck',1).addClass('changes');
//         }else{
//             objs.css({"background": "#E5E5E5","color":"#000"});
//             objs.attr('isCheck',0).addClass('changes');
//         }
//     }
// });
// //打开窗口
// function open_window(objs){
//     var text,edit_name;
//     text=(objs.hasClass('adds')) ? '新增仓位' : '修改仓位';
//     if(!objs.hasClass('adds')){
//         edit_name=objs.find('.text').text();
//         var ids=objs.attr('id');
//     }
//     var html = [];
//     html.push('<span class="title">'+text+'</span>');
//     html.push('<input type="text" class="input-box" name="type" id="type" value="'+(edit_name || '')+'"/></li>');
//     fun.dialog({
//         content: html.join(''),
//         btn:['保存', '取消'],
//         style:'width: 85%; padding-top:0.3rem; border:none; background: #fff; border-radius: 0.5rem; position: absolute; top: 30%; left: 7.5%;',
//         yes: function () {
//             if(!$('#type').val()){
//                 fun.toast('不能为空！');
//                 return true;
//             }else{
//                 if(!!$("[name="+$('#type').val()+"]").attr('name')){
//                     fun.toast($('#type').val()+'已存在');
//                     return true;
//                 }
//
//                 if(!!$('.hourse').length){
//                     if(!!edit_name){
//                         sort_count=objs.attr('sort');//修改状态
//                         objs.remove();
//                     }else{
//                         sort_count=$('.hourse').length+1;
//                     }
//                 }else{
//                     sort_count=1;
//                 }
//
//                 var data=[{
//                     "id":ids || '',
//                     "sort":sort_count,
//                     "name":$('#type').val()
//                 }];
//
//                 if(!!edit_name){//修改状态
//                     addHouse(data,'modify');
//                     objs.remove();
//                 }else{
//                     addHouse(data,'add');
//                 }
//
//                 layer.closeAll();
//             }
//         },
//         no:function(){
//             layer.closeAll();
//         }
//     });
//     $('.lay-warm .lay-warm-content').css('display','block');
// }
//
// //删除仓位
// $('body').on('tap','.delete-btn,#del_btn',function(e){
//     e.stopPropagation();
//     var obs=$(this);
//     if(obs.attr('id') == 'del_btn'){
//         // $('#del_btn').addClass('changes');
//         del_bit=1;
//         objs='';
//     }else{
//         $(this).parents('.hourse').parent().addClass('changes');
//         var del_obj=$(this).parents('.hourse');
//         var id=$(this).parents('.hourse').attr('id');
//         var objs=$(this).siblings('.text').text();
//         var sort=$(this).parents('.hourse').attr('sort');
//         if(sort != $('.hourse').length){//如果删除的不是最后一个
//             var newx_obj=$(this).parents('.hourse').next();
//             newx_obj.attr('sort',(newx_obj.attr('sort')-1));
//             newx_obj.find('.sort').text(newx_obj.attr('sort'));
//         }
//         del_cw.push(id);//要删除的id
//     }
//     fun.dialog({
//         content:'你确定要删除'+objs+'吗',
//         btn: ['删除', '取消'],
//         yes: function () {
//             if(del_bit == 1 && objs==''){
//                 saveData();
//             }else{
//                 del_obj.remove();
//             }
//             layer.closeAll();
//         },
//         no:function(){
//             layer.closeAll();
//         }
//     });
// })
//
// function saveData(){
//     var place_data=[],is_house;
//     if(!$('.del-info input').val()){
//         fun.toast('仓库不能为空！');
//         return false;
//     }
//     if(!$('#lx').val()){
//         fun.toast('类型不能为空！');
//         return false;
//     }
//     for(var i=0;i<$('.hourse').length;i++){
//         place_data.push({
//             "id":$('.hourse:eq('+i+')').attr('id') || '',
//             "name":$('.hourse:eq('+i+')').find('.text').text() || '',
//             "sort":$('.hourse:eq('+i+')').attr('sort') || 1,
//             "tm":"",
//             "remark":$('.hourse:eq('+i+')').attr('remark') || ''
//         });
//     }
//     if(page_data['state'] == 'add'){
//         is_house=1;
//     }else{//如果添加
//         if(cw_count != $('.hourse').length && $('.hourse').length > cw_count){
//             is_house=1;
//         }else{
//             is_house=0;
//         }
//     }
//
//     if(!del_bit){
//         var save_data={
//             "save_type":"save",
//             "id":$('.cut').attr('info_id') || '',
//             "date":house_date || fun.getNowFormatDate(),
//             "name":$('#employee_name').val() || '',
//             "store_id":$('#md').attr('ids') || 0,
//             "address":$('#dz').val() || '',
//             "remark":$('#bz').val() || '',
//             "type":$('#lx').val() || '',
//             "is_stop":$('.stop-btn').attr('isCheck') || 0,
//             "is_bar":$('#tm').attr('isCheck') || 0,
//             "is_detail":$('#mx').attr('isCheck') || 0,
//             "is_minus":$('#kc').attr('isCheck') || 0,
//             "is_batch":$('#pc').attr('isCheck') || 0,
//             "is_place":is_house,//仓位管理默认为1
//             "is_inferior":0,
//             "house_place":place_data,
//             "delete_place":del_cw
//         };
//     }else{
//         var save_data={
//             "id":$('.cut').attr('info_id') || '',
//             "save_type":"delete"
//         };
//     }
//     fun.ajax({
//         showLoad:true,
//         hideLoad:true,
//         url:AJAX_URL.saveHouseInfo,
//         data:save_data,
//         success:function(res){
//             if(res.status == 'IS_NO_MINUS'){return fun.toast('['+page_data['house_name']+']有负库存数据，不能开启');}
//             if (!!del_bit && res.status != 0) return fun.toast(res.msg);
//             if (!del_bit && res.status != 0) return fun.toast(res.msg);
//             var info_list=res.data;
//             if(!del_bit && !!info_list){
//                 fun.toast('保存成功！');
//                 api.sendEvent({
//                     name: page_arr.storehouse,
//                     extra: {
//                         'status': 'refresh'
//                     }
//                 });
//                 setTimeout(function () {
//                     api.closeWin();
//                 }, 500);
//             }else{
//                 fun.toast('删除成功！');
//                 api.sendEvent({
//                     name: page_arr.storehouse,
//                     extra: {
//                         'status': 'refresh'
//                     }
//                 });
//                 setTimeout(function () {
//                     api.closeWin();
//                 }, 500);
//             }
//         }
//     });
// }
//
// //保存数据,删除数据
// $('body').on('tap','#button',function(){
//     if(page_data['state'] == 'modify'){
//         if(!is_has && $('.manage a').hasClass('changes') || $('#lx').hasClass('changes')){
//             fun.dialog({
//                 content: '['+(page_data['house_name'] || '该')+']仓库已开过单，不能更改设置！',
//                 btn:['我知道了'],
//                 width:'30%',
//                 style:'width: 85%; padding-top:0.3rem; border:none; background: #fff; border-radius: 0.5rem; position: absolute; top: 30%; left: 7.5%;',
//                 yes: function () {
//                     if($('.manage a').hasClass('changes')){
//                         if(!!ye_change['is_bar']){
//                             $('#tm').css({"background": "#18B4ED","color":"#fff"});
//                         }else{
//                             $('#tm').css({"background": "#E5E5E5","color":"#000"});
//                         }
//                         $('#tm').attr('isCheck',ye_change['is_bar']);
//                         if(!!ye_change['is_detail']){
//                             $('#mx').css({"background": "#18B4ED","color":"#fff"});
//                         }else{
//                             $('#mx').css({"background": "#E5E5E5","color":"#000"});
//                         }
//                         $('#mx').attr('isCheck',ye_change['is_detail']);
//                         if(!!ye_change['is_minus']){
//                             $('#kc').css({"background": "#18B4ED","color":"#fff"});
//                         }else{
//                             $('#kc').css({"background": "#E5E5E5","color":"#000"});
//                         }
//                         $('#kc').attr('isCheck',ye_change['is_minus']);
//                         if(!!ye_change['is_batch']){
//                             $('#pc').css({"background": "#18B4ED","color":"#fff"});
//                         }else{
//                             $('#pc').css({"background": "#E5E5E5","color":"#000"});
//                         }
//                         $('#pc').attr('isCheck',ye_change['is_batch']),
//                             $('.manage a').removeClass('changes');
//                     }
//                     if($('#lx').hasClass('changes')){
//                         $('#lx').val(ye_change['lx']);
//                         $('#lx').removeClass('changes');
//                     }
//                 },
//                 no:function(){
//                     layer.closeAll();
//                 }
//             });
//             $('.layer_save_btn').css({"background": "#FF7373","margin-left": "64%","margin-top": "-7%","margin-bottom": "7%"});
//             $('button').css('color','#fff');
//             return false;
//         }
//     }
//
//     if(!$('#employee_name').val()){
//         fun.toast('仓库名称不能为空');
//         return false;
//     }
//     saveData();
// });
