var html_name = page_arr.sxcg_lthjs_tj;


//默认开始显示数据
var to_month = fun.getLatelyTime(1,false);
var page_list = [], ztj_data = [];
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};
//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

// 头部
$('#header').header({
    back: true,
    filter: true,
    title: '来退货结算'
});

var USER_INFO = {};

// 汇总查询的字段内容
var hz_group_columns = {
    'dh': 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc',
    'wldw': 'wldw_id,wldw_mc',
    'cp': 'cp_bh,cp_mc',
    'cp_ys': 'cp_ys_bh,cp_ys_mc',
    "hsdj": 'hsdj',
    "gg": 'gg',
    "sx_pp":'sx_pp',
    "sx_dq":'sx_dq',
};

$('.increase').hide();

//接收查询后的参数
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    // ======= 区分纱线/布匹 ========
    fthStatistics.moduleType = 'sx';

    if (Auth.check('sx_cgthjs', 'edit') && Auth.check('sx_cglhjs', 'edit')) {
        $('.increase').show();
    } else if (Auth.check('sx_cgthjs', 'edit')) {
        $('.increase').show();
        $('.come').hide();
        $('.retreat').addClass('single-btn-style');
    } else if (Auth.check('sx_cglhjs', 'edit')) {
        $('.increase').show();
        $('.retreat').hide();
        $('.come').addClass('single-btn-style');
    } else {
        $('.increase').hide();
        $('.content').removeClass('fthjs');
    }
    // $('.increase-p:visible:first').css('margin-left', '2%');

    var hnh = html_name + '_';
    search_storage = $.extend(true, {
        'ycysh': fun.getItem(html_name + '_ycysh', 0),
        'hldj': fun.getItem(html_name + '_hldj', 0),
        'xsmx': fun.getItem(html_name + '_xsmx', 0),
        "hz": {
            "choose": {
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "dh": fun.getItem(hnh + 'dh', 1),
                "wldw": fun.getItem(hnh + 'wldw', 1),
                "cp": fun.getItem(hnh + 'cp', 1),
                "cp_ys": fun.getItem(hnh + 'cp_ys', 1),
                "gg": fun.getItem(hnh + 'gg', 0),
                "hsdj": fun.getItem(hnh + 'hsdj', 1),
                "sx_pp": fun.getItem(hnh + 'sx_pp', 0),
                "sx_dq": fun.getItem(hnh + 'sx_dq', 0)
            },
            "text": fun.getItem(hnh + 'text', ""),
        },
        'djlx': fun.getItem(html_name + "_djlx")
    }, search_storage);

    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(html_name + '_' + 'hz') || '');

    search_data = $.extend({}, search_data, search_storage);
    // 初始化汇总条件
    fun.initGroupOfSearchData(search_data, search_storage.hz.choose, hz_group_columns, ',jjdw_id,jjdw_mc');

    getList(search_data);

    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        // console.log(ret)
        if (ret.value.status === 'refresh') {                               // 刷新数据
            page_list = [];
            getList(search_data);
        } else {
            var param = ret.value.data;
            // console.log('--------');
            // console.log(JSON.stringify(param));
            search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
            search_data['begin_time'] = param.begin_date;                   //开始时间
            search_data['end_time'] = param.end_date;                       //结束时间
            search_data['wldw_id'] = param.gys['id'] || 0;                  //供应商
            search_data['cp_id'] = param.cp['id'] || 0;                     //纱线
            search_data['cp_lb_id'] = param.sx_lb['id'] || 0;               //纱线类别
            search_data['ck_id'] = param.ck['id'] || 0;                     //仓库
            search_data['md_id'] = param.md['id'] || 0;                     //门店
            search_data['sx_pp'] = param.sx_pp && param.sx_pp['text'] || '';//品牌
            search_data['sx_dq'] = param.sx_dq && param.sx_dq['text'] || '';//地区 
            search_data['gg'] = param.gg && param.gg['text'] || '';         //规格
            search_data['ycysh'] = param['ycysh'];
            search_data['hldj'] = param['hldj'];
            search_data['xsmx'] = param['xsmx'];
            search_data['dh'] = param['dh'] || '';                          //订单单号

            if (param.djlx['type'].indexOf(',') > -1) {
                var split = param.djlx['type'].split(',');
                search_data['djlx'] = [split[0], split[1]]
            } else {
                search_data['djlx'] = param.djlx['type'] != "" ? [param.djlx['type']] : ["sx_cglhjs", "sx_cgthjs"];
            }
            search_data['djlx_text'] = param.djlx['text'];
            fun.setItem(hnh + 'djlx', search_data['djlx'])
            fun.setItem(hnh + 'djlx_text', search_data['djlx_text'])
            if (param.djlx['keys']['sx_cglhjs'] == 0 && param.djlx['keys']['sx_cgthjs'] == 0) {
                fun.setItem(hnh + 'sx_cglhjs', 1);
                fun.setItem(hnh + 'sx_cgthjs', 1);
            } else {
                fun.setItem(hnh + 'sx_cglhjs', param.djlx['keys']['sx_cglhjs']);
                fun.setItem(hnh + 'sx_cgthjs', param.djlx['keys']['sx_cgthjs']);
            }

            //搜索菜单需要缓存的数据
            search_storage['keyword'] = search_data['keyword'];
            search_storage['begin_date'] = search_data['begin_time'];
            search_storage['end_date'] = search_data['end_time'];
            search_storage['gys'] = param.gys;
            search_storage['cp'] = param.cp;
            search_storage['cp_lb'] = param.sx_lb;
            search_storage['ck'] = param.ck;
            search_storage['md'] = param.md;
            search_storage['sx_pp'] = param.sx_pp;
            search_storage['sx_dq'] = param.sx_dq;
            search_storage['gg'] = param.gg;
            search_storage['ycysh'] = search_data['ycysh'];
            search_storage['hldj'] = search_data['hldj'];
            search_storage['xsmx'] = search_data['xsmx'];
            search_storage['dh'] = search_data['dh'];
            //设置时间控件时间
            date_bar.setDate(search_storage);

            // 汇总功能
            search_data['group'] = param.hz['group'] || '';
            search_storage['hz'] = param.hz;
            var hc = param['hz']['choose'];
            fun.setItem(hnh + 'md_mc', hc['md_mc']);
            fun.setItem(hnh + 'dh', hc['dh']);
            fun.setItem(hnh + 'wldw', hc['wldw']);
            fun.setItem(hnh + 'cp', hc['cp']);
            fun.setItem(hnh + 'cp_ys', hc['cp_ys']);
            fun.setItem(hnh + 'sx_pp', hc['sx_pp']);
            fun.setItem(hnh + 'sx_dq', hc['sx_dq']);
            fun.setItem(hnh + 'gg', hc['gg']);
            fun.setItem(hnh + 'hsdj', hc['hsdj']);
            fun.setItem(hnh + 'text', param.hz['text']);
            fun.setGroupCondition(search_data, 'jjdw_id,jjdw_mc');
            // if (!!search_data['group']) {
            //     var group_data = search_data['group'];
            //     group_data += ',dw_id,dw_mc,jjdw_mc';
            //     search_data['group'] = group_data;
            // }
            fun.setItem(hnh + 'hz', search_data['group']);

            fun.setItem(html_name + '_ycysh', search_storage['ycysh']);
            fun.setItem(html_name + '_hldj', search_storage['hldj']);
            fun.setItem(html_name + '_xsmx', search_storage['xsmx']);

            fun.setItem(html_name + 'sideslip', true);

            page_list = [];
            getList(search_data);
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });

}


fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');

    // console.log(fun.getItem(html_name+'_'+'djlx'))
    // console.log(fun.getItem(html_name+'_'+'djlx_text'))
    // console.log(typeof fun.getItem(html_name+'_'+'sx_cglhjs'))
    // console.log(typeof fun.getItem(html_name+'_'+'sx_cgthjs'))

    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "dh_wrap": {
            "key": "dh",
            "value": search_storage['dh'] || "",
            "placeholder": "采购订单单号"
        },
        "choose_merchants": [
            {
                key: "gys",
                "text": "供应商",
                "value": (search_storage['gys'] && search_storage['gys']['text']) || "",
                "id": (search_storage['gys'] && search_storage['gys']['id']) || 0,
                is_yarn: 1
            }, {
                key: "cp",
                "text": "纱线",
                "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
                "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
                is_yarn: 1
            }, {
                key: "cp_lb",
                "text": "纱线类别",
                "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
                "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
                is_yarn: 1
            }, {
                key: "ck",
                "text": "仓库",
                "value": (search_storage['ck'] && search_storage['ck']['text']) || "",
                "id": (search_storage['ck'] && search_storage['ck']['id']) || 0,
                is_yarn: 1
            }, 
            {
                key: "sx_pp",
                "text": "品牌",
                "value": (search_storage['sx_pp'] && search_storage['sx_pp']['text']) || "",
                "id": (search_storage['sx_pp'] && search_storage['sx_pp']['id']) || 0,
            }, 
            {
                key: "sx_dq",
                "text": "地区",
                "value": (search_storage['sx_dq'] && search_storage['sx_dq']['text']) || "",
                "id": (search_storage['sx_dq'] && search_storage['sx_dq']['id']) || 0,
            },
            {
                key: "gg",
                "text": "规格",
                "value": (search_storage['gg'] && search_storage['gg']['text']) || "",
                "id": (search_storage['gg'] && search_storage['gg']['id']) || 0,
                is_yarn: 1
            },
             {
                key: "md",
                "text": "门店",
                "value": (search_storage['md'] && search_storage['md']['text']) || "",
                "id": (search_storage['md'] && search_storage['md']['id']) || 0,
            },
            {
                key: "hz",
                "text": "汇总",
                "group": [
                    // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                    { key: 'dh', name: '单号', columns: hz_group_columns.dh, choose: getHz('dh') },
                    { key: 'wldw', name: '供应商', columns: hz_group_columns.wldw, choose: getHz('wldw') },
                    { key: 'cp', name: '纱线', columns: hz_group_columns.cp, choose: getHz('cp') },
                    { key: 'cp_ys', name: '颜色', columns: hz_group_columns.cp_ys, choose: getHz('cp_ys') },
                    { key: "hsdj", name: '单价', columns: hz_group_columns.hsdj, choose: getHz('hsdj') },
                    { key: "sx_pp", name: '品牌', columns: hz_group_columns.sx_pp, choose: getHz('sx_pp') },
                    { key: "sx_dq", name: '地区', columns: hz_group_columns.sx_dq, choose: getHz('sx_dq') },
                    { key: "gg", name: '规格', columns: hz_group_columns.gg, choose: getHz('gg') }

                ],
                "value": getTwo('hz', 'text'),
            }
        ],
        'xs': [
            {
                "key": 'djlx',
                "text": "单据类型",
                "xsType": (((fun.getItem(html_name + '_' + 'djlx') || []).join(',')) || 'sx_cglhjs,sx_cgthjs'),
                "list": [
                    { 'name': '来货', 'column': 'sx_cglhjs', 'is_choose': fun.getItem(html_name + '_' + 'sx_cglhjs') == 0 ? 0 : 1 },
                    { 'name': '退货', 'column': 'sx_cgthjs', 'is_choose': fun.getItem(html_name + '_' + 'sx_cgthjs') == 0 ? 0 : 1 },
                ],
                "alone": false,
                "value": (fun.getItem(html_name + '_' + 'djlx_text') || "来货、退货"),
            }],

        "switch": [
            {
                "text": "隐藏已审核单据",
                "max_width": true,
                "key": "ycysh",
                "value": (!!fun.getItem(html_name + '_ycysh') ? fun.getItem(html_name + '_ycysh') : 0)
            },
            {
                "text": "显示明细数据",
                "max_width": true,
                "key": "xsmx",
                "value": (!!fun.getItem(html_name + '_xsmx') ? fun.getItem(html_name + '_xsmx') : 0)
            },
            {
                "text": "合拢单据",
                "max_width": true,
                "key": "hldj",
                "value": (!!fun.getItem(html_name + '_hldj') ? fun.getItem(html_name + '_hldj') : 0)
            }
        ],
    }
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false)
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

// 退货结算-开单
$('body').on('tap', '.increase-retreat', function () {
    if (!fun.checkKz()) return;
    tlhjskd('sx_cgthjs', 'cgthjs_dj');
});

// 来货结算-开单
$('body').on('tap', '.increase-come', function () {
    if (!fun.checkKz()) return;
    tlhjskd('sx_cglhjs', 'cglhjs_dj');
});

// 来退货结算开单
function tlhjskd(djlx, table) {
    // 页面顺序  供应商 -> 选产品 -> 选颜色 -> 开单编辑
    // 默认读取有权限浏览的最后一张来/退货结算的仓库
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBillsPageDefInfo,
        data: {
            'djlx': djlx,
            'table': table
        },
        success: function (res) {
            var __PAGE_INFO = {};
            if (res.status === 0) {
                __PAGE_INFO = { ck_id: res.data.ck_id };
            }

            var kd_url;
            if (djlx === 'sx_cglhjs') {
                kd_url = page_arr.cg_lhjs_kd;
            } else if (djlx === 'sx_cgthjs') {
                kd_url = page_arr.cg_thjs_kd;
            }

            const __route = [
                {
                    url: page_arr.customer_search,
                    page_data: {
                        djlx: djlx,
                        return_page: html_name,
                        page_type: 'gys',
                        type: djlx,
                        wldw_tmp: {
                            return_page: html_name,
                            page_type: 'gys',
                            djlx: djlx,
                            getBillsPageDefInfo: AJAX_URL.getBillsPageDefInfo
                        },
                        __PAGE_INFO: __PAGE_INFO,
                        loadScdj: true
                    }
                },
                {
                    url: page_arr.choice_product,
                    page_data: {
                        djlx: djlx,
                        return_page: html_name,
                        cp_tmp: {
                            return_page: html_name
                        }
                    }
                },
                {
                    url: kd_url,
                    page_data: {}
                }
            ];

            fun.showPageFull({
                page_url: __route[0].url,
                pageParam: $.extend({}, { __route: __route }, __route[0]['page_data'])
            });
        }
    });
}

//时间控件
var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getList(search_data);
        }
    });


/** 获取来退货结算数据
 * @param {*} data
 */
function getList(data) {
    page_list = [];
    //暂时使用这种方式访问api接口，如果没有这个就会访问不到
    data['djlx'] = search_data['djlx'] || ["sx_cglhjs", "sx_cgthjs"];

    console.log('search_data', data);
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL['getSxCglthjstj'],
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj1').text(0);
                    $('#tj2').text(0);
                    $('#tj3').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: '#order_list', btnShow: false });
                }
                ztj_data = res['info'];
                fun.clearPage($('#order_list'));
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createKeysValueFun: function (obj) {
                        return {
                            "wldw_mc": obj['wldw_mc'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "md_id": obj['md_id'],
                            "is_sh": obj['is_sh'],
                            "ysje": obj['ysje'],
                            "dj_ps": fun.is_value(obj['dj_ps'], 0),
                            "dj_zsl": fun.is_value(obj['dj_zsl'], 0),
                            "dj_je": fun.is_value(obj['dj_je'], 0),
                            "zdw_mc_tmp": fun.is_value(obj['zjjdw_mc']),  // 总计价单位名称
                            "djlx": obj['djlx']
                        };
                    }
                });
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}

function showList(data) {
    // 合计赋值
    $('#tj1').text(ztj_data[0]['ps'] || 0);
    // $('#tj2').text(ztj_data[0]['zsl'] || 0);
    $('#tj2').text(ztj_data[0]['jjsl'] || 0);
    $('#tj3').text(ztj_data[0]['hszje'] || 0); //含税总金额

    // var kzxx = JSON.parse(fun.getItem('sys_config')['kzxx']); //获取开账信息
    // kzxx = JSON.stringify(kzxx['cbhs'])
    // switch(JSON.parse(kzxx)) {
    //     case 'hs':
    //         $('#tj3').text(ztj_data['je'] || 0); //总金额
    //         break;
    //     case 'bhs':
    //         break;
    // }
    // var i;
    var hldj = fun.getItem(html_name + '_hldj', 0)
    var xsmx = fun.getItem(html_name + '_xsmx') == 1 ? true : false;
    
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !hldj,
        isNoExpand: xsmx,
        render: {
            titlebar: function (res) {
                return fthStatistics.createTitlebar(res, {
                    showPrice: true,
                    search_data: search_data
                });
            },
            subtitle: function (res) {
                return fthStatistics.createSubtitle(res, {
                    search_data: search_data
                });
            },
            subdata: function (res) {
                return fthStatistics.createSubdata(res, {
                    search_data: search_data,
                    showPrice: true,
                    ps_tmp: res.ps,
                    sl_tmp: res.jjsl,
                    dw_tmp: res.jjdw_mc
                });
            }
        },
    });
}

fun.tjContentTap(function (dj_data) {
    if (!fun.checkKz()) return;
    var page_url;
    if (!Auth.check(dj_data['djlx'], 'view')) return;
    switch (dj_data['djlx']) {
        case 'sx_cglhjs': //来货结算
            page_url = page_arr.sxcg_lhjs;
            break;
        case 'sx_cgthjs': //退货结算
            page_url = page_arr.sxcg_thjs;
            break;
    }
    if ($.nui.isEmpty(dj_data['dj_id'])) return;
    fun.showPageFull({
        page_url: page_url,
        pageParam: {
            return_page: html_name,
            dj_id: dj_data['dj_id'] || 0,
        }
    });

    return;
    if (!fun.checkKz()) return;

    if (data_list.djlx === 'sx_cglhjs') {
        page_url = page_arr.cg_lhjs_kd;
    } else if (data_list.djlx === 'sx_cgthjs') {
        page_url = page_arr.cg_thjs_kd;
    }

    var id = data_list.dj_id,
        dh = data_list.dh,
        wldw_id = data_list.wldw_id,
        wldw_mc = data_list.wldw_mc,
        kdsj = data_list.kdsj,
        zdr = data_list.zdr_mc;

    if ($.nui.isEmpty(id)) return;

    fun.showPageFull({
        page_url: page_url,
        pageParam: {
            return_page: html_name,
            id: id,
            dh: dh,
            wldw_id: wldw_id,
            wldw_mc: wldw_mc,
            kdsj: kdsj,
            zdr: zdr
        }
    })
});

$('body').on('click', '.row-list', function () {
    if (fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var list = $(this).children('.summary').children('.summary-content').data('list');
    if ($.nui.isEmpty(list['dj_id'])) return;
    var page_url;
    if (!Auth.check(list['djlx'], 'view')) return;
    switch (list['djlx']) {
        case 'sx_cglhjs': //来货结算
            page_url = page_arr.sxcg_lhjs;
            break;
        case 'sx_cgthjs': //退货结算
            page_url = page_arr.sxcg_thjs;
            break;
    }

    fun.showPageFull({
        page_url: page_url,
        pageParam: {
            return_page: html_name,
            dj_id: list['dj_id']
        }
    });
    return
    if (fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var data_list = $(this).children('.summary').children('.summary-content').data('list');
    if (data_list.djlx === 'sx_cglhjs') {
        page_url = page_arr.cg_lhjs_kd;
    } else if (data_list.djlx === 'sx_cgthjs') {
        page_url = page_arr.cg_thjs_kd;
    }

    var id = data_list.dj_id,
        dh = data_list.dh,
        wldw_id = data_list.wldw_id,
        wldw_mc = data_list.wldw_mc,
        kdsj = data_list.kdsj,
        zdr = data_list.zdr_mc;

    if ($.nui.isEmpty(id)) return;

    fun.showPageFull({
        page_url: page_url,
        pageParam: {
            return_page: html_name,
            id: id,
            dh: dh,
            wldw_id: wldw_id,
            wldw_mc: wldw_mc,
            kdsj: kdsj,
            zdr: zdr
        }
    })
})