var obj, title;
var html_name = page_arr.sxkc_hdb_mx;

var search_storage = [];

page_init = function () {
    // console.log(JSON.stringify(page_data))
    obj = page_data.obj || "cloth";
    title = page_data.title;
    search_storage = page_data.search_storage;
    search_storage['ck_id'] = page_data.ck.id || 0;

    search_storage['cp_id'] = page_data.hdb_params.cp_id || 0;
    search_storage['cp_bh'] = page_data.hdb_params.cp_bh || 0;
    search_storage['cp_mc'] = page_data.hdb_params.cp_mc || 0;
    search_storage['cp_ys_id'] = page_data.hdb_params.cp_ys_id || 0;
    search_storage['sx_pp'] = page_data.hdb_params.pp || '';
    search_storage['sx_dq'] = page_data.hdb_params.dq || '';
    search_storage['gg'] = page_data.hdb_params.gg || '';
    search_storage['dw_id'] = page_data.hdb_params.dw_id || 0;
    search_storage['dw_mc'] = page_data.hdb_params.dw_mc || '';

    search_storage['begin_time'] = search_storage.begin_date;
    search_storage['end_time'] = search_storage.end_date;
    search_storage['hide_zf'] = 1;
    search_storage['group'] = "cp_id,cp_ys_id,sx_pp,sx_dq,gg,dw_id";


    $('#ck_name').text(page_data.ck.select_val);
    $('#query_date').text(search_storage.begin_date + '~' + search_storage.end_date);

    $('#header').header({
        back: true,
        title: title
    });
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showClothList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
    initPage(obj);
}

function initPage(obj) {
    switch (obj) {
        case 'yarn':
            var order_data = [{
                wldw_mc: '客户名称',
                md_mc: '单据类型',
                zdr_mc: '制单人',
                kdsj: '2018-05-28 15:30',
                dh: 'CDD1812270006',
                list: [{
                    cp_pp: '品牌',
                    cp_mc: '名称',
                    cp_sh: '色号',
                    cp_ys: '颜色',
                    dq: '地区',
                    xz: '性质',
                    gg: '规格',
                    ph: 'XXX',
                    qc: 30,
                    rk: 30,
                    qm: 30,
                }, {
                    cp_pp: '品牌',
                    cp_mc: '名称',
                    cp_sh: '色号',
                    cp_ys: '颜色',
                    dq: '地区',
                    xz: '性质',
                    gg: '规格',
                    ph: 'XXX',
                    qc: 30,
                    rk: 30,
                    qm: 30,
                }],
            },];
            showList(order_data);

        function showList(data) {
            $('#order_list').OrderList({
                data: data,
                schedule: false,
                render: {
                    titlebar: function (res) {
                        return [
                            '<div class="title-bar-row">',
                            '    <div><span style="color:' + res['color_val'] + '">' + fun.is_value(res['wldw_mc']) + '</span></div>',
                            '    <div class="align-right" ><a>' + fun.is_value(res['md_mc']) + '</a>&nbsp;<a>' + fun.is_value(res['zdr_mc']) + '</a></div>',
                            '</div>',
                            '<div class="title-bar-row">',
                            '    <div><span>' + fun.is_value(res['kdsj']) + '</span></div>',
                            '    <div class="align-right" ><a>' + fun.is_value(res['dh']) + '</a></div>',
                            '</div>',
                        ].join('');
                    },
                    subtitle: function (res) {
                        return [
                            '<div class="row">',
                            '     <div>' + fun.is_value(res['cp_mc']) + '</div>',
                            '     <div class="align-right">' + fun.is_value(res['cp_pp']) + '</div>',
                            '</div>',
                            '<div class="row">',
                            '     <div>' + fun.is_value(res['cp_sh']) + '+' + fun.is_value(res['cp_ys']) + '</div>',
                            '     <div class="align-right"><a>' + fun.is_value(res['dq']) + '</a><a>' + fun.is_value(res['xz']) + '</a></div>',
                            '</div>',
                            '<div class="row">',
                            '     <div><a>' + fun.is_value(res['gg']) + '</a></div>',
                            '     <div class="align-right"><a>批号</a>' + fun.is_value(res['ph']) + '</div>',
                            '</div>',
                        ].join('')
                    },
                    subdata: function (res) {
                        return [
                            '<div class="row">',
                            '    <div><span>期初</span><span>' + fun.is_value(res['qc']) + '</span></div>',
                            '    <div><span>入库</span><span>' + fun.is_value(res['rk']) + '</span></div>',
                            '</div>',
                            '<div class="row">',
                            '    <div><span>期末</span><span>' + fun.is_value(res['qm']) + '</span></div>',
                            '</div>',
                        ].join('');
                    }
                },
            });
        }

            break;
        case 'cloth':
            getList(search_storage);
            break;

    }
}


function showClothList(data) {
    var isnumber = search_storage['type']['number'];

    function queCon(res, key) {
        return function (key) {
            var map = isnumber ? {
                qc: "qc_sl",
                lc: "lc_sl",
                rk: "rk_sl",
                ck: "ck_sl",
            } : {
                qc: "qc_ps",
                lc: "lc_ps",
                rk: "rk_ps",
                ck: "ck_ps",
            }
            if (isnumber) {
                return (parseFloat(res[map[key]])) || 0;
            } else {
                return parseFloat(res[map[key]]) || 0;
            }
        }
    }

    function getFKKZ(fk, kz) {
        if ((!fk || !kz)) {
            return "";
        } else {
            return (fk + (fk && kz ? 'x' : "") + (kz));
        }
    }

    $('#order_list').empty();
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        render: {
            titlebar: function (res) {

                var djlx_mc = res['djlx_mc'] || '';
                djlx_mc = djlx_mc.replace(/销售发货结算/g,'销售开单');
                djlx_mc = djlx_mc.replace(/销售退货结算/g,'销售退单');

                return [
                    // '<div class="title-bar-row">',
                    // '    <div><span style="color:' + res['color_val'] + '">' + fun.is_value(res['wldw_mc'], "") + '</span></div>',
                    // '    <div class="align-right" ><a>' + fun.is_value(res['djlx_mc'], "") + '</a>&nbsp;<a>' + fun.is_value(res['zdr_mc']) + '</a></div>',
                    // '</div>',
                    // '<div class="title-bar-row">',
                    // '    <div><span>' + fun.is_value(fun.dateFormat(res['kdsj'])) + '</span></div>',
                    // '    <div class="align-right" ><a>' + fun.is_value(res['dh']) + '</a></div>',
                    // '</div>',
                    '<div class="title-bar-row bar-kc-hdbmx">',
                    '    <div><span class="font-bold">' + fun.is_value(res['wldw_mc'], "") + '</span></div>',
                    '    <div class="align-right font-ss" ><a>' + fun.formatTime(fun.dateFormat(res['kdsj'])) + '</a>&nbsp;<a>' + fun.is_value(res['zdr_mc']) + '</a></div>',
                    '</div>',
                    '<div class="title-bar-row bar-cgbj" style="width: 100%;">',
                    '    <div style="width: 100%;" class="font-ss paddingbm color-gray"><span>' + fun.is_value(djlx_mc, "") + '&nbsp;:&nbsp;</span><span>' + fun.is_value(res['dh']) + '</span></div>',
                    '</div>',
                ].join('');
            },
            subtitle: function (res) {
                return [
                    '<div class="row row-2">',
                    '     <div>' +  fun.is_value(res['cp_mc']) + ' ' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</div>',
                    '</div>',
                    '<div class="row">',
                    '     <div><span class="color-gray">品牌</span><span>' + fun.is_value(res['sx_pp']) + '</span></div>',
                    '     <div><span class="color-gray">地区</span><span>' + fun.is_value(res['sx_dq']) + '</span></div>',
                    '     <div><span class="color-gray">规格</span><span>' + fun.is_value(res['gg']) + '</span></div>',
                    '</div>',
                ].join('')
            },
            subdata: function (res) {
                var qc = queCon(res);
                return [
                    '<div class="row row-2 bg-gray">',
                    '    <div><span class="color-gray">&nbsp;&nbsp;期初</span><span>' + qc('qc') + '</span></div>',
                    qc('rk') > 0 ?
                        '    <div><span class="color-gray">入库</span><span>' + qc('rk') + "" + (isnumber ? res['dw_mc'] : "") + '</span></div>' :
                        '    <div><span class="color-gray">出库</span><span>' + qc('ck') + "" + (isnumber ? res['dw_mc'] : "") + '</span></div>',
                    '    <div><span class="color-gray">期末</span><span>' + qc('lc') + '</span></div>',
                    '</div>',
                ].join('');

            }
        },
    });
}


function getList(data) {
    function convertData(apidata) {
        if (JSON.stringify(apidata) == "[]")
            return [];
        if ((!(apidata instanceof Array))) {
            return "参数错误";
        }

        var list = [], tmp = {};
        $(apidata).each(function (i, obj) {
            if (!tmp[obj["dh"]]) {
                tmp[obj["dh"]] = {
                    "wldw_mc": obj['wldw_mc'],
                    "md_mc": obj['md_mc'],
                    "zdr_mc": obj['zdr_mc'],
                    "kdsj": obj['kdsj'],
                    "dh": obj['dh'],
                    "djlx_mc": obj['djlx_mc'],
                }
                tmp[obj["dh"]]['list'] = [];
            }
            tmp[obj["dh"]]['list'].push(obj);
        })
        for (var i in tmp) {
            list.push(tmp[i]);
        }
        return list;
    }

    var tmpdata = $.extend(true, {}, data);
    tmpdata['type'] = 'hdb_lsz';
// console.log(JSON.stringify(tmpdata))
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSxHdbList,
        data: tmpdata,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                page_list = convertData(res.data);
                showClothList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}

// var date_arr = fun.getMonthArr(6),
//     date_bar = $('#date_bar').dateBar({
//         'data': date_arr,
//         'tap': function (ret) {
//             var begintime = fun.Date(ret['begin_date']).Format('yy-mm-dd');
//             var endtime = fun.Date(ret['end_date']).Format('yy-mm-dd');
//         }
//     });
