var html_name = page_arr.sxkc_kcfx,
    obj, text_val,
    list = [];
search_data = {
    type: (!Auth.check('yxcksxcbj', 'view')) ? 'ps' : 'cb',       //类型
    limit: fun.getItem('sxkc_top') ? fun.getItem('sxkc_top')['id'] : 10,       //条数
    top: fun.getItem('sxkc_top') ? fun.getItem('sxkc_top')['id'] : 10,      //数量
    get_type: 'kcfx',
};
var USER_INFO = {};
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));
    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    if(!Auth.check('yxcksxcbj', 'view')) {
        $('.cb-line').hide();
        $('.ls-line').addClass('active').siblings().removeClass('active');
    }
    search_data['xs'] = page_data['xs'];
    $('body').on('touchend', '#complete_btn', function (e) {
        e.preventDefault();
        var list = [
            {id: 10, name: "TOP 10", is_choose: 1},
            {id: 20, name: "TOP 20", is_choose: 0},
            {id: 30, name: "TOP 30", is_choose: 0}
        ];
        for (var i = 0; i < list.length; i++) {
            if (!fun.getItem('sxkc_top')) break;
            if (list[i]['id'] == fun.getItem('sxkc_top')['id']) {
                list[i]['is_choose'] = 1;
            } else {
                list[i]['is_choose'] = 0;
            }
        }
        fun.showBookList({
            list: list,
            choose: function (res) {
                search_data['limit'] = res['id'];
                fun.setItem('sxkc_top', {'id': res['id'], 'name': res['name']});
                $('#complete_btn').text(res['name']);
                getList();
            }
            // return true;
        });
    })
    getList();
    obj = page_data.obj;
    $('#header').header({
        back: true,
        title: '全部库存',
        text_btn: true, //文字按钮
        text_val: fun.getItem('sxkc_top') ? fun.getItem('sxkc_top')['name'] : 'TOP 10' //文字按钮值
    });
    $('.cut > li:visible').eq(0).addClass('active');
    $('.cut > li:visible').eq(0).addClass('set-radius');
    if($('.cut > li:visible').length===2){
        $('.cut').css({width:'40%'});
        $('.sx_cut .show-list').css({width:'50%'});
    }
    //切换，
    $('.show-list').on('tap', function () {
        $(this).addClass('active').siblings().removeClass('active');
        search_data['type'] = $('.active').attr('gooas-id');
        $('.empty_bottom').remove();
        $('.store-list').empty();
        getList();
    });
    //滚动到底提示
    fun.scrollToBottom({}, function () {
        if (list.length > 0) {
            appendList(fun.PagingData(list, 5)); 
        }
        else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('content_list', ".store");
        }
    });
}


function getList() {
    // console.log('==>'+JSON.stringify(search_data));
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getMobileSxkc,
        data: search_data,
        success: function (res) {
            showData(res || '');
        }
    })
}

function showData(data) {
    // console.log(JSON.stringify(data))
    var listPs = [];
    var list = data['list'];
    //合计
    var total = Math.round((data['hj'] || 0) * 10) / 10;
    var text = '';
    var ck_data = [];
    var text_arr = {'ps': '总粒数', 'sl': '总数量', 'cb': '总成本'};
    var text_dw = {'ps': '粒', 'sl': '', 'cb': '元'};
    if (list != null) {
        //调整临时高度
        $('.content').css({'height': 'auto', 'position': 'unset'});
        var close = [];//存负数数据
        for (var i = 0; i < list.length; i++) {
            var value = (list[i]['value'] || 0);
            var colour = order_color[i % order_color.length];
            listPs.push('<div class="store lower-border-line">');
            listPs.push('   <div class="store-top">');
            listPs.push('       <span class="store-id">' + (i + 1) + '.</span>');
            listPs.push('       <div class="store-box" style="background:' + colour + ';"></div>');
            listPs.push('       <span class="store-title dot">' + list[i]['ck_mc'] + '</span>');
            listPs.push('   </div>');
            listPs.push('   <div class="bot">');
            // listPs.push('       <span class="all">' + text_arr[data['type']] + ':</span>');
            listPs.push('       <span class="all-m ">' + value + text_dw[data['type']] + '</span>');
            listPs.push('   </div>');
            listPs.push('</div>');

            if (value < 0 || value === 0) {
                close.push({'value': value, 'name': list[i]['ck_mc']});
            }else {
                ck_data.push({'value': value, 'name': list[i]['ck_mc']});
            }
    

        }
    } else {
        //调整临时高度
        $('.content').css({'height': '40%', 'position': 'fixed'});
        // $('.content').html('<p class="empty_text">暂无数据！</p>');
        return fun.createDataEmptyTips({dom:'.content',btnShow:false});
    }
    $('.store-list').empty();
    $('.store-list').append(listPs.join(''));
    ck_data = (list.length === close.length) ? close : ck_data;
    var myChart = echarts.init(document.getElementById('cost'));
    var option = {
        title: [{
            text: text_arr[data['type']],
            x: 'center',
            top: '45%',
            textStyle: {
                color: '#a5a5a5',
                fontStyle: 'normal',
                fontWeight: '600',
                fontFamily: 'sans-serif',
                fontSize: 12
            }
        }, {
            text: total,
            x: 'center',
            top: '50%',
            textStyle: {
                color: '#000',
                width: '50%',
                fontStyle: 'normal',
                fontWeight: '400',
                fontFamily: 'sans-serif',
                fontSize: 16
            }
        }],
        tooltip: {
            trigger: 'item',
            formatter: "{b} ({d}%)<br/>{a}: {c} "
        },
        series: [{
            name: text_arr[data['type']],
            type: 'pie',
            color: order_color,
            radius: ['60%', '80%'],
            avoidLabelOverlap: true,
            label: {
                normal: {
                    show: false,
                    position: 'center'
                }

            },
            labelLine: {
                normal: {
                    show: false
                }
            },
            data: ck_data
        }]
    };
    // pie = echarts.init(obj);
    myChart.setOption(option);
    myChart.on('click', function (param) {//不监听会报错
        return;
    });
}