var html_name = page_arr.sxkc_tbd;
var to_month = fun.getLatelyTime(1,false);//获取时间

//要查询的数据
//data: {"begin_time":"2019-03-04","end_time":"2019-04-03","ck_id":0,"cp_id":0,"cp_ys_id":0,"cp_lb_id":0,"group":"","xszf":false}
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    "ck_id": 0,
    "dcck_id": 0,
    "cp_id": 0,
    "cp_ys_id": 0,
    "cp_lb_id": 0,
    "group": "",
    "xszf": false,
};

//搜索页数据
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

//头部样式
$('#header').header({
    back: true,
    filter: true,
    title: '调拨单'
});

var page_list = [];
var USER_INFO = {};
var hz_group_columns = {
    'dh': 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc,ck_id,ck_mc',
    'ck': 'ck_id,ck_mc',
    'cp': 'cp_bh,cp_mc',
    'cp_ys': 'cp_ys_bh,cp_ys_mc',
    "drck": 'drck_id,drck_mc',
    "sx_pp": 'sx_pp',
    "sx_dq": 'sx_dq',
    // "fkkz": 'fk,kz',
    "gg": 'gg'
};

//页面加载完后加载
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var hnh = html_name + '_';
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = (fun.getItem(html_name + '_' + 'hz') || '')

    search_storage = $.extend(true, {
        hldj: fun.getItem(hnh + 'hldj', 0),
        xsmx: fun.getItem(hnh + 'xsmx', 0),
        "hz": {
            "choose": {
                "md_mc": fun.getItem(hnh + 'md_mc', 0),
                "dh": fun.getItem(hnh + 'dh', 1),
                "ck": fun.getItem(hnh + 'ck', 1),
                "drck": fun.getItem(hnh + 'drck', 1),
                "cp": fun.getItem(hnh + 'cp', 1),
                "cp_ys": fun.getItem(hnh + 'cp_ys', 1),
                "sx_pp": fun.getItem(hnh + 'sx_pp', 0),
                "sx_dq": fun.getItem(hnh + 'sx_dq', 0),
                // "fkkz": fun.getItem(hnh + 'fkkz', 0),
                "gg": fun.getItem(hnh + 'gg', 0)
            },
            "text": fun.getItem(hnh + 'text', ""),
        }
    }, search_storage);

    // console.log(search_storage);

    search_data = $.extend({}, search_data, search_storage);
    fun.initGroupOfSearchData(search_data, search_storage.hz.choose, hz_group_columns, ',dw_id,dw_mc');
    getList(search_data);

    //接收搜索页的数据
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        // console.log(ret);
        var temp = ret.value;

        switch (temp['status']) {
            case 'search':
                var param = ret.value.data;
                search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
                search_data['begin_time'] = param.begin_date;                   //开始时间
                search_data['end_time'] = param.end_date;                       //结束时间
                search_data['cp_id'] = param.cp['id'] || '';                    //纱线
                search_data['cp_lb_id'] = param.sx_lb['id'] || 0;             //纱线类别
                search_data['ck_id'] = param.ck['id'] || '';                    //调入仓库
                search_data['dcck_id'] = param.dcck['id'] || '';                    //调出仓库
                search_data['md_id'] = param.md['id'] || '';                    //门店
                search_data['xszf'] = param['xszf'];                            //作废单据
                search_data['hldj'] = param['hldj'];                            //合拢单据
                search_data['xsmx'] = param['xsmx'];                            //显示明细数据

                //搜索菜单需要缓存的数据
                search_storage['keyword'] = search_data['keyword'];
                search_storage['begin_date'] = search_data['begin_time'];
                search_storage['end_date'] = search_data['end_time'];
                search_storage['cp'] = param.cp;
                search_storage['cp_lb'] = param.sx_lb;
                search_storage['ck'] = param.ck;
                search_storage['dcck'] = param.dcck;
                search_storage['md'] = param.md;
                search_storage['xszf'] = search_data['xszf'];
                search_storage['hldj'] = search_data['hldj'];
                search_storage['xsmx'] = search_data['xsmx'];

                //设置时间控件时间
                date_bar.setDate(search_storage);
                fun.setItem(html_name + '_xszf', search_storage['xszf']);
                fun.setItem(html_name + '_hldj', search_storage['hldj']);
                fun.setItem(html_name + '_xsmx', search_storage['xsmx']);

                //汇总功能
                search_data['group'] = param.hz['group'] || '';
                search_storage['hz'] = param.hz;
                var hc = param['hz']['choose'];
                search_storage['hz']['choose'] = hc;

                fun.setItem(hnh + 'md_mc', hc['md_mc']);
                fun.setItem(hnh + 'dh', hc['dh']);
                fun.setItem(hnh + 'ck', hc['ck']);
                fun.setItem(hnh + 'drck', hc['drck']);
                fun.setItem(hnh + 'cp', hc['cp']);
                fun.setItem(hnh + 'cp_ys', hc['cp_ys']);
                // fun.setItem(hnh + 'fkkz', hc['fkkz']);
                fun.setItem(hnh + 'sx_pp', hc['sx_pp']);
                fun.setItem(hnh + 'sx_dq', hc['sx_dq']);
                fun.setItem(hnh + 'gg', hc['gg']);
                fun.setItem(hnh + 'text', param.hz['text']);
                fun.setGroupCondition(search_data, 'dw_id,dw_mc');

                // if (!!search_data['group']) {
                //     var group_data = search_data['group'];
                //     group_data += ',dw_id,dw_mc';
                //     search_data['group'] = group_data;
                // }
                fun.setItem(html_name + '_' + 'hz', search_data['group']);
                fun.setItem(html_name + 'sideslip', true);

                getList(search_data);
                break;
            case 'refresh':
                getList(search_data);
                break;
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
}

//获取最近6个月
var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            getList(search_data);
        }
    });

//获取数据
function getList(data) {
    page_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getSxtbdtj,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#zps').text(0);
                    $('#zsl').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                ztj_data = res['info'];
                $('#order_list').empty();
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    hzDhFun: function (obj) {
                        return obj['dh'] + '_' + obj['ck_mc'] + '_' + obj['drck_mc'];
                    },
                    hzCpOrYsFun: function (obj) {
                        return obj['md_mc'] + '_' + obj['zdr_mc'] + '_' + obj["kdsj"] + '_' + obj["dh"] + '_' + obj['md_mc'] + '_' + obj['ck_mc'] + '_' + obj['drck_mc'] + '_' + obj['md_id'] + '_' + obj["cp_bh"] + '_' + obj["cp_mc"] + '_' + obj["cp_ys_bh"] + '_' + obj["cp_ys_mc"];
                    },
                    hzOthersFun: function (obj) {
                        return obj['ck_mc'] + '_' + '_' + obj['drck_mc'] + obj['md_mc'] + '_' + obj['zdr_mc'] + '_' + obj["kdsj"] + '_' + obj["dh"] + '_' + obj['md_id'];
                    },
                    createKeysValueFun: function(obj) {
                        return {
                            "ck_mc": obj['ck_mc'],
                            "drck_mc": obj['drck_mc'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "md_id": obj['md_id'],
                            "is_sh": obj['is_sh'],
                            "list": [],
                            "dj_zsl": obj["dj_zsl"],
                            "dj_ps": obj["dj_ps"],
                            "zdw_mc": obj["zdw_mc"]
                        }
                    }
                });
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.toast(res.msg);
            }
        }
    })
}

//动态加载数据
function showList(data) {
    $('#zps').text(ztj_data['zps'] || 0);
    $('#zsl').text(ztj_data['zsl'] || 0);
    var i;
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !search_storage['hldj'],
        isNoExpand: search_storage['xsmx'],
        render: {
            titlebar: function (res) {
                var info = res['list'][0];
                var Html = [];

                // 判断是否审核
                var is_shClass = res['is_sh'] ? 'button-blue' : 'button-gray';
                var is_shText = res['is_sh'] ? '已审核' : '未审核';
                var text_left = !res['ck_mc'] ? 'text-align: left;' : '';
                var marLeft_none = !res['ck_mc'] ? 'margin-left: 0;' : '';
                var overShow = res['kdsj'] || res['zdr'] || res['is_sh'] ? '' : 'show-dcck';
                var showLine = !res['ck_mc'] ? 'width: auto;' : '';

                Html.push('<div class="item-top border-bottom">');
                Html.push('    <div class="list-top-item">');

                // 有仓库名称才显示
                if (!!res['ck_mc']) {
                    Html.push('        <p class="dcck-name font-bold font-ls ' + overShow + '">' + fun.is_value(res['ck_mc']) + '</p>');
                }

                Html.push('        <div class="list-right" style="' + text_left + '">');
                Html.push('            <span class="time color-gray margin-right-s font-ss" style="' + showLine + '">' + fun.formatTime(res['kdsj']) + '</span>');
                Html.push('            <span class="zdr color-gray margin-right-s zdr-text-width font-ss" style="' + showLine + '">' + fun.is_value(res['zdr_mc']) + '</span>');

                // 有开启汇总不显示审核状态
                if (!search_data.group || (/dh/i.test(search_data.group) && res['is_sh'] !== undefined)) {
                    Html.push('            <span class="' + is_shClass + ' font-ss border-radius-s">' + is_shText + '</span>');
                }

                Html.push('        </div>');
                Html.push('    </div>');
                Html.push('    <div class="list-drck font-ms">');

                // 调入仓库名称才显示
                if (res['drck_mc']) {
                    Html.push('        <p class="color-gray  margin-right-5 font-ms">');
                    Html.push('            <span>调入 :</span>');
                    Html.push('            <span>' + fun.is_value(res['drck_mc']) + ',' + '</span>');
                    Html.push('        </p>');
                }

                var zdw_mc = fun.getHzUnitName(search_data['group'], res, 'zdw_mc');

                Html.push('        <p class="total-sum font-ms" style=' + marLeft_none + '>');
                Html.push('            <span class="color-gray">共</span>');
                Html.push('            <span class="drck-name">' + (fun.is_value(res.dj_ps, 0) + '粒' + fun.is_value(res.dj_zsl, 0) + zdw_mc) + '</span>');
                Html.push('        </p>');
                Html.push('    </div>');
                Html.push('</div>');
                return Html.join('');
            },
            subtitle: function (res) {
                // console.log(res);
                // var div_style = !res['gg'] ? 'style="width:50%;"' : '';
                var htmlArr = [];

                var cp_bh_mc = !!res['cp_mc'];
                var ys_bh_mc = !!res['cp_ys_bh'] || !!res['cp_ys_mc'];
                // var is_show_fkkzgg = (search_data['group'].indexOf('fk') > -1) || (search_data['group'].indexOf('kz') > -1) || (search_data['group'].indexOf('gg') > -1); // 幅宽克重规格有一个找得到就显示

                htmlArr.push('<div class="item-bottom">');

                // 有纱线名称 或 纱线颜色编号才显示
                if (cp_bh_mc || ys_bh_mc) {
                    htmlArr.push('    <p class="cp-info font-ms">');
                    htmlArr.push('        <span>' + fun.is_value(res['cp_mc']) + '</span>');
                    htmlArr.push('        <span>' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</span>');
                    htmlArr.push('    </p>');
                }

                htmlArr.push(fun.createPpDqGgHtml(search_data, res,true));

                htmlArr.push('</div>');

                return htmlArr.join('');
            },
            subdata: function (res) {
                // 获取汇总单位名称
                var dwmc = fun.getUnitName(search_data['group'], res, 'dw_mc');
                return '<p class="cp-ps-gj bg-gray font-ms">' + res['ps'] + '粒 ' + res['zsl'] + '' + dwmc + '</p>';
            }
        },
    });
}
//存储一个值用于判定是否打开搜索页//值为false即为打开
fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    var n = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [{
            key: "cp",
            "text": "纱线",
            "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
            "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
            is_yarn: 1
        }, {
            key: "cp_lb",
            "text": "纱线类别",
            "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
            "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
            is_yarn: 1
        }, {
            key: "ck",
            "text": "调入仓库",
            "value": (search_storage['ck'] && search_storage['ck']['text']) || "",
            "id": (search_storage['ck'] && search_storage['ck']['id']) || 0,
            is_yarn: 1
        }, {
            key: "dcck",
            "text": "调出仓库",
            "value": (search_storage['dcck'] && search_storage['dcck']['text']) || "",
            "id": (search_storage['dcck'] && search_storage['dcck']['id']) || 0,
            is_yarn: 1
        }, {
            key: "md",
            "text": "门店",
            "value": (search_storage['md'] && search_storage['md']['text']) || "",
            "id": (search_storage['md'] && search_storage['md']['id']) || 0,
        },
        {
            key: "hz",
            "text": "汇总",
            //加工商、单号、门店、纱线、颜色
            group: [
                // { key: 'md_mc', name: '门店', columns: 'md_id, md_mc', choose: getHz('md_mc') },
                { key: 'dh', name: '单号', columns: hz_group_columns.dh, choose: getHz('dh') },
                { key: 'ck', name: '调出仓库', columns: hz_group_columns.ck, choose: getHz('ck') },
                { key: 'cp', name: '纱线', columns: hz_group_columns.cp, choose: getHz('cp') },
                { key: 'cp_ys', name: '颜色', columns: hz_group_columns.cp_ys, choose: getHz('cp_ys') },
                { key: "drck", name: '调入仓库', columns: hz_group_columns.drck, choose: getHz('drck') },
                // { key: "fkkz", name: '幅宽克重', columns: hz_group_columns.fkkz, choose: getHz('fkkz') },
                { key: "sx_pp", name: '品牌', columns: hz_group_columns.sx_pp, choose: getHz('sx_pp') },
                { key: "sx_dq", name: '地区', columns: hz_group_columns.sx_dq, choose: getHz('sx_dq') },
                { key: "gg", name: '规格', columns: hz_group_columns.gg, choose: getHz('gg') }
            ],
            "value": getTwo('hz', 'text'),
        }
        ],
        "switch": [{
            "text": "显示明细数据",
            "max_width": true,
            "key": "xsmx",
            "value": (!!fun.getItem(html_name + '_xsmx') ? fun.getItem(html_name + '_xsmx') : 0)
        },{
            "text": "合拢单据",
            "max_width": true,
            "key": "hldj",
            "value": (!!fun.getItem(html_name + '_hldj') ? fun.getItem(html_name + '_hldj') : 0)
        },]
    }
    if (n) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

$('body').on('tap', '#add_btn', function () {
    return
    if (!fun.checkKz()) return;
    // 页面顺序， 选择纱线 -> 选择颜色 -> 开单编辑 -> 调拨单编辑
    // 默认读取有权限浏览的最后一张调拨单的调出仓库
    // 查找仓库信息。获取单号接口，有返回
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBillsPageDefInfo,
        data: {
            djlx: 'kc_bptbd',
            table: 'kc_bptbd_dj'
        },
        success: function (res) {
            if (!res) {
                res = {};
            }
            res.data = res.data || {};

            var ck_id = res.data.ck_id || 0;
            var dcck_id = res.data.dcck_id || 0;
            const route = [
                {
                    url: page_arr.choice_product,
                    page_data: {
                        djlx: 'kc_bptbd',
                        cp_tmp: {
                            __PAGE_INFO: {  // 仓库信息
                                ck_id: ck_id,
                                dcck_id: dcck_id,
                            }
                        },
                        return_page: page_arr.kc_dbd,
                        // BILL_PAGE: page_arr.kc_dbd_edit,
                        // LIST_PAGE: page_arr.kc_dbd,
                    }
                },
                {
                    url: page_arr.select_list,
                    page_data: {
                        page_type: 'cp_ys',
                    }
                },
                {
                    url: NEW_BILLS?page_arr.bills_zsmx:page_arr.single_editor,
                    page_data: {
                        return_page: page_arr.choice_product
                    }
                },
                {
                    url: page_arr.kc_dbd_edit,
                    page_data: {
                        return_page: page_arr.kc_dbd
                    }
                }
            ];

            fun.showPageFull({
                page_url: route[0].url,
                pageParam: $.extend(true, { __route: route }, route[0]['page_data'])
            });
        }
    })
});

// 调拨单编辑 详情跳转
fun.tjContentTap(function (data_list) {
    return;
    if (!fun.checkKz()) return;
    if (data_list['dj_id']) {
        fun.showPageFull({
            page_url: page_arr.kc_dbd_edit,
            pageParam: {
                return_page: html_name,
                id: data_list['dj_id'],
                dh: data_list['dh'],
                kdsj: data_list['kdsj'],
                zdr: data_list['zdr_mc']
            }
        });
    }
});

function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

$('body').on('click','.row-list',function(){
    return
    if(fun.getItem(html_name + '_xsmx', 0)) return;
    if (!fun.checkKz()) return;
    var data_list = $(this).children('.summary').children('.summary-content').data('list');
    if (data_list['dj_id']) {
        fun.showPageFull({
            page_url: page_arr.kc_dbd_edit,
            pageParam: {
                return_page: html_name,
                id: data_list['dj_id'],
                dh: data_list['dh'],
                kdsj: data_list['kdsj'],
                zdr: data_list['zdr_mc']
            }
        });
    }
})