var html_name = page_arr.urgent_level;
var label_arr = [],
    is_edit = false,
    color_index = 0,
    search_data = {};

var jjcd_list = [];
var UPDATE = { del_id: [], up: [], update: [] };
var _url_data = {};
var quest_url = '';
var save_url = '';
var type_data = false;

//样式数据 没用到
// var style_data = [
//     { id: 1, colour: '#FF2E2E', border: '#D12626' },
//     { id: 2, colour: '#FF5391', border: '#E14980' },
//     { id: 3, colour: '#FFD334', border: '#E1BA2E' },
//     { id: 4, colour: '#99D75A', border: '#8AC251' },
//     { id: 5, colour: '#38BB5C', border: '#35B057' },
//     { id: 6, colour: '#22D7BB', border: '#1EC0A7' },
//     { id: 7, colour: '#2CBDFF', border: '#26A3DC' },
//     { id: 8, colour: '#7076FB', border: '#6368DE' },
//     { id: 9, colour: '#C572EF', border: '#B167D7' },
//     { id: 10, colour: '#8d8d8d', border: '#8d8d8d' }
// ];
//标题栏
$('#header').header({
    back: true,
    title: ' ',
    edit: true,
    add: true,
    foot_input: {
        show: true,
        plader: '搜索',
    },
    appendBackBtnEvt: updatePrevPage
});

// TODO代码可优化
page_init = function () {
    var index = fun.getItem('color_index' + page_data['page_type']) || 0;
    if (index === 10) {
        index = 0;
    } else if (index === 0) {
        index = 0;
    } else {
        index = index + 1;
    }
    color_index = index || 0;
    var title;
    switch (page_data['page_type']) {
        case 'jjcd':
            title = '紧急程度';
            _url_data['type'] = 'jjcd';
            quest_url = AJAX_URL.getSimpleRecordList;
            save_url = AJAX_URL.saveSimpleRecord;
            break;
        case 'sx_jjcd':
            title = '紧急程度';
            _url_data['type'] = 'sx_jjcd';
            quest_url = AJAX_URL.getSimpleRecordList;
            save_url = AJAX_URL.saveSimpleRecord;
            break;
        case 'zt':
            title = '状态档案';
            if (page_data['url_type'] == 'xsdd') {
                _url_data['type'] = 'xsdd';
            } else if (page_data['url_type'] == 'wwjg') {
                _url_data['type'] = 'wwjg';
            } else if (page_data['url_type'] == 'cgdd') {
                _url_data['type'] = 'cgdd';
            } else if (page_data['url_type'] == 'sx_xsdd') {
                _url_data['type'] = 'sx_xsdd';
            } else if (page_data['url_type'] == 'sx_wwjg') {
                _url_data['type'] = 'sx_wwjg';
            } else if (page_data['url_type'] == 'sx_cgdd') {
                _url_data['type'] = 'sx_cgdd';
            } else if (page_data['url_type'] == 'sx_xzd') {
                _url_data['type'] = 'sx_xzd';
            }
            quest_url = AJAX_URL.getLabelList;
            save_url = AJAX_URL.saveLabelInfo;
            break;
    }
    $('#header_title').text(title);

    // $('#foot_search').select();
    page_data.keyback = updatePrevPage;//  监听返回键

    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        var temp = ret['value'],
            data = temp['data'];
        switch (temp.status) {
            case 'search':
                search_data['is_stop'] = data['is_stop'] || '';//是否显示停用
                fun.setItem(html_name + '_isStop', data['is_stop']);
                fun.setItem(html_name + 'sideslip', true);
                break;
            case 'refresh':
                getData();
                break;
        }
    });
    getData();

    fun.orderListHeight({ dom: '#list' });
};

function getData() {
    jjcd_list = [];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: quest_url,
        data: $.extend({
            "type": _url_data['type'],
        }, search_data),
        success: function (res) {
            if (res.status != 0) return fun.toast('获取信息失败！');
            var info_list = res.data;
            jjcd_list = [];

            jjcd_list = res.data.slice(0);

            if (jjcd_list.length === 0) {
                if (type_data) {
                    is_event(is_edit);
                }
                var btnText = (page_data['page_type'] == 'jjcd' || page_data['page_type'] == 'sx_jjcd') ? '新增紧急程度' : '新增状态档案';
                return fun.createDataEmptyTips({ dom: '#list', btnText: btnText, auth: '', isDa: true });
            }

            // console.log(JSON.stringify(info_list));
            showData(info_list);
            if (type_data) {
                is_event(is_edit);
            }
        }
    });
}

//保存数据
function saveData(opt, options) {
    var __options = $.extend({ callback: null }, options);
    var label_count = (($('.list-term').length < 1) ? 1 : $('.list-term').length);
    var params = {};
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: quest_url,
        data: {
            "type": page_data['page_type'] == 'zt' ? page_data['url_type'] : page_data['page_type']
        },
        success: function (res) {
            if (res.status != 0) return;
            var info_list = res.data;
            var info_data = [];
            var len = info_list.length - 1 || 0;
            for (var i = 0; i < info_list.length; i++) {
                info_data.push(info_list[i]);
                if (i == len) {
                    label_count = info_list[len]['sort'] + 1 || 1;
                }
            }
            switch (page_data['page_type']) {
                case 'jjcd':
                case 'sx_jjcd':
                    params = $.extend({}, {
                        "save_type": (opt && !!opt.save_type) ? opt.save_type : "save",
                        "type": _url_data['type'],
                        "data": [],
                        "delete_simple_record": []
                    }, opt);
                    params['data'] = info_data;
                    $('.list-term').each(function (i, list) {
                        if ($.nui.isEmpty($(list).attr('id'))) {
                            params['data'].push({
                                "id": $(list).attr('id') || 0,
                                "name": $(list).attr('name') || "",
                                "type": _url_data['type'],
                                // "colour": $(list).attr('colour') || '',
                                "sort": $(list).find('.text').attr('sort') || label_count,
                                "remark": $(list).attr('remark') || '',
                                config: { colour: $(list).attr('colour') || '' }
                            });
                        }
                    });
                    break;
                case 'zt':
                    params = $.extend({}, {
                        "save_type": (opt && !!opt.save_type) ? opt.save_type : "save",
                        "type": _url_data['type'],
                        "label": []
                    }, opt);
                    $('.list-term').each(function (i, list) {
                        params['label'].push({
                            "id": $(list).attr('id') || 0,
                            "name": $(list).attr('name') || "",
                            "type": _url_data['type'],
                            "colour": $(list).attr('colour') || '',
                            "sort": $(list).find('.text').attr('sort') || label_count,
                            // "sort": (i + 1),
                            "remark": $(list).attr('remark') || ''
                        });
                    })
                    break;
            }
            //删除
            if (opt && opt.save_type == "delete") {
                params['id'] = opt.id || 0;
                delete params['label'];
            }

            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: save_url,
                data: params,
                success: function (res) {
                    // console.log(JSON.stringify(res));
                    switch (res.status) {
                        case 0:
                            if (params.save_type == 'delete') {
                                fun.toast('删除成功!');
                                UPDATE['del_id'].push(params['id']);
                            } else {
                                switch (page_data['page_type']) {
                                    case 'jjcd':
                                    case 'sx_jjcd':
                                        UPDATE['update'] = params['data'];
                                        UPDATE['up'] = params['data'];
                                        break;
                                    case 'zt':
                                        UPDATE['update'] = params['label'];
                                        UPDATE['up'] = params['label'];
                                        break;
                                }

                                fun.toast('保存成功!');
                            }
                            if (typeof __options['callback'] === 'function') __options['callback']();
                            $('#add_btn').css('visibility', 'visible');

                            // getData();
                            api.sendEvent({
                                name: html_name,
                                extra: {
                                    'status': 'refresh',
                                }
                            });
                            is_edit = true;
                            is_event(is_edit);
                            break;
                        case 103:
                            fun.dialog({
                                content: (opt['name'] || '') + '已被引用过，不能删除！',
                                btn: ['我知道了'],
                                width: '30%',
                                style: 'width: 85%; padding-top:0.3rem; border:none; background: #fff; border-radius: 0.5rem; '//position: absolute; top: 30%; left: 7.5%;
                            });
                            $('.btn-wrap button').css('width', '100%');
                            is_edit = true;
                            is_event(is_edit);
                            api.sendEvent({
                                name: html_name,
                                extra: {
                                    'status': 'refresh'
                                }
                            });
                            break;
                        case 104:
                            fun.toast("该状态已存在！");
                            is_edit = true;
                            is_event(is_edit);
                            api.sendEvent({
                                name: html_name,
                                extra: {
                                    'status': 'refresh'
                                }
                            });
                            break;
                        default:
                            fun.toast("保存失败！");
                            is_edit = true;
                            is_event(is_edit);
                            api.sendEvent({
                                name: html_name,
                                extra: {
                                    'status': 'refresh'
                                }
                            });
                            break;
                    }
                }
            });
        }
        // }
    });


}

//显示数据
function showData(data) {
    var html = [], label_arr;
    // label_arr = page_data['label_arr'].split(',');
    for (var i = 0; i < data.length; i++) {
        var val = data[i],
            bg_color = "background-color:" + val['colour'] + ";";

        var label_style = '';
        var label_colour = '';


        switch (page_data['page_type']) {
            case 'jjcd':
            case 'sx_jjcd':
                if ($.nui.isTrue(val['config']) && $.nui.isTrue(val['config']['colour'])) {
                    label_colour = val['config']['colour'];
                    label_style = 'background-color:' + label_colour + ';color:#fff;';
                }
                break;
            case 'zt':
                if ($.nui.isTrue(val['colour'])) {
                    label_colour = val['colour'];
                    label_style = 'background-color:' + label_colour + ';color:#fff;';
                }
                break;
        }

        if (!!label_arr && label_arr.indexOf(String(val['id'])) !== -1) {
            html.push('<li class="list-term" data-oriColor="' + label_colour + '" colour="' + label_colour + '" is="true" id="' + (val['id'] || 0) + '" name="' + val['name'] + '" remark="' + val['remark'] + '">');
            html.push('<div class="box" style="' + label_style + '" id="' + (val['id'] || 0) + '">');
        } else {
            html.push('<li class="list-term" data-oriColor="' + label_colour + '" colour="' + label_colour + '" is="false" id="' + (val['id'] || 0) + '" name="' + val['name'] + '" remark="' + val['remark'] + '">');
            html.push('<div class="box" style="' + label_style + '" id="' + (val['id'] || 0) + '">');
        }
        html.push('<span class="text" type="' + val['type'] + '" sort="' + val['sort'] + '">' + val['name'] + '</span>');
        html.push('</div>');
        html.push('<div class="pack"><i class="iconfont icon-fork fork"></i></div>');
        html.push('</li>');
    }
    $('#list').html(html.join(''));
}

//弹窗
function addLabel(node, status) {
    var html = [],
        style = 'width: 85%;  border:none; background: #fff; border-radius: 0.5rem; ',//position: absolute; top: 30%; left: 7.5%;
        value = (status == 'edit') ? (node.attr('name') || "") : "";
    html.push('<span class="label">' + ((status == 'add') ? "添加" : "修改") + '状态</span>');
    html.push('<input id="label_value" type="text" class="input-box" value="' + value + '" placeholder="状态"/>');
    html.push('<ul class="status-list"><li class="label-wrap">');
    html.push('<div class="circle1" color="#FF2E2E" data-bordercolor="#D12626" data-index="0"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#FF5391" data-bordercolor="#E14980" data-index="1"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#FFD334" data-bordercolor="#E1BA2E" data-index="2"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#99D75A" data-bordercolor="#8AC251" data-index="3"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#38BB5C" data-bordercolor="#35B057" data-index="4"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#22D7BB" data-bordercolor="#1EC0A7" data-index="5"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#2CBDFF" data-bordercolor="#26A3DC" data-index="6"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#7076FB" data-bordercolor="#6368DE" data-index="7"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#C572EF" data-bordercolor="#B167D7" data-index="8"><i class="iconfont icon-check status"></i></div>');
    html.push('<div class="circle1" color="#8d8d8d" data-bordercolor="#8d8d8d" data-index="9"><i class="iconfont icon-check status"></i></div>');
    html.push('</li></ul>')
    //暂时隐藏停用按钮
    // html.push('<div class="switch"><div class="nui-switch nui-switch-md nui-unactive nui-switch-btn stops">');
    // html.push('<div class="nui-switch-handle"></div></div>');
    // html.push('<span class="switch-title">停用</span></div>');

    var oriColor = '';

    fun.dialog({
        content: html.join(''),
        btn: ['保存', '取消'],
        style: style,
        isClose: false,
        yes: function () {
            var toast_text = (page_data['page_type'] == 'jjcd' || page_data['page_type'] == 'sx_jjcd') ? '标签' : '状态';
            var edit_name = $('#label_value').val().trim();
            if ($.nui.isEmpty(edit_name)) return fun.toast(toast_text + '名不能为空！');
            switch (status) {
                case 'add':
                    if (!!$("[name='" + edit_name + "']").attr('name')) return fun.toast("该" + toast_text + "已存在！");
                    var index = fun.getItem('color_index' + page_data['page_type']) || 0;
                    color_index = index || color_index;
                    $('.label-wrap div').eq(color_index).addClass('choice');
                    if (!$('#label_value').val()) {
                        return fun.toast('请输入' + toast_text + '名称！');
                    } else if ($('.choice').length < 1) {
                        return fun.toast('请选择' + toast_text + '颜色！');
                    }
                    $('#list').append([
                        '<li class="list-term" data-oriColor="' + $('.choice').attr('color') + '" colour="' + $('.choice').attr('color') + '" is="false" id="" name="' + $('#label_value').val() + '" remark="">',
                        ' <div class="box">',// style="background-color:' + $('.choice').attr('color') + ';"
                        '    <span class="text">' + $('#label_value').val() + '</span>',
                        '</div>',
                        '<div class="pack"><i class="iconfont icon-fork fork"></i></div>',
                        '</li>'
                    ].join(''));
                    saveData({}, {
                        callback: function () {
                            color_index = $('.choice').data('index') + 1 || 0;
                            if (color_index > 9) color_index = 0;
                            fun.setItem('color_index' + page_data['page_type'], color_index);
                            layer.closeAll();
                            // getData();
                        }
                    });


                    // layer.closeAll();
                    break;
                case 'edit':
                    var label_name = node.attr('name');
                    if (edit_name && edit_name != label_name) {
                        node.find('.text').text(edit_name);
                        node.attr('name', edit_name);
                        node.addClass('edit_label');
                        $('#label_value').select();
                    }
                    if (node.hasClass('edit_label')) {
                        saveData({}, {
                            callback: function () {
                                layer.closeAll();
                            }
                        });
                    }
                    break;
            }
        },
        success: function () {
            if (node) {
                oriColor = node.attr('colour');
            }
            $('body .no-padding .layui-m-layercont').css('border-radius', '0.5rem');
            $('.lay-warm .lay-warm-content').css({ 'display': 'block', 'min-height': '9rem', 'max-height': '9rem' });
        },
        no: function () {
            if (status == 'edit') {
                node.attr('colour', node.data('oriColor'));
                node.removeClass('edit_label');
            }
        }
    });


    if (status == 'edit') {
        $('.circle1').each(function () {
            if ($(this).attr('color') == node.attr('colour')) {
                $(this).addClass('choice');
            }
        });
    } else {
        var index = fun.getItem('color_index' + page_data['page_type']) || 0;
        color_index = index || color_index;
        $('.label-wrap div').eq(color_index).addClass('choice');
    }

    $('body').off('tap', '.circle1').on('tap', '.circle1', function () {
        $(this).addClass('choice').siblings().removeClass('choice');
        color_index = $('.choice').data('index') || 0;
        if (status == 'edit') {
            node.attr('colour', $(this).attr('color')).data('oriColor', oriColor);
            node.addClass('edit_label');
        } else {
            fun.setItem('color_index' + page_data.page_type, color_index);
        }
    })
}


function is_event(state) {
    if (!state) {
        $('#add_btn').css('visibility', 'hidden');
        $('.pack').show();
        $('.pack').addClass('changes');
        $('.list-term').addClass('label_shake');
        // Sortable.options.disabled = false;
        is_edit = true;
    } else {
        $('#add_btn').css('visibility', 'visible');
        $('.pack').hide();
        $('.pack').removeClass('changes');
        $('.list-term').removeClass('label_shake');
        // Sortable.options.disabled = true;
        is_edit = false;
    }
}


// 拖拽排序
// var Sortable = new Sortable($('#list')[0], {
//     animation: 150,
//     disabled: true,
//     onStart: function (evt) {
//         evt.stopPropagation();
//         $('.list-term').removeClass('label_shake');
//     },
//     onEnd: function (evt) {
//         $('.list-term').addClass('label_shake');
//         // saveData();
//     }
// });

//点击键盘搜索
// $("#foot_search").bind('search', function () {
//     search_data["keyword"] = $(this).val().trim();
//     $(this).select();
//     $('#list').empty();
//     getData();
// });
$('body').bind('search', "#foot_search", function (e) {
    // is_edit = false;
    search_data['keyword'] = $('#foot_search').val().trim();
    // $('#foot_search').select();
    $('#list').empty();
    getData();
    if (type_data) {
        is_event(is_edit);
        $('#add_btn').css('visibility', 'hidden');
    }
});
//选择标签
$('body').on('tap', '.list-term', function (event) {
    event.stopPropagation();

    if (!$(this).hasClass('label_shake')) {
        var index = $(this).index();
        var list_data = jjcd_list[index] || {};
        api.sendEvent({
            name: page_data.return_page,
            extra: {
                'status': 'select_list',
                data: {
                    'page_type': page_data['page_type'],
                    'list_data': list_data,
                    id: list_data['id'],
                    select_val: list_data['name']
                }
            }
        });

        setTimeout(function () {
            api.closeWin();
        }, 200);

        return;
    }

    if (!$('.pack').hasClass('changes')) {
        // var id = $(this).attr('id'),
        //     colour = $(this).attr('colour');
        // if ($(this).attr('is') == 'false') {
        //     if (label_arr.indexOf(id) == -1) {
        //         label_arr.push(id);
        //     }
        //     $(this).children('.box').css('background-color', colour);
        //     $(this).attr('is', 'true');
        // } else {
        //     if (label_arr.indexOf(id) > -1) {
        //         label_arr.splice(label_arr.indexOf(id), 1);
        //     }
        //     $(this).children('.box').css('background-color', '#e2e2e2');
        //     $(this).attr('is', 'false');
        // }
    } else {//处于编辑状态
        addLabel($(this), 'edit');
    }
    page_data['label_arr'] = label_arr.toString();
});

//点击编辑
$('body').on('tap', '#edit_btn', function () {
    type_data = true;
    is_event(is_edit);
});

//点击空白处
$('body').on('tap', '.content', function () {
    is_edit = true;
    type_data = false;
    is_event(is_edit);
});


//删除标签
$('body').on('tap', '.pack', function (event) {
    event.stopPropagation();
    var label_name = $(this).siblings('.box').children('span').text();
    var id = $(this).parent().attr('id');
    fun.dialog({
        content: '你确定要删除【' + label_name + '】吗?',
        btn: ['删除', '取消'],
        yes: function () {
            is_edit = true;
            is_event(is_edit);
            saveData({
                "save_type": "delete",
                "id": [id],
                "name": label_name
            });
        }
    });
})

//添加标签
$('body').on('tap', '#add_btn', function () {
    type_data = false;
    addLabel('', 'add');
});


function updatePrevPage() {
    var list_data = {};
    if ($.nui.isTrue(page_data['list_id'])) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: quest_url,
            data: {
                "type": page_data['page_type'] == 'zt' ? page_data['url_type'] : page_data['page_type']
            },
            success: function (res) {
                if (res.status != 0) return;
                var info_list = res.data;
                var info = {};
                for (var i = 0; i < info_list.length; i++) {
                    info = info_list[i];
                    if (page_data['list_id'] == info['id']) {
                        list_data = {
                            "id": info['id'] || 0,
                            "name": info['name'] || "",
                            "colour": page_data['page_type'] == 'zt' ? info['colour'] : info['config']['colour'],
                        };

                    }
                }
                UPDATE['page_type'] = page_data['page_type'];
                UPDATE['list_data'] = list_data;
                api.sendEvent({
                    name: page_data['return_page'],
                    extra: {
                        'status': 'update',
                        'data': UPDATE
                    }
                });
                setTimeout(function () {
                    api.closeWin();
                }, 200);
            }
        });
    } else {
        UPDATE['page_type'] = page_data['page_type'];
        api.sendEvent({
            name: page_data['return_page'],
            extra: {
                'status': 'uptype',
                'data': UPDATE
            }
        });
        setTimeout(function () {
            api.closeWin();
        }, 200);
    }
}
