var html_name = page_arr.welcome;
var propaganda_img = '',
    propaganda_id = '',
    propaganda_type = '',
    propaganda_url = '';

var socket;
var COMPANY_INFO = {};

var propaganda_data = {};

var propaganda_to_show = true;

page_init = function () {
    if(api.systemType!=='android'){
        $('.welcome-bg').css('backgroundSize','cover');
    }
    // $('#videoDom')[0].play();
    COMPANY_INFO = fun.getItem('company_info') || {};

    propaganda_data = fun.getItem('welcome_propaganda') || {};
    // 清除临时下载的弹窗变量
    fun.clearItem('temp_download_alert');
    // 清除临时下载的弹窗变量
    fun.clearItem('download_fialed_alert');
    
    api.removeLaunchView();
    // TODO
    // DBB_FIXED && VersionManager.removeAllPackage();


    if ($.nui.isEmpty(fun.getItem('welcomeNotPlayVideo'))) {
        $('#videoDom').show();
        $('#welBg').hide();
        $('body').removeClass('welcome-bg');
    } else {
        $('#videoDom').hide();
        $('#welBg').show();
        $('body').addClass('welcome-bg');
    }

    getWelcomeImg();

    api.addEventListener({
        name: 'smartupdatefinish'
    }, function (ret, err) {
        console.log(JSON.stringify(ret))
        if (ret && ret.value && ret.value.length) {
            try {
                var extra = ret.value[0]['extra'];
                if (typeof extra === 'string') {
                    try {
                        extra = JSON.parse(extra);
                    } catch (err) {
                    }
                }

                if ((typeof extra === 'object') && (extra['display'] == 1)) {
                    var msg = extra['msg'] || '1.优化部分细节体验';
                    // var title = '';
                    //
                    // if (CUSTOM_UPDATE_TIPS) {
                    //     title = '提示';
                    //     msg = msg + '\r\n';
                    // } else {
                    //     title = '提示';
                    //     msg = '本次修复:\r\n' + msg + '\r\n\r\n建议您重启应用。';
                    // }
                    //
                    // api.alert({
                    //     title: title,
                    //     msg: msg,
                    //     buttons: ['我知道了']
                    // }, function (ret, err) {
                    //     if (extra['reboot'] == 1) {
                    //         if (extra['relogin']) {
                    //             // 重新登录
                    //             fun.delAllItem(['theme_color', 'account_info', 'company_info', 'printer_local', 'printer_cloud', 'printer_lanya', 'printConfig', 'print_default_config']);
                    //         }
                    //         api.rebootApp();
                    //     }
                    // });

                    if(api.systemType === 'android' && extra['androidDisplay']) {
                        showFixedAlert();
                    } else if(api.systemType !== 'android' && extra['iosDisplay']) {
                        showFixedAlert();
                    }

                    function showFixedAlert() {
                        api.alert({
                            title: '提示',
                            msg: msg,
                            buttons: ['我知道了']
                        }, function (ret, err) {
                            if (extra['reboot'] == 1) {
                                if(extra['clearToolBar']) {
                                    fun.clearItem('quick_toolbar_data');
                                }
    
                                // 清除视频状态
                                if(extra['clearVideo']){
                                    fun.clearItem('welcomeNotPlayVideo');
                                }
    
                                if (extra['relogin']) {
                                    // 重新登录
                                    fun.logoutClearItem();
                                }
                                if (api.systemType === 'android') {
                                    extra['androidReboot'] && api.rebootApp();
                                } else {
                                    extra['iosReboot'] && api.rebootApp();
                                }
                            }
                        });
                    }
                }
            } catch (err) {
            }
        }
    });

    api.setStatusBarStyle({
        style: 'light',
        color: 'transparent'
    });

    if (ONLINE_SOCKET) {
        api.addEventListener({
            name: 'pause'
        }, function (ret, err) {
            // 进入后台、关闭屏幕
            try{
                closeWS();
                fun.clearItem('versionInfo');
            }catch(e){

            }
        });

        api.addEventListener({
            name: 'resume'
        }, function (ret, err) {
            api.hideProgress();
            // 获取信息
            fun.checkBaseVersion({
                callback: function(){
                    api.sendEvent({
                        name:'show_version_tips'
                    });
                }
            });

            // 由后台回到前台、打开屏幕
            try{
                linkWS();
            }catch(e){

            }
        });

        // 检测 用户是否操作了：退出、切换账套的操作
        var checkTokenAndBook = setInterval(function () {
            if ($.nui.isEmpty(fun.getItem('book_id'))) return false;

            var USER_INFO = fun.getItem('user_info') || {};

            var msg = '';
            if (fun.getItem('token') != USER_INFO['token']) {
                msg = '会话已失效，请重新登录！'
            } else if (fun.getItem('book_id') != USER_INFO['book_id']) {
                msg = '已切换账套，请刷新当前页面！';
            }

            if ($.nui.isTrue(msg)) {
                if (html_name == page_arr.welcome 
                    || html_name == page_arr.propaganda
                    || html_name == page_arr.login_enterprise
                    || html_name == page_arr.my_enterprise
                    || html_name == page_arr.more_set
                ) {
                } else {
                    fun.alert({
                        msg: msg,
                        callback: function () {
                            fun.logoutToLogin({rebot:true});
                        }
                    });
                }

                clearInterval(checkTokenAndBook);
            }
        }, 300);

        function clearCheckTokenAndBook() {
            clearInterval(checkTokenAndBook);
            console.log('clearCheckTokenAndBook');
        }

        linkWS();
    }

    if (LOG_DEVICE_INFO) {
        // console.log('应用的ID：' + api.appId)
        // console.log('应用名称：' + api.appName)
        // console.log('应用版本号：' + api.appVersion)
        // console.log('系统类型：' + api.systemType)
        // console.log('系统版本：' + api.systemVersion + (typeof api.systemVersion))
        // console.log('引擎版本：' + api.version)
        // console.log('设备标识：' + api.deviceId)
        // console.log('设备型号：' + api.deviceModel)
        // console.log('设备名称：' + api.deviceName)
        // console.log('网络状态：' + api.connectionType)
        // console.log('设备类型：' + api.uiMode)
        // console.log('navigator.userAgent',navigator.userAgent)
        // console.log('运营商名称：' + api.operator)
    }

    if(LOG_COMPATIBLE){
        // console.log('new Date()---' + new Date())
        // console.log('new Date("2020/03/12")---' + new Date("2020/03/12"))
        // console.log('new Date("2020-03-12")---' + new Date("2020-03-12"))
        // console.log('new Date("2020-03-12 12:12")---' + new Date('2020-03-12 12:12'))
        // console.log('new Date("2020/03/12 12:12")---' + new Date('2020/03/12 12:12'))
        // console.log('fun.formatDate("2020/03/12 12:12")---' + fun.formatDate('2020/03/12 12:12'))
        // console.log('fun.formatDate("2020-03-12 12:12")---' + fun.formatDate('2020-03-12 12:12'))
        // console.log('fun.formatDate(new Date(),"YYYY-MM-DD")---' + fun.formatDate(new Date(),'YYYY-MM-DD'))
    }

    mainPage();
};

function closeWS() {
    if (ONLINE_SOCKET) {
        console.log('--------------------------关闭socket------------------------')
        if (socket && (typeof socket.disconnect === 'function')) socket.disconnect();
        socket = undefined;
    }
}

function linkWS() {
    if (ONLINE_SOCKET) {
        closeWS();
        console.log('--------------------------链接socket------------------------')
        // 连接 在线服务
        socket = io(USER_URL, {
            path: '/user/socket.io', // 连接路径,因我们是使用二级路由所以需要在这里填写完整路径
            query: {
                'type': 'mobile', // 网页=web, 手机=mobile
                'token': fun.getItem('token') || '',
                'company_id': ($.nui.isTrue(COMPANY_INFO) ? COMPANY_INFO['company_id'] : 0),
                'app_version': APP_VERSION,
                'app_base_version': api.appVersion,
                'device_info': {
                    systemType: api.systemType,
                    systemVersion: api.systemVersion,
                    deviceId: api.deviceId,
                    deviceModel: api.deviceModel,
                    deviceName: api.deviceName,
                    connectionType: api.connectionType,
                    uiMode: api.uiMode
                }
            }
        });

        // 接收信息-事件
        socket.on('msg', function (data) {
            console.log(data);

            api.sendEvent({
                name: 'websocket_event',
                extra: {
                    res: data
                }
            });

            // switch (data['status']) {
            //     case 'ok':
            //         break;
            //     case 'OFF_LINE': // 被踢下线
            //         fun.alert({
            //             msg: data['msg'],
            //             callback: function () {
            //                 fun.logout();
            //             }
            //         });
            //         break;
            //     case 'DIALOG_MSG': // 弹出提示对话框
            //         fun.alert({
            //             msg: data['msg']
            //         });
            //         break;
            //     case 'TIPS_MSG': // 弹出 顶部提示框(3秒自动关闭)
            //         fun.toast(data['msg']);
            //         break;
            //     default:
            //         console.log(data);
            //         break;
            // }
        });
        // 链接断开-事件
        socket.on('disconnect', function (res) {
            console.log(res);
            console.log('断开连接', (new Date().getTime()));
        });
    }
}

function getWelcomeImg() {
    if ($.nui.isEmpty(fun.getItem('user_info'))) return;
    fun.ajax({
        showLoad: false,
        hideLoad: true,
        async: false,
        url: AJAX_URL.getPromoteInfo,
        data: {
            product: 'mobile'
        },
        success: function (res) {
            if (res['status'] == 0) {
                var data = res['data'] || {};
                if($.nui.isTrue(fun.getItem('propaganda_nolonger_show')) && $.nui.isObjEquals(data, propaganda_data)) {
                    propaganda_to_show = false;
                } else {
                    propaganda_to_show = true;
                    fun.setItem('propaganda_nolonger_show', 0);
                }
                fun.setItem('welcome_propaganda', data);//储存到本地，下一次则不用再去请求
                propaganda_img = data['img_url'];
                propaganda_url = data['link'];
                propaganda_type = 'url';
                propaganda_id = data['id'];
            }
        }
    })
}

function mainPage() {
    var welcomeTime = 2500;
    if ($.nui.isTrue(fun.getItem('welcomeNotPlayVideo')) && $.nui.isEmpty(propaganda_data)) {
        welcomeTime = 500;
    } else if ($.nui.isTrue(fun.getItem('welcomeNotPlayVideo')) && $.nui.isTrue(propaganda_data)) {
        welcomeTime = 500;
    }

    setTimeout(function () {
        fun.setItem('welcomeNotPlayVideo', 1);
        // propaganda_img //需要去拿后端的宣传图片
        if (propaganda_to_show && $.nui.isTrue(propaganda_img)) {//有值则跳转宣传页面
            fun.showPageFull({
                page_url: page_arr.propaganda,
                pageParam: {//把宣传图img传过去
                    img: propaganda_img,
                    type: propaganda_type,
                    url: propaganda_url,
                    id : propaganda_id,//广告id
                },
                hideAnimate: true
            });
        } else {
            if ($.nui.isTrue(fun.getItem('user_info'))) {
                var company_config = fun.getItem('user_info').company_config || {};
                var is_mask = company_config.is_mask;
                if($.nui.isTrue(is_mask)){
                   return fun.showPageFull({
                        page_url: page_arr.login_new,
                        closeWin: true
                    });
                }
                if(fun.getItem('is_yfw') == 0){
                    if($.nui.isTrue(fun.getItem('user_info')['is_admin'])){
                        fun.showPageFull({
                            page_url: page_arr.cloud_services,
                        });
                    }else{
                        fun.showPageFull({
                            page_url: page_arr.login_new,
                            closeWin: true
                        });
                        fun.dialog({
                            className: 'package-rebot-skin',
                            shadeClose: false,
                            content: '小云已搭乘808航班去追寻诗和远方了',
                            btn: ['我知道了'],
                            yes: function () {
                            }
                        })
                    }
                }else{
                    fun.showPageFull({
                        page_url: page_arr.index,
                    });
                }
            } else {
                fun.showPageFull({
                    page_url: page_arr.login_new,
                    pageParam: {
                    }
                });
            }
        }
    }, welcomeTime);
}


