var html_name = page_arr.xs_bfjl;
var cur_year = new Date().getFullYear();
var cur_month = new Date().getMonth() + 1;
cur_month = cur_month < 10 ? '0' + cur_month : cur_month;
// 头部
$('#header').header({
    back: true, //返回
    title: cur_year + '-' + cur_month, //标题
    add: true, //文字按钮
    text_val: 'TOP 10', //文字按钮值
    foot_input: {
        show: true,
        plader: '搜索'
    },
    text_btn: true, text_val: "今天"

});

$(".xia").click(function () {
    $(this).next().slideToggle(200);
});

/** 点击加号按钮 - 跳转 拜访计划-添加 */
function gotoBFJH_ADD() {
    fun.tap('#add_btn', function () {
        fun.showPageFull({
            page_url: page_arr.xs_bfjh_add
        });
    });
}

//点击标题 - 弹出时间
var begin_lCalendar = new lCalendar();
begin_lCalendar.init({
    'trigger': '#header_title',
    'type': 'date_month',
    callback: function (date) {
        $('#header_title').text(date);
    }
});


//#region 切换月份



function createDateSelect() {

    var monthDates = function (y) {
        var isLeapYear = function (year) {
            var flag;
            year % 4 === 0 ? (year % 100 !== 0 ? flag = 1 : (year % 400 === 0 ? flag = 1 : flag = 0)) : flag = 0;//闰年处理
            return flag;
        };
        return [31, 28 + isLeapYear(y), 31, 30, 31, 30, 31, 31, 30, 31, 30, 31];
    }

    var curyear = new Date().getFullYear();
    var curmonth = new Date().getMonth();
    var curMonthDays = monthDates(curyear)[curmonth];
    var monthTitleHtmlArr = [];
    monthTitleHtmlArr.push("            <div class=\"date-select\">");
    for (var i = 1; i <= curMonthDays; i++) {
        monthTitleHtmlArr.push("            <div class=\"month-item\">");
        monthTitleHtmlArr.push("                <span class=\"month-item-txt\">" + i + "</span>");
        monthTitleHtmlArr.push("                <span class=\"month-item-line\"></span>");
        monthTitleHtmlArr.push("            </div>");
    }
    monthTitleHtmlArr.push("            </div>");

    $('#dateSelect').html(monthTitleHtmlArr.join(''));


    $('.month-item').attr("tapmode", "");
    $('.month-item').off('tap').on('tap', function (event) {
        // event.stopPropagetion();
        var _this = this;
        $('.month-item').removeClass('active');
        $(_this).addClass('active');
    })
    var _curMonth = new Date().getMonth() + 1;
    var offLeftArr = [];
    var monthArr = [];
    $('.month-item').each(function (i, obj) {
        var offL = $(this).position().left;
        offLeftArr.push(offL);
        monthArr.push(i + 1);
        if (_curMonth == i + 1) {
            $('.month-item').removeClass('active');
            $(this).addClass('active');
        }
    })
    var offLeft = offLeftArr[monthArr.indexOf(_curMonth)];
    $('.date-select').scrollLeft(offLeft);



    fun.tap('.month-item .month-item-line', function (event) {

        var datearr = $('#header .header-title').text().split('-');
        var _curyear = datearr[0];
        var _curmonth = datearr[1];

        $('#dateSelect').addClass("hide");
        $('#calender').removeClass('hide');
        $('#off').removeClass("hide");
        fun.tap('#off', function () {
            $('#dateSelect').removeClass("hide");
            $('#off').addClass("hide");
            $('#calender').addClass('hide');
        });
        //打开日历
        $('#calender').calendar({
            year: _curyear,
            month: _curmonth,
            undoneProArr: [
                '20181023'
            ],
            doneProArr: [
                '20181022'
            ],
            slideEvt: function ($date) {
                var _month = $date.month < 10 ? '0' + $date.month : $date.month;
                var curdate = $date.year + '-' + _month;
                $('#header').header({
                    back: true, //返回
                    title: curdate, //标题
                    add: true, //文字按钮
                    text_val: 'TOP 10', //文字按钮值
                    foot_input: {
                        show: true,
                        plader: '搜索'
                    },
                    text_btn: true, text_val: "今天"

                });
            }
        });

        event.stopPropagetion();
    });
}
createDateSelect();



//#endregion



//#region 点击标题 - 展开、收缩

$('.dli-list').each(function () {
    var h = $(this).height();
    $(this).css('height', h + 'px');
});
$('.dli-title').off('tap').on('tap', function () {
    if ($(this).hasClass('active')) $(this).removeClass('active');
    else $(this).addClass('active');
})

/** 点击记录行 - 跳转 拜访计划-详情*/
function tapRecordRow() {
    $('.dli-list-item').off('tap').on('tap', function (event) {

        fun.showPageFull({
            page_url: page_arr.xs_bfjh_xq
        });
    })
}
//#endregion



//#region 滑动按钮

//左右滑动事件
function slideEvt(jqSelector, leftFunc, rightFunc) {
    $(jqSelector).off("touchstart").on("touchstart", function (e) {
        // 判断默认行为是否可以被禁用
        if (e.cancelable) {
            // 判断默认行为是否已经被禁用
            if (!e.defaultPrevented) {
                e.preventDefault();
            }
        }
        startX = e.originalEvent.changedTouches[0].pageX,
            startY = e.originalEvent.changedTouches[0].pageY;
    });
    $(jqSelector).off("touchend").on("touchend", function (e) {
        var _this = this;
        // 判断默认行为是否可以被禁用
        if (e.cancelable) {
            // 判断默认行为是否已经被禁用
            if (!e.defaultPrevented) {
                e.preventDefault();
            }
        }
        moveEndX = e.originalEvent.changedTouches[0].pageX,
            moveEndY = e.originalEvent.changedTouches[0].pageY,
            X = moveEndX - startX,
            Y = moveEndY - startY;
        var offset = 30;
        //左滑
        if (X < -offset) {
            if (typeof leftFunc == "function")
                leftFunc(_this);
        }
        //右滑
        else if (X > offset) {
            if (typeof rightFunc == "function")
                rightFunc(_this);
        }
        // //下滑
        // else if ( Y > 0) {
        // }
        // //上滑
        // else if ( Y < 0 ) {
        // }
        // //单击
        // else{
        // }
    });
}
//滑动显示按钮
function showSlideBtns() {
    slideEvt('.slide', function (self) {
        $(self).addClass('active');
    }, function (self) {
        $(self).removeClass('active');
    });
}
//设置滑动按钮事件
function setSlideBtnEvt() {

    var follow = $('.slide-btn[tname="follow"]');
    var done = $('.slide-btn[tname="done"]');
    var cancel = $('.slide-btn[tname="cancel"]');
    var del = $('.slide-btn[tname="del"]');

    //写跟进按钮
    fun.tap(follow, function (event) {
        event.stopPropagation();
        fun.showPageFull({
            page_url: page_arr.xs_bfjl_edit
        });
    });

    //取消按钮
    fun.tap(cancel, function (event) {
        event.stopPropagation();
        showCancelProjectHint();
    });

    //删除按钮
    fun.tap(del, function (event) {
        event.stopPropagation();
        showDelHint();
    });

}

//#endregion



//#region 弹出删除提示

function showDelHint() {
    $('#poput_win_del').removeClass('hide');
    $('#mask').removeClass('hide');
}
function hideDelHint() {
    $('#poput_win_del').addClass('hide'); 
    $('#mask').addClass('hide');
}
function confirmBtn(func) {
    $('#poput_win_del').off('tap').on('tap', 'button[name="confirmBtn"]', function (event) {
        setTimeout(function () {
            hideDelHint();
            func(event);
        }, 50);
    });
}
fun.tap('#poput_win_del', function () {
    setTimeout(function () {
        hideDelHint();
    }, 50);
}, '.popup-buttons button[name="cancelBtn"]');

//#endregion



//#region 弹出取消计划提示

function showCancelProjectHint() {
    $('#hintCancelPro').removeClass('hide');
    $('#mask').removeClass('hide');
}
function hideCancelProjectHint() {
    $('#hintCancelPro').addClass('hide');
    $('#mask').addClass('hide');
    $('#cancelProTxt').val('');
}
fun.tap('#hintCancelPro', function () {
    setTimeout(function () {
        hideCancelProjectHint();
    }, 50)
}, '.hintWin-buttons button[name="confirmBtn"]');
fun.tap('#hintCancelPro', function () {
    setTimeout(function () {
        hideCancelProjectHint();
    }, 80)
}, '.hintWin-buttons button[name="cancelBtn"]');

//#endregion



//PC端
if (1) {
    showSlideBtns();
    setSlideBtnEvt(); //电脑一点问题没有，可以正常触发这个事件
}


page_init = function () {
    gotoBFJH_ADD();
    tapRecordRow();
    showSlideBtns();
    setSlideBtnEvt();  //移动端就不行，一直触发不了：我手机的问题
}
