var html_name = page_arr.xs_bfjh_xq;
$('#header').header({
    back: true,
    del: true,
    title: '拜访详情'
});


//#region 设置中心部分的高度

function getWinHeight() {

    // 获取窗口宽度
    if (window.innerWidth)
        winWidth = window.innerWidth;
    else if ((document.body) && (document.body.clientWidth))
        winWidth = document.body.clientWidth;
    // 获取窗口高度
    if (window.innerHeight)
        winHeight = window.innerHeight;
    else if ((document.body) && (document.body.clientHeight))
        winHeight = document.body.clientHeight;
    // 通过深入 Document 内部对 body 进行检测，获取窗口大小
    if (document.documentElement && document.documentElement.clientHeight && document.documentElement.clientWidth) {
        winHeight = document.documentElement.clientHeight;
        winWidth = document.documentElement.clientWidth;
    }
    return {
        winHeight: winHeight,
        winWidth: winWidth
    };
}
function getHeadHeight() {
    var headH = $('#header').height();
    var headTitH = $("#clientNameTitle").height();
    return headH + headTitH;
}
function getFooterHeight() {
    return footerH = $('#footer').height();
}
function getContentHeight() {
    var winH = getWinHeight().winHeight;
    var contentH = winH - getHeadHeight() - getFooterHeight();
    return contentH;
}
$('#content').height(getContentHeight());

//#endregion


//点击遮罩关闭提示窗口
$('#mask').on('tap', function () {
    hideDelHint();
    hideSaveHint();
    hidePoputBottom();
});


//#region 弹出提示框：保存、不保存、取消

function showSaveHint() {
    $('#poput_win').removeClass('hide');
    $('#mask').removeClass('hide');
}
function hideSaveHint() {
    $('#poput_win').addClass('hide');
    $('#mask').addClass('hide');
}
//点击保存按钮
function saveBtnClick() {

}
//点击不保存按钮
function noSaveBtnClick() {

}
//点击保存取消按钮
function saveCancelBtnClick() {

}

//#endregion


//#region 弹出提示框：删除、取消

function showDelHint() {
    $('#poput_win_del').removeClass('hide');
    $('#mask').removeClass('hide');
}
function hideDelHint() {
    $('#poput_win_del').addClass('hide');
    $('#mask').addClass('hide');
}
function delHintDelBtn() {
    $('#delBtn').off('tap');
    $('#delBtn').on('tap', function () {
        setTimeout(function () {
            hideDelHint();
            api.closeWin();
        }, 50);
    });
}
function delHintCancelBtn() {
    $('#cancelDelBtn').off('tap');
    $('#cancelDelBtn').on('tap', function () {
        setTimeout(function () {
            hideDelHint();
        }, 50);
    });
}

//#endregion


// 点击头部右上角删除按钮时
$('#del_btn').on('tap', function () {
    showDelHint();
    delHintDelBtn();
    delHintCancelBtn();
});


//数据列表
var options = {
    check: false,
    dataList: [{
        titleBar: {
            name: '客户名称',
            subhead: {
                type: 1
            },
            store: '门店',
            making: '制单人',
            time: '2018-08-17 15:30',
            bill_num: 'SCDDHDSZOWEA',
        },
        data: [{
            titleOfBFJL: {
                content: "主要事宜",
                typeTxt: '意向客户',
                type: 0
            },
            list: [{
                column1: {
                    name: '拜访结果',
                    value: ''
                },

            }]
        }]
    },
    {
        titleBar: {
            name: '客户名称',
            subhead: {
                type: 0,
                txt: '联系人'
            },
            store: '门店',
            making: '制单人',
            time: '2018-08-17 15:30',
            bill_num: 'SCDDHDSZOWEA',
        },
        data: [{
            titleOfBFJL: {
                content: "主要事宜",
                typeTxt: '初次拜访',
                type: 1
            },
            list: [{
                column1: {
                    name: '拜访结果',
                    value: ''
                },
            }]
        }]
    }
    ]
}
$('#order_list').orderList(options);


//#region 设置从下往上弹出的 联系人信息

function hidePoputBottom() {
    var h = $('#contactMan').height();
    $('#contactMan').css('bottom', -h + 'px');
    $('#contactMan').removeClass('show');
    $('#mask').addClass('hide');
}
hidePoputBottom();
function showPoputBottomn() {
    $('#contactMan').addClass('show');
    $('#mask').removeClass('hide');
}

//#endregion

//设置联系人信息 按钮事件
function setContactBtnEvt() {
    var call = $('*[tname="call"]');
    fun.tap(call, function () {
        api.call({
            type: 'tel_prompt',
            number: '10086'
        });
    });

    var curlist1 = [
        {
            is_choose: 1,
            text: '百度地图',
            apitype: "bMap"
        },
        {
            is_choose: 0,
            text: '高德地图',
            apitype: "aMap"
        },
        {
            is_choose: 0,
            text: '腾讯地图',
            apitype: ""
        },
    ];
    $('*[tname="gps"]').off('tap').on('tap', function () {

        setTimeout(function () {
            //下方弹出联系人菜单 - 导航

            fun.showBookList({
                list: curlist1,
                choose: function (data, list, close) {

                    // $('*[tname="gps"]').text(data.text);
                    curlist1 = list;


                    var navigator = api.require('navigator');
                    navigator.installed({
                        target: data.apitype
                    }, function (ret, err) {
                        if (ret.status) {
                            console.log(JSON.stringify(ret));
                        } else {
                            console.log(JSON.stringify(err));
                        }
                    });


                    return true;
                }
            });

        }, 50);
    });
}


//#region 弹出取消计划提示

function showCancelProjectHint() {
    $('#hintCancelPro').removeClass('hide');
    $('#mask').removeClass('hide');
}
function hideCancelProjectHint() {
    $('#hintCancelPro').addClass('hide');
    $('#mask').addClass('hide');
    $('#cancelProTxt').val('');
}
fun.tap('#hintCancelPro', function () {
    setTimeout(function () {
        hideCancelProjectHint();
    }, 50)
}, '.hintWin-buttons button[name="confirmBtn"]');
fun.tap('#hintCancelPro', function () {
    setTimeout(function () {
        hideCancelProjectHint();
    }, 80)
}, '.hintWin-buttons button[name="cancelBtn"]');

//#endregion


//#region 底部导航栏

/** 底部导航栏  点击联系按钮时，从下弹出 */
function footerContact() {
    fun.tap('#contact', function () {
        showPoputBottomn();
    })
}


/** 底部导航栏  延期按钮跳转 */
function footerPostpone() {

    fun.tap('#postpone', function () {
        fun.showPageFull({
            page_url: page_arr.xs_bfjh_yq
        });
    });
}

/** 底部导航栏  延期按钮跳转 */
function footerWriteFollown() {
    $('#writeFollow').off('tap').on('tap', function () {
        fun.showPageFull({
            page_url: page_arr.xs_bfjl_edit
        });
    });
}

/** 底部导航栏  完成按钮 */
function footerFinish() {
    fun.tap('#finish', function () {


    });
}

/** 底部导航栏  取消按钮 */
function footerCancel() {
    fun.tap('#cancel', function () {
        showCancelProjectHint();
    });
}

function footerSetEvt() {
    footerContact();
    footerPostpone();
    footerWriteFollown();
    footerFinish();
    footerCancel();
    setContactBtnEvt();
}

//#endregion


footerSetEvt();
page_init = function () {
    footerSetEvt();
}
