var html_name = page_arr.xs_bfjl_edit;
var initInpDat = getInputData();
// 头部
$('#header').header({
    back: true, //返回
    title: '拜访记录', //标题
    del: true, //文字按钮
    appendBackBtnEvt: function (isOver) {

        //如果用户修改了数据则提示
        var lastInpDat = getInputData();
        var isEq = fun.compareObject(initInpDat, lastInpDat);

        if (!isEq) {
            showSaveHint();
            $('#saveBtn').off('tap');
            $('#saveBtn').on('tap', function () {

                //保存数据
                saveBtnClick();
                setTimeout(function () {
                    hideSaveHint();
                    isOver();
                }, 50);

            });

            $('#noSaveBtn').off('tap');
            $('#noSaveBtn').on('tap', function () {

                //不保存数据
                noSaveBtnClick();
                setTimeout(function () {
                    hideSaveHint();
                    isOver();
                }, 50);
            });

            $('#saveCancelBtn').off('tap');
            $('#saveCancelBtn').on('tap', function () {

                //取消保存数据
                saveCancelBtnClick();
                setTimeout(function () {
                    hideSaveHint();
                    // isOver();
                }, 50);
            });

            initInpDat = lastInpDat;
        } else {
            isOver();
        }
    }
});
//点击保存按钮
function saveHintSaveBtn() {

}
//点击不保存按钮
function saveHintNoSaveBtn() {

}
//点击保存取消按钮
function saveHintSaveCancelBtn() {

}

//点击客户跳转
$('#title_client').on('tap', function () {
    fun.showPageFull({
        page_url: page_arr.customer_search
    });
});

//#region 显示、隐藏提示框 方法封装
function showDelHint() {
    $('#poput_win_del').removeClass('hide');
    $('#mask').removeClass('hide');
}
function hideDelHint() {
    $('#poput_win_del').addClass('hide');
    $('#mask').addClass('hide');
}
function showSaveHint() {
    $('#poput_win').removeClass('hide');
    $('#mask').removeClass('hide');
}
function hideSaveHint() {
    $('#poput_win').addClass('hide');
    $('#mask').addClass('hide');
}

function showCameraHint() {
    $('#openCamera').removeClass('hide');
    $('#mask').removeClass('hide');
}
function hideCameraHint() {
    $('#openCamera').addClass('hide');
    $('#mask').addClass('hide');
}
/**
 * 删除提示弹出框 - 删除按钮
 * @param {Function} func 点击按钮后，要干什么
*/
function delHintDelBtn(func) {
    $('#delBtn').off('tap').on('tap', function () {
        setTimeout(function () {
            hideDelHint();
            func();
        }, 50);
    });
}

$('#cancelDelBtn').off('tap').on('tap', function () {
    setTimeout(function () {
        hideDelHint();
    }, 50);
});
//#endregion

// 头部 - 点击删除按钮 ‘垃圾桶’ 时
$('#del_btn').on('tap', function () {
    showDelHint();

    //删除提示 - 点击删除按钮后
    delHintDelBtn(function () {



    });
});

//获取 界面用户输入的数据
function getInputData() {
    var bfjlObj = {};
    bfjlObj['client'] = $('#inp_client').val();
    bfjlObj['status'] = $('#inp_status').val();
    bfjlObj['linkman'] = $('#inp_linkman').val();
    bfjlObj['post'] = $('#inp_post').val();
    bfjlObj['phone'] = $('#inp_phone').val();
    bfjlObj['mainEvt'] = $('#inp_mainEvt').val();
    bfjlObj['visitRet'] = $('#inp_visitRet').val();
    bfjlObj['position'] = $('#inp_position').val();
    bfjlObj['address'] = $('#inp_address').val();
    bfjlObj['nextTime'] = $('#inp_nextTime').val();
    bfjlObj['nextEvt'] = $('#inp_nextEvt').val();
    bfjlObj['remark'] = $('#inp_remark').val();
    return bfjlObj;
}

//默认显示今天时间
$('#top_date').text(fun.dateFormat('yyyy-MM-dd hh:mm'));

//点击遮罩关闭提示窗口
$('#mask').on('tap', function () {
    hideCameraHint();
    hideDelHint();
    hideSaveHint();
});

$('#cancelPhoto').on('click', function () {
    $('#openCamera').css('display', 'none');
    $('#mask').css('display', 'none');
});
//点击添加图片时，弹出询问框
$("#addImgBtn").on('tap', function () {

    setTimeout(function () {

        showCameraHint();
    }, 50);
});


var begin_lCalendar = new lCalendar();
begin_lCalendar.init({
    'trigger': '#top_date',
    'type': 'datetime',
    callback: function (date) {
        $('#top_date').text(date);
    }
});

var begin_lCalendar = new lCalendar();
begin_lCalendar.init({
    'trigger': '#inp_nextTime',
    'type': 'datetime',
    callback: function (date) {
        // $('#inp_nextTime').text(date);
        var week = fun.getWeek(date);
        var txt = date + ' ' + week;
        $('#inp_nextTime').text(txt);
    }
});

//拍照
function photograph(func) {
    $('#paizhao').off('tap').on('tap', function () {
        QuestPermission.requestPermission('camera', null,function () {
            api.getPicture({
                sourceType: 'camera',
                encodingType: 'jpg',
                mediaValue: 'pic',
                destinationType: 'url',
                allowEdit: true,
                quality: 50,
                targetWidth: 100,
                targetHeight: 100,
                saveToPhotoAlbum: false
            }, function (ret, err) {
                if (ret) {
                    func(ret);
                } else {
                    console.log(JSON.stringify(err));
                    func(err);
                }
            });
        });
        
    });
}

//从相册中选择
function fromPhoto(func) {
    $('#selectPhoto').off('tap').on('tap', function () {
        QuestPermission.requestPermission('camera', null,function () {
            api.getPicture({
                sourceType: 'album',
                encodingType: 'jpg',
                mediaValue: 'pic',
                destinationType: 'url',
                allowEdit: true,
                quality: 100,
                // targetWidth: 100,
                // targetHeight: 100,
                saveToPhotoAlbum: false
            }, function (ret, err) {
                if (ret) {
                    func(ret);
                } else {
                    console.log(JSON.stringify(err));
                    func(err);
                }
            });
        });
        
    });
}

//取消拍照
$('#cancelPhoto').off('tap').on('tap', function () {
    setTimeout(function () {
        hideCameraHint();
    }, 50);
});

//添加照片 - 弹出询问框 拍照、从相册中选择
$('#addImgBtn').off('tap').on('tap', function () {
    showCameraHint();
});

//#region 上传图片
$.fn.extend({
    parentFind: function (targetSelector, next) {
        var curEl = $(this);
        curEl = next ? next : curEl;
        if (curEl.parent().length == 0)
            return false;
        return curEl.parent(targetSelector).length ? curEl.parent(targetSelector).eq(0) : arguments.callee(targetSelector, curEl.parent());
    }
})

//删除图片按钮
function addCloseBtnEvt() {
    $('.close-btn').off('tap').on('tap', function () {
        var self = this;
        showDelHint();

        delHintDelBtn(function () {
            // var self = $(self);
            var parnode = $(self).parentFind('.img-item');
            parnode.remove();
        });
    });
}
addCloseBtnEvt();
//点击图片预览
function photoBrowserEvt(imgarr) {
    $('.img-item').off('tap').on('tap', '.img', function () {
        var photoBrowser = api.require('photoBrowser');
        photoBrowser.open({
            images: imgarr,
            placeholderImg: 'widget://res/img/apicloud.png',
            bgColor: '#000'
        }, function (ret, err) {
            if (ret) {
            } else {
            }
        });
    });
}

//添加图片
function addImgToImgs(path, maximgcount) {
    var _path = path, _maximgcount = maximgcount || 6;
    var imgcount = $('#uploadImgs').children().length - 1;
    if (imgcount >= _maximgcount) return false;

    var imgItemNode = $(`<div class="img-item">
                            <img class="img" src="${_path}" alt="1">
                            <div class="close-btn">X</div>
                        </div>
    `);
    $('#addImgBtn').before(imgItemNode);
    addCloseBtnEvt();
    var allimg = getAllImg();
    photoBrowserEvt(allimg);
}

//获取所有的图片
function getAllImg() {
    var imgs = $('#uploadImgs .img-item .img');
    var imgArr = [];
    imgs.each(function (i, obj) {
        imgArr.push(obj.src);
    });
    return imgArr;
}


//#endregion

//保存按钮
function bigSaveBtn() {
    $('#bigSaveBtn').off('tap').on('tap', function () {

        var inpdataObj = getInputData();
        if (!!!inpdataObj.client) {
            fun.toast('请选择客户');
        }
        else if (!!!inpdataObj.mainEvt) {
            fun.toast('请填写主要事宜');
        }
        else if (!!!inpdataObj.visitRet) {
            fun.toast('请填写拜访结果');
        }
        else if (!!inpdataObj.nextTime || !!inpdataObj.nextEvt || !!inpdataObj.remark) {

            if (!!!inpdataObj.nextTime) {
                fun.toast('请选择下次跟进时间');
            }
            else if (!!!inpdataObj.nextEvt) {
                fun.toast('请填写下次跟进事宜');
            }
        }
    })

}

page_init = function () {
    bigSaveBtn();
    photograph(function (ret) {
        if (!!ret.data) {
            addImgToImgs(ret.data);
            hideCameraHint();
        }
    });

    fromPhoto(function (ret) {
        if (!!ret.data) {
            addImgToImgs(ret.data);
            hideCameraHint();
        }
    });
}

fun.keyboardEject('#bigSaveBtn');
