var html_name = page_arr.xs_dykhdd;
var date_arr = fun.getMonthArr(6),
    to_month = fun.getMonthArr(1)[0];

var page_list = [];
var total_data = {};

var Bills = Bills || {};
var hjText = {};

var USER_INFO = {};
var SYS_CONFIG = {};
var wldw_kh_list = [];

var PAGE_DATA = {};
var begin_date = fun.Date(to_month['begin_date']).Format('yy.mm.dd');
var end_date = fun.Date(to_month['end_date']).Format('yy.mm.dd');

$('#date_range').text(begin_date + ' ~ ' + end_date);

var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
    "ycjd": 0,
    "ycywc": 0,
    "xscq": 0,
    "is_mobile": 1
};
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd')
};

var headerTitle = '';
var fieldConfig = {};

page_init = function () {
    // $('#order_list').css('min-height',($('.content').height() - ($('.number-list').height() + $('.show-time').height() + $('#date_bar').height() + $('#order_list').height())));
    USER_INFO = fun.getItem('user_info') || {};
    SYS_CONFIG = fun.getItem('sys_config') || {};

    if ($.nui.isTrue(page_data['__route'])) {
        PAGE_DATA = page_data['xsdykhdd_tmp'];
    } else {
        PAGE_DATA = page_data;
    }

    fun.load_DATA_LIST(['wldw_kh'], function () {
        wldw_kh_list = fun.getItem('wldw_kh_list') || [];
    });

    switch (PAGE_DATA['djlx']) {
        case 'bp_xsfhjs':
            hjText['wfps'] = '未发匹';
            hjText['wfsl'] = '未发数';
            headerTitle = '未发货的订单';
            fieldConfig['wfps'] = 'wfps';
            fieldConfig['wfsl'] = 'wfsl';
            break;
        case 'bp_xsthjs':
            hjText['wfps'] = '已发匹';
            hjText['wfsl'] = '已发数';
            headerTitle = '已发货的订单';
            fieldConfig['wfps'] = 'fhps';
            fieldConfig['wfsl'] = 'fhsl';
            break;
    }

    $('#header').header({
        back: true,
        filter: true,
        title: headerTitle
    });

    $('#wfps').text(hjText['wfps']);
    $('#wfsl').text(hjText['wfsl']);

    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');

    var hn = html_name + '_';
    // 页面加载，要先读取有记忆的搜索条件
    search_storage = $.extend(true, {
        // 'ycywc': fun.getItem(hn + 'ycywc', 1),
        // 'ycjd': fun.getItem(hn + 'ycjd', 1)
        'xsjd': fun.getItem(hn + 'xsjd', 0)
    }, search_storage);


    search_data['wldw_id'] = PAGE_DATA['wldw_id'] || 0;
    search_data['is_dy'] = 1;
    search_data['gxlx_id'] = (PAGE_DATA['gxlx_id'] || 0);
    search_data['is_dy_djlx'] = PAGE_DATA['djlx'];
    search_data['jl_id_notin'] = PAGE_DATA['jl_id_notin'] || [];
    // search_data['ycywc'] = search_storage['ycywc'] || 0;
    // search_data['ycjd'] = search_storage['ycjd'] || 0;
    search_data['xsjd'] = search_storage['xsjd'] || 0;
    getList(search_data);

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var param = ret.value.data;
        search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
        search_data['begin_time'] = param.begin_date;                   //开始时间
        search_data['end_time'] = param.end_date;                       //结束时间
        search_data['wldw_id'] = param.kh['id'] || 0;                 //供应商
        search_data['cp_id'] = param.cp['id'] || 0;                    //产品
        search_data['md_id'] = param.md['id'] || 0;                    //门店
        // search_data['ycywc'] = param['ycywc'];                //隐藏已结单记录
        // search_data['ycjd'] = param['ycjd'];                //隐藏已结单记录
        search_data['xsjd'] = param['xsjd'];                //显示已结单记录

        search_storage['keyword'] = param['LIKE_DATA'] || '';
        search_storage['begin_date'] = param.begin_date;                   //开始时间
        search_storage['end_date'] = param.end_date;                       //结束时间
        // search_storage['ycywc'] = param['ycywc'];                //隐藏已结单记录
        // search_storage['ycjd'] = param['ycjd'];                //隐藏已结单记录
        search_storage['xsjd'] = param['xsjd'];                //显示已结单记录

        search_storage['kh'] = param.kh;
        search_storage['cp'] = param.cp;
        search_storage['md'] = param.md;

        $('#date_range').text(fun.Date(param.begin_date).Format('yy.mm.dd') + ' ~ ' + fun.Date(param.end_date).Format('yy.mm.dd'));

        //缓存按钮开关
        // fun.setItem(hn + 'ycywc', param['ycywc']);
        // fun.setItem(hn + 'ycjd', param['ycjd']);
        fun.setItem(hn + 'xsjd', param['xsjd']);
        fun.setItem(html_name + 'sideslip', true);

        $('#order_list').empty();
        getList(search_data);
    });


    // fun.scrollToBottom({}, function () {
    //     if (page_list.length > 0) {
    //         showList(fun.PagingData(page_list) || []);
    //     } else {
    //         // fun.createBottomLine('order_list', ".list-wrap");
    //     }
    // });
};

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

function getList(data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpXsddtj,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#zps').text(0);
                    $('#zsl').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                total_data = res['info'];
                page_list = convertData(res.data);
                // showList(fun.PagingData(page_list) || []);

                showList(page_list);
            } else {
                fun.alert({msg: '网络异常！'});
            }
        }
    })
}

function convertData(apidata) {
    if ($.nui.isEmpty(apidata)) return [];
    if ((!(apidata instanceof Array))) {
        return "参数错误";
    }
    var list = [], tmp = {};
    $(apidata).each(function (i, obj) {
        if (!tmp[obj["dh"]]) {
            tmp[obj["dh"]] = {
                "dh": obj['dh'],
                "kdsj": obj['kdsj'],
                "zdr_mc": obj['zdr_mc'],
                "wldw_mc": obj['wldw_mc'],
                "md_mc": obj['md_mc'],
                dj_wfps: obj['dj_wfps'],
                dj_wfsl: obj['dj_wfsl'],
                dj_fhps: obj['dj_fhps'],
                dj_fhsl: obj['dj_fhsl'],
                zdw_mc: obj['zdw_mc']
            };
            tmp[obj["dh"]]['list'] = [];
        }
        tmp[obj["dh"]]['list'].push(obj);
    });
    for (var i in tmp) {
        list.push(tmp[i]);
    }

    return list;
}

function showList(data) {
    var t_ps = 0, t_sl = 0;
    switch (PAGE_DATA['djlx']) {
        case 'bp_xsfhjs':
            t_ps = total_data[0]['wfps'] || 0;
            t_sl = total_data[0]['wfsl'] || 0;
            break;
        case 'bp_xsthjs':
            t_ps = total_data[0]['fhps'] || 0;
            t_sl = total_data[0]['fhsl'] || 0;
            break;
    }

    $('#zps').text(t_ps);
    $('#zsl').text(t_sl);


    $('#order_list').OrderList({
        data: data,
        bindevent: false,
        // schedule: true,
        render: {
            titlebar: function (res) {
                var style = [];
                style.push('<div class="title-bar-row">');
                style.push('    <span class="check-box"><i class="iconfont icon-check"></i></span>');
                style.push('    <div><span  class="font-bold font-ls">&nbsp;' + fun.is_value(res['wldw_mc']) + '</span></div>');
                style.push('    <div class="align-right time-option" ><a>' + fun.is_value(res['md_mc']) + '</a>');
                style.push('<span class="font-ss"><a>' + fun.formatTime(res['kdsj']) + '</a></span>');
                style.push('&nbsp;<span class="font-ss"><a>' + fun.is_value(res['zdr_mc']) + '</a></span></div>');
                style.push('</div>');
                style.push('<div class="title-bar-row">');
                style.push('<div style="width: 55%;"><span class="color-gray">' + hjText['wfps'].substring(0, 2) + '&nbsp;</span>');
                style.push('<span>' + fun.is_value(res['dj_' + fieldConfig['wfps']], 0) + '匹&nbsp;</span>');
                style.push('<span>' + fun.is_value(res['dj_' + fieldConfig['wfsl']], 0) + fun.is_value(res['zdw_mc'], '') + '</span></div>');
                style.push('    <div style="width: 40%;" class="align-right number font-ss fixed-right" ><a>' + fun.is_value(res['dh']) + '</a></div>');

                style.push('</div>');
                return style.join('');
            },
            subtitle: function (res) {
                var title_html = [];
                // fkkz = fun.is_value(res['fk']) + (res['fk'] && res['kz'] ? "×" : "") + fun.is_value(res['kz']);
                title_html.push('<div class="row" data-list_data=\'' + fun.formatString(JSON.stringify(res)) + '\'>');
                title_html.push('<div>');
                title_html.push('<span class="check-box checkbox-option"><i class="iconfont icon-check"></i></span>');
                title_html.push('<span class="row-select">' + fun.is_value(res['cp_bh']) + ' ' + fun.is_value(res['cp_mc']) + '&nbsp;' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</span></div>');
                title_html.push('</div>');
                // title_html.push('<div class="row">');
                // title_html.push('     <div>' + fun.is_value(res['cp_ys_bh']) + ' ' + fun.is_value(res['cp_ys_mc']) + '</div>');
                // if (!!res['fk'] || !!res['kz']) {
                //     title_html.push('     <div class="align-right"><a>幅\\克</a>' + fkkz + '</div>');
                // }
                // title_html.push('</div>');
                return title_html.join('');
            },
            subdata: function (res) {
                var s_ps = 0, s_sl = 0;
                switch (PAGE_DATA['djlx']) {
                    case 'bp_xsfhjs':
                        s_ps = res['wfps'] || 0;
                        s_sl = res['wfsl'] || 0;
                        break;
                    case 'bp_xsthjs':
                        s_ps = res['fhps'] || 0;
                        s_sl = res['fhsl'] || 0;
                        break;
                }

                return [
                    '<div class="row row-option bg-gray top-margin">',
                    '    <div><span class="color-gray padd-left">订单匹</span><span>' + (res['ps'] || 0) + '</span></div>',
                    '    <div><span class="color-gray">' + hjText['wfps'] + '</span><span>' + (s_ps || 0) + '</span></div>',
                    '</div>',
                    '<div class="row row-option bg-gray border-radius">',
                    '    <div><span class="color-gray padd-left">订单数</span><span>' + (res['zsl'] || 0) + '</span></div>',
                    '    <div><span class="color-gray">' + hjText['wfsl'] + '</span><span>' + (s_sl || 0) + '</span></div>',
                    '</div>',
                ].join('');
            }
        },
    });

    $('.title-bar').off('tap');


    $('.check-box').removeClass('check-choice');
    setSelCount();

}

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').off('tap').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var disabled = $.nui.isTrue(PAGE_DATA['wldw_id']);
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'],
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage['begin_date'],
            "end_date": search_storage['end_date']
        },
        "choose_merchants": [
            {
                key: "kh",
                "text": "客户",
                "value": fun.getValByKey(wldw_kh_list || [], PAGE_DATA['wldw_id'], 'merchant_name') || getTwo('kh', 'text'),
                "id": PAGE_DATA['wldw_id'] || getTwo('kh', 'id'),
                "disabled": disabled
            }, {
                key: "cp",
                "text": "产品",
                "value": getTwo('cp', 'text'),
                "id": getTwo('cp', 'id'),
            }, {
                key: "md",
                "text": "门店",
                "value": getTwo('md', 'text'),
                "id": getTwo('md', 'id'),
            },
        ],
        "switch": [
            {
                // "text": "隐藏已发完记录",
                "text": "显示结单记录",
                "max_width": true,
                "key": "xsjd",//ycywcycjd
                "value": search_storage['xsjd']//ycywc
            }
        ]
    };
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});


$('body').on('tap', '.check-box', function (e) {
    e.stopPropagation();
    if ($(this).hasClass('check-choice')) {
        $(this).removeClass('check-choice');
    } else {
        $(this).addClass('check-choice');
    }
});


$('body').on('tap', '#selAll', function (e) {
    if ($(this).hasClass('check-choice')) {
        $('.check-box').addClass('check-choice');
    } else {
        $('.check-box').removeClass('check-choice');
    }
    setSelCount();
});

$('body').on('tap', '.title-bar .check-box', function (e) {
    e.stopPropagation();
    if ($(this).hasClass('check-choice')) {
        $(this).closest('li').find('.summary-title .check-box').addClass('check-choice');
    } else {
        $(this).closest('li').find('.summary-title .check-box').removeClass('check-choice');
    }
    setSelCount();

    setSelAllState();
});


$('body').on('tap', '.summary-title .check-box', function (e) {
    e.stopPropagation();
    var $closeLi = $(this).closest('li');
    var totalCount = $closeLi.find('.summary-title .check-box').length;
    var selCount = $closeLi.find('.summary-title .check-box.check-choice').length;

    if (totalCount == selCount) {
        $closeLi.find('.title-bar .check-box').addClass('check-choice');
    } else {
        $closeLi.find('.title-bar .check-box').removeClass('check-choice');
    }
    setSelCount();

    setSelAllState();
});

$('body').on('tap', '.title-bar', function (e) {
    e.stopPropagation();
    var cb = $(this).find('.check-box');
    if (cb.hasClass('check-choice')) {
        cb.removeClass('check-choice');
        $(this).closest('li').find('.summary-title .check-box').removeClass('check-choice');
    } else {
        cb.addClass('check-choice');
        $(this).closest('li').find('.summary-title .check-box').addClass('check-choice');
    }
    setSelCount();
    setSelAllState();
});

$('body').on('tap', '.summary-title', function (e) {
    e.stopPropagation();

    var cb = $(this).find('.check-box');
    if (cb.hasClass('check-choice')) {
        cb.removeClass('check-choice');
    } else {
        cb.addClass('check-choice');
    }

    var $closeLi = $(this).closest('li');
    var totalCount = $closeLi.find('.summary-title .check-box').length;
    var selCount = $closeLi.find('.summary-title .check-box.check-choice').length;

    if (totalCount == selCount) {
        $closeLi.find('.title-bar .check-box').addClass('check-choice');
    } else {
        $closeLi.find('.title-bar .check-box').removeClass('check-choice');
    }

    setSelCount();
    setSelAllState();
});


function setSelAllState() {
    var titleBox = $('.title-bar .check-box').length;
    var titleSelBox = $('.title-bar .check-box.check-choice').length;

    if (titleBox == titleSelBox) {
        $('#selAll').addClass('check-choice');
    } else {
        $('#selAll').removeClass('check-choice');
    }
}


function setSelCount() {
    var selData = getSelectedData();

    console.log(JSON.stringify(selData))


    var count = 0;
    for (var i = 0; i < selData.length; i++) {
        switch (PAGE_DATA['djlx']) {
            case 'bp_xsfhjs':
                count += selData[i]['wfps'];
                break;
            case 'bp_xsthjs':
                count += selData[i]['fhps'];
                break;
        }
    }
    $('#sel_ps').text(count);
}

$('body').on('tap', '#save', function (e) {
    e.stopPropagation();
    var msg = '';
    var selData = getSelectedData();

    if ($.nui.isEmpty(selData)) return;

    var __data = {list: [], wldw_id: 0, ck_id: 0, fp_id: 0, hy_id: 0};

    var flag = callByBpxs(selData, msg, __data);
    if ($.nui.isTrue(msg)) {
        fun.dialog({
            content: msg,
            btn: ['我知道了'],
            yes: function () {
                call();
            },
        });
    } else {
        call();
    }

    function call() {
        if ($.nui.isTrue(flag)) {
            if ($.nui.isTrue(page_data['__route'])) {
                var __opt = {html_name: html_name, page_data: page_data};
                __opt['page_data']['dykhdd_data'] = {
                    data: __data,
                    __JL_DATA: page_data['__JL_DATA']
                };

                __opt['page_data']['return_page'] = page_data['LIST_PAGE'] || page_arr.xs_fthjs_tj;
                __opt['page_data']['LIST_PAGE'] = page_data['LIST_PAGE'] || page_arr.xs_fthjs_tj;

                PageShow.gotoNextPage(__opt);
            } else {
                api.sendEvent({
                    name: PAGE_DATA['goto_page'],
                    extra: {
                        'status': 'dykhdd',//调用客户订单
                        'data': {
                            data: __data,
                            __JL_DATA: page_data['__JL_DATA']
                        }
                    }
                });


                var target_page = '';

                switch (page_data['djlx']) {
                    case 'bp_xsfhjs':
                        target_page = page_arr.xs_fhjs_kd;
                        break;
                    case 'bp_xsthjs':
                        target_page = page_arr.xs_thjs_kd;
                        break;
                }

                setTimeout(function () {
                    api.closeToWin({name: target_page});
                }, 500);
            }
        }
    }
});


function getSelectedData() {
    var data = [];
    for (var i = 0; i < $('.summary-title .check-box').length; i++) {
        var $ele = $('.summary-title .check-box').eq(i);
        var $row = $ele.closest('.row');

        if ($ele.hasClass('check-choice')) {
            data.push($row.data('list_data'));
        }
    }
    return data;
}

//被销售模块调用
function callByBpxs(selData, msg, __data) {
    for (var i = 0; i < selData.length; i++) {
        if (i !== 0) {
            if (__data['wldw_id'] !== selData[i]['wldw_id']) {
                fun.toast('请选择相同客户的单据。');
                __data['wldw_id'] = undefined;
                return false;
            }

            if (__data['hy_id'] !== selData[i]['hy_id']) {
                msg = '你所选记录有多个不同的货运，<br/><br/>调用过去【货运】不会自动赋值。';
                __data['hy_id'] = undefined;
            }

            if (($.inArray(PAGE_DATA['djlx'], ['bp_cglhjs', 'bp_cgthjs']) !== -1) &&
                $.nui.isTrue(selData[i]['fp_id'])
                (__data['fp_id'] !== selData[i]['fp_id'])) {
                msg = '你所选记录有多个不同的发票类型，<br/><br/>调用过去【发票类型】不会自动赋值。';
                __data['fp_id'] = undefined;
            }

            if ($.nui.isEmpty(SYS_CONFIG[Bills['config']['dckms']]) && $.nui.isEmpty(SYS_CONFIG[Bills['config']['dbtckjs']])) {
                if (__data['ck_id'] !== selData[i]['ck_id']) {
                    msg = '你所选记录有多个不同的仓库，<br/><br/>调用过去【仓库】不会自动赋值。';
                    __data['ck_id'] = undefined;
                }
            }
        }

        __data['wldw_id'] = selData[i]['wldw_id'];
        __data['lxr'] = selData[i]['lxr'];
        __data['lxr_dh'] = selData[i]['lxr_dh'];
        __data['lxr_dz'] = selData[i]['lxr_dz'];

        (__data['ck_id'] === 0) && (__data['ck_id'] = selData[i]['ck_id']);
        (__data['fp_id'] === 0) && (__data['fp_id'] = selData[i]['fp_id']);
        (__data['hy_id'] === 0) && (__data['hy_id'] = selData[i]['hy_id']);

        var rmpRow = {
            'yy_djlx': selData[i]['djlx'],
            'ps': ($.inArray(PAGE_DATA['djlx'], ['bp_xsthd', 'bp_xsthjs']) !== -1) ? selData[i]['fhps'] : selData[i]['wfps'],
            'zsl': ($.inArray(PAGE_DATA['djlx'], ['bp_xsthd', 'bp_xsthjs']) !== -1) ? selData[i]['fhsl'] : selData[i]['wfsl'],
            'dd_dh': selData[i]['dh'],
            'dd_kdsj': selData[i]['kdsj'],
            'dd_lb_mc': selData[i]['dd_lb_mc'],
            'dd_lb_id': selData[i]['dd_lb_id'],
            'dd_dj_id': selData[i]['dj_id'],
            'dd_jl_id': selData[i]['jl_id']
        };

        rmpRow['ps'] = (rmpRow['ps'] < 0) ? 0 : rmpRow['ps'];
        rmpRow['zsl'] = (rmpRow['zsl'] < 0) ? 0 : rmpRow['zsl'];

        __data['list'].push($.extend(true, {}, selData[i], rmpRow));
    }
    return true;
}


function closePage() {
    api.sendEvent({
        name: PAGE_DATA['return_page'],
        extra: {
            'status': 'dykhdd',//调用客户订单
            'data': {}
        }
    });

    setTimeout(function () {
        api.closeWin();
    }, 200);
}
