var html_name = page_arr.xs_fth_tj;

//默认开始显示数据
var to_month = fun.getLatelyTime(1,false);
var page_list = [], ztj_data = [];
var search_data = {
    "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
};

$('#header').header({
    back: true,
    filter: true,
    title: '发退货单'
});
var USER_INFO = {};
var hz_group_columns = {
    'dh': 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc',
    'kh': 'wldw_id,wldw_mc',
    'cp': 'cp_bh,cp_mc',
    'ys': 'cp_ys_bh,cp_ys_mc',
    "fkkz": 'fk,kz',
    "gg": 'gg'
};
var _hz = html_name + '_hz_';
var _html_name = html_name + '_';

//接收查询后的参数
page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');

    search_data['group'] = fun.getItem(_html_name + 'group') || "";

    search_storage = $.extend(true, {
        hldj: fun.getItem(_html_name + 'hldj', 0), // 合拢单据
        xsmx: fun.getItem(_html_name + 'xsmx', 0), // 合拢单据
        "hz": {
            "choose": {
                "kh": fun.getItem(_hz + 'kh', 1),
                "dh": fun.getItem(_hz + 'dh', 1),
                "md": fun.getItem(_hz + 'md', 0),
                "cp": fun.getItem(_hz + 'cp', 1),
                "ys": fun.getItem(_hz + 'ys', 1),
                "fkkz": fun.getItem(_hz + 'fkkz', 0),
                "gg": fun.getItem(_hz + 'gg', 0),
            },
            "text": fun.getItem(_hz + 'text', ""),
        },
        'djlx': fun.getItem(html_name + "_djlx")
    }, search_storage);

    search_data = $.extend({}, search_data, search_storage);
    fun.initGroupOfSearchData(search_data, search_storage.hz.choose, hz_group_columns, ',dw_id,dw_mc');
    getList(search_data);

    //接收搜索页值
    api.addEventListener({
        name: html_name
    }, function (ret, err) {

        // yspdj_hidezero = ret.value.data.yspdj_hidezero;

        var param = ret.value.data;

        search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
        search_data['begin_time'] = param.begin_date;                   //开始时间
        search_data['end_time'] = param.end_date;                       //结束时间
        search_data['wldw_id'] = param.kh['id'] || '';                  //供应商
        search_data['cp_id'] = param.cp['id'] || '';                    //产品
        search_data['cp_lb_id'] = param.cp_lb['id'] || 0;             //产品类别
        search_data['ck_id'] = param.ck['id'] || '';                    //仓库
        search_data['md_id'] = param.md['id'] || '';                    //门店
        search_data['kh_id'] = param.kh['id'] || '';                    //客户
        search_data['hldj'] = param['hldj'];                            //合拢单据
        search_data['xsmx'] = param['xsmx'];                            //显示明细数据

        if (param.djlx['type'].indexOf(',') > -1) {
            var split = param.djlx['type'].split(',');
            search_data['djlx'] = [split[0], split[1]]
        } else {
            search_data['djlx'] = param.djlx['type'] != "" ? [param.djlx['type']] : ["bp_xsfhd", "bp_xsthd"];
        }

        search_data['djlx_text'] = param.djlx['text'];
        fun.setItem(html_name + '_djlx', search_data['djlx'])
        fun.setItem(html_name + '_djlx_text', search_data['djlx_text'])
        if (param.djlx['keys']['bp_xsfhd'] == 0 && param.djlx['keys']['bp_xsthd'] == 0) {
            fun.setItem(html_name + '_bp_xsfhd', 1);
            fun.setItem(html_name + '_bp_xsthd', 1);
        } else {
            fun.setItem(html_name + '_bp_xsfhd', param.djlx['keys']['bp_xsfhd']);
            fun.setItem(html_name + '_bp_xsthd', param.djlx['keys']['bp_xsthd']);
        }


        //搜索菜单需要缓存的数据
        search_storage['keyword'] = search_data['keyword'];
        search_storage['begin_date'] = search_data['begin_time'];
        search_storage['end_date'] = search_data['end_time'];
        search_storage['kh'] = param.kh;
        search_storage['cp'] = param.cp;
        search_storage['cp_lb'] = param.cp_lb;
        search_storage['ck'] = param.ck;
        search_storage['md'] = param.md;
        search_storage['kh'] = param.kh;
        search_storage['hldj'] = search_data['hldj'];
        search_storage['xsmx'] = search_data['xsmx'];


        //设置时间控件时间
        date_bar.setDate(search_storage);
        fun.setItem(html_name + '_hldj', search_storage['hldj']);
        fun.setItem(html_name + '_xsmx', search_storage['xsmx']);

        //汇总功能
        search_data['group'] = param.hz['group'] || '';
        search_storage['hz'] = param.hz;
        fun.setGroupCondition(search_data, 'dw_id,dw_mc');
        // if (!!search_data['group']) search_data['group'] = search_data['group'] += ',dw_id,dw_mc,jjdw_mc';
        var hc = param['hz']['choose'];
        fun.setItem(_html_name + 'group', search_data['group']);
        fun.setItem(_hz + 'kh', hc['kh']);
        fun.setItem(_hz + 'dh', hc['dh']);
        fun.setItem(_hz + 'md', hc['md']);
        fun.setItem(_hz + 'cp', hc['cp']);
        fun.setItem(_hz + 'ys', hc['ys']);
        fun.setItem(_hz + 'fkkz', hc['fkkz']);
        fun.setItem(_hz + 'gg', hc['gg']);
        fun.setItem(_hz + 'text', param.hz['text']);
        fun.setItem(html_name + 'sideslip', true);
        // $('#order_list').empty();
        // page_list = [];
        getList(search_data);
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        }
        else {
            // $('#order_list').html('<p class="empty_text">暂无数据！</p>');
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });

}
//储存值用于判断是否打开搜索页
fun.setItem(html_name + 'sideslip', true);

//打开搜索页
$('body').on('tap', '#filter_btn', function () {
    //拿取值
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'] || "",
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage.begin_date,
            "end_date": search_storage.end_date
        },
        "choose_merchants": [
            {
                key: "kh",
                "text": "客户",
                "value": (search_storage['kh'] && search_storage['kh']['text']) || "",
                "id": (search_storage['kh'] && search_storage['kh']['id']) || 0,
            }, {
                key: "cp",
                "text": "产品",
                "value": (search_storage['cp'] && search_storage['cp']['text']) || "",
                "id": (search_storage['cp'] && search_storage['cp']['id']) || 0,
            }, {
                key: "cp_lb",
                "text": "产品类别",
                "value": (search_storage['cp_lb'] && search_storage['cp_lb']['text']) || "",
                "id": (search_storage['cp_lb'] && search_storage['cp_lb']['id']) || 0,
            }, {
                key: "ck",
                "text": "仓库",
                "value": (search_storage['ck'] && search_storage['ck']['text']) || "",
                "id": (search_storage['ck'] && search_storage['ck']['id']) || 0,
            }, {
                key: "md",
                "text": "门店",
                "value": (search_storage['md'] && search_storage['md']['text']) || "",
                "id": (search_storage['md'] && search_storage['md']['id']) || 0,
            },
            {
                key: "kh",
                "text": "客户",
                "value": (search_storage['kh'] && search_storage['kh']['text']) || "",
                "id": (search_storage['kh'] && search_storage['kh']['id']) || 0,
            },
            {
                key: 'hz',
                "text": "汇总",
                "group": [
                    // { name: '门店', key: "md", columns: 'md_id,md_mc', choose: getHz('md') },
                    { key: 'dh', name: '单号', columns: hz_group_columns.dh, choose: getHz('dh') },
                    { key: 'kh', name: '客户', columns: hz_group_columns.kh, choose: getHz('kh') },
                    { key: 'cp', name: '产品', columns: hz_group_columns.cp, choose: getHz('cp') },
                    { key: 'ys', name: '颜色', columns: hz_group_columns.ys, choose: getHz('ys') },
                    { key: "fkkz", name: '幅宽克重', columns: hz_group_columns.fkkz, choose: getHz('fkkz')},
                    { key: "gg", name: '规格', columns: hz_group_columns.gg, choose: getHz('gg')}
                ],
                "value": getVal('hz', 'text'),
            }
        ],
        'xs': [
            {
                "key": 'djlx',
                "text": "单据类型",
                "xsType": (fun.getItem(html_name + '_' + 'djlx') || 'bp_xsfhd,bp_xsthd'),
                "list": [
                    { 'name': '发货', 'column': 'bp_xsfhd', 'is_choose': fun.getItem(html_name + '_' + 'bp_xsfhd') == 0 ? 0 : 1 },
                    { 'name': '退货', 'column': 'bp_xsthd', 'is_choose': fun.getItem(html_name + '_' + 'bp_xsthd') == 0 ? 0 : 1 },
                ],
                "alone": false,
                "value": (fun.getItem(html_name + '_' + 'djlx_text') || "发货、退货"),
            }],
        "switch": [{
            "text": "显示明细数据",
            "max_width": true,
            "key": "xsmx",
            "value": (!!fun.getItem(html_name + '_xsmx') ? fun.getItem(html_name + '_xsmx') : 0)
        },{
            "text": "合拢单据",
            "max_width": true,
            "key": "hldj",
            "value": (!!fun.getItem(html_name + '_hldj') ? fun.getItem(html_name + '_hldj') : 0)
        },]
    }
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false);
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
});

var date_arr = fun.getDateArr(),
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            //发送ajax数据
            // $('#order_list').empty();
            getList(search_data);
        }
    });

// 获取汇总选中值
function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}
// 获取汇总文本
function getVal(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

/** 获取发退货结算数据
 * @param {*} data
 */
function getList(data) {
    page_list = [];
    //暂时使用这种方式访问api接口，如果没有这个就会访问不到
    data['djlx'] = search_data['djlx'] || ["bp_xsfhd", "bp_xsthd"];
    data['group'] = fun.groupRepeat(data['group'] || "");
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpXsfthdtj,
        data: data,
        success: function (res) {
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj1').text(0);
                    $('#tj2').text(0);
                    // $('#tj3').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({dom:'#order_list',btnShow:false});
                }
                ztj_data = res['info'];
                fun.clearPage($('#order_list'));
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createKeysValueFun: function(obj) {
                        return {
                            "wldw_mc": obj['wldw_mc'],
                            "md_id": obj['md_id'],
                            "md_mc": obj['md_mc'],
                            "zdr_mc": obj['zdr_mc'],
                            "kdsj": obj['kdsj'],
                            "dh": obj['dh'],
                            "dj_ps": obj['dj_ps'],
                            "dj_zsl": obj['dj_zsl'],
                            "zdw_mc_tmp": obj['zdw_mc'],  // 计价单位名称
                            "is_sh": obj['is_sh']
                        };
                    }
                });

                showList(fun.PagingData(page_list) || []);
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}

function showList(data) {
    $('#tj1').text(ztj_data['ps'] || 0);
    $('#tj2').text(ztj_data['zsl'] || 0);
    // $('#tj2').text(ztj_data['jjsl'] || 0);
    $('#order_list').OrderList({
        data: data,
        schedule: false,
        isExpand: !search_storage['hldj'],
        isNoExpand: search_storage['xsmx'],
        render: {
            titlebar: function (res) {
                return fthStatistics.createTitlebar(res, {
                    showPrice: false,
                    search_data: search_data
                });
            },
            subtitle: function (res) {
                return fthStatistics.createSubtitle(res, {
                    search_data: search_data
                });
            },
            subdata: function (res) {
                return fthStatistics.createSubdata(res, {
                    search_data: search_data,
                    showPrice: false,
                    ps_tmp: res.ps,
                    sl_tmp: res.zsl,
                    dw_tmp: res.dw_mc
                });
            }
        },
    });
}

// 详情点击
fun.tjContentTap(function(data_list) {
    if ($.nui.isTrue(data_list['dj_id'])) {
        var djlx = data_list['djlx'];
        var id = data_list['dj_id'];
        var dh = data_list['dh'];
        var kdsj = data_list['kdsj'];
        var zdr = data_list['zdr_mc'];
        var djlx_lth, p_url;
        if (djlx == 'bp_xsthd') {
            djlx_lth = '退货单';
            p_url = page_arr.xs_thd_xq;
        } else {
            djlx_lth = '发货单';
            p_url = page_arr.xs_fhd_xq;
        }
        fun.showPageFull({
            page_url: p_url,
            pageParam: {
                return_page: html_name,
                id: id,
                mc: djlx_lth,
                dh: dh,
                kdsj: kdsj,
                zdr: zdr
            }
        });
    }
});

$('body').on('click','.row-list',function(){
    if(fun.getItem(html_name + '_xsmx', 0)) return;
    var data_list = $(this).children('.summary').children('.summary-content').data('list');
    if ($.nui.isTrue(data_list['dj_id'])) {
        var djlx = data_list['djlx'];
        var id = data_list['dj_id'];
        var dh = data_list['dh'];
        var kdsj = data_list['kdsj'];
        var zdr = data_list['zdr_mc'];
        var djlx_lth, p_url;
        if (djlx == 'bp_xsthd') {
            djlx_lth = '退货单';
            p_url = page_arr.xs_thd_xq;
        } else {
            djlx_lth = '发货单';
            p_url = page_arr.xs_fhd_xq;
        }

        fun.showPageFull({
            page_url: p_url,
            pageParam: {
                return_page: html_name,
                id: id,
                mc: djlx_lth,
                dh: dh,
                kdsj: kdsj,
                zdr: zdr
            }
        });
    }
})