var html_name = page_arr.xs_khdd_tj,
    date_arr = fun.getDateArr(),
    to_month = fun.getLatelyTime(1,false),
	search_data = {
        "begin_time": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        "end_time": fun.Date(to_month['end_date']).Format('yy-mm-dd'),
        // "wldw_id":0,
        // "ck_id":0,
        // "cp_id":0,
        // "cp_ys_id":"",
        // "cp_lb_id":"",
        // "wldw_lb_id":"",
        "ycjd": 0,
        "ycywc": 0,
        "xscq": 0,
        "group": "",

        jjcd_id: 0,
        zt_id: 0,
        jd: '',
    },
    search_storage = {
        "begin_date": fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        "end_date": fun.Date(to_month['end_date']).Format('yy-mm-dd')
    },
    date_bar = $('#date_bar').dateBar({
        'data': date_arr,
        'tap': function (ret) {
            search_data['begin_time'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_data['end_time'] = fun.Date(ret['end_date']).Format('yy-mm-dd');
            search_storage['begin_date'] = fun.Date(ret['begin_date']).Format('yy-mm-dd');
            search_storage['end_date'] = fun.Date(ret['end_date']).Format('yy-mm-dd');

            // $('#order_list').empty();
            fun.clearPage($('#order_list'));
            getList(search_data);
        }
    }),
    page_list = [], ztj_data = [], page_lists = [], group;

var USER_INFO = {};

var _type = html_name + '_type_';
var _hz = html_name + '_hz_';
var _html_name = html_name + '_';
var jglx = [];

page_init = function () {
    USER_INFO = fun.getItem('user_info') || {};
    $('#header').header({
        back: true,
        add: Auth.check('bp_xsdd', 'edit'),
        filter: true,
        title: '客户订单',
    });
    var disabled = (USER_INFO['store_id'] && !Auth.check('yxckqtmd', 'view'));

    search_data['md_id'] = (disabled ? (USER_INFO['store_id']) : 0);
    search_data['md_mc'] = (disabled ? (USER_INFO['store_name']) : '');
    search_data['group'] = fun.getItem(_html_name + 'group') || "";
    search_data['keyword'] = page_data['dh'] || "";
    // 页面加载，要先读取有记忆的搜索条件
    search_storage = $.extend(true, {
        'ycjd': fun.getItem(_html_name + 'ycjd', 1),
        'ycywc': fun.getItem(_html_name + 'ycywc', 0),
        'xscq': fun.getItem(_html_name + 'xscq', 0),
        'xsgg': fun.getItem(_html_name + 'xsgg', 0),
        'hldj': fun.getItem(_html_name + 'hldj', 0),
        'xsmx': fun.getItem(_html_name + 'xsmx', 1),
        'type': {
            'number': fun.getItem(_type + 'number', 1),
            'horse': fun.getItem(_type + 'horse', 0),
        },
        "hz": {
            "choose": {
                "md": fun.getItem(_hz + 'md', 0),
                "dh": fun.getItem(_hz + 'dh', 0),
                "kh": fun.getItem(_hz + 'kh', 0),
                "cp": fun.getItem(_hz + 'cp', 0),
                "ys": fun.getItem(_hz + 'ys', 0),
            },
            "text": fun.getItem(_hz + 'text', ""),
        },
        'keyword': page_data['dh'] || ''
    }, search_storage);

    search_data = $.extend({}, search_data, search_storage);

    getList(search_data);

    api.addEventListener({
        name: html_name,
    }, function (ret, err) {
        var status = ret.value['status'];
        var param = ret.value.data;
        switch (status) {
            case 'search':
                search_data['keyword'] = param['LIKE_DATA'] || '';              //关键字
                search_data['begin_time'] = param.begin_date;                   //开始时间
                search_data['end_time'] = param.end_date;                       //结束时间
                search_data['wldw_id'] = param.kh['id'] || 0;                 //供应商
                search_data['cp_id'] = param.cp['id'] || 0;                    //产品
                search_data['cp_lb_id'] = param.cp_lb['id'] || 0;             //产品类别
                search_data['ck_id'] = param.ck['id'] || 0;                    //仓库
                search_data['md_id'] = param.md['id'] || 0;                    //门店
                search_data['ycjd'] = param['ycjd'];                            //隐藏已结单记录
                search_data['ycywc'] = param['ycywc'];                          //隐藏已发完记录
                search_data['xscq'] = param['xscq'];                            //只显示超期产品
                search_data['xsgg'] = param['xsgg'];                            //显示规格
                search_data['hldj'] = param['hldj'];                            //合拢单据
                search_data['xsmx'] = param['xsmx'];                            //合拢单据

                search_data['jjcd_id'] = param.jjcd['id'];                   //紧急程度
                search_data['zt_id'] = param.zt['id'];                          //状态
                search_data['jd'] = param.jd['text'];                           //进度

                search_storage['keyword'] = param['LIKE_DATA'] || '';
                search_storage['begin_date'] = param.begin_date;                   //开始时间
                search_storage['end_date'] = param.end_date;                       //结束时间
                search_storage['type'] = param['type'];                //数量
                search_storage['ycjd'] = param['ycjd'];                //隐藏已结单记录
                search_storage['ycywc'] = param['ycywc'];              //隐藏已发完记录
                search_storage['xscq'] = param['xscq'];                //只显示超期产品
                search_storage['xsgg'] = param['xsgg'];
                search_storage['hldj'] = param['hldj'];
                search_storage['xsmx'] = param['xsmx'];

                search_storage['jjcd'] = param.jjcd;                            //紧急程度
                search_storage['zt'] = param.zt;                                //状态
                search_storage['jd'] = param.jd;                                //进度

                search_storage['kh'] = param.kh;
                search_storage['cp'] = param.cp;
                search_storage['cp_lb'] = param.cp_lb;
                search_storage['ck'] = param.ck;
                search_storage['md'] = param.md;

                //设置时间控件
                date_bar.setDate(search_storage);

                //缓存按钮开关
                fun.setItem(_type + 'number', param['type']['number']);
                fun.setItem(_type + 'horse', param['type']['horse']);
                fun.setItem(_html_name + 'ycjd', param['ycjd']);
                fun.setItem(_html_name + 'ycywc', param['ycywc']);
                fun.setItem(_html_name + 'xscq', param['xscq']);
                fun.setItem(_html_name + 'xsgg', param['xsgg']);
                fun.setItem(_html_name + 'hldj', param['hldj']);
                fun.setItem(_html_name + 'xsmx', param['xsmx']);

                //汇总功能
                search_data['group'] = param.hz['group'] || '';
                search_storage['hz'] = param.hz;

                fun.setGroupCondition(search_data, 'jjdw_id,jjdw_mc,dw_id,dw_mc');
                // if (!!search_data['group']) {
                //     search_data['group'] = search_data['group'] += ',dw_id,dw_mc';
                // }

                var hc = param['hz']['choose'];
                fun.setItem(_html_name + 'group', search_data['group']);
                fun.setItem(_hz + 'md', hc['md']);
                fun.setItem(_hz + 'dh', hc['dh']);
                fun.setItem(_hz + 'kh', hc['kh']);
                fun.setItem(_hz + 'cp', hc['cp']);
                fun.setItem(_hz + 'ys', hc['ys']);
                fun.setItem(_hz + 'text', param.hz['text']);

                fun.setItem(html_name + 'sideslip', true);

                // $('#order_list').empty();
                // page_list = [];
                getList(search_data);
                break;
            case 'refresh':
                // $('#order_list').empty();
                // page_list = [];
                getList(search_data);
                if (ret.value['closeLayer']) layer.closeAll();
                break;
            case 'closeLayer':
                // $('#order_list').empty();
                // page_list = [];
                getList(search_data);
                layer.closeAll();
                break;
        }
    });

    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('order_list', ".list-wrap");
        }
    });
}


    
function getHz(key, def) {
    def = def || 0;
    return (search_storage['hz'] && search_storage['hz']['choose'][key]) || def;
}

function getTwo(key, son, def) {
    def = def || "";
    return (search_storage[key] && search_storage[key][son]) || def;
}

fun.setItem(html_name + 'sideslip', true);
//打开搜索页
$('body').off('tap').on('tap', '#filter_btn', function () {
    var sideslip = fun.getItem(html_name + 'sideslip');
    var options = {
        "keywords": {
            "key": "LIKE_DATA",
            "value": search_storage['keyword'],
            "placeholder": "单号、色号、颜色"
        },
        "time": {
            "begin_date": search_storage['begin_date'],
            "end_date": search_storage['end_date']
        },
        "choose_merchants": [
            {
                key: "kh",
                "text": "客户",
                "value": getTwo('kh', 'text'),
                "id": getTwo('kh', 'id'),
            }, {
                key: "cp",
                "text": "产品",
                "value": getTwo('cp', 'text'),
                "id": getTwo('cp', 'id'),
            }, {
                key: "cp_lb",
                "text": "产品类别",
                "value": getTwo('cp_lb', 'text'),
                "id": getTwo('cp_lb', 'id'),
            }, {
                key: "ck",
                "text": "仓库",
                "value": getTwo('ck', 'text'),
                "id": getTwo('ck', 'id'),
            }, {
                key: "md",
                "text": "门店",
                "value": getTwo('md', 'text'),
                "id": getTwo('md', 'id'),
            },
            {
                key: "zt",
                text: "状态",
                value: getTwo('zt', 'text'),
                id: getTwo('zt', 'id'),
                loadData: true,
                loadDataType: 'xsdd',
                list: []
            },
            {
                key: "jd",
                text: "进度",
                value: getTwo('jd', 'text'),
                id: getTwo('jd', 'id'),
                loadData: true,
                list: [
                    { id: 1, 'name': '发货完成', 'column': 'jd1', 'is_choose': 0 },
                    { id: 2, 'name': '已发货', 'column': 'jd2', 'is_choose': 0 },
                    { id: 3, 'name': '加工完成', 'column': 'jd3', 'is_choose': 0 },
                    { id: 4, 'name': '加工中', 'column': 'jd4', 'is_choose': 0 },
                    { id: 5, 'name': '成品采购完成', 'column': 'jd5', 'is_choose': 0 },
                    { id: 6, 'name': '成品采购中', 'column': 'jd6', 'is_choose': 0 },
                    { id: 7, 'name': '坯布采购完成', 'column': 'jd7', 'is_choose': 0 },
                    { id: 8, 'name': '坯布采购中', 'column': 'jd8', 'is_choose': 0 }
                ],
            },
            {
                key: "jjcd",
                text: "紧急",
                value: getTwo('jjcd', 'text'),
                id: getTwo('jjcd', 'id'),
                loadData: true,
                list: []
            },
            {
                key: "hz",
                "text": "汇总",
                "group": [
                    // {name: '门店', key: "md", columns: 'md_id,md_mc', choose: getHz('md')},
                    {
                        name: '单号',
                        key: "dh",
                        columns: 'dh,dj_lsh,djlx,dj_id,kdsj,md_id,md_mc,zdr_id,zdr_mc',
                        choose: getHz('dh')
                    },
                    { name: '客户', key: "kh", columns: 'wldw_id,wldw_mc', choose: getHz('kh') },
                    { name: '产品', key: "cp", columns: 'cp_bh,cp_mc', choose: getHz('cp') },
                    { name: '颜色', key: "ys", columns: 'cp_ys_bh,cp_ys_mc', choose: getHz('ys') }
                ],
                "value": getTwo('hz', 'text'),
            },

        ],
        'type': [
            {
                key: "number",
                "text": "数量",
                "value": getTwo('type', 'number'),
            }, {
                key: "horse",
                "text": "匹数",
                "value": getTwo('type', 'horse'),
            }
        ],

        "switch": [
            {
                "text": "隐藏已结单记录",
                "max_width": true,
                "key": "ycjd",
                "value": search_storage['ycjd']
            }, {
                "text": "隐藏已发完记录",
                "max_width": true,
                "key": "ycywc",
                "value": search_storage['ycywc']
            }, {
                "text": "只显示超期产品",
                "max_width": true,
                "key": "xscq",
                "value": search_storage['xscq']
            },
            { "text": "显示明细数据", "max_width": true, "key": "xsmx", "value": search_storage['xsmx'] },
            { "text": "合拢单据", "max_width": true, "key": "hldj", "value": search_storage['hldj'] },
            { "text": "显示规格", "max_width": true, "key": "xsgg", "value": search_storage['xsgg'] }
        ],
    }
    if (sideslip) {
        fun.setItem(html_name + 'sideslip', false)
        fun.openFrame({
            frame_url: page_arr.search,
            pageParam: {
                "return_page": html_name,
                "search_data": options
            },
            // y: fun.fontUnit(header)
        });
    }
})

/** 获取发退货结算数据
 * @param {*} data
 */
function getList(data) {
    page_list = [];

    data['group'] = fun.groupRepeat(data['group'] || "");

    //暂时使用这种方式访问api接口，如果没有这个就会访问不到
    // data['djlx'] = ["bp_cglhjs", "bp_cgthjs"];
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL['getBpXsddtj'],
        data: data,
        success: function (res) {
            page_lists = res.data;
            if (res['status'] == 0) {
                if (!res['data'] || res['data'].length == 0) {
                    $('#tj1').text(0);
                    $('#tj2').text(0);
                    $('#tj3').text(0);
                    // return $('#order_list').html('<p class="empty_text">暂无数据！</p>');
                    return fun.createDataEmptyTips({ dom: '#order_list', btnText: '新增客户订单', auth: 'bp_xsdd' });
                }


                ztj_data = res['info'];
                jglx = res['jglx'] || [];

                // page_list = convertData(res.data);
                fun.clearPage($('#order_list'));
                page_list = fun.convertTjData({
                    apiData: res.data,
                    search_storage: search_storage,
                    createKeysValueFun: function (obj) {
                        return {
                            "dh": obj['dh'],
                            "kdsj": obj['kdsj'],
                            "zdr_mc": obj['zdr_mc'],
                            "wldw_mc": obj['wldw_mc'],
                            "md_mc": obj['md_mc'],
                            "zh_mc": obj['zh_mc'],
                            "zh_tb": obj['zh_tb'],
                            "zh_je": obj['zh_je'],

                            "dj_ps": obj['dj_ps'],
                            "dj_zsl": obj['dj_zsl'],
                            "dj_je": obj['dj_je'],          // 单据金额
                            "zdw_mc_tmp": obj['zjjdw_mc'],  // 总计价单位名称
                            "dd_lb_mc": obj['dd_lb_mc'],

                            // 审核状态
                            "is_sh": obj["is_sh"],
                            "is_fh": obj["is_fh"],
                            "is_jd": obj["is_jd"],
                            "dj_jd": obj["dj_jd"],
                            "dd_lb_fh": obj["dd_lb_fh"]
                        };
                    }
                });

                // console.log(JSON.parse(JSON.stringify(page_list)))
                showList(fun.PagingData(page_list) || []);
            } else {
                fun.alert({ msg: '网络异常！' });
            }
        }
    })
}

/** 数量和匹数转换
 * @param {*} isNumber 是否选择数量
 * @param {*} res 数据源
 */
function numberHorse(isNumber, res) {
    if (isNumber) {
        return {
            title: {
                "0": "订单",
                "1": "发货",
                "2": "未发",
            },
            value: {
                "0": $.nui.decimalAdd(parseFloat(res['zsl'] || 0) , parseFloat(res['cxsl'] || 0)) || "",
                "1": res['fhsl'] || "",
                "2": res['wfsl'] || "",
            }
        }
    }

    var ps = $.nui.decimalAdd(parseFloat(res['ps'] || 0), parseFloat(res['cxps'] || 0));
    if (ps) {
        ps = ps + '匹';
    }

    return {
        title: {
            "0": "订单",
            "1": "发货",
            "2": "未发",
        },
        value: {
            "0": ps,
            "1": res['fhps'] || "",
            "2": res['wfps'] || "",
        }
    }
}

/** 生成 剩/超 天 字符串
 * @param {*} hqts 货期天数
 */
function hqtsStr(hqts) {
    if (hqts < 0)
        return "超" + Math.abs(hqts) + "天";
    else if ((hqts > 0)) {
        return "剩" + hqts + "天";
    }
    return "";
}

function showList(data) {
    var hj_type = search_storage['type'];
    $.each(hj_type, function (key, val) {
        if (!!val) {
            if (key == 'number') {//类型 = 数量
                $('#tj1').text($.nui.decimalAdd(Number(ztj_data[0]['zsl']), Number(ztj_data[0]['cxsl'])) || 0);
                $('#tj2').text(ztj_data[0]['fhsl'] || 0);
                $('#tj3').text(ztj_data[0]['wfsl'] || 0);
            } else {//类型 = 匹数
                $('#tj1').text($.nui.decimalAdd(Number(ztj_data[0]['ps']), Number(ztj_data[0]['cxps'])) || 0);
                $('#tj2').text(ztj_data[0]['fhps'] || 0);
                $('#tj3').text(ztj_data[0]['wfps'] || 0);
            }
        }
    });
    group = search_data['group'];
    var hldj = fun.getItem(html_name + '_hldj', 0);
    var xsmx = fun.getItem(html_name + '_xsmx') == 0 ? false : true;
    $('#order_list').OrderList({
        is_row: true,
        data: data,
        isExpand: !hldj,
        isNoExpand: xsmx,
        // showLog: true,
        render: {
            titlebar: function (res) {
                var is_ddfh = fun.getKzValue('ddfh', 'bp_xsdd'); // 订单复核
                
                return statistics.order.createTitlebar(res, {
                    group: search_data.group,
                    other_condition: is_ddfh && (!res.dd_lb_mc || $.nui.isTrue(res.dd_lb_fh)),
                    dd_lb_fh: $.nui.isTrue(res.dd_lb_fh),
                    type: res.dd_lb_mc
                })
            },
            subtitle: function (res) {
                return statistics.order.createSubtitle(res, {
                    group: search_data.group,
                    search_data: search_data,
                    showIcon: true
                });
            },
            subdata: function (res) {
                var isSelectNum = search_storage['type']['number'] ? search_storage['type']['number'] : 0;
                var numberHorseVal = numberHorse(isSelectNum, res);

                return statistics.order.createSubdata(res, {
                    group: group,
                    search_storage: search_storage,
                    title: numberHorseVal.title,
                    value: numberHorseVal.value,
                    isSelectNum: isSelectNum,
                    showJd: true,
                    renderJdHtml: true
                });
            }

        },
    });
}
function popup(e, _this) {
    e.stopPropagation();
    if (group) return;

    var row_data = $(_this).data('row');
    var color_val = row_data['color_val'];

    var bgColor = 'background-color: ' + color_val + ';';
    var borderColor = 'border-left-color: ' + color_val + ';';
    var fontColor = 'color: ' + color_val + ';';


    var id = $(_this).data('row')['dj_id'] || 0;
    var jl_id = $(_this).data('row')['jl_id'] || 0;

    if ($.nui.isEmpty(id)) return;
    var params = [];
    var type = fun.getItem(_type + 'number'), type_unit;
    if (type != 0) type_unit = '数';
    else type_unit = '匹';
    params = getBoxData(id, jl_id);
    var html = [];
    style = 'width: calc(95% - 3rem); height: 70%; border:none; background: ' + color_val + ';  padding: 0.5rem;border-radius: 0.5rem;';//position: absolute; top: 10%; left: 2.5%; right: 2.5%;
    html.push('<div class="top">');
    html.push(' <span class="name">' + params['kh_mc'] + '</span>');
    html.push(' <i class="iconfont icon-fork fork dd-close"></i>');
    html.push(' <span class="number">' + params['cp_str'] + '</span>');
    html.push(' <span class="colour">' + params['cp_ys_str'] + '</span>');
    html.push(' <div class="right">');
    if (!!params['fk_str']) {
        html.push('    <span class="vice">幅/克</span>');
        html.push('    <span class="size">' + params['fk_str'] + '</span></div>');
    } else html.push('<span></span>')
    html.push('</div>');

    html.push('<ul class="list">');
    html.push(' <li style="' + borderColor + '" class="term">');
    html.push('     <div class="head">');
    html.push('         <span style="' + bgColor + '" class="radius"></span>');
    html.push('         <span class="title" style="' + fontColor + '">总订货</span>');
    html.push('    </div>');
    html.push('    <div class="column">');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">订单' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['zdh_dd'] || 0) + '</span>');
    html.push('         </div>');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">发货' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['zdh_fh'] || 0) + '</span>');
    html.push('         </div>');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">未发' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['zdh_wfh'] || 0) + '</span>');
    html.push('         </div>');
    html.push('    </div>');
    html.push(' </li>');

    html.push(' <li style="' + borderColor + '" class="term">');
    html.push('     <div class="head">');
    html.push('         <span style="' + bgColor + '" class="radius"></span>');
    html.push('         <span class="title" style="' + fontColor + '">未采购/加工</span>');
    html.push('    </div>');
    html.push('    <div class="column">');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">坯布' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['wcg_pb'] || 0) + '</span>');
    html.push('         </div>');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">成品' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['wcg_cp'] || 0) + '</span>');
    html.push('         </div>');
    html.push('    </div>');
    html.push(' </li>');

    // html.push(' <li class="term2">');
    // html.push('     <div class="head">');
    // html.push('         <span style="'+bgColor+'" class="radius"></span>');
    // html.push('         <span class="title">下织</span>');
    // html.push('    </div>');
    // html.push('    <div class="column">');
    // html.push('         <div class="content2">');
    // html.push('             <div class="container"><span class="text">下织日期</span></div>');
    // html.push('             <span class="number2"></span>');
    // html.push('         </div>');
    // html.push('         <div class="content2">');
    // html.push('             <div class="container"><span class="text">完成日期</span></div>');
    // html.push('             <span class="number2"></span>');
    // html.push('         </div>');
    // html.push('    </div>');
    // html.push('    <div class="column">');
    // html.push('         <div class="content2">');
    // html.push('             <div class="container"><span class="text">下织匹</span></div>');
    // html.push('             <span class="number2"></span>');
    // html.push('         </div>');
    // html.push('         <div class="content2">');
    // html.push('             <div class="container"><span class="text">完成匹</span></div>');
    // html.push('             <span class="number2"></span>');
    // html.push('         </div>');
    // html.push('    </div>');
    // html.push(' </li>');

    html.push(' <li style="' + borderColor + '" class="term">');
    html.push('     <div class="head">');
    html.push('         <span style="' + bgColor + '" class="radius"></span>');
    html.push('         <span class="title" style="' + fontColor + '">坯布采购</span>');
    html.push('    </div>');
    html.push('    <div class="column">');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">采购' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['pbcg_cg'] || 0) + '</span>');
    html.push('         </div>');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">来货' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['pbcg_lh'] || 0) + '</span>');
    html.push('         </div>');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">未来' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['pbcg_wl'] || 0) + '</span>');
    html.push('         </div>');
    html.push('    </div>');
    html.push(' </li>');

    html.push(' <li style="' + borderColor + '" class="term">');
    html.push('     <div class="head">');
    html.push('         <span style="' + bgColor + '" class="radius"></span>');
    html.push('         <span class="title" style="' + fontColor + '">成品采购</span>');
    html.push('    </div>');
    html.push('    <div class="column">');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">采购' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['cpcg_cg'] || 0) + '</span>');
    html.push('         </div>');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">来货' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['cpcg_lh'] || 0) + '</span>');
    html.push('         </div>');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">未来' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['cpcg_wl'] || 0) + '</span>');
    html.push('         </div>');
    html.push('    </div>');
    html.push(' </li>');

    html.push(' <li style="' + borderColor + '" class="term2">');
    html.push('     <div class="head">');
    html.push('         <span style="' + bgColor + '" class="radius"></span>');
    html.push('         <span class="title" style="' + fontColor + '">加工</span>');
    html.push('    </div>');
    // html.push('    <div class="column">');
    // html.push('         <div class="content2">');
    // html.push('             <div class="container"><span class="text">加工日期</span></div>');
    // html.push('             <span class="number2"></span>');
    // html.push('         </div>');
    // html.push('         <div class="content2">');
    // html.push('             <div class="container"><span class="text">完成日期</span></div>');
    // html.push('             <span class="number2"></span>');
    // html.push('         </div>');
    // html.push('    </div>');
    html.push('    <div class="column">');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">加工' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['jg_jg'] || 0) + '</span>');
    html.push('         </div>');
    html.push('         <div class="content2">');
    html.push('             <div class="container"><span class="text">完成' + type_unit + '</span></div>');
    html.push('             <span class="number2">' + (params['jg_wc'] || 0) + '</span>');
    html.push('         </div>');
    html.push('    </div>');
    html.push(' </li>');
    html.push('</ul>')

    layer.open({
        type: 1,
        content: html.join(''),
        style: style,
        success: function (layero, index) {
            $('html').css({ "height": "100%", "overflow": "hidden" });
            $('body').css({ "height": "100%", "overflow": "hidden" });
            $('.fork').on('click', function () {
                layer.closeAll()
            })
        },
        end: function () {
            $('html').css({ "overflow": "unset" });
            $('body').css({ "overflow": "unset" });
        }
    });
}

function getBoxData(id, jl_id) {
    var params = [];
    var sj_type = search_storage['type'];
    var number = search_storage['type']['number'];
    var horse = search_storage['type']['horse'];
    $.each(page_lists, function (i, item) {
        if (item['dj_id'] == id && item['jl_id'] == jl_id) {
            params.push({
                'kh_mc': item['wldw_mc'] || '',
                'cp_str': (item['cp_bh'] + ' ' + item['cp_mc']) || '',
                'cp_ys_str': (item['cp_ys_bh'] + ' ' + item['cp_ys_mc']) || '',
                'fk_str': (item['fk'] || '') + ((item['fk'] && item['kz']) ? '×' : '') + (item['kz'] || ''),
                //总订货
                'zdh_dd': (horse > 0) ? ((Number(item['ps']) + Number(item['cxps'])) || '') : (Number(item['zsl']) + Number(item['cxsl']) || ''),
                'zdh_fh': (horse > 0) ? (item['fhps'] || '') : (item['fhsl'] || ''),
                'zdh_wfh': (horse > 0) ? (item['wfps'] || '') : (item['wfsl'] || ''),
                //未采购/加工
                'wcg_pb': (horse > 0) ? (item['pb_ps'] || '') : (item['pb_sl'] || ''),
                'wcg_cp': (horse > 0) ? (item['cp_ps'] || '') : (item['cp_sl'] || ''),
                //坯布采购
                'pbcg_cg': (horse > 0) ? (item['pbcg_ps'] || '') : (item['pbcg_sl'] || ''),
                'pbcg_lh': (horse > 0) ? (item['pbcg_lhps'] || '') : (item['pbcg_lhsl'] || ''),
                'pbcg_wl': (horse > 0) ? (item['pbcg_wlhps'] || '') : (item['pbcg_wlhsl'] || ''),
                //成品采购
                'cpcg_cg': (horse > 0) ? (item['cpcg_ps'] || '') : (item['cpcg_sl'] || ''),
                'cpcg_lh': (horse > 0) ? (item['cpcg_lhps'] || '') : (item['cpcg_lhsl'] || ''),
                'cpcg_wl': (horse > 0) ? (item['cpcg_wlhps'] || '') : (item['cpcg_wlhsl'] || ''),
                //加工
                // 'jg_jgrq':item['wwjg_ps'] || '',//加工日期
                // 'jg_wcrq':item['wwjg_ps'] || '',//完成日期
                'jg_jg': (horse > 0) ? (item['wwjg_ps'] || '') : (item['wwjg_sl'] || ''),
                'jg_wc': (horse > 0) ? (item['wwjg_lhps'] || '') : (item['wwjg_lhsl'] || ''),
            });
        }
    });
    return params[0];
}

/*
    判断选择汇总条件，汇总条件为空返回true
*/
function groupOf(value, key) {
    if (value == "" || !key) return true;
    var group = fun.skipEmptyElementForArray(value.split(','));
    if (group.indexOf(key) > -1) return true;
    return false;
}


$('body').on('tap', '#add_btn', function (e) {
    if (!fun.checkKz()) return;
    e.stopPropagation();
    PageShow.xskhdd();
});

// fun.dblclick('.summary-content', function (e, _this) {
//     e.stopPropagation();
//     var list_data = $(_this).data('row');
//     fun.showPageFull({
//         page_url: page_arr.xs_khdd_kd,
//         pageParam: {
//             return_page: html_name,
//             id: list_data['dj_id']
//         }
//     });
// }, function (e, _this) {
//     popup(e, _this);
// });

$('body').on('tap', '.particulars', function (e) {
    e.stopPropagation();
});
$('body').on('click', '.particulars', function (e) {
    e.stopPropagation();

    var $row = $(this).closest('.summary-title').next('.summary-content');
    var index = Number($row.data('index'));
    var indent_data = fun.apiData[index];
    fun.showPageFull({
        page_url: NEW_BILLS ? page_arr.bills_xsddxq : page_arr.xs_khdd_xqy,//
        pageParam: {
            return_page: html_name,
            data: indent_data,
            search_type: search_data.type,
            jglx: jglx,
            djlx: 'bp_xsdd',
            initType: 'view'
        }
    })
    // popup(e, $row);
});

//跳转到详情页
fun.tjContentTap(function (list_data) {
    if (!fun.checkKz()) return;
    if ($.nui.isEmpty(list_data['dj_id'])) return;
    fun.showPageFull({
        page_url: page_arr.xs_khdd_kd,
        pageParam: {
            return_page: html_name,
            id: list_data['dj_id']
        }
    });
});

$('body').on('click', '.row-list', function () {
    if (fun.getItem(html_name + '_xsmx', 1)) return;
    if (!fun.checkKz()) return;
    var list_data = $(this).data('row');
    if ($.nui.isEmpty(list_data['list'][0]['dj_id'])) return;
    fun.showPageFull({
        page_url: page_arr.xs_khdd_kd,
        pageParam: {
            return_page: html_name,
            id: list_data['list'][0]['dj_id']
        }
    });
})