var html_name = page_arr.xs_khdd_xqy; // 页面名称
var data, __JL_DATA, row_index, search_type = { number: 1, horse: 0 };

var imgs, cp_list, photoBrowser;

// 单据调整数据记录
var __DJTZ_JL = [], is_adjust_save = false;
var AJAX_SAVE = AJAX_URL.saveBpXsddInfo;

page_init = function () {
    data = page_data['data'];
    cp_list = fun.getItem('cp_list') || [];
    imgs = fun.getValByKey(cp_list, data['cp_id'], 'imgs');
    photoBrowser = api.require('photoBrowser');
    // var is_edit = Auth.check("bp_xsdd", 'edit', false) && !$.nui.isTrue(data.is_jd); // 判断权限

    // FIXME 编辑功能暂时不做
    $('#header').header({
        back: true, // 返回
        title: data['cp_bh'] + data['cp_mc'], // 标题
        edit: false, // 权限
        // edit1: page_data['edit'] ? true : false, // 权限
        appendBackBtnEvt: closePage
    });

    page_data.keyback = closePage;

    showData(data);
    showDocumentary(data);
    getAjaxData(data.dj_id, data.jl_id);
    // getData(is_edit, data.dj_id);

    // 设置默认值
    var $switcher_btn = $('.switcher-btn');
    var default_unit = fun.getItem(html_name + '_unit');
    var hasDefault = false;

    var length = $switcher_btn.length;
    $switcher_btn.removeClass('activate');
    $switcher_btn.each(function (index, element) {
        var unit = $(element).data('unit');
        if (unit === default_unit) {
            hasDefault = true;
            search_type[unit] = 1;
            $(element).addClass('activate');
            return false;
        }

        // 还是没有默认值,设置第一个为默认值
        if (index + 1 === length) {
            if (!hasDefault) {
                $switcher_btn.first().addClass('activate');
                search_type.number = 1;
            }
        }
    });
    if ($('.header-title-wrap').siblings().length <= 2) {
        $('#header_title').css({
            'width': 'calc(100% - 5rem)',
            'margin-left': '2.5rem',
            'margin-right': '2.5rem',
            'text-align': 'center',
        })
    }
}

function closePage() {
    // api.sendEvent({
    //     name: page_data['return_page'],
    //     extra: {
    //         'status': 'refresh',
    //     }
    // });
    setTimeout(function () {
        api.closeWin();
    }, 200);
}

// 编辑功能
$('body').on('tap', '#edit_btn', function () {
    // if (!Auth.check("bp_xsdd", 'edit', false)) { // 没有权限，return;
    //     return;
    // }
    var AUTH_EDIT = Auth.check("bp_xsdd", 'edit', false);

    var data = page_data['data']; // 页面参数
    var ck_list = fun.getItem('ck_list') || []; // 仓库

    var ck_id = data['ck_id'] || 0; // 仓库id
    var ck_info = fun.getListInfoByKey(ck_list, ck_id); // 仓库信息

    var __PAGE_EDIT = AUTH_EDIT || data['is_fh'] || data['is_jd'];

    var pageParam = {                         // 开单编辑页参数
        djlx: data['djlx'],                   // 单据类型
        return_page: page_arr.xs_khdd_tj,     // 返回页面名称
        list_data: data,
        ck_info: ck_info,
        edit_row: true,
        row_index: row_index,
        __JL_DATA: __JL_DATA,
        __DJ_DATA: __DJ_DATA,
        __PAGE_EDIT: __PAGE_EDIT,
        bj_type: 'zs',                       // 开启总数模式
        __JD_INFO: {}
    };

    // 跳转到单据详情页面，
    fun.showPageFull({
        page_url: page_arr.kdbj_dd,          // 开单编辑页
        pageParam: pageParam
    });
});

//切换
$('.danju-float-left').on('click', function () {
    var $this = $(this);
    if ($this.hasClass('kh-on')) {
        return;
    } else {
        var curTxt = $this.data('dom');
        if (curTxt === 'detail') {
            showSeal(page_data['data']);
        } else if (curTxt === 'order') {
            $('#state_icon').remove();
        }
        $this.addClass('kh-on');
        $this.siblings().removeClass('kh-on');
    }

    // $('#' + $this.data('dom')).show();
    var index = $this.index();
    $('.card').hide();
    $('.card:eq(' + index + ')').show();
    if ($this.data('dom') === 'order') {
        showDocumentary(data);
    }
});

$('.switcher-btn').on('click', function () {
    if ($(this).hasClass('activate')) {
        return
    } else {
        $(this).addClass('activate');
        $(this).siblings().removeClass('activate');
    }
    // 跟单显示处理
    search_type = { number: 0, horse: 0 };
    var type = $(this).data('unit');
    search_type[type] = 1;

    fun.setItem(html_name + '_unit', type);
    showDocumentary(data);
})

// 显示页面盖章
function showSeal(data) {
    $('.settle-wrap').show();
    if (!!data.is_jd) { // 显示已结单
        // fun.seal(
        //     {
        //         type: 'jd',
        //         top: '20.5rem',
        //         right: '3rem'
        //     }
        // );
        $('.show-seal').show();
    } else {
        $('.settle-icon').hide();
        $('#settle').text('未结单');
        $('.show-seal').hide();
    }
}

/**
 * 获取单据info，编辑情况时才去获取
 * @param is_edit
 * @param id
 */
function getData(is_edit, id) {
    if (is_edit) {
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.getBpXsddInfo,
            data: { 'id': id },
            success: function (res) {
                if (res['status'] == 0) {
                    __JL_DATA = res['data']['jl'];
                    __DJ_DATA = res['data']['dj'];

                    row_index = $.nui.findIndex(__JL_DATA, function (item) {
                        return data.jl_id === item.id;
                    });
                }
            }
        })
    }
}


// 获取订单记录数据
function getAjaxData(dj_id, jl_id) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getBpXsddInfo,
        data: { 'id': dj_id },
        success: function (res) {
            if (res['status'] == 0) {
                var jl = res['data']['jl'] || [];
                for (var i = 0; i < jl.length; i++) {
                    var val = jl[i];

                    if (val['id'] == jl_id) {
                        __DJTZ_JL.push(val);
                        break;
                    }
                }
            }
        }
    })
}

//信息
function showData(data) {
    showSeal(data); // 显示页面盖章

    fun.load_DATA_LIST(['cp']);

    var goods_list = fun.getItem('cp_list') || [];
    var goods_info = fun.getListInfoByKey(goods_list || [], data['cp_id']);

    var img_url = (goods_info['imgs']) ? fun.getImgPath(goods_info['imgs']) : "../img/logo.png";

    var large_arr = [];
    var imgs_split = imgs.split(',');
    $(imgs_split).each(function (i, obj) {
        obj && large_arr.push((obj) ? fun.getImgPath(obj, true) : "");
    })


    $('.shehao-title').text(data['cp_ys_bh'] + data['cp_ys_mc']);//颜色编号+颜色名称


    var _sys_config = fun.getItem('sys_config');
    var kdphsz_arr = _sys_config['kdphsz'] && _sys_config['kdphsz'].split(',') || [];
    var html = [];
    if (kdphsz_arr.length > 3) {
        html.push('<li class="lower-border-line clearfix">');
        html.push('    <div class="input-width-long">');
        html.push('        <span class="danju-title">幅宽</span>');
        html.push('        <span class="remark-input book-choice" id="fk">' + (data['fk'] || '') + '</span>');
        html.push('    </div>');
        html.push('    <div class="input-width-short">');
        html.push('        <span class="danju-title">克重</span>');
        html.push('        <span class="remark-input book-choice" id="kz">' + (data['kz'] || '') + '</span>');
        html.push('    </div>');
        html.push('    <div class="input-width-long">');
        html.push('        <span class="danju-title">规格</span>');
        html.push('        <span class="remark-input book-choice" id="gg">' + (data['gg'] || '') + '</span>');
        html.push('    </div>');
        html.push('</li>');
        // html.push('    <li class="lower-border-line clearfix">');
        // html.push('        <div class="input-width-short">');
        // html.push('            <span class="danju-title">缸号</span>');
        // html.push('            <span class="remark-input book-choice" id="gh">' + (data['gh'] || '') + '</span>');
        // html.push('        </div>');
        // html.push('    </li>');
    } else if (kdphsz_arr.length <= 3 && kdphsz_arr.length != 0) {
        html.push('<li class="lower-border-line clearfix">');
        $(kdphsz_arr).each(function (i, item) {
            switch (kdphsz_arr[i]) {
                case 'fk':
                    html.push('    <div class="input-width-long">');
                    html.push('        <span class="danju-title">幅宽</span>');
                    html.push('        <span class="remark-input book-choice" id="fk">' + (data['fk'] || '') + '</span>');
                    html.push('    </div>');
                    break;
                case 'kz':
                    html.push('    <div class="input-width-short">');
                    html.push('        <span class="danju-title">克重</span>');
                    html.push('        <span class="remark-input book-choice" id="kz">' + (data['kz'] || '') + '</span>');
                    html.push('    </div>');
                    break;
                case 'gg':
                    html.push('    <div class="input-width-long">');
                    html.push('        <span class="danju-title">规格</span>');
                    html.push('        <span class="remark-input book-choice" id="gg">' + (data['gg'] || '') + '</span>');
                    html.push('    </div>');
                    break;
                case 'gh':
                    // html.push('        <div class="input-width-short">');
                    // html.push('            <span class="danju-title">缸号</span>');
                    // html.push('            <span class="remark-input book-choice" id="gh">' + (data['gh'] || '') + '</span>');
                    // html.push('        </div>');
                    break;

            }
        })
        html.push('    </li>');
    }
    $('.likeSet').html(html.join(''));

    // $('#fk').text(data['fk'] || '');//幅宽
    // $('#kz').text(data['kz'] || '');//克重
    $('#bills_type').text(data['jg_lx_mc'] || '');//单据类型
    if(img_url == '../img/logo.png'){
        $('#preview').css({
            'background-color': '#f5f5f5',
            'border-radius': '0.25rem',
        });
    }else{
        $('.img-logo').attr('src',img_url).css({
            'width': '100%',
            'height': '100%',
            'opacity': 1,
            'margin': 0,
        });
        $('.img-mask').show();
        $('#preview').attr('large_url', JSON.stringify(large_arr));
    }
    // var lWidth = fun.fontUnit(1.8) + 'px';
    // var rWidth = fun.fontUnit(1.5) + 'px';
    // $('#preview').css({
    //     marginRight: 'calc((35% - ' + lWidth + ' + ' + rWidth + ') / 2)',
    //     background: 'url(' + img_url + ') no-repeat center/cover',
    //     // backgroundPosition: 'center center',
    //     // opacity: 0.8
    // }).attr('large_url', JSON.stringify(large_arr));

    $('#ps').text(data['ps'] || '');//匹数
    $('#wfps').text(data['wfps'] || '');//未发匹数
    $('#cxps').text(data['cxps'] || '');//
    $('#sl').text(data['zsl'] || '');//数量
    $('#sldw').text(data['dw_mc'] || '');//单位
    $('#wfsl').text(data['wfsl'] || '');//未发数量
    $('#cxsl').text(data['cxsl'] || '');//
    $('#jjsl').text(data['jjsl'] || '');//计价数量
    $('#jjdw').text(data['jjdw_mc'] || '');//计价单位
    $('#dj').text(data['hsdj'] || '');//含税单价
    $('#je').text(data['hszje'] || '');//含税总金额

    if($.nui.isTrue(data['jjcd_mc'])){
        $('#jjcd_mc').text(data['jjcd_mc'] || '暂无').css({
            'backgroundColor': data['jjcd_colour'],
        }).removeClass('black-import').addClass('white-import');//紧急程度
    }else{
        $('#jjcd_mc').text('暂无');
        $('#jjcd_mc').css({
            'backgroundColor': '#fff',
        }).removeClass('white-import').addClass('black-import');//紧急程度
    }

    // if (!(!!data['hq'] && !!data['jl_bz'])) {
    if ($.nui.isEmpty(data['hq'])) {
        $('#qbhq').hide();
    } else {
        $('#hqts').text(data['hqts'] || '');//货期天数
        $('#hq').text(fun.formatDate(data['hq'], 'YY-MM-DD') || '');//货期
        var date = fun.getNowFormatDate();
        // var _date = date.split(' ')[0];
        // var days = Math.abs(new Date(data['hq']).getTime() - new Date(_date).getTime()) / (1000 * 60 * 60 * 24);
        if (data['hqts'] >= 0) {
            $('#cq').siblings().text('剩余');
            $('#cq').text((data['hqts'] || 0) + '天').css('color', '#48C157');
        } else {
            // days = days.String().replace(/['-']/);
            $('#cq').text(Math.abs(data['hqts']) + '天').css('color', '#ff4e44');
        }
    }
    
    $('#jd').text(data['jd'] || '暂无');
    $('#bz').text(data['jl_bz'] || '');//备注

    //单据信息
    $('#kh').text(data['wldw_mc'] || '');//客户名称
    $('#dh').text(data['dh'] || '');//单号
    $('#kdsj').text(data['kdsj'] || '');//开单时间
}

//跟单
function showDocumentary(data) {
    var html = [];
    var unit_point = search_type.number ? '数' : '匹';
    html.push('<li class="content-list">');
    html.push('    <div class="dot"></div>');
    html.push('    <p class="content-titel">');
    html.push('        <span>总订货</span>');
    html.push('    </p>');
    html.push('    <div class="order-form">');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">订单</span>');
    html.push('            <span>' + (search_type.horse ? ((Number(data['ps']) + Number(data['cxps'])) || 0) : (Number(data['zsl']) + Number(data['cxsl']) || 0)) + '</span>');
    html.push('        </span>');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">发货</span>');
    html.push('            <span>' + (search_type.horse ? (data['fhps'] || 0) : (data['fhsl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">未发货</span>');
    html.push('            <span>' + (search_type.horse ? (data['wfps'] || 0) : (data['wfsl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('    </div>');
    html.push('</li>');

    html.push('<li class="content-list">');
    html.push('    <div class="dot"></div>');
    html.push('    <p class="content-titel">');
    html.push('        <span>未采购/加工</span>');
    html.push('    </p>');
    html.push('    <div class="order-form">');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">坯布</span>');
    html.push('            <span>' + (search_type.horse ? (data['pbcg_wcgps'] || 0) : (data['pbcg_wcgsl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">成品</span>');
    html.push('            <span>' + (search_type.horse ? (data['cpcg_wcgps'] || 0) : (data['cpcg_wcgsl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('    </div>');
    html.push('</li>');

    // html.push('<li class="content-list">');
    // html.push('    <div class="dot"></div>');
    // html.push('    <p class="content-titel">');
    // html.push('        <span>下织</span>');
    // html.push('    </p>');
    // html.push('    <div class="order-form">');
    // html.push('        <span>');
    // html.push('            <span>下织日期</span>');
    // html.push('            <span>XX</span>');
    // html.push('        </span>');
    // html.push('        <span>');
    // html.push('            <span>完成日期</span>');
    // html.push('            <span>XX</span>');
    // html.push('        </span>');
    // html.push('    </div>');
    // html.push('    <div class="order-form">');
    // html.push('        <span>');
    // html.push('            <span>下织'+unit+'</span>');
    // html.push('            <span>XX</span>');
    // html.push('        </span>');
    // html.push('        <span>');
    // html.push('            <span>完成'+unit+'</span>');
    // html.push('            <span>XX</span>');
    // html.push('        </span>');
    // html.push('    </div>');
    // html.push('</li>');

    var pbcg_wldw_mc = $.nui.isTrue(data['pbcg_wldw_mc']) ? ('：' + data['pbcg_wldw_mc']) : '';

    html.push('<li class="content-list">');
    html.push('    <div class="dot"></div>');
    html.push('    <p class="content-titel">');
    html.push('        <span>坯布采购' + pbcg_wldw_mc + '</span>');
    html.push('    </p>');
    html.push('    <div class="order-form">');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">采购</span>');
    html.push('            <span>' + (search_type.horse ? (data['pbcg_ps'] || 0) : (data['pbcg_sl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">来货</span>');
    html.push('            <span>' + (search_type.horse ? (data['pbcg_lhps'] || 0) : (data['pbcg_lhsl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">未来</span>');
    html.push('            <span>' + (search_type.horse ? (data['pbcg_wlhps'] || 0) : (data['pbcg_wlhsl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('    </div>');
    html.push('</li>');

    var cpcg_wldw_mc = $.nui.isTrue(data['cpcg_wldw_mc']) ? ('：' + data['cpcg_wldw_mc']) : '';

    html.push('<li class="content-list">');
    html.push('    <div class="dot"></div>');
    html.push('    <p class="content-titel">');
    html.push('        <span>成品采购' + cpcg_wldw_mc + '</span>');
    html.push('    </p>');
    html.push('    <div class="order-form">');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">采购</span>');
    html.push('            <span>' + (search_type.horse ? (data['cpcg_ps'] || 0) : (data['cpcg_sl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">来货</span>');
    html.push('            <span>' + (search_type.horse ? (data['cpcg_lhps'] || 0) : (data['cpcg_lhsl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('        <span>');
    html.push('            <span class="width-auto align-left">未来</span>');
    html.push('            <span>' + (search_type.horse ? (data['cpcg_wlhps'] || 0) : (data['cpcg_wlhsl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('    </div>');
    html.push('</li>');

    var wwjg_wldw_mc = $.nui.isTrue(data['wwjg_wldw_mc']) ? ('：' + data['wwjg_wldw_mc']) : '';

    html.push('<li class="content-list">');
    html.push('    <div class="dot"></div>');
    html.push('    <p class="content-titel">');
    html.push('        <span>加工' + wwjg_wldw_mc + '</span>');
    html.push('    </p>');
    // if (data['wwjg_hq'] || data['wwjg_kdsj']) {
    var hq_time = data['wwjg_hq'] ? fun.formatDate(data['wwjg_hq'], 'YY-MM-DD') : '';
    var kdsj_time = data['wwjg_kdsj'] ? fun.formatDate(data['wwjg_kdsj'], 'YY-MM-DD') : '';
    html.push('    <div class="order-form">');
    html.push('        <span>');
    html.push('            <span class="width-auto overflow;">加工</span>');
    html.push('            <span style="width: 65%;">' + kdsj_time + '</span>');
    html.push('        </span>');
    html.push('        <span style="width: 60%;">');
    html.push('            <span class="width-auto overflow;">货期</span>');
    html.push('            <span style="width: 65%;">' + hq_time + '</span>');
    html.push('        </span>');
    html.push('    </div>');
    // }
    html.push('    <div class="order-form">');
    html.push('        <span>');
    html.push('            <span class="width-auto overflow;">加工</span>');
    html.push('            <span>' + (search_type.horse ? (data['wwjg_ps'] || 0) : (data['wwjg_sl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('        <span>');
    html.push('            <span class="width-auto overflow;">完成</span>');
    html.push('            <span>' + (search_type.horse ? (data['wwjg_lhps'] || 0) : (data['wwjg_lhsl'] || 0)) + '</span>');
    html.push('        </span>');
    html.push('    </div>');
    html.push('</li>');


    $(page_data['jglx']).each(function (idx, item) {
        var _field = 'jglx_' + item['id'] + '_';

        if (typeof data[_field + 'gxlx_id'] === 'undefined') return true;

        var jglx_mc = item['name'] ? item['name'] : '';
        var jgs_mc = data[_field + 'jgs_mc'] ? "：" + data[_field + 'jgs_mc'] : '';

        var hq_time = data[_field + 'wwjg_hq'] ? fun.formatDate(data[_field + 'wwjg_hq'], 'YY-MM-DD') : '';
        var kdsj_time = data[_field + 'wwjg_kdsj'] ? fun.formatDate(data[_field + 'wwjg_kdsj'], 'YY-MM-DD') : '';

        html.push('<li class="content-list">');
        html.push('    <div class="dot"></div>');
        html.push('    <p class="content-titel">');
        html.push('        <span>' + jglx_mc + jgs_mc + '</span>');
        html.push('    </p>');

        if (hq_time || kdsj_time) {
            html.push('    <div class="order-form">');
            html.push('        <span>');
            html.push('            <span class="width-auto overflow;">加工</span>');
            html.push('            <span style="width: 65%;">' + kdsj_time + '</span>');
            html.push('        </span>');
            html.push('        <span style="width: 60%;">');
            html.push('            <span class="width-auto overflow;">货期</span>');
            html.push('            <span style="width: 65%;">' + hq_time + '</span>');
            html.push('        </span>');
            html.push('    </div>');
        }

        html.push('    <div class="order-form">');
        html.push('        <span>');
        html.push('            <span class="width-auto overflow;">加工</span>');
        html.push('            <span style="width: 65%;">' + (search_type.horse ? (data[_field + 'wwjg_ps'] || 0) : (data[_field + 'wwjg_sl'] || 0)) + '</span>');
        html.push('        </span>');
        html.push('        <span>');
        html.push('            <span class="width-auto overflow;">完成</span>');
        html.push('            <span style="width: 65%;">' + (search_type.horse ? (data[_field + 'wwjg_lhps'] || 0) : (data[_field + 'wwjg_lhsl'] || 0)) + '</span>');
        html.push('        </span>');
        html.push('    </div>');
        html.push('</li>');
    })

    // console.log(html.join(''));
    $('.content-ul').html(html.join(''))
}


//列表模式 点击预览图片
$('#preview').on('tap', function (e) {
    e.preventDefault();
    if ($(this).attr('large_url') == '') return;

    var img_arr = JSON.parse($(this).attr('large_url'));
    // return;
    if (img_arr.length == 0) return;
    // var index = $(this).prev().attr('index');
    photoBrowser.open({
        images: img_arr,
        // activeIndex: 1 ,
        placeholderImg: '../img/logo.png',
        bgColor: '#000'
    }, function (ret, err) {
        // alerts(ret);
        if (ret) {
            if (ret['eventType'] == 'click') {
                photoBrowser.close();
            }
        } else {
            console.log(JSON.stringify(err));
        }
    });
    return false;
})


$('body').on('click', '.settle-wrap', function (e) {
    e.stopPropagation();
    var AUTH_JD = Auth.check('bp_xsdd', 'settle');
    if (!AUTH_JD) return;

    var text = $('#settle').text().trim();
    var msg = '', flag = false;
    switch (text) {
        case '未结单':
            msg = '您确定要结单该产品吗？';
            flag = true;
            break;
        case '已结单':
            msg = '您确定要取消该产品的结单状态吗？';
            flag = false;
            break;
    }

    fun.dialog({
        content: msg,
        btn: ['确定', '取消'],
        yes: function () {
            if ($.nui.isTrue(__DJTZ_JL)) {
                var USER_INFO = fun.getItem('user_info') || {};
                __DJTZ_JL[0]['is_jd'] = flag ? 1 : 0;
                __DJTZ_JL[0]['jdr_id'] = flag ? USER_INFO['id'] : 0;
                __DJTZ_JL[0]['jdr_mc'] = flag ? USER_INFO['name'] : '';
                __DJTZ_JL[0]['jd_sj'] = flag ? fun.formatDate(new Date()) : '';
            }

            __adjust(flag);
        }
    });
});



function __adjust(flag) {
    var save_data = $.extend(true, {}, {
        status: 'adjust',
        data: __DJTZ_JL,
        dj_id: data['dj_id'],
        isSave: is_adjust_save
    });

    save_data['isSave'] = is_adjust_save;
    var text = '';
    text = flag ? '结单' : '反结单';

    fun.ajax({
        showLoad: true,
        hideLoad: true,
        loadTitle: text + '中...',
        url: AJAX_SAVE,
        data: save_data,
        success: function (res) {
            switch (res['status']) {
                case 0:
                    fun.toast(text + '成功');
                    $('.settle-wrap').show();
                    if (flag) {
                        $('.settle-icon').show();
                        $('#settle').text('已结单');
                        $('.show-seal').show();
                    } else {
                        $('.settle-icon').hide();
                        $('#settle').text('未结单');
                        $('.show-seal').hide();
                    }
                    api.sendEvent({
                        name: page_data['return_page'],
                        extra: {
                            'status': 'refresh',
                        }
                    });
                    break;
                case 'IS_ZS_FKC':
                    var list = res['data']['list'][0];
                    var ps_display = list['bz_ps'] > 0;
                    var sl_display = list['bz_sl'] > 0;
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '库存：' + (list['kc_ps'] || 0) + '匹 ' + (list['kc_sl'] || 0) + list['dw_mc'] + '\r\n',
                        '不足：' + (ps_display ? ((list['bz_ps'] || 0) + '匹 ') : '') + (sl_display ? ((list['bz_sl'] || 0) + list['dw_mc']) : '')
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'IS_TM_FKC':
                    var list = res['data']['list'][0];
                    fun.toast('条码' + list['tm'] + '和库存信息不一致');
                    break;
                case 'IS_MX_FKC':
                    var list = res['data']['list'][0];
                    var msg = [
                        list['cp_bh'] + list['cp_mc'] + '\r\n',
                        list['cp_ys_bh'] + list['cp_ys_mc'] + '\r\n',
                        '不足：' + (list['ps'] || 0) + '匹 ' + (list['sl'] || 0) + list['dw_mc']
                    ].join('');
                    fun.toast(msg);
                    break;
                case 'DDJ_NOT_EMPTY':
                    fun.jdts({
                        content: '<div style="text-align:left;margin-top: -0.5rem;">未抵用订金：' + res['data']['wdyje'] + ' <br>您确定要结单吗？</div>',
                        btn: ['确定结单', '取消'],
                        yes: function () {
                            is_adjust_save = true;
                            __adjust(flag);
                        },
                    });
                    break;
                case 'IS_NOT_FINISH':
                    fun.jdts({
                        content: '部分产品还没发完货，你确定要结单吗？',
                        yes: function () {
                            fun.ajax({
                                showLoad: true,
                                hideLoad: true,
                                loadTitle: '结单中...',
                                url: AJAX_SAVE,
                                data: $.extend(true, { 'notCheckFinish': 1 }, save_data),
                                success: function (res) {
                                    switch (res['status']) {
                                        case 0:
                                            fun.toast('结单成功。');
                                            $('.settle-wrap').show();
                                            $('.settle-icon').show();
                                            $('#settle').text('已结单');
                                            $('.show-seal').show();
                                            api.sendEvent({
                                                name: page_data['return_page'],
                                                extra: {
                                                    'status': 'refresh',
                                                }
                                            });
                                            break;
                                        default:
                                            fun.toast(res['msg']);
                                            break;
                                    }
                                }
                            });
                        },
                    });
                    break;
                default:
                    fun.toast(res['msg']);
                    break;
            }
        }
    });
}

// $('body').on('click', '#edit_btn1', function () {

// })