var html_name = page_arr.xs_khfx_xq;
var date_arr = fun.getMonthArr(12);
// var date_xfxg = fun.getMonthArr(12);
var page_index = 'xfxg';
var nyxh_column = "nywxh";
// var color1 = ['#ABDCFF', '#FEB692', '#CE9FFC', '#90F7EC', '#FFF6B7', '#E2B0FF'];
// var color2 = ['#0396FF', '#EA5455', '#7367F0', '#32CCBC', '#F6416C', '#9F44D3'];
var xfxg_search = { // 消费习惯
    "begin_time": fun.Date(date_arr[0]['begin_date']).Format('yy-mm-dd'),
    "end_time": fun.Date(date_arr[11]['end_date']).Format('yy-mm-dd')
},
    nyfx_search = { // 拿样分析
        "begin_time": fun.Date(date_arr[9]['begin_date']).Format('yy-mm-dd'),
        "end_time": fun.Date(date_arr[11]['end_date']).Format('yy-mm-dd')
    },
    wlqk_search = {}; // 往来情况

var last = { // 限制切换同一个tab造成的再次请求
    tab: 0, // 顶部tab
    lb: 0, // 类别
    gy: 0 // 工艺
}

//查询菜单缓存变量
var search_storage = {
    "begin_date": fun.Date(date_arr[9]['begin_date']).Format('yy-mm-dd'),
    "end_date": fun.Date(date_arr[11]['end_date']).Format('yy-mm-dd'),
};

var xsKhfxXq = {
    backEvent: null, // 返回按钮回调
    selectBackPageInit: null, // 选择客户返回
    clientName: '', // 客户名称
    clientId: '' // 客户id
};

// 点击头部返回按钮回调
xsKhfxXq.backEvent = function () {
    if ('closeAll' in page_data) {
        api.closeToWin({
            name: VersionManager.setPagePath(page_arr.index)
        })
    } else {
        api.closeWin();
    }
}

// 选择客户后回调
xsKhfxXq.selectBackPageInit = function (parmas) {
    var wldwId = parmas.wldwId;
    var wldwName = parmas.wldwName;
    $('#finance_client').text(wldwName).data('id', wldwId);
}

// 选择客户后重置搜索条件
xsKhfxXq.setSearchDataId = function (id) {
    var tempArr = [nyfx_search, wlqk_search, xfxg_search];
    for (var i = 0; i < tempArr.length; i++) {
        var item = tempArr[i];
        item['wldw_id'] = id;
    }
};

// 页面初始化
page_init = function () {
    if (page_data.page_index) {
        page_index = page_data.page_index;
    }
    if (page_data['wldw_id'] && page_data['wldw_mc']) {
        nyfx_search['wldw_id'] = page_data['wldw_id'] || 0;
        wlqk_search['wldw_id'] = page_data['wldw_id'] || 0;
        xfxg_search['wldw_id'] = page_data['wldw_id'] || 0;
        var title = page_data['wldw_mc'] || "";
        xsKhfxXq.clientName = title;
        xsKhfxXq.clientId = page_data['wldw_id'] || 0;
    }
    if (Auth.check('cw_dzb_kh', 'view')) {
        $('.icon-hkl').css('display', 'inline-block');
    }
    // 头部
    $('#header').header({
        back: true, //返回
        title: '客户画像', //标题
        star: true,       //五角星
        filter: true,     //筛选
        appendBackBtnEvt: xsKhfxXq.backEvent
    });
    page_data.keyback = xsKhfxXq.backEvent;
    api.addEventListener({
        name: html_name,
    }, function (ret, err) {

        var temp = ret['value'];
        switch (temp['status']) {
            case 'search':
                nyfx_search['begin_time'] = temp['data']['begin_date'];
                nyfx_search['end_time'] = temp['data']['end_date'];
                var title_date = nyfx_search['begin_time'] + '-' + nyfx_search['end_time'];
                $('#nyfx_title').text(title_date);
                fun.setItem(html_name + 'sideslip', true);
                getList();
                break;
            case "refresh":
                getList();
                break;
            case 'select_list':
                // 更新数据
                var id = temp['data']['id'];
                var clientName = temp['data']['select_val'];
                xsKhfxXq.clientName = clientName;
                xsKhfxXq.clientId = id;
                xsKhfxXq.selectBackPageInit({
                    wldwName: clientName,
                    wldwId: id
                });
                xsKhfxXq.setSearchDataId(id);
                getList(); // 重新获取数据
                break;
            // 没有 default
        }
    });
    $('.finance-return-rate').hide()
    //头部时间标题赋值
    var title_date = nyfx_search['begin_time'] + '-' + nyfx_search['end_time'];
    $('#nyfx_title').text(title_date);
    $('#filter_btn').css('display', 'none');
    $('#finance_client').text(page_data['wldw_mc'] || '');
    getList();
    xfxgInit();
    bindEvent();
    // 软键盘处理
    fun.setKeyBoard({
        isIos: {
            showFn: iosKeyBoardShow,
            hideFn: iosKeyBoardHide
        }
    })

    if (page_index == 'nyfx') {
        $('.layout').removeClass('choice').siblings().eq(1).addClass('choice'); // tab切换
        $('.switch').hide().eq(1).show();
        detailsStyleSwitch(1); // 切换样式
        //拿样分析才显示筛选按钮
        $('#filter_btn').css('display', 'inline-block');
    }
}

// 客户分析-详情，顶部样式
function detailsStyle(ele) {
    $(ele).css({
        marginTop: parseFloat($('.top-half').css('top')) + $('.top-half').outerHeight()
    })
}

// 访客分析-详情，切换样式
function detailsStyleSwitch(idx) {
    switch (idx) {
        case 0: // 消费习惯
            // var res = parseFloat($('#xsfx_switch').css('marginTop')) + $('#xfxg_detail').outerHeight() + $('#xfxg_show').outerHeight();
            // $('#category_analyze').css({
            // 	top: res
            // })
            break;
        case 1: // 拿样分析
            $('.top').css({
                top: parseFloat($('.top-half').css('top')) + $('.top-half').outerHeight()
            })
            $('#nyfx_content').css({
                top: parseFloat($('.top').css('top')) + $('.top').outerHeight()
            })
            break;
        case 2: // 往来情况
            $('.contact-content').css({
                top: parseFloat($('.top-half').css('top')) + $('.top-half').outerHeight()
            })
            break;
        // 没有default
    }
}

// 消费习惯距离顶部样式
function xfxgInit() {
    $('.top-half').css({
        top: api.safeArea.top + $('#header').outerHeight() - parseFloat($('html').css('fontSize'))
    })
    detailsStyle('#xsfx_switch');
    // var identify = parseFloat($('#xsfx_switch').css('marginTop')) / 1.7 + $('#xfxg_detail').outerHeight() + $('#xfxg_show').outerHeight();
    // $('#category_analyze').css({
    //     top: identify
    // })
    // $('.technology').css({
    //     top: parseFloat($('#category_analyze').css('top')) + $('#category_analyze').outerHeight()
    // })
    // $('.finance-bottom').css({
    //     top: parseFloat($('.technology').css('top')) + $('.technology').outerHeight()
    // })
}

// // 拿样分析距离顶部样式
// function nyfxInit() {
// 	detailsStyle('#nyfx_switch');
// }

// // 往来情况距离顶部样式
// function wlqkInit() {
// 	detailsStyle('#nyfx_switch');
// }

//获取数据
function getList() {
    switch (page_index) {
        case 'xfxg': // 消费习惯
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.getKhfxList,
                data: $.extend({}, {
                    "begin_date": '',
                    "end_date": '',
                    "wldw_id": 0,
                    "type": "kh_xq",
                    "lbfx_time": 'j3y',
                    "lbfx_top": 5,
                    "gyfx_time": 'j3y',
                    "gyfx_top": 5,
                }, xfxg_search),
                success: function (res) {
                    // console.log('请求的数据');
                    // console.log(res);
                    // console.log('请求的数据');

                    // 2020-02-25 hcx 暂时隐藏收藏图标

                    if (res['is_gz'] === 1) {
                        $('#star_btn').removeClass('icon-wujiaoxing').addClass('icon-shoucang');
                        $('#star_btn').css({ 'color': '#FF9D01' });
                    }

                    // console.log(JSON.stringify(res))
                    $('#finance-phone').text(res['mobile'] || '');//手机
                    $('#contacts').text(res['lxr_mc'] || '');//联系人
                    $('#finance-address').text(res['lxr_dz'] || '');//地址
                    $('#store').text(res['md_mc'] || '');//门店	
                    $('#salesman').text(res['ywy_mc'] || '');//业务员
                    var hkl = Math.floor((res['hkl'] || 0) * 100) / 100;
                    if (hkl !== 0) {
                        $('.finance-return-rate').show()
                        $('#hkl').text(hkl + '%');//回款率
                    }
                    if ($.nui.isEmpty($('#store').text()) && $.nui.isEmpty($('#salesman').text()) && hkl === 0) {
                        $('#receivable').hide();
                    }
                    var identify = parseFloat($('#xsfx_switch').css('marginTop')) + $('#xfxg_detail').outerHeight() + $('#xfxg_show').outerHeight();
                    $('#category_analyze').css({
                        top: identify
                    })
                    $('.technology').css({
                        top: parseFloat($('#category_analyze').css('top')) + $('#category_analyze').outerHeight()
                    })
                    $('.finance-bottom').css({
                        top: parseFloat($('.technology').css('top')) + $('.technology').outerHeight()
                    })
                    if (res['md_mc'] == '' && res['ywy_mc'] == '') {
                        $('.finance-text2').css('display', 'none');
                    }
                    if (res['lxr_mc'] == '' && res['mobile'] == '') {
                        $('.finance-dianhua').css('display', 'none');
                    }
                    $('#arrears').text(res['qk'] || 0); //欠款
                    // $('#arrears_cycle').text(res['qkzq'] || 0); //欠款周期
                    $('#credibility').text(res['xye'] || 0);//信誉额
                    $('#available').text(res['kyed'] || 0);//可用额度
                    $('#hzsj_rq').text(res['hzsj'] || '');//合作时间
                    $('#hzsj_zq').text(res['hzzq'] || 0);//合作周期
                    $('#hzje_xse').text(res['hszje'] || 0);//总销售额
                    //月均销售
                    var yjxs = Math.round((res['yjxs'] || 0) * 10) / 10;
                    $('#hzje_yjxs').text(yjxs || 0);
                    //客单价
                    var kdj = Math.round((res['kdj'] || 0) * 10000) / 10000;
                    $('#pj_kdj').text(kdj || 0);
                    //客单量/匹
                    var kdl = Math.round((res['kdl'] || 0) * 10) / 10;
                    $('#pj_kdl').text(kdl);
                    //总单量
                    $('#pc_zdl').text(res['zdl'] || 0);
                    //月均购买
                    var yjgm = Math.round(res['yjgm'] || 0);
                    $('#pc_yj').text(yjgm + '次' || 0);

                    var xsqk = res['xsqk'] || [];
                    var xsqkHtml = [];
                    if (xsqk.length == 0) {
                        $('.finance-bottom').remove();
                    }
                    // console.log(JSON.stringify(res))
                    for (var i = 0; i < xsqk.length; i++) {
                        xsqkHtml.push('<li class="finance-term2 lower-border-line" data-date="' + xsqk[i]['kdsj'] + '">');
                        xsqkHtml.push('    <span class="finance-date">' + xsqk[i]['kdsj'] + '</span>');
                        xsqkHtml.push('    <div class="finance-sales-number">');
                        xsqkHtml.push('         <span class="finance-kilo">' + xsqk[i]['xss'] + xsqk[i]['dw_mc'] + '</span>');
                        xsqkHtml.push('         <span class="finance-piece">' + xsqk[i]['xsp'] + '匹' + '</span>');
                        xsqkHtml.push('    </div>');
                        xsqkHtml.push('    <div class="finance-sales-volume">');
                        xsqkHtml.push('         <span class="finance-achievement">' + xsqk[i]['xse'] + '</span>');
                        xsqkHtml.push('         <i class="iconfont icon-youfanhui finance-youfanhui"></i>');
                        xsqkHtml.push('    </div>');
                        xsqkHtml.push('</li>');
                    }
                    $('#myxs').html(xsqkHtml.join(''));

                    //类别分析
                    var lbfx = res['lbfx'] || [];
                    if (lbfx.length != 0) {
                        var lbfx_data = [];
                        var lbfx_close = [];
                        var lbfx_title = res['lbfx_xse'] || 0;

                        for (var i = 0; i < lbfx.length; i++) {
                            // console.log(color1[i])
                            var xse = lbfx[i]['xse'] || 0;
                            if (xse < 0 || xse === 0) {
                                lbfx_close.push({
                                    value: xse,
                                    name: (lbfx[i]['lb_mc'] || '无类别'),
                                });
                                xse = 0;
                            }
                            lbfx_data.push({
                                value: xse,
                                name: (res['lbfx'][i]['lb_mc'] || '无类别'),
                            });
                        }
                        lbfx_data = lbfx_close.length === lbfx.length ? lbfx_close : lbfx_data;
                        var myChart = echarts.init(document.getElementById('category_chart'));
                        var option = {
                            title: [{
                                text: '总销售额',
                                x: 'center',
                                top: '40%',
                                textStyle: {
                                    color: '#a5a5a5',
                                    fontSize: 16
                                }
                            }, {
                                text: lbfx_title,
                                x: 'center',
                                top: '50%',
                                textStyle: {
                                    color: '#000',
                                    width: '50%',
                                    fontSize: 16
                                }
                            }],
                            tooltip: {
                                trigger: 'item',
                                //强制去掉tooltip的overflow
                                position: function (point, params, dom, rect, size) {
                                    dom.style.transform = "translateZ(0)";
                                },
                                confine: true,
                                formatter: "{b} ({d}%)<br/>{a}: {c} "
                            },
                            series: [{
                                name: '销售额',
                                type: 'pie',
                                color: order_color,
                                radius: ['55%', '75%'],
                                avoidLabelOverlap: true,
                                label: {
                                    normal: {
                                        show: false,
                                        position: 'center'
                                    }

                                },
                                labelLine: {
                                    normal: {
                                        show: false
                                    }
                                },
                                data: lbfx_data
                            }]
                        };
                        myChart.setOption(option);
                        myChart.on('click', function (param) {//不监听会报错
                            return;
                        });
                    } else {
                        // $('#category_chart').html('<p class="empty_text">暂无数据！</p>');
                        fun.createDataEmptyTips({ dom: '#category_chart', btnShow: false });
                    }

                    var gyfx = res['gyfx'] || [];
                    if (gyfx.length != 0) {
                        var gyfx_data = [];
                        var gyfx_close = [];
                        var gyfx_title = res['gyfx_xse'] || 0;
                        for (var i = 0; i < gyfx.length; i++) {
                            var xse = gyfx[i]['xse'] || 0;
                            if (xse < 0 || xse === 0) {
                                gyfx_close.push({
                                    'value': xse, 'name': (gyfx[i]['gy_mc'] || ''),
                                });
                                xse = 0;
                            }
                            gyfx_data.push({
                                'value': xse, 'name': (gyfx[i]['gy_mc'] || ''),
                            });
                        }
                        gyfx_data = gyfx_close.length === gyfx.length ? gyfx_close : gyfx_data;
                        var technology_myChart = echarts.init(document.getElementById('technology_chart'));
                        var technology_option = {
                            title: [{
                                text: '总销售额',
                                x: 'center',
                                top: '40%',
                                textStyle: {
                                    color: '#a5a5a5',

                                    fontSize: 16
                                }
                            }, {
                                text: gyfx_title,
                                x: 'center',
                                top: '50%',
                                textStyle: {
                                    color: '#000',
                                    width: '50%',
                                    fontSize: 16
                                }
                            }],
                            tooltip: {
                                trigger: 'item',
                                //强制去掉tooltip的overflow
                                position: function (point, params, dom, rect, size) {
                                    dom.style.transform = "translateZ(0)";
                                },
                                confine: true,
                                formatter: "{b} ({d}%)<br/>{a}: {c} "
                            },
                            series: [{
                                name: '销售额',
                                type: 'pie',
                                color: order_color,
                                radius: ['55%', '75%'],
                                avoidLabelOverlap: true,
                                label: {
                                    normal: {
                                        show: false,
                                        position: 'center'
                                    }

                                },
                                labelLine: {
                                    normal: {
                                        show: false
                                    }
                                },
                                data: gyfx_data
                            }]
                        };
                        technology_myChart.setOption(technology_option);
                        technology_myChart.on('click', function (param) {//不监听会报错
                            return;
                        });
                    } else {
                        // $('#technology_chart').html('<p class="empty_text">暂无数据！</p>');
                        return fun.createDataEmptyTips({ dom: '#technology_chart', btnShow: false });
                    }
                }
            });
            break;
        case 'nyfx': // 拿样分析
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.getNyfxList,
                data: $.extend({}, {
                    "begin_time": "",
                    "end_time": "",
                    "md_id": 0,
                    "cp_id": 0,
                    "wldw_id": 0,
                    "wldw_lb_id": 0,
                    "type": "fx_kh",
                    "cx_type": "yb"
                }, nyfx_search),
                success: function (res) {
                    console.log('拿样分析的请求', res)
                    if (res['status'] == 0) {
                        if ($.nui.isTrue(res['data'])) {
                            nyfxDataShow();
                            var data = res['data'] || [];
                            showList(data);
                        } else {
                            // return $('#nyfx_list').html('<p class="empty_text">暂无数据！</p>');
                            nyfxDataEmpty(); // 拿样记录列表无数据
                            return fun.createDataEmptyTips({ dom: '#nyfx_list', btnShow: false });
                        }
                    }
                }
            });
            break;
        case 'wlqk': // 往来情况
            fun.ajax({
                showLoad: true,
                hideLoad: true,
                url: AJAX_URL.getKhfxList,
                data: $.extend({}, {
                    "wldw_id": 0,
                    "type": "kh_wlqk"
                }, wlqk_search),
                success: function (res) {
                    $('#wyw_ts').text(res['wywts'] || 0);
                    $('#wlx_ts').text(res['wlxts'] || 0);
                    $('#zhdh_rq').text(res['dd_kdsj'] || '');
                    $('#zhdh_je').text(res['dd_zje'] || 0);
                    $('#zhfh_rq').text(res['fh_kdsj'] || '');
                    $('#zhfh_je').text(res['fh_zje'] || 0);
                    $('#zhth_rq').text(res['th_kdsj'] || '');
                    $('#zhth_je').text(res['th_zje'] || 0);
                    $('#zhlk_rq').text(res['sk_kdsj'] || '');
                    $('#zhlk_je').text(res['sk_zje'] || 0);
                }
            });
            break;
    }
}

fun.setItem(html_name + 'sideslip', true);

//拿样分析，数据渲染
function showList(data) {
    console.log(JSON.stringify(data))
    var nyfxHtml = [];
    switch (nyxh_column) {
        case 'nyyxh':
            $('#nyfx_list').html('');
            //有下货
            var nyyxh = data[0]['cp_info'] || [];
            for (var i = 0; i < nyyxh.length; i++) {
                var nysj = fun.formatDate(nyyxh[i]['nysj'], 'YYYY-MM-DD') || '';
                var xhs = nyyxh[i]['xhzsl'] || 0;
                if (xhs > 0) {
                    nyfxHtml.push('<li class="term lower-border-line padding-dot-2">');
                    nyfxHtml.push('    <p class="name blue-color line-height15">' + nyyxh[i]['cp_bh'] + ' ' + nyyxh[i]['cp_mc'] + '</p>');

                    if (nyyxh[i]['cf'] && $.nui.isTrue(nyyxh[i]['cf'])) {
                        nyfxHtml.push('    <p class="component line-height15">' + nyyxh[i]['cf'] || '' + '</p>');
                    }

                    nyfxHtml.push('    <div class="term-box clearfix">');
                    nyfxHtml.push('        <div class="box clearfix">');
                    nyfxHtml.push('            <span class="text line-height15">最后拿样</span>');
                    nyfxHtml.push('            <span class="date line-height15">' + nysj + '</span>');
                    nyfxHtml.push('        </div>');
                    nyfxHtml.push('        <div class="box clearfix">');
                    nyfxHtml.push('            <span class="text2 line-height15">下货数</span>');
                    nyfxHtml.push('            <span class="date2 line-height15 blue-color">' + xhs + '</span>');
                    nyfxHtml.push('        </div>');
                    nyfxHtml.push('    </div>');
                    nyfxHtml.push('</li>');
                }
            }
            $('#nyfx_list').html(nyfxHtml.join(''));

            break;
        case 'nywxh':
            $('#nyfx_list').html('');
            //未下货
            // var nywxh = data[0]['wxh_info'] || [];
            var nywxh = data[0]['cp_info'] || [];
            for (var i = 0; i < nywxh.length; i++) {
                var wxh_nysj = fun.formatDate(nywxh[i]['nysj'], 'YYYY-MM-DD');

                nyfxHtml.push('<li class="term lower-border-line padding-dot-2">');
                nyfxHtml.push('    <p class="name">' + nywxh[i]['cp_bh'] + ' ' + nywxh[i]['cp_mc'] + '</p>');

                if (nywxh[i]['cf'] && $.nui.isTrue(nywxh[i]['cf'])) {
                    nyfxHtml.push('    <p class="component line-height15">' + nywxh[i]['cf'] || '' + '</p>');
                }

                nyfxHtml.push('    <div class="term-box">');
                nyfxHtml.push('        <span class="text line-height15">最后拿样</span>');
                nyfxHtml.push('        <span class="date line-height15">' + wxh_nysj || '' + '</span>');
                nyfxHtml.push('    </div>');
                nyfxHtml.push('</li>');
            }
            $('#nyfx_list').html(nyfxHtml.join(''));
            break;
    }
}

//打开扫描
function openScanner(options) {
    // 打开-扫描页面
    var _options = $.extend(true, {}, {
        callback: null,   // 回调函数
        close_win: true   // 扫描完成后，是否关闭窗口
    }, options);
    var FNScanner = api.require('FNScanner');
    FNScanner.open({
        autorotation: false
    }, function (ret, err) {
        if (ret) {
            if (ret.eventType == 'success') {
                if (typeof _options.callback === 'function') _options.callback(ret.content);
                if (_options.close_win) FNScanner.closeView();
            }
        }
        // FNScanner.closeView();
    });

}

// ios软键盘弹起处理
function iosKeyBoardShow() {
    fun.headerAbsolute('#header');
}

// ios软键盘收起处理
function iosKeyBoardHide() {
    fun.headerFixed('#header');
}

// 记录列表有数据
function nyfxDataShow() {
    $('#nyfx_title').show();
    $('#nyfx_content').css({
        top: parseFloat($('.top').css('top')) + $('.top').outerHeight(),
        height: 'auto'
    })
    $('#nyfx_list').css({
        height: 'auto',
    })
}

// 记录列表无数据
function nyfxDataEmpty() {
    $('#nyfx_title').hide();
    $('#nyfx_content').css({
        height: $(window).height() - parseFloat($('#nyfx_content').css('top')),
    })
    $('#nyfx_list').css({
        height: '100%'
    })
}

// 初始化事件
function bindEvent() {
    //点击每月销售记录，跳转到发退货结算统计
    $('body').on('tap', '.finance-term2', function () {
        if (Auth.checkArr(['bp_xsfhjs', 'bp_xsthjs'], 'view', 'in')) {
            var date = $(this).data('date');
            if (page_data['wldw_id'] && page_data['wldw_mc']) {
                var wldw_id = page_data['wldw_id'];
                var wldw_mc = page_data['wldw_mc'];
            }
            var begin_date = $.nui.dayjs(date).startOf('month').format('YYYY-MM-DD');
            var end_date = $.nui.dayjs(date).endOf('month').format('YYYY-MM-DD');

            var details = {
                wldw_id: wldw_id,
                wldw_mc: wldw_mc,
                begin_date: begin_date,
                end_date: end_date
            };

            fun.showPageFull({
                page_url: page_arr.xs_fthjs_tj,
                pageParam: {
                    // "wldw_id": wldw_id,
                    // "wldw_mc": wldw_mc,
                    // "begin_date": begin_date,
                    // "end_date": end_date,
                    "details": details
                }
            });
        }
    });

    //上月回款率跳转到客户对账
    $('body').on('tap', '.icon-hkl', function () {
        if (Auth.check('cw_dzb_kh', 'view')) {
            var begin = fun.Date(date_arr[10]['begin_date']).Format('yy-mm-dd');
            var end = fun.Date(date_arr[10]['end_date']).Format('yy-mm-dd');
            fun.showPageFull({
                page_url: page_arr.cw_dz,
                pageParam: {
                    title: '客户对账表',
                    page_type: 'kh',
                    "begin_time": begin,
                    "end_time": end,
                }
            });
        }
    });

    // 切换
    $('.layout').on('tap', fun.debounce(function () {
        if (last['tab'] === $(this).index()) return;
        last['tab'] = $(this).index();
        $(this).addClass('choice').siblings().removeClass('choice'); // tab切换
        page_index = $(this).attr('index');
        var index = $(this).index();
        $('.switch').hide();
        $('.switch').eq(index).show();
        detailsStyleSwitch(index); // 切换样式
        //拿样分析才显示筛选按钮
        if (page_index === 'nyfx') {
            $('#filter_btn').css('display', 'inline-block');
        } else {
            $('#filter_btn').css('display', 'none');
        }
        getList();
    }, 300));

    // 点击弹出选择框
    $('#take_samples').on('click', function (e) {
        var val = $(this).val();
        var unloading_list = [
            { "name": "拿样未下货", "column": "nywxh", "is_choose": 1 },
            { "name": "拿样有下货", "column": "nyyxh", "is_choose": 0 },
        ];
        $(unloading_list).each(function (i, arr) {
            if (arr['name'] == val) {
                unloading_list[i]['is_choose'] = 1;
            } else {
                unloading_list[i]['is_choose'] = 0;
            }
        });
        fun.showBookList({
            list: unloading_list,
            choose: function (res) {
                $('#take_samples').val(res['name']);
                $('#take_samples').data('type', res['column']);
                nyxh_column = res['column'];
                getList();
            }
        })
        return false;
    });

    $('#sample_plate').on('click', function (e) {
        var val = $(this).val();
        var sample_list = [
            { "name": "样版/剪样", "column": "yb", "is_choose": 1 },
            { "name": "色卡", "column": "sk", "is_choose": 0 },
        ];
        $(sample_list).each(function (i, arr) {
            if (arr['name'] == val) {
                sample_list[i]['is_choose'] = 1;
            } else {
                sample_list[i]['is_choose'] = 0;
            }
        });
        fun.showBookList({
            list: sample_list,
            choose: function (res) {
                $('#sample_plate').val(res['name']);
                $('#sample_plate').data('type', res['column']);
                nyfx_search['cx_type'] = res['column'];
                getList();
            }
        })
        return false;
    });

    //类别分析TOP选择
    $('#category_top').on('click', function (e) {
        var val = $(this).text();
        var category_list = [
            { "name": "TOP 5", "column": "5", "is_choose": 1 },
            { "name": "TOP 10", "column": "10", "is_choose": 0 },
        ];
        $(category_list).each(function (i, arr) {
            if (arr['name'] == val) {
                category_list[i]['is_choose'] = 1;
            } else {
                category_list[i]['is_choose'] = 0;
            }
        });

        fun.showBookList({
            list: category_list,
            choose: function (res) {
                $('#category_top').text(res['name']);
                xfxg_search.lbfx_top = res['column'];

                // $('#sample_plate').data('type', res['column']);
                // nyfx_search['cx_type'] = res['column'];
                getList();
            },

        })
        return false;
    });

    //工艺分析TOP选择
    $('#technology_top').on('click', function (e) {
        var val = $(this).text();
        var technology_list = [
            { "name": "TOP 5", "column": "5", "is_choose": 1 },
            { "name": "TOP 10", "column": "10", "is_choose": 0 },
        ];
        $(technology_list).each(function (i, arr) {
            if (arr['name'] == val) {
                technology_list[i]['is_choose'] = 1;
            } else {
                technology_list[i]['is_choose'] = 0;
            }
        });
        fun.showBookList({
            list: technology_list,
            choose: function (res) {
                $('#technology_top').text(res['name']);
                xfxg_search.gyfx_top = res['column'];
                getList();
            },

        })
        return false;
    });

    //类别分析-月份切换
    $('body').on('tap', '.lbfx', fun.debounce(function () {
        if (last['lb'] === $(this).index()) return;
        last['lb'] = $(this).index();
        $(this).addClass('choice2').siblings().removeClass('choice2');
        // var type_data = $(this).parent().attr('index');
        var type_data = $(this).attr('index');
        xfxg_search['lbfx_time'] = type_data;
        getList();
    }, 300))

    //工艺分析-月份切换
    $('body').on('tap', '.gyfx', fun.debounce(function () {
        if (last['gy'] === $(this).index()) return;
        last['gy'] = $(this).index();
        $(this).addClass('choice2').siblings().removeClass('choice2');
        // var type_data = $(this).parent().attr('index');
        var type_data = $(this).attr('index');
        xfxg_search['gyfx_time'] = type_data;
        console.log('---');
        console.log(xfxg_search);
        console.log('---');
        getList();
    }, 300));

    //打开搜索页
    $('body').on('tap', '#filter_btn', function () {
        var sideslip = fun.getItem(html_name + 'sideslip');
        var options = {
            "time": {
                "begin_date": nyfx_search['begin_time'],
                "end_date": nyfx_search['end_time']
            },
        }
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    "return_page": html_name,
                    "search_data": options
                },
                // y: fun.fontUnit(header)
            });
        }
    })

    //拨打电话
    $('body').on('tap', '#phone', function () {
        event.stopPropagation();
        var number = $('#finance-phone').text();
        // console.log(number)
        if ($.nui.isTrue(number) && fun.regCheck(number, 'phone')) {
            api.call({
                type: 'tel_prompt',
                number: number
            });
        } else {
            fun.toast('手机号码有误！无法拨打电话.');
        }
        return false;
    });

    //点击键盘搜索
    $("#foot_search").bind('search', function () {
        // console.log($(this).val().trim())
        nyfx_search['keyword'] = $(this).val().trim();
        console.log(JSON.stringify(nyfx_search));
        $('#nyfx_list').empty();
        getList();
    });

    //扫一扫
    $('body').on('tap', ".icon-saoma", function () {
        QuestPermission.requestPermission('camera', null,function () {
            openScanner({
                callback: function (value) {
                    $("#foot_search").val(value);
                    if (!!$("#foot_search").val()) {
                        nyfx_search['keyword'] = $('#foot_search').val().trim();
                        $('#nyfx_list').empty();
                        getList();
                        return true;
                    } else {
                        fun.toast('扫码失败！');
                        return true;
                    }
                }
            });
        });
       
    });

    // 选客户
    $('body').on('click', '#detail_client', function () {
        fun.showPageFull({
            page_url: page_arr.customer_search,
            pageParam: {
                return_page: html_name,
                BILL_PAGE: page_arr.xs_khfx_xq,
                page_type: 'kh'
            }
        });
    });

    // 当 客户名称 看不到时，则标题栏字眼变为：客户名称。反之，则显示：客户画像。
    $(window).off('scroll').on('scroll', fun.throttle(function () {
        var scrollTop = $(document).scrollTop();
        var tabListHeight = $('.top-half').outerHeight();
        var clientHeight = $('#detail_client').outerHeight() / 1.6;
        if (scrollTop >= (tabListHeight + clientHeight)) { // 显示客户名称
            $('#header_title').text(xsKhfxXq.clientName);
        } else { // 显示客户画像
            $('#header_title').text('客户画像');
        }
    }, 100));


    // 点击收藏
    $('body').on('click', '#star_btn', function (e) {
        if ($(this).attr('disabled')) return;
        var isCollect = 0;
        if ($(this).hasClass('icon-shoucang')) {
            $(this).removeClass('icon-shoucang').addClass('icon-wujiaoxing');
            $(this).css({ 'color': '' });
            isCollect = 0;
        } else {
            $(this).removeClass('icon-wujiaoxing').addClass('icon-shoucang');
            $(this).css({ 'color': '#FF9D01' });
            isCollect = 1;
        }
        fun.ajax({
            showLoad: true,
            hideLoad: true,
            url: AJAX_URL.saveMerchant,
            data: {
                save_type: 'collect',
                id: xsKhfxXq.clientId,
                is_gz: isCollect
            },
            success: function (res) {
                console.log('---success');
                console.log(res);
            },
            error: function (err) {
                console.log('---errer');
                console.log(err);
            }
        })
    });
}