/**获取日期*/
var html_name = page_arr.xs_nyfx_cpxq;
var date_arr = fun.getMonthArr(6),
    to_month = fun.getMonthArr(1)[0], //获取本月第一天和最后一天
    search_data = {},
    page_list = [];
var reset;//重置日期
/**标题栏 */
$('#header').header({
    back: true,
    title: '拿样分析',
    filter: true,
});

/**页面初始化 */
page_init = function () {
    reset = {
        begin_date: page_data['begin_time'],
        end_date: page_data['end_time']
    }
    search_data = {
        'cx_type': '',
        'type': 'fx_cp',
        'begin_time': page_data['begin_time'], //fun.Date(to_month['begin_date']).Format('yy-mm-dd'),
        'end_time': page_data['end_time'], //fun.Date(to_month['end_date']).Format('yy-mm-dd'),
        'cp_id': page_data['cp_id'] || 0,
        'md_id': page_data['list']['md_id'] || 0,
        'md_mc': page_data['list']['md_mc'] || "",
    }
    getList()
    bindEvent();

    /**监听筛选返回事件 */
    api.addEventListener({
        name: html_name
    }, function (ret, err) {
        // 根据点击筛选返回的状态做处理
        var temp = ret['value'];
        switch (ret['value']['status']) {
            case 'search': // 搜索
            case 'reset': // 重置
                search(temp);
                // pageVal(nyfx_sx);
                // bindEvent();
                break;
        }
    })
    fun.scrollToBottom({}, function () {
        if (page_list.length > 0) {
            showList(fun.PagingData(page_list) || []);
        } else {
            fun.createBottomLine('wx_list', "");
        }
    });
}

function search(temp) {
    fun.setItem(html_name + 'sideslip', true); // 筛选按钮,是否可以打开
    search_data['begin_time'] = temp['data']['begin_date'];
    search_data['end_time'] = temp['data']['end_date'];
    $('.wx_list').empty();
    getList();
}

function getList() {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getNyfxList,
        data: search_data,
        success: function (res) {
            if (res.status === 0) {
                var info_data = res.data[0] || {};
                if (res.data.length < 1) {
                    $('.cp_card').hide();
                    $('.wx_list').empty();
                    return $('#zangwu').show()
                } else {
                    if ($.nui.isTrue(info_data)) {
                        $('.wx_list').empty();
                        $('#zangwu').hide();
                        $('.cp_card').show();
                        pageVal(info_data)
                        page_list = [];
                        page_list = info_data['kh_info'];
                        // 把数据按时间进行降序
                        page_list.sort(function (a, b) {
                            var x = a["nysj"];
                            var y = b["nysj"];
                            return x > y ? -1 : x < y ? 1 : 0;
                        });
                        showList(fun.PagingData(page_list) || []);
                    }
                }
            }
        }
    })
}

/**渲染微信用户的数据 */
function showList(data) {
    console.log('123', data)

    var html = [];
    for (var i = 0; i < data.length; i++) {
        html.push('<div class="list_info" data-wxinfo=\'' + JSON.stringify(data[i]) + '\'>')
        // html.push('    <span class="wx_img"><img src="../img/' + data[i]['img'] + '" alt=""></span>')
        html.push('     <p class="wx_info">')
        html.push('         <span class="wxnc over-flow hidden-width">' + data[i]['wldw_mc'] + '</span>')
        html.push('         <span class="wxsj" style="' + ($.nui.isTrue(data[i]['lxr_mc']) && $.nui.isTrue(data[i]['mobile']) ? 'display: block;' : 'display: none;') + '"><em class="sj over-flow phone" style="max-width: calc(55% - 2.5rem);">' + (data[i]['lxr_mc'] || '') + '</em> <em class="hidden margin-left-ms phone" id="mobile">' + (data[i]['mobile'] || '') + '</em></span>')
        html.push('         <span class="wxs">')
        html.push('             <em class="wx_time">' + data[i]['nysj'].substr(0, 16) + '</em>')
        html.push('             <em class="wx_sl"><em>数量：</em><em>' + (data[i]['xhzsl'] || 0) + '</em></em>')
        html.push('         </span>')
        html.push('     </p>')
        html.push('</div>')
    }
    $('.wx_list').html(html.join(''));
}

// console.log($('.wx_list').html());

/**页面初始化数据的方法 */
function pageVal(data) {
    var img_url = ((!!data['cp_tp']) ? fun.getImgPath(data['cp_tp']) : "../img/logo.png");
    if (img_url === "../img/logo.png") {
        // console.log('666')
        $('.mask-img').hide();
        // $('.mask-img').attr('src', '');
        $('.cp_img').addClass('mr-box');
    }
    // var img = []
    // if ($.nui.isEmpty(data['cp_tp'])) {
    //     img = []
    // } else {
    //     if ($.isArray(data['cp_tp'])) {
    //         img = data['cp_tp']
    //     } else {
    //         if (data['cp_tp'].indexOf(',') > -1) {
    //             img = data['cp_tp'].split(',')
    //         } else {
    //             img.push(data['cp_tp'])
    //         }
    //     }
    // }
    $('.xzrq').text(search_data['begin_time'] + ' ~ ' + search_data['end_time']);// 日期
    $('.cpImg').attr('src', img_url); //产品图片

    $('.cp_title').text(data['cp_bh'] + ' ' + data['cp_mc'] || ''); //产品图片
    $('.cp_cf').text(data['cf'] || ''); //产品成分
    $('.nyfx_nyr').text(data['nys'] || 0); // 拿样人数
    $('.nyfx_bl').text(fun.is_value(valueRound(data['xhbl'])) + '%'); // 下货比例
    $('.nyfx_fk').text(data['fk'] || 0); //幅宽
    $('.nyfx_kz').text(data['kz'] || 0); //克重
    if ($.nui.isEmpty(data['fk']) && $.nui.isEmpty(data['kz'])) {
        $('.fkkz').hide()
    } else {
        $('.fkkz').show()
    }
    //价格
    if (data['zdj'] != undefined && data['zdj'] != null && data['bzj'] != undefined && data['bzj'] != null) {
        if (data['zdj'] == data['bzj']) {
            $('.nyfx_jg').html((data['bzj']) + '/' + ($.nui.isTrue(data['xsdw_mc']) ? data['xsdw_mc'] : data['dw_mc']) + '');
        } else {
            $('.nyfx_jg').html((data['zdj']) + '~' + (data['bzj']) + '/' + ($.nui.isTrue(data['xsdw_mc']) ? data['xsdw_mc'] : data['dw_mc']) || '');
        }
    } else {
        $('.nyfx_jg').html('0/' + ($.nui.isTrue(data['xsdw_mc']) ? data['xsdw_mc'] : data['dw_mc'] || ''));
    }
    $('.nyfx_xhs').text(data['xhzsl'] || 0); //下货数量
    $('.nyfx_xhr').text(data['xhs'] || 0); //下货人数
}

/**事件的公用页面方法（事件可以写方法里） */
function bindEvent() {
    // 点击大图预览
    $('body').on('tap', '.cp_img', function () {
        var imgs = $(this).children('.cpImg').attr('src');
        var photoBrowser = api.require('photoBrowser');
        if (imgs != '../img/logo.png') {
            photoBrowser.open({
                images: [imgs],
                activeIndex: 0,
                placeholderImg: '../img/logo.png',
                bgColor: '#000'
            }, function (ret, err) {
                if (ret) {
                    if (ret['eventType'] == 'click') photoBrowser.close();
                } else {
                    fun.toast('图片打开失败！');
                    photoBrowser.close();
                }
            });
        }
    });

    /**筛选一开始默认为true表示为可打开状态 */
    fun.setItem(html_name + 'sideslip', true);

    // 打开搜索页 
    $('body').on('tap', '#filter_btn', function () {
        var sideslip = fun.getItem(html_name + 'sideslip');
        // console.log(sideslip)
        var options = {
            "time": {
                "begin_date": search_data['begin_time'],
                "end_date": search_data['end_time']
            },
        };
        if (sideslip) {
            fun.setItem(html_name + 'sideslip', false);
            fun.openFrame({
                frame_url: page_arr.search,
                pageParam: {
                    "return_page": html_name,
                    "search_data": options,
                    "reset": reset,
                    "is_restbutton": true,
                    "type": 'xs_nyfx_cpxq'
                },
                // y: fun.fontUnit(header)
            });
        }
    })

    // 跳转到客户分析-拿样分析
    $('body').on('click', '.list_info', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var data = $(this).data('wxinfo');
        fun.showPageFull({
            page_url: page_arr['xs_khfx_xq'],
            pageParam: {
                wldw_mc: data['wldw_mc'],
                wldw_id: data['wldw_id'],
                page_index: 'nyfx'
            }
        })
    })

    // 拨打手机
    // $('body').on('click', '.wxsj', function (e) {
    $('body').on('click', '.phone', function (e) {
        e.stopPropagation();
        e.preventDefault();
        var mobile = $('#mobile').text().trim()
        if ($.nui.isTrue(mobile)) {
            api.call({
                type: 'tel_prompt',
                number: mobile
            })
        }
    })
}

// 比例值取整
function valueRound(value) {
    switch (typeof value) {
        case 'number':
            value += ''; // eg: 100.00 => 100
            break;
        case 'string':  // eg: '100.00'  => 100
            if (/^\d{1,3}\.00$/.test(value)) {
                var dotIdx = value.indexOf('.');
                if (dotIdx > -1) {
                    value = value.slice(0, dotIdx);
                }
            }
            break;
        // 没有default
    }

    return value;
}