$('#header').header({
    back: true, //返回
    title: '销售分析', //标题
});


// 基于准备好的dom，初始化echarts实例
var myChart = echarts.init(document.getElementById('bar'));

// 指定图表的配置项和数据
var option = {
    tooltip: {
        trigger: 'axis',
        axisPointer: { // 坐标轴指示器，坐标轴触发有效
            type: 'shadow' // 默认为直线，可选为：'line' | 'shadow'
        }
    },
    series: [{
        type: 'bar',
    }],
    grid: {
        left: '20',
        right: '20',
        top: '10',
        bottom: '10',
        containLabel: true
    },
    xAxis: {
        type: 'value',
        show: false,
    },
    yAxis: [{
        axisLine: {
            show: false
        },
        axisTick: {
            show: false
        },
        splitLine: {
            show: false
        },
        min: 0,
        max: 11,
        splitNumber: 12,
        type: 'category',
        data: ['1月', '2月', '3月', '4月', '5月', '6月', '7月', '8月', '9月', '10月', '11月', '12月'],
    }],
    series: [{
        name: '金额',
        type: 'bar',
        stack: '总量',
        itemStyle: {
            normal: {
                color: function(params) {　 //首先定义一个数组
                    var colorList = [
                        '#98c1f3', '#80e5d3', '#85ca8d', '#fbc987', '#f09777', '#da5859',
                        '#98c1f3', '#80e5d3', '#85ca8d', '#fbc987', '#f09777', '#da5859'
                    ];
                    return colorList[params.dataIndex]
                },
            }
        },
        label: {
            normal: {
                show: true,
                position: 'insideRight'
            }
        },
        data: [820, 832, 901, 934, 1290, 1330, 1320, 1500, 1250, 200, 150, 1480],

    }]
};


myChart.setOption(option);
