var html_name = page_arr.yarn_requirement;
var exist = []//存在的其他要求
/******头部显示******/
$("#header").header({
	back: true,
	title: '其他要求',
	add: Auth.check('sx','edit'),
	appendBackBtnEvt: isDataChange
});
var delete_arr = [];
var goods_craft = [];
page_init = function () {
	console.log(page_data);
	console.log(html_name);
	goods_craft = page_data['list'];
	delete_arr = page_data['delete'];
	if (!$.nui.isEmpty(goods_craft)) {
		//每次进来都将数据进行排序
		$(goods_craft).each(function (i, item) {
			goods_craft[i]['sort'] = i + 1;
		})
	}
	showList(goods_craft);

	//监听返回键
	page_data.keyback = function () {
		isDataChange();
	};

	api.addEventListener({
		name: html_name,
	}, function (ret, err) {
		var temp = ret['value']['data'];
		if (!temp) return;
		switch (temp['page_type']) {
			case 'qtyq_lx':
				if ($.nui.isEmpty(temp['id'])) return;
				if (temp['type'] == 'modify') {
					$(goods_craft).each(function (i, item) {
						if (goods_craft[i]['sort'] === temp['sort']) {
							goods_craft[i]['craft_id'] = temp['id'];
							if (goods_craft[i]['craft_name'] !== temp['select_val']) {
								goods_craft[i]['craft_options'] = '';
							}
							goods_craft[i]['craft_name'] = temp['select_val'];
							goods_craft[i]['craft_options'] = '';
							return false;
						}
					});
				} else if (temp['type'] == 'add') {
					var temporary = {
						id: 0,
						craft_id: temp['id'],
						craft_name: temp['select_val'],
						craft_options: '',
						sort: (goods_craft.length + 1) || 1,
						is_delete: 0
					}
					goods_craft.push(temporary);
				}
				
				$('.swipe-delete').empty();
				// $('.empty-tips-wrap').remove();
				showList(goods_craft);
				break;
			case 'qtyq_ms':
				if ($.nui.isEmpty(temp['select_val'])) return;
				$(goods_craft).each(function (i, item) {
					if (goods_craft[i]['sort'] === temp['sort']) {
						goods_craft[i]['craft_options'] = temp['select_val'];
						return false;
					}
				});
				// $('.empty-tips-wrap').remove();
				$('.swipe-delete').empty();
				showList(goods_craft);
				break;
		}
	}
	);
}

function showList(data) {

	exist = [];
	if (data.length == 0) {
		// return $('.content').append('<p class="empty_text">暂无数据！</p>');
		return fun.createDataEmptyTips({dom:'.swipe-delete',btnShow:false});
	}
	$(data).each(function (i, item) {
		var html = [];
		html.push('	<li class="account-list lower-border-line">');
		html.push('		<div class="le" data-list=\'' + JSON.stringify(item) + '\'>');
		html.push('			<div class="gy_name float-left" >' + item['craft_name'] + '</div>');
		html.push('			<div class="gy_text float-left" >' + item['craft_options'] + '</div>');
		html.push('         <div class="iconfont icon-fork params-list-icon float-left"></div>');
		html.push('			<div class="delete dels1 delete-btn">删除</div>');
		html.push('		</div>');
		html.push('	</li>');
		$('.swipe-delete').append(html.join(''));
		if (item['craft_options'] == '') {
			$('.params-list-icon').eq(i).hide();
		}
		exist.push(Number(item['craft_id']));
	})

}

$('body').on('tap', '.params-list-icon', function () {
	var index = $('.params-list-icon').index(this);
	$('.gy_text').eq(index).text('');
	$(this).hide();
	// goods_craft
})

// 添加新的 工艺类型
$('body').on('tap', '#add_btn', function () {
	fun.showLoad();
	fun.showPageFull({
		page_url: page_arr.select_sx_list,
		pageParam: {
			return_page: html_name,
			page_type: 'qtyq_lx',
			form: 'sx',
			type: 'add',
			exist: exist
		}
	});
	fun.hideLoad();
});

// 工艺描述，记录行过去
$('body').on('tap', '.gy_text', function () {
	var list = $(this).parent('.le').data('list');
	var select_valInput = $(this).text();
	fun.showPageFull({
		page_url: page_arr.select_sx_list,
		pageParam: {
			return_page: html_name,
			page_type: 'qtyq_ms',
			form:'sx',
			sort: list['sort'],//返回后修改哪条记录
			craft_id: list['craft_id'] || 0,//查数据用
			select_valInput: select_valInput // 把当前记录行的值传过去，做判断，如果用户不做操作直接返回则拿原来的值
		}
	});
})

//其他工艺，记录行过去
$('body').on('tap', '.gy_name', function () {
	var list = $(this).parent('.le').data('list');
	fun.showPageFull({
		page_url: page_arr.select_sx_list,
		pageParam: {
			return_page: html_name,
			page_type: 'qtyq_lx',
			form: 'sx',
			sort: list['sort'],
			type: 'modify',
			exist: exist
		}
	});
});

//删除工艺类型
$('body').on('tap', '.delete-btn', function () {
	var list = $(this).parent('.le').data('list');
	fun.dialog({
		content: '你确定要删除【' + list['craft_name'] + '】吗？',//删除工艺字眼
		btn: ['删除', '取消'],
		yes: function () {
			if (list['id'] != 0) delete_arr.push(list['id']); // 编辑状态删除，返回被删除的工艺id
			goods_craft.splice(list['sort'] - 1, 1);
			$(goods_craft).each(function (i, item) {
				goods_craft[i]['sort'] = i + 1;
			})
			$('.swipe-delete').empty();
			showList(goods_craft);
		}
	});
})

//返回到产品编辑
function isDataChange() {
	$(goods_craft).each(function (i, item) {
		goods_craft[i]['sort'] = (i + 1);//将数组进行排序
	})
	api.sendEvent({
		name: page_data.return_page,
		extra: {
			'status': 'cpzl_data',
			'page_type': 'qtyq',//fkkz gg
			'list': goods_craft,//列表数据
			'delete': delete_arr
		}
	});
	closePage();
}

//返回上一页
function closePage() {
	setTimeout(function () {
		api.closeWin();
	}, 200);
}
