var page_name = page_arr.zylm;
var pageList = [];
var save_data = {}; // 保存数据
var all_next = [];
// 页面初始化
page_init = function () {

    $('#header').header({
        back: true,
        title: '主营类目',
        foot_input: {
            show: true,
            plader: '搜索',
            readonly: true
        },
        appendBackBtnEvt: isDataChange
    });
    console.log('++++')
    console.log(page_data)
    init();
    getLish(page_data);
    api.addEventListener({
        name: page_name,
    }, function (ret, err) {
        console.log(ret.value)
        var temp = ret.value;
        switch (temp['status']) {
            case 'next':
                all_next = $.extend(true, all_next, temp['all_data']);
                break;
            case 'search':
                all_next = $.extend(true, all_next, temp['data']);
                $('#choice_list ul').html('');
                $('#show_list').html('');
                showList(all_next);
                break;
            // 没有default
        }

        var idx = $('.list-left').find('.select').index();
        var find_li = $('#show_list ul').eq(idx).find('.data_right').eq(temp['index']);
        // 右边标记显示和赋值
        find_li.find('.circle_right').remove();
        if (temp['sum'] != '0') {
            var html = [];
            html.push('   <span class="circle_right">' + temp['sum'] + '</span>');
            find_li.append(html.join(''))
        }
        find_li.data('jy_array', temp['jy_array']);

        // 左边标记显示
        function list_num() {
            $('.list-left').find('.select').find('.circle').remove();
            var count = 0;
            for (var i = 0; i < $('#show_list ul:eq(' + idx + ') li').length; i++) {
                count += Number($('#show_list ul:eq(' + idx + ') li').eq(i).find('.circle_right').text());
            }
            if (count != 0) {
                var list_html = [];
                list_html.push('<span class="circle">' + count + '</span>')
                $('.list-left').find('.select').append(list_html.join(''));
            } else {
                return;
            }

        }
        list_num()
    });
    page_data['keyback'] = isDataChange;  // 安卓返回键
}

// 初始化
function init() {

    $('.content').css({
        marginTop: $('#header').outerHeight() + api.safeArea.top - parseFloat($('html').css('fontSize')),
        marginBottom: api.safeArea.bottom + 'px'
    })

    if ($('#choice_list').outerHeight() < ($(window).height() - parseFloat($('.content').css('marginTop')))) {
        $('#choice_list').css({
            height: ($(window).height() - parseFloat($('.content').css('marginTop')))
        })
    } else {
        $('#choice_list').css({
            // height: $('#choice_list').outerHeight()
            height: 100 / $(window).height() * (($(window).height() - parseFloat($('.content').css('marginTop')))) + 'vh'
        })
    }

    if ($('#show_list').outerHeight() < ($(window).height() - parseFloat($('.content').css('marginTop')))) { // 在可视区域内
        $('#show_list').css({
            height: ($(window).height() - parseFloat($('.content').css('marginTop')))
        })
    } else {
        $('#show_list').css({ // 超出可视区域内
            height: 100 / $(window).height() * (($(window).height() - parseFloat($('.content').css('marginTop')))) + 'vh'
        })
    }
}
// 获取数据
function getLish(page_data) {
    fun.ajax({
        showLoad: true,
        hideLoad: true,
        url: AJAX_URL.getZyjy,
        success: function (res) {
            if (res['status'] === 0) {
                pageList = res['data'];
                for (var i = 0; i < pageList.length; i++) {
                    for (var m = 0; m < pageList[i]['child'].length; m++) {
                        pageList[i]['child'][m]['_index'] = i;
                        pageList[i]['child'][m]['select'] = false;
                        for (var y = 0; y < pageList[i]['child'][m]['child'].length; y++) {
                            pageList[i]['child'][m]['child'][y]['_index'] = i;
                            pageList[i]['child'][m]['child'][y]['type_index'] = m;
                            pageList[i]['child'][m]['child'][y]['select'] = false;
                        }
                    }
                }

                if ($.nui.isTrue(page_data['load_data'])) {
                    var upDataArr = typeof page_data['load_data'] === 'string' ? JSON.parse(page_data['load_data']) : page_data['load_data'];
                } else {
                    var upDataArr = false;
                }

                // 请求回来的新数据与上页面返回的数据匹配
                if ($.nui.isTrue(upDataArr)) {
                    for (var j = 0; j < pageList.length; j++) {
                        for (var k = 0; k < pageList[j]['child'].length; k++) {
                            for (var r = 0; r < upDataArr.length; r++) {
                                if (pageList[j]['child'][k]['id'] === upDataArr[r]['id']) {
                                    pageList[j]['child'][k]['select'] = true;
                                }
                            }
                            for (var y = 0; y < pageList[j]['child'][k]['child'].length; y++) {
                                for (var w = 0; w < upDataArr.length; w++) {
                                    if (pageList[j]['child'][k]['child'][y]['id'] === upDataArr[w]['id']) {
                                        pageList[j]['child'][k]['child'][y]['select'] = true;
                                    }
                                }
                            }
                        }
                    }
                    all_next = pageList;
                } else {
                    all_next = pageList;
                }
                // }
                console.log('----')
                console.log(all_next)
                // showList(pageList, page_data);
                showList(all_next, page_data);
            }
        }
    })
}

// 渲染数据
function showList(data, page_data) {
    var html = [];
    var list_html = [];
    for (var i = 0; i < data.length; i++) {
        var init_count = 0;
        for (var k = 0; k < data[i]['child'].length; k++) {
            if (data[i]['child'][k]['select'] === true) {
                init_count++;
            }
            for (var u = 0; u < data[i]['child'][k]['child'].length; u++) {
                if (data[i]['child'][k]['child'][u]['select'] === true) {
                    init_count++;
                }
            }
        }
        html.push('<li class="data_left" data-list=\'' + fun.formatString(JSON.stringify(data[i])) + '\'>');
        html.push('   <span class="left_font limit">' + data[i]['title'] + '</span>');
        if (init_count !== 0) {
            html.push('   <span class="circle">' + init_count + '</span>');
        }
        html.push('</li>');
    }
    $('.list-left ul').html(html.join(''));
    $('.data_left:first').addClass('select');

    // 默认渲染第二节点
    var list_html = [];
    list_html.push('<ul>');
    // if ($.nui.isTrue(upDataArr)) {
    var item = data[0];
    for (var j = 0; j < item['child'].length; j++) {
        var second_count = 0;
        if (item['child'][j]['select'] === true) {
            second_count++;
        }
        var three_count = 0;
        for (var z = 0; z < item['child'][j]['child'].length; z++) {
            var child = item['child'][j]['child'][z];
            if (child['select'] === true) {
                three_count++;
            }
        }
        list_html.push('    <li class="data_right">');
        list_html.push('        <span class="right_font limit_second">' + item['child'][j]['title'] + '</span>');
        if ((second_count + three_count) !== 0) {
            list_html.push('        <span class="circle_right">' + (second_count + three_count) + '</span>');
        }
        list_html.push('    </li>');
    }
    list_html.push('</ul>');
    for (var y = 1; y < data.length; y++) {
        list_html.push('<ul>');
        list_html.push('</ul>');
    }

    // }
    $('#show_list').append(list_html.join(''));

}

$('#show_list ul').hide();

// 一级节点点击事件
$('body').on('click', '.data_left', function () {
    var idx = $(this).index();
    $('.data_left').removeClass('select');
    $(this).addClass('select');
    // var list = $(this).data('list');

    if ($.nui.isTrue($('#show_list ul').eq(idx).children().length)) {
        $('#show_list ul').hide();
        $('#show_list ul').eq(idx).show();
    } else {
        $('#show_list ul').hide();
        var html = [];
        // html.push('<ul>');
        for (var i = 0; i < all_next[idx]['child'].length; i++) {
            var item = all_next[idx]['child'][i];
            var second_count = 0;
            if (all_next[idx]['child'][i]['select'] === true) {
                second_count++;
            }
            var three_count = 0;
            // 循环三级节点选中的数量
            for (var j = 0; j < item['child'].length; j++) {
                if (item['child'][j]['select'] === true) {
                    three_count++;
                }
            }
            html.push('    <li class="data_right">');
            html.push('        <span class="right_font limit_second">' + item['title'] + '</span>');
            if ((second_count + three_count) !== 0) {
                html.push('        <span class="circle_right">' + (second_count + three_count) + '</span>');
            }
            html.push('    </li>');
        }
        // html.push('</ul>');
        // $('.list-right ul').data('index', idx);
        // $('#show_list').append(html.join(''));
        $('#show_list ul').eq(idx).append(html.join(''));
        $('#show_list ul').eq(idx).show();
    }
})

// 二级节点点击事件
$('body').on('click', '.data_right', function () {
    var index = $(this).index();
    var left_count = 0;
    var right_count = 0;
    var count = 0;
    // for (var i = 0; i < $('#choice_list ul li').length; i++) {
    //     count += Number($('#choice_list ul li').eq(i).find('.circle').text());
    // }

    for (var i = 0; i < $('#choice_list ul li').length; i++) {
        if (i === $(this).parent().index()) {
            left_count += 0;
        } else {
            left_count += Number($('#choice_list ul li').eq(i).find('.circle').text());
        }
    }

    for (var j = 0; j < $(this).parent().children().length; j++) {
        if (j === index) {
            right_count += 0;
        } else {
            right_count += Number($(this).parent().children().eq(j).find('.circle_right').text());
        }

    }
    count = left_count + right_count;
    fun.showLoad();
    fun.showPageFull({
        page_url: page_arr.zylm_next,
        pageParam: {
            amount: count,    //页面选中的数量
            index: index,   //点击行的下标
            up_index: $(this).parent().index(),  // 第一节点下标
            data: all_next,
            jy_array: ($(this).data('jy_array') || ''),    //选中数组
            company_array: $(this).data('company'),  //从店铺信息中带来的数据
            return_page: page_name,
        }
    });
});

// 搜索框
$('body').on('click', '#foot_search', function () {
    fun.showLoad();
    fun.showPageFull({
        page_url: page_arr.zylm_search,
        pageParam: {
            data: all_next,
            // pageTwo: pageTwo,
            // pageThree: pageThree,
            return_page: page_name,
        }
    });
})

//返回
function isDataChange() {
    var data = [];
    // 下个页面需要保存的数据
    for (var i = 0; i < all_next.length; i++) {
        for (var j = 0; j < all_next[i]['child'].length; j++) {
            if (all_next[i]['child'][j]['select'] === true) {
                data.push({
                    id: all_next[i]['child'][j]['id'],
                    title: all_next[i]['child'][j]['title']
                })
            }
            for (var k = 0; k < all_next[i]['child'][j]['child'].length; k++) {
                if (all_next[i]['child'][j]['child'][k]['select'] === true) {
                    data.push({
                        id: all_next[i]['child'][j]['child'][k]['id'],
                        title: all_next[i]['child'][j]['child'][k]['title']
                    })
                }
            }
        }
    }
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            status: 'zylm',
            data: JSON.stringify(data),
        }
    })
    setTimeout(function () {
        api.closeWin();
    }, 200);
}