var page_name = page_arr.zylm_search;
var search_data = [];
var isAndroid = navigator.userAgent.indexOf('Android') > -1 || navigator.userAgent.indexOf('Adr') > -1;
var mark;  // 用于是否显示暂无数据
page_init = function () {
    $('#header').header({
        back: true,
        title: '主营类目',
        foot_input: {
            show: true,
            plader: '搜索',
        },
        appendBackBtnEvt: isDataChange
    });
    mark = true;
    console.log(page_data)
    page_data['keyback'] = isDataChange;//监听安卓返回键
    search_data = page_data['data'];

    $('.content').css({
        paddingTop: $('#header').outerHeight() + api.safeArea.top - parseFloat($('html').css('fontSize'))
    })

    // 显示暂无数据
    fun.createDataEmptyTips({ dom: '.search_matter', btnShow: false });
    $('.search_matter').css({
        height: $(window).height() - api.safeArea.top - $('#header').outerHeight() - fun.computedHtmlFontSize()
    })

    // 是否安卓（针对软键盘弹起错位）
    if (isAndroid) {
        $('.empty-tips-wrap').css({
            'position': 'relative'
        })
    }

}

$('body').on('search', '#foot_search', function () {
    mark = true;
    var dataTwo = [];
    var dataThree = [];
    for (var i = 0; i < search_data.length; i++) {
        for (var m = 0; m < search_data[i]['child'].length; m++) {
            dataTwo.push(search_data[i]['child'][m])
            for (var y = 0; y < search_data[i]['child'][m]['child'].length; y++) {
                dataThree.push(search_data[i]['child'][m]['child'][y]);
            }
        }
    }
    var text = $(this).val();
    var data = search_data;

    var secondary = fuzzyQuery(dataTwo,text);
    var threeary = fuzzyQuery(dataThree,text);

    var html = [];

    // 搜索第二级关键词
    if ($.nui.isTrue(secondary)) {
        mark = false;
        for (var z = 0; z < secondary.length; z++) {
            html.push('<li class="clearfix two_choice">');
            html.push('  <div class="search_node">');
            html.push('    <span class="oneValue limit_two" data-oneValue=\'' + data[secondary[z]['_index']]['id'] + '\' >' + data[secondary[z]['_index']]['title'] + '</span>');
            html.push('    <span>-></span>');
            html.push('    <span class="twoValue limit_two" data-twoValue=\'' + secondary[z]['id'] + '\'>' + secondary[z]['title'] + '</span>');
            html.push('  </div>');
            html.push('  <div class="search_node_select">');
            html.push('    <i class="check-choice iconfont"></i>');
            html.push('  </div>');
            html.push('</li>');
        }
    }

    // 搜索第三级关键词
    if ($.nui.isTrue(threeary)) {
        mark = false;
        for (var p = 0; p < threeary.length; p++) {
            html.push('<li class="clearfix three_choice">');
            html.push('  <div class="search_node">');
            html.push('    <span class="oneValue limit_search" data-oneValue=\'' + data[threeary[p]['_index']]['id'] + '\'>' + data[threeary[p]['_index']]['title'] + '</span>');
            html.push('    <span>-></span>');
            html.push('    <span class="twoValue limit_search" data-twoValue=\'' + data[threeary[p]['_index']]['child'][threeary[p]['type_index']]['id'] + '\'>' + data[threeary[p]['_index']]['child'][threeary[p]['type_index']]['title'] + '</span>');
            html.push('    <span>-></span>');
            html.push('    <span class="threeValue limit_search" data-threeValue=\'' + threeary[p]['id'] + '\'>' + threeary[p]['title'] + '</span>');
            html.push('  </div>');
            html.push('  <div class="search_node_select">');
            html.push('    <i class="check-choice iconfont"></i>');
            html.push('  </div>');
            html.push('</li>');
        }
    }

    $('.search_matter').html(html.join(''));

    // 没有搜索到或是第一级的关键词
    if (mark) {
        fun.createDataEmptyTips({ dom: 'ul', btnShow: false });
        $('.search_matter').css({
            height: $(window).height() - api.safeArea.top - $('#header').outerHeight() - fun.computedHtmlFontSize()
        })

        if (isAndroid) {
            $('.empty-tips-wrap').css({
                'position': 'relative'
            })
        }
    }

    // 判断二级节点是否有选中
    if ($.nui.isTrue(secondary)) {
        for (var w = 0; w < secondary.length; w++) {
            if ($.nui.isTrue(secondary[w]['select'])) {
                $('.two_choice').eq(w).find('.iconfont').addClass('icon-check');
            }
        }
    }

    // 判断三级节点是否有选中
    if ($.nui.isTrue(threeary)) {
        for (var q = 0; q < threeary.length; q++) {
            if ($.nui.isTrue(threeary[q]['select'])) {
                $('.three_choice').eq(q).find('.iconfont').addClass('icon-check');
            }
        }
    }
})

// 点击第二节点
$('body').on('click', '.two_choice', function () {
    var first_id = $(this).find('.oneValue').data('onevalue');
    var second_id = $(this).find('.twoValue').data('twovalue');
    if ($(this).find('.iconfont').hasClass('icon-check')) {
        $(this).find('.iconfont').removeClass('icon-check');
        for (var i = 0; i < search_data.length; i++) {
            if (search_data[i]['id'] === first_id) {
                for (var j = 0; j < search_data[i]['child'].length; j++) {
                    if (search_data[i]['child'][j]['id'] === second_id) {
                        search_data[i]['child'][j]['select'] = false;
                    }
                }
            }
        }
    } else {
        var second_count = 0;
        for (var q = 0; q < search_data.length; q++) {
            for (var w = 0; w < search_data[q]['child'].length; w++) {
                if (search_data[q]['child'][w]['select'] === true) {
                    second_count++;
                }
                for (var e = 0; e < search_data[q]['child'][w]['child'].length; e++) {
                    if (search_data[q]['child'][w]['child'][e]['select'] === true) {
                        second_count++;
                    }
                }
            }
        }
        if (second_count < 8) {
            $(this).find('.iconfont').addClass('icon-check');
            for (var i = 0; i < search_data.length; i++) {
                if (search_data[i]['id'] === first_id) {
                    for (var j = 0; j < search_data[i]['child'].length; j++) {
                        if (search_data[i]['child'][j]['id'] === second_id) {
                            search_data[i]['child'][j]['select'] = true;
                        }
                    }
                }
            }
        } else {
            fun.toast('主营类目不能超出8个');
        }

    }
})

// 点击第三节点
$('body').on('click', '.three_choice', function () {
    var first_id = $(this).find('.oneValue').data('onevalue');
    var second_id = $(this).find('.twoValue').data('twovalue');
    var three_id = $(this).find('.threeValue').data('threevalue');
    if ($(this).find('.iconfont').hasClass('icon-check')) {
        $(this).find('.iconfont').removeClass('icon-check');
        for (var i = 0; i < search_data.length; i++) {
            if (search_data[i]['id'] === first_id) {
                for (var j = 0; j < search_data[i]['child'].length; j++) {
                    if (search_data[i]['child'][j]['id'] === second_id) {
                        for (var k = 0; k < search_data[i]['child'][j]['child'].length; k++) {
                            if (search_data[i]['child'][j]['child'][k]['id'] === three_id) {
                                search_data[i]['child'][j]['child'][k]['select'] = false;
                            }
                        }
                    }
                }
            }
        }
    } else {
        var three_count = 0;
        for (var q = 0; q < search_data.length; q++) {
            for (var w = 0; w < search_data[q]['child'].length; w++) {
                if (search_data[q]['child'][w]['select'] === true) {
                    three_count++;
                }
                for (var e = 0; e < search_data[q]['child'][w]['child'].length; e++) {
                    if (search_data[q]['child'][w]['child'][e]['select'] === true) {
                        three_count++;
                    }
                }
            }
        }
        if (three_count < 8) {
            $(this).find('.iconfont').addClass('icon-check');
            for (var i = 0; i < search_data.length; i++) {
                if (search_data[i]['id'] === first_id) {
                    for (var j = 0; j < search_data[i]['child'].length; j++) {
                        if (search_data[i]['child'][j]['id'] === second_id) {
                            for (var k = 0; k < search_data[i]['child'][j]['child'].length; k++) {
                                if (search_data[i]['child'][j]['child'][k]['id'] === three_id) {
                                    search_data[i]['child'][j]['child'][k]['select'] = true;
                                }
                            }
                        }
                    }
                }
            }
        } else {
            fun.toast('主营类目不能超出8个');
        }
    }
})

function isDataChange() {
    var search_array = [];
    // search_array.push(search_data)
    search_array = search_data;
    api.sendEvent({
        name: page_data['return_page'],
        extra: {
            status: 'search',
            data: search_array,
        }
    })
    setTimeout(function () {
        api.closeWin();
    }, 200);
}

// 模糊搜索
function fuzzyQuery(list, keyWord) {
    if($.nui.isTrue(keyWord)){
        var reg = new RegExp(keyWord);
        var arr = [];
        for (var i = 0; i < list.length; i++) {
            if (reg.test(list[i]['title'])) {
                arr.push(list[i]);
            }
        }
        return arr;
    }else{
        return false;
    }
}