;(function($){
	$.fn.pop=function(option){
		var value={
			isWarm:false,//是否为提示语，如果不为提示语，则是其它操作
			warmText:'提示语',//提示语
			title:'',//标题
			noSave:false,//不保存
			showDefault:false,//是否显示默认
			isAssist:false,//是否为新增辅助
			paramsName:[],//字段名字
			showParams:'',
			isStop:false,//是否停用
			noSave:false,//还没保存
			isEdit:false,//单据处于修改状态
			isDrop:[],//第几个参数是下拉
			callback:null
		}
		option=$.extend(value,option);
		var boxHtml=[];
		boxHtml.push('<div class="warm">');
		if(value.isWarm && value.title==''){//为提示语
			boxHtml.push('<div class="warm-content">');
			boxHtml.push(value.warmText);
			boxHtml.push('</div>');
			boxHtml.push('<div class="warm-ope">');
			if(value.noSave){
				boxHtml.push('<button class="btn save">保存</button>');
				boxHtml.push('<button class="btn nosave">不保存</button>');
				boxHtml.push('<button class="btn cancel">取消</button>');
			}
			if(value.isEdit){//如果处于修改状态
				boxHtml.push('<button class="btn del">删除</button>');
				boxHtml.push('<button class="btn cancel" id="cancel">取消</button>');
			}
			boxHtml.push('</div>');
		}else{//不为提示语
			if(value.title){
				boxHtml.push('<div class="warm-title">');
				boxHtml.push('<span class="title">'+value.title+'</span>');
				boxHtml.push('</div>');
			}
			boxHtml.push('<div class="warm-con">');
			boxHtml.push('<ul>');
			if(value.paramsName.length>0){//字段个数大于0
				if(value.isAssist){//如果是新增辅助
					boxHtml.push('<li class="obj-title"><i>对象</i>');
					boxHtml.push('<input type="text" name="obj-type" id="obj-type">');
					boxHtml.push('<input type="text" name="search-type" id="search-type">');
					boxHtml.push('</li>');
				}
				for(var i=0;i<value.paramsName.length;i++){
					var bit;
					for(var j=0;j<value.isDrop.length;j++){
						if(bit==value.isDrop[value.isDrop.length-1]){bit=null;}
						if(i==value.isDrop[j]){
							bit=value.isDrop[j];
							break;
						}else{
							bit=null;
						}
					}
					if(bit || bit==0){
						boxHtml.push('<li class="obj-title"><span class="param">'+value.paramsName[i]+'</span><input type="text"><i class="iconfont icon-xia" id="sel"></i></li>');
					}else{
						boxHtml.push('<li class="obj-title"><span class="param">'+value.paramsName[i]+'</span><input type="text"></li>');
					}

				}
			}
			boxHtml.push('</ul>');
			if(value.showDefault){
				boxHtml.push('<div class="shows">');
				if(value.isStop){
					boxHtml.push('<span class="shows-title stp">停用</span>');
					boxHtml.push('<i class="stp-btn nui-switch nui-switch-md nui-unactive nui-switch-btn"><i class="nui-switch-handle" id="st"></i></i>');
				}else{
					boxHtml.push('<i class="stop-btn nui-switch nui-switch-md nui-unactive nui-switch-btn"><i class="nui-switch-handle" id="st"></i></i>');
					boxHtml.push('<span class="shows-title">'+value.showParams+'</span>');
				}
				boxHtml.push('</div>');
			}
			boxHtml.push('</div>');
			boxHtml.push('<div class="warm-operation">');
			boxHtml.push('<button class="btn" id="cancel">取消</button>');
			boxHtml.push('<button class="btn" id="confirm">确认</button>');
			boxHtml.push('</div>');
		}
		boxHtml.push('</div>');
		layer.open({
			type:1,
			content:boxHtml.join(''),
			style: 'width: 90%; min-height: auto; border:none;background-color: #fff; overflow-y: hidden;',//position: fixed;top: 25%;left: 5%;
			success:function(layero, index){
				$('#confirm').on('tap', function () {
					if (typeof option.callback == 'function') {
						option.callback();
					}
					setTimeout(function(){
						layer.closeAll()
					},50)
				})
				$('#cancel').on('tap', function () {
					setTimeout(function(){
						layer.closeAll()
					},50)
				})
			}
		});
		// $(this).html(boxHtml.join(''));
	};
})(jQuery);

//添加修改颜色
// function addColour(opt){
//     var html = [];
//     if(!opt) return;
//     var val = opt.value || {},
//         is_stop = (val['is_stop'] && val['is_stop'] == 1) ? "nui-active" : "nui-unactive";
//     html.push('  <div class="warm"> ');
//     html.push('   <div class="warm-title"> ');
//     html.push('    <span class="title">'+((opt.type == "add") ? "新增颜色" : "修改颜色")+'</span> ');
//     html.push('   </div> ');
//     html.push('   <div class="warm-con"> ');
//     html.push('    <ul> ');
//     html.push('     <li class="obj-title"> <span class="param">色号</span> <input id="colour_number" type="text" value="'+(val['number'] || "")+'" /> </li> ');
//     html.push('     <li class="obj-title"> <span class="param">颜色</span> <input id="colour" type="text" value="'+(val['name'] || "")+'" /> </li> ');
//     html.push('     <li class="obj-title"> <span class="param">色系</span> <input id="colour_series" type="text" readonly="readonly" value="'+(val['type'] || "")+'" /> <i class="iconfont icon-xia" id="sel"></i> </li> ');
//     html.push('     <li class="obj-title"> <span class="param">加工商</span> <input id="xz_jgs" type="text" readonly="readonly" jgs_id="'+(val['merchant_id'] || "")+'" value="'+(val['wldw_mc'] || "")+'" /> <i class="iconfont icon-xia" id="sel"></i> </li> ');
//     html.push('     <li class="obj-title"> <span class="param">起订量</span> <input id="cp_qdl" type="number" value="'+(val['order_amount'] || "")+'" /> </li> ');
//     html.push('    </ul> ');
//     if(opt.type != "add"){
//         html.push('    <div class="shows"> ');
//         html.push('     <span class="shows-title stp">停用</span> ');
//         html.push('     <i id="ys_is_stop" class="stp-btn nui-switch nui-switch-md nui-switch-btn '+is_stop+'"><i class="nui-switch-handle" id="st"></i></i> ');
//         html.push('    </div> ');
//     }
//     html.push('   </div> ');
//     html.push('   <div class="warm-operation"> ');
//     html.push('    <button class="btn" id="confirm">确认</button> ');
//     html.push('    <button class="btn" id="cancel">取消</button>');
//     html.push('   </div> ');
//     html.push('  </div>');
//     layer.open({
//         type:1,
//         content:html.join(''),
//         shadeClose: false,
//         style: 'width: 90%; min-height: auto; border:none;background-color: #fff; position: fixed;top: 25%;left: 5%;overflow-y: hidden;',
//         success:function(ele){
//             //确定
//             $('#confirm').on('tap', function () {
//                 if (typeof opt.callback == 'function') {
//                     if(!$('#colour_number').val()){
//                         return fun.toast("色号不能为空。");
//                     }
//                     var param = {
//                         "id":(val['id'] || 0),
//                         "sort":(val['sort'] || 0),
//                         "number":($('#colour_number').val().trim() || ""),
//                         "name":($('#colour').val().trim() || ""),
//                         "type":($('#colour_series').val().trim() || ""),
//                         "wldw_mc":($('#xz_jgs').val().trim() || ""),
//                         "merchant_id":($('#xz_jgs').attr('jgs_id') || 0),
//                         "order_amount":($('#cp_qdl').val().trim() || ""),
//                         "is_stop":($('#ys_is_stop').hasClass('nui-active') ? 1 : 0),
//                         "remark":"",
//                         "imgs":[],
//                         "goods_material":[]
//                     }
//                     opt.callback(param);
//                 }
//                 setTimeout(function(){
//                     layer.closeAll()
//                 },50)
//             });
//             $('#cancel').on('tap', function () {
//                 setTimeout(function(){
//                     layer.closeAll()
//                 },50)
//             });

//             Select_color_series($('#colour_series'));

//             //选择加工商
//             $('#xz_jgs').on('tap',function(){
//                 fun.showPageFull({
//                     "page_url": page_arr.customer_search,
//                     "pageParam": {
//                         "return_page":html_name,
//                         "page_type":"jgs"
//                     }
//                 });
//             })

//             //起订量限制小数点4位
//             $('#cp_qdl').on('input',function(){
//                 var _this = $(this);
//                 fun.restrictVal({
//                     "num_type":2,
//                     "value":$(_this).val(),
//                     "decimal_digits":4,
//                     "CursorPos": fun.getCursorPos($(_this).attr('id'))
//                 },function(params){
//                     $(_this).val(params['val'])
//                 });
//             })
//         }
//     });
// }